/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include <libint/libint.h>
#include "libderiv.h"
#include <libint/hrr_header.h>

#include "d1hrr_header.h"

extern void d12vrr_order_00hd(Libderiv_t *, prim_data *);

  /* Computes derivatives of (00|hd) integrals */

void d12hrr_order_00hd(Libderiv_t *Libderiv, int num_prim_comb)
{
 prim_data *Data = Libderiv->PrimQuartet;
 double *int_stack = Libderiv->int_stack;
 double *zero_stack = Libderiv->zero_stack;
 int i,j;
 double tmp, *target;

 Libderiv->deriv_classes[0][7][11] = int_stack + 0;
 Libderiv->deriv_classes[0][7][10] = int_stack + 36;
 Libderiv->deriv_classes[0][7][9] = int_stack + 72;
 Libderiv->deriv_classes[0][7][8] = int_stack + 108;
 Libderiv->deriv_classes[0][7][7] = int_stack + 144;
 Libderiv->dvrr_classes[0][6] = int_stack + 180;
 Libderiv->deriv_classes[0][7][6] = int_stack + 208;
 Libderiv->deriv_classes[0][7][2] = int_stack + 244;
 Libderiv->deriv_classes[0][7][1] = int_stack + 280;
 Libderiv->deriv_classes[0][7][0] = int_stack + 316;
 Libderiv->deriv2_classes[0][5][143] = int_stack + 352;
 Libderiv->deriv2_classes[0][6][143] = int_stack + 373;
 Libderiv->deriv2_classes[0][7][143] = int_stack + 401;
 Libderiv->deriv2_classes[0][5][131] = int_stack + 437;
 Libderiv->deriv2_classes[0][6][131] = int_stack + 458;
 Libderiv->deriv2_classes[0][7][131] = int_stack + 486;
 Libderiv->deriv2_classes[0][5][130] = int_stack + 522;
 Libderiv->deriv2_classes[0][6][130] = int_stack + 543;
 Libderiv->deriv2_classes[0][7][130] = int_stack + 571;
 Libderiv->deriv2_classes[0][5][119] = int_stack + 607;
 Libderiv->deriv2_classes[0][6][119] = int_stack + 628;
 Libderiv->deriv2_classes[0][7][119] = int_stack + 656;
 Libderiv->deriv2_classes[0][5][118] = int_stack + 692;
 Libderiv->deriv2_classes[0][6][118] = int_stack + 713;
 Libderiv->deriv2_classes[0][7][118] = int_stack + 741;
 Libderiv->deriv2_classes[0][5][117] = int_stack + 777;
 Libderiv->deriv2_classes[0][6][117] = int_stack + 798;
 Libderiv->deriv2_classes[0][7][117] = int_stack + 826;
 Libderiv->deriv2_classes[0][5][107] = int_stack + 862;
 Libderiv->deriv2_classes[0][6][107] = int_stack + 883;
 Libderiv->deriv2_classes[0][7][107] = int_stack + 911;
 Libderiv->deriv2_classes[0][5][106] = int_stack + 947;
 Libderiv->deriv2_classes[0][6][106] = int_stack + 968;
 Libderiv->deriv2_classes[0][7][106] = int_stack + 996;
 Libderiv->deriv2_classes[0][5][105] = int_stack + 1032;
 Libderiv->deriv2_classes[0][6][105] = int_stack + 1053;
 Libderiv->deriv2_classes[0][7][105] = int_stack + 1081;
 Libderiv->deriv2_classes[0][5][104] = int_stack + 1117;
 Libderiv->deriv2_classes[0][6][104] = int_stack + 1138;
 Libderiv->deriv2_classes[0][7][104] = int_stack + 1166;
 Libderiv->deriv2_classes[0][5][95] = int_stack + 1202;
 Libderiv->deriv2_classes[0][6][95] = int_stack + 1223;
 Libderiv->deriv2_classes[0][7][95] = int_stack + 1251;
 Libderiv->deriv2_classes[0][5][94] = int_stack + 1287;
 Libderiv->deriv2_classes[0][6][94] = int_stack + 1308;
 Libderiv->deriv2_classes[0][7][94] = int_stack + 1336;
 Libderiv->deriv2_classes[0][5][93] = int_stack + 1372;
 Libderiv->deriv2_classes[0][6][93] = int_stack + 1393;
 Libderiv->deriv2_classes[0][7][93] = int_stack + 1421;
 Libderiv->deriv2_classes[0][5][92] = int_stack + 1457;
 Libderiv->deriv2_classes[0][6][92] = int_stack + 1478;
 Libderiv->deriv2_classes[0][7][92] = int_stack + 1506;
 Libderiv->deriv2_classes[0][5][91] = int_stack + 1542;
 Libderiv->deriv2_classes[0][6][91] = int_stack + 1563;
 Libderiv->deriv2_classes[0][7][91] = int_stack + 1591;
 Libderiv->deriv_classes[0][5][11] = int_stack + 1627;
 Libderiv->deriv2_classes[0][5][83] = int_stack + 1648;
 Libderiv->deriv_classes[0][6][11] = int_stack + 1669;
 Libderiv->deriv2_classes[0][6][83] = int_stack + 1697;
 Libderiv->deriv2_classes[0][7][83] = int_stack + 1725;
 Libderiv->deriv_classes[0][5][10] = int_stack + 1761;
 Libderiv->deriv2_classes[0][5][82] = int_stack + 1782;
 Libderiv->deriv_classes[0][6][10] = int_stack + 1803;
 Libderiv->deriv2_classes[0][6][82] = int_stack + 1831;
 Libderiv->deriv2_classes[0][7][82] = int_stack + 1859;
 Libderiv->deriv_classes[0][5][9] = int_stack + 1895;
 Libderiv->deriv2_classes[0][5][81] = int_stack + 1916;
 Libderiv->deriv_classes[0][6][9] = int_stack + 1937;
 Libderiv->deriv2_classes[0][6][81] = int_stack + 1965;
 Libderiv->deriv2_classes[0][7][81] = int_stack + 1993;
 Libderiv->deriv_classes[0][5][8] = int_stack + 2029;
 Libderiv->deriv2_classes[0][5][80] = int_stack + 2050;
 Libderiv->deriv_classes[0][6][8] = int_stack + 2071;
 Libderiv->deriv2_classes[0][6][80] = int_stack + 2099;
 Libderiv->deriv2_classes[0][7][80] = int_stack + 2127;
 Libderiv->deriv_classes[0][5][7] = int_stack + 2163;
 Libderiv->deriv2_classes[0][5][79] = int_stack + 2184;
 Libderiv->deriv_classes[0][6][7] = int_stack + 2205;
 Libderiv->deriv2_classes[0][6][79] = int_stack + 2233;
 Libderiv->deriv2_classes[0][7][79] = int_stack + 2261;
 Libderiv->dvrr_classes[0][5] = int_stack + 2297;
 Libderiv->deriv_classes[0][5][6] = int_stack + 2318;
 Libderiv->deriv2_classes[0][5][78] = int_stack + 2339;
 Libderiv->deriv_classes[0][6][6] = int_stack + 2360;
 Libderiv->deriv2_classes[0][6][78] = int_stack + 2388;
 Libderiv->deriv2_classes[0][7][78] = int_stack + 2416;
 Libderiv->deriv2_classes[0][5][35] = int_stack + 2452;
 Libderiv->deriv2_classes[0][6][35] = int_stack + 2473;
 Libderiv->deriv2_classes[0][7][35] = int_stack + 2501;
 Libderiv->deriv2_classes[0][5][34] = int_stack + 2537;
 Libderiv->deriv2_classes[0][6][34] = int_stack + 2558;
 Libderiv->deriv2_classes[0][7][34] = int_stack + 2586;
 Libderiv->deriv2_classes[0][5][33] = int_stack + 2622;
 Libderiv->deriv2_classes[0][6][33] = int_stack + 2643;
 Libderiv->deriv2_classes[0][7][33] = int_stack + 2671;
 Libderiv->deriv2_classes[0][5][32] = int_stack + 2707;
 Libderiv->deriv2_classes[0][6][32] = int_stack + 2728;
 Libderiv->deriv2_classes[0][7][32] = int_stack + 2756;
 Libderiv->deriv2_classes[0][5][31] = int_stack + 2792;
 Libderiv->deriv2_classes[0][6][31] = int_stack + 2813;
 Libderiv->deriv2_classes[0][7][31] = int_stack + 2841;
 Libderiv->deriv_classes[0][5][2] = int_stack + 2877;
 Libderiv->deriv2_classes[0][5][30] = int_stack + 2898;
 Libderiv->deriv_classes[0][6][2] = int_stack + 2919;
 Libderiv->deriv2_classes[0][6][30] = int_stack + 2947;
 Libderiv->deriv2_classes[0][7][30] = int_stack + 2975;
 Libderiv->deriv2_classes[0][5][26] = int_stack + 3011;
 Libderiv->deriv2_classes[0][6][26] = int_stack + 3032;
 Libderiv->deriv2_classes[0][7][26] = int_stack + 3060;
 Libderiv->deriv2_classes[0][5][23] = int_stack + 3096;
 Libderiv->deriv2_classes[0][6][23] = int_stack + 3117;
 Libderiv->deriv2_classes[0][7][23] = int_stack + 3145;
 Libderiv->deriv2_classes[0][5][22] = int_stack + 3181;
 Libderiv->deriv2_classes[0][6][22] = int_stack + 3202;
 Libderiv->deriv2_classes[0][7][22] = int_stack + 3230;
 Libderiv->deriv2_classes[0][5][21] = int_stack + 3266;
 Libderiv->deriv2_classes[0][6][21] = int_stack + 3287;
 Libderiv->deriv2_classes[0][7][21] = int_stack + 3315;
 Libderiv->deriv2_classes[0][5][20] = int_stack + 3351;
 Libderiv->deriv2_classes[0][6][20] = int_stack + 3372;
 Libderiv->deriv2_classes[0][7][20] = int_stack + 3400;
 Libderiv->deriv2_classes[0][5][19] = int_stack + 3436;
 Libderiv->deriv2_classes[0][6][19] = int_stack + 3457;
 Libderiv->deriv2_classes[0][7][19] = int_stack + 3485;
 Libderiv->deriv_classes[0][5][1] = int_stack + 3521;
 Libderiv->deriv2_classes[0][5][18] = int_stack + 3542;
 Libderiv->deriv_classes[0][6][1] = int_stack + 3563;
 Libderiv->deriv2_classes[0][6][18] = int_stack + 3591;
 Libderiv->deriv2_classes[0][7][18] = int_stack + 3619;
 Libderiv->deriv2_classes[0][5][14] = int_stack + 3655;
 Libderiv->deriv2_classes[0][6][14] = int_stack + 3676;
 Libderiv->deriv2_classes[0][7][14] = int_stack + 3704;
 Libderiv->deriv2_classes[0][5][13] = int_stack + 3740;
 Libderiv->deriv2_classes[0][6][13] = int_stack + 3761;
 Libderiv->deriv2_classes[0][7][13] = int_stack + 3789;
 Libderiv->deriv2_classes[0][5][11] = int_stack + 3825;
 Libderiv->deriv2_classes[0][6][11] = int_stack + 3846;
 Libderiv->deriv2_classes[0][7][11] = int_stack + 3874;
 Libderiv->deriv2_classes[0][5][10] = int_stack + 3910;
 Libderiv->deriv2_classes[0][6][10] = int_stack + 3931;
 Libderiv->deriv2_classes[0][7][10] = int_stack + 3959;
 Libderiv->deriv2_classes[0][5][9] = int_stack + 3995;
 Libderiv->deriv2_classes[0][6][9] = int_stack + 4016;
 Libderiv->deriv2_classes[0][7][9] = int_stack + 4044;
 Libderiv->deriv2_classes[0][5][8] = int_stack + 4080;
 Libderiv->deriv2_classes[0][6][8] = int_stack + 4101;
 Libderiv->deriv2_classes[0][7][8] = int_stack + 4129;
 Libderiv->deriv2_classes[0][5][7] = int_stack + 4165;
 Libderiv->deriv2_classes[0][6][7] = int_stack + 4186;
 Libderiv->deriv2_classes[0][7][7] = int_stack + 4214;
 Libderiv->deriv_classes[0][5][0] = int_stack + 4250;
 Libderiv->deriv2_classes[0][5][6] = int_stack + 4271;
 Libderiv->deriv_classes[0][6][0] = int_stack + 4292;
 Libderiv->deriv2_classes[0][6][6] = int_stack + 4320;
 Libderiv->deriv2_classes[0][7][6] = int_stack + 4348;
 Libderiv->deriv2_classes[0][5][2] = int_stack + 4384;
 Libderiv->deriv2_classes[0][6][2] = int_stack + 4405;
 Libderiv->deriv2_classes[0][7][2] = int_stack + 4433;
 Libderiv->deriv2_classes[0][5][1] = int_stack + 4469;
 Libderiv->deriv2_classes[0][6][1] = int_stack + 4490;
 Libderiv->deriv2_classes[0][7][1] = int_stack + 4518;
 Libderiv->deriv2_classes[0][5][0] = int_stack + 4554;
 Libderiv->deriv2_classes[0][6][0] = int_stack + 4575;
 Libderiv->deriv2_classes[0][7][0] = int_stack + 4603;
 memset(int_stack,0,37112);

 Libderiv->dvrr_stack = int_stack + 8755;
 for(i=0;i<num_prim_comb;i++) {
   d12vrr_order_00hd(Libderiv, Data);
   Data++;
 }

 /*--- compute (00|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+4639,int_stack+180,int_stack+2297,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+4702,int_stack+1669,int_stack+1627, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2297,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+4765,int_stack+0,int_stack+1669, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+180,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+4849,int_stack+1803,int_stack+1761, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2297, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+4912,int_stack+36,int_stack+1803, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+180, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+0,int_stack+1937,int_stack+1895, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2297, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+4996,int_stack+72,int_stack+1937, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+180, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+5080,int_stack+2071,int_stack+2029, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2297, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+5143,int_stack+108,int_stack+2071, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+180, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+63,int_stack+2205,int_stack+2163, 0.0, zero_stack, 1.0, int_stack+2297, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+5227,int_stack+144,int_stack+2205, 0.0, zero_stack, 1.0, int_stack+180, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+5311,int_stack+2360,int_stack+2318, 1.0, int_stack+2297, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+5374,int_stack+208,int_stack+2360, 1.0, int_stack+180, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+126,int_stack+2919,int_stack+2877,1);
 /*--- compute (00|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+5458,int_stack+244,int_stack+2919,1);
 /*--- compute (00|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+189,int_stack+3563,int_stack+3521,1);
 /*--- compute (00|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+5542,int_stack+280,int_stack+3563,1);
 /*--- compute (00|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+252,int_stack+4292,int_stack+4250,1);
 /*--- compute (00|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+5626,int_stack+316,int_stack+4292,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+5710,int_stack+373,int_stack+352, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1627,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+5773,int_stack+401,int_stack+373, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1669,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+315,int_stack+458,int_stack+437, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1627, 1.0, int_stack+1761,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+5857,int_stack+486,int_stack+458, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1669, 1.0, int_stack+1803,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+378,int_stack+543,int_stack+522, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1761, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+441,int_stack+571,int_stack+543, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1803, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+525,int_stack+628,int_stack+607, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1627, 0.0, zero_stack, 1.0, int_stack+1895,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+5941,int_stack+656,int_stack+628, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1669, 0.0, zero_stack, 1.0, int_stack+1937,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+588,int_stack+713,int_stack+692, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1761, 1.0, int_stack+1895, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+6025,int_stack+741,int_stack+713, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1803, 1.0, int_stack+1937, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+651,int_stack+798,int_stack+777, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1895, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+714,int_stack+826,int_stack+798, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1937, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+798,int_stack+883,int_stack+862, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1627, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2029,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+6109,int_stack+911,int_stack+883, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1669, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2071,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+861,int_stack+968,int_stack+947, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1761, 0.0, zero_stack, 1.0, int_stack+2029, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+6193,int_stack+996,int_stack+968, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1803, 0.0, zero_stack, 1.0, int_stack+2071, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+924,int_stack+1053,int_stack+1032, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1895, 1.0, int_stack+2029, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+6277,int_stack+1081,int_stack+1053, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1937, 1.0, int_stack+2071, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+987,int_stack+1138,int_stack+1117, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+2029, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1050,int_stack+1166,int_stack+1138, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+2071, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1134,int_stack+1223,int_stack+1202, 0.0, zero_stack, 1.0, int_stack+1627, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2163,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+6361,int_stack+1251,int_stack+1223, 0.0, zero_stack, 1.0, int_stack+1669, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2205,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1197,int_stack+1308,int_stack+1287, 0.0, zero_stack, 1.0, int_stack+1761, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2163, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+6445,int_stack+1336,int_stack+1308, 0.0, zero_stack, 1.0, int_stack+1803, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2205, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1260,int_stack+1393,int_stack+1372, 0.0, zero_stack, 1.0, int_stack+1895, 0.0, zero_stack, 1.0, int_stack+2163, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+6529,int_stack+1421,int_stack+1393, 0.0, zero_stack, 1.0, int_stack+1937, 0.0, zero_stack, 1.0, int_stack+2205, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1323,int_stack+1478,int_stack+1457, 0.0, zero_stack, 1.0, int_stack+2029, 1.0, int_stack+2163, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1386,int_stack+1506,int_stack+1478, 0.0, zero_stack, 1.0, int_stack+2071, 1.0, int_stack+2205, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1470,int_stack+1563,int_stack+1542, 0.0, zero_stack, 2.0, int_stack+2163, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+6613,int_stack+1591,int_stack+1563, 0.0, zero_stack, 2.0, int_stack+2205, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1533,int_stack+1697,int_stack+1648, 1.0, int_stack+1627, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2318,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+6697,int_stack+1725,int_stack+1697, 1.0, int_stack+1669, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2360,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1596,int_stack+1831,int_stack+1782, 1.0, int_stack+1761, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2318, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1659,int_stack+1859,int_stack+1831, 1.0, int_stack+1803, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2360, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1743,int_stack+1965,int_stack+1916, 1.0, int_stack+1895, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2318, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1806,int_stack+1993,int_stack+1965, 1.0, int_stack+1937, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2360, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1890,int_stack+2099,int_stack+2050, 1.0, int_stack+2029, 0.0, zero_stack, 1.0, int_stack+2318, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1953,int_stack+2127,int_stack+2099, 1.0, int_stack+2071, 0.0, zero_stack, 1.0, int_stack+2360, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2037,int_stack+2233,int_stack+2184, 1.0, int_stack+2163, 1.0, int_stack+2318, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2100,int_stack+2261,int_stack+2233, 1.0, int_stack+2205, 1.0, int_stack+2360, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2184,int_stack+2388,int_stack+2339, 2.0, int_stack+2318, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2247,int_stack+2416,int_stack+2388, 2.0, int_stack+2360, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2331,int_stack+2473,int_stack+2452, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2877,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+6781,int_stack+2501,int_stack+2473, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2919,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2394,int_stack+2558,int_stack+2537, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2877, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2457,int_stack+2586,int_stack+2558, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2919, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2541,int_stack+2643,int_stack+2622, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2877, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+6865,int_stack+2671,int_stack+2643, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2919, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2604,int_stack+2728,int_stack+2707, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2877, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+6949,int_stack+2756,int_stack+2728, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2919, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2667,int_stack+2813,int_stack+2792, 0.0, zero_stack, 1.0, int_stack+2877, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+7033,int_stack+2841,int_stack+2813, 0.0, zero_stack, 1.0, int_stack+2919, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2730,int_stack+2947,int_stack+2898, 1.0, int_stack+2877, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2793,int_stack+2975,int_stack+2947, 1.0, int_stack+2919, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+2877,int_stack+3032,int_stack+3011,1);
 /*--- compute (00|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+2940,int_stack+3060,int_stack+3032,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+3024,int_stack+3117,int_stack+3096, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3521,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+7117,int_stack+3145,int_stack+3117, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3563,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+3087,int_stack+3202,int_stack+3181, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3521, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+7201,int_stack+3230,int_stack+3202, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3563, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+3150,int_stack+3287,int_stack+3266, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3521, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+7285,int_stack+3315,int_stack+3287, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3563, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+3213,int_stack+3372,int_stack+3351, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3521, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+3276,int_stack+3400,int_stack+3372, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3563, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+3360,int_stack+3457,int_stack+3436, 0.0, zero_stack, 1.0, int_stack+3521, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+7369,int_stack+3485,int_stack+3457, 0.0, zero_stack, 1.0, int_stack+3563, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+3423,int_stack+3591,int_stack+3542, 1.0, int_stack+3521, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+7453,int_stack+3619,int_stack+3591, 1.0, int_stack+3563, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+3486,int_stack+3676,int_stack+3655,1);
 /*--- compute (00|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+3549,int_stack+3704,int_stack+3676,1);
 /*--- compute (00|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+3633,int_stack+3761,int_stack+3740,1);
 /*--- compute (00|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+7537,int_stack+3789,int_stack+3761,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+3696,int_stack+3846,int_stack+3825, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4250,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+3759,int_stack+3874,int_stack+3846, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4292,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+3843,int_stack+3931,int_stack+3910, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4250, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+7621,int_stack+3959,int_stack+3931, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4292, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+3906,int_stack+4016,int_stack+3995, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4250, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+7705,int_stack+4044,int_stack+4016, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4292, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+3969,int_stack+4101,int_stack+4080, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4250, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+7789,int_stack+4129,int_stack+4101, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4292, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+4032,int_stack+4186,int_stack+4165, 0.0, zero_stack, 1.0, int_stack+4250, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+4095,int_stack+4214,int_stack+4186, 0.0, zero_stack, 1.0, int_stack+4292, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+4179,int_stack+4320,int_stack+4271, 1.0, int_stack+4250, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+7873,int_stack+4348,int_stack+4320, 1.0, int_stack+4292, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+4242,int_stack+4405,int_stack+4384,1);
 /*--- compute (00|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+4305,int_stack+4433,int_stack+4405,1);
 /*--- compute (00|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+4389,int_stack+4490,int_stack+4469,1);
 /*--- compute (00|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+7957,int_stack+4518,int_stack+4490,1);
 /*--- compute (00|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+4452,int_stack+4575,int_stack+4554,1);
 /*--- compute (00|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+8041,int_stack+4603,int_stack+4575,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+8125,int_stack+4765,int_stack+4702, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4639,1);
     Libderiv->ABCD[11] = int_stack + 8125;
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+8251,int_stack+4912,int_stack+4849, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4639, 0.0, zero_stack,1);
     Libderiv->ABCD[10] = int_stack + 8251;
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+8377,int_stack+4996,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4639, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[9] = int_stack + 8377;
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+4912,int_stack+5143,int_stack+5080, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4639, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[8] = int_stack + 4912;
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+8503,int_stack+5227,int_stack+63, 0.0, zero_stack, 1.0, int_stack+4639, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[7] = int_stack + 8503;
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+5143,int_stack+5374,int_stack+5311, 1.0, int_stack+4639, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[6] = int_stack + 5143;
 /*--- compute (00|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+4515,int_stack+5458,int_stack+126,1);
     Libderiv->ABCD[2] = int_stack + 4515;
 /*--- compute (00|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+5374,int_stack+5542,int_stack+189,1);
     Libderiv->ABCD[1] = int_stack + 5374;
 /*--- compute (00|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+5500,int_stack+5626,int_stack+252,1);
     Libderiv->ABCD[0] = int_stack + 5500;
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+8629,int_stack+5773,int_stack+5710, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+4702,1);
     Libderiv->ABCD[155] = int_stack + 8629;
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+5626,int_stack+5857,int_stack+315, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4702, 1.0, int_stack+4849,1);
     Libderiv->ABCD[143] = int_stack + 5626;
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+5752,int_stack+441,int_stack+378, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+4849, 0.0, zero_stack,1);
     Libderiv->ABCD[142] = int_stack + 5752;
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+315,int_stack+5941,int_stack+525, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4702, 0.0, zero_stack, 1.0, int_stack+0,1);
     Libderiv->ABCD[131] = int_stack + 315;
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+441,int_stack+6025,int_stack+588, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4849, 1.0, int_stack+0, 0.0, zero_stack,1);
     Libderiv->ABCD[130] = int_stack + 441;
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+5878,int_stack+714,int_stack+651, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[129] = int_stack + 5878;
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+567,int_stack+6109,int_stack+798, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4702, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5080,1);
     Libderiv->ABCD[119] = int_stack + 567;
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+693,int_stack+6193,int_stack+861, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4849, 0.0, zero_stack, 1.0, int_stack+5080, 0.0, zero_stack,1);
     Libderiv->ABCD[118] = int_stack + 693;
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+6004,int_stack+6277,int_stack+924, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+0, 1.0, int_stack+5080, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[117] = int_stack + 6004;
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+819,int_stack+1050,int_stack+987, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+5080, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[116] = int_stack + 819;
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+945,int_stack+6361,int_stack+1134, 0.0, zero_stack, 1.0, int_stack+4702, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+63,1);
     Libderiv->ABCD[107] = int_stack + 945;
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1071,int_stack+6445,int_stack+1197, 0.0, zero_stack, 1.0, int_stack+4849, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+63, 0.0, zero_stack,1);
     Libderiv->ABCD[106] = int_stack + 1071;
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+6130,int_stack+6529,int_stack+1260, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack, 1.0, int_stack+63, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[105] = int_stack + 6130;
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1197,int_stack+1386,int_stack+1323, 0.0, zero_stack, 1.0, int_stack+5080, 1.0, int_stack+63, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[104] = int_stack + 1197;
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1323,int_stack+6613,int_stack+1470, 0.0, zero_stack, 2.0, int_stack+63, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[103] = int_stack + 1323;
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+6256,int_stack+6697,int_stack+1533, 1.0, int_stack+4702, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5311,1);
     Libderiv->ABCD[95] = int_stack + 6256;
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1449,int_stack+1659,int_stack+1596, 1.0, int_stack+4849, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5311, 0.0, zero_stack,1);
     Libderiv->ABCD[94] = int_stack + 1449;
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1575,int_stack+1806,int_stack+1743, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5311, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[93] = int_stack + 1575;
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1701,int_stack+1953,int_stack+1890, 1.0, int_stack+5080, 0.0, zero_stack, 1.0, int_stack+5311, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[92] = int_stack + 1701;
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1827,int_stack+2100,int_stack+2037, 1.0, int_stack+63, 1.0, int_stack+5311, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[91] = int_stack + 1827;
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+0,int_stack+2247,int_stack+2184, 2.0, int_stack+5311, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[90] = int_stack + 0;
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1953,int_stack+6781,int_stack+2331, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+126,1);
     Libderiv->ABCD[47] = int_stack + 1953;
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2079,int_stack+2457,int_stack+2394, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+126, 0.0, zero_stack,1);
     Libderiv->ABCD[46] = int_stack + 2079;
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2205,int_stack+6865,int_stack+2541, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+126, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[45] = int_stack + 2205;
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2331,int_stack+6949,int_stack+2604, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+126, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[44] = int_stack + 2331;
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2457,int_stack+7033,int_stack+2667, 0.0, zero_stack, 1.0, int_stack+126, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[43] = int_stack + 2457;
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2583,int_stack+2793,int_stack+2730, 1.0, int_stack+126, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[42] = int_stack + 2583;
 /*--- compute (00|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+2709,int_stack+2940,int_stack+2877,1);
     Libderiv->ABCD[38] = int_stack + 2709;
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2835,int_stack+7117,int_stack+3024, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+189,1);
     Libderiv->ABCD[35] = int_stack + 2835;
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2961,int_stack+7201,int_stack+3087, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+189, 0.0, zero_stack,1);
     Libderiv->ABCD[34] = int_stack + 2961;
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+6382,int_stack+7285,int_stack+3150, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+189, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[33] = int_stack + 6382;
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+3087,int_stack+3276,int_stack+3213, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+189, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[32] = int_stack + 3087;
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+3213,int_stack+7369,int_stack+3360, 0.0, zero_stack, 1.0, int_stack+189, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[31] = int_stack + 3213;
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+6508,int_stack+7453,int_stack+3423, 1.0, int_stack+189, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[30] = int_stack + 6508;
 /*--- compute (00|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+126,int_stack+3549,int_stack+3486,1);
     Libderiv->ABCD[26] = int_stack + 126;
 /*--- compute (00|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+3339,int_stack+7537,int_stack+3633,1);
     Libderiv->ABCD[25] = int_stack + 3339;
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+3465,int_stack+3759,int_stack+3696, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+252,1);
     Libderiv->ABCD[23] = int_stack + 3465;
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+3591,int_stack+7621,int_stack+3843, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+252, 0.0, zero_stack,1);
     Libderiv->ABCD[22] = int_stack + 3591;
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+3717,int_stack+7705,int_stack+3906, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+252, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[21] = int_stack + 3717;
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+3843,int_stack+7789,int_stack+3969, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+252, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[20] = int_stack + 3843;
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+6634,int_stack+4095,int_stack+4032, 0.0, zero_stack, 1.0, int_stack+252, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[19] = int_stack + 6634;
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+3969,int_stack+7873,int_stack+4179, 1.0, int_stack+252, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[18] = int_stack + 3969;
 /*--- compute (00|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+4095,int_stack+4305,int_stack+4242,1);
     Libderiv->ABCD[14] = int_stack + 4095;
 /*--- compute (00|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+4221,int_stack+7957,int_stack+4389,1);
     Libderiv->ABCD[13] = int_stack + 4221;
 /*--- compute (00|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+6760,int_stack+8041,int_stack+4452,1);
     Libderiv->ABCD[12] = int_stack + 6760;

}
