/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include <libint/libint.h>
#include "libderiv.h"
#include <libint/hrr_header.h>

#include "d1hrr_header.h"

extern void d12vrr_order_ffhp(Libderiv_t *, prim_data *);

  /* Computes derivatives of (ff|hp) integrals */

void d12hrr_order_ffhp(Libderiv_t *Libderiv, int num_prim_comb)
{
 prim_data *Data = Libderiv->PrimQuartet;
 double *int_stack = Libderiv->int_stack;
 double *zero_stack = Libderiv->zero_stack;
 int i,j;
 double tmp, *target;

 Libderiv->deriv_classes[6][6][11] = int_stack + 0;
 Libderiv->deriv_classes[6][6][10] = int_stack + 784;
 Libderiv->deriv_classes[6][6][9] = int_stack + 1568;
 Libderiv->deriv_classes[6][6][8] = int_stack + 2352;
 Libderiv->deriv_classes[6][6][7] = int_stack + 3136;
 Libderiv->dvrr_classes[6][5] = int_stack + 3920;
 Libderiv->deriv_classes[6][6][6] = int_stack + 4508;
 Libderiv->deriv_classes[6][6][2] = int_stack + 5292;
 Libderiv->deriv_classes[6][6][1] = int_stack + 6076;
 Libderiv->dvrr_classes[5][6] = int_stack + 6860;
 Libderiv->deriv_classes[6][6][0] = int_stack + 7448;
 Libderiv->deriv2_classes[3][5][143] = int_stack + 8232;
 Libderiv->deriv2_classes[3][6][143] = int_stack + 8442;
 Libderiv->deriv2_classes[4][5][143] = int_stack + 8722;
 Libderiv->deriv2_classes[4][6][143] = int_stack + 9037;
 Libderiv->deriv2_classes[5][5][143] = int_stack + 9457;
 Libderiv->deriv2_classes[5][6][143] = int_stack + 9898;
 Libderiv->deriv2_classes[6][5][143] = int_stack + 10486;
 Libderiv->deriv2_classes[6][6][143] = int_stack + 11074;
 Libderiv->deriv2_classes[3][5][131] = int_stack + 11858;
 Libderiv->deriv2_classes[3][6][131] = int_stack + 12068;
 Libderiv->deriv2_classes[4][5][131] = int_stack + 12348;
 Libderiv->deriv2_classes[4][6][131] = int_stack + 12663;
 Libderiv->deriv2_classes[5][5][131] = int_stack + 13083;
 Libderiv->deriv2_classes[5][6][131] = int_stack + 13524;
 Libderiv->deriv2_classes[6][5][131] = int_stack + 14112;
 Libderiv->deriv2_classes[6][6][131] = int_stack + 14700;
 Libderiv->deriv2_classes[3][5][130] = int_stack + 15484;
 Libderiv->deriv2_classes[3][6][130] = int_stack + 15694;
 Libderiv->deriv2_classes[4][5][130] = int_stack + 15974;
 Libderiv->deriv2_classes[4][6][130] = int_stack + 16289;
 Libderiv->deriv2_classes[5][5][130] = int_stack + 16709;
 Libderiv->deriv2_classes[5][6][130] = int_stack + 17150;
 Libderiv->deriv2_classes[6][5][130] = int_stack + 17738;
 Libderiv->deriv2_classes[6][6][130] = int_stack + 18326;
 Libderiv->deriv2_classes[3][5][119] = int_stack + 19110;
 Libderiv->deriv2_classes[3][6][119] = int_stack + 19320;
 Libderiv->deriv2_classes[4][5][119] = int_stack + 19600;
 Libderiv->deriv2_classes[4][6][119] = int_stack + 19915;
 Libderiv->deriv2_classes[5][5][119] = int_stack + 20335;
 Libderiv->deriv2_classes[5][6][119] = int_stack + 20776;
 Libderiv->deriv2_classes[6][5][119] = int_stack + 21364;
 Libderiv->deriv2_classes[6][6][119] = int_stack + 21952;
 Libderiv->deriv2_classes[3][5][118] = int_stack + 22736;
 Libderiv->deriv2_classes[3][6][118] = int_stack + 22946;
 Libderiv->deriv2_classes[4][5][118] = int_stack + 23226;
 Libderiv->deriv2_classes[4][6][118] = int_stack + 23541;
 Libderiv->deriv2_classes[5][5][118] = int_stack + 23961;
 Libderiv->deriv2_classes[5][6][118] = int_stack + 24402;
 Libderiv->deriv2_classes[6][5][118] = int_stack + 24990;
 Libderiv->deriv2_classes[6][6][118] = int_stack + 25578;
 Libderiv->deriv2_classes[3][5][117] = int_stack + 26362;
 Libderiv->deriv2_classes[3][6][117] = int_stack + 26572;
 Libderiv->deriv2_classes[4][5][117] = int_stack + 26852;
 Libderiv->deriv2_classes[4][6][117] = int_stack + 27167;
 Libderiv->deriv2_classes[5][5][117] = int_stack + 27587;
 Libderiv->deriv2_classes[5][6][117] = int_stack + 28028;
 Libderiv->deriv2_classes[6][5][117] = int_stack + 28616;
 Libderiv->deriv2_classes[6][6][117] = int_stack + 29204;
 Libderiv->deriv2_classes[3][5][107] = int_stack + 29988;
 Libderiv->deriv2_classes[3][6][107] = int_stack + 30198;
 Libderiv->deriv2_classes[4][5][107] = int_stack + 30478;
 Libderiv->deriv2_classes[4][6][107] = int_stack + 30793;
 Libderiv->deriv2_classes[5][5][107] = int_stack + 31213;
 Libderiv->deriv2_classes[5][6][107] = int_stack + 31654;
 Libderiv->deriv2_classes[6][5][107] = int_stack + 32242;
 Libderiv->deriv2_classes[6][6][107] = int_stack + 32830;
 Libderiv->deriv2_classes[3][5][106] = int_stack + 33614;
 Libderiv->deriv2_classes[3][6][106] = int_stack + 33824;
 Libderiv->deriv2_classes[4][5][106] = int_stack + 34104;
 Libderiv->deriv2_classes[4][6][106] = int_stack + 34419;
 Libderiv->deriv2_classes[5][5][106] = int_stack + 34839;
 Libderiv->deriv2_classes[5][6][106] = int_stack + 35280;
 Libderiv->deriv2_classes[6][5][106] = int_stack + 35868;
 Libderiv->deriv2_classes[6][6][106] = int_stack + 36456;
 Libderiv->deriv2_classes[3][5][105] = int_stack + 37240;
 Libderiv->deriv2_classes[3][6][105] = int_stack + 37450;
 Libderiv->deriv2_classes[4][5][105] = int_stack + 37730;
 Libderiv->deriv2_classes[4][6][105] = int_stack + 38045;
 Libderiv->deriv2_classes[5][5][105] = int_stack + 38465;
 Libderiv->deriv2_classes[5][6][105] = int_stack + 38906;
 Libderiv->deriv2_classes[6][5][105] = int_stack + 39494;
 Libderiv->deriv2_classes[6][6][105] = int_stack + 40082;
 Libderiv->deriv2_classes[3][5][104] = int_stack + 40866;
 Libderiv->deriv2_classes[3][6][104] = int_stack + 41076;
 Libderiv->deriv2_classes[4][5][104] = int_stack + 41356;
 Libderiv->deriv2_classes[4][6][104] = int_stack + 41671;
 Libderiv->deriv2_classes[5][5][104] = int_stack + 42091;
 Libderiv->deriv2_classes[5][6][104] = int_stack + 42532;
 Libderiv->deriv2_classes[6][5][104] = int_stack + 43120;
 Libderiv->deriv2_classes[6][6][104] = int_stack + 43708;
 Libderiv->deriv2_classes[3][5][95] = int_stack + 44492;
 Libderiv->deriv2_classes[3][6][95] = int_stack + 44702;
 Libderiv->deriv2_classes[4][5][95] = int_stack + 44982;
 Libderiv->deriv2_classes[4][6][95] = int_stack + 45297;
 Libderiv->deriv2_classes[5][5][95] = int_stack + 45717;
 Libderiv->deriv2_classes[5][6][95] = int_stack + 46158;
 Libderiv->deriv2_classes[6][5][95] = int_stack + 46746;
 Libderiv->deriv2_classes[6][6][95] = int_stack + 47334;
 Libderiv->deriv2_classes[3][5][94] = int_stack + 48118;
 Libderiv->deriv2_classes[3][6][94] = int_stack + 48328;
 Libderiv->deriv2_classes[4][5][94] = int_stack + 48608;
 Libderiv->deriv2_classes[4][6][94] = int_stack + 48923;
 Libderiv->deriv2_classes[5][5][94] = int_stack + 49343;
 Libderiv->deriv2_classes[5][6][94] = int_stack + 49784;
 Libderiv->deriv2_classes[6][5][94] = int_stack + 50372;
 Libderiv->deriv2_classes[6][6][94] = int_stack + 50960;
 Libderiv->deriv2_classes[3][5][93] = int_stack + 51744;
 Libderiv->deriv2_classes[3][6][93] = int_stack + 51954;
 Libderiv->deriv2_classes[4][5][93] = int_stack + 52234;
 Libderiv->deriv2_classes[4][6][93] = int_stack + 52549;
 Libderiv->deriv2_classes[5][5][93] = int_stack + 52969;
 Libderiv->deriv2_classes[5][6][93] = int_stack + 53410;
 Libderiv->deriv2_classes[6][5][93] = int_stack + 53998;
 Libderiv->deriv2_classes[6][6][93] = int_stack + 54586;
 Libderiv->deriv2_classes[3][5][92] = int_stack + 55370;
 Libderiv->deriv2_classes[3][6][92] = int_stack + 55580;
 Libderiv->deriv2_classes[4][5][92] = int_stack + 55860;
 Libderiv->deriv2_classes[4][6][92] = int_stack + 56175;
 Libderiv->deriv2_classes[5][5][92] = int_stack + 56595;
 Libderiv->deriv2_classes[5][6][92] = int_stack + 57036;
 Libderiv->deriv2_classes[6][5][92] = int_stack + 57624;
 Libderiv->deriv2_classes[6][6][92] = int_stack + 58212;
 Libderiv->deriv2_classes[3][5][91] = int_stack + 58996;
 Libderiv->deriv2_classes[3][6][91] = int_stack + 59206;
 Libderiv->deriv2_classes[4][5][91] = int_stack + 59486;
 Libderiv->deriv2_classes[4][6][91] = int_stack + 59801;
 Libderiv->deriv2_classes[5][5][91] = int_stack + 60221;
 Libderiv->deriv2_classes[5][6][91] = int_stack + 60662;
 Libderiv->deriv2_classes[6][5][91] = int_stack + 61250;
 Libderiv->deriv2_classes[6][6][91] = int_stack + 61838;
 Libderiv->deriv2_classes[3][5][83] = int_stack + 62622;
 Libderiv->deriv2_classes[3][6][83] = int_stack + 62832;
 Libderiv->deriv2_classes[4][5][83] = int_stack + 63112;
 Libderiv->deriv2_classes[4][6][83] = int_stack + 63427;
 Libderiv->deriv2_classes[5][5][83] = int_stack + 63847;
 Libderiv->deriv2_classes[5][6][83] = int_stack + 64288;
 Libderiv->deriv_classes[6][5][11] = int_stack + 64876;
 Libderiv->deriv2_classes[6][5][83] = int_stack + 65464;
 Libderiv->deriv2_classes[6][6][83] = int_stack + 66052;
 Libderiv->deriv2_classes[3][5][82] = int_stack + 66836;
 Libderiv->deriv2_classes[3][6][82] = int_stack + 67046;
 Libderiv->deriv2_classes[4][5][82] = int_stack + 67326;
 Libderiv->deriv2_classes[4][6][82] = int_stack + 67641;
 Libderiv->deriv2_classes[5][5][82] = int_stack + 68061;
 Libderiv->deriv2_classes[5][6][82] = int_stack + 68502;
 Libderiv->deriv_classes[6][5][10] = int_stack + 69090;
 Libderiv->deriv2_classes[6][5][82] = int_stack + 69678;
 Libderiv->deriv2_classes[6][6][82] = int_stack + 70266;
 Libderiv->deriv2_classes[3][5][81] = int_stack + 71050;
 Libderiv->deriv2_classes[3][6][81] = int_stack + 71260;
 Libderiv->deriv2_classes[4][5][81] = int_stack + 71540;
 Libderiv->deriv2_classes[4][6][81] = int_stack + 71855;
 Libderiv->deriv2_classes[5][5][81] = int_stack + 72275;
 Libderiv->deriv2_classes[5][6][81] = int_stack + 72716;
 Libderiv->deriv_classes[6][5][9] = int_stack + 73304;
 Libderiv->deriv2_classes[6][5][81] = int_stack + 73892;
 Libderiv->deriv2_classes[6][6][81] = int_stack + 74480;
 Libderiv->deriv2_classes[3][5][80] = int_stack + 75264;
 Libderiv->deriv2_classes[3][6][80] = int_stack + 75474;
 Libderiv->deriv2_classes[4][5][80] = int_stack + 75754;
 Libderiv->deriv2_classes[4][6][80] = int_stack + 76069;
 Libderiv->deriv2_classes[5][5][80] = int_stack + 76489;
 Libderiv->deriv2_classes[5][6][80] = int_stack + 76930;
 Libderiv->deriv_classes[6][5][8] = int_stack + 77518;
 Libderiv->deriv2_classes[6][5][80] = int_stack + 78106;
 Libderiv->deriv2_classes[6][6][80] = int_stack + 78694;
 Libderiv->deriv2_classes[3][5][79] = int_stack + 79478;
 Libderiv->deriv2_classes[3][6][79] = int_stack + 79688;
 Libderiv->deriv2_classes[4][5][79] = int_stack + 79968;
 Libderiv->deriv2_classes[4][6][79] = int_stack + 80283;
 Libderiv->deriv2_classes[5][5][79] = int_stack + 80703;
 Libderiv->deriv2_classes[5][6][79] = int_stack + 81144;
 Libderiv->deriv_classes[6][5][7] = int_stack + 81732;
 Libderiv->deriv2_classes[6][5][79] = int_stack + 82320;
 Libderiv->deriv2_classes[6][6][79] = int_stack + 82908;
 Libderiv->deriv2_classes[3][5][78] = int_stack + 83692;
 Libderiv->deriv2_classes[3][6][78] = int_stack + 83902;
 Libderiv->deriv2_classes[4][5][78] = int_stack + 84182;
 Libderiv->deriv2_classes[4][6][78] = int_stack + 84497;
 Libderiv->deriv2_classes[5][5][78] = int_stack + 84917;
 Libderiv->deriv2_classes[5][6][78] = int_stack + 85358;
 Libderiv->deriv_classes[6][5][6] = int_stack + 85946;
 Libderiv->deriv2_classes[6][5][78] = int_stack + 86534;
 Libderiv->deriv2_classes[6][6][78] = int_stack + 87122;
 Libderiv->deriv2_classes[3][5][35] = int_stack + 87906;
 Libderiv->deriv2_classes[3][6][35] = int_stack + 88116;
 Libderiv->deriv2_classes[4][5][35] = int_stack + 88396;
 Libderiv->deriv2_classes[4][6][35] = int_stack + 88711;
 Libderiv->deriv2_classes[5][5][35] = int_stack + 89131;
 Libderiv->deriv2_classes[5][6][35] = int_stack + 89572;
 Libderiv->deriv2_classes[6][5][35] = int_stack + 90160;
 Libderiv->deriv2_classes[6][6][35] = int_stack + 90748;
 Libderiv->deriv2_classes[3][5][34] = int_stack + 91532;
 Libderiv->deriv2_classes[3][6][34] = int_stack + 91742;
 Libderiv->deriv2_classes[4][5][34] = int_stack + 92022;
 Libderiv->deriv2_classes[4][6][34] = int_stack + 92337;
 Libderiv->deriv2_classes[5][5][34] = int_stack + 92757;
 Libderiv->deriv2_classes[5][6][34] = int_stack + 93198;
 Libderiv->deriv2_classes[6][5][34] = int_stack + 93786;
 Libderiv->deriv2_classes[6][6][34] = int_stack + 94374;
 Libderiv->deriv2_classes[3][5][33] = int_stack + 95158;
 Libderiv->deriv2_classes[3][6][33] = int_stack + 95368;
 Libderiv->deriv2_classes[4][5][33] = int_stack + 95648;
 Libderiv->deriv2_classes[4][6][33] = int_stack + 95963;
 Libderiv->deriv2_classes[5][5][33] = int_stack + 96383;
 Libderiv->deriv2_classes[5][6][33] = int_stack + 96824;
 Libderiv->deriv2_classes[6][5][33] = int_stack + 97412;
 Libderiv->deriv2_classes[6][6][33] = int_stack + 98000;
 Libderiv->deriv2_classes[3][5][32] = int_stack + 98784;
 Libderiv->deriv2_classes[3][6][32] = int_stack + 98994;
 Libderiv->deriv2_classes[4][5][32] = int_stack + 99274;
 Libderiv->deriv2_classes[4][6][32] = int_stack + 99589;
 Libderiv->deriv2_classes[5][5][32] = int_stack + 100009;
 Libderiv->deriv2_classes[5][6][32] = int_stack + 100450;
 Libderiv->deriv2_classes[6][5][32] = int_stack + 101038;
 Libderiv->deriv2_classes[6][6][32] = int_stack + 101626;
 Libderiv->deriv2_classes[3][5][31] = int_stack + 102410;
 Libderiv->deriv2_classes[3][6][31] = int_stack + 102620;
 Libderiv->deriv2_classes[4][5][31] = int_stack + 102900;
 Libderiv->deriv2_classes[4][6][31] = int_stack + 103215;
 Libderiv->deriv2_classes[5][5][31] = int_stack + 103635;
 Libderiv->deriv2_classes[5][6][31] = int_stack + 104076;
 Libderiv->deriv2_classes[6][5][31] = int_stack + 104664;
 Libderiv->deriv2_classes[6][6][31] = int_stack + 105252;
 Libderiv->deriv2_classes[3][5][30] = int_stack + 106036;
 Libderiv->deriv2_classes[3][6][30] = int_stack + 106246;
 Libderiv->deriv2_classes[4][5][30] = int_stack + 106526;
 Libderiv->deriv2_classes[4][6][30] = int_stack + 106841;
 Libderiv->deriv2_classes[5][5][30] = int_stack + 107261;
 Libderiv->deriv2_classes[5][6][30] = int_stack + 107702;
 Libderiv->deriv_classes[6][5][2] = int_stack + 108290;
 Libderiv->deriv2_classes[6][5][30] = int_stack + 108878;
 Libderiv->deriv2_classes[6][6][30] = int_stack + 109466;
 Libderiv->deriv2_classes[3][5][26] = int_stack + 110250;
 Libderiv->deriv2_classes[3][6][26] = int_stack + 110460;
 Libderiv->deriv2_classes[4][5][26] = int_stack + 110740;
 Libderiv->deriv2_classes[4][6][26] = int_stack + 111055;
 Libderiv->deriv2_classes[5][5][26] = int_stack + 111475;
 Libderiv->deriv2_classes[5][6][26] = int_stack + 111916;
 Libderiv->deriv2_classes[6][5][26] = int_stack + 112504;
 Libderiv->deriv2_classes[6][6][26] = int_stack + 113092;
 Libderiv->deriv2_classes[3][5][23] = int_stack + 113876;
 Libderiv->deriv2_classes[3][6][23] = int_stack + 114086;
 Libderiv->deriv2_classes[4][5][23] = int_stack + 114366;
 Libderiv->deriv2_classes[4][6][23] = int_stack + 114681;
 Libderiv->deriv2_classes[5][5][23] = int_stack + 115101;
 Libderiv->deriv2_classes[5][6][23] = int_stack + 115542;
 Libderiv->deriv2_classes[6][5][23] = int_stack + 116130;
 Libderiv->deriv2_classes[6][6][23] = int_stack + 116718;
 Libderiv->deriv2_classes[3][5][22] = int_stack + 117502;
 Libderiv->deriv2_classes[3][6][22] = int_stack + 117712;
 Libderiv->deriv2_classes[4][5][22] = int_stack + 117992;
 Libderiv->deriv2_classes[4][6][22] = int_stack + 118307;
 Libderiv->deriv2_classes[5][5][22] = int_stack + 118727;
 Libderiv->deriv2_classes[5][6][22] = int_stack + 119168;
 Libderiv->deriv2_classes[6][5][22] = int_stack + 119756;
 Libderiv->deriv2_classes[6][6][22] = int_stack + 120344;
 Libderiv->deriv2_classes[3][5][21] = int_stack + 121128;
 Libderiv->deriv2_classes[3][6][21] = int_stack + 121338;
 Libderiv->deriv2_classes[4][5][21] = int_stack + 121618;
 Libderiv->deriv2_classes[4][6][21] = int_stack + 121933;
 Libderiv->deriv2_classes[5][5][21] = int_stack + 122353;
 Libderiv->deriv2_classes[5][6][21] = int_stack + 122794;
 Libderiv->deriv2_classes[6][5][21] = int_stack + 123382;
 Libderiv->deriv2_classes[6][6][21] = int_stack + 123970;
 Libderiv->deriv2_classes[3][5][20] = int_stack + 124754;
 Libderiv->deriv2_classes[3][6][20] = int_stack + 124964;
 Libderiv->deriv2_classes[4][5][20] = int_stack + 125244;
 Libderiv->deriv2_classes[4][6][20] = int_stack + 125559;
 Libderiv->deriv2_classes[5][5][20] = int_stack + 125979;
 Libderiv->deriv2_classes[5][6][20] = int_stack + 126420;
 Libderiv->deriv2_classes[6][5][20] = int_stack + 127008;
 Libderiv->deriv2_classes[6][6][20] = int_stack + 127596;
 Libderiv->deriv2_classes[3][5][19] = int_stack + 128380;
 Libderiv->deriv2_classes[3][6][19] = int_stack + 128590;
 Libderiv->deriv2_classes[4][5][19] = int_stack + 128870;
 Libderiv->deriv2_classes[4][6][19] = int_stack + 129185;
 Libderiv->deriv2_classes[5][5][19] = int_stack + 129605;
 Libderiv->deriv2_classes[5][6][19] = int_stack + 130046;
 Libderiv->deriv2_classes[6][5][19] = int_stack + 130634;
 Libderiv->deriv2_classes[6][6][19] = int_stack + 131222;
 Libderiv->deriv2_classes[3][5][18] = int_stack + 132006;
 Libderiv->deriv2_classes[3][6][18] = int_stack + 132216;
 Libderiv->deriv2_classes[4][5][18] = int_stack + 132496;
 Libderiv->deriv2_classes[4][6][18] = int_stack + 132811;
 Libderiv->deriv2_classes[5][5][18] = int_stack + 133231;
 Libderiv->deriv2_classes[5][6][18] = int_stack + 133672;
 Libderiv->deriv_classes[6][5][1] = int_stack + 134260;
 Libderiv->deriv2_classes[6][5][18] = int_stack + 134848;
 Libderiv->deriv2_classes[6][6][18] = int_stack + 135436;
 Libderiv->deriv2_classes[3][5][14] = int_stack + 136220;
 Libderiv->deriv2_classes[3][6][14] = int_stack + 136430;
 Libderiv->deriv2_classes[4][5][14] = int_stack + 136710;
 Libderiv->deriv2_classes[4][6][14] = int_stack + 137025;
 Libderiv->deriv2_classes[5][5][14] = int_stack + 137445;
 Libderiv->deriv2_classes[5][6][14] = int_stack + 137886;
 Libderiv->deriv2_classes[6][5][14] = int_stack + 138474;
 Libderiv->deriv2_classes[6][6][14] = int_stack + 139062;
 Libderiv->deriv2_classes[3][5][13] = int_stack + 139846;
 Libderiv->deriv2_classes[3][6][13] = int_stack + 140056;
 Libderiv->deriv2_classes[4][5][13] = int_stack + 140336;
 Libderiv->deriv2_classes[4][6][13] = int_stack + 140651;
 Libderiv->deriv2_classes[5][5][13] = int_stack + 141071;
 Libderiv->deriv2_classes[5][6][13] = int_stack + 141512;
 Libderiv->deriv2_classes[6][5][13] = int_stack + 142100;
 Libderiv->deriv2_classes[6][6][13] = int_stack + 142688;
 Libderiv->deriv_classes[3][5][11] = int_stack + 143472;
 Libderiv->deriv_classes[3][6][11] = int_stack + 143682;
 Libderiv->deriv2_classes[3][5][11] = int_stack + 143962;
 Libderiv->deriv2_classes[3][6][11] = int_stack + 144172;
 Libderiv->deriv_classes[4][5][11] = int_stack + 144452;
 Libderiv->deriv_classes[4][6][11] = int_stack + 144767;
 Libderiv->deriv2_classes[4][5][11] = int_stack + 145187;
 Libderiv->deriv2_classes[4][6][11] = int_stack + 145502;
 Libderiv->deriv_classes[5][5][11] = int_stack + 145922;
 Libderiv->deriv_classes[5][6][11] = int_stack + 146363;
 Libderiv->deriv2_classes[5][5][11] = int_stack + 146951;
 Libderiv->deriv2_classes[5][6][11] = int_stack + 147392;
 Libderiv->deriv2_classes[6][5][11] = int_stack + 147980;
 Libderiv->deriv2_classes[6][6][11] = int_stack + 148568;
 Libderiv->deriv_classes[3][5][10] = int_stack + 149352;
 Libderiv->deriv_classes[3][6][10] = int_stack + 149562;
 Libderiv->deriv2_classes[3][5][10] = int_stack + 149842;
 Libderiv->deriv2_classes[3][6][10] = int_stack + 150052;
 Libderiv->deriv_classes[4][5][10] = int_stack + 150332;
 Libderiv->deriv_classes[4][6][10] = int_stack + 150647;
 Libderiv->deriv2_classes[4][5][10] = int_stack + 151067;
 Libderiv->deriv2_classes[4][6][10] = int_stack + 151382;
 Libderiv->deriv_classes[5][5][10] = int_stack + 151802;
 Libderiv->deriv_classes[5][6][10] = int_stack + 152243;
 Libderiv->deriv2_classes[5][5][10] = int_stack + 152831;
 Libderiv->deriv2_classes[5][6][10] = int_stack + 153272;
 Libderiv->deriv2_classes[6][5][10] = int_stack + 153860;
 Libderiv->deriv2_classes[6][6][10] = int_stack + 154448;
 Libderiv->deriv_classes[3][5][9] = int_stack + 155232;
 Libderiv->deriv_classes[3][6][9] = int_stack + 155442;
 Libderiv->deriv2_classes[3][5][9] = int_stack + 155722;
 Libderiv->deriv2_classes[3][6][9] = int_stack + 155932;
 Libderiv->deriv_classes[4][5][9] = int_stack + 156212;
 Libderiv->deriv_classes[4][6][9] = int_stack + 156527;
 Libderiv->deriv2_classes[4][5][9] = int_stack + 156947;
 Libderiv->deriv2_classes[4][6][9] = int_stack + 157262;
 Libderiv->deriv_classes[5][5][9] = int_stack + 157682;
 Libderiv->deriv_classes[5][6][9] = int_stack + 158123;
 Libderiv->deriv2_classes[5][5][9] = int_stack + 158711;
 Libderiv->deriv2_classes[5][6][9] = int_stack + 159152;
 Libderiv->deriv2_classes[6][5][9] = int_stack + 159740;
 Libderiv->deriv2_classes[6][6][9] = int_stack + 160328;
 Libderiv->deriv_classes[3][5][8] = int_stack + 161112;
 Libderiv->deriv_classes[3][6][8] = int_stack + 161322;
 Libderiv->deriv2_classes[3][5][8] = int_stack + 161602;
 Libderiv->deriv2_classes[3][6][8] = int_stack + 161812;
 Libderiv->deriv_classes[4][5][8] = int_stack + 162092;
 Libderiv->deriv_classes[4][6][8] = int_stack + 162407;
 Libderiv->deriv2_classes[4][5][8] = int_stack + 162827;
 Libderiv->deriv2_classes[4][6][8] = int_stack + 163142;
 Libderiv->deriv_classes[5][5][8] = int_stack + 163562;
 Libderiv->deriv_classes[5][6][8] = int_stack + 164003;
 Libderiv->deriv2_classes[5][5][8] = int_stack + 164591;
 Libderiv->deriv2_classes[5][6][8] = int_stack + 165032;
 Libderiv->deriv2_classes[6][5][8] = int_stack + 165620;
 Libderiv->deriv2_classes[6][6][8] = int_stack + 166208;
 Libderiv->deriv_classes[3][5][7] = int_stack + 166992;
 Libderiv->deriv_classes[3][6][7] = int_stack + 167202;
 Libderiv->deriv2_classes[3][5][7] = int_stack + 167482;
 Libderiv->deriv2_classes[3][6][7] = int_stack + 167692;
 Libderiv->deriv_classes[4][5][7] = int_stack + 167972;
 Libderiv->deriv_classes[4][6][7] = int_stack + 168287;
 Libderiv->deriv2_classes[4][5][7] = int_stack + 168707;
 Libderiv->deriv2_classes[4][6][7] = int_stack + 169022;
 Libderiv->deriv_classes[5][5][7] = int_stack + 169442;
 Libderiv->deriv_classes[5][6][7] = int_stack + 169883;
 Libderiv->deriv2_classes[5][5][7] = int_stack + 170471;
 Libderiv->deriv2_classes[5][6][7] = int_stack + 170912;
 Libderiv->deriv2_classes[6][5][7] = int_stack + 171500;
 Libderiv->deriv2_classes[6][6][7] = int_stack + 172088;
 Libderiv->deriv_classes[3][5][6] = int_stack + 172872;
 Libderiv->deriv_classes[3][6][6] = int_stack + 173082;
 Libderiv->deriv2_classes[3][5][6] = int_stack + 173362;
 Libderiv->deriv2_classes[3][6][6] = int_stack + 173572;
 Libderiv->deriv_classes[4][5][6] = int_stack + 173852;
 Libderiv->deriv_classes[4][6][6] = int_stack + 174167;
 Libderiv->deriv2_classes[4][5][6] = int_stack + 174587;
 Libderiv->deriv2_classes[4][6][6] = int_stack + 174902;
 Libderiv->dvrr_classes[5][5] = int_stack + 175322;
 Libderiv->deriv_classes[5][5][6] = int_stack + 175763;
 Libderiv->deriv_classes[5][6][6] = int_stack + 176204;
 Libderiv->deriv2_classes[5][5][6] = int_stack + 176792;
 Libderiv->deriv2_classes[5][6][6] = int_stack + 177233;
 Libderiv->deriv_classes[6][5][0] = int_stack + 177821;
 Libderiv->deriv2_classes[6][5][6] = int_stack + 178409;
 Libderiv->deriv2_classes[6][6][6] = int_stack + 178997;
 Libderiv->deriv_classes[3][5][2] = int_stack + 179781;
 Libderiv->deriv_classes[3][6][2] = int_stack + 179991;
 Libderiv->deriv2_classes[3][5][2] = int_stack + 180271;
 Libderiv->deriv2_classes[3][6][2] = int_stack + 180481;
 Libderiv->deriv_classes[4][5][2] = int_stack + 180761;
 Libderiv->deriv_classes[4][6][2] = int_stack + 181076;
 Libderiv->deriv2_classes[4][5][2] = int_stack + 181496;
 Libderiv->deriv2_classes[4][6][2] = int_stack + 181811;
 Libderiv->deriv_classes[5][5][2] = int_stack + 182231;
 Libderiv->deriv_classes[5][6][2] = int_stack + 182672;
 Libderiv->deriv2_classes[5][5][2] = int_stack + 183260;
 Libderiv->deriv2_classes[5][6][2] = int_stack + 183701;
 Libderiv->deriv2_classes[6][5][2] = int_stack + 184289;
 Libderiv->deriv2_classes[6][6][2] = int_stack + 184877;
 Libderiv->deriv_classes[3][5][1] = int_stack + 185661;
 Libderiv->deriv_classes[3][6][1] = int_stack + 185871;
 Libderiv->deriv2_classes[3][5][1] = int_stack + 186151;
 Libderiv->deriv2_classes[3][6][1] = int_stack + 186361;
 Libderiv->deriv_classes[4][5][1] = int_stack + 186641;
 Libderiv->deriv_classes[4][6][1] = int_stack + 186956;
 Libderiv->deriv2_classes[4][5][1] = int_stack + 187376;
 Libderiv->deriv2_classes[4][6][1] = int_stack + 187691;
 Libderiv->deriv_classes[5][5][1] = int_stack + 188111;
 Libderiv->deriv_classes[5][6][1] = int_stack + 188552;
 Libderiv->deriv2_classes[5][5][1] = int_stack + 189140;
 Libderiv->deriv2_classes[5][6][1] = int_stack + 189581;
 Libderiv->deriv2_classes[6][5][1] = int_stack + 190169;
 Libderiv->deriv2_classes[6][6][1] = int_stack + 190757;
 Libderiv->dvrr_classes[3][5] = int_stack + 191541;
 Libderiv->dvrr_classes[3][6] = int_stack + 191751;
 Libderiv->deriv_classes[3][5][0] = int_stack + 192031;
 Libderiv->deriv_classes[3][6][0] = int_stack + 192241;
 Libderiv->deriv2_classes[3][5][0] = int_stack + 192521;
 Libderiv->deriv2_classes[3][6][0] = int_stack + 192731;
 Libderiv->dvrr_classes[4][5] = int_stack + 193011;
 Libderiv->dvrr_classes[4][6] = int_stack + 193326;
 Libderiv->deriv_classes[4][5][0] = int_stack + 193746;
 Libderiv->deriv_classes[4][6][0] = int_stack + 194061;
 Libderiv->deriv2_classes[4][5][0] = int_stack + 194481;
 Libderiv->deriv2_classes[4][6][0] = int_stack + 194796;
 Libderiv->deriv_classes[5][5][0] = int_stack + 195216;
 Libderiv->deriv_classes[5][6][0] = int_stack + 195657;
 Libderiv->deriv2_classes[5][5][0] = int_stack + 196245;
 Libderiv->deriv2_classes[5][6][0] = int_stack + 196686;
 Libderiv->deriv2_classes[6][5][0] = int_stack + 197274;
 Libderiv->deriv2_classes[6][6][0] = int_stack + 197862;
 memset(int_stack,0,1589168);

 Libderiv->dvrr_stack = int_stack + 578158;
 for(i=0;i<num_prim_comb;i++) {
   d12vrr_order_ffhp(Libderiv, Data);
   Data++;
 }

 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+198646,int_stack+143682,int_stack+143472, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+191541,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+199276,int_stack+144767,int_stack+144452, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+193011,15);
 /*--- compute (fp|hp) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+200221,int_stack+199276,int_stack+198646,63);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+202111,int_stack+146363,int_stack+145922, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+175322,21);
 /*--- compute (gp|hp) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+203434,int_stack+202111,int_stack+199276,63);
 /*--- compute (fd|hp) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+206269,int_stack+203434,int_stack+200221,63);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+210049,int_stack+0,int_stack+64876, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3920,28);
 /*--- compute (hp|hp) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+211813,int_stack+210049,int_stack+202111,63);
 /*--- compute (gd|hp) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+215782,int_stack+211813,int_stack+203434,63);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+210049,int_stack+149562,int_stack+149352, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+191541, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+210679,int_stack+150647,int_stack+150332, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+193011, 0.0, zero_stack,15);
 /*--- compute (fp|hp) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+211624,int_stack+210679,int_stack+210049,63);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+213514,int_stack+152243,int_stack+151802, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+175322, 0.0, zero_stack,21);
 /*--- compute (gp|hp) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+221452,int_stack+213514,int_stack+210679,63);
 /*--- compute (fd|hp) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+224287,int_stack+221452,int_stack+211624,63);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+228067,int_stack+784,int_stack+69090, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3920, 0.0, zero_stack,28);
 /*--- compute (hp|hp) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+229831,int_stack+228067,int_stack+213514,63);
 /*--- compute (gd|hp) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+233800,int_stack+229831,int_stack+221452,63);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+228067,int_stack+155442,int_stack+155232, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+191541, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+214837,int_stack+156527,int_stack+156212, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+193011, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|hp) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+228697,int_stack+214837,int_stack+228067,63);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+230587,int_stack+158123,int_stack+157682, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+175322, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|hp) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+239470,int_stack+230587,int_stack+214837,63);
 /*--- compute (fd|hp) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+242305,int_stack+239470,int_stack+228697,63);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+231910,int_stack+1568,int_stack+73304, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3920, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|hp) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+246085,int_stack+231910,int_stack+230587,63);
 /*--- compute (gd|hp) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+250054,int_stack+246085,int_stack+239470,63);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+246085,int_stack+161322,int_stack+161112, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+191541, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+246715,int_stack+162407,int_stack+162092, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+193011, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|hp) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+231910,int_stack+246715,int_stack+246085,63);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+247660,int_stack+164003,int_stack+163562, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+175322, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|hp) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+255724,int_stack+247660,int_stack+246715,63);
 /*--- compute (fd|hp) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+258559,int_stack+255724,int_stack+231910,63);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+0,int_stack+2352,int_stack+77518, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3920, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|hp) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+262339,int_stack+0,int_stack+247660,63);
 /*--- compute (gd|hp) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+266308,int_stack+262339,int_stack+255724,63);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+262339,int_stack+167202,int_stack+166992, 0.0, zero_stack, 1.0, int_stack+191541, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+262969,int_stack+168287,int_stack+167972, 0.0, zero_stack, 1.0, int_stack+193011, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|hp) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+263914,int_stack+262969,int_stack+262339,63);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+0,int_stack+169883,int_stack+169442, 0.0, zero_stack, 1.0, int_stack+175322, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|hp) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+271978,int_stack+0,int_stack+262969,63);
 /*--- compute (fd|hp) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+274813,int_stack+271978,int_stack+263914,63);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1323,int_stack+3136,int_stack+81732, 0.0, zero_stack, 1.0, int_stack+3920, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|hp) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+278593,int_stack+1323,int_stack+0,63);
 /*--- compute (gd|hp) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+282562,int_stack+278593,int_stack+271978,63);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+278593,int_stack+173082,int_stack+172872, 1.0, int_stack+191541, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+279223,int_stack+174167,int_stack+173852, 1.0, int_stack+193011, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|hp) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+280168,int_stack+279223,int_stack+278593,63);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1323,int_stack+176204,int_stack+175763, 1.0, int_stack+175322, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|hp) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+288232,int_stack+1323,int_stack+279223,63);
 /*--- compute (fd|hp) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+291067,int_stack+288232,int_stack+280168,63);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+294847,int_stack+4508,int_stack+85946, 1.0, int_stack+3920, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|hp) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+296611,int_stack+294847,int_stack+1323,63);
 /*--- compute (gd|hp) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+300580,int_stack+296611,int_stack+288232,63);
 /*--- compute (f0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+294847,int_stack+191751,int_stack+191541,10);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+295477,int_stack+193326,int_stack+193011,15);
 /*--- compute (fp|hp) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+296422,int_stack+295477,int_stack+294847,63);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+298312,int_stack+6860,int_stack+175322,21);
 /*--- compute (gp|hp) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+306250,int_stack+298312,int_stack+295477,63);
 /*--- compute (fd|hp) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+309085,int_stack+306250,int_stack+296422,63);
 /*--- compute (f0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+193011,int_stack+179991,int_stack+179781,10);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+299635,int_stack+181076,int_stack+180761,15);
 /*--- compute (fp|hp) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+2646,int_stack+299635,int_stack+193011, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+294847, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+312865,int_stack+182672,int_stack+182231,21);
 /*--- compute (gp|hp) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+314188,int_stack+312865,int_stack+299635, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+295477, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
 /*--- compute (fd|hp) ---*/
   d1hrr1_build_fd(Libderiv->AB,int_stack+317023,int_stack+314188,int_stack+2646, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+296422, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+320803,int_stack+5292,int_stack+108290,28);
 /*--- compute (hp|hp) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+322567,int_stack+320803,int_stack+312865, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+298312, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
 /*--- compute (gd|hp) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+326536,int_stack+322567,int_stack+314188, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+306250, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
 /*--- compute (f0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+320803,int_stack+185871,int_stack+185661,10);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+321433,int_stack+186956,int_stack+186641,15);
 /*--- compute (fp|hp) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+322378,int_stack+321433,int_stack+320803, 0.0, zero_stack, 1.0, int_stack+294847, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+324268,int_stack+188552,int_stack+188111,21);
 /*--- compute (gp|hp) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+332206,int_stack+324268,int_stack+321433, 0.0, zero_stack, 1.0, int_stack+295477, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
 /*--- compute (fd|hp) ---*/
   d1hrr1_build_fd(Libderiv->AB,int_stack+335041,int_stack+332206,int_stack+322378, 0.0, zero_stack, 1.0, int_stack+296422, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+338821,int_stack+6076,int_stack+134260,28);
 /*--- compute (hp|hp) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+340585,int_stack+338821,int_stack+324268, 0.0, zero_stack, 1.0, int_stack+298312, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
 /*--- compute (gd|hp) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+344554,int_stack+340585,int_stack+332206, 0.0, zero_stack, 1.0, int_stack+306250, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
 /*--- compute (f0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+338821,int_stack+192241,int_stack+192031,10);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+325591,int_stack+194061,int_stack+193746,15);
 /*--- compute (fp|hp) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+339451,int_stack+325591,int_stack+338821, 1.0, int_stack+294847, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+341341,int_stack+195657,int_stack+195216,21);
 /*--- compute (gp|hp) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+4536,int_stack+341341,int_stack+325591, 1.0, int_stack+295477, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
 /*--- compute (fd|hp) ---*/
   d1hrr1_build_fd(Libderiv->AB,int_stack+350224,int_stack+4536,int_stack+339451, 1.0, int_stack+296422, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+294847,int_stack+7448,int_stack+177821,28);
 /*--- compute (hp|hp) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+354004,int_stack+294847,int_stack+341341, 1.0, int_stack+298312, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
 /*--- compute (gd|hp) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+357973,int_stack+354004,int_stack+4536, 1.0, int_stack+306250, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+306250,int_stack+8442,int_stack+8232, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+143472,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+306880,int_stack+9037,int_stack+8722, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+144452,15);
 /*--- compute (fp|hp) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+342664,int_stack+306880,int_stack+306250,63);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+354004,int_stack+9898,int_stack+9457, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+145922,21);
 /*--- compute (gp|hp) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+294847,int_stack+354004,int_stack+306880,63);
 /*--- compute (fd|hp) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+363643,int_stack+294847,int_stack+342664,63);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+342664,int_stack+11074,int_stack+10486, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+64876,28);
 /*--- compute (hp|hp) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+7371,int_stack+342664,int_stack+354004,63);
 /*--- compute (gd|hp) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+367423,int_stack+7371,int_stack+294847,63);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+294847,int_stack+12068,int_stack+11858, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+143472, 1.0, int_stack+149352,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+295477,int_stack+12663,int_stack+12348, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+144452, 1.0, int_stack+150332,15);
 /*--- compute (fp|hp) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+342664,int_stack+295477,int_stack+294847,63);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+296422,int_stack+13524,int_stack+13083, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+145922, 1.0, int_stack+151802,21);
 /*--- compute (gp|hp) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+306250,int_stack+296422,int_stack+295477,63);
 /*--- compute (fd|hp) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+7371,int_stack+306250,int_stack+342664,63);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+342664,int_stack+14700,int_stack+14112, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+64876, 1.0, int_stack+69090,28);
 /*--- compute (hp|hp) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+354004,int_stack+342664,int_stack+296422,63);
 /*--- compute (gd|hp) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+373093,int_stack+354004,int_stack+306250,63);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+306250,int_stack+15694,int_stack+15484, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+149352, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+306880,int_stack+16289,int_stack+15974, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+150332, 0.0, zero_stack,15);
 /*--- compute (fp|hp) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+342664,int_stack+306880,int_stack+306250,63);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+354004,int_stack+17150,int_stack+16709, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+151802, 0.0, zero_stack,21);
 /*--- compute (gp|hp) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+294847,int_stack+354004,int_stack+306880,63);
 /*--- compute (fd|hp) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+11151,int_stack+294847,int_stack+342664,63);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+342664,int_stack+18326,int_stack+17738, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+69090, 0.0, zero_stack,28);
 /*--- compute (hp|hp) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+14931,int_stack+342664,int_stack+354004,63);
 /*--- compute (gd|hp) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+378763,int_stack+14931,int_stack+294847,63);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+294847,int_stack+19320,int_stack+19110, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+143472, 0.0, zero_stack, 1.0, int_stack+155232,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+295477,int_stack+19915,int_stack+19600, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+144452, 0.0, zero_stack, 1.0, int_stack+156212,15);
 /*--- compute (fp|hp) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+342664,int_stack+295477,int_stack+294847,63);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+296422,int_stack+20776,int_stack+20335, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+145922, 0.0, zero_stack, 1.0, int_stack+157682,21);
 /*--- compute (gp|hp) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+306250,int_stack+296422,int_stack+295477,63);
 /*--- compute (fd|hp) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+14931,int_stack+306250,int_stack+342664,63);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+342664,int_stack+21952,int_stack+21364, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+64876, 0.0, zero_stack, 1.0, int_stack+73304,28);
 /*--- compute (hp|hp) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+354004,int_stack+342664,int_stack+296422,63);
 /*--- compute (gd|hp) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+384433,int_stack+354004,int_stack+306250,63);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+306250,int_stack+22946,int_stack+22736, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+149352, 1.0, int_stack+155232, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+306880,int_stack+23541,int_stack+23226, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+150332, 1.0, int_stack+156212, 0.0, zero_stack,15);
 /*--- compute (fp|hp) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+342664,int_stack+306880,int_stack+306250,63);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+354004,int_stack+24402,int_stack+23961, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+151802, 1.0, int_stack+157682, 0.0, zero_stack,21);
 /*--- compute (gp|hp) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+294847,int_stack+354004,int_stack+306880,63);
 /*--- compute (fd|hp) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+18711,int_stack+294847,int_stack+342664,63);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+342664,int_stack+25578,int_stack+24990, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+69090, 1.0, int_stack+73304, 0.0, zero_stack,28);
 /*--- compute (hp|hp) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+390103,int_stack+342664,int_stack+354004,63);
 /*--- compute (gd|hp) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+394072,int_stack+390103,int_stack+294847,63);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+294847,int_stack+26572,int_stack+26362, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+155232, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+295477,int_stack+27167,int_stack+26852, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+156212, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|hp) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+342664,int_stack+295477,int_stack+294847,63);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+296422,int_stack+28028,int_stack+27587, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+157682, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|hp) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+306250,int_stack+296422,int_stack+295477,63);
 /*--- compute (fd|hp) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+390103,int_stack+306250,int_stack+342664,63);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+342664,int_stack+29204,int_stack+28616, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+73304, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|hp) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+354004,int_stack+342664,int_stack+296422,63);
 /*--- compute (gd|hp) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+22491,int_stack+354004,int_stack+306250,63);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+306250,int_stack+30198,int_stack+29988, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+143472, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+161112,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+306880,int_stack+30793,int_stack+30478, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+144452, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+162092,15);
 /*--- compute (fp|hp) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+342664,int_stack+306880,int_stack+306250,63);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+354004,int_stack+31654,int_stack+31213, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+145922, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+163562,21);
 /*--- compute (gp|hp) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+294847,int_stack+354004,int_stack+306880,63);
 /*--- compute (fd|hp) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+28161,int_stack+294847,int_stack+342664,63);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+342664,int_stack+32830,int_stack+32242, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+64876, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+77518,28);
 /*--- compute (hp|hp) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+399742,int_stack+342664,int_stack+354004,63);
 /*--- compute (gd|hp) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+403711,int_stack+399742,int_stack+294847,63);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+294847,int_stack+33824,int_stack+33614, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+149352, 0.0, zero_stack, 1.0, int_stack+161112, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+295477,int_stack+34419,int_stack+34104, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+150332, 0.0, zero_stack, 1.0, int_stack+162092, 0.0, zero_stack,15);
 /*--- compute (fp|hp) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+342664,int_stack+295477,int_stack+294847,63);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+296422,int_stack+35280,int_stack+34839, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+151802, 0.0, zero_stack, 1.0, int_stack+163562, 0.0, zero_stack,21);
 /*--- compute (gp|hp) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+306250,int_stack+296422,int_stack+295477,63);
 /*--- compute (fd|hp) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+399742,int_stack+306250,int_stack+342664,63);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+342664,int_stack+36456,int_stack+35868, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+69090, 0.0, zero_stack, 1.0, int_stack+77518, 0.0, zero_stack,28);
 /*--- compute (hp|hp) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+354004,int_stack+342664,int_stack+296422,63);
 /*--- compute (gd|hp) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+409381,int_stack+354004,int_stack+306250,63);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+306250,int_stack+37450,int_stack+37240, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+155232, 1.0, int_stack+161112, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+306880,int_stack+38045,int_stack+37730, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+156212, 1.0, int_stack+162092, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|hp) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+342664,int_stack+306880,int_stack+306250,63);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+354004,int_stack+38906,int_stack+38465, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+157682, 1.0, int_stack+163562, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|hp) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+294847,int_stack+354004,int_stack+306880,63);
 /*--- compute (fd|hp) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+31941,int_stack+294847,int_stack+342664,63);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+342664,int_stack+40082,int_stack+39494, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+73304, 1.0, int_stack+77518, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|hp) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+35721,int_stack+342664,int_stack+354004,63);
 /*--- compute (gd|hp) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+415051,int_stack+35721,int_stack+294847,63);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+294847,int_stack+41076,int_stack+40866, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+161112, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+295477,int_stack+41671,int_stack+41356, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+162092, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|hp) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+342664,int_stack+295477,int_stack+294847,63);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+296422,int_stack+42532,int_stack+42091, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+163562, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|hp) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+306250,int_stack+296422,int_stack+295477,63);
 /*--- compute (fd|hp) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+35721,int_stack+306250,int_stack+342664,63);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+342664,int_stack+43708,int_stack+43120, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+77518, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|hp) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+354004,int_stack+342664,int_stack+296422,63);
 /*--- compute (gd|hp) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+420721,int_stack+354004,int_stack+306250,63);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+306250,int_stack+44702,int_stack+44492, 0.0, zero_stack, 1.0, int_stack+143472, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+166992,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+306880,int_stack+45297,int_stack+44982, 0.0, zero_stack, 1.0, int_stack+144452, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+167972,15);
 /*--- compute (fp|hp) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+342664,int_stack+306880,int_stack+306250,63);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+354004,int_stack+46158,int_stack+45717, 0.0, zero_stack, 1.0, int_stack+145922, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+169442,21);
 /*--- compute (gp|hp) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+294847,int_stack+354004,int_stack+306880,63);
 /*--- compute (fd|hp) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+39501,int_stack+294847,int_stack+342664,63);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+342664,int_stack+47334,int_stack+46746, 0.0, zero_stack, 1.0, int_stack+64876, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+81732,28);
 /*--- compute (hp|hp) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+43281,int_stack+342664,int_stack+354004,63);
 /*--- compute (gd|hp) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+426391,int_stack+43281,int_stack+294847,63);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+294847,int_stack+48328,int_stack+48118, 0.0, zero_stack, 1.0, int_stack+149352, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+166992, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+295477,int_stack+48923,int_stack+48608, 0.0, zero_stack, 1.0, int_stack+150332, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+167972, 0.0, zero_stack,15);
 /*--- compute (fp|hp) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+342664,int_stack+295477,int_stack+294847,63);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+296422,int_stack+49784,int_stack+49343, 0.0, zero_stack, 1.0, int_stack+151802, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+169442, 0.0, zero_stack,21);
 /*--- compute (gp|hp) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+306250,int_stack+296422,int_stack+295477,63);
 /*--- compute (fd|hp) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+43281,int_stack+306250,int_stack+342664,63);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+342664,int_stack+50960,int_stack+50372, 0.0, zero_stack, 1.0, int_stack+69090, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+81732, 0.0, zero_stack,28);
 /*--- compute (hp|hp) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+354004,int_stack+342664,int_stack+296422,63);
 /*--- compute (gd|hp) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+432061,int_stack+354004,int_stack+306250,63);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+306250,int_stack+51954,int_stack+51744, 0.0, zero_stack, 1.0, int_stack+155232, 0.0, zero_stack, 1.0, int_stack+166992, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+306880,int_stack+52549,int_stack+52234, 0.0, zero_stack, 1.0, int_stack+156212, 0.0, zero_stack, 1.0, int_stack+167972, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|hp) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+342664,int_stack+306880,int_stack+306250,63);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+354004,int_stack+53410,int_stack+52969, 0.0, zero_stack, 1.0, int_stack+157682, 0.0, zero_stack, 1.0, int_stack+169442, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|hp) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+294847,int_stack+354004,int_stack+306880,63);
 /*--- compute (fd|hp) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+47061,int_stack+294847,int_stack+342664,63);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+342664,int_stack+54586,int_stack+53998, 0.0, zero_stack, 1.0, int_stack+73304, 0.0, zero_stack, 1.0, int_stack+81732, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|hp) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+50841,int_stack+342664,int_stack+354004,63);
 /*--- compute (gd|hp) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+437731,int_stack+50841,int_stack+294847,63);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+294847,int_stack+55580,int_stack+55370, 0.0, zero_stack, 1.0, int_stack+161112, 1.0, int_stack+166992, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+295477,int_stack+56175,int_stack+55860, 0.0, zero_stack, 1.0, int_stack+162092, 1.0, int_stack+167972, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|hp) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+342664,int_stack+295477,int_stack+294847,63);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+296422,int_stack+57036,int_stack+56595, 0.0, zero_stack, 1.0, int_stack+163562, 1.0, int_stack+169442, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|hp) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+306250,int_stack+296422,int_stack+295477,63);
 /*--- compute (fd|hp) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+50841,int_stack+306250,int_stack+342664,63);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+342664,int_stack+58212,int_stack+57624, 0.0, zero_stack, 1.0, int_stack+77518, 1.0, int_stack+81732, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|hp) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+354004,int_stack+342664,int_stack+296422,63);
 /*--- compute (gd|hp) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+443401,int_stack+354004,int_stack+306250,63);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+306250,int_stack+59206,int_stack+58996, 0.0, zero_stack, 2.0, int_stack+166992, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+306880,int_stack+59801,int_stack+59486, 0.0, zero_stack, 2.0, int_stack+167972, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|hp) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+342664,int_stack+306880,int_stack+306250,63);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+354004,int_stack+60662,int_stack+60221, 0.0, zero_stack, 2.0, int_stack+169442, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|hp) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+294847,int_stack+354004,int_stack+306880,63);
 /*--- compute (fd|hp) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+54621,int_stack+294847,int_stack+342664,63);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+342664,int_stack+61838,int_stack+61250, 0.0, zero_stack, 2.0, int_stack+81732, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|hp) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+58401,int_stack+342664,int_stack+354004,63);
 /*--- compute (gd|hp) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+449071,int_stack+58401,int_stack+294847,63);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+294847,int_stack+62832,int_stack+62622, 1.0, int_stack+143472, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+172872,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+295477,int_stack+63427,int_stack+63112, 1.0, int_stack+144452, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+173852,15);
 /*--- compute (fp|hp) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+342664,int_stack+295477,int_stack+294847,63);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+296422,int_stack+64288,int_stack+63847, 1.0, int_stack+145922, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+175763,21);
 /*--- compute (gp|hp) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+306250,int_stack+296422,int_stack+295477,63);
 /*--- compute (fd|hp) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+58401,int_stack+306250,int_stack+342664,63);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+342664,int_stack+66052,int_stack+65464, 1.0, int_stack+64876, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+85946,28);
 /*--- compute (hp|hp) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+354004,int_stack+342664,int_stack+296422,63);
 /*--- compute (gd|hp) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+454741,int_stack+354004,int_stack+306250,63);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+306250,int_stack+67046,int_stack+66836, 1.0, int_stack+149352, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+172872, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+306880,int_stack+67641,int_stack+67326, 1.0, int_stack+150332, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+173852, 0.0, zero_stack,15);
 /*--- compute (fp|hp) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+342664,int_stack+306880,int_stack+306250,63);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+354004,int_stack+68502,int_stack+68061, 1.0, int_stack+151802, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+175763, 0.0, zero_stack,21);
 /*--- compute (gp|hp) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+294847,int_stack+354004,int_stack+306880,63);
 /*--- compute (fd|hp) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+62181,int_stack+294847,int_stack+342664,63);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+342664,int_stack+70266,int_stack+69678, 1.0, int_stack+69090, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+85946, 0.0, zero_stack,28);
 /*--- compute (hp|hp) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+65961,int_stack+342664,int_stack+354004,63);
 /*--- compute (gd|hp) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+460411,int_stack+65961,int_stack+294847,63);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+294847,int_stack+71260,int_stack+71050, 1.0, int_stack+155232, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+172872, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+295477,int_stack+71855,int_stack+71540, 1.0, int_stack+156212, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+173852, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|hp) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+342664,int_stack+295477,int_stack+294847,63);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+296422,int_stack+72716,int_stack+72275, 1.0, int_stack+157682, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+175763, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|hp) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+306250,int_stack+296422,int_stack+295477,63);
 /*--- compute (fd|hp) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+65961,int_stack+306250,int_stack+342664,63);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+342664,int_stack+74480,int_stack+73892, 1.0, int_stack+73304, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+85946, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|hp) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+354004,int_stack+342664,int_stack+296422,63);
 /*--- compute (gd|hp) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+466081,int_stack+354004,int_stack+306250,63);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+306250,int_stack+75474,int_stack+75264, 1.0, int_stack+161112, 0.0, zero_stack, 1.0, int_stack+172872, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+306880,int_stack+76069,int_stack+75754, 1.0, int_stack+162092, 0.0, zero_stack, 1.0, int_stack+173852, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|hp) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+342664,int_stack+306880,int_stack+306250,63);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+354004,int_stack+76930,int_stack+76489, 1.0, int_stack+163562, 0.0, zero_stack, 1.0, int_stack+175763, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|hp) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+294847,int_stack+354004,int_stack+306880,63);
 /*--- compute (fd|hp) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+69741,int_stack+294847,int_stack+342664,63);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+342664,int_stack+78694,int_stack+78106, 1.0, int_stack+77518, 0.0, zero_stack, 1.0, int_stack+85946, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|hp) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+73521,int_stack+342664,int_stack+354004,63);
 /*--- compute (gd|hp) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+471751,int_stack+73521,int_stack+294847,63);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+294847,int_stack+79688,int_stack+79478, 1.0, int_stack+166992, 1.0, int_stack+172872, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+295477,int_stack+80283,int_stack+79968, 1.0, int_stack+167972, 1.0, int_stack+173852, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|hp) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+342664,int_stack+295477,int_stack+294847,63);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+296422,int_stack+81144,int_stack+80703, 1.0, int_stack+169442, 1.0, int_stack+175763, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|hp) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+306250,int_stack+296422,int_stack+295477,63);
 /*--- compute (fd|hp) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+73521,int_stack+306250,int_stack+342664,63);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+342664,int_stack+82908,int_stack+82320, 1.0, int_stack+81732, 1.0, int_stack+85946, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|hp) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+354004,int_stack+342664,int_stack+296422,63);
 /*--- compute (gd|hp) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+77301,int_stack+354004,int_stack+306250,63);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+306250,int_stack+83902,int_stack+83692, 2.0, int_stack+172872, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+306880,int_stack+84497,int_stack+84182, 2.0, int_stack+173852, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|hp) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+342664,int_stack+306880,int_stack+306250,63);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+354004,int_stack+85358,int_stack+84917, 2.0, int_stack+175763, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|hp) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+294847,int_stack+354004,int_stack+306880,63);
 /*--- compute (fd|hp) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+477421,int_stack+294847,int_stack+342664,63);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+342664,int_stack+87122,int_stack+86534, 2.0, int_stack+85946, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|hp) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+82971,int_stack+342664,int_stack+354004,63);
 /*--- compute (gd|hp) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+481201,int_stack+82971,int_stack+294847,63);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+294847,int_stack+88116,int_stack+87906, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+179781,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+295477,int_stack+88711,int_stack+88396, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+180761,15);
 /*--- compute (fp|hp) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+342664,int_stack+295477,int_stack+294847, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+198646, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+296422,int_stack+89572,int_stack+89131, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+182231,21);
 /*--- compute (gp|hp) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+306250,int_stack+296422,int_stack+295477, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+199276, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
 /*--- compute (fd|hp) ---*/
   d1hrr1_build_fd(Libderiv->AB,int_stack+82971,int_stack+306250,int_stack+342664, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+200221, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+342664,int_stack+90748,int_stack+90160, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+108290,28);
 /*--- compute (hp|hp) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+354004,int_stack+342664,int_stack+296422, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+202111, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
 /*--- compute (gd|hp) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+486871,int_stack+354004,int_stack+306250, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+203434, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+306250,int_stack+91742,int_stack+91532, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+179781, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+306880,int_stack+92337,int_stack+92022, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+180761, 0.0, zero_stack,15);
 /*--- compute (fp|hp) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+342664,int_stack+306880,int_stack+306250, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+210049, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+354004,int_stack+93198,int_stack+92757, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+182231, 0.0, zero_stack,21);
 /*--- compute (gp|hp) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+294847,int_stack+354004,int_stack+306880, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+210679, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
 /*--- compute (fd|hp) ---*/
   d1hrr1_build_fd(Libderiv->AB,int_stack+86751,int_stack+294847,int_stack+342664, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+211624, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+342664,int_stack+94374,int_stack+93786, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+108290, 0.0, zero_stack,28);
 /*--- compute (hp|hp) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+90531,int_stack+342664,int_stack+354004, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+213514, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
 /*--- compute (gd|hp) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+492541,int_stack+90531,int_stack+294847, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+221452, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+294847,int_stack+95368,int_stack+95158, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+179781, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+295477,int_stack+95963,int_stack+95648, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+180761, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|hp) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+342664,int_stack+295477,int_stack+294847, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+228067, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+296422,int_stack+96824,int_stack+96383, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+182231, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|hp) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+306250,int_stack+296422,int_stack+295477, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+214837, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
 /*--- compute (fd|hp) ---*/
   d1hrr1_build_fd(Libderiv->AB,int_stack+90531,int_stack+306250,int_stack+342664, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+228697, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+342664,int_stack+98000,int_stack+97412, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+108290, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|hp) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+354004,int_stack+342664,int_stack+296422, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+230587, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
 /*--- compute (gd|hp) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+498211,int_stack+354004,int_stack+306250, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+239470, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+306250,int_stack+98994,int_stack+98784, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+179781, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+306880,int_stack+99589,int_stack+99274, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+180761, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|hp) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+342664,int_stack+306880,int_stack+306250, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+246085, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+354004,int_stack+100450,int_stack+100009, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+182231, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|hp) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+294847,int_stack+354004,int_stack+306880, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+246715, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
 /*--- compute (fd|hp) ---*/
   d1hrr1_build_fd(Libderiv->AB,int_stack+94311,int_stack+294847,int_stack+342664, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+231910, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+342664,int_stack+101626,int_stack+101038, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+108290, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|hp) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+98091,int_stack+342664,int_stack+354004, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+247660, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
 /*--- compute (gd|hp) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+503881,int_stack+98091,int_stack+294847, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+255724, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+294847,int_stack+102620,int_stack+102410, 0.0, zero_stack, 1.0, int_stack+179781, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+295477,int_stack+103215,int_stack+102900, 0.0, zero_stack, 1.0, int_stack+180761, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|hp) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+342664,int_stack+295477,int_stack+294847, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+262339, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+296422,int_stack+104076,int_stack+103635, 0.0, zero_stack, 1.0, int_stack+182231, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|hp) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+306250,int_stack+296422,int_stack+295477, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+262969, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
 /*--- compute (fd|hp) ---*/
   d1hrr1_build_fd(Libderiv->AB,int_stack+98091,int_stack+306250,int_stack+342664, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+263914, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+342664,int_stack+105252,int_stack+104664, 0.0, zero_stack, 1.0, int_stack+108290, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|hp) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+354004,int_stack+342664,int_stack+296422, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
 /*--- compute (gd|hp) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+509551,int_stack+354004,int_stack+306250, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+271978, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+306250,int_stack+106246,int_stack+106036, 1.0, int_stack+179781, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+306880,int_stack+106841,int_stack+106526, 1.0, int_stack+180761, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|hp) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+342664,int_stack+306880,int_stack+306250, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+278593, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+354004,int_stack+107702,int_stack+107261, 1.0, int_stack+182231, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|hp) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+294847,int_stack+354004,int_stack+306880, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+279223, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
 /*--- compute (fd|hp) ---*/
   d1hrr1_build_fd(Libderiv->AB,int_stack+101871,int_stack+294847,int_stack+342664, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+280168, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+342664,int_stack+109466,int_stack+108878, 1.0, int_stack+108290, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|hp) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+105651,int_stack+342664,int_stack+354004, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1323, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
 /*--- compute (gd|hp) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+515221,int_stack+105651,int_stack+294847, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+288232, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
 /*--- compute (f0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+294847,int_stack+110460,int_stack+110250,10);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+295477,int_stack+111055,int_stack+110740,15);
 /*--- compute (fp|hp) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+342664,int_stack+295477,int_stack+294847, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+193011, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+296422,int_stack+111916,int_stack+111475,21);
 /*--- compute (gp|hp) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+306250,int_stack+296422,int_stack+295477, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+299635, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
 /*--- compute (fd|hp) ---*/
   d1hrr1_build_fd(Libderiv->AB,int_stack+105651,int_stack+306250,int_stack+342664, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+2646, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+342664,int_stack+113092,int_stack+112504,28);
 /*--- compute (hp|hp) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+354004,int_stack+342664,int_stack+296422, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+312865, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
 /*--- compute (gd|hp) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+520891,int_stack+354004,int_stack+306250, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+314188, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+306250,int_stack+114086,int_stack+113876, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+185661,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+306880,int_stack+114681,int_stack+114366, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+186641,15);
 /*--- compute (fp|hp) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+342664,int_stack+306880,int_stack+306250, 0.0, zero_stack, 1.0, int_stack+198646, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+354004,int_stack+115542,int_stack+115101, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+188111,21);
 /*--- compute (gp|hp) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+294847,int_stack+354004,int_stack+306880, 0.0, zero_stack, 1.0, int_stack+199276, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
 /*--- compute (fd|hp) ---*/
   d1hrr1_build_fd(Libderiv->AB,int_stack+109431,int_stack+294847,int_stack+342664, 0.0, zero_stack, 1.0, int_stack+200221, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+342664,int_stack+116718,int_stack+116130, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+134260,28);
 /*--- compute (hp|hp) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+113211,int_stack+342664,int_stack+354004, 0.0, zero_stack, 1.0, int_stack+202111, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
 /*--- compute (gd|hp) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+526561,int_stack+113211,int_stack+294847, 0.0, zero_stack, 1.0, int_stack+203434, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+294847,int_stack+117712,int_stack+117502, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+185661, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+295477,int_stack+118307,int_stack+117992, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+186641, 0.0, zero_stack,15);
 /*--- compute (fp|hp) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+342664,int_stack+295477,int_stack+294847, 0.0, zero_stack, 1.0, int_stack+210049, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+296422,int_stack+119168,int_stack+118727, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+188111, 0.0, zero_stack,21);
 /*--- compute (gp|hp) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+306250,int_stack+296422,int_stack+295477, 0.0, zero_stack, 1.0, int_stack+210679, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
 /*--- compute (fd|hp) ---*/
   d1hrr1_build_fd(Libderiv->AB,int_stack+113211,int_stack+306250,int_stack+342664, 0.0, zero_stack, 1.0, int_stack+211624, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+342664,int_stack+120344,int_stack+119756, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+134260, 0.0, zero_stack,28);
 /*--- compute (hp|hp) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+354004,int_stack+342664,int_stack+296422, 0.0, zero_stack, 1.0, int_stack+213514, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
 /*--- compute (gd|hp) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+532231,int_stack+354004,int_stack+306250, 0.0, zero_stack, 1.0, int_stack+221452, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+306250,int_stack+121338,int_stack+121128, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+185661, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+306880,int_stack+121933,int_stack+121618, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+186641, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|hp) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+342664,int_stack+306880,int_stack+306250, 0.0, zero_stack, 1.0, int_stack+228067, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+354004,int_stack+122794,int_stack+122353, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+188111, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|hp) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+294847,int_stack+354004,int_stack+306880, 0.0, zero_stack, 1.0, int_stack+214837, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
 /*--- compute (fd|hp) ---*/
   d1hrr1_build_fd(Libderiv->AB,int_stack+116991,int_stack+294847,int_stack+342664, 0.0, zero_stack, 1.0, int_stack+228697, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+342664,int_stack+123970,int_stack+123382, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+134260, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|hp) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+120771,int_stack+342664,int_stack+354004, 0.0, zero_stack, 1.0, int_stack+230587, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
 /*--- compute (gd|hp) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+537901,int_stack+120771,int_stack+294847, 0.0, zero_stack, 1.0, int_stack+239470, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+294847,int_stack+124964,int_stack+124754, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+185661, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+295477,int_stack+125559,int_stack+125244, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+186641, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|hp) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+342664,int_stack+295477,int_stack+294847, 0.0, zero_stack, 1.0, int_stack+246085, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+296422,int_stack+126420,int_stack+125979, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+188111, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|hp) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+306250,int_stack+296422,int_stack+295477, 0.0, zero_stack, 1.0, int_stack+246715, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
 /*--- compute (fd|hp) ---*/
   d1hrr1_build_fd(Libderiv->AB,int_stack+120771,int_stack+306250,int_stack+342664, 0.0, zero_stack, 1.0, int_stack+231910, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+342664,int_stack+127596,int_stack+127008, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+134260, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|hp) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+354004,int_stack+342664,int_stack+296422, 0.0, zero_stack, 1.0, int_stack+247660, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
 /*--- compute (gd|hp) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+543571,int_stack+354004,int_stack+306250, 0.0, zero_stack, 1.0, int_stack+255724, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+306250,int_stack+128590,int_stack+128380, 0.0, zero_stack, 1.0, int_stack+185661, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+306880,int_stack+129185,int_stack+128870, 0.0, zero_stack, 1.0, int_stack+186641, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|hp) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+342664,int_stack+306880,int_stack+306250, 0.0, zero_stack, 1.0, int_stack+262339, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+354004,int_stack+130046,int_stack+129605, 0.0, zero_stack, 1.0, int_stack+188111, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|hp) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+294847,int_stack+354004,int_stack+306880, 0.0, zero_stack, 1.0, int_stack+262969, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
 /*--- compute (fd|hp) ---*/
   d1hrr1_build_fd(Libderiv->AB,int_stack+124551,int_stack+294847,int_stack+342664, 0.0, zero_stack, 1.0, int_stack+263914, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+342664,int_stack+131222,int_stack+130634, 0.0, zero_stack, 1.0, int_stack+134260, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|hp) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+549241,int_stack+342664,int_stack+354004, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
 /*--- compute (gd|hp) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+553210,int_stack+549241,int_stack+294847, 0.0, zero_stack, 1.0, int_stack+271978, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+294847,int_stack+132216,int_stack+132006, 1.0, int_stack+185661, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+295477,int_stack+132811,int_stack+132496, 1.0, int_stack+186641, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|hp) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+342664,int_stack+295477,int_stack+294847, 0.0, zero_stack, 1.0, int_stack+278593, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+296422,int_stack+133672,int_stack+133231, 1.0, int_stack+188111, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|hp) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+306250,int_stack+296422,int_stack+295477, 0.0, zero_stack, 1.0, int_stack+279223, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
 /*--- compute (fd|hp) ---*/
   d1hrr1_build_fd(Libderiv->AB,int_stack+549241,int_stack+306250,int_stack+342664, 0.0, zero_stack, 1.0, int_stack+280168, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+342664,int_stack+135436,int_stack+134848, 1.0, int_stack+134260, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|hp) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+354004,int_stack+342664,int_stack+296422, 0.0, zero_stack, 1.0, int_stack+1323, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
 /*--- compute (gd|hp) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+128331,int_stack+354004,int_stack+306250, 0.0, zero_stack, 1.0, int_stack+288232, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
 /*--- compute (f0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+306250,int_stack+136430,int_stack+136220,10);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+306880,int_stack+137025,int_stack+136710,15);
 /*--- compute (fp|hp) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+342664,int_stack+306880,int_stack+306250, 0.0, zero_stack, 1.0, int_stack+193011, 1.0, int_stack+320803, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+354004,int_stack+137886,int_stack+137445,21);
 /*--- compute (gp|hp) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+294847,int_stack+354004,int_stack+306880, 0.0, zero_stack, 1.0, int_stack+299635, 1.0, int_stack+321433, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
 /*--- compute (fd|hp) ---*/
   d1hrr1_build_fd(Libderiv->AB,int_stack+134001,int_stack+294847,int_stack+342664, 0.0, zero_stack, 1.0, int_stack+2646, 1.0, int_stack+322378, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+342664,int_stack+139062,int_stack+138474,28);
 /*--- compute (hp|hp) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+558880,int_stack+342664,int_stack+354004, 0.0, zero_stack, 1.0, int_stack+312865, 1.0, int_stack+324268, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
 /*--- compute (gd|hp) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+562849,int_stack+558880,int_stack+294847, 0.0, zero_stack, 1.0, int_stack+314188, 1.0, int_stack+332206, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
 /*--- compute (f0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+294847,int_stack+140056,int_stack+139846,10);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+295477,int_stack+140651,int_stack+140336,15);
 /*--- compute (fp|hp) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+342664,int_stack+295477,int_stack+294847, 0.0, zero_stack, 2.0, int_stack+320803, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+296422,int_stack+141512,int_stack+141071,21);
 /*--- compute (gp|hp) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+306250,int_stack+296422,int_stack+295477, 0.0, zero_stack, 2.0, int_stack+321433, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
 /*--- compute (fd|hp) ---*/
   d1hrr1_build_fd(Libderiv->AB,int_stack+558880,int_stack+306250,int_stack+342664, 0.0, zero_stack, 2.0, int_stack+322378, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+342664,int_stack+142688,int_stack+142100,28);
 /*--- compute (hp|hp) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+354004,int_stack+342664,int_stack+296422, 0.0, zero_stack, 2.0, int_stack+324268, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
 /*--- compute (gd|hp) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+137781,int_stack+354004,int_stack+306250, 0.0, zero_stack, 2.0, int_stack+332206, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+306250,int_stack+144172,int_stack+143962, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+192031,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+306880,int_stack+145502,int_stack+145187, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+193746,15);
 /*--- compute (fp|hp) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+342664,int_stack+306880,int_stack+306250, 1.0, int_stack+198646, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+354004,int_stack+147392,int_stack+146951, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+195216,21);
 /*--- compute (gp|hp) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+294847,int_stack+354004,int_stack+306880, 1.0, int_stack+199276, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
 /*--- compute (fd|hp) ---*/
   d1hrr1_build_fd(Libderiv->AB,int_stack+143451,int_stack+294847,int_stack+342664, 1.0, int_stack+200221, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+342664,int_stack+148568,int_stack+147980, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+177821,28);
 /*--- compute (hp|hp) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+568519,int_stack+342664,int_stack+354004, 1.0, int_stack+202111, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
 /*--- compute (gd|hp) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+572488,int_stack+568519,int_stack+294847, 1.0, int_stack+203434, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+294847,int_stack+150052,int_stack+149842, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+192031, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+295477,int_stack+151382,int_stack+151067, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+193746, 0.0, zero_stack,15);
 /*--- compute (fp|hp) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+342664,int_stack+295477,int_stack+294847, 1.0, int_stack+210049, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+296422,int_stack+153272,int_stack+152831, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+195216, 0.0, zero_stack,21);
 /*--- compute (gp|hp) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+306250,int_stack+296422,int_stack+295477, 1.0, int_stack+210679, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
 /*--- compute (fd|hp) ---*/
   d1hrr1_build_fd(Libderiv->AB,int_stack+568519,int_stack+306250,int_stack+342664, 1.0, int_stack+211624, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+342664,int_stack+154448,int_stack+153860, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+177821, 0.0, zero_stack,28);
 /*--- compute (hp|hp) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+354004,int_stack+342664,int_stack+296422, 1.0, int_stack+213514, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
 /*--- compute (gd|hp) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+198646,int_stack+354004,int_stack+306250, 1.0, int_stack+221452, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+221452,int_stack+155932,int_stack+155722, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+192031, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+222082,int_stack+157262,int_stack+156947, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+193746, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|hp) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+342664,int_stack+222082,int_stack+221452, 1.0, int_stack+228067, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+306250,int_stack+159152,int_stack+158711, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+195216, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|hp) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+354004,int_stack+306250,int_stack+222082, 1.0, int_stack+214837, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
 /*--- compute (fd|hp) ---*/
   d1hrr1_build_fd(Libderiv->AB,int_stack+210049,int_stack+354004,int_stack+342664, 1.0, int_stack+228697, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+342664,int_stack+160328,int_stack+159740, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+177821, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|hp) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+294847,int_stack+342664,int_stack+306250, 1.0, int_stack+230587, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
 /*--- compute (gd|hp) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+147231,int_stack+294847,int_stack+354004, 1.0, int_stack+239470, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+239470,int_stack+161812,int_stack+161602, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+192031, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+240100,int_stack+163142,int_stack+162827, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+193746, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|hp) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+342664,int_stack+240100,int_stack+239470, 1.0, int_stack+246085, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+354004,int_stack+165032,int_stack+164591, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+195216, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|hp) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+306250,int_stack+354004,int_stack+240100, 1.0, int_stack+246715, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
 /*--- compute (fd|hp) ---*/
   d1hrr1_build_fd(Libderiv->AB,int_stack+294847,int_stack+306250,int_stack+342664, 1.0, int_stack+231910, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+342664,int_stack+166208,int_stack+165620, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+177821, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|hp) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+228067,int_stack+342664,int_stack+354004, 1.0, int_stack+247660, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
 /*--- compute (gd|hp) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+152901,int_stack+228067,int_stack+306250, 1.0, int_stack+255724, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+255724,int_stack+167692,int_stack+167482, 0.0, zero_stack, 1.0, int_stack+192031, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+256354,int_stack+169022,int_stack+168707, 0.0, zero_stack, 1.0, int_stack+193746, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|hp) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+342664,int_stack+256354,int_stack+255724, 1.0, int_stack+262339, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+306250,int_stack+170912,int_stack+170471, 0.0, zero_stack, 1.0, int_stack+195216, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|hp) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+239470,int_stack+306250,int_stack+256354, 1.0, int_stack+262969, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
 /*--- compute (fd|hp) ---*/
   d1hrr1_build_fd(Libderiv->AB,int_stack+228067,int_stack+239470,int_stack+342664, 1.0, int_stack+263914, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+342664,int_stack+172088,int_stack+171500, 0.0, zero_stack, 1.0, int_stack+177821, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|hp) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+262339,int_stack+342664,int_stack+306250, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
 /*--- compute (gd|hp) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+158571,int_stack+262339,int_stack+239470, 1.0, int_stack+271978, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+271978,int_stack+173572,int_stack+173362, 1.0, int_stack+192031, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+272608,int_stack+174902,int_stack+174587, 1.0, int_stack+193746, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|hp) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+342664,int_stack+272608,int_stack+271978, 1.0, int_stack+278593, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+0,int_stack+177233,int_stack+176792, 1.0, int_stack+195216, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|hp) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+239470,int_stack+0,int_stack+272608, 1.0, int_stack+279223, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
 /*--- compute (fd|hp) ---*/
   d1hrr1_build_fd(Libderiv->AB,int_stack+262339,int_stack+239470,int_stack+342664, 1.0, int_stack+280168, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+342664,int_stack+178997,int_stack+178409, 1.0, int_stack+177821, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|hp) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+278593,int_stack+342664,int_stack+0, 1.0, int_stack+1323, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
 /*--- compute (gd|hp) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+164241,int_stack+278593,int_stack+239470, 1.0, int_stack+288232, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
 /*--- compute (f0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+288232,int_stack+180481,int_stack+180271,10);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+288862,int_stack+181811,int_stack+181496,15);
 /*--- compute (fp|hp) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+342664,int_stack+288862,int_stack+288232, 1.0, int_stack+193011, 0.0, zero_stack, 1.0, int_stack+338821, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+193011,int_stack+183701,int_stack+183260,21);
 /*--- compute (gp|hp) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+239470,int_stack+193011,int_stack+288862, 1.0, int_stack+299635, 0.0, zero_stack, 1.0, int_stack+325591, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
 /*--- compute (fd|hp) ---*/
   d1hrr1_build_fd(Libderiv->AB,int_stack+278593,int_stack+239470,int_stack+342664, 1.0, int_stack+2646, 0.0, zero_stack, 1.0, int_stack+339451, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+342664,int_stack+184877,int_stack+184289,28);
 /*--- compute (hp|hp) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+354004,int_stack+342664,int_stack+193011, 1.0, int_stack+312865, 0.0, zero_stack, 1.0, int_stack+341341, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
 /*--- compute (gd|hp) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+169911,int_stack+354004,int_stack+239470, 1.0, int_stack+314188, 0.0, zero_stack, 1.0, int_stack+4536, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
 /*--- compute (f0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+239470,int_stack+186361,int_stack+186151,10);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+240100,int_stack+187691,int_stack+187376,15);
 /*--- compute (fp|hp) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+342664,int_stack+240100,int_stack+239470, 1.0, int_stack+320803, 1.0, int_stack+338821, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+354004,int_stack+189581,int_stack+189140,21);
 /*--- compute (gp|hp) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+288232,int_stack+354004,int_stack+240100, 1.0, int_stack+321433, 1.0, int_stack+325591, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
 /*--- compute (fd|hp) ---*/
   d1hrr1_build_fd(Libderiv->AB,int_stack+312865,int_stack+288232,int_stack+342664, 1.0, int_stack+322378, 1.0, int_stack+339451, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+342664,int_stack+190757,int_stack+190169,28);
 /*--- compute (hp|hp) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+246085,int_stack+342664,int_stack+354004, 1.0, int_stack+324268, 1.0, int_stack+341341, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
 /*--- compute (gd|hp) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+175581,int_stack+246085,int_stack+288232, 1.0, int_stack+332206, 1.0, int_stack+4536, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
 /*--- compute (f0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+332206,int_stack+192731,int_stack+192521,10);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+332836,int_stack+194796,int_stack+194481,15);
 /*--- compute (fp|hp) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+342664,int_stack+332836,int_stack+332206, 2.0, int_stack+338821, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+288232,int_stack+196686,int_stack+196245,21);
 /*--- compute (gp|hp) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+239470,int_stack+288232,int_stack+332836, 2.0, int_stack+325591, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
 /*--- compute (fd|hp) ---*/
   d1hrr1_build_fd(Libderiv->AB,int_stack+246085,int_stack+239470,int_stack+342664, 2.0, int_stack+339451, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+342664,int_stack+197862,int_stack+197274,28);
 /*--- compute (hp|hp) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+354004,int_stack+342664,int_stack+288232, 2.0, int_stack+341341, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
 /*--- compute (gd|hp) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+338821,int_stack+354004,int_stack+239470, 2.0, int_stack+4536, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
 /*--- compute (ff|hp) ---*/
   hrr1_build_ff(Libderiv->AB,int_stack+0,int_stack+215782,int_stack+206269,63);
     Libderiv->ABCD[11] = int_stack + 0;
 /*--- compute (ff|hp) ---*/
   hrr1_build_ff(Libderiv->AB,int_stack+213829,int_stack+233800,int_stack+224287,63);
     Libderiv->ABCD[10] = int_stack + 213829;
 /*--- compute (ff|hp) ---*/
   hrr1_build_ff(Libderiv->AB,int_stack+231847,int_stack+250054,int_stack+242305,63);
     Libderiv->ABCD[9] = int_stack + 231847;
 /*--- compute (ff|hp) ---*/
   hrr1_build_ff(Libderiv->AB,int_stack+249865,int_stack+266308,int_stack+258559,63);
     Libderiv->ABCD[8] = int_stack + 249865;
 /*--- compute (ff|hp) ---*/
   hrr1_build_ff(Libderiv->AB,int_stack+266119,int_stack+282562,int_stack+274813,63);
     Libderiv->ABCD[7] = int_stack + 266119;
 /*--- compute (ff|hp) ---*/
   hrr1_build_ff(Libderiv->AB,int_stack+282373,int_stack+300580,int_stack+291067,63);
     Libderiv->ABCD[6] = int_stack + 282373;
 /*--- compute (ff|hp) ---*/
   d1hrr1_build_ff(Libderiv->AB,int_stack+298627,int_stack+326536,int_stack+317023, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+309085, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
     Libderiv->ABCD[2] = int_stack + 298627;
 /*--- compute (ff|hp) ---*/
   d1hrr1_build_ff(Libderiv->AB,int_stack+320803,int_stack+344554,int_stack+335041, 0.0, zero_stack, 1.0, int_stack+309085, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
     Libderiv->ABCD[1] = int_stack + 320803;
 /*--- compute (ff|hp) ---*/
   d1hrr1_build_ff(Libderiv->AB,int_stack+327103,int_stack+357973,int_stack+350224, 1.0, int_stack+309085, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
     Libderiv->ABCD[0] = int_stack + 327103;
 /*--- compute (ff|hp) ---*/
   hrr1_build_ff(Libderiv->AB,int_stack+354004,int_stack+367423,int_stack+363643,63);
     Libderiv->ABCD[155] = int_stack + 354004;
 /*--- compute (ff|hp) ---*/
   hrr1_build_ff(Libderiv->AB,int_stack+360304,int_stack+373093,int_stack+7371,63);
     Libderiv->ABCD[143] = int_stack + 360304;
 /*--- compute (ff|hp) ---*/
   hrr1_build_ff(Libderiv->AB,int_stack+366604,int_stack+378763,int_stack+11151,63);
     Libderiv->ABCD[142] = int_stack + 366604;
 /*--- compute (ff|hp) ---*/
   hrr1_build_ff(Libderiv->AB,int_stack+372904,int_stack+384433,int_stack+14931,63);
     Libderiv->ABCD[131] = int_stack + 372904;
 /*--- compute (ff|hp) ---*/
   hrr1_build_ff(Libderiv->AB,int_stack+379204,int_stack+394072,int_stack+18711,63);
     Libderiv->ABCD[130] = int_stack + 379204;
 /*--- compute (ff|hp) ---*/
   hrr1_build_ff(Libderiv->AB,int_stack+6300,int_stack+22491,int_stack+390103,63);
     Libderiv->ABCD[129] = int_stack + 6300;
 /*--- compute (ff|hp) ---*/
   hrr1_build_ff(Libderiv->AB,int_stack+385504,int_stack+403711,int_stack+28161,63);
     Libderiv->ABCD[119] = int_stack + 385504;
 /*--- compute (ff|hp) ---*/
   hrr1_build_ff(Libderiv->AB,int_stack+391804,int_stack+409381,int_stack+399742,63);
     Libderiv->ABCD[118] = int_stack + 391804;
 /*--- compute (ff|hp) ---*/
   hrr1_build_ff(Libderiv->AB,int_stack+398104,int_stack+415051,int_stack+31941,63);
     Libderiv->ABCD[117] = int_stack + 398104;
 /*--- compute (ff|hp) ---*/
   hrr1_build_ff(Libderiv->AB,int_stack+404404,int_stack+420721,int_stack+35721,63);
     Libderiv->ABCD[116] = int_stack + 404404;
 /*--- compute (ff|hp) ---*/
   hrr1_build_ff(Libderiv->AB,int_stack+410704,int_stack+426391,int_stack+39501,63);
     Libderiv->ABCD[107] = int_stack + 410704;
 /*--- compute (ff|hp) ---*/
   hrr1_build_ff(Libderiv->AB,int_stack+417004,int_stack+432061,int_stack+43281,63);
     Libderiv->ABCD[106] = int_stack + 417004;
 /*--- compute (ff|hp) ---*/
   hrr1_build_ff(Libderiv->AB,int_stack+423304,int_stack+437731,int_stack+47061,63);
     Libderiv->ABCD[105] = int_stack + 423304;
 /*--- compute (ff|hp) ---*/
   hrr1_build_ff(Libderiv->AB,int_stack+429604,int_stack+443401,int_stack+50841,63);
     Libderiv->ABCD[104] = int_stack + 429604;
 /*--- compute (ff|hp) ---*/
   hrr1_build_ff(Libderiv->AB,int_stack+435904,int_stack+449071,int_stack+54621,63);
     Libderiv->ABCD[103] = int_stack + 435904;
 /*--- compute (ff|hp) ---*/
   hrr1_build_ff(Libderiv->AB,int_stack+442204,int_stack+454741,int_stack+58401,63);
     Libderiv->ABCD[95] = int_stack + 442204;
 /*--- compute (ff|hp) ---*/
   hrr1_build_ff(Libderiv->AB,int_stack+448504,int_stack+460411,int_stack+62181,63);
     Libderiv->ABCD[94] = int_stack + 448504;
 /*--- compute (ff|hp) ---*/
   hrr1_build_ff(Libderiv->AB,int_stack+454804,int_stack+466081,int_stack+65961,63);
     Libderiv->ABCD[93] = int_stack + 454804;
 /*--- compute (ff|hp) ---*/
   hrr1_build_ff(Libderiv->AB,int_stack+461104,int_stack+471751,int_stack+69741,63);
     Libderiv->ABCD[92] = int_stack + 461104;
 /*--- compute (ff|hp) ---*/
   hrr1_build_ff(Libderiv->AB,int_stack+467404,int_stack+77301,int_stack+73521,63);
     Libderiv->ABCD[91] = int_stack + 467404;
 /*--- compute (ff|hp) ---*/
   hrr1_build_ff(Libderiv->AB,int_stack+12600,int_stack+481201,int_stack+477421,63);
     Libderiv->ABCD[90] = int_stack + 12600;
 /*--- compute (ff|hp) ---*/
   d1hrr1_build_ff(Libderiv->AB,int_stack+473704,int_stack+486871,int_stack+82971, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+206269, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
     Libderiv->ABCD[47] = int_stack + 473704;
 /*--- compute (ff|hp) ---*/
   d1hrr1_build_ff(Libderiv->AB,int_stack+480004,int_stack+492541,int_stack+86751, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+224287, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
     Libderiv->ABCD[46] = int_stack + 480004;
 /*--- compute (ff|hp) ---*/
   d1hrr1_build_ff(Libderiv->AB,int_stack+486304,int_stack+498211,int_stack+90531, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+242305, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
     Libderiv->ABCD[45] = int_stack + 486304;
 /*--- compute (ff|hp) ---*/
   d1hrr1_build_ff(Libderiv->AB,int_stack+492604,int_stack+503881,int_stack+94311, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+258559, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
     Libderiv->ABCD[44] = int_stack + 492604;
 /*--- compute (ff|hp) ---*/
   d1hrr1_build_ff(Libderiv->AB,int_stack+498904,int_stack+509551,int_stack+98091, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+274813, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
     Libderiv->ABCD[43] = int_stack + 498904;
 /*--- compute (ff|hp) ---*/
   d1hrr1_build_ff(Libderiv->AB,int_stack+505204,int_stack+515221,int_stack+101871, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+291067, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
     Libderiv->ABCD[42] = int_stack + 505204;
 /*--- compute (ff|hp) ---*/
   d1hrr1_build_ff(Libderiv->AB,int_stack+511504,int_stack+520891,int_stack+105651, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+317023, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
     Libderiv->ABCD[38] = int_stack + 511504;
 /*--- compute (ff|hp) ---*/
   d1hrr1_build_ff(Libderiv->AB,int_stack+517804,int_stack+526561,int_stack+109431, 0.0, zero_stack, 1.0, int_stack+206269, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
     Libderiv->ABCD[35] = int_stack + 517804;
 /*--- compute (ff|hp) ---*/
   d1hrr1_build_ff(Libderiv->AB,int_stack+524104,int_stack+532231,int_stack+113211, 0.0, zero_stack, 1.0, int_stack+224287, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
     Libderiv->ABCD[34] = int_stack + 524104;
 /*--- compute (ff|hp) ---*/
   d1hrr1_build_ff(Libderiv->AB,int_stack+530404,int_stack+537901,int_stack+116991, 0.0, zero_stack, 1.0, int_stack+242305, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
     Libderiv->ABCD[33] = int_stack + 530404;
 /*--- compute (ff|hp) ---*/
   d1hrr1_build_ff(Libderiv->AB,int_stack+536704,int_stack+543571,int_stack+120771, 0.0, zero_stack, 1.0, int_stack+258559, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
     Libderiv->ABCD[32] = int_stack + 536704;
 /*--- compute (ff|hp) ---*/
   d1hrr1_build_ff(Libderiv->AB,int_stack+18900,int_stack+553210,int_stack+124551, 0.0, zero_stack, 1.0, int_stack+274813, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
     Libderiv->ABCD[31] = int_stack + 18900;
 /*--- compute (ff|hp) ---*/
   d1hrr1_build_ff(Libderiv->AB,int_stack+25200,int_stack+128331,int_stack+549241, 0.0, zero_stack, 1.0, int_stack+291067, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
     Libderiv->ABCD[30] = int_stack + 25200;
 /*--- compute (ff|hp) ---*/
   d1hrr1_build_ff(Libderiv->AB,int_stack+543004,int_stack+562849,int_stack+134001, 0.0, zero_stack, 1.0, int_stack+317023, 1.0, int_stack+335041, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
     Libderiv->ABCD[26] = int_stack + 543004;
 /*--- compute (ff|hp) ---*/
   d1hrr1_build_ff(Libderiv->AB,int_stack+549304,int_stack+137781,int_stack+558880, 0.0, zero_stack, 2.0, int_stack+335041, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
     Libderiv->ABCD[25] = int_stack + 549304;
 /*--- compute (ff|hp) ---*/
   d1hrr1_build_ff(Libderiv->AB,int_stack+555604,int_stack+572488,int_stack+143451, 1.0, int_stack+206269, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
     Libderiv->ABCD[23] = int_stack + 555604;
 /*--- compute (ff|hp) ---*/
   d1hrr1_build_ff(Libderiv->AB,int_stack+561904,int_stack+198646,int_stack+568519, 1.0, int_stack+224287, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
     Libderiv->ABCD[22] = int_stack + 561904;
 /*--- compute (ff|hp) ---*/
   d1hrr1_build_ff(Libderiv->AB,int_stack+568204,int_stack+147231,int_stack+210049, 1.0, int_stack+242305, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
     Libderiv->ABCD[21] = int_stack + 568204;
 /*--- compute (ff|hp) ---*/
   d1hrr1_build_ff(Libderiv->AB,int_stack+31500,int_stack+152901,int_stack+294847, 1.0, int_stack+258559, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
     Libderiv->ABCD[20] = int_stack + 31500;
 /*--- compute (ff|hp) ---*/
   d1hrr1_build_ff(Libderiv->AB,int_stack+37800,int_stack+158571,int_stack+228067, 1.0, int_stack+274813, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
     Libderiv->ABCD[19] = int_stack + 37800;
 /*--- compute (ff|hp) ---*/
   d1hrr1_build_ff(Libderiv->AB,int_stack+44100,int_stack+164241,int_stack+262339, 1.0, int_stack+291067, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
     Libderiv->ABCD[18] = int_stack + 44100;
 /*--- compute (ff|hp) ---*/
   d1hrr1_build_ff(Libderiv->AB,int_stack+256165,int_stack+169911,int_stack+278593, 1.0, int_stack+317023, 0.0, zero_stack, 1.0, int_stack+350224, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
     Libderiv->ABCD[14] = int_stack + 256165;
 /*--- compute (ff|hp) ---*/
   d1hrr1_build_ff(Libderiv->AB,int_stack+288673,int_stack+175581,int_stack+312865, 1.0, int_stack+335041, 1.0, int_stack+350224, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
     Libderiv->ABCD[13] = int_stack + 288673;
 /*--- compute (ff|hp) ---*/
   d1hrr1_build_ff(Libderiv->AB,int_stack+50400,int_stack+338821,int_stack+246085, 2.0, int_stack+350224, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
     Libderiv->ABCD[12] = int_stack + 50400;

}
