/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include <libint/libint.h>
#include "libderiv.h"
#include <libint/hrr_header.h>

#include "d1hrr_header.h"

extern void d12vrr_order_hphp(Libderiv_t *, prim_data *);

  /* Computes derivatives of (hp|hp) integrals */

void d12hrr_order_hphp(Libderiv_t *Libderiv, int num_prim_comb)
{
 prim_data *Data = Libderiv->PrimQuartet;
 double *int_stack = Libderiv->int_stack;
 double *zero_stack = Libderiv->zero_stack;
 int i,j;
 double tmp, *target;

 Libderiv->deriv_classes[6][6][11] = int_stack + 0;
 Libderiv->deriv_classes[6][6][10] = int_stack + 784;
 Libderiv->deriv_classes[6][6][9] = int_stack + 1568;
 Libderiv->deriv_classes[6][6][8] = int_stack + 2352;
 Libderiv->deriv_classes[6][6][7] = int_stack + 3136;
 Libderiv->dvrr_classes[6][5] = int_stack + 3920;
 Libderiv->deriv_classes[6][6][6] = int_stack + 4508;
 Libderiv->deriv_classes[6][6][2] = int_stack + 5292;
 Libderiv->deriv_classes[6][6][1] = int_stack + 6076;
 Libderiv->dvrr_classes[5][6] = int_stack + 6860;
 Libderiv->deriv_classes[6][6][0] = int_stack + 7448;
 Libderiv->deriv2_classes[5][5][143] = int_stack + 8232;
 Libderiv->deriv2_classes[5][6][143] = int_stack + 8673;
 Libderiv->deriv2_classes[6][5][143] = int_stack + 9261;
 Libderiv->deriv2_classes[6][6][143] = int_stack + 9849;
 Libderiv->deriv2_classes[5][5][131] = int_stack + 10633;
 Libderiv->deriv2_classes[5][6][131] = int_stack + 11074;
 Libderiv->deriv2_classes[6][5][131] = int_stack + 11662;
 Libderiv->deriv2_classes[6][6][131] = int_stack + 12250;
 Libderiv->deriv2_classes[5][5][130] = int_stack + 13034;
 Libderiv->deriv2_classes[5][6][130] = int_stack + 13475;
 Libderiv->deriv2_classes[6][5][130] = int_stack + 14063;
 Libderiv->deriv2_classes[6][6][130] = int_stack + 14651;
 Libderiv->deriv2_classes[5][5][119] = int_stack + 15435;
 Libderiv->deriv2_classes[5][6][119] = int_stack + 15876;
 Libderiv->deriv2_classes[6][5][119] = int_stack + 16464;
 Libderiv->deriv2_classes[6][6][119] = int_stack + 17052;
 Libderiv->deriv2_classes[5][5][118] = int_stack + 17836;
 Libderiv->deriv2_classes[5][6][118] = int_stack + 18277;
 Libderiv->deriv2_classes[6][5][118] = int_stack + 18865;
 Libderiv->deriv2_classes[6][6][118] = int_stack + 19453;
 Libderiv->deriv2_classes[5][5][117] = int_stack + 20237;
 Libderiv->deriv2_classes[5][6][117] = int_stack + 20678;
 Libderiv->deriv2_classes[6][5][117] = int_stack + 21266;
 Libderiv->deriv2_classes[6][6][117] = int_stack + 21854;
 Libderiv->deriv2_classes[5][5][107] = int_stack + 22638;
 Libderiv->deriv2_classes[5][6][107] = int_stack + 23079;
 Libderiv->deriv2_classes[6][5][107] = int_stack + 23667;
 Libderiv->deriv2_classes[6][6][107] = int_stack + 24255;
 Libderiv->deriv2_classes[5][5][106] = int_stack + 25039;
 Libderiv->deriv2_classes[5][6][106] = int_stack + 25480;
 Libderiv->deriv2_classes[6][5][106] = int_stack + 26068;
 Libderiv->deriv2_classes[6][6][106] = int_stack + 26656;
 Libderiv->deriv2_classes[5][5][105] = int_stack + 27440;
 Libderiv->deriv2_classes[5][6][105] = int_stack + 27881;
 Libderiv->deriv2_classes[6][5][105] = int_stack + 28469;
 Libderiv->deriv2_classes[6][6][105] = int_stack + 29057;
 Libderiv->deriv2_classes[5][5][104] = int_stack + 29841;
 Libderiv->deriv2_classes[5][6][104] = int_stack + 30282;
 Libderiv->deriv2_classes[6][5][104] = int_stack + 30870;
 Libderiv->deriv2_classes[6][6][104] = int_stack + 31458;
 Libderiv->deriv2_classes[5][5][95] = int_stack + 32242;
 Libderiv->deriv2_classes[5][6][95] = int_stack + 32683;
 Libderiv->deriv2_classes[6][5][95] = int_stack + 33271;
 Libderiv->deriv2_classes[6][6][95] = int_stack + 33859;
 Libderiv->deriv2_classes[5][5][94] = int_stack + 34643;
 Libderiv->deriv2_classes[5][6][94] = int_stack + 35084;
 Libderiv->deriv2_classes[6][5][94] = int_stack + 35672;
 Libderiv->deriv2_classes[6][6][94] = int_stack + 36260;
 Libderiv->deriv2_classes[5][5][93] = int_stack + 37044;
 Libderiv->deriv2_classes[5][6][93] = int_stack + 37485;
 Libderiv->deriv2_classes[6][5][93] = int_stack + 38073;
 Libderiv->deriv2_classes[6][6][93] = int_stack + 38661;
 Libderiv->deriv2_classes[5][5][92] = int_stack + 39445;
 Libderiv->deriv2_classes[5][6][92] = int_stack + 39886;
 Libderiv->deriv2_classes[6][5][92] = int_stack + 40474;
 Libderiv->deriv2_classes[6][6][92] = int_stack + 41062;
 Libderiv->deriv2_classes[5][5][91] = int_stack + 41846;
 Libderiv->deriv2_classes[5][6][91] = int_stack + 42287;
 Libderiv->deriv2_classes[6][5][91] = int_stack + 42875;
 Libderiv->deriv2_classes[6][6][91] = int_stack + 43463;
 Libderiv->deriv2_classes[5][5][83] = int_stack + 44247;
 Libderiv->deriv2_classes[5][6][83] = int_stack + 44688;
 Libderiv->deriv_classes[6][5][11] = int_stack + 45276;
 Libderiv->deriv2_classes[6][5][83] = int_stack + 45864;
 Libderiv->deriv2_classes[6][6][83] = int_stack + 46452;
 Libderiv->deriv2_classes[5][5][82] = int_stack + 47236;
 Libderiv->deriv2_classes[5][6][82] = int_stack + 47677;
 Libderiv->deriv_classes[6][5][10] = int_stack + 48265;
 Libderiv->deriv2_classes[6][5][82] = int_stack + 48853;
 Libderiv->deriv2_classes[6][6][82] = int_stack + 49441;
 Libderiv->deriv2_classes[5][5][81] = int_stack + 50225;
 Libderiv->deriv2_classes[5][6][81] = int_stack + 50666;
 Libderiv->deriv_classes[6][5][9] = int_stack + 51254;
 Libderiv->deriv2_classes[6][5][81] = int_stack + 51842;
 Libderiv->deriv2_classes[6][6][81] = int_stack + 52430;
 Libderiv->deriv2_classes[5][5][80] = int_stack + 53214;
 Libderiv->deriv2_classes[5][6][80] = int_stack + 53655;
 Libderiv->deriv_classes[6][5][8] = int_stack + 54243;
 Libderiv->deriv2_classes[6][5][80] = int_stack + 54831;
 Libderiv->deriv2_classes[6][6][80] = int_stack + 55419;
 Libderiv->deriv2_classes[5][5][79] = int_stack + 56203;
 Libderiv->deriv2_classes[5][6][79] = int_stack + 56644;
 Libderiv->deriv_classes[6][5][7] = int_stack + 57232;
 Libderiv->deriv2_classes[6][5][79] = int_stack + 57820;
 Libderiv->deriv2_classes[6][6][79] = int_stack + 58408;
 Libderiv->deriv2_classes[5][5][78] = int_stack + 59192;
 Libderiv->deriv2_classes[5][6][78] = int_stack + 59633;
 Libderiv->deriv_classes[6][5][6] = int_stack + 60221;
 Libderiv->deriv2_classes[6][5][78] = int_stack + 60809;
 Libderiv->deriv2_classes[6][6][78] = int_stack + 61397;
 Libderiv->deriv2_classes[5][5][35] = int_stack + 62181;
 Libderiv->deriv2_classes[5][6][35] = int_stack + 62622;
 Libderiv->deriv2_classes[6][5][35] = int_stack + 63210;
 Libderiv->deriv2_classes[6][6][35] = int_stack + 63798;
 Libderiv->deriv2_classes[5][5][34] = int_stack + 64582;
 Libderiv->deriv2_classes[5][6][34] = int_stack + 65023;
 Libderiv->deriv2_classes[6][5][34] = int_stack + 65611;
 Libderiv->deriv2_classes[6][6][34] = int_stack + 66199;
 Libderiv->deriv2_classes[5][5][33] = int_stack + 66983;
 Libderiv->deriv2_classes[5][6][33] = int_stack + 67424;
 Libderiv->deriv2_classes[6][5][33] = int_stack + 68012;
 Libderiv->deriv2_classes[6][6][33] = int_stack + 68600;
 Libderiv->deriv2_classes[5][5][32] = int_stack + 69384;
 Libderiv->deriv2_classes[5][6][32] = int_stack + 69825;
 Libderiv->deriv2_classes[6][5][32] = int_stack + 70413;
 Libderiv->deriv2_classes[6][6][32] = int_stack + 71001;
 Libderiv->deriv2_classes[5][5][31] = int_stack + 71785;
 Libderiv->deriv2_classes[5][6][31] = int_stack + 72226;
 Libderiv->deriv2_classes[6][5][31] = int_stack + 72814;
 Libderiv->deriv2_classes[6][6][31] = int_stack + 73402;
 Libderiv->deriv2_classes[5][5][30] = int_stack + 74186;
 Libderiv->deriv2_classes[5][6][30] = int_stack + 74627;
 Libderiv->deriv_classes[6][5][2] = int_stack + 75215;
 Libderiv->deriv2_classes[6][5][30] = int_stack + 75803;
 Libderiv->deriv2_classes[6][6][30] = int_stack + 76391;
 Libderiv->deriv2_classes[5][5][26] = int_stack + 77175;
 Libderiv->deriv2_classes[5][6][26] = int_stack + 77616;
 Libderiv->deriv2_classes[6][5][26] = int_stack + 78204;
 Libderiv->deriv2_classes[6][6][26] = int_stack + 78792;
 Libderiv->deriv2_classes[5][5][23] = int_stack + 79576;
 Libderiv->deriv2_classes[5][6][23] = int_stack + 80017;
 Libderiv->deriv2_classes[6][5][23] = int_stack + 80605;
 Libderiv->deriv2_classes[6][6][23] = int_stack + 81193;
 Libderiv->deriv2_classes[5][5][22] = int_stack + 81977;
 Libderiv->deriv2_classes[5][6][22] = int_stack + 82418;
 Libderiv->deriv2_classes[6][5][22] = int_stack + 83006;
 Libderiv->deriv2_classes[6][6][22] = int_stack + 83594;
 Libderiv->deriv2_classes[5][5][21] = int_stack + 84378;
 Libderiv->deriv2_classes[5][6][21] = int_stack + 84819;
 Libderiv->deriv2_classes[6][5][21] = int_stack + 85407;
 Libderiv->deriv2_classes[6][6][21] = int_stack + 85995;
 Libderiv->deriv2_classes[5][5][20] = int_stack + 86779;
 Libderiv->deriv2_classes[5][6][20] = int_stack + 87220;
 Libderiv->deriv2_classes[6][5][20] = int_stack + 87808;
 Libderiv->deriv2_classes[6][6][20] = int_stack + 88396;
 Libderiv->deriv2_classes[5][5][19] = int_stack + 89180;
 Libderiv->deriv2_classes[5][6][19] = int_stack + 89621;
 Libderiv->deriv2_classes[6][5][19] = int_stack + 90209;
 Libderiv->deriv2_classes[6][6][19] = int_stack + 90797;
 Libderiv->deriv2_classes[5][5][18] = int_stack + 91581;
 Libderiv->deriv2_classes[5][6][18] = int_stack + 92022;
 Libderiv->deriv_classes[6][5][1] = int_stack + 92610;
 Libderiv->deriv2_classes[6][5][18] = int_stack + 93198;
 Libderiv->deriv2_classes[6][6][18] = int_stack + 93786;
 Libderiv->deriv2_classes[5][5][14] = int_stack + 94570;
 Libderiv->deriv2_classes[5][6][14] = int_stack + 95011;
 Libderiv->deriv2_classes[6][5][14] = int_stack + 95599;
 Libderiv->deriv2_classes[6][6][14] = int_stack + 96187;
 Libderiv->deriv2_classes[5][5][13] = int_stack + 96971;
 Libderiv->deriv2_classes[5][6][13] = int_stack + 97412;
 Libderiv->deriv2_classes[6][5][13] = int_stack + 98000;
 Libderiv->deriv2_classes[6][6][13] = int_stack + 98588;
 Libderiv->deriv_classes[5][5][11] = int_stack + 99372;
 Libderiv->deriv_classes[5][6][11] = int_stack + 99813;
 Libderiv->deriv2_classes[5][5][11] = int_stack + 100401;
 Libderiv->deriv2_classes[5][6][11] = int_stack + 100842;
 Libderiv->deriv2_classes[6][5][11] = int_stack + 101430;
 Libderiv->deriv2_classes[6][6][11] = int_stack + 102018;
 Libderiv->deriv_classes[5][5][10] = int_stack + 102802;
 Libderiv->deriv_classes[5][6][10] = int_stack + 103243;
 Libderiv->deriv2_classes[5][5][10] = int_stack + 103831;
 Libderiv->deriv2_classes[5][6][10] = int_stack + 104272;
 Libderiv->deriv2_classes[6][5][10] = int_stack + 104860;
 Libderiv->deriv2_classes[6][6][10] = int_stack + 105448;
 Libderiv->deriv_classes[5][5][9] = int_stack + 106232;
 Libderiv->deriv_classes[5][6][9] = int_stack + 106673;
 Libderiv->deriv2_classes[5][5][9] = int_stack + 107261;
 Libderiv->deriv2_classes[5][6][9] = int_stack + 107702;
 Libderiv->deriv2_classes[6][5][9] = int_stack + 108290;
 Libderiv->deriv2_classes[6][6][9] = int_stack + 108878;
 Libderiv->deriv_classes[5][5][8] = int_stack + 109662;
 Libderiv->deriv_classes[5][6][8] = int_stack + 110103;
 Libderiv->deriv2_classes[5][5][8] = int_stack + 110691;
 Libderiv->deriv2_classes[5][6][8] = int_stack + 111132;
 Libderiv->deriv2_classes[6][5][8] = int_stack + 111720;
 Libderiv->deriv2_classes[6][6][8] = int_stack + 112308;
 Libderiv->deriv_classes[5][5][7] = int_stack + 113092;
 Libderiv->deriv_classes[5][6][7] = int_stack + 113533;
 Libderiv->deriv2_classes[5][5][7] = int_stack + 114121;
 Libderiv->deriv2_classes[5][6][7] = int_stack + 114562;
 Libderiv->deriv2_classes[6][5][7] = int_stack + 115150;
 Libderiv->deriv2_classes[6][6][7] = int_stack + 115738;
 Libderiv->dvrr_classes[5][5] = int_stack + 116522;
 Libderiv->deriv_classes[5][5][6] = int_stack + 116963;
 Libderiv->deriv_classes[5][6][6] = int_stack + 117404;
 Libderiv->deriv2_classes[5][5][6] = int_stack + 117992;
 Libderiv->deriv2_classes[5][6][6] = int_stack + 118433;
 Libderiv->deriv_classes[6][5][0] = int_stack + 119021;
 Libderiv->deriv2_classes[6][5][6] = int_stack + 119609;
 Libderiv->deriv2_classes[6][6][6] = int_stack + 120197;
 Libderiv->deriv_classes[5][5][2] = int_stack + 120981;
 Libderiv->deriv_classes[5][6][2] = int_stack + 121422;
 Libderiv->deriv2_classes[5][5][2] = int_stack + 122010;
 Libderiv->deriv2_classes[5][6][2] = int_stack + 122451;
 Libderiv->deriv2_classes[6][5][2] = int_stack + 123039;
 Libderiv->deriv2_classes[6][6][2] = int_stack + 123627;
 Libderiv->deriv_classes[5][5][1] = int_stack + 124411;
 Libderiv->deriv_classes[5][6][1] = int_stack + 124852;
 Libderiv->deriv2_classes[5][5][1] = int_stack + 125440;
 Libderiv->deriv2_classes[5][6][1] = int_stack + 125881;
 Libderiv->deriv2_classes[6][5][1] = int_stack + 126469;
 Libderiv->deriv2_classes[6][6][1] = int_stack + 127057;
 Libderiv->deriv_classes[5][5][0] = int_stack + 127841;
 Libderiv->deriv_classes[5][6][0] = int_stack + 128282;
 Libderiv->deriv2_classes[5][5][0] = int_stack + 128870;
 Libderiv->deriv2_classes[5][6][0] = int_stack + 129311;
 Libderiv->deriv2_classes[6][5][0] = int_stack + 129899;
 Libderiv->deriv2_classes[6][6][0] = int_stack + 130487;
 memset(int_stack,0,1050168);

 Libderiv->dvrr_stack = int_stack + 242403;
 for(i=0;i<num_prim_comb;i++) {
   d12vrr_order_hphp(Libderiv, Data);
   Data++;
 }

 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+131271,int_stack+99813,int_stack+99372, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+116522,21);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+132594,int_stack+0,int_stack+45276, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3920,28);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+134358,int_stack+103243,int_stack+102802, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+116522, 0.0, zero_stack,21);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+135681,int_stack+784,int_stack+48265, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3920, 0.0, zero_stack,28);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+0,int_stack+106673,int_stack+106232, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+116522, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+137445,int_stack+1568,int_stack+51254, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3920, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+139209,int_stack+110103,int_stack+109662, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+116522, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+140532,int_stack+2352,int_stack+54243, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3920, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1323,int_stack+113533,int_stack+113092, 0.0, zero_stack, 1.0, int_stack+116522, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+142296,int_stack+3136,int_stack+57232, 0.0, zero_stack, 1.0, int_stack+3920, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+144060,int_stack+117404,int_stack+116963, 1.0, int_stack+116522, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+145383,int_stack+4508,int_stack+60221, 1.0, int_stack+3920, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+2646,int_stack+6860,int_stack+116522,21);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+3969,int_stack+121422,int_stack+120981,21);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+147147,int_stack+5292,int_stack+75215,28);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+148911,int_stack+124852,int_stack+124411,21);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+150234,int_stack+6076,int_stack+92610,28);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+5292,int_stack+128282,int_stack+127841,21);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+151998,int_stack+7448,int_stack+119021,28);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+6615,int_stack+8673,int_stack+8232, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+99372,21);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+153762,int_stack+9849,int_stack+9261, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+45276,28);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+7938,int_stack+11074,int_stack+10633, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+99372, 1.0, int_stack+102802,21);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+9261,int_stack+12250,int_stack+11662, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+45276, 1.0, int_stack+48265,28);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+11025,int_stack+13475,int_stack+13034, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+102802, 0.0, zero_stack,21);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+155526,int_stack+14651,int_stack+14063, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+48265, 0.0, zero_stack,28);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+12348,int_stack+15876,int_stack+15435, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+99372, 0.0, zero_stack, 1.0, int_stack+106232,21);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+13671,int_stack+17052,int_stack+16464, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+45276, 0.0, zero_stack, 1.0, int_stack+51254,28);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+15435,int_stack+18277,int_stack+17836, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+102802, 1.0, int_stack+106232, 0.0, zero_stack,21);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+16758,int_stack+19453,int_stack+18865, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+48265, 1.0, int_stack+51254, 0.0, zero_stack,28);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+18522,int_stack+20678,int_stack+20237, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+106232, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+157290,int_stack+21854,int_stack+21266, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+51254, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+19845,int_stack+23079,int_stack+22638, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+99372, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+109662,21);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+21168,int_stack+24255,int_stack+23667, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+45276, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+54243,28);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+22932,int_stack+25480,int_stack+25039, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+102802, 0.0, zero_stack, 1.0, int_stack+109662, 0.0, zero_stack,21);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+24255,int_stack+26656,int_stack+26068, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+48265, 0.0, zero_stack, 1.0, int_stack+54243, 0.0, zero_stack,28);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+26019,int_stack+27881,int_stack+27440, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+106232, 1.0, int_stack+109662, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+159054,int_stack+29057,int_stack+28469, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+51254, 1.0, int_stack+54243, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+27342,int_stack+30282,int_stack+29841, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+109662, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+28665,int_stack+31458,int_stack+30870, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+54243, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+30429,int_stack+32683,int_stack+32242, 0.0, zero_stack, 1.0, int_stack+99372, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+113092,21);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+160818,int_stack+33859,int_stack+33271, 0.0, zero_stack, 1.0, int_stack+45276, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+57232,28);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+31752,int_stack+35084,int_stack+34643, 0.0, zero_stack, 1.0, int_stack+102802, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+113092, 0.0, zero_stack,21);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+33075,int_stack+36260,int_stack+35672, 0.0, zero_stack, 1.0, int_stack+48265, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+57232, 0.0, zero_stack,28);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+34839,int_stack+37485,int_stack+37044, 0.0, zero_stack, 1.0, int_stack+106232, 0.0, zero_stack, 1.0, int_stack+113092, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+36162,int_stack+38661,int_stack+38073, 0.0, zero_stack, 1.0, int_stack+51254, 0.0, zero_stack, 1.0, int_stack+57232, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+37926,int_stack+39886,int_stack+39445, 0.0, zero_stack, 1.0, int_stack+109662, 1.0, int_stack+113092, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+162582,int_stack+41062,int_stack+40474, 0.0, zero_stack, 1.0, int_stack+54243, 1.0, int_stack+57232, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+39249,int_stack+42287,int_stack+41846, 0.0, zero_stack, 2.0, int_stack+113092, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+40572,int_stack+43463,int_stack+42875, 0.0, zero_stack, 2.0, int_stack+57232, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+42336,int_stack+44688,int_stack+44247, 1.0, int_stack+99372, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+116963,21);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+164346,int_stack+46452,int_stack+45864, 1.0, int_stack+45276, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+60221,28);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+43659,int_stack+47677,int_stack+47236, 1.0, int_stack+102802, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+116963, 0.0, zero_stack,21);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+44982,int_stack+49441,int_stack+48853, 1.0, int_stack+48265, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+60221, 0.0, zero_stack,28);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+46746,int_stack+50666,int_stack+50225, 1.0, int_stack+106232, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+116963, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+48069,int_stack+52430,int_stack+51842, 1.0, int_stack+51254, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+60221, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+49833,int_stack+53655,int_stack+53214, 1.0, int_stack+109662, 0.0, zero_stack, 1.0, int_stack+116963, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+51156,int_stack+55419,int_stack+54831, 1.0, int_stack+54243, 0.0, zero_stack, 1.0, int_stack+60221, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+52920,int_stack+56644,int_stack+56203, 1.0, int_stack+113092, 1.0, int_stack+116963, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+54243,int_stack+58408,int_stack+57820, 1.0, int_stack+57232, 1.0, int_stack+60221, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+56007,int_stack+59633,int_stack+59192, 2.0, int_stack+116963, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+57330,int_stack+61397,int_stack+60809, 2.0, int_stack+60221, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+59094,int_stack+62622,int_stack+62181, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+120981,21);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+60417,int_stack+63798,int_stack+63210, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+75215,28);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+62181,int_stack+65023,int_stack+64582, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+120981, 0.0, zero_stack,21);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+63504,int_stack+66199,int_stack+65611, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+75215, 0.0, zero_stack,28);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+65268,int_stack+67424,int_stack+66983, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+120981, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+166110,int_stack+68600,int_stack+68012, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+75215, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+66591,int_stack+69825,int_stack+69384, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+120981, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+67914,int_stack+71001,int_stack+70413, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+75215, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+69678,int_stack+72226,int_stack+71785, 0.0, zero_stack, 1.0, int_stack+120981, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+71001,int_stack+73402,int_stack+72814, 0.0, zero_stack, 1.0, int_stack+75215, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+72765,int_stack+74627,int_stack+74186, 1.0, int_stack+120981, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+167874,int_stack+76391,int_stack+75803, 1.0, int_stack+75215, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+74088,int_stack+77616,int_stack+77175,21);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+75411,int_stack+78792,int_stack+78204,28);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+77175,int_stack+80017,int_stack+79576, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+124411,21);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+78498,int_stack+81193,int_stack+80605, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+92610,28);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+80262,int_stack+82418,int_stack+81977, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+124411, 0.0, zero_stack,21);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+169638,int_stack+83594,int_stack+83006, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+92610, 0.0, zero_stack,28);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+81585,int_stack+84819,int_stack+84378, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+124411, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+82908,int_stack+85995,int_stack+85407, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+92610, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+84672,int_stack+87220,int_stack+86779, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+124411, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+85995,int_stack+88396,int_stack+87808, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+92610, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+87759,int_stack+89621,int_stack+89180, 0.0, zero_stack, 1.0, int_stack+124411, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+171402,int_stack+90797,int_stack+90209, 0.0, zero_stack, 1.0, int_stack+92610, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+89082,int_stack+92022,int_stack+91581, 1.0, int_stack+124411, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+90405,int_stack+93786,int_stack+93198, 1.0, int_stack+92610, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+92169,int_stack+95011,int_stack+94570,21);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+93492,int_stack+96187,int_stack+95599,28);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+95256,int_stack+97412,int_stack+96971,21);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+173166,int_stack+98588,int_stack+98000,28);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+96579,int_stack+100842,int_stack+100401, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+127841,21);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+97902,int_stack+102018,int_stack+101430, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+119021,28);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+99666,int_stack+104272,int_stack+103831, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+127841, 0.0, zero_stack,21);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+100989,int_stack+105448,int_stack+104860, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+119021, 0.0, zero_stack,28);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+102753,int_stack+107702,int_stack+107261, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+127841, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+104076,int_stack+108878,int_stack+108290, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+119021, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+105840,int_stack+111132,int_stack+110691, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+127841, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+107163,int_stack+112308,int_stack+111720, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+119021, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+108927,int_stack+114562,int_stack+114121, 0.0, zero_stack, 1.0, int_stack+127841, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+110250,int_stack+115738,int_stack+115150, 0.0, zero_stack, 1.0, int_stack+119021, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+112014,int_stack+118433,int_stack+117992, 1.0, int_stack+127841, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+113337,int_stack+120197,int_stack+119609, 1.0, int_stack+119021, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+115101,int_stack+122451,int_stack+122010,21);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+116424,int_stack+123627,int_stack+123039,28);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+118188,int_stack+125881,int_stack+125440,21);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+119511,int_stack+127057,int_stack+126469,28);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+121275,int_stack+129311,int_stack+128870,21);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+122598,int_stack+130487,int_stack+129899,28);
 /*--- compute (hp|hp) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+124362,int_stack+132594,int_stack+131271,63);
     Libderiv->ABCD[11] = int_stack + 124362;
 /*--- compute (hp|hp) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+174930,int_stack+135681,int_stack+134358,63);
     Libderiv->ABCD[10] = int_stack + 174930;
 /*--- compute (hp|hp) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+178899,int_stack+137445,int_stack+0,63);
     Libderiv->ABCD[9] = int_stack + 178899;
 /*--- compute (hp|hp) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+182868,int_stack+140532,int_stack+139209,63);
     Libderiv->ABCD[8] = int_stack + 182868;
 /*--- compute (hp|hp) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+186837,int_stack+142296,int_stack+1323,63);
     Libderiv->ABCD[7] = int_stack + 186837;
 /*--- compute (hp|hp) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+190806,int_stack+145383,int_stack+144060,63);
     Libderiv->ABCD[6] = int_stack + 190806;
 /*--- compute (hp|hp) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+194775,int_stack+147147,int_stack+3969, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2646, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
     Libderiv->ABCD[2] = int_stack + 194775;
 /*--- compute (hp|hp) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+198744,int_stack+150234,int_stack+148911, 0.0, zero_stack, 1.0, int_stack+2646, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
     Libderiv->ABCD[1] = int_stack + 198744;
 /*--- compute (hp|hp) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+202713,int_stack+151998,int_stack+5292, 1.0, int_stack+2646, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
     Libderiv->ABCD[0] = int_stack + 202713;
 /*--- compute (hp|hp) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+206682,int_stack+153762,int_stack+6615,63);
     Libderiv->ABCD[155] = int_stack + 206682;
 /*--- compute (hp|hp) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+150234,int_stack+9261,int_stack+7938,63);
     Libderiv->ABCD[143] = int_stack + 150234;
 /*--- compute (hp|hp) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+6615,int_stack+155526,int_stack+11025,63);
     Libderiv->ABCD[142] = int_stack + 6615;
 /*--- compute (hp|hp) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+210651,int_stack+13671,int_stack+12348,63);
     Libderiv->ABCD[131] = int_stack + 210651;
 /*--- compute (hp|hp) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+10584,int_stack+16758,int_stack+15435,63);
     Libderiv->ABCD[130] = int_stack + 10584;
 /*--- compute (hp|hp) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+14553,int_stack+157290,int_stack+18522,63);
     Libderiv->ABCD[129] = int_stack + 14553;
 /*--- compute (hp|hp) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+154203,int_stack+21168,int_stack+19845,63);
     Libderiv->ABCD[119] = int_stack + 154203;
 /*--- compute (hp|hp) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+18522,int_stack+24255,int_stack+22932,63);
     Libderiv->ABCD[118] = int_stack + 18522;
 /*--- compute (hp|hp) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+214620,int_stack+159054,int_stack+26019,63);
     Libderiv->ABCD[117] = int_stack + 214620;
 /*--- compute (hp|hp) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+22491,int_stack+28665,int_stack+27342,63);
     Libderiv->ABCD[116] = int_stack + 22491;
 /*--- compute (hp|hp) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+26460,int_stack+160818,int_stack+30429,63);
     Libderiv->ABCD[107] = int_stack + 26460;
 /*--- compute (hp|hp) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+158172,int_stack+33075,int_stack+31752,63);
     Libderiv->ABCD[106] = int_stack + 158172;
 /*--- compute (hp|hp) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+30429,int_stack+36162,int_stack+34839,63);
     Libderiv->ABCD[105] = int_stack + 30429;
 /*--- compute (hp|hp) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+218589,int_stack+162582,int_stack+37926,63);
     Libderiv->ABCD[104] = int_stack + 218589;
 /*--- compute (hp|hp) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+34398,int_stack+40572,int_stack+39249,63);
     Libderiv->ABCD[103] = int_stack + 34398;
 /*--- compute (hp|hp) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+38367,int_stack+164346,int_stack+42336,63);
     Libderiv->ABCD[95] = int_stack + 38367;
 /*--- compute (hp|hp) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+162141,int_stack+44982,int_stack+43659,63);
     Libderiv->ABCD[94] = int_stack + 162141;
 /*--- compute (hp|hp) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+42336,int_stack+48069,int_stack+46746,63);
     Libderiv->ABCD[93] = int_stack + 42336;
 /*--- compute (hp|hp) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+222558,int_stack+51156,int_stack+49833,63);
     Libderiv->ABCD[92] = int_stack + 222558;
 /*--- compute (hp|hp) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+46305,int_stack+54243,int_stack+52920,63);
     Libderiv->ABCD[91] = int_stack + 46305;
 /*--- compute (hp|hp) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+50274,int_stack+57330,int_stack+56007,63);
     Libderiv->ABCD[90] = int_stack + 50274;
 /*--- compute (hp|hp) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+54243,int_stack+60417,int_stack+59094, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+131271, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
     Libderiv->ABCD[47] = int_stack + 54243;
 /*--- compute (hp|hp) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+58212,int_stack+63504,int_stack+62181, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+134358, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
     Libderiv->ABCD[46] = int_stack + 58212;
 /*--- compute (hp|hp) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+226527,int_stack+166110,int_stack+65268, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
     Libderiv->ABCD[45] = int_stack + 226527;
 /*--- compute (hp|hp) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+62181,int_stack+67914,int_stack+66591, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+139209, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
     Libderiv->ABCD[44] = int_stack + 62181;
 /*--- compute (hp|hp) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+230496,int_stack+71001,int_stack+69678, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1323, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
     Libderiv->ABCD[43] = int_stack + 230496;
 /*--- compute (hp|hp) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+66150,int_stack+167874,int_stack+72765, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+144060, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
     Libderiv->ABCD[42] = int_stack + 66150;
 /*--- compute (hp|hp) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+70119,int_stack+75411,int_stack+74088, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+3969, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
     Libderiv->ABCD[38] = int_stack + 70119;
 /*--- compute (hp|hp) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+234465,int_stack+78498,int_stack+77175, 0.0, zero_stack, 1.0, int_stack+131271, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
     Libderiv->ABCD[35] = int_stack + 234465;
 /*--- compute (hp|hp) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+74088,int_stack+169638,int_stack+80262, 0.0, zero_stack, 1.0, int_stack+134358, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
     Libderiv->ABCD[34] = int_stack + 74088;
 /*--- compute (hp|hp) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+166110,int_stack+82908,int_stack+81585, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
     Libderiv->ABCD[33] = int_stack + 166110;
 /*--- compute (hp|hp) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+78057,int_stack+85995,int_stack+84672, 0.0, zero_stack, 1.0, int_stack+139209, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
     Libderiv->ABCD[32] = int_stack + 78057;
 /*--- compute (hp|hp) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+82026,int_stack+171402,int_stack+87759, 0.0, zero_stack, 1.0, int_stack+1323, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
     Libderiv->ABCD[31] = int_stack + 82026;
 /*--- compute (hp|hp) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+238434,int_stack+90405,int_stack+89082, 0.0, zero_stack, 1.0, int_stack+144060, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
     Libderiv->ABCD[30] = int_stack + 238434;
 /*--- compute (hp|hp) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+85995,int_stack+93492,int_stack+92169, 0.0, zero_stack, 1.0, int_stack+3969, 1.0, int_stack+148911, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
     Libderiv->ABCD[26] = int_stack + 85995;
 /*--- compute (hp|hp) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+89964,int_stack+173166,int_stack+95256, 0.0, zero_stack, 2.0, int_stack+148911, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
     Libderiv->ABCD[25] = int_stack + 89964;
 /*--- compute (hp|hp) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+170079,int_stack+97902,int_stack+96579, 1.0, int_stack+131271, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
     Libderiv->ABCD[23] = int_stack + 170079;
 /*--- compute (hp|hp) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+93933,int_stack+100989,int_stack+99666, 1.0, int_stack+134358, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
     Libderiv->ABCD[22] = int_stack + 93933;
 /*--- compute (hp|hp) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+97902,int_stack+104076,int_stack+102753, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
     Libderiv->ABCD[21] = int_stack + 97902;
 /*--- compute (hp|hp) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+101871,int_stack+107163,int_stack+105840, 1.0, int_stack+139209, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
     Libderiv->ABCD[20] = int_stack + 101871;
 /*--- compute (hp|hp) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+128331,int_stack+110250,int_stack+108927, 1.0, int_stack+1323, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
     Libderiv->ABCD[19] = int_stack + 128331;
 /*--- compute (hp|hp) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+0,int_stack+113337,int_stack+112014, 1.0, int_stack+144060, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
     Libderiv->ABCD[18] = int_stack + 0;
 /*--- compute (hp|hp) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+105840,int_stack+116424,int_stack+115101, 1.0, int_stack+3969, 0.0, zero_stack, 1.0, int_stack+5292, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
     Libderiv->ABCD[14] = int_stack + 105840;
 /*--- compute (hp|hp) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+109809,int_stack+119511,int_stack+118188, 1.0, int_stack+148911, 1.0, int_stack+5292, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
     Libderiv->ABCD[13] = int_stack + 109809;
 /*--- compute (hp|hp) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+113778,int_stack+122598,int_stack+121275, 2.0, int_stack+5292, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
     Libderiv->ABCD[12] = int_stack + 113778;

}
