/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include <libint/libint.h>
#include "libderiv.h"
#include <libint/hrr_header.h>

#include "d1hrr_header.h"

extern void d1vrr_order_00hd(Libderiv_t *, prim_data *);

  /* Computes derivatives of (00|hd) integrals */

void d1hrr_order_00hd(Libderiv_t *Libderiv, int num_prim_comb)
{
 prim_data *Data = Libderiv->PrimQuartet;
 double *int_stack = Libderiv->int_stack;
 double *zero_stack = Libderiv->zero_stack;
 int i,j;
 double tmp, *target;

 Libderiv->deriv_classes[0][5][11] = int_stack + 0;
 Libderiv->deriv_classes[0][6][11] = int_stack + 21;
 Libderiv->deriv_classes[0][7][11] = int_stack + 49;
 Libderiv->deriv_classes[0][5][10] = int_stack + 85;
 Libderiv->deriv_classes[0][6][10] = int_stack + 106;
 Libderiv->deriv_classes[0][7][10] = int_stack + 134;
 Libderiv->deriv_classes[0][5][9] = int_stack + 170;
 Libderiv->deriv_classes[0][6][9] = int_stack + 191;
 Libderiv->deriv_classes[0][7][9] = int_stack + 219;
 Libderiv->deriv_classes[0][5][8] = int_stack + 255;
 Libderiv->deriv_classes[0][6][8] = int_stack + 276;
 Libderiv->deriv_classes[0][7][8] = int_stack + 304;
 Libderiv->deriv_classes[0][5][7] = int_stack + 340;
 Libderiv->deriv_classes[0][6][7] = int_stack + 361;
 Libderiv->deriv_classes[0][7][7] = int_stack + 389;
 Libderiv->dvrr_classes[0][5] = int_stack + 425;
 Libderiv->deriv_classes[0][5][6] = int_stack + 446;
 Libderiv->dvrr_classes[0][6] = int_stack + 467;
 Libderiv->deriv_classes[0][6][6] = int_stack + 495;
 Libderiv->deriv_classes[0][7][6] = int_stack + 523;
 Libderiv->deriv_classes[0][5][2] = int_stack + 559;
 Libderiv->deriv_classes[0][6][2] = int_stack + 580;
 Libderiv->deriv_classes[0][7][2] = int_stack + 608;
 Libderiv->deriv_classes[0][5][1] = int_stack + 644;
 Libderiv->deriv_classes[0][6][1] = int_stack + 665;
 Libderiv->deriv_classes[0][7][1] = int_stack + 693;
 Libderiv->deriv_classes[0][5][0] = int_stack + 729;
 Libderiv->deriv_classes[0][6][0] = int_stack + 750;
 Libderiv->deriv_classes[0][7][0] = int_stack + 778;
 memset(int_stack,0,6512);

 Libderiv->dvrr_stack = int_stack + 1654;
 for(i=0;i<num_prim_comb;i++) {
   d1vrr_order_00hd(Libderiv, Data);
   Data++;
 }

 /*--- compute (00|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+814,int_stack+467,int_stack+425,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+877,int_stack+21,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+425,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+940,int_stack+49,int_stack+21, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+467,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+0,int_stack+106,int_stack+85, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+425, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1024,int_stack+134,int_stack+106, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+467, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+63,int_stack+191,int_stack+170, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+425, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1108,int_stack+219,int_stack+191, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+467, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+126,int_stack+276,int_stack+255, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+425, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+189,int_stack+304,int_stack+276, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+467, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+273,int_stack+361,int_stack+340, 0.0, zero_stack, 1.0, int_stack+425, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1192,int_stack+389,int_stack+361, 0.0, zero_stack, 1.0, int_stack+467, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+336,int_stack+495,int_stack+446, 1.0, int_stack+425, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1276,int_stack+523,int_stack+495, 1.0, int_stack+467, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+399,int_stack+580,int_stack+559,1);
 /*--- compute (00|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+462,int_stack+608,int_stack+580,1);
 /*--- compute (00|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+546,int_stack+665,int_stack+644,1);
 /*--- compute (00|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+1360,int_stack+693,int_stack+665,1);
 /*--- compute (00|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+609,int_stack+750,int_stack+729,1);
 /*--- compute (00|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+1444,int_stack+778,int_stack+750,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+672,int_stack+940,int_stack+877, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+814,1);
     Libderiv->ABCD[11] = int_stack + 672;
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+877,int_stack+1024,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+814, 0.0, zero_stack,1);
     Libderiv->ABCD[10] = int_stack + 877;
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1528,int_stack+1108,int_stack+63, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+814, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[9] = int_stack + 1528;
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+0,int_stack+189,int_stack+126, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+814, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[8] = int_stack + 0;
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+126,int_stack+1192,int_stack+273, 0.0, zero_stack, 1.0, int_stack+814, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[7] = int_stack + 126;
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1003,int_stack+1276,int_stack+336, 1.0, int_stack+814, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[6] = int_stack + 1003;
 /*--- compute (00|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+252,int_stack+462,int_stack+399,1);
     Libderiv->ABCD[2] = int_stack + 252;
 /*--- compute (00|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+378,int_stack+1360,int_stack+546,1);
     Libderiv->ABCD[1] = int_stack + 378;
 /*--- compute (00|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+1129,int_stack+1444,int_stack+609,1);
     Libderiv->ABCD[0] = int_stack + 1129;

}
