/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include <libint/libint.h>
#include "libderiv.h"
#include <libint/hrr_header.h>

#include "d1hrr_header.h"

extern void d1vrr_order_00hg(Libderiv_t *, prim_data *);

  /* Computes derivatives of (00|hg) integrals */

void d1hrr_order_00hg(Libderiv_t *Libderiv, int num_prim_comb)
{
 prim_data *Data = Libderiv->PrimQuartet;
 double *int_stack = Libderiv->int_stack;
 double *zero_stack = Libderiv->zero_stack;
 int i,j;
 double tmp, *target;

 Libderiv->deriv_classes[0][5][11] = int_stack + 0;
 Libderiv->deriv_classes[0][6][11] = int_stack + 21;
 Libderiv->deriv_classes[0][7][11] = int_stack + 49;
 Libderiv->deriv_classes[0][8][11] = int_stack + 85;
 Libderiv->deriv_classes[0][9][11] = int_stack + 130;
 Libderiv->deriv_classes[0][5][10] = int_stack + 185;
 Libderiv->deriv_classes[0][6][10] = int_stack + 206;
 Libderiv->deriv_classes[0][7][10] = int_stack + 234;
 Libderiv->deriv_classes[0][8][10] = int_stack + 270;
 Libderiv->deriv_classes[0][9][10] = int_stack + 315;
 Libderiv->deriv_classes[0][5][9] = int_stack + 370;
 Libderiv->deriv_classes[0][6][9] = int_stack + 391;
 Libderiv->deriv_classes[0][7][9] = int_stack + 419;
 Libderiv->deriv_classes[0][8][9] = int_stack + 455;
 Libderiv->deriv_classes[0][9][9] = int_stack + 500;
 Libderiv->deriv_classes[0][5][8] = int_stack + 555;
 Libderiv->deriv_classes[0][6][8] = int_stack + 576;
 Libderiv->deriv_classes[0][7][8] = int_stack + 604;
 Libderiv->deriv_classes[0][8][8] = int_stack + 640;
 Libderiv->deriv_classes[0][9][8] = int_stack + 685;
 Libderiv->deriv_classes[0][5][7] = int_stack + 740;
 Libderiv->deriv_classes[0][6][7] = int_stack + 761;
 Libderiv->deriv_classes[0][7][7] = int_stack + 789;
 Libderiv->deriv_classes[0][8][7] = int_stack + 825;
 Libderiv->deriv_classes[0][9][7] = int_stack + 870;
 Libderiv->dvrr_classes[0][5] = int_stack + 925;
 Libderiv->deriv_classes[0][5][6] = int_stack + 946;
 Libderiv->dvrr_classes[0][6] = int_stack + 967;
 Libderiv->deriv_classes[0][6][6] = int_stack + 995;
 Libderiv->dvrr_classes[0][7] = int_stack + 1023;
 Libderiv->deriv_classes[0][7][6] = int_stack + 1059;
 Libderiv->dvrr_classes[0][8] = int_stack + 1095;
 Libderiv->deriv_classes[0][8][6] = int_stack + 1140;
 Libderiv->deriv_classes[0][9][6] = int_stack + 1185;
 Libderiv->deriv_classes[0][5][2] = int_stack + 1240;
 Libderiv->deriv_classes[0][6][2] = int_stack + 1261;
 Libderiv->deriv_classes[0][7][2] = int_stack + 1289;
 Libderiv->deriv_classes[0][8][2] = int_stack + 1325;
 Libderiv->deriv_classes[0][9][2] = int_stack + 1370;
 Libderiv->deriv_classes[0][5][1] = int_stack + 1425;
 Libderiv->deriv_classes[0][6][1] = int_stack + 1446;
 Libderiv->deriv_classes[0][7][1] = int_stack + 1474;
 Libderiv->deriv_classes[0][8][1] = int_stack + 1510;
 Libderiv->deriv_classes[0][9][1] = int_stack + 1555;
 Libderiv->deriv_classes[0][5][0] = int_stack + 1610;
 Libderiv->deriv_classes[0][6][0] = int_stack + 1631;
 Libderiv->deriv_classes[0][7][0] = int_stack + 1659;
 Libderiv->deriv_classes[0][8][0] = int_stack + 1695;
 Libderiv->deriv_classes[0][9][0] = int_stack + 1740;
 memset(int_stack,0,14360);

 Libderiv->dvrr_stack = int_stack + 6473;
 for(i=0;i<num_prim_comb;i++) {
   d1vrr_order_00hg(Libderiv, Data);
   Data++;
 }

 /*--- compute (00|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+1795,int_stack+967,int_stack+925,1);
 /*--- compute (00|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+1858,int_stack+1023,int_stack+967,1);
 /*--- compute (00|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+1942,int_stack+1858,int_stack+1795,1);
 /*--- compute (00|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+2068,int_stack+1095,int_stack+1023,1);
 /*--- compute (00|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+2176,int_stack+2068,int_stack+1858,1);
 /*--- compute (00|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+2344,int_stack+2176,int_stack+1942,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2554,int_stack+21,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+925,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2617,int_stack+49,int_stack+21, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+967,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2701,int_stack+2617,int_stack+2554, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1795,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2827,int_stack+85,int_stack+49, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1023,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2935,int_stack+2827,int_stack+2617, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1858,1);
 /*--- compute (00|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+3103,int_stack+2935,int_stack+2701, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1942,1);
 /*--- compute (00|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+2554,int_stack+130,int_stack+85, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1095,1);
 /*--- compute (00|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+3313,int_stack+2554,int_stack+2827, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2068,1);
 /*--- compute (00|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+2554,int_stack+3313,int_stack+2935, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2176,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+3313,int_stack+206,int_stack+185, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+925, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+3376,int_stack+234,int_stack+206, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+967, 0.0, zero_stack,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+3460,int_stack+3376,int_stack+3313, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1795, 0.0, zero_stack,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+3586,int_stack+270,int_stack+234, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1023, 0.0, zero_stack,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+3694,int_stack+3586,int_stack+3376, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1858, 0.0, zero_stack,1);
 /*--- compute (00|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2834,int_stack+3694,int_stack+3460, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1942, 0.0, zero_stack,1);
 /*--- compute (00|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+3313,int_stack+315,int_stack+270, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1095, 0.0, zero_stack,1);
 /*--- compute (00|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+0,int_stack+3313,int_stack+3586, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2068, 0.0, zero_stack,1);
 /*--- compute (00|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+3313,int_stack+0,int_stack+3694, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2176, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+0,int_stack+391,int_stack+370, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+925, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+63,int_stack+419,int_stack+391, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+967, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+147,int_stack+63,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1795, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+273,int_stack+455,int_stack+419, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1023, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+3593,int_stack+273,int_stack+63, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1858, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+3761,int_stack+3593,int_stack+147, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1942, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+0,int_stack+500,int_stack+455, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1095, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+3971,int_stack+0,int_stack+273, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2068, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+0,int_stack+3971,int_stack+3593, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2176, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+3593,int_stack+576,int_stack+555, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+925, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+3656,int_stack+604,int_stack+576, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+967, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+3971,int_stack+3656,int_stack+3593, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1795, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+4097,int_stack+640,int_stack+604, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1023, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+4205,int_stack+4097,int_stack+3656, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1858, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+4373,int_stack+4205,int_stack+3971, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1942, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+3593,int_stack+685,int_stack+640, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1095, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+4583,int_stack+3593,int_stack+4097, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2068, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+280,int_stack+4583,int_stack+4205, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2176, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+4583,int_stack+761,int_stack+740, 0.0, zero_stack, 1.0, int_stack+925, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+4646,int_stack+789,int_stack+761, 0.0, zero_stack, 1.0, int_stack+967, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+4730,int_stack+4646,int_stack+4583, 0.0, zero_stack, 1.0, int_stack+1795, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+4856,int_stack+825,int_stack+789, 0.0, zero_stack, 1.0, int_stack+1023, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+3593,int_stack+4856,int_stack+4646, 0.0, zero_stack, 1.0, int_stack+1858, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+3971,int_stack+3593,int_stack+4730, 0.0, zero_stack, 1.0, int_stack+1942, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+4583,int_stack+870,int_stack+825, 0.0, zero_stack, 1.0, int_stack+1095, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+560,int_stack+4583,int_stack+4856, 0.0, zero_stack, 1.0, int_stack+2068, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+4583,int_stack+560,int_stack+3593, 0.0, zero_stack, 1.0, int_stack+2176, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+3593,int_stack+995,int_stack+946, 1.0, int_stack+925, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+3656,int_stack+1059,int_stack+995, 1.0, int_stack+967, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+560,int_stack+3656,int_stack+3593, 1.0, int_stack+1795, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+686,int_stack+1140,int_stack+1059, 1.0, int_stack+1023, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+794,int_stack+686,int_stack+3656, 1.0, int_stack+1858, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+4863,int_stack+794,int_stack+560, 1.0, int_stack+1942, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1795,int_stack+1185,int_stack+1140, 1.0, int_stack+1095, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+962,int_stack+1795,int_stack+686, 1.0, int_stack+2068, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1795,int_stack+962,int_stack+794, 1.0, int_stack+2176, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+2075,int_stack+1261,int_stack+1240,1);
 /*--- compute (00|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+2138,int_stack+1289,int_stack+1261,1);
 /*--- compute (00|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+560,int_stack+2138,int_stack+2075,1);
 /*--- compute (00|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+2222,int_stack+1325,int_stack+1289,1);
 /*--- compute (00|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+3593,int_stack+2222,int_stack+2138,1);
 /*--- compute (00|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+686,int_stack+3593,int_stack+560,1);
 /*--- compute (00|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+2075,int_stack+1370,int_stack+1325,1);
 /*--- compute (00|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+896,int_stack+2075,int_stack+2222,1);
 /*--- compute (00|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+1112,int_stack+896,int_stack+3593,1);
 /*--- compute (00|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+3593,int_stack+1446,int_stack+1425,1);
 /*--- compute (00|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+3656,int_stack+1474,int_stack+1446,1);
 /*--- compute (00|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+560,int_stack+3656,int_stack+3593,1);
 /*--- compute (00|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+896,int_stack+1510,int_stack+1474,1);
 /*--- compute (00|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+2075,int_stack+896,int_stack+3656,1);
 /*--- compute (00|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+5073,int_stack+2075,int_stack+560,1);
 /*--- compute (00|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+3593,int_stack+1555,int_stack+1510,1);
 /*--- compute (00|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+1392,int_stack+3593,int_stack+896,1);
 /*--- compute (00|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+5283,int_stack+1392,int_stack+2075,1);
 /*--- compute (00|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+2075,int_stack+1631,int_stack+1610,1);
 /*--- compute (00|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+2138,int_stack+1659,int_stack+1631,1);
 /*--- compute (00|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+560,int_stack+2138,int_stack+2075,1);
 /*--- compute (00|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+2222,int_stack+1695,int_stack+1659,1);
 /*--- compute (00|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+3593,int_stack+2222,int_stack+2138,1);
 /*--- compute (00|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+1392,int_stack+3593,int_stack+560,1);
 /*--- compute (00|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+2075,int_stack+1740,int_stack+1695,1);
 /*--- compute (00|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+896,int_stack+2075,int_stack+2222,1);
 /*--- compute (00|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+5563,int_stack+896,int_stack+3593,1);
 /*--- compute (00|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+5843,int_stack+2554,int_stack+3103, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2344,1);
     Libderiv->ABCD[11] = int_stack + 5843;
 /*--- compute (00|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+6158,int_stack+3313,int_stack+2834, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2344, 0.0, zero_stack,1);
     Libderiv->ABCD[10] = int_stack + 6158;
 /*--- compute (00|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+2554,int_stack+0,int_stack+3761, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2344, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[9] = int_stack + 2554;
 /*--- compute (00|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+2869,int_stack+280,int_stack+4373, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2344, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[8] = int_stack + 2869;
 /*--- compute (00|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+0,int_stack+4583,int_stack+3971, 0.0, zero_stack, 1.0, int_stack+2344, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[7] = int_stack + 0;
 /*--- compute (00|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+315,int_stack+1795,int_stack+4863, 1.0, int_stack+2344, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[6] = int_stack + 315;
 /*--- compute (00|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+3184,int_stack+1112,int_stack+686,1);
     Libderiv->ABCD[2] = int_stack + 3184;
 /*--- compute (00|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+630,int_stack+5283,int_stack+5073,1);
     Libderiv->ABCD[1] = int_stack + 630;
 /*--- compute (00|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+945,int_stack+5563,int_stack+1392,1);
     Libderiv->ABCD[0] = int_stack + 945;

}
