/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include <libint/libint.h>
#include "libderiv.h"
#include <libint/hrr_header.h>

#include "d1hrr_header.h"

extern void d1vrr_order_d0ig(Libderiv_t *, prim_data *);

  /* Computes derivatives of (d0|ig) integrals */

void d1hrr_order_d0ig(Libderiv_t *Libderiv, int num_prim_comb)
{
 prim_data *Data = Libderiv->PrimQuartet;
 double *int_stack = Libderiv->int_stack;
 double *zero_stack = Libderiv->zero_stack;
 int i,j;
 double tmp, *target;

 Libderiv->deriv_classes[2][6][11] = int_stack + 0;
 Libderiv->deriv_classes[2][7][11] = int_stack + 168;
 Libderiv->deriv_classes[2][8][11] = int_stack + 384;
 Libderiv->deriv_classes[2][9][11] = int_stack + 654;
 Libderiv->deriv_classes[2][10][11] = int_stack + 984;
 Libderiv->deriv_classes[2][6][10] = int_stack + 1380;
 Libderiv->deriv_classes[2][7][10] = int_stack + 1548;
 Libderiv->deriv_classes[2][8][10] = int_stack + 1764;
 Libderiv->deriv_classes[2][9][10] = int_stack + 2034;
 Libderiv->deriv_classes[2][10][10] = int_stack + 2364;
 Libderiv->deriv_classes[2][6][9] = int_stack + 2760;
 Libderiv->deriv_classes[2][7][9] = int_stack + 2928;
 Libderiv->deriv_classes[2][8][9] = int_stack + 3144;
 Libderiv->deriv_classes[2][9][9] = int_stack + 3414;
 Libderiv->deriv_classes[2][10][9] = int_stack + 3744;
 Libderiv->deriv_classes[2][6][8] = int_stack + 4140;
 Libderiv->deriv_classes[2][7][8] = int_stack + 4308;
 Libderiv->deriv_classes[2][8][8] = int_stack + 4524;
 Libderiv->deriv_classes[2][9][8] = int_stack + 4794;
 Libderiv->deriv_classes[2][10][8] = int_stack + 5124;
 Libderiv->deriv_classes[2][6][7] = int_stack + 5520;
 Libderiv->deriv_classes[2][7][7] = int_stack + 5688;
 Libderiv->deriv_classes[2][8][7] = int_stack + 5904;
 Libderiv->deriv_classes[2][9][7] = int_stack + 6174;
 Libderiv->deriv_classes[2][10][7] = int_stack + 6504;
 Libderiv->dvrr_classes[2][6] = int_stack + 6900;
 Libderiv->deriv_classes[2][6][6] = int_stack + 7068;
 Libderiv->dvrr_classes[2][7] = int_stack + 7236;
 Libderiv->deriv_classes[2][7][6] = int_stack + 7452;
 Libderiv->dvrr_classes[2][8] = int_stack + 7668;
 Libderiv->deriv_classes[2][8][6] = int_stack + 7938;
 Libderiv->dvrr_classes[2][9] = int_stack + 8208;
 Libderiv->deriv_classes[2][9][6] = int_stack + 8538;
 Libderiv->deriv_classes[2][10][6] = int_stack + 8868;
 Libderiv->deriv_classes[2][6][2] = int_stack + 9264;
 Libderiv->deriv_classes[2][7][2] = int_stack + 9432;
 Libderiv->deriv_classes[2][8][2] = int_stack + 9648;
 Libderiv->deriv_classes[2][9][2] = int_stack + 9918;
 Libderiv->deriv_classes[2][10][2] = int_stack + 10248;
 Libderiv->deriv_classes[2][6][1] = int_stack + 10644;
 Libderiv->deriv_classes[2][7][1] = int_stack + 10812;
 Libderiv->deriv_classes[2][8][1] = int_stack + 11028;
 Libderiv->deriv_classes[2][9][1] = int_stack + 11298;
 Libderiv->deriv_classes[2][10][1] = int_stack + 11628;
 Libderiv->deriv_classes[2][6][0] = int_stack + 12024;
 Libderiv->deriv_classes[2][7][0] = int_stack + 12192;
 Libderiv->deriv_classes[2][8][0] = int_stack + 12408;
 Libderiv->deriv_classes[2][9][0] = int_stack + 12678;
 Libderiv->deriv_classes[2][10][0] = int_stack + 13008;
 memset(int_stack,0,107232);

 Libderiv->dvrr_stack = int_stack + 47094;
 for(i=0;i<num_prim_comb;i++) {
   d1vrr_order_d0ig(Libderiv, Data);
   Data++;
 }

 /*--- compute (d0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+13404,int_stack+7236,int_stack+6900,6);
 /*--- compute (d0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+13908,int_stack+7668,int_stack+7236,6);
 /*--- compute (d0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+14556,int_stack+13908,int_stack+13404,6);
 /*--- compute (d0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+15564,int_stack+8208,int_stack+7668,6);
 /*--- compute (d0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+16374,int_stack+15564,int_stack+13908,6);
 /*--- compute (d0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+17670,int_stack+16374,int_stack+14556,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+19350,int_stack+168,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6900,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+19854,int_stack+384,int_stack+168, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7236,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+20502,int_stack+19854,int_stack+19350, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+13404,6);
 /*--- compute (d0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+21510,int_stack+654,int_stack+384, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7668,6);
 /*--- compute (d0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+22320,int_stack+21510,int_stack+19854, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+13908,6);
 /*--- compute (d0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+23616,int_stack+22320,int_stack+20502, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+14556,6);
 /*--- compute (d0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+19350,int_stack+984,int_stack+654, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8208,6);
 /*--- compute (d0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+25296,int_stack+19350,int_stack+21510, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+15564,6);
 /*--- compute (d0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+19350,int_stack+25296,int_stack+22320, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+16374,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+25296,int_stack+1548,int_stack+1380, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6900, 0.0, zero_stack,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+25800,int_stack+1764,int_stack+1548, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7236, 0.0, zero_stack,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+21510,int_stack+25800,int_stack+25296, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+13404, 0.0, zero_stack,6);
 /*--- compute (d0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+22518,int_stack+2034,int_stack+1764, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7668, 0.0, zero_stack,6);
 /*--- compute (d0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+0,int_stack+22518,int_stack+25800, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+13908, 0.0, zero_stack,6);
 /*--- compute (d0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+25296,int_stack+0,int_stack+21510, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+14556, 0.0, zero_stack,6);
 /*--- compute (d0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+21510,int_stack+2364,int_stack+2034, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8208, 0.0, zero_stack,6);
 /*--- compute (d0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+26976,int_stack+21510,int_stack+22518, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+15564, 0.0, zero_stack,6);
 /*--- compute (d0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+28596,int_stack+26976,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+16374, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+0,int_stack+2928,int_stack+2760, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6900, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+504,int_stack+3144,int_stack+2928, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7236, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1152,int_stack+504,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+13404, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+2160,int_stack+3414,int_stack+3144, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7668, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+26976,int_stack+2160,int_stack+504, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+13908, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+21510,int_stack+26976,int_stack+1152, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+14556, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+0,int_stack+3744,int_stack+3414, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8208, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+30756,int_stack+0,int_stack+2160, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+15564, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+0,int_stack+30756,int_stack+26976, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+16374, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+26976,int_stack+4308,int_stack+4140, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6900, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+27480,int_stack+4524,int_stack+4308, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7236, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+30756,int_stack+27480,int_stack+26976, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+13404, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+31764,int_stack+4794,int_stack+4524, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7668, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+2160,int_stack+31764,int_stack+27480, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+13908, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+32574,int_stack+2160,int_stack+30756, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+14556, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+30756,int_stack+5124,int_stack+4794, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8208, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+26976,int_stack+30756,int_stack+31764, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+15564, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+34254,int_stack+26976,int_stack+2160, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+16374, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2160,int_stack+5688,int_stack+5520, 0.0, zero_stack, 1.0, int_stack+6900, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2664,int_stack+5904,int_stack+5688, 0.0, zero_stack, 1.0, int_stack+7236, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+3312,int_stack+2664,int_stack+2160, 0.0, zero_stack, 1.0, int_stack+13404, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+4320,int_stack+6174,int_stack+5904, 0.0, zero_stack, 1.0, int_stack+7668, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+26976,int_stack+4320,int_stack+2664, 0.0, zero_stack, 1.0, int_stack+13908, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+30756,int_stack+26976,int_stack+3312, 0.0, zero_stack, 1.0, int_stack+14556, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+2160,int_stack+6504,int_stack+6174, 0.0, zero_stack, 1.0, int_stack+8208, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+5130,int_stack+2160,int_stack+4320, 0.0, zero_stack, 1.0, int_stack+15564, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+2160,int_stack+5130,int_stack+26976, 0.0, zero_stack, 1.0, int_stack+16374, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+26976,int_stack+7452,int_stack+7068, 1.0, int_stack+6900, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+27480,int_stack+7938,int_stack+7452, 1.0, int_stack+7236, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+4320,int_stack+27480,int_stack+26976, 1.0, int_stack+13404, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+5328,int_stack+8538,int_stack+7938, 1.0, int_stack+7668, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+6138,int_stack+5328,int_stack+27480, 1.0, int_stack+13908, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+36414,int_stack+6138,int_stack+4320, 1.0, int_stack+14556, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+4320,int_stack+8868,int_stack+8538, 1.0, int_stack+8208, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+26976,int_stack+4320,int_stack+5328, 1.0, int_stack+15564, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+13404,int_stack+26976,int_stack+6138, 1.0, int_stack+16374, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+26976,int_stack+9432,int_stack+9264,6);
 /*--- compute (d0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+27480,int_stack+9648,int_stack+9432,6);
 /*--- compute (d0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+4320,int_stack+27480,int_stack+26976,6);
 /*--- compute (d0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+5328,int_stack+9918,int_stack+9648,6);
 /*--- compute (d0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+6138,int_stack+5328,int_stack+27480,6);
 /*--- compute (d0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+7434,int_stack+6138,int_stack+4320,6);
 /*--- compute (d0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+4320,int_stack+10248,int_stack+9918,6);
 /*--- compute (d0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+26976,int_stack+4320,int_stack+5328,6);
 /*--- compute (d0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+38094,int_stack+26976,int_stack+6138,6);
 /*--- compute (d0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+26976,int_stack+10812,int_stack+10644,6);
 /*--- compute (d0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+27480,int_stack+11028,int_stack+10812,6);
 /*--- compute (d0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+4320,int_stack+27480,int_stack+26976,6);
 /*--- compute (d0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+5328,int_stack+11298,int_stack+11028,6);
 /*--- compute (d0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+6138,int_stack+5328,int_stack+27480,6);
 /*--- compute (d0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+9114,int_stack+6138,int_stack+4320,6);
 /*--- compute (d0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+4320,int_stack+11628,int_stack+11298,6);
 /*--- compute (d0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+26976,int_stack+4320,int_stack+5328,6);
 /*--- compute (d0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+40254,int_stack+26976,int_stack+6138,6);
 /*--- compute (d0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+26976,int_stack+12192,int_stack+12024,6);
 /*--- compute (d0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+27480,int_stack+12408,int_stack+12192,6);
 /*--- compute (d0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+4320,int_stack+27480,int_stack+26976,6);
 /*--- compute (d0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+5328,int_stack+12678,int_stack+12408,6);
 /*--- compute (d0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+6138,int_stack+5328,int_stack+27480,6);
 /*--- compute (d0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+10794,int_stack+6138,int_stack+4320,6);
 /*--- compute (d0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+4320,int_stack+13008,int_stack+12678,6);
 /*--- compute (d0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+26976,int_stack+4320,int_stack+5328,6);
 /*--- compute (d0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+42414,int_stack+26976,int_stack+6138,6);
 /*--- compute (d0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+4320,int_stack+19350,int_stack+23616, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+17670,6);
     Libderiv->ABCD[11] = int_stack + 4320;
 /*--- compute (d0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+44574,int_stack+28596,int_stack+25296, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+17670, 0.0, zero_stack,6);
     Libderiv->ABCD[10] = int_stack + 44574;
 /*--- compute (d0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+23190,int_stack+0,int_stack+21510, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+17670, 0.0, zero_stack, 0.0, zero_stack,6);
     Libderiv->ABCD[9] = int_stack + 23190;
 /*--- compute (d0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+19350,int_stack+34254,int_stack+32574, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+17670, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
     Libderiv->ABCD[8] = int_stack + 19350;
 /*--- compute (d0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+32436,int_stack+2160,int_stack+30756, 0.0, zero_stack, 1.0, int_stack+17670, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
     Libderiv->ABCD[7] = int_stack + 32436;
 /*--- compute (d0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+0,int_stack+13404,int_stack+36414, 1.0, int_stack+17670, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
     Libderiv->ABCD[6] = int_stack + 0;
 /*--- compute (d0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+12474,int_stack+38094,int_stack+7434,6);
     Libderiv->ABCD[2] = int_stack + 12474;
 /*--- compute (d0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+14994,int_stack+40254,int_stack+9114,6);
     Libderiv->ABCD[1] = int_stack + 14994;
 /*--- compute (d0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+6840,int_stack+42414,int_stack+10794,6);
     Libderiv->ABCD[0] = int_stack + 6840;

}
