/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include <libint/libint.h>
#include "libderiv.h"
#include <libint/hrr_header.h>

#include "d1hrr_header.h"

extern void d1vrr_order_ddhp(Libderiv_t *, prim_data *);

  /* Computes derivatives of (dd|hp) integrals */

void d1hrr_order_ddhp(Libderiv_t *Libderiv, int num_prim_comb)
{
 prim_data *Data = Libderiv->PrimQuartet;
 double *int_stack = Libderiv->int_stack;
 double *zero_stack = Libderiv->zero_stack;
 int i,j;
 double tmp, *target;

 Libderiv->deriv_classes[2][5][11] = int_stack + 0;
 Libderiv->deriv_classes[2][6][11] = int_stack + 126;
 Libderiv->deriv_classes[3][5][11] = int_stack + 294;
 Libderiv->deriv_classes[3][6][11] = int_stack + 504;
 Libderiv->deriv_classes[4][5][11] = int_stack + 784;
 Libderiv->deriv_classes[4][6][11] = int_stack + 1099;
 Libderiv->deriv_classes[2][5][10] = int_stack + 1519;
 Libderiv->deriv_classes[2][6][10] = int_stack + 1645;
 Libderiv->deriv_classes[3][5][10] = int_stack + 1813;
 Libderiv->deriv_classes[3][6][10] = int_stack + 2023;
 Libderiv->deriv_classes[4][5][10] = int_stack + 2303;
 Libderiv->deriv_classes[4][6][10] = int_stack + 2618;
 Libderiv->deriv_classes[2][5][9] = int_stack + 3038;
 Libderiv->deriv_classes[2][6][9] = int_stack + 3164;
 Libderiv->deriv_classes[3][5][9] = int_stack + 3332;
 Libderiv->deriv_classes[3][6][9] = int_stack + 3542;
 Libderiv->deriv_classes[4][5][9] = int_stack + 3822;
 Libderiv->deriv_classes[4][6][9] = int_stack + 4137;
 Libderiv->deriv_classes[2][5][8] = int_stack + 4557;
 Libderiv->deriv_classes[2][6][8] = int_stack + 4683;
 Libderiv->deriv_classes[3][5][8] = int_stack + 4851;
 Libderiv->deriv_classes[3][6][8] = int_stack + 5061;
 Libderiv->deriv_classes[4][5][8] = int_stack + 5341;
 Libderiv->deriv_classes[4][6][8] = int_stack + 5656;
 Libderiv->deriv_classes[2][5][7] = int_stack + 6076;
 Libderiv->deriv_classes[2][6][7] = int_stack + 6202;
 Libderiv->deriv_classes[3][5][7] = int_stack + 6370;
 Libderiv->deriv_classes[3][6][7] = int_stack + 6580;
 Libderiv->deriv_classes[4][5][7] = int_stack + 6860;
 Libderiv->deriv_classes[4][6][7] = int_stack + 7175;
 Libderiv->deriv_classes[2][5][6] = int_stack + 7595;
 Libderiv->deriv_classes[2][6][6] = int_stack + 7721;
 Libderiv->deriv_classes[3][5][6] = int_stack + 7889;
 Libderiv->deriv_classes[3][6][6] = int_stack + 8099;
 Libderiv->dvrr_classes[4][5] = int_stack + 8379;
 Libderiv->deriv_classes[4][5][6] = int_stack + 8694;
 Libderiv->deriv_classes[4][6][6] = int_stack + 9009;
 Libderiv->deriv_classes[2][5][2] = int_stack + 9429;
 Libderiv->deriv_classes[2][6][2] = int_stack + 9555;
 Libderiv->deriv_classes[3][5][2] = int_stack + 9723;
 Libderiv->deriv_classes[3][6][2] = int_stack + 9933;
 Libderiv->deriv_classes[4][5][2] = int_stack + 10213;
 Libderiv->deriv_classes[4][6][2] = int_stack + 10528;
 Libderiv->deriv_classes[2][5][1] = int_stack + 10948;
 Libderiv->deriv_classes[2][6][1] = int_stack + 11074;
 Libderiv->deriv_classes[3][5][1] = int_stack + 11242;
 Libderiv->deriv_classes[3][6][1] = int_stack + 11452;
 Libderiv->deriv_classes[4][5][1] = int_stack + 11732;
 Libderiv->deriv_classes[4][6][1] = int_stack + 12047;
 Libderiv->dvrr_classes[2][5] = int_stack + 12467;
 Libderiv->dvrr_classes[2][6] = int_stack + 12593;
 Libderiv->deriv_classes[2][5][0] = int_stack + 12761;
 Libderiv->deriv_classes[2][6][0] = int_stack + 12887;
 Libderiv->dvrr_classes[3][5] = int_stack + 13055;
 Libderiv->dvrr_classes[3][6] = int_stack + 13265;
 Libderiv->deriv_classes[3][5][0] = int_stack + 13545;
 Libderiv->deriv_classes[3][6][0] = int_stack + 13755;
 Libderiv->deriv_classes[4][5][0] = int_stack + 14035;
 Libderiv->deriv_classes[4][6][0] = int_stack + 14350;
 memset(int_stack,0,118160);

 Libderiv->dvrr_stack = int_stack + 33922;
 for(i=0;i<num_prim_comb;i++) {
   d1vrr_order_ddhp(Libderiv, Data);
   Data++;
 }

 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+14770,int_stack+126,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+12467,6);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+15148,int_stack+504,int_stack+294, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+13055,10);
 /*--- compute (dp|hp) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+15778,int_stack+15148,int_stack+14770,63);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+16912,int_stack+1099,int_stack+784, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8379,15);
 /*--- compute (fp|hp) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+17857,int_stack+16912,int_stack+15148,63);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+16912,int_stack+1645,int_stack+1519, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+12467, 0.0, zero_stack,6);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+14770,int_stack+2023,int_stack+1813, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+13055, 0.0, zero_stack,10);
 /*--- compute (dp|hp) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+0,int_stack+14770,int_stack+16912,63);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+16912,int_stack+2618,int_stack+2303, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8379, 0.0, zero_stack,15);
 /*--- compute (fp|hp) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+1134,int_stack+16912,int_stack+14770,63);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+14770,int_stack+3164,int_stack+3038, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+12467, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+15148,int_stack+3542,int_stack+3332, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+13055, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (dp|hp) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+19747,int_stack+15148,int_stack+14770,63);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+16912,int_stack+4137,int_stack+3822, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8379, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|hp) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+20881,int_stack+16912,int_stack+15148,63);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+16912,int_stack+4683,int_stack+4557, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+12467, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+14770,int_stack+5061,int_stack+4851, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+13055, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (dp|hp) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+3024,int_stack+14770,int_stack+16912,63);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+16912,int_stack+5656,int_stack+5341, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8379, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|hp) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+4158,int_stack+16912,int_stack+14770,63);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+14770,int_stack+6202,int_stack+6076, 0.0, zero_stack, 1.0, int_stack+12467, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+15148,int_stack+6580,int_stack+6370, 0.0, zero_stack, 1.0, int_stack+13055, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (dp|hp) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+22771,int_stack+15148,int_stack+14770,63);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+16912,int_stack+7175,int_stack+6860, 0.0, zero_stack, 1.0, int_stack+8379, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|hp) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+23905,int_stack+16912,int_stack+15148,63);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+16912,int_stack+7721,int_stack+7595, 1.0, int_stack+12467, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+14770,int_stack+8099,int_stack+7889, 1.0, int_stack+13055, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (dp|hp) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+6048,int_stack+14770,int_stack+16912,63);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+16912,int_stack+9009,int_stack+8694, 1.0, int_stack+8379, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|hp) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+7182,int_stack+16912,int_stack+14770,63);
 /*--- compute (d0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+14770,int_stack+12593,int_stack+12467,6);
 /*--- compute (f0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+15148,int_stack+13265,int_stack+13055,10);
 /*--- compute (dp|hp) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+25795,int_stack+15148,int_stack+14770,63);
 /*--- compute (d0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+13055,int_stack+9555,int_stack+9429,6);
 /*--- compute (f0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+16912,int_stack+9933,int_stack+9723,10);
 /*--- compute (dp|hp) ---*/
   d1hrr1_build_dp(Libderiv->AB,int_stack+9072,int_stack+16912,int_stack+13055, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+14770, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+26929,int_stack+10528,int_stack+10213,15);
 /*--- compute (fp|hp) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+27874,int_stack+26929,int_stack+16912, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+15148, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
 /*--- compute (d0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+16912,int_stack+11074,int_stack+10948,6);
 /*--- compute (f0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+26929,int_stack+11452,int_stack+11242,10);
 /*--- compute (dp|hp) ---*/
   d1hrr1_build_dp(Libderiv->AB,int_stack+10206,int_stack+26929,int_stack+16912, 0.0, zero_stack, 1.0, int_stack+14770, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+16912,int_stack+12047,int_stack+11732,15);
 /*--- compute (fp|hp) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+29764,int_stack+16912,int_stack+26929, 0.0, zero_stack, 1.0, int_stack+15148, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
 /*--- compute (d0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+26929,int_stack+12887,int_stack+12761,6);
 /*--- compute (f0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+16912,int_stack+13755,int_stack+13545,10);
 /*--- compute (dp|hp) ---*/
   d1hrr1_build_dp(Libderiv->AB,int_stack+11340,int_stack+16912,int_stack+26929, 1.0, int_stack+14770, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+26929,int_stack+14350,int_stack+14035,15);
 /*--- compute (fp|hp) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+12474,int_stack+26929,int_stack+16912, 1.0, int_stack+15148, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
 /*--- compute (dd|hp) ---*/
   hrr1_build_dd(Libderiv->AB,int_stack+31654,int_stack+17857,int_stack+15778,63);
     Libderiv->ABCD[11] = int_stack + 31654;
 /*--- compute (dd|hp) ---*/
   hrr1_build_dd(Libderiv->AB,int_stack+14364,int_stack+1134,int_stack+0,63);
     Libderiv->ABCD[10] = int_stack + 14364;
 /*--- compute (dd|hp) ---*/
   hrr1_build_dd(Libderiv->AB,int_stack+0,int_stack+20881,int_stack+19747,63);
     Libderiv->ABCD[9] = int_stack + 0;
 /*--- compute (dd|hp) ---*/
   hrr1_build_dd(Libderiv->AB,int_stack+16632,int_stack+4158,int_stack+3024,63);
     Libderiv->ABCD[8] = int_stack + 16632;
 /*--- compute (dd|hp) ---*/
   hrr1_build_dd(Libderiv->AB,int_stack+2268,int_stack+23905,int_stack+22771,63);
     Libderiv->ABCD[7] = int_stack + 2268;
 /*--- compute (dd|hp) ---*/
   hrr1_build_dd(Libderiv->AB,int_stack+18900,int_stack+7182,int_stack+6048,63);
     Libderiv->ABCD[6] = int_stack + 18900;
 /*--- compute (dd|hp) ---*/
   d1hrr1_build_dd(Libderiv->AB,int_stack+4536,int_stack+27874,int_stack+9072, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+25795, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
     Libderiv->ABCD[2] = int_stack + 4536;
 /*--- compute (dd|hp) ---*/
   d1hrr1_build_dd(Libderiv->AB,int_stack+6804,int_stack+29764,int_stack+10206, 0.0, zero_stack, 1.0, int_stack+25795, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
     Libderiv->ABCD[1] = int_stack + 6804;
 /*--- compute (dd|hp) ---*/
   d1hrr1_build_dd(Libderiv->AB,int_stack+9072,int_stack+12474,int_stack+11340, 1.0, int_stack+25795, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
     Libderiv->ABCD[0] = int_stack + 9072;

}
