/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include <libint/libint.h>
#include "libderiv.h"
#include <libint/hrr_header.h>

#include "d1hrr_header.h"

extern void d1vrr_order_dpip(Libderiv_t *, prim_data *);

  /* Computes derivatives of (dp|ip) integrals */

void d1hrr_order_dpip(Libderiv_t *Libderiv, int num_prim_comb)
{
 prim_data *Data = Libderiv->PrimQuartet;
 double *int_stack = Libderiv->int_stack;
 double *zero_stack = Libderiv->zero_stack;
 int i,j;
 double tmp, *target;

 Libderiv->deriv_classes[2][6][11] = int_stack + 0;
 Libderiv->deriv_classes[2][7][11] = int_stack + 168;
 Libderiv->deriv_classes[3][6][11] = int_stack + 384;
 Libderiv->deriv_classes[3][7][11] = int_stack + 664;
 Libderiv->deriv_classes[2][6][10] = int_stack + 1024;
 Libderiv->deriv_classes[2][7][10] = int_stack + 1192;
 Libderiv->deriv_classes[3][6][10] = int_stack + 1408;
 Libderiv->deriv_classes[3][7][10] = int_stack + 1688;
 Libderiv->deriv_classes[2][6][9] = int_stack + 2048;
 Libderiv->deriv_classes[2][7][9] = int_stack + 2216;
 Libderiv->deriv_classes[3][6][9] = int_stack + 2432;
 Libderiv->deriv_classes[3][7][9] = int_stack + 2712;
 Libderiv->deriv_classes[2][6][8] = int_stack + 3072;
 Libderiv->deriv_classes[2][7][8] = int_stack + 3240;
 Libderiv->deriv_classes[3][6][8] = int_stack + 3456;
 Libderiv->deriv_classes[3][7][8] = int_stack + 3736;
 Libderiv->deriv_classes[2][6][7] = int_stack + 4096;
 Libderiv->deriv_classes[2][7][7] = int_stack + 4264;
 Libderiv->deriv_classes[3][6][7] = int_stack + 4480;
 Libderiv->deriv_classes[3][7][7] = int_stack + 4760;
 Libderiv->deriv_classes[2][6][6] = int_stack + 5120;
 Libderiv->deriv_classes[2][7][6] = int_stack + 5288;
 Libderiv->dvrr_classes[3][6] = int_stack + 5504;
 Libderiv->deriv_classes[3][6][6] = int_stack + 5784;
 Libderiv->deriv_classes[3][7][6] = int_stack + 6064;
 Libderiv->deriv_classes[2][6][2] = int_stack + 6424;
 Libderiv->deriv_classes[2][7][2] = int_stack + 6592;
 Libderiv->deriv_classes[3][6][2] = int_stack + 6808;
 Libderiv->deriv_classes[3][7][2] = int_stack + 7088;
 Libderiv->deriv_classes[2][6][1] = int_stack + 7448;
 Libderiv->deriv_classes[2][7][1] = int_stack + 7616;
 Libderiv->deriv_classes[3][6][1] = int_stack + 7832;
 Libderiv->deriv_classes[3][7][1] = int_stack + 8112;
 Libderiv->dvrr_classes[2][6] = int_stack + 8472;
 Libderiv->dvrr_classes[2][7] = int_stack + 8640;
 Libderiv->deriv_classes[2][6][0] = int_stack + 8856;
 Libderiv->deriv_classes[2][7][0] = int_stack + 9024;
 Libderiv->deriv_classes[3][6][0] = int_stack + 9240;
 Libderiv->deriv_classes[3][7][0] = int_stack + 9520;
 memset(int_stack,0,79040);

 Libderiv->dvrr_stack = int_stack + 16768;
 for(i=0;i<num_prim_comb;i++) {
   d1vrr_order_dpip(Libderiv, Data);
   Data++;
 }

 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+9880,int_stack+168,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8472,6);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+10384,int_stack+664,int_stack+384, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5504,10);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+0,int_stack+1192,int_stack+1024, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8472, 0.0, zero_stack,6);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+504,int_stack+1688,int_stack+1408, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5504, 0.0, zero_stack,10);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1344,int_stack+2216,int_stack+2048, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8472, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+11224,int_stack+2712,int_stack+2432, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5504, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1848,int_stack+3240,int_stack+3072, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8472, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2352,int_stack+3736,int_stack+3456, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5504, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+3192,int_stack+4264,int_stack+4096, 0.0, zero_stack, 1.0, int_stack+8472, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+12064,int_stack+4760,int_stack+4480, 0.0, zero_stack, 1.0, int_stack+5504, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+3696,int_stack+5288,int_stack+5120, 1.0, int_stack+8472, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+4200,int_stack+6064,int_stack+5784, 1.0, int_stack+5504, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (d0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+5040,int_stack+8640,int_stack+8472,6);
 /*--- compute (d0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+5544,int_stack+6592,int_stack+6424,6);
 /*--- compute (f0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+12904,int_stack+7088,int_stack+6808,10);
 /*--- compute (d0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+6048,int_stack+7616,int_stack+7448,6);
 /*--- compute (f0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+6552,int_stack+8112,int_stack+7832,10);
 /*--- compute (d0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+7392,int_stack+9024,int_stack+8856,6);
 /*--- compute (f0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+7896,int_stack+9520,int_stack+9240,10);
 /*--- compute (dp|ip) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+13744,int_stack+10384,int_stack+9880,84);
     Libderiv->ABCD[11] = int_stack + 13744;
 /*--- compute (dp|ip) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+8736,int_stack+504,int_stack+0,84);
     Libderiv->ABCD[10] = int_stack + 8736;
 /*--- compute (dp|ip) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+15256,int_stack+11224,int_stack+1344,84);
     Libderiv->ABCD[9] = int_stack + 15256;
 /*--- compute (dp|ip) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+0,int_stack+2352,int_stack+1848,84);
     Libderiv->ABCD[8] = int_stack + 0;
 /*--- compute (dp|ip) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+1512,int_stack+12064,int_stack+3192,84);
     Libderiv->ABCD[7] = int_stack + 1512;
 /*--- compute (dp|ip) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+10248,int_stack+4200,int_stack+3696,84);
     Libderiv->ABCD[6] = int_stack + 10248;
 /*--- compute (dp|ip) ---*/
   d1hrr1_build_dp(Libderiv->AB,int_stack+3024,int_stack+12904,int_stack+5544, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5040, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,84);
     Libderiv->ABCD[2] = int_stack + 3024;
 /*--- compute (dp|ip) ---*/
   d1hrr1_build_dp(Libderiv->AB,int_stack+11760,int_stack+6552,int_stack+6048, 0.0, zero_stack, 1.0, int_stack+5040, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,84);
     Libderiv->ABCD[1] = int_stack + 11760;
 /*--- compute (dp|ip) ---*/
   d1hrr1_build_dp(Libderiv->AB,int_stack+5544,int_stack+7896,int_stack+7392, 1.0, int_stack+5040, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,84);
     Libderiv->ABCD[0] = int_stack + 5544;

}
