/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include <libint/libint.h>
#include "libderiv.h"
#include <libint/hrr_header.h>

#include "d1hrr_header.h"

extern void d1vrr_order_ffhp(Libderiv_t *, prim_data *);

  /* Computes derivatives of (ff|hp) integrals */

void d1hrr_order_ffhp(Libderiv_t *Libderiv, int num_prim_comb)
{
 prim_data *Data = Libderiv->PrimQuartet;
 double *int_stack = Libderiv->int_stack;
 double *zero_stack = Libderiv->zero_stack;
 int i,j;
 double tmp, *target;

 Libderiv->deriv_classes[3][5][11] = int_stack + 0;
 Libderiv->deriv_classes[3][6][11] = int_stack + 210;
 Libderiv->deriv_classes[4][5][11] = int_stack + 490;
 Libderiv->deriv_classes[4][6][11] = int_stack + 805;
 Libderiv->deriv_classes[5][5][11] = int_stack + 1225;
 Libderiv->deriv_classes[5][6][11] = int_stack + 1666;
 Libderiv->deriv_classes[6][5][11] = int_stack + 2254;
 Libderiv->deriv_classes[6][6][11] = int_stack + 2842;
 Libderiv->deriv_classes[3][5][10] = int_stack + 3626;
 Libderiv->deriv_classes[3][6][10] = int_stack + 3836;
 Libderiv->deriv_classes[4][5][10] = int_stack + 4116;
 Libderiv->deriv_classes[4][6][10] = int_stack + 4431;
 Libderiv->deriv_classes[5][5][10] = int_stack + 4851;
 Libderiv->deriv_classes[5][6][10] = int_stack + 5292;
 Libderiv->deriv_classes[6][5][10] = int_stack + 5880;
 Libderiv->deriv_classes[6][6][10] = int_stack + 6468;
 Libderiv->deriv_classes[3][5][9] = int_stack + 7252;
 Libderiv->deriv_classes[3][6][9] = int_stack + 7462;
 Libderiv->deriv_classes[4][5][9] = int_stack + 7742;
 Libderiv->deriv_classes[4][6][9] = int_stack + 8057;
 Libderiv->deriv_classes[5][5][9] = int_stack + 8477;
 Libderiv->deriv_classes[5][6][9] = int_stack + 8918;
 Libderiv->deriv_classes[6][5][9] = int_stack + 9506;
 Libderiv->deriv_classes[6][6][9] = int_stack + 10094;
 Libderiv->deriv_classes[3][5][8] = int_stack + 10878;
 Libderiv->deriv_classes[3][6][8] = int_stack + 11088;
 Libderiv->deriv_classes[4][5][8] = int_stack + 11368;
 Libderiv->deriv_classes[4][6][8] = int_stack + 11683;
 Libderiv->deriv_classes[5][5][8] = int_stack + 12103;
 Libderiv->deriv_classes[5][6][8] = int_stack + 12544;
 Libderiv->deriv_classes[6][5][8] = int_stack + 13132;
 Libderiv->deriv_classes[6][6][8] = int_stack + 13720;
 Libderiv->deriv_classes[3][5][7] = int_stack + 14504;
 Libderiv->deriv_classes[3][6][7] = int_stack + 14714;
 Libderiv->deriv_classes[4][5][7] = int_stack + 14994;
 Libderiv->deriv_classes[4][6][7] = int_stack + 15309;
 Libderiv->deriv_classes[5][5][7] = int_stack + 15729;
 Libderiv->deriv_classes[5][6][7] = int_stack + 16170;
 Libderiv->deriv_classes[6][5][7] = int_stack + 16758;
 Libderiv->deriv_classes[6][6][7] = int_stack + 17346;
 Libderiv->deriv_classes[3][5][6] = int_stack + 18130;
 Libderiv->deriv_classes[3][6][6] = int_stack + 18340;
 Libderiv->deriv_classes[4][5][6] = int_stack + 18620;
 Libderiv->deriv_classes[4][6][6] = int_stack + 18935;
 Libderiv->deriv_classes[5][5][6] = int_stack + 19355;
 Libderiv->deriv_classes[5][6][6] = int_stack + 19796;
 Libderiv->dvrr_classes[6][5] = int_stack + 20384;
 Libderiv->deriv_classes[6][5][6] = int_stack + 20972;
 Libderiv->deriv_classes[6][6][6] = int_stack + 21560;
 Libderiv->deriv_classes[3][5][2] = int_stack + 22344;
 Libderiv->deriv_classes[3][6][2] = int_stack + 22554;
 Libderiv->deriv_classes[4][5][2] = int_stack + 22834;
 Libderiv->deriv_classes[4][6][2] = int_stack + 23149;
 Libderiv->deriv_classes[5][5][2] = int_stack + 23569;
 Libderiv->deriv_classes[5][6][2] = int_stack + 24010;
 Libderiv->deriv_classes[6][5][2] = int_stack + 24598;
 Libderiv->deriv_classes[6][6][2] = int_stack + 25186;
 Libderiv->deriv_classes[3][5][1] = int_stack + 25970;
 Libderiv->deriv_classes[3][6][1] = int_stack + 26180;
 Libderiv->deriv_classes[4][5][1] = int_stack + 26460;
 Libderiv->deriv_classes[4][6][1] = int_stack + 26775;
 Libderiv->deriv_classes[5][5][1] = int_stack + 27195;
 Libderiv->deriv_classes[5][6][1] = int_stack + 27636;
 Libderiv->deriv_classes[6][5][1] = int_stack + 28224;
 Libderiv->deriv_classes[6][6][1] = int_stack + 28812;
 Libderiv->dvrr_classes[3][5] = int_stack + 29596;
 Libderiv->dvrr_classes[3][6] = int_stack + 29806;
 Libderiv->deriv_classes[3][5][0] = int_stack + 30086;
 Libderiv->deriv_classes[3][6][0] = int_stack + 30296;
 Libderiv->dvrr_classes[4][5] = int_stack + 30576;
 Libderiv->dvrr_classes[4][6] = int_stack + 30891;
 Libderiv->deriv_classes[4][5][0] = int_stack + 31311;
 Libderiv->deriv_classes[4][6][0] = int_stack + 31626;
 Libderiv->dvrr_classes[5][5] = int_stack + 32046;
 Libderiv->dvrr_classes[5][6] = int_stack + 32487;
 Libderiv->deriv_classes[5][5][0] = int_stack + 33075;
 Libderiv->deriv_classes[5][6][0] = int_stack + 33516;
 Libderiv->deriv_classes[6][5][0] = int_stack + 34104;
 Libderiv->deriv_classes[6][6][0] = int_stack + 34692;
 memset(int_stack,0,283808);

 Libderiv->dvrr_stack = int_stack + 117061;
 for(i=0;i<num_prim_comb;i++) {
   d1vrr_order_ffhp(Libderiv, Data);
   Data++;
 }

 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+35476,int_stack+210,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+29596,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+36106,int_stack+805,int_stack+490, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+30576,15);
 /*--- compute (fp|hp) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+37051,int_stack+36106,int_stack+35476,63);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+38941,int_stack+1666,int_stack+1225, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+32046,21);
 /*--- compute (gp|hp) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+40264,int_stack+38941,int_stack+36106,63);
 /*--- compute (fd|hp) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+43099,int_stack+40264,int_stack+37051,63);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+35476,int_stack+2842,int_stack+2254, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+20384,28);
 /*--- compute (hp|hp) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+46879,int_stack+35476,int_stack+38941,63);
 /*--- compute (gd|hp) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+50848,int_stack+46879,int_stack+40264,63);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+46879,int_stack+3836,int_stack+3626, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+29596, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+47509,int_stack+4431,int_stack+4116, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+30576, 0.0, zero_stack,15);
 /*--- compute (fp|hp) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+48454,int_stack+47509,int_stack+46879,63);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+35476,int_stack+5292,int_stack+4851, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+32046, 0.0, zero_stack,21);
 /*--- compute (gp|hp) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+36799,int_stack+35476,int_stack+47509,63);
 /*--- compute (fd|hp) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+0,int_stack+36799,int_stack+48454,63);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+46879,int_stack+6468,int_stack+5880, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+20384, 0.0, zero_stack,28);
 /*--- compute (hp|hp) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+56518,int_stack+46879,int_stack+35476,63);
 /*--- compute (gd|hp) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+60487,int_stack+56518,int_stack+36799,63);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+56518,int_stack+7462,int_stack+7252, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+29596, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+57148,int_stack+8057,int_stack+7742, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+30576, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|hp) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+58093,int_stack+57148,int_stack+56518,63);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+35476,int_stack+8918,int_stack+8477, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+32046, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|hp) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+36799,int_stack+35476,int_stack+57148,63);
 /*--- compute (fd|hp) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+46879,int_stack+36799,int_stack+58093,63);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+56518,int_stack+10094,int_stack+9506, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+20384, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|hp) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+3780,int_stack+56518,int_stack+35476,63);
 /*--- compute (gd|hp) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+66157,int_stack+3780,int_stack+36799,63);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+3780,int_stack+11088,int_stack+10878, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+29596, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+4410,int_stack+11683,int_stack+11368, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+30576, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|hp) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+5355,int_stack+4410,int_stack+3780,63);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+7245,int_stack+12544,int_stack+12103, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+32046, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|hp) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+8568,int_stack+7245,int_stack+4410,63);
 /*--- compute (fd|hp) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+35476,int_stack+8568,int_stack+5355,63);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+3780,int_stack+13720,int_stack+13132, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+20384, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|hp) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+56518,int_stack+3780,int_stack+7245,63);
 /*--- compute (gd|hp) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+71827,int_stack+56518,int_stack+8568,63);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+56518,int_stack+14714,int_stack+14504, 0.0, zero_stack, 1.0, int_stack+29596, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+57148,int_stack+15309,int_stack+14994, 0.0, zero_stack, 1.0, int_stack+30576, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|hp) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+58093,int_stack+57148,int_stack+56518,63);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+3780,int_stack+16170,int_stack+15729, 0.0, zero_stack, 1.0, int_stack+32046, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|hp) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+5103,int_stack+3780,int_stack+57148,63);
 /*--- compute (fd|hp) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+7938,int_stack+5103,int_stack+58093,63);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+56518,int_stack+17346,int_stack+16758, 0.0, zero_stack, 1.0, int_stack+20384, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|hp) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+11718,int_stack+56518,int_stack+3780,63);
 /*--- compute (gd|hp) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+77497,int_stack+11718,int_stack+5103,63);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+11718,int_stack+18340,int_stack+18130, 1.0, int_stack+29596, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+12348,int_stack+18935,int_stack+18620, 1.0, int_stack+30576, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|hp) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+13293,int_stack+12348,int_stack+11718,63);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+15183,int_stack+19796,int_stack+19355, 1.0, int_stack+32046, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|hp) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+16506,int_stack+15183,int_stack+12348,63);
 /*--- compute (fd|hp) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+3780,int_stack+16506,int_stack+13293,63);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+11718,int_stack+21560,int_stack+20972, 1.0, int_stack+20384, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|hp) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+56518,int_stack+11718,int_stack+15183,63);
 /*--- compute (gd|hp) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+83167,int_stack+56518,int_stack+16506,63);
 /*--- compute (f0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+56518,int_stack+29806,int_stack+29596,10);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+57148,int_stack+30891,int_stack+30576,15);
 /*--- compute (fp|hp) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+58093,int_stack+57148,int_stack+56518,63);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+11718,int_stack+32487,int_stack+32046,21);
 /*--- compute (gp|hp) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+13041,int_stack+11718,int_stack+57148,63);
 /*--- compute (fd|hp) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+15876,int_stack+13041,int_stack+58093,63);
 /*--- compute (f0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+32046,int_stack+22554,int_stack+22344,10);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+19656,int_stack+23149,int_stack+22834,15);
 /*--- compute (fp|hp) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+20601,int_stack+19656,int_stack+32046, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+56518, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+39256,int_stack+24010,int_stack+23569,21);
 /*--- compute (gp|hp) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+88837,int_stack+39256,int_stack+19656, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+57148, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
 /*--- compute (fd|hp) ---*/
   d1hrr1_build_fd(Libderiv->AB,int_stack+91672,int_stack+88837,int_stack+20601, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+58093, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+19656,int_stack+25186,int_stack+24598,28);
 /*--- compute (hp|hp) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+21420,int_stack+19656,int_stack+39256, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+11718, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
 /*--- compute (gd|hp) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+95452,int_stack+21420,int_stack+88837, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+13041, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
 /*--- compute (f0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+88837,int_stack+26180,int_stack+25970,10);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+89467,int_stack+26775,int_stack+26460,15);
 /*--- compute (fp|hp) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+39256,int_stack+89467,int_stack+88837, 0.0, zero_stack, 1.0, int_stack+56518, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+41146,int_stack+27636,int_stack+27195,21);
 /*--- compute (gp|hp) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+19656,int_stack+41146,int_stack+89467, 0.0, zero_stack, 1.0, int_stack+57148, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
 /*--- compute (fd|hp) ---*/
   d1hrr1_build_fd(Libderiv->AB,int_stack+22491,int_stack+19656,int_stack+39256, 0.0, zero_stack, 1.0, int_stack+58093, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+39256,int_stack+28812,int_stack+28224,28);
 /*--- compute (hp|hp) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+101122,int_stack+39256,int_stack+41146, 0.0, zero_stack, 1.0, int_stack+11718, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
 /*--- compute (gd|hp) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+105091,int_stack+101122,int_stack+19656, 0.0, zero_stack, 1.0, int_stack+13041, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
 /*--- compute (f0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+19656,int_stack+30296,int_stack+30086,10);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+20286,int_stack+31626,int_stack+31311,15);
 /*--- compute (fp|hp) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+101122,int_stack+20286,int_stack+19656, 1.0, int_stack+56518, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+103012,int_stack+33516,int_stack+33075,21);
 /*--- compute (gp|hp) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+88837,int_stack+103012,int_stack+20286, 1.0, int_stack+57148, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
 /*--- compute (fd|hp) ---*/
   d1hrr1_build_fd(Libderiv->AB,int_stack+39256,int_stack+88837,int_stack+101122, 1.0, int_stack+58093, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+101122,int_stack+34692,int_stack+34104,28);
 /*--- compute (hp|hp) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+56518,int_stack+101122,int_stack+103012, 1.0, int_stack+11718, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
 /*--- compute (gd|hp) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+26271,int_stack+56518,int_stack+88837, 1.0, int_stack+13041, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
 /*--- compute (ff|hp) ---*/
   hrr1_build_ff(Libderiv->AB,int_stack+110761,int_stack+50848,int_stack+43099,63);
     Libderiv->ABCD[11] = int_stack + 110761;
 /*--- compute (ff|hp) ---*/
   hrr1_build_ff(Libderiv->AB,int_stack+50659,int_stack+60487,int_stack+0,63);
     Libderiv->ABCD[10] = int_stack + 50659;
 /*--- compute (ff|hp) ---*/
   hrr1_build_ff(Libderiv->AB,int_stack+56959,int_stack+66157,int_stack+46879,63);
     Libderiv->ABCD[9] = int_stack + 56959;
 /*--- compute (ff|hp) ---*/
   hrr1_build_ff(Libderiv->AB,int_stack+43036,int_stack+71827,int_stack+35476,63);
     Libderiv->ABCD[8] = int_stack + 43036;
 /*--- compute (ff|hp) ---*/
   hrr1_build_ff(Libderiv->AB,int_stack+31941,int_stack+77497,int_stack+7938,63);
     Libderiv->ABCD[7] = int_stack + 31941;
 /*--- compute (ff|hp) ---*/
   hrr1_build_ff(Libderiv->AB,int_stack+7560,int_stack+83167,int_stack+3780,63);
     Libderiv->ABCD[6] = int_stack + 7560;
 /*--- compute (ff|hp) ---*/
   d1hrr1_build_ff(Libderiv->AB,int_stack+0,int_stack+95452,int_stack+91672, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+15876, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
     Libderiv->ABCD[2] = int_stack + 0;
 /*--- compute (ff|hp) ---*/
   d1hrr1_build_ff(Libderiv->AB,int_stack+63259,int_stack+105091,int_stack+22491, 0.0, zero_stack, 1.0, int_stack+15876, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
     Libderiv->ABCD[1] = int_stack + 63259;
 /*--- compute (ff|hp) ---*/
   d1hrr1_build_ff(Libderiv->AB,int_stack+19656,int_stack+26271,int_stack+39256, 1.0, int_stack+15876, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
     Libderiv->ABCD[0] = int_stack + 19656;

}
