/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include <libint/libint.h>
#include "libderiv.h"
#include <libint/hrr_header.h>

#include "d1hrr_header.h"

extern void d1vrr_order_gdhh(Libderiv_t *, prim_data *);

  /* Computes derivatives of (gd|hh) integrals */

void d1hrr_order_gdhh(Libderiv_t *Libderiv, int num_prim_comb)
{
 prim_data *Data = Libderiv->PrimQuartet;
 double *int_stack = Libderiv->int_stack;
 double *zero_stack = Libderiv->zero_stack;
 int i,j;
 double tmp, *target;

 Libderiv->deriv_classes[4][5][11] = int_stack + 0;
 Libderiv->deriv_classes[4][6][11] = int_stack + 315;
 Libderiv->deriv_classes[4][7][11] = int_stack + 735;
 Libderiv->deriv_classes[4][8][11] = int_stack + 1275;
 Libderiv->deriv_classes[4][9][11] = int_stack + 1950;
 Libderiv->deriv_classes[4][10][11] = int_stack + 2775;
 Libderiv->deriv_classes[5][5][11] = int_stack + 3765;
 Libderiv->deriv_classes[5][6][11] = int_stack + 4206;
 Libderiv->deriv_classes[5][7][11] = int_stack + 4794;
 Libderiv->deriv_classes[5][8][11] = int_stack + 5550;
 Libderiv->deriv_classes[5][9][11] = int_stack + 6495;
 Libderiv->deriv_classes[5][10][11] = int_stack + 7650;
 Libderiv->deriv_classes[6][5][11] = int_stack + 9036;
 Libderiv->deriv_classes[6][6][11] = int_stack + 9624;
 Libderiv->deriv_classes[6][7][11] = int_stack + 10408;
 Libderiv->deriv_classes[6][8][11] = int_stack + 11416;
 Libderiv->deriv_classes[6][9][11] = int_stack + 12676;
 Libderiv->deriv_classes[6][10][11] = int_stack + 14216;
 Libderiv->deriv_classes[4][5][10] = int_stack + 16064;
 Libderiv->deriv_classes[4][6][10] = int_stack + 16379;
 Libderiv->deriv_classes[4][7][10] = int_stack + 16799;
 Libderiv->deriv_classes[4][8][10] = int_stack + 17339;
 Libderiv->deriv_classes[4][9][10] = int_stack + 18014;
 Libderiv->deriv_classes[4][10][10] = int_stack + 18839;
 Libderiv->deriv_classes[5][5][10] = int_stack + 19829;
 Libderiv->deriv_classes[5][6][10] = int_stack + 20270;
 Libderiv->deriv_classes[5][7][10] = int_stack + 20858;
 Libderiv->deriv_classes[5][8][10] = int_stack + 21614;
 Libderiv->deriv_classes[5][9][10] = int_stack + 22559;
 Libderiv->deriv_classes[5][10][10] = int_stack + 23714;
 Libderiv->deriv_classes[6][5][10] = int_stack + 25100;
 Libderiv->deriv_classes[6][6][10] = int_stack + 25688;
 Libderiv->deriv_classes[6][7][10] = int_stack + 26472;
 Libderiv->deriv_classes[6][8][10] = int_stack + 27480;
 Libderiv->deriv_classes[6][9][10] = int_stack + 28740;
 Libderiv->deriv_classes[6][10][10] = int_stack + 30280;
 Libderiv->deriv_classes[4][5][9] = int_stack + 32128;
 Libderiv->deriv_classes[4][6][9] = int_stack + 32443;
 Libderiv->deriv_classes[4][7][9] = int_stack + 32863;
 Libderiv->deriv_classes[4][8][9] = int_stack + 33403;
 Libderiv->deriv_classes[4][9][9] = int_stack + 34078;
 Libderiv->deriv_classes[4][10][9] = int_stack + 34903;
 Libderiv->deriv_classes[5][5][9] = int_stack + 35893;
 Libderiv->deriv_classes[5][6][9] = int_stack + 36334;
 Libderiv->deriv_classes[5][7][9] = int_stack + 36922;
 Libderiv->deriv_classes[5][8][9] = int_stack + 37678;
 Libderiv->deriv_classes[5][9][9] = int_stack + 38623;
 Libderiv->deriv_classes[5][10][9] = int_stack + 39778;
 Libderiv->deriv_classes[6][5][9] = int_stack + 41164;
 Libderiv->deriv_classes[6][6][9] = int_stack + 41752;
 Libderiv->deriv_classes[6][7][9] = int_stack + 42536;
 Libderiv->deriv_classes[6][8][9] = int_stack + 43544;
 Libderiv->deriv_classes[6][9][9] = int_stack + 44804;
 Libderiv->deriv_classes[6][10][9] = int_stack + 46344;
 Libderiv->deriv_classes[4][5][8] = int_stack + 48192;
 Libderiv->deriv_classes[4][6][8] = int_stack + 48507;
 Libderiv->deriv_classes[4][7][8] = int_stack + 48927;
 Libderiv->deriv_classes[4][8][8] = int_stack + 49467;
 Libderiv->deriv_classes[4][9][8] = int_stack + 50142;
 Libderiv->deriv_classes[4][10][8] = int_stack + 50967;
 Libderiv->deriv_classes[5][5][8] = int_stack + 51957;
 Libderiv->deriv_classes[5][6][8] = int_stack + 52398;
 Libderiv->deriv_classes[5][7][8] = int_stack + 52986;
 Libderiv->deriv_classes[5][8][8] = int_stack + 53742;
 Libderiv->deriv_classes[5][9][8] = int_stack + 54687;
 Libderiv->deriv_classes[5][10][8] = int_stack + 55842;
 Libderiv->deriv_classes[6][5][8] = int_stack + 57228;
 Libderiv->deriv_classes[6][6][8] = int_stack + 57816;
 Libderiv->deriv_classes[6][7][8] = int_stack + 58600;
 Libderiv->deriv_classes[6][8][8] = int_stack + 59608;
 Libderiv->deriv_classes[6][9][8] = int_stack + 60868;
 Libderiv->deriv_classes[6][10][8] = int_stack + 62408;
 Libderiv->deriv_classes[4][5][7] = int_stack + 64256;
 Libderiv->deriv_classes[4][6][7] = int_stack + 64571;
 Libderiv->deriv_classes[4][7][7] = int_stack + 64991;
 Libderiv->deriv_classes[4][8][7] = int_stack + 65531;
 Libderiv->deriv_classes[4][9][7] = int_stack + 66206;
 Libderiv->deriv_classes[4][10][7] = int_stack + 67031;
 Libderiv->deriv_classes[5][5][7] = int_stack + 68021;
 Libderiv->deriv_classes[5][6][7] = int_stack + 68462;
 Libderiv->deriv_classes[5][7][7] = int_stack + 69050;
 Libderiv->deriv_classes[5][8][7] = int_stack + 69806;
 Libderiv->deriv_classes[5][9][7] = int_stack + 70751;
 Libderiv->deriv_classes[5][10][7] = int_stack + 71906;
 Libderiv->deriv_classes[6][5][7] = int_stack + 73292;
 Libderiv->deriv_classes[6][6][7] = int_stack + 73880;
 Libderiv->deriv_classes[6][7][7] = int_stack + 74664;
 Libderiv->deriv_classes[6][8][7] = int_stack + 75672;
 Libderiv->deriv_classes[6][9][7] = int_stack + 76932;
 Libderiv->deriv_classes[6][10][7] = int_stack + 78472;
 Libderiv->deriv_classes[4][5][6] = int_stack + 80320;
 Libderiv->deriv_classes[4][6][6] = int_stack + 80635;
 Libderiv->deriv_classes[4][7][6] = int_stack + 81055;
 Libderiv->deriv_classes[4][8][6] = int_stack + 81595;
 Libderiv->deriv_classes[4][9][6] = int_stack + 82270;
 Libderiv->deriv_classes[4][10][6] = int_stack + 83095;
 Libderiv->deriv_classes[5][5][6] = int_stack + 84085;
 Libderiv->deriv_classes[5][6][6] = int_stack + 84526;
 Libderiv->deriv_classes[5][7][6] = int_stack + 85114;
 Libderiv->deriv_classes[5][8][6] = int_stack + 85870;
 Libderiv->deriv_classes[5][9][6] = int_stack + 86815;
 Libderiv->deriv_classes[5][10][6] = int_stack + 87970;
 Libderiv->dvrr_classes[6][5] = int_stack + 89356;
 Libderiv->deriv_classes[6][5][6] = int_stack + 89944;
 Libderiv->dvrr_classes[6][6] = int_stack + 90532;
 Libderiv->deriv_classes[6][6][6] = int_stack + 91316;
 Libderiv->dvrr_classes[6][7] = int_stack + 92100;
 Libderiv->deriv_classes[6][7][6] = int_stack + 93108;
 Libderiv->dvrr_classes[6][8] = int_stack + 94116;
 Libderiv->deriv_classes[6][8][6] = int_stack + 95376;
 Libderiv->dvrr_classes[6][9] = int_stack + 96636;
 Libderiv->deriv_classes[6][9][6] = int_stack + 98176;
 Libderiv->deriv_classes[6][10][6] = int_stack + 99716;
 Libderiv->deriv_classes[4][5][2] = int_stack + 101564;
 Libderiv->deriv_classes[4][6][2] = int_stack + 101879;
 Libderiv->deriv_classes[4][7][2] = int_stack + 102299;
 Libderiv->deriv_classes[4][8][2] = int_stack + 102839;
 Libderiv->deriv_classes[4][9][2] = int_stack + 103514;
 Libderiv->deriv_classes[4][10][2] = int_stack + 104339;
 Libderiv->deriv_classes[5][5][2] = int_stack + 105329;
 Libderiv->deriv_classes[5][6][2] = int_stack + 105770;
 Libderiv->deriv_classes[5][7][2] = int_stack + 106358;
 Libderiv->deriv_classes[5][8][2] = int_stack + 107114;
 Libderiv->deriv_classes[5][9][2] = int_stack + 108059;
 Libderiv->deriv_classes[5][10][2] = int_stack + 109214;
 Libderiv->deriv_classes[6][5][2] = int_stack + 110600;
 Libderiv->deriv_classes[6][6][2] = int_stack + 111188;
 Libderiv->deriv_classes[6][7][2] = int_stack + 111972;
 Libderiv->deriv_classes[6][8][2] = int_stack + 112980;
 Libderiv->deriv_classes[6][9][2] = int_stack + 114240;
 Libderiv->deriv_classes[6][10][2] = int_stack + 115780;
 Libderiv->deriv_classes[4][5][1] = int_stack + 117628;
 Libderiv->deriv_classes[4][6][1] = int_stack + 117943;
 Libderiv->deriv_classes[4][7][1] = int_stack + 118363;
 Libderiv->deriv_classes[4][8][1] = int_stack + 118903;
 Libderiv->deriv_classes[4][9][1] = int_stack + 119578;
 Libderiv->deriv_classes[4][10][1] = int_stack + 120403;
 Libderiv->deriv_classes[5][5][1] = int_stack + 121393;
 Libderiv->deriv_classes[5][6][1] = int_stack + 121834;
 Libderiv->deriv_classes[5][7][1] = int_stack + 122422;
 Libderiv->deriv_classes[5][8][1] = int_stack + 123178;
 Libderiv->deriv_classes[5][9][1] = int_stack + 124123;
 Libderiv->deriv_classes[5][10][1] = int_stack + 125278;
 Libderiv->deriv_classes[6][5][1] = int_stack + 126664;
 Libderiv->deriv_classes[6][6][1] = int_stack + 127252;
 Libderiv->deriv_classes[6][7][1] = int_stack + 128036;
 Libderiv->deriv_classes[6][8][1] = int_stack + 129044;
 Libderiv->deriv_classes[6][9][1] = int_stack + 130304;
 Libderiv->deriv_classes[6][10][1] = int_stack + 131844;
 Libderiv->dvrr_classes[4][5] = int_stack + 133692;
 Libderiv->dvrr_classes[4][6] = int_stack + 134007;
 Libderiv->dvrr_classes[4][7] = int_stack + 134427;
 Libderiv->dvrr_classes[4][8] = int_stack + 134967;
 Libderiv->dvrr_classes[4][9] = int_stack + 135642;
 Libderiv->dvrr_classes[4][10] = int_stack + 136467;
 Libderiv->deriv_classes[4][5][0] = int_stack + 137457;
 Libderiv->deriv_classes[4][6][0] = int_stack + 137772;
 Libderiv->deriv_classes[4][7][0] = int_stack + 138192;
 Libderiv->deriv_classes[4][8][0] = int_stack + 138732;
 Libderiv->deriv_classes[4][9][0] = int_stack + 139407;
 Libderiv->deriv_classes[4][10][0] = int_stack + 140232;
 Libderiv->dvrr_classes[5][5] = int_stack + 141222;
 Libderiv->dvrr_classes[5][6] = int_stack + 141663;
 Libderiv->dvrr_classes[5][7] = int_stack + 142251;
 Libderiv->dvrr_classes[5][8] = int_stack + 143007;
 Libderiv->dvrr_classes[5][9] = int_stack + 143952;
 Libderiv->dvrr_classes[5][10] = int_stack + 145107;
 Libderiv->deriv_classes[5][5][0] = int_stack + 146493;
 Libderiv->deriv_classes[5][6][0] = int_stack + 146934;
 Libderiv->deriv_classes[5][7][0] = int_stack + 147522;
 Libderiv->deriv_classes[5][8][0] = int_stack + 148278;
 Libderiv->deriv_classes[5][9][0] = int_stack + 149223;
 Libderiv->deriv_classes[5][10][0] = int_stack + 150378;
 Libderiv->deriv_classes[6][5][0] = int_stack + 151764;
 Libderiv->deriv_classes[6][6][0] = int_stack + 152352;
 Libderiv->deriv_classes[6][7][0] = int_stack + 153136;
 Libderiv->deriv_classes[6][8][0] = int_stack + 154144;
 Libderiv->deriv_classes[6][9][0] = int_stack + 155404;
 Libderiv->deriv_classes[6][10][0] = int_stack + 156944;
 memset(int_stack,0,1270336);

 Libderiv->dvrr_stack = int_stack + 627546;
 for(i=0;i<num_prim_comb;i++) {
   d1vrr_order_gdhh(Libderiv, Data);
   Data++;
 }

 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+158792,int_stack+134007,int_stack+133692,15);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+159737,int_stack+134427,int_stack+134007,15);
 /*--- compute (g0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+160997,int_stack+159737,int_stack+158792,15);
 /*--- compute (g0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+162887,int_stack+134967,int_stack+134427,15);
 /*--- compute (g0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+164507,int_stack+162887,int_stack+159737,15);
 /*--- compute (g0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+167027,int_stack+164507,int_stack+160997,15);
 /*--- compute (g0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+170177,int_stack+135642,int_stack+134967,15);
 /*--- compute (g0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+172202,int_stack+170177,int_stack+162887,15);
 /*--- compute (g0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+175442,int_stack+172202,int_stack+164507,15);
 /*--- compute (g0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+179642,int_stack+175442,int_stack+167027,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+184367,int_stack+315,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+133692,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+185312,int_stack+735,int_stack+315, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+134007,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+186572,int_stack+185312,int_stack+184367, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+158792,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+188462,int_stack+1275,int_stack+735, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+134427,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+190082,int_stack+188462,int_stack+185312, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+159737,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+192602,int_stack+190082,int_stack+186572, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+160997,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+184367,int_stack+1950,int_stack+1275, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+134967,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+195752,int_stack+184367,int_stack+188462, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+162887,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+198992,int_stack+195752,int_stack+190082, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+164507,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+186392,int_stack+198992,int_stack+192602, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+167027,15);
 /*--- compute (g0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+191117,int_stack+2775,int_stack+1950, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+135642,15);
 /*--- compute (g0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+203192,int_stack+191117,int_stack+184367, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+170177,15);
 /*--- compute (g0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+207242,int_stack+203192,int_stack+195752, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+172202,15);
 /*--- compute (g0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+191117,int_stack+207242,int_stack+198992, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+175442,15);
 /*--- compute (g0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+197417,int_stack+191117,int_stack+186392, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+179642,15);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+184367,int_stack+141663,int_stack+141222,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+185690,int_stack+142251,int_stack+141663,21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+187454,int_stack+185690,int_stack+184367,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+190100,int_stack+143007,int_stack+142251,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+192368,int_stack+190100,int_stack+185690,21);
 /*--- compute (h0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+204032,int_stack+192368,int_stack+187454,21);
 /*--- compute (h0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+208442,int_stack+143952,int_stack+143007,21);
 /*--- compute (h0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+211277,int_stack+208442,int_stack+190100,21);
 /*--- compute (h0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+215813,int_stack+211277,int_stack+192368,21);
 /*--- compute (h0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+221693,int_stack+215813,int_stack+204032,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+195896,int_stack+4206,int_stack+3765, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+141222,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+0,int_stack+4794,int_stack+4206, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+141663,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1764,int_stack+0,int_stack+195896, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+184367,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+228308,int_stack+5550,int_stack+4794, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+142251,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+230576,int_stack+228308,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+185690,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+234104,int_stack+230576,int_stack+1764, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+187454,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+0,int_stack+6495,int_stack+5550, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+143007,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+238514,int_stack+0,int_stack+228308, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+190100,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+243050,int_stack+238514,int_stack+230576, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+192368,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+248930,int_stack+243050,int_stack+234104, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+204032,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+228308,int_stack+7650,int_stack+6495, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+143952,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+231773,int_stack+228308,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+208442,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+0,int_stack+231773,int_stack+238514, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+211277,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+228308,int_stack+0,int_stack+243050, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+215813,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+237128,int_stack+228308,int_stack+248930, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+221693,21);
 /*--- compute (gp|hh) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+246389,int_stack+237128,int_stack+197417,441);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+228308,int_stack+90532,int_stack+89356,28);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+230072,int_stack+92100,int_stack+90532,28);
 /*--- compute (i0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+232424,int_stack+230072,int_stack+228308,28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+0,int_stack+94116,int_stack+92100,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+3024,int_stack+0,int_stack+230072,28);
 /*--- compute (i0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+195896,int_stack+3024,int_stack+232424,28);
 /*--- compute (i0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+266234,int_stack+96636,int_stack+94116,28);
 /*--- compute (i0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+270014,int_stack+266234,int_stack+0,28);
 /*--- compute (i0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+276062,int_stack+270014,int_stack+3024,28);
 /*--- compute (i0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+283902,int_stack+276062,int_stack+195896,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+201776,int_stack+9624,int_stack+9036, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+89356,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+292722,int_stack+10408,int_stack+9624, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+90532,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+295074,int_stack+292722,int_stack+201776, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+228308,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+298602,int_stack+11416,int_stack+10408, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+92100,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+301626,int_stack+298602,int_stack+292722, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+230072,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+306330,int_stack+301626,int_stack+295074, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+232424,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+292722,int_stack+12676,int_stack+11416, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+94116,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+312210,int_stack+292722,int_stack+298602, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+0,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+318258,int_stack+312210,int_stack+301626, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3024,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+296502,int_stack+318258,int_stack+306330, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+195896,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+305322,int_stack+14216,int_stack+12676, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+96636,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+7728,int_stack+305322,int_stack+292722, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+266234,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+326098,int_stack+7728,int_stack+312210, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+270014,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+305322,int_stack+326098,int_stack+318258, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+276062,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+317082,int_stack+305322,int_stack+296502, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+283902,28);
 /*--- compute (hp|hh) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+329430,int_stack+317082,int_stack+237128,441);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+7728,int_stack+16379,int_stack+16064, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+133692, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+8673,int_stack+16799,int_stack+16379, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+134007, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+9933,int_stack+8673,int_stack+7728, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+158792, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+11823,int_stack+17339,int_stack+16799, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+134427, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+13443,int_stack+11823,int_stack+8673, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+159737, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+292722,int_stack+13443,int_stack+9933, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+160997, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+7728,int_stack+18014,int_stack+17339, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+134967, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+295872,int_stack+7728,int_stack+11823, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+162887, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+299112,int_stack+295872,int_stack+13443, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+164507, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+9753,int_stack+299112,int_stack+292722, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+167027, 0.0, zero_stack,15);
 /*--- compute (g0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+292722,int_stack+18839,int_stack+18014, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+135642, 0.0, zero_stack,15);
 /*--- compute (g0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+14478,int_stack+292722,int_stack+7728, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+170177, 0.0, zero_stack,15);
 /*--- compute (g0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+303312,int_stack+14478,int_stack+295872, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+172202, 0.0, zero_stack,15);
 /*--- compute (g0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+292722,int_stack+303312,int_stack+299112, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+175442, 0.0, zero_stack,15);
 /*--- compute (g0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+299022,int_stack+292722,int_stack+9753, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+179642, 0.0, zero_stack,15);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+292722,int_stack+20270,int_stack+19829, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+141222, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+294045,int_stack+20858,int_stack+20270, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+141663, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+295809,int_stack+294045,int_stack+292722, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+184367, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+7728,int_stack+21614,int_stack+20858, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+142251, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+9996,int_stack+7728,int_stack+294045, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+185690, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+13524,int_stack+9996,int_stack+295809, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+187454, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+292722,int_stack+22559,int_stack+21614, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+143007, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+17934,int_stack+292722,int_stack+7728, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+190100, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+305637,int_stack+17934,int_stack+9996, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+192368, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+311517,int_stack+305637,int_stack+13524, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+204032, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+295557,int_stack+23714,int_stack+22559, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+143952, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+7728,int_stack+295557,int_stack+292722, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+208442, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+318132,int_stack+7728,int_stack+17934, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+211277, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+7728,int_stack+318132,int_stack+305637, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+215813, 0.0, zero_stack,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+318132,int_stack+7728,int_stack+311517, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+221693, 0.0, zero_stack,21);
 /*--- compute (gp|hh) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+357213,int_stack+318132,int_stack+299022,441);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+7728,int_stack+25688,int_stack+25100, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+89356, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+9492,int_stack+26472,int_stack+25688, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+90532, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+11844,int_stack+9492,int_stack+7728, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+228308, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+15372,int_stack+27480,int_stack+26472, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+92100, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+18396,int_stack+15372,int_stack+9492, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+230072, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+292722,int_stack+18396,int_stack+11844, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+232424, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+7728,int_stack+28740,int_stack+27480, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+94116, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+298602,int_stack+7728,int_stack+15372, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+304650,int_stack+298602,int_stack+18396, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3024, 0.0, zero_stack,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+11508,int_stack+304650,int_stack+292722, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+195896, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+292722,int_stack+30280,int_stack+28740, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+96636, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+20328,int_stack+292722,int_stack+7728, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+266234, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+235952,int_stack+20328,int_stack+298602, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+270014, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+20328,int_stack+235952,int_stack+304650, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+276062, 0.0, zero_stack,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+292722,int_stack+20328,int_stack+11508, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+283902, 0.0, zero_stack,28);
 /*--- compute (hp|hh) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+377058,int_stack+292722,int_stack+318132,441);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+292722,int_stack+32443,int_stack+32128, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+133692, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+293667,int_stack+32863,int_stack+32443, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+134007, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+294927,int_stack+293667,int_stack+292722, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+158792, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+296817,int_stack+33403,int_stack+32863, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+134427, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+298437,int_stack+296817,int_stack+293667, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+159737, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+300957,int_stack+298437,int_stack+294927, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+160997, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+292722,int_stack+34078,int_stack+33403, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+134967, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+304107,int_stack+292722,int_stack+296817, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+162887, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+307347,int_stack+304107,int_stack+298437, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+164507, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+294747,int_stack+307347,int_stack+300957, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+167027, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+299472,int_stack+34903,int_stack+34078, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+135642, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+311547,int_stack+299472,int_stack+292722, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+170177, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+315597,int_stack+311547,int_stack+304107, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+172202, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+299472,int_stack+315597,int_stack+307347, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+175442, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+305772,int_stack+299472,int_stack+294747, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+179642, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+292722,int_stack+36334,int_stack+35893, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+141222, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+294045,int_stack+36922,int_stack+36334, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+141663, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+295809,int_stack+294045,int_stack+292722, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+184367, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+298455,int_stack+37678,int_stack+36922, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+142251, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+300723,int_stack+298455,int_stack+294045, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+185690, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+312387,int_stack+300723,int_stack+295809, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+187454, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+292722,int_stack+38623,int_stack+37678, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+143007, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+316797,int_stack+292722,int_stack+298455, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+190100, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+321333,int_stack+316797,int_stack+300723, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+192368, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+295557,int_stack+321333,int_stack+312387, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+204032, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+312387,int_stack+39778,int_stack+38623, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+143952, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+235952,int_stack+312387,int_stack+292722, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+208442, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+7728,int_stack+235952,int_stack+316797, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+211277, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+235952,int_stack+7728,int_stack+321333, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+215813, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+7728,int_stack+235952,int_stack+295557, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+221693, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|hh) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+16989,int_stack+7728,int_stack+305772,441);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+235952,int_stack+41752,int_stack+41164, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+89356, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+237716,int_stack+42536,int_stack+41752, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+90532, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+240068,int_stack+237716,int_stack+235952, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+228308, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+36834,int_stack+43544,int_stack+42536, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+92100, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+292722,int_stack+36834,int_stack+237716, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+230072, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+297426,int_stack+292722,int_stack+240068, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+232424, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+235952,int_stack+44804,int_stack+43544, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+94116, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+239732,int_stack+235952,int_stack+36834, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+36834,int_stack+239732,int_stack+292722, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3024, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+303306,int_stack+36834,int_stack+297426, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+195896, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+292722,int_stack+46344,int_stack+44804, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+96636, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+312126,int_stack+292722,int_stack+235952, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+266234, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+292722,int_stack+312126,int_stack+239732, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+270014, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+312126,int_stack+292722,int_stack+36834, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+276062, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+404841,int_stack+312126,int_stack+303306, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+283902, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|hh) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+292722,int_stack+404841,int_stack+7728,441);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+7728,int_stack+48507,int_stack+48192, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+133692, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+8673,int_stack+48927,int_stack+48507, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+134007, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+9933,int_stack+8673,int_stack+7728, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+158792, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+11823,int_stack+49467,int_stack+48927, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+134427, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+13443,int_stack+11823,int_stack+8673, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+159737, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+404841,int_stack+13443,int_stack+9933, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+160997, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+7728,int_stack+50142,int_stack+49467, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+134967, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+407991,int_stack+7728,int_stack+11823, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+162887, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+411231,int_stack+407991,int_stack+13443, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+164507, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+9753,int_stack+411231,int_stack+404841, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+167027, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+404841,int_stack+50967,int_stack+50142, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+135642, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+36834,int_stack+404841,int_stack+7728, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+170177, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+40884,int_stack+36834,int_stack+407991, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+172202, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+404841,int_stack+40884,int_stack+411231, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+175442, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+36834,int_stack+404841,int_stack+9753, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+179642, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+404841,int_stack+52398,int_stack+51957, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+141222, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+406164,int_stack+52986,int_stack+52398, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+141663, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+407928,int_stack+406164,int_stack+404841, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+184367, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+410574,int_stack+53742,int_stack+52986, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+142251, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+412842,int_stack+410574,int_stack+406164, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+185690, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+43449,int_stack+412842,int_stack+407928, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+187454, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+404841,int_stack+54687,int_stack+53742, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+143007, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+47859,int_stack+404841,int_stack+410574, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+190100, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+7728,int_stack+47859,int_stack+412842, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+192368, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+407676,int_stack+7728,int_stack+43449, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+204032, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+43449,int_stack+55842,int_stack+54687, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+143952, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+320505,int_stack+43449,int_stack+404841, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+208442, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+235952,int_stack+320505,int_stack+47859, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+211277, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+320505,int_stack+235952,int_stack+7728, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+215813, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+7728,int_stack+320505,int_stack+407676, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+221693, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|hh) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+404841,int_stack+7728,int_stack+36834,441);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+36834,int_stack+57816,int_stack+57228, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+89356, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+38598,int_stack+58600,int_stack+57816, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+90532, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+40950,int_stack+38598,int_stack+36834, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+228308, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+44478,int_stack+59608,int_stack+58600, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+92100, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+47502,int_stack+44478,int_stack+38598, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+230072, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+52206,int_stack+47502,int_stack+40950, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+232424, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+36834,int_stack+60868,int_stack+59608, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+94116, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+320505,int_stack+36834,int_stack+44478, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+235952,int_stack+320505,int_stack+47502, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3024, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+40614,int_stack+235952,int_stack+52206, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+195896, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+49434,int_stack+62408,int_stack+60868, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+96636, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+54054,int_stack+49434,int_stack+36834, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+266234, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+424686,int_stack+54054,int_stack+320505, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+270014, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+49434,int_stack+424686,int_stack+235952, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+276062, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+424686,int_stack+49434,int_stack+40614, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+283902, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|hh) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+437034,int_stack+424686,int_stack+7728,441);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+7728,int_stack+64571,int_stack+64256, 0.0, zero_stack, 1.0, int_stack+133692, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+8673,int_stack+64991,int_stack+64571, 0.0, zero_stack, 1.0, int_stack+134007, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+9933,int_stack+8673,int_stack+7728, 0.0, zero_stack, 1.0, int_stack+158792, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+11823,int_stack+65531,int_stack+64991, 0.0, zero_stack, 1.0, int_stack+134427, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+13443,int_stack+11823,int_stack+8673, 0.0, zero_stack, 1.0, int_stack+159737, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+424686,int_stack+13443,int_stack+9933, 0.0, zero_stack, 1.0, int_stack+160997, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+7728,int_stack+66206,int_stack+65531, 0.0, zero_stack, 1.0, int_stack+134967, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+427836,int_stack+7728,int_stack+11823, 0.0, zero_stack, 1.0, int_stack+162887, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+431076,int_stack+427836,int_stack+13443, 0.0, zero_stack, 1.0, int_stack+164507, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+9753,int_stack+431076,int_stack+424686, 0.0, zero_stack, 1.0, int_stack+167027, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+424686,int_stack+67031,int_stack+66206, 0.0, zero_stack, 1.0, int_stack+135642, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+235952,int_stack+424686,int_stack+7728, 0.0, zero_stack, 1.0, int_stack+170177, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+240002,int_stack+235952,int_stack+427836, 0.0, zero_stack, 1.0, int_stack+172202, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+424686,int_stack+240002,int_stack+431076, 0.0, zero_stack, 1.0, int_stack+175442, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+235952,int_stack+424686,int_stack+9753, 0.0, zero_stack, 1.0, int_stack+179642, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+424686,int_stack+68462,int_stack+68021, 0.0, zero_stack, 1.0, int_stack+141222, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+426009,int_stack+69050,int_stack+68462, 0.0, zero_stack, 1.0, int_stack+141663, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+427773,int_stack+426009,int_stack+424686, 0.0, zero_stack, 1.0, int_stack+184367, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+430419,int_stack+69806,int_stack+69050, 0.0, zero_stack, 1.0, int_stack+142251, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+432687,int_stack+430419,int_stack+426009, 0.0, zero_stack, 1.0, int_stack+185690, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+7728,int_stack+432687,int_stack+427773, 0.0, zero_stack, 1.0, int_stack+187454, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+424686,int_stack+70751,int_stack+69806, 0.0, zero_stack, 1.0, int_stack+143007, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+12138,int_stack+424686,int_stack+430419, 0.0, zero_stack, 1.0, int_stack+190100, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+320505,int_stack+12138,int_stack+432687, 0.0, zero_stack, 1.0, int_stack+192368, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+427521,int_stack+320505,int_stack+7728, 0.0, zero_stack, 1.0, int_stack+204032, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+7728,int_stack+71906,int_stack+70751, 0.0, zero_stack, 1.0, int_stack+143952, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+36834,int_stack+7728,int_stack+424686, 0.0, zero_stack, 1.0, int_stack+208442, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+42504,int_stack+36834,int_stack+12138, 0.0, zero_stack, 1.0, int_stack+211277, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+7728,int_stack+42504,int_stack+320505, 0.0, zero_stack, 1.0, int_stack+215813, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+36834,int_stack+7728,int_stack+427521, 0.0, zero_stack, 1.0, int_stack+221693, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|hh) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+46095,int_stack+36834,int_stack+235952,441);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+235952,int_stack+73880,int_stack+73292, 0.0, zero_stack, 1.0, int_stack+89356, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+237716,int_stack+74664,int_stack+73880, 0.0, zero_stack, 1.0, int_stack+90532, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+240068,int_stack+237716,int_stack+235952, 0.0, zero_stack, 1.0, int_stack+228308, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+7728,int_stack+75672,int_stack+74664, 0.0, zero_stack, 1.0, int_stack+92100, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+10752,int_stack+7728,int_stack+237716, 0.0, zero_stack, 1.0, int_stack+230072, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+320505,int_stack+10752,int_stack+240068, 0.0, zero_stack, 1.0, int_stack+232424, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+235952,int_stack+76932,int_stack+75672, 0.0, zero_stack, 1.0, int_stack+94116, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+239732,int_stack+235952,int_stack+7728, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+65940,int_stack+239732,int_stack+10752, 0.0, zero_stack, 1.0, int_stack+3024, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+7728,int_stack+65940,int_stack+320505, 0.0, zero_stack, 1.0, int_stack+195896, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+320505,int_stack+78472,int_stack+76932, 0.0, zero_stack, 1.0, int_stack+96636, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+424686,int_stack+320505,int_stack+235952, 0.0, zero_stack, 1.0, int_stack+266234, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+464817,int_stack+424686,int_stack+239732, 0.0, zero_stack, 1.0, int_stack+270014, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+424686,int_stack+464817,int_stack+65940, 0.0, zero_stack, 1.0, int_stack+276062, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+65940,int_stack+424686,int_stack+7728, 0.0, zero_stack, 1.0, int_stack+283902, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|hh) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+464817,int_stack+65940,int_stack+36834,441);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+36834,int_stack+80635,int_stack+80320, 1.0, int_stack+133692, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+37779,int_stack+81055,int_stack+80635, 1.0, int_stack+134007, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+39039,int_stack+37779,int_stack+36834, 1.0, int_stack+158792, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+40929,int_stack+81595,int_stack+81055, 1.0, int_stack+134427, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+42549,int_stack+40929,int_stack+37779, 1.0, int_stack+159737, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+65940,int_stack+42549,int_stack+39039, 1.0, int_stack+160997, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+158792,int_stack+82270,int_stack+81595, 1.0, int_stack+134967, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+36834,int_stack+158792,int_stack+40929, 1.0, int_stack+162887, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+69090,int_stack+36834,int_stack+42549, 1.0, int_stack+164507, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+160817,int_stack+69090,int_stack+65940, 1.0, int_stack+167027, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+65940,int_stack+83095,int_stack+82270, 1.0, int_stack+135642, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+165542,int_stack+65940,int_stack+158792, 1.0, int_stack+170177, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+40074,int_stack+165542,int_stack+36834, 1.0, int_stack+172202, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+73290,int_stack+40074,int_stack+69090, 1.0, int_stack+175442, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+36834,int_stack+73290,int_stack+160817, 1.0, int_stack+179642, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+43449,int_stack+84526,int_stack+84085, 1.0, int_stack+141222, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+158792,int_stack+85114,int_stack+84526, 1.0, int_stack+141663, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+160556,int_stack+158792,int_stack+43449, 1.0, int_stack+184367, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+43449,int_stack+85870,int_stack+85114, 1.0, int_stack+142251, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+163202,int_stack+43449,int_stack+158792, 1.0, int_stack+185690, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+65940,int_stack+163202,int_stack+160556, 1.0, int_stack+187454, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+158792,int_stack+86815,int_stack+85870, 1.0, int_stack+143007, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+184367,int_stack+158792,int_stack+43449, 1.0, int_stack+190100, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+70350,int_stack+184367,int_stack+163202, 1.0, int_stack+192368, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+161627,int_stack+70350,int_stack+65940, 1.0, int_stack+204032, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+65940,int_stack+87970,int_stack+86815, 1.0, int_stack+143952, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+188903,int_stack+65940,int_stack+158792, 1.0, int_stack+208442, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+76230,int_stack+188903,int_stack+184367, 1.0, int_stack+211277, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+184367,int_stack+76230,int_stack+70350, 1.0, int_stack+215813, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+7728,int_stack+184367,int_stack+161627, 1.0, int_stack+221693, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|hh) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+65940,int_stack+7728,int_stack+36834,441);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+36834,int_stack+91316,int_stack+89944, 1.0, int_stack+89356, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+38598,int_stack+93108,int_stack+91316, 1.0, int_stack+90532, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+40950,int_stack+38598,int_stack+36834, 1.0, int_stack+228308, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+184367,int_stack+95376,int_stack+93108, 1.0, int_stack+92100, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+187391,int_stack+184367,int_stack+38598, 1.0, int_stack+230072, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+158792,int_stack+187391,int_stack+40950, 1.0, int_stack+232424, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+228308,int_stack+98176,int_stack+95376, 1.0, int_stack+94116, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+232088,int_stack+228308,int_stack+184367, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+238136,int_stack+232088,int_stack+187391, 1.0, int_stack+3024, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+184367,int_stack+238136,int_stack+158792, 1.0, int_stack+195896, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+158792,int_stack+99716,int_stack+98176, 1.0, int_stack+96636, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+0,int_stack+158792,int_stack+228308, 1.0, int_stack+266234, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+158792,int_stack+0,int_stack+232088, 1.0, int_stack+270014, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+193187,int_stack+158792,int_stack+238136, 1.0, int_stack+276062, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+424686,int_stack+193187,int_stack+184367, 1.0, int_stack+283902, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|hh) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+492600,int_stack+424686,int_stack+7728,441);
 /*--- compute (g0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+424686,int_stack+136467,int_stack+135642,15);
 /*--- compute (g0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+427161,int_stack+424686,int_stack+170177,15);
 /*--- compute (g0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+431211,int_stack+427161,int_stack+172202,15);
 /*--- compute (g0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+424686,int_stack+431211,int_stack+175442,15);
 /*--- compute (g0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+184367,int_stack+424686,int_stack+179642,15);
 /*--- compute (h0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+424686,int_stack+145107,int_stack+143952,21);
 /*--- compute (h0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+428151,int_stack+424686,int_stack+208442,21);
 /*--- compute (h0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+190982,int_stack+428151,int_stack+211277,21);
 /*--- compute (h0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+424686,int_stack+190982,int_stack+215813,21);
 /*--- compute (h0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+36834,int_stack+424686,int_stack+221693,21);
 /*--- compute (gp|hh) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+190982,int_stack+36834,int_stack+184367,441);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+424686,int_stack+101879,int_stack+101564,15);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+425631,int_stack+102299,int_stack+101879,15);
 /*--- compute (g0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+426891,int_stack+425631,int_stack+424686,15);
 /*--- compute (g0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+428781,int_stack+102839,int_stack+102299,15);
 /*--- compute (g0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+430401,int_stack+428781,int_stack+425631,15);
 /*--- compute (g0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+432921,int_stack+430401,int_stack+426891,15);
 /*--- compute (g0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+424686,int_stack+103514,int_stack+102839,15);
 /*--- compute (g0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+210827,int_stack+424686,int_stack+428781,15);
 /*--- compute (g0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+214067,int_stack+210827,int_stack+430401,15);
 /*--- compute (g0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+426711,int_stack+214067,int_stack+432921,15);
 /*--- compute (g0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+431436,int_stack+104339,int_stack+103514,15);
 /*--- compute (g0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+218267,int_stack+431436,int_stack+424686,15);
 /*--- compute (g0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+431436,int_stack+218267,int_stack+210827,15);
 /*--- compute (g0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+218267,int_stack+431436,int_stack+214067,15);
 /*--- compute (g0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+210827,int_stack+218267,int_stack+426711,15);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+217442,int_stack+105770,int_stack+105329,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+218765,int_stack+106358,int_stack+105770,21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+220529,int_stack+218765,int_stack+217442,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+223175,int_stack+107114,int_stack+106358,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+225443,int_stack+223175,int_stack+218765,21);
 /*--- compute (h0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+228971,int_stack+225443,int_stack+220529,21);
 /*--- compute (h0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+217442,int_stack+108059,int_stack+107114,21);
 /*--- compute (h0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+233381,int_stack+217442,int_stack+223175,21);
 /*--- compute (h0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+237917,int_stack+233381,int_stack+225443,21);
 /*--- compute (h0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+220277,int_stack+237917,int_stack+228971,21);
 /*--- compute (h0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+226892,int_stack+109214,int_stack+108059,21);
 /*--- compute (h0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+424686,int_stack+226892,int_stack+217442,21);
 /*--- compute (h0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+158792,int_stack+424686,int_stack+233381,21);
 /*--- compute (h0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+424686,int_stack+158792,int_stack+237917,21);
 /*--- compute (h0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+158792,int_stack+424686,int_stack+220277,21);
 /*--- compute (gp|hh) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+217442,int_stack+158792,int_stack+210827, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+184367, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+210827,int_stack+111188,int_stack+110600,28);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+212591,int_stack+111972,int_stack+111188,28);
 /*--- compute (i0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+424686,int_stack+212591,int_stack+210827,28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+428214,int_stack+112980,int_stack+111972,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+431238,int_stack+428214,int_stack+212591,28);
 /*--- compute (i0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+210827,int_stack+431238,int_stack+424686,28);
 /*--- compute (i0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+168053,int_stack+114240,int_stack+112980,28);
 /*--- compute (i0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+171833,int_stack+168053,int_stack+428214,28);
 /*--- compute (i0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+237287,int_stack+171833,int_stack+431238,28);
 /*--- compute (i0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+424686,int_stack+237287,int_stack+210827,28);
 /*--- compute (i0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+210827,int_stack+115780,int_stack+114240,28);
 /*--- compute (i0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+0,int_stack+210827,int_stack+168053,28);
 /*--- compute (i0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+266234,int_stack+0,int_stack+171833,28);
 /*--- compute (i0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+0,int_stack+266234,int_stack+237287,28);
 /*--- compute (i0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+266234,int_stack+0,int_stack+424686,28);
 /*--- compute (hp|hh) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+85785,int_stack+266234,int_stack+158792, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+36834, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+158792,int_stack+117943,int_stack+117628,15);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+159737,int_stack+118363,int_stack+117943,15);
 /*--- compute (g0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+160997,int_stack+159737,int_stack+158792,15);
 /*--- compute (g0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+162887,int_stack+118903,int_stack+118363,15);
 /*--- compute (g0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+164507,int_stack+162887,int_stack+159737,15);
 /*--- compute (g0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+167027,int_stack+164507,int_stack+160997,15);
 /*--- compute (g0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+158792,int_stack+119578,int_stack+118903,15);
 /*--- compute (g0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+170177,int_stack+158792,int_stack+162887,15);
 /*--- compute (g0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+173417,int_stack+170177,int_stack+164507,15);
 /*--- compute (g0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+160817,int_stack+173417,int_stack+167027,15);
 /*--- compute (g0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+165542,int_stack+120403,int_stack+119578,15);
 /*--- compute (g0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+177617,int_stack+165542,int_stack+158792,15);
 /*--- compute (g0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+266234,int_stack+177617,int_stack+170177,15);
 /*--- compute (g0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+177617,int_stack+266234,int_stack+173417,15);
 /*--- compute (g0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+210827,int_stack+177617,int_stack+160817,15);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+266234,int_stack+121834,int_stack+121393,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+267557,int_stack+122422,int_stack+121834,21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+269321,int_stack+267557,int_stack+266234,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+271967,int_stack+123178,int_stack+122422,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+274235,int_stack+271967,int_stack+267557,21);
 /*--- compute (h0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+277763,int_stack+274235,int_stack+269321,21);
 /*--- compute (h0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+266234,int_stack+124123,int_stack+123178,21);
 /*--- compute (h0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+282173,int_stack+266234,int_stack+271967,21);
 /*--- compute (h0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+286709,int_stack+282173,int_stack+274235,21);
 /*--- compute (h0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+269069,int_stack+286709,int_stack+277763,21);
 /*--- compute (h0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+275684,int_stack+125278,int_stack+124123,21);
 /*--- compute (h0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+158792,int_stack+275684,int_stack+266234,21);
 /*--- compute (h0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+164462,int_stack+158792,int_stack+282173,21);
 /*--- compute (h0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+275684,int_stack+164462,int_stack+286709,21);
 /*--- compute (h0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+158792,int_stack+275684,int_stack+269069,21);
 /*--- compute (gp|hh) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+266234,int_stack+158792,int_stack+210827, 0.0, zero_stack, 1.0, int_stack+184367, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+210827,int_stack+127252,int_stack+126664,28);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+212591,int_stack+128036,int_stack+127252,28);
 /*--- compute (i0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+168053,int_stack+212591,int_stack+210827,28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+171581,int_stack+129044,int_stack+128036,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+174605,int_stack+171581,int_stack+212591,28);
 /*--- compute (i0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+210827,int_stack+174605,int_stack+168053,28);
 /*--- compute (i0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+179309,int_stack+130304,int_stack+129044,28);
 /*--- compute (i0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+286079,int_stack+179309,int_stack+171581,28);
 /*--- compute (i0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+424686,int_stack+286079,int_stack+174605,28);
 /*--- compute (i0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+168053,int_stack+424686,int_stack+210827,28);
 /*--- compute (i0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+210827,int_stack+131844,int_stack+130304,28);
 /*--- compute (i0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+0,int_stack+210827,int_stack+179309,28);
 /*--- compute (i0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+113568,int_stack+0,int_stack+286079,28);
 /*--- compute (i0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+0,int_stack+113568,int_stack+424686,28);
 /*--- compute (i0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+424686,int_stack+0,int_stack+168053,28);
 /*--- compute (hp|hh) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+520383,int_stack+424686,int_stack+158792, 0.0, zero_stack, 1.0, int_stack+36834, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+158792,int_stack+137772,int_stack+137457,15);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+159737,int_stack+138192,int_stack+137772,15);
 /*--- compute (g0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+160997,int_stack+159737,int_stack+158792,15);
 /*--- compute (g0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+162887,int_stack+138732,int_stack+138192,15);
 /*--- compute (g0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+164507,int_stack+162887,int_stack+159737,15);
 /*--- compute (g0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+167027,int_stack+164507,int_stack+160997,15);
 /*--- compute (g0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+158792,int_stack+139407,int_stack+138732,15);
 /*--- compute (g0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+170177,int_stack+158792,int_stack+162887,15);
 /*--- compute (g0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+173417,int_stack+170177,int_stack+164507,15);
 /*--- compute (g0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+160817,int_stack+173417,int_stack+167027,15);
 /*--- compute (g0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+165542,int_stack+140232,int_stack+139407,15);
 /*--- compute (g0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+177617,int_stack+165542,int_stack+158792,15);
 /*--- compute (g0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+424686,int_stack+177617,int_stack+170177,15);
 /*--- compute (g0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+177617,int_stack+424686,int_stack+173417,15);
 /*--- compute (g0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+210827,int_stack+177617,int_stack+160817,15);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+424686,int_stack+146934,int_stack+146493,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+426009,int_stack+147522,int_stack+146934,21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+427773,int_stack+426009,int_stack+424686,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+430419,int_stack+148278,int_stack+147522,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+432687,int_stack+430419,int_stack+426009,21);
 /*--- compute (h0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+158792,int_stack+432687,int_stack+427773,21);
 /*--- compute (h0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+424686,int_stack+149223,int_stack+148278,21);
 /*--- compute (h0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+163202,int_stack+424686,int_stack+430419,21);
 /*--- compute (h0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+167738,int_stack+163202,int_stack+432687,21);
 /*--- compute (h0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+427521,int_stack+167738,int_stack+158792,21);
 /*--- compute (h0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+158792,int_stack+150378,int_stack+149223,21);
 /*--- compute (h0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+173618,int_stack+158792,int_stack+424686,21);
 /*--- compute (h0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+0,int_stack+173618,int_stack+163202,21);
 /*--- compute (h0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+173618,int_stack+0,int_stack+167738,21);
 /*--- compute (h0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+0,int_stack+173618,int_stack+427521,21);
 /*--- compute (gp|hh) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+158792,int_stack+0,int_stack+210827, 1.0, int_stack+184367, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+210827,int_stack+152352,int_stack+151764,28);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+212591,int_stack+153136,int_stack+152352,28);
 /*--- compute (i0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+9261,int_stack+212591,int_stack+210827,28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+12789,int_stack+154144,int_stack+153136,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+424686,int_stack+12789,int_stack+212591,28);
 /*--- compute (i0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+210827,int_stack+424686,int_stack+9261,28);
 /*--- compute (i0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+429390,int_stack+155404,int_stack+154144,28);
 /*--- compute (i0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+178637,int_stack+429390,int_stack+12789,28);
 /*--- compute (i0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+113568,int_stack+178637,int_stack+424686,28);
 /*--- compute (i0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+121408,int_stack+113568,int_stack+210827,28);
 /*--- compute (i0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+210827,int_stack+156944,int_stack+155404,28);
 /*--- compute (i0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+9261,int_stack+210827,int_stack+429390,28);
 /*--- compute (i0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+424686,int_stack+9261,int_stack+178637,28);
 /*--- compute (i0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+178637,int_stack+424686,int_stack+113568,28);
 /*--- compute (i0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+424686,int_stack+178637,int_stack+121408,28);
 /*--- compute (hp|hh) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+113568,int_stack+424686,int_stack+0, 1.0, int_stack+36834, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (gd|hh) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+548166,int_stack+329430,int_stack+246389,441);
     Libderiv->ABCD[11] = int_stack + 548166;
 /*--- compute (gd|hh) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+587856,int_stack+377058,int_stack+357213,441);
     Libderiv->ABCD[10] = int_stack + 587856;
 /*--- compute (gd|hh) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+320505,int_stack+292722,int_stack+16989,441);
     Libderiv->ABCD[9] = int_stack + 320505;
 /*--- compute (gd|hh) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+0,int_stack+437034,int_stack+404841,441);
     Libderiv->ABCD[8] = int_stack + 0;
 /*--- compute (gd|hh) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+360195,int_stack+464817,int_stack+46095,441);
     Libderiv->ABCD[7] = int_stack + 360195;
 /*--- compute (gd|hh) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+399885,int_stack+492600,int_stack+65940,441);
     Libderiv->ABCD[6] = int_stack + 399885;
 /*--- compute (gd|hh) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+39690,int_stack+85785,int_stack+217442, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+190982, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
     Libderiv->ABCD[2] = int_stack + 39690;
 /*--- compute (gd|hh) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+210827,int_stack+520383,int_stack+266234, 0.0, zero_stack, 1.0, int_stack+190982, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
     Libderiv->ABCD[1] = int_stack + 210827;
 /*--- compute (gd|hh) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+250517,int_stack+113568,int_stack+158792, 1.0, int_stack+190982, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
     Libderiv->ABCD[0] = int_stack + 250517;

}
