/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <libint/libint.h>
#include "libderiv.h"

void deriv_build_DY_r(prim_data *Data, const int abc_num, double *vp, const double *I0, const double *I1)
{
  const double twotzeta = Data->twozeta_d;
  const double *i0, *i1;
  int abc;

  for(abc=0;abc<abc_num;abc++) {
    *(vp++) = twotzeta*I0[1] ;
    *(vp++) = twotzeta*I0[3] - 1.000000*I1[0];
    *(vp++) = twotzeta*I0[4] ;
    *(vp++) = twotzeta*I0[6] - 2.000000*I1[1];
    *(vp++) = twotzeta*I0[7] - 1.000000*I1[2];
    *(vp++) = twotzeta*I0[8] ;
    *(vp++) = twotzeta*I0[10] - 3.000000*I1[3];
    *(vp++) = twotzeta*I0[11] - 2.000000*I1[4];
    *(vp++) = twotzeta*I0[12] - 1.000000*I1[5];
    *(vp++) = twotzeta*I0[13] ;
    *(vp++) = twotzeta*I0[15] - 4.000000*I1[6];
    *(vp++) = twotzeta*I0[16] - 3.000000*I1[7];
    *(vp++) = twotzeta*I0[17] - 2.000000*I1[8];
    *(vp++) = twotzeta*I0[18] - 1.000000*I1[9];
    *(vp++) = twotzeta*I0[19] ;
    *(vp++) = twotzeta*I0[21] - 5.000000*I1[10];
    *(vp++) = twotzeta*I0[22] - 4.000000*I1[11];
    *(vp++) = twotzeta*I0[23] - 3.000000*I1[12];
    *(vp++) = twotzeta*I0[24] - 2.000000*I1[13];
    *(vp++) = twotzeta*I0[25] - 1.000000*I1[14];
    *(vp++) = twotzeta*I0[26] ;
    *(vp++) = twotzeta*I0[28] - 6.000000*I1[15];
    *(vp++) = twotzeta*I0[29] - 5.000000*I1[16];
    *(vp++) = twotzeta*I0[30] - 4.000000*I1[17];
    *(vp++) = twotzeta*I0[31] - 3.000000*I1[18];
    *(vp++) = twotzeta*I0[32] - 2.000000*I1[19];
    *(vp++) = twotzeta*I0[33] - 1.000000*I1[20];
    *(vp++) = twotzeta*I0[34] ;
    *(vp++) = twotzeta*I0[36] - 7.000000*I1[21];
    *(vp++) = twotzeta*I0[37] - 6.000000*I1[22];
    *(vp++) = twotzeta*I0[38] - 5.000000*I1[23];
    *(vp++) = twotzeta*I0[39] - 4.000000*I1[24];
    *(vp++) = twotzeta*I0[40] - 3.000000*I1[25];
    *(vp++) = twotzeta*I0[41] - 2.000000*I1[26];
    *(vp++) = twotzeta*I0[42] - 1.000000*I1[27];
    *(vp++) = twotzeta*I0[43] ;
    *(vp++) = twotzeta*I0[45] - 8.000000*I1[28];
    *(vp++) = twotzeta*I0[46] - 7.000000*I1[29];
    *(vp++) = twotzeta*I0[47] - 6.000000*I1[30];
    *(vp++) = twotzeta*I0[48] - 5.000000*I1[31];
    *(vp++) = twotzeta*I0[49] - 4.000000*I1[32];
    *(vp++) = twotzeta*I0[50] - 3.000000*I1[33];
    *(vp++) = twotzeta*I0[51] - 2.000000*I1[34];
    *(vp++) = twotzeta*I0[52] - 1.000000*I1[35];
    *(vp++) = twotzeta*I0[53] ;
    *(vp++) = twotzeta*I0[55] - 9.000000*I1[36];
    *(vp++) = twotzeta*I0[56] - 8.000000*I1[37];
    *(vp++) = twotzeta*I0[57] - 7.000000*I1[38];
    *(vp++) = twotzeta*I0[58] - 6.000000*I1[39];
    *(vp++) = twotzeta*I0[59] - 5.000000*I1[40];
    *(vp++) = twotzeta*I0[60] - 4.000000*I1[41];
    *(vp++) = twotzeta*I0[61] - 3.000000*I1[42];
    *(vp++) = twotzeta*I0[62] - 2.000000*I1[43];
    *(vp++) = twotzeta*I0[63] - 1.000000*I1[44];
    *(vp++) = twotzeta*I0[64] ;
    *(vp++) = twotzeta*I0[66] - 10.000000*I1[45];
    *(vp++) = twotzeta*I0[67] - 9.000000*I1[46];
    *(vp++) = twotzeta*I0[68] - 8.000000*I1[47];
    *(vp++) = twotzeta*I0[69] - 7.000000*I1[48];
    *(vp++) = twotzeta*I0[70] - 6.000000*I1[49];
    *(vp++) = twotzeta*I0[71] - 5.000000*I1[50];
    *(vp++) = twotzeta*I0[72] - 4.000000*I1[51];
    *(vp++) = twotzeta*I0[73] - 3.000000*I1[52];
    *(vp++) = twotzeta*I0[74] - 2.000000*I1[53];
    *(vp++) = twotzeta*I0[75] - 1.000000*I1[54];
    *(vp++) = twotzeta*I0[76] ;
    *(vp++) = twotzeta*I0[78] - 11.000000*I1[55];
    *(vp++) = twotzeta*I0[79] - 10.000000*I1[56];
    *(vp++) = twotzeta*I0[80] - 9.000000*I1[57];
    *(vp++) = twotzeta*I0[81] - 8.000000*I1[58];
    *(vp++) = twotzeta*I0[82] - 7.000000*I1[59];
    *(vp++) = twotzeta*I0[83] - 6.000000*I1[60];
    *(vp++) = twotzeta*I0[84] - 5.000000*I1[61];
    *(vp++) = twotzeta*I0[85] - 4.000000*I1[62];
    *(vp++) = twotzeta*I0[86] - 3.000000*I1[63];
    *(vp++) = twotzeta*I0[87] - 2.000000*I1[64];
    *(vp++) = twotzeta*I0[88] - 1.000000*I1[65];
    *(vp++) = twotzeta*I0[89] ;
    *(vp++) = twotzeta*I0[91] - 12.000000*I1[66];
    *(vp++) = twotzeta*I0[92] - 11.000000*I1[67];
    *(vp++) = twotzeta*I0[93] - 10.000000*I1[68];
    *(vp++) = twotzeta*I0[94] - 9.000000*I1[69];
    *(vp++) = twotzeta*I0[95] - 8.000000*I1[70];
    *(vp++) = twotzeta*I0[96] - 7.000000*I1[71];
    *(vp++) = twotzeta*I0[97] - 6.000000*I1[72];
    *(vp++) = twotzeta*I0[98] - 5.000000*I1[73];
    *(vp++) = twotzeta*I0[99] - 4.000000*I1[74];
    *(vp++) = twotzeta*I0[100] - 3.000000*I1[75];
    *(vp++) = twotzeta*I0[101] - 2.000000*I1[76];
    *(vp++) = twotzeta*I0[102] - 1.000000*I1[77];
    *(vp++) = twotzeta*I0[103] ;
    *(vp++) = twotzeta*I0[105] - 13.000000*I1[78];
    *(vp++) = twotzeta*I0[106] - 12.000000*I1[79];
    *(vp++) = twotzeta*I0[107] - 11.000000*I1[80];
    *(vp++) = twotzeta*I0[108] - 10.000000*I1[81];
    *(vp++) = twotzeta*I0[109] - 9.000000*I1[82];
    *(vp++) = twotzeta*I0[110] - 8.000000*I1[83];
    *(vp++) = twotzeta*I0[111] - 7.000000*I1[84];
    *(vp++) = twotzeta*I0[112] - 6.000000*I1[85];
    *(vp++) = twotzeta*I0[113] - 5.000000*I1[86];
    *(vp++) = twotzeta*I0[114] - 4.000000*I1[87];
    *(vp++) = twotzeta*I0[115] - 3.000000*I1[88];
    *(vp++) = twotzeta*I0[116] - 2.000000*I1[89];
    *(vp++) = twotzeta*I0[117] - 1.000000*I1[90];
    *(vp++) = twotzeta*I0[118] ;
  I0 += 120;  I1 += 91;
  }
}
