/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

  /* These machine-generated functions compute a quartet of (ps|os) integrals */

#include "libint.h"

void _build_p0o0(prim_data *Data, REALTYPE *vp, const REALTYPE *I0, const REALTYPE *I1, const REALTYPE *I2, const REALTYPE *I3, const REALTYPE *I4)
{
  REALTYPE U00, U01, U02, U10, U11, U12, U20, U21, U22;
  REALTYPE U30, U31, U32, U40, U41, U42, U50, U51, U52;
  REALTYPE lpoz = Data->poz;
  REALTYPE lpon = Data->pon;
  REALTYPE oneo2zn;
  REALTYPE twoo2zn;
  REALTYPE threeo2zn;
  REALTYPE fouro2zn;
  REALTYPE fiveo2zn;
  REALTYPE sixo2zn;
  REALTYPE seveno2zn;
  REALTYPE eighto2zn;
  REALTYPE nineo2zn;
  REALTYPE teno2zn;
  REALTYPE eleveno2zn;
  oneo2zn = 1.0*Data->oo2zn;
  twoo2zn = 2.0*Data->oo2zn;
  threeo2zn = 3.0*Data->oo2zn;
  fouro2zn = 4.0*Data->oo2zn;
  fiveo2zn = 5.0*Data->oo2zn;
  sixo2zn = 6.0*Data->oo2zn;
  seveno2zn = 7.0*Data->oo2zn;
  eighto2zn = 8.0*Data->oo2zn;
  nineo2zn = 9.0*Data->oo2zn;
  teno2zn = 10.0*Data->oo2zn;
  eleveno2zn = 11.0*Data->oo2zn;
  U00 = Data->U[0][0];
  U01 = Data->U[0][1];
  U02 = Data->U[0][2];
  U40 = Data->U[4][0];
  U41 = Data->U[4][1];
  U42 = Data->U[4][2];


*(vp++) = U00*I0[0] + U40*I1[0]
           + (eleveno2zn)*I4[0];
*(vp++) = U00*I0[1] + U40*I1[1]
           + (teno2zn)*I4[1];
*(vp++) = U00*I0[2] + U40*I1[2]
           + (teno2zn)*I4[2];
*(vp++) = U00*I0[3] + U40*I1[3]
           + (nineo2zn)*I4[3];
*(vp++) = U00*I0[4] + U40*I1[4]
           + (nineo2zn)*I4[4];
*(vp++) = U00*I0[5] + U40*I1[5]
           + (nineo2zn)*I4[5];
*(vp++) = U00*I0[6] + U40*I1[6]
           + (eighto2zn)*I4[6];
*(vp++) = U00*I0[7] + U40*I1[7]
           + (eighto2zn)*I4[7];
*(vp++) = U00*I0[8] + U40*I1[8]
           + (eighto2zn)*I4[8];
*(vp++) = U00*I0[9] + U40*I1[9]
           + (eighto2zn)*I4[9];
*(vp++) = U00*I0[10] + U40*I1[10]
           + (seveno2zn)*I4[10];
*(vp++) = U00*I0[11] + U40*I1[11]
           + (seveno2zn)*I4[11];
*(vp++) = U00*I0[12] + U40*I1[12]
           + (seveno2zn)*I4[12];
*(vp++) = U00*I0[13] + U40*I1[13]
           + (seveno2zn)*I4[13];
*(vp++) = U00*I0[14] + U40*I1[14]
           + (seveno2zn)*I4[14];
*(vp++) = U00*I0[15] + U40*I1[15]
           + (sixo2zn)*I4[15];
*(vp++) = U00*I0[16] + U40*I1[16]
           + (sixo2zn)*I4[16];
*(vp++) = U00*I0[17] + U40*I1[17]
           + (sixo2zn)*I4[17];
*(vp++) = U00*I0[18] + U40*I1[18]
           + (sixo2zn)*I4[18];
*(vp++) = U00*I0[19] + U40*I1[19]
           + (sixo2zn)*I4[19];
*(vp++) = U00*I0[20] + U40*I1[20]
           + (sixo2zn)*I4[20];
*(vp++) = U00*I0[21] + U40*I1[21]
           + (fiveo2zn)*I4[21];
*(vp++) = U00*I0[22] + U40*I1[22]
           + (fiveo2zn)*I4[22];
*(vp++) = U00*I0[23] + U40*I1[23]
           + (fiveo2zn)*I4[23];
*(vp++) = U00*I0[24] + U40*I1[24]
           + (fiveo2zn)*I4[24];
*(vp++) = U00*I0[25] + U40*I1[25]
           + (fiveo2zn)*I4[25];
*(vp++) = U00*I0[26] + U40*I1[26]
           + (fiveo2zn)*I4[26];
*(vp++) = U00*I0[27] + U40*I1[27]
           + (fiveo2zn)*I4[27];
*(vp++) = U00*I0[28] + U40*I1[28]
           + (fouro2zn)*I4[28];
*(vp++) = U00*I0[29] + U40*I1[29]
           + (fouro2zn)*I4[29];
*(vp++) = U00*I0[30] + U40*I1[30]
           + (fouro2zn)*I4[30];
*(vp++) = U00*I0[31] + U40*I1[31]
           + (fouro2zn)*I4[31];
*(vp++) = U00*I0[32] + U40*I1[32]
           + (fouro2zn)*I4[32];
*(vp++) = U00*I0[33] + U40*I1[33]
           + (fouro2zn)*I4[33];
*(vp++) = U00*I0[34] + U40*I1[34]
           + (fouro2zn)*I4[34];
*(vp++) = U00*I0[35] + U40*I1[35]
           + (fouro2zn)*I4[35];
*(vp++) = U00*I0[36] + U40*I1[36]
           + (threeo2zn)*I4[36];
*(vp++) = U00*I0[37] + U40*I1[37]
           + (threeo2zn)*I4[37];
*(vp++) = U00*I0[38] + U40*I1[38]
           + (threeo2zn)*I4[38];
*(vp++) = U00*I0[39] + U40*I1[39]
           + (threeo2zn)*I4[39];
*(vp++) = U00*I0[40] + U40*I1[40]
           + (threeo2zn)*I4[40];
*(vp++) = U00*I0[41] + U40*I1[41]
           + (threeo2zn)*I4[41];
*(vp++) = U00*I0[42] + U40*I1[42]
           + (threeo2zn)*I4[42];
*(vp++) = U00*I0[43] + U40*I1[43]
           + (threeo2zn)*I4[43];
*(vp++) = U00*I0[44] + U40*I1[44]
           + (threeo2zn)*I4[44];
*(vp++) = U00*I0[45] + U40*I1[45]
           + (twoo2zn)*I4[45];
*(vp++) = U00*I0[46] + U40*I1[46]
           + (twoo2zn)*I4[46];
*(vp++) = U00*I0[47] + U40*I1[47]
           + (twoo2zn)*I4[47];
*(vp++) = U00*I0[48] + U40*I1[48]
           + (twoo2zn)*I4[48];
*(vp++) = U00*I0[49] + U40*I1[49]
           + (twoo2zn)*I4[49];
*(vp++) = U00*I0[50] + U40*I1[50]
           + (twoo2zn)*I4[50];
*(vp++) = U00*I0[51] + U40*I1[51]
           + (twoo2zn)*I4[51];
*(vp++) = U00*I0[52] + U40*I1[52]
           + (twoo2zn)*I4[52];
*(vp++) = U00*I0[53] + U40*I1[53]
           + (twoo2zn)*I4[53];
*(vp++) = U00*I0[54] + U40*I1[54]
           + (twoo2zn)*I4[54];
*(vp++) = U00*I0[55] + U40*I1[55]
           + (oneo2zn)*I4[55];
*(vp++) = U00*I0[56] + U40*I1[56]
           + (oneo2zn)*I4[56];
*(vp++) = U00*I0[57] + U40*I1[57]
           + (oneo2zn)*I4[57];
*(vp++) = U00*I0[58] + U40*I1[58]
           + (oneo2zn)*I4[58];
*(vp++) = U00*I0[59] + U40*I1[59]
           + (oneo2zn)*I4[59];
*(vp++) = U00*I0[60] + U40*I1[60]
           + (oneo2zn)*I4[60];
*(vp++) = U00*I0[61] + U40*I1[61]
           + (oneo2zn)*I4[61];
*(vp++) = U00*I0[62] + U40*I1[62]
           + (oneo2zn)*I4[62];
*(vp++) = U00*I0[63] + U40*I1[63]
           + (oneo2zn)*I4[63];
*(vp++) = U00*I0[64] + U40*I1[64]
           + (oneo2zn)*I4[64];
*(vp++) = U00*I0[65] + U40*I1[65]
           + (oneo2zn)*I4[65];
*(vp++) = U00*I0[66] + U40*I1[66];
*(vp++) = U00*I0[67] + U40*I1[67];
*(vp++) = U00*I0[68] + U40*I1[68];
*(vp++) = U00*I0[69] + U40*I1[69];
*(vp++) = U00*I0[70] + U40*I1[70];
*(vp++) = U00*I0[71] + U40*I1[71];
*(vp++) = U00*I0[72] + U40*I1[72];
*(vp++) = U00*I0[73] + U40*I1[73];
*(vp++) = U00*I0[74] + U40*I1[74];
*(vp++) = U00*I0[75] + U40*I1[75];
*(vp++) = U00*I0[76] + U40*I1[76];
*(vp++) = U00*I0[77] + U40*I1[77];
*(vp++) = U01*I0[0] + U41*I1[0];
*(vp++) = U01*I0[1] + U41*I1[1]
           + (oneo2zn)*I4[0];
*(vp++) = U01*I0[2] + U41*I1[2];
*(vp++) = U01*I0[3] + U41*I1[3]
           + (twoo2zn)*I4[1];
*(vp++) = U01*I0[4] + U41*I1[4]
           + (oneo2zn)*I4[2];
*(vp++) = U01*I0[5] + U41*I1[5];
*(vp++) = U01*I0[6] + U41*I1[6]
           + (threeo2zn)*I4[3];
*(vp++) = U01*I0[7] + U41*I1[7]
           + (twoo2zn)*I4[4];
*(vp++) = U01*I0[8] + U41*I1[8]
           + (oneo2zn)*I4[5];
*(vp++) = U01*I0[9] + U41*I1[9];
*(vp++) = U01*I0[10] + U41*I1[10]
           + (fouro2zn)*I4[6];
*(vp++) = U01*I0[11] + U41*I1[11]
           + (threeo2zn)*I4[7];
*(vp++) = U01*I0[12] + U41*I1[12]
           + (twoo2zn)*I4[8];
*(vp++) = U01*I0[13] + U41*I1[13]
           + (oneo2zn)*I4[9];
*(vp++) = U01*I0[14] + U41*I1[14];
*(vp++) = U01*I0[15] + U41*I1[15]
           + (fiveo2zn)*I4[10];
*(vp++) = U01*I0[16] + U41*I1[16]
           + (fouro2zn)*I4[11];
*(vp++) = U01*I0[17] + U41*I1[17]
           + (threeo2zn)*I4[12];
*(vp++) = U01*I0[18] + U41*I1[18]
           + (twoo2zn)*I4[13];
*(vp++) = U01*I0[19] + U41*I1[19]
           + (oneo2zn)*I4[14];
*(vp++) = U01*I0[20] + U41*I1[20];
*(vp++) = U01*I0[21] + U41*I1[21]
           + (sixo2zn)*I4[15];
*(vp++) = U01*I0[22] + U41*I1[22]
           + (fiveo2zn)*I4[16];
*(vp++) = U01*I0[23] + U41*I1[23]
           + (fouro2zn)*I4[17];
*(vp++) = U01*I0[24] + U41*I1[24]
           + (threeo2zn)*I4[18];
*(vp++) = U01*I0[25] + U41*I1[25]
           + (twoo2zn)*I4[19];
*(vp++) = U01*I0[26] + U41*I1[26]
           + (oneo2zn)*I4[20];
*(vp++) = U01*I0[27] + U41*I1[27];
*(vp++) = U01*I0[28] + U41*I1[28]
           + (seveno2zn)*I4[21];
*(vp++) = U01*I0[29] + U41*I1[29]
           + (sixo2zn)*I4[22];
*(vp++) = U01*I0[30] + U41*I1[30]
           + (fiveo2zn)*I4[23];
*(vp++) = U01*I0[31] + U41*I1[31]
           + (fouro2zn)*I4[24];
*(vp++) = U01*I0[32] + U41*I1[32]
           + (threeo2zn)*I4[25];
*(vp++) = U01*I0[33] + U41*I1[33]
           + (twoo2zn)*I4[26];
*(vp++) = U01*I0[34] + U41*I1[34]
           + (oneo2zn)*I4[27];
*(vp++) = U01*I0[35] + U41*I1[35];
*(vp++) = U01*I0[36] + U41*I1[36]
           + (eighto2zn)*I4[28];
*(vp++) = U01*I0[37] + U41*I1[37]
           + (seveno2zn)*I4[29];
*(vp++) = U01*I0[38] + U41*I1[38]
           + (sixo2zn)*I4[30];
*(vp++) = U01*I0[39] + U41*I1[39]
           + (fiveo2zn)*I4[31];
*(vp++) = U01*I0[40] + U41*I1[40]
           + (fouro2zn)*I4[32];
*(vp++) = U01*I0[41] + U41*I1[41]
           + (threeo2zn)*I4[33];
*(vp++) = U01*I0[42] + U41*I1[42]
           + (twoo2zn)*I4[34];
*(vp++) = U01*I0[43] + U41*I1[43]
           + (oneo2zn)*I4[35];
*(vp++) = U01*I0[44] + U41*I1[44];
*(vp++) = U01*I0[45] + U41*I1[45]
           + (nineo2zn)*I4[36];
*(vp++) = U01*I0[46] + U41*I1[46]
           + (eighto2zn)*I4[37];
*(vp++) = U01*I0[47] + U41*I1[47]
           + (seveno2zn)*I4[38];
*(vp++) = U01*I0[48] + U41*I1[48]
           + (sixo2zn)*I4[39];
*(vp++) = U01*I0[49] + U41*I1[49]
           + (fiveo2zn)*I4[40];
*(vp++) = U01*I0[50] + U41*I1[50]
           + (fouro2zn)*I4[41];
*(vp++) = U01*I0[51] + U41*I1[51]
           + (threeo2zn)*I4[42];
*(vp++) = U01*I0[52] + U41*I1[52]
           + (twoo2zn)*I4[43];
*(vp++) = U01*I0[53] + U41*I1[53]
           + (oneo2zn)*I4[44];
*(vp++) = U01*I0[54] + U41*I1[54];
*(vp++) = U01*I0[55] + U41*I1[55]
           + (teno2zn)*I4[45];
*(vp++) = U01*I0[56] + U41*I1[56]
           + (nineo2zn)*I4[46];
*(vp++) = U01*I0[57] + U41*I1[57]
           + (eighto2zn)*I4[47];
*(vp++) = U01*I0[58] + U41*I1[58]
           + (seveno2zn)*I4[48];
*(vp++) = U01*I0[59] + U41*I1[59]
           + (sixo2zn)*I4[49];
*(vp++) = U01*I0[60] + U41*I1[60]
           + (fiveo2zn)*I4[50];
*(vp++) = U01*I0[61] + U41*I1[61]
           + (fouro2zn)*I4[51];
*(vp++) = U01*I0[62] + U41*I1[62]
           + (threeo2zn)*I4[52];
*(vp++) = U01*I0[63] + U41*I1[63]
           + (twoo2zn)*I4[53];
*(vp++) = U01*I0[64] + U41*I1[64]
           + (oneo2zn)*I4[54];
*(vp++) = U01*I0[65] + U41*I1[65];
*(vp++) = U01*I0[66] + U41*I1[66]
           + (eleveno2zn)*I4[55];
*(vp++) = U01*I0[67] + U41*I1[67]
           + (teno2zn)*I4[56];
*(vp++) = U01*I0[68] + U41*I1[68]
           + (nineo2zn)*I4[57];
*(vp++) = U01*I0[69] + U41*I1[69]
           + (eighto2zn)*I4[58];
*(vp++) = U01*I0[70] + U41*I1[70]
           + (seveno2zn)*I4[59];
*(vp++) = U01*I0[71] + U41*I1[71]
           + (sixo2zn)*I4[60];
*(vp++) = U01*I0[72] + U41*I1[72]
           + (fiveo2zn)*I4[61];
*(vp++) = U01*I0[73] + U41*I1[73]
           + (fouro2zn)*I4[62];
*(vp++) = U01*I0[74] + U41*I1[74]
           + (threeo2zn)*I4[63];
*(vp++) = U01*I0[75] + U41*I1[75]
           + (twoo2zn)*I4[64];
*(vp++) = U01*I0[76] + U41*I1[76]
           + (oneo2zn)*I4[65];
*(vp++) = U01*I0[77] + U41*I1[77];
*(vp++) = U02*I0[0] + U42*I1[0];
*(vp++) = U02*I0[1] + U42*I1[1];
*(vp++) = U02*I0[2] + U42*I1[2]
           + (oneo2zn)*I4[0];
*(vp++) = U02*I0[3] + U42*I1[3];
*(vp++) = U02*I0[4] + U42*I1[4]
           + (oneo2zn)*I4[1];
*(vp++) = U02*I0[5] + U42*I1[5]
           + (twoo2zn)*I4[2];
*(vp++) = U02*I0[6] + U42*I1[6];
*(vp++) = U02*I0[7] + U42*I1[7]
           + (oneo2zn)*I4[3];
*(vp++) = U02*I0[8] + U42*I1[8]
           + (twoo2zn)*I4[4];
*(vp++) = U02*I0[9] + U42*I1[9]
           + (threeo2zn)*I4[5];
*(vp++) = U02*I0[10] + U42*I1[10];
*(vp++) = U02*I0[11] + U42*I1[11]
           + (oneo2zn)*I4[6];
*(vp++) = U02*I0[12] + U42*I1[12]
           + (twoo2zn)*I4[7];
*(vp++) = U02*I0[13] + U42*I1[13]
           + (threeo2zn)*I4[8];
*(vp++) = U02*I0[14] + U42*I1[14]
           + (fouro2zn)*I4[9];
*(vp++) = U02*I0[15] + U42*I1[15];
*(vp++) = U02*I0[16] + U42*I1[16]
           + (oneo2zn)*I4[10];
*(vp++) = U02*I0[17] + U42*I1[17]
           + (twoo2zn)*I4[11];
*(vp++) = U02*I0[18] + U42*I1[18]
           + (threeo2zn)*I4[12];
*(vp++) = U02*I0[19] + U42*I1[19]
           + (fouro2zn)*I4[13];
*(vp++) = U02*I0[20] + U42*I1[20]
           + (fiveo2zn)*I4[14];
*(vp++) = U02*I0[21] + U42*I1[21];
*(vp++) = U02*I0[22] + U42*I1[22]
           + (oneo2zn)*I4[15];
*(vp++) = U02*I0[23] + U42*I1[23]
           + (twoo2zn)*I4[16];
*(vp++) = U02*I0[24] + U42*I1[24]
           + (threeo2zn)*I4[17];
*(vp++) = U02*I0[25] + U42*I1[25]
           + (fouro2zn)*I4[18];
*(vp++) = U02*I0[26] + U42*I1[26]
           + (fiveo2zn)*I4[19];
*(vp++) = U02*I0[27] + U42*I1[27]
           + (sixo2zn)*I4[20];
*(vp++) = U02*I0[28] + U42*I1[28];
*(vp++) = U02*I0[29] + U42*I1[29]
           + (oneo2zn)*I4[21];
*(vp++) = U02*I0[30] + U42*I1[30]
           + (twoo2zn)*I4[22];
*(vp++) = U02*I0[31] + U42*I1[31]
           + (threeo2zn)*I4[23];
*(vp++) = U02*I0[32] + U42*I1[32]
           + (fouro2zn)*I4[24];
*(vp++) = U02*I0[33] + U42*I1[33]
           + (fiveo2zn)*I4[25];
*(vp++) = U02*I0[34] + U42*I1[34]
           + (sixo2zn)*I4[26];
*(vp++) = U02*I0[35] + U42*I1[35]
           + (seveno2zn)*I4[27];
*(vp++) = U02*I0[36] + U42*I1[36];
*(vp++) = U02*I0[37] + U42*I1[37]
           + (oneo2zn)*I4[28];
*(vp++) = U02*I0[38] + U42*I1[38]
           + (twoo2zn)*I4[29];
*(vp++) = U02*I0[39] + U42*I1[39]
           + (threeo2zn)*I4[30];
*(vp++) = U02*I0[40] + U42*I1[40]
           + (fouro2zn)*I4[31];
*(vp++) = U02*I0[41] + U42*I1[41]
           + (fiveo2zn)*I4[32];
*(vp++) = U02*I0[42] + U42*I1[42]
           + (sixo2zn)*I4[33];
*(vp++) = U02*I0[43] + U42*I1[43]
           + (seveno2zn)*I4[34];
*(vp++) = U02*I0[44] + U42*I1[44]
           + (eighto2zn)*I4[35];
*(vp++) = U02*I0[45] + U42*I1[45];
*(vp++) = U02*I0[46] + U42*I1[46]
           + (oneo2zn)*I4[36];
*(vp++) = U02*I0[47] + U42*I1[47]
           + (twoo2zn)*I4[37];
*(vp++) = U02*I0[48] + U42*I1[48]
           + (threeo2zn)*I4[38];
*(vp++) = U02*I0[49] + U42*I1[49]
           + (fouro2zn)*I4[39];
*(vp++) = U02*I0[50] + U42*I1[50]
           + (fiveo2zn)*I4[40];
*(vp++) = U02*I0[51] + U42*I1[51]
           + (sixo2zn)*I4[41];
*(vp++) = U02*I0[52] + U42*I1[52]
           + (seveno2zn)*I4[42];
*(vp++) = U02*I0[53] + U42*I1[53]
           + (eighto2zn)*I4[43];
*(vp++) = U02*I0[54] + U42*I1[54]
           + (nineo2zn)*I4[44];
*(vp++) = U02*I0[55] + U42*I1[55];
*(vp++) = U02*I0[56] + U42*I1[56]
           + (oneo2zn)*I4[45];
*(vp++) = U02*I0[57] + U42*I1[57]
           + (twoo2zn)*I4[46];
*(vp++) = U02*I0[58] + U42*I1[58]
           + (threeo2zn)*I4[47];
*(vp++) = U02*I0[59] + U42*I1[59]
           + (fouro2zn)*I4[48];
*(vp++) = U02*I0[60] + U42*I1[60]
           + (fiveo2zn)*I4[49];
*(vp++) = U02*I0[61] + U42*I1[61]
           + (sixo2zn)*I4[50];
*(vp++) = U02*I0[62] + U42*I1[62]
           + (seveno2zn)*I4[51];
*(vp++) = U02*I0[63] + U42*I1[63]
           + (eighto2zn)*I4[52];
*(vp++) = U02*I0[64] + U42*I1[64]
           + (nineo2zn)*I4[53];
*(vp++) = U02*I0[65] + U42*I1[65]
           + (teno2zn)*I4[54];
*(vp++) = U02*I0[66] + U42*I1[66];
*(vp++) = U02*I0[67] + U42*I1[67]
           + (oneo2zn)*I4[55];
*(vp++) = U02*I0[68] + U42*I1[68]
           + (twoo2zn)*I4[56];
*(vp++) = U02*I0[69] + U42*I1[69]
           + (threeo2zn)*I4[57];
*(vp++) = U02*I0[70] + U42*I1[70]
           + (fouro2zn)*I4[58];
*(vp++) = U02*I0[71] + U42*I1[71]
           + (fiveo2zn)*I4[59];
*(vp++) = U02*I0[72] + U42*I1[72]
           + (sixo2zn)*I4[60];
*(vp++) = U02*I0[73] + U42*I1[73]
           + (seveno2zn)*I4[61];
*(vp++) = U02*I0[74] + U42*I1[74]
           + (eighto2zn)*I4[62];
*(vp++) = U02*I0[75] + U42*I1[75]
           + (nineo2zn)*I4[63];
*(vp++) = U02*I0[76] + U42*I1[76]
           + (teno2zn)*I4[64];
*(vp++) = U02*I0[77] + U42*I1[77]
           + (eleveno2zn)*I4[65];

}
/* Total number of FLOPs = 1098 */
