/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_00ll(Libint_t*, prim_data*);

  /* Computes quartets of (00|ll) integrals */

REALTYPE *hrr_order_00ll(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[0][8] = int_stack + 0;
 Libint->vrr_classes[0][9] = int_stack + 45;
 Libint->vrr_classes[0][10] = int_stack + 100;
 Libint->vrr_classes[0][11] = int_stack + 166;
 Libint->vrr_classes[0][12] = int_stack + 244;
 Libint->vrr_classes[0][13] = int_stack + 335;
 Libint->vrr_classes[0][14] = int_stack + 440;
 Libint->vrr_classes[0][15] = int_stack + 560;
 Libint->vrr_classes[0][16] = int_stack + 696;
 memset(int_stack,0,849*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 849;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_00ll(Libint, Data);
   Data++;
 }
 /*--- compute (00|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+849,int_stack+45,int_stack+0,1);
 /*--- compute (00|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+984,int_stack+100,int_stack+45,1);
 /*--- compute (00|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+1149,int_stack+984,int_stack+849,1);
 /*--- compute (00|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+1419,int_stack+166,int_stack+100,1);
 /*--- compute (00|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+1617,int_stack+1419,int_stack+984,1);
 /*--- compute (00|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+1947,int_stack+1617,int_stack+1149,1);
 /*--- compute (00|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+849,int_stack+244,int_stack+166,1);
 /*--- compute (00|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+2397,int_stack+849,int_stack+1419,1);
 /*--- compute (00|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+2793,int_stack+2397,int_stack+1617,1);
 /*--- compute (00|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+1083,int_stack+2793,int_stack+1947,1);
 /*--- compute (00|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+1758,int_stack+335,int_stack+244,1);
 /*--- compute (00|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+3343,int_stack+1758,int_stack+849,1);
 /*--- compute (00|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+3811,int_stack+3343,int_stack+2397,1);
 /*--- compute (00|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+4471,int_stack+3811,int_stack+2793,1);
 /*--- compute (00|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+2031,int_stack+4471,int_stack+1083,1);
 /*--- compute (00|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+849,int_stack+440,int_stack+335,1);
 /*--- compute (00|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+1164,int_stack+849,int_stack+1758,1);
 /*--- compute (00|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+5296,int_stack+1164,int_stack+3343,1);
 /*--- compute (00|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+6076,int_stack+5296,int_stack+3811,1);
 /*--- compute (00|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+2976,int_stack+6076,int_stack+4471,1);
 /*--- compute (00|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+7066,int_stack+2976,int_stack+2031,1);
 /*--- compute (00|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+1710,int_stack+560,int_stack+440,1);
 /*--- compute (00|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+2070,int_stack+1710,int_stack+849,1);
 /*--- compute (00|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+4131,int_stack+2070,int_stack+1164,1);
 /*--- compute (00|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+8326,int_stack+4131,int_stack+5296,1);
 /*--- compute (00|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+9496,int_stack+8326,int_stack+6076,1);
 /*--- compute (00|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+5041,int_stack+9496,int_stack+2976,1);
 /*--- compute (00|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+10882,int_stack+5041,int_stack+7066,1);
 /*--- compute (00|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+849,int_stack+696,int_stack+560,1);
 /*--- compute (00|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+2700,int_stack+849,int_stack+1710,1);
 /*--- compute (00|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+6581,int_stack+2700,int_stack+2070,1);
 /*--- compute (00|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+0,int_stack+6581,int_stack+4131,1);
 /*--- compute (00|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+6581,int_stack+0,int_stack+8326,1);
 /*--- compute (00|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+0,int_stack+6581,int_stack+9496,1);
 /*--- compute (00|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+6581,int_stack+0,int_stack+5041,1);
 /*--- compute (00|ll) ---*/
 hrr3_build_ll(Libint->CD,int_stack+0,int_stack+6581,int_stack+10882,1);
 return int_stack+0;}
