/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_00ni(Libint_t*, prim_data*);

  /* Computes quartets of (00|ni) integrals */

REALTYPE *hrr_order_00ni(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[0][10] = int_stack + 0;
 Libint->vrr_classes[0][11] = int_stack + 66;
 Libint->vrr_classes[0][12] = int_stack + 144;
 Libint->vrr_classes[0][13] = int_stack + 235;
 Libint->vrr_classes[0][14] = int_stack + 340;
 Libint->vrr_classes[0][15] = int_stack + 460;
 Libint->vrr_classes[0][16] = int_stack + 596;
 memset(int_stack,0,749*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 749;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_00ni(Libint, Data);
   Data++;
 }
 /*--- compute (00|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+749,int_stack+66,int_stack+0,1);
 /*--- compute (00|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+947,int_stack+144,int_stack+66,1);
 /*--- compute (00|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+1181,int_stack+947,int_stack+749,1);
 /*--- compute (00|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+1577,int_stack+235,int_stack+144,1);
 /*--- compute (00|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+1850,int_stack+1577,int_stack+947,1);
 /*--- compute (00|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+2318,int_stack+1850,int_stack+1181,1);
 /*--- compute (00|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+749,int_stack+340,int_stack+235,1);
 /*--- compute (00|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+2978,int_stack+749,int_stack+1577,1);
 /*--- compute (00|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1064,int_stack+2978,int_stack+1850,1);
 /*--- compute (00|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+3524,int_stack+1064,int_stack+2318,1);
 /*--- compute (00|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+1844,int_stack+460,int_stack+340,1);
 /*--- compute (00|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+2204,int_stack+1844,int_stack+749,1);
 /*--- compute (00|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+4514,int_stack+2204,int_stack+2978,1);
 /*--- compute (00|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+5424,int_stack+4514,int_stack+1064,1);
 /*--- compute (00|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+6594,int_stack+5424,int_stack+3524,1);
 /*--- compute (00|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+749,int_stack+596,int_stack+460,1);
 /*--- compute (00|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+2834,int_stack+749,int_stack+1844,1);
 /*--- compute (00|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+0,int_stack+2834,int_stack+2204,1);
 /*--- compute (00|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1050,int_stack+0,int_stack+4514,1);
 /*--- compute (00|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+2415,int_stack+1050,int_stack+5424,1);
 /*--- compute (00|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+0,int_stack+2415,int_stack+6594,1);
 return int_stack+0;}
