/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_d0nm(Libint_t*, prim_data*);

  /* Computes quartets of (d0|nm) integrals */

REALTYPE *hrr_order_d0nm(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[2][10] = int_stack + 0;
 Libint->vrr_classes[2][11] = int_stack + 396;
 Libint->vrr_classes[2][12] = int_stack + 864;
 Libint->vrr_classes[2][13] = int_stack + 1410;
 Libint->vrr_classes[2][14] = int_stack + 2040;
 Libint->vrr_classes[2][15] = int_stack + 2760;
 Libint->vrr_classes[2][16] = int_stack + 3576;
 Libint->vrr_classes[2][17] = int_stack + 4494;
 Libint->vrr_classes[2][18] = int_stack + 5520;
 Libint->vrr_classes[2][19] = int_stack + 6660;
 memset(int_stack,0,7920*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 7920;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_d0nm(Libint, Data);
   Data++;
 }
 /*--- compute (d0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+7920,int_stack+396,int_stack+0,6);
 /*--- compute (d0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+9108,int_stack+864,int_stack+396,6);
 /*--- compute (d0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+10512,int_stack+9108,int_stack+7920,6);
 /*--- compute (d0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+12888,int_stack+1410,int_stack+864,6);
 /*--- compute (d0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+14526,int_stack+12888,int_stack+9108,6);
 /*--- compute (d0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+17334,int_stack+14526,int_stack+10512,6);
 /*--- compute (d0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+7920,int_stack+2040,int_stack+1410,6);
 /*--- compute (d0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+21294,int_stack+7920,int_stack+12888,6);
 /*--- compute (d0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+9810,int_stack+21294,int_stack+14526,6);
 /*--- compute (d0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+24570,int_stack+9810,int_stack+17334,6);
 /*--- compute (d0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+14490,int_stack+2760,int_stack+2040,6);
 /*--- compute (d0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+16650,int_stack+14490,int_stack+7920,6);
 /*--- compute (d0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+30510,int_stack+16650,int_stack+21294,6);
 /*--- compute (d0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+35970,int_stack+30510,int_stack+9810,6);
 /*--- compute (d0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+42990,int_stack+35970,int_stack+24570,6);
 /*--- compute (d0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+7920,int_stack+3576,int_stack+2760,6);
 /*--- compute (d0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+20430,int_stack+7920,int_stack+14490,6);
 /*--- compute (d0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+51306,int_stack+20430,int_stack+16650,6);
 /*--- compute (d0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+10368,int_stack+51306,int_stack+30510,6);
 /*--- compute (d0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+24750,int_stack+10368,int_stack+35970,6);
 /*--- compute (d0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+57606,int_stack+24750,int_stack+42990,6);
 /*--- compute (d0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+34578,int_stack+4494,int_stack+3576,6);
 /*--- compute (d0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+37332,int_stack+34578,int_stack+7920,6);
 /*--- compute (d0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+42228,int_stack+37332,int_stack+20430,6);
 /*--- compute (d0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+68694,int_stack+42228,int_stack+51306,6);
 /*--- compute (d0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+78144,int_stack+68694,int_stack+10368,6);
 /*--- compute (d0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+7920,int_stack+78144,int_stack+24750,6);
 /*--- compute (d0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+89610,int_stack+7920,int_stack+57606,6);
 /*--- compute (d0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+21024,int_stack+5520,int_stack+4494,6);
 /*--- compute (d0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+24102,int_stack+21024,int_stack+34578,6);
 /*--- compute (d0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+49428,int_stack+24102,int_stack+37332,6);
 /*--- compute (d0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+29610,int_stack+49428,int_stack+42228,6);
 /*--- compute (d0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+103866,int_stack+29610,int_stack+68694,6);
 /*--- compute (d0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+57588,int_stack+103866,int_stack+78144,6);
 /*--- compute (d0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+117096,int_stack+57588,int_stack+7920,6);
 /*--- compute (d0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+133944,int_stack+117096,int_stack+89610,6);
 /*--- compute (d0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+7920,int_stack+6660,int_stack+5520,6);
 /*--- compute (d0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+11340,int_stack+7920,int_stack+21024,6);
 /*--- compute (d0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+72876,int_stack+11340,int_stack+24102,6);
 /*--- compute (d0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+82056,int_stack+72876,int_stack+49428,6);
 /*--- compute (d0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+40410,int_stack+82056,int_stack+29610,6);
 /*--- compute (d0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+72876,int_stack+40410,int_stack+103866,6);
 /*--- compute (d0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+90516,int_stack+72876,int_stack+57588,6);
 /*--- compute (d0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+0,int_stack+90516,int_stack+117096,6);
 /*--- compute (d0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+21060,int_stack+0,int_stack+133944,6);
 return int_stack+21060;}
