/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_ddip(Libint_t*, prim_data*);

  /* Computes quartets of (dd|ip) integrals */

REALTYPE *hrr_order_ddip(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[2][6] = int_stack + 0;
 Libint->vrr_classes[2][7] = int_stack + 168;
 Libint->vrr_classes[3][6] = int_stack + 384;
 Libint->vrr_classes[3][7] = int_stack + 664;
 Libint->vrr_classes[4][6] = int_stack + 1024;
 Libint->vrr_classes[4][7] = int_stack + 1444;
 memset(int_stack,0,1984*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 1984;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_ddip(Libint, Data);
   Data++;
 }
 /*--- compute (d0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+1984,int_stack+168,int_stack+0,6);
 /*--- compute (f0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+2488,int_stack+664,int_stack+384,10);
 /*--- compute (dp|ip) ---*/
 hrr1_build_dp(Libint->AB,int_stack+3328,int_stack+2488,int_stack+1984,84);
 /*--- compute (g0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+4840,int_stack+1444,int_stack+1024,15);
 /*--- compute (fp|ip) ---*/
 hrr1_build_fp(Libint->AB,int_stack+6100,int_stack+4840,int_stack+2488,84);
 /*--- compute (dd|ip) ---*/
 hrr1_build_dd(Libint->AB,int_stack+0,int_stack+6100,int_stack+3328,84);
 return int_stack+0;}
