/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_ddll(Libint_t*, prim_data*);

  /* Computes quartets of (dd|ll) integrals */

REALTYPE *hrr_order_ddll(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[2][8] = int_stack + 0;
 Libint->vrr_classes[2][9] = int_stack + 270;
 Libint->vrr_classes[2][10] = int_stack + 600;
 Libint->vrr_classes[2][11] = int_stack + 996;
 Libint->vrr_classes[2][12] = int_stack + 1464;
 Libint->vrr_classes[2][13] = int_stack + 2010;
 Libint->vrr_classes[2][14] = int_stack + 2640;
 Libint->vrr_classes[2][15] = int_stack + 3360;
 Libint->vrr_classes[2][16] = int_stack + 4176;
 Libint->vrr_classes[3][8] = int_stack + 5094;
 Libint->vrr_classes[3][9] = int_stack + 5544;
 Libint->vrr_classes[3][10] = int_stack + 6094;
 Libint->vrr_classes[3][11] = int_stack + 6754;
 Libint->vrr_classes[3][12] = int_stack + 7534;
 Libint->vrr_classes[3][13] = int_stack + 8444;
 Libint->vrr_classes[3][14] = int_stack + 9494;
 Libint->vrr_classes[3][15] = int_stack + 10694;
 Libint->vrr_classes[3][16] = int_stack + 12054;
 Libint->vrr_classes[4][8] = int_stack + 13584;
 Libint->vrr_classes[4][9] = int_stack + 14259;
 Libint->vrr_classes[4][10] = int_stack + 15084;
 Libint->vrr_classes[4][11] = int_stack + 16074;
 Libint->vrr_classes[4][12] = int_stack + 17244;
 Libint->vrr_classes[4][13] = int_stack + 18609;
 Libint->vrr_classes[4][14] = int_stack + 20184;
 Libint->vrr_classes[4][15] = int_stack + 21984;
 Libint->vrr_classes[4][16] = int_stack + 24024;
 memset(int_stack,0,26319*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 26319;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_ddll(Libint, Data);
   Data++;
 }
 /*--- compute (d0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+26319,int_stack+270,int_stack+0,6);
 /*--- compute (d0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+27129,int_stack+600,int_stack+270,6);
 /*--- compute (d0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+28119,int_stack+27129,int_stack+26319,6);
 /*--- compute (d0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+29739,int_stack+996,int_stack+600,6);
 /*--- compute (d0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+30927,int_stack+29739,int_stack+27129,6);
 /*--- compute (d0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+32907,int_stack+30927,int_stack+28119,6);
 /*--- compute (d0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+26319,int_stack+1464,int_stack+996,6);
 /*--- compute (d0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+35607,int_stack+26319,int_stack+29739,6);
 /*--- compute (d0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+37983,int_stack+35607,int_stack+30927,6);
 /*--- compute (d0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+27723,int_stack+37983,int_stack+32907,6);
 /*--- compute (d0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+31773,int_stack+2010,int_stack+1464,6);
 /*--- compute (d0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+41283,int_stack+31773,int_stack+26319,6);
 /*--- compute (d0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+44091,int_stack+41283,int_stack+35607,6);
 /*--- compute (d0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+48051,int_stack+44091,int_stack+37983,6);
 /*--- compute (d0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+33411,int_stack+48051,int_stack+27723,6);
 /*--- compute (d0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+26319,int_stack+2640,int_stack+2010,6);
 /*--- compute (d0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+28209,int_stack+26319,int_stack+31773,6);
 /*--- compute (d0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+53001,int_stack+28209,int_stack+41283,6);
 /*--- compute (d0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+57681,int_stack+53001,int_stack+44091,6);
 /*--- compute (d0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+39081,int_stack+57681,int_stack+48051,6);
 /*--- compute (d0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+63621,int_stack+39081,int_stack+33411,6);
 /*--- compute (d0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+31485,int_stack+3360,int_stack+2640,6);
 /*--- compute (d0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+33645,int_stack+31485,int_stack+26319,6);
 /*--- compute (d0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+46011,int_stack+33645,int_stack+28209,6);
 /*--- compute (d0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+71181,int_stack+46011,int_stack+53001,6);
 /*--- compute (d0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+78201,int_stack+71181,int_stack+57681,6);
 /*--- compute (d0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+51471,int_stack+78201,int_stack+39081,6);
 /*--- compute (d0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+86517,int_stack+51471,int_stack+63621,6);
 /*--- compute (d0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+26319,int_stack+4176,int_stack+3360,6);
 /*--- compute (d0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+37425,int_stack+26319,int_stack+31485,6);
 /*--- compute (d0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+26319,int_stack+37425,int_stack+33645,6);
 /*--- compute (d0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+32619,int_stack+26319,int_stack+46011,6);
 /*--- compute (d0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+40809,int_stack+32619,int_stack+71181,6);
 /*--- compute (d0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+26319,int_stack+40809,int_stack+78201,6);
 /*--- compute (d0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+37407,int_stack+26319,int_stack+51471,6);
 /*--- compute (d0|ll) ---*/
 hrr3_build_ll(Libint->CD,int_stack+49287,int_stack+37407,int_stack+86517,6);
 /*--- compute (f0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+26319,int_stack+5544,int_stack+5094,10);
 /*--- compute (f0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+27669,int_stack+6094,int_stack+5544,10);
 /*--- compute (f0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+29319,int_stack+27669,int_stack+26319,10);
 /*--- compute (f0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+32019,int_stack+6754,int_stack+6094,10);
 /*--- compute (f0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+33999,int_stack+32019,int_stack+27669,10);
 /*--- compute (f0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+37299,int_stack+33999,int_stack+29319,10);
 /*--- compute (f0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+26319,int_stack+7534,int_stack+6754,10);
 /*--- compute (f0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+41799,int_stack+26319,int_stack+32019,10);
 /*--- compute (f0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+61437,int_stack+41799,int_stack+33999,10);
 /*--- compute (f0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+28659,int_stack+61437,int_stack+37299,10);
 /*--- compute (f0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+35409,int_stack+8444,int_stack+7534,10);
 /*--- compute (f0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+66937,int_stack+35409,int_stack+26319,10);
 /*--- compute (f0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+71617,int_stack+66937,int_stack+41799,10);
 /*--- compute (f0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+38139,int_stack+71617,int_stack+61437,10);
 /*--- compute (f0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+78217,int_stack+38139,int_stack+28659,10);
 /*--- compute (f0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+61437,int_stack+9494,int_stack+8444,10);
 /*--- compute (f0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+26319,int_stack+61437,int_stack+35409,10);
 /*--- compute (f0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+87667,int_stack+26319,int_stack+66937,10);
 /*--- compute (f0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+95467,int_stack+87667,int_stack+71617,10);
 /*--- compute (f0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+64587,int_stack+95467,int_stack+38139,10);
 /*--- compute (f0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+31779,int_stack+64587,int_stack+78217,10);
 /*--- compute (f0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+76137,int_stack+10694,int_stack+9494,10);
 /*--- compute (f0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+79737,int_stack+76137,int_stack+61437,10);
 /*--- compute (f0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+0,int_stack+79737,int_stack+26319,10);
 /*--- compute (f0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+105367,int_stack+0,int_stack+87667,10);
 /*--- compute (f0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+117067,int_stack+105367,int_stack+95467,10);
 /*--- compute (f0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+86037,int_stack+117067,int_stack+64587,10);
 /*--- compute (f0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+130927,int_stack+86037,int_stack+31779,10);
 /*--- compute (f0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+26319,int_stack+12054,int_stack+10694,10);
 /*--- compute (f0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+30399,int_stack+26319,int_stack+76137,10);
 /*--- compute (f0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+37599,int_stack+30399,int_stack+79737,10);
 /*--- compute (f0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+61437,int_stack+37599,int_stack+0,10);
 /*--- compute (f0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+26319,int_stack+61437,int_stack+105367,10);
 /*--- compute (f0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+61437,int_stack+26319,int_stack+117067,10);
 /*--- compute (f0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+26319,int_stack+61437,int_stack+86037,10);
 /*--- compute (f0|ll) ---*/
 hrr3_build_ll(Libint->CD,int_stack+61437,int_stack+26319,int_stack+130927,10);
 /*--- compute (dp|ll) ---*/
 hrr1_build_dp(Libint->AB,int_stack+81687,int_stack+61437,int_stack+49287,2025);
 /*--- compute (g0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+26319,int_stack+14259,int_stack+13584,15);
 /*--- compute (g0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+28344,int_stack+15084,int_stack+14259,15);
 /*--- compute (g0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+30819,int_stack+28344,int_stack+26319,15);
 /*--- compute (g0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+34869,int_stack+16074,int_stack+15084,15);
 /*--- compute (g0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+37839,int_stack+34869,int_stack+28344,15);
 /*--- compute (g0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+42789,int_stack+37839,int_stack+30819,15);
 /*--- compute (g0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+26319,int_stack+17244,int_stack+16074,15);
 /*--- compute (g0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+49539,int_stack+26319,int_stack+34869,15);
 /*--- compute (g0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+118137,int_stack+49539,int_stack+37839,15);
 /*--- compute (g0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+29829,int_stack+118137,int_stack+42789,15);
 /*--- compute (g0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+39954,int_stack+18609,int_stack+17244,15);
 /*--- compute (g0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+126387,int_stack+39954,int_stack+26319,15);
 /*--- compute (g0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+133407,int_stack+126387,int_stack+49539,15);
 /*--- compute (g0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+44049,int_stack+133407,int_stack+118137,15);
 /*--- compute (g0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+0,int_stack+44049,int_stack+29829,15);
 /*--- compute (g0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+118137,int_stack+20184,int_stack+18609,15);
 /*--- compute (g0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+26319,int_stack+118137,int_stack+39954,15);
 /*--- compute (g0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+143307,int_stack+26319,int_stack+126387,15);
 /*--- compute (g0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+155007,int_stack+143307,int_stack+133407,15);
 /*--- compute (g0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+122862,int_stack+155007,int_stack+44049,15);
 /*--- compute (g0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+34509,int_stack+122862,int_stack+0,15);
 /*--- compute (g0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+0,int_stack+21984,int_stack+20184,15);
 /*--- compute (g0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+5400,int_stack+0,int_stack+118137,15);
 /*--- compute (g0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+169857,int_stack+5400,int_stack+26319,15);
 /*--- compute (g0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+183507,int_stack+169857,int_stack+143307,15);
 /*--- compute (g0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+201057,int_stack+183507,int_stack+155007,15);
 /*--- compute (g0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+140187,int_stack+201057,int_stack+122862,15);
 /*--- compute (g0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+221847,int_stack+140187,int_stack+34509,15);
 /*--- compute (g0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+26319,int_stack+24024,int_stack+21984,15);
 /*--- compute (g0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+32439,int_stack+26319,int_stack+0,15);
 /*--- compute (g0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+43239,int_stack+32439,int_stack+5400,15);
 /*--- compute (g0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+0,int_stack+43239,int_stack+169857,15);
 /*--- compute (g0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+20475,int_stack+0,int_stack+183507,15);
 /*--- compute (g0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+163287,int_stack+20475,int_stack+201057,15);
 /*--- compute (g0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+0,int_stack+163287,int_stack+140187,15);
 /*--- compute (g0|ll) ---*/
 hrr3_build_ll(Libint->CD,int_stack+29700,int_stack+0,int_stack+221847,15);
 /*--- compute (fp|ll) ---*/
 hrr1_build_fp(Libint->AB,int_stack+118137,int_stack+29700,int_stack+61437,2025);
 /*--- compute (dd|ll) ---*/
 hrr1_build_dd(Libint->AB,int_stack+0,int_stack+118137,int_stack+81687,2025);
 return int_stack+0;}
