/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_dpmm(Libint_t*, prim_data*);

  /* Computes quartets of (dp|mm) integrals */

REALTYPE *hrr_order_dpmm(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[2][9] = int_stack + 0;
 Libint->vrr_classes[2][10] = int_stack + 330;
 Libint->vrr_classes[2][11] = int_stack + 726;
 Libint->vrr_classes[2][12] = int_stack + 1194;
 Libint->vrr_classes[2][13] = int_stack + 1740;
 Libint->vrr_classes[2][14] = int_stack + 2370;
 Libint->vrr_classes[2][15] = int_stack + 3090;
 Libint->vrr_classes[2][16] = int_stack + 3906;
 Libint->vrr_classes[2][17] = int_stack + 4824;
 Libint->vrr_classes[2][18] = int_stack + 5850;
 Libint->vrr_classes[3][9] = int_stack + 6990;
 Libint->vrr_classes[3][10] = int_stack + 7540;
 Libint->vrr_classes[3][11] = int_stack + 8200;
 Libint->vrr_classes[3][12] = int_stack + 8980;
 Libint->vrr_classes[3][13] = int_stack + 9890;
 Libint->vrr_classes[3][14] = int_stack + 10940;
 Libint->vrr_classes[3][15] = int_stack + 12140;
 Libint->vrr_classes[3][16] = int_stack + 13500;
 Libint->vrr_classes[3][17] = int_stack + 15030;
 Libint->vrr_classes[3][18] = int_stack + 16740;
 memset(int_stack,0,18640*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 18640;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_dpmm(Libint, Data);
   Data++;
 }
 /*--- compute (d0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+18640,int_stack+330,int_stack+0,6);
 /*--- compute (d0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+19630,int_stack+726,int_stack+330,6);
 /*--- compute (d0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+20818,int_stack+19630,int_stack+18640,6);
 /*--- compute (d0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+22798,int_stack+1194,int_stack+726,6);
 /*--- compute (d0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+24202,int_stack+22798,int_stack+19630,6);
 /*--- compute (d0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+26578,int_stack+24202,int_stack+20818,6);
 /*--- compute (d0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+18640,int_stack+1740,int_stack+1194,6);
 /*--- compute (d0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+29878,int_stack+18640,int_stack+22798,6);
 /*--- compute (d0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+32686,int_stack+29878,int_stack+24202,6);
 /*--- compute (d0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+20278,int_stack+32686,int_stack+26578,6);
 /*--- compute (d0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+25228,int_stack+2370,int_stack+1740,6);
 /*--- compute (d0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+36646,int_stack+25228,int_stack+18640,6);
 /*--- compute (d0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+39922,int_stack+36646,int_stack+29878,6);
 /*--- compute (d0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+44602,int_stack+39922,int_stack+32686,6);
 /*--- compute (d0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+27118,int_stack+44602,int_stack+20278,6);
 /*--- compute (d0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+18640,int_stack+3090,int_stack+2370,6);
 /*--- compute (d0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+20800,int_stack+18640,int_stack+25228,6);
 /*--- compute (d0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+50542,int_stack+20800,int_stack+36646,6);
 /*--- compute (d0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+56002,int_stack+50542,int_stack+39922,6);
 /*--- compute (d0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+34048,int_stack+56002,int_stack+44602,6);
 /*--- compute (d0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+63022,int_stack+34048,int_stack+27118,6);
 /*--- compute (d0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+24580,int_stack+3906,int_stack+3090,6);
 /*--- compute (d0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+27028,int_stack+24580,int_stack+18640,6);
 /*--- compute (d0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+42364,int_stack+27028,int_stack+20800,6);
 /*--- compute (d0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+72262,int_stack+42364,int_stack+50542,6);
 /*--- compute (d0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+80452,int_stack+72262,int_stack+56002,6);
 /*--- compute (d0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+48664,int_stack+80452,int_stack+34048,6);
 /*--- compute (d0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+90280,int_stack+48664,int_stack+63022,6);
 /*--- compute (d0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+18640,int_stack+4824,int_stack+3906,6);
 /*--- compute (d0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+31348,int_stack+18640,int_stack+24580,6);
 /*--- compute (d0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+59752,int_stack+31348,int_stack+27028,6);
 /*--- compute (d0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+21394,int_stack+59752,int_stack+42364,6);
 /*--- compute (d0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+36244,int_stack+21394,int_stack+72262,6);
 /*--- compute (d0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+66952,int_stack+36244,int_stack+80452,6);
 /*--- compute (d0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+102160,int_stack+66952,int_stack+48664,6);
 /*--- compute (d0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+116416,int_stack+102160,int_stack+90280,6);
 /*--- compute (d0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+47710,int_stack+5850,int_stack+4824,6);
 /*--- compute (d0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+50788,int_stack+47710,int_stack+18640,6);
 /*--- compute (d0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+80056,int_stack+50788,int_stack+31348,6);
 /*--- compute (d0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+47710,int_stack+80056,int_stack+59752,6);
 /*--- compute (d0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+80056,int_stack+47710,int_stack+21394,6);
 /*--- compute (d0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+47710,int_stack+80056,int_stack+36244,6);
 /*--- compute (d0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+80056,int_stack+47710,int_stack+66952,6);
 /*--- compute (d0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+18640,int_stack+80056,int_stack+102160,6);
 /*--- compute (d0|mm) ---*/
 hrr3_build_mm(Libint->CD,int_stack+36460,int_stack+18640,int_stack+116416,6);
 /*--- compute (f0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+18640,int_stack+7540,int_stack+6990,10);
 /*--- compute (f0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+20290,int_stack+8200,int_stack+7540,10);
 /*--- compute (f0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+22270,int_stack+20290,int_stack+18640,10);
 /*--- compute (f0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+25570,int_stack+8980,int_stack+8200,10);
 /*--- compute (f0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+27910,int_stack+25570,int_stack+20290,10);
 /*--- compute (f0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+54610,int_stack+27910,int_stack+22270,10);
 /*--- compute (f0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+18640,int_stack+9890,int_stack+8980,10);
 /*--- compute (f0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+60110,int_stack+18640,int_stack+25570,10);
 /*--- compute (f0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+64790,int_stack+60110,int_stack+27910,10);
 /*--- compute (f0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+21370,int_stack+64790,int_stack+54610,10);
 /*--- compute (f0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+54610,int_stack+10940,int_stack+9890,10);
 /*--- compute (f0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+29620,int_stack+54610,int_stack+18640,10);
 /*--- compute (f0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+71390,int_stack+29620,int_stack+60110,10);
 /*--- compute (f0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+79190,int_stack+71390,int_stack+64790,10);
 /*--- compute (f0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+57760,int_stack+79190,int_stack+21370,10);
 /*--- compute (f0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+18640,int_stack+12140,int_stack+10940,10);
 /*--- compute (f0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+22240,int_stack+18640,int_stack+54610,10);
 /*--- compute (f0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+89090,int_stack+22240,int_stack+29620,10);
 /*--- compute (f0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+98190,int_stack+89090,int_stack+71390,10);
 /*--- compute (f0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+109890,int_stack+98190,int_stack+79190,10);
 /*--- compute (f0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+69310,int_stack+109890,int_stack+57760,10);
 /*--- compute (f0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+54610,int_stack+13500,int_stack+12140,10);
 /*--- compute (f0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+58690,int_stack+54610,int_stack+18640,10);
 /*--- compute (f0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+0,int_stack+58690,int_stack+22240,10);
 /*--- compute (f0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+18640,int_stack+0,int_stack+89090,10);
 /*--- compute (f0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+123750,int_stack+18640,int_stack+98190,10);
 /*--- compute (f0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+84710,int_stack+123750,int_stack+109890,10);
 /*--- compute (f0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+103190,int_stack+84710,int_stack+69310,10);
 /*--- compute (f0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+65890,int_stack+15030,int_stack+13500,10);
 /*--- compute (f0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+70480,int_stack+65890,int_stack+54610,10);
 /*--- compute (f0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+140130,int_stack+70480,int_stack+58690,10);
 /*--- compute (f0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+152130,int_stack+140130,int_stack+0,10);
 /*--- compute (f0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+167880,int_stack+152130,int_stack+18640,10);
 /*--- compute (f0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+186990,int_stack+167880,int_stack+123750,10);
 /*--- compute (f0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+208830,int_stack+186990,int_stack+84710,10);
 /*--- compute (f0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+232590,int_stack+208830,int_stack+103190,10);
 /*--- compute (f0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+18640,int_stack+16740,int_stack+15030,10);
 /*--- compute (f0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+23770,int_stack+18640,int_stack+65890,10);
 /*--- compute (f0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+0,int_stack+23770,int_stack+70480,10);
 /*--- compute (f0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+13600,int_stack+0,int_stack+140130,10);
 /*--- compute (f0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+54610,int_stack+13600,int_stack+152130,10);
 /*--- compute (f0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+0,int_stack+54610,int_stack+167880,10);
 /*--- compute (f0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+54610,int_stack+0,int_stack+186990,10);
 /*--- compute (f0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+0,int_stack+54610,int_stack+208830,10);
 /*--- compute (f0|mm) ---*/
 hrr3_build_mm(Libint->CD,int_stack+54610,int_stack+0,int_stack+232590,10);
 /*--- compute (dp|mm) ---*/
 hrr1_build_dp(Libint->AB,int_stack+84860,int_stack+54610,int_stack+36460,3025);
 return int_stack+84860;}
