/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_f0li(Libint_t*, prim_data*);

  /* Computes quartets of (f0|li) integrals */

REALTYPE *hrr_order_f0li(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[3][8] = int_stack + 0;
 Libint->vrr_classes[3][9] = int_stack + 450;
 Libint->vrr_classes[3][10] = int_stack + 1000;
 Libint->vrr_classes[3][11] = int_stack + 1660;
 Libint->vrr_classes[3][12] = int_stack + 2440;
 Libint->vrr_classes[3][13] = int_stack + 3350;
 Libint->vrr_classes[3][14] = int_stack + 4400;
 memset(int_stack,0,5600*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 5600;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_f0li(Libint, Data);
   Data++;
 }
 /*--- compute (f0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+5600,int_stack+450,int_stack+0,10);
 /*--- compute (f0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+6950,int_stack+1000,int_stack+450,10);
 /*--- compute (f0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+8600,int_stack+6950,int_stack+5600,10);
 /*--- compute (f0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+11300,int_stack+1660,int_stack+1000,10);
 /*--- compute (f0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+13280,int_stack+11300,int_stack+6950,10);
 /*--- compute (f0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+16580,int_stack+13280,int_stack+8600,10);
 /*--- compute (f0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+5600,int_stack+2440,int_stack+1660,10);
 /*--- compute (f0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+21080,int_stack+5600,int_stack+11300,10);
 /*--- compute (f0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+25040,int_stack+21080,int_stack+13280,10);
 /*--- compute (f0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+7940,int_stack+25040,int_stack+16580,10);
 /*--- compute (f0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+14690,int_stack+3350,int_stack+2440,10);
 /*--- compute (f0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+30540,int_stack+14690,int_stack+5600,10);
 /*--- compute (f0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+35220,int_stack+30540,int_stack+21080,10);
 /*--- compute (f0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+41820,int_stack+35220,int_stack+25040,10);
 /*--- compute (f0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+17420,int_stack+41820,int_stack+7940,10);
 /*--- compute (f0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+5600,int_stack+4400,int_stack+3350,10);
 /*--- compute (f0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+8750,int_stack+5600,int_stack+14690,10);
 /*--- compute (f0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+0,int_stack+8750,int_stack+30540,10);
 /*--- compute (f0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+50070,int_stack+0,int_stack+35220,10);
 /*--- compute (f0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+0,int_stack+50070,int_stack+41820,10);
 /*--- compute (f0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+26870,int_stack+0,int_stack+17420,10);
 return int_stack+26870;}
