/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_fdkh(Libint_t*, prim_data*);

  /* Computes quartets of (fd|kh) integrals */

REALTYPE *hrr_order_fdkh(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[3][7] = int_stack + 0;
 Libint->vrr_classes[3][8] = int_stack + 360;
 Libint->vrr_classes[3][9] = int_stack + 810;
 Libint->vrr_classes[3][10] = int_stack + 1360;
 Libint->vrr_classes[3][11] = int_stack + 2020;
 Libint->vrr_classes[3][12] = int_stack + 2800;
 Libint->vrr_classes[4][7] = int_stack + 3710;
 Libint->vrr_classes[4][8] = int_stack + 4250;
 Libint->vrr_classes[4][9] = int_stack + 4925;
 Libint->vrr_classes[4][10] = int_stack + 5750;
 Libint->vrr_classes[4][11] = int_stack + 6740;
 Libint->vrr_classes[4][12] = int_stack + 7910;
 Libint->vrr_classes[5][7] = int_stack + 9275;
 Libint->vrr_classes[5][8] = int_stack + 10031;
 Libint->vrr_classes[5][9] = int_stack + 10976;
 Libint->vrr_classes[5][10] = int_stack + 12131;
 Libint->vrr_classes[5][11] = int_stack + 13517;
 Libint->vrr_classes[5][12] = int_stack + 15155;
 memset(int_stack,0,17066*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 17066;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_fdkh(Libint, Data);
   Data++;
 }
 /*--- compute (f0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+17066,int_stack+360,int_stack+0,10);
 /*--- compute (f0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+18146,int_stack+810,int_stack+360,10);
 /*--- compute (f0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+19496,int_stack+18146,int_stack+17066,10);
 /*--- compute (f0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+21656,int_stack+1360,int_stack+810,10);
 /*--- compute (f0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+23306,int_stack+21656,int_stack+18146,10);
 /*--- compute (f0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+26006,int_stack+23306,int_stack+19496,10);
 /*--- compute (f0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+17066,int_stack+2020,int_stack+1360,10);
 /*--- compute (f0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+29606,int_stack+17066,int_stack+21656,10);
 /*--- compute (f0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+32906,int_stack+29606,int_stack+23306,10);
 /*--- compute (f0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+19046,int_stack+32906,int_stack+26006,10);
 /*--- compute (f0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+24446,int_stack+2800,int_stack+2020,10);
 /*--- compute (f0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+37406,int_stack+24446,int_stack+17066,10);
 /*--- compute (f0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+41366,int_stack+37406,int_stack+29606,10);
 /*--- compute (f0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+24446,int_stack+41366,int_stack+32906,10);
 /*--- compute (f0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+31196,int_stack+24446,int_stack+19046,10);
 /*--- compute (g0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+17066,int_stack+4250,int_stack+3710,15);
 /*--- compute (g0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+18686,int_stack+4925,int_stack+4250,15);
 /*--- compute (g0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+20711,int_stack+18686,int_stack+17066,15);
 /*--- compute (g0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+23951,int_stack+5750,int_stack+4925,15);
 /*--- compute (g0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+26426,int_stack+23951,int_stack+18686,15);
 /*--- compute (g0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+38756,int_stack+26426,int_stack+20711,15);
 /*--- compute (g0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+17066,int_stack+6740,int_stack+5750,15);
 /*--- compute (g0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+0,int_stack+17066,int_stack+23951,15);
 /*--- compute (g0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+44156,int_stack+0,int_stack+26426,15);
 /*--- compute (g0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+20036,int_stack+44156,int_stack+38756,15);
 /*--- compute (g0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+38756,int_stack+7910,int_stack+6740,15);
 /*--- compute (g0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+50906,int_stack+38756,int_stack+17066,15);
 /*--- compute (g0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+56846,int_stack+50906,int_stack+0,15);
 /*--- compute (g0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+65096,int_stack+56846,int_stack+44156,15);
 /*--- compute (g0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+38756,int_stack+65096,int_stack+20036,15);
 /*--- compute (fp|kh) ---*/
 hrr1_build_fp(Libint->AB,int_stack+50096,int_stack+38756,int_stack+31196,756);
 /*--- compute (h0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+0,int_stack+10031,int_stack+9275,21);
 /*--- compute (h0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+2268,int_stack+10976,int_stack+10031,21);
 /*--- compute (h0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+5103,int_stack+2268,int_stack+0,21);
 /*--- compute (h0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+17066,int_stack+12131,int_stack+10976,21);
 /*--- compute (h0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+20531,int_stack+17066,int_stack+2268,21);
 /*--- compute (h0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+26201,int_stack+20531,int_stack+5103,21);
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+13517,int_stack+12131,21);
 /*--- compute (h0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+4158,int_stack+0,int_stack+17066,21);
 /*--- compute (h0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+72776,int_stack+4158,int_stack+20531,21);
 /*--- compute (h0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+82226,int_stack+72776,int_stack+26201,21);
 /*--- compute (h0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+17066,int_stack+15155,int_stack+13517,21);
 /*--- compute (h0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+21980,int_stack+17066,int_stack+0,21);
 /*--- compute (h0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+93566,int_stack+21980,int_stack+4158,21);
 /*--- compute (h0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+0,int_stack+93566,int_stack+72776,21);
 /*--- compute (h0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+14175,int_stack+0,int_stack+82226,21);
 /*--- compute (gp|kh) ---*/
 hrr1_build_gp(Libint->AB,int_stack+72776,int_stack+14175,int_stack+38756,756);
 /*--- compute (fd|kh) ---*/
 hrr1_build_fd(Libint->AB,int_stack+0,int_stack+72776,int_stack+50096,756);
 return int_stack+0;}
