/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_ffnk(Libint_t*, prim_data*);

  /* Computes quartets of (ff|nk) integrals */

REALTYPE *hrr_order_ffnk(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[3][10] = int_stack + 0;
 Libint->vrr_classes[3][11] = int_stack + 660;
 Libint->vrr_classes[3][12] = int_stack + 1440;
 Libint->vrr_classes[3][13] = int_stack + 2350;
 Libint->vrr_classes[3][14] = int_stack + 3400;
 Libint->vrr_classes[3][15] = int_stack + 4600;
 Libint->vrr_classes[3][16] = int_stack + 5960;
 Libint->vrr_classes[3][17] = int_stack + 7490;
 Libint->vrr_classes[4][10] = int_stack + 9200;
 Libint->vrr_classes[4][11] = int_stack + 10190;
 Libint->vrr_classes[4][12] = int_stack + 11360;
 Libint->vrr_classes[4][13] = int_stack + 12725;
 Libint->vrr_classes[4][14] = int_stack + 14300;
 Libint->vrr_classes[4][15] = int_stack + 16100;
 Libint->vrr_classes[4][16] = int_stack + 18140;
 Libint->vrr_classes[4][17] = int_stack + 20435;
 Libint->vrr_classes[5][10] = int_stack + 23000;
 Libint->vrr_classes[5][11] = int_stack + 24386;
 Libint->vrr_classes[5][12] = int_stack + 26024;
 Libint->vrr_classes[5][13] = int_stack + 27935;
 Libint->vrr_classes[5][14] = int_stack + 30140;
 Libint->vrr_classes[5][15] = int_stack + 32660;
 Libint->vrr_classes[5][16] = int_stack + 35516;
 Libint->vrr_classes[5][17] = int_stack + 38729;
 Libint->vrr_classes[6][10] = int_stack + 42320;
 Libint->vrr_classes[6][11] = int_stack + 44168;
 Libint->vrr_classes[6][12] = int_stack + 46352;
 Libint->vrr_classes[6][13] = int_stack + 48900;
 Libint->vrr_classes[6][14] = int_stack + 51840;
 Libint->vrr_classes[6][15] = int_stack + 55200;
 Libint->vrr_classes[6][16] = int_stack + 59008;
 Libint->vrr_classes[6][17] = int_stack + 63292;
 memset(int_stack,0,68080*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 68080;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_ffnk(Libint, Data);
   Data++;
 }
 /*--- compute (f0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+68080,int_stack+660,int_stack+0,10);
 /*--- compute (f0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+70060,int_stack+1440,int_stack+660,10);
 /*--- compute (f0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+72400,int_stack+70060,int_stack+68080,10);
 /*--- compute (f0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+76360,int_stack+2350,int_stack+1440,10);
 /*--- compute (f0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+79090,int_stack+76360,int_stack+70060,10);
 /*--- compute (f0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+83770,int_stack+79090,int_stack+72400,10);
 /*--- compute (f0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+68080,int_stack+3400,int_stack+2350,10);
 /*--- compute (f0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+90370,int_stack+68080,int_stack+76360,10);
 /*--- compute (f0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+71230,int_stack+90370,int_stack+79090,10);
 /*--- compute (f0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+95830,int_stack+71230,int_stack+83770,10);
 /*--- compute (f0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+79030,int_stack+4600,int_stack+3400,10);
 /*--- compute (f0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+82630,int_stack+79030,int_stack+68080,10);
 /*--- compute (f0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+105730,int_stack+82630,int_stack+90370,10);
 /*--- compute (f0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+114830,int_stack+105730,int_stack+71230,10);
 /*--- compute (f0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+126530,int_stack+114830,int_stack+95830,10);
 /*--- compute (f0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+68080,int_stack+5960,int_stack+4600,10);
 /*--- compute (f0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+88930,int_stack+68080,int_stack+79030,10);
 /*--- compute (f0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+140390,int_stack+88930,int_stack+82630,10);
 /*--- compute (f0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+72160,int_stack+140390,int_stack+105730,10);
 /*--- compute (f0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+96130,int_stack+72160,int_stack+114830,10);
 /*--- compute (f0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+150890,int_stack+96130,int_stack+126530,10);
 /*--- compute (f0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+112510,int_stack+7490,int_stack+5960,10);
 /*--- compute (f0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+117100,int_stack+112510,int_stack+68080,10);
 /*--- compute (f0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+125260,int_stack+117100,int_stack+88930,10);
 /*--- compute (f0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+169370,int_stack+125260,int_stack+140390,10);
 /*--- compute (f0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+112510,int_stack+169370,int_stack+72160,10);
 /*--- compute (f0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+68080,int_stack+112510,int_stack+96130,10);
 /*--- compute (f0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+89920,int_stack+68080,int_stack+150890,10);
 /*--- compute (g0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+68080,int_stack+10190,int_stack+9200,15);
 /*--- compute (g0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+71050,int_stack+11360,int_stack+10190,15);
 /*--- compute (g0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+74560,int_stack+71050,int_stack+68080,15);
 /*--- compute (g0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+80500,int_stack+12725,int_stack+11360,15);
 /*--- compute (g0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+113680,int_stack+80500,int_stack+71050,15);
 /*--- compute (g0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+120700,int_stack+113680,int_stack+74560,15);
 /*--- compute (g0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+68080,int_stack+14300,int_stack+12725,15);
 /*--- compute (g0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+130600,int_stack+68080,int_stack+80500,15);
 /*--- compute (g0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+72805,int_stack+130600,int_stack+113680,15);
 /*--- compute (g0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+138790,int_stack+72805,int_stack+120700,15);
 /*--- compute (g0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+113680,int_stack+16100,int_stack+14300,15);
 /*--- compute (g0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+119080,int_stack+113680,int_stack+68080,15);
 /*--- compute (g0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+153640,int_stack+119080,int_stack+130600,15);
 /*--- compute (g0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+167290,int_stack+153640,int_stack+72805,15);
 /*--- compute (g0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+68080,int_stack+167290,int_stack+138790,15);
 /*--- compute (g0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+128530,int_stack+18140,int_stack+16100,15);
 /*--- compute (g0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+134650,int_stack+128530,int_stack+113680,15);
 /*--- compute (g0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+0,int_stack+134650,int_stack+119080,15);
 /*--- compute (g0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+184840,int_stack+0,int_stack+153640,15);
 /*--- compute (g0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+205315,int_stack+184840,int_stack+167290,15);
 /*--- compute (g0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+145450,int_stack+205315,int_stack+68080,15);
 /*--- compute (g0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+68080,int_stack+20435,int_stack+18140,15);
 /*--- compute (g0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+74965,int_stack+68080,int_stack+128530,15);
 /*--- compute (g0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+113680,int_stack+74965,int_stack+134650,15);
 /*--- compute (g0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+229885,int_stack+113680,int_stack+0,15);
 /*--- compute (g0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+113680,int_stack+229885,int_stack+184840,15);
 /*--- compute (g0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+229885,int_stack+113680,int_stack+205315,15);
 /*--- compute (g0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+173170,int_stack+229885,int_stack+145450,15);
 /*--- compute (fp|nk) ---*/
 hrr1_build_fp(Libint->AB,int_stack+208810,int_stack+173170,int_stack+89920,2376);
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+24386,int_stack+23000,21);
 /*--- compute (h0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+4158,int_stack+26024,int_stack+24386,21);
 /*--- compute (h0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+9072,int_stack+4158,int_stack+0,21);
 /*--- compute (h0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+17388,int_stack+27935,int_stack+26024,21);
 /*--- compute (h0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+68080,int_stack+17388,int_stack+4158,21);
 /*--- compute (h0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+77908,int_stack+68080,int_stack+9072,21);
 /*--- compute (h0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+30140,int_stack+27935,21);
 /*--- compute (h0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+91768,int_stack+0,int_stack+17388,21);
 /*--- compute (h0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+6615,int_stack+91768,int_stack+68080,21);
 /*--- compute (h0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+103234,int_stack+6615,int_stack+77908,21);
 /*--- compute (h0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+68080,int_stack+32660,int_stack+30140,21);
 /*--- compute (h0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+75640,int_stack+68080,int_stack+0,21);
 /*--- compute (h0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+124024,int_stack+75640,int_stack+91768,21);
 /*--- compute (h0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+143134,int_stack+124024,int_stack+6615,21);
 /*--- compute (h0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+0,int_stack+143134,int_stack+103234,21);
 /*--- compute (h0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+88870,int_stack+35516,int_stack+32660,21);
 /*--- compute (h0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+97438,int_stack+88870,int_stack+68080,21);
 /*--- compute (h0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+280090,int_stack+97438,int_stack+75640,21);
 /*--- compute (h0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+302140,int_stack+280090,int_stack+124024,21);
 /*--- compute (h0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+330805,int_stack+302140,int_stack+143134,21);
 /*--- compute (h0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+112558,int_stack+330805,int_stack+0,21);
 /*--- compute (h0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+0,int_stack+38729,int_stack+35516,21);
 /*--- compute (h0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+9639,int_stack+0,int_stack+88870,21);
 /*--- compute (h0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+68080,int_stack+9639,int_stack+97438,21);
 /*--- compute (h0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+0,int_stack+68080,int_stack+280090,21);
 /*--- compute (h0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+68080,int_stack+0,int_stack+302140,21);
 /*--- compute (h0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+280090,int_stack+68080,int_stack+330805,21);
 /*--- compute (h0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+325954,int_stack+280090,int_stack+112558,21);
 /*--- compute (gp|nk) ---*/
 hrr1_build_gp(Libint->AB,int_stack+375850,int_stack+325954,int_stack+173170,2376);
 /*--- compute (fd|nk) ---*/
 hrr1_build_fd(Libint->AB,int_stack+482770,int_stack+375850,int_stack+208810,2376);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+68080,int_stack+44168,int_stack+42320,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+73624,int_stack+46352,int_stack+44168,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+80176,int_stack+73624,int_stack+68080,28);
 /*--- compute (i0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+91264,int_stack+48900,int_stack+46352,28);
 /*--- compute (i0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+98908,int_stack+91264,int_stack+73624,28);
 /*--- compute (i0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+112012,int_stack+98908,int_stack+80176,28);
 /*--- compute (i0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+68080,int_stack+51840,int_stack+48900,28);
 /*--- compute (i0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+130492,int_stack+68080,int_stack+91264,28);
 /*--- compute (i0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+76900,int_stack+130492,int_stack+98908,28);
 /*--- compute (i0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+145780,int_stack+76900,int_stack+112012,28);
 /*--- compute (i0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+98740,int_stack+55200,int_stack+51840,28);
 /*--- compute (i0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+108820,int_stack+98740,int_stack+68080,28);
 /*--- compute (i0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+173500,int_stack+108820,int_stack+130492,28);
 /*--- compute (i0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+198980,int_stack+173500,int_stack+76900,28);
 /*--- compute (i0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+231740,int_stack+198980,int_stack+145780,28);
 /*--- compute (i0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+68080,int_stack+59008,int_stack+55200,28);
 /*--- compute (i0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+126460,int_stack+68080,int_stack+98740,28);
 /*--- compute (i0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+270548,int_stack+126460,int_stack+108820,28);
 /*--- compute (i0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+79504,int_stack+270548,int_stack+173500,28);
 /*--- compute (i0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+146620,int_stack+79504,int_stack+198980,28);
 /*--- compute (i0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+0,int_stack+146620,int_stack+231740,28);
 /*--- compute (i0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+192484,int_stack+63292,int_stack+59008,28);
 /*--- compute (i0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+205336,int_stack+192484,int_stack+68080,28);
 /*--- compute (i0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+228184,int_stack+205336,int_stack+126460,28);
 /*--- compute (i0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+625330,int_stack+228184,int_stack+270548,28);
 /*--- compute (i0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+192484,int_stack+625330,int_stack+79504,28);
 /*--- compute (i0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+245992,int_stack+192484,int_stack+146620,28);
 /*--- compute (i0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+51744,int_stack+245992,int_stack+0,28);
 /*--- compute (hp|nk) ---*/
 hrr1_build_hp(Libint->AB,int_stack+118272,int_stack+51744,int_stack+325954,2376);
 /*--- compute (gd|nk) ---*/
 hrr1_build_gd(Libint->AB,int_stack+625330,int_stack+118272,int_stack+375850,2376);
 /*--- compute (ff|nk) ---*/
 hrr1_build_ff(Libint->AB,int_stack+0,int_stack+625330,int_stack+482770,2376);
 return int_stack+0;}
