/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_gdki(Libint_t*, prim_data*);

  /* Computes quartets of (gd|ki) integrals */

REALTYPE *hrr_order_gdki(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[4][7] = int_stack + 0;
 Libint->vrr_classes[4][8] = int_stack + 540;
 Libint->vrr_classes[4][9] = int_stack + 1215;
 Libint->vrr_classes[4][10] = int_stack + 2040;
 Libint->vrr_classes[4][11] = int_stack + 3030;
 Libint->vrr_classes[4][12] = int_stack + 4200;
 Libint->vrr_classes[4][13] = int_stack + 5565;
 Libint->vrr_classes[5][7] = int_stack + 7140;
 Libint->vrr_classes[5][8] = int_stack + 7896;
 Libint->vrr_classes[5][9] = int_stack + 8841;
 Libint->vrr_classes[5][10] = int_stack + 9996;
 Libint->vrr_classes[5][11] = int_stack + 11382;
 Libint->vrr_classes[5][12] = int_stack + 13020;
 Libint->vrr_classes[5][13] = int_stack + 14931;
 Libint->vrr_classes[6][7] = int_stack + 17136;
 Libint->vrr_classes[6][8] = int_stack + 18144;
 Libint->vrr_classes[6][9] = int_stack + 19404;
 Libint->vrr_classes[6][10] = int_stack + 20944;
 Libint->vrr_classes[6][11] = int_stack + 22792;
 Libint->vrr_classes[6][12] = int_stack + 24976;
 Libint->vrr_classes[6][13] = int_stack + 27524;
 memset(int_stack,0,30464*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 30464;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_gdki(Libint, Data);
   Data++;
 }
 /*--- compute (g0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+30464,int_stack+540,int_stack+0,15);
 /*--- compute (g0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+32084,int_stack+1215,int_stack+540,15);
 /*--- compute (g0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+34109,int_stack+32084,int_stack+30464,15);
 /*--- compute (g0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+37349,int_stack+2040,int_stack+1215,15);
 /*--- compute (g0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+39824,int_stack+37349,int_stack+32084,15);
 /*--- compute (g0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+43874,int_stack+39824,int_stack+34109,15);
 /*--- compute (g0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+30464,int_stack+3030,int_stack+2040,15);
 /*--- compute (g0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+49274,int_stack+30464,int_stack+37349,15);
 /*--- compute (g0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+54224,int_stack+49274,int_stack+39824,15);
 /*--- compute (g0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+33434,int_stack+54224,int_stack+43874,15);
 /*--- compute (g0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+41534,int_stack+4200,int_stack+3030,15);
 /*--- compute (g0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+60974,int_stack+41534,int_stack+30464,15);
 /*--- compute (g0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+66914,int_stack+60974,int_stack+49274,15);
 /*--- compute (g0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+75164,int_stack+66914,int_stack+54224,15);
 /*--- compute (g0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+45044,int_stack+75164,int_stack+33434,15);
 /*--- compute (g0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+30464,int_stack+5565,int_stack+4200,15);
 /*--- compute (g0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+0,int_stack+30464,int_stack+41534,15);
 /*--- compute (g0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+30464,int_stack+0,int_stack+60974,15);
 /*--- compute (g0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+85289,int_stack+30464,int_stack+66914,15);
 /*--- compute (g0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+30464,int_stack+85289,int_stack+75164,15);
 /*--- compute (g0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+56384,int_stack+30464,int_stack+45044,15);
 /*--- compute (h0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+30464,int_stack+7896,int_stack+7140,21);
 /*--- compute (h0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+32732,int_stack+8841,int_stack+7896,21);
 /*--- compute (h0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+35567,int_stack+32732,int_stack+30464,21);
 /*--- compute (h0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+40103,int_stack+9996,int_stack+8841,21);
 /*--- compute (h0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+43568,int_stack+40103,int_stack+32732,21);
 /*--- compute (h0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+0,int_stack+43568,int_stack+35567,21);
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+30464,int_stack+11382,int_stack+9996,21);
 /*--- compute (h0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+49238,int_stack+30464,int_stack+40103,21);
 /*--- compute (h0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+71504,int_stack+49238,int_stack+43568,21);
 /*--- compute (h0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+34622,int_stack+71504,int_stack+0,21);
 /*--- compute (h0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+0,int_stack+13020,int_stack+11382,21);
 /*--- compute (h0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+80954,int_stack+0,int_stack+30464,21);
 /*--- compute (h0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+89270,int_stack+80954,int_stack+49238,21);
 /*--- compute (h0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+100820,int_stack+89270,int_stack+71504,21);
 /*--- compute (h0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+114995,int_stack+100820,int_stack+34622,21);
 /*--- compute (h0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+71504,int_stack+14931,int_stack+13020,21);
 /*--- compute (h0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+30464,int_stack+71504,int_stack+0,21);
 /*--- compute (h0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+0,int_stack+30464,int_stack+80954,21);
 /*--- compute (h0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+30464,int_stack+0,int_stack+89270,21);
 /*--- compute (h0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+71504,int_stack+30464,int_stack+100820,21);
 /*--- compute (h0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+30464,int_stack+71504,int_stack+114995,21);
 /*--- compute (gp|ki) ---*/
 hrr1_build_gp(Libint->AB,int_stack+71504,int_stack+30464,int_stack+56384,1008);
 /*--- compute (i0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+116864,int_stack+18144,int_stack+17136,28);
 /*--- compute (i0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+119888,int_stack+19404,int_stack+18144,28);
 /*--- compute (i0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+123668,int_stack+119888,int_stack+116864,28);
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+51632,int_stack+20944,int_stack+19404,28);
 /*--- compute (i0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+56252,int_stack+51632,int_stack+119888,28);
 /*--- compute (i0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+0,int_stack+56252,int_stack+123668,28);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+116864,int_stack+22792,int_stack+20944,28);
 /*--- compute (i0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+10080,int_stack+116864,int_stack+51632,28);
 /*--- compute (i0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+122408,int_stack+10080,int_stack+56252,28);
 /*--- compute (i0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+51632,int_stack+122408,int_stack+0,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+0,int_stack+24976,int_stack+22792,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+135008,int_stack+0,int_stack+116864,28);
 /*--- compute (i0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+146096,int_stack+135008,int_stack+10080,28);
 /*--- compute (i0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+161496,int_stack+146096,int_stack+122408,28);
 /*--- compute (i0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+180396,int_stack+161496,int_stack+51632,28);
 /*--- compute (i0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+51632,int_stack+27524,int_stack+24976,28);
 /*--- compute (i0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+116864,int_stack+51632,int_stack+0,28);
 /*--- compute (i0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+0,int_stack+116864,int_stack+135008,28);
 /*--- compute (i0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+116864,int_stack+0,int_stack+146096,28);
 /*--- compute (i0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+0,int_stack+116864,int_stack+161496,28);
 /*--- compute (i0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+116864,int_stack+0,int_stack+180396,28);
 /*--- compute (hp|ki) ---*/
 hrr1_build_hp(Libint->AB,int_stack+145088,int_stack+116864,int_stack+30464,1008);
 /*--- compute (gd|ki) ---*/
 hrr1_build_gd(Libint->AB,int_stack+208592,int_stack+145088,int_stack+71504,1008);
 return int_stack+208592;}
