/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_gdmf(Libint_t*, prim_data*);

  /* Computes quartets of (gd|mf) integrals */

REALTYPE *hrr_order_gdmf(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[4][9] = int_stack + 0;
 Libint->vrr_classes[4][10] = int_stack + 825;
 Libint->vrr_classes[4][11] = int_stack + 1815;
 Libint->vrr_classes[4][12] = int_stack + 2985;
 Libint->vrr_classes[5][9] = int_stack + 4350;
 Libint->vrr_classes[5][10] = int_stack + 5505;
 Libint->vrr_classes[5][11] = int_stack + 6891;
 Libint->vrr_classes[5][12] = int_stack + 8529;
 Libint->vrr_classes[6][9] = int_stack + 10440;
 Libint->vrr_classes[6][10] = int_stack + 11980;
 Libint->vrr_classes[6][11] = int_stack + 13828;
 Libint->vrr_classes[6][12] = int_stack + 16012;
 memset(int_stack,0,18560*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 18560;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_gdmf(Libint, Data);
   Data++;
 }
 /*--- compute (g0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+18560,int_stack+825,int_stack+0,15);
 /*--- compute (g0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+21035,int_stack+1815,int_stack+825,15);
 /*--- compute (g0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+24005,int_stack+21035,int_stack+18560,15);
 /*--- compute (g0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+28955,int_stack+2985,int_stack+1815,15);
 /*--- compute (g0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+32465,int_stack+28955,int_stack+21035,15);
 /*--- compute (g0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+38405,int_stack+32465,int_stack+24005,15);
 /*--- compute (h0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+18560,int_stack+5505,int_stack+4350,21);
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+22025,int_stack+6891,int_stack+5505,21);
 /*--- compute (h0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+26183,int_stack+22025,int_stack+18560,21);
 /*--- compute (h0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+33113,int_stack+8529,int_stack+6891,21);
 /*--- compute (h0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+0,int_stack+33113,int_stack+22025,21);
 /*--- compute (h0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+46655,int_stack+0,int_stack+26183,21);
 /*--- compute (gp|mf) ---*/
 hrr1_build_gp(Libint->AB,int_stack+58205,int_stack+46655,int_stack+38405,550);
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+0,int_stack+11980,int_stack+10440,28);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+4620,int_stack+13828,int_stack+11980,28);
 /*--- compute (i0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+18560,int_stack+4620,int_stack+0,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+27800,int_stack+16012,int_stack+13828,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+34352,int_stack+27800,int_stack+4620,28);
 /*--- compute (i0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+0,int_stack+34352,int_stack+18560,28);
 /*--- compute (hp|mf) ---*/
 hrr1_build_hp(Libint->AB,int_stack+82955,int_stack+0,int_stack+46655,550);
 /*--- compute (gd|mf) ---*/
 hrr1_build_gd(Libint->AB,int_stack+0,int_stack+82955,int_stack+58205,550);
 return int_stack+0;}
