/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_gdmk(Libint_t*, prim_data*);

  /* Computes quartets of (gd|mk) integrals */

REALTYPE *hrr_order_gdmk(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[4][9] = int_stack + 0;
 Libint->vrr_classes[4][10] = int_stack + 825;
 Libint->vrr_classes[4][11] = int_stack + 1815;
 Libint->vrr_classes[4][12] = int_stack + 2985;
 Libint->vrr_classes[4][13] = int_stack + 4350;
 Libint->vrr_classes[4][14] = int_stack + 5925;
 Libint->vrr_classes[4][15] = int_stack + 7725;
 Libint->vrr_classes[4][16] = int_stack + 9765;
 Libint->vrr_classes[5][9] = int_stack + 12060;
 Libint->vrr_classes[5][10] = int_stack + 13215;
 Libint->vrr_classes[5][11] = int_stack + 14601;
 Libint->vrr_classes[5][12] = int_stack + 16239;
 Libint->vrr_classes[5][13] = int_stack + 18150;
 Libint->vrr_classes[5][14] = int_stack + 20355;
 Libint->vrr_classes[5][15] = int_stack + 22875;
 Libint->vrr_classes[5][16] = int_stack + 25731;
 Libint->vrr_classes[6][9] = int_stack + 28944;
 Libint->vrr_classes[6][10] = int_stack + 30484;
 Libint->vrr_classes[6][11] = int_stack + 32332;
 Libint->vrr_classes[6][12] = int_stack + 34516;
 Libint->vrr_classes[6][13] = int_stack + 37064;
 Libint->vrr_classes[6][14] = int_stack + 40004;
 Libint->vrr_classes[6][15] = int_stack + 43364;
 Libint->vrr_classes[6][16] = int_stack + 47172;
 memset(int_stack,0,51456*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 51456;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_gdmk(Libint, Data);
   Data++;
 }
 /*--- compute (g0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+51456,int_stack+825,int_stack+0,15);
 /*--- compute (g0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+53931,int_stack+1815,int_stack+825,15);
 /*--- compute (g0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+56901,int_stack+53931,int_stack+51456,15);
 /*--- compute (g0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+61851,int_stack+2985,int_stack+1815,15);
 /*--- compute (g0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+65361,int_stack+61851,int_stack+53931,15);
 /*--- compute (g0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+71301,int_stack+65361,int_stack+56901,15);
 /*--- compute (g0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+51456,int_stack+4350,int_stack+2985,15);
 /*--- compute (g0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+79551,int_stack+51456,int_stack+61851,15);
 /*--- compute (g0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+86571,int_stack+79551,int_stack+65361,15);
 /*--- compute (g0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+55551,int_stack+86571,int_stack+71301,15);
 /*--- compute (g0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+67926,int_stack+5925,int_stack+4350,15);
 /*--- compute (g0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+96471,int_stack+67926,int_stack+51456,15);
 /*--- compute (g0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+104661,int_stack+96471,int_stack+79551,15);
 /*--- compute (g0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+116361,int_stack+104661,int_stack+86571,15);
 /*--- compute (g0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+72651,int_stack+116361,int_stack+55551,15);
 /*--- compute (g0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+51456,int_stack+7725,int_stack+5925,15);
 /*--- compute (g0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+56856,int_stack+51456,int_stack+67926,15);
 /*--- compute (g0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+131211,int_stack+56856,int_stack+96471,15);
 /*--- compute (g0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+144861,int_stack+131211,int_stack+104661,15);
 /*--- compute (g0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+89976,int_stack+144861,int_stack+116361,15);
 /*--- compute (g0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+162411,int_stack+89976,int_stack+72651,15);
 /*--- compute (g0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+66306,int_stack+9765,int_stack+7725,15);
 /*--- compute (g0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+72426,int_stack+66306,int_stack+51456,15);
 /*--- compute (g0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+110766,int_stack+72426,int_stack+56856,15);
 /*--- compute (g0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+51456,int_stack+110766,int_stack+131211,15);
 /*--- compute (g0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+110766,int_stack+51456,int_stack+144861,15);
 /*--- compute (g0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+51456,int_stack+110766,int_stack+89976,15);
 /*--- compute (g0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+79176,int_stack+51456,int_stack+162411,15);
 /*--- compute (h0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+51456,int_stack+13215,int_stack+12060,21);
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+54921,int_stack+14601,int_stack+13215,21);
 /*--- compute (h0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+59079,int_stack+54921,int_stack+51456,21);
 /*--- compute (h0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+66009,int_stack+16239,int_stack+14601,21);
 /*--- compute (h0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+108876,int_stack+66009,int_stack+54921,21);
 /*--- compute (h0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+117192,int_stack+108876,int_stack+59079,21);
 /*--- compute (h0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+51456,int_stack+18150,int_stack+16239,21);
 /*--- compute (h0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+128742,int_stack+51456,int_stack+66009,21);
 /*--- compute (h0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+57189,int_stack+128742,int_stack+108876,21);
 /*--- compute (h0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+138570,int_stack+57189,int_stack+117192,21);
 /*--- compute (h0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+108876,int_stack+20355,int_stack+18150,21);
 /*--- compute (h0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+115491,int_stack+108876,int_stack+51456,21);
 /*--- compute (h0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+155895,int_stack+115491,int_stack+128742,21);
 /*--- compute (h0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+172275,int_stack+155895,int_stack+57189,21);
 /*--- compute (h0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+51456,int_stack+172275,int_stack+138570,21);
 /*--- compute (h0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+126957,int_stack+22875,int_stack+20355,21);
 /*--- compute (h0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+134517,int_stack+126957,int_stack+108876,21);
 /*--- compute (h0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+0,int_stack+134517,int_stack+115491,21);
 /*--- compute (h0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+193065,int_stack+0,int_stack+155895,21);
 /*--- compute (h0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+217635,int_stack+193065,int_stack+172275,21);
 /*--- compute (h0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+147747,int_stack+217635,int_stack+51456,21);
 /*--- compute (h0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+51456,int_stack+25731,int_stack+22875,21);
 /*--- compute (h0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+60024,int_stack+51456,int_stack+126957,21);
 /*--- compute (h0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+108876,int_stack+60024,int_stack+134517,21);
 /*--- compute (h0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+246741,int_stack+108876,int_stack+0,21);
 /*--- compute (h0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+108876,int_stack+246741,int_stack+193065,21);
 /*--- compute (h0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+246741,int_stack+108876,int_stack+217635,21);
 /*--- compute (h0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+180087,int_stack+246741,int_stack+147747,21);
 /*--- compute (gp|mk) ---*/
 hrr1_build_gp(Libint->AB,int_stack+221667,int_stack+180087,int_stack+79176,1980);
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+0,int_stack+30484,int_stack+28944,28);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+4620,int_stack+32332,int_stack+30484,28);
 /*--- compute (i0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+10164,int_stack+4620,int_stack+0,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+19404,int_stack+34516,int_stack+32332,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+51456,int_stack+19404,int_stack+4620,28);
 /*--- compute (i0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+62544,int_stack+51456,int_stack+10164,28);
 /*--- compute (i0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+37064,int_stack+34516,28);
 /*--- compute (i0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+77944,int_stack+0,int_stack+19404,28);
 /*--- compute (i0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+7644,int_stack+77944,int_stack+51456,28);
 /*--- compute (i0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+91048,int_stack+7644,int_stack+62544,28);
 /*--- compute (i0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+51456,int_stack+40004,int_stack+37064,28);
 /*--- compute (i0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+60276,int_stack+51456,int_stack+0,28);
 /*--- compute (i0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+114148,int_stack+60276,int_stack+77944,28);
 /*--- compute (i0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+135988,int_stack+114148,int_stack+7644,28);
 /*--- compute (i0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+0,int_stack+135988,int_stack+91048,28);
 /*--- compute (i0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+75564,int_stack+43364,int_stack+40004,28);
 /*--- compute (i0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+85644,int_stack+75564,int_stack+51456,28);
 /*--- compute (i0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+310767,int_stack+85644,int_stack+60276,28);
 /*--- compute (i0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+336247,int_stack+310767,int_stack+114148,28);
 /*--- compute (i0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+369007,int_stack+336247,int_stack+135988,28);
 /*--- compute (i0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+103284,int_stack+369007,int_stack+0,28);
 /*--- compute (i0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+0,int_stack+47172,int_stack+43364,28);
 /*--- compute (i0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+11424,int_stack+0,int_stack+75564,28);
 /*--- compute (i0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+31584,int_stack+11424,int_stack+85644,28);
 /*--- compute (i0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+60984,int_stack+31584,int_stack+310767,28);
 /*--- compute (i0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+0,int_stack+60984,int_stack+336247,28);
 /*--- compute (i0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+310767,int_stack+0,int_stack+369007,28);
 /*--- compute (i0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+0,int_stack+310767,int_stack+103284,28);
 /*--- compute (hp|mk) ---*/
 hrr1_build_hp(Libint->AB,int_stack+310767,int_stack+0,int_stack+180087,1980);
 /*--- compute (gd|mk) ---*/
 hrr1_build_gd(Libint->AB,int_stack+0,int_stack+310767,int_stack+221667,1980);
 return int_stack+0;}
