/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_gfld(Libint_t*, prim_data*);

  /* Computes quartets of (gf|ld) integrals */

REALTYPE *hrr_order_gfld(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[4][8] = int_stack + 0;
 Libint->vrr_classes[4][9] = int_stack + 675;
 Libint->vrr_classes[4][10] = int_stack + 1500;
 Libint->vrr_classes[5][8] = int_stack + 2490;
 Libint->vrr_classes[5][9] = int_stack + 3435;
 Libint->vrr_classes[5][10] = int_stack + 4590;
 Libint->vrr_classes[6][8] = int_stack + 5976;
 Libint->vrr_classes[6][9] = int_stack + 7236;
 Libint->vrr_classes[6][10] = int_stack + 8776;
 Libint->vrr_classes[7][8] = int_stack + 10624;
 Libint->vrr_classes[7][9] = int_stack + 12244;
 Libint->vrr_classes[7][10] = int_stack + 14224;
 memset(int_stack,0,16600*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 16600;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_gfld(Libint, Data);
   Data++;
 }
 /*--- compute (g0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+16600,int_stack+675,int_stack+0,15);
 /*--- compute (g0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+18625,int_stack+1500,int_stack+675,15);
 /*--- compute (g0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+21100,int_stack+18625,int_stack+16600,15);
 /*--- compute (h0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+16600,int_stack+3435,int_stack+2490,21);
 /*--- compute (h0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+25150,int_stack+4590,int_stack+3435,21);
 /*--- compute (h0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+0,int_stack+25150,int_stack+16600,21);
 /*--- compute (gp|ld) ---*/
 hrr1_build_gp(Libint->AB,int_stack+25150,int_stack+0,int_stack+21100,270);
 /*--- compute (i0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+16600,int_stack+7236,int_stack+5976,28);
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+20380,int_stack+8776,int_stack+7236,28);
 /*--- compute (i0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+37300,int_stack+20380,int_stack+16600,28);
 /*--- compute (hp|ld) ---*/
 hrr1_build_hp(Libint->AB,int_stack+44860,int_stack+37300,int_stack+0,270);
 /*--- compute (gd|ld) ---*/
 hrr1_build_gd(Libint->AB,int_stack+61870,int_stack+44860,int_stack+25150,270);
 /*--- compute (k0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+0,int_stack+12244,int_stack+10624,36);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+4860,int_stack+14224,int_stack+12244,36);
 /*--- compute (k0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+10800,int_stack+4860,int_stack+0,36);
 /*--- compute (ip|ld) ---*/
 hrr1_build_ip(Libint->AB,int_stack+86170,int_stack+10800,int_stack+37300,270);
 /*--- compute (hd|ld) ---*/
 hrr1_build_hd(Libint->AB,int_stack+0,int_stack+86170,int_stack+44860,270);
 /*--- compute (gf|ld) ---*/
 hrr1_build_gf(Libint->AB,int_stack+86170,int_stack+0,int_stack+61870,270);
 return int_stack+86170;}
