/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_gfnf(Libint_t*, prim_data*);

  /* Computes quartets of (gf|nf) integrals */

REALTYPE *hrr_order_gfnf(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[4][10] = int_stack + 0;
 Libint->vrr_classes[4][11] = int_stack + 990;
 Libint->vrr_classes[4][12] = int_stack + 2160;
 Libint->vrr_classes[4][13] = int_stack + 3525;
 Libint->vrr_classes[5][10] = int_stack + 5100;
 Libint->vrr_classes[5][11] = int_stack + 6486;
 Libint->vrr_classes[5][12] = int_stack + 8124;
 Libint->vrr_classes[5][13] = int_stack + 10035;
 Libint->vrr_classes[6][10] = int_stack + 12240;
 Libint->vrr_classes[6][11] = int_stack + 14088;
 Libint->vrr_classes[6][12] = int_stack + 16272;
 Libint->vrr_classes[6][13] = int_stack + 18820;
 Libint->vrr_classes[7][10] = int_stack + 21760;
 Libint->vrr_classes[7][11] = int_stack + 24136;
 Libint->vrr_classes[7][12] = int_stack + 26944;
 Libint->vrr_classes[7][13] = int_stack + 30220;
 memset(int_stack,0,34000*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 34000;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_gfnf(Libint, Data);
   Data++;
 }
 /*--- compute (g0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+34000,int_stack+990,int_stack+0,15);
 /*--- compute (g0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+36970,int_stack+2160,int_stack+990,15);
 /*--- compute (g0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+40480,int_stack+36970,int_stack+34000,15);
 /*--- compute (g0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+46420,int_stack+3525,int_stack+2160,15);
 /*--- compute (g0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+50515,int_stack+46420,int_stack+36970,15);
 /*--- compute (g0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+57535,int_stack+50515,int_stack+40480,15);
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+34000,int_stack+6486,int_stack+5100,21);
 /*--- compute (h0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+38158,int_stack+8124,int_stack+6486,21);
 /*--- compute (h0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+43072,int_stack+38158,int_stack+34000,21);
 /*--- compute (h0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+51388,int_stack+10035,int_stack+8124,21);
 /*--- compute (h0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+0,int_stack+51388,int_stack+38158,21);
 /*--- compute (h0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+67435,int_stack+0,int_stack+43072,21);
 /*--- compute (gp|nf) ---*/
 hrr1_build_gp(Libint->AB,int_stack+81295,int_stack+67435,int_stack+57535,660);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+14088,int_stack+12240,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+5544,int_stack+16272,int_stack+14088,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+34000,int_stack+5544,int_stack+0,28);
 /*--- compute (i0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+45088,int_stack+18820,int_stack+16272,28);
 /*--- compute (i0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+52732,int_stack+45088,int_stack+5544,28);
 /*--- compute (i0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+0,int_stack+52732,int_stack+34000,28);
 /*--- compute (hp|nf) ---*/
 hrr1_build_hp(Libint->AB,int_stack+110995,int_stack+0,int_stack+67435,660);
 /*--- compute (gd|nf) ---*/
 hrr1_build_gd(Libint->AB,int_stack+152575,int_stack+110995,int_stack+81295,660);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+34000,int_stack+24136,int_stack+21760,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+41128,int_stack+26944,int_stack+24136,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+49552,int_stack+41128,int_stack+34000,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+63808,int_stack+30220,int_stack+26944,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+73636,int_stack+63808,int_stack+41128,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+18480,int_stack+73636,int_stack+49552,36);
 /*--- compute (ip|nf) ---*/
 hrr1_build_ip(Libint->AB,int_stack+42240,int_stack+18480,int_stack+0,660);
 /*--- compute (hd|nf) ---*/
 hrr1_build_hd(Libint->AB,int_stack+211975,int_stack+42240,int_stack+110995,660);
 /*--- compute (gf|nf) ---*/
 hrr1_build_gf(Libint->AB,int_stack+0,int_stack+211975,int_stack+152575,660);
 return int_stack+0;}
