/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_ggmg(Libint_t*, prim_data*);

  /* Computes quartets of (gg|mg) integrals */

REALTYPE *hrr_order_ggmg(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[4][9] = int_stack + 0;
 Libint->vrr_classes[4][10] = int_stack + 825;
 Libint->vrr_classes[4][11] = int_stack + 1815;
 Libint->vrr_classes[4][12] = int_stack + 2985;
 Libint->vrr_classes[4][13] = int_stack + 4350;
 Libint->vrr_classes[5][9] = int_stack + 5925;
 Libint->vrr_classes[5][10] = int_stack + 7080;
 Libint->vrr_classes[5][11] = int_stack + 8466;
 Libint->vrr_classes[5][12] = int_stack + 10104;
 Libint->vrr_classes[5][13] = int_stack + 12015;
 Libint->vrr_classes[6][9] = int_stack + 14220;
 Libint->vrr_classes[6][10] = int_stack + 15760;
 Libint->vrr_classes[6][11] = int_stack + 17608;
 Libint->vrr_classes[6][12] = int_stack + 19792;
 Libint->vrr_classes[6][13] = int_stack + 22340;
 Libint->vrr_classes[7][9] = int_stack + 25280;
 Libint->vrr_classes[7][10] = int_stack + 27260;
 Libint->vrr_classes[7][11] = int_stack + 29636;
 Libint->vrr_classes[7][12] = int_stack + 32444;
 Libint->vrr_classes[7][13] = int_stack + 35720;
 Libint->vrr_classes[8][9] = int_stack + 39500;
 Libint->vrr_classes[8][10] = int_stack + 41975;
 Libint->vrr_classes[8][11] = int_stack + 44945;
 Libint->vrr_classes[8][12] = int_stack + 48455;
 Libint->vrr_classes[8][13] = int_stack + 52550;
 memset(int_stack,0,57275*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 57275;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_ggmg(Libint, Data);
   Data++;
 }
 /*--- compute (g0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+57275,int_stack+825,int_stack+0,15);
 /*--- compute (g0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+59750,int_stack+1815,int_stack+825,15);
 /*--- compute (g0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+62720,int_stack+59750,int_stack+57275,15);
 /*--- compute (g0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+67670,int_stack+2985,int_stack+1815,15);
 /*--- compute (g0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+71180,int_stack+67670,int_stack+59750,15);
 /*--- compute (g0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+77120,int_stack+71180,int_stack+62720,15);
 /*--- compute (g0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+57275,int_stack+4350,int_stack+2985,15);
 /*--- compute (g0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+85370,int_stack+57275,int_stack+67670,15);
 /*--- compute (g0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+57275,int_stack+85370,int_stack+71180,15);
 /*--- compute (g0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+85370,int_stack+57275,int_stack+77120,15);
 /*--- compute (h0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+57275,int_stack+7080,int_stack+5925,21);
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+60740,int_stack+8466,int_stack+7080,21);
 /*--- compute (h0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+64898,int_stack+60740,int_stack+57275,21);
 /*--- compute (h0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+71828,int_stack+10104,int_stack+8466,21);
 /*--- compute (h0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+76742,int_stack+71828,int_stack+60740,21);
 /*--- compute (h0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+97745,int_stack+76742,int_stack+64898,21);
 /*--- compute (h0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+57275,int_stack+12015,int_stack+10104,21);
 /*--- compute (h0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+0,int_stack+57275,int_stack+71828,21);
 /*--- compute (h0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+57275,int_stack+0,int_stack+76742,21);
 /*--- compute (h0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+109295,int_stack+57275,int_stack+97745,21);
 /*--- compute (gp|mg) ---*/
 hrr1_build_gp(Libint->AB,int_stack+126620,int_stack+109295,int_stack+85370,825);
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+57275,int_stack+15760,int_stack+14220,28);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+61895,int_stack+17608,int_stack+15760,28);
 /*--- compute (i0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+67439,int_stack+61895,int_stack+57275,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+76679,int_stack+19792,int_stack+17608,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+83231,int_stack+76679,int_stack+61895,28);
 /*--- compute (i0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+0,int_stack+83231,int_stack+67439,28);
 /*--- compute (i0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+57275,int_stack+22340,int_stack+19792,28);
 /*--- compute (i0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+94319,int_stack+57275,int_stack+76679,28);
 /*--- compute (i0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+57275,int_stack+94319,int_stack+83231,28);
 /*--- compute (i0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+75755,int_stack+57275,int_stack+0,28);
 /*--- compute (hp|mg) ---*/
 hrr1_build_hp(Libint->AB,int_stack+163745,int_stack+75755,int_stack+109295,825);
 /*--- compute (gd|mg) ---*/
 hrr1_build_gd(Libint->AB,int_stack+215720,int_stack+163745,int_stack+126620,825);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+0,int_stack+27260,int_stack+25280,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+5940,int_stack+29636,int_stack+27260,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+13068,int_stack+5940,int_stack+0,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+57275,int_stack+32444,int_stack+29636,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+98855,int_stack+57275,int_stack+5940,36);
 /*--- compute (k0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+113111,int_stack+98855,int_stack+13068,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+35720,int_stack+32444,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+9828,int_stack+0,int_stack+57275,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+132911,int_stack+9828,int_stack+98855,36);
 /*--- compute (k0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+0,int_stack+132911,int_stack+113111,36);
 /*--- compute (ip|mg) ---*/
 hrr1_build_ip(Libint->AB,int_stack+289970,int_stack+0,int_stack+75755,825);
 /*--- compute (hd|mg) ---*/
 hrr1_build_hd(Libint->AB,int_stack+57275,int_stack+289970,int_stack+163745,825);
 /*--- compute (gf|mg) ---*/
 hrr1_build_gf(Libint->AB,int_stack+359270,int_stack+57275,int_stack+215720,825);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+161225,int_stack+41975,int_stack+39500,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+168650,int_stack+44945,int_stack+41975,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+177560,int_stack+168650,int_stack+161225,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+192410,int_stack+48455,int_stack+44945,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+202940,int_stack+192410,int_stack+168650,45);
 /*--- compute (l0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+220760,int_stack+202940,int_stack+177560,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+161225,int_stack+52550,int_stack+48455,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+245510,int_stack+161225,int_stack+192410,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+161225,int_stack+245510,int_stack+202940,45);
 /*--- compute (l0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+245510,int_stack+161225,int_stack+220760,45);
 /*--- compute (kp|mg) ---*/
 hrr1_build_kp(Libint->AB,int_stack+483020,int_stack+245510,int_stack+0,825);
 /*--- compute (id|mg) ---*/
 hrr1_build_id(Libint->AB,int_stack+572120,int_stack+483020,int_stack+289970,825);
 /*--- compute (hf|mg) ---*/
 hrr1_build_hf(Libint->AB,int_stack+161225,int_stack+572120,int_stack+57275,825);
 /*--- compute (gg|mg) ---*/
 hrr1_build_gg(Libint->AB,int_stack+483020,int_stack+161225,int_stack+359270,825);
 return int_stack+483020;}
