/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_ggnd(Libint_t*, prim_data*);

  /* Computes quartets of (gg|nd) integrals */

REALTYPE *hrr_order_ggnd(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[4][10] = int_stack + 0;
 Libint->vrr_classes[4][11] = int_stack + 990;
 Libint->vrr_classes[4][12] = int_stack + 2160;
 Libint->vrr_classes[5][10] = int_stack + 3525;
 Libint->vrr_classes[5][11] = int_stack + 4911;
 Libint->vrr_classes[5][12] = int_stack + 6549;
 Libint->vrr_classes[6][10] = int_stack + 8460;
 Libint->vrr_classes[6][11] = int_stack + 10308;
 Libint->vrr_classes[6][12] = int_stack + 12492;
 Libint->vrr_classes[7][10] = int_stack + 15040;
 Libint->vrr_classes[7][11] = int_stack + 17416;
 Libint->vrr_classes[7][12] = int_stack + 20224;
 Libint->vrr_classes[8][10] = int_stack + 23500;
 Libint->vrr_classes[8][11] = int_stack + 26470;
 Libint->vrr_classes[8][12] = int_stack + 29980;
 memset(int_stack,0,34075*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 34075;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_ggnd(Libint, Data);
   Data++;
 }
 /*--- compute (g0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+34075,int_stack+990,int_stack+0,15);
 /*--- compute (g0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+37045,int_stack+2160,int_stack+990,15);
 /*--- compute (g0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+40555,int_stack+37045,int_stack+34075,15);
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+34075,int_stack+4911,int_stack+3525,21);
 /*--- compute (h0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+46495,int_stack+6549,int_stack+4911,21);
 /*--- compute (h0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+0,int_stack+46495,int_stack+34075,21);
 /*--- compute (gp|nd) ---*/
 hrr1_build_gp(Libint->AB,int_stack+46495,int_stack+0,int_stack+40555,396);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+34075,int_stack+10308,int_stack+8460,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+39619,int_stack+12492,int_stack+10308,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+64315,int_stack+39619,int_stack+34075,28);
 /*--- compute (hp|nd) ---*/
 hrr1_build_hp(Libint->AB,int_stack+75403,int_stack+64315,int_stack+0,396);
 /*--- compute (gd|nd) ---*/
 hrr1_build_gd(Libint->AB,int_stack+100351,int_stack+75403,int_stack+46495,396);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+17416,int_stack+15040,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+7128,int_stack+20224,int_stack+17416,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+34075,int_stack+7128,int_stack+0,36);
 /*--- compute (ip|nd) ---*/
 hrr1_build_ip(Libint->AB,int_stack+135991,int_stack+34075,int_stack+64315,396);
 /*--- compute (hd|nd) ---*/
 hrr1_build_hd(Libint->AB,int_stack+169255,int_stack+135991,int_stack+75403,396);
 /*--- compute (gf|nd) ---*/
 hrr1_build_gf(Libint->AB,int_stack+219151,int_stack+169255,int_stack+100351,396);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+26470,int_stack+23500,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+8910,int_stack+29980,int_stack+26470,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+48331,int_stack+8910,int_stack+0,45);
 /*--- compute (kp|nd) ---*/
 hrr1_build_kp(Libint->AB,int_stack+66151,int_stack+48331,int_stack+34075,396);
 /*--- compute (id|nd) ---*/
 hrr1_build_id(Libint->AB,int_stack+278551,int_stack+66151,int_stack+135991,396);
 /*--- compute (hf|nd) ---*/
 hrr1_build_hf(Libint->AB,int_stack+0,int_stack+278551,int_stack+169255,396);
 /*--- compute (gg|nd) ---*/
 hrr1_build_gg(Libint->AB,int_stack+83160,int_stack+0,int_stack+219151,396);
 return int_stack+83160;}
