/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_h0lk(Libint_t*, prim_data*);

  /* Computes quartets of (h0|lk) integrals */

REALTYPE *hrr_order_h0lk(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[5][8] = int_stack + 0;
 Libint->vrr_classes[5][9] = int_stack + 945;
 Libint->vrr_classes[5][10] = int_stack + 2100;
 Libint->vrr_classes[5][11] = int_stack + 3486;
 Libint->vrr_classes[5][12] = int_stack + 5124;
 Libint->vrr_classes[5][13] = int_stack + 7035;
 Libint->vrr_classes[5][14] = int_stack + 9240;
 Libint->vrr_classes[5][15] = int_stack + 11760;
 memset(int_stack,0,14616*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 14616;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_h0lk(Libint, Data);
   Data++;
 }
 /*--- compute (h0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+14616,int_stack+945,int_stack+0,21);
 /*--- compute (h0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+17451,int_stack+2100,int_stack+945,21);
 /*--- compute (h0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+20916,int_stack+17451,int_stack+14616,21);
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+26586,int_stack+3486,int_stack+2100,21);
 /*--- compute (h0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+30744,int_stack+26586,int_stack+17451,21);
 /*--- compute (h0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+37674,int_stack+30744,int_stack+20916,21);
 /*--- compute (h0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+14616,int_stack+5124,int_stack+3486,21);
 /*--- compute (h0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+47124,int_stack+14616,int_stack+26586,21);
 /*--- compute (h0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+55440,int_stack+47124,int_stack+30744,21);
 /*--- compute (h0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+19530,int_stack+55440,int_stack+37674,21);
 /*--- compute (h0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+33705,int_stack+7035,int_stack+5124,21);
 /*--- compute (h0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+66990,int_stack+33705,int_stack+14616,21);
 /*--- compute (h0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+76818,int_stack+66990,int_stack+47124,21);
 /*--- compute (h0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+90678,int_stack+76818,int_stack+55440,21);
 /*--- compute (h0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+39438,int_stack+90678,int_stack+19530,21);
 /*--- compute (h0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+14616,int_stack+9240,int_stack+7035,21);
 /*--- compute (h0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+21231,int_stack+14616,int_stack+33705,21);
 /*--- compute (h0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+108003,int_stack+21231,int_stack+66990,21);
 /*--- compute (h0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+124383,int_stack+108003,int_stack+76818,21);
 /*--- compute (h0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+59283,int_stack+124383,int_stack+90678,21);
 /*--- compute (h0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+145173,int_stack+59283,int_stack+39438,21);
 /*--- compute (h0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+32697,int_stack+11760,int_stack+9240,21);
 /*--- compute (h0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+40257,int_stack+32697,int_stack+14616,21);
 /*--- compute (h0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+83538,int_stack+40257,int_stack+21231,21);
 /*--- compute (h0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+0,int_stack+83538,int_stack+108003,21);
 /*--- compute (h0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+83538,int_stack+0,int_stack+124383,21);
 /*--- compute (h0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+0,int_stack+83538,int_stack+59283,21);
 /*--- compute (h0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+32340,int_stack+0,int_stack+145173,21);
 return int_stack+32340;}
