/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_hfid(Libint_t*, prim_data*);

  /* Computes quartets of (hf|id) integrals */

REALTYPE *hrr_order_hfid(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[5][6] = int_stack + 0;
 Libint->vrr_classes[5][7] = int_stack + 588;
 Libint->vrr_classes[5][8] = int_stack + 1344;
 Libint->vrr_classes[6][6] = int_stack + 2289;
 Libint->vrr_classes[6][7] = int_stack + 3073;
 Libint->vrr_classes[6][8] = int_stack + 4081;
 Libint->vrr_classes[7][6] = int_stack + 5341;
 Libint->vrr_classes[7][7] = int_stack + 6349;
 Libint->vrr_classes[7][8] = int_stack + 7645;
 Libint->vrr_classes[8][6] = int_stack + 9265;
 Libint->vrr_classes[8][7] = int_stack + 10525;
 Libint->vrr_classes[8][8] = int_stack + 12145;
 memset(int_stack,0,14170*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 14170;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_hfid(Libint, Data);
   Data++;
 }
 /*--- compute (h0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+14170,int_stack+588,int_stack+0,21);
 /*--- compute (h0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+15934,int_stack+1344,int_stack+588,21);
 /*--- compute (h0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+18202,int_stack+15934,int_stack+14170,21);
 /*--- compute (i0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+14170,int_stack+3073,int_stack+2289,28);
 /*--- compute (i0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+0,int_stack+4081,int_stack+3073,28);
 /*--- compute (i0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+21730,int_stack+0,int_stack+14170,28);
 /*--- compute (hp|id) ---*/
 hrr1_build_hp(Libint->AB,int_stack+26434,int_stack+21730,int_stack+18202,168);
 /*--- compute (k0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+14170,int_stack+6349,int_stack+5341,36);
 /*--- compute (k0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+17194,int_stack+7645,int_stack+6349,36);
 /*--- compute (k0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+0,int_stack+17194,int_stack+14170,36);
 /*--- compute (ip|id) ---*/
 hrr1_build_ip(Libint->AB,int_stack+37018,int_stack+0,int_stack+21730,168);
 /*--- compute (hd|id) ---*/
 hrr1_build_hd(Libint->AB,int_stack+51130,int_stack+37018,int_stack+26434,168);
 /*--- compute (l0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+14170,int_stack+10525,int_stack+9265,45);
 /*--- compute (l0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+17950,int_stack+12145,int_stack+10525,45);
 /*--- compute (l0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+22810,int_stack+17950,int_stack+14170,45);
 /*--- compute (kp|id) ---*/
 hrr1_build_kp(Libint->AB,int_stack+72298,int_stack+22810,int_stack+0,168);
 /*--- compute (id|id) ---*/
 hrr1_build_id(Libint->AB,int_stack+0,int_stack+72298,int_stack+37018,168);
 /*--- compute (hf|id) ---*/
 hrr1_build_hf(Libint->AB,int_stack+72298,int_stack+0,int_stack+51130,168);
 return int_stack+72298;}
