/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_hfkf(Libint_t*, prim_data*);

  /* Computes quartets of (hf|kf) integrals */

REALTYPE *hrr_order_hfkf(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[5][7] = int_stack + 0;
 Libint->vrr_classes[5][8] = int_stack + 756;
 Libint->vrr_classes[5][9] = int_stack + 1701;
 Libint->vrr_classes[5][10] = int_stack + 2856;
 Libint->vrr_classes[6][7] = int_stack + 4242;
 Libint->vrr_classes[6][8] = int_stack + 5250;
 Libint->vrr_classes[6][9] = int_stack + 6510;
 Libint->vrr_classes[6][10] = int_stack + 8050;
 Libint->vrr_classes[7][7] = int_stack + 9898;
 Libint->vrr_classes[7][8] = int_stack + 11194;
 Libint->vrr_classes[7][9] = int_stack + 12814;
 Libint->vrr_classes[7][10] = int_stack + 14794;
 Libint->vrr_classes[8][7] = int_stack + 17170;
 Libint->vrr_classes[8][8] = int_stack + 18790;
 Libint->vrr_classes[8][9] = int_stack + 20815;
 Libint->vrr_classes[8][10] = int_stack + 23290;
 memset(int_stack,0,26260*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 26260;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_hfkf(Libint, Data);
   Data++;
 }
 /*--- compute (h0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+26260,int_stack+756,int_stack+0,21);
 /*--- compute (h0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+28528,int_stack+1701,int_stack+756,21);
 /*--- compute (h0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+31363,int_stack+28528,int_stack+26260,21);
 /*--- compute (h0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+35899,int_stack+2856,int_stack+1701,21);
 /*--- compute (h0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+39364,int_stack+35899,int_stack+28528,21);
 /*--- compute (h0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+45034,int_stack+39364,int_stack+31363,21);
 /*--- compute (i0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+26260,int_stack+5250,int_stack+4242,28);
 /*--- compute (i0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+29284,int_stack+6510,int_stack+5250,28);
 /*--- compute (i0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+33064,int_stack+29284,int_stack+26260,28);
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+39112,int_stack+8050,int_stack+6510,28);
 /*--- compute (i0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+0,int_stack+39112,int_stack+29284,28);
 /*--- compute (i0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+52594,int_stack+0,int_stack+33064,28);
 /*--- compute (hp|kf) ---*/
 hrr1_build_hp(Libint->AB,int_stack+62674,int_stack+52594,int_stack+45034,360);
 /*--- compute (k0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+0,int_stack+11194,int_stack+9898,36);
 /*--- compute (k0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+3888,int_stack+12814,int_stack+11194,36);
 /*--- compute (k0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+26260,int_stack+3888,int_stack+0,36);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+34036,int_stack+14794,int_stack+12814,36);
 /*--- compute (k0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+39976,int_stack+34036,int_stack+3888,36);
 /*--- compute (k0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+0,int_stack+39976,int_stack+26260,36);
 /*--- compute (ip|kf) ---*/
 hrr1_build_ip(Libint->AB,int_stack+85354,int_stack+0,int_stack+52594,360);
 /*--- compute (hd|kf) ---*/
 hrr1_build_hd(Libint->AB,int_stack+115594,int_stack+85354,int_stack+62674,360);
 /*--- compute (l0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+26260,int_stack+18790,int_stack+17170,45);
 /*--- compute (l0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+31120,int_stack+20815,int_stack+18790,45);
 /*--- compute (l0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+37195,int_stack+31120,int_stack+26260,45);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+46915,int_stack+23290,int_stack+20815,45);
 /*--- compute (l0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+54340,int_stack+46915,int_stack+31120,45);
 /*--- compute (l0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+66490,int_stack+54340,int_stack+37195,45);
 /*--- compute (kp|kf) ---*/
 hrr1_build_kp(Libint->AB,int_stack+12960,int_stack+66490,int_stack+0,360);
 /*--- compute (id|kf) ---*/
 hrr1_build_id(Libint->AB,int_stack+160954,int_stack+12960,int_stack+85354,360);
 /*--- compute (hf|kf) ---*/
 hrr1_build_hf(Libint->AB,int_stack+0,int_stack+160954,int_stack+115594,360);
 return int_stack+0;}
