/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_hfkh(Libint_t*, prim_data*);

  /* Computes quartets of (hf|kh) integrals */

REALTYPE *hrr_order_hfkh(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[5][7] = int_stack + 0;
 Libint->vrr_classes[5][8] = int_stack + 756;
 Libint->vrr_classes[5][9] = int_stack + 1701;
 Libint->vrr_classes[5][10] = int_stack + 2856;
 Libint->vrr_classes[5][11] = int_stack + 4242;
 Libint->vrr_classes[5][12] = int_stack + 5880;
 Libint->vrr_classes[6][7] = int_stack + 7791;
 Libint->vrr_classes[6][8] = int_stack + 8799;
 Libint->vrr_classes[6][9] = int_stack + 10059;
 Libint->vrr_classes[6][10] = int_stack + 11599;
 Libint->vrr_classes[6][11] = int_stack + 13447;
 Libint->vrr_classes[6][12] = int_stack + 15631;
 Libint->vrr_classes[7][7] = int_stack + 18179;
 Libint->vrr_classes[7][8] = int_stack + 19475;
 Libint->vrr_classes[7][9] = int_stack + 21095;
 Libint->vrr_classes[7][10] = int_stack + 23075;
 Libint->vrr_classes[7][11] = int_stack + 25451;
 Libint->vrr_classes[7][12] = int_stack + 28259;
 Libint->vrr_classes[8][7] = int_stack + 31535;
 Libint->vrr_classes[8][8] = int_stack + 33155;
 Libint->vrr_classes[8][9] = int_stack + 35180;
 Libint->vrr_classes[8][10] = int_stack + 37655;
 Libint->vrr_classes[8][11] = int_stack + 40625;
 Libint->vrr_classes[8][12] = int_stack + 44135;
 memset(int_stack,0,48230*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 48230;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_hfkh(Libint, Data);
   Data++;
 }
 /*--- compute (h0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+48230,int_stack+756,int_stack+0,21);
 /*--- compute (h0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+50498,int_stack+1701,int_stack+756,21);
 /*--- compute (h0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+53333,int_stack+50498,int_stack+48230,21);
 /*--- compute (h0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+57869,int_stack+2856,int_stack+1701,21);
 /*--- compute (h0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+61334,int_stack+57869,int_stack+50498,21);
 /*--- compute (h0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+67004,int_stack+61334,int_stack+53333,21);
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+48230,int_stack+4242,int_stack+2856,21);
 /*--- compute (h0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+74564,int_stack+48230,int_stack+57869,21);
 /*--- compute (h0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+81494,int_stack+74564,int_stack+61334,21);
 /*--- compute (h0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+52388,int_stack+81494,int_stack+67004,21);
 /*--- compute (h0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+63728,int_stack+5880,int_stack+4242,21);
 /*--- compute (h0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+90944,int_stack+63728,int_stack+48230,21);
 /*--- compute (h0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+99260,int_stack+90944,int_stack+74564,21);
 /*--- compute (h0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+63728,int_stack+99260,int_stack+81494,21);
 /*--- compute (h0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+77903,int_stack+63728,int_stack+52388,21);
 /*--- compute (i0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+48230,int_stack+8799,int_stack+7791,28);
 /*--- compute (i0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+51254,int_stack+10059,int_stack+8799,28);
 /*--- compute (i0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+55034,int_stack+51254,int_stack+48230,28);
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+61082,int_stack+11599,int_stack+10059,28);
 /*--- compute (i0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+65702,int_stack+61082,int_stack+51254,28);
 /*--- compute (i0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+93779,int_stack+65702,int_stack+55034,28);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+48230,int_stack+13447,int_stack+11599,28);
 /*--- compute (i0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+0,int_stack+48230,int_stack+61082,28);
 /*--- compute (i0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+103859,int_stack+0,int_stack+65702,28);
 /*--- compute (i0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+53774,int_stack+103859,int_stack+93779,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+93779,int_stack+15631,int_stack+13447,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+116459,int_stack+93779,int_stack+48230,28);
 /*--- compute (i0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+127547,int_stack+116459,int_stack+0,28);
 /*--- compute (i0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+142947,int_stack+127547,int_stack+103859,28);
 /*--- compute (i0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+93779,int_stack+142947,int_stack+53774,28);
 /*--- compute (hp|kh) ---*/
 hrr1_build_hp(Libint->AB,int_stack+114947,int_stack+93779,int_stack+77903,756);
 /*--- compute (k0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+0,int_stack+19475,int_stack+18179,36);
 /*--- compute (k0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+3888,int_stack+21095,int_stack+19475,36);
 /*--- compute (k0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+8748,int_stack+3888,int_stack+0,36);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+48230,int_stack+23075,int_stack+21095,36);
 /*--- compute (k0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+54170,int_stack+48230,int_stack+3888,36);
 /*--- compute (k0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+63890,int_stack+54170,int_stack+8748,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+25451,int_stack+23075,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+7128,int_stack+0,int_stack+48230,36);
 /*--- compute (k0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+76850,int_stack+7128,int_stack+54170,36);
 /*--- compute (k0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+162575,int_stack+76850,int_stack+63890,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+48230,int_stack+28259,int_stack+25451,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+56654,int_stack+48230,int_stack+0,36);
 /*--- compute (k0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+182015,int_stack+56654,int_stack+7128,36);
 /*--- compute (k0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+0,int_stack+182015,int_stack+76850,36);
 /*--- compute (k0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+48230,int_stack+0,int_stack+162575,36);
 /*--- compute (ip|kh) ---*/
 hrr1_build_ip(Libint->AB,int_stack+162575,int_stack+48230,int_stack+93779,756);
 /*--- compute (hd|kh) ---*/
 hrr1_build_hd(Libint->AB,int_stack+226079,int_stack+162575,int_stack+114947,756);
 /*--- compute (l0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+0,int_stack+33155,int_stack+31535,45);
 /*--- compute (l0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+4860,int_stack+35180,int_stack+33155,45);
 /*--- compute (l0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+10935,int_stack+4860,int_stack+0,45);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+20655,int_stack+37655,int_stack+35180,45);
 /*--- compute (l0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+75446,int_stack+20655,int_stack+4860,45);
 /*--- compute (l0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+87596,int_stack+75446,int_stack+10935,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+40625,int_stack+37655,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+103796,int_stack+0,int_stack+20655,45);
 /*--- compute (l0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+8910,int_stack+103796,int_stack+75446,45);
 /*--- compute (l0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+118646,int_stack+8910,int_stack+87596,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+75446,int_stack+44135,int_stack+40625,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+85976,int_stack+75446,int_stack+0,45);
 /*--- compute (l0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+321335,int_stack+85976,int_stack+103796,45);
 /*--- compute (l0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+75446,int_stack+321335,int_stack+8910,45);
 /*--- compute (l0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+0,int_stack+75446,int_stack+118646,45);
 /*--- compute (kp|kh) ---*/
 hrr1_build_kp(Libint->AB,int_stack+75446,int_stack+0,int_stack+48230,756);
 /*--- compute (id|kh) ---*/
 hrr1_build_id(Libint->AB,int_stack+321335,int_stack+75446,int_stack+162575,756);
 /*--- compute (hf|kh) ---*/
 hrr1_build_hf(Libint->AB,int_stack+0,int_stack+321335,int_stack+226079,756);
 return int_stack+0;}
