/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_hfkk(Libint_t*, prim_data*);

  /* Computes quartets of (hf|kk) integrals */

REALTYPE *hrr_order_hfkk(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[5][7] = int_stack + 0;
 Libint->vrr_classes[5][8] = int_stack + 756;
 Libint->vrr_classes[5][9] = int_stack + 1701;
 Libint->vrr_classes[5][10] = int_stack + 2856;
 Libint->vrr_classes[5][11] = int_stack + 4242;
 Libint->vrr_classes[5][12] = int_stack + 5880;
 Libint->vrr_classes[5][13] = int_stack + 7791;
 Libint->vrr_classes[5][14] = int_stack + 9996;
 Libint->vrr_classes[6][7] = int_stack + 12516;
 Libint->vrr_classes[6][8] = int_stack + 13524;
 Libint->vrr_classes[6][9] = int_stack + 14784;
 Libint->vrr_classes[6][10] = int_stack + 16324;
 Libint->vrr_classes[6][11] = int_stack + 18172;
 Libint->vrr_classes[6][12] = int_stack + 20356;
 Libint->vrr_classes[6][13] = int_stack + 22904;
 Libint->vrr_classes[6][14] = int_stack + 25844;
 Libint->vrr_classes[7][7] = int_stack + 29204;
 Libint->vrr_classes[7][8] = int_stack + 30500;
 Libint->vrr_classes[7][9] = int_stack + 32120;
 Libint->vrr_classes[7][10] = int_stack + 34100;
 Libint->vrr_classes[7][11] = int_stack + 36476;
 Libint->vrr_classes[7][12] = int_stack + 39284;
 Libint->vrr_classes[7][13] = int_stack + 42560;
 Libint->vrr_classes[7][14] = int_stack + 46340;
 Libint->vrr_classes[8][7] = int_stack + 50660;
 Libint->vrr_classes[8][8] = int_stack + 52280;
 Libint->vrr_classes[8][9] = int_stack + 54305;
 Libint->vrr_classes[8][10] = int_stack + 56780;
 Libint->vrr_classes[8][11] = int_stack + 59750;
 Libint->vrr_classes[8][12] = int_stack + 63260;
 Libint->vrr_classes[8][13] = int_stack + 67355;
 Libint->vrr_classes[8][14] = int_stack + 72080;
 memset(int_stack,0,77480*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 77480;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_hfkk(Libint, Data);
   Data++;
 }
 /*--- compute (h0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+77480,int_stack+756,int_stack+0,21);
 /*--- compute (h0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+79748,int_stack+1701,int_stack+756,21);
 /*--- compute (h0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+82583,int_stack+79748,int_stack+77480,21);
 /*--- compute (h0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+87119,int_stack+2856,int_stack+1701,21);
 /*--- compute (h0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+90584,int_stack+87119,int_stack+79748,21);
 /*--- compute (h0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+96254,int_stack+90584,int_stack+82583,21);
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+77480,int_stack+4242,int_stack+2856,21);
 /*--- compute (h0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+103814,int_stack+77480,int_stack+87119,21);
 /*--- compute (h0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+110744,int_stack+103814,int_stack+90584,21);
 /*--- compute (h0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+81638,int_stack+110744,int_stack+96254,21);
 /*--- compute (h0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+92978,int_stack+5880,int_stack+4242,21);
 /*--- compute (h0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+120194,int_stack+92978,int_stack+77480,21);
 /*--- compute (h0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+128510,int_stack+120194,int_stack+103814,21);
 /*--- compute (h0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+140060,int_stack+128510,int_stack+110744,21);
 /*--- compute (h0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+97892,int_stack+140060,int_stack+81638,21);
 /*--- compute (h0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+77480,int_stack+7791,int_stack+5880,21);
 /*--- compute (h0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+154235,int_stack+77480,int_stack+92978,21);
 /*--- compute (h0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+83213,int_stack+154235,int_stack+120194,21);
 /*--- compute (h0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+164063,int_stack+83213,int_stack+128510,21);
 /*--- compute (h0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+113768,int_stack+164063,int_stack+140060,21);
 /*--- compute (h0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+181388,int_stack+113768,int_stack+97892,21);
 /*--- compute (h0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+97073,int_stack+9996,int_stack+7791,21);
 /*--- compute (h0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+133613,int_stack+97073,int_stack+77480,21);
 /*--- compute (h0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+97073,int_stack+133613,int_stack+154235,21);
 /*--- compute (h0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+133613,int_stack+97073,int_stack+83213,21);
 /*--- compute (h0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+77480,int_stack+133613,int_stack+164063,21);
 /*--- compute (h0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+133613,int_stack+77480,int_stack+113768,21);
 /*--- compute (h0|kk) ---*/
 hrr3_build_kk(Libint->CD,int_stack+77480,int_stack+133613,int_stack+181388,21);
 /*--- compute (i0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+104696,int_stack+13524,int_stack+12516,28);
 /*--- compute (i0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+107720,int_stack+14784,int_stack+13524,28);
 /*--- compute (i0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+111500,int_stack+107720,int_stack+104696,28);
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+117548,int_stack+16324,int_stack+14784,28);
 /*--- compute (i0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+122168,int_stack+117548,int_stack+107720,28);
 /*--- compute (i0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+129728,int_stack+122168,int_stack+111500,28);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+104696,int_stack+18172,int_stack+16324,28);
 /*--- compute (i0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+139808,int_stack+104696,int_stack+117548,28);
 /*--- compute (i0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+149048,int_stack+139808,int_stack+122168,28);
 /*--- compute (i0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+110240,int_stack+149048,int_stack+129728,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+125360,int_stack+20356,int_stack+18172,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+161648,int_stack+125360,int_stack+104696,28);
 /*--- compute (i0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+172736,int_stack+161648,int_stack+139808,28);
 /*--- compute (i0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+0,int_stack+172736,int_stack+149048,28);
 /*--- compute (i0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+131912,int_stack+0,int_stack+110240,28);
 /*--- compute (i0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+104696,int_stack+22904,int_stack+20356,28);
 /*--- compute (i0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+188136,int_stack+104696,int_stack+125360,28);
 /*--- compute (i0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+112340,int_stack+188136,int_stack+161648,28);
 /*--- compute (i0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+201240,int_stack+112340,int_stack+172736,28);
 /*--- compute (i0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+153080,int_stack+201240,int_stack+0,28);
 /*--- compute (i0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+224340,int_stack+153080,int_stack+131912,28);
 /*--- compute (i0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+25844,int_stack+22904,28);
 /*--- compute (i0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+8820,int_stack+0,int_stack+104696,28);
 /*--- compute (i0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+130820,int_stack+8820,int_stack+188136,28);
 /*--- compute (i0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+0,int_stack+130820,int_stack+112340,28);
 /*--- compute (i0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+104696,int_stack+0,int_stack+201240,28);
 /*--- compute (i0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+179540,int_stack+104696,int_stack+153080,28);
 /*--- compute (i0|kk) ---*/
 hrr3_build_kk(Libint->CD,int_stack+104696,int_stack+179540,int_stack+224340,28);
 /*--- compute (hp|kk) ---*/
 hrr1_build_hp(Libint->AB,int_stack+140984,int_stack+104696,int_stack+77480,1296);
 /*--- compute (k0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+77480,int_stack+30500,int_stack+29204,36);
 /*--- compute (k0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+81368,int_stack+32120,int_stack+30500,36);
 /*--- compute (k0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+86228,int_stack+81368,int_stack+77480,36);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+94004,int_stack+34100,int_stack+32120,36);
 /*--- compute (k0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+222632,int_stack+94004,int_stack+81368,36);
 /*--- compute (k0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+232352,int_stack+222632,int_stack+86228,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+77480,int_stack+36476,int_stack+34100,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+0,int_stack+77480,int_stack+94004,36);
 /*--- compute (k0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+84608,int_stack+0,int_stack+222632,36);
 /*--- compute (k0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+11880,int_stack+84608,int_stack+232352,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+222632,int_stack+39284,int_stack+36476,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+231056,int_stack+222632,int_stack+77480,36);
 /*--- compute (k0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+245312,int_stack+231056,int_stack+0,36);
 /*--- compute (k0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+265112,int_stack+245312,int_stack+84608,36);
 /*--- compute (k0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+77480,int_stack+265112,int_stack+11880,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+42560,int_stack+39284,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+9828,int_stack+0,int_stack+222632,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+289412,int_stack+9828,int_stack+231056,36);
 /*--- compute (k0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+313172,int_stack+289412,int_stack+245312,36);
 /*--- compute (k0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+222632,int_stack+313172,int_stack+265112,36);
 /*--- compute (k0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+342872,int_stack+222632,int_stack+77480,36);
 /*--- compute (k0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+77480,int_stack+46340,int_stack+42560,36);
 /*--- compute (k0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+256652,int_stack+77480,int_stack+0,36);
 /*--- compute (k0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+379160,int_stack+256652,int_stack+9828,36);
 /*--- compute (k0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+0,int_stack+379160,int_stack+289412,36);
 /*--- compute (k0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+256652,int_stack+0,int_stack+313172,36);
 /*--- compute (k0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+0,int_stack+256652,int_stack+222632,36);
 /*--- compute (k0|kk) ---*/
 hrr3_build_kk(Libint->CD,int_stack+222632,int_stack+0,int_stack+342872,36);
 /*--- compute (ip|kk) ---*/
 hrr1_build_ip(Libint->AB,int_stack+269288,int_stack+222632,int_stack+104696,1296);
 /*--- compute (hd|kk) ---*/
 hrr1_build_hd(Libint->AB,int_stack+378152,int_stack+269288,int_stack+140984,1296);
 /*--- compute (l0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+0,int_stack+52280,int_stack+50660,45);
 /*--- compute (l0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+4860,int_stack+54305,int_stack+52280,45);
 /*--- compute (l0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+10935,int_stack+4860,int_stack+0,45);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+20655,int_stack+56780,int_stack+54305,45);
 /*--- compute (l0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+28080,int_stack+20655,int_stack+4860,45);
 /*--- compute (l0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+40230,int_stack+28080,int_stack+10935,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+59750,int_stack+56780,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+77480,int_stack+0,int_stack+20655,45);
 /*--- compute (l0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+92330,int_stack+77480,int_stack+28080,45);
 /*--- compute (l0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+8910,int_stack+92330,int_stack+40230,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+33210,int_stack+63260,int_stack+59750,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+43740,int_stack+33210,int_stack+0,45);
 /*--- compute (l0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+112580,int_stack+43740,int_stack+77480,45);
 /*--- compute (l0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+137330,int_stack+112580,int_stack+92330,45);
 /*--- compute (l0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+77480,int_stack+137330,int_stack+8910,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+67355,int_stack+63260,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+167705,int_stack+0,int_stack+33210,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+12285,int_stack+167705,int_stack+43740,45);
 /*--- compute (l0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+541448,int_stack+12285,int_stack+112580,45);
 /*--- compute (l0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+578573,int_stack+541448,int_stack+137330,45);
 /*--- compute (l0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+111500,int_stack+578573,int_stack+77480,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+77480,int_stack+72080,int_stack+67355,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+41985,int_stack+77480,int_stack+0,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+66555,int_stack+41985,int_stack+167705,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+156860,int_stack+66555,int_stack+12285,45);
 /*--- compute (l0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+0,int_stack+156860,int_stack+541448,45);
 /*--- compute (l0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+156860,int_stack+0,int_stack+578573,45);
 /*--- compute (l0|kk) ---*/
 hrr3_build_kk(Libint->CD,int_stack+0,int_stack+156860,int_stack+111500,45);
 /*--- compute (kp|kk) ---*/
 hrr1_build_kp(Libint->AB,int_stack+58320,int_stack+0,int_stack+222632,1296);
 /*--- compute (id|kk) ---*/
 hrr1_build_id(Libint->AB,int_stack+541448,int_stack+58320,int_stack+269288,1296);
 /*--- compute (hf|kk) ---*/
 hrr1_build_hf(Libint->AB,int_stack+0,int_stack+541448,int_stack+378152,1296);
 return int_stack+0;}
