/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_hfld(Libint_t*, prim_data*);

  /* Computes quartets of (hf|ld) integrals */

REALTYPE *hrr_order_hfld(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[5][8] = int_stack + 0;
 Libint->vrr_classes[5][9] = int_stack + 945;
 Libint->vrr_classes[5][10] = int_stack + 2100;
 Libint->vrr_classes[6][8] = int_stack + 3486;
 Libint->vrr_classes[6][9] = int_stack + 4746;
 Libint->vrr_classes[6][10] = int_stack + 6286;
 Libint->vrr_classes[7][8] = int_stack + 8134;
 Libint->vrr_classes[7][9] = int_stack + 9754;
 Libint->vrr_classes[7][10] = int_stack + 11734;
 Libint->vrr_classes[8][8] = int_stack + 14110;
 Libint->vrr_classes[8][9] = int_stack + 16135;
 Libint->vrr_classes[8][10] = int_stack + 18610;
 memset(int_stack,0,21580*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 21580;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_hfld(Libint, Data);
   Data++;
 }
 /*--- compute (h0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+21580,int_stack+945,int_stack+0,21);
 /*--- compute (h0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+24415,int_stack+2100,int_stack+945,21);
 /*--- compute (h0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+27880,int_stack+24415,int_stack+21580,21);
 /*--- compute (i0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+21580,int_stack+4746,int_stack+3486,28);
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+0,int_stack+6286,int_stack+4746,28);
 /*--- compute (i0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+33550,int_stack+0,int_stack+21580,28);
 /*--- compute (hp|ld) ---*/
 hrr1_build_hp(Libint->AB,int_stack+41110,int_stack+33550,int_stack+27880,270);
 /*--- compute (k0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+21580,int_stack+9754,int_stack+8134,36);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+26440,int_stack+11734,int_stack+9754,36);
 /*--- compute (k0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+0,int_stack+26440,int_stack+21580,36);
 /*--- compute (ip|ld) ---*/
 hrr1_build_ip(Libint->AB,int_stack+58120,int_stack+0,int_stack+33550,270);
 /*--- compute (hd|ld) ---*/
 hrr1_build_hd(Libint->AB,int_stack+80800,int_stack+58120,int_stack+41110,270);
 /*--- compute (l0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+21580,int_stack+16135,int_stack+14110,45);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+27655,int_stack+18610,int_stack+16135,45);
 /*--- compute (l0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+35080,int_stack+27655,int_stack+21580,45);
 /*--- compute (kp|ld) ---*/
 hrr1_build_kp(Libint->AB,int_stack+114820,int_stack+35080,int_stack+0,270);
 /*--- compute (id|ld) ---*/
 hrr1_build_id(Libint->AB,int_stack+0,int_stack+114820,int_stack+58120,270);
 /*--- compute (hf|ld) ---*/
 hrr1_build_hf(Libint->AB,int_stack+114820,int_stack+0,int_stack+80800,270);
 return int_stack+114820;}
