/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_hflk(Libint_t*, prim_data*);

  /* Computes quartets of (hf|lk) integrals */

REALTYPE *hrr_order_hflk(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[5][8] = int_stack + 0;
 Libint->vrr_classes[5][9] = int_stack + 945;
 Libint->vrr_classes[5][10] = int_stack + 2100;
 Libint->vrr_classes[5][11] = int_stack + 3486;
 Libint->vrr_classes[5][12] = int_stack + 5124;
 Libint->vrr_classes[5][13] = int_stack + 7035;
 Libint->vrr_classes[5][14] = int_stack + 9240;
 Libint->vrr_classes[5][15] = int_stack + 11760;
 Libint->vrr_classes[6][8] = int_stack + 14616;
 Libint->vrr_classes[6][9] = int_stack + 15876;
 Libint->vrr_classes[6][10] = int_stack + 17416;
 Libint->vrr_classes[6][11] = int_stack + 19264;
 Libint->vrr_classes[6][12] = int_stack + 21448;
 Libint->vrr_classes[6][13] = int_stack + 23996;
 Libint->vrr_classes[6][14] = int_stack + 26936;
 Libint->vrr_classes[6][15] = int_stack + 30296;
 Libint->vrr_classes[7][8] = int_stack + 34104;
 Libint->vrr_classes[7][9] = int_stack + 35724;
 Libint->vrr_classes[7][10] = int_stack + 37704;
 Libint->vrr_classes[7][11] = int_stack + 40080;
 Libint->vrr_classes[7][12] = int_stack + 42888;
 Libint->vrr_classes[7][13] = int_stack + 46164;
 Libint->vrr_classes[7][14] = int_stack + 49944;
 Libint->vrr_classes[7][15] = int_stack + 54264;
 Libint->vrr_classes[8][8] = int_stack + 59160;
 Libint->vrr_classes[8][9] = int_stack + 61185;
 Libint->vrr_classes[8][10] = int_stack + 63660;
 Libint->vrr_classes[8][11] = int_stack + 66630;
 Libint->vrr_classes[8][12] = int_stack + 70140;
 Libint->vrr_classes[8][13] = int_stack + 74235;
 Libint->vrr_classes[8][14] = int_stack + 78960;
 Libint->vrr_classes[8][15] = int_stack + 84360;
 memset(int_stack,0,90480*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 90480;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_hflk(Libint, Data);
   Data++;
 }
 /*--- compute (h0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+90480,int_stack+945,int_stack+0,21);
 /*--- compute (h0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+93315,int_stack+2100,int_stack+945,21);
 /*--- compute (h0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+96780,int_stack+93315,int_stack+90480,21);
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+102450,int_stack+3486,int_stack+2100,21);
 /*--- compute (h0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+106608,int_stack+102450,int_stack+93315,21);
 /*--- compute (h0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+113538,int_stack+106608,int_stack+96780,21);
 /*--- compute (h0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+90480,int_stack+5124,int_stack+3486,21);
 /*--- compute (h0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+122988,int_stack+90480,int_stack+102450,21);
 /*--- compute (h0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+131304,int_stack+122988,int_stack+106608,21);
 /*--- compute (h0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+95394,int_stack+131304,int_stack+113538,21);
 /*--- compute (h0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+109569,int_stack+7035,int_stack+5124,21);
 /*--- compute (h0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+142854,int_stack+109569,int_stack+90480,21);
 /*--- compute (h0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+152682,int_stack+142854,int_stack+122988,21);
 /*--- compute (h0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+166542,int_stack+152682,int_stack+131304,21);
 /*--- compute (h0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+115302,int_stack+166542,int_stack+95394,21);
 /*--- compute (h0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+90480,int_stack+9240,int_stack+7035,21);
 /*--- compute (h0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+97095,int_stack+90480,int_stack+109569,21);
 /*--- compute (h0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+183867,int_stack+97095,int_stack+142854,21);
 /*--- compute (h0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+200247,int_stack+183867,int_stack+152682,21);
 /*--- compute (h0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+135147,int_stack+200247,int_stack+166542,21);
 /*--- compute (h0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+221037,int_stack+135147,int_stack+115302,21);
 /*--- compute (h0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+108561,int_stack+11760,int_stack+9240,21);
 /*--- compute (h0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+116121,int_stack+108561,int_stack+90480,21);
 /*--- compute (h0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+159402,int_stack+116121,int_stack+97095,21);
 /*--- compute (h0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+90480,int_stack+159402,int_stack+183867,21);
 /*--- compute (h0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+159402,int_stack+90480,int_stack+200247,21);
 /*--- compute (h0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+90480,int_stack+159402,int_stack+135147,21);
 /*--- compute (h0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+122820,int_stack+90480,int_stack+221037,21);
 /*--- compute (i0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+90480,int_stack+15876,int_stack+14616,28);
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+94260,int_stack+17416,int_stack+15876,28);
 /*--- compute (i0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+98880,int_stack+94260,int_stack+90480,28);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+106440,int_stack+19264,int_stack+17416,28);
 /*--- compute (i0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+111984,int_stack+106440,int_stack+94260,28);
 /*--- compute (i0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+156840,int_stack+111984,int_stack+98880,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+90480,int_stack+21448,int_stack+19264,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+169440,int_stack+90480,int_stack+106440,28);
 /*--- compute (i0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+180528,int_stack+169440,int_stack+111984,28);
 /*--- compute (i0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+97032,int_stack+180528,int_stack+156840,28);
 /*--- compute (i0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+156840,int_stack+23996,int_stack+21448,28);
 /*--- compute (i0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+195928,int_stack+156840,int_stack+90480,28);
 /*--- compute (i0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+209032,int_stack+195928,int_stack+169440,28);
 /*--- compute (i0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+0,int_stack+209032,int_stack+180528,28);
 /*--- compute (i0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+164484,int_stack+0,int_stack+97032,28);
 /*--- compute (i0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+90480,int_stack+26936,int_stack+23996,28);
 /*--- compute (i0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+99300,int_stack+90480,int_stack+156840,28);
 /*--- compute (i0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+227512,int_stack+99300,int_stack+195928,28);
 /*--- compute (i0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+249352,int_stack+227512,int_stack+209032,28);
 /*--- compute (i0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+190944,int_stack+249352,int_stack+0,28);
 /*--- compute (i0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+277072,int_stack+190944,int_stack+164484,28);
 /*--- compute (i0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+0,int_stack+30296,int_stack+26936,28);
 /*--- compute (i0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+10080,int_stack+0,int_stack+90480,28);
 /*--- compute (i0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+156840,int_stack+10080,int_stack+99300,28);
 /*--- compute (i0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+0,int_stack+156840,int_stack+227512,28);
 /*--- compute (i0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+312352,int_stack+0,int_stack+249352,28);
 /*--- compute (i0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+223284,int_stack+312352,int_stack+190944,28);
 /*--- compute (i0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+156840,int_stack+223284,int_stack+277072,28);
 /*--- compute (hp|lk) ---*/
 hrr1_build_hp(Libint->AB,int_stack+202200,int_stack+156840,int_stack+122820,1620);
 /*--- compute (k0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+0,int_stack+35724,int_stack+34104,36);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+4860,int_stack+37704,int_stack+35724,36);
 /*--- compute (k0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+10800,int_stack+4860,int_stack+0,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+20520,int_stack+40080,int_stack+37704,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+27648,int_stack+20520,int_stack+4860,36);
 /*--- compute (k0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+304260,int_stack+27648,int_stack+10800,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+0,int_stack+42888,int_stack+40080,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+320460,int_stack+0,int_stack+20520,36);
 /*--- compute (k0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+90480,int_stack+320460,int_stack+27648,36);
 /*--- compute (k0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+8424,int_stack+90480,int_stack+304260,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+304260,int_stack+46164,int_stack+42888,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+334716,int_stack+304260,int_stack+0,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+110280,int_stack+334716,int_stack+320460,36);
 /*--- compute (k0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+351564,int_stack+110280,int_stack+90480,36);
 /*--- compute (k0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+381264,int_stack+351564,int_stack+8424,36);
 /*--- compute (k0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+90480,int_stack+49944,int_stack+46164,36);
 /*--- compute (k0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+0,int_stack+90480,int_stack+304260,36);
 /*--- compute (k0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+304260,int_stack+0,int_stack+334716,36);
 /*--- compute (k0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+415284,int_stack+304260,int_stack+110280,36);
 /*--- compute (k0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+101820,int_stack+415284,int_stack+351564,36);
 /*--- compute (k0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+332340,int_stack+101820,int_stack+381264,36);
 /*--- compute (k0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+377700,int_stack+54264,int_stack+49944,36);
 /*--- compute (k0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+390660,int_stack+377700,int_stack+90480,36);
 /*--- compute (k0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+19656,int_stack+390660,int_stack+0,36);
 /*--- compute (k0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+450924,int_stack+19656,int_stack+304260,36);
 /*--- compute (k0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+0,int_stack+450924,int_stack+415284,36);
 /*--- compute (k0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+377700,int_stack+0,int_stack+101820,36);
 /*--- compute (k0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+0,int_stack+377700,int_stack+332340,36);
 /*--- compute (ip|lk) ---*/
 hrr1_build_ip(Libint->AB,int_stack+304260,int_stack+0,int_stack+156840,1620);
 /*--- compute (hd|lk) ---*/
 hrr1_build_hd(Libint->AB,int_stack+440340,int_stack+304260,int_stack+202200,1620);
 /*--- compute (l0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+90480,int_stack+61185,int_stack+59160,45);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+96555,int_stack+63660,int_stack+61185,45);
 /*--- compute (l0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+103980,int_stack+96555,int_stack+90480,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+116130,int_stack+66630,int_stack+63660,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+125040,int_stack+116130,int_stack+96555,45);
 /*--- compute (l0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+139890,int_stack+125040,int_stack+103980,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+90480,int_stack+70140,int_stack+66630,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+160140,int_stack+90480,int_stack+116130,45);
 /*--- compute (l0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+177960,int_stack+160140,int_stack+125040,45);
 /*--- compute (l0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+101010,int_stack+177960,int_stack+139890,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+131385,int_stack+74235,int_stack+70140,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+202710,int_stack+131385,int_stack+90480,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+223770,int_stack+202710,int_stack+160140,45);
 /*--- compute (l0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+253470,int_stack+223770,int_stack+177960,45);
 /*--- compute (l0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+143670,int_stack+253470,int_stack+101010,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+90480,int_stack+78960,int_stack+74235,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+104655,int_stack+90480,int_stack+131385,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+644460,int_stack+104655,int_stack+202710,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+679560,int_stack+644460,int_stack+223770,45);
 /*--- compute (l0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+186195,int_stack+679560,int_stack+253470,45);
 /*--- compute (l0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+238170,int_stack+186195,int_stack+143670,45);
 /*--- compute (l0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+129225,int_stack+84360,int_stack+78960,45);
 /*--- compute (l0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+145425,int_stack+129225,int_stack+90480,45);
 /*--- compute (l0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+58320,int_stack+145425,int_stack+104655,45);
 /*--- compute (l0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+99270,int_stack+58320,int_stack+644460,45);
 /*--- compute (l0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+724110,int_stack+99270,int_stack+679560,45);
 /*--- compute (l0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+644460,int_stack+724110,int_stack+186195,45);
 /*--- compute (l0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+713760,int_stack+644460,int_stack+238170,45);
 /*--- compute (kp|lk) ---*/
 hrr1_build_kp(Libint->AB,int_stack+58320,int_stack+713760,int_stack+0,1620);
 /*--- compute (id|lk) ---*/
 hrr1_build_id(Libint->AB,int_stack+644460,int_stack+58320,int_stack+304260,1620);
 /*--- compute (hf|lk) ---*/
 hrr1_build_hf(Libint->AB,int_stack+0,int_stack+644460,int_stack+440340,1620);
 return int_stack+0;}
