/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_hfnn(Libint_t*, prim_data*);

  /* Computes quartets of (hf|nn) integrals */

REALTYPE *hrr_order_hfnn(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[5][10] = int_stack + 0;
 Libint->vrr_classes[5][11] = int_stack + 1386;
 Libint->vrr_classes[5][12] = int_stack + 3024;
 Libint->vrr_classes[5][13] = int_stack + 4935;
 Libint->vrr_classes[5][14] = int_stack + 7140;
 Libint->vrr_classes[5][15] = int_stack + 9660;
 Libint->vrr_classes[5][16] = int_stack + 12516;
 Libint->vrr_classes[5][17] = int_stack + 15729;
 Libint->vrr_classes[5][18] = int_stack + 19320;
 Libint->vrr_classes[5][19] = int_stack + 23310;
 Libint->vrr_classes[5][20] = int_stack + 27720;
 Libint->vrr_classes[6][10] = int_stack + 32571;
 Libint->vrr_classes[6][11] = int_stack + 34419;
 Libint->vrr_classes[6][12] = int_stack + 36603;
 Libint->vrr_classes[6][13] = int_stack + 39151;
 Libint->vrr_classes[6][14] = int_stack + 42091;
 Libint->vrr_classes[6][15] = int_stack + 45451;
 Libint->vrr_classes[6][16] = int_stack + 49259;
 Libint->vrr_classes[6][17] = int_stack + 53543;
 Libint->vrr_classes[6][18] = int_stack + 58331;
 Libint->vrr_classes[6][19] = int_stack + 63651;
 Libint->vrr_classes[6][20] = int_stack + 69531;
 Libint->vrr_classes[7][10] = int_stack + 75999;
 Libint->vrr_classes[7][11] = int_stack + 78375;
 Libint->vrr_classes[7][12] = int_stack + 81183;
 Libint->vrr_classes[7][13] = int_stack + 84459;
 Libint->vrr_classes[7][14] = int_stack + 88239;
 Libint->vrr_classes[7][15] = int_stack + 92559;
 Libint->vrr_classes[7][16] = int_stack + 97455;
 Libint->vrr_classes[7][17] = int_stack + 102963;
 Libint->vrr_classes[7][18] = int_stack + 109119;
 Libint->vrr_classes[7][19] = int_stack + 115959;
 Libint->vrr_classes[7][20] = int_stack + 123519;
 Libint->vrr_classes[8][10] = int_stack + 131835;
 Libint->vrr_classes[8][11] = int_stack + 134805;
 Libint->vrr_classes[8][12] = int_stack + 138315;
 Libint->vrr_classes[8][13] = int_stack + 142410;
 Libint->vrr_classes[8][14] = int_stack + 147135;
 Libint->vrr_classes[8][15] = int_stack + 152535;
 Libint->vrr_classes[8][16] = int_stack + 158655;
 Libint->vrr_classes[8][17] = int_stack + 165540;
 Libint->vrr_classes[8][18] = int_stack + 173235;
 Libint->vrr_classes[8][19] = int_stack + 181785;
 Libint->vrr_classes[8][20] = int_stack + 191235;
 memset(int_stack,0,201630*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 201630;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_hfnn(Libint, Data);
   Data++;
 }
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+201630,int_stack+1386,int_stack+0,21);
 /*--- compute (h0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+205788,int_stack+3024,int_stack+1386,21);
 /*--- compute (h0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+210702,int_stack+205788,int_stack+201630,21);
 /*--- compute (h0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+219018,int_stack+4935,int_stack+3024,21);
 /*--- compute (h0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+224751,int_stack+219018,int_stack+205788,21);
 /*--- compute (h0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+234579,int_stack+224751,int_stack+210702,21);
 /*--- compute (h0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+201630,int_stack+7140,int_stack+4935,21);
 /*--- compute (h0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+248439,int_stack+201630,int_stack+219018,21);
 /*--- compute (h0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+208245,int_stack+248439,int_stack+224751,21);
 /*--- compute (h0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+259905,int_stack+208245,int_stack+234579,21);
 /*--- compute (h0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+224625,int_stack+9660,int_stack+7140,21);
 /*--- compute (h0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+232185,int_stack+224625,int_stack+201630,21);
 /*--- compute (h0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+280695,int_stack+232185,int_stack+248439,21);
 /*--- compute (h0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+299805,int_stack+280695,int_stack+208245,21);
 /*--- compute (h0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+324375,int_stack+299805,int_stack+259905,21);
 /*--- compute (h0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+201630,int_stack+12516,int_stack+9660,21);
 /*--- compute (h0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+245415,int_stack+201630,int_stack+224625,21);
 /*--- compute (h0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+353481,int_stack+245415,int_stack+232185,21);
 /*--- compute (h0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+210198,int_stack+353481,int_stack+280695,21);
 /*--- compute (h0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+260535,int_stack+210198,int_stack+299805,21);
 /*--- compute (h0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+375531,int_stack+260535,int_stack+324375,21);
 /*--- compute (h0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+294933,int_stack+15729,int_stack+12516,21);
 /*--- compute (h0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+304572,int_stack+294933,int_stack+201630,21);
 /*--- compute (h0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+321708,int_stack+304572,int_stack+245415,21);
 /*--- compute (h0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+414339,int_stack+321708,int_stack+353481,21);
 /*--- compute (h0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+447414,int_stack+414339,int_stack+210198,21);
 /*--- compute (h0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+201630,int_stack+447414,int_stack+260535,21);
 /*--- compute (h0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+487545,int_stack+201630,int_stack+375531,21);
 /*--- compute (h0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+247494,int_stack+19320,int_stack+15729,21);
 /*--- compute (h0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+258267,int_stack+247494,int_stack+294933,21);
 /*--- compute (h0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+346908,int_stack+258267,int_stack+304572,21);
 /*--- compute (h0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+277545,int_stack+346908,int_stack+321708,21);
 /*--- compute (h0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+537441,int_stack+277545,int_stack+414339,21);
 /*--- compute (h0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+375468,int_stack+537441,int_stack+447414,21);
 /*--- compute (h0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+583746,int_stack+375468,int_stack+201630,21);
 /*--- compute (h0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+642714,int_stack+583746,int_stack+487545,21);
 /*--- compute (h0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+201630,int_stack+23310,int_stack+19320,21);
 /*--- compute (h0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+213600,int_stack+201630,int_stack+247494,21);
 /*--- compute (h0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+428976,int_stack+213600,int_stack+258267,21);
 /*--- compute (h0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+461106,int_stack+428976,int_stack+346908,21);
 /*--- compute (h0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+315345,int_stack+461106,int_stack+277545,21);
 /*--- compute (h0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+235146,int_stack+315345,int_stack+537441,21);
 /*--- compute (h0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+503946,int_stack+235146,int_stack+375468,21);
 /*--- compute (h0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+705084,int_stack+503946,int_stack+583746,21);
 /*--- compute (h0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+778794,int_stack+705084,int_stack+642714,21);
 /*--- compute (h0|yp) ---*/
 hrr3_build_yp(Libint->CD,int_stack+296886,int_stack+27720,int_stack+23310,21);
 /*--- compute (h0|xd) ---*/
 hrr3_build_xd(Libint->CD,int_stack+368265,int_stack+296886,int_stack+201630,21);
 /*--- compute (h0|wf) ---*/
 hrr3_build_wf(Libint->CD,int_stack+392205,int_stack+368265,int_stack+213600,21);
 /*--- compute (h0|vg) ---*/
 hrr3_build_vg(Libint->CD,int_stack+572742,int_stack+392205,int_stack+428976,21);
 /*--- compute (h0|uh) ---*/
 hrr3_build_uh(Libint->CD,int_stack+368265,int_stack+572742,int_stack+461106,21);
 /*--- compute (h0|ti) ---*/
 hrr3_build_ti(Libint->CD,int_stack+572742,int_stack+368265,int_stack+315345,21);
 /*--- compute (h0|rk) ---*/
 hrr3_build_rk(Libint->CD,int_stack+296886,int_stack+572742,int_stack+235146,21);
 /*--- compute (h0|ql) ---*/
 hrr3_build_ql(Libint->CD,int_stack+572742,int_stack+296886,int_stack+503946,21);
 /*--- compute (h0|om) ---*/
 hrr3_build_om(Libint->CD,int_stack+201630,int_stack+572742,int_stack+705084,21);
 /*--- compute (h0|nn) ---*/
 hrr3_build_nn(Libint->CD,int_stack+291720,int_stack+201630,int_stack+778794,21);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+201630,int_stack+34419,int_stack+32571,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+207174,int_stack+36603,int_stack+34419,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+213726,int_stack+207174,int_stack+201630,28);
 /*--- compute (i0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+224814,int_stack+39151,int_stack+36603,28);
 /*--- compute (i0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+232458,int_stack+224814,int_stack+207174,28);
 /*--- compute (i0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+245562,int_stack+232458,int_stack+213726,28);
 /*--- compute (i0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+201630,int_stack+42091,int_stack+39151,28);
 /*--- compute (i0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+264042,int_stack+201630,int_stack+224814,28);
 /*--- compute (i0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+210450,int_stack+264042,int_stack+232458,28);
 /*--- compute (i0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+383196,int_stack+210450,int_stack+245562,28);
 /*--- compute (i0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+232290,int_stack+45451,int_stack+42091,28);
 /*--- compute (i0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+242370,int_stack+232290,int_stack+201630,28);
 /*--- compute (i0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+410916,int_stack+242370,int_stack+264042,28);
 /*--- compute (i0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+436396,int_stack+410916,int_stack+210450,28);
 /*--- compute (i0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+469156,int_stack+436396,int_stack+383196,28);
 /*--- compute (i0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+383196,int_stack+49259,int_stack+45451,28);
 /*--- compute (i0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+201630,int_stack+383196,int_stack+232290,28);
 /*--- compute (i0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+260010,int_stack+201630,int_stack+242370,28);
 /*--- compute (i0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+221790,int_stack+260010,int_stack+410916,28);
 /*--- compute (i0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+507964,int_stack+221790,int_stack+436396,28);
 /*--- compute (i0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+394620,int_stack+507964,int_stack+469156,28);
 /*--- compute (i0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+446364,int_stack+53543,int_stack+49259,28);
 /*--- compute (i0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+459216,int_stack+446364,int_stack+383196,28);
 /*--- compute (i0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+553828,int_stack+459216,int_stack+201630,28);
 /*--- compute (i0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+587428,int_stack+553828,int_stack+260010,28);
 /*--- compute (i0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+631528,int_stack+587428,int_stack+221790,28);
 /*--- compute (i0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+201630,int_stack+631528,int_stack+507964,28);
 /*--- compute (i0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+482064,int_stack+201630,int_stack+394620,28);
 /*--- compute (i0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+262782,int_stack+58331,int_stack+53543,28);
 /*--- compute (i0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+383196,int_stack+262782,int_stack+446364,28);
 /*--- compute (i0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+408900,int_stack+383196,int_stack+459216,28);
 /*--- compute (i0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+685036,int_stack+408900,int_stack+553828,28);
 /*--- compute (i0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+735436,int_stack+685036,int_stack+587428,28);
 /*--- compute (i0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+548592,int_stack+735436,int_stack+631528,28);
 /*--- compute (i0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+797176,int_stack+548592,int_stack+201630,28);
 /*--- compute (i0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+875800,int_stack+797176,int_stack+482064,28);
 /*--- compute (i0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+201630,int_stack+63651,int_stack+58331,28);
 /*--- compute (i0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+217590,int_stack+201630,int_stack+262782,28);
 /*--- compute (i0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+246318,int_stack+217590,int_stack+383196,28);
 /*--- compute (i0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+446980,int_stack+246318,int_stack+408900,28);
 /*--- compute (i0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+958960,int_stack+446980,int_stack+685036,28);
 /*--- compute (i0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+619936,int_stack+958960,int_stack+735436,28);
 /*--- compute (i0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+702256,int_stack+619936,int_stack+548592,28);
 /*--- compute (i0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+504100,int_stack+702256,int_stack+797176,28);
 /*--- compute (i0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+1029520,int_stack+504100,int_stack+875800,28);
 /*--- compute (i0|yp) ---*/
 hrr3_build_yp(Libint->CD,int_stack+383196,int_stack+69531,int_stack+63651,28);
 /*--- compute (i0|xd) ---*/
 hrr3_build_xd(Libint->CD,int_stack+400836,int_stack+383196,int_stack+201630,28);
 /*--- compute (i0|wf) ---*/
 hrr3_build_wf(Libint->CD,int_stack+793984,int_stack+400836,int_stack+217590,28);
 /*--- compute (i0|vg) ---*/
 hrr3_build_vg(Libint->CD,int_stack+841864,int_stack+793984,int_stack+246318,28);
 /*--- compute (i0|uh) ---*/
 hrr3_build_uh(Libint->CD,int_stack+201630,int_stack+841864,int_stack+446980,28);
 /*--- compute (i0|ti) ---*/
 hrr3_build_ti(Libint->CD,int_stack+793984,int_stack+201630,int_stack+958960,28);
 /*--- compute (i0|rk) ---*/
 hrr3_build_rk(Libint->CD,int_stack+888064,int_stack+793984,int_stack+619936,28);
 /*--- compute (i0|ql) ---*/
 hrr3_build_ql(Libint->CD,int_stack+383196,int_stack+888064,int_stack+702256,28);
 /*--- compute (i0|om) ---*/
 hrr3_build_om(Libint->CD,int_stack+602380,int_stack+383196,int_stack+504100,28);
 /*--- compute (i0|nn) ---*/
 hrr3_build_nn(Libint->CD,int_stack+383196,int_stack+602380,int_stack+1029520,28);
 /*--- compute (hp|nn) ---*/
 hrr1_build_hp(Libint->AB,int_stack+505164,int_stack+383196,int_stack+291720,4356);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+779592,int_stack+78375,int_stack+75999,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+786720,int_stack+81183,int_stack+78375,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+795144,int_stack+786720,int_stack+779592,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+809400,int_stack+84459,int_stack+81183,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+819228,int_stack+809400,int_stack+786720,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+836076,int_stack+819228,int_stack+795144,36);
 /*--- compute (k0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+779592,int_stack+88239,int_stack+84459,36);
 /*--- compute (k0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+859836,int_stack+779592,int_stack+809400,36);
 /*--- compute (k0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+790932,int_stack+859836,int_stack+819228,36);
 /*--- compute (k0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+879492,int_stack+790932,int_stack+836076,36);
 /*--- compute (k0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+819012,int_stack+92559,int_stack+88239,36);
 /*--- compute (k0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+831972,int_stack+819012,int_stack+779592,36);
 /*--- compute (k0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+915132,int_stack+831972,int_stack+859836,36);
 /*--- compute (k0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+947892,int_stack+915132,int_stack+790932,36);
 /*--- compute (k0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+990012,int_stack+947892,int_stack+879492,36);
 /*--- compute (k0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+779592,int_stack+97455,int_stack+92559,36);
 /*--- compute (k0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+854652,int_stack+779592,int_stack+819012,36);
 /*--- compute (k0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1039908,int_stack+854652,int_stack+831972,36);
 /*--- compute (k0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+794280,int_stack+1039908,int_stack+915132,36);
 /*--- compute (k0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+880572,int_stack+794280,int_stack+947892,36);
 /*--- compute (k0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+201630,int_stack+880572,int_stack+990012,36);
 /*--- compute (k0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+939540,int_stack+102963,int_stack+97455,36);
 /*--- compute (k0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+956064,int_stack+939540,int_stack+779592,36);
 /*--- compute (k0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+985440,int_stack+956064,int_stack+854652,36);
 /*--- compute (k0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+268158,int_stack+985440,int_stack+1039908,36);
 /*--- compute (k0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1028640,int_stack+268158,int_stack+794280,36);
 /*--- compute (k0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+779592,int_stack+1028640,int_stack+880572,36);
 /*--- compute (k0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+0,int_stack+779592,int_stack+201630,36);
 /*--- compute (k0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+201630,int_stack+109119,int_stack+102963,36);
 /*--- compute (k0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+220098,int_stack+201630,int_stack+939540,36);
 /*--- compute (k0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+858216,int_stack+220098,int_stack+956064,36);
 /*--- compute (k0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+907176,int_stack+858216,int_stack+985440,36);
 /*--- compute (k0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+1097436,int_stack+907176,int_stack+268158,36);
 /*--- compute (k0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+253146,int_stack+1097436,int_stack+1028640,36);
 /*--- compute (k0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+971976,int_stack+253146,int_stack+779592,36);
 /*--- compute (k0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+1176816,int_stack+971976,int_stack+0,36);
 /*--- compute (k0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+0,int_stack+115959,int_stack+109119,36);
 /*--- compute (k0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+20520,int_stack+0,int_stack+201630,36);
 /*--- compute (k0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+57456,int_stack+20520,int_stack+220098,36);
 /*--- compute (k0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+779592,int_stack+57456,int_stack+858216,36);
 /*--- compute (k0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+1283736,int_stack+779592,int_stack+907176,36);
 /*--- compute (k0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+853032,int_stack+1283736,int_stack+1097436,36);
 /*--- compute (k0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+1374456,int_stack+853032,int_stack+253146,36);
 /*--- compute (k0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+201630,int_stack+1374456,int_stack+971976,36);
 /*--- compute (k0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+958872,int_stack+201630,int_stack+1176816,36);
 /*--- compute (k0|yp) ---*/
 hrr3_build_yp(Libint->CD,int_stack+327990,int_stack+123519,int_stack+115959,36);
 /*--- compute (k0|xd) ---*/
 hrr3_build_xd(Libint->CD,int_stack+1089552,int_stack+327990,int_stack+0,36);
 /*--- compute (k0|wf) ---*/
 hrr3_build_wf(Libint->CD,int_stack+1130592,int_stack+1089552,int_stack+20520,36);
 /*--- compute (k0|vg) ---*/
 hrr3_build_vg(Libint->CD,int_stack+1192152,int_stack+1130592,int_stack+57456,36);
 /*--- compute (k0|uh) ---*/
 hrr3_build_uh(Libint->CD,int_stack+0,int_stack+1192152,int_stack+779592,36);
 /*--- compute (k0|ti) ---*/
 hrr3_build_ti(Libint->CD,int_stack+1089552,int_stack+0,int_stack+1283736,36);
 /*--- compute (k0|rk) ---*/
 hrr3_build_rk(Libint->CD,int_stack+1210512,int_stack+1089552,int_stack+853032,36);
 /*--- compute (k0|ql) ---*/
 hrr3_build_ql(Libint->CD,int_stack+779592,int_stack+1210512,int_stack+1374456,36);
 /*--- compute (k0|om) ---*/
 hrr3_build_om(Libint->CD,int_stack+1089552,int_stack+779592,int_stack+201630,36);
 /*--- compute (k0|nn) ---*/
 hrr3_build_nn(Libint->CD,int_stack+201630,int_stack+1089552,int_stack+958872,36);
 /*--- compute (ip|nn) ---*/
 hrr1_build_ip(Libint->AB,int_stack+779592,int_stack+201630,int_stack+383196,4356);
 /*--- compute (hd|nn) ---*/
 hrr1_build_hd(Libint->AB,int_stack+1145496,int_stack+779592,int_stack+505164,4356);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+358446,int_stack+134805,int_stack+131835,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+367356,int_stack+138315,int_stack+134805,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+377886,int_stack+367356,int_stack+358446,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+395706,int_stack+142410,int_stack+138315,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+407991,int_stack+395706,int_stack+367356,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+429051,int_stack+407991,int_stack+377886,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+358446,int_stack+147135,int_stack+142410,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+458751,int_stack+358446,int_stack+395706,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+372621,int_stack+458751,int_stack+407991,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+483321,int_stack+372621,int_stack+429051,45);
 /*--- compute (l0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+407721,int_stack+152535,int_stack+147135,45);
 /*--- compute (l0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+423921,int_stack+407721,int_stack+358446,45);
 /*--- compute (l0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+527871,int_stack+423921,int_stack+458751,45);
 /*--- compute (l0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+568821,int_stack+527871,int_stack+372621,45);
 /*--- compute (l0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+621471,int_stack+568821,int_stack+483321,45);
 /*--- compute (l0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+358446,int_stack+158655,int_stack+152535,45);
 /*--- compute (l0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+452271,int_stack+358446,int_stack+407721,45);
 /*--- compute (l0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+683841,int_stack+452271,int_stack+423921,45);
 /*--- compute (l0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+376806,int_stack+683841,int_stack+527871,45);
 /*--- compute (l0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+484671,int_stack+376806,int_stack+568821,45);
 /*--- compute (l0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+0,int_stack+484671,int_stack+621471,45);
 /*--- compute (l0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+558381,int_stack+165540,int_stack+158655,45);
 /*--- compute (l0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+579036,int_stack+558381,int_stack+358446,45);
 /*--- compute (l0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+615756,int_stack+579036,int_stack+452271,45);
 /*--- compute (l0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+83160,int_stack+615756,int_stack+683841,45);
 /*--- compute (l0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+669756,int_stack+83160,int_stack+376806,45);
 /*--- compute (l0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+358446,int_stack+669756,int_stack+484671,45);
 /*--- compute (l0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1694352,int_stack+358446,int_stack+0,45);
 /*--- compute (l0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+0,int_stack+173235,int_stack+165540,45);
 /*--- compute (l0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+23085,int_stack+0,int_stack+558381,45);
 /*--- compute (l0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+456726,int_stack+23085,int_stack+579036,45);
 /*--- compute (l0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+517926,int_stack+456726,int_stack+615756,45);
 /*--- compute (l0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+1801272,int_stack+517926,int_stack+83160,45);
 /*--- compute (l0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+1900497,int_stack+1801272,int_stack+669756,45);
 /*--- compute (l0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+598926,int_stack+1900497,int_stack+358446,45);
 /*--- compute (l0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+2015157,int_stack+598926,int_stack+1694352,45);
 /*--- compute (l0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+1694352,int_stack+181785,int_stack+173235,45);
 /*--- compute (l0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+1720002,int_stack+1694352,int_stack+0,45);
 /*--- compute (l0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+358446,int_stack+1720002,int_stack+23085,45);
 /*--- compute (l0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+0,int_stack+358446,int_stack+456726,45);
 /*--- compute (l0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+2148807,int_stack+0,int_stack+517926,45);
 /*--- compute (l0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+427296,int_stack+2148807,int_stack+1801272,45);
 /*--- compute (l0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+2262207,int_stack+427296,int_stack+1900497,45);
 /*--- compute (l0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+1766172,int_stack+2262207,int_stack+598926,45);
 /*--- compute (l0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+559596,int_stack+1766172,int_stack+2015157,45);
 /*--- compute (l0|yp) ---*/
 hrr3_build_yp(Libint->CD,int_stack+91800,int_stack+191235,int_stack+181785,45);
 /*--- compute (l0|xd) ---*/
 hrr3_build_xd(Libint->CD,int_stack+120150,int_stack+91800,int_stack+1694352,45);
 /*--- compute (l0|wf) ---*/
 hrr3_build_wf(Libint->CD,int_stack+1924122,int_stack+120150,int_stack+1720002,45);
 /*--- compute (l0|vg) ---*/
 hrr3_build_vg(Libint->CD,int_stack+91800,int_stack+1924122,int_stack+358446,45);
 /*--- compute (l0|uh) ---*/
 hrr3_build_uh(Libint->CD,int_stack+1924122,int_stack+91800,int_stack+0,45);
 /*--- compute (l0|ti) ---*/
 hrr3_build_ti(Libint->CD,int_stack+0,int_stack+1924122,int_stack+2148807,45);
 /*--- compute (l0|rk) ---*/
 hrr3_build_rk(Libint->CD,int_stack+1924122,int_stack+0,int_stack+427296,45);
 /*--- compute (l0|ql) ---*/
 hrr3_build_ql(Libint->CD,int_stack+0,int_stack+1924122,int_stack+2262207,45);
 /*--- compute (l0|om) ---*/
 hrr3_build_om(Libint->CD,int_stack+1924122,int_stack+0,int_stack+1766172,45);
 /*--- compute (l0|nn) ---*/
 hrr3_build_nn(Libint->CD,int_stack+0,int_stack+1924122,int_stack+559596,45);
 /*--- compute (kp|nn) ---*/
 hrr1_build_kp(Libint->AB,int_stack+1694352,int_stack+0,int_stack+201630,4356);
 /*--- compute (id|nn) ---*/
 hrr1_build_id(Libint->AB,int_stack+0,int_stack+1694352,int_stack+779592,4356);
 /*--- compute (hf|nn) ---*/
 hrr1_build_hf(Libint->AB,int_stack+1694352,int_stack+0,int_stack+1145496,4356);
 return int_stack+1694352;}
