/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_hglf(Libint_t*, prim_data*);

  /* Computes quartets of (hg|lf) integrals */

REALTYPE *hrr_order_hglf(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[5][8] = int_stack + 0;
 Libint->vrr_classes[5][9] = int_stack + 945;
 Libint->vrr_classes[5][10] = int_stack + 2100;
 Libint->vrr_classes[5][11] = int_stack + 3486;
 Libint->vrr_classes[6][8] = int_stack + 5124;
 Libint->vrr_classes[6][9] = int_stack + 6384;
 Libint->vrr_classes[6][10] = int_stack + 7924;
 Libint->vrr_classes[6][11] = int_stack + 9772;
 Libint->vrr_classes[7][8] = int_stack + 11956;
 Libint->vrr_classes[7][9] = int_stack + 13576;
 Libint->vrr_classes[7][10] = int_stack + 15556;
 Libint->vrr_classes[7][11] = int_stack + 17932;
 Libint->vrr_classes[8][8] = int_stack + 20740;
 Libint->vrr_classes[8][9] = int_stack + 22765;
 Libint->vrr_classes[8][10] = int_stack + 25240;
 Libint->vrr_classes[8][11] = int_stack + 28210;
 Libint->vrr_classes[9][8] = int_stack + 31720;
 Libint->vrr_classes[9][9] = int_stack + 34195;
 Libint->vrr_classes[9][10] = int_stack + 37220;
 Libint->vrr_classes[9][11] = int_stack + 40850;
 memset(int_stack,0,45140*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 45140;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_hglf(Libint, Data);
   Data++;
 }
 /*--- compute (h0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+45140,int_stack+945,int_stack+0,21);
 /*--- compute (h0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+47975,int_stack+2100,int_stack+945,21);
 /*--- compute (h0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+51440,int_stack+47975,int_stack+45140,21);
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+57110,int_stack+3486,int_stack+2100,21);
 /*--- compute (h0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+61268,int_stack+57110,int_stack+47975,21);
 /*--- compute (h0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+68198,int_stack+61268,int_stack+51440,21);
 /*--- compute (i0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+45140,int_stack+6384,int_stack+5124,28);
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+48920,int_stack+7924,int_stack+6384,28);
 /*--- compute (i0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+53540,int_stack+48920,int_stack+45140,28);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+61100,int_stack+9772,int_stack+7924,28);
 /*--- compute (i0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+0,int_stack+61100,int_stack+48920,28);
 /*--- compute (i0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+77648,int_stack+0,int_stack+53540,28);
 /*--- compute (hp|lf) ---*/
 hrr1_build_hp(Libint->AB,int_stack+90248,int_stack+77648,int_stack+68198,450);
 /*--- compute (k0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+0,int_stack+13576,int_stack+11956,36);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+4860,int_stack+15556,int_stack+13576,36);
 /*--- compute (k0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+45140,int_stack+4860,int_stack+0,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+54860,int_stack+17932,int_stack+15556,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+61988,int_stack+54860,int_stack+4860,36);
 /*--- compute (k0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+0,int_stack+61988,int_stack+45140,36);
 /*--- compute (ip|lf) ---*/
 hrr1_build_ip(Libint->AB,int_stack+118598,int_stack+0,int_stack+77648,450);
 /*--- compute (hd|lf) ---*/
 hrr1_build_hd(Libint->AB,int_stack+156398,int_stack+118598,int_stack+90248,450);
 /*--- compute (l0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+45140,int_stack+22765,int_stack+20740,45);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+51215,int_stack+25240,int_stack+22765,45);
 /*--- compute (l0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+58640,int_stack+51215,int_stack+45140,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+70790,int_stack+28210,int_stack+25240,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+79700,int_stack+70790,int_stack+51215,45);
 /*--- compute (l0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+94550,int_stack+79700,int_stack+58640,45);
 /*--- compute (kp|lf) ---*/
 hrr1_build_kp(Libint->AB,int_stack+45140,int_stack+94550,int_stack+0,450);
 /*--- compute (id|lf) ---*/
 hrr1_build_id(Libint->AB,int_stack+213098,int_stack+45140,int_stack+118598,450);
 /*--- compute (hf|lf) ---*/
 hrr1_build_hf(Libint->AB,int_stack+288698,int_stack+213098,int_stack+156398,450);
 /*--- compute (m0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+0,int_stack+34195,int_stack+31720,55);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+7425,int_stack+37220,int_stack+34195,55);
 /*--- compute (m0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+16500,int_stack+7425,int_stack+0,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+114800,int_stack+40850,int_stack+37220,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+125690,int_stack+114800,int_stack+7425,55);
 /*--- compute (m0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+143840,int_stack+125690,int_stack+16500,55);
 /*--- compute (lp|lf) ---*/
 hrr1_build_lp(Libint->AB,int_stack+383198,int_stack+143840,int_stack+94550,450);
 /*--- compute (kd|lf) ---*/
 hrr1_build_kd(Libint->AB,int_stack+93740,int_stack+383198,int_stack+45140,450);
 /*--- compute (if|lf) ---*/
 hrr1_build_if(Libint->AB,int_stack+383198,int_stack+93740,int_stack+213098,450);
 /*--- compute (hg|lf) ---*/
 hrr1_build_hg(Libint->AB,int_stack+0,int_stack+383198,int_stack+288698,450);
 return int_stack+0;}
