/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_hglp(Libint_t*, prim_data*);

  /* Computes quartets of (hg|lp) integrals */

REALTYPE *hrr_order_hglp(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[5][8] = int_stack + 0;
 Libint->vrr_classes[5][9] = int_stack + 945;
 Libint->vrr_classes[6][8] = int_stack + 2100;
 Libint->vrr_classes[6][9] = int_stack + 3360;
 Libint->vrr_classes[7][8] = int_stack + 4900;
 Libint->vrr_classes[7][9] = int_stack + 6520;
 Libint->vrr_classes[8][8] = int_stack + 8500;
 Libint->vrr_classes[8][9] = int_stack + 10525;
 Libint->vrr_classes[9][8] = int_stack + 13000;
 Libint->vrr_classes[9][9] = int_stack + 15475;
 memset(int_stack,0,18500*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 18500;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_hglp(Libint, Data);
   Data++;
 }
 /*--- compute (h0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+18500,int_stack+945,int_stack+0,21);
 /*--- compute (i0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+21335,int_stack+3360,int_stack+2100,28);
 /*--- compute (hp|lp) ---*/
 hrr1_build_hp(Libint->AB,int_stack+25115,int_stack+21335,int_stack+18500,135);
 /*--- compute (k0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+0,int_stack+6520,int_stack+4900,36);
 /*--- compute (ip|lp) ---*/
 hrr1_build_ip(Libint->AB,int_stack+33620,int_stack+0,int_stack+21335,135);
 /*--- compute (hd|lp) ---*/
 hrr1_build_hd(Libint->AB,int_stack+44960,int_stack+33620,int_stack+25115,135);
 /*--- compute (l0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+18500,int_stack+10525,int_stack+8500,45);
 /*--- compute (kp|lp) ---*/
 hrr1_build_kp(Libint->AB,int_stack+61970,int_stack+18500,int_stack+0,135);
 /*--- compute (id|lp) ---*/
 hrr1_build_id(Libint->AB,int_stack+76550,int_stack+61970,int_stack+33620,135);
 /*--- compute (hf|lp) ---*/
 hrr1_build_hf(Libint->AB,int_stack+99230,int_stack+76550,int_stack+44960,135);
 /*--- compute (m0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+0,int_stack+15475,int_stack+13000,55);
 /*--- compute (lp|lp) ---*/
 hrr1_build_lp(Libint->AB,int_stack+24575,int_stack+0,int_stack+18500,135);
 /*--- compute (kd|lp) ---*/
 hrr1_build_kd(Libint->AB,int_stack+127580,int_stack+24575,int_stack+61970,135);
 /*--- compute (if|lp) ---*/
 hrr1_build_if(Libint->AB,int_stack+0,int_stack+127580,int_stack+76550,135);
 /*--- compute (hg|lp) ---*/
 hrr1_build_hg(Libint->AB,int_stack+37800,int_stack+0,int_stack+99230,135);
 return int_stack+37800;}
