/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_hgmd(Libint_t*, prim_data*);

  /* Computes quartets of (hg|md) integrals */

REALTYPE *hrr_order_hgmd(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[5][9] = int_stack + 0;
 Libint->vrr_classes[5][10] = int_stack + 1155;
 Libint->vrr_classes[5][11] = int_stack + 2541;
 Libint->vrr_classes[6][9] = int_stack + 4179;
 Libint->vrr_classes[6][10] = int_stack + 5719;
 Libint->vrr_classes[6][11] = int_stack + 7567;
 Libint->vrr_classes[7][9] = int_stack + 9751;
 Libint->vrr_classes[7][10] = int_stack + 11731;
 Libint->vrr_classes[7][11] = int_stack + 14107;
 Libint->vrr_classes[8][9] = int_stack + 16915;
 Libint->vrr_classes[8][10] = int_stack + 19390;
 Libint->vrr_classes[8][11] = int_stack + 22360;
 Libint->vrr_classes[9][9] = int_stack + 25870;
 Libint->vrr_classes[9][10] = int_stack + 28895;
 Libint->vrr_classes[9][11] = int_stack + 32525;
 memset(int_stack,0,36815*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 36815;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_hgmd(Libint, Data);
   Data++;
 }
 /*--- compute (h0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+36815,int_stack+1155,int_stack+0,21);
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+40280,int_stack+2541,int_stack+1155,21);
 /*--- compute (h0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+44438,int_stack+40280,int_stack+36815,21);
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+36815,int_stack+5719,int_stack+4179,28);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+7567,int_stack+5719,28);
 /*--- compute (i0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+51368,int_stack+0,int_stack+36815,28);
 /*--- compute (hp|md) ---*/
 hrr1_build_hp(Libint->AB,int_stack+60608,int_stack+51368,int_stack+44438,330);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+36815,int_stack+11731,int_stack+9751,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+42755,int_stack+14107,int_stack+11731,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+0,int_stack+42755,int_stack+36815,36);
 /*--- compute (ip|md) ---*/
 hrr1_build_ip(Libint->AB,int_stack+81398,int_stack+0,int_stack+51368,330);
 /*--- compute (hd|md) ---*/
 hrr1_build_hd(Libint->AB,int_stack+109118,int_stack+81398,int_stack+60608,330);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+36815,int_stack+19390,int_stack+16915,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+44240,int_stack+22360,int_stack+19390,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+53150,int_stack+44240,int_stack+36815,45);
 /*--- compute (kp|md) ---*/
 hrr1_build_kp(Libint->AB,int_stack+150698,int_stack+53150,int_stack+0,330);
 /*--- compute (id|md) ---*/
 hrr1_build_id(Libint->AB,int_stack+186338,int_stack+150698,int_stack+81398,330);
 /*--- compute (hf|md) ---*/
 hrr1_build_hf(Libint->AB,int_stack+241778,int_stack+186338,int_stack+109118,330);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+0,int_stack+28895,int_stack+25870,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+9075,int_stack+32525,int_stack+28895,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+19965,int_stack+9075,int_stack+0,55);
 /*--- compute (lp|md) ---*/
 hrr1_build_lp(Libint->AB,int_stack+68000,int_stack+19965,int_stack+53150,330);
 /*--- compute (kd|md) ---*/
 hrr1_build_kd(Libint->AB,int_stack+311078,int_stack+68000,int_stack+150698,330);
 /*--- compute (if|md) ---*/
 hrr1_build_if(Libint->AB,int_stack+0,int_stack+311078,int_stack+186338,330);
 /*--- compute (hg|md) ---*/
 hrr1_build_hg(Libint->AB,int_stack+92400,int_stack+0,int_stack+241778,330);
 return int_stack+92400;}
