/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_hgnk(Libint_t*, prim_data*);

  /* Computes quartets of (hg|nk) integrals */

REALTYPE *hrr_order_hgnk(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[5][10] = int_stack + 0;
 Libint->vrr_classes[5][11] = int_stack + 1386;
 Libint->vrr_classes[5][12] = int_stack + 3024;
 Libint->vrr_classes[5][13] = int_stack + 4935;
 Libint->vrr_classes[5][14] = int_stack + 7140;
 Libint->vrr_classes[5][15] = int_stack + 9660;
 Libint->vrr_classes[5][16] = int_stack + 12516;
 Libint->vrr_classes[5][17] = int_stack + 15729;
 Libint->vrr_classes[6][10] = int_stack + 19320;
 Libint->vrr_classes[6][11] = int_stack + 21168;
 Libint->vrr_classes[6][12] = int_stack + 23352;
 Libint->vrr_classes[6][13] = int_stack + 25900;
 Libint->vrr_classes[6][14] = int_stack + 28840;
 Libint->vrr_classes[6][15] = int_stack + 32200;
 Libint->vrr_classes[6][16] = int_stack + 36008;
 Libint->vrr_classes[6][17] = int_stack + 40292;
 Libint->vrr_classes[7][10] = int_stack + 45080;
 Libint->vrr_classes[7][11] = int_stack + 47456;
 Libint->vrr_classes[7][12] = int_stack + 50264;
 Libint->vrr_classes[7][13] = int_stack + 53540;
 Libint->vrr_classes[7][14] = int_stack + 57320;
 Libint->vrr_classes[7][15] = int_stack + 61640;
 Libint->vrr_classes[7][16] = int_stack + 66536;
 Libint->vrr_classes[7][17] = int_stack + 72044;
 Libint->vrr_classes[8][10] = int_stack + 78200;
 Libint->vrr_classes[8][11] = int_stack + 81170;
 Libint->vrr_classes[8][12] = int_stack + 84680;
 Libint->vrr_classes[8][13] = int_stack + 88775;
 Libint->vrr_classes[8][14] = int_stack + 93500;
 Libint->vrr_classes[8][15] = int_stack + 98900;
 Libint->vrr_classes[8][16] = int_stack + 105020;
 Libint->vrr_classes[8][17] = int_stack + 111905;
 Libint->vrr_classes[9][10] = int_stack + 119600;
 Libint->vrr_classes[9][11] = int_stack + 123230;
 Libint->vrr_classes[9][12] = int_stack + 127520;
 Libint->vrr_classes[9][13] = int_stack + 132525;
 Libint->vrr_classes[9][14] = int_stack + 138300;
 Libint->vrr_classes[9][15] = int_stack + 144900;
 Libint->vrr_classes[9][16] = int_stack + 152380;
 Libint->vrr_classes[9][17] = int_stack + 160795;
 memset(int_stack,0,170200*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 170200;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_hgnk(Libint, Data);
   Data++;
 }
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+170200,int_stack+1386,int_stack+0,21);
 /*--- compute (h0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+174358,int_stack+3024,int_stack+1386,21);
 /*--- compute (h0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+179272,int_stack+174358,int_stack+170200,21);
 /*--- compute (h0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+187588,int_stack+4935,int_stack+3024,21);
 /*--- compute (h0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+193321,int_stack+187588,int_stack+174358,21);
 /*--- compute (h0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+203149,int_stack+193321,int_stack+179272,21);
 /*--- compute (h0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+170200,int_stack+7140,int_stack+4935,21);
 /*--- compute (h0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+217009,int_stack+170200,int_stack+187588,21);
 /*--- compute (h0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+176815,int_stack+217009,int_stack+193321,21);
 /*--- compute (h0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+228475,int_stack+176815,int_stack+203149,21);
 /*--- compute (h0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+193195,int_stack+9660,int_stack+7140,21);
 /*--- compute (h0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+200755,int_stack+193195,int_stack+170200,21);
 /*--- compute (h0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+249265,int_stack+200755,int_stack+217009,21);
 /*--- compute (h0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+268375,int_stack+249265,int_stack+176815,21);
 /*--- compute (h0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+292945,int_stack+268375,int_stack+228475,21);
 /*--- compute (h0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+170200,int_stack+12516,int_stack+9660,21);
 /*--- compute (h0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+213985,int_stack+170200,int_stack+193195,21);
 /*--- compute (h0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+322051,int_stack+213985,int_stack+200755,21);
 /*--- compute (h0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+178768,int_stack+322051,int_stack+249265,21);
 /*--- compute (h0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+229105,int_stack+178768,int_stack+268375,21);
 /*--- compute (h0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+344101,int_stack+229105,int_stack+292945,21);
 /*--- compute (h0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+263503,int_stack+15729,int_stack+12516,21);
 /*--- compute (h0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+273142,int_stack+263503,int_stack+170200,21);
 /*--- compute (h0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+290278,int_stack+273142,int_stack+213985,21);
 /*--- compute (h0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+382909,int_stack+290278,int_stack+322051,21);
 /*--- compute (h0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+263503,int_stack+382909,int_stack+178768,21);
 /*--- compute (h0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+170200,int_stack+263503,int_stack+229105,21);
 /*--- compute (h0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+216064,int_stack+170200,int_stack+344101,21);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+170200,int_stack+21168,int_stack+19320,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+175744,int_stack+23352,int_stack+21168,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+182296,int_stack+175744,int_stack+170200,28);
 /*--- compute (i0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+193384,int_stack+25900,int_stack+23352,28);
 /*--- compute (i0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+201028,int_stack+193384,int_stack+175744,28);
 /*--- compute (i0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+265960,int_stack+201028,int_stack+182296,28);
 /*--- compute (i0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+170200,int_stack+28840,int_stack+25900,28);
 /*--- compute (i0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+284440,int_stack+170200,int_stack+193384,28);
 /*--- compute (i0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+179020,int_stack+284440,int_stack+201028,28);
 /*--- compute (i0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+299728,int_stack+179020,int_stack+265960,28);
 /*--- compute (i0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+265960,int_stack+32200,int_stack+28840,28);
 /*--- compute (i0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+327448,int_stack+265960,int_stack+170200,28);
 /*--- compute (i0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+345088,int_stack+327448,int_stack+284440,28);
 /*--- compute (i0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+370568,int_stack+345088,int_stack+179020,28);
 /*--- compute (i0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+170200,int_stack+370568,int_stack+299728,28);
 /*--- compute (i0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+276040,int_stack+36008,int_stack+32200,28);
 /*--- compute (i0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+287464,int_stack+276040,int_stack+265960,28);
 /*--- compute (i0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+0,int_stack+287464,int_stack+327448,28);
 /*--- compute (i0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+403328,int_stack+0,int_stack+345088,28);
 /*--- compute (i0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+307624,int_stack+403328,int_stack+370568,28);
 /*--- compute (i0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+441548,int_stack+307624,int_stack+170200,28);
 /*--- compute (i0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+170200,int_stack+40292,int_stack+36008,28);
 /*--- compute (i0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+183052,int_stack+170200,int_stack+276040,28);
 /*--- compute (i0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+353488,int_stack+183052,int_stack+287464,28);
 /*--- compute (i0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+170200,int_stack+353488,int_stack+0,28);
 /*--- compute (i0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+493292,int_stack+170200,int_stack+403328,28);
 /*--- compute (i0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+353488,int_stack+493292,int_stack+307624,28);
 /*--- compute (i0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+265960,int_stack+353488,int_stack+441548,28);
 /*--- compute (hp|nk) ---*/
 hrr1_build_hp(Libint->AB,int_stack+332488,int_stack+265960,int_stack+216064,2376);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+170200,int_stack+47456,int_stack+45080,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+177328,int_stack+50264,int_stack+47456,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+185752,int_stack+177328,int_stack+170200,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+200008,int_stack+53540,int_stack+50264,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+209836,int_stack+200008,int_stack+177328,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+226684,int_stack+209836,int_stack+185752,36);
 /*--- compute (k0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+170200,int_stack+57320,int_stack+53540,36);
 /*--- compute (k0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+0,int_stack+170200,int_stack+200008,36);
 /*--- compute (k0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+181540,int_stack+0,int_stack+209836,36);
 /*--- compute (k0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+19656,int_stack+181540,int_stack+226684,36);
 /*--- compute (k0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+209620,int_stack+61640,int_stack+57320,36);
 /*--- compute (k0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+222580,int_stack+209620,int_stack+170200,36);
 /*--- compute (k0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+482176,int_stack+222580,int_stack+0,36);
 /*--- compute (k0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+514936,int_stack+482176,int_stack+181540,36);
 /*--- compute (k0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+557056,int_stack+514936,int_stack+19656,36);
 /*--- compute (k0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+0,int_stack+66536,int_stack+61640,36);
 /*--- compute (k0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+14688,int_stack+0,int_stack+209620,36);
 /*--- compute (k0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+170200,int_stack+14688,int_stack+222580,36);
 /*--- compute (k0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+208000,int_stack+170200,int_stack+482176,36);
 /*--- compute (k0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+606952,int_stack+208000,int_stack+514936,36);
 /*--- compute (k0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+482176,int_stack+606952,int_stack+557056,36);
 /*--- compute (k0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+548704,int_stack+72044,int_stack+66536,36);
 /*--- compute (k0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+565228,int_stack+548704,int_stack+0,36);
 /*--- compute (k0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+665920,int_stack+565228,int_stack+14688,36);
 /*--- compute (k0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+0,int_stack+665920,int_stack+170200,36);
 /*--- compute (k0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+665920,int_stack+0,int_stack+208000,36);
 /*--- compute (k0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+170200,int_stack+665920,int_stack+606952,36);
 /*--- compute (k0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+548704,int_stack+170200,int_stack+482176,36);
 /*--- compute (ip|nk) ---*/
 hrr1_build_ip(Libint->AB,int_stack+634240,int_stack+548704,int_stack+265960,2376);
 /*--- compute (hd|nk) ---*/
 hrr1_build_hd(Libint->AB,int_stack+833824,int_stack+634240,int_stack+332488,2376);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+170200,int_stack+81170,int_stack+78200,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+179110,int_stack+84680,int_stack+81170,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+189640,int_stack+179110,int_stack+170200,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+207460,int_stack+88775,int_stack+84680,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+219745,int_stack+207460,int_stack+179110,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+240805,int_stack+219745,int_stack+189640,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+170200,int_stack+93500,int_stack+88775,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+270505,int_stack+170200,int_stack+207460,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+184375,int_stack+270505,int_stack+219745,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+295075,int_stack+184375,int_stack+240805,45);
 /*--- compute (l0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+219475,int_stack+98900,int_stack+93500,45);
 /*--- compute (l0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+235675,int_stack+219475,int_stack+170200,45);
 /*--- compute (l0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+339625,int_stack+235675,int_stack+270505,45);
 /*--- compute (l0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+380575,int_stack+339625,int_stack+184375,45);
 /*--- compute (l0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+433225,int_stack+380575,int_stack+295075,45);
 /*--- compute (l0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+170200,int_stack+105020,int_stack+98900,45);
 /*--- compute (l0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+264025,int_stack+170200,int_stack+219475,45);
 /*--- compute (l0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+495595,int_stack+264025,int_stack+235675,45);
 /*--- compute (l0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+188560,int_stack+495595,int_stack+339625,45);
 /*--- compute (l0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+296425,int_stack+188560,int_stack+380575,45);
 /*--- compute (l0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+0,int_stack+296425,int_stack+433225,45);
 /*--- compute (l0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+370135,int_stack+111905,int_stack+105020,45);
 /*--- compute (l0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+390790,int_stack+370135,int_stack+170200,45);
 /*--- compute (l0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+427510,int_stack+390790,int_stack+264025,45);
 /*--- compute (l0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1133200,int_stack+427510,int_stack+495595,45);
 /*--- compute (l0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+370135,int_stack+1133200,int_stack+188560,45);
 /*--- compute (l0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+170200,int_stack+370135,int_stack+296425,45);
 /*--- compute (l0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+268480,int_stack+170200,int_stack+0,45);
 /*--- compute (kp|nk) ---*/
 hrr1_build_kp(Libint->AB,int_stack+1133200,int_stack+268480,int_stack+548704,2376);
 /*--- compute (id|nk) ---*/
 hrr1_build_id(Libint->AB,int_stack+1389808,int_stack+1133200,int_stack+634240,2376);
 /*--- compute (hf|nk) ---*/
 hrr1_build_hf(Libint->AB,int_stack+1788976,int_stack+1389808,int_stack+833824,2376);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+123230,int_stack+119600,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+10890,int_stack+127520,int_stack+123230,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+23760,int_stack+10890,int_stack+0,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+45540,int_stack+132525,int_stack+127520,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+60555,int_stack+45540,int_stack+10890,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+86295,int_stack+60555,int_stack+23760,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+138300,int_stack+132525,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+170200,int_stack+0,int_stack+45540,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+17325,int_stack+170200,int_stack+60555,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+200230,int_stack+17325,int_stack+86295,55);
 /*--- compute (m0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+60225,int_stack+144900,int_stack+138300,55);
 /*--- compute (m0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+80025,int_stack+60225,int_stack+0,55);
 /*--- compute (m0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+375400,int_stack+80025,int_stack+170200,55);
 /*--- compute (m0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+425450,int_stack+375400,int_stack+17325,55);
 /*--- compute (m0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+489800,int_stack+425450,int_stack+200230,55);
 /*--- compute (m0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+170200,int_stack+152380,int_stack+144900,55);
 /*--- compute (m0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+192640,int_stack+170200,int_stack+60225,55);
 /*--- compute (m0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+0,int_stack+192640,int_stack+80025,55);
 /*--- compute (m0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+57750,int_stack+0,int_stack+375400,55);
 /*--- compute (m0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+566030,int_stack+57750,int_stack+425450,55);
 /*--- compute (m0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+375400,int_stack+566030,int_stack+489800,55);
 /*--- compute (m0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+477040,int_stack+160795,int_stack+152380,55);
 /*--- compute (m0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+502285,int_stack+477040,int_stack+170200,55);
 /*--- compute (m0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+656120,int_stack+502285,int_stack+192640,55);
 /*--- compute (m0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+477040,int_stack+656120,int_stack+0,55);
 /*--- compute (m0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+656120,int_stack+477040,int_stack+57750,55);
 /*--- compute (m0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+0,int_stack+656120,int_stack+566030,55);
 /*--- compute (m0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+477040,int_stack+0,int_stack+375400,55);
 /*--- compute (lp|nk) ---*/
 hrr1_build_lp(Libint->AB,int_stack+607720,int_stack+477040,int_stack+268480,2376);
 /*--- compute (kd|nk) ---*/
 hrr1_build_kd(Libint->AB,int_stack+0,int_stack+607720,int_stack+1133200,2376);
 /*--- compute (if|nk) ---*/
 hrr1_build_if(Libint->AB,int_stack+513216,int_stack+0,int_stack+1389808,2376);
 /*--- compute (hg|nk) ---*/
 hrr1_build_hg(Libint->AB,int_stack+2287936,int_stack+513216,int_stack+1788976,2376);
 return int_stack+2287936;}
