/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_hhng(Libint_t*, prim_data*);

  /* Computes quartets of (hh|ng) integrals */

REALTYPE *hrr_order_hhng(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[5][10] = int_stack + 0;
 Libint->vrr_classes[5][11] = int_stack + 1386;
 Libint->vrr_classes[5][12] = int_stack + 3024;
 Libint->vrr_classes[5][13] = int_stack + 4935;
 Libint->vrr_classes[5][14] = int_stack + 7140;
 Libint->vrr_classes[6][10] = int_stack + 9660;
 Libint->vrr_classes[6][11] = int_stack + 11508;
 Libint->vrr_classes[6][12] = int_stack + 13692;
 Libint->vrr_classes[6][13] = int_stack + 16240;
 Libint->vrr_classes[6][14] = int_stack + 19180;
 Libint->vrr_classes[7][10] = int_stack + 22540;
 Libint->vrr_classes[7][11] = int_stack + 24916;
 Libint->vrr_classes[7][12] = int_stack + 27724;
 Libint->vrr_classes[7][13] = int_stack + 31000;
 Libint->vrr_classes[7][14] = int_stack + 34780;
 Libint->vrr_classes[8][10] = int_stack + 39100;
 Libint->vrr_classes[8][11] = int_stack + 42070;
 Libint->vrr_classes[8][12] = int_stack + 45580;
 Libint->vrr_classes[8][13] = int_stack + 49675;
 Libint->vrr_classes[8][14] = int_stack + 54400;
 Libint->vrr_classes[9][10] = int_stack + 59800;
 Libint->vrr_classes[9][11] = int_stack + 63430;
 Libint->vrr_classes[9][12] = int_stack + 67720;
 Libint->vrr_classes[9][13] = int_stack + 72725;
 Libint->vrr_classes[9][14] = int_stack + 78500;
 Libint->vrr_classes[10][10] = int_stack + 85100;
 Libint->vrr_classes[10][11] = int_stack + 89456;
 Libint->vrr_classes[10][12] = int_stack + 94604;
 Libint->vrr_classes[10][13] = int_stack + 100610;
 Libint->vrr_classes[10][14] = int_stack + 107540;
 memset(int_stack,0,115460*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 115460;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_hhng(Libint, Data);
   Data++;
 }
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+115460,int_stack+1386,int_stack+0,21);
 /*--- compute (h0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+119618,int_stack+3024,int_stack+1386,21);
 /*--- compute (h0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+124532,int_stack+119618,int_stack+115460,21);
 /*--- compute (h0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+132848,int_stack+4935,int_stack+3024,21);
 /*--- compute (h0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+138581,int_stack+132848,int_stack+119618,21);
 /*--- compute (h0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+148409,int_stack+138581,int_stack+124532,21);
 /*--- compute (h0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+115460,int_stack+7140,int_stack+4935,21);
 /*--- compute (h0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+162269,int_stack+115460,int_stack+132848,21);
 /*--- compute (h0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+115460,int_stack+162269,int_stack+138581,21);
 /*--- compute (h0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+162269,int_stack+115460,int_stack+148409,21);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+115460,int_stack+11508,int_stack+9660,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+121004,int_stack+13692,int_stack+11508,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+127556,int_stack+121004,int_stack+115460,28);
 /*--- compute (i0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+138644,int_stack+16240,int_stack+13692,28);
 /*--- compute (i0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+146288,int_stack+138644,int_stack+121004,28);
 /*--- compute (i0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+183059,int_stack+146288,int_stack+127556,28);
 /*--- compute (i0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+115460,int_stack+19180,int_stack+16240,28);
 /*--- compute (i0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+0,int_stack+115460,int_stack+138644,28);
 /*--- compute (i0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+115460,int_stack+0,int_stack+146288,28);
 /*--- compute (i0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+201539,int_stack+115460,int_stack+183059,28);
 /*--- compute (hp|ng) ---*/
 hrr1_build_hp(Libint->AB,int_stack+229259,int_stack+201539,int_stack+162269,990);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+115460,int_stack+24916,int_stack+22540,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+122588,int_stack+27724,int_stack+24916,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+131012,int_stack+122588,int_stack+115460,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+145268,int_stack+31000,int_stack+27724,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+155096,int_stack+145268,int_stack+122588,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+171944,int_stack+155096,int_stack+131012,36);
 /*--- compute (k0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+115460,int_stack+34780,int_stack+31000,36);
 /*--- compute (k0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+0,int_stack+115460,int_stack+145268,36);
 /*--- compute (k0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+115460,int_stack+0,int_stack+155096,36);
 /*--- compute (k0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+0,int_stack+115460,int_stack+171944,36);
 /*--- compute (ip|ng) ---*/
 hrr1_build_ip(Libint->AB,int_stack+115460,int_stack+0,int_stack+201539,990);
 /*--- compute (hd|ng) ---*/
 hrr1_build_hd(Libint->AB,int_stack+291629,int_stack+115460,int_stack+229259,990);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+198620,int_stack+42070,int_stack+39100,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+207530,int_stack+45580,int_stack+42070,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+218060,int_stack+207530,int_stack+198620,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+235880,int_stack+49675,int_stack+45580,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+248165,int_stack+235880,int_stack+207530,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+416369,int_stack+248165,int_stack+218060,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+198620,int_stack+54400,int_stack+49675,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+446069,int_stack+198620,int_stack+235880,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+198620,int_stack+446069,int_stack+248165,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+233720,int_stack+198620,int_stack+416369,45);
 /*--- compute (kp|ng) ---*/
 hrr1_build_kp(Libint->AB,int_stack+416369,int_stack+233720,int_stack+0,990);
 /*--- compute (id|ng) ---*/
 hrr1_build_id(Libint->AB,int_stack+523289,int_stack+416369,int_stack+115460,990);
 /*--- compute (hf|ng) ---*/
 hrr1_build_hf(Libint->AB,int_stack+689609,int_stack+523289,int_stack+291629,990);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+115460,int_stack+63430,int_stack+59800,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+126350,int_stack+67720,int_stack+63430,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+139220,int_stack+126350,int_stack+115460,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+161000,int_stack+72725,int_stack+67720,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+176015,int_stack+161000,int_stack+126350,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+0,int_stack+176015,int_stack+139220,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+115460,int_stack+78500,int_stack+72725,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+201755,int_stack+115460,int_stack+161000,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+115460,int_stack+201755,int_stack+176015,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+158360,int_stack+115460,int_stack+0,55);
 /*--- compute (lp|ng) ---*/
 hrr1_build_lp(Libint->AB,int_stack+278270,int_stack+158360,int_stack+233720,990);
 /*--- compute (kd|ng) ---*/
 hrr1_build_kd(Libint->AB,int_stack+897509,int_stack+278270,int_stack+416369,990);
 /*--- compute (if|ng) ---*/
 hrr1_build_if(Libint->AB,int_stack+1111349,int_stack+897509,int_stack+523289,990);
 /*--- compute (hg|ng) ---*/
 hrr1_build_hg(Libint->AB,int_stack+1388549,int_stack+1111349,int_stack+689609,990);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+89456,int_stack+85100,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+13068,int_stack+94604,int_stack+89456,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+28512,int_stack+13068,int_stack+0,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+54648,int_stack+100610,int_stack+94604,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+115460,int_stack+54648,int_stack+13068,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+212810,int_stack+115460,int_stack+28512,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+107540,int_stack+100610,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+72666,int_stack+0,int_stack+54648,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+0,int_stack+72666,int_stack+115460,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+51480,int_stack+0,int_stack+212810,66);
 /*--- compute (mp|ng) ---*/
 hrr1_build_mp(Libint->AB,int_stack+411920,int_stack+51480,int_stack+158360,990);
 /*--- compute (ld|ng) ---*/
 hrr1_build_ld(Libint->AB,int_stack+0,int_stack+411920,int_stack+278270,990);
 /*--- compute (kf|ng) ---*/
 hrr1_build_kf(Libint->AB,int_stack+267300,int_stack+0,int_stack+897509,990);
 /*--- compute (ig|ng) ---*/
 hrr1_build_ig(Libint->AB,int_stack+623700,int_stack+267300,int_stack+1111349,990);
 /*--- compute (hh|ng) ---*/
 hrr1_build_hh(Libint->AB,int_stack+0,int_stack+623700,int_stack+1388549,990);
 return int_stack+0;}
