/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_hpkh(Libint_t*, prim_data*);

  /* Computes quartets of (hp|kh) integrals */

REALTYPE *hrr_order_hpkh(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[5][7] = int_stack + 0;
 Libint->vrr_classes[5][8] = int_stack + 756;
 Libint->vrr_classes[5][9] = int_stack + 1701;
 Libint->vrr_classes[5][10] = int_stack + 2856;
 Libint->vrr_classes[5][11] = int_stack + 4242;
 Libint->vrr_classes[5][12] = int_stack + 5880;
 Libint->vrr_classes[6][7] = int_stack + 7791;
 Libint->vrr_classes[6][8] = int_stack + 8799;
 Libint->vrr_classes[6][9] = int_stack + 10059;
 Libint->vrr_classes[6][10] = int_stack + 11599;
 Libint->vrr_classes[6][11] = int_stack + 13447;
 Libint->vrr_classes[6][12] = int_stack + 15631;
 memset(int_stack,0,18179*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 18179;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_hpkh(Libint, Data);
   Data++;
 }
 /*--- compute (h0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+18179,int_stack+756,int_stack+0,21);
 /*--- compute (h0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+20447,int_stack+1701,int_stack+756,21);
 /*--- compute (h0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+23282,int_stack+20447,int_stack+18179,21);
 /*--- compute (h0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+27818,int_stack+2856,int_stack+1701,21);
 /*--- compute (h0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+31283,int_stack+27818,int_stack+20447,21);
 /*--- compute (h0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+36953,int_stack+31283,int_stack+23282,21);
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+18179,int_stack+4242,int_stack+2856,21);
 /*--- compute (h0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+44513,int_stack+18179,int_stack+27818,21);
 /*--- compute (h0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+51443,int_stack+44513,int_stack+31283,21);
 /*--- compute (h0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+22337,int_stack+51443,int_stack+36953,21);
 /*--- compute (h0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+33677,int_stack+5880,int_stack+4242,21);
 /*--- compute (h0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+60893,int_stack+33677,int_stack+18179,21);
 /*--- compute (h0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+69209,int_stack+60893,int_stack+44513,21);
 /*--- compute (h0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+33677,int_stack+69209,int_stack+51443,21);
 /*--- compute (h0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+47852,int_stack+33677,int_stack+22337,21);
 /*--- compute (i0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+18179,int_stack+8799,int_stack+7791,28);
 /*--- compute (i0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+21203,int_stack+10059,int_stack+8799,28);
 /*--- compute (i0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+24983,int_stack+21203,int_stack+18179,28);
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+31031,int_stack+11599,int_stack+10059,28);
 /*--- compute (i0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+35651,int_stack+31031,int_stack+21203,28);
 /*--- compute (i0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+63728,int_stack+35651,int_stack+24983,28);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+18179,int_stack+13447,int_stack+11599,28);
 /*--- compute (i0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+0,int_stack+18179,int_stack+31031,28);
 /*--- compute (i0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+73808,int_stack+0,int_stack+35651,28);
 /*--- compute (i0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+23723,int_stack+73808,int_stack+63728,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+63728,int_stack+15631,int_stack+13447,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+86408,int_stack+63728,int_stack+18179,28);
 /*--- compute (i0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+97496,int_stack+86408,int_stack+0,28);
 /*--- compute (i0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+0,int_stack+97496,int_stack+73808,28);
 /*--- compute (i0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+63728,int_stack+0,int_stack+23723,28);
 /*--- compute (hp|kh) ---*/
 hrr1_build_hp(Libint->AB,int_stack+0,int_stack+63728,int_stack+47852,756);
 return int_stack+0;}
