/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_i0kk(Libint_t*, prim_data*);

  /* Computes quartets of (i0|kk) integrals */

REALTYPE *hrr_order_i0kk(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[6][7] = int_stack + 0;
 Libint->vrr_classes[6][8] = int_stack + 1008;
 Libint->vrr_classes[6][9] = int_stack + 2268;
 Libint->vrr_classes[6][10] = int_stack + 3808;
 Libint->vrr_classes[6][11] = int_stack + 5656;
 Libint->vrr_classes[6][12] = int_stack + 7840;
 Libint->vrr_classes[6][13] = int_stack + 10388;
 Libint->vrr_classes[6][14] = int_stack + 13328;
 memset(int_stack,0,16688*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 16688;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_i0kk(Libint, Data);
   Data++;
 }
 /*--- compute (i0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+16688,int_stack+1008,int_stack+0,28);
 /*--- compute (i0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+19712,int_stack+2268,int_stack+1008,28);
 /*--- compute (i0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+23492,int_stack+19712,int_stack+16688,28);
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+29540,int_stack+3808,int_stack+2268,28);
 /*--- compute (i0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+34160,int_stack+29540,int_stack+19712,28);
 /*--- compute (i0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+41720,int_stack+34160,int_stack+23492,28);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+16688,int_stack+5656,int_stack+3808,28);
 /*--- compute (i0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+51800,int_stack+16688,int_stack+29540,28);
 /*--- compute (i0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+61040,int_stack+51800,int_stack+34160,28);
 /*--- compute (i0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+22232,int_stack+61040,int_stack+41720,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+37352,int_stack+7840,int_stack+5656,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+73640,int_stack+37352,int_stack+16688,28);
 /*--- compute (i0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+84728,int_stack+73640,int_stack+51800,28);
 /*--- compute (i0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+100128,int_stack+84728,int_stack+61040,28);
 /*--- compute (i0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+43904,int_stack+100128,int_stack+22232,28);
 /*--- compute (i0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+16688,int_stack+10388,int_stack+7840,28);
 /*--- compute (i0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+119028,int_stack+16688,int_stack+37352,28);
 /*--- compute (i0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+24332,int_stack+119028,int_stack+73640,28);
 /*--- compute (i0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+132132,int_stack+24332,int_stack+84728,28);
 /*--- compute (i0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+65072,int_stack+132132,int_stack+100128,28);
 /*--- compute (i0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+155232,int_stack+65072,int_stack+43904,28);
 /*--- compute (i0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+42812,int_stack+13328,int_stack+10388,28);
 /*--- compute (i0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+91532,int_stack+42812,int_stack+16688,28);
 /*--- compute (i0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+42812,int_stack+91532,int_stack+119028,28);
 /*--- compute (i0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+91532,int_stack+42812,int_stack+24332,28);
 /*--- compute (i0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+0,int_stack+91532,int_stack+132132,28);
 /*--- compute (i0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+91532,int_stack+0,int_stack+65072,28);
 /*--- compute (i0|kk) ---*/
 hrr3_build_kk(Libint->CD,int_stack+0,int_stack+91532,int_stack+155232,28);
 return int_stack+0;}
