/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_ifkd(Libint_t*, prim_data*);

  /* Computes quartets of (if|kd) integrals */

REALTYPE *hrr_order_ifkd(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[6][7] = int_stack + 0;
 Libint->vrr_classes[6][8] = int_stack + 1008;
 Libint->vrr_classes[6][9] = int_stack + 2268;
 Libint->vrr_classes[7][7] = int_stack + 3808;
 Libint->vrr_classes[7][8] = int_stack + 5104;
 Libint->vrr_classes[7][9] = int_stack + 6724;
 Libint->vrr_classes[8][7] = int_stack + 8704;
 Libint->vrr_classes[8][8] = int_stack + 10324;
 Libint->vrr_classes[8][9] = int_stack + 12349;
 Libint->vrr_classes[9][7] = int_stack + 14824;
 Libint->vrr_classes[9][8] = int_stack + 16804;
 Libint->vrr_classes[9][9] = int_stack + 19279;
 memset(int_stack,0,22304*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 22304;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_ifkd(Libint, Data);
   Data++;
 }
 /*--- compute (i0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+22304,int_stack+1008,int_stack+0,28);
 /*--- compute (i0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+25328,int_stack+2268,int_stack+1008,28);
 /*--- compute (i0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+29108,int_stack+25328,int_stack+22304,28);
 /*--- compute (k0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+22304,int_stack+5104,int_stack+3808,36);
 /*--- compute (k0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+0,int_stack+6724,int_stack+5104,36);
 /*--- compute (k0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+35156,int_stack+0,int_stack+22304,36);
 /*--- compute (ip|kd) ---*/
 hrr1_build_ip(Libint->AB,int_stack+42932,int_stack+35156,int_stack+29108,216);
 /*--- compute (l0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+22304,int_stack+10324,int_stack+8704,45);
 /*--- compute (l0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+27164,int_stack+12349,int_stack+10324,45);
 /*--- compute (l0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+0,int_stack+27164,int_stack+22304,45);
 /*--- compute (kp|kd) ---*/
 hrr1_build_kp(Libint->AB,int_stack+61076,int_stack+0,int_stack+35156,216);
 /*--- compute (id|kd) ---*/
 hrr1_build_id(Libint->AB,int_stack+84404,int_stack+61076,int_stack+42932,216);
 /*--- compute (m0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+22304,int_stack+16804,int_stack+14824,55);
 /*--- compute (m0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+28244,int_stack+19279,int_stack+16804,55);
 /*--- compute (m0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+35669,int_stack+28244,int_stack+22304,55);
 /*--- compute (lp|kd) ---*/
 hrr1_build_lp(Libint->AB,int_stack+120692,int_stack+35669,int_stack+0,216);
 /*--- compute (kd|kd) ---*/
 hrr1_build_kd(Libint->AB,int_stack+0,int_stack+120692,int_stack+61076,216);
 /*--- compute (if|kd) ---*/
 hrr1_build_if(Libint->AB,int_stack+120692,int_stack+0,int_stack+84404,216);
 return int_stack+120692;}
