/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_ifmk(Libint_t*, prim_data*);

  /* Computes quartets of (if|mk) integrals */

REALTYPE *hrr_order_ifmk(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[6][9] = int_stack + 0;
 Libint->vrr_classes[6][10] = int_stack + 1540;
 Libint->vrr_classes[6][11] = int_stack + 3388;
 Libint->vrr_classes[6][12] = int_stack + 5572;
 Libint->vrr_classes[6][13] = int_stack + 8120;
 Libint->vrr_classes[6][14] = int_stack + 11060;
 Libint->vrr_classes[6][15] = int_stack + 14420;
 Libint->vrr_classes[6][16] = int_stack + 18228;
 Libint->vrr_classes[7][9] = int_stack + 22512;
 Libint->vrr_classes[7][10] = int_stack + 24492;
 Libint->vrr_classes[7][11] = int_stack + 26868;
 Libint->vrr_classes[7][12] = int_stack + 29676;
 Libint->vrr_classes[7][13] = int_stack + 32952;
 Libint->vrr_classes[7][14] = int_stack + 36732;
 Libint->vrr_classes[7][15] = int_stack + 41052;
 Libint->vrr_classes[7][16] = int_stack + 45948;
 Libint->vrr_classes[8][9] = int_stack + 51456;
 Libint->vrr_classes[8][10] = int_stack + 53931;
 Libint->vrr_classes[8][11] = int_stack + 56901;
 Libint->vrr_classes[8][12] = int_stack + 60411;
 Libint->vrr_classes[8][13] = int_stack + 64506;
 Libint->vrr_classes[8][14] = int_stack + 69231;
 Libint->vrr_classes[8][15] = int_stack + 74631;
 Libint->vrr_classes[8][16] = int_stack + 80751;
 Libint->vrr_classes[9][9] = int_stack + 87636;
 Libint->vrr_classes[9][10] = int_stack + 90661;
 Libint->vrr_classes[9][11] = int_stack + 94291;
 Libint->vrr_classes[9][12] = int_stack + 98581;
 Libint->vrr_classes[9][13] = int_stack + 103586;
 Libint->vrr_classes[9][14] = int_stack + 109361;
 Libint->vrr_classes[9][15] = int_stack + 115961;
 Libint->vrr_classes[9][16] = int_stack + 123441;
 memset(int_stack,0,131856*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 131856;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_ifmk(Libint, Data);
   Data++;
 }
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+131856,int_stack+1540,int_stack+0,28);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+136476,int_stack+3388,int_stack+1540,28);
 /*--- compute (i0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+142020,int_stack+136476,int_stack+131856,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+151260,int_stack+5572,int_stack+3388,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+157812,int_stack+151260,int_stack+136476,28);
 /*--- compute (i0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+168900,int_stack+157812,int_stack+142020,28);
 /*--- compute (i0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+131856,int_stack+8120,int_stack+5572,28);
 /*--- compute (i0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+184300,int_stack+131856,int_stack+151260,28);
 /*--- compute (i0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+197404,int_stack+184300,int_stack+157812,28);
 /*--- compute (i0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+139500,int_stack+197404,int_stack+168900,28);
 /*--- compute (i0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+162600,int_stack+11060,int_stack+8120,28);
 /*--- compute (i0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+215884,int_stack+162600,int_stack+131856,28);
 /*--- compute (i0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+231172,int_stack+215884,int_stack+184300,28);
 /*--- compute (i0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+253012,int_stack+231172,int_stack+197404,28);
 /*--- compute (i0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+171420,int_stack+253012,int_stack+139500,28);
 /*--- compute (i0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+131856,int_stack+14420,int_stack+11060,28);
 /*--- compute (i0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+141936,int_stack+131856,int_stack+162600,28);
 /*--- compute (i0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+280732,int_stack+141936,int_stack+215884,28);
 /*--- compute (i0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+306212,int_stack+280732,int_stack+231172,28);
 /*--- compute (i0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+203760,int_stack+306212,int_stack+253012,28);
 /*--- compute (i0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+338972,int_stack+203760,int_stack+171420,28);
 /*--- compute (i0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+159576,int_stack+18228,int_stack+14420,28);
 /*--- compute (i0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+171000,int_stack+159576,int_stack+131856,28);
 /*--- compute (i0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+242568,int_stack+171000,int_stack+141936,28);
 /*--- compute (i0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+131856,int_stack+242568,int_stack+280732,28);
 /*--- compute (i0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+242568,int_stack+131856,int_stack+306212,28);
 /*--- compute (i0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+131856,int_stack+242568,int_stack+203760,28);
 /*--- compute (i0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+183600,int_stack+131856,int_stack+338972,28);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+131856,int_stack+24492,int_stack+22512,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+137796,int_stack+26868,int_stack+24492,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+144924,int_stack+137796,int_stack+131856,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+156804,int_stack+29676,int_stack+26868,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+165228,int_stack+156804,int_stack+137796,36);
 /*--- compute (k0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+239040,int_stack+165228,int_stack+144924,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+131856,int_stack+32952,int_stack+29676,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+258840,int_stack+131856,int_stack+156804,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+275688,int_stack+258840,int_stack+165228,36);
 /*--- compute (k0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+141684,int_stack+275688,int_stack+239040,36);
 /*--- compute (k0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+239040,int_stack+36732,int_stack+32952,36);
 /*--- compute (k0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+299448,int_stack+239040,int_stack+131856,36);
 /*--- compute (k0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+319104,int_stack+299448,int_stack+258840,36);
 /*--- compute (k0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+347184,int_stack+319104,int_stack+275688,36);
 /*--- compute (k0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+250380,int_stack+347184,int_stack+141684,36);
 /*--- compute (k0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+131856,int_stack+41052,int_stack+36732,36);
 /*--- compute (k0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+144816,int_stack+131856,int_stack+239040,36);
 /*--- compute (k0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+0,int_stack+144816,int_stack+299448,36);
 /*--- compute (k0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+382824,int_stack+0,int_stack+319104,36);
 /*--- compute (k0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+291960,int_stack+382824,int_stack+347184,36);
 /*--- compute (k0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+424944,int_stack+291960,int_stack+250380,36);
 /*--- compute (k0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+239040,int_stack+45948,int_stack+41052,36);
 /*--- compute (k0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+253728,int_stack+239040,int_stack+131856,36);
 /*--- compute (k0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+341856,int_stack+253728,int_stack+144816,36);
 /*--- compute (k0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+131856,int_stack+341856,int_stack+0,36);
 /*--- compute (k0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+480384,int_stack+131856,int_stack+382824,36);
 /*--- compute (k0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+341856,int_stack+480384,int_stack+291960,36);
 /*--- compute (k0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+239040,int_stack+341856,int_stack+424944,36);
 /*--- compute (ip|mk) ---*/
 hrr1_build_ip(Libint->AB,int_stack+310320,int_stack+239040,int_stack+183600,1980);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+131856,int_stack+53931,int_stack+51456,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+139281,int_stack+56901,int_stack+53931,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+148191,int_stack+139281,int_stack+131856,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+163041,int_stack+60411,int_stack+56901,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+173571,int_stack+163041,int_stack+139281,45);
 /*--- compute (l0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+191391,int_stack+173571,int_stack+148191,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+131856,int_stack+64506,int_stack+60411,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+216141,int_stack+131856,int_stack+163041,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+0,int_stack+216141,int_stack+173571,45);
 /*--- compute (l0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+144141,int_stack+0,int_stack+191391,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+181266,int_stack+69231,int_stack+64506,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+29700,int_stack+181266,int_stack+131856,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+476640,int_stack+29700,int_stack+216141,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+511740,int_stack+476640,int_stack+0,45);
 /*--- compute (l0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+556290,int_stack+511740,int_stack+144141,45);
 /*--- compute (l0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+0,int_stack+74631,int_stack+69231,45);
 /*--- compute (l0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+131856,int_stack+0,int_stack+181266,45);
 /*--- compute (l0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+160206,int_stack+131856,int_stack+29700,45);
 /*--- compute (l0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+16200,int_stack+160206,int_stack+476640,45);
 /*--- compute (l0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+608265,int_stack+16200,int_stack+511740,45);
 /*--- compute (l0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+476640,int_stack+608265,int_stack+556290,45);
 /*--- compute (l0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+545940,int_stack+80751,int_stack+74631,45);
 /*--- compute (l0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+564300,int_stack+545940,int_stack+0,45);
 /*--- compute (l0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+670635,int_stack+564300,int_stack+131856,45);
 /*--- compute (l0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+545940,int_stack+670635,int_stack+160206,45);
 /*--- compute (l0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+131856,int_stack+545940,int_stack+16200,45);
 /*--- compute (l0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+0,int_stack+131856,int_stack+608265,45);
 /*--- compute (l0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+131856,int_stack+0,int_stack+476640,45);
 /*--- compute (kp|mk) ---*/
 hrr1_build_kp(Libint->AB,int_stack+476640,int_stack+131856,int_stack+239040,1980);
 /*--- compute (id|mk) ---*/
 hrr1_build_id(Libint->AB,int_stack+690480,int_stack+476640,int_stack+310320,1980);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+0,int_stack+90661,int_stack+87636,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+9075,int_stack+94291,int_stack+90661,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+19965,int_stack+9075,int_stack+0,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+38115,int_stack+98581,int_stack+94291,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+50985,int_stack+38115,int_stack+9075,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+220956,int_stack+50985,int_stack+19965,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+103586,int_stack+98581,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+72765,int_stack+0,int_stack+38115,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+251206,int_stack+72765,int_stack+50985,55);
 /*--- compute (m0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+15015,int_stack+251206,int_stack+220956,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+220956,int_stack+109361,int_stack+103586,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+287506,int_stack+220956,int_stack+0,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+317536,int_stack+287506,int_stack+72765,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+360436,int_stack+317536,int_stack+251206,55);
 /*--- compute (m0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+1023120,int_stack+360436,int_stack+15015,55);
 /*--- compute (m0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+0,int_stack+115961,int_stack+109361,55);
 /*--- compute (m0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+19800,int_stack+0,int_stack+220956,55);
 /*--- compute (m0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+220956,int_stack+19800,int_stack+287506,55);
 /*--- compute (m0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1086645,int_stack+220956,int_stack+317536,55);
 /*--- compute (m0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+271006,int_stack+1086645,int_stack+360436,55);
 /*--- compute (m0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+347236,int_stack+271006,int_stack+1023120,55);
 /*--- compute (m0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+1023120,int_stack+123441,int_stack+115961,55);
 /*--- compute (m0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1045560,int_stack+1023120,int_stack+0,55);
 /*--- compute (m0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+54450,int_stack+1045560,int_stack+19800,55);
 /*--- compute (m0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1150995,int_stack+54450,int_stack+220956,55);
 /*--- compute (m0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+0,int_stack+1150995,int_stack+1086645,55);
 /*--- compute (m0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1023120,int_stack+0,int_stack+271006,55);
 /*--- compute (m0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+0,int_stack+1023120,int_stack+347236,55);
 /*--- compute (lp|mk) ---*/
 hrr1_build_lp(Libint->AB,int_stack+1023120,int_stack+0,int_stack+131856,1980);
 /*--- compute (kd|mk) ---*/
 hrr1_build_kd(Libint->AB,int_stack+0,int_stack+1023120,int_stack+476640,1980);
 /*--- compute (if|mk) ---*/
 hrr1_build_if(Libint->AB,int_stack+1023120,int_stack+0,int_stack+690480,1980);
 return int_stack+1023120;}
