/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_igld(Libint_t*, prim_data*);

  /* Computes quartets of (ig|ld) integrals */

REALTYPE *hrr_order_igld(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[6][8] = int_stack + 0;
 Libint->vrr_classes[6][9] = int_stack + 1260;
 Libint->vrr_classes[6][10] = int_stack + 2800;
 Libint->vrr_classes[7][8] = int_stack + 4648;
 Libint->vrr_classes[7][9] = int_stack + 6268;
 Libint->vrr_classes[7][10] = int_stack + 8248;
 Libint->vrr_classes[8][8] = int_stack + 10624;
 Libint->vrr_classes[8][9] = int_stack + 12649;
 Libint->vrr_classes[8][10] = int_stack + 15124;
 Libint->vrr_classes[9][8] = int_stack + 18094;
 Libint->vrr_classes[9][9] = int_stack + 20569;
 Libint->vrr_classes[9][10] = int_stack + 23594;
 Libint->vrr_classes[10][8] = int_stack + 27224;
 Libint->vrr_classes[10][9] = int_stack + 30194;
 Libint->vrr_classes[10][10] = int_stack + 33824;
 memset(int_stack,0,38180*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 38180;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_igld(Libint, Data);
   Data++;
 }
 /*--- compute (i0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+38180,int_stack+1260,int_stack+0,28);
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+41960,int_stack+2800,int_stack+1260,28);
 /*--- compute (i0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+46580,int_stack+41960,int_stack+38180,28);
 /*--- compute (k0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+38180,int_stack+6268,int_stack+4648,36);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+0,int_stack+8248,int_stack+6268,36);
 /*--- compute (k0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+54140,int_stack+0,int_stack+38180,36);
 /*--- compute (ip|ld) ---*/
 hrr1_build_ip(Libint->AB,int_stack+63860,int_stack+54140,int_stack+46580,270);
 /*--- compute (l0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+38180,int_stack+12649,int_stack+10624,45);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+44255,int_stack+15124,int_stack+12649,45);
 /*--- compute (l0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+0,int_stack+44255,int_stack+38180,45);
 /*--- compute (kp|ld) ---*/
 hrr1_build_kp(Libint->AB,int_stack+86540,int_stack+0,int_stack+54140,270);
 /*--- compute (id|ld) ---*/
 hrr1_build_id(Libint->AB,int_stack+115700,int_stack+86540,int_stack+63860,270);
 /*--- compute (m0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+38180,int_stack+20569,int_stack+18094,55);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+45605,int_stack+23594,int_stack+20569,55);
 /*--- compute (m0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+54680,int_stack+45605,int_stack+38180,55);
 /*--- compute (lp|ld) ---*/
 hrr1_build_lp(Libint->AB,int_stack+161060,int_stack+54680,int_stack+0,270);
 /*--- compute (kd|ld) ---*/
 hrr1_build_kd(Libint->AB,int_stack+197510,int_stack+161060,int_stack+86540,270);
 /*--- compute (if|ld) ---*/
 hrr1_build_if(Libint->AB,int_stack+255830,int_stack+197510,int_stack+115700,270);
 /*--- compute (n0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+0,int_stack+30194,int_stack+27224,66);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+8910,int_stack+33824,int_stack+30194,66);
 /*--- compute (n0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+19800,int_stack+8910,int_stack+0,66);
 /*--- compute (mp|ld) ---*/
 hrr1_build_mp(Libint->AB,int_stack+69530,int_stack+19800,int_stack+54680,270);
 /*--- compute (ld|ld) ---*/
 hrr1_build_ld(Libint->AB,int_stack+331430,int_stack+69530,int_stack+161060,270);
 /*--- compute (kf|ld) ---*/
 hrr1_build_kf(Libint->AB,int_stack+0,int_stack+331430,int_stack+197510,270);
 /*--- compute (ig|ld) ---*/
 hrr1_build_ig(Libint->AB,int_stack+97200,int_stack+0,int_stack+255830,270);
 return int_stack+97200;}
