/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_ihmh(Libint_t*, prim_data*);

  /* Computes quartets of (ih|mh) integrals */

REALTYPE *hrr_order_ihmh(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[6][9] = int_stack + 0;
 Libint->vrr_classes[6][10] = int_stack + 1540;
 Libint->vrr_classes[6][11] = int_stack + 3388;
 Libint->vrr_classes[6][12] = int_stack + 5572;
 Libint->vrr_classes[6][13] = int_stack + 8120;
 Libint->vrr_classes[6][14] = int_stack + 11060;
 Libint->vrr_classes[7][9] = int_stack + 14420;
 Libint->vrr_classes[7][10] = int_stack + 16400;
 Libint->vrr_classes[7][11] = int_stack + 18776;
 Libint->vrr_classes[7][12] = int_stack + 21584;
 Libint->vrr_classes[7][13] = int_stack + 24860;
 Libint->vrr_classes[7][14] = int_stack + 28640;
 Libint->vrr_classes[8][9] = int_stack + 32960;
 Libint->vrr_classes[8][10] = int_stack + 35435;
 Libint->vrr_classes[8][11] = int_stack + 38405;
 Libint->vrr_classes[8][12] = int_stack + 41915;
 Libint->vrr_classes[8][13] = int_stack + 46010;
 Libint->vrr_classes[8][14] = int_stack + 50735;
 Libint->vrr_classes[9][9] = int_stack + 56135;
 Libint->vrr_classes[9][10] = int_stack + 59160;
 Libint->vrr_classes[9][11] = int_stack + 62790;
 Libint->vrr_classes[9][12] = int_stack + 67080;
 Libint->vrr_classes[9][13] = int_stack + 72085;
 Libint->vrr_classes[9][14] = int_stack + 77860;
 Libint->vrr_classes[10][9] = int_stack + 84460;
 Libint->vrr_classes[10][10] = int_stack + 88090;
 Libint->vrr_classes[10][11] = int_stack + 92446;
 Libint->vrr_classes[10][12] = int_stack + 97594;
 Libint->vrr_classes[10][13] = int_stack + 103600;
 Libint->vrr_classes[10][14] = int_stack + 110530;
 Libint->vrr_classes[11][9] = int_stack + 118450;
 Libint->vrr_classes[11][10] = int_stack + 122740;
 Libint->vrr_classes[11][11] = int_stack + 127888;
 Libint->vrr_classes[11][12] = int_stack + 133972;
 Libint->vrr_classes[11][13] = int_stack + 141070;
 Libint->vrr_classes[11][14] = int_stack + 149260;
 memset(int_stack,0,158620*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 158620;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_ihmh(Libint, Data);
   Data++;
 }
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+158620,int_stack+1540,int_stack+0,28);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+163240,int_stack+3388,int_stack+1540,28);
 /*--- compute (i0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+168784,int_stack+163240,int_stack+158620,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+178024,int_stack+5572,int_stack+3388,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+184576,int_stack+178024,int_stack+163240,28);
 /*--- compute (i0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+195664,int_stack+184576,int_stack+168784,28);
 /*--- compute (i0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+158620,int_stack+8120,int_stack+5572,28);
 /*--- compute (i0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+211064,int_stack+158620,int_stack+178024,28);
 /*--- compute (i0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+224168,int_stack+211064,int_stack+184576,28);
 /*--- compute (i0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+166264,int_stack+224168,int_stack+195664,28);
 /*--- compute (i0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+189364,int_stack+11060,int_stack+8120,28);
 /*--- compute (i0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+242648,int_stack+189364,int_stack+158620,28);
 /*--- compute (i0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+257936,int_stack+242648,int_stack+211064,28);
 /*--- compute (i0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+189364,int_stack+257936,int_stack+224168,28);
 /*--- compute (i0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+217084,int_stack+189364,int_stack+166264,28);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+158620,int_stack+16400,int_stack+14420,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+164560,int_stack+18776,int_stack+16400,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+171688,int_stack+164560,int_stack+158620,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+183568,int_stack+21584,int_stack+18776,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+191992,int_stack+183568,int_stack+164560,36);
 /*--- compute (k0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+249424,int_stack+191992,int_stack+171688,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+158620,int_stack+24860,int_stack+21584,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+0,int_stack+158620,int_stack+183568,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+269224,int_stack+0,int_stack+191992,36);
 /*--- compute (k0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+168448,int_stack+269224,int_stack+249424,36);
 /*--- compute (k0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+249424,int_stack+28640,int_stack+24860,36);
 /*--- compute (k0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+292984,int_stack+249424,int_stack+158620,36);
 /*--- compute (k0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+312640,int_stack+292984,int_stack+0,36);
 /*--- compute (k0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+340720,int_stack+312640,int_stack+269224,36);
 /*--- compute (k0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+249424,int_stack+340720,int_stack+168448,36);
 /*--- compute (ip|mh) ---*/
 hrr1_build_ip(Libint->AB,int_stack+291004,int_stack+249424,int_stack+217084,1155);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+0,int_stack+35435,int_stack+32960,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+7425,int_stack+38405,int_stack+35435,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+16335,int_stack+7425,int_stack+0,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+158620,int_stack+41915,int_stack+38405,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+169150,int_stack+158620,int_stack+7425,45);
 /*--- compute (l0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+186970,int_stack+169150,int_stack+16335,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+46010,int_stack+41915,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+12285,int_stack+0,int_stack+158620,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+211720,int_stack+12285,int_stack+169150,45);
 /*--- compute (l0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+388024,int_stack+211720,int_stack+186970,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+158620,int_stack+50735,int_stack+46010,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+172795,int_stack+158620,int_stack+0,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+425149,int_stack+172795,int_stack+12285,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+0,int_stack+425149,int_stack+211720,45);
 /*--- compute (l0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+158620,int_stack+0,int_stack+388024,45);
 /*--- compute (kp|mh) ---*/
 hrr1_build_kp(Libint->AB,int_stack+388024,int_stack+158620,int_stack+249424,1155);
 /*--- compute (id|mh) ---*/
 hrr1_build_id(Libint->AB,int_stack+512764,int_stack+388024,int_stack+291004,1155);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+0,int_stack+59160,int_stack+56135,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+9075,int_stack+62790,int_stack+59160,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+19965,int_stack+9075,int_stack+0,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+38115,int_stack+67080,int_stack+62790,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+210595,int_stack+38115,int_stack+9075,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+232375,int_stack+210595,int_stack+19965,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+72085,int_stack+67080,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+262625,int_stack+0,int_stack+38115,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+15015,int_stack+262625,int_stack+210595,55);
 /*--- compute (m0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+288365,int_stack+15015,int_stack+232375,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+210595,int_stack+77860,int_stack+72085,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+227920,int_stack+210595,int_stack+0,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+333740,int_stack+227920,int_stack+262625,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+210595,int_stack+333740,int_stack+15015,55);
 /*--- compute (m0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+0,int_stack+210595,int_stack+288365,55);
 /*--- compute (lp|mh) ---*/
 hrr1_build_lp(Libint->AB,int_stack+210595,int_stack+0,int_stack+158620,1155);
 /*--- compute (kd|mh) ---*/
 hrr1_build_kd(Libint->AB,int_stack+706804,int_stack+210595,int_stack+388024,1155);
 /*--- compute (if|mh) ---*/
 hrr1_build_if(Libint->AB,int_stack+956284,int_stack+706804,int_stack+512764,1155);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+158620,int_stack+88090,int_stack+84460,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+169510,int_stack+92446,int_stack+88090,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+182578,int_stack+169510,int_stack+158620,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+366520,int_stack+97594,int_stack+92446,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+381964,int_stack+366520,int_stack+169510,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+408100,int_stack+381964,int_stack+182578,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+158620,int_stack+103600,int_stack+97594,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+176638,int_stack+158620,int_stack+366520,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+444400,int_stack+176638,int_stack+381964,66);
 /*--- compute (n0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+487960,int_stack+444400,int_stack+408100,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+366520,int_stack+110530,int_stack+103600,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+387310,int_stack+366520,int_stack+158620,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+542410,int_stack+387310,int_stack+176638,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+366520,int_stack+542410,int_stack+444400,66);
 /*--- compute (n0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+542410,int_stack+366520,int_stack+487960,66);
 /*--- compute (mp|mh) ---*/
 hrr1_build_mp(Libint->AB,int_stack+1279684,int_stack+542410,int_stack+0,1155);
 /*--- compute (ld|mh) ---*/
 hrr1_build_ld(Libint->AB,int_stack+1470259,int_stack+1279684,int_stack+210595,1155);
 /*--- compute (kf|mh) ---*/
 hrr1_build_kf(Libint->AB,int_stack+1782109,int_stack+1470259,int_stack+706804,1155);
 /*--- compute (ig|mh) ---*/
 hrr1_build_ig(Libint->AB,int_stack+2197909,int_stack+1782109,int_stack+956284,1155);
 /*--- compute (o0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+0,int_stack+122740,int_stack+118450,78);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+12870,int_stack+127888,int_stack+122740,78);
 /*--- compute (o0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+28314,int_stack+12870,int_stack+0,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+54054,int_stack+133972,int_stack+127888,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+72306,int_stack+54054,int_stack+12870,78);
 /*--- compute (o0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+618640,int_stack+72306,int_stack+28314,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+141070,int_stack+133972,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+103194,int_stack+0,int_stack+54054,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+661540,int_stack+103194,int_stack+72306,78);
 /*--- compute (o0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+21294,int_stack+661540,int_stack+618640,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+618640,int_stack+149260,int_stack+141070,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+139698,int_stack+618640,int_stack+0,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+182286,int_stack+139698,int_stack+103194,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+85644,int_stack+182286,int_stack+661540,78);
 /*--- compute (o0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+618640,int_stack+85644,int_stack+21294,78);
 /*--- compute (np|mh) ---*/
 hrr1_build_np(Libint->AB,int_stack+0,int_stack+618640,int_stack+542410,1155);
 /*--- compute (md|mh) ---*/
 hrr1_build_md(Libint->AB,int_stack+228690,int_stack+0,int_stack+1279684,1155);
 /*--- compute (lf|mh) ---*/
 hrr1_build_lf(Libint->AB,int_stack+609840,int_stack+228690,int_stack+1470259,1155);
 /*--- compute (kg|mh) ---*/
 hrr1_build_kg(Libint->AB,int_stack+1129590,int_stack+609840,int_stack+1782109,1155);
 /*--- compute (ih|mh) ---*/
 hrr1_build_ih(Libint->AB,int_stack+0,int_stack+1129590,int_stack+2197909,1155);
 return int_stack+0;}
