/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_iikh(Libint_t*, prim_data*);

  /* Computes quartets of (ii|kh) integrals */

REALTYPE *hrr_order_iikh(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[6][7] = int_stack + 0;
 Libint->vrr_classes[6][8] = int_stack + 1008;
 Libint->vrr_classes[6][9] = int_stack + 2268;
 Libint->vrr_classes[6][10] = int_stack + 3808;
 Libint->vrr_classes[6][11] = int_stack + 5656;
 Libint->vrr_classes[6][12] = int_stack + 7840;
 Libint->vrr_classes[7][7] = int_stack + 10388;
 Libint->vrr_classes[7][8] = int_stack + 11684;
 Libint->vrr_classes[7][9] = int_stack + 13304;
 Libint->vrr_classes[7][10] = int_stack + 15284;
 Libint->vrr_classes[7][11] = int_stack + 17660;
 Libint->vrr_classes[7][12] = int_stack + 20468;
 Libint->vrr_classes[8][7] = int_stack + 23744;
 Libint->vrr_classes[8][8] = int_stack + 25364;
 Libint->vrr_classes[8][9] = int_stack + 27389;
 Libint->vrr_classes[8][10] = int_stack + 29864;
 Libint->vrr_classes[8][11] = int_stack + 32834;
 Libint->vrr_classes[8][12] = int_stack + 36344;
 Libint->vrr_classes[9][7] = int_stack + 40439;
 Libint->vrr_classes[9][8] = int_stack + 42419;
 Libint->vrr_classes[9][9] = int_stack + 44894;
 Libint->vrr_classes[9][10] = int_stack + 47919;
 Libint->vrr_classes[9][11] = int_stack + 51549;
 Libint->vrr_classes[9][12] = int_stack + 55839;
 Libint->vrr_classes[10][7] = int_stack + 60844;
 Libint->vrr_classes[10][8] = int_stack + 63220;
 Libint->vrr_classes[10][9] = int_stack + 66190;
 Libint->vrr_classes[10][10] = int_stack + 69820;
 Libint->vrr_classes[10][11] = int_stack + 74176;
 Libint->vrr_classes[10][12] = int_stack + 79324;
 Libint->vrr_classes[11][7] = int_stack + 85330;
 Libint->vrr_classes[11][8] = int_stack + 88138;
 Libint->vrr_classes[11][9] = int_stack + 91648;
 Libint->vrr_classes[11][10] = int_stack + 95938;
 Libint->vrr_classes[11][11] = int_stack + 101086;
 Libint->vrr_classes[11][12] = int_stack + 107170;
 Libint->vrr_classes[12][7] = int_stack + 114268;
 Libint->vrr_classes[12][8] = int_stack + 117544;
 Libint->vrr_classes[12][9] = int_stack + 121639;
 Libint->vrr_classes[12][10] = int_stack + 126644;
 Libint->vrr_classes[12][11] = int_stack + 132650;
 Libint->vrr_classes[12][12] = int_stack + 139748;
 memset(int_stack,0,148029*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 148029;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_iikh(Libint, Data);
   Data++;
 }
 /*--- compute (i0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+148029,int_stack+1008,int_stack+0,28);
 /*--- compute (i0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+151053,int_stack+2268,int_stack+1008,28);
 /*--- compute (i0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+154833,int_stack+151053,int_stack+148029,28);
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+160881,int_stack+3808,int_stack+2268,28);
 /*--- compute (i0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+165501,int_stack+160881,int_stack+151053,28);
 /*--- compute (i0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+173061,int_stack+165501,int_stack+154833,28);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+148029,int_stack+5656,int_stack+3808,28);
 /*--- compute (i0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+183141,int_stack+148029,int_stack+160881,28);
 /*--- compute (i0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+192381,int_stack+183141,int_stack+165501,28);
 /*--- compute (i0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+153573,int_stack+192381,int_stack+173061,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+168693,int_stack+7840,int_stack+5656,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+204981,int_stack+168693,int_stack+148029,28);
 /*--- compute (i0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+216069,int_stack+204981,int_stack+183141,28);
 /*--- compute (i0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+168693,int_stack+216069,int_stack+192381,28);
 /*--- compute (i0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+187593,int_stack+168693,int_stack+153573,28);
 /*--- compute (k0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+148029,int_stack+11684,int_stack+10388,36);
 /*--- compute (k0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+151917,int_stack+13304,int_stack+11684,36);
 /*--- compute (k0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+156777,int_stack+151917,int_stack+148029,36);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+164553,int_stack+15284,int_stack+13304,36);
 /*--- compute (k0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+170493,int_stack+164553,int_stack+151917,36);
 /*--- compute (k0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+208761,int_stack+170493,int_stack+156777,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+148029,int_stack+17660,int_stack+15284,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+0,int_stack+148029,int_stack+164553,36);
 /*--- compute (k0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+221721,int_stack+0,int_stack+170493,36);
 /*--- compute (k0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+155157,int_stack+221721,int_stack+208761,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+208761,int_stack+20468,int_stack+17660,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+237921,int_stack+208761,int_stack+148029,36);
 /*--- compute (k0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+252177,int_stack+237921,int_stack+0,36);
 /*--- compute (k0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+271977,int_stack+252177,int_stack+221721,36);
 /*--- compute (k0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+208761,int_stack+271977,int_stack+155157,36);
 /*--- compute (ip|kh) ---*/
 hrr1_build_ip(Libint->AB,int_stack+235977,int_stack+208761,int_stack+187593,756);
 /*--- compute (l0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+0,int_stack+25364,int_stack+23744,45);
 /*--- compute (l0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+4860,int_stack+27389,int_stack+25364,45);
 /*--- compute (l0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+10935,int_stack+4860,int_stack+0,45);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+148029,int_stack+29864,int_stack+27389,45);
 /*--- compute (l0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+155454,int_stack+148029,int_stack+4860,45);
 /*--- compute (l0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+167604,int_stack+155454,int_stack+10935,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+32834,int_stack+29864,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+8910,int_stack+0,int_stack+148029,45);
 /*--- compute (l0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+183804,int_stack+8910,int_stack+155454,45);
 /*--- compute (l0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+299481,int_stack+183804,int_stack+167604,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+148029,int_stack+36344,int_stack+32834,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+158559,int_stack+148029,int_stack+0,45);
 /*--- compute (l0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+323781,int_stack+158559,int_stack+8910,45);
 /*--- compute (l0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+0,int_stack+323781,int_stack+183804,45);
 /*--- compute (l0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+148029,int_stack+0,int_stack+299481,45);
 /*--- compute (kp|kh) ---*/
 hrr1_build_kp(Libint->AB,int_stack+299481,int_stack+148029,int_stack+208761,756);
 /*--- compute (id|kh) ---*/
 hrr1_build_id(Libint->AB,int_stack+381129,int_stack+299481,int_stack+235977,756);
 /*--- compute (m0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+0,int_stack+42419,int_stack+40439,55);
 /*--- compute (m0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+5940,int_stack+44894,int_stack+42419,55);
 /*--- compute (m0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+13365,int_stack+5940,int_stack+0,55);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+25245,int_stack+47919,int_stack+44894,55);
 /*--- compute (m0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+182049,int_stack+25245,int_stack+5940,55);
 /*--- compute (m0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+196899,int_stack+182049,int_stack+13365,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+51549,int_stack+47919,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+216699,int_stack+0,int_stack+25245,55);
 /*--- compute (m0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+10890,int_stack+216699,int_stack+182049,55);
 /*--- compute (m0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+234849,int_stack+10890,int_stack+196899,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+182049,int_stack+55839,int_stack+51549,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+194919,int_stack+182049,int_stack+0,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+264549,int_stack+194919,int_stack+216699,55);
 /*--- compute (m0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+182049,int_stack+264549,int_stack+10890,55);
 /*--- compute (m0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+0,int_stack+182049,int_stack+234849,55);
 /*--- compute (lp|kh) ---*/
 hrr1_build_lp(Libint->AB,int_stack+182049,int_stack+0,int_stack+148029,756);
 /*--- compute (kd|kh) ---*/
 hrr1_build_kd(Libint->AB,int_stack+508137,int_stack+182049,int_stack+299481,756);
 /*--- compute (if|kh) ---*/
 hrr1_build_if(Libint->AB,int_stack+671433,int_stack+508137,int_stack+381129,756);
 /*--- compute (n0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+148029,int_stack+63220,int_stack+60844,66);
 /*--- compute (n0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+155157,int_stack+66190,int_stack+63220,66);
 /*--- compute (n0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+164067,int_stack+155157,int_stack+148029,66);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+284109,int_stack+69820,int_stack+66190,66);
 /*--- compute (n0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+294999,int_stack+284109,int_stack+155157,66);
 /*--- compute (n0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+312819,int_stack+294999,int_stack+164067,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+148029,int_stack+74176,int_stack+69820,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+336579,int_stack+148029,int_stack+284109,66);
 /*--- compute (n0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+358359,int_stack+336579,int_stack+294999,66);
 /*--- compute (n0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+388059,int_stack+358359,int_stack+312819,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+284109,int_stack+79324,int_stack+74176,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+299553,int_stack+284109,int_stack+148029,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+423699,int_stack+299553,int_stack+336579,66);
 /*--- compute (n0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+284109,int_stack+423699,int_stack+358359,66);
 /*--- compute (n0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+423699,int_stack+284109,int_stack+388059,66);
 /*--- compute (mp|kh) ---*/
 hrr1_build_mp(Libint->AB,int_stack+284109,int_stack+423699,int_stack+0,756);
 /*--- compute (ld|kh) ---*/
 hrr1_build_ld(Libint->AB,int_stack+883113,int_stack+284109,int_stack+182049,756);
 /*--- compute (kf|kh) ---*/
 hrr1_build_kf(Libint->AB,int_stack+1087233,int_stack+883113,int_stack+508137,756);
 /*--- compute (ig|kh) ---*/
 hrr1_build_ig(Libint->AB,int_stack+1359393,int_stack+1087233,int_stack+671433,756);
 /*--- compute (o0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+0,int_stack+88138,int_stack+85330,78);
 /*--- compute (o0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+8424,int_stack+91648,int_stack+88138,78);
 /*--- compute (o0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+18954,int_stack+8424,int_stack+0,78);
 /*--- compute (o0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+35802,int_stack+95938,int_stack+91648,78);
 /*--- compute (o0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+48672,int_stack+35802,int_stack+8424,78);
 /*--- compute (o0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+473595,int_stack+48672,int_stack+18954,78);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+101086,int_stack+95938,78);
 /*--- compute (o0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+69732,int_stack+0,int_stack+35802,78);
 /*--- compute (o0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+501675,int_stack+69732,int_stack+48672,78);
 /*--- compute (o0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+15444,int_stack+501675,int_stack+473595,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+473595,int_stack+107170,int_stack+101086,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+536775,int_stack+473595,int_stack+0,78);
 /*--- compute (o0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+567663,int_stack+536775,int_stack+69732,78);
 /*--- compute (o0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+57564,int_stack+567663,int_stack+501675,78);
 /*--- compute (o0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+473595,int_stack+57564,int_stack+15444,78);
 /*--- compute (np|kh) ---*/
 hrr1_build_np(Libint->AB,int_stack+532563,int_stack+473595,int_stack+423699,756);
 /*--- compute (md|kh) ---*/
 hrr1_build_md(Libint->AB,int_stack+1676913,int_stack+532563,int_stack+284109,756);
 /*--- compute (lf|kh) ---*/
 hrr1_build_lf(Libint->AB,int_stack+1926393,int_stack+1676913,int_stack+883113,756);
 /*--- compute (kg|kh) ---*/
 hrr1_build_kg(Libint->AB,int_stack+2266593,int_stack+1926393,int_stack+1087233,756);
 /*--- compute (ih|kh) ---*/
 hrr1_build_ih(Libint->AB,int_stack+682251,int_stack+2266593,int_stack+1359393,756);
 /*--- compute (q0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+0,int_stack+117544,int_stack+114268,91);
 /*--- compute (q0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+9828,int_stack+121639,int_stack+117544,91);
 /*--- compute (q0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+22113,int_stack+9828,int_stack+0,91);
 /*--- compute (q0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+41769,int_stack+126644,int_stack+121639,91);
 /*--- compute (q0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+56784,int_stack+41769,int_stack+9828,91);
 /*--- compute (q0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+81354,int_stack+56784,int_stack+22113,91);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+132650,int_stack+126644,91);
 /*--- compute (q0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+1126779,int_stack+0,int_stack+41769,91);
 /*--- compute (q0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+1156809,int_stack+1126779,int_stack+56784,91);
 /*--- compute (q0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+18018,int_stack+1156809,int_stack+81354,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+67158,int_stack+139748,int_stack+132650,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+88452,int_stack+67158,int_stack+0,91);
 /*--- compute (q0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+124488,int_stack+88452,int_stack+1126779,91);
 /*--- compute (q0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+174538,int_stack+124488,int_stack+1156809,91);
 /*--- compute (q0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+1126779,int_stack+174538,int_stack+18018,91);
 /*--- compute (op|kh) ---*/
 hrr1_build_op(Libint->AB,int_stack+1195575,int_stack+1126779,int_stack+473595,756);
 /*--- compute (nd|kh) ---*/
 hrr1_build_nd(Libint->AB,int_stack+1372479,int_stack+1195575,int_stack+532563,756);
 /*--- compute (mf|kh) ---*/
 hrr1_build_mf(Libint->AB,int_stack+0,int_stack+1372479,int_stack+1676913,756);
 /*--- compute (lg|kh) ---*/
 hrr1_build_lg(Libint->AB,int_stack+1126779,int_stack+0,int_stack+1926393,756);
 /*--- compute (kh|kh) ---*/
 hrr1_build_kh(Libint->AB,int_stack+0,int_stack+1126779,int_stack+2266593,756);
 /*--- compute (ii|kh) ---*/
 hrr1_build_ii(Libint->AB,int_stack+1126779,int_stack+0,int_stack+682251,756);
 return int_stack+1126779;}
