/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_iimk(Libint_t*, prim_data*);

  /* Computes quartets of (ii|mk) integrals */

REALTYPE *hrr_order_iimk(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[6][9] = int_stack + 0;
 Libint->vrr_classes[6][10] = int_stack + 1540;
 Libint->vrr_classes[6][11] = int_stack + 3388;
 Libint->vrr_classes[6][12] = int_stack + 5572;
 Libint->vrr_classes[6][13] = int_stack + 8120;
 Libint->vrr_classes[6][14] = int_stack + 11060;
 Libint->vrr_classes[6][15] = int_stack + 14420;
 Libint->vrr_classes[6][16] = int_stack + 18228;
 Libint->vrr_classes[7][9] = int_stack + 22512;
 Libint->vrr_classes[7][10] = int_stack + 24492;
 Libint->vrr_classes[7][11] = int_stack + 26868;
 Libint->vrr_classes[7][12] = int_stack + 29676;
 Libint->vrr_classes[7][13] = int_stack + 32952;
 Libint->vrr_classes[7][14] = int_stack + 36732;
 Libint->vrr_classes[7][15] = int_stack + 41052;
 Libint->vrr_classes[7][16] = int_stack + 45948;
 Libint->vrr_classes[8][9] = int_stack + 51456;
 Libint->vrr_classes[8][10] = int_stack + 53931;
 Libint->vrr_classes[8][11] = int_stack + 56901;
 Libint->vrr_classes[8][12] = int_stack + 60411;
 Libint->vrr_classes[8][13] = int_stack + 64506;
 Libint->vrr_classes[8][14] = int_stack + 69231;
 Libint->vrr_classes[8][15] = int_stack + 74631;
 Libint->vrr_classes[8][16] = int_stack + 80751;
 Libint->vrr_classes[9][9] = int_stack + 87636;
 Libint->vrr_classes[9][10] = int_stack + 90661;
 Libint->vrr_classes[9][11] = int_stack + 94291;
 Libint->vrr_classes[9][12] = int_stack + 98581;
 Libint->vrr_classes[9][13] = int_stack + 103586;
 Libint->vrr_classes[9][14] = int_stack + 109361;
 Libint->vrr_classes[9][15] = int_stack + 115961;
 Libint->vrr_classes[9][16] = int_stack + 123441;
 Libint->vrr_classes[10][9] = int_stack + 131856;
 Libint->vrr_classes[10][10] = int_stack + 135486;
 Libint->vrr_classes[10][11] = int_stack + 139842;
 Libint->vrr_classes[10][12] = int_stack + 144990;
 Libint->vrr_classes[10][13] = int_stack + 150996;
 Libint->vrr_classes[10][14] = int_stack + 157926;
 Libint->vrr_classes[10][15] = int_stack + 165846;
 Libint->vrr_classes[10][16] = int_stack + 174822;
 Libint->vrr_classes[11][9] = int_stack + 184920;
 Libint->vrr_classes[11][10] = int_stack + 189210;
 Libint->vrr_classes[11][11] = int_stack + 194358;
 Libint->vrr_classes[11][12] = int_stack + 200442;
 Libint->vrr_classes[11][13] = int_stack + 207540;
 Libint->vrr_classes[11][14] = int_stack + 215730;
 Libint->vrr_classes[11][15] = int_stack + 225090;
 Libint->vrr_classes[11][16] = int_stack + 235698;
 Libint->vrr_classes[12][9] = int_stack + 247632;
 Libint->vrr_classes[12][10] = int_stack + 252637;
 Libint->vrr_classes[12][11] = int_stack + 258643;
 Libint->vrr_classes[12][12] = int_stack + 265741;
 Libint->vrr_classes[12][13] = int_stack + 274022;
 Libint->vrr_classes[12][14] = int_stack + 283577;
 Libint->vrr_classes[12][15] = int_stack + 294497;
 Libint->vrr_classes[12][16] = int_stack + 306873;
 memset(int_stack,0,320796*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 320796;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_iimk(Libint, Data);
   Data++;
 }
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+320796,int_stack+1540,int_stack+0,28);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+325416,int_stack+3388,int_stack+1540,28);
 /*--- compute (i0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+330960,int_stack+325416,int_stack+320796,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+340200,int_stack+5572,int_stack+3388,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+346752,int_stack+340200,int_stack+325416,28);
 /*--- compute (i0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+357840,int_stack+346752,int_stack+330960,28);
 /*--- compute (i0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+320796,int_stack+8120,int_stack+5572,28);
 /*--- compute (i0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+373240,int_stack+320796,int_stack+340200,28);
 /*--- compute (i0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+386344,int_stack+373240,int_stack+346752,28);
 /*--- compute (i0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+328440,int_stack+386344,int_stack+357840,28);
 /*--- compute (i0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+351540,int_stack+11060,int_stack+8120,28);
 /*--- compute (i0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+404824,int_stack+351540,int_stack+320796,28);
 /*--- compute (i0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+420112,int_stack+404824,int_stack+373240,28);
 /*--- compute (i0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+441952,int_stack+420112,int_stack+386344,28);
 /*--- compute (i0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+360360,int_stack+441952,int_stack+328440,28);
 /*--- compute (i0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+320796,int_stack+14420,int_stack+11060,28);
 /*--- compute (i0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+330876,int_stack+320796,int_stack+351540,28);
 /*--- compute (i0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+469672,int_stack+330876,int_stack+404824,28);
 /*--- compute (i0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+495152,int_stack+469672,int_stack+420112,28);
 /*--- compute (i0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+392700,int_stack+495152,int_stack+441952,28);
 /*--- compute (i0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+527912,int_stack+392700,int_stack+360360,28);
 /*--- compute (i0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+348516,int_stack+18228,int_stack+14420,28);
 /*--- compute (i0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+359940,int_stack+348516,int_stack+320796,28);
 /*--- compute (i0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+431508,int_stack+359940,int_stack+330876,28);
 /*--- compute (i0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+320796,int_stack+431508,int_stack+469672,28);
 /*--- compute (i0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+431508,int_stack+320796,int_stack+495152,28);
 /*--- compute (i0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+320796,int_stack+431508,int_stack+392700,28);
 /*--- compute (i0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+372540,int_stack+320796,int_stack+527912,28);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+320796,int_stack+24492,int_stack+22512,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+326736,int_stack+26868,int_stack+24492,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+333864,int_stack+326736,int_stack+320796,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+345744,int_stack+29676,int_stack+26868,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+354168,int_stack+345744,int_stack+326736,36);
 /*--- compute (k0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+427980,int_stack+354168,int_stack+333864,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+320796,int_stack+32952,int_stack+29676,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+447780,int_stack+320796,int_stack+345744,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+464628,int_stack+447780,int_stack+354168,36);
 /*--- compute (k0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+330624,int_stack+464628,int_stack+427980,36);
 /*--- compute (k0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+427980,int_stack+36732,int_stack+32952,36);
 /*--- compute (k0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+488388,int_stack+427980,int_stack+320796,36);
 /*--- compute (k0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+508044,int_stack+488388,int_stack+447780,36);
 /*--- compute (k0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+536124,int_stack+508044,int_stack+464628,36);
 /*--- compute (k0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+439320,int_stack+536124,int_stack+330624,36);
 /*--- compute (k0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+320796,int_stack+41052,int_stack+36732,36);
 /*--- compute (k0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+333756,int_stack+320796,int_stack+427980,36);
 /*--- compute (k0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+0,int_stack+333756,int_stack+488388,36);
 /*--- compute (k0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+571764,int_stack+0,int_stack+508044,36);
 /*--- compute (k0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+480900,int_stack+571764,int_stack+536124,36);
 /*--- compute (k0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+613884,int_stack+480900,int_stack+439320,36);
 /*--- compute (k0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+427980,int_stack+45948,int_stack+41052,36);
 /*--- compute (k0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+442668,int_stack+427980,int_stack+320796,36);
 /*--- compute (k0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+530796,int_stack+442668,int_stack+333756,36);
 /*--- compute (k0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+320796,int_stack+530796,int_stack+0,36);
 /*--- compute (k0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+669324,int_stack+320796,int_stack+571764,36);
 /*--- compute (k0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+530796,int_stack+669324,int_stack+480900,36);
 /*--- compute (k0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+427980,int_stack+530796,int_stack+613884,36);
 /*--- compute (ip|mk) ---*/
 hrr1_build_ip(Libint->AB,int_stack+499260,int_stack+427980,int_stack+372540,1980);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+320796,int_stack+53931,int_stack+51456,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+328221,int_stack+56901,int_stack+53931,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+337131,int_stack+328221,int_stack+320796,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+351981,int_stack+60411,int_stack+56901,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+362511,int_stack+351981,int_stack+328221,45);
 /*--- compute (l0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+380331,int_stack+362511,int_stack+337131,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+320796,int_stack+64506,int_stack+60411,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+405081,int_stack+320796,int_stack+351981,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+0,int_stack+405081,int_stack+362511,45);
 /*--- compute (l0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+333081,int_stack+0,int_stack+380331,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+370206,int_stack+69231,int_stack+64506,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+29700,int_stack+370206,int_stack+320796,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+665580,int_stack+29700,int_stack+405081,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+700680,int_stack+665580,int_stack+0,45);
 /*--- compute (l0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+745230,int_stack+700680,int_stack+333081,45);
 /*--- compute (l0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+0,int_stack+74631,int_stack+69231,45);
 /*--- compute (l0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+320796,int_stack+0,int_stack+370206,45);
 /*--- compute (l0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+349146,int_stack+320796,int_stack+29700,45);
 /*--- compute (l0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+16200,int_stack+349146,int_stack+665580,45);
 /*--- compute (l0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+797205,int_stack+16200,int_stack+700680,45);
 /*--- compute (l0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+665580,int_stack+797205,int_stack+745230,45);
 /*--- compute (l0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+734880,int_stack+80751,int_stack+74631,45);
 /*--- compute (l0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+753240,int_stack+734880,int_stack+0,45);
 /*--- compute (l0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+859575,int_stack+753240,int_stack+320796,45);
 /*--- compute (l0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+734880,int_stack+859575,int_stack+349146,45);
 /*--- compute (l0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+320796,int_stack+734880,int_stack+16200,45);
 /*--- compute (l0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+0,int_stack+320796,int_stack+797205,45);
 /*--- compute (l0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+320796,int_stack+0,int_stack+665580,45);
 /*--- compute (kp|mk) ---*/
 hrr1_build_kp(Libint->AB,int_stack+665580,int_stack+320796,int_stack+427980,1980);
 /*--- compute (id|mk) ---*/
 hrr1_build_id(Libint->AB,int_stack+879420,int_stack+665580,int_stack+499260,1980);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+0,int_stack+90661,int_stack+87636,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+9075,int_stack+94291,int_stack+90661,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+19965,int_stack+9075,int_stack+0,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+38115,int_stack+98581,int_stack+94291,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+50985,int_stack+38115,int_stack+9075,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+409896,int_stack+50985,int_stack+19965,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+103586,int_stack+98581,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+72765,int_stack+0,int_stack+38115,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+440146,int_stack+72765,int_stack+50985,55);
 /*--- compute (m0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+15015,int_stack+440146,int_stack+409896,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+409896,int_stack+109361,int_stack+103586,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+476446,int_stack+409896,int_stack+0,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+506476,int_stack+476446,int_stack+72765,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+549376,int_stack+506476,int_stack+440146,55);
 /*--- compute (m0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+1212060,int_stack+549376,int_stack+15015,55);
 /*--- compute (m0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+0,int_stack+115961,int_stack+109361,55);
 /*--- compute (m0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+19800,int_stack+0,int_stack+409896,55);
 /*--- compute (m0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+409896,int_stack+19800,int_stack+476446,55);
 /*--- compute (m0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1275585,int_stack+409896,int_stack+506476,55);
 /*--- compute (m0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+459946,int_stack+1275585,int_stack+549376,55);
 /*--- compute (m0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+536176,int_stack+459946,int_stack+1212060,55);
 /*--- compute (m0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+1212060,int_stack+123441,int_stack+115961,55);
 /*--- compute (m0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1234500,int_stack+1212060,int_stack+0,55);
 /*--- compute (m0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+54450,int_stack+1234500,int_stack+19800,55);
 /*--- compute (m0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1339935,int_stack+54450,int_stack+409896,55);
 /*--- compute (m0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+0,int_stack+1339935,int_stack+1275585,55);
 /*--- compute (m0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1212060,int_stack+0,int_stack+459946,55);
 /*--- compute (m0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+0,int_stack+1212060,int_stack+536176,55);
 /*--- compute (lp|mk) ---*/
 hrr1_build_lp(Libint->AB,int_stack+1212060,int_stack+0,int_stack+320796,1980);
 /*--- compute (kd|mk) ---*/
 hrr1_build_kd(Libint->AB,int_stack+1479360,int_stack+1212060,int_stack+665580,1980);
 /*--- compute (if|mk) ---*/
 hrr1_build_if(Libint->AB,int_stack+320796,int_stack+1479360,int_stack+879420,1980);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+875196,int_stack+135486,int_stack+131856,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+886086,int_stack+139842,int_stack+135486,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+899154,int_stack+886086,int_stack+875196,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+920934,int_stack+144990,int_stack+139842,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+936378,int_stack+920934,int_stack+886086,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+962514,int_stack+936378,int_stack+899154,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+875196,int_stack+150996,int_stack+144990,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+998814,int_stack+875196,int_stack+920934,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+1029702,int_stack+998814,int_stack+936378,66);
 /*--- compute (n0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+893214,int_stack+1029702,int_stack+962514,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+947664,int_stack+157926,int_stack+150996,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+1073262,int_stack+947664,int_stack+875196,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1109298,int_stack+1073262,int_stack+998814,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1907040,int_stack+1109298,int_stack+1029702,66);
 /*--- compute (n0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+968454,int_stack+1907040,int_stack+893214,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+875196,int_stack+165846,int_stack+157926,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+898956,int_stack+875196,int_stack+947664,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1972380,int_stack+898956,int_stack+1073262,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+2032440,int_stack+1972380,int_stack+1109298,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1044684,int_stack+2032440,int_stack+1907040,66);
 /*--- compute (n0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+2109660,int_stack+1044684,int_stack+968454,66);
 /*--- compute (n0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+1907040,int_stack+174822,int_stack+165846,66);
 /*--- compute (n0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+940536,int_stack+1907040,int_stack+875196,66);
 /*--- compute (n0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1136160,int_stack+940536,int_stack+898956,66);
 /*--- compute (n0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+875196,int_stack+1136160,int_stack+1972380,66);
 /*--- compute (n0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1907040,int_stack+875196,int_stack+2032440,66);
 /*--- compute (n0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+875196,int_stack+1907040,int_stack+1044684,66);
 /*--- compute (n0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+1907040,int_stack+875196,int_stack+2109660,66);
 /*--- compute (mp|mk) ---*/
 hrr1_build_mp(Libint->AB,int_stack+875196,int_stack+1907040,int_stack+0,1980);
 /*--- compute (ld|mk) ---*/
 hrr1_build_ld(Libint->AB,int_stack+2037720,int_stack+875196,int_stack+1212060,1980);
 /*--- compute (kf|mk) ---*/
 hrr1_build_kf(Libint->AB,int_stack+2572320,int_stack+2037720,int_stack+1479360,1980);
 /*--- compute (ig|mk) ---*/
 hrr1_build_ig(Libint->AB,int_stack+3285120,int_stack+2572320,int_stack+320796,1980);
 /*--- compute (o0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+320796,int_stack+189210,int_stack+184920,78);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+333666,int_stack+194358,int_stack+189210,78);
 /*--- compute (o0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+349110,int_stack+333666,int_stack+320796,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+374850,int_stack+200442,int_stack+194358,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+393102,int_stack+374850,int_stack+333666,78);
 /*--- compute (o0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+423990,int_stack+393102,int_stack+349110,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+320796,int_stack+207540,int_stack+200442,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+466890,int_stack+320796,int_stack+374850,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+503394,int_stack+466890,int_stack+393102,78);
 /*--- compute (o0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+342090,int_stack+503394,int_stack+423990,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+406440,int_stack+215730,int_stack+207540,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+554874,int_stack+406440,int_stack+320796,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+597462,int_stack+554874,int_stack+466890,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+658302,int_stack+597462,int_stack+503394,78);
 /*--- compute (o0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+431010,int_stack+658302,int_stack+342090,78);
 /*--- compute (o0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+320796,int_stack+225090,int_stack+215730,78);
 /*--- compute (o0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+348876,int_stack+320796,int_stack+406440,78);
 /*--- compute (o0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+735522,int_stack+348876,int_stack+554874,78);
 /*--- compute (o0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+0,int_stack+735522,int_stack+597462,78);
 /*--- compute (o0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+521100,int_stack+0,int_stack+658302,78);
 /*--- compute (o0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+91260,int_stack+521100,int_stack+431010,78);
 /*--- compute (o0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+398016,int_stack+235698,int_stack+225090,78);
 /*--- compute (o0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+429840,int_stack+398016,int_stack+320796,78);
 /*--- compute (o0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+629208,int_stack+429840,int_stack+348876,78);
 /*--- compute (o0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+320796,int_stack+629208,int_stack+735522,78);
 /*--- compute (o0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+629208,int_stack+320796,int_stack+0,78);
 /*--- compute (o0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+320796,int_stack+629208,int_stack+521100,78);
 /*--- compute (o0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+464940,int_stack+320796,int_stack+91260,78);
 /*--- compute (np|mk) ---*/
 hrr1_build_np(Libint->AB,int_stack+1201896,int_stack+464940,int_stack+1907040,1980);
 /*--- compute (md|mk) ---*/
 hrr1_build_md(Libint->AB,int_stack+4116720,int_stack+1201896,int_stack+875196,1980);
 /*--- compute (lf|mk) ---*/
 hrr1_build_lf(Libint->AB,int_stack+4770120,int_stack+4116720,int_stack+2037720,1980);
 /*--- compute (kg|mk) ---*/
 hrr1_build_kg(Libint->AB,int_stack+5661120,int_stack+4770120,int_stack+2572320,1980);
 /*--- compute (ih|mk) ---*/
 hrr1_build_ih(Libint->AB,int_stack+1593936,int_stack+5661120,int_stack+3285120,1980);
 /*--- compute (q0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+320796,int_stack+252637,int_stack+247632,91);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+335811,int_stack+258643,int_stack+252637,91);
 /*--- compute (q0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+353829,int_stack+335811,int_stack+320796,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+383859,int_stack+265741,int_stack+258643,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+405153,int_stack+383859,int_stack+335811,91);
 /*--- compute (q0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+0,int_stack+405153,int_stack+353829,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+320796,int_stack+274022,int_stack+265741,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+50050,int_stack+320796,int_stack+383859,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+92638,int_stack+50050,int_stack+405153,91);
 /*--- compute (q0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+345639,int_stack+92638,int_stack+0,91);
 /*--- compute (q0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+283577,int_stack+274022,91);
 /*--- compute (q0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+152698,int_stack+0,int_stack+320796,91);
 /*--- compute (q0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+202384,int_stack+152698,int_stack+50050,91);
 /*--- compute (q0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+619380,int_stack+202384,int_stack+92638,91);
 /*--- compute (q0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+28665,int_stack+619380,int_stack+345639,91);
 /*--- compute (q0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+320796,int_stack+294497,int_stack+283577,91);
 /*--- compute (q0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+353556,int_stack+320796,int_stack+0,91);
 /*--- compute (q0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+709470,int_stack+353556,int_stack+152698,91);
 /*--- compute (q0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+792280,int_stack+709470,int_stack+202384,91);
 /*--- compute (q0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+133770,int_stack+792280,int_stack+619380,91);
 /*--- compute (q0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+898750,int_stack+133770,int_stack+28665,91);
 /*--- compute (q0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+619380,int_stack+306873,int_stack+294497,91);
 /*--- compute (q0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+0,int_stack+619380,int_stack+320796,91);
 /*--- compute (q0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1038890,int_stack+0,int_stack+353556,91);
 /*--- compute (q0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+0,int_stack+1038890,int_stack+709470,91);
 /*--- compute (q0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1038890,int_stack+0,int_stack+792280,91);
 /*--- compute (q0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+619380,int_stack+1038890,int_stack+133770,91);
 /*--- compute (q0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+0,int_stack+619380,int_stack+898750,91);
 /*--- compute (op|mk) ---*/
 hrr1_build_op(Libint->AB,int_stack+619380,int_stack+0,int_stack+464940,1980);
 /*--- compute (nd|mk) ---*/
 hrr1_build_nd(Libint->AB,int_stack+2758176,int_stack+619380,int_stack+1201896,1980);
 /*--- compute (mf|mk) ---*/
 hrr1_build_mf(Libint->AB,int_stack+0,int_stack+2758176,int_stack+4116720,1980);
 /*--- compute (lg|mk) ---*/
 hrr1_build_lg(Libint->AB,int_stack+2758176,int_stack+0,int_stack+4770120,1980);
 /*--- compute (kh|mk) ---*/
 hrr1_build_kh(Libint->AB,int_stack+0,int_stack+2758176,int_stack+5661120,1980);
 /*--- compute (ii|mk) ---*/
 hrr1_build_ii(Libint->AB,int_stack+2758176,int_stack+0,int_stack+1593936,1980);
 return int_stack+2758176;}
