/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_ipig(Libint_t*, prim_data*);

  /* Computes quartets of (ip|ig) integrals */

REALTYPE *hrr_order_ipig(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[6][6] = int_stack + 0;
 Libint->vrr_classes[6][7] = int_stack + 784;
 Libint->vrr_classes[6][8] = int_stack + 1792;
 Libint->vrr_classes[6][9] = int_stack + 3052;
 Libint->vrr_classes[6][10] = int_stack + 4592;
 Libint->vrr_classes[7][6] = int_stack + 6440;
 Libint->vrr_classes[7][7] = int_stack + 7448;
 Libint->vrr_classes[7][8] = int_stack + 8744;
 Libint->vrr_classes[7][9] = int_stack + 10364;
 Libint->vrr_classes[7][10] = int_stack + 12344;
 memset(int_stack,0,14720*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 14720;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_ipig(Libint, Data);
   Data++;
 }
 /*--- compute (i0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+14720,int_stack+784,int_stack+0,28);
 /*--- compute (i0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+17072,int_stack+1792,int_stack+784,28);
 /*--- compute (i0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+20096,int_stack+17072,int_stack+14720,28);
 /*--- compute (i0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+24800,int_stack+3052,int_stack+1792,28);
 /*--- compute (i0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+28580,int_stack+24800,int_stack+17072,28);
 /*--- compute (i0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+34628,int_stack+28580,int_stack+20096,28);
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+14720,int_stack+4592,int_stack+3052,28);
 /*--- compute (i0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+42468,int_stack+14720,int_stack+24800,28);
 /*--- compute (i0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+14720,int_stack+42468,int_stack+28580,28);
 /*--- compute (i0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+42468,int_stack+14720,int_stack+34628,28);
 /*--- compute (k0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+14720,int_stack+7448,int_stack+6440,36);
 /*--- compute (k0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+17744,int_stack+8744,int_stack+7448,36);
 /*--- compute (k0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+21632,int_stack+17744,int_stack+14720,36);
 /*--- compute (k0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+27680,int_stack+10364,int_stack+8744,36);
 /*--- compute (k0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+32540,int_stack+27680,int_stack+17744,36);
 /*--- compute (k0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+0,int_stack+32540,int_stack+21632,36);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+14720,int_stack+12344,int_stack+10364,36);
 /*--- compute (k0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+54228,int_stack+14720,int_stack+27680,36);
 /*--- compute (k0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+10080,int_stack+54228,int_stack+32540,36);
 /*--- compute (k0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+23040,int_stack+10080,int_stack+0,36);
 /*--- compute (ip|ig) ---*/
 hrr1_build_ip(Libint->AB,int_stack+54228,int_stack+23040,int_stack+42468,420);
 return int_stack+54228;}
