/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_ipmf(Libint_t*, prim_data*);

  /* Computes quartets of (ip|mf) integrals */

REALTYPE *hrr_order_ipmf(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[6][9] = int_stack + 0;
 Libint->vrr_classes[6][10] = int_stack + 1540;
 Libint->vrr_classes[6][11] = int_stack + 3388;
 Libint->vrr_classes[6][12] = int_stack + 5572;
 Libint->vrr_classes[7][9] = int_stack + 8120;
 Libint->vrr_classes[7][10] = int_stack + 10100;
 Libint->vrr_classes[7][11] = int_stack + 12476;
 Libint->vrr_classes[7][12] = int_stack + 15284;
 memset(int_stack,0,18560*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 18560;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_ipmf(Libint, Data);
   Data++;
 }
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+18560,int_stack+1540,int_stack+0,28);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+23180,int_stack+3388,int_stack+1540,28);
 /*--- compute (i0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+28724,int_stack+23180,int_stack+18560,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+37964,int_stack+5572,int_stack+3388,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+44516,int_stack+37964,int_stack+23180,28);
 /*--- compute (i0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+55604,int_stack+44516,int_stack+28724,28);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+18560,int_stack+10100,int_stack+8120,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+24500,int_stack+12476,int_stack+10100,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+31628,int_stack+24500,int_stack+18560,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+43508,int_stack+15284,int_stack+12476,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+0,int_stack+43508,int_stack+24500,36);
 /*--- compute (k0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+71004,int_stack+0,int_stack+31628,36);
 /*--- compute (ip|mf) ---*/
 hrr1_build_ip(Libint->AB,int_stack+0,int_stack+71004,int_stack+55604,550);
 return int_stack+0;}
