/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_ipmh(Libint_t*, prim_data*);

  /* Computes quartets of (ip|mh) integrals */

REALTYPE *hrr_order_ipmh(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[6][9] = int_stack + 0;
 Libint->vrr_classes[6][10] = int_stack + 1540;
 Libint->vrr_classes[6][11] = int_stack + 3388;
 Libint->vrr_classes[6][12] = int_stack + 5572;
 Libint->vrr_classes[6][13] = int_stack + 8120;
 Libint->vrr_classes[6][14] = int_stack + 11060;
 Libint->vrr_classes[7][9] = int_stack + 14420;
 Libint->vrr_classes[7][10] = int_stack + 16400;
 Libint->vrr_classes[7][11] = int_stack + 18776;
 Libint->vrr_classes[7][12] = int_stack + 21584;
 Libint->vrr_classes[7][13] = int_stack + 24860;
 Libint->vrr_classes[7][14] = int_stack + 28640;
 memset(int_stack,0,32960*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 32960;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_ipmh(Libint, Data);
   Data++;
 }
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+32960,int_stack+1540,int_stack+0,28);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+37580,int_stack+3388,int_stack+1540,28);
 /*--- compute (i0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+43124,int_stack+37580,int_stack+32960,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+52364,int_stack+5572,int_stack+3388,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+58916,int_stack+52364,int_stack+37580,28);
 /*--- compute (i0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+70004,int_stack+58916,int_stack+43124,28);
 /*--- compute (i0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+32960,int_stack+8120,int_stack+5572,28);
 /*--- compute (i0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+85404,int_stack+32960,int_stack+52364,28);
 /*--- compute (i0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+98508,int_stack+85404,int_stack+58916,28);
 /*--- compute (i0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+40604,int_stack+98508,int_stack+70004,28);
 /*--- compute (i0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+63704,int_stack+11060,int_stack+8120,28);
 /*--- compute (i0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+116988,int_stack+63704,int_stack+32960,28);
 /*--- compute (i0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+132276,int_stack+116988,int_stack+85404,28);
 /*--- compute (i0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+63704,int_stack+132276,int_stack+98508,28);
 /*--- compute (i0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+91424,int_stack+63704,int_stack+40604,28);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+32960,int_stack+16400,int_stack+14420,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+38900,int_stack+18776,int_stack+16400,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+46028,int_stack+38900,int_stack+32960,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+57908,int_stack+21584,int_stack+18776,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+66332,int_stack+57908,int_stack+38900,36);
 /*--- compute (k0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+123764,int_stack+66332,int_stack+46028,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+32960,int_stack+24860,int_stack+21584,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+0,int_stack+32960,int_stack+57908,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+143564,int_stack+0,int_stack+66332,36);
 /*--- compute (k0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+42788,int_stack+143564,int_stack+123764,36);
 /*--- compute (k0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+123764,int_stack+28640,int_stack+24860,36);
 /*--- compute (k0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+167324,int_stack+123764,int_stack+32960,36);
 /*--- compute (k0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+186980,int_stack+167324,int_stack+0,36);
 /*--- compute (k0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+0,int_stack+186980,int_stack+143564,36);
 /*--- compute (k0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+123764,int_stack+0,int_stack+42788,36);
 /*--- compute (ip|mh) ---*/
 hrr1_build_ip(Libint->AB,int_stack+165344,int_stack+123764,int_stack+91424,1155);
 return int_stack+165344;}
