/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_kdii(Libint_t*, prim_data*);

  /* Computes quartets of (kd|ii) integrals */

REALTYPE *hrr_order_kdii(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[7][6] = int_stack + 0;
 Libint->vrr_classes[7][7] = int_stack + 1008;
 Libint->vrr_classes[7][8] = int_stack + 2304;
 Libint->vrr_classes[7][9] = int_stack + 3924;
 Libint->vrr_classes[7][10] = int_stack + 5904;
 Libint->vrr_classes[7][11] = int_stack + 8280;
 Libint->vrr_classes[7][12] = int_stack + 11088;
 Libint->vrr_classes[8][6] = int_stack + 14364;
 Libint->vrr_classes[8][7] = int_stack + 15624;
 Libint->vrr_classes[8][8] = int_stack + 17244;
 Libint->vrr_classes[8][9] = int_stack + 19269;
 Libint->vrr_classes[8][10] = int_stack + 21744;
 Libint->vrr_classes[8][11] = int_stack + 24714;
 Libint->vrr_classes[8][12] = int_stack + 28224;
 Libint->vrr_classes[9][6] = int_stack + 32319;
 Libint->vrr_classes[9][7] = int_stack + 33859;
 Libint->vrr_classes[9][8] = int_stack + 35839;
 Libint->vrr_classes[9][9] = int_stack + 38314;
 Libint->vrr_classes[9][10] = int_stack + 41339;
 Libint->vrr_classes[9][11] = int_stack + 44969;
 Libint->vrr_classes[9][12] = int_stack + 49259;
 memset(int_stack,0,54264*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 54264;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_kdii(Libint, Data);
   Data++;
 }
 /*--- compute (k0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+54264,int_stack+1008,int_stack+0,36);
 /*--- compute (k0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+57288,int_stack+2304,int_stack+1008,36);
 /*--- compute (k0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+61176,int_stack+57288,int_stack+54264,36);
 /*--- compute (k0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+67224,int_stack+3924,int_stack+2304,36);
 /*--- compute (k0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+72084,int_stack+67224,int_stack+57288,36);
 /*--- compute (k0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+79860,int_stack+72084,int_stack+61176,36);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+54264,int_stack+5904,int_stack+3924,36);
 /*--- compute (k0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+89940,int_stack+54264,int_stack+67224,36);
 /*--- compute (k0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+99660,int_stack+89940,int_stack+72084,36);
 /*--- compute (k0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+60204,int_stack+99660,int_stack+79860,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+75324,int_stack+8280,int_stack+5904,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+112620,int_stack+75324,int_stack+54264,36);
 /*--- compute (k0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+124500,int_stack+112620,int_stack+89940,36);
 /*--- compute (k0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+140700,int_stack+124500,int_stack+99660,36);
 /*--- compute (k0|ih) ---*/
 hrr3_build_ih(Libint->CD,int_stack+82452,int_stack+140700,int_stack+60204,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+54264,int_stack+11088,int_stack+8280,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+0,int_stack+54264,int_stack+75324,36);
 /*--- compute (k0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+54264,int_stack+0,int_stack+112620,36);
 /*--- compute (k0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+160140,int_stack+54264,int_stack+124500,36);
 /*--- compute (k0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+54264,int_stack+160140,int_stack+140700,36);
 /*--- compute (k0|ii) ---*/
 hrr3_build_ii(Libint->CD,int_stack+103620,int_stack+54264,int_stack+82452,36);
 /*--- compute (l0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+54264,int_stack+15624,int_stack+14364,45);
 /*--- compute (l0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+58044,int_stack+17244,int_stack+15624,45);
 /*--- compute (l0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+62904,int_stack+58044,int_stack+54264,45);
 /*--- compute (l0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+70464,int_stack+19269,int_stack+17244,45);
 /*--- compute (l0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+76539,int_stack+70464,int_stack+58044,45);
 /*--- compute (l0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+86259,int_stack+76539,int_stack+62904,45);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+54264,int_stack+21744,int_stack+19269,45);
 /*--- compute (l0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+0,int_stack+54264,int_stack+70464,45);
 /*--- compute (l0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+131844,int_stack+0,int_stack+76539,45);
 /*--- compute (l0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+61689,int_stack+131844,int_stack+86259,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+80589,int_stack+24714,int_stack+21744,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+148044,int_stack+80589,int_stack+54264,45);
 /*--- compute (l0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+162894,int_stack+148044,int_stack+0,45);
 /*--- compute (l0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+0,int_stack+162894,int_stack+131844,45);
 /*--- compute (l0|ih) ---*/
 hrr3_build_ih(Libint->CD,int_stack+183144,int_stack+0,int_stack+61689,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+131844,int_stack+28224,int_stack+24714,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+54264,int_stack+131844,int_stack+80589,45);
 /*--- compute (l0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+72084,int_stack+54264,int_stack+148044,45);
 /*--- compute (l0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+131844,int_stack+72084,int_stack+162894,45);
 /*--- compute (l0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+54264,int_stack+131844,int_stack+0,45);
 /*--- compute (l0|ii) ---*/
 hrr3_build_ii(Libint->CD,int_stack+131844,int_stack+54264,int_stack+183144,45);
 /*--- compute (kp|ii) ---*/
 hrr1_build_kp(Libint->AB,int_stack+167124,int_stack+131844,int_stack+103620,784);
 /*--- compute (m0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+54264,int_stack+33859,int_stack+32319,55);
 /*--- compute (m0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+58884,int_stack+35839,int_stack+33859,55);
 /*--- compute (m0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+64824,int_stack+58884,int_stack+54264,55);
 /*--- compute (m0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+74064,int_stack+38314,int_stack+35839,55);
 /*--- compute (m0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+81489,int_stack+74064,int_stack+58884,55);
 /*--- compute (m0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+93369,int_stack+81489,int_stack+64824,55);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+54264,int_stack+41339,int_stack+38314,55);
 /*--- compute (m0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+108769,int_stack+54264,int_stack+74064,55);
 /*--- compute (m0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+0,int_stack+108769,int_stack+81489,55);
 /*--- compute (m0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+63339,int_stack+0,int_stack+93369,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+86439,int_stack+44969,int_stack+41339,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+19800,int_stack+86439,int_stack+54264,55);
 /*--- compute (m0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+251796,int_stack+19800,int_stack+108769,55);
 /*--- compute (m0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+97329,int_stack+251796,int_stack+0,55);
 /*--- compute (m0|ih) ---*/
 hrr3_build_ih(Libint->CD,int_stack+276546,int_stack+97329,int_stack+63339,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+0,int_stack+49259,int_stack+44969,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+37950,int_stack+0,int_stack+86439,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+59730,int_stack+37950,int_stack+19800,55);
 /*--- compute (m0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+0,int_stack+59730,int_stack+251796,55);
 /*--- compute (m0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+37125,int_stack+0,int_stack+97329,55);
 /*--- compute (m0|ii) ---*/
 hrr3_build_ii(Libint->CD,int_stack+78705,int_stack+37125,int_stack+276546,55);
 /*--- compute (lp|ii) ---*/
 hrr1_build_lp(Libint->AB,int_stack+251796,int_stack+78705,int_stack+131844,784);
 /*--- compute (kd|ii) ---*/
 hrr1_build_kd(Libint->AB,int_stack+357636,int_stack+251796,int_stack+167124,784);
 return int_stack+357636;}
