/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_kdkh(Libint_t*, prim_data*);

  /* Computes quartets of (kd|kh) integrals */

REALTYPE *hrr_order_kdkh(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[7][7] = int_stack + 0;
 Libint->vrr_classes[7][8] = int_stack + 1296;
 Libint->vrr_classes[7][9] = int_stack + 2916;
 Libint->vrr_classes[7][10] = int_stack + 4896;
 Libint->vrr_classes[7][11] = int_stack + 7272;
 Libint->vrr_classes[7][12] = int_stack + 10080;
 Libint->vrr_classes[8][7] = int_stack + 13356;
 Libint->vrr_classes[8][8] = int_stack + 14976;
 Libint->vrr_classes[8][9] = int_stack + 17001;
 Libint->vrr_classes[8][10] = int_stack + 19476;
 Libint->vrr_classes[8][11] = int_stack + 22446;
 Libint->vrr_classes[8][12] = int_stack + 25956;
 Libint->vrr_classes[9][7] = int_stack + 30051;
 Libint->vrr_classes[9][8] = int_stack + 32031;
 Libint->vrr_classes[9][9] = int_stack + 34506;
 Libint->vrr_classes[9][10] = int_stack + 37531;
 Libint->vrr_classes[9][11] = int_stack + 41161;
 Libint->vrr_classes[9][12] = int_stack + 45451;
 memset(int_stack,0,50456*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 50456;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_kdkh(Libint, Data);
   Data++;
 }
 /*--- compute (k0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+50456,int_stack+1296,int_stack+0,36);
 /*--- compute (k0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+54344,int_stack+2916,int_stack+1296,36);
 /*--- compute (k0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+59204,int_stack+54344,int_stack+50456,36);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+66980,int_stack+4896,int_stack+2916,36);
 /*--- compute (k0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+72920,int_stack+66980,int_stack+54344,36);
 /*--- compute (k0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+82640,int_stack+72920,int_stack+59204,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+50456,int_stack+7272,int_stack+4896,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+95600,int_stack+50456,int_stack+66980,36);
 /*--- compute (k0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+107480,int_stack+95600,int_stack+72920,36);
 /*--- compute (k0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+57584,int_stack+107480,int_stack+82640,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+77024,int_stack+10080,int_stack+7272,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+123680,int_stack+77024,int_stack+50456,36);
 /*--- compute (k0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+137936,int_stack+123680,int_stack+95600,36);
 /*--- compute (k0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+77024,int_stack+137936,int_stack+107480,36);
 /*--- compute (k0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+101324,int_stack+77024,int_stack+57584,36);
 /*--- compute (l0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+50456,int_stack+14976,int_stack+13356,45);
 /*--- compute (l0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+55316,int_stack+17001,int_stack+14976,45);
 /*--- compute (l0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+61391,int_stack+55316,int_stack+50456,45);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+71111,int_stack+19476,int_stack+17001,45);
 /*--- compute (l0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+78536,int_stack+71111,int_stack+55316,45);
 /*--- compute (l0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+128540,int_stack+78536,int_stack+61391,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+50456,int_stack+22446,int_stack+19476,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+0,int_stack+50456,int_stack+71111,45);
 /*--- compute (l0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+144740,int_stack+0,int_stack+78536,45);
 /*--- compute (l0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+59366,int_stack+144740,int_stack+128540,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+128540,int_stack+25956,int_stack+22446,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+164990,int_stack+128540,int_stack+50456,45);
 /*--- compute (l0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+182810,int_stack+164990,int_stack+0,45);
 /*--- compute (l0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+207560,int_stack+182810,int_stack+144740,45);
 /*--- compute (l0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+128540,int_stack+207560,int_stack+59366,45);
 /*--- compute (kp|kh) ---*/
 hrr1_build_kp(Libint->AB,int_stack+162560,int_stack+128540,int_stack+101324,756);
 /*--- compute (m0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+0,int_stack+32031,int_stack+30051,55);
 /*--- compute (m0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+5940,int_stack+34506,int_stack+32031,55);
 /*--- compute (m0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+13365,int_stack+5940,int_stack+0,55);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+25245,int_stack+37531,int_stack+34506,55);
 /*--- compute (m0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+50456,int_stack+25245,int_stack+5940,55);
 /*--- compute (m0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+65306,int_stack+50456,int_stack+13365,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+41161,int_stack+37531,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+85106,int_stack+0,int_stack+25245,55);
 /*--- compute (m0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+10890,int_stack+85106,int_stack+50456,55);
 /*--- compute (m0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+244208,int_stack+10890,int_stack+65306,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+50456,int_stack+45451,int_stack+41161,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+63326,int_stack+50456,int_stack+0,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+273908,int_stack+63326,int_stack+85106,55);
 /*--- compute (m0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+35640,int_stack+273908,int_stack+10890,55);
 /*--- compute (m0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+72765,int_stack+35640,int_stack+244208,55);
 /*--- compute (lp|kh) ---*/
 hrr1_build_lp(Libint->AB,int_stack+244208,int_stack+72765,int_stack+128540,756);
 /*--- compute (kd|kh) ---*/
 hrr1_build_kd(Libint->AB,int_stack+346268,int_stack+244208,int_stack+162560,756);
 return int_stack+346268;}
