/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_kgnf(Libint_t*, prim_data*);

  /* Computes quartets of (kg|nf) integrals */

REALTYPE *hrr_order_kgnf(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[7][10] = int_stack + 0;
 Libint->vrr_classes[7][11] = int_stack + 2376;
 Libint->vrr_classes[7][12] = int_stack + 5184;
 Libint->vrr_classes[7][13] = int_stack + 8460;
 Libint->vrr_classes[8][10] = int_stack + 12240;
 Libint->vrr_classes[8][11] = int_stack + 15210;
 Libint->vrr_classes[8][12] = int_stack + 18720;
 Libint->vrr_classes[8][13] = int_stack + 22815;
 Libint->vrr_classes[9][10] = int_stack + 27540;
 Libint->vrr_classes[9][11] = int_stack + 31170;
 Libint->vrr_classes[9][12] = int_stack + 35460;
 Libint->vrr_classes[9][13] = int_stack + 40465;
 Libint->vrr_classes[10][10] = int_stack + 46240;
 Libint->vrr_classes[10][11] = int_stack + 50596;
 Libint->vrr_classes[10][12] = int_stack + 55744;
 Libint->vrr_classes[10][13] = int_stack + 61750;
 Libint->vrr_classes[11][10] = int_stack + 68680;
 Libint->vrr_classes[11][11] = int_stack + 73828;
 Libint->vrr_classes[11][12] = int_stack + 79912;
 Libint->vrr_classes[11][13] = int_stack + 87010;
 memset(int_stack,0,95200*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 95200;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_kgnf(Libint, Data);
   Data++;
 }
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+95200,int_stack+2376,int_stack+0,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+102328,int_stack+5184,int_stack+2376,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+110752,int_stack+102328,int_stack+95200,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+125008,int_stack+8460,int_stack+5184,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+134836,int_stack+125008,int_stack+102328,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+151684,int_stack+134836,int_stack+110752,36);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+95200,int_stack+15210,int_stack+12240,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+104110,int_stack+18720,int_stack+15210,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+114640,int_stack+104110,int_stack+95200,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+132460,int_stack+22815,int_stack+18720,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+0,int_stack+132460,int_stack+104110,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+175444,int_stack+0,int_stack+114640,45);
 /*--- compute (kp|nf) ---*/
 hrr1_build_kp(Libint->AB,int_stack+205144,int_stack+175444,int_stack+151684,660);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+31170,int_stack+27540,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+10890,int_stack+35460,int_stack+31170,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+95200,int_stack+10890,int_stack+0,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+116980,int_stack+40465,int_stack+35460,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+131995,int_stack+116980,int_stack+10890,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+0,int_stack+131995,int_stack+95200,55);
 /*--- compute (lp|nf) ---*/
 hrr1_build_lp(Libint->AB,int_stack+276424,int_stack+0,int_stack+175444,660);
 /*--- compute (kd|nf) ---*/
 hrr1_build_kd(Libint->AB,int_stack+365524,int_stack+276424,int_stack+205144,660);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+95200,int_stack+50596,int_stack+46240,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+108268,int_stack+55744,int_stack+50596,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+123712,int_stack+108268,int_stack+95200,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+149848,int_stack+61750,int_stack+55744,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+167866,int_stack+149848,int_stack+108268,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+198754,int_stack+167866,int_stack+123712,66);
 /*--- compute (mp|nf) ---*/
 hrr1_build_mp(Libint->AB,int_stack+508084,int_stack+198754,int_stack+0,660);
 /*--- compute (ld|nf) ---*/
 hrr1_build_ld(Libint->AB,int_stack+616984,int_stack+508084,int_stack+276424,660);
 /*--- compute (kf|nf) ---*/
 hrr1_build_kf(Libint->AB,int_stack+795184,int_stack+616984,int_stack+365524,660);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+73828,int_stack+68680,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+15444,int_stack+79912,int_stack+73828,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+33696,int_stack+15444,int_stack+0,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+95200,int_stack+87010,int_stack+79912,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+116494,int_stack+95200,int_stack+15444,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+64584,int_stack+116494,int_stack+33696,78);
 /*--- compute (np|nf) ---*/
 hrr1_build_np(Libint->AB,int_stack+242314,int_stack+64584,int_stack+198754,660);
 /*--- compute (md|nf) ---*/
 hrr1_build_md(Libint->AB,int_stack+0,int_stack+242314,int_stack+508084,660);
 /*--- compute (lf|nf) ---*/
 hrr1_build_lf(Libint->AB,int_stack+217800,int_stack+0,int_stack+616984,660);
 /*--- compute (kg|nf) ---*/
 hrr1_build_kg(Libint->AB,int_stack+1032784,int_stack+217800,int_stack+795184,660);
 return int_stack+1032784;}
