/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_khlk(Libint_t*, prim_data*);

  /* Computes quartets of (kh|lk) integrals */

REALTYPE *hrr_order_khlk(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[7][8] = int_stack + 0;
 Libint->vrr_classes[7][9] = int_stack + 1620;
 Libint->vrr_classes[7][10] = int_stack + 3600;
 Libint->vrr_classes[7][11] = int_stack + 5976;
 Libint->vrr_classes[7][12] = int_stack + 8784;
 Libint->vrr_classes[7][13] = int_stack + 12060;
 Libint->vrr_classes[7][14] = int_stack + 15840;
 Libint->vrr_classes[7][15] = int_stack + 20160;
 Libint->vrr_classes[8][8] = int_stack + 25056;
 Libint->vrr_classes[8][9] = int_stack + 27081;
 Libint->vrr_classes[8][10] = int_stack + 29556;
 Libint->vrr_classes[8][11] = int_stack + 32526;
 Libint->vrr_classes[8][12] = int_stack + 36036;
 Libint->vrr_classes[8][13] = int_stack + 40131;
 Libint->vrr_classes[8][14] = int_stack + 44856;
 Libint->vrr_classes[8][15] = int_stack + 50256;
 Libint->vrr_classes[9][8] = int_stack + 56376;
 Libint->vrr_classes[9][9] = int_stack + 58851;
 Libint->vrr_classes[9][10] = int_stack + 61876;
 Libint->vrr_classes[9][11] = int_stack + 65506;
 Libint->vrr_classes[9][12] = int_stack + 69796;
 Libint->vrr_classes[9][13] = int_stack + 74801;
 Libint->vrr_classes[9][14] = int_stack + 80576;
 Libint->vrr_classes[9][15] = int_stack + 87176;
 Libint->vrr_classes[10][8] = int_stack + 94656;
 Libint->vrr_classes[10][9] = int_stack + 97626;
 Libint->vrr_classes[10][10] = int_stack + 101256;
 Libint->vrr_classes[10][11] = int_stack + 105612;
 Libint->vrr_classes[10][12] = int_stack + 110760;
 Libint->vrr_classes[10][13] = int_stack + 116766;
 Libint->vrr_classes[10][14] = int_stack + 123696;
 Libint->vrr_classes[10][15] = int_stack + 131616;
 Libint->vrr_classes[11][8] = int_stack + 140592;
 Libint->vrr_classes[11][9] = int_stack + 144102;
 Libint->vrr_classes[11][10] = int_stack + 148392;
 Libint->vrr_classes[11][11] = int_stack + 153540;
 Libint->vrr_classes[11][12] = int_stack + 159624;
 Libint->vrr_classes[11][13] = int_stack + 166722;
 Libint->vrr_classes[11][14] = int_stack + 174912;
 Libint->vrr_classes[11][15] = int_stack + 184272;
 Libint->vrr_classes[12][8] = int_stack + 194880;
 Libint->vrr_classes[12][9] = int_stack + 198975;
 Libint->vrr_classes[12][10] = int_stack + 203980;
 Libint->vrr_classes[12][11] = int_stack + 209986;
 Libint->vrr_classes[12][12] = int_stack + 217084;
 Libint->vrr_classes[12][13] = int_stack + 225365;
 Libint->vrr_classes[12][14] = int_stack + 234920;
 Libint->vrr_classes[12][15] = int_stack + 245840;
 memset(int_stack,0,258216*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 258216;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_khlk(Libint, Data);
   Data++;
 }
 /*--- compute (k0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+258216,int_stack+1620,int_stack+0,36);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+263076,int_stack+3600,int_stack+1620,36);
 /*--- compute (k0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+269016,int_stack+263076,int_stack+258216,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+278736,int_stack+5976,int_stack+3600,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+285864,int_stack+278736,int_stack+263076,36);
 /*--- compute (k0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+297744,int_stack+285864,int_stack+269016,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+258216,int_stack+8784,int_stack+5976,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+313944,int_stack+258216,int_stack+278736,36);
 /*--- compute (k0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+328200,int_stack+313944,int_stack+285864,36);
 /*--- compute (k0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+266640,int_stack+328200,int_stack+297744,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+290940,int_stack+12060,int_stack+8784,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+348000,int_stack+290940,int_stack+258216,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+364848,int_stack+348000,int_stack+313944,36);
 /*--- compute (k0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+388608,int_stack+364848,int_stack+328200,36);
 /*--- compute (k0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+300768,int_stack+388608,int_stack+266640,36);
 /*--- compute (k0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+258216,int_stack+15840,int_stack+12060,36);
 /*--- compute (k0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+269556,int_stack+258216,int_stack+290940,36);
 /*--- compute (k0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+418308,int_stack+269556,int_stack+348000,36);
 /*--- compute (k0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+446388,int_stack+418308,int_stack+364848,36);
 /*--- compute (k0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+334788,int_stack+446388,int_stack+388608,36);
 /*--- compute (k0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+482028,int_stack+334788,int_stack+300768,36);
 /*--- compute (k0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+289212,int_stack+20160,int_stack+15840,36);
 /*--- compute (k0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+302172,int_stack+289212,int_stack+258216,36);
 /*--- compute (k0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+376368,int_stack+302172,int_stack+269556,36);
 /*--- compute (k0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+258216,int_stack+376368,int_stack+418308,36);
 /*--- compute (k0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+376368,int_stack+258216,int_stack+446388,36);
 /*--- compute (k0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+258216,int_stack+376368,int_stack+334788,36);
 /*--- compute (k0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+313656,int_stack+258216,int_stack+482028,36);
 /*--- compute (l0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+258216,int_stack+27081,int_stack+25056,45);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+264291,int_stack+29556,int_stack+27081,45);
 /*--- compute (l0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+271716,int_stack+264291,int_stack+258216,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+283866,int_stack+32526,int_stack+29556,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+292776,int_stack+283866,int_stack+264291,45);
 /*--- compute (l0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+371976,int_stack+292776,int_stack+271716,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+258216,int_stack+36036,int_stack+32526,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+392226,int_stack+258216,int_stack+283866,45);
 /*--- compute (l0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+410046,int_stack+392226,int_stack+292776,45);
 /*--- compute (l0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+268746,int_stack+410046,int_stack+371976,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+371976,int_stack+40131,int_stack+36036,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+434796,int_stack+371976,int_stack+258216,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+455856,int_stack+434796,int_stack+392226,45);
 /*--- compute (l0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+485556,int_stack+455856,int_stack+410046,45);
 /*--- compute (l0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+384261,int_stack+485556,int_stack+268746,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+258216,int_stack+44856,int_stack+40131,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+272391,int_stack+258216,int_stack+371976,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+0,int_stack+272391,int_stack+434796,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+522681,int_stack+0,int_stack+455856,45);
 /*--- compute (l0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+426786,int_stack+522681,int_stack+485556,45);
 /*--- compute (l0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+567231,int_stack+426786,int_stack+384261,45);
 /*--- compute (l0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+371976,int_stack+50256,int_stack+44856,45);
 /*--- compute (l0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+388176,int_stack+371976,int_stack+258216,45);
 /*--- compute (l0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+478761,int_stack+388176,int_stack+272391,45);
 /*--- compute (l0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+258216,int_stack+478761,int_stack+0,45);
 /*--- compute (l0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+623931,int_stack+258216,int_stack+522681,45);
 /*--- compute (l0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+478761,int_stack+623931,int_stack+426786,45);
 /*--- compute (l0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+371976,int_stack+478761,int_stack+567231,45);
 /*--- compute (kp|lk) ---*/
 hrr1_build_kp(Libint->AB,int_stack+444876,int_stack+371976,int_stack+313656,1620);
 /*--- compute (m0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+258216,int_stack+58851,int_stack+56376,55);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+265641,int_stack+61876,int_stack+58851,55);
 /*--- compute (m0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+274716,int_stack+265641,int_stack+258216,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+289566,int_stack+65506,int_stack+61876,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+300456,int_stack+289566,int_stack+265641,55);
 /*--- compute (m0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+318606,int_stack+300456,int_stack+274716,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+258216,int_stack+69796,int_stack+65506,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+343356,int_stack+258216,int_stack+289566,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+0,int_stack+343356,int_stack+300456,55);
 /*--- compute (m0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+271086,int_stack+0,int_stack+318606,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+308211,int_stack+74801,int_stack+69796,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+30250,int_stack+308211,int_stack+258216,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+619836,int_stack+30250,int_stack+343356,55);
 /*--- compute (m0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+323226,int_stack+619836,int_stack+0,55);
 /*--- compute (m0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+656136,int_stack+323226,int_stack+271086,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+80576,int_stack+74801,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+258216,int_stack+0,int_stack+308211,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+708111,int_stack+258216,int_stack+30250,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+17325,int_stack+708111,int_stack+619836,55);
 /*--- compute (m0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+751011,int_stack+17325,int_stack+323226,55);
 /*--- compute (m0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+288246,int_stack+751011,int_stack+656136,55);
 /*--- compute (m0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+619836,int_stack+87176,int_stack+80576,55);
 /*--- compute (m0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+639636,int_stack+619836,int_stack+0,55);
 /*--- compute (m0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+814536,int_stack+639636,int_stack+258216,55);
 /*--- compute (m0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+619836,int_stack+814536,int_stack+708111,55);
 /*--- compute (m0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+814536,int_stack+619836,int_stack+17325,55);
 /*--- compute (m0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+619836,int_stack+814536,int_stack+751011,55);
 /*--- compute (m0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+704536,int_stack+619836,int_stack+288246,55);
 /*--- compute (lp|lk) ---*/
 hrr1_build_lp(Libint->AB,int_stack+793636,int_stack+704536,int_stack+371976,1620);
 /*--- compute (kd|lk) ---*/
 hrr1_build_kd(Libint->AB,int_stack+1012336,int_stack+793636,int_stack+444876,1620);
 /*--- compute (n0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+258216,int_stack+97626,int_stack+94656,66);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+267126,int_stack+101256,int_stack+97626,66);
 /*--- compute (n0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+278016,int_stack+267126,int_stack+258216,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+295836,int_stack+105612,int_stack+101256,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+308904,int_stack+295836,int_stack+267126,66);
 /*--- compute (n0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+330684,int_stack+308904,int_stack+278016,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+258216,int_stack+110760,int_stack+105612,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+360384,int_stack+258216,int_stack+295836,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+386520,int_stack+360384,int_stack+308904,66);
 /*--- compute (n0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+273660,int_stack+386520,int_stack+330684,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+318210,int_stack+116766,int_stack+110760,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+422820,int_stack+318210,int_stack+258216,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+453708,int_stack+422820,int_stack+360384,66);
 /*--- compute (n0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+497268,int_stack+453708,int_stack+386520,66);
 /*--- compute (n0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+336228,int_stack+497268,int_stack+273660,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+258216,int_stack+123696,int_stack+116766,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+279006,int_stack+258216,int_stack+318210,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+551718,int_stack+279006,int_stack+422820,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+603198,int_stack+551718,int_stack+453708,66);
 /*--- compute (n0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+398598,int_stack+603198,int_stack+497268,66);
 /*--- compute (n0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+0,int_stack+398598,int_stack+336228,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+315042,int_stack+131616,int_stack+123696,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+338802,int_stack+315042,int_stack+258216,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+474828,int_stack+338802,int_stack+279006,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+258216,int_stack+474828,int_stack+551718,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+474828,int_stack+258216,int_stack+603198,66);
 /*--- compute (n0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+258216,int_stack+474828,int_stack+398598,66);
 /*--- compute (n0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+359856,int_stack+258216,int_stack+0,66);
 /*--- compute (mp|lk) ---*/
 hrr1_build_mp(Libint->AB,int_stack+1362256,int_stack+359856,int_stack+704536,1620);
 /*--- compute (ld|lk) ---*/
 hrr1_build_ld(Libint->AB,int_stack+1629556,int_stack+1362256,int_stack+793636,1620);
 /*--- compute (kf|lk) ---*/
 hrr1_build_kf(Libint->AB,int_stack+2066956,int_stack+1629556,int_stack+1012336,1620);
 /*--- compute (o0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+0,int_stack+144102,int_stack+140592,78);
 /*--- compute (o0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+10530,int_stack+148392,int_stack+144102,78);
 /*--- compute (o0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+23400,int_stack+10530,int_stack+0,78);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+44460,int_stack+153540,int_stack+148392,78);
 /*--- compute (o0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+59904,int_stack+44460,int_stack+10530,78);
 /*--- compute (o0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+85644,int_stack+59904,int_stack+23400,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+0,int_stack+159624,int_stack+153540,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+120744,int_stack+0,int_stack+44460,78);
 /*--- compute (o0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+258216,int_stack+120744,int_stack+59904,78);
 /*--- compute (o0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+18252,int_stack+258216,int_stack+85644,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+70902,int_stack+166722,int_stack+159624,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+301116,int_stack+70902,int_stack+0,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+466776,int_stack+301116,int_stack+120744,78);
 /*--- compute (o0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+92196,int_stack+466776,int_stack+258216,78);
 /*--- compute (o0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+518256,int_stack+92196,int_stack+18252,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+258216,int_stack+174912,int_stack+166722,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+0,int_stack+258216,int_stack+70902,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+591966,int_stack+0,int_stack+301116,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+652806,int_stack+591966,int_stack+466776,78);
 /*--- compute (o0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+730026,int_stack+652806,int_stack+92196,78);
 /*--- compute (o0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+42588,int_stack+730026,int_stack+518256,78);
 /*--- compute (o0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+466776,int_stack+184272,int_stack+174912,78);
 /*--- compute (o0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+494856,int_stack+466776,int_stack+258216,78);
 /*--- compute (o0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+258216,int_stack+494856,int_stack+0,78);
 /*--- compute (o0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+466776,int_stack+258216,int_stack+591966,78);
 /*--- compute (o0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+820116,int_stack+466776,int_stack+652806,78);
 /*--- compute (o0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+466776,int_stack+820116,int_stack+730026,78);
 /*--- compute (o0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+586896,int_stack+466776,int_stack+42588,78);
 /*--- compute (np|lk) ---*/
 hrr1_build_np(Libint->AB,int_stack+713256,int_stack+586896,int_stack+359856,1620);
 /*--- compute (md|lk) ---*/
 hrr1_build_md(Libint->AB,int_stack+2650156,int_stack+713256,int_stack+1362256,1620);
 /*--- compute (lf|lk) ---*/
 hrr1_build_lf(Libint->AB,int_stack+3184756,int_stack+2650156,int_stack+1629556,1620);
 /*--- compute (kg|lk) ---*/
 hrr1_build_kg(Libint->AB,int_stack+1034016,int_stack+3184756,int_stack+2066956,1620);
 /*--- compute (q0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+1908816,int_stack+198975,int_stack+194880,91);
 /*--- compute (q0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+1921101,int_stack+203980,int_stack+198975,91);
 /*--- compute (q0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+1936116,int_stack+1921101,int_stack+1908816,91);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+1960686,int_stack+209986,int_stack+203980,91);
 /*--- compute (q0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+1978704,int_stack+1960686,int_stack+1921101,91);
 /*--- compute (q0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+2008734,int_stack+1978704,int_stack+1936116,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+1908816,int_stack+217084,int_stack+209986,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+2049684,int_stack+1908816,int_stack+1960686,91);
 /*--- compute (q0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+2085720,int_stack+2049684,int_stack+1978704,91);
 /*--- compute (q0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+1930110,int_stack+2085720,int_stack+2008734,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+1991535,int_stack+225365,int_stack+217084,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+2135770,int_stack+1991535,int_stack+1908816,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+2178358,int_stack+2135770,int_stack+2049684,91);
 /*--- compute (q0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+2238418,int_stack+2178358,int_stack+2085720,91);
 /*--- compute (q0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+2016378,int_stack+2238418,int_stack+1930110,91);
 /*--- compute (q0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+1908816,int_stack+234920,int_stack+225365,91);
 /*--- compute (q0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+1937481,int_stack+1908816,int_stack+1991535,91);
 /*--- compute (q0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+2313493,int_stack+1937481,int_stack+2135770,91);
 /*--- compute (q0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+2384473,int_stack+2313493,int_stack+2178358,91);
 /*--- compute (q0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+2102373,int_stack+2384473,int_stack+2238418,91);
 /*--- compute (q0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+2474563,int_stack+2102373,int_stack+2016378,91);
 /*--- compute (q0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+1987167,int_stack+245840,int_stack+234920,91);
 /*--- compute (q0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+2019927,int_stack+1987167,int_stack+1908816,91);
 /*--- compute (q0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+2207478,int_stack+2019927,int_stack+1937481,91);
 /*--- compute (q0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1908816,int_stack+2207478,int_stack+2313493,91);
 /*--- compute (q0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+2207478,int_stack+1908816,int_stack+2384473,91);
 /*--- compute (q0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+1908816,int_stack+2207478,int_stack+2102373,91);
 /*--- compute (q0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+2048956,int_stack+1908816,int_stack+2474563,91);
 /*--- compute (op|lk) ---*/
 hrr1_build_op(Libint->AB,int_stack+2196376,int_stack+2048956,int_stack+586896,1620);
 /*--- compute (nd|lk) ---*/
 hrr1_build_nd(Libint->AB,int_stack+0,int_stack+2196376,int_stack+713256,1620);
 /*--- compute (mf|lk) ---*/
 hrr1_build_mf(Libint->AB,int_stack+3913756,int_stack+0,int_stack+2650156,1620);
 /*--- compute (lg|lk) ---*/
 hrr1_build_lg(Libint->AB,int_stack+1908816,int_stack+3913756,int_stack+3184756,1620);
 /*--- compute (kh|lk) ---*/
 hrr1_build_kh(Libint->AB,int_stack+3002316,int_stack+1908816,int_stack+1034016,1620);
 return int_stack+3002316;}
