/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_kimg(Libint_t*, prim_data*);

  /* Computes quartets of (ki|mg) integrals */

REALTYPE *hrr_order_kimg(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[7][9] = int_stack + 0;
 Libint->vrr_classes[7][10] = int_stack + 1980;
 Libint->vrr_classes[7][11] = int_stack + 4356;
 Libint->vrr_classes[7][12] = int_stack + 7164;
 Libint->vrr_classes[7][13] = int_stack + 10440;
 Libint->vrr_classes[8][9] = int_stack + 14220;
 Libint->vrr_classes[8][10] = int_stack + 16695;
 Libint->vrr_classes[8][11] = int_stack + 19665;
 Libint->vrr_classes[8][12] = int_stack + 23175;
 Libint->vrr_classes[8][13] = int_stack + 27270;
 Libint->vrr_classes[9][9] = int_stack + 31995;
 Libint->vrr_classes[9][10] = int_stack + 35020;
 Libint->vrr_classes[9][11] = int_stack + 38650;
 Libint->vrr_classes[9][12] = int_stack + 42940;
 Libint->vrr_classes[9][13] = int_stack + 47945;
 Libint->vrr_classes[10][9] = int_stack + 53720;
 Libint->vrr_classes[10][10] = int_stack + 57350;
 Libint->vrr_classes[10][11] = int_stack + 61706;
 Libint->vrr_classes[10][12] = int_stack + 66854;
 Libint->vrr_classes[10][13] = int_stack + 72860;
 Libint->vrr_classes[11][9] = int_stack + 79790;
 Libint->vrr_classes[11][10] = int_stack + 84080;
 Libint->vrr_classes[11][11] = int_stack + 89228;
 Libint->vrr_classes[11][12] = int_stack + 95312;
 Libint->vrr_classes[11][13] = int_stack + 102410;
 Libint->vrr_classes[12][9] = int_stack + 110600;
 Libint->vrr_classes[12][10] = int_stack + 115605;
 Libint->vrr_classes[12][11] = int_stack + 121611;
 Libint->vrr_classes[12][12] = int_stack + 128709;
 Libint->vrr_classes[12][13] = int_stack + 136990;
 Libint->vrr_classes[13][9] = int_stack + 146545;
 Libint->vrr_classes[13][10] = int_stack + 152320;
 Libint->vrr_classes[13][11] = int_stack + 159250;
 Libint->vrr_classes[13][12] = int_stack + 167440;
 Libint->vrr_classes[13][13] = int_stack + 176995;
 memset(int_stack,0,188020*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 188020;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_kimg(Libint, Data);
   Data++;
 }
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+188020,int_stack+1980,int_stack+0,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+193960,int_stack+4356,int_stack+1980,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+201088,int_stack+193960,int_stack+188020,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+212968,int_stack+7164,int_stack+4356,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+221392,int_stack+212968,int_stack+193960,36);
 /*--- compute (k0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+235648,int_stack+221392,int_stack+201088,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+188020,int_stack+10440,int_stack+7164,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+255448,int_stack+188020,int_stack+212968,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+188020,int_stack+255448,int_stack+221392,36);
 /*--- compute (k0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+255448,int_stack+188020,int_stack+235648,36);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+188020,int_stack+16695,int_stack+14220,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+195445,int_stack+19665,int_stack+16695,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+204355,int_stack+195445,int_stack+188020,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+219205,int_stack+23175,int_stack+19665,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+229735,int_stack+219205,int_stack+195445,45);
 /*--- compute (l0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+285148,int_stack+229735,int_stack+204355,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+188020,int_stack+27270,int_stack+23175,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+0,int_stack+188020,int_stack+219205,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+188020,int_stack+0,int_stack+229735,45);
 /*--- compute (l0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+217720,int_stack+188020,int_stack+285148,45);
 /*--- compute (kp|mg) ---*/
 hrr1_build_kp(Libint->AB,int_stack+285148,int_stack+217720,int_stack+255448,825);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+188020,int_stack+35020,int_stack+31995,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+197095,int_stack+38650,int_stack+35020,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+0,int_stack+197095,int_stack+188020,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+18150,int_stack+42940,int_stack+38650,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+254845,int_stack+18150,int_stack+197095,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+374248,int_stack+254845,int_stack+0,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+47945,int_stack+42940,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+188020,int_stack+0,int_stack+18150,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+0,int_stack+188020,int_stack+254845,55);
 /*--- compute (m0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+404498,int_stack+0,int_stack+374248,55);
 /*--- compute (lp|mg) ---*/
 hrr1_build_lp(Libint->AB,int_stack+449873,int_stack+404498,int_stack+217720,825);
 /*--- compute (kd|mg) ---*/
 hrr1_build_kd(Libint->AB,int_stack+561248,int_stack+449873,int_stack+285148,825);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+0,int_stack+57350,int_stack+53720,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+10890,int_stack+61706,int_stack+57350,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+23958,int_stack+10890,int_stack+0,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+45738,int_stack+66854,int_stack+61706,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+188020,int_stack+45738,int_stack+10890,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+214156,int_stack+188020,int_stack+23958,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+72860,int_stack+66854,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+250456,int_stack+0,int_stack+45738,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+0,int_stack+250456,int_stack+188020,66);
 /*--- compute (n0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+250456,int_stack+0,int_stack+214156,66);
 /*--- compute (mp|mg) ---*/
 hrr1_build_mp(Libint->AB,int_stack+739448,int_stack+250456,int_stack+404498,825);
 /*--- compute (ld|mg) ---*/
 hrr1_build_ld(Libint->AB,int_stack+875573,int_stack+739448,int_stack+449873,825);
 /*--- compute (kf|mg) ---*/
 hrr1_build_kf(Libint->AB,int_stack+1098323,int_stack+875573,int_stack+561248,825);
 /*--- compute (o0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+0,int_stack+84080,int_stack+79790,78);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+12870,int_stack+89228,int_stack+84080,78);
 /*--- compute (o0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+28314,int_stack+12870,int_stack+0,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+54054,int_stack+95312,int_stack+89228,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+188020,int_stack+54054,int_stack+12870,78);
 /*--- compute (o0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+304906,int_stack+188020,int_stack+28314,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+102410,int_stack+95312,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+72306,int_stack+0,int_stack+54054,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+0,int_stack+72306,int_stack+188020,78);
 /*--- compute (o0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+347806,int_stack+0,int_stack+304906,78);
 /*--- compute (np|mg) ---*/
 hrr1_build_np(Libint->AB,int_stack+412156,int_stack+347806,int_stack+250456,825);
 /*--- compute (md|mg) ---*/
 hrr1_build_md(Libint->AB,int_stack+1395323,int_stack+412156,int_stack+739448,825);
 /*--- compute (lf|mg) ---*/
 hrr1_build_lf(Libint->AB,int_stack+1667573,int_stack+1395323,int_stack+875573,825);
 /*--- compute (kg|mg) ---*/
 hrr1_build_kg(Libint->AB,int_stack+575506,int_stack+1667573,int_stack+1098323,825);
 /*--- compute (q0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+0,int_stack+115605,int_stack+110600,91);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+15015,int_stack+121611,int_stack+115605,91);
 /*--- compute (q0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+33033,int_stack+15015,int_stack+0,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+63063,int_stack+128709,int_stack+121611,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+84357,int_stack+63063,int_stack+15015,91);
 /*--- compute (q0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+188020,int_stack+84357,int_stack+33033,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+136990,int_stack+128709,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+238070,int_stack+0,int_stack+63063,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+0,int_stack+238070,int_stack+84357,91);
 /*--- compute (q0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+238070,int_stack+0,int_stack+188020,91);
 /*--- compute (op|mg) ---*/
 hrr1_build_op(Libint->AB,int_stack+1021006,int_stack+238070,int_stack+347806,825);
 /*--- compute (nd|mg) ---*/
 hrr1_build_nd(Libint->AB,int_stack+2038823,int_stack+1021006,int_stack+412156,825);
 /*--- compute (mf|mg) ---*/
 hrr1_build_mf(Libint->AB,int_stack+2365523,int_stack+2038823,int_stack+1395323,825);
 /*--- compute (lg|mg) ---*/
 hrr1_build_lg(Libint->AB,int_stack+2819273,int_stack+2365523,int_stack+1667573,825);
 /*--- compute (kh|mg) ---*/
 hrr1_build_kh(Libint->AB,int_stack+1214056,int_stack+2819273,int_stack+575506,825);
 /*--- compute (r0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+188020,int_stack+152320,int_stack+146545,105);
 /*--- compute (r0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+205345,int_stack+159250,int_stack+152320,105);
 /*--- compute (r0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+0,int_stack+205345,int_stack+188020,105);
 /*--- compute (r0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+34650,int_stack+167440,int_stack+159250,105);
 /*--- compute (r0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+59220,int_stack+34650,int_stack+205345,105);
 /*--- compute (r0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+100800,int_stack+59220,int_stack+0,105);
 /*--- compute (r0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+176995,int_stack+167440,105);
 /*--- compute (r0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+158550,int_stack+0,int_stack+34650,105);
 /*--- compute (r0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+313145,int_stack+158550,int_stack+59220,105);
 /*--- compute (r0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+0,int_stack+313145,int_stack+100800,105);
 /*--- compute (qp|mg) ---*/
 hrr1_build_qp(Libint->AB,int_stack+313145,int_stack+0,int_stack+238070,825);
 /*--- compute (od|mg) ---*/
 hrr1_build_od(Libint->AB,int_stack+538370,int_stack+313145,int_stack+1021006,825);
 /*--- compute (nf|mg) ---*/
 hrr1_build_nf(Libint->AB,int_stack+3376148,int_stack+538370,int_stack+2038823,825);
 /*--- compute (mg|mg) ---*/
 hrr1_build_mg(Libint->AB,int_stack+0,int_stack+3376148,int_stack+2365523,825);
 /*--- compute (lh|mg) ---*/
 hrr1_build_lh(Libint->AB,int_stack+1837756,int_stack+0,int_stack+2819273,825);
 /*--- compute (ki|mg) ---*/
 hrr1_build_ki(Libint->AB,int_stack+0,int_stack+1837756,int_stack+1214056,825);
 return int_stack+0;}
