/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_kphh(Libint_t*, prim_data*);

  /* Computes quartets of (kp|hh) integrals */

REALTYPE *hrr_order_kphh(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[7][5] = int_stack + 0;
 Libint->vrr_classes[7][6] = int_stack + 756;
 Libint->vrr_classes[7][7] = int_stack + 1764;
 Libint->vrr_classes[7][8] = int_stack + 3060;
 Libint->vrr_classes[7][9] = int_stack + 4680;
 Libint->vrr_classes[7][10] = int_stack + 6660;
 Libint->vrr_classes[8][5] = int_stack + 9036;
 Libint->vrr_classes[8][6] = int_stack + 9981;
 Libint->vrr_classes[8][7] = int_stack + 11241;
 Libint->vrr_classes[8][8] = int_stack + 12861;
 Libint->vrr_classes[8][9] = int_stack + 14886;
 Libint->vrr_classes[8][10] = int_stack + 17361;
 memset(int_stack,0,20331*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 20331;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_kphh(Libint, Data);
   Data++;
 }
 /*--- compute (k0|hp) ---*/
 hrr3_build_hp(Libint->CD,int_stack+20331,int_stack+756,int_stack+0,36);
 /*--- compute (k0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+22599,int_stack+1764,int_stack+756,36);
 /*--- compute (k0|hd) ---*/
 hrr3_build_hd(Libint->CD,int_stack+25623,int_stack+22599,int_stack+20331,36);
 /*--- compute (k0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+30159,int_stack+3060,int_stack+1764,36);
 /*--- compute (k0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+34047,int_stack+30159,int_stack+22599,36);
 /*--- compute (k0|hf) ---*/
 hrr3_build_hf(Libint->CD,int_stack+40095,int_stack+34047,int_stack+25623,36);
 /*--- compute (k0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+20331,int_stack+4680,int_stack+3060,36);
 /*--- compute (k0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+47655,int_stack+20331,int_stack+30159,36);
 /*--- compute (k0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+55431,int_stack+47655,int_stack+34047,36);
 /*--- compute (k0|hg) ---*/
 hrr3_build_hg(Libint->CD,int_stack+25191,int_stack+55431,int_stack+40095,36);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+36531,int_stack+6660,int_stack+4680,36);
 /*--- compute (k0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+65511,int_stack+36531,int_stack+20331,36);
 /*--- compute (k0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+75231,int_stack+65511,int_stack+47655,36);
 /*--- compute (k0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+36531,int_stack+75231,int_stack+55431,36);
 /*--- compute (k0|hh) ---*/
 hrr3_build_hh(Libint->CD,int_stack+51651,int_stack+36531,int_stack+25191,36);
 /*--- compute (l0|hp) ---*/
 hrr3_build_hp(Libint->CD,int_stack+20331,int_stack+9981,int_stack+9036,45);
 /*--- compute (l0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+23166,int_stack+11241,int_stack+9981,45);
 /*--- compute (l0|hd) ---*/
 hrr3_build_hd(Libint->CD,int_stack+26946,int_stack+23166,int_stack+20331,45);
 /*--- compute (l0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+32616,int_stack+12861,int_stack+11241,45);
 /*--- compute (l0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+37476,int_stack+32616,int_stack+23166,45);
 /*--- compute (l0|hf) ---*/
 hrr3_build_hf(Libint->CD,int_stack+67527,int_stack+37476,int_stack+26946,45);
 /*--- compute (l0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+20331,int_stack+14886,int_stack+12861,45);
 /*--- compute (l0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+76977,int_stack+20331,int_stack+32616,45);
 /*--- compute (l0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+0,int_stack+76977,int_stack+37476,45);
 /*--- compute (l0|hg) ---*/
 hrr3_build_hg(Libint->CD,int_stack+26406,int_stack+0,int_stack+67527,45);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+67527,int_stack+17361,int_stack+14886,45);
 /*--- compute (l0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+86697,int_stack+67527,int_stack+20331,45);
 /*--- compute (l0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+98847,int_stack+86697,int_stack+76977,45);
 /*--- compute (l0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+67527,int_stack+98847,int_stack+0,45);
 /*--- compute (l0|hh) ---*/
 hrr3_build_hh(Libint->CD,int_stack+0,int_stack+67527,int_stack+26406,45);
 /*--- compute (kp|hh) ---*/
 hrr1_build_kp(Libint->AB,int_stack+67527,int_stack+0,int_stack+51651,441);
 return int_stack+67527;}
