/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_kpni(Libint_t*, prim_data*);

  /* Computes quartets of (kp|ni) integrals */

REALTYPE *hrr_order_kpni(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[7][10] = int_stack + 0;
 Libint->vrr_classes[7][11] = int_stack + 2376;
 Libint->vrr_classes[7][12] = int_stack + 5184;
 Libint->vrr_classes[7][13] = int_stack + 8460;
 Libint->vrr_classes[7][14] = int_stack + 12240;
 Libint->vrr_classes[7][15] = int_stack + 16560;
 Libint->vrr_classes[7][16] = int_stack + 21456;
 Libint->vrr_classes[8][10] = int_stack + 26964;
 Libint->vrr_classes[8][11] = int_stack + 29934;
 Libint->vrr_classes[8][12] = int_stack + 33444;
 Libint->vrr_classes[8][13] = int_stack + 37539;
 Libint->vrr_classes[8][14] = int_stack + 42264;
 Libint->vrr_classes[8][15] = int_stack + 47664;
 Libint->vrr_classes[8][16] = int_stack + 53784;
 memset(int_stack,0,60669*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 60669;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_kpni(Libint, Data);
   Data++;
 }
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+60669,int_stack+2376,int_stack+0,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+67797,int_stack+5184,int_stack+2376,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+76221,int_stack+67797,int_stack+60669,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+90477,int_stack+8460,int_stack+5184,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+100305,int_stack+90477,int_stack+67797,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+117153,int_stack+100305,int_stack+76221,36);
 /*--- compute (k0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+60669,int_stack+12240,int_stack+8460,36);
 /*--- compute (k0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+140913,int_stack+60669,int_stack+90477,36);
 /*--- compute (k0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+72009,int_stack+140913,int_stack+100305,36);
 /*--- compute (k0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+160569,int_stack+72009,int_stack+117153,36);
 /*--- compute (k0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+100089,int_stack+16560,int_stack+12240,36);
 /*--- compute (k0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+113049,int_stack+100089,int_stack+60669,36);
 /*--- compute (k0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+196209,int_stack+113049,int_stack+140913,36);
 /*--- compute (k0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+228969,int_stack+196209,int_stack+72009,36);
 /*--- compute (k0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+271089,int_stack+228969,int_stack+160569,36);
 /*--- compute (k0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+60669,int_stack+21456,int_stack+16560,36);
 /*--- compute (k0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+135729,int_stack+60669,int_stack+100089,36);
 /*--- compute (k0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+60669,int_stack+135729,int_stack+113049,36);
 /*--- compute (k0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+98469,int_stack+60669,int_stack+196209,36);
 /*--- compute (k0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+147609,int_stack+98469,int_stack+228969,36);
 /*--- compute (k0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+60669,int_stack+147609,int_stack+271089,36);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+127197,int_stack+29934,int_stack+26964,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+136107,int_stack+33444,int_stack+29934,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+146637,int_stack+136107,int_stack+127197,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+164457,int_stack+37539,int_stack+33444,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+176742,int_stack+164457,int_stack+136107,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+197802,int_stack+176742,int_stack+146637,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+127197,int_stack+42264,int_stack+37539,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+227502,int_stack+127197,int_stack+164457,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+141372,int_stack+227502,int_stack+176742,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+252072,int_stack+141372,int_stack+197802,45);
 /*--- compute (l0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+176472,int_stack+47664,int_stack+42264,45);
 /*--- compute (l0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+192672,int_stack+176472,int_stack+127197,45);
 /*--- compute (l0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+0,int_stack+192672,int_stack+227502,45);
 /*--- compute (l0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+296622,int_stack+0,int_stack+141372,45);
 /*--- compute (l0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+349272,int_stack+296622,int_stack+252072,45);
 /*--- compute (l0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+127197,int_stack+53784,int_stack+47664,45);
 /*--- compute (l0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+221022,int_stack+127197,int_stack+176472,45);
 /*--- compute (l0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+127197,int_stack+221022,int_stack+192672,45);
 /*--- compute (l0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+174447,int_stack+127197,int_stack+0,45);
 /*--- compute (l0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+411642,int_stack+174447,int_stack+296622,45);
 /*--- compute (l0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+127197,int_stack+411642,int_stack+349272,45);
 /*--- compute (kp|ni) ---*/
 hrr1_build_kp(Libint->AB,int_stack+210357,int_stack+127197,int_stack+60669,1848);
 return int_stack+210357;}
