/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_ldll(Libint_t*, prim_data*);

  /* Computes quartets of (ld|ll) integrals */

REALTYPE *hrr_order_ldll(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[8][8] = int_stack + 0;
 Libint->vrr_classes[8][9] = int_stack + 2025;
 Libint->vrr_classes[8][10] = int_stack + 4500;
 Libint->vrr_classes[8][11] = int_stack + 7470;
 Libint->vrr_classes[8][12] = int_stack + 10980;
 Libint->vrr_classes[8][13] = int_stack + 15075;
 Libint->vrr_classes[8][14] = int_stack + 19800;
 Libint->vrr_classes[8][15] = int_stack + 25200;
 Libint->vrr_classes[8][16] = int_stack + 31320;
 Libint->vrr_classes[9][8] = int_stack + 38205;
 Libint->vrr_classes[9][9] = int_stack + 40680;
 Libint->vrr_classes[9][10] = int_stack + 43705;
 Libint->vrr_classes[9][11] = int_stack + 47335;
 Libint->vrr_classes[9][12] = int_stack + 51625;
 Libint->vrr_classes[9][13] = int_stack + 56630;
 Libint->vrr_classes[9][14] = int_stack + 62405;
 Libint->vrr_classes[9][15] = int_stack + 69005;
 Libint->vrr_classes[9][16] = int_stack + 76485;
 Libint->vrr_classes[10][8] = int_stack + 84900;
 Libint->vrr_classes[10][9] = int_stack + 87870;
 Libint->vrr_classes[10][10] = int_stack + 91500;
 Libint->vrr_classes[10][11] = int_stack + 95856;
 Libint->vrr_classes[10][12] = int_stack + 101004;
 Libint->vrr_classes[10][13] = int_stack + 107010;
 Libint->vrr_classes[10][14] = int_stack + 113940;
 Libint->vrr_classes[10][15] = int_stack + 121860;
 Libint->vrr_classes[10][16] = int_stack + 130836;
 memset(int_stack,0,140934*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 140934;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_ldll(Libint, Data);
   Data++;
 }
 /*--- compute (l0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+140934,int_stack+2025,int_stack+0,45);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+147009,int_stack+4500,int_stack+2025,45);
 /*--- compute (l0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+154434,int_stack+147009,int_stack+140934,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+166584,int_stack+7470,int_stack+4500,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+175494,int_stack+166584,int_stack+147009,45);
 /*--- compute (l0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+190344,int_stack+175494,int_stack+154434,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+140934,int_stack+10980,int_stack+7470,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+210594,int_stack+140934,int_stack+166584,45);
 /*--- compute (l0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+228414,int_stack+210594,int_stack+175494,45);
 /*--- compute (l0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+151464,int_stack+228414,int_stack+190344,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+181839,int_stack+15075,int_stack+10980,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+253164,int_stack+181839,int_stack+140934,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+274224,int_stack+253164,int_stack+210594,45);
 /*--- compute (l0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+303924,int_stack+274224,int_stack+228414,45);
 /*--- compute (l0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+194124,int_stack+303924,int_stack+151464,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+140934,int_stack+19800,int_stack+15075,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+155109,int_stack+140934,int_stack+181839,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+341049,int_stack+155109,int_stack+253164,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+376149,int_stack+341049,int_stack+274224,45);
 /*--- compute (l0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+236649,int_stack+376149,int_stack+303924,45);
 /*--- compute (l0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+420699,int_stack+236649,int_stack+194124,45);
 /*--- compute (l0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+179679,int_stack+25200,int_stack+19800,45);
 /*--- compute (l0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+195879,int_stack+179679,int_stack+140934,45);
 /*--- compute (l0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+288624,int_stack+195879,int_stack+155109,45);
 /*--- compute (l0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+477399,int_stack+288624,int_stack+341049,45);
 /*--- compute (l0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+530049,int_stack+477399,int_stack+376149,45);
 /*--- compute (l0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+329574,int_stack+530049,int_stack+236649,45);
 /*--- compute (l0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+592419,int_stack+329574,int_stack+420699,45);
 /*--- compute (l0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+140934,int_stack+31320,int_stack+25200,45);
 /*--- compute (l0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+224229,int_stack+140934,int_stack+179679,45);
 /*--- compute (l0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+140934,int_stack+224229,int_stack+195879,45);
 /*--- compute (l0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+188184,int_stack+140934,int_stack+288624,45);
 /*--- compute (l0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+249609,int_stack+188184,int_stack+477399,45);
 /*--- compute (l0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+140934,int_stack+249609,int_stack+530049,45);
 /*--- compute (l0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+224094,int_stack+140934,int_stack+329574,45);
 /*--- compute (l0|ll) ---*/
 hrr3_build_ll(Libint->CD,int_stack+313194,int_stack+224094,int_stack+592419,45);
 /*--- compute (m0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+140934,int_stack+40680,int_stack+38205,55);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+148359,int_stack+43705,int_stack+40680,55);
 /*--- compute (m0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+157434,int_stack+148359,int_stack+140934,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+172284,int_stack+47335,int_stack+43705,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+183174,int_stack+172284,int_stack+148359,55);
 /*--- compute (m0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+201324,int_stack+183174,int_stack+157434,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+140934,int_stack+51625,int_stack+47335,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+226074,int_stack+140934,int_stack+172284,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+247854,int_stack+226074,int_stack+183174,55);
 /*--- compute (m0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+153804,int_stack+247854,int_stack+201324,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+190929,int_stack+56630,int_stack+51625,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+278104,int_stack+190929,int_stack+140934,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+404319,int_stack+278104,int_stack+226074,55);
 /*--- compute (m0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+440619,int_stack+404319,int_stack+247854,55);
 /*--- compute (m0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+205944,int_stack+440619,int_stack+153804,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+140934,int_stack+62405,int_stack+56630,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+158259,int_stack+140934,int_stack+190929,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+485994,int_stack+158259,int_stack+278104,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+257919,int_stack+485994,int_stack+404319,55);
 /*--- compute (m0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+528894,int_stack+257919,int_stack+440619,55);
 /*--- compute (m0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+404319,int_stack+528894,int_stack+205944,55);
 /*--- compute (m0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+188289,int_stack+69005,int_stack+62405,55);
 /*--- compute (m0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+208089,int_stack+188289,int_stack+140934,55);
 /*--- compute (m0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+592419,int_stack+208089,int_stack+158259,55);
 /*--- compute (m0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+0,int_stack+592419,int_stack+485994,55);
 /*--- compute (m0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+642469,int_stack+0,int_stack+257919,55);
 /*--- compute (m0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+718699,int_stack+642469,int_stack+528894,55);
 /*--- compute (m0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+473619,int_stack+718699,int_stack+404319,55);
 /*--- compute (m0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+404319,int_stack+76485,int_stack+69005,55);
 /*--- compute (m0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+426759,int_stack+404319,int_stack+188289,55);
 /*--- compute (m0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+140934,int_stack+426759,int_stack+208089,55);
 /*--- compute (m0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+198684,int_stack+140934,int_stack+592419,55);
 /*--- compute (m0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+803399,int_stack+198684,int_stack+0,55);
 /*--- compute (m0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+140934,int_stack+803399,int_stack+642469,55);
 /*--- compute (m0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+562719,int_stack+140934,int_stack+718699,55);
 /*--- compute (m0|ll) ---*/
 hrr3_build_ll(Libint->CD,int_stack+140934,int_stack+562719,int_stack+473619,55);
 /*--- compute (lp|ll) ---*/
 hrr1_build_lp(Libint->AB,int_stack+404319,int_stack+140934,int_stack+313194,2025);
 /*--- compute (n0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+252309,int_stack+87870,int_stack+84900,66);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+261219,int_stack+91500,int_stack+87870,66);
 /*--- compute (n0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+272109,int_stack+261219,int_stack+252309,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+289929,int_stack+95856,int_stack+91500,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+302997,int_stack+289929,int_stack+261219,66);
 /*--- compute (n0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+324777,int_stack+302997,int_stack+272109,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+252309,int_stack+101004,int_stack+95856,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+354477,int_stack+252309,int_stack+289929,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+0,int_stack+354477,int_stack+302997,66);
 /*--- compute (n0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+267753,int_stack+0,int_stack+324777,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+312303,int_stack+107010,int_stack+101004,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+36300,int_stack+312303,int_stack+252309,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+677694,int_stack+36300,int_stack+354477,66);
 /*--- compute (n0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+330321,int_stack+677694,int_stack+0,66);
 /*--- compute (n0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+721254,int_stack+330321,int_stack+267753,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+113940,int_stack+107010,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+252309,int_stack+0,int_stack+312303,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+783624,int_stack+252309,int_stack+36300,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+20790,int_stack+783624,int_stack+677694,66);
 /*--- compute (n0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+835104,int_stack+20790,int_stack+330321,66);
 /*--- compute (n0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+288345,int_stack+835104,int_stack+721254,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+677694,int_stack+121860,int_stack+113940,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+701454,int_stack+677694,int_stack+0,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+911334,int_stack+701454,int_stack+252309,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+971394,int_stack+911334,int_stack+783624,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+743034,int_stack+971394,int_stack+20790,66);
 /*--- compute (n0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+0,int_stack+743034,int_stack+835104,66);
 /*--- compute (n0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+1048614,int_stack+0,int_stack+288345,66);
 /*--- compute (n0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+252309,int_stack+130836,int_stack+121860,66);
 /*--- compute (n0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+279237,int_stack+252309,int_stack+677694,66);
 /*--- compute (n0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+326757,int_stack+279237,int_stack+701454,66);
 /*--- compute (n0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1155534,int_stack+326757,int_stack+911334,66);
 /*--- compute (n0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+252309,int_stack+1155534,int_stack+971394,66);
 /*--- compute (n0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+834510,int_stack+252309,int_stack+743034,66);
 /*--- compute (n0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+252309,int_stack+834510,int_stack+0,66);
 /*--- compute (n0|ll) ---*/
 hrr3_build_ll(Libint->CD,int_stack+0,int_stack+252309,int_stack+1048614,66);
 /*--- compute (mp|ll) ---*/
 hrr1_build_mp(Libint->AB,int_stack+677694,int_stack+0,int_stack+140934,2025);
 /*--- compute (ld|ll) ---*/
 hrr1_build_ld(Libint->AB,int_stack+1011819,int_stack+677694,int_stack+404319,2025);
 return int_stack+1011819;}
