/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_ldmm(Libint_t*, prim_data*);

  /* Computes quartets of (ld|mm) integrals */

REALTYPE *hrr_order_ldmm(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[8][9] = int_stack + 0;
 Libint->vrr_classes[8][10] = int_stack + 2475;
 Libint->vrr_classes[8][11] = int_stack + 5445;
 Libint->vrr_classes[8][12] = int_stack + 8955;
 Libint->vrr_classes[8][13] = int_stack + 13050;
 Libint->vrr_classes[8][14] = int_stack + 17775;
 Libint->vrr_classes[8][15] = int_stack + 23175;
 Libint->vrr_classes[8][16] = int_stack + 29295;
 Libint->vrr_classes[8][17] = int_stack + 36180;
 Libint->vrr_classes[8][18] = int_stack + 43875;
 Libint->vrr_classes[9][9] = int_stack + 52425;
 Libint->vrr_classes[9][10] = int_stack + 55450;
 Libint->vrr_classes[9][11] = int_stack + 59080;
 Libint->vrr_classes[9][12] = int_stack + 63370;
 Libint->vrr_classes[9][13] = int_stack + 68375;
 Libint->vrr_classes[9][14] = int_stack + 74150;
 Libint->vrr_classes[9][15] = int_stack + 80750;
 Libint->vrr_classes[9][16] = int_stack + 88230;
 Libint->vrr_classes[9][17] = int_stack + 96645;
 Libint->vrr_classes[9][18] = int_stack + 106050;
 Libint->vrr_classes[10][9] = int_stack + 116500;
 Libint->vrr_classes[10][10] = int_stack + 120130;
 Libint->vrr_classes[10][11] = int_stack + 124486;
 Libint->vrr_classes[10][12] = int_stack + 129634;
 Libint->vrr_classes[10][13] = int_stack + 135640;
 Libint->vrr_classes[10][14] = int_stack + 142570;
 Libint->vrr_classes[10][15] = int_stack + 150490;
 Libint->vrr_classes[10][16] = int_stack + 159466;
 Libint->vrr_classes[10][17] = int_stack + 169564;
 Libint->vrr_classes[10][18] = int_stack + 180850;
 memset(int_stack,0,193390*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 193390;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_ldmm(Libint, Data);
   Data++;
 }
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+193390,int_stack+2475,int_stack+0,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+200815,int_stack+5445,int_stack+2475,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+209725,int_stack+200815,int_stack+193390,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+224575,int_stack+8955,int_stack+5445,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+235105,int_stack+224575,int_stack+200815,45);
 /*--- compute (l0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+252925,int_stack+235105,int_stack+209725,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+193390,int_stack+13050,int_stack+8955,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+277675,int_stack+193390,int_stack+224575,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+298735,int_stack+277675,int_stack+235105,45);
 /*--- compute (l0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+205675,int_stack+298735,int_stack+252925,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+242800,int_stack+17775,int_stack+13050,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+328435,int_stack+242800,int_stack+193390,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+353005,int_stack+328435,int_stack+277675,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+388105,int_stack+353005,int_stack+298735,45);
 /*--- compute (l0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+256975,int_stack+388105,int_stack+205675,45);
 /*--- compute (l0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+193390,int_stack+23175,int_stack+17775,45);
 /*--- compute (l0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+209590,int_stack+193390,int_stack+242800,45);
 /*--- compute (l0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+432655,int_stack+209590,int_stack+328435,45);
 /*--- compute (l0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+473605,int_stack+432655,int_stack+353005,45);
 /*--- compute (l0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+308950,int_stack+473605,int_stack+388105,45);
 /*--- compute (l0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+526255,int_stack+308950,int_stack+256975,45);
 /*--- compute (l0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+237940,int_stack+29295,int_stack+23175,45);
 /*--- compute (l0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+256300,int_stack+237940,int_stack+193390,45);
 /*--- compute (l0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+371320,int_stack+256300,int_stack+209590,45);
 /*--- compute (l0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+595555,int_stack+371320,int_stack+432655,45);
 /*--- compute (l0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+656980,int_stack+595555,int_stack+473605,45);
 /*--- compute (l0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+418570,int_stack+656980,int_stack+308950,45);
 /*--- compute (l0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+730690,int_stack+418570,int_stack+526255,45);
 /*--- compute (l0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+193390,int_stack+36180,int_stack+29295,45);
 /*--- compute (l0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+288700,int_stack+193390,int_stack+237940,45);
 /*--- compute (l0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+501730,int_stack+288700,int_stack+256300,45);
 /*--- compute (l0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+214045,int_stack+501730,int_stack+371320,45);
 /*--- compute (l0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+325420,int_stack+214045,int_stack+595555,45);
 /*--- compute (l0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+555730,int_stack+325420,int_stack+656980,45);
 /*--- compute (l0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+819790,int_stack+555730,int_stack+418570,45);
 /*--- compute (l0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+926710,int_stack+819790,int_stack+730690,45);
 /*--- compute (l0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+411415,int_stack+43875,int_stack+36180,45);
 /*--- compute (l0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+434500,int_stack+411415,int_stack+193390,45);
 /*--- compute (l0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+654010,int_stack+434500,int_stack+288700,45);
 /*--- compute (l0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+411415,int_stack+654010,int_stack+501730,45);
 /*--- compute (l0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+654010,int_stack+411415,int_stack+214045,45);
 /*--- compute (l0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+411415,int_stack+654010,int_stack+325420,45);
 /*--- compute (l0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+654010,int_stack+411415,int_stack+555730,45);
 /*--- compute (l0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+193390,int_stack+654010,int_stack+819790,45);
 /*--- compute (l0|mm) ---*/
 hrr3_build_mm(Libint->CD,int_stack+327040,int_stack+193390,int_stack+926710,45);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+193390,int_stack+55450,int_stack+52425,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+202465,int_stack+59080,int_stack+55450,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+213355,int_stack+202465,int_stack+193390,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+231505,int_stack+63370,int_stack+59080,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+244375,int_stack+231505,int_stack+202465,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+266155,int_stack+244375,int_stack+213355,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+193390,int_stack+68375,int_stack+63370,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+296405,int_stack+193390,int_stack+231505,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+463165,int_stack+296405,int_stack+244375,55);
 /*--- compute (m0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+208405,int_stack+463165,int_stack+266155,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+253780,int_stack+74150,int_stack+68375,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+499465,int_stack+253780,int_stack+193390,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+529495,int_stack+499465,int_stack+296405,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+271105,int_stack+529495,int_stack+463165,55);
 /*--- compute (m0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+572395,int_stack+271105,int_stack+208405,55);
 /*--- compute (m0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+463165,int_stack+80750,int_stack+74150,55);
 /*--- compute (m0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+193390,int_stack+463165,int_stack+253780,55);
 /*--- compute (m0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+635920,int_stack+193390,int_stack+499465,55);
 /*--- compute (m0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+685970,int_stack+635920,int_stack+529495,55);
 /*--- compute (m0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+482965,int_stack+685970,int_stack+271105,55);
 /*--- compute (m0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+228040,int_stack+482965,int_stack+572395,55);
 /*--- compute (m0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+559195,int_stack+88230,int_stack+80750,55);
 /*--- compute (m0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+581635,int_stack+559195,int_stack+463165,55);
 /*--- compute (m0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+750320,int_stack+581635,int_stack+193390,55);
 /*--- compute (m0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+808070,int_stack+750320,int_stack+635920,55);
 /*--- compute (m0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+883145,int_stack+808070,int_stack+685970,55);
 /*--- compute (m0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+621235,int_stack+883145,int_stack+482965,55);
 /*--- compute (m0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+973235,int_stack+621235,int_stack+228040,55);
 /*--- compute (m0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+193390,int_stack+96645,int_stack+88230,55);
 /*--- compute (m0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+218635,int_stack+193390,int_stack+559195,55);
 /*--- compute (m0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+463165,int_stack+218635,int_stack+581635,55);
 /*--- compute (m0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+529165,int_stack+463165,int_stack+750320,55);
 /*--- compute (m0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1082135,int_stack+529165,int_stack+808070,55);
 /*--- compute (m0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+722875,int_stack+1082135,int_stack+883145,55);
 /*--- compute (m0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1187240,int_stack+722875,int_stack+621235,55);
 /*--- compute (m0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+1317920,int_stack+1187240,int_stack+973235,55);
 /*--- compute (m0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+263515,int_stack+106050,int_stack+96645,55);
 /*--- compute (m0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+615790,int_stack+263515,int_stack+193390,55);
 /*--- compute (m0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+842995,int_stack+615790,int_stack+218635,55);
 /*--- compute (m0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+615790,int_stack+842995,int_stack+463165,55);
 /*--- compute (m0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+842995,int_stack+615790,int_stack+529165,55);
 /*--- compute (m0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+463165,int_stack+842995,int_stack+1082135,55);
 /*--- compute (m0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+842995,int_stack+463165,int_stack+722875,55);
 /*--- compute (m0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+463165,int_stack+842995,int_stack+1187240,55);
 /*--- compute (m0|mm) ---*/
 hrr3_build_mm(Libint->CD,int_stack+626515,int_stack+463165,int_stack+1317920,55);
 /*--- compute (lp|mm) ---*/
 hrr1_build_lp(Libint->AB,int_stack+792890,int_stack+626515,int_stack+327040,3025);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+1201265,int_stack+120130,int_stack+116500,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+1212155,int_stack+124486,int_stack+120130,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+1225223,int_stack+1212155,int_stack+1201265,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+1247003,int_stack+129634,int_stack+124486,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+1262447,int_stack+1247003,int_stack+1212155,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+1288583,int_stack+1262447,int_stack+1225223,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+1201265,int_stack+135640,int_stack+129634,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+1324883,int_stack+1201265,int_stack+1247003,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+1355771,int_stack+1324883,int_stack+1262447,66);
 /*--- compute (n0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+1219283,int_stack+1355771,int_stack+1288583,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+1273733,int_stack+142570,int_stack+135640,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+1399331,int_stack+1273733,int_stack+1201265,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+193390,int_stack+1399331,int_stack+1324883,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+244870,int_stack+193390,int_stack+1355771,66);
 /*--- compute (n0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+1294523,int_stack+244870,int_stack+1219283,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+1201265,int_stack+150490,int_stack+142570,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+1225025,int_stack+1201265,int_stack+1273733,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+310210,int_stack+1225025,int_stack+1399331,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1370753,int_stack+310210,int_stack+193390,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+370270,int_stack+1370753,int_stack+244870,66);
 /*--- compute (n0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+193390,int_stack+370270,int_stack+1294523,66);
 /*--- compute (n0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+1266605,int_stack+159466,int_stack+150490,66);
 /*--- compute (n0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1293533,int_stack+1266605,int_stack+1201265,66);
 /*--- compute (n0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+461746,int_stack+1293533,int_stack+1225025,66);
 /*--- compute (n0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+531046,int_stack+461746,int_stack+310210,66);
 /*--- compute (n0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+0,int_stack+531046,int_stack+1370753,66);
 /*--- compute (n0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1341053,int_stack+0,int_stack+370270,66);
 /*--- compute (n0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+295030,int_stack+1341053,int_stack+193390,66);
 /*--- compute (n0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+193390,int_stack+169564,int_stack+159466,66);
 /*--- compute (n0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+223684,int_stack+193390,int_stack+1266605,66);
 /*--- compute (n0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1201265,int_stack+223684,int_stack+1293533,66);
 /*--- compute (n0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1463021,int_stack+1201265,int_stack+461746,66);
 /*--- compute (n0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1566971,int_stack+1463021,int_stack+531046,66);
 /*--- compute (n0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+425710,int_stack+1566971,int_stack+0,66);
 /*--- compute (n0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+0,int_stack+425710,int_stack+1341053,66);
 /*--- compute (n0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+1280465,int_stack+0,int_stack+295030,66);
 /*--- compute (n0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+277540,int_stack+180850,int_stack+169564,66);
 /*--- compute (n0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+311398,int_stack+277540,int_stack+193390,66);
 /*--- compute (n0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+1693097,int_stack+311398,int_stack+223684,66);
 /*--- compute (n0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+156816,int_stack+1693097,int_stack+1201265,66);
 /*--- compute (n0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+275616,int_stack+156816,int_stack+1463021,66);
 /*--- compute (n0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+1693097,int_stack+275616,int_stack+1566971,66);
 /*--- compute (n0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+156816,int_stack+1693097,int_stack+425710,66);
 /*--- compute (n0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+342144,int_stack+156816,int_stack+0,66);
 /*--- compute (n0|mm) ---*/
 hrr3_build_mm(Libint->CD,int_stack+0,int_stack+342144,int_stack+1280465,66);
 /*--- compute (mp|mm) ---*/
 hrr1_build_mp(Libint->AB,int_stack+1201265,int_stack+0,int_stack+626515,3025);
 /*--- compute (ld|mm) ---*/
 hrr1_build_ld(Libint->AB,int_stack+1700390,int_stack+1201265,int_stack+792890,3025);
 return int_stack+1700390;}
