/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_ldnf(Libint_t*, prim_data*);

  /* Computes quartets of (ld|nf) integrals */

REALTYPE *hrr_order_ldnf(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[8][10] = int_stack + 0;
 Libint->vrr_classes[8][11] = int_stack + 2970;
 Libint->vrr_classes[8][12] = int_stack + 6480;
 Libint->vrr_classes[8][13] = int_stack + 10575;
 Libint->vrr_classes[9][10] = int_stack + 15300;
 Libint->vrr_classes[9][11] = int_stack + 18930;
 Libint->vrr_classes[9][12] = int_stack + 23220;
 Libint->vrr_classes[9][13] = int_stack + 28225;
 Libint->vrr_classes[10][10] = int_stack + 34000;
 Libint->vrr_classes[10][11] = int_stack + 38356;
 Libint->vrr_classes[10][12] = int_stack + 43504;
 Libint->vrr_classes[10][13] = int_stack + 49510;
 memset(int_stack,0,56440*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 56440;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_ldnf(Libint, Data);
   Data++;
 }
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+56440,int_stack+2970,int_stack+0,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+65350,int_stack+6480,int_stack+2970,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+75880,int_stack+65350,int_stack+56440,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+93700,int_stack+10575,int_stack+6480,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+105985,int_stack+93700,int_stack+65350,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+127045,int_stack+105985,int_stack+75880,45);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+56440,int_stack+18930,int_stack+15300,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+67330,int_stack+23220,int_stack+18930,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+80200,int_stack+67330,int_stack+56440,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+101980,int_stack+28225,int_stack+23220,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+0,int_stack+101980,int_stack+67330,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+156745,int_stack+0,int_stack+80200,55);
 /*--- compute (lp|nf) ---*/
 hrr1_build_lp(Libint->AB,int_stack+193045,int_stack+156745,int_stack+127045,660);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+38356,int_stack+34000,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+13068,int_stack+43504,int_stack+38356,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+56440,int_stack+13068,int_stack+0,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+82576,int_stack+49510,int_stack+43504,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+100594,int_stack+82576,int_stack+13068,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+0,int_stack+100594,int_stack+56440,66);
 /*--- compute (mp|nf) ---*/
 hrr1_build_mp(Libint->AB,int_stack+43560,int_stack+0,int_stack+156745,660);
 /*--- compute (ld|nf) ---*/
 hrr1_build_ld(Libint->AB,int_stack+282145,int_stack+43560,int_stack+193045,660);
 return int_stack+282145;}
