/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_lflg(Libint_t*, prim_data*);

  /* Computes quartets of (lf|lg) integrals */

REALTYPE *hrr_order_lflg(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[8][8] = int_stack + 0;
 Libint->vrr_classes[8][9] = int_stack + 2025;
 Libint->vrr_classes[8][10] = int_stack + 4500;
 Libint->vrr_classes[8][11] = int_stack + 7470;
 Libint->vrr_classes[8][12] = int_stack + 10980;
 Libint->vrr_classes[9][8] = int_stack + 15075;
 Libint->vrr_classes[9][9] = int_stack + 17550;
 Libint->vrr_classes[9][10] = int_stack + 20575;
 Libint->vrr_classes[9][11] = int_stack + 24205;
 Libint->vrr_classes[9][12] = int_stack + 28495;
 Libint->vrr_classes[10][8] = int_stack + 33500;
 Libint->vrr_classes[10][9] = int_stack + 36470;
 Libint->vrr_classes[10][10] = int_stack + 40100;
 Libint->vrr_classes[10][11] = int_stack + 44456;
 Libint->vrr_classes[10][12] = int_stack + 49604;
 Libint->vrr_classes[11][8] = int_stack + 55610;
 Libint->vrr_classes[11][9] = int_stack + 59120;
 Libint->vrr_classes[11][10] = int_stack + 63410;
 Libint->vrr_classes[11][11] = int_stack + 68558;
 Libint->vrr_classes[11][12] = int_stack + 74642;
 memset(int_stack,0,81740*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 81740;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_lflg(Libint, Data);
   Data++;
 }
 /*--- compute (l0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+81740,int_stack+2025,int_stack+0,45);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+87815,int_stack+4500,int_stack+2025,45);
 /*--- compute (l0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+95240,int_stack+87815,int_stack+81740,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+107390,int_stack+7470,int_stack+4500,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+116300,int_stack+107390,int_stack+87815,45);
 /*--- compute (l0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+131150,int_stack+116300,int_stack+95240,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+81740,int_stack+10980,int_stack+7470,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+151400,int_stack+81740,int_stack+107390,45);
 /*--- compute (l0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+81740,int_stack+151400,int_stack+116300,45);
 /*--- compute (l0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+151400,int_stack+81740,int_stack+131150,45);
 /*--- compute (m0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+81740,int_stack+17550,int_stack+15075,55);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+89165,int_stack+20575,int_stack+17550,55);
 /*--- compute (m0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+98240,int_stack+89165,int_stack+81740,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+113090,int_stack+24205,int_stack+20575,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+123980,int_stack+113090,int_stack+89165,55);
 /*--- compute (m0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+181775,int_stack+123980,int_stack+98240,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+81740,int_stack+28495,int_stack+24205,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+0,int_stack+81740,int_stack+113090,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+81740,int_stack+0,int_stack+123980,55);
 /*--- compute (m0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+111990,int_stack+81740,int_stack+181775,55);
 /*--- compute (lp|lg) ---*/
 hrr1_build_lp(Libint->AB,int_stack+181775,int_stack+111990,int_stack+151400,675);
 /*--- compute (n0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+81740,int_stack+36470,int_stack+33500,66);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+90650,int_stack+40100,int_stack+36470,66);
 /*--- compute (n0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+0,int_stack+90650,int_stack+81740,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+17820,int_stack+44456,int_stack+40100,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+149115,int_stack+17820,int_stack+90650,66);
 /*--- compute (n0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+81740,int_stack+149115,int_stack+0,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+0,int_stack+49604,int_stack+44456,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+272900,int_stack+0,int_stack+17820,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+0,int_stack+272900,int_stack+149115,66);
 /*--- compute (n0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+272900,int_stack+0,int_stack+81740,66);
 /*--- compute (mp|lg) ---*/
 hrr1_build_mp(Libint->AB,int_stack+317450,int_stack+272900,int_stack+111990,675);
 /*--- compute (ld|lg) ---*/
 hrr1_build_ld(Libint->AB,int_stack+428825,int_stack+317450,int_stack+181775,675);
 /*--- compute (o0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+81740,int_stack+59120,int_stack+55610,78);
 /*--- compute (o0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+92270,int_stack+63410,int_stack+59120,78);
 /*--- compute (o0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+105140,int_stack+92270,int_stack+81740,78);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+126200,int_stack+68558,int_stack+63410,78);
 /*--- compute (o0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+141644,int_stack+126200,int_stack+92270,78);
 /*--- compute (o0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+167384,int_stack+141644,int_stack+105140,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+81740,int_stack+74642,int_stack+68558,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+202484,int_stack+81740,int_stack+126200,78);
 /*--- compute (o0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+0,int_stack+202484,int_stack+141644,78);
 /*--- compute (o0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+202484,int_stack+0,int_stack+167384,78);
 /*--- compute (np|lg) ---*/
 hrr1_build_np(Libint->AB,int_stack+0,int_stack+202484,int_stack+272900,675);
 /*--- compute (md|lg) ---*/
 hrr1_build_md(Libint->AB,int_stack+611075,int_stack+0,int_stack+317450,675);
 /*--- compute (lf|lg) ---*/
 hrr1_build_lf(Libint->AB,int_stack+0,int_stack+611075,int_stack+428825,675);
 return int_stack+0;}
