/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_lgmm(Libint_t*, prim_data*);

  /* Computes quartets of (lg|mm) integrals */

REALTYPE *hrr_order_lgmm(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[8][9] = int_stack + 0;
 Libint->vrr_classes[8][10] = int_stack + 2475;
 Libint->vrr_classes[8][11] = int_stack + 5445;
 Libint->vrr_classes[8][12] = int_stack + 8955;
 Libint->vrr_classes[8][13] = int_stack + 13050;
 Libint->vrr_classes[8][14] = int_stack + 17775;
 Libint->vrr_classes[8][15] = int_stack + 23175;
 Libint->vrr_classes[8][16] = int_stack + 29295;
 Libint->vrr_classes[8][17] = int_stack + 36180;
 Libint->vrr_classes[8][18] = int_stack + 43875;
 Libint->vrr_classes[9][9] = int_stack + 52425;
 Libint->vrr_classes[9][10] = int_stack + 55450;
 Libint->vrr_classes[9][11] = int_stack + 59080;
 Libint->vrr_classes[9][12] = int_stack + 63370;
 Libint->vrr_classes[9][13] = int_stack + 68375;
 Libint->vrr_classes[9][14] = int_stack + 74150;
 Libint->vrr_classes[9][15] = int_stack + 80750;
 Libint->vrr_classes[9][16] = int_stack + 88230;
 Libint->vrr_classes[9][17] = int_stack + 96645;
 Libint->vrr_classes[9][18] = int_stack + 106050;
 Libint->vrr_classes[10][9] = int_stack + 116500;
 Libint->vrr_classes[10][10] = int_stack + 120130;
 Libint->vrr_classes[10][11] = int_stack + 124486;
 Libint->vrr_classes[10][12] = int_stack + 129634;
 Libint->vrr_classes[10][13] = int_stack + 135640;
 Libint->vrr_classes[10][14] = int_stack + 142570;
 Libint->vrr_classes[10][15] = int_stack + 150490;
 Libint->vrr_classes[10][16] = int_stack + 159466;
 Libint->vrr_classes[10][17] = int_stack + 169564;
 Libint->vrr_classes[10][18] = int_stack + 180850;
 Libint->vrr_classes[11][9] = int_stack + 193390;
 Libint->vrr_classes[11][10] = int_stack + 197680;
 Libint->vrr_classes[11][11] = int_stack + 202828;
 Libint->vrr_classes[11][12] = int_stack + 208912;
 Libint->vrr_classes[11][13] = int_stack + 216010;
 Libint->vrr_classes[11][14] = int_stack + 224200;
 Libint->vrr_classes[11][15] = int_stack + 233560;
 Libint->vrr_classes[11][16] = int_stack + 244168;
 Libint->vrr_classes[11][17] = int_stack + 256102;
 Libint->vrr_classes[11][18] = int_stack + 269440;
 Libint->vrr_classes[12][9] = int_stack + 284260;
 Libint->vrr_classes[12][10] = int_stack + 289265;
 Libint->vrr_classes[12][11] = int_stack + 295271;
 Libint->vrr_classes[12][12] = int_stack + 302369;
 Libint->vrr_classes[12][13] = int_stack + 310650;
 Libint->vrr_classes[12][14] = int_stack + 320205;
 Libint->vrr_classes[12][15] = int_stack + 331125;
 Libint->vrr_classes[12][16] = int_stack + 343501;
 Libint->vrr_classes[12][17] = int_stack + 357424;
 Libint->vrr_classes[12][18] = int_stack + 372985;
 memset(int_stack,0,390275*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 390275;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_lgmm(Libint, Data);
   Data++;
 }
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+390275,int_stack+2475,int_stack+0,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+397700,int_stack+5445,int_stack+2475,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+406610,int_stack+397700,int_stack+390275,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+421460,int_stack+8955,int_stack+5445,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+431990,int_stack+421460,int_stack+397700,45);
 /*--- compute (l0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+449810,int_stack+431990,int_stack+406610,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+390275,int_stack+13050,int_stack+8955,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+474560,int_stack+390275,int_stack+421460,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+495620,int_stack+474560,int_stack+431990,45);
 /*--- compute (l0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+402560,int_stack+495620,int_stack+449810,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+439685,int_stack+17775,int_stack+13050,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+525320,int_stack+439685,int_stack+390275,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+549890,int_stack+525320,int_stack+474560,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+584990,int_stack+549890,int_stack+495620,45);
 /*--- compute (l0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+453860,int_stack+584990,int_stack+402560,45);
 /*--- compute (l0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+390275,int_stack+23175,int_stack+17775,45);
 /*--- compute (l0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+406475,int_stack+390275,int_stack+439685,45);
 /*--- compute (l0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+629540,int_stack+406475,int_stack+525320,45);
 /*--- compute (l0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+670490,int_stack+629540,int_stack+549890,45);
 /*--- compute (l0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+505835,int_stack+670490,int_stack+584990,45);
 /*--- compute (l0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+723140,int_stack+505835,int_stack+453860,45);
 /*--- compute (l0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+434825,int_stack+29295,int_stack+23175,45);
 /*--- compute (l0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+453185,int_stack+434825,int_stack+390275,45);
 /*--- compute (l0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+568205,int_stack+453185,int_stack+406475,45);
 /*--- compute (l0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+792440,int_stack+568205,int_stack+629540,45);
 /*--- compute (l0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+853865,int_stack+792440,int_stack+670490,45);
 /*--- compute (l0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+615455,int_stack+853865,int_stack+505835,45);
 /*--- compute (l0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+927575,int_stack+615455,int_stack+723140,45);
 /*--- compute (l0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+390275,int_stack+36180,int_stack+29295,45);
 /*--- compute (l0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+485585,int_stack+390275,int_stack+434825,45);
 /*--- compute (l0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+698615,int_stack+485585,int_stack+453185,45);
 /*--- compute (l0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+410930,int_stack+698615,int_stack+568205,45);
 /*--- compute (l0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+522305,int_stack+410930,int_stack+792440,45);
 /*--- compute (l0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+752615,int_stack+522305,int_stack+853865,45);
 /*--- compute (l0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1016675,int_stack+752615,int_stack+615455,45);
 /*--- compute (l0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+1123595,int_stack+1016675,int_stack+927575,45);
 /*--- compute (l0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+608300,int_stack+43875,int_stack+36180,45);
 /*--- compute (l0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+631385,int_stack+608300,int_stack+390275,45);
 /*--- compute (l0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+850895,int_stack+631385,int_stack+485585,45);
 /*--- compute (l0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+608300,int_stack+850895,int_stack+698615,45);
 /*--- compute (l0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+850895,int_stack+608300,int_stack+410930,45);
 /*--- compute (l0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+608300,int_stack+850895,int_stack+522305,45);
 /*--- compute (l0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+850895,int_stack+608300,int_stack+752615,45);
 /*--- compute (l0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+390275,int_stack+850895,int_stack+1016675,45);
 /*--- compute (l0|mm) ---*/
 hrr3_build_mm(Libint->CD,int_stack+523925,int_stack+390275,int_stack+1123595,45);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+390275,int_stack+55450,int_stack+52425,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+399350,int_stack+59080,int_stack+55450,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+410240,int_stack+399350,int_stack+390275,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+428390,int_stack+63370,int_stack+59080,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+441260,int_stack+428390,int_stack+399350,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+463040,int_stack+441260,int_stack+410240,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+390275,int_stack+68375,int_stack+63370,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+493290,int_stack+390275,int_stack+428390,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+660050,int_stack+493290,int_stack+441260,55);
 /*--- compute (m0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+405290,int_stack+660050,int_stack+463040,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+450665,int_stack+74150,int_stack+68375,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+696350,int_stack+450665,int_stack+390275,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+726380,int_stack+696350,int_stack+493290,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+467990,int_stack+726380,int_stack+660050,55);
 /*--- compute (m0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+769280,int_stack+467990,int_stack+405290,55);
 /*--- compute (m0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+660050,int_stack+80750,int_stack+74150,55);
 /*--- compute (m0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+390275,int_stack+660050,int_stack+450665,55);
 /*--- compute (m0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+832805,int_stack+390275,int_stack+696350,55);
 /*--- compute (m0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+882855,int_stack+832805,int_stack+726380,55);
 /*--- compute (m0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+679850,int_stack+882855,int_stack+467990,55);
 /*--- compute (m0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+424925,int_stack+679850,int_stack+769280,55);
 /*--- compute (m0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+756080,int_stack+88230,int_stack+80750,55);
 /*--- compute (m0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+778520,int_stack+756080,int_stack+660050,55);
 /*--- compute (m0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+947205,int_stack+778520,int_stack+390275,55);
 /*--- compute (m0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1004955,int_stack+947205,int_stack+832805,55);
 /*--- compute (m0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1080030,int_stack+1004955,int_stack+882855,55);
 /*--- compute (m0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+818120,int_stack+1080030,int_stack+679850,55);
 /*--- compute (m0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+1170120,int_stack+818120,int_stack+424925,55);
 /*--- compute (m0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+390275,int_stack+96645,int_stack+88230,55);
 /*--- compute (m0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+415520,int_stack+390275,int_stack+756080,55);
 /*--- compute (m0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+660050,int_stack+415520,int_stack+778520,55);
 /*--- compute (m0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+726050,int_stack+660050,int_stack+947205,55);
 /*--- compute (m0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1279020,int_stack+726050,int_stack+1004955,55);
 /*--- compute (m0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+919760,int_stack+1279020,int_stack+1080030,55);
 /*--- compute (m0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1384125,int_stack+919760,int_stack+818120,55);
 /*--- compute (m0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+1514805,int_stack+1384125,int_stack+1170120,55);
 /*--- compute (m0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+460400,int_stack+106050,int_stack+96645,55);
 /*--- compute (m0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+812675,int_stack+460400,int_stack+390275,55);
 /*--- compute (m0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+1039880,int_stack+812675,int_stack+415520,55);
 /*--- compute (m0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+812675,int_stack+1039880,int_stack+660050,55);
 /*--- compute (m0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+1039880,int_stack+812675,int_stack+726050,55);
 /*--- compute (m0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+660050,int_stack+1039880,int_stack+1279020,55);
 /*--- compute (m0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+1039880,int_stack+660050,int_stack+919760,55);
 /*--- compute (m0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+660050,int_stack+1039880,int_stack+1384125,55);
 /*--- compute (m0|mm) ---*/
 hrr3_build_mm(Libint->CD,int_stack+823400,int_stack+660050,int_stack+1514805,55);
 /*--- compute (lp|mm) ---*/
 hrr1_build_lp(Libint->AB,int_stack+989775,int_stack+823400,int_stack+523925,3025);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+1398150,int_stack+120130,int_stack+116500,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+1409040,int_stack+124486,int_stack+120130,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+1422108,int_stack+1409040,int_stack+1398150,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+1443888,int_stack+129634,int_stack+124486,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+1459332,int_stack+1443888,int_stack+1409040,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+1485468,int_stack+1459332,int_stack+1422108,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+1398150,int_stack+135640,int_stack+129634,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+1521768,int_stack+1398150,int_stack+1443888,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+1552656,int_stack+1521768,int_stack+1459332,66);
 /*--- compute (n0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+1416168,int_stack+1552656,int_stack+1485468,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+1470618,int_stack+142570,int_stack+135640,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+1596216,int_stack+1470618,int_stack+1398150,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+390275,int_stack+1596216,int_stack+1521768,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+441755,int_stack+390275,int_stack+1552656,66);
 /*--- compute (n0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+1491408,int_stack+441755,int_stack+1416168,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+1398150,int_stack+150490,int_stack+142570,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+1421910,int_stack+1398150,int_stack+1470618,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+507095,int_stack+1421910,int_stack+1596216,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1567638,int_stack+507095,int_stack+390275,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+567155,int_stack+1567638,int_stack+441755,66);
 /*--- compute (n0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+390275,int_stack+567155,int_stack+1491408,66);
 /*--- compute (n0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+1463490,int_stack+159466,int_stack+150490,66);
 /*--- compute (n0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1490418,int_stack+1463490,int_stack+1398150,66);
 /*--- compute (n0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+658631,int_stack+1490418,int_stack+1421910,66);
 /*--- compute (n0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+727931,int_stack+658631,int_stack+507095,66);
 /*--- compute (n0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+0,int_stack+727931,int_stack+1567638,66);
 /*--- compute (n0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1537938,int_stack+0,int_stack+567155,66);
 /*--- compute (n0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+491915,int_stack+1537938,int_stack+390275,66);
 /*--- compute (n0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+390275,int_stack+169564,int_stack+159466,66);
 /*--- compute (n0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+420569,int_stack+390275,int_stack+1463490,66);
 /*--- compute (n0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1398150,int_stack+420569,int_stack+1490418,66);
 /*--- compute (n0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1659906,int_stack+1398150,int_stack+658631,66);
 /*--- compute (n0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1763856,int_stack+1659906,int_stack+727931,66);
 /*--- compute (n0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+622595,int_stack+1763856,int_stack+0,66);
 /*--- compute (n0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+0,int_stack+622595,int_stack+1537938,66);
 /*--- compute (n0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+1477350,int_stack+0,int_stack+491915,66);
 /*--- compute (n0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+474425,int_stack+180850,int_stack+169564,66);
 /*--- compute (n0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+508283,int_stack+474425,int_stack+390275,66);
 /*--- compute (n0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+1889982,int_stack+508283,int_stack+420569,66);
 /*--- compute (n0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+390275,int_stack+1889982,int_stack+1398150,66);
 /*--- compute (n0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+1889982,int_stack+390275,int_stack+1659906,66);
 /*--- compute (n0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+390275,int_stack+1889982,int_stack+1763856,66);
 /*--- compute (n0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+1640700,int_stack+390275,int_stack+622595,66);
 /*--- compute (n0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+390275,int_stack+1640700,int_stack+0,66);
 /*--- compute (n0|mm) ---*/
 hrr3_build_mm(Libint->CD,int_stack+1640700,int_stack+390275,int_stack+1477350,66);
 /*--- compute (mp|mm) ---*/
 hrr1_build_mp(Libint->AB,int_stack+1840350,int_stack+1640700,int_stack+823400,3025);
 /*--- compute (ld|mm) ---*/
 hrr1_build_ld(Libint->AB,int_stack+2339475,int_stack+1840350,int_stack+989775,3025);
 /*--- compute (o0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+390275,int_stack+197680,int_stack+193390,78);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+403145,int_stack+202828,int_stack+197680,78);
 /*--- compute (o0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+418589,int_stack+403145,int_stack+390275,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+444329,int_stack+208912,int_stack+202828,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+462581,int_stack+444329,int_stack+403145,78);
 /*--- compute (o0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+493469,int_stack+462581,int_stack+418589,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+390275,int_stack+216010,int_stack+208912,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+536369,int_stack+390275,int_stack+444329,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+572873,int_stack+536369,int_stack+462581,78);
 /*--- compute (o0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+411569,int_stack+572873,int_stack+493469,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+475919,int_stack+224200,int_stack+216010,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+624353,int_stack+475919,int_stack+390275,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+666941,int_stack+624353,int_stack+536369,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+727781,int_stack+666941,int_stack+572873,78);
 /*--- compute (o0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+500489,int_stack+727781,int_stack+411569,78);
 /*--- compute (o0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+390275,int_stack+233560,int_stack+224200,78);
 /*--- compute (o0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+418355,int_stack+390275,int_stack+475919,78);
 /*--- compute (o0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+805001,int_stack+418355,int_stack+624353,78);
 /*--- compute (o0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+875981,int_stack+805001,int_stack+666941,78);
 /*--- compute (o0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+590579,int_stack+875981,int_stack+727781,78);
 /*--- compute (o0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+967241,int_stack+590579,int_stack+500489,78);
 /*--- compute (o0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+467495,int_stack+244168,int_stack+233560,78);
 /*--- compute (o0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+499319,int_stack+467495,int_stack+390275,78);
 /*--- compute (o0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+698687,int_stack+499319,int_stack+418355,78);
 /*--- compute (o0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1087361,int_stack+698687,int_stack+805001,78);
 /*--- compute (o0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1193831,int_stack+1087361,int_stack+875981,78);
 /*--- compute (o0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+780587,int_stack+1193831,int_stack+590579,78);
 /*--- compute (o0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+1321595,int_stack+780587,int_stack+967241,78);
 /*--- compute (o0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+390275,int_stack+256102,int_stack+244168,78);
 /*--- compute (o0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+555479,int_stack+390275,int_stack+467495,78);
 /*--- compute (o0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+924731,int_stack+555479,int_stack+499319,78);
 /*--- compute (o0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+426077,int_stack+924731,int_stack+698687,78);
 /*--- compute (o0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+619127,int_stack+426077,int_stack+1087361,78);
 /*--- compute (o0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1018331,int_stack+619127,int_stack+1193831,78);
 /*--- compute (o0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+0,int_stack+1018331,int_stack+780587,78);
 /*--- compute (o0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+3156225,int_stack+0,int_stack+1321595,78);
 /*--- compute (o0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+768185,int_stack+269440,int_stack+256102,78);
 /*--- compute (o0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+808199,int_stack+768185,int_stack+390275,78);
 /*--- compute (o0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+1188683,int_stack+808199,int_stack+555479,78);
 /*--- compute (o0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+768185,int_stack+1188683,int_stack+924731,78);
 /*--- compute (o0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+1188683,int_stack+768185,int_stack+426077,78);
 /*--- compute (o0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+768185,int_stack+1188683,int_stack+619127,78);
 /*--- compute (o0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+1188683,int_stack+768185,int_stack+1018331,78);
 /*--- compute (o0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+1407707,int_stack+1188683,int_stack+0,78);
 /*--- compute (o0|mm) ---*/
 hrr3_build_mm(Libint->CD,int_stack+0,int_stack+1407707,int_stack+3156225,78);
 /*--- compute (np|mm) ---*/
 hrr1_build_np(Libint->AB,int_stack+390275,int_stack+0,int_stack+1640700,3025);
 /*--- compute (md|mm) ---*/
 hrr1_build_md(Libint->AB,int_stack+3156225,int_stack+390275,int_stack+1840350,3025);
 /*--- compute (lf|mm) ---*/
 hrr1_build_lf(Libint->AB,int_stack+4154475,int_stack+3156225,int_stack+2339475,3025);
 /*--- compute (q0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+235950,int_stack+289265,int_stack+284260,91);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+250965,int_stack+295271,int_stack+289265,91);
 /*--- compute (q0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+989225,int_stack+250965,int_stack+235950,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+268983,int_stack+302369,int_stack+295271,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+1019255,int_stack+268983,int_stack+250965,91);
 /*--- compute (q0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+1055291,int_stack+1019255,int_stack+989225,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+989225,int_stack+310650,int_stack+302369,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+1105341,int_stack+989225,int_stack+268983,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+235950,int_stack+1105341,int_stack+1019255,91);
 /*--- compute (q0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+1147929,int_stack+235950,int_stack+1055291,91);
 /*--- compute (q0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+1014068,int_stack+320205,int_stack+310650,91);
 /*--- compute (q0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+1042733,int_stack+1014068,int_stack+989225,91);
 /*--- compute (q0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1223004,int_stack+1042733,int_stack+1105341,91);
 /*--- compute (q0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1293984,int_stack+1223004,int_stack+235950,91);
 /*--- compute (q0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+1384074,int_stack+1293984,int_stack+1147929,91);
 /*--- compute (q0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+235950,int_stack+331125,int_stack+320205,91);
 /*--- compute (q0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+268710,int_stack+235950,int_stack+1014068,91);
 /*--- compute (q0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1092419,int_stack+268710,int_stack+1042733,91);
 /*--- compute (q0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1489179,int_stack+1092419,int_stack+1223004,91);
 /*--- compute (q0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1595649,int_stack+1489179,int_stack+1293984,91);
 /*--- compute (q0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+1175229,int_stack+1595649,int_stack+1384074,91);
 /*--- compute (q0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+989225,int_stack+343501,int_stack+331125,91);
 /*--- compute (q0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1026353,int_stack+989225,int_stack+235950,91);
 /*--- compute (q0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1315369,int_stack+1026353,int_stack+268710,91);
 /*--- compute (q0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1721775,int_stack+1315369,int_stack+1092419,91);
 /*--- compute (q0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1845990,int_stack+1721775,int_stack+1489179,91);
 /*--- compute (q0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1410919,int_stack+1845990,int_stack+1595649,91);
 /*--- compute (q0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+1995048,int_stack+1410919,int_stack+1175229,91);
 /*--- compute (q0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+235950,int_stack+357424,int_stack+343501,91);
 /*--- compute (q0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+277719,int_stack+235950,int_stack+989225,91);
 /*--- compute (q0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1091873,int_stack+277719,int_stack+1026353,91);
 /*--- compute (q0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+2175228,int_stack+1091873,int_stack+1315369,91);
 /*--- compute (q0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1201073,int_stack+2175228,int_stack+1721775,91);
 /*--- compute (q0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1579087,int_stack+1201073,int_stack+1845990,91);
 /*--- compute (q0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1777831,int_stack+1579087,int_stack+1410919,91);
 /*--- compute (q0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+2318553,int_stack+1777831,int_stack+1995048,91);
 /*--- compute (q0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+989225,int_stack+372985,int_stack+357424,91);
 /*--- compute (q0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+1374974,int_stack+989225,int_stack+235950,91);
 /*--- compute (q0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+1994047,int_stack+1374974,int_stack+277719,91);
 /*--- compute (q0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+1374974,int_stack+1994047,int_stack+1091873,91);
 /*--- compute (q0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+989225,int_stack+1374974,int_stack+2175228,91);
 /*--- compute (q0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+1994047,int_stack+989225,int_stack+1201073,91);
 /*--- compute (q0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+989225,int_stack+1994047,int_stack+1579087,91);
 /*--- compute (q0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+1994047,int_stack+989225,int_stack+1777831,91);
 /*--- compute (q0|mm) ---*/
 hrr3_build_mm(Libint->CD,int_stack+989225,int_stack+1994047,int_stack+2318553,91);
 /*--- compute (op|mm) ---*/
 hrr1_build_op(Libint->AB,int_stack+1264500,int_stack+989225,int_stack+0,3025);
 /*--- compute (nd|mm) ---*/
 hrr1_build_nd(Libint->AB,int_stack+5515725,int_stack+1264500,int_stack+390275,3025);
 /*--- compute (mf|mm) ---*/
 hrr1_build_mf(Libint->AB,int_stack+0,int_stack+5515725,int_stack+3156225,3025);
 /*--- compute (lg|mm) ---*/
 hrr1_build_lg(Libint->AB,int_stack+1663750,int_stack+0,int_stack+4154475,3025);
 return int_stack+1663750;}
