/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_lhng(Libint_t*, prim_data*);

  /* Computes quartets of (lh|ng) integrals */

REALTYPE *hrr_order_lhng(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[8][10] = int_stack + 0;
 Libint->vrr_classes[8][11] = int_stack + 2970;
 Libint->vrr_classes[8][12] = int_stack + 6480;
 Libint->vrr_classes[8][13] = int_stack + 10575;
 Libint->vrr_classes[8][14] = int_stack + 15300;
 Libint->vrr_classes[9][10] = int_stack + 20700;
 Libint->vrr_classes[9][11] = int_stack + 24330;
 Libint->vrr_classes[9][12] = int_stack + 28620;
 Libint->vrr_classes[9][13] = int_stack + 33625;
 Libint->vrr_classes[9][14] = int_stack + 39400;
 Libint->vrr_classes[10][10] = int_stack + 46000;
 Libint->vrr_classes[10][11] = int_stack + 50356;
 Libint->vrr_classes[10][12] = int_stack + 55504;
 Libint->vrr_classes[10][13] = int_stack + 61510;
 Libint->vrr_classes[10][14] = int_stack + 68440;
 Libint->vrr_classes[11][10] = int_stack + 76360;
 Libint->vrr_classes[11][11] = int_stack + 81508;
 Libint->vrr_classes[11][12] = int_stack + 87592;
 Libint->vrr_classes[11][13] = int_stack + 94690;
 Libint->vrr_classes[11][14] = int_stack + 102880;
 Libint->vrr_classes[12][10] = int_stack + 112240;
 Libint->vrr_classes[12][11] = int_stack + 118246;
 Libint->vrr_classes[12][12] = int_stack + 125344;
 Libint->vrr_classes[12][13] = int_stack + 133625;
 Libint->vrr_classes[12][14] = int_stack + 143180;
 Libint->vrr_classes[13][10] = int_stack + 154100;
 Libint->vrr_classes[13][11] = int_stack + 161030;
 Libint->vrr_classes[13][12] = int_stack + 169220;
 Libint->vrr_classes[13][13] = int_stack + 178775;
 Libint->vrr_classes[13][14] = int_stack + 189800;
 memset(int_stack,0,202400*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 202400;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_lhng(Libint, Data);
   Data++;
 }
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+202400,int_stack+2970,int_stack+0,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+211310,int_stack+6480,int_stack+2970,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+221840,int_stack+211310,int_stack+202400,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+239660,int_stack+10575,int_stack+6480,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+251945,int_stack+239660,int_stack+211310,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+273005,int_stack+251945,int_stack+221840,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+202400,int_stack+15300,int_stack+10575,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+302705,int_stack+202400,int_stack+239660,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+202400,int_stack+302705,int_stack+251945,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+302705,int_stack+202400,int_stack+273005,45);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+202400,int_stack+24330,int_stack+20700,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+213290,int_stack+28620,int_stack+24330,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+226160,int_stack+213290,int_stack+202400,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+247940,int_stack+33625,int_stack+28620,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+262955,int_stack+247940,int_stack+213290,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+347255,int_stack+262955,int_stack+226160,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+202400,int_stack+39400,int_stack+33625,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+0,int_stack+202400,int_stack+247940,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+202400,int_stack+0,int_stack+262955,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+245300,int_stack+202400,int_stack+347255,55);
 /*--- compute (lp|ng) ---*/
 hrr1_build_lp(Libint->AB,int_stack+347255,int_stack+245300,int_stack+302705,990);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+202400,int_stack+50356,int_stack+46000,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+215468,int_stack+55504,int_stack+50356,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+0,int_stack+215468,int_stack+202400,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+26136,int_stack+61510,int_stack+55504,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+299750,int_stack+26136,int_stack+215468,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+480905,int_stack+299750,int_stack+0,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+68440,int_stack+61510,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+202400,int_stack+0,int_stack+26136,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+0,int_stack+202400,int_stack+299750,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+524465,int_stack+0,int_stack+480905,66);
 /*--- compute (mp|ng) ---*/
 hrr1_build_mp(Libint->AB,int_stack+589805,int_stack+524465,int_stack+245300,990);
 /*--- compute (ld|ng) ---*/
 hrr1_build_ld(Libint->AB,int_stack+753155,int_stack+589805,int_stack+347255,990);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+81508,int_stack+76360,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+15444,int_stack+87592,int_stack+81508,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+33696,int_stack+15444,int_stack+0,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+64584,int_stack+94690,int_stack+87592,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+202400,int_stack+64584,int_stack+15444,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+238904,int_stack+202400,int_stack+33696,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+102880,int_stack+94690,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+290384,int_stack+0,int_stack+64584,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+0,int_stack+290384,int_stack+202400,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+290384,int_stack+0,int_stack+238904,78);
 /*--- compute (np|ng) ---*/
 hrr1_build_np(Libint->AB,int_stack+1020455,int_stack+290384,int_stack+524465,990);
 /*--- compute (md|ng) ---*/
 hrr1_build_md(Libint->AB,int_stack+1216475,int_stack+1020455,int_stack+589805,990);
 /*--- compute (lf|ng) ---*/
 hrr1_build_lf(Libint->AB,int_stack+1543175,int_stack+1216475,int_stack+753155,990);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+118246,int_stack+112240,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+18018,int_stack+125344,int_stack+118246,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+39312,int_stack+18018,int_stack+0,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+75348,int_stack+133625,int_stack+125344,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+202400,int_stack+75348,int_stack+18018,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+367604,int_stack+202400,int_stack+39312,91);
 /*--- compute (q0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+143180,int_stack+133625,91);
 /*--- compute (q0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+100191,int_stack+0,int_stack+75348,91);
 /*--- compute (q0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+0,int_stack+100191,int_stack+202400,91);
 /*--- compute (q0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+427664,int_stack+0,int_stack+367604,91);
 /*--- compute (op|ng) ---*/
 hrr1_build_op(Libint->AB,int_stack+517754,int_stack+427664,int_stack+290384,990);
 /*--- compute (nd|ng) ---*/
 hrr1_build_nd(Libint->AB,int_stack+1988675,int_stack+517754,int_stack+1020455,990);
 /*--- compute (mf|ng) ---*/
 hrr1_build_mf(Libint->AB,int_stack+2380715,int_stack+1988675,int_stack+1216475,990);
 /*--- compute (lg|ng) ---*/
 hrr1_build_lg(Libint->AB,int_stack+749414,int_stack+2380715,int_stack+1543175,990);
 /*--- compute (r0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+161030,int_stack+154100,105);
 /*--- compute (r0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+20790,int_stack+169220,int_stack+161030,105);
 /*--- compute (r0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+45360,int_stack+20790,int_stack+0,105);
 /*--- compute (r0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+86940,int_stack+178775,int_stack+169220,105);
 /*--- compute (r0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+115605,int_stack+86940,int_stack+20790,105);
 /*--- compute (r0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+202400,int_stack+115605,int_stack+45360,105);
 /*--- compute (r0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+189800,int_stack+178775,105);
 /*--- compute (r0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+271700,int_stack+0,int_stack+86940,105);
 /*--- compute (r0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+0,int_stack+271700,int_stack+115605,105);
 /*--- compute (r0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+271700,int_stack+0,int_stack+202400,105);
 /*--- compute (qp|ng) ---*/
 hrr1_build_qp(Libint->AB,int_stack+0,int_stack+271700,int_stack+427664,990);
 /*--- compute (od|ng) ---*/
 hrr1_build_od(Libint->AB,int_stack+1417664,int_stack+0,int_stack+517754,990);
 /*--- compute (nf|ng) ---*/
 hrr1_build_nf(Libint->AB,int_stack+0,int_stack+1417664,int_stack+1988675,990);
 /*--- compute (mg|ng) ---*/
 hrr1_build_mg(Libint->AB,int_stack+1417664,int_stack+0,int_stack+2380715,990);
 /*--- compute (lh|ng) ---*/
 hrr1_build_lh(Libint->AB,int_stack+2234414,int_stack+1417664,int_stack+749414,990);
 return int_stack+2234414;}
