/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_lhni(Libint_t*, prim_data*);

  /* Computes quartets of (lh|ni) integrals */

REALTYPE *hrr_order_lhni(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[8][10] = int_stack + 0;
 Libint->vrr_classes[8][11] = int_stack + 2970;
 Libint->vrr_classes[8][12] = int_stack + 6480;
 Libint->vrr_classes[8][13] = int_stack + 10575;
 Libint->vrr_classes[8][14] = int_stack + 15300;
 Libint->vrr_classes[8][15] = int_stack + 20700;
 Libint->vrr_classes[8][16] = int_stack + 26820;
 Libint->vrr_classes[9][10] = int_stack + 33705;
 Libint->vrr_classes[9][11] = int_stack + 37335;
 Libint->vrr_classes[9][12] = int_stack + 41625;
 Libint->vrr_classes[9][13] = int_stack + 46630;
 Libint->vrr_classes[9][14] = int_stack + 52405;
 Libint->vrr_classes[9][15] = int_stack + 59005;
 Libint->vrr_classes[9][16] = int_stack + 66485;
 Libint->vrr_classes[10][10] = int_stack + 74900;
 Libint->vrr_classes[10][11] = int_stack + 79256;
 Libint->vrr_classes[10][12] = int_stack + 84404;
 Libint->vrr_classes[10][13] = int_stack + 90410;
 Libint->vrr_classes[10][14] = int_stack + 97340;
 Libint->vrr_classes[10][15] = int_stack + 105260;
 Libint->vrr_classes[10][16] = int_stack + 114236;
 Libint->vrr_classes[11][10] = int_stack + 124334;
 Libint->vrr_classes[11][11] = int_stack + 129482;
 Libint->vrr_classes[11][12] = int_stack + 135566;
 Libint->vrr_classes[11][13] = int_stack + 142664;
 Libint->vrr_classes[11][14] = int_stack + 150854;
 Libint->vrr_classes[11][15] = int_stack + 160214;
 Libint->vrr_classes[11][16] = int_stack + 170822;
 Libint->vrr_classes[12][10] = int_stack + 182756;
 Libint->vrr_classes[12][11] = int_stack + 188762;
 Libint->vrr_classes[12][12] = int_stack + 195860;
 Libint->vrr_classes[12][13] = int_stack + 204141;
 Libint->vrr_classes[12][14] = int_stack + 213696;
 Libint->vrr_classes[12][15] = int_stack + 224616;
 Libint->vrr_classes[12][16] = int_stack + 236992;
 Libint->vrr_classes[13][10] = int_stack + 250915;
 Libint->vrr_classes[13][11] = int_stack + 257845;
 Libint->vrr_classes[13][12] = int_stack + 266035;
 Libint->vrr_classes[13][13] = int_stack + 275590;
 Libint->vrr_classes[13][14] = int_stack + 286615;
 Libint->vrr_classes[13][15] = int_stack + 299215;
 Libint->vrr_classes[13][16] = int_stack + 313495;
 memset(int_stack,0,329560*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 329560;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_lhni(Libint, Data);
   Data++;
 }
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+329560,int_stack+2970,int_stack+0,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+338470,int_stack+6480,int_stack+2970,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+349000,int_stack+338470,int_stack+329560,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+366820,int_stack+10575,int_stack+6480,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+379105,int_stack+366820,int_stack+338470,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+400165,int_stack+379105,int_stack+349000,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+329560,int_stack+15300,int_stack+10575,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+429865,int_stack+329560,int_stack+366820,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+343735,int_stack+429865,int_stack+379105,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+454435,int_stack+343735,int_stack+400165,45);
 /*--- compute (l0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+378835,int_stack+20700,int_stack+15300,45);
 /*--- compute (l0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+395035,int_stack+378835,int_stack+329560,45);
 /*--- compute (l0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+498985,int_stack+395035,int_stack+429865,45);
 /*--- compute (l0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+539935,int_stack+498985,int_stack+343735,45);
 /*--- compute (l0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+592585,int_stack+539935,int_stack+454435,45);
 /*--- compute (l0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+329560,int_stack+26820,int_stack+20700,45);
 /*--- compute (l0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+423385,int_stack+329560,int_stack+378835,45);
 /*--- compute (l0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+329560,int_stack+423385,int_stack+395035,45);
 /*--- compute (l0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+376810,int_stack+329560,int_stack+498985,45);
 /*--- compute (l0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+438235,int_stack+376810,int_stack+539935,45);
 /*--- compute (l0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+329560,int_stack+438235,int_stack+592585,45);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+412720,int_stack+37335,int_stack+33705,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+423610,int_stack+41625,int_stack+37335,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+436480,int_stack+423610,int_stack+412720,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+458260,int_stack+46630,int_stack+41625,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+473275,int_stack+458260,int_stack+423610,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+499015,int_stack+473275,int_stack+436480,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+412720,int_stack+52405,int_stack+46630,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+535315,int_stack+412720,int_stack+458260,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+430045,int_stack+535315,int_stack+473275,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+565345,int_stack+430045,int_stack+499015,55);
 /*--- compute (m0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+472945,int_stack+59005,int_stack+52405,55);
 /*--- compute (m0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+492745,int_stack+472945,int_stack+412720,55);
 /*--- compute (m0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+0,int_stack+492745,int_stack+535315,55);
 /*--- compute (m0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+619795,int_stack+0,int_stack+430045,55);
 /*--- compute (m0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+684145,int_stack+619795,int_stack+565345,55);
 /*--- compute (m0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+412720,int_stack+66485,int_stack+59005,55);
 /*--- compute (m0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+527395,int_stack+412720,int_stack+472945,55);
 /*--- compute (m0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+412720,int_stack+527395,int_stack+492745,55);
 /*--- compute (m0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+470470,int_stack+412720,int_stack+0,55);
 /*--- compute (m0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+760375,int_stack+470470,int_stack+619795,55);
 /*--- compute (m0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+412720,int_stack+760375,int_stack+684145,55);
 /*--- compute (lp|ni) ---*/
 hrr1_build_lp(Libint->AB,int_stack+514360,int_stack+412720,int_stack+329560,1848);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+329560,int_stack+79256,int_stack+74900,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+342628,int_stack+84404,int_stack+79256,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+358072,int_stack+342628,int_stack+329560,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+384208,int_stack+90410,int_stack+84404,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+0,int_stack+384208,int_stack+342628,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+30888,int_stack+0,int_stack+358072,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+329560,int_stack+97340,int_stack+90410,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+763840,int_stack+329560,int_stack+384208,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+350350,int_stack+763840,int_stack+0,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+799876,int_stack+350350,int_stack+30888,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+0,int_stack+105260,int_stack+97340,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+23760,int_stack+0,int_stack+329560,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+865216,int_stack+23760,int_stack+763840,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+925276,int_stack+865216,int_stack+350350,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1002496,int_stack+925276,int_stack+799876,66);
 /*--- compute (n0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+763840,int_stack+114236,int_stack+105260,66);
 /*--- compute (n0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+790768,int_stack+763840,int_stack+0,66);
 /*--- compute (n0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+329560,int_stack+790768,int_stack+23760,66);
 /*--- compute (n0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+0,int_stack+329560,int_stack+865216,66);
 /*--- compute (n0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+763840,int_stack+0,int_stack+925276,66);
 /*--- compute (n0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+0,int_stack+763840,int_stack+1002496,66);
 /*--- compute (mp|ni) ---*/
 hrr1_build_mp(Libint->AB,int_stack+763840,int_stack+0,int_stack+412720,1848);
 /*--- compute (ld|ni) ---*/
 hrr1_build_ld(Libint->AB,int_stack+1068760,int_stack+763840,int_stack+514360,1848);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+329560,int_stack+129482,int_stack+124334,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+345004,int_stack+135566,int_stack+129482,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+363256,int_stack+345004,int_stack+329560,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+394144,int_stack+142664,int_stack+135566,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+415438,int_stack+394144,int_stack+345004,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+451942,int_stack+415438,int_stack+363256,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+329560,int_stack+150854,int_stack+142664,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+503422,int_stack+329560,int_stack+394144,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+354130,int_stack+503422,int_stack+415438,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+546010,int_stack+354130,int_stack+451942,78);
 /*--- compute (o0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+414970,int_stack+160214,int_stack+150854,78);
 /*--- compute (o0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+443050,int_stack+414970,int_stack+329560,78);
 /*--- compute (o0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+623230,int_stack+443050,int_stack+503422,78);
 /*--- compute (o0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1567720,int_stack+623230,int_stack+354130,78);
 /*--- compute (o0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1658980,int_stack+1567720,int_stack+546010,78);
 /*--- compute (o0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+329560,int_stack+170822,int_stack+160214,78);
 /*--- compute (o0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+492190,int_stack+329560,int_stack+414970,78);
 /*--- compute (o0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+329560,int_stack+492190,int_stack+443050,78);
 /*--- compute (o0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+411460,int_stack+329560,int_stack+623230,78);
 /*--- compute (o0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+517930,int_stack+411460,int_stack+1567720,78);
 /*--- compute (o0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+329560,int_stack+517930,int_stack+1658980,78);
 /*--- compute (np|ni) ---*/
 hrr1_build_np(Libint->AB,int_stack+1567720,int_stack+329560,int_stack+0,1848);
 /*--- compute (md|ni) ---*/
 hrr1_build_md(Libint->AB,int_stack+1933624,int_stack+1567720,int_stack+763840,1848);
 /*--- compute (lf|ni) ---*/
 hrr1_build_lf(Libint->AB,int_stack+2543464,int_stack+1933624,int_stack+1068760,1848);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+188762,int_stack+182756,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+18018,int_stack+195860,int_stack+188762,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+39312,int_stack+18018,int_stack+0,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+75348,int_stack+204141,int_stack+195860,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+100191,int_stack+75348,int_stack+18018,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+142779,int_stack+100191,int_stack+39312,91);
 /*--- compute (q0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+213696,int_stack+204141,91);
 /*--- compute (q0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+473704,int_stack+0,int_stack+75348,91);
 /*--- compute (q0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+28665,int_stack+473704,int_stack+100191,91);
 /*--- compute (q0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+523390,int_stack+28665,int_stack+142779,91);
 /*--- compute (q0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+99645,int_stack+224616,int_stack+213696,91);
 /*--- compute (q0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+132405,int_stack+99645,int_stack+0,91);
 /*--- compute (q0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+613480,int_stack+132405,int_stack+473704,91);
 /*--- compute (q0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+696290,int_stack+613480,int_stack+28665,91);
 /*--- compute (q0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+802760,int_stack+696290,int_stack+523390,91);
 /*--- compute (q0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+473704,int_stack+236992,int_stack+224616,91);
 /*--- compute (q0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+510832,int_stack+473704,int_stack+99645,91);
 /*--- compute (q0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+0,int_stack+510832,int_stack+132405,91);
 /*--- compute (q0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+473704,int_stack+0,int_stack+613480,91);
 /*--- compute (q0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+0,int_stack+473704,int_stack+696290,91);
 /*--- compute (q0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+473704,int_stack+0,int_stack+802760,91);
 /*--- compute (op|ni) ---*/
 hrr1_build_op(Libint->AB,int_stack+641872,int_stack+473704,int_stack+329560,1848);
 /*--- compute (nd|ni) ---*/
 hrr1_build_nd(Libint->AB,int_stack+3375064,int_stack+641872,int_stack+1567720,1848);
 /*--- compute (mf|ni) ---*/
 hrr1_build_mf(Libint->AB,int_stack+4106872,int_stack+3375064,int_stack+1933624,1848);
 /*--- compute (lg|ni) ---*/
 hrr1_build_lg(Libint->AB,int_stack+1074304,int_stack+4106872,int_stack+2543464,1848);
 /*--- compute (r0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+329560,int_stack+257845,int_stack+250915,105);
 /*--- compute (r0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+350350,int_stack+266035,int_stack+257845,105);
 /*--- compute (r0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+374920,int_stack+350350,int_stack+329560,105);
 /*--- compute (r0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+416500,int_stack+275590,int_stack+266035,105);
 /*--- compute (r0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+0,int_stack+416500,int_stack+350350,105);
 /*--- compute (r0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+49140,int_stack+0,int_stack+374920,105);
 /*--- compute (r0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+329560,int_stack+286615,int_stack+275590,105);
 /*--- compute (r0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+118440,int_stack+329560,int_stack+416500,105);
 /*--- compute (r0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+362635,int_stack+118440,int_stack+0,105);
 /*--- compute (r0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+175770,int_stack+362635,int_stack+49140,105);
 /*--- compute (r0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+0,int_stack+299215,int_stack+286615,105);
 /*--- compute (r0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+37800,int_stack+0,int_stack+329560,105);
 /*--- compute (r0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+2321704,int_stack+37800,int_stack+118440,105);
 /*--- compute (r0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+2417254,int_stack+2321704,int_stack+362635,105);
 /*--- compute (r0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+2540104,int_stack+2417254,int_stack+175770,105);
 /*--- compute (r0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+329560,int_stack+313495,int_stack+299215,105);
 /*--- compute (r0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+372400,int_stack+329560,int_stack+0,105);
 /*--- compute (r0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+103950,int_stack+372400,int_stack+37800,105);
 /*--- compute (r0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+214200,int_stack+103950,int_stack+2321704,105);
 /*--- compute (r0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+0,int_stack+214200,int_stack+2417254,105);
 /*--- compute (r0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+2321704,int_stack+0,int_stack+2540104,105);
 /*--- compute (qp|ni) ---*/
 hrr1_build_qp(Libint->AB,int_stack+2515744,int_stack+2321704,int_stack+473704,1848);
 /*--- compute (od|ni) ---*/
 hrr1_build_od(Libint->AB,int_stack+5123272,int_stack+2515744,int_stack+641872,1848);
 /*--- compute (nf|ni) ---*/
 hrr1_build_nf(Libint->AB,int_stack+5988136,int_stack+5123272,int_stack+3375064,1848);
 /*--- compute (mg|ni) ---*/
 hrr1_build_mg(Libint->AB,int_stack+2321704,int_stack+5988136,int_stack+4106872,1848);
 /*--- compute (lh|ni) ---*/
 hrr1_build_lh(Libint->AB,int_stack+3846304,int_stack+2321704,int_stack+1074304,1848);
 return int_stack+3846304;}
