/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_lpli(Libint_t*, prim_data*);

  /* Computes quartets of (lp|li) integrals */

REALTYPE *hrr_order_lpli(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[8][8] = int_stack + 0;
 Libint->vrr_classes[8][9] = int_stack + 2025;
 Libint->vrr_classes[8][10] = int_stack + 4500;
 Libint->vrr_classes[8][11] = int_stack + 7470;
 Libint->vrr_classes[8][12] = int_stack + 10980;
 Libint->vrr_classes[8][13] = int_stack + 15075;
 Libint->vrr_classes[8][14] = int_stack + 19800;
 Libint->vrr_classes[9][8] = int_stack + 25200;
 Libint->vrr_classes[9][9] = int_stack + 27675;
 Libint->vrr_classes[9][10] = int_stack + 30700;
 Libint->vrr_classes[9][11] = int_stack + 34330;
 Libint->vrr_classes[9][12] = int_stack + 38620;
 Libint->vrr_classes[9][13] = int_stack + 43625;
 Libint->vrr_classes[9][14] = int_stack + 49400;
 memset(int_stack,0,56000*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 56000;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_lpli(Libint, Data);
   Data++;
 }
 /*--- compute (l0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+56000,int_stack+2025,int_stack+0,45);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+62075,int_stack+4500,int_stack+2025,45);
 /*--- compute (l0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+69500,int_stack+62075,int_stack+56000,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+81650,int_stack+7470,int_stack+4500,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+90560,int_stack+81650,int_stack+62075,45);
 /*--- compute (l0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+105410,int_stack+90560,int_stack+69500,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+56000,int_stack+10980,int_stack+7470,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+125660,int_stack+56000,int_stack+81650,45);
 /*--- compute (l0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+143480,int_stack+125660,int_stack+90560,45);
 /*--- compute (l0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+66530,int_stack+143480,int_stack+105410,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+96905,int_stack+15075,int_stack+10980,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+168230,int_stack+96905,int_stack+56000,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+189290,int_stack+168230,int_stack+125660,45);
 /*--- compute (l0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+218990,int_stack+189290,int_stack+143480,45);
 /*--- compute (l0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+109190,int_stack+218990,int_stack+66530,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+56000,int_stack+19800,int_stack+15075,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+70175,int_stack+56000,int_stack+96905,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+256115,int_stack+70175,int_stack+168230,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+56000,int_stack+256115,int_stack+189290,45);
 /*--- compute (l0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+151715,int_stack+56000,int_stack+218990,45);
 /*--- compute (l0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+203690,int_stack+151715,int_stack+109190,45);
 /*--- compute (m0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+56000,int_stack+27675,int_stack+25200,55);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+63425,int_stack+30700,int_stack+27675,55);
 /*--- compute (m0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+72500,int_stack+63425,int_stack+56000,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+87350,int_stack+34330,int_stack+30700,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+98240,int_stack+87350,int_stack+63425,55);
 /*--- compute (m0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+116390,int_stack+98240,int_stack+72500,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+56000,int_stack+38620,int_stack+34330,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+141140,int_stack+56000,int_stack+87350,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+162920,int_stack+141140,int_stack+98240,55);
 /*--- compute (m0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+68870,int_stack+162920,int_stack+116390,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+105995,int_stack+43625,int_stack+38620,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+260390,int_stack+105995,int_stack+56000,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+0,int_stack+260390,int_stack+141140,55);
 /*--- compute (m0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+286130,int_stack+0,int_stack+162920,55);
 /*--- compute (m0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+121010,int_stack+286130,int_stack+68870,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+56000,int_stack+49400,int_stack+43625,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+73325,int_stack+56000,int_stack+105995,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+331505,int_stack+73325,int_stack+260390,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+36300,int_stack+331505,int_stack+0,55);
 /*--- compute (m0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+331505,int_stack+36300,int_stack+286130,55);
 /*--- compute (m0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+0,int_stack+331505,int_stack+121010,55);
 /*--- compute (lp|li) ---*/
 hrr1_build_lp(Libint->AB,int_stack+260390,int_stack+0,int_stack+203690,1260);
 return int_stack+260390;}
