/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_lpmf(Libint_t*, prim_data*);

  /* Computes quartets of (lp|mf) integrals */

REALTYPE *hrr_order_lpmf(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[8][9] = int_stack + 0;
 Libint->vrr_classes[8][10] = int_stack + 2475;
 Libint->vrr_classes[8][11] = int_stack + 5445;
 Libint->vrr_classes[8][12] = int_stack + 8955;
 Libint->vrr_classes[9][9] = int_stack + 13050;
 Libint->vrr_classes[9][10] = int_stack + 16075;
 Libint->vrr_classes[9][11] = int_stack + 19705;
 Libint->vrr_classes[9][12] = int_stack + 23995;
 memset(int_stack,0,29000*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 29000;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_lpmf(Libint, Data);
   Data++;
 }
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+29000,int_stack+2475,int_stack+0,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+36425,int_stack+5445,int_stack+2475,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+45335,int_stack+36425,int_stack+29000,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+60185,int_stack+8955,int_stack+5445,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+70715,int_stack+60185,int_stack+36425,45);
 /*--- compute (l0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+88535,int_stack+70715,int_stack+45335,45);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+29000,int_stack+16075,int_stack+13050,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+38075,int_stack+19705,int_stack+16075,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+48965,int_stack+38075,int_stack+29000,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+67115,int_stack+23995,int_stack+19705,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+0,int_stack+67115,int_stack+38075,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+113285,int_stack+0,int_stack+48965,55);
 /*--- compute (lp|mf) ---*/
 hrr1_build_lp(Libint->AB,int_stack+0,int_stack+113285,int_stack+88535,550);
 return int_stack+0;}
