/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_m0kk(Libint_t*, prim_data*);

  /* Computes quartets of (m0|kk) integrals */

REALTYPE *hrr_order_m0kk(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[9][7] = int_stack + 0;
 Libint->vrr_classes[9][8] = int_stack + 1980;
 Libint->vrr_classes[9][9] = int_stack + 4455;
 Libint->vrr_classes[9][10] = int_stack + 7480;
 Libint->vrr_classes[9][11] = int_stack + 11110;
 Libint->vrr_classes[9][12] = int_stack + 15400;
 Libint->vrr_classes[9][13] = int_stack + 20405;
 Libint->vrr_classes[9][14] = int_stack + 26180;
 memset(int_stack,0,32780*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 32780;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_m0kk(Libint, Data);
   Data++;
 }
 /*--- compute (m0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+32780,int_stack+1980,int_stack+0,55);
 /*--- compute (m0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+38720,int_stack+4455,int_stack+1980,55);
 /*--- compute (m0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+46145,int_stack+38720,int_stack+32780,55);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+58025,int_stack+7480,int_stack+4455,55);
 /*--- compute (m0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+67100,int_stack+58025,int_stack+38720,55);
 /*--- compute (m0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+81950,int_stack+67100,int_stack+46145,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+32780,int_stack+11110,int_stack+7480,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+101750,int_stack+32780,int_stack+58025,55);
 /*--- compute (m0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+119900,int_stack+101750,int_stack+67100,55);
 /*--- compute (m0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+43670,int_stack+119900,int_stack+81950,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+73370,int_stack+15400,int_stack+11110,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+144650,int_stack+73370,int_stack+32780,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+166430,int_stack+144650,int_stack+101750,55);
 /*--- compute (m0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+196680,int_stack+166430,int_stack+119900,55);
 /*--- compute (m0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+86240,int_stack+196680,int_stack+43670,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+32780,int_stack+20405,int_stack+15400,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+233805,int_stack+32780,int_stack+73370,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+47795,int_stack+233805,int_stack+144650,55);
 /*--- compute (m0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+259545,int_stack+47795,int_stack+166430,55);
 /*--- compute (m0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+127820,int_stack+259545,int_stack+196680,55);
 /*--- compute (m0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+304920,int_stack+127820,int_stack+86240,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+84095,int_stack+26180,int_stack+20405,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+179795,int_stack+84095,int_stack+32780,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+84095,int_stack+179795,int_stack+233805,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+179795,int_stack+84095,int_stack+47795,55);
 /*--- compute (m0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+0,int_stack+179795,int_stack+259545,55);
 /*--- compute (m0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+179795,int_stack+0,int_stack+127820,55);
 /*--- compute (m0|kk) ---*/
 hrr3_build_kk(Libint->CD,int_stack+0,int_stack+179795,int_stack+304920,55);
 return int_stack+0;}
