/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_mdlh(Libint_t*, prim_data*);

  /* Computes quartets of (md|lh) integrals */

REALTYPE *hrr_order_mdlh(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[9][8] = int_stack + 0;
 Libint->vrr_classes[9][9] = int_stack + 2475;
 Libint->vrr_classes[9][10] = int_stack + 5500;
 Libint->vrr_classes[9][11] = int_stack + 9130;
 Libint->vrr_classes[9][12] = int_stack + 13420;
 Libint->vrr_classes[9][13] = int_stack + 18425;
 Libint->vrr_classes[10][8] = int_stack + 24200;
 Libint->vrr_classes[10][9] = int_stack + 27170;
 Libint->vrr_classes[10][10] = int_stack + 30800;
 Libint->vrr_classes[10][11] = int_stack + 35156;
 Libint->vrr_classes[10][12] = int_stack + 40304;
 Libint->vrr_classes[10][13] = int_stack + 46310;
 Libint->vrr_classes[11][8] = int_stack + 53240;
 Libint->vrr_classes[11][9] = int_stack + 56750;
 Libint->vrr_classes[11][10] = int_stack + 61040;
 Libint->vrr_classes[11][11] = int_stack + 66188;
 Libint->vrr_classes[11][12] = int_stack + 72272;
 Libint->vrr_classes[11][13] = int_stack + 79370;
 memset(int_stack,0,87560*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 87560;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_mdlh(Libint, Data);
   Data++;
 }
 /*--- compute (m0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+87560,int_stack+2475,int_stack+0,55);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+94985,int_stack+5500,int_stack+2475,55);
 /*--- compute (m0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+104060,int_stack+94985,int_stack+87560,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+118910,int_stack+9130,int_stack+5500,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+129800,int_stack+118910,int_stack+94985,55);
 /*--- compute (m0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+147950,int_stack+129800,int_stack+104060,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+87560,int_stack+13420,int_stack+9130,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+172700,int_stack+87560,int_stack+118910,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+194480,int_stack+172700,int_stack+129800,55);
 /*--- compute (m0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+100430,int_stack+194480,int_stack+147950,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+137555,int_stack+18425,int_stack+13420,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+224730,int_stack+137555,int_stack+87560,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+250470,int_stack+224730,int_stack+172700,55);
 /*--- compute (m0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+137555,int_stack+250470,int_stack+194480,55);
 /*--- compute (m0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+182930,int_stack+137555,int_stack+100430,55);
 /*--- compute (n0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+87560,int_stack+27170,int_stack+24200,66);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+96470,int_stack+30800,int_stack+27170,66);
 /*--- compute (n0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+107360,int_stack+96470,int_stack+87560,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+125180,int_stack+35156,int_stack+30800,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+138248,int_stack+125180,int_stack+96470,66);
 /*--- compute (n0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+234905,int_stack+138248,int_stack+107360,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+87560,int_stack+40304,int_stack+35156,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+0,int_stack+87560,int_stack+125180,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+264605,int_stack+0,int_stack+138248,66);
 /*--- compute (n0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+103004,int_stack+264605,int_stack+234905,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+234905,int_stack+46310,int_stack+40304,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+147554,int_stack+234905,int_stack+87560,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+300905,int_stack+147554,int_stack+0,66);
 /*--- compute (n0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+344465,int_stack+300905,int_stack+264605,66);
 /*--- compute (n0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+234905,int_stack+344465,int_stack+103004,66);
 /*--- compute (mp|lh) ---*/
 hrr1_build_mp(Libint->AB,int_stack+297275,int_stack+234905,int_stack+182930,945);
 /*--- compute (o0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+0,int_stack+56750,int_stack+53240,78);
 /*--- compute (o0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+10530,int_stack+61040,int_stack+56750,78);
 /*--- compute (o0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+23400,int_stack+10530,int_stack+0,78);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+44460,int_stack+66188,int_stack+61040,78);
 /*--- compute (o0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+87560,int_stack+44460,int_stack+10530,78);
 /*--- compute (o0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+113300,int_stack+87560,int_stack+23400,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+0,int_stack+72272,int_stack+66188,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+148400,int_stack+0,int_stack+44460,78);
 /*--- compute (o0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+18252,int_stack+148400,int_stack+87560,78);
 /*--- compute (o0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+179288,int_stack+18252,int_stack+113300,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+87560,int_stack+79370,int_stack+72272,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+108854,int_stack+87560,int_stack+0,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+453200,int_stack+108854,int_stack+148400,78);
 /*--- compute (o0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+61152,int_stack+453200,int_stack+18252,78);
 /*--- compute (o0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+453200,int_stack+61152,int_stack+179288,78);
 /*--- compute (np|lh) ---*/
 hrr1_build_np(Libint->AB,int_stack+0,int_stack+453200,int_stack+234905,945);
 /*--- compute (md|lh) ---*/
 hrr1_build_md(Libint->AB,int_stack+453200,int_stack+0,int_stack+297275,945);
 return int_stack+453200;}
