/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_mdnd(Libint_t*, prim_data*);

  /* Computes quartets of (md|nd) integrals */

REALTYPE *hrr_order_mdnd(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[9][10] = int_stack + 0;
 Libint->vrr_classes[9][11] = int_stack + 3630;
 Libint->vrr_classes[9][12] = int_stack + 7920;
 Libint->vrr_classes[10][10] = int_stack + 12925;
 Libint->vrr_classes[10][11] = int_stack + 17281;
 Libint->vrr_classes[10][12] = int_stack + 22429;
 Libint->vrr_classes[11][10] = int_stack + 28435;
 Libint->vrr_classes[11][11] = int_stack + 33583;
 Libint->vrr_classes[11][12] = int_stack + 39667;
 memset(int_stack,0,46765*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 46765;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_mdnd(Libint, Data);
   Data++;
 }
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+46765,int_stack+3630,int_stack+0,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+57655,int_stack+7920,int_stack+3630,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+70525,int_stack+57655,int_stack+46765,55);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+46765,int_stack+17281,int_stack+12925,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+0,int_stack+22429,int_stack+17281,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+92305,int_stack+0,int_stack+46765,66);
 /*--- compute (mp|nd) ---*/
 hrr1_build_mp(Libint->AB,int_stack+118441,int_stack+92305,int_stack+70525,396);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+46765,int_stack+33583,int_stack+28435,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+62209,int_stack+39667,int_stack+33583,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+0,int_stack+62209,int_stack+46765,78);
 /*--- compute (np|nd) ---*/
 hrr1_build_np(Libint->AB,int_stack+183781,int_stack+0,int_stack+92305,396);
 /*--- compute (md|nd) ---*/
 hrr1_build_md(Libint->AB,int_stack+262189,int_stack+183781,int_stack+118441,396);
 return int_stack+262189;}
