/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_mflg(Libint_t*, prim_data*);

  /* Computes quartets of (mf|lg) integrals */

REALTYPE *hrr_order_mflg(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[9][8] = int_stack + 0;
 Libint->vrr_classes[9][9] = int_stack + 2475;
 Libint->vrr_classes[9][10] = int_stack + 5500;
 Libint->vrr_classes[9][11] = int_stack + 9130;
 Libint->vrr_classes[9][12] = int_stack + 13420;
 Libint->vrr_classes[10][8] = int_stack + 18425;
 Libint->vrr_classes[10][9] = int_stack + 21395;
 Libint->vrr_classes[10][10] = int_stack + 25025;
 Libint->vrr_classes[10][11] = int_stack + 29381;
 Libint->vrr_classes[10][12] = int_stack + 34529;
 Libint->vrr_classes[11][8] = int_stack + 40535;
 Libint->vrr_classes[11][9] = int_stack + 44045;
 Libint->vrr_classes[11][10] = int_stack + 48335;
 Libint->vrr_classes[11][11] = int_stack + 53483;
 Libint->vrr_classes[11][12] = int_stack + 59567;
 Libint->vrr_classes[12][8] = int_stack + 66665;
 Libint->vrr_classes[12][9] = int_stack + 70760;
 Libint->vrr_classes[12][10] = int_stack + 75765;
 Libint->vrr_classes[12][11] = int_stack + 81771;
 Libint->vrr_classes[12][12] = int_stack + 88869;
 memset(int_stack,0,97150*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 97150;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_mflg(Libint, Data);
   Data++;
 }
 /*--- compute (m0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+97150,int_stack+2475,int_stack+0,55);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+104575,int_stack+5500,int_stack+2475,55);
 /*--- compute (m0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+113650,int_stack+104575,int_stack+97150,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+128500,int_stack+9130,int_stack+5500,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+139390,int_stack+128500,int_stack+104575,55);
 /*--- compute (m0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+157540,int_stack+139390,int_stack+113650,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+97150,int_stack+13420,int_stack+9130,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+182290,int_stack+97150,int_stack+128500,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+97150,int_stack+182290,int_stack+139390,55);
 /*--- compute (m0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+182290,int_stack+97150,int_stack+157540,55);
 /*--- compute (n0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+97150,int_stack+21395,int_stack+18425,66);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+106060,int_stack+25025,int_stack+21395,66);
 /*--- compute (n0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+116950,int_stack+106060,int_stack+97150,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+134770,int_stack+29381,int_stack+25025,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+147838,int_stack+134770,int_stack+106060,66);
 /*--- compute (n0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+219415,int_stack+147838,int_stack+116950,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+97150,int_stack+34529,int_stack+29381,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+0,int_stack+97150,int_stack+134770,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+97150,int_stack+0,int_stack+147838,66);
 /*--- compute (n0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+133450,int_stack+97150,int_stack+219415,66);
 /*--- compute (mp|lg) ---*/
 hrr1_build_mp(Libint->AB,int_stack+219415,int_stack+133450,int_stack+182290,675);
 /*--- compute (o0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+97150,int_stack+44045,int_stack+40535,78);
 /*--- compute (o0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+107680,int_stack+48335,int_stack+44045,78);
 /*--- compute (o0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+0,int_stack+107680,int_stack+97150,78);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+21060,int_stack+53483,int_stack+48335,78);
 /*--- compute (o0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+178000,int_stack+21060,int_stack+107680,78);
 /*--- compute (o0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+97150,int_stack+178000,int_stack+0,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+0,int_stack+59567,int_stack+53483,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+330790,int_stack+0,int_stack+21060,78);
 /*--- compute (o0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+0,int_stack+330790,int_stack+178000,78);
 /*--- compute (o0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+330790,int_stack+0,int_stack+97150,78);
 /*--- compute (np|lg) ---*/
 hrr1_build_np(Libint->AB,int_stack+383440,int_stack+330790,int_stack+133450,675);
 /*--- compute (md|lg) ---*/
 hrr1_build_md(Libint->AB,int_stack+517090,int_stack+383440,int_stack+219415,675);
 /*--- compute (q0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+97150,int_stack+70760,int_stack+66665,91);
 /*--- compute (q0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+109435,int_stack+75765,int_stack+70760,91);
 /*--- compute (q0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+124450,int_stack+109435,int_stack+97150,91);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+149020,int_stack+81771,int_stack+75765,91);
 /*--- compute (q0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+167038,int_stack+149020,int_stack+109435,91);
 /*--- compute (q0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+197068,int_stack+167038,int_stack+124450,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+97150,int_stack+88869,int_stack+81771,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+238018,int_stack+97150,int_stack+149020,91);
 /*--- compute (q0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+274054,int_stack+238018,int_stack+167038,91);
 /*--- compute (q0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+0,int_stack+274054,int_stack+197068,91);
 /*--- compute (op|lg) ---*/
 hrr1_build_op(Libint->AB,int_stack+61425,int_stack+0,int_stack+330790,675);
 /*--- compute (nd|lg) ---*/
 hrr1_build_nd(Libint->AB,int_stack+739840,int_stack+61425,int_stack+383440,675);
 /*--- compute (mf|lg) ---*/
 hrr1_build_mf(Libint->AB,int_stack+0,int_stack+739840,int_stack+517090,675);
 return int_stack+0;}
