/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_mfml(Libint_t*, prim_data*);

  /* Computes quartets of (mf|ml) integrals */

REALTYPE *hrr_order_mfml(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[9][9] = int_stack + 0;
 Libint->vrr_classes[9][10] = int_stack + 3025;
 Libint->vrr_classes[9][11] = int_stack + 6655;
 Libint->vrr_classes[9][12] = int_stack + 10945;
 Libint->vrr_classes[9][13] = int_stack + 15950;
 Libint->vrr_classes[9][14] = int_stack + 21725;
 Libint->vrr_classes[9][15] = int_stack + 28325;
 Libint->vrr_classes[9][16] = int_stack + 35805;
 Libint->vrr_classes[9][17] = int_stack + 44220;
 Libint->vrr_classes[10][9] = int_stack + 53625;
 Libint->vrr_classes[10][10] = int_stack + 57255;
 Libint->vrr_classes[10][11] = int_stack + 61611;
 Libint->vrr_classes[10][12] = int_stack + 66759;
 Libint->vrr_classes[10][13] = int_stack + 72765;
 Libint->vrr_classes[10][14] = int_stack + 79695;
 Libint->vrr_classes[10][15] = int_stack + 87615;
 Libint->vrr_classes[10][16] = int_stack + 96591;
 Libint->vrr_classes[10][17] = int_stack + 106689;
 Libint->vrr_classes[11][9] = int_stack + 117975;
 Libint->vrr_classes[11][10] = int_stack + 122265;
 Libint->vrr_classes[11][11] = int_stack + 127413;
 Libint->vrr_classes[11][12] = int_stack + 133497;
 Libint->vrr_classes[11][13] = int_stack + 140595;
 Libint->vrr_classes[11][14] = int_stack + 148785;
 Libint->vrr_classes[11][15] = int_stack + 158145;
 Libint->vrr_classes[11][16] = int_stack + 168753;
 Libint->vrr_classes[11][17] = int_stack + 180687;
 Libint->vrr_classes[12][9] = int_stack + 194025;
 Libint->vrr_classes[12][10] = int_stack + 199030;
 Libint->vrr_classes[12][11] = int_stack + 205036;
 Libint->vrr_classes[12][12] = int_stack + 212134;
 Libint->vrr_classes[12][13] = int_stack + 220415;
 Libint->vrr_classes[12][14] = int_stack + 229970;
 Libint->vrr_classes[12][15] = int_stack + 240890;
 Libint->vrr_classes[12][16] = int_stack + 253266;
 Libint->vrr_classes[12][17] = int_stack + 267189;
 memset(int_stack,0,282750*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 282750;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_mfml(Libint, Data);
   Data++;
 }
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+282750,int_stack+3025,int_stack+0,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+291825,int_stack+6655,int_stack+3025,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+302715,int_stack+291825,int_stack+282750,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+320865,int_stack+10945,int_stack+6655,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+333735,int_stack+320865,int_stack+291825,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+355515,int_stack+333735,int_stack+302715,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+282750,int_stack+15950,int_stack+10945,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+385765,int_stack+282750,int_stack+320865,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+411505,int_stack+385765,int_stack+333735,55);
 /*--- compute (m0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+297765,int_stack+411505,int_stack+355515,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+343140,int_stack+21725,int_stack+15950,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+447805,int_stack+343140,int_stack+282750,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+477835,int_stack+447805,int_stack+385765,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+520735,int_stack+477835,int_stack+411505,55);
 /*--- compute (m0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+360465,int_stack+520735,int_stack+297765,55);
 /*--- compute (m0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+282750,int_stack+28325,int_stack+21725,55);
 /*--- compute (m0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+302550,int_stack+282750,int_stack+343140,55);
 /*--- compute (m0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+575185,int_stack+302550,int_stack+447805,55);
 /*--- compute (m0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+625235,int_stack+575185,int_stack+477835,55);
 /*--- compute (m0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+423990,int_stack+625235,int_stack+520735,55);
 /*--- compute (m0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+689585,int_stack+423990,int_stack+360465,55);
 /*--- compute (m0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+337200,int_stack+35805,int_stack+28325,55);
 /*--- compute (m0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+359640,int_stack+337200,int_stack+282750,55);
 /*--- compute (m0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+500220,int_stack+359640,int_stack+302550,55);
 /*--- compute (m0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+774285,int_stack+500220,int_stack+575185,55);
 /*--- compute (m0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+849360,int_stack+774285,int_stack+625235,55);
 /*--- compute (m0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+557970,int_stack+849360,int_stack+423990,55);
 /*--- compute (m0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+939450,int_stack+557970,int_stack+689585,55);
 /*--- compute (m0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+282750,int_stack+44220,int_stack+35805,55);
 /*--- compute (m0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+399240,int_stack+282750,int_stack+337200,55);
 /*--- compute (m0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+282750,int_stack+399240,int_stack+359640,55);
 /*--- compute (m0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+348750,int_stack+282750,int_stack+500220,55);
 /*--- compute (m0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+435375,int_stack+348750,int_stack+774285,55);
 /*--- compute (m0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+282750,int_stack+435375,int_stack+849360,55);
 /*--- compute (m0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+402870,int_stack+282750,int_stack+557970,55);
 /*--- compute (m0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+533550,int_stack+402870,int_stack+939450,55);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+282750,int_stack+57255,int_stack+53625,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+293640,int_stack+61611,int_stack+57255,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+306708,int_stack+293640,int_stack+282750,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+328488,int_stack+66759,int_stack+61611,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+343932,int_stack+328488,int_stack+293640,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+370068,int_stack+343932,int_stack+306708,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+282750,int_stack+72765,int_stack+66759,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+406368,int_stack+282750,int_stack+328488,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+437256,int_stack+406368,int_stack+343932,66);
 /*--- compute (n0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+300768,int_stack+437256,int_stack+370068,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+355218,int_stack+79695,int_stack+72765,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+480816,int_stack+355218,int_stack+282750,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+669675,int_stack+480816,int_stack+406368,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+721155,int_stack+669675,int_stack+437256,66);
 /*--- compute (n0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+376008,int_stack+721155,int_stack+300768,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+282750,int_stack+87615,int_stack+79695,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+306510,int_stack+282750,int_stack+355218,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+786495,int_stack+306510,int_stack+480816,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+452238,int_stack+786495,int_stack+669675,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+846555,int_stack+452238,int_stack+721155,66);
 /*--- compute (n0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+669675,int_stack+846555,int_stack+376008,66);
 /*--- compute (n0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+348090,int_stack+96591,int_stack+87615,66);
 /*--- compute (n0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+375018,int_stack+348090,int_stack+282750,66);
 /*--- compute (n0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+938031,int_stack+375018,int_stack+306510,66);
 /*--- compute (n0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+0,int_stack+938031,int_stack+786495,66);
 /*--- compute (n0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1007331,int_stack+0,int_stack+452238,66);
 /*--- compute (n0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1115439,int_stack+1007331,int_stack+846555,66);
 /*--- compute (n0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+771315,int_stack+1115439,int_stack+669675,66);
 /*--- compute (n0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+669675,int_stack+106689,int_stack+96591,66);
 /*--- compute (n0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+699969,int_stack+669675,int_stack+348090,66);
 /*--- compute (n0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+282750,int_stack+699969,int_stack+375018,66);
 /*--- compute (n0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+361950,int_stack+282750,int_stack+938031,66);
 /*--- compute (n0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1237407,int_stack+361950,int_stack+0,66);
 /*--- compute (n0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+282750,int_stack+1237407,int_stack+1007331,66);
 /*--- compute (n0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+901995,int_stack+282750,int_stack+1115439,66);
 /*--- compute (n0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+282750,int_stack+901995,int_stack+771315,66);
 /*--- compute (mp|ml) ---*/
 hrr1_build_mp(Libint->AB,int_stack+669675,int_stack+282750,int_stack+533550,2475);
 /*--- compute (o0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+446100,int_stack+122265,int_stack+117975,78);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+458970,int_stack+127413,int_stack+122265,78);
 /*--- compute (o0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+474414,int_stack+458970,int_stack+446100,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+500154,int_stack+133497,int_stack+127413,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+518406,int_stack+500154,int_stack+458970,78);
 /*--- compute (o0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+549294,int_stack+518406,int_stack+474414,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+446100,int_stack+140595,int_stack+133497,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+592194,int_stack+446100,int_stack+500154,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+0,int_stack+592194,int_stack+518406,78);
 /*--- compute (o0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+467394,int_stack+0,int_stack+549294,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+531744,int_stack+148785,int_stack+140595,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+51480,int_stack+531744,int_stack+446100,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1078050,int_stack+51480,int_stack+592194,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+556314,int_stack+1078050,int_stack+0,78);
 /*--- compute (o0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+1138890,int_stack+556314,int_stack+467394,78);
 /*--- compute (o0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+0,int_stack+158145,int_stack+148785,78);
 /*--- compute (o0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+446100,int_stack+0,int_stack+531744,78);
 /*--- compute (o0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1228980,int_stack+446100,int_stack+51480,78);
 /*--- compute (o0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+28080,int_stack+1228980,int_stack+1078050,78);
 /*--- compute (o0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1299960,int_stack+28080,int_stack+556314,78);
 /*--- compute (o0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+495240,int_stack+1299960,int_stack+1138890,78);
 /*--- compute (o0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+1078050,int_stack+168753,int_stack+158145,78);
 /*--- compute (o0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1109874,int_stack+1078050,int_stack+0,78);
 /*--- compute (o0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1408068,int_stack+1109874,int_stack+446100,78);
 /*--- compute (o0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1489968,int_stack+1408068,int_stack+1228980,78);
 /*--- compute (o0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1166034,int_stack+1489968,int_stack+28080,78);
 /*--- compute (o0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+0,int_stack+1166034,int_stack+1299960,78);
 /*--- compute (o0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+1596438,int_stack+0,int_stack+495240,78);
 /*--- compute (o0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+446100,int_stack+180687,int_stack+168753,78);
 /*--- compute (o0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+481902,int_stack+446100,int_stack+1078050,78);
 /*--- compute (o0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+545550,int_stack+481902,int_stack+1109874,78);
 /*--- compute (o0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1750878,int_stack+545550,int_stack+1408068,78);
 /*--- compute (o0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+446100,int_stack+1750878,int_stack+1489968,78);
 /*--- compute (o0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1293798,int_stack+446100,int_stack+1166034,78);
 /*--- compute (o0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+446100,int_stack+1293798,int_stack+0,78);
 /*--- compute (o0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+0,int_stack+446100,int_stack+1596438,78);
 /*--- compute (np|ml) ---*/
 hrr1_build_np(Libint->AB,int_stack+1078050,int_stack+0,int_stack+282750,2475);
 /*--- compute (md|ml) ---*/
 hrr1_build_md(Libint->AB,int_stack+1568100,int_stack+1078050,int_stack+669675,2475);
 /*--- compute (q0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+282750,int_stack+199030,int_stack+194025,91);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+297765,int_stack+205036,int_stack+199030,91);
 /*--- compute (q0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+315783,int_stack+297765,int_stack+282750,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+345813,int_stack+212134,int_stack+205036,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+367107,int_stack+345813,int_stack+297765,91);
 /*--- compute (q0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+403143,int_stack+367107,int_stack+315783,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+282750,int_stack+220415,int_stack+212134,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+453193,int_stack+282750,int_stack+345813,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+495781,int_stack+453193,int_stack+367107,91);
 /*--- compute (q0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+307593,int_stack+495781,int_stack+403143,91);
 /*--- compute (q0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+382668,int_stack+229970,int_stack+220415,91);
 /*--- compute (q0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+555841,int_stack+382668,int_stack+282750,91);
 /*--- compute (q0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+605527,int_stack+555841,int_stack+453193,91);
 /*--- compute (q0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+676507,int_stack+605527,int_stack+495781,91);
 /*--- compute (q0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+411333,int_stack+676507,int_stack+307593,91);
 /*--- compute (q0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+282750,int_stack+240890,int_stack+229970,91);
 /*--- compute (q0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+315510,int_stack+282750,int_stack+382668,91);
 /*--- compute (q0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+766597,int_stack+315510,int_stack+555841,91);
 /*--- compute (q0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+849407,int_stack+766597,int_stack+605527,91);
 /*--- compute (q0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+516438,int_stack+849407,int_stack+676507,91);
 /*--- compute (q0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+2384850,int_stack+516438,int_stack+411333,91);
 /*--- compute (q0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+372840,int_stack+253266,int_stack+240890,91);
 /*--- compute (q0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+409968,int_stack+372840,int_stack+282750,91);
 /*--- compute (q0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+642564,int_stack+409968,int_stack+315510,91);
 /*--- compute (q0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+2524990,int_stack+642564,int_stack+766597,91);
 /*--- compute (q0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+2649205,int_stack+2524990,int_stack+849407,91);
 /*--- compute (q0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+738114,int_stack+2649205,int_stack+516438,91);
 /*--- compute (q0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+2798263,int_stack+738114,int_stack+2384850,91);
 /*--- compute (q0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+2384850,int_stack+267189,int_stack+253266,91);
 /*--- compute (q0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+2426619,int_stack+2384850,int_stack+372840,91);
 /*--- compute (q0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+475488,int_stack+2426619,int_stack+409968,91);
 /*--- compute (q0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+906282,int_stack+475488,int_stack+642564,91);
 /*--- compute (q0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+193050,int_stack+906282,int_stack+2524990,91);
 /*--- compute (q0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+2384850,int_stack+193050,int_stack+2649205,91);
 /*--- compute (q0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+193050,int_stack+2384850,int_stack+738114,91);
 /*--- compute (q0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+2384850,int_stack+193050,int_stack+2798263,91);
 /*--- compute (op|ml) ---*/
 hrr1_build_op(Libint->AB,int_stack+193050,int_stack+2384850,int_stack+0,2475);
 /*--- compute (nd|ml) ---*/
 hrr1_build_nd(Libint->AB,int_stack+2384850,int_stack+193050,int_stack+1078050,2475);
 /*--- compute (mf|ml) ---*/
 hrr1_build_mf(Libint->AB,int_stack+0,int_stack+2384850,int_stack+1568100,2475);
 return int_stack+0;}
