/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_mgkk(Libint_t*, prim_data*);

  /* Computes quartets of (mg|kk) integrals */

REALTYPE *hrr_order_mgkk(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[9][7] = int_stack + 0;
 Libint->vrr_classes[9][8] = int_stack + 1980;
 Libint->vrr_classes[9][9] = int_stack + 4455;
 Libint->vrr_classes[9][10] = int_stack + 7480;
 Libint->vrr_classes[9][11] = int_stack + 11110;
 Libint->vrr_classes[9][12] = int_stack + 15400;
 Libint->vrr_classes[9][13] = int_stack + 20405;
 Libint->vrr_classes[9][14] = int_stack + 26180;
 Libint->vrr_classes[10][7] = int_stack + 32780;
 Libint->vrr_classes[10][8] = int_stack + 35156;
 Libint->vrr_classes[10][9] = int_stack + 38126;
 Libint->vrr_classes[10][10] = int_stack + 41756;
 Libint->vrr_classes[10][11] = int_stack + 46112;
 Libint->vrr_classes[10][12] = int_stack + 51260;
 Libint->vrr_classes[10][13] = int_stack + 57266;
 Libint->vrr_classes[10][14] = int_stack + 64196;
 Libint->vrr_classes[11][7] = int_stack + 72116;
 Libint->vrr_classes[11][8] = int_stack + 74924;
 Libint->vrr_classes[11][9] = int_stack + 78434;
 Libint->vrr_classes[11][10] = int_stack + 82724;
 Libint->vrr_classes[11][11] = int_stack + 87872;
 Libint->vrr_classes[11][12] = int_stack + 93956;
 Libint->vrr_classes[11][13] = int_stack + 101054;
 Libint->vrr_classes[11][14] = int_stack + 109244;
 Libint->vrr_classes[12][7] = int_stack + 118604;
 Libint->vrr_classes[12][8] = int_stack + 121880;
 Libint->vrr_classes[12][9] = int_stack + 125975;
 Libint->vrr_classes[12][10] = int_stack + 130980;
 Libint->vrr_classes[12][11] = int_stack + 136986;
 Libint->vrr_classes[12][12] = int_stack + 144084;
 Libint->vrr_classes[12][13] = int_stack + 152365;
 Libint->vrr_classes[12][14] = int_stack + 161920;
 Libint->vrr_classes[13][7] = int_stack + 172840;
 Libint->vrr_classes[13][8] = int_stack + 176620;
 Libint->vrr_classes[13][9] = int_stack + 181345;
 Libint->vrr_classes[13][10] = int_stack + 187120;
 Libint->vrr_classes[13][11] = int_stack + 194050;
 Libint->vrr_classes[13][12] = int_stack + 202240;
 Libint->vrr_classes[13][13] = int_stack + 211795;
 Libint->vrr_classes[13][14] = int_stack + 222820;
 memset(int_stack,0,235420*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 235420;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_mgkk(Libint, Data);
   Data++;
 }
 /*--- compute (m0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+235420,int_stack+1980,int_stack+0,55);
 /*--- compute (m0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+241360,int_stack+4455,int_stack+1980,55);
 /*--- compute (m0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+248785,int_stack+241360,int_stack+235420,55);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+260665,int_stack+7480,int_stack+4455,55);
 /*--- compute (m0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+269740,int_stack+260665,int_stack+241360,55);
 /*--- compute (m0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+284590,int_stack+269740,int_stack+248785,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+235420,int_stack+11110,int_stack+7480,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+304390,int_stack+235420,int_stack+260665,55);
 /*--- compute (m0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+322540,int_stack+304390,int_stack+269740,55);
 /*--- compute (m0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+246310,int_stack+322540,int_stack+284590,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+276010,int_stack+15400,int_stack+11110,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+347290,int_stack+276010,int_stack+235420,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+369070,int_stack+347290,int_stack+304390,55);
 /*--- compute (m0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+399320,int_stack+369070,int_stack+322540,55);
 /*--- compute (m0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+288880,int_stack+399320,int_stack+246310,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+235420,int_stack+20405,int_stack+15400,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+436445,int_stack+235420,int_stack+276010,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+250435,int_stack+436445,int_stack+347290,55);
 /*--- compute (m0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+462185,int_stack+250435,int_stack+369070,55);
 /*--- compute (m0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+330460,int_stack+462185,int_stack+399320,55);
 /*--- compute (m0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+507560,int_stack+330460,int_stack+288880,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+286735,int_stack+26180,int_stack+20405,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+382435,int_stack+286735,int_stack+235420,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+286735,int_stack+382435,int_stack+436445,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+382435,int_stack+286735,int_stack+250435,55);
 /*--- compute (m0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+235420,int_stack+382435,int_stack+462185,55);
 /*--- compute (m0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+382435,int_stack+235420,int_stack+330460,55);
 /*--- compute (m0|kk) ---*/
 hrr3_build_kk(Libint->CD,int_stack+235420,int_stack+382435,int_stack+507560,55);
 /*--- compute (n0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+306700,int_stack+35156,int_stack+32780,66);
 /*--- compute (n0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+313828,int_stack+38126,int_stack+35156,66);
 /*--- compute (n0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+322738,int_stack+313828,int_stack+306700,66);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+336994,int_stack+41756,int_stack+38126,66);
 /*--- compute (n0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+347884,int_stack+336994,int_stack+313828,66);
 /*--- compute (n0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+365704,int_stack+347884,int_stack+322738,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+306700,int_stack+46112,int_stack+41756,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+389464,int_stack+306700,int_stack+336994,66);
 /*--- compute (n0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+411244,int_stack+389464,int_stack+347884,66);
 /*--- compute (n0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+319768,int_stack+411244,int_stack+365704,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+355408,int_stack+51260,int_stack+46112,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+440944,int_stack+355408,int_stack+306700,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+467080,int_stack+440944,int_stack+389464,66);
 /*--- compute (n0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+503380,int_stack+467080,int_stack+411244,66);
 /*--- compute (n0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+370852,int_stack+503380,int_stack+319768,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+306700,int_stack+57266,int_stack+51260,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+0,int_stack+306700,int_stack+355408,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+324718,int_stack+0,int_stack+440944,66);
 /*--- compute (n0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+547930,int_stack+324718,int_stack+467080,66);
 /*--- compute (n0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+420748,int_stack+547930,int_stack+503380,66);
 /*--- compute (n0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+602380,int_stack+420748,int_stack+370852,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+368278,int_stack+64196,int_stack+57266,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+483118,int_stack+368278,int_stack+306700,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+368278,int_stack+483118,int_stack+0,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+0,int_stack+368278,int_stack+324718,66);
 /*--- compute (n0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+306700,int_stack+0,int_stack+547930,66);
 /*--- compute (n0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+483118,int_stack+306700,int_stack+420748,66);
 /*--- compute (n0|kk) ---*/
 hrr3_build_kk(Libint->CD,int_stack+306700,int_stack+483118,int_stack+602380,66);
 /*--- compute (mp|kk) ---*/
 hrr1_build_mp(Libint->AB,int_stack+392236,int_stack+306700,int_stack+235420,1296);
 /*--- compute (o0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+235420,int_stack+74924,int_stack+72116,78);
 /*--- compute (o0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+243844,int_stack+78434,int_stack+74924,78);
 /*--- compute (o0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+254374,int_stack+243844,int_stack+235420,78);
 /*--- compute (o0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+271222,int_stack+82724,int_stack+78434,78);
 /*--- compute (o0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+284092,int_stack+271222,int_stack+243844,78);
 /*--- compute (o0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+606076,int_stack+284092,int_stack+254374,78);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+235420,int_stack+87872,int_stack+82724,78);
 /*--- compute (o0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+634156,int_stack+235420,int_stack+271222,78);
 /*--- compute (o0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+0,int_stack+634156,int_stack+284092,78);
 /*--- compute (o0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+250864,int_stack+0,int_stack+606076,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+606076,int_stack+93956,int_stack+87872,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+35100,int_stack+606076,int_stack+235420,78);
 /*--- compute (o0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+659896,int_stack+35100,int_stack+634156,78);
 /*--- compute (o0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+702796,int_stack+659896,int_stack+0,78);
 /*--- compute (o0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+755446,int_stack+702796,int_stack+250864,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+101054,int_stack+93956,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+235420,int_stack+0,int_stack+606076,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+606076,int_stack+235420,int_stack+35100,78);
 /*--- compute (o0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+21294,int_stack+606076,int_stack+659896,78);
 /*--- compute (o0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+814414,int_stack+21294,int_stack+702796,78);
 /*--- compute (o0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+657556,int_stack+814414,int_stack+755446,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+736180,int_stack+109244,int_stack+101054,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+760750,int_stack+736180,int_stack+0,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+888124,int_stack+760750,int_stack+235420,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+736180,int_stack+888124,int_stack+606076,78);
 /*--- compute (o0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+888124,int_stack+736180,int_stack+21294,78);
 /*--- compute (o0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+0,int_stack+888124,int_stack+814414,78);
 /*--- compute (o0|kk) ---*/
 hrr3_build_kk(Libint->CD,int_stack+736180,int_stack+0,int_stack+657556,78);
 /*--- compute (np|kk) ---*/
 hrr1_build_np(Libint->AB,int_stack+837268,int_stack+736180,int_stack+306700,1296);
 /*--- compute (md|kk) ---*/
 hrr1_build_md(Libint->AB,int_stack+1093876,int_stack+837268,int_stack+392236,1296);
 /*--- compute (q0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+0,int_stack+121880,int_stack+118604,91);
 /*--- compute (q0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+9828,int_stack+125975,int_stack+121880,91);
 /*--- compute (q0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+22113,int_stack+9828,int_stack+0,91);
 /*--- compute (q0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+41769,int_stack+130980,int_stack+125975,91);
 /*--- compute (q0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+56784,int_stack+41769,int_stack+9828,91);
 /*--- compute (q0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+81354,int_stack+56784,int_stack+22113,91);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+136986,int_stack+130980,91);
 /*--- compute (q0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+235420,int_stack+0,int_stack+41769,91);
 /*--- compute (q0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+265450,int_stack+235420,int_stack+56784,91);
 /*--- compute (q0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+18018,int_stack+265450,int_stack+81354,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+67158,int_stack+144084,int_stack+136986,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+88452,int_stack+67158,int_stack+0,91);
 /*--- compute (q0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+306400,int_stack+88452,int_stack+235420,91);
 /*--- compute (q0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+356450,int_stack+306400,int_stack+265450,91);
 /*--- compute (q0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+235420,int_stack+356450,int_stack+18018,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+152365,int_stack+144084,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+417875,int_stack+0,int_stack+67158,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+24843,int_stack+417875,int_stack+88452,91);
 /*--- compute (q0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+460463,int_stack+24843,int_stack+306400,91);
 /*--- compute (q0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+535538,int_stack+460463,int_stack+356450,91);
 /*--- compute (q0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+304216,int_stack+535538,int_stack+235420,91);
 /*--- compute (q0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+235420,int_stack+161920,int_stack+152365,91);
 /*--- compute (q0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+84903,int_stack+235420,int_stack+0,91);
 /*--- compute (q0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+621533,int_stack+84903,int_stack+417875,91);
 /*--- compute (q0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1521556,int_stack+621533,int_stack+24843,91);
 /*--- compute (q0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+621533,int_stack+1521556,int_stack+460463,91);
 /*--- compute (q0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+0,int_stack+621533,int_stack+535538,91);
 /*--- compute (q0|kk) ---*/
 hrr3_build_kk(Libint->CD,int_stack+395944,int_stack+0,int_stack+304216,91);
 /*--- compute (op|kk) ---*/
 hrr1_build_op(Libint->AB,int_stack+1521556,int_stack+395944,int_stack+736180,1296);
 /*--- compute (nd|kk) ---*/
 hrr1_build_nd(Libint->AB,int_stack+1824820,int_stack+1521556,int_stack+837268,1296);
 /*--- compute (mf|kk) ---*/
 hrr1_build_mf(Libint->AB,int_stack+2338036,int_stack+1824820,int_stack+1093876,1296);
 /*--- compute (r0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+0,int_stack+176620,int_stack+172840,105);
 /*--- compute (r0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+11340,int_stack+181345,int_stack+176620,105);
 /*--- compute (r0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+25515,int_stack+11340,int_stack+0,105);
 /*--- compute (r0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+48195,int_stack+187120,int_stack+181345,105);
 /*--- compute (r0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+65520,int_stack+48195,int_stack+11340,105);
 /*--- compute (r0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+93870,int_stack+65520,int_stack+25515,105);
 /*--- compute (r0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+194050,int_stack+187120,105);
 /*--- compute (r0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+131670,int_stack+0,int_stack+48195,105);
 /*--- compute (r0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+235420,int_stack+131670,int_stack+65520,105);
 /*--- compute (r0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+20790,int_stack+235420,int_stack+93870,105);
 /*--- compute (r0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+77490,int_stack+202240,int_stack+194050,105);
 /*--- compute (r0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+282670,int_stack+77490,int_stack+0,105);
 /*--- compute (r0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+324250,int_stack+282670,int_stack+131670,105);
 /*--- compute (r0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+102060,int_stack+324250,int_stack+235420,105);
 /*--- compute (r0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+513880,int_stack+102060,int_stack+20790,105);
 /*--- compute (r0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+235420,int_stack+211795,int_stack+202240,105);
 /*--- compute (r0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+0,int_stack+235420,int_stack+77490,105);
 /*--- compute (r0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+593260,int_stack+0,int_stack+282670,105);
 /*--- compute (r0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+662560,int_stack+593260,int_stack+324250,105);
 /*--- compute (r0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+264085,int_stack+662560,int_stack+102060,105);
 /*--- compute (r0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+49140,int_stack+264085,int_stack+513880,105);
 /*--- compute (r0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+513880,int_stack+222820,int_stack+211795,105);
 /*--- compute (r0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+154980,int_stack+513880,int_stack+235420,105);
 /*--- compute (r0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+749185,int_stack+154980,int_stack+0,105);
 /*--- compute (r0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+154980,int_stack+749185,int_stack+593260,105);
 /*--- compute (r0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+749185,int_stack+154980,int_stack+662560,105);
 /*--- compute (r0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+870460,int_stack+749185,int_stack+264085,105);
 /*--- compute (r0|kk) ---*/
 hrr3_build_kk(Libint->CD,int_stack+154980,int_stack+870460,int_stack+49140,105);
 /*--- compute (qp|kk) ---*/
 hrr1_build_qp(Libint->AB,int_stack+513880,int_stack+154980,int_stack+395944,1296);
 /*--- compute (od|kk) ---*/
 hrr1_build_od(Libint->AB,int_stack+867688,int_stack+513880,int_stack+1521556,1296);
 /*--- compute (nf|kk) ---*/
 hrr1_build_nf(Libint->AB,int_stack+0,int_stack+867688,int_stack+1824820,1296);
 /*--- compute (mg|kk) ---*/
 hrr1_build_mg(Libint->AB,int_stack+855360,int_stack+0,int_stack+2338036,1296);
 return int_stack+855360;}
