/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_mgmg(Libint_t*, prim_data*);

  /* Computes quartets of (mg|mg) integrals */

REALTYPE *hrr_order_mgmg(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[9][9] = int_stack + 0;
 Libint->vrr_classes[9][10] = int_stack + 3025;
 Libint->vrr_classes[9][11] = int_stack + 6655;
 Libint->vrr_classes[9][12] = int_stack + 10945;
 Libint->vrr_classes[9][13] = int_stack + 15950;
 Libint->vrr_classes[10][9] = int_stack + 21725;
 Libint->vrr_classes[10][10] = int_stack + 25355;
 Libint->vrr_classes[10][11] = int_stack + 29711;
 Libint->vrr_classes[10][12] = int_stack + 34859;
 Libint->vrr_classes[10][13] = int_stack + 40865;
 Libint->vrr_classes[11][9] = int_stack + 47795;
 Libint->vrr_classes[11][10] = int_stack + 52085;
 Libint->vrr_classes[11][11] = int_stack + 57233;
 Libint->vrr_classes[11][12] = int_stack + 63317;
 Libint->vrr_classes[11][13] = int_stack + 70415;
 Libint->vrr_classes[12][9] = int_stack + 78605;
 Libint->vrr_classes[12][10] = int_stack + 83610;
 Libint->vrr_classes[12][11] = int_stack + 89616;
 Libint->vrr_classes[12][12] = int_stack + 96714;
 Libint->vrr_classes[12][13] = int_stack + 104995;
 Libint->vrr_classes[13][9] = int_stack + 114550;
 Libint->vrr_classes[13][10] = int_stack + 120325;
 Libint->vrr_classes[13][11] = int_stack + 127255;
 Libint->vrr_classes[13][12] = int_stack + 135445;
 Libint->vrr_classes[13][13] = int_stack + 145000;
 memset(int_stack,0,156025*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 156025;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_mgmg(Libint, Data);
   Data++;
 }
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+156025,int_stack+3025,int_stack+0,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+165100,int_stack+6655,int_stack+3025,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+175990,int_stack+165100,int_stack+156025,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+194140,int_stack+10945,int_stack+6655,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+207010,int_stack+194140,int_stack+165100,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+228790,int_stack+207010,int_stack+175990,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+156025,int_stack+15950,int_stack+10945,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+259040,int_stack+156025,int_stack+194140,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+156025,int_stack+259040,int_stack+207010,55);
 /*--- compute (m0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+259040,int_stack+156025,int_stack+228790,55);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+156025,int_stack+25355,int_stack+21725,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+166915,int_stack+29711,int_stack+25355,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+179983,int_stack+166915,int_stack+156025,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+201763,int_stack+34859,int_stack+29711,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+217207,int_stack+201763,int_stack+166915,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+304415,int_stack+217207,int_stack+179983,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+156025,int_stack+40865,int_stack+34859,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+0,int_stack+156025,int_stack+201763,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+156025,int_stack+0,int_stack+217207,66);
 /*--- compute (n0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+199585,int_stack+156025,int_stack+304415,66);
 /*--- compute (mp|mg) ---*/
 hrr1_build_mp(Libint->AB,int_stack+304415,int_stack+199585,int_stack+259040,825);
 /*--- compute (o0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+156025,int_stack+52085,int_stack+47795,78);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+168895,int_stack+57233,int_stack+52085,78);
 /*--- compute (o0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+0,int_stack+168895,int_stack+156025,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+25740,int_stack+63317,int_stack+57233,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+254035,int_stack+25740,int_stack+168895,78);
 /*--- compute (o0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+156025,int_stack+254035,int_stack+0,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+70415,int_stack+63317,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+440540,int_stack+0,int_stack+25740,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+0,int_stack+440540,int_stack+254035,78);
 /*--- compute (o0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+440540,int_stack+0,int_stack+156025,78);
 /*--- compute (np|mg) ---*/
 hrr1_build_np(Libint->AB,int_stack+504890,int_stack+440540,int_stack+199585,825);
 /*--- compute (md|mg) ---*/
 hrr1_build_md(Libint->AB,int_stack+668240,int_stack+504890,int_stack+304415,825);
 /*--- compute (q0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+156025,int_stack+83610,int_stack+78605,91);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+171040,int_stack+89616,int_stack+83610,91);
 /*--- compute (q0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+189058,int_stack+171040,int_stack+156025,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+219088,int_stack+96714,int_stack+89616,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+240382,int_stack+219088,int_stack+171040,91);
 /*--- compute (q0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+276418,int_stack+240382,int_stack+189058,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+156025,int_stack+104995,int_stack+96714,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+326468,int_stack+156025,int_stack+219088,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+156025,int_stack+326468,int_stack+240382,91);
 /*--- compute (q0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+326468,int_stack+156025,int_stack+276418,91);
 /*--- compute (op|mg) ---*/
 hrr1_build_op(Libint->AB,int_stack+940490,int_stack+326468,int_stack+440540,825);
 /*--- compute (nd|mg) ---*/
 hrr1_build_nd(Libint->AB,int_stack+1133540,int_stack+940490,int_stack+504890,825);
 /*--- compute (mf|mg) ---*/
 hrr1_build_mf(Libint->AB,int_stack+1460240,int_stack+1133540,int_stack+668240,825);
 /*--- compute (r0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+156025,int_stack+120325,int_stack+114550,105);
 /*--- compute (r0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+173350,int_stack+127255,int_stack+120325,105);
 /*--- compute (r0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+194140,int_stack+173350,int_stack+156025,105);
 /*--- compute (r0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+228790,int_stack+135445,int_stack+127255,105);
 /*--- compute (r0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+253360,int_stack+228790,int_stack+173350,105);
 /*--- compute (r0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+401543,int_stack+253360,int_stack+194140,105);
 /*--- compute (r0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+156025,int_stack+145000,int_stack+135445,105);
 /*--- compute (r0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+459293,int_stack+156025,int_stack+228790,105);
 /*--- compute (r0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+508433,int_stack+459293,int_stack+253360,105);
 /*--- compute (r0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+577733,int_stack+508433,int_stack+401543,105);
 /*--- compute (qp|mg) ---*/
 hrr1_build_qp(Libint->AB,int_stack+664358,int_stack+577733,int_stack+326468,825);
 /*--- compute (od|mg) ---*/
 hrr1_build_od(Libint->AB,int_stack+0,int_stack+664358,int_stack+940490,825);
 /*--- compute (nf|mg) ---*/
 hrr1_build_nf(Libint->AB,int_stack+386100,int_stack+0,int_stack+1133540,825);
 /*--- compute (mg|mg) ---*/
 hrr1_build_mg(Libint->AB,int_stack+1913990,int_stack+386100,int_stack+1460240,825);
 return int_stack+1913990;}
