/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_mpkh(Libint_t*, prim_data*);

  /* Computes quartets of (mp|kh) integrals */

REALTYPE *hrr_order_mpkh(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[9][7] = int_stack + 0;
 Libint->vrr_classes[9][8] = int_stack + 1980;
 Libint->vrr_classes[9][9] = int_stack + 4455;
 Libint->vrr_classes[9][10] = int_stack + 7480;
 Libint->vrr_classes[9][11] = int_stack + 11110;
 Libint->vrr_classes[9][12] = int_stack + 15400;
 Libint->vrr_classes[10][7] = int_stack + 20405;
 Libint->vrr_classes[10][8] = int_stack + 22781;
 Libint->vrr_classes[10][9] = int_stack + 25751;
 Libint->vrr_classes[10][10] = int_stack + 29381;
 Libint->vrr_classes[10][11] = int_stack + 33737;
 Libint->vrr_classes[10][12] = int_stack + 38885;
 memset(int_stack,0,44891*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 44891;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_mpkh(Libint, Data);
   Data++;
 }
 /*--- compute (m0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+44891,int_stack+1980,int_stack+0,55);
 /*--- compute (m0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+50831,int_stack+4455,int_stack+1980,55);
 /*--- compute (m0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+58256,int_stack+50831,int_stack+44891,55);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+70136,int_stack+7480,int_stack+4455,55);
 /*--- compute (m0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+79211,int_stack+70136,int_stack+50831,55);
 /*--- compute (m0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+94061,int_stack+79211,int_stack+58256,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+44891,int_stack+11110,int_stack+7480,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+113861,int_stack+44891,int_stack+70136,55);
 /*--- compute (m0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+132011,int_stack+113861,int_stack+79211,55);
 /*--- compute (m0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+55781,int_stack+132011,int_stack+94061,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+85481,int_stack+15400,int_stack+11110,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+156761,int_stack+85481,int_stack+44891,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+178541,int_stack+156761,int_stack+113861,55);
 /*--- compute (m0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+85481,int_stack+178541,int_stack+132011,55);
 /*--- compute (m0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+122606,int_stack+85481,int_stack+55781,55);
 /*--- compute (n0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+44891,int_stack+22781,int_stack+20405,66);
 /*--- compute (n0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+52019,int_stack+25751,int_stack+22781,66);
 /*--- compute (n0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+60929,int_stack+52019,int_stack+44891,66);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+75185,int_stack+29381,int_stack+25751,66);
 /*--- compute (n0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+86075,int_stack+75185,int_stack+52019,66);
 /*--- compute (n0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+164186,int_stack+86075,int_stack+60929,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+44891,int_stack+33737,int_stack+29381,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+0,int_stack+44891,int_stack+75185,66);
 /*--- compute (n0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+187946,int_stack+0,int_stack+86075,66);
 /*--- compute (n0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+57959,int_stack+187946,int_stack+164186,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+164186,int_stack+38885,int_stack+33737,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+93599,int_stack+164186,int_stack+44891,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+217646,int_stack+93599,int_stack+0,66);
 /*--- compute (n0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+0,int_stack+217646,int_stack+187946,66);
 /*--- compute (n0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+164186,int_stack+0,int_stack+57959,66);
 /*--- compute (mp|kh) ---*/
 hrr1_build_mp(Libint->AB,int_stack+214082,int_stack+164186,int_stack+122606,756);
 return int_stack+214082;}
