/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_mpng(Libint_t*, prim_data*);

  /* Computes quartets of (mp|ng) integrals */

REALTYPE *hrr_order_mpng(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[9][10] = int_stack + 0;
 Libint->vrr_classes[9][11] = int_stack + 3630;
 Libint->vrr_classes[9][12] = int_stack + 7920;
 Libint->vrr_classes[9][13] = int_stack + 12925;
 Libint->vrr_classes[9][14] = int_stack + 18700;
 Libint->vrr_classes[10][10] = int_stack + 25300;
 Libint->vrr_classes[10][11] = int_stack + 29656;
 Libint->vrr_classes[10][12] = int_stack + 34804;
 Libint->vrr_classes[10][13] = int_stack + 40810;
 Libint->vrr_classes[10][14] = int_stack + 47740;
 memset(int_stack,0,55660*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 55660;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_mpng(Libint, Data);
   Data++;
 }
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+55660,int_stack+3630,int_stack+0,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+66550,int_stack+7920,int_stack+3630,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+79420,int_stack+66550,int_stack+55660,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+101200,int_stack+12925,int_stack+7920,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+116215,int_stack+101200,int_stack+66550,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+141955,int_stack+116215,int_stack+79420,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+55660,int_stack+18700,int_stack+12925,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+178255,int_stack+55660,int_stack+101200,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+55660,int_stack+178255,int_stack+116215,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+178255,int_stack+55660,int_stack+141955,55);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+55660,int_stack+29656,int_stack+25300,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+68728,int_stack+34804,int_stack+29656,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+84172,int_stack+68728,int_stack+55660,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+110308,int_stack+40810,int_stack+34804,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+128326,int_stack+110308,int_stack+68728,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+232705,int_stack+128326,int_stack+84172,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+55660,int_stack+47740,int_stack+40810,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+0,int_stack+55660,int_stack+110308,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+36036,int_stack+0,int_stack+128326,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+87516,int_stack+36036,int_stack+232705,66);
 /*--- compute (mp|ng) ---*/
 hrr1_build_mp(Libint->AB,int_stack+232705,int_stack+87516,int_stack+178255,990);
 return int_stack+232705;}
