/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_n0ii(Libint_t*, prim_data*);

  /* Computes quartets of (n0|ii) integrals */

REALTYPE *hrr_order_n0ii(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[10][6] = int_stack + 0;
 Libint->vrr_classes[10][7] = int_stack + 1848;
 Libint->vrr_classes[10][8] = int_stack + 4224;
 Libint->vrr_classes[10][9] = int_stack + 7194;
 Libint->vrr_classes[10][10] = int_stack + 10824;
 Libint->vrr_classes[10][11] = int_stack + 15180;
 Libint->vrr_classes[10][12] = int_stack + 20328;
 memset(int_stack,0,26334*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 26334;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_n0ii(Libint, Data);
   Data++;
 }
 /*--- compute (n0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+26334,int_stack+1848,int_stack+0,66);
 /*--- compute (n0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+31878,int_stack+4224,int_stack+1848,66);
 /*--- compute (n0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+39006,int_stack+31878,int_stack+26334,66);
 /*--- compute (n0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+50094,int_stack+7194,int_stack+4224,66);
 /*--- compute (n0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+59004,int_stack+50094,int_stack+31878,66);
 /*--- compute (n0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+73260,int_stack+59004,int_stack+39006,66);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+26334,int_stack+10824,int_stack+7194,66);
 /*--- compute (n0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+91740,int_stack+26334,int_stack+50094,66);
 /*--- compute (n0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+109560,int_stack+91740,int_stack+59004,66);
 /*--- compute (n0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+37224,int_stack+109560,int_stack+73260,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+64944,int_stack+15180,int_stack+10824,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+133320,int_stack+64944,int_stack+26334,66);
 /*--- compute (n0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+155100,int_stack+133320,int_stack+91740,66);
 /*--- compute (n0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+184800,int_stack+155100,int_stack+109560,66);
 /*--- compute (n0|ih) ---*/
 hrr3_build_ih(Libint->CD,int_stack+78012,int_stack+184800,int_stack+37224,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+26334,int_stack+20328,int_stack+15180,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+0,int_stack+26334,int_stack+64944,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+26136,int_stack+0,int_stack+133320,66);
 /*--- compute (n0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+220440,int_stack+26136,int_stack+155100,66);
 /*--- compute (n0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+0,int_stack+220440,int_stack+184800,66);
 /*--- compute (n0|ii) ---*/
 hrr3_build_ii(Libint->CD,int_stack+116820,int_stack+0,int_stack+78012,66);
 return int_stack+116820;}
