/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_ndii(Libint_t*, prim_data*);

  /* Computes quartets of (nd|ii) integrals */

REALTYPE *hrr_order_ndii(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[10][6] = int_stack + 0;
 Libint->vrr_classes[10][7] = int_stack + 1848;
 Libint->vrr_classes[10][8] = int_stack + 4224;
 Libint->vrr_classes[10][9] = int_stack + 7194;
 Libint->vrr_classes[10][10] = int_stack + 10824;
 Libint->vrr_classes[10][11] = int_stack + 15180;
 Libint->vrr_classes[10][12] = int_stack + 20328;
 Libint->vrr_classes[11][6] = int_stack + 26334;
 Libint->vrr_classes[11][7] = int_stack + 28518;
 Libint->vrr_classes[11][8] = int_stack + 31326;
 Libint->vrr_classes[11][9] = int_stack + 34836;
 Libint->vrr_classes[11][10] = int_stack + 39126;
 Libint->vrr_classes[11][11] = int_stack + 44274;
 Libint->vrr_classes[11][12] = int_stack + 50358;
 Libint->vrr_classes[12][6] = int_stack + 57456;
 Libint->vrr_classes[12][7] = int_stack + 60004;
 Libint->vrr_classes[12][8] = int_stack + 63280;
 Libint->vrr_classes[12][9] = int_stack + 67375;
 Libint->vrr_classes[12][10] = int_stack + 72380;
 Libint->vrr_classes[12][11] = int_stack + 78386;
 Libint->vrr_classes[12][12] = int_stack + 85484;
 memset(int_stack,0,93765*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 93765;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_ndii(Libint, Data);
   Data++;
 }
 /*--- compute (n0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+93765,int_stack+1848,int_stack+0,66);
 /*--- compute (n0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+99309,int_stack+4224,int_stack+1848,66);
 /*--- compute (n0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+106437,int_stack+99309,int_stack+93765,66);
 /*--- compute (n0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+117525,int_stack+7194,int_stack+4224,66);
 /*--- compute (n0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+126435,int_stack+117525,int_stack+99309,66);
 /*--- compute (n0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+140691,int_stack+126435,int_stack+106437,66);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+93765,int_stack+10824,int_stack+7194,66);
 /*--- compute (n0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+159171,int_stack+93765,int_stack+117525,66);
 /*--- compute (n0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+176991,int_stack+159171,int_stack+126435,66);
 /*--- compute (n0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+104655,int_stack+176991,int_stack+140691,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+132375,int_stack+15180,int_stack+10824,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+200751,int_stack+132375,int_stack+93765,66);
 /*--- compute (n0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+222531,int_stack+200751,int_stack+159171,66);
 /*--- compute (n0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+252231,int_stack+222531,int_stack+176991,66);
 /*--- compute (n0|ih) ---*/
 hrr3_build_ih(Libint->CD,int_stack+145443,int_stack+252231,int_stack+104655,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+93765,int_stack+20328,int_stack+15180,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+0,int_stack+93765,int_stack+132375,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+93765,int_stack+0,int_stack+200751,66);
 /*--- compute (n0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+287871,int_stack+93765,int_stack+222531,66);
 /*--- compute (n0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+93765,int_stack+287871,int_stack+252231,66);
 /*--- compute (n0|ii) ---*/
 hrr3_build_ii(Libint->CD,int_stack+184251,int_stack+93765,int_stack+145443,66);
 /*--- compute (o0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+93765,int_stack+28518,int_stack+26334,78);
 /*--- compute (o0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+100317,int_stack+31326,int_stack+28518,78);
 /*--- compute (o0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+108741,int_stack+100317,int_stack+93765,78);
 /*--- compute (o0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+121845,int_stack+34836,int_stack+31326,78);
 /*--- compute (o0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+132375,int_stack+121845,int_stack+100317,78);
 /*--- compute (o0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+149223,int_stack+132375,int_stack+108741,78);
 /*--- compute (o0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+93765,int_stack+39126,int_stack+34836,78);
 /*--- compute (o0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+0,int_stack+93765,int_stack+121845,78);
 /*--- compute (o0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+235995,int_stack+0,int_stack+132375,78);
 /*--- compute (o0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+106635,int_stack+235995,int_stack+149223,78);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+139395,int_stack+44274,int_stack+39126,78);
 /*--- compute (o0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+154839,int_stack+139395,int_stack+93765,78);
 /*--- compute (o0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+264075,int_stack+154839,int_stack+0,78);
 /*--- compute (o0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+0,int_stack+264075,int_stack+235995,78);
 /*--- compute (o0|ih) ---*/
 hrr3_build_ih(Libint->CD,int_stack+299175,int_stack+0,int_stack+106635,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+235995,int_stack+50358,int_stack+44274,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+93765,int_stack+235995,int_stack+139395,78);
 /*--- compute (o0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+345039,int_stack+93765,int_stack+154839,78);
 /*--- compute (o0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+93765,int_stack+345039,int_stack+264075,78);
 /*--- compute (o0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+235995,int_stack+93765,int_stack+0,78);
 /*--- compute (o0|ii) ---*/
 hrr3_build_ii(Libint->CD,int_stack+93765,int_stack+235995,int_stack+299175,78);
 /*--- compute (np|ii) ---*/
 hrr1_build_np(Libint->AB,int_stack+235995,int_stack+93765,int_stack+184251,784);
 /*--- compute (q0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+0,int_stack+60004,int_stack+57456,91);
 /*--- compute (q0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+7644,int_stack+63280,int_stack+60004,91);
 /*--- compute (q0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+17472,int_stack+7644,int_stack+0,91);
 /*--- compute (q0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+32760,int_stack+67375,int_stack+63280,91);
 /*--- compute (q0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+45045,int_stack+32760,int_stack+7644,91);
 /*--- compute (q0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+154917,int_stack+45045,int_stack+17472,91);
 /*--- compute (q0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+0,int_stack+72380,int_stack+67375,91);
 /*--- compute (q0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+180397,int_stack+0,int_stack+32760,91);
 /*--- compute (q0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+391227,int_stack+180397,int_stack+45045,91);
 /*--- compute (q0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+15015,int_stack+391227,int_stack+154917,91);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+154917,int_stack+78386,int_stack+72380,91);
 /*--- compute (q0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+204967,int_stack+154917,int_stack+0,91);
 /*--- compute (q0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+423987,int_stack+204967,int_stack+180397,91);
 /*--- compute (q0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+464937,int_stack+423987,int_stack+391227,91);
 /*--- compute (q0|ih) ---*/
 hrr3_build_ih(Libint->CD,int_stack+514077,int_stack+464937,int_stack+15015,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+391227,int_stack+85484,int_stack+78386,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+0,int_stack+391227,int_stack+154917,91);
 /*--- compute (q0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+154917,int_stack+0,int_stack+204967,91);
 /*--- compute (q0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+0,int_stack+154917,int_stack+423987,91);
 /*--- compute (q0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+154917,int_stack+0,int_stack+464937,91);
 /*--- compute (q0|ii) ---*/
 hrr3_build_ii(Libint->CD,int_stack+0,int_stack+154917,int_stack+514077,91);
 /*--- compute (op|ii) ---*/
 hrr1_build_op(Libint->AB,int_stack+391227,int_stack+0,int_stack+93765,784);
 /*--- compute (nd|ii) ---*/
 hrr1_build_nd(Libint->AB,int_stack+574683,int_stack+391227,int_stack+235995,784);
 return int_stack+574683;}
