/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_ndlh(Libint_t*, prim_data*);

  /* Computes quartets of (nd|lh) integrals */

REALTYPE *hrr_order_ndlh(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[10][8] = int_stack + 0;
 Libint->vrr_classes[10][9] = int_stack + 2970;
 Libint->vrr_classes[10][10] = int_stack + 6600;
 Libint->vrr_classes[10][11] = int_stack + 10956;
 Libint->vrr_classes[10][12] = int_stack + 16104;
 Libint->vrr_classes[10][13] = int_stack + 22110;
 Libint->vrr_classes[11][8] = int_stack + 29040;
 Libint->vrr_classes[11][9] = int_stack + 32550;
 Libint->vrr_classes[11][10] = int_stack + 36840;
 Libint->vrr_classes[11][11] = int_stack + 41988;
 Libint->vrr_classes[11][12] = int_stack + 48072;
 Libint->vrr_classes[11][13] = int_stack + 55170;
 Libint->vrr_classes[12][8] = int_stack + 63360;
 Libint->vrr_classes[12][9] = int_stack + 67455;
 Libint->vrr_classes[12][10] = int_stack + 72460;
 Libint->vrr_classes[12][11] = int_stack + 78466;
 Libint->vrr_classes[12][12] = int_stack + 85564;
 Libint->vrr_classes[12][13] = int_stack + 93845;
 memset(int_stack,0,103400*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 103400;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_ndlh(Libint, Data);
   Data++;
 }
 /*--- compute (n0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+103400,int_stack+2970,int_stack+0,66);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+112310,int_stack+6600,int_stack+2970,66);
 /*--- compute (n0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+123200,int_stack+112310,int_stack+103400,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+141020,int_stack+10956,int_stack+6600,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+154088,int_stack+141020,int_stack+112310,66);
 /*--- compute (n0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+175868,int_stack+154088,int_stack+123200,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+103400,int_stack+16104,int_stack+10956,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+205568,int_stack+103400,int_stack+141020,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+231704,int_stack+205568,int_stack+154088,66);
 /*--- compute (n0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+118844,int_stack+231704,int_stack+175868,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+163394,int_stack+22110,int_stack+16104,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+268004,int_stack+163394,int_stack+103400,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+298892,int_stack+268004,int_stack+205568,66);
 /*--- compute (n0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+163394,int_stack+298892,int_stack+231704,66);
 /*--- compute (n0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+217844,int_stack+163394,int_stack+118844,66);
 /*--- compute (o0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+103400,int_stack+32550,int_stack+29040,78);
 /*--- compute (o0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+113930,int_stack+36840,int_stack+32550,78);
 /*--- compute (o0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+126800,int_stack+113930,int_stack+103400,78);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+147860,int_stack+41988,int_stack+36840,78);
 /*--- compute (o0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+163304,int_stack+147860,int_stack+113930,78);
 /*--- compute (o0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+280214,int_stack+163304,int_stack+126800,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+103400,int_stack+48072,int_stack+41988,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+0,int_stack+103400,int_stack+147860,78);
 /*--- compute (o0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+315314,int_stack+0,int_stack+163304,78);
 /*--- compute (o0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+121652,int_stack+315314,int_stack+280214,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+280214,int_stack+55170,int_stack+48072,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+174302,int_stack+280214,int_stack+103400,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+358214,int_stack+174302,int_stack+0,78);
 /*--- compute (o0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+409694,int_stack+358214,int_stack+315314,78);
 /*--- compute (o0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+280214,int_stack+409694,int_stack+121652,78);
 /*--- compute (np|lh) ---*/
 hrr1_build_np(Libint->AB,int_stack+353924,int_stack+280214,int_stack+217844,945);
 /*--- compute (q0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+0,int_stack+67455,int_stack+63360,91);
 /*--- compute (q0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+12285,int_stack+72460,int_stack+67455,91);
 /*--- compute (q0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+27300,int_stack+12285,int_stack+0,91);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+51870,int_stack+78466,int_stack+72460,91);
 /*--- compute (q0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+103400,int_stack+51870,int_stack+12285,91);
 /*--- compute (q0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+133430,int_stack+103400,int_stack+27300,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+0,int_stack+85564,int_stack+78466,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+174380,int_stack+0,int_stack+51870,91);
 /*--- compute (q0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+21294,int_stack+174380,int_stack+103400,91);
 /*--- compute (q0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+210416,int_stack+21294,int_stack+133430,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+103400,int_stack+93845,int_stack+85564,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+128243,int_stack+103400,int_stack+0,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+541034,int_stack+128243,int_stack+174380,91);
 /*--- compute (q0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+71344,int_stack+541034,int_stack+21294,91);
 /*--- compute (q0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+541034,int_stack+71344,int_stack+210416,91);
 /*--- compute (op|lh) ---*/
 hrr1_build_op(Libint->AB,int_stack+0,int_stack+541034,int_stack+280214,945);
 /*--- compute (nd|lh) ---*/
 hrr1_build_nd(Libint->AB,int_stack+541034,int_stack+0,int_stack+353924,945);
 return int_stack+541034;}
