/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_ndnh(Libint_t*, prim_data*);

  /* Computes quartets of (nd|nh) integrals */

REALTYPE *hrr_order_ndnh(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[10][10] = int_stack + 0;
 Libint->vrr_classes[10][11] = int_stack + 4356;
 Libint->vrr_classes[10][12] = int_stack + 9504;
 Libint->vrr_classes[10][13] = int_stack + 15510;
 Libint->vrr_classes[10][14] = int_stack + 22440;
 Libint->vrr_classes[10][15] = int_stack + 30360;
 Libint->vrr_classes[11][10] = int_stack + 39336;
 Libint->vrr_classes[11][11] = int_stack + 44484;
 Libint->vrr_classes[11][12] = int_stack + 50568;
 Libint->vrr_classes[11][13] = int_stack + 57666;
 Libint->vrr_classes[11][14] = int_stack + 65856;
 Libint->vrr_classes[11][15] = int_stack + 75216;
 Libint->vrr_classes[12][10] = int_stack + 85824;
 Libint->vrr_classes[12][11] = int_stack + 91830;
 Libint->vrr_classes[12][12] = int_stack + 98928;
 Libint->vrr_classes[12][13] = int_stack + 107209;
 Libint->vrr_classes[12][14] = int_stack + 116764;
 Libint->vrr_classes[12][15] = int_stack + 127684;
 memset(int_stack,0,140060*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 140060;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_ndnh(Libint, Data);
   Data++;
 }
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+140060,int_stack+4356,int_stack+0,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+153128,int_stack+9504,int_stack+4356,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+168572,int_stack+153128,int_stack+140060,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+194708,int_stack+15510,int_stack+9504,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+212726,int_stack+194708,int_stack+153128,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+243614,int_stack+212726,int_stack+168572,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+140060,int_stack+22440,int_stack+15510,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+287174,int_stack+140060,int_stack+194708,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+160850,int_stack+287174,int_stack+212726,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+323210,int_stack+160850,int_stack+243614,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+212330,int_stack+30360,int_stack+22440,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+236090,int_stack+212330,int_stack+140060,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+388550,int_stack+236090,int_stack+287174,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+212330,int_stack+388550,int_stack+160850,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+388550,int_stack+212330,int_stack+323210,66);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+140060,int_stack+44484,int_stack+39336,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+155504,int_stack+50568,int_stack+44484,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+173756,int_stack+155504,int_stack+140060,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+204644,int_stack+57666,int_stack+50568,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+225938,int_stack+204644,int_stack+155504,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+262442,int_stack+225938,int_stack+173756,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+140060,int_stack+65856,int_stack+57666,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+313922,int_stack+140060,int_stack+204644,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+164630,int_stack+313922,int_stack+225938,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+480026,int_stack+164630,int_stack+262442,78);
 /*--- compute (o0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+225470,int_stack+75216,int_stack+65856,78);
 /*--- compute (o0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+253550,int_stack+225470,int_stack+140060,78);
 /*--- compute (o0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+0,int_stack+253550,int_stack+313922,78);
 /*--- compute (o0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+225470,int_stack+0,int_stack+164630,78);
 /*--- compute (o0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+557246,int_stack+225470,int_stack+480026,78);
 /*--- compute (np|nh) ---*/
 hrr1_build_np(Libint->AB,int_stack+665354,int_stack+557246,int_stack+388550,1386);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+91830,int_stack+85824,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+18018,int_stack+98928,int_stack+91830,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+39312,int_stack+18018,int_stack+0,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+140060,int_stack+107209,int_stack+98928,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+164903,int_stack+140060,int_stack+18018,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+207491,int_stack+164903,int_stack+39312,91);
 /*--- compute (q0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+116764,int_stack+107209,91);
 /*--- compute (q0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+28665,int_stack+0,int_stack+140060,91);
 /*--- compute (q0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+267551,int_stack+28665,int_stack+164903,91);
 /*--- compute (q0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+338531,int_stack+267551,int_stack+207491,91);
 /*--- compute (q0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+140060,int_stack+127684,int_stack+116764,91);
 /*--- compute (q0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+172820,int_stack+140060,int_stack+0,91);
 /*--- compute (q0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+78351,int_stack+172820,int_stack+28665,91);
 /*--- compute (q0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+428621,int_stack+78351,int_stack+267551,91);
 /*--- compute (q0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+0,int_stack+428621,int_stack+338531,91);
 /*--- compute (op|nh) ---*/
 hrr1_build_op(Libint->AB,int_stack+126126,int_stack+0,int_stack+557246,1386);
 /*--- compute (nd|nh) ---*/
 hrr1_build_nd(Libint->AB,int_stack+939782,int_stack+126126,int_stack+665354,1386);
 return int_stack+939782;}
