/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_nflk(Libint_t*, prim_data*);

  /* Computes quartets of (nf|lk) integrals */

REALTYPE *hrr_order_nflk(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[10][8] = int_stack + 0;
 Libint->vrr_classes[10][9] = int_stack + 2970;
 Libint->vrr_classes[10][10] = int_stack + 6600;
 Libint->vrr_classes[10][11] = int_stack + 10956;
 Libint->vrr_classes[10][12] = int_stack + 16104;
 Libint->vrr_classes[10][13] = int_stack + 22110;
 Libint->vrr_classes[10][14] = int_stack + 29040;
 Libint->vrr_classes[10][15] = int_stack + 36960;
 Libint->vrr_classes[11][8] = int_stack + 45936;
 Libint->vrr_classes[11][9] = int_stack + 49446;
 Libint->vrr_classes[11][10] = int_stack + 53736;
 Libint->vrr_classes[11][11] = int_stack + 58884;
 Libint->vrr_classes[11][12] = int_stack + 64968;
 Libint->vrr_classes[11][13] = int_stack + 72066;
 Libint->vrr_classes[11][14] = int_stack + 80256;
 Libint->vrr_classes[11][15] = int_stack + 89616;
 Libint->vrr_classes[12][8] = int_stack + 100224;
 Libint->vrr_classes[12][9] = int_stack + 104319;
 Libint->vrr_classes[12][10] = int_stack + 109324;
 Libint->vrr_classes[12][11] = int_stack + 115330;
 Libint->vrr_classes[12][12] = int_stack + 122428;
 Libint->vrr_classes[12][13] = int_stack + 130709;
 Libint->vrr_classes[12][14] = int_stack + 140264;
 Libint->vrr_classes[12][15] = int_stack + 151184;
 Libint->vrr_classes[13][8] = int_stack + 163560;
 Libint->vrr_classes[13][9] = int_stack + 168285;
 Libint->vrr_classes[13][10] = int_stack + 174060;
 Libint->vrr_classes[13][11] = int_stack + 180990;
 Libint->vrr_classes[13][12] = int_stack + 189180;
 Libint->vrr_classes[13][13] = int_stack + 198735;
 Libint->vrr_classes[13][14] = int_stack + 209760;
 Libint->vrr_classes[13][15] = int_stack + 222360;
 memset(int_stack,0,236640*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 236640;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_nflk(Libint, Data);
   Data++;
 }
 /*--- compute (n0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+236640,int_stack+2970,int_stack+0,66);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+245550,int_stack+6600,int_stack+2970,66);
 /*--- compute (n0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+256440,int_stack+245550,int_stack+236640,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+274260,int_stack+10956,int_stack+6600,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+287328,int_stack+274260,int_stack+245550,66);
 /*--- compute (n0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+309108,int_stack+287328,int_stack+256440,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+236640,int_stack+16104,int_stack+10956,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+338808,int_stack+236640,int_stack+274260,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+364944,int_stack+338808,int_stack+287328,66);
 /*--- compute (n0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+252084,int_stack+364944,int_stack+309108,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+296634,int_stack+22110,int_stack+16104,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+401244,int_stack+296634,int_stack+236640,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+432132,int_stack+401244,int_stack+338808,66);
 /*--- compute (n0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+475692,int_stack+432132,int_stack+364944,66);
 /*--- compute (n0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+314652,int_stack+475692,int_stack+252084,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+236640,int_stack+29040,int_stack+22110,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+257430,int_stack+236640,int_stack+296634,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+530142,int_stack+257430,int_stack+401244,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+581622,int_stack+530142,int_stack+432132,66);
 /*--- compute (n0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+377022,int_stack+581622,int_stack+475692,66);
 /*--- compute (n0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+646962,int_stack+377022,int_stack+314652,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+293466,int_stack+36960,int_stack+29040,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+317226,int_stack+293466,int_stack+236640,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+453252,int_stack+317226,int_stack+257430,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+236640,int_stack+453252,int_stack+530142,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+453252,int_stack+236640,int_stack+581622,66);
 /*--- compute (n0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+236640,int_stack+453252,int_stack+377022,66);
 /*--- compute (n0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+338280,int_stack+236640,int_stack+646962,66);
 /*--- compute (o0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+236640,int_stack+49446,int_stack+45936,78);
 /*--- compute (o0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+247170,int_stack+53736,int_stack+49446,78);
 /*--- compute (o0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+260040,int_stack+247170,int_stack+236640,78);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+281100,int_stack+58884,int_stack+53736,78);
 /*--- compute (o0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+296544,int_stack+281100,int_stack+247170,78);
 /*--- compute (o0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+445200,int_stack+296544,int_stack+260040,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+236640,int_stack+64968,int_stack+58884,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+480300,int_stack+236640,int_stack+281100,78);
 /*--- compute (o0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+511188,int_stack+480300,int_stack+296544,78);
 /*--- compute (o0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+254892,int_stack+511188,int_stack+445200,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+445200,int_stack+72066,int_stack+64968,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+554088,int_stack+445200,int_stack+236640,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+590592,int_stack+554088,int_stack+480300,78);
 /*--- compute (o0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+642072,int_stack+590592,int_stack+511188,78);
 /*--- compute (o0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+466494,int_stack+642072,int_stack+254892,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+236640,int_stack+80256,int_stack+72066,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+261210,int_stack+236640,int_stack+445200,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+0,int_stack+261210,int_stack+554088,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+706422,int_stack+0,int_stack+590592,78);
 /*--- compute (o0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+540204,int_stack+706422,int_stack+642072,78);
 /*--- compute (o0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+783642,int_stack+540204,int_stack+466494,78);
 /*--- compute (o0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+445200,int_stack+89616,int_stack+80256,78);
 /*--- compute (o0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+473280,int_stack+445200,int_stack+236640,78);
 /*--- compute (o0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+630294,int_stack+473280,int_stack+261210,78);
 /*--- compute (o0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+236640,int_stack+630294,int_stack+0,78);
 /*--- compute (o0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+881922,int_stack+236640,int_stack+706422,78);
 /*--- compute (o0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+630294,int_stack+881922,int_stack+540204,78);
 /*--- compute (o0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+445200,int_stack+630294,int_stack+783642,78);
 /*--- compute (np|lk) ---*/
 hrr1_build_np(Libint->AB,int_stack+571560,int_stack+445200,int_stack+338280,1620);
 /*--- compute (q0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+236640,int_stack+104319,int_stack+100224,91);
 /*--- compute (q0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+248925,int_stack+109324,int_stack+104319,91);
 /*--- compute (q0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+263940,int_stack+248925,int_stack+236640,91);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+288510,int_stack+115330,int_stack+109324,91);
 /*--- compute (q0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+306528,int_stack+288510,int_stack+248925,91);
 /*--- compute (q0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+336558,int_stack+306528,int_stack+263940,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+236640,int_stack+122428,int_stack+115330,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+377508,int_stack+236640,int_stack+288510,91);
 /*--- compute (q0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+0,int_stack+377508,int_stack+306528,91);
 /*--- compute (q0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+257934,int_stack+0,int_stack+336558,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+319359,int_stack+130709,int_stack+122428,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+50050,int_stack+319359,int_stack+236640,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+892320,int_stack+50050,int_stack+377508,91);
 /*--- compute (q0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+344202,int_stack+892320,int_stack+0,91);
 /*--- compute (q0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+952380,int_stack+344202,int_stack+257934,91);
 /*--- compute (q0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+140264,int_stack+130709,91);
 /*--- compute (q0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+236640,int_stack+0,int_stack+319359,91);
 /*--- compute (q0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1038375,int_stack+236640,int_stack+50050,91);
 /*--- compute (q0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+28665,int_stack+1038375,int_stack+892320,91);
 /*--- compute (q0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+1109355,int_stack+28665,int_stack+344202,91);
 /*--- compute (q0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+286326,int_stack+1109355,int_stack+952380,91);
 /*--- compute (q0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+892320,int_stack+151184,int_stack+140264,91);
 /*--- compute (q0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+925080,int_stack+892320,int_stack+0,91);
 /*--- compute (q0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1214460,int_stack+925080,int_stack+236640,91);
 /*--- compute (q0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+892320,int_stack+1214460,int_stack+1038375,91);
 /*--- compute (q0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1214460,int_stack+892320,int_stack+28665,91);
 /*--- compute (q0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+892320,int_stack+1214460,int_stack+1109355,91);
 /*--- compute (q0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+1032460,int_stack+892320,int_stack+286326,91);
 /*--- compute (op|lk) ---*/
 hrr1_build_op(Libint->AB,int_stack+1179880,int_stack+1032460,int_stack+445200,1620);
 /*--- compute (nd|lk) ---*/
 hrr1_build_nd(Libint->AB,int_stack+1558960,int_stack+1179880,int_stack+571560,1620);
 /*--- compute (r0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+236640,int_stack+168285,int_stack+163560,105);
 /*--- compute (r0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+250815,int_stack+174060,int_stack+168285,105);
 /*--- compute (r0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+268140,int_stack+250815,int_stack+236640,105);
 /*--- compute (r0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+296490,int_stack+180990,int_stack+174060,105);
 /*--- compute (r0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+317280,int_stack+296490,int_stack+250815,105);
 /*--- compute (r0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+351930,int_stack+317280,int_stack+268140,105);
 /*--- compute (r0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+236640,int_stack+189180,int_stack+180990,105);
 /*--- compute (r0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+399180,int_stack+236640,int_stack+296490,105);
 /*--- compute (r0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+440760,int_stack+399180,int_stack+317280,105);
 /*--- compute (r0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+261210,int_stack+440760,int_stack+351930,105);
 /*--- compute (r0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+332085,int_stack+198735,int_stack+189180,105);
 /*--- compute (r0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+498510,int_stack+332085,int_stack+236640,105);
 /*--- compute (r0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+547650,int_stack+498510,int_stack+399180,105);
 /*--- compute (r0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+616950,int_stack+547650,int_stack+440760,105);
 /*--- compute (r0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+360750,int_stack+616950,int_stack+261210,105);
 /*--- compute (r0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+236640,int_stack+209760,int_stack+198735,105);
 /*--- compute (r0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+269715,int_stack+236640,int_stack+332085,105);
 /*--- compute (r0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+703575,int_stack+269715,int_stack+498510,105);
 /*--- compute (r0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+785475,int_stack+703575,int_stack+547650,105);
 /*--- compute (r0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+459975,int_stack+785475,int_stack+616950,105);
 /*--- compute (r0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+889425,int_stack+459975,int_stack+360750,105);
 /*--- compute (r0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+327045,int_stack+222360,int_stack+209760,105);
 /*--- compute (r0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+364845,int_stack+327045,int_stack+236640,105);
 /*--- compute (r0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+581250,int_stack+364845,int_stack+269715,105);
 /*--- compute (r0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+0,int_stack+581250,int_stack+703575,105);
 /*--- compute (r0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+581250,int_stack+0,int_stack+785475,105);
 /*--- compute (r0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+0,int_stack+581250,int_stack+459975,105);
 /*--- compute (r0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+161700,int_stack+0,int_stack+889425,105);
 /*--- compute (qp|lk) ---*/
 hrr1_build_qp(Libint->AB,int_stack+331800,int_stack+161700,int_stack+1032460,1620);
 /*--- compute (od|lk) ---*/
 hrr1_build_od(Libint->AB,int_stack+2200480,int_stack+331800,int_stack+1179880,1620);
 /*--- compute (nf|lk) ---*/
 hrr1_build_nf(Libint->AB,int_stack+0,int_stack+2200480,int_stack+1558960,1620);
 return int_stack+0;}
