/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_nfmh(Libint_t*, prim_data*);

  /* Computes quartets of (nf|mh) integrals */

REALTYPE *hrr_order_nfmh(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[10][9] = int_stack + 0;
 Libint->vrr_classes[10][10] = int_stack + 3630;
 Libint->vrr_classes[10][11] = int_stack + 7986;
 Libint->vrr_classes[10][12] = int_stack + 13134;
 Libint->vrr_classes[10][13] = int_stack + 19140;
 Libint->vrr_classes[10][14] = int_stack + 26070;
 Libint->vrr_classes[11][9] = int_stack + 33990;
 Libint->vrr_classes[11][10] = int_stack + 38280;
 Libint->vrr_classes[11][11] = int_stack + 43428;
 Libint->vrr_classes[11][12] = int_stack + 49512;
 Libint->vrr_classes[11][13] = int_stack + 56610;
 Libint->vrr_classes[11][14] = int_stack + 64800;
 Libint->vrr_classes[12][9] = int_stack + 74160;
 Libint->vrr_classes[12][10] = int_stack + 79165;
 Libint->vrr_classes[12][11] = int_stack + 85171;
 Libint->vrr_classes[12][12] = int_stack + 92269;
 Libint->vrr_classes[12][13] = int_stack + 100550;
 Libint->vrr_classes[12][14] = int_stack + 110105;
 Libint->vrr_classes[13][9] = int_stack + 121025;
 Libint->vrr_classes[13][10] = int_stack + 126800;
 Libint->vrr_classes[13][11] = int_stack + 133730;
 Libint->vrr_classes[13][12] = int_stack + 141920;
 Libint->vrr_classes[13][13] = int_stack + 151475;
 Libint->vrr_classes[13][14] = int_stack + 162500;
 memset(int_stack,0,175100*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 175100;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_nfmh(Libint, Data);
   Data++;
 }
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+175100,int_stack+3630,int_stack+0,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+185990,int_stack+7986,int_stack+3630,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+199058,int_stack+185990,int_stack+175100,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+220838,int_stack+13134,int_stack+7986,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+236282,int_stack+220838,int_stack+185990,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+262418,int_stack+236282,int_stack+199058,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+175100,int_stack+19140,int_stack+13134,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+298718,int_stack+175100,int_stack+220838,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+329606,int_stack+298718,int_stack+236282,66);
 /*--- compute (n0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+193118,int_stack+329606,int_stack+262418,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+247568,int_stack+26070,int_stack+19140,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+373166,int_stack+247568,int_stack+175100,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+409202,int_stack+373166,int_stack+298718,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+247568,int_stack+409202,int_stack+329606,66);
 /*--- compute (n0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+312908,int_stack+247568,int_stack+193118,66);
 /*--- compute (o0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+175100,int_stack+38280,int_stack+33990,78);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+187970,int_stack+43428,int_stack+38280,78);
 /*--- compute (o0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+203414,int_stack+187970,int_stack+175100,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+229154,int_stack+49512,int_stack+43428,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+247406,int_stack+229154,int_stack+187970,78);
 /*--- compute (o0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+389138,int_stack+247406,int_stack+203414,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+175100,int_stack+56610,int_stack+49512,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+0,int_stack+175100,int_stack+229154,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+432038,int_stack+0,int_stack+247406,78);
 /*--- compute (o0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+196394,int_stack+432038,int_stack+389138,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+389138,int_stack+64800,int_stack+56610,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+260744,int_stack+389138,int_stack+175100,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+483518,int_stack+260744,int_stack+0,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+544358,int_stack+483518,int_stack+432038,78);
 /*--- compute (o0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+389138,int_stack+544358,int_stack+196394,78);
 /*--- compute (np|mh) ---*/
 hrr1_build_np(Libint->AB,int_stack+479228,int_stack+389138,int_stack+312908,1155);
 /*--- compute (q0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+0,int_stack+79165,int_stack+74160,91);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+15015,int_stack+85171,int_stack+79165,91);
 /*--- compute (q0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+33033,int_stack+15015,int_stack+0,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+63063,int_stack+92269,int_stack+85171,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+175100,int_stack+63063,int_stack+15015,91);
 /*--- compute (q0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+211136,int_stack+175100,int_stack+33033,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+100550,int_stack+92269,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+261186,int_stack+0,int_stack+63063,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+24843,int_stack+261186,int_stack+175100,91);
 /*--- compute (q0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+303774,int_stack+24843,int_stack+211136,91);
 /*--- compute (q0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+175100,int_stack+110105,int_stack+100550,91);
 /*--- compute (q0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+203765,int_stack+175100,int_stack+0,91);
 /*--- compute (q0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+707918,int_stack+203765,int_stack+261186,91);
 /*--- compute (q0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+175100,int_stack+707918,int_stack+24843,91);
 /*--- compute (q0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+0,int_stack+175100,int_stack+303774,91);
 /*--- compute (op|mh) ---*/
 hrr1_build_op(Libint->AB,int_stack+707918,int_stack+0,int_stack+389138,1155);
 /*--- compute (nd|mh) ---*/
 hrr1_build_nd(Libint->AB,int_stack+978188,int_stack+707918,int_stack+479228,1155);
 /*--- compute (r0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+175100,int_stack+126800,int_stack+121025,105);
 /*--- compute (r0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+192425,int_stack+133730,int_stack+126800,105);
 /*--- compute (r0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+213215,int_stack+192425,int_stack+175100,105);
 /*--- compute (r0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+247865,int_stack+141920,int_stack+133730,105);
 /*--- compute (r0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+272435,int_stack+247865,int_stack+192425,105);
 /*--- compute (r0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+314015,int_stack+272435,int_stack+213215,105);
 /*--- compute (r0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+175100,int_stack+151475,int_stack+141920,105);
 /*--- compute (r0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+371765,int_stack+175100,int_stack+247865,105);
 /*--- compute (r0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+420905,int_stack+371765,int_stack+272435,105);
 /*--- compute (r0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+203765,int_stack+420905,int_stack+314015,105);
 /*--- compute (r0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+290390,int_stack+162500,int_stack+151475,105);
 /*--- compute (r0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+490205,int_stack+290390,int_stack+175100,105);
 /*--- compute (r0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+547535,int_stack+490205,int_stack+371765,105);
 /*--- compute (r0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+290390,int_stack+547535,int_stack+420905,105);
 /*--- compute (r0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+394340,int_stack+290390,int_stack+203765,105);
 /*--- compute (qp|mh) ---*/
 hrr1_build_qp(Libint->AB,int_stack+1435568,int_stack+394340,int_stack+0,1155);
 /*--- compute (od|mh) ---*/
 hrr1_build_od(Libint->AB,int_stack+0,int_stack+1435568,int_stack+707918,1155);
 /*--- compute (nf|mh) ---*/
 hrr1_build_nf(Libint->AB,int_stack+1435568,int_stack+0,int_stack+978188,1155);
 return int_stack+1435568;}
