/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_ngll(Libint_t*, prim_data*);

  /* Computes quartets of (ng|ll) integrals */

REALTYPE *hrr_order_ngll(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[10][8] = int_stack + 0;
 Libint->vrr_classes[10][9] = int_stack + 2970;
 Libint->vrr_classes[10][10] = int_stack + 6600;
 Libint->vrr_classes[10][11] = int_stack + 10956;
 Libint->vrr_classes[10][12] = int_stack + 16104;
 Libint->vrr_classes[10][13] = int_stack + 22110;
 Libint->vrr_classes[10][14] = int_stack + 29040;
 Libint->vrr_classes[10][15] = int_stack + 36960;
 Libint->vrr_classes[10][16] = int_stack + 45936;
 Libint->vrr_classes[11][8] = int_stack + 56034;
 Libint->vrr_classes[11][9] = int_stack + 59544;
 Libint->vrr_classes[11][10] = int_stack + 63834;
 Libint->vrr_classes[11][11] = int_stack + 68982;
 Libint->vrr_classes[11][12] = int_stack + 75066;
 Libint->vrr_classes[11][13] = int_stack + 82164;
 Libint->vrr_classes[11][14] = int_stack + 90354;
 Libint->vrr_classes[11][15] = int_stack + 99714;
 Libint->vrr_classes[11][16] = int_stack + 110322;
 Libint->vrr_classes[12][8] = int_stack + 122256;
 Libint->vrr_classes[12][9] = int_stack + 126351;
 Libint->vrr_classes[12][10] = int_stack + 131356;
 Libint->vrr_classes[12][11] = int_stack + 137362;
 Libint->vrr_classes[12][12] = int_stack + 144460;
 Libint->vrr_classes[12][13] = int_stack + 152741;
 Libint->vrr_classes[12][14] = int_stack + 162296;
 Libint->vrr_classes[12][15] = int_stack + 173216;
 Libint->vrr_classes[12][16] = int_stack + 185592;
 Libint->vrr_classes[13][8] = int_stack + 199515;
 Libint->vrr_classes[13][9] = int_stack + 204240;
 Libint->vrr_classes[13][10] = int_stack + 210015;
 Libint->vrr_classes[13][11] = int_stack + 216945;
 Libint->vrr_classes[13][12] = int_stack + 225135;
 Libint->vrr_classes[13][13] = int_stack + 234690;
 Libint->vrr_classes[13][14] = int_stack + 245715;
 Libint->vrr_classes[13][15] = int_stack + 258315;
 Libint->vrr_classes[13][16] = int_stack + 272595;
 Libint->vrr_classes[14][8] = int_stack + 288660;
 Libint->vrr_classes[14][9] = int_stack + 294060;
 Libint->vrr_classes[14][10] = int_stack + 300660;
 Libint->vrr_classes[14][11] = int_stack + 308580;
 Libint->vrr_classes[14][12] = int_stack + 317940;
 Libint->vrr_classes[14][13] = int_stack + 328860;
 Libint->vrr_classes[14][14] = int_stack + 341460;
 Libint->vrr_classes[14][15] = int_stack + 355860;
 Libint->vrr_classes[14][16] = int_stack + 372180;
 memset(int_stack,0,390540*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 390540;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_ngll(Libint, Data);
   Data++;
 }
 /*--- compute (n0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+390540,int_stack+2970,int_stack+0,66);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+399450,int_stack+6600,int_stack+2970,66);
 /*--- compute (n0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+410340,int_stack+399450,int_stack+390540,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+428160,int_stack+10956,int_stack+6600,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+441228,int_stack+428160,int_stack+399450,66);
 /*--- compute (n0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+463008,int_stack+441228,int_stack+410340,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+390540,int_stack+16104,int_stack+10956,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+492708,int_stack+390540,int_stack+428160,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+518844,int_stack+492708,int_stack+441228,66);
 /*--- compute (n0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+405984,int_stack+518844,int_stack+463008,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+450534,int_stack+22110,int_stack+16104,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+555144,int_stack+450534,int_stack+390540,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+586032,int_stack+555144,int_stack+492708,66);
 /*--- compute (n0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+629592,int_stack+586032,int_stack+518844,66);
 /*--- compute (n0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+468552,int_stack+629592,int_stack+405984,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+390540,int_stack+29040,int_stack+22110,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+411330,int_stack+390540,int_stack+450534,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+684042,int_stack+411330,int_stack+555144,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+735522,int_stack+684042,int_stack+586032,66);
 /*--- compute (n0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+530922,int_stack+735522,int_stack+629592,66);
 /*--- compute (n0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+800862,int_stack+530922,int_stack+468552,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+447366,int_stack+36960,int_stack+29040,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+471126,int_stack+447366,int_stack+390540,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+607152,int_stack+471126,int_stack+411330,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+884022,int_stack+607152,int_stack+684042,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+961242,int_stack+884022,int_stack+735522,66);
 /*--- compute (n0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+667212,int_stack+961242,int_stack+530922,66);
 /*--- compute (n0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+1052718,int_stack+667212,int_stack+800862,66);
 /*--- compute (n0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+390540,int_stack+45936,int_stack+36960,66);
 /*--- compute (n0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+512706,int_stack+390540,int_stack+447366,66);
 /*--- compute (n0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+390540,int_stack+512706,int_stack+471126,66);
 /*--- compute (n0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+459840,int_stack+390540,int_stack+607152,66);
 /*--- compute (n0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+549930,int_stack+459840,int_stack+884022,66);
 /*--- compute (n0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+390540,int_stack+549930,int_stack+961242,66);
 /*--- compute (n0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+512508,int_stack+390540,int_stack+667212,66);
 /*--- compute (n0|ll) ---*/
 hrr3_build_ll(Libint->CD,int_stack+643188,int_stack+512508,int_stack+1052718,66);
 /*--- compute (o0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+390540,int_stack+59544,int_stack+56034,78);
 /*--- compute (o0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+401070,int_stack+63834,int_stack+59544,78);
 /*--- compute (o0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+413940,int_stack+401070,int_stack+390540,78);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+435000,int_stack+68982,int_stack+63834,78);
 /*--- compute (o0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+450444,int_stack+435000,int_stack+401070,78);
 /*--- compute (o0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+476184,int_stack+450444,int_stack+413940,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+390540,int_stack+75066,int_stack+68982,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+511284,int_stack+390540,int_stack+435000,78);
 /*--- compute (o0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+542172,int_stack+511284,int_stack+450444,78);
 /*--- compute (o0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+408792,int_stack+542172,int_stack+476184,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+461442,int_stack+82164,int_stack+75066,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+585072,int_stack+461442,int_stack+390540,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+776838,int_stack+585072,int_stack+511284,78);
 /*--- compute (o0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+828318,int_stack+776838,int_stack+542172,78);
 /*--- compute (o0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+482736,int_stack+828318,int_stack+408792,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+390540,int_stack+90354,int_stack+82164,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+415110,int_stack+390540,int_stack+461442,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+892668,int_stack+415110,int_stack+585072,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+556446,int_stack+892668,int_stack+776838,78);
 /*--- compute (o0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+953508,int_stack+556446,int_stack+828318,78);
 /*--- compute (o0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+776838,int_stack+953508,int_stack+482736,78);
 /*--- compute (o0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+457698,int_stack+99714,int_stack+90354,78);
 /*--- compute (o0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+485778,int_stack+457698,int_stack+390540,78);
 /*--- compute (o0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1043598,int_stack+485778,int_stack+415110,78);
 /*--- compute (o0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+0,int_stack+1043598,int_stack+892668,78);
 /*--- compute (o0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1114578,int_stack+0,int_stack+556446,78);
 /*--- compute (o0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+1222686,int_stack+1114578,int_stack+953508,78);
 /*--- compute (o0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+875118,int_stack+1222686,int_stack+776838,78);
 /*--- compute (o0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+776838,int_stack+110322,int_stack+99714,78);
 /*--- compute (o0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+808662,int_stack+776838,int_stack+457698,78);
 /*--- compute (o0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+390540,int_stack+808662,int_stack+485778,78);
 /*--- compute (o0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+472440,int_stack+390540,int_stack+1043598,78);
 /*--- compute (o0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1342806,int_stack+472440,int_stack+0,78);
 /*--- compute (o0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+390540,int_stack+1342806,int_stack+1114578,78);
 /*--- compute (o0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+1001478,int_stack+390540,int_stack+1222686,78);
 /*--- compute (o0|ll) ---*/
 hrr3_build_ll(Libint->CD,int_stack+390540,int_stack+1001478,int_stack+875118,78);
 /*--- compute (np|ll) ---*/
 hrr1_build_np(Libint->AB,int_stack+776838,int_stack+390540,int_stack+643188,2025);
 /*--- compute (q0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+548490,int_stack+126351,int_stack+122256,91);
 /*--- compute (q0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+560775,int_stack+131356,int_stack+126351,91);
 /*--- compute (q0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+575790,int_stack+560775,int_stack+548490,91);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+600360,int_stack+137362,int_stack+131356,91);
 /*--- compute (q0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+618378,int_stack+600360,int_stack+560775,91);
 /*--- compute (q0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+648408,int_stack+618378,int_stack+575790,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+548490,int_stack+144460,int_stack+137362,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+689358,int_stack+548490,int_stack+600360,91);
 /*--- compute (q0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+725394,int_stack+689358,int_stack+618378,91);
 /*--- compute (q0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+569784,int_stack+725394,int_stack+648408,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+631209,int_stack+152741,int_stack+144460,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+0,int_stack+631209,int_stack+548490,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+42588,int_stack+0,int_stack+689358,91);
 /*--- compute (q0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+1177788,int_stack+42588,int_stack+725394,91);
 /*--- compute (q0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+656052,int_stack+1177788,int_stack+569784,91);
 /*--- compute (q0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+548490,int_stack+162296,int_stack+152741,91);
 /*--- compute (q0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+577155,int_stack+548490,int_stack+631209,91);
 /*--- compute (q0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1252863,int_stack+577155,int_stack+0,91);
 /*--- compute (q0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1323843,int_stack+1252863,int_stack+42588,91);
 /*--- compute (q0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+0,int_stack+1323843,int_stack+1177788,91);
 /*--- compute (q0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+1413933,int_stack+0,int_stack+656052,91);
 /*--- compute (q0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+1177788,int_stack+173216,int_stack+162296,91);
 /*--- compute (q0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+105105,int_stack+1177788,int_stack+548490,91);
 /*--- compute (q0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+626841,int_stack+105105,int_stack+577155,91);
 /*--- compute (q0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1528593,int_stack+626841,int_stack+1252863,91);
 /*--- compute (q0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1635063,int_stack+1528593,int_stack+1323843,91);
 /*--- compute (q0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+1210548,int_stack+1635063,int_stack+0,91);
 /*--- compute (q0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+1761189,int_stack+1210548,int_stack+1413933,91);
 /*--- compute (q0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+0,int_stack+185592,int_stack+173216,91);
 /*--- compute (q0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+37128,int_stack+0,int_stack+1177788,91);
 /*--- compute (q0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1350688,int_stack+37128,int_stack+105105,91);
 /*--- compute (q0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+0,int_stack+1350688,int_stack+626841,91);
 /*--- compute (q0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1350688,int_stack+0,int_stack+1528593,91);
 /*--- compute (q0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+0,int_stack+1350688,int_stack+1635063,91);
 /*--- compute (q0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+1350688,int_stack+0,int_stack+1210548,91);
 /*--- compute (q0|ll) ---*/
 hrr3_build_ll(Libint->CD,int_stack+0,int_stack+1350688,int_stack+1761189,91);
 /*--- compute (op|ll) ---*/
 hrr1_build_op(Libint->AB,int_stack+1177788,int_stack+0,int_stack+390540,2025);
 /*--- compute (nd|ll) ---*/
 hrr1_build_nd(Libint->AB,int_stack+1651638,int_stack+1177788,int_stack+776838,2025);
 /*--- compute (r0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+390540,int_stack+204240,int_stack+199515,105);
 /*--- compute (r0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+404715,int_stack+210015,int_stack+204240,105);
 /*--- compute (r0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+422040,int_stack+404715,int_stack+390540,105);
 /*--- compute (r0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+450390,int_stack+216945,int_stack+210015,105);
 /*--- compute (r0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+471180,int_stack+450390,int_stack+404715,105);
 /*--- compute (r0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+505830,int_stack+471180,int_stack+422040,105);
 /*--- compute (r0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+390540,int_stack+225135,int_stack+216945,105);
 /*--- compute (r0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+553080,int_stack+390540,int_stack+450390,105);
 /*--- compute (r0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+594660,int_stack+553080,int_stack+471180,105);
 /*--- compute (r0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+415110,int_stack+594660,int_stack+505830,105);
 /*--- compute (r0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+485985,int_stack+234690,int_stack+225135,105);
 /*--- compute (r0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+652410,int_stack+485985,int_stack+390540,105);
 /*--- compute (r0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+701550,int_stack+652410,int_stack+553080,105);
 /*--- compute (r0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+770850,int_stack+701550,int_stack+594660,105);
 /*--- compute (r0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+514650,int_stack+770850,int_stack+415110,105);
 /*--- compute (r0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+390540,int_stack+245715,int_stack+234690,105);
 /*--- compute (r0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+423615,int_stack+390540,int_stack+485985,105);
 /*--- compute (r0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+857475,int_stack+423615,int_stack+652410,105);
 /*--- compute (r0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+939375,int_stack+857475,int_stack+701550,105);
 /*--- compute (r0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+613875,int_stack+939375,int_stack+770850,105);
 /*--- compute (r0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+1043325,int_stack+613875,int_stack+514650,105);
 /*--- compute (r0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+480945,int_stack+258315,int_stack+245715,105);
 /*--- compute (r0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+518745,int_stack+480945,int_stack+390540,105);
 /*--- compute (r0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+735150,int_stack+518745,int_stack+423615,105);
 /*--- compute (r0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+2453538,int_stack+735150,int_stack+857475,105);
 /*--- compute (r0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+2576388,int_stack+2453538,int_stack+939375,105);
 /*--- compute (r0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+830700,int_stack+2576388,int_stack+613875,105);
 /*--- compute (r0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+2721918,int_stack+830700,int_stack+1043325,105);
 /*--- compute (r0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+390540,int_stack+272595,int_stack+258315,105);
 /*--- compute (r0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+584895,int_stack+390540,int_stack+480945,105);
 /*--- compute (r0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+390540,int_stack+584895,int_stack+518745,105);
 /*--- compute (r0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+500790,int_stack+390540,int_stack+735150,105);
 /*--- compute (r0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+644115,int_stack+500790,int_stack+2453538,105);
 /*--- compute (r0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+390540,int_stack+644115,int_stack+2576388,105);
 /*--- compute (r0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+2453538,int_stack+390540,int_stack+830700,105);
 /*--- compute (r0|ll) ---*/
 hrr3_build_ll(Libint->CD,int_stack+390540,int_stack+2453538,int_stack+2721918,105);
 /*--- compute (qp|ll) ---*/
 hrr1_build_qp(Libint->AB,int_stack+603165,int_stack+390540,int_stack+0,2025);
 /*--- compute (od|ll) ---*/
 hrr1_build_od(Libint->AB,int_stack+2453538,int_stack+603165,int_stack+1177788,2025);
 /*--- compute (nf|ll) ---*/
 hrr1_build_nf(Libint->AB,int_stack+3401238,int_stack+2453538,int_stack+1651638,2025);
 /*--- compute (t0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+0,int_stack+294060,int_stack+288660,120);
 /*--- compute (t0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+16200,int_stack+300660,int_stack+294060,120);
 /*--- compute (t0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+36000,int_stack+16200,int_stack+0,120);
 /*--- compute (t0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+68400,int_stack+308580,int_stack+300660,120);
 /*--- compute (t0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+92160,int_stack+68400,int_stack+16200,120);
 /*--- compute (t0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+131760,int_stack+92160,int_stack+36000,120);
 /*--- compute (t0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+0,int_stack+317940,int_stack+308580,120);
 /*--- compute (t0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+185760,int_stack+0,int_stack+68400,120);
 /*--- compute (t0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+233280,int_stack+185760,int_stack+92160,120);
 /*--- compute (t0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+28080,int_stack+233280,int_stack+131760,120);
 /*--- compute (t0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+109080,int_stack+328860,int_stack+317940,120);
 /*--- compute (t0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+1155990,int_stack+109080,int_stack+0,120);
 /*--- compute (t0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+1212150,int_stack+1155990,int_stack+185760,120);
 /*--- compute (t0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+1291350,int_stack+1212150,int_stack+233280,120);
 /*--- compute (t0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+141840,int_stack+1291350,int_stack+28080,120);
 /*--- compute (t0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+341460,int_stack+328860,120);
 /*--- compute (t0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+37800,int_stack+0,int_stack+109080,120);
 /*--- compute (t0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1390350,int_stack+37800,int_stack+1155990,120);
 /*--- compute (t0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1483950,int_stack+1390350,int_stack+1212150,120);
 /*--- compute (t0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+1602750,int_stack+1483950,int_stack+1291350,120);
 /*--- compute (t0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+1155990,int_stack+1602750,int_stack+141840,120);
 /*--- compute (t0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+1307190,int_stack+355860,int_stack+341460,120);
 /*--- compute (t0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+103320,int_stack+1307190,int_stack+0,120);
 /*--- compute (t0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+178920,int_stack+103320,int_stack+37800,120);
 /*--- compute (t0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1741350,int_stack+178920,int_stack+1390350,120);
 /*--- compute (t0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1881750,int_stack+1741350,int_stack+1483950,120);
 /*--- compute (t0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+1350390,int_stack+1881750,int_stack+1602750,120);
 /*--- compute (t0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+1535190,int_stack+1350390,int_stack+1155990,120);
 /*--- compute (t0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+1155990,int_stack+372180,int_stack+355860,120);
 /*--- compute (t0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1204950,int_stack+1155990,int_stack+1307190,120);
 /*--- compute (t0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+2048070,int_stack+1204950,int_stack+103320,120);
 /*--- compute (t0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1155990,int_stack+2048070,int_stack+178920,120);
 /*--- compute (t0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+2048070,int_stack+1155990,int_stack+1741350,120);
 /*--- compute (t0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+0,int_stack+2048070,int_stack+1881750,120);
 /*--- compute (t0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+1729590,int_stack+0,int_stack+1350390,120);
 /*--- compute (t0|ll) ---*/
 hrr3_build_ll(Libint->CD,int_stack+0,int_stack+1729590,int_stack+1535190,120);
 /*--- compute (rp|ll) ---*/
 hrr1_build_rp(Libint->AB,int_stack+1155990,int_stack+0,int_stack+390540,2025);
 /*--- compute (qd|ll) ---*/
 hrr1_build_qd(Libint->AB,int_stack+4737738,int_stack+1155990,int_stack+603165,2025);
 /*--- compute (of|ll) ---*/
 hrr1_build_of(Libint->AB,int_stack+0,int_stack+4737738,int_stack+2453538,2025);
 /*--- compute (ng|ll) ---*/
 hrr1_build_ng(Libint->AB,int_stack+4737738,int_stack+0,int_stack+3401238,2025);
 return int_stack+4737738;}
