/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_nhni(Libint_t*, prim_data*);

  /* Computes quartets of (nh|ni) integrals */

REALTYPE *hrr_order_nhni(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[10][10] = int_stack + 0;
 Libint->vrr_classes[10][11] = int_stack + 4356;
 Libint->vrr_classes[10][12] = int_stack + 9504;
 Libint->vrr_classes[10][13] = int_stack + 15510;
 Libint->vrr_classes[10][14] = int_stack + 22440;
 Libint->vrr_classes[10][15] = int_stack + 30360;
 Libint->vrr_classes[10][16] = int_stack + 39336;
 Libint->vrr_classes[11][10] = int_stack + 49434;
 Libint->vrr_classes[11][11] = int_stack + 54582;
 Libint->vrr_classes[11][12] = int_stack + 60666;
 Libint->vrr_classes[11][13] = int_stack + 67764;
 Libint->vrr_classes[11][14] = int_stack + 75954;
 Libint->vrr_classes[11][15] = int_stack + 85314;
 Libint->vrr_classes[11][16] = int_stack + 95922;
 Libint->vrr_classes[12][10] = int_stack + 107856;
 Libint->vrr_classes[12][11] = int_stack + 113862;
 Libint->vrr_classes[12][12] = int_stack + 120960;
 Libint->vrr_classes[12][13] = int_stack + 129241;
 Libint->vrr_classes[12][14] = int_stack + 138796;
 Libint->vrr_classes[12][15] = int_stack + 149716;
 Libint->vrr_classes[12][16] = int_stack + 162092;
 Libint->vrr_classes[13][10] = int_stack + 176015;
 Libint->vrr_classes[13][11] = int_stack + 182945;
 Libint->vrr_classes[13][12] = int_stack + 191135;
 Libint->vrr_classes[13][13] = int_stack + 200690;
 Libint->vrr_classes[13][14] = int_stack + 211715;
 Libint->vrr_classes[13][15] = int_stack + 224315;
 Libint->vrr_classes[13][16] = int_stack + 238595;
 Libint->vrr_classes[14][10] = int_stack + 254660;
 Libint->vrr_classes[14][11] = int_stack + 262580;
 Libint->vrr_classes[14][12] = int_stack + 271940;
 Libint->vrr_classes[14][13] = int_stack + 282860;
 Libint->vrr_classes[14][14] = int_stack + 295460;
 Libint->vrr_classes[14][15] = int_stack + 309860;
 Libint->vrr_classes[14][16] = int_stack + 326180;
 Libint->vrr_classes[15][10] = int_stack + 344540;
 Libint->vrr_classes[15][11] = int_stack + 353516;
 Libint->vrr_classes[15][12] = int_stack + 364124;
 Libint->vrr_classes[15][13] = int_stack + 376500;
 Libint->vrr_classes[15][14] = int_stack + 390780;
 Libint->vrr_classes[15][15] = int_stack + 407100;
 Libint->vrr_classes[15][16] = int_stack + 425596;
 memset(int_stack,0,446404*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 446404;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_nhni(Libint, Data);
   Data++;
 }
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+446404,int_stack+4356,int_stack+0,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+459472,int_stack+9504,int_stack+4356,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+474916,int_stack+459472,int_stack+446404,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+501052,int_stack+15510,int_stack+9504,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+519070,int_stack+501052,int_stack+459472,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+549958,int_stack+519070,int_stack+474916,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+446404,int_stack+22440,int_stack+15510,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+593518,int_stack+446404,int_stack+501052,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+467194,int_stack+593518,int_stack+519070,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+629554,int_stack+467194,int_stack+549958,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+518674,int_stack+30360,int_stack+22440,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+542434,int_stack+518674,int_stack+446404,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+694894,int_stack+542434,int_stack+593518,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+754954,int_stack+694894,int_stack+467194,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+832174,int_stack+754954,int_stack+629554,66);
 /*--- compute (n0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+446404,int_stack+39336,int_stack+30360,66);
 /*--- compute (n0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+584014,int_stack+446404,int_stack+518674,66);
 /*--- compute (n0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+446404,int_stack+584014,int_stack+542434,66);
 /*--- compute (n0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+515704,int_stack+446404,int_stack+694894,66);
 /*--- compute (n0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+605794,int_stack+515704,int_stack+754954,66);
 /*--- compute (n0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+446404,int_stack+605794,int_stack+832174,66);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+568372,int_stack+54582,int_stack+49434,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+583816,int_stack+60666,int_stack+54582,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+602068,int_stack+583816,int_stack+568372,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+632956,int_stack+67764,int_stack+60666,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+654250,int_stack+632956,int_stack+583816,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+690754,int_stack+654250,int_stack+602068,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+568372,int_stack+75954,int_stack+67764,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+742234,int_stack+568372,int_stack+632956,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+592942,int_stack+742234,int_stack+654250,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+784822,int_stack+592942,int_stack+690754,78);
 /*--- compute (o0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+653782,int_stack+85314,int_stack+75954,78);
 /*--- compute (o0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+681862,int_stack+653782,int_stack+568372,78);
 /*--- compute (o0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+0,int_stack+681862,int_stack+742234,78);
 /*--- compute (o0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+862042,int_stack+0,int_stack+592942,78);
 /*--- compute (o0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+953302,int_stack+862042,int_stack+784822,78);
 /*--- compute (o0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+568372,int_stack+95922,int_stack+85314,78);
 /*--- compute (o0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+731002,int_stack+568372,int_stack+653782,78);
 /*--- compute (o0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+568372,int_stack+731002,int_stack+681862,78);
 /*--- compute (o0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+650272,int_stack+568372,int_stack+0,78);
 /*--- compute (o0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1061410,int_stack+650272,int_stack+862042,78);
 /*--- compute (o0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+568372,int_stack+1061410,int_stack+953302,78);
 /*--- compute (np|ni) ---*/
 hrr1_build_np(Libint->AB,int_stack+712516,int_stack+568372,int_stack+446404,1848);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+446404,int_stack+113862,int_stack+107856,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+464422,int_stack+120960,int_stack+113862,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+485716,int_stack+464422,int_stack+446404,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+521752,int_stack+129241,int_stack+120960,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+0,int_stack+521752,int_stack+464422,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+42588,int_stack+0,int_stack+485716,91);
 /*--- compute (q0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+446404,int_stack+138796,int_stack+129241,91);
 /*--- compute (q0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+1078420,int_stack+446404,int_stack+521752,91);
 /*--- compute (q0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+475069,int_stack+1078420,int_stack+0,91);
 /*--- compute (q0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1128106,int_stack+475069,int_stack+42588,91);
 /*--- compute (q0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+0,int_stack+149716,int_stack+138796,91);
 /*--- compute (q0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+32760,int_stack+0,int_stack+446404,91);
 /*--- compute (q0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1218196,int_stack+32760,int_stack+1078420,91);
 /*--- compute (q0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1301006,int_stack+1218196,int_stack+475069,91);
 /*--- compute (q0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1407476,int_stack+1301006,int_stack+1128106,91);
 /*--- compute (q0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+1078420,int_stack+162092,int_stack+149716,91);
 /*--- compute (q0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1115548,int_stack+1078420,int_stack+0,91);
 /*--- compute (q0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+446404,int_stack+1115548,int_stack+32760,91);
 /*--- compute (q0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+0,int_stack+446404,int_stack+1218196,91);
 /*--- compute (q0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1078420,int_stack+0,int_stack+1301006,91);
 /*--- compute (q0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+0,int_stack+1078420,int_stack+1407476,91);
 /*--- compute (op|ni) ---*/
 hrr1_build_op(Libint->AB,int_stack+1078420,int_stack+0,int_stack+568372,1848);
 /*--- compute (nd|ni) ---*/
 hrr1_build_nd(Libint->AB,int_stack+1510852,int_stack+1078420,int_stack+712516,1848);
 /*--- compute (r0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+446404,int_stack+182945,int_stack+176015,105);
 /*--- compute (r0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+467194,int_stack+191135,int_stack+182945,105);
 /*--- compute (r0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+491764,int_stack+467194,int_stack+446404,105);
 /*--- compute (r0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+533344,int_stack+200690,int_stack+191135,105);
 /*--- compute (r0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+562009,int_stack+533344,int_stack+467194,105);
 /*--- compute (r0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+611149,int_stack+562009,int_stack+491764,105);
 /*--- compute (r0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+446404,int_stack+211715,int_stack+200690,105);
 /*--- compute (r0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+680449,int_stack+446404,int_stack+533344,105);
 /*--- compute (r0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+479479,int_stack+680449,int_stack+562009,105);
 /*--- compute (r0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+737779,int_stack+479479,int_stack+611149,105);
 /*--- compute (r0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+561379,int_stack+224315,int_stack+211715,105);
 /*--- compute (r0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+599179,int_stack+561379,int_stack+446404,105);
 /*--- compute (r0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+841729,int_stack+599179,int_stack+680449,105);
 /*--- compute (r0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+937279,int_stack+841729,int_stack+479479,105);
 /*--- compute (r0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+2242660,int_stack+937279,int_stack+737779,105);
 /*--- compute (r0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+446404,int_stack+238595,int_stack+224315,105);
 /*--- compute (r0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+665329,int_stack+446404,int_stack+561379,105);
 /*--- compute (r0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+446404,int_stack+665329,int_stack+599179,105);
 /*--- compute (r0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+556654,int_stack+446404,int_stack+841729,105);
 /*--- compute (r0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+699979,int_stack+556654,int_stack+937279,105);
 /*--- compute (r0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+446404,int_stack+699979,int_stack+2242660,105);
 /*--- compute (qp|ni) ---*/
 hrr1_build_qp(Libint->AB,int_stack+2242660,int_stack+446404,int_stack+0,1848);
 /*--- compute (od|ni) ---*/
 hrr1_build_od(Libint->AB,int_stack+2747164,int_stack+2242660,int_stack+1078420,1848);
 /*--- compute (nf|ni) ---*/
 hrr1_build_nf(Libint->AB,int_stack+3612028,int_stack+2747164,int_stack+1510852,1848);
 /*--- compute (t0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+262580,int_stack+254660,120);
 /*--- compute (t0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+23760,int_stack+271940,int_stack+262580,120);
 /*--- compute (t0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+51840,int_stack+23760,int_stack+0,120);
 /*--- compute (t0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+99360,int_stack+282860,int_stack+271940,120);
 /*--- compute (t0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+132120,int_stack+99360,int_stack+23760,120);
 /*--- compute (t0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+188280,int_stack+132120,int_stack+51840,120);
 /*--- compute (t0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+295460,int_stack+282860,120);
 /*--- compute (t0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+640444,int_stack+0,int_stack+99360,120);
 /*--- compute (t0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+37800,int_stack+640444,int_stack+132120,120);
 /*--- compute (t0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+705964,int_stack+37800,int_stack+188280,120);
 /*--- compute (t0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+131400,int_stack+309860,int_stack+295460,120);
 /*--- compute (t0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+174600,int_stack+131400,int_stack+0,120);
 /*--- compute (t0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+824764,int_stack+174600,int_stack+640444,120);
 /*--- compute (t0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+933964,int_stack+824764,int_stack+37800,120);
 /*--- compute (t0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1074364,int_stack+933964,int_stack+705964,120);
 /*--- compute (t0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+640444,int_stack+326180,int_stack+309860,120);
 /*--- compute (t0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+689404,int_stack+640444,int_stack+131400,120);
 /*--- compute (t0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+0,int_stack+689404,int_stack+174600,120);
 /*--- compute (t0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+640444,int_stack+0,int_stack+824764,120);
 /*--- compute (t0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+0,int_stack+640444,int_stack+933964,120);
 /*--- compute (t0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+640444,int_stack+0,int_stack+1074364,120);
 /*--- compute (rp|ni) ---*/
 hrr1_build_rp(Libint->AB,int_stack+862204,int_stack+640444,int_stack+446404,1848);
 /*--- compute (qd|ni) ---*/
 hrr1_build_qd(Libint->AB,int_stack+4831708,int_stack+862204,int_stack+2242660,1848);
 /*--- compute (of|ni) ---*/
 hrr1_build_of(Libint->AB,int_stack+5840716,int_stack+4831708,int_stack+2747164,1848);
 /*--- compute (ng|ni) ---*/
 hrr1_build_ng(Libint->AB,int_stack+1444324,int_stack+5840716,int_stack+3612028,1848);
 /*--- compute (u0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+446404,int_stack+353516,int_stack+344540,136);
 /*--- compute (u0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+473332,int_stack+364124,int_stack+353516,136);
 /*--- compute (u0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+505156,int_stack+473332,int_stack+446404,136);
 /*--- compute (u0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+559012,int_stack+376500,int_stack+364124,136);
 /*--- compute (u0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+0,int_stack+559012,int_stack+473332,136);
 /*--- compute (u0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+63648,int_stack+0,int_stack+505156,136);
 /*--- compute (u0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+446404,int_stack+390780,int_stack+376500,136);
 /*--- compute (u0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+153408,int_stack+446404,int_stack+559012,136);
 /*--- compute (u0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+489244,int_stack+153408,int_stack+0,136);
 /*--- compute (u0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+227664,int_stack+489244,int_stack+63648,136);
 /*--- compute (u0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+0,int_stack+407100,int_stack+390780,136);
 /*--- compute (u0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+48960,int_stack+0,int_stack+446404,136);
 /*--- compute (u0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+3273844,int_stack+48960,int_stack+153408,136);
 /*--- compute (u0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+3397604,int_stack+3273844,int_stack+489244,136);
 /*--- compute (u0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+446404,int_stack+3397604,int_stack+227664,136);
 /*--- compute (u0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+134640,int_stack+425596,int_stack+407100,136);
 /*--- compute (u0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+190128,int_stack+134640,int_stack+0,136);
 /*--- compute (u0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+288048,int_stack+190128,int_stack+48960,136);
 /*--- compute (u0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+0,int_stack+288048,int_stack+3273844,136);
 /*--- compute (u0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+185640,int_stack+0,int_stack+3397604,136);
 /*--- compute (u0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+3273844,int_stack+185640,int_stack+446404,136);
 /*--- compute (tp|ni) ---*/
 hrr1_build_tp(Libint->AB,int_stack+3525172,int_stack+3273844,int_stack+640444,1848);
 /*--- compute (rd|ni) ---*/
 hrr1_build_rd(Libint->AB,int_stack+7282156,int_stack+3525172,int_stack+862204,1848);
 /*--- compute (qf|ni) ---*/
 hrr1_build_qf(Libint->AB,int_stack+8446396,int_stack+7282156,int_stack+4831708,1848);
 /*--- compute (og|ni) ---*/
 hrr1_build_og(Libint->AB,int_stack+3273844,int_stack+8446396,int_stack+5840716,1848);
 /*--- compute (nh|ni) ---*/
 hrr1_build_nh(Libint->AB,int_stack+5436004,int_stack+3273844,int_stack+1444324,1848);
 return int_stack+5436004;}
