/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_ninm(Libint_t*, prim_data*);

  /* Computes quartets of (ni|nm) integrals */

REALTYPE *hrr_order_ninm(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[10][10] = int_stack + 0;
 Libint->vrr_classes[10][11] = int_stack + 4356;
 Libint->vrr_classes[10][12] = int_stack + 9504;
 Libint->vrr_classes[10][13] = int_stack + 15510;
 Libint->vrr_classes[10][14] = int_stack + 22440;
 Libint->vrr_classes[10][15] = int_stack + 30360;
 Libint->vrr_classes[10][16] = int_stack + 39336;
 Libint->vrr_classes[10][17] = int_stack + 49434;
 Libint->vrr_classes[10][18] = int_stack + 60720;
 Libint->vrr_classes[10][19] = int_stack + 73260;
 Libint->vrr_classes[11][10] = int_stack + 87120;
 Libint->vrr_classes[11][11] = int_stack + 92268;
 Libint->vrr_classes[11][12] = int_stack + 98352;
 Libint->vrr_classes[11][13] = int_stack + 105450;
 Libint->vrr_classes[11][14] = int_stack + 113640;
 Libint->vrr_classes[11][15] = int_stack + 123000;
 Libint->vrr_classes[11][16] = int_stack + 133608;
 Libint->vrr_classes[11][17] = int_stack + 145542;
 Libint->vrr_classes[11][18] = int_stack + 158880;
 Libint->vrr_classes[11][19] = int_stack + 173700;
 Libint->vrr_classes[12][10] = int_stack + 190080;
 Libint->vrr_classes[12][11] = int_stack + 196086;
 Libint->vrr_classes[12][12] = int_stack + 203184;
 Libint->vrr_classes[12][13] = int_stack + 211465;
 Libint->vrr_classes[12][14] = int_stack + 221020;
 Libint->vrr_classes[12][15] = int_stack + 231940;
 Libint->vrr_classes[12][16] = int_stack + 244316;
 Libint->vrr_classes[12][17] = int_stack + 258239;
 Libint->vrr_classes[12][18] = int_stack + 273800;
 Libint->vrr_classes[12][19] = int_stack + 291090;
 Libint->vrr_classes[13][10] = int_stack + 310200;
 Libint->vrr_classes[13][11] = int_stack + 317130;
 Libint->vrr_classes[13][12] = int_stack + 325320;
 Libint->vrr_classes[13][13] = int_stack + 334875;
 Libint->vrr_classes[13][14] = int_stack + 345900;
 Libint->vrr_classes[13][15] = int_stack + 358500;
 Libint->vrr_classes[13][16] = int_stack + 372780;
 Libint->vrr_classes[13][17] = int_stack + 388845;
 Libint->vrr_classes[13][18] = int_stack + 406800;
 Libint->vrr_classes[13][19] = int_stack + 426750;
 Libint->vrr_classes[14][10] = int_stack + 448800;
 Libint->vrr_classes[14][11] = int_stack + 456720;
 Libint->vrr_classes[14][12] = int_stack + 466080;
 Libint->vrr_classes[14][13] = int_stack + 477000;
 Libint->vrr_classes[14][14] = int_stack + 489600;
 Libint->vrr_classes[14][15] = int_stack + 504000;
 Libint->vrr_classes[14][16] = int_stack + 520320;
 Libint->vrr_classes[14][17] = int_stack + 538680;
 Libint->vrr_classes[14][18] = int_stack + 559200;
 Libint->vrr_classes[14][19] = int_stack + 582000;
 Libint->vrr_classes[15][10] = int_stack + 607200;
 Libint->vrr_classes[15][11] = int_stack + 616176;
 Libint->vrr_classes[15][12] = int_stack + 626784;
 Libint->vrr_classes[15][13] = int_stack + 639160;
 Libint->vrr_classes[15][14] = int_stack + 653440;
 Libint->vrr_classes[15][15] = int_stack + 669760;
 Libint->vrr_classes[15][16] = int_stack + 688256;
 Libint->vrr_classes[15][17] = int_stack + 709064;
 Libint->vrr_classes[15][18] = int_stack + 732320;
 Libint->vrr_classes[15][19] = int_stack + 758160;
 Libint->vrr_classes[16][10] = int_stack + 786720;
 Libint->vrr_classes[16][11] = int_stack + 796818;
 Libint->vrr_classes[16][12] = int_stack + 808752;
 Libint->vrr_classes[16][13] = int_stack + 822675;
 Libint->vrr_classes[16][14] = int_stack + 838740;
 Libint->vrr_classes[16][15] = int_stack + 857100;
 Libint->vrr_classes[16][16] = int_stack + 877908;
 Libint->vrr_classes[16][17] = int_stack + 901317;
 Libint->vrr_classes[16][18] = int_stack + 927480;
 Libint->vrr_classes[16][19] = int_stack + 956550;
 memset(int_stack,0,988680*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 988680;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_ninm(Libint, Data);
   Data++;
 }
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+988680,int_stack+4356,int_stack+0,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+1001748,int_stack+9504,int_stack+4356,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+1017192,int_stack+1001748,int_stack+988680,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+1043328,int_stack+15510,int_stack+9504,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+1061346,int_stack+1043328,int_stack+1001748,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+1092234,int_stack+1061346,int_stack+1017192,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+988680,int_stack+22440,int_stack+15510,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+1135794,int_stack+988680,int_stack+1043328,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1009470,int_stack+1135794,int_stack+1061346,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1171830,int_stack+1009470,int_stack+1092234,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+1060950,int_stack+30360,int_stack+22440,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+1084710,int_stack+1060950,int_stack+988680,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1237170,int_stack+1084710,int_stack+1135794,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1297230,int_stack+1237170,int_stack+1009470,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1374450,int_stack+1297230,int_stack+1171830,66);
 /*--- compute (n0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+988680,int_stack+39336,int_stack+30360,66);
 /*--- compute (n0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1126290,int_stack+988680,int_stack+1060950,66);
 /*--- compute (n0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1465926,int_stack+1126290,int_stack+1084710,66);
 /*--- compute (n0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1015608,int_stack+1465926,int_stack+1237170,66);
 /*--- compute (n0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1173810,int_stack+1015608,int_stack+1297230,66);
 /*--- compute (n0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1535226,int_stack+1173810,int_stack+1374450,66);
 /*--- compute (n0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+1281918,int_stack+49434,int_stack+39336,66);
 /*--- compute (n0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+1312212,int_stack+1281918,int_stack+988680,66);
 /*--- compute (n0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1366068,int_stack+1312212,int_stack+1126290,66);
 /*--- compute (n0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1657194,int_stack+1366068,int_stack+1465926,66);
 /*--- compute (n0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1761144,int_stack+1657194,int_stack+1015608,66);
 /*--- compute (n0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+988680,int_stack+1761144,int_stack+1173810,66);
 /*--- compute (n0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1887270,int_stack+988680,int_stack+1535226,66);
 /*--- compute (n0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+1132824,int_stack+60720,int_stack+49434,66);
 /*--- compute (n0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+1166682,int_stack+1132824,int_stack+1281918,66);
 /*--- compute (n0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+1445268,int_stack+1166682,int_stack+1312212,66);
 /*--- compute (n0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+1227270,int_stack+1445268,int_stack+1366068,66);
 /*--- compute (n0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+2044086,int_stack+1227270,int_stack+1657194,66);
 /*--- compute (n0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+1535028,int_stack+2044086,int_stack+1761144,66);
 /*--- compute (n0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+2189616,int_stack+1535028,int_stack+988680,66);
 /*--- compute (n0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+2374944,int_stack+2189616,int_stack+1887270,66);
 /*--- compute (n0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+988680,int_stack+73260,int_stack+60720,66);
 /*--- compute (n0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+1026300,int_stack+988680,int_stack+1132824,66);
 /*--- compute (n0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+1703196,int_stack+1026300,int_stack+1166682,66);
 /*--- compute (n0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+988680,int_stack+1703196,int_stack+1445268,66);
 /*--- compute (n0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+1703196,int_stack+988680,int_stack+1227270,66);
 /*--- compute (n0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+988680,int_stack+1703196,int_stack+2044086,66);
 /*--- compute (n0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+1703196,int_stack+988680,int_stack+1535028,66);
 /*--- compute (n0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+988680,int_stack+1703196,int_stack+2189616,66);
 /*--- compute (n0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+1220340,int_stack+988680,int_stack+2374944,66);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+988680,int_stack+92268,int_stack+87120,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+1004124,int_stack+98352,int_stack+92268,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+1022376,int_stack+1004124,int_stack+988680,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+1053264,int_stack+105450,int_stack+98352,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+1074558,int_stack+1053264,int_stack+1004124,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+1111062,int_stack+1074558,int_stack+1022376,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+988680,int_stack+113640,int_stack+105450,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+1162542,int_stack+988680,int_stack+1053264,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1013250,int_stack+1162542,int_stack+1074558,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1459920,int_stack+1013250,int_stack+1111062,78);
 /*--- compute (o0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+1074090,int_stack+123000,int_stack+113640,78);
 /*--- compute (o0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+1102170,int_stack+1074090,int_stack+988680,78);
 /*--- compute (o0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1537140,int_stack+1102170,int_stack+1162542,78);
 /*--- compute (o0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1608120,int_stack+1537140,int_stack+1013250,78);
 /*--- compute (o0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1699380,int_stack+1608120,int_stack+1459920,78);
 /*--- compute (o0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+1459920,int_stack+133608,int_stack+123000,78);
 /*--- compute (o0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+988680,int_stack+1459920,int_stack+1074090,78);
 /*--- compute (o0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1807488,int_stack+988680,int_stack+1102170,78);
 /*--- compute (o0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1044840,int_stack+1807488,int_stack+1537140,78);
 /*--- compute (o0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1889388,int_stack+1044840,int_stack+1608120,78);
 /*--- compute (o0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1491744,int_stack+1889388,int_stack+1699380,78);
 /*--- compute (o0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+1635888,int_stack+145542,int_stack+133608,78);
 /*--- compute (o0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+1671690,int_stack+1635888,int_stack+1459920,78);
 /*--- compute (o0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+2017152,int_stack+1671690,int_stack+988680,78);
 /*--- compute (o0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+2110752,int_stack+2017152,int_stack+1807488,78);
 /*--- compute (o0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1735338,int_stack+2110752,int_stack+1044840,78);
 /*--- compute (o0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+988680,int_stack+1735338,int_stack+1889388,78);
 /*--- compute (o0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+2233602,int_stack+988680,int_stack+1491744,78);
 /*--- compute (o0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+1159032,int_stack+158880,int_stack+145542,78);
 /*--- compute (o0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+1459920,int_stack+1159032,int_stack+1635888,78);
 /*--- compute (o0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+1531524,int_stack+1459920,int_stack+1671690,78);
 /*--- compute (o0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+2418930,int_stack+1531524,int_stack+2017152,78);
 /*--- compute (o0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+1884396,int_stack+2418930,int_stack+2110752,78);
 /*--- compute (o0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+2559330,int_stack+1884396,int_stack+1735338,78);
 /*--- compute (o0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+1637604,int_stack+2559330,int_stack+988680,78);
 /*--- compute (o0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+2758074,int_stack+1637604,int_stack+2233602,78);
 /*--- compute (o0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+988680,int_stack+173700,int_stack+158880,78);
 /*--- compute (o0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+1033140,int_stack+988680,int_stack+1159032,78);
 /*--- compute (o0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+2056386,int_stack+1033140,int_stack+1459920,78);
 /*--- compute (o0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+988680,int_stack+2056386,int_stack+1531524,78);
 /*--- compute (o0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+2056386,int_stack+988680,int_stack+2418930,78);
 /*--- compute (o0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+988680,int_stack+2056386,int_stack+1884396,78);
 /*--- compute (o0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+1856628,int_stack+988680,int_stack+2559330,78);
 /*--- compute (o0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+2112156,int_stack+1856628,int_stack+1637604,78);
 /*--- compute (o0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+1459920,int_stack+2112156,int_stack+2758074,78);
 /*--- compute (np|nm) ---*/
 hrr1_build_np(Libint->AB,int_stack+1743060,int_stack+1459920,int_stack+1220340,3630);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+988680,int_stack+196086,int_stack+190080,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+1006698,int_stack+203184,int_stack+196086,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+1027992,int_stack+1006698,int_stack+988680,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+1064028,int_stack+211465,int_stack+203184,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+1088871,int_stack+1064028,int_stack+1006698,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+1131459,int_stack+1088871,int_stack+1027992,91);
 /*--- compute (q0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+988680,int_stack+221020,int_stack+211465,91);
 /*--- compute (q0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+1191519,int_stack+988680,int_stack+1064028,91);
 /*--- compute (q0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1017345,int_stack+1191519,int_stack+1088871,91);
 /*--- compute (q0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1241205,int_stack+1017345,int_stack+1131459,91);
 /*--- compute (q0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+1088325,int_stack+231940,int_stack+221020,91);
 /*--- compute (q0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+1121085,int_stack+1088325,int_stack+988680,91);
 /*--- compute (q0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1331295,int_stack+1121085,int_stack+1191519,91);
 /*--- compute (q0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+2461800,int_stack+1331295,int_stack+1017345,91);
 /*--- compute (q0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+2568270,int_stack+2461800,int_stack+1241205,91);
 /*--- compute (q0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+988680,int_stack+244316,int_stack+231940,91);
 /*--- compute (q0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1178415,int_stack+988680,int_stack+1088325,91);
 /*--- compute (q0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+2694396,int_stack+1178415,int_stack+1121085,91);
 /*--- compute (q0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1025808,int_stack+2694396,int_stack+1331295,91);
 /*--- compute (q0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1243935,int_stack+1025808,int_stack+2461800,91);
 /*--- compute (q0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+2789946,int_stack+1243935,int_stack+2568270,91);
 /*--- compute (q0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+2461800,int_stack+258239,int_stack+244316,91);
 /*--- compute (q0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+2503569,int_stack+2461800,int_stack+988680,91);
 /*--- compute (q0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+2577825,int_stack+2503569,int_stack+1178415,91);
 /*--- compute (q0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+0,int_stack+2577825,int_stack+2694396,91);
 /*--- compute (q0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+2958114,int_stack+0,int_stack+1025808,91);
 /*--- compute (q0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+988680,int_stack+2958114,int_stack+1243935,91);
 /*--- compute (q0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1187424,int_stack+988680,int_stack+2789946,91);
 /*--- compute (q0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+1403640,int_stack+273800,int_stack+258239,91);
 /*--- compute (q0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+2687025,int_stack+1403640,int_stack+2461800,91);
 /*--- compute (q0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+2770563,int_stack+2687025,int_stack+2503569,91);
 /*--- compute (q0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+3132015,int_stack+2770563,int_stack+2577825,91);
 /*--- compute (q0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+2461800,int_stack+3132015,int_stack+0,91);
 /*--- compute (q0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+0,int_stack+2461800,int_stack+2958114,91);
 /*--- compute (q0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+3295815,int_stack+0,int_stack+988680,91);
 /*--- compute (q0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+3551343,int_stack+3295815,int_stack+1187424,91);
 /*--- compute (q0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+988680,int_stack+291090,int_stack+273800,91);
 /*--- compute (q0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+1040550,int_stack+988680,int_stack+1403640,91);
 /*--- compute (q0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+1133916,int_stack+1040550,int_stack+2687025,91);
 /*--- compute (q0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+1273146,int_stack+1133916,int_stack+2770563,91);
 /*--- compute (q0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+988680,int_stack+1273146,int_stack+3132015,91);
 /*--- compute (q0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+2662455,int_stack+988680,int_stack+2461800,91);
 /*--- compute (q0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+988680,int_stack+2662455,int_stack+0,91);
 /*--- compute (q0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+2461800,int_stack+988680,int_stack+3295815,91);
 /*--- compute (q0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+988680,int_stack+2461800,int_stack+3551343,91);
 /*--- compute (op|nm) ---*/
 hrr1_build_op(Libint->AB,int_stack+2461800,int_stack+988680,int_stack+1459920,3630);
 /*--- compute (nd|nm) ---*/
 hrr1_build_nd(Libint->AB,int_stack+3311220,int_stack+2461800,int_stack+1743060,3630);
 /*--- compute (r0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+1319010,int_stack+317130,int_stack+310200,105);
 /*--- compute (r0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+1339800,int_stack+325320,int_stack+317130,105);
 /*--- compute (r0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+1364370,int_stack+1339800,int_stack+1319010,105);
 /*--- compute (r0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+1405950,int_stack+334875,int_stack+325320,105);
 /*--- compute (r0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+1434615,int_stack+1405950,int_stack+1339800,105);
 /*--- compute (r0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+1483755,int_stack+1434615,int_stack+1364370,105);
 /*--- compute (r0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+1319010,int_stack+345900,int_stack+334875,105);
 /*--- compute (r0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+1553055,int_stack+1319010,int_stack+1405950,105);
 /*--- compute (r0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1352085,int_stack+1553055,int_stack+1434615,105);
 /*--- compute (r0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1610385,int_stack+1352085,int_stack+1483755,105);
 /*--- compute (r0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+1433985,int_stack+358500,int_stack+345900,105);
 /*--- compute (r0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+1471785,int_stack+1433985,int_stack+1319010,105);
 /*--- compute (r0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1714335,int_stack+1471785,int_stack+1553055,105);
 /*--- compute (r0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1809885,int_stack+1714335,int_stack+1352085,105);
 /*--- compute (r0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1932735,int_stack+1809885,int_stack+1610385,105);
 /*--- compute (r0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+1319010,int_stack+372780,int_stack+358500,105);
 /*--- compute (r0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1537935,int_stack+1319010,int_stack+1433985,105);
 /*--- compute (r0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+2078265,int_stack+1537935,int_stack+1471785,105);
 /*--- compute (r0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1361850,int_stack+2078265,int_stack+1714335,105);
 /*--- compute (r0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1613535,int_stack+1361850,int_stack+1809885,105);
 /*--- compute (r0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+2188515,int_stack+1613535,int_stack+1932735,105);
 /*--- compute (r0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+1785525,int_stack+388845,int_stack+372780,105);
 /*--- compute (r0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+1833720,int_stack+1785525,int_stack+1319010,105);
 /*--- compute (r0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1919400,int_stack+1833720,int_stack+1537935,105);
 /*--- compute (r0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+0,int_stack+1919400,int_stack+2078265,105);
 /*--- compute (r0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+165375,int_stack+0,int_stack+1361850,105);
 /*--- compute (r0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1319010,int_stack+165375,int_stack+1613535,105);
 /*--- compute (r0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+4748700,int_stack+1319010,int_stack+2188515,105);
 /*--- compute (r0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+1548330,int_stack+406800,int_stack+388845,105);
 /*--- compute (r0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+1602195,int_stack+1548330,int_stack+1785525,105);
 /*--- compute (r0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+2045400,int_stack+1602195,int_stack+1833720,105);
 /*--- compute (r0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+1698585,int_stack+2045400,int_stack+1919400,105);
 /*--- compute (r0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+2188200,int_stack+1698585,int_stack+0,105);
 /*--- compute (r0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+4998180,int_stack+2188200,int_stack+165375,105);
 /*--- compute (r0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+0,int_stack+4998180,int_stack+1319010,105);
 /*--- compute (r0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+5265720,int_stack+0,int_stack+4748700,105);
 /*--- compute (r0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+4748700,int_stack+426750,int_stack+406800,105);
 /*--- compute (r0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+4808550,int_stack+4748700,int_stack+1548330,105);
 /*--- compute (r0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+1319010,int_stack+4808550,int_stack+1602195,105);
 /*--- compute (r0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+4748700,int_stack+1319010,int_stack+2045400,105);
 /*--- compute (r0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+1319010,int_stack+4748700,int_stack+1698585,105);
 /*--- compute (r0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+1583610,int_stack+1319010,int_stack+2188200,105);
 /*--- compute (r0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+1892310,int_stack+1583610,int_stack+4998180,105);
 /*--- compute (r0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+1319010,int_stack+1892310,int_stack+0,105);
 /*--- compute (r0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+0,int_stack+1319010,int_stack+5265720,105);
 /*--- compute (qp|nm) ---*/
 hrr1_build_qp(Libint->AB,int_stack+1319010,int_stack+0,int_stack+988680,3630);
 /*--- compute (od|nm) ---*/
 hrr1_build_od(Libint->AB,int_stack+4748700,int_stack+1319010,int_stack+2461800,3630);
 /*--- compute (nf|nm) ---*/
 hrr1_build_nf(Libint->AB,int_stack+6447540,int_stack+4748700,int_stack+3311220,3630);
 /*--- compute (t0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+988680,int_stack+456720,int_stack+448800,120);
 /*--- compute (t0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+1012440,int_stack+466080,int_stack+456720,120);
 /*--- compute (t0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+1040520,int_stack+1012440,int_stack+988680,120);
 /*--- compute (t0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+1088040,int_stack+477000,int_stack+466080,120);
 /*--- compute (t0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+1120800,int_stack+1088040,int_stack+1012440,120);
 /*--- compute (t0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+1176960,int_stack+1120800,int_stack+1040520,120);
 /*--- compute (t0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+988680,int_stack+489600,int_stack+477000,120);
 /*--- compute (t0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+2310000,int_stack+988680,int_stack+1088040,120);
 /*--- compute (t0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1026480,int_stack+2310000,int_stack+1120800,120);
 /*--- compute (t0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+2375520,int_stack+1026480,int_stack+1176960,120);
 /*--- compute (t0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+1120080,int_stack+504000,int_stack+489600,120);
 /*--- compute (t0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+1163280,int_stack+1120080,int_stack+988680,120);
 /*--- compute (t0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+2494320,int_stack+1163280,int_stack+2310000,120);
 /*--- compute (t0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+2603520,int_stack+2494320,int_stack+1026480,120);
 /*--- compute (t0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+2743920,int_stack+2603520,int_stack+2375520,120);
 /*--- compute (t0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+2310000,int_stack+520320,int_stack+504000,120);
 /*--- compute (t0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+2358960,int_stack+2310000,int_stack+1120080,120);
 /*--- compute (t0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+988680,int_stack+2358960,int_stack+1163280,120);
 /*--- compute (t0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1114680,int_stack+988680,int_stack+2494320,120);
 /*--- compute (t0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+2910240,int_stack+1114680,int_stack+2603520,120);
 /*--- compute (t0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+2445360,int_stack+2910240,int_stack+2743920,120);
 /*--- compute (t0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+2667120,int_stack+538680,int_stack+520320,120);
 /*--- compute (t0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+2722200,int_stack+2667120,int_stack+2310000,120);
 /*--- compute (t0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+3106800,int_stack+2722200,int_stack+2358960,120);
 /*--- compute (t0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+3250800,int_stack+3106800,int_stack+988680,120);
 /*--- compute (t0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+3439800,int_stack+3250800,int_stack+1114680,120);
 /*--- compute (t0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+988680,int_stack+3439800,int_stack+2910240,120);
 /*--- compute (t0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+2820120,int_stack+988680,int_stack+2445360,120);
 /*--- compute (t0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+1250760,int_stack+559200,int_stack+538680,120);
 /*--- compute (t0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+2310000,int_stack+1250760,int_stack+2667120,120);
 /*--- compute (t0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+2420160,int_stack+2310000,int_stack+2722200,120);
 /*--- compute (t0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+2583360,int_stack+2420160,int_stack+3106800,120);
 /*--- compute (t0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+3669120,int_stack+2583360,int_stack+3250800,120);
 /*--- compute (t0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+3105240,int_stack+3669120,int_stack+3439800,120);
 /*--- compute (t0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+3933720,int_stack+3105240,int_stack+988680,120);
 /*--- compute (t0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+4270680,int_stack+3933720,int_stack+2820120,120);
 /*--- compute (t0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+988680,int_stack+582000,int_stack+559200,120);
 /*--- compute (t0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+1057080,int_stack+988680,int_stack+1250760,120);
 /*--- compute (t0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+2799360,int_stack+1057080,int_stack+2310000,120);
 /*--- compute (t0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+988680,int_stack+2799360,int_stack+2420160,120);
 /*--- compute (t0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+2799360,int_stack+988680,int_stack+2583360,120);
 /*--- compute (t0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+2310000,int_stack+2799360,int_stack+3669120,120);
 /*--- compute (t0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+2662800,int_stack+2310000,int_stack+3105240,120);
 /*--- compute (t0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+3055920,int_stack+2662800,int_stack+3933720,120);
 /*--- compute (t0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+2310000,int_stack+3055920,int_stack+4270680,120);
 /*--- compute (rp|nm) ---*/
 hrr1_build_rp(Libint->AB,int_stack+2745600,int_stack+2310000,int_stack+0,3630);
 /*--- compute (qd|nm) ---*/
 hrr1_build_qd(Libint->AB,int_stack+8843340,int_stack+2745600,int_stack+1319010,3630);
 /*--- compute (of|nm) ---*/
 hrr1_build_of(Libint->AB,int_stack+10825320,int_stack+8843340,int_stack+4748700,3630);
 /*--- compute (ng|nm) ---*/
 hrr1_build_ng(Libint->AB,int_stack+13656720,int_stack+10825320,int_stack+6447540,3630);
 /*--- compute (u0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+616176,int_stack+607200,136);
 /*--- compute (u0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+26928,int_stack+626784,int_stack+616176,136);
 /*--- compute (u0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+58752,int_stack+26928,int_stack+0,136);
 /*--- compute (u0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+112608,int_stack+639160,int_stack+626784,136);
 /*--- compute (u0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+149736,int_stack+112608,int_stack+26928,136);
 /*--- compute (u0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+213384,int_stack+149736,int_stack+58752,136);
 /*--- compute (u0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+653440,int_stack+639160,136);
 /*--- compute (u0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+303144,int_stack+0,int_stack+112608,136);
 /*--- compute (u0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+42840,int_stack+303144,int_stack+149736,136);
 /*--- compute (u0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+377400,int_stack+42840,int_stack+213384,136);
 /*--- compute (u0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+148920,int_stack+669760,int_stack+653440,136);
 /*--- compute (u0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+197880,int_stack+148920,int_stack+0,136);
 /*--- compute (u0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+512040,int_stack+197880,int_stack+303144,136);
 /*--- compute (u0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+3889050,int_stack+512040,int_stack+42840,136);
 /*--- compute (u0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+4048170,int_stack+3889050,int_stack+377400,136);
 /*--- compute (u0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+0,int_stack+688256,int_stack+669760,136);
 /*--- compute (u0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+283560,int_stack+0,int_stack+148920,136);
 /*--- compute (u0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+4236666,int_stack+283560,int_stack+197880,136);
 /*--- compute (u0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+55488,int_stack+4236666,int_stack+512040,136);
 /*--- compute (u0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+381480,int_stack+55488,int_stack+3889050,136);
 /*--- compute (u0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+4379466,int_stack+381480,int_stack+4048170,136);
 /*--- compute (u0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+3889050,int_stack+709064,int_stack+688256,136);
 /*--- compute (u0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+3951474,int_stack+3889050,int_stack+0,136);
 /*--- compute (u0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+4062450,int_stack+3951474,int_stack+283560,136);
 /*--- compute (u0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+4630794,int_stack+4062450,int_stack+4236666,136);
 /*--- compute (u0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+4844994,int_stack+4630794,int_stack+55488,136);
 /*--- compute (u0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+0,int_stack+4844994,int_stack+381480,136);
 /*--- compute (u0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+297024,int_stack+0,int_stack+4379466,136);
 /*--- compute (u0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+620160,int_stack+732320,int_stack+709064,136);
 /*--- compute (u0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+4225650,int_stack+620160,int_stack+3889050,136);
 /*--- compute (u0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+4350498,int_stack+4225650,int_stack+3951474,136);
 /*--- compute (u0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+5104890,int_stack+4350498,int_stack+4062450,136);
 /*--- compute (u0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+3889050,int_stack+5104890,int_stack+4630794,136);
 /*--- compute (u0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+5349690,int_stack+3889050,int_stack+4844994,136);
 /*--- compute (u0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+4535458,int_stack+5349690,int_stack+0,136);
 /*--- compute (u0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+5696218,int_stack+4535458,int_stack+297024,136);
 /*--- compute (u0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+0,int_stack+758160,int_stack+732320,136);
 /*--- compute (u0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+77520,int_stack+0,int_stack+620160,136);
 /*--- compute (u0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+217056,int_stack+77520,int_stack+4225650,136);
 /*--- compute (u0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+425136,int_stack+217056,int_stack+4350498,136);
 /*--- compute (u0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+0,int_stack+425136,int_stack+5104890,136);
 /*--- compute (u0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+342720,int_stack+0,int_stack+3889050,136);
 /*--- compute (u0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+3889050,int_stack+342720,int_stack+5349690,136);
 /*--- compute (u0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+0,int_stack+3889050,int_stack+4535458,136);
 /*--- compute (u0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+3889050,int_stack+0,int_stack+5696218,136);
 /*--- compute (tp|nm) ---*/
 hrr1_build_tp(Libint->AB,int_stack+4382730,int_stack+3889050,int_stack+2310000,3630);
 /*--- compute (rd|nm) ---*/
 hrr1_build_rd(Libint->AB,int_stack+5689530,int_stack+4382730,int_stack+2745600,3630);
 /*--- compute (qf|nm) ---*/
 hrr1_build_qf(Libint->AB,int_stack+17250420,int_stack+5689530,int_stack+8843340,3630);
 /*--- compute (og|nm) ---*/
 hrr1_build_og(Libint->AB,int_stack+20553720,int_stack+17250420,int_stack+10825320,3630);
 /*--- compute (nh|nm) ---*/
 hrr1_build_nh(Libint->AB,int_stack+7976430,int_stack+20553720,int_stack+13656720,3630);
 /*--- compute (v0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+796818,int_stack+786720,153);
 /*--- compute (v0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+30294,int_stack+808752,int_stack+796818,153);
 /*--- compute (v0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+66096,int_stack+30294,int_stack+0,153);
 /*--- compute (v0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+126684,int_stack+822675,int_stack+808752,153);
 /*--- compute (v0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+168453,int_stack+126684,int_stack+30294,153);
 /*--- compute (v0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+240057,int_stack+168453,int_stack+66096,153);
 /*--- compute (v0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+838740,int_stack+822675,153);
 /*--- compute (v0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+341037,int_stack+0,int_stack+126684,153);
 /*--- compute (v0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+48195,int_stack+341037,int_stack+168453,153);
 /*--- compute (v0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+424575,int_stack+48195,int_stack+240057,153);
 /*--- compute (v0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+167535,int_stack+857100,int_stack+838740,153);
 /*--- compute (v0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+222615,int_stack+167535,int_stack+0,153);
 /*--- compute (v0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+576045,int_stack+222615,int_stack+341037,153);
 /*--- compute (v0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+13007610,int_stack+576045,int_stack+48195,153);
 /*--- compute (v0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+13186620,int_stack+13007610,int_stack+424575,153);
 /*--- compute (v0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+0,int_stack+877908,int_stack+857100,153);
 /*--- compute (v0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+319005,int_stack+0,int_stack+167535,153);
 /*--- compute (v0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+715275,int_stack+319005,int_stack+222615,153);
 /*--- compute (v0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+62424,int_stack+715275,int_stack+576045,153);
 /*--- compute (v0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+429165,int_stack+62424,int_stack+13007610,153);
 /*--- compute (v0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+13398678,int_stack+429165,int_stack+13186620,153);
 /*--- compute (v0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+13007610,int_stack+901317,int_stack+877908,153);
 /*--- compute (v0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+13077837,int_stack+13007610,int_stack+0,153);
 /*--- compute (v0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+13202685,int_stack+13077837,int_stack+319005,153);
 /*--- compute (v0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+13681422,int_stack+13202685,int_stack+715275,153);
 /*--- compute (v0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+13922397,int_stack+13681422,int_stack+62424,153);
 /*--- compute (v0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+0,int_stack+13922397,int_stack+429165,153);
 /*--- compute (v0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+334152,int_stack+0,int_stack+13398678,153);
 /*--- compute (v0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+697680,int_stack+927480,int_stack+901317,153);
 /*--- compute (v0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+776169,int_stack+697680,int_stack+13007610,153);
 /*--- compute (v0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+13386285,int_stack+776169,int_stack+13077837,153);
 /*--- compute (v0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+14214780,int_stack+13386285,int_stack+13202685,153);
 /*--- compute (v0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+13007610,int_stack+14214780,int_stack+13681422,153);
 /*--- compute (v0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+14490180,int_stack+13007610,int_stack+13922397,153);
 /*--- compute (v0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+13594365,int_stack+14490180,int_stack+0,153);
 /*--- compute (v0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+14880024,int_stack+13594365,int_stack+334152,153);
 /*--- compute (v0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+0,int_stack+956550,int_stack+927480,153);
 /*--- compute (v0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+87210,int_stack+0,int_stack+697680,153);
 /*--- compute (v0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+244188,int_stack+87210,int_stack+776169,153);
 /*--- compute (v0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+478278,int_stack+244188,int_stack+13386285,153);
 /*--- compute (v0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+0,int_stack+478278,int_stack+14214780,153);
 /*--- compute (v0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+385560,int_stack+0,int_stack+13007610,153);
 /*--- compute (v0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+13007610,int_stack+385560,int_stack+14490180,153);
 /*--- compute (v0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+0,int_stack+13007610,int_stack+13594365,153);
 /*--- compute (v0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+13007610,int_stack+0,int_stack+14880024,153);
 /*--- compute (up|nm) ---*/
 hrr1_build_up(Libint->AB,int_stack+0,int_stack+13007610,int_stack+3889050,3630);
 /*--- compute (td|nm) ---*/
 hrr1_build_td(Libint->AB,int_stack+13007610,int_stack+0,int_stack+4382730,3630);
 /*--- compute (rf|nm) ---*/
 hrr1_build_rf(Libint->AB,int_stack+0,int_stack+13007610,int_stack+5689530,3630);
 /*--- compute (qg|nm) ---*/
 hrr1_build_qg(Libint->AB,int_stack+24800820,int_stack+0,int_stack+17250420,3630);
 /*--- compute (oh|nm) ---*/
 hrr1_build_oh(Libint->AB,int_stack+0,int_stack+24800820,int_stack+20553720,3630);
 /*--- compute (ni|nm) ---*/
 hrr1_build_ni(Libint->AB,int_stack+13007610,int_stack+0,int_stack+7976430,3630);
 return int_stack+13007610;}
