/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_nkml(Libint_t*, prim_data*);

  /* Computes quartets of (nk|ml) integrals */

REALTYPE *hrr_order_nkml(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[10][9] = int_stack + 0;
 Libint->vrr_classes[10][10] = int_stack + 3630;
 Libint->vrr_classes[10][11] = int_stack + 7986;
 Libint->vrr_classes[10][12] = int_stack + 13134;
 Libint->vrr_classes[10][13] = int_stack + 19140;
 Libint->vrr_classes[10][14] = int_stack + 26070;
 Libint->vrr_classes[10][15] = int_stack + 33990;
 Libint->vrr_classes[10][16] = int_stack + 42966;
 Libint->vrr_classes[10][17] = int_stack + 53064;
 Libint->vrr_classes[11][9] = int_stack + 64350;
 Libint->vrr_classes[11][10] = int_stack + 68640;
 Libint->vrr_classes[11][11] = int_stack + 73788;
 Libint->vrr_classes[11][12] = int_stack + 79872;
 Libint->vrr_classes[11][13] = int_stack + 86970;
 Libint->vrr_classes[11][14] = int_stack + 95160;
 Libint->vrr_classes[11][15] = int_stack + 104520;
 Libint->vrr_classes[11][16] = int_stack + 115128;
 Libint->vrr_classes[11][17] = int_stack + 127062;
 Libint->vrr_classes[12][9] = int_stack + 140400;
 Libint->vrr_classes[12][10] = int_stack + 145405;
 Libint->vrr_classes[12][11] = int_stack + 151411;
 Libint->vrr_classes[12][12] = int_stack + 158509;
 Libint->vrr_classes[12][13] = int_stack + 166790;
 Libint->vrr_classes[12][14] = int_stack + 176345;
 Libint->vrr_classes[12][15] = int_stack + 187265;
 Libint->vrr_classes[12][16] = int_stack + 199641;
 Libint->vrr_classes[12][17] = int_stack + 213564;
 Libint->vrr_classes[13][9] = int_stack + 229125;
 Libint->vrr_classes[13][10] = int_stack + 234900;
 Libint->vrr_classes[13][11] = int_stack + 241830;
 Libint->vrr_classes[13][12] = int_stack + 250020;
 Libint->vrr_classes[13][13] = int_stack + 259575;
 Libint->vrr_classes[13][14] = int_stack + 270600;
 Libint->vrr_classes[13][15] = int_stack + 283200;
 Libint->vrr_classes[13][16] = int_stack + 297480;
 Libint->vrr_classes[13][17] = int_stack + 313545;
 Libint->vrr_classes[14][9] = int_stack + 331500;
 Libint->vrr_classes[14][10] = int_stack + 338100;
 Libint->vrr_classes[14][11] = int_stack + 346020;
 Libint->vrr_classes[14][12] = int_stack + 355380;
 Libint->vrr_classes[14][13] = int_stack + 366300;
 Libint->vrr_classes[14][14] = int_stack + 378900;
 Libint->vrr_classes[14][15] = int_stack + 393300;
 Libint->vrr_classes[14][16] = int_stack + 409620;
 Libint->vrr_classes[14][17] = int_stack + 427980;
 Libint->vrr_classes[15][9] = int_stack + 448500;
 Libint->vrr_classes[15][10] = int_stack + 455980;
 Libint->vrr_classes[15][11] = int_stack + 464956;
 Libint->vrr_classes[15][12] = int_stack + 475564;
 Libint->vrr_classes[15][13] = int_stack + 487940;
 Libint->vrr_classes[15][14] = int_stack + 502220;
 Libint->vrr_classes[15][15] = int_stack + 518540;
 Libint->vrr_classes[15][16] = int_stack + 537036;
 Libint->vrr_classes[15][17] = int_stack + 557844;
 Libint->vrr_classes[16][9] = int_stack + 581100;
 Libint->vrr_classes[16][10] = int_stack + 589515;
 Libint->vrr_classes[16][11] = int_stack + 599613;
 Libint->vrr_classes[16][12] = int_stack + 611547;
 Libint->vrr_classes[16][13] = int_stack + 625470;
 Libint->vrr_classes[16][14] = int_stack + 641535;
 Libint->vrr_classes[16][15] = int_stack + 659895;
 Libint->vrr_classes[16][16] = int_stack + 680703;
 Libint->vrr_classes[16][17] = int_stack + 704112;
 Libint->vrr_classes[17][9] = int_stack + 730275;
 Libint->vrr_classes[17][10] = int_stack + 739680;
 Libint->vrr_classes[17][11] = int_stack + 750966;
 Libint->vrr_classes[17][12] = int_stack + 764304;
 Libint->vrr_classes[17][13] = int_stack + 779865;
 Libint->vrr_classes[17][14] = int_stack + 797820;
 Libint->vrr_classes[17][15] = int_stack + 818340;
 Libint->vrr_classes[17][16] = int_stack + 841596;
 Libint->vrr_classes[17][17] = int_stack + 867759;
 memset(int_stack,0,897000*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 897000;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_nkml(Libint, Data);
   Data++;
 }
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+897000,int_stack+3630,int_stack+0,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+907890,int_stack+7986,int_stack+3630,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+920958,int_stack+907890,int_stack+897000,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+942738,int_stack+13134,int_stack+7986,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+958182,int_stack+942738,int_stack+907890,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+984318,int_stack+958182,int_stack+920958,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+897000,int_stack+19140,int_stack+13134,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+1020618,int_stack+897000,int_stack+942738,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+1051506,int_stack+1020618,int_stack+958182,66);
 /*--- compute (n0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+915018,int_stack+1051506,int_stack+984318,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+969468,int_stack+26070,int_stack+19140,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+1095066,int_stack+969468,int_stack+897000,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1131102,int_stack+1095066,int_stack+1020618,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1182582,int_stack+1131102,int_stack+1051506,66);
 /*--- compute (n0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+990258,int_stack+1182582,int_stack+915018,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+897000,int_stack+33990,int_stack+26070,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+920760,int_stack+897000,int_stack+969468,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1247922,int_stack+920760,int_stack+1095066,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1307982,int_stack+1247922,int_stack+1131102,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1066488,int_stack+1307982,int_stack+1182582,66);
 /*--- compute (n0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+1385202,int_stack+1066488,int_stack+990258,66);
 /*--- compute (n0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+962340,int_stack+42966,int_stack+33990,66);
 /*--- compute (n0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+989268,int_stack+962340,int_stack+897000,66);
 /*--- compute (n0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1157964,int_stack+989268,int_stack+920760,66);
 /*--- compute (n0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1486842,int_stack+1157964,int_stack+1247922,66);
 /*--- compute (n0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1576932,int_stack+1486842,int_stack+1307982,66);
 /*--- compute (n0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1227264,int_stack+1576932,int_stack+1066488,66);
 /*--- compute (n0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+1685040,int_stack+1227264,int_stack+1385202,66);
 /*--- compute (n0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+897000,int_stack+53064,int_stack+42966,66);
 /*--- compute (n0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+1036788,int_stack+897000,int_stack+962340,66);
 /*--- compute (n0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+897000,int_stack+1036788,int_stack+989268,66);
 /*--- compute (n0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+976200,int_stack+897000,int_stack+1157964,66);
 /*--- compute (n0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1080150,int_stack+976200,int_stack+1486842,66);
 /*--- compute (n0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+897000,int_stack+1080150,int_stack+1576932,66);
 /*--- compute (n0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1041144,int_stack+897000,int_stack+1227264,66);
 /*--- compute (n0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+1197960,int_stack+1041144,int_stack+1685040,66);
 /*--- compute (o0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+897000,int_stack+68640,int_stack+64350,78);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+909870,int_stack+73788,int_stack+68640,78);
 /*--- compute (o0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+925314,int_stack+909870,int_stack+897000,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+951054,int_stack+79872,int_stack+73788,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+969306,int_stack+951054,int_stack+909870,78);
 /*--- compute (o0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+1000194,int_stack+969306,int_stack+925314,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+897000,int_stack+86970,int_stack+79872,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+1043094,int_stack+897000,int_stack+951054,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+1079598,int_stack+1043094,int_stack+969306,78);
 /*--- compute (o0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+918294,int_stack+1079598,int_stack+1000194,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+982644,int_stack+95160,int_stack+86970,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+1131078,int_stack+982644,int_stack+897000,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1361310,int_stack+1131078,int_stack+1043094,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1422150,int_stack+1361310,int_stack+1079598,78);
 /*--- compute (o0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+1007214,int_stack+1422150,int_stack+918294,78);
 /*--- compute (o0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+897000,int_stack+104520,int_stack+95160,78);
 /*--- compute (o0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+925080,int_stack+897000,int_stack+982644,78);
 /*--- compute (o0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1499370,int_stack+925080,int_stack+1131078,78);
 /*--- compute (o0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1097304,int_stack+1499370,int_stack+1361310,78);
 /*--- compute (o0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1570350,int_stack+1097304,int_stack+1422150,78);
 /*--- compute (o0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+1361310,int_stack+1570350,int_stack+1007214,78);
 /*--- compute (o0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+974220,int_stack+115128,int_stack+104520,78);
 /*--- compute (o0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1006044,int_stack+974220,int_stack+897000,78);
 /*--- compute (o0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1678458,int_stack+1006044,int_stack+925080,78);
 /*--- compute (o0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+0,int_stack+1678458,int_stack+1499370,78);
 /*--- compute (o0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1760358,int_stack+0,int_stack+1097304,78);
 /*--- compute (o0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1888122,int_stack+1760358,int_stack+1570350,78);
 /*--- compute (o0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+1481430,int_stack+1888122,int_stack+1361310,78);
 /*--- compute (o0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+1361310,int_stack+127062,int_stack+115128,78);
 /*--- compute (o0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+1397112,int_stack+1361310,int_stack+974220,78);
 /*--- compute (o0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+897000,int_stack+1397112,int_stack+1006044,78);
 /*--- compute (o0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+990600,int_stack+897000,int_stack+1678458,78);
 /*--- compute (o0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+2032266,int_stack+990600,int_stack+0,78);
 /*--- compute (o0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+897000,int_stack+2032266,int_stack+1760358,78);
 /*--- compute (o0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1635870,int_stack+897000,int_stack+1888122,78);
 /*--- compute (o0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+897000,int_stack+1635870,int_stack+1481430,78);
 /*--- compute (np|ml) ---*/
 hrr1_build_np(Libint->AB,int_stack+1361310,int_stack+897000,int_stack+1197960,2475);
 /*--- compute (q0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+1090050,int_stack+145405,int_stack+140400,91);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+1105065,int_stack+151411,int_stack+145405,91);
 /*--- compute (q0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+1123083,int_stack+1105065,int_stack+1090050,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+1153113,int_stack+158509,int_stack+151411,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+1174407,int_stack+1153113,int_stack+1105065,91);
 /*--- compute (q0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+1210443,int_stack+1174407,int_stack+1123083,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+1090050,int_stack+166790,int_stack+158509,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+1260493,int_stack+1090050,int_stack+1153113,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+0,int_stack+1260493,int_stack+1174407,91);
 /*--- compute (q0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+1114893,int_stack+0,int_stack+1210443,91);
 /*--- compute (q0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+1189968,int_stack+176345,int_stack+166790,91);
 /*--- compute (q0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+1303081,int_stack+1189968,int_stack+1090050,91);
 /*--- compute (q0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+60060,int_stack+1303081,int_stack+1260493,91);
 /*--- compute (q0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1851360,int_stack+60060,int_stack+0,91);
 /*--- compute (q0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+1941450,int_stack+1851360,int_stack+1114893,91);
 /*--- compute (q0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+0,int_stack+187265,int_stack+176345,91);
 /*--- compute (q0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+1090050,int_stack+0,int_stack+1189968,91);
 /*--- compute (q0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1147380,int_stack+1090050,int_stack+1303081,91);
 /*--- compute (q0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1230190,int_stack+1147380,int_stack+60060,91);
 /*--- compute (q0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+32760,int_stack+1230190,int_stack+1851360,91);
 /*--- compute (q0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+2046555,int_stack+32760,int_stack+1941450,91);
 /*--- compute (q0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+1851360,int_stack+199641,int_stack+187265,91);
 /*--- compute (q0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1888488,int_stack+1851360,int_stack+0,91);
 /*--- compute (q0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+2186695,int_stack+1888488,int_stack+1090050,91);
 /*--- compute (q0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+2282245,int_stack+2186695,int_stack+1147380,91);
 /*--- compute (q0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+2406460,int_stack+2282245,int_stack+1230190,91);
 /*--- compute (q0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1090050,int_stack+2406460,int_stack+32760,91);
 /*--- compute (q0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+0,int_stack+1090050,int_stack+2046555,91);
 /*--- compute (q0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+1258218,int_stack+213564,int_stack+199641,91);
 /*--- compute (q0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+1954008,int_stack+1258218,int_stack+1851360,91);
 /*--- compute (q0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+2028264,int_stack+1954008,int_stack+1888488,91);
 /*--- compute (q0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1851360,int_stack+2028264,int_stack+2186695,91);
 /*--- compute (q0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1994685,int_stack+1851360,int_stack+2282245,91);
 /*--- compute (q0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+2168586,int_stack+1994685,int_stack+2406460,91);
 /*--- compute (q0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1851360,int_stack+2168586,int_stack+1090050,91);
 /*--- compute (q0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+1090050,int_stack+1851360,int_stack+0,91);
 /*--- compute (op|ml) ---*/
 hrr1_build_op(Libint->AB,int_stack+1851360,int_stack+1090050,int_stack+897000,2475);
 /*--- compute (nd|ml) ---*/
 hrr1_build_nd(Libint->AB,int_stack+2430510,int_stack+1851360,int_stack+1361310,2475);
 /*--- compute (r0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+897000,int_stack+234900,int_stack+229125,105);
 /*--- compute (r0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+914325,int_stack+241830,int_stack+234900,105);
 /*--- compute (r0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+935115,int_stack+914325,int_stack+897000,105);
 /*--- compute (r0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+969765,int_stack+250020,int_stack+241830,105);
 /*--- compute (r0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+994335,int_stack+969765,int_stack+914325,105);
 /*--- compute (r0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+0,int_stack+994335,int_stack+935115,105);
 /*--- compute (r0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+897000,int_stack+259575,int_stack+250020,105);
 /*--- compute (r0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+1035915,int_stack+897000,int_stack+969765,105);
 /*--- compute (r0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+57750,int_stack+1035915,int_stack+994335,105);
 /*--- compute (r0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+925665,int_stack+57750,int_stack+0,105);
 /*--- compute (r0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+270600,int_stack+259575,105);
 /*--- compute (r0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+127050,int_stack+0,int_stack+897000,105);
 /*--- compute (r0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+184380,int_stack+127050,int_stack+1035915,105);
 /*--- compute (r0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1315275,int_stack+184380,int_stack+57750,105);
 /*--- compute (r0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+1419225,int_stack+1315275,int_stack+925665,105);
 /*--- compute (r0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+897000,int_stack+283200,int_stack+270600,105);
 /*--- compute (r0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+934800,int_stack+897000,int_stack+0,105);
 /*--- compute (r0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+0,int_stack+934800,int_stack+127050,105);
 /*--- compute (r0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1540500,int_stack+0,int_stack+184380,105);
 /*--- compute (r0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+95550,int_stack+1540500,int_stack+1315275,105);
 /*--- compute (r0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+1663350,int_stack+95550,int_stack+1419225,105);
 /*--- compute (r0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+1315275,int_stack+297480,int_stack+283200,105);
 /*--- compute (r0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1358115,int_stack+1315275,int_stack+897000,105);
 /*--- compute (r0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+3410610,int_stack+1358115,int_stack+934800,105);
 /*--- compute (r0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+897000,int_stack+3410610,int_stack+0,105);
 /*--- compute (r0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+3520860,int_stack+897000,int_stack+1540500,105);
 /*--- compute (r0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1433715,int_stack+3520860,int_stack+95550,105);
 /*--- compute (r0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+0,int_stack+1433715,int_stack+1663350,105);
 /*--- compute (r0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+207900,int_stack+313545,int_stack+297480,105);
 /*--- compute (r0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+1627755,int_stack+207900,int_stack+1315275,105);
 /*--- compute (r0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1713435,int_stack+1627755,int_stack+1358115,105);
 /*--- compute (r0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+3692850,int_stack+1713435,int_stack+3410610,105);
 /*--- compute (r0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1627755,int_stack+3692850,int_stack+897000,105);
 /*--- compute (r0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+3692850,int_stack+1627755,int_stack+3520860,105);
 /*--- compute (r0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+3410610,int_stack+3692850,int_stack+1433715,105);
 /*--- compute (r0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+3660090,int_stack+3410610,int_stack+0,105);
 /*--- compute (qp|ml) ---*/
 hrr1_build_qp(Libint->AB,int_stack+3919965,int_stack+3660090,int_stack+1090050,2475);
 /*--- compute (od|ml) ---*/
 hrr1_build_od(Libint->AB,int_stack+4595640,int_stack+3919965,int_stack+1851360,2475);
 /*--- compute (nf|ml) ---*/
 hrr1_build_nf(Libint->AB,int_stack+5753940,int_stack+4595640,int_stack+2430510,2475);
 /*--- compute (t0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+0,int_stack+338100,int_stack+331500,120);
 /*--- compute (t0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+19800,int_stack+346020,int_stack+338100,120);
 /*--- compute (t0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+43560,int_stack+19800,int_stack+0,120);
 /*--- compute (t0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+83160,int_stack+355380,int_stack+346020,120);
 /*--- compute (t0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+111240,int_stack+83160,int_stack+19800,120);
 /*--- compute (t0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+158760,int_stack+111240,int_stack+43560,120);
 /*--- compute (t0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+366300,int_stack+355380,120);
 /*--- compute (t0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+224760,int_stack+0,int_stack+83160,120);
 /*--- compute (t0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+280920,int_stack+224760,int_stack+111240,120);
 /*--- compute (t0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+32760,int_stack+280920,int_stack+158760,120);
 /*--- compute (t0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+131760,int_stack+378900,int_stack+366300,120);
 /*--- compute (t0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+897000,int_stack+131760,int_stack+0,120);
 /*--- compute (t0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+962520,int_stack+897000,int_stack+224760,120);
 /*--- compute (t0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1056120,int_stack+962520,int_stack+280920,120);
 /*--- compute (t0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+169560,int_stack+1056120,int_stack+32760,120);
 /*--- compute (t0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+0,int_stack+393300,int_stack+378900,120);
 /*--- compute (t0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+43200,int_stack+0,int_stack+131760,120);
 /*--- compute (t0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1174920,int_stack+43200,int_stack+897000,120);
 /*--- compute (t0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1284120,int_stack+1174920,int_stack+962520,120);
 /*--- compute (t0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1424520,int_stack+1284120,int_stack+1056120,120);
 /*--- compute (t0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+897000,int_stack+1424520,int_stack+169560,120);
 /*--- compute (t0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+1081800,int_stack+409620,int_stack+393300,120);
 /*--- compute (t0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+118800,int_stack+1081800,int_stack+0,120);
 /*--- compute (t0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+205200,int_stack+118800,int_stack+43200,120);
 /*--- compute (t0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1590840,int_stack+205200,int_stack+1174920,120);
 /*--- compute (t0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1754640,int_stack+1590840,int_stack+1284120,120);
 /*--- compute (t0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1130760,int_stack+1754640,int_stack+1424520,120);
 /*--- compute (t0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+1352520,int_stack+1130760,int_stack+897000,120);
 /*--- compute (t0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+897000,int_stack+427980,int_stack+409620,120);
 /*--- compute (t0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+952080,int_stack+897000,int_stack+1081800,120);
 /*--- compute (t0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1951200,int_stack+952080,int_stack+118800,120);
 /*--- compute (t0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+897000,int_stack+1951200,int_stack+205200,120);
 /*--- compute (t0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1951200,int_stack+897000,int_stack+1590840,120);
 /*--- compute (t0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+2180520,int_stack+1951200,int_stack+1754640,120);
 /*--- compute (t0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+2442600,int_stack+2180520,int_stack+1130760,120);
 /*--- compute (t0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+897000,int_stack+2442600,int_stack+1352520,120);
 /*--- compute (rp|ml) ---*/
 hrr1_build_rp(Libint->AB,int_stack+1194000,int_stack+897000,int_stack+3660090,2475);
 /*--- compute (qd|ml) ---*/
 hrr1_build_qd(Libint->AB,int_stack+1973625,int_stack+1194000,int_stack+3919965,2475);
 /*--- compute (of|ml) ---*/
 hrr1_build_of(Libint->AB,int_stack+7387440,int_stack+1973625,int_stack+4595640,2475);
 /*--- compute (ng|ml) ---*/
 hrr1_build_ng(Libint->AB,int_stack+9317940,int_stack+7387440,int_stack+5753940,2475);
 /*--- compute (u0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+3324975,int_stack+455980,int_stack+448500,136);
 /*--- compute (u0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+3347415,int_stack+464956,int_stack+455980,136);
 /*--- compute (u0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+3374343,int_stack+3347415,int_stack+3324975,136);
 /*--- compute (u0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+3419223,int_stack+475564,int_stack+464956,136);
 /*--- compute (u0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+3451047,int_stack+3419223,int_stack+3347415,136);
 /*--- compute (u0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+3504903,int_stack+3451047,int_stack+3374343,136);
 /*--- compute (u0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+3324975,int_stack+487940,int_stack+475564,136);
 /*--- compute (u0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+3579703,int_stack+3324975,int_stack+3419223,136);
 /*--- compute (u0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+3643351,int_stack+3579703,int_stack+3451047,136);
 /*--- compute (u0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+3362103,int_stack+3643351,int_stack+3504903,136);
 /*--- compute (u0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+3474303,int_stack+502220,int_stack+487940,136);
 /*--- compute (u0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+3733111,int_stack+3474303,int_stack+3324975,136);
 /*--- compute (u0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+3807367,int_stack+3733111,int_stack+3579703,136);
 /*--- compute (u0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+3913447,int_stack+3807367,int_stack+3643351,136);
 /*--- compute (u0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+3517143,int_stack+3913447,int_stack+3362103,136);
 /*--- compute (u0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+3324975,int_stack+518540,int_stack+502220,136);
 /*--- compute (u0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+3373935,int_stack+3324975,int_stack+3474303,136);
 /*--- compute (u0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+4048087,int_stack+3373935,int_stack+3733111,136);
 /*--- compute (u0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+4171847,int_stack+4048087,int_stack+3807367,136);
 /*--- compute (u0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+3674223,int_stack+4171847,int_stack+3913447,136);
 /*--- compute (u0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+4330967,int_stack+3674223,int_stack+3517143,136);
 /*--- compute (u0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+3459615,int_stack+537036,int_stack+518540,136);
 /*--- compute (u0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+3515103,int_stack+3459615,int_stack+3324975,136);
 /*--- compute (u0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+3862719,int_stack+3515103,int_stack+3373935,136);
 /*--- compute (u0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+4540407,int_stack+3862719,int_stack+4048087,136);
 /*--- compute (u0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+4726047,int_stack+4540407,int_stack+4171847,136);
 /*--- compute (u0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+4005519,int_stack+4726047,int_stack+3674223,136);
 /*--- compute (u0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+4948815,int_stack+4005519,int_stack+4330967,136);
 /*--- compute (u0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+3324975,int_stack+557844,int_stack+537036,136);
 /*--- compute (u0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+3613023,int_stack+3324975,int_stack+3459615,136);
 /*--- compute (u0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+3324975,int_stack+3613023,int_stack+3515103,136);
 /*--- compute (u0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+3488175,int_stack+3324975,int_stack+3862719,136);
 /*--- compute (u0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+3702375,int_stack+3488175,int_stack+4540407,136);
 /*--- compute (u0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+3324975,int_stack+3702375,int_stack+4726047,136);
 /*--- compute (u0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+3621999,int_stack+3324975,int_stack+4005519,136);
 /*--- compute (u0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+3945135,int_stack+3621999,int_stack+4948815,136);
 /*--- compute (tp|ml) ---*/
 hrr1_build_tp(Libint->AB,int_stack+4281735,int_stack+3945135,int_stack+897000,2475);
 /*--- compute (rd|ml) ---*/
 hrr1_build_rd(Libint->AB,int_stack+5172735,int_stack+4281735,int_stack+1194000,2475);
 /*--- compute (qf|ml) ---*/
 hrr1_build_qf(Libint->AB,int_stack+11768190,int_stack+5172735,int_stack+1973625,2475);
 /*--- compute (og|ml) ---*/
 hrr1_build_og(Libint->AB,int_stack+897000,int_stack+11768190,int_stack+7387440,2475);
 /*--- compute (nh|ml) ---*/
 hrr1_build_nh(Libint->AB,int_stack+14020440,int_stack+897000,int_stack+9317940,2475);
 /*--- compute (v0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+3792750,int_stack+589515,int_stack+581100,153);
 /*--- compute (v0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+3817995,int_stack+599613,int_stack+589515,153);
 /*--- compute (v0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+3848289,int_stack+3817995,int_stack+3792750,153);
 /*--- compute (v0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+3898779,int_stack+611547,int_stack+599613,153);
 /*--- compute (v0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+6731985,int_stack+3898779,int_stack+3817995,153);
 /*--- compute (v0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+6792573,int_stack+6731985,int_stack+3848289,153);
 /*--- compute (v0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+3792750,int_stack+625470,int_stack+611547,153);
 /*--- compute (v0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+6876723,int_stack+3792750,int_stack+3898779,153);
 /*--- compute (v0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+3834519,int_stack+6876723,int_stack+6731985,153);
 /*--- compute (v0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+6948327,int_stack+3834519,int_stack+6792573,153);
 /*--- compute (v0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+6731985,int_stack+641535,int_stack+625470,153);
 /*--- compute (v0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+6780180,int_stack+6731985,int_stack+3792750,153);
 /*--- compute (v0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+7074552,int_stack+6780180,int_stack+6876723,153);
 /*--- compute (v0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+7193892,int_stack+7074552,int_stack+3834519,153);
 /*--- compute (v0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+7345362,int_stack+7193892,int_stack+6948327,153);
 /*--- compute (v0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+3792750,int_stack+659895,int_stack+641535,153);
 /*--- compute (v0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+3847830,int_stack+3792750,int_stack+6731985,153);
 /*--- compute (v0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+6863718,int_stack+3847830,int_stack+6780180,153);
 /*--- compute (v0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+7522077,int_stack+6863718,int_stack+7074552,153);
 /*--- compute (v0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+7701087,int_stack+7522077,int_stack+7193892,153);
 /*--- compute (v0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+7002948,int_stack+7701087,int_stack+7345362,153);
 /*--- compute (v0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+6731985,int_stack+680703,int_stack+659895,153);
 /*--- compute (v0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+7238568,int_stack+6731985,int_stack+3792750,153);
 /*--- compute (v0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+7348728,int_stack+7238568,int_stack+3847830,153);
 /*--- compute (v0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+7913145,int_stack+7348728,int_stack+6863718,153);
 /*--- compute (v0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+8121990,int_stack+7913145,int_stack+7522077,153);
 /*--- compute (v0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+8372604,int_stack+8121990,int_stack+7701087,153);
 /*--- compute (v0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+7509378,int_stack+8372604,int_stack+7002948,153);
 /*--- compute (v0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+3792750,int_stack+704112,int_stack+680703,153);
 /*--- compute (v0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+6794409,int_stack+3792750,int_stack+6731985,153);
 /*--- compute (v0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+6919257,int_stack+6794409,int_stack+7238568,153);
 /*--- compute (v0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+7102857,int_stack+6919257,int_stack+7348728,153);
 /*--- compute (v0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+6731985,int_stack+7102857,int_stack+7913145,153);
 /*--- compute (v0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+7024368,int_stack+6731985,int_stack+8121990,153);
 /*--- compute (v0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+7812318,int_stack+7024368,int_stack+8372604,153);
 /*--- compute (v0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+6731985,int_stack+7812318,int_stack+7509378,153);
 /*--- compute (up|ml) ---*/
 hrr1_build_up(Libint->AB,int_stack+7110660,int_stack+6731985,int_stack+3945135,2475);
 /*--- compute (td|ml) ---*/
 hrr1_build_td(Libint->AB,int_stack+8120460,int_stack+7110660,int_stack+4281735,2475);
 /*--- compute (rf|ml) ---*/
 hrr1_build_rf(Libint->AB,int_stack+17450790,int_stack+8120460,int_stack+5172735,2475);
 /*--- compute (qg|ml) ---*/
 hrr1_build_qg(Libint->AB,int_stack+20049540,int_stack+17450790,int_stack+11768190,2475);
 /*--- compute (oh|ml) ---*/
 hrr1_build_oh(Libint->AB,int_stack+9902460,int_stack+20049540,int_stack+897000,2475);
 /*--- compute (ni|ml) ---*/
 hrr1_build_ni(Libint->AB,int_stack+897000,int_stack+9902460,int_stack+14020440,2475);
 /*--- compute (w0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+5470800,int_stack+739680,int_stack+730275,171);
 /*--- compute (w0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+5499015,int_stack+750966,int_stack+739680,171);
 /*--- compute (w0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+5532873,int_stack+5499015,int_stack+5470800,171);
 /*--- compute (w0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+5589303,int_stack+764304,int_stack+750966,171);
 /*--- compute (w0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+5629317,int_stack+5589303,int_stack+5499015,171);
 /*--- compute (w0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+5697033,int_stack+5629317,int_stack+5532873,171);
 /*--- compute (w0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+5470800,int_stack+779865,int_stack+764304,171);
 /*--- compute (w0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+5791083,int_stack+5470800,int_stack+5589303,171);
 /*--- compute (w0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+5871111,int_stack+5791083,int_stack+5629317,171);
 /*--- compute (w0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+5517483,int_stack+5871111,int_stack+5697033,171);
 /*--- compute (w0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+5658558,int_stack+797820,int_stack+779865,171);
 /*--- compute (w0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+5983971,int_stack+5658558,int_stack+5470800,171);
 /*--- compute (w0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+6077337,int_stack+5983971,int_stack+5791083,171);
 /*--- compute (w0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+6210717,int_stack+6077337,int_stack+5871111,171);
 /*--- compute (w0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+5712423,int_stack+6210717,int_stack+5517483,171);
 /*--- compute (w0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+5470800,int_stack+818340,int_stack+797820,171);
 /*--- compute (w0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+5532360,int_stack+5470800,int_stack+5658558,171);
 /*--- compute (w0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+6380007,int_stack+5532360,int_stack+5983971,171);
 /*--- compute (w0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+13956510,int_stack+6380007,int_stack+6077337,171);
 /*--- compute (w0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+5909928,int_stack+13956510,int_stack+6210717,171);
 /*--- compute (w0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+14156580,int_stack+5909928,int_stack+5712423,171);
 /*--- compute (w0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+5640090,int_stack+841596,int_stack+818340,171);
 /*--- compute (w0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+5709858,int_stack+5640090,int_stack+5470800,171);
 /*--- compute (w0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+6146934,int_stack+5709858,int_stack+5532360,171);
 /*--- compute (w0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+14419920,int_stack+6146934,int_stack+6380007,171);
 /*--- compute (w0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+6326484,int_stack+14419920,int_stack+13956510,171);
 /*--- compute (w0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+14653335,int_stack+6326484,int_stack+5909928,171);
 /*--- compute (w0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+14969343,int_stack+14653335,int_stack+14156580,171);
 /*--- compute (w0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+13956510,int_stack+867759,int_stack+841596,171);
 /*--- compute (w0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+14034999,int_stack+13956510,int_stack+5640090,171);
 /*--- compute (w0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+14174535,int_stack+14034999,int_stack+5709858,171);
 /*--- compute (w0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+5470800,int_stack+14174535,int_stack+6146934,171);
 /*--- compute (w0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+13956510,int_stack+5470800,int_stack+14419920,171);
 /*--- compute (w0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+5470800,int_stack+13956510,int_stack+6326484,171);
 /*--- compute (w0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+13956510,int_stack+5470800,int_stack+14653335,171);
 /*--- compute (w0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+5470800,int_stack+13956510,int_stack+14969343,171);
 /*--- compute (vp|ml) ---*/
 hrr1_build_vp(Libint->AB,int_stack+13956510,int_stack+5470800,int_stack+6731985,2475);
 /*--- compute (ud|ml) ---*/
 hrr1_build_ud(Libint->AB,int_stack+15092535,int_stack+13956510,int_stack+7110660,2475);
 /*--- compute (tf|ml) ---*/
 hrr1_build_tf(Libint->AB,int_stack+23427915,int_stack+15092535,int_stack+8120460,2475);
 /*--- compute (rg|ml) ---*/
 hrr1_build_rg(Libint->AB,int_stack+5470800,int_stack+23427915,int_stack+17450790,2475);
 /*--- compute (qh|ml) ---*/
 hrr1_build_qh(Libint->AB,int_stack+13956510,int_stack+5470800,int_stack+20049540,2475);
 /*--- compute (oi|ml) ---*/
 hrr1_build_oi(Libint->AB,int_stack+18686235,int_stack+13956510,int_stack+9902460,2475);
 /*--- compute (nk|ml) ---*/
 hrr1_build_nk(Libint->AB,int_stack+5470800,int_stack+18686235,int_stack+897000,2475);
 return int_stack+5470800;}
