/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_npkh(Libint_t*, prim_data*);

  /* Computes quartets of (np|kh) integrals */

REALTYPE *hrr_order_npkh(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[10][7] = int_stack + 0;
 Libint->vrr_classes[10][8] = int_stack + 2376;
 Libint->vrr_classes[10][9] = int_stack + 5346;
 Libint->vrr_classes[10][10] = int_stack + 8976;
 Libint->vrr_classes[10][11] = int_stack + 13332;
 Libint->vrr_classes[10][12] = int_stack + 18480;
 Libint->vrr_classes[11][7] = int_stack + 24486;
 Libint->vrr_classes[11][8] = int_stack + 27294;
 Libint->vrr_classes[11][9] = int_stack + 30804;
 Libint->vrr_classes[11][10] = int_stack + 35094;
 Libint->vrr_classes[11][11] = int_stack + 40242;
 Libint->vrr_classes[11][12] = int_stack + 46326;
 memset(int_stack,0,53424*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 53424;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_npkh(Libint, Data);
   Data++;
 }
 /*--- compute (n0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+53424,int_stack+2376,int_stack+0,66);
 /*--- compute (n0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+60552,int_stack+5346,int_stack+2376,66);
 /*--- compute (n0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+69462,int_stack+60552,int_stack+53424,66);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+83718,int_stack+8976,int_stack+5346,66);
 /*--- compute (n0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+94608,int_stack+83718,int_stack+60552,66);
 /*--- compute (n0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+112428,int_stack+94608,int_stack+69462,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+53424,int_stack+13332,int_stack+8976,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+136188,int_stack+53424,int_stack+83718,66);
 /*--- compute (n0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+157968,int_stack+136188,int_stack+94608,66);
 /*--- compute (n0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+66492,int_stack+157968,int_stack+112428,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+102132,int_stack+18480,int_stack+13332,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+187668,int_stack+102132,int_stack+53424,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+213804,int_stack+187668,int_stack+136188,66);
 /*--- compute (n0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+102132,int_stack+213804,int_stack+157968,66);
 /*--- compute (n0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+146682,int_stack+102132,int_stack+66492,66);
 /*--- compute (o0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+53424,int_stack+27294,int_stack+24486,78);
 /*--- compute (o0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+61848,int_stack+30804,int_stack+27294,78);
 /*--- compute (o0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+72378,int_stack+61848,int_stack+53424,78);
 /*--- compute (o0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+89226,int_stack+35094,int_stack+30804,78);
 /*--- compute (o0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+102096,int_stack+89226,int_stack+61848,78);
 /*--- compute (o0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+196578,int_stack+102096,int_stack+72378,78);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+53424,int_stack+40242,int_stack+35094,78);
 /*--- compute (o0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+224658,int_stack+53424,int_stack+89226,78);
 /*--- compute (o0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+0,int_stack+224658,int_stack+102096,78);
 /*--- compute (o0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+68868,int_stack+0,int_stack+196578,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+196578,int_stack+46326,int_stack+40242,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+110988,int_stack+196578,int_stack+53424,78);
 /*--- compute (o0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+250398,int_stack+110988,int_stack+224658,78);
 /*--- compute (o0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+196578,int_stack+250398,int_stack+0,78);
 /*--- compute (o0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+0,int_stack+196578,int_stack+68868,78);
 /*--- compute (np|kh) ---*/
 hrr1_build_np(Libint->AB,int_stack+196578,int_stack+0,int_stack+146682,756);
 return int_stack+196578;}
