/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_nplg(Libint_t*, prim_data*);

  /* Computes quartets of (np|lg) integrals */

REALTYPE *hrr_order_nplg(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[10][8] = int_stack + 0;
 Libint->vrr_classes[10][9] = int_stack + 2970;
 Libint->vrr_classes[10][10] = int_stack + 6600;
 Libint->vrr_classes[10][11] = int_stack + 10956;
 Libint->vrr_classes[10][12] = int_stack + 16104;
 Libint->vrr_classes[11][8] = int_stack + 22110;
 Libint->vrr_classes[11][9] = int_stack + 25620;
 Libint->vrr_classes[11][10] = int_stack + 29910;
 Libint->vrr_classes[11][11] = int_stack + 35058;
 Libint->vrr_classes[11][12] = int_stack + 41142;
 memset(int_stack,0,48240*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 48240;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_nplg(Libint, Data);
   Data++;
 }
 /*--- compute (n0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+48240,int_stack+2970,int_stack+0,66);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+57150,int_stack+6600,int_stack+2970,66);
 /*--- compute (n0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+68040,int_stack+57150,int_stack+48240,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+85860,int_stack+10956,int_stack+6600,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+98928,int_stack+85860,int_stack+57150,66);
 /*--- compute (n0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+120708,int_stack+98928,int_stack+68040,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+48240,int_stack+16104,int_stack+10956,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+150408,int_stack+48240,int_stack+85860,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+48240,int_stack+150408,int_stack+98928,66);
 /*--- compute (n0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+150408,int_stack+48240,int_stack+120708,66);
 /*--- compute (o0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+48240,int_stack+25620,int_stack+22110,78);
 /*--- compute (o0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+58770,int_stack+29910,int_stack+25620,78);
 /*--- compute (o0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+71640,int_stack+58770,int_stack+48240,78);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+92700,int_stack+35058,int_stack+29910,78);
 /*--- compute (o0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+108144,int_stack+92700,int_stack+58770,78);
 /*--- compute (o0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+194958,int_stack+108144,int_stack+71640,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+48240,int_stack+41142,int_stack+35058,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+0,int_stack+48240,int_stack+92700,78);
 /*--- compute (o0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+30888,int_stack+0,int_stack+108144,78);
 /*--- compute (o0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+73788,int_stack+30888,int_stack+194958,78);
 /*--- compute (np|lg) ---*/
 hrr1_build_np(Libint->AB,int_stack+194958,int_stack+73788,int_stack+150408,675);
 return int_stack+194958;}
