/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_p0ki(Libint_t*, prim_data*);

  /* Computes quartets of (p0|ki) integrals */

REALTYPE *hrr_order_p0ki(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[1][7] = int_stack + 0;
 Libint->vrr_classes[1][8] = int_stack + 108;
 Libint->vrr_classes[1][9] = int_stack + 243;
 Libint->vrr_classes[1][10] = int_stack + 408;
 Libint->vrr_classes[1][11] = int_stack + 606;
 Libint->vrr_classes[1][12] = int_stack + 840;
 Libint->vrr_classes[1][13] = int_stack + 1113;
 memset(int_stack,0,1428*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 1428;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_p0ki(Libint, Data);
   Data++;
 }
 /*--- compute (p0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+1428,int_stack+108,int_stack+0,3);
 /*--- compute (p0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+1752,int_stack+243,int_stack+108,3);
 /*--- compute (p0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+2157,int_stack+1752,int_stack+1428,3);
 /*--- compute (p0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+2805,int_stack+408,int_stack+243,3);
 /*--- compute (p0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+3300,int_stack+2805,int_stack+1752,3);
 /*--- compute (p0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+4110,int_stack+3300,int_stack+2157,3);
 /*--- compute (p0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+1428,int_stack+606,int_stack+408,3);
 /*--- compute (p0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+5190,int_stack+1428,int_stack+2805,3);
 /*--- compute (p0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+6180,int_stack+5190,int_stack+3300,3);
 /*--- compute (p0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+2022,int_stack+6180,int_stack+4110,3);
 /*--- compute (p0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+3642,int_stack+840,int_stack+606,3);
 /*--- compute (p0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+7530,int_stack+3642,int_stack+1428,3);
 /*--- compute (p0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+8718,int_stack+7530,int_stack+5190,3);
 /*--- compute (p0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+10368,int_stack+8718,int_stack+6180,3);
 /*--- compute (p0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+4344,int_stack+10368,int_stack+2022,3);
 /*--- compute (p0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+1428,int_stack+1113,int_stack+840,3);
 /*--- compute (p0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+0,int_stack+1428,int_stack+3642,3);
 /*--- compute (p0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+1404,int_stack+0,int_stack+7530,3);
 /*--- compute (p0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+12393,int_stack+1404,int_stack+8718,3);
 /*--- compute (p0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+0,int_stack+12393,int_stack+10368,3);
 /*--- compute (p0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+6612,int_stack+0,int_stack+4344,3);
 return int_stack+6612;}
