/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_pplk(Libint_t*, prim_data*);

  /* Computes quartets of (pp|lk) integrals */

REALTYPE *hrr_order_pplk(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[1][8] = int_stack + 0;
 Libint->vrr_classes[1][9] = int_stack + 135;
 Libint->vrr_classes[1][10] = int_stack + 300;
 Libint->vrr_classes[1][11] = int_stack + 498;
 Libint->vrr_classes[1][12] = int_stack + 732;
 Libint->vrr_classes[1][13] = int_stack + 1005;
 Libint->vrr_classes[1][14] = int_stack + 1320;
 Libint->vrr_classes[1][15] = int_stack + 1680;
 Libint->vrr_classes[2][8] = int_stack + 2088;
 Libint->vrr_classes[2][9] = int_stack + 2358;
 Libint->vrr_classes[2][10] = int_stack + 2688;
 Libint->vrr_classes[2][11] = int_stack + 3084;
 Libint->vrr_classes[2][12] = int_stack + 3552;
 Libint->vrr_classes[2][13] = int_stack + 4098;
 Libint->vrr_classes[2][14] = int_stack + 4728;
 Libint->vrr_classes[2][15] = int_stack + 5448;
 memset(int_stack,0,6264*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 6264;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_pplk(Libint, Data);
   Data++;
 }
 /*--- compute (p0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+6264,int_stack+135,int_stack+0,3);
 /*--- compute (p0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+6669,int_stack+300,int_stack+135,3);
 /*--- compute (p0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+7164,int_stack+6669,int_stack+6264,3);
 /*--- compute (p0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+7974,int_stack+498,int_stack+300,3);
 /*--- compute (p0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+8568,int_stack+7974,int_stack+6669,3);
 /*--- compute (p0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+9558,int_stack+8568,int_stack+7164,3);
 /*--- compute (p0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+6264,int_stack+732,int_stack+498,3);
 /*--- compute (p0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+10908,int_stack+6264,int_stack+7974,3);
 /*--- compute (p0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+12096,int_stack+10908,int_stack+8568,3);
 /*--- compute (p0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+6966,int_stack+12096,int_stack+9558,3);
 /*--- compute (p0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+8991,int_stack+1005,int_stack+732,3);
 /*--- compute (p0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+13746,int_stack+8991,int_stack+6264,3);
 /*--- compute (p0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+15150,int_stack+13746,int_stack+10908,3);
 /*--- compute (p0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+17130,int_stack+15150,int_stack+12096,3);
 /*--- compute (p0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+9810,int_stack+17130,int_stack+6966,3);
 /*--- compute (p0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+6264,int_stack+1320,int_stack+1005,3);
 /*--- compute (p0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+7209,int_stack+6264,int_stack+8991,3);
 /*--- compute (p0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+19605,int_stack+7209,int_stack+13746,3);
 /*--- compute (p0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+21945,int_stack+19605,int_stack+15150,3);
 /*--- compute (p0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+12645,int_stack+21945,int_stack+17130,3);
 /*--- compute (p0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+24915,int_stack+12645,int_stack+9810,3);
 /*--- compute (p0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+8847,int_stack+1680,int_stack+1320,3);
 /*--- compute (p0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+9927,int_stack+8847,int_stack+6264,3);
 /*--- compute (p0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+16110,int_stack+9927,int_stack+7209,3);
 /*--- compute (p0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+6264,int_stack+16110,int_stack+19605,3);
 /*--- compute (p0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+16110,int_stack+6264,int_stack+21945,3);
 /*--- compute (p0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+6264,int_stack+16110,int_stack+12645,3);
 /*--- compute (p0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+10884,int_stack+6264,int_stack+24915,3);
 /*--- compute (d0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+6264,int_stack+2358,int_stack+2088,6);
 /*--- compute (d0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+7074,int_stack+2688,int_stack+2358,6);
 /*--- compute (d0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+8064,int_stack+7074,int_stack+6264,6);
 /*--- compute (d0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+9684,int_stack+3084,int_stack+2688,6);
 /*--- compute (d0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+15744,int_stack+9684,int_stack+7074,6);
 /*--- compute (d0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+17724,int_stack+15744,int_stack+8064,6);
 /*--- compute (d0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+6264,int_stack+3552,int_stack+3084,6);
 /*--- compute (d0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+20424,int_stack+6264,int_stack+9684,6);
 /*--- compute (d0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+22800,int_stack+20424,int_stack+15744,6);
 /*--- compute (d0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+26100,int_stack+22800,int_stack+17724,6);
 /*--- compute (d0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+15744,int_stack+4098,int_stack+3552,6);
 /*--- compute (d0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+17382,int_stack+15744,int_stack+6264,6);
 /*--- compute (d0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+6264,int_stack+17382,int_stack+20424,6);
 /*--- compute (d0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+30150,int_stack+6264,int_stack+22800,6);
 /*--- compute (d0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+20190,int_stack+30150,int_stack+26100,6);
 /*--- compute (d0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+25860,int_stack+4728,int_stack+4098,6);
 /*--- compute (d0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+0,int_stack+25860,int_stack+15744,6);
 /*--- compute (d0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+35100,int_stack+0,int_stack+17382,6);
 /*--- compute (d0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+39780,int_stack+35100,int_stack+6264,6);
 /*--- compute (d0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+45720,int_stack+39780,int_stack+30150,6);
 /*--- compute (d0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+52650,int_stack+45720,int_stack+20190,6);
 /*--- compute (d0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+6264,int_stack+5448,int_stack+4728,6);
 /*--- compute (d0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+15744,int_stack+6264,int_stack+25860,6);
 /*--- compute (d0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+19524,int_stack+15744,int_stack+0,6);
 /*--- compute (d0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+0,int_stack+19524,int_stack+35100,6);
 /*--- compute (d0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+15744,int_stack+0,int_stack+39780,6);
 /*--- compute (d0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+0,int_stack+15744,int_stack+45720,6);
 /*--- compute (d0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+15744,int_stack+0,int_stack+52650,6);
 /*--- compute (pp|lk) ---*/
 hrr1_build_pp(Libint->AB,int_stack+25464,int_stack+15744,int_stack+10884,1620);
 return int_stack+25464;}
