/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_ppnd(Libint_t*, prim_data*);

  /* Computes quartets of (pp|nd) integrals */

REALTYPE *hrr_order_ppnd(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[1][10] = int_stack + 0;
 Libint->vrr_classes[1][11] = int_stack + 198;
 Libint->vrr_classes[1][12] = int_stack + 432;
 Libint->vrr_classes[2][10] = int_stack + 705;
 Libint->vrr_classes[2][11] = int_stack + 1101;
 Libint->vrr_classes[2][12] = int_stack + 1569;
 memset(int_stack,0,2115*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 2115;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_ppnd(Libint, Data);
   Data++;
 }
 /*--- compute (p0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+2115,int_stack+198,int_stack+0,3);
 /*--- compute (p0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+2709,int_stack+432,int_stack+198,3);
 /*--- compute (p0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+3411,int_stack+2709,int_stack+2115,3);
 /*--- compute (d0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+2115,int_stack+1101,int_stack+705,6);
 /*--- compute (d0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+4599,int_stack+1569,int_stack+1101,6);
 /*--- compute (d0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+6003,int_stack+4599,int_stack+2115,6);
 /*--- compute (pp|nd) ---*/
 hrr1_build_pp(Libint->AB,int_stack+8379,int_stack+6003,int_stack+3411,396);
 return int_stack+8379;}
