/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_ppnl(Libint_t*, prim_data*);

  /* Computes quartets of (pp|nl) integrals */

REALTYPE *hrr_order_ppnl(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[1][10] = int_stack + 0;
 Libint->vrr_classes[1][11] = int_stack + 198;
 Libint->vrr_classes[1][12] = int_stack + 432;
 Libint->vrr_classes[1][13] = int_stack + 705;
 Libint->vrr_classes[1][14] = int_stack + 1020;
 Libint->vrr_classes[1][15] = int_stack + 1380;
 Libint->vrr_classes[1][16] = int_stack + 1788;
 Libint->vrr_classes[1][17] = int_stack + 2247;
 Libint->vrr_classes[1][18] = int_stack + 2760;
 Libint->vrr_classes[2][10] = int_stack + 3330;
 Libint->vrr_classes[2][11] = int_stack + 3726;
 Libint->vrr_classes[2][12] = int_stack + 4194;
 Libint->vrr_classes[2][13] = int_stack + 4740;
 Libint->vrr_classes[2][14] = int_stack + 5370;
 Libint->vrr_classes[2][15] = int_stack + 6090;
 Libint->vrr_classes[2][16] = int_stack + 6906;
 Libint->vrr_classes[2][17] = int_stack + 7824;
 Libint->vrr_classes[2][18] = int_stack + 8850;
 memset(int_stack,0,9990*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 9990;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_ppnl(Libint, Data);
   Data++;
 }
 /*--- compute (p0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+9990,int_stack+198,int_stack+0,3);
 /*--- compute (p0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+10584,int_stack+432,int_stack+198,3);
 /*--- compute (p0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+11286,int_stack+10584,int_stack+9990,3);
 /*--- compute (p0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+12474,int_stack+705,int_stack+432,3);
 /*--- compute (p0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+13293,int_stack+12474,int_stack+10584,3);
 /*--- compute (p0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+14697,int_stack+13293,int_stack+11286,3);
 /*--- compute (p0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+9990,int_stack+1020,int_stack+705,3);
 /*--- compute (p0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+16677,int_stack+9990,int_stack+12474,3);
 /*--- compute (p0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+10935,int_stack+16677,int_stack+13293,3);
 /*--- compute (p0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+18315,int_stack+10935,int_stack+14697,3);
 /*--- compute (p0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+13275,int_stack+1380,int_stack+1020,3);
 /*--- compute (p0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+14355,int_stack+13275,int_stack+9990,3);
 /*--- compute (p0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+21285,int_stack+14355,int_stack+16677,3);
 /*--- compute (p0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+24015,int_stack+21285,int_stack+10935,3);
 /*--- compute (p0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+27525,int_stack+24015,int_stack+18315,3);
 /*--- compute (p0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+9990,int_stack+1788,int_stack+1380,3);
 /*--- compute (p0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+16245,int_stack+9990,int_stack+13275,3);
 /*--- compute (p0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+31683,int_stack+16245,int_stack+14355,3);
 /*--- compute (p0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+11214,int_stack+31683,int_stack+21285,3);
 /*--- compute (p0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+18405,int_stack+11214,int_stack+24015,3);
 /*--- compute (p0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+34833,int_stack+18405,int_stack+27525,3);
 /*--- compute (p0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+23319,int_stack+2247,int_stack+1788,3);
 /*--- compute (p0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+24696,int_stack+23319,int_stack+9990,3);
 /*--- compute (p0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+27144,int_stack+24696,int_stack+16245,3);
 /*--- compute (p0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+40377,int_stack+27144,int_stack+31683,3);
 /*--- compute (p0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+45102,int_stack+40377,int_stack+11214,3);
 /*--- compute (p0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+9990,int_stack+45102,int_stack+18405,3);
 /*--- compute (p0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+50835,int_stack+9990,int_stack+34833,3);
 /*--- compute (p0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+16542,int_stack+2760,int_stack+2247,3);
 /*--- compute (p0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+18081,int_stack+16542,int_stack+23319,3);
 /*--- compute (p0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+30744,int_stack+18081,int_stack+24696,3);
 /*--- compute (p0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+16542,int_stack+30744,int_stack+27144,3);
 /*--- compute (p0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+21942,int_stack+16542,int_stack+40377,3);
 /*--- compute (p0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+28557,int_stack+21942,int_stack+45102,3);
 /*--- compute (p0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+16542,int_stack+28557,int_stack+9990,3);
 /*--- compute (p0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+24966,int_stack+16542,int_stack+50835,3);
 /*--- compute (d0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+9990,int_stack+3726,int_stack+3330,6);
 /*--- compute (d0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+11178,int_stack+4194,int_stack+3726,6);
 /*--- compute (d0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+12582,int_stack+11178,int_stack+9990,6);
 /*--- compute (d0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+14958,int_stack+4740,int_stack+4194,6);
 /*--- compute (d0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+16596,int_stack+14958,int_stack+11178,6);
 /*--- compute (d0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+19404,int_stack+16596,int_stack+12582,6);
 /*--- compute (d0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+9990,int_stack+5370,int_stack+4740,6);
 /*--- compute (d0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+33876,int_stack+9990,int_stack+14958,6);
 /*--- compute (d0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+11880,int_stack+33876,int_stack+16596,6);
 /*--- compute (d0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+37152,int_stack+11880,int_stack+19404,6);
 /*--- compute (d0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+16560,int_stack+6090,int_stack+5370,6);
 /*--- compute (d0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+18720,int_stack+16560,int_stack+9990,6);
 /*--- compute (d0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+43092,int_stack+18720,int_stack+33876,6);
 /*--- compute (d0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+48552,int_stack+43092,int_stack+11880,6);
 /*--- compute (d0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+55572,int_stack+48552,int_stack+37152,6);
 /*--- compute (d0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+33876,int_stack+6906,int_stack+6090,6);
 /*--- compute (d0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+36324,int_stack+33876,int_stack+16560,6);
 /*--- compute (d0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+9990,int_stack+36324,int_stack+18720,6);
 /*--- compute (d0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+16290,int_stack+9990,int_stack+43092,6);
 /*--- compute (d0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+63888,int_stack+16290,int_stack+48552,6);
 /*--- compute (d0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+40644,int_stack+63888,int_stack+55572,6);
 /*--- compute (d0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+51732,int_stack+7824,int_stack+6906,6);
 /*--- compute (d0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+54486,int_stack+51732,int_stack+33876,6);
 /*--- compute (d0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+0,int_stack+54486,int_stack+36324,6);
 /*--- compute (d0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+73716,int_stack+0,int_stack+9990,6);
 /*--- compute (d0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+83166,int_stack+73716,int_stack+16290,6);
 /*--- compute (d0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+9990,int_stack+83166,int_stack+63888,6);
 /*--- compute (d0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+59382,int_stack+9990,int_stack+40644,6);
 /*--- compute (d0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+33876,int_stack+8850,int_stack+7824,6);
 /*--- compute (d0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+36954,int_stack+33876,int_stack+51732,6);
 /*--- compute (d0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+42462,int_stack+36954,int_stack+54486,6);
 /*--- compute (d0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+94632,int_stack+42462,int_stack+0,6);
 /*--- compute (d0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+33876,int_stack+94632,int_stack+73716,6);
 /*--- compute (d0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+94632,int_stack+33876,int_stack+83166,6);
 /*--- compute (d0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+33876,int_stack+94632,int_stack+9990,6);
 /*--- compute (d0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+0,int_stack+33876,int_stack+59382,6);
 /*--- compute (pp|nl) ---*/
 hrr1_build_pp(Libint->AB,int_stack+33876,int_stack+0,int_stack+24966,2970);
 return int_stack+33876;}
