/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include "libint.h"
#include "vrr_header.h"

  /* Computes quartets necessary to compute (00|nf) integrals */

void vrr_order_00nf(Libint_t * Libint, prim_data *Data)
{
 REALTYPE *vrr_stack = Libint->vrr_stack;
 REALTYPE *tmp, *target_ptr;
 int i, am[2];
 _BUILD_00p0(Data,vrr_stack+0, Data->F+6, Data->F+7, NULL, NULL, NULL);
 _BUILD_00p0(Data,vrr_stack+3, Data->F+5, Data->F+6, NULL, NULL, NULL);
 _BUILD_00p0(Data,vrr_stack+6, Data->F+7, Data->F+8, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+9, vrr_stack+0, vrr_stack+6, Data->F+6, Data->F+7, NULL);
 _BUILD_00d0(Data,vrr_stack+15, vrr_stack+3, vrr_stack+0, Data->F+5, Data->F+6, NULL);
 _BUILD_00f0(Data,vrr_stack+21, vrr_stack+15, vrr_stack+9, vrr_stack+3, vrr_stack+0, NULL);
 _BUILD_00p0(Data,vrr_stack+31, Data->F+4, Data->F+5, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+34, vrr_stack+31, vrr_stack+3, Data->F+4, Data->F+5, NULL);
 _BUILD_00f0(Data,vrr_stack+40, vrr_stack+34, vrr_stack+15, vrr_stack+31, vrr_stack+3, NULL);
 _BUILD_00p0(Data,vrr_stack+3, Data->F+8, Data->F+9, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+50, vrr_stack+6, vrr_stack+3, Data->F+7, Data->F+8, NULL);
 _BUILD_00f0(Data,vrr_stack+56, vrr_stack+9, vrr_stack+50, vrr_stack+0, vrr_stack+6, NULL);
 _BUILD_00g0(Data,vrr_stack+66, vrr_stack+21, vrr_stack+56, vrr_stack+15, vrr_stack+9, NULL);
 _BUILD_00g0(Data,vrr_stack+81, vrr_stack+40, vrr_stack+21, vrr_stack+34, vrr_stack+15, NULL);
 _BUILD_00h0(Data,vrr_stack+96, vrr_stack+81, vrr_stack+66, vrr_stack+40, vrr_stack+21, NULL);
 _BUILD_00p0(Data,vrr_stack+0, Data->F+3, Data->F+4, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+15, vrr_stack+0, vrr_stack+31, Data->F+3, Data->F+4, NULL);
 _BUILD_00f0(Data,vrr_stack+117, vrr_stack+15, vrr_stack+34, vrr_stack+0, vrr_stack+31, NULL);
 _BUILD_00g0(Data,vrr_stack+127, vrr_stack+117, vrr_stack+40, vrr_stack+15, vrr_stack+34, NULL);
 _BUILD_00h0(Data,vrr_stack+142, vrr_stack+127, vrr_stack+81, vrr_stack+117, vrr_stack+40, NULL);
 _BUILD_00p0(Data,vrr_stack+31, Data->F+9, Data->F+10, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+34, vrr_stack+3, vrr_stack+31, Data->F+8, Data->F+9, NULL);
 _BUILD_00f0(Data,vrr_stack+40, vrr_stack+50, vrr_stack+34, vrr_stack+6, vrr_stack+3, NULL);
 _BUILD_00g0(Data,vrr_stack+163, vrr_stack+56, vrr_stack+40, vrr_stack+9, vrr_stack+50, NULL);
 _BUILD_00h0(Data,vrr_stack+178, vrr_stack+66, vrr_stack+163, vrr_stack+21, vrr_stack+56, NULL);
 _BUILD_00i0(Data,vrr_stack+199, vrr_stack+96, vrr_stack+178, vrr_stack+81, vrr_stack+66, NULL);
 _BUILD_00i0(Data,vrr_stack+227, vrr_stack+142, vrr_stack+96, vrr_stack+127, vrr_stack+81, NULL);
 _BUILD_00k0(Data,vrr_stack+255, vrr_stack+227, vrr_stack+199, vrr_stack+142, vrr_stack+96, NULL);
 _BUILD_00p0(Data,vrr_stack+81, Data->F+2, Data->F+3, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+84, vrr_stack+81, vrr_stack+0, Data->F+2, Data->F+3, NULL);
 _BUILD_00f0(Data,vrr_stack+21, vrr_stack+84, vrr_stack+15, vrr_stack+81, vrr_stack+0, NULL);
 _BUILD_00g0(Data,vrr_stack+291, vrr_stack+21, vrr_stack+117, vrr_stack+84, vrr_stack+15, NULL);
 _BUILD_00h0(Data,vrr_stack+306, vrr_stack+291, vrr_stack+127, vrr_stack+21, vrr_stack+117, NULL);
 _BUILD_00i0(Data,vrr_stack+327, vrr_stack+306, vrr_stack+142, vrr_stack+291, vrr_stack+127, NULL);
 _BUILD_00k0(Data,vrr_stack+355, vrr_stack+327, vrr_stack+227, vrr_stack+306, vrr_stack+142, NULL);
 _BUILD_00p0(Data,vrr_stack+0, Data->F+10, Data->F+11, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+90, vrr_stack+31, vrr_stack+0, Data->F+9, Data->F+10, NULL);
 _BUILD_00f0(Data,vrr_stack+117, vrr_stack+34, vrr_stack+90, vrr_stack+3, vrr_stack+31, NULL);
 _BUILD_00g0(Data,vrr_stack+3, vrr_stack+40, vrr_stack+117, vrr_stack+50, vrr_stack+34, NULL);
 _BUILD_00h0(Data,vrr_stack+127, vrr_stack+163, vrr_stack+3, vrr_stack+56, vrr_stack+40, NULL);
 _BUILD_00i0(Data,vrr_stack+391, vrr_stack+178, vrr_stack+127, vrr_stack+66, vrr_stack+163, NULL);
 _BUILD_00k0(Data,vrr_stack+419, vrr_stack+199, vrr_stack+391, vrr_stack+96, vrr_stack+178, NULL);
 _BUILD_00l0(Data,vrr_stack+455, vrr_stack+255, vrr_stack+419, vrr_stack+227, vrr_stack+199, NULL);
 _BUILD_00l0(Data,vrr_stack+500, vrr_stack+355, vrr_stack+255, vrr_stack+327, vrr_stack+227, NULL);
 _BUILD_00m0(Data,vrr_stack+545, vrr_stack+500, vrr_stack+455, vrr_stack+355, vrr_stack+255, NULL);
 _BUILD_00p0(Data,vrr_stack+18, Data->F+1, Data->F+2, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+227, vrr_stack+18, vrr_stack+81, Data->F+1, Data->F+2, NULL);
 _BUILD_00f0(Data,vrr_stack+233, vrr_stack+227, vrr_stack+84, vrr_stack+18, vrr_stack+81, NULL);
 _BUILD_00g0(Data,vrr_stack+148, vrr_stack+233, vrr_stack+21, vrr_stack+227, vrr_stack+84, NULL);
 _BUILD_00h0(Data,vrr_stack+96, vrr_stack+148, vrr_stack+291, vrr_stack+233, vrr_stack+21, NULL);
 _BUILD_00i0(Data,vrr_stack+50, vrr_stack+96, vrr_stack+306, vrr_stack+148, vrr_stack+291, NULL);
 _BUILD_00k0(Data,vrr_stack+600, vrr_stack+50, vrr_stack+327, vrr_stack+96, vrr_stack+306, NULL);
 _BUILD_00l0(Data,vrr_stack+636, vrr_stack+600, vrr_stack+355, vrr_stack+50, vrr_stack+327, NULL);
 _BUILD_00m0(Data,vrr_stack+291, vrr_stack+636, vrr_stack+500, vrr_stack+600, vrr_stack+355, NULL);
 _BUILD_00p0(Data,vrr_stack+346, Data->F+11, Data->F+12, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+349, vrr_stack+0, vrr_stack+346, Data->F+10, Data->F+11, NULL);
 _BUILD_00f0(Data,vrr_stack+21, vrr_stack+90, vrr_stack+349, vrr_stack+31, vrr_stack+0, NULL);
 _BUILD_00g0(Data,vrr_stack+355, vrr_stack+117, vrr_stack+21, vrr_stack+34, vrr_stack+90, NULL);
 _BUILD_00h0(Data,vrr_stack+370, vrr_stack+3, vrr_stack+355, vrr_stack+40, vrr_stack+117, NULL);
 _BUILD_00i0(Data,vrr_stack+681, vrr_stack+127, vrr_stack+370, vrr_stack+163, vrr_stack+3, NULL);
 _BUILD_00k0(Data,vrr_stack+709, vrr_stack+391, vrr_stack+681, vrr_stack+178, vrr_stack+127, NULL);
 _BUILD_00l0(Data,vrr_stack+745, vrr_stack+419, vrr_stack+709, vrr_stack+199, vrr_stack+391, NULL);
 _BUILD_00m0(Data,vrr_stack+163, vrr_stack+455, vrr_stack+745, vrr_stack+255, vrr_stack+419, NULL);
 _BUILD_00n0(Data,vrr_stack+790, vrr_stack+545, vrr_stack+163, vrr_stack+500, vrr_stack+455, NULL);
 _BUILD_00n0(Data,vrr_stack+856, vrr_stack+291, vrr_stack+545, vrr_stack+636, vrr_stack+500, NULL);
 _BUILD_00o0(Data,vrr_stack+922, vrr_stack+856, vrr_stack+790, vrr_stack+291, vrr_stack+545, NULL);
 _BUILD_00p0(Data,vrr_stack+500, Data->F+0, Data->F+1, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+503, vrr_stack+500, vrr_stack+18, Data->F+0, Data->F+1, NULL);
 _BUILD_00f0(Data,vrr_stack+509, vrr_stack+503, vrr_stack+227, vrr_stack+500, vrr_stack+18, NULL);
 _BUILD_00g0(Data,vrr_stack+519, vrr_stack+509, vrr_stack+233, vrr_stack+503, vrr_stack+227, NULL);
 _BUILD_00h0(Data,vrr_stack+243, vrr_stack+519, vrr_stack+148, vrr_stack+509, vrr_stack+233, NULL);
 _BUILD_00i0(Data,vrr_stack+1000, vrr_stack+243, vrr_stack+96, vrr_stack+519, vrr_stack+148, NULL);
 _BUILD_00k0(Data,vrr_stack+500, vrr_stack+1000, vrr_stack+50, vrr_stack+243, vrr_stack+96, NULL);
 _BUILD_00l0(Data,vrr_stack+218, vrr_stack+500, vrr_stack+600, vrr_stack+1000, vrr_stack+50, NULL);
 _BUILD_00m0(Data,vrr_stack+1000, vrr_stack+218, vrr_stack+636, vrr_stack+500, vrr_stack+600, NULL);
 _BUILD_00n0(Data,vrr_stack+1055, vrr_stack+1000, vrr_stack+291, vrr_stack+218, vrr_stack+636, NULL);
   tmp = vrr_stack + 1055;
   target_ptr = Libint->vrr_classes[0][10];
   for(i=0;i<66;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00o0(Data,vrr_stack+600, vrr_stack+1055, vrr_stack+856, vrr_stack+1000, vrr_stack+291, NULL);
   tmp = vrr_stack + 600;
   target_ptr = Libint->vrr_classes[0][11];
   for(i=0;i<78;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00p0(Data,vrr_stack+678, Data->F+12, Data->F+13, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+1000, vrr_stack+346, vrr_stack+678, Data->F+11, Data->F+12, NULL);
 _BUILD_00f0(Data,vrr_stack+1006, vrr_stack+349, vrr_stack+1000, vrr_stack+0, vrr_stack+346, NULL);
 _BUILD_00g0(Data,vrr_stack+148, vrr_stack+21, vrr_stack+1006, vrr_stack+90, vrr_stack+349, NULL);
 _BUILD_00h0(Data,vrr_stack+1000, vrr_stack+355, vrr_stack+148, vrr_stack+117, vrr_stack+21, NULL);
 _BUILD_00i0(Data,vrr_stack+1021, vrr_stack+370, vrr_stack+1000, vrr_stack+3, vrr_stack+355, NULL);
 _BUILD_00k0(Data,vrr_stack+0, vrr_stack+681, vrr_stack+1021, vrr_stack+127, vrr_stack+370, NULL);
 _BUILD_00l0(Data,vrr_stack+500, vrr_stack+709, vrr_stack+0, vrr_stack+391, vrr_stack+681, NULL);
 _BUILD_00m0(Data,vrr_stack+1000, vrr_stack+745, vrr_stack+500, vrr_stack+419, vrr_stack+709, NULL);
 _BUILD_00n0(Data,vrr_stack+0, vrr_stack+163, vrr_stack+1000, vrr_stack+455, vrr_stack+745, NULL);
 _BUILD_00o0(Data,vrr_stack+66, vrr_stack+790, vrr_stack+0, vrr_stack+545, vrr_stack+163, NULL);
 _BUILD_00q0(Data,vrr_stack+144, vrr_stack+922, vrr_stack+66, vrr_stack+856, vrr_stack+790, NULL);
 _BUILD_00q0(Data,vrr_stack+0, vrr_stack+600, vrr_stack+922, vrr_stack+1055, vrr_stack+856, NULL);
   tmp = vrr_stack + 0;
   target_ptr = Libint->vrr_classes[0][12];
   for(i=0;i<91;i++)
     target_ptr[i] += tmp[i];
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+1000, vrr_stack+0, vrr_stack+144, vrr_stack+600, vrr_stack+922, NULL);
   tmp = vrr_stack + 1000;
   target_ptr = Libint->vrr_classes[0][13];
   for(i=0;i<105;i++)
     target_ptr[i] += tmp[i];

}

