/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include "libint.h"
#include "vrr_header.h"

  /* Computes quartets necessary to compute (fd|mp) integrals */

void vrr_order_fdmp(Libint_t * Libint, prim_data *Data)
{
 REALTYPE *vrr_stack = Libint->vrr_stack;
 REALTYPE *tmp, *target_ptr;
 int i, am[2];
 _BUILD_00p0(Data,vrr_stack+0, Data->F+7, Data->F+8, NULL, NULL, NULL);
 _BUILD_00p0(Data,vrr_stack+3, Data->F+6, Data->F+7, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+6, vrr_stack+3, vrr_stack+0, Data->F+6, Data->F+7, NULL);
 _BUILD_00p0(Data,vrr_stack+12, Data->F+5, Data->F+6, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+15, vrr_stack+12, vrr_stack+3, Data->F+5, Data->F+6, NULL);
 _BUILD_00p0(Data,vrr_stack+21, Data->F+8, Data->F+9, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+24, vrr_stack+0, vrr_stack+21, Data->F+7, Data->F+8, NULL);
 _BUILD_00f0(Data,vrr_stack+30, vrr_stack+6, vrr_stack+24, vrr_stack+3, vrr_stack+0, NULL);
 _BUILD_00f0(Data,vrr_stack+40, vrr_stack+15, vrr_stack+6, vrr_stack+12, vrr_stack+3, NULL);
 _BUILD_00g0(Data,vrr_stack+50, vrr_stack+40, vrr_stack+30, vrr_stack+15, vrr_stack+6, NULL);
 _BUILD_00p0(Data,vrr_stack+3, Data->F+9, Data->F+10, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+65, vrr_stack+21, vrr_stack+3, Data->F+8, Data->F+9, NULL);
 _BUILD_00f0(Data,vrr_stack+71, vrr_stack+24, vrr_stack+65, vrr_stack+0, vrr_stack+21, NULL);
 _BUILD_00g0(Data,vrr_stack+81, vrr_stack+30, vrr_stack+71, vrr_stack+6, vrr_stack+24, NULL);
 _BUILD_00h0(Data,vrr_stack+96, vrr_stack+50, vrr_stack+81, vrr_stack+40, vrr_stack+30, NULL);
 _BUILD_00p0(Data,vrr_stack+0, Data->F+4, Data->F+5, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+6, vrr_stack+0, vrr_stack+12, Data->F+4, Data->F+5, NULL);
 _BUILD_00f0(Data,vrr_stack+117, vrr_stack+6, vrr_stack+15, vrr_stack+0, vrr_stack+12, NULL);
 _BUILD_00g0(Data,vrr_stack+127, vrr_stack+117, vrr_stack+40, vrr_stack+6, vrr_stack+15, NULL);
 _BUILD_00h0(Data,vrr_stack+142, vrr_stack+127, vrr_stack+50, vrr_stack+117, vrr_stack+40, NULL);
 _BUILD_p0h0(Data,vrr_stack+163, vrr_stack+142, vrr_stack+96, NULL, NULL, vrr_stack+50);
 _BUILD_00i0(Data,vrr_stack+226, vrr_stack+142, vrr_stack+96, vrr_stack+127, vrr_stack+50, NULL);
 _BUILD_00p0(Data,vrr_stack+40, Data->F+3, Data->F+4, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+43, vrr_stack+40, vrr_stack+0, Data->F+3, Data->F+4, NULL);
 _BUILD_00f0(Data,vrr_stack+254, vrr_stack+43, vrr_stack+6, vrr_stack+40, vrr_stack+0, NULL);
 _BUILD_00g0(Data,vrr_stack+264, vrr_stack+254, vrr_stack+117, vrr_stack+43, vrr_stack+6, NULL);
 _BUILD_00h0(Data,vrr_stack+279, vrr_stack+264, vrr_stack+127, vrr_stack+254, vrr_stack+117, NULL);
 _BUILD_00i0(Data,vrr_stack+300, vrr_stack+279, vrr_stack+142, vrr_stack+264, vrr_stack+127, NULL);
 _BUILD_00p0(Data,vrr_stack+0, Data->F+10, Data->F+11, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+117, vrr_stack+3, vrr_stack+0, Data->F+9, Data->F+10, NULL);
 _BUILD_00f0(Data,vrr_stack+123, vrr_stack+65, vrr_stack+117, vrr_stack+21, vrr_stack+3, NULL);
 _BUILD_00g0(Data,vrr_stack+6, vrr_stack+71, vrr_stack+123, vrr_stack+24, vrr_stack+65, NULL);
 _BUILD_00h0(Data,vrr_stack+328, vrr_stack+81, vrr_stack+6, vrr_stack+30, vrr_stack+71, NULL);
 _BUILD_00i0(Data,vrr_stack+349, vrr_stack+96, vrr_stack+328, vrr_stack+50, vrr_stack+81, NULL);
 _BUILD_p0i0(Data,vrr_stack+377, vrr_stack+226, vrr_stack+349, NULL, NULL, vrr_stack+96);
 _BUILD_p0i0(Data,vrr_stack+461, vrr_stack+300, vrr_stack+226, NULL, NULL, vrr_stack+142);
 _BUILD_d0i0(Data,vrr_stack+545, vrr_stack+461, vrr_stack+377, vrr_stack+300, vrr_stack+226, vrr_stack+163);
 _BUILD_00k0(Data,vrr_stack+163, vrr_stack+226, vrr_stack+349, vrr_stack+142, vrr_stack+96, NULL);
 _BUILD_00k0(Data,vrr_stack+713, vrr_stack+300, vrr_stack+226, vrr_stack+279, vrr_stack+142, NULL);
 _BUILD_p0k0(Data,vrr_stack+749, vrr_stack+713, vrr_stack+163, NULL, NULL, vrr_stack+226);
 _BUILD_00p0(Data,vrr_stack+199, Data->F+2, Data->F+3, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+202, vrr_stack+199, vrr_stack+40, Data->F+2, Data->F+3, NULL);
 _BUILD_00f0(Data,vrr_stack+208, vrr_stack+202, vrr_stack+43, vrr_stack+199, vrr_stack+40, NULL);
 _BUILD_00g0(Data,vrr_stack+133, vrr_stack+208, vrr_stack+254, vrr_stack+202, vrr_stack+43, NULL);
 _BUILD_00h0(Data,vrr_stack+21, vrr_stack+133, vrr_stack+264, vrr_stack+208, vrr_stack+254, NULL);
 _BUILD_00i0(Data,vrr_stack+857, vrr_stack+21, vrr_stack+279, vrr_stack+133, vrr_stack+264, NULL);
 _BUILD_00k0(Data,vrr_stack+885, vrr_stack+857, vrr_stack+300, vrr_stack+21, vrr_stack+279, NULL);
 _BUILD_p0k0(Data,vrr_stack+921, vrr_stack+885, vrr_stack+713, NULL, NULL, vrr_stack+300);
 _BUILD_00p0(Data,vrr_stack+254, Data->F+11, Data->F+12, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+257, vrr_stack+0, vrr_stack+254, Data->F+10, Data->F+11, NULL);
 _BUILD_00f0(Data,vrr_stack+263, vrr_stack+117, vrr_stack+257, vrr_stack+3, vrr_stack+0, NULL);
 _BUILD_00g0(Data,vrr_stack+148, vrr_stack+123, vrr_stack+263, vrr_stack+65, vrr_stack+117, NULL);
 _BUILD_00h0(Data,vrr_stack+273, vrr_stack+6, vrr_stack+148, vrr_stack+71, vrr_stack+123, NULL);
 _BUILD_00i0(Data,vrr_stack+42, vrr_stack+328, vrr_stack+273, vrr_stack+81, vrr_stack+6, NULL);
 _BUILD_00k0(Data,vrr_stack+1029, vrr_stack+349, vrr_stack+42, vrr_stack+96, vrr_stack+328, NULL);
 _BUILD_p0k0(Data,vrr_stack+1065, vrr_stack+163, vrr_stack+1029, NULL, NULL, vrr_stack+349);
 _BUILD_d0k0(Data,vrr_stack+1173, vrr_stack+749, vrr_stack+1065, vrr_stack+713, vrr_stack+163, vrr_stack+377);
 _BUILD_d0k0(Data,vrr_stack+1389, vrr_stack+921, vrr_stack+749, vrr_stack+885, vrr_stack+713, vrr_stack+461);
 _BUILD_f0k0(Data,vrr_stack+1605, vrr_stack+1389, vrr_stack+1173, vrr_stack+921, vrr_stack+749, vrr_stack+545);
 _BUILD_00l0(Data,vrr_stack+377, vrr_stack+713, vrr_stack+163, vrr_stack+300, vrr_stack+226, NULL);
 _BUILD_00l0(Data,vrr_stack+422, vrr_stack+885, vrr_stack+713, vrr_stack+857, vrr_stack+300, NULL);
 _BUILD_00l0(Data,vrr_stack+467, vrr_stack+163, vrr_stack+1029, vrr_stack+226, vrr_stack+349, NULL);
 _BUILD_p0l0(Data,vrr_stack+512, vrr_stack+377, vrr_stack+467, NULL, NULL, vrr_stack+163);
 _BUILD_p0l0(Data,vrr_stack+1965, vrr_stack+422, vrr_stack+377, NULL, NULL, vrr_stack+713);
 _BUILD_d0l0(Data,vrr_stack+2100, vrr_stack+1965, vrr_stack+512, vrr_stack+422, vrr_stack+377, vrr_stack+749);
 _BUILD_00p0(Data,vrr_stack+3, Data->F+1, Data->F+2, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+749, vrr_stack+3, vrr_stack+199, Data->F+1, Data->F+2, NULL);
 _BUILD_00f0(Data,vrr_stack+755, vrr_stack+749, vrr_stack+202, vrr_stack+3, vrr_stack+199, NULL);
 _BUILD_00g0(Data,vrr_stack+765, vrr_stack+755, vrr_stack+208, vrr_stack+749, vrr_stack+202, NULL);
 _BUILD_00h0(Data,vrr_stack+780, vrr_stack+765, vrr_stack+133, vrr_stack+755, vrr_stack+208, NULL);
 _BUILD_00i0(Data,vrr_stack+199, vrr_stack+780, vrr_stack+21, vrr_stack+765, vrr_stack+133, NULL);
 _BUILD_00k0(Data,vrr_stack+801, vrr_stack+199, vrr_stack+857, vrr_stack+780, vrr_stack+21, NULL);
 _BUILD_00l0(Data,vrr_stack+647, vrr_stack+801, vrr_stack+885, vrr_stack+199, vrr_stack+857, NULL);
 _BUILD_p0l0(Data,vrr_stack+2370, vrr_stack+647, vrr_stack+422, NULL, NULL, vrr_stack+885);
 _BUILD_d0l0(Data,vrr_stack+2505, vrr_stack+2370, vrr_stack+1965, vrr_stack+647, vrr_stack+422, vrr_stack+921);
 _BUILD_00p0(Data,vrr_stack+921, Data->F+12, Data->F+13, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+924, vrr_stack+254, vrr_stack+921, Data->F+11, Data->F+12, NULL);
 _BUILD_00f0(Data,vrr_stack+930, vrr_stack+257, vrr_stack+924, vrr_stack+0, vrr_stack+254, NULL);
 _BUILD_00g0(Data,vrr_stack+133, vrr_stack+263, vrr_stack+930, vrr_stack+117, vrr_stack+257, NULL);
 _BUILD_00h0(Data,vrr_stack+21, vrr_stack+148, vrr_stack+133, vrr_stack+123, vrr_stack+263, NULL);
 _BUILD_00i0(Data,vrr_stack+940, vrr_stack+273, vrr_stack+21, vrr_stack+6, vrr_stack+148, NULL);
 _BUILD_00k0(Data,vrr_stack+968, vrr_stack+42, vrr_stack+940, vrr_stack+328, vrr_stack+273, NULL);
 _BUILD_00l0(Data,vrr_stack+837, vrr_stack+1029, vrr_stack+968, vrr_stack+349, vrr_stack+42, NULL);
 _BUILD_p0l0(Data,vrr_stack+2775, vrr_stack+467, vrr_stack+837, NULL, NULL, vrr_stack+1029);
 _BUILD_d0l0(Data,vrr_stack+2910, vrr_stack+512, vrr_stack+2775, vrr_stack+377, vrr_stack+467, vrr_stack+1065);
 _BUILD_f0l0(Data,vrr_stack+3180, vrr_stack+2100, vrr_stack+2910, vrr_stack+1965, vrr_stack+512, vrr_stack+1173);
 _BUILD_f0l0(Data,vrr_stack+3630, vrr_stack+2505, vrr_stack+2100, vrr_stack+2370, vrr_stack+1965, vrr_stack+1389);
 _BUILD_g0l0(Data,vrr_stack+4080, vrr_stack+3630, vrr_stack+3180, vrr_stack+2505, vrr_stack+2100, vrr_stack+1605);
 _BUILD_00m0(Data,vrr_stack+1065, vrr_stack+377, vrr_stack+467, vrr_stack+713, vrr_stack+163, NULL);
 _BUILD_00m0(Data,vrr_stack+1120, vrr_stack+422, vrr_stack+377, vrr_stack+885, vrr_stack+713, NULL);
 _BUILD_p0m0(Data,vrr_stack+1175, vrr_stack+1120, vrr_stack+1065, NULL, NULL, vrr_stack+377);
 _BUILD_00m0(Data,vrr_stack+1340, vrr_stack+647, vrr_stack+422, vrr_stack+801, vrr_stack+885, NULL);
 _BUILD_p0m0(Data,vrr_stack+1395, vrr_stack+1340, vrr_stack+1120, NULL, NULL, vrr_stack+422);
 _BUILD_00m0(Data,vrr_stack+1560, vrr_stack+467, vrr_stack+837, vrr_stack+163, vrr_stack+1029, NULL);
 _BUILD_p0m0(Data,vrr_stack+1615, vrr_stack+1065, vrr_stack+1560, NULL, NULL, vrr_stack+467);
 _BUILD_d0m0(Data,vrr_stack+4755, vrr_stack+1175, vrr_stack+1615, vrr_stack+1120, vrr_stack+1065, vrr_stack+512);
 _BUILD_d0m0(Data,vrr_stack+5085, vrr_stack+1395, vrr_stack+1175, vrr_stack+1340, vrr_stack+1120, vrr_stack+1965);
 _BUILD_f0m0(Data,vrr_stack+5415, vrr_stack+5085, vrr_stack+4755, vrr_stack+1395, vrr_stack+1175, vrr_stack+2100);
 _BUILD_00p0(Data,vrr_stack+0, Data->F+0, Data->F+1, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+512, vrr_stack+0, vrr_stack+3, Data->F+0, Data->F+1, NULL);
 _BUILD_00f0(Data,vrr_stack+518, vrr_stack+512, vrr_stack+749, vrr_stack+0, vrr_stack+3, NULL);
 _BUILD_00g0(Data,vrr_stack+0, vrr_stack+518, vrr_stack+755, vrr_stack+512, vrr_stack+749, NULL);
 _BUILD_00h0(Data,vrr_stack+528, vrr_stack+0, vrr_stack+765, vrr_stack+518, vrr_stack+755, NULL);
 _BUILD_00i0(Data,vrr_stack+549, vrr_stack+528, vrr_stack+780, vrr_stack+0, vrr_stack+765, NULL);
 _BUILD_00k0(Data,vrr_stack+163, vrr_stack+549, vrr_stack+199, vrr_stack+528, vrr_stack+780, NULL);
 _BUILD_00l0(Data,vrr_stack+577, vrr_stack+163, vrr_stack+801, vrr_stack+549, vrr_stack+199, NULL);
 _BUILD_00m0(Data,vrr_stack+199, vrr_stack+577, vrr_stack+647, vrr_stack+163, vrr_stack+801, NULL);
 _BUILD_p0m0(Data,vrr_stack+1780, vrr_stack+199, vrr_stack+1340, NULL, NULL, vrr_stack+647);
 _BUILD_d0m0(Data,vrr_stack+1945, vrr_stack+1780, vrr_stack+1395, vrr_stack+199, vrr_stack+1340, vrr_stack+2370);
 _BUILD_f0m0(Data,vrr_stack+5965, vrr_stack+1945, vrr_stack+5085, vrr_stack+1780, vrr_stack+1395, vrr_stack+2505);
   tmp = vrr_stack + 5965;
   target_ptr = Libint->vrr_classes[3][9];
   for(i=0;i<550;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00p0(Data,vrr_stack+1780, Data->F+13, Data->F+14, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+1783, vrr_stack+921, vrr_stack+1780, Data->F+12, Data->F+13, NULL);
 _BUILD_00f0(Data,vrr_stack+1789, vrr_stack+924, vrr_stack+1783, vrr_stack+254, vrr_stack+921, NULL);
 _BUILD_00g0(Data,vrr_stack+1799, vrr_stack+930, vrr_stack+1789, vrr_stack+257, vrr_stack+924, NULL);
 _BUILD_00h0(Data,vrr_stack+0, vrr_stack+133, vrr_stack+1799, vrr_stack+263, vrr_stack+930, NULL);
 _BUILD_00i0(Data,vrr_stack+1814, vrr_stack+21, vrr_stack+0, vrr_stack+148, vrr_stack+133, NULL);
 _BUILD_00k0(Data,vrr_stack+148, vrr_stack+940, vrr_stack+1814, vrr_stack+273, vrr_stack+21, NULL);
 _BUILD_00l0(Data,vrr_stack+254, vrr_stack+968, vrr_stack+148, vrr_stack+42, vrr_stack+940, NULL);
 _BUILD_00m0(Data,vrr_stack+42, vrr_stack+837, vrr_stack+254, vrr_stack+1029, vrr_stack+968, NULL);
 _BUILD_p0m0(Data,vrr_stack+2275, vrr_stack+1560, vrr_stack+42, NULL, NULL, vrr_stack+837);
 _BUILD_d0m0(Data,vrr_stack+2440, vrr_stack+1615, vrr_stack+2275, vrr_stack+1065, vrr_stack+1560, vrr_stack+2775);
 _BUILD_f0m0(Data,vrr_stack+6515, vrr_stack+4755, vrr_stack+2440, vrr_stack+1175, vrr_stack+1615, vrr_stack+2910);
 _BUILD_g0m0(Data,vrr_stack+7065, vrr_stack+5415, vrr_stack+6515, vrr_stack+5085, vrr_stack+4755, vrr_stack+3180);
 _BUILD_g0m0(Data,vrr_stack+2770, vrr_stack+5965, vrr_stack+5415, vrr_stack+1945, vrr_stack+5085, vrr_stack+3630);
   tmp = vrr_stack + 2770;
   target_ptr = Libint->vrr_classes[4][9];
   for(i=0;i<825;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00n0(Data,vrr_stack+299, vrr_stack+1065, vrr_stack+1560, vrr_stack+377, vrr_stack+467, NULL);
 _BUILD_00n0(Data,vrr_stack+1842, vrr_stack+1120, vrr_stack+1065, vrr_stack+422, vrr_stack+377, NULL);
 _BUILD_p0n0(Data,vrr_stack+1908, vrr_stack+1842, vrr_stack+299, NULL, NULL, vrr_stack+1065);
 _BUILD_00n0(Data,vrr_stack+2106, vrr_stack+1340, vrr_stack+1120, vrr_stack+647, vrr_stack+422, NULL);
 _BUILD_p0n0(Data,vrr_stack+3595, vrr_stack+2106, vrr_stack+1842, NULL, NULL, vrr_stack+1120);
 _BUILD_00n0(Data,vrr_stack+365, vrr_stack+1560, vrr_stack+42, vrr_stack+467, vrr_stack+837, NULL);
 _BUILD_p0n0(Data,vrr_stack+3793, vrr_stack+299, vrr_stack+365, NULL, NULL, vrr_stack+1560);
 _BUILD_d0n0(Data,vrr_stack+7890, vrr_stack+1908, vrr_stack+3793, vrr_stack+1842, vrr_stack+299, vrr_stack+1615);
 _BUILD_d0n0(Data,vrr_stack+8286, vrr_stack+3595, vrr_stack+1908, vrr_stack+2106, vrr_stack+1842, vrr_stack+1175);
 _BUILD_f0n0(Data,vrr_stack+8682, vrr_stack+8286, vrr_stack+7890, vrr_stack+3595, vrr_stack+1908, vrr_stack+4755);
 _BUILD_00n0(Data,vrr_stack+1842, vrr_stack+199, vrr_stack+1340, vrr_stack+577, vrr_stack+647, NULL);
 _BUILD_p0n0(Data,vrr_stack+4755, vrr_stack+1842, vrr_stack+2106, NULL, NULL, vrr_stack+1340);
 _BUILD_d0n0(Data,vrr_stack+431, vrr_stack+4755, vrr_stack+3595, vrr_stack+1842, vrr_stack+2106, vrr_stack+1395);
 _BUILD_f0n0(Data,vrr_stack+1004, vrr_stack+431, vrr_stack+8286, vrr_stack+4755, vrr_stack+3595, vrr_stack+5085);
   tmp = vrr_stack + 1004;
   target_ptr = Libint->vrr_classes[3][10];
   for(i=0;i<660;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00p0(Data,vrr_stack+3595, Data->F+14, Data->F+15, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+3598, vrr_stack+1780, vrr_stack+3595, Data->F+13, Data->F+14, NULL);
 _BUILD_00f0(Data,vrr_stack+827, vrr_stack+1783, vrr_stack+3598, vrr_stack+921, vrr_stack+1780, NULL);
 _BUILD_00g0(Data,vrr_stack+3595, vrr_stack+1789, vrr_stack+827, vrr_stack+924, vrr_stack+1783, NULL);
 _BUILD_00h0(Data,vrr_stack+3610, vrr_stack+1799, vrr_stack+3595, vrr_stack+930, vrr_stack+1789, NULL);
 _BUILD_00i0(Data,vrr_stack+3631, vrr_stack+0, vrr_stack+3610, vrr_stack+133, vrr_stack+1799, NULL);
 _BUILD_00k0(Data,vrr_stack+3595, vrr_stack+1814, vrr_stack+3631, vrr_stack+21, vrr_stack+0, NULL);
 _BUILD_00l0(Data,vrr_stack+3631, vrr_stack+148, vrr_stack+3595, vrr_stack+940, vrr_stack+1814, NULL);
 _BUILD_00m0(Data,vrr_stack+3676, vrr_stack+254, vrr_stack+3631, vrr_stack+968, vrr_stack+148, NULL);
 _BUILD_00n0(Data,vrr_stack+3595, vrr_stack+42, vrr_stack+3676, vrr_stack+837, vrr_stack+254, NULL);
 _BUILD_p0n0(Data,vrr_stack+4755, vrr_stack+365, vrr_stack+3595, NULL, NULL, vrr_stack+42);
 _BUILD_d0n0(Data,vrr_stack+4953, vrr_stack+3793, vrr_stack+4755, vrr_stack+299, vrr_stack+365, vrr_stack+2275);
 _BUILD_f0n0(Data,vrr_stack+9342, vrr_stack+7890, vrr_stack+4953, vrr_stack+1908, vrr_stack+3793, vrr_stack+2440);
 _BUILD_g0n0(Data,vrr_stack+1664, vrr_stack+8682, vrr_stack+9342, vrr_stack+8286, vrr_stack+7890, vrr_stack+6515);
 _BUILD_g0n0(Data,vrr_stack+9342, vrr_stack+1004, vrr_stack+8682, vrr_stack+431, vrr_stack+8286, vrr_stack+5415);
   tmp = vrr_stack + 9342;
   target_ptr = Libint->vrr_classes[4][10];
   for(i=0;i<990;i++)
     target_ptr[i] += tmp[i];
 _BUILD_h0m0(Data,vrr_stack+10332, vrr_stack+2770, vrr_stack+7065, vrr_stack+5965, vrr_stack+5415, vrr_stack+4080);
   tmp = vrr_stack + 10332;
   target_ptr = Libint->vrr_classes[5][9];
   for(i=0;i<1155;i++)
     target_ptr[i] += tmp[i];
 _BUILD_h0n0(Data,vrr_stack+2654, vrr_stack+9342, vrr_stack+1664, vrr_stack+1004, vrr_stack+8682, vrr_stack+7065);
   tmp = vrr_stack + 2654;
   target_ptr = Libint->vrr_classes[5][10];
   for(i=0;i<1386;i++)
     target_ptr[i] += tmp[i];

}

