/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include "libint.h"
#include "vrr_header.h"

  /* Computes quartets necessary to compute (ff|kg) integrals */

void vrr_order_ffkg(Libint_t * Libint, prim_data *Data)
{
 REALTYPE *vrr_stack = Libint->vrr_stack;
 REALTYPE *tmp, *target_ptr;
 int i, am[2];
 _BUILD_00p0(Data,vrr_stack+0, Data->F+6, Data->F+7, NULL, NULL, NULL);
 _BUILD_00p0(Data,vrr_stack+3, Data->F+7, Data->F+8, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+6, vrr_stack+0, vrr_stack+3, Data->F+6, Data->F+7, NULL);
 _BUILD_00p0(Data,vrr_stack+12, Data->F+5, Data->F+6, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+15, vrr_stack+12, vrr_stack+0, Data->F+5, Data->F+6, NULL);
 _BUILD_p0d0(Data,vrr_stack+21, vrr_stack+15, vrr_stack+6, NULL, NULL, vrr_stack+0);
 _BUILD_00f0(Data,vrr_stack+39, vrr_stack+15, vrr_stack+6, vrr_stack+12, vrr_stack+0, NULL);
 _BUILD_00p0(Data,vrr_stack+49, Data->F+4, Data->F+5, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+52, vrr_stack+49, vrr_stack+12, Data->F+4, Data->F+5, NULL);
 _BUILD_00f0(Data,vrr_stack+58, vrr_stack+52, vrr_stack+15, vrr_stack+49, vrr_stack+12, NULL);
 _BUILD_00p0(Data,vrr_stack+12, Data->F+8, Data->F+9, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+68, vrr_stack+3, vrr_stack+12, Data->F+7, Data->F+8, NULL);
 _BUILD_00f0(Data,vrr_stack+74, vrr_stack+6, vrr_stack+68, vrr_stack+0, vrr_stack+3, NULL);
 _BUILD_p0f0(Data,vrr_stack+84, vrr_stack+39, vrr_stack+74, NULL, NULL, vrr_stack+6);
 _BUILD_p0f0(Data,vrr_stack+114, vrr_stack+58, vrr_stack+39, NULL, NULL, vrr_stack+15);
 _BUILD_d0f0(Data,vrr_stack+144, vrr_stack+114, vrr_stack+84, vrr_stack+58, vrr_stack+39, vrr_stack+21);
 _BUILD_00g0(Data,vrr_stack+21, vrr_stack+39, vrr_stack+74, vrr_stack+15, vrr_stack+6, NULL);
 _BUILD_00g0(Data,vrr_stack+204, vrr_stack+58, vrr_stack+39, vrr_stack+52, vrr_stack+15, NULL);
 _BUILD_p0g0(Data,vrr_stack+219, vrr_stack+204, vrr_stack+21, NULL, NULL, vrr_stack+39);
 _BUILD_00p0(Data,vrr_stack+36, Data->F+3, Data->F+4, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+15, vrr_stack+36, vrr_stack+49, Data->F+3, Data->F+4, NULL);
 _BUILD_00f0(Data,vrr_stack+264, vrr_stack+15, vrr_stack+52, vrr_stack+36, vrr_stack+49, NULL);
 _BUILD_00g0(Data,vrr_stack+274, vrr_stack+264, vrr_stack+58, vrr_stack+15, vrr_stack+52, NULL);
 _BUILD_p0g0(Data,vrr_stack+289, vrr_stack+274, vrr_stack+204, NULL, NULL, vrr_stack+58);
 _BUILD_00p0(Data,vrr_stack+0, Data->F+9, Data->F+10, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+49, vrr_stack+12, vrr_stack+0, Data->F+8, Data->F+9, NULL);
 _BUILD_00f0(Data,vrr_stack+334, vrr_stack+68, vrr_stack+49, vrr_stack+3, vrr_stack+12, NULL);
 _BUILD_00g0(Data,vrr_stack+344, vrr_stack+74, vrr_stack+334, vrr_stack+6, vrr_stack+68, NULL);
 _BUILD_p0g0(Data,vrr_stack+359, vrr_stack+21, vrr_stack+344, NULL, NULL, vrr_stack+74);
 _BUILD_d0g0(Data,vrr_stack+404, vrr_stack+219, vrr_stack+359, vrr_stack+204, vrr_stack+21, vrr_stack+84);
 _BUILD_d0g0(Data,vrr_stack+494, vrr_stack+289, vrr_stack+219, vrr_stack+274, vrr_stack+204, vrr_stack+114);
 _BUILD_f0g0(Data,vrr_stack+584, vrr_stack+494, vrr_stack+404, vrr_stack+289, vrr_stack+219, vrr_stack+144);
 _BUILD_00h0(Data,vrr_stack+84, vrr_stack+204, vrr_stack+21, vrr_stack+58, vrr_stack+39, NULL);
 _BUILD_00h0(Data,vrr_stack+105, vrr_stack+274, vrr_stack+204, vrr_stack+264, vrr_stack+58, NULL);
 _BUILD_00h0(Data,vrr_stack+126, vrr_stack+21, vrr_stack+344, vrr_stack+39, vrr_stack+74, NULL);
 _BUILD_p0h0(Data,vrr_stack+734, vrr_stack+84, vrr_stack+126, NULL, NULL, vrr_stack+21);
 _BUILD_p0h0(Data,vrr_stack+797, vrr_stack+105, vrr_stack+84, NULL, NULL, vrr_stack+204);
 _BUILD_d0h0(Data,vrr_stack+860, vrr_stack+797, vrr_stack+734, vrr_stack+105, vrr_stack+84, vrr_stack+219);
 _BUILD_00p0(Data,vrr_stack+219, Data->F+2, Data->F+3, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+222, vrr_stack+219, vrr_stack+36, Data->F+2, Data->F+3, NULL);
 _BUILD_00f0(Data,vrr_stack+39, vrr_stack+222, vrr_stack+15, vrr_stack+219, vrr_stack+36, NULL);
 _BUILD_00g0(Data,vrr_stack+986, vrr_stack+39, vrr_stack+264, vrr_stack+222, vrr_stack+15, NULL);
 _BUILD_00h0(Data,vrr_stack+228, vrr_stack+986, vrr_stack+274, vrr_stack+39, vrr_stack+264, NULL);
 _BUILD_p0h0(Data,vrr_stack+1001, vrr_stack+228, vrr_stack+105, NULL, NULL, vrr_stack+274);
 _BUILD_d0h0(Data,vrr_stack+1064, vrr_stack+1001, vrr_stack+797, vrr_stack+228, vrr_stack+105, vrr_stack+289);
 _BUILD_00p0(Data,vrr_stack+36, Data->F+10, Data->F+11, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+15, vrr_stack+0, vrr_stack+36, Data->F+9, Data->F+10, NULL);
 _BUILD_00f0(Data,vrr_stack+289, vrr_stack+49, vrr_stack+15, vrr_stack+12, vrr_stack+0, NULL);
 _BUILD_00g0(Data,vrr_stack+299, vrr_stack+334, vrr_stack+289, vrr_stack+68, vrr_stack+49, NULL);
 _BUILD_00h0(Data,vrr_stack+249, vrr_stack+344, vrr_stack+299, vrr_stack+74, vrr_stack+334, NULL);
 _BUILD_p0h0(Data,vrr_stack+1190, vrr_stack+126, vrr_stack+249, NULL, NULL, vrr_stack+344);
 _BUILD_d0h0(Data,vrr_stack+1253, vrr_stack+734, vrr_stack+1190, vrr_stack+84, vrr_stack+126, vrr_stack+359);
 _BUILD_f0h0(Data,vrr_stack+1379, vrr_stack+860, vrr_stack+1253, vrr_stack+797, vrr_stack+734, vrr_stack+404);
 _BUILD_f0h0(Data,vrr_stack+1589, vrr_stack+1064, vrr_stack+860, vrr_stack+1001, vrr_stack+797, vrr_stack+494);
 _BUILD_g0h0(Data,vrr_stack+1799, vrr_stack+1589, vrr_stack+1379, vrr_stack+1064, vrr_stack+860, vrr_stack+584);
 _BUILD_00i0(Data,vrr_stack+359, vrr_stack+84, vrr_stack+126, vrr_stack+204, vrr_stack+21, NULL);
 _BUILD_00i0(Data,vrr_stack+387, vrr_stack+105, vrr_stack+84, vrr_stack+274, vrr_stack+204, NULL);
 _BUILD_p0i0(Data,vrr_stack+415, vrr_stack+387, vrr_stack+359, NULL, NULL, vrr_stack+84);
 _BUILD_00i0(Data,vrr_stack+499, vrr_stack+228, vrr_stack+105, vrr_stack+986, vrr_stack+274, NULL);
 _BUILD_p0i0(Data,vrr_stack+527, vrr_stack+499, vrr_stack+387, NULL, NULL, vrr_stack+105);
 _BUILD_00i0(Data,vrr_stack+611, vrr_stack+126, vrr_stack+249, vrr_stack+21, vrr_stack+344, NULL);
 _BUILD_p0i0(Data,vrr_stack+639, vrr_stack+359, vrr_stack+611, NULL, NULL, vrr_stack+126);
 _BUILD_d0i0(Data,vrr_stack+2114, vrr_stack+415, vrr_stack+639, vrr_stack+387, vrr_stack+359, vrr_stack+734);
 _BUILD_d0i0(Data,vrr_stack+2282, vrr_stack+527, vrr_stack+415, vrr_stack+499, vrr_stack+387, vrr_stack+797);
 _BUILD_f0i0(Data,vrr_stack+2450, vrr_stack+2282, vrr_stack+2114, vrr_stack+527, vrr_stack+415, vrr_stack+860);
 _BUILD_00p0(Data,vrr_stack+21, Data->F+1, Data->F+2, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+24, vrr_stack+21, vrr_stack+219, Data->F+1, Data->F+2, NULL);
 _BUILD_00f0(Data,vrr_stack+723, vrr_stack+24, vrr_stack+222, vrr_stack+21, vrr_stack+219, NULL);
 _BUILD_00g0(Data,vrr_stack+733, vrr_stack+723, vrr_stack+39, vrr_stack+24, vrr_stack+222, NULL);
 _BUILD_00h0(Data,vrr_stack+748, vrr_stack+733, vrr_stack+986, vrr_stack+723, vrr_stack+39, NULL);
 _BUILD_00i0(Data,vrr_stack+769, vrr_stack+748, vrr_stack+228, vrr_stack+733, vrr_stack+986, NULL);
 _BUILD_p0i0(Data,vrr_stack+797, vrr_stack+769, vrr_stack+499, NULL, NULL, vrr_stack+228);
 _BUILD_d0i0(Data,vrr_stack+2730, vrr_stack+797, vrr_stack+527, vrr_stack+769, vrr_stack+499, vrr_stack+1001);
 _BUILD_f0i0(Data,vrr_stack+2898, vrr_stack+2730, vrr_stack+2282, vrr_stack+797, vrr_stack+527, vrr_stack+1064);
 _BUILD_00p0(Data,vrr_stack+39, Data->F+11, Data->F+12, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+30, vrr_stack+36, vrr_stack+39, Data->F+10, Data->F+11, NULL);
 _BUILD_00f0(Data,vrr_stack+881, vrr_stack+15, vrr_stack+30, vrr_stack+0, vrr_stack+36, NULL);
 _BUILD_00g0(Data,vrr_stack+0, vrr_stack+289, vrr_stack+881, vrr_stack+49, vrr_stack+15, NULL);
 _BUILD_00h0(Data,vrr_stack+42, vrr_stack+299, vrr_stack+0, vrr_stack+334, vrr_stack+289, NULL);
 _BUILD_00i0(Data,vrr_stack+891, vrr_stack+249, vrr_stack+42, vrr_stack+344, vrr_stack+299, NULL);
 _BUILD_p0i0(Data,vrr_stack+919, vrr_stack+611, vrr_stack+891, NULL, NULL, vrr_stack+249);
 _BUILD_d0i0(Data,vrr_stack+1003, vrr_stack+639, vrr_stack+919, vrr_stack+359, vrr_stack+611, vrr_stack+1190);
 _BUILD_f0i0(Data,vrr_stack+3178, vrr_stack+2114, vrr_stack+1003, vrr_stack+415, vrr_stack+639, vrr_stack+1253);
 _BUILD_g0i0(Data,vrr_stack+3458, vrr_stack+2450, vrr_stack+3178, vrr_stack+2282, vrr_stack+2114, vrr_stack+1379);
 _BUILD_g0i0(Data,vrr_stack+3878, vrr_stack+2898, vrr_stack+2450, vrr_stack+2730, vrr_stack+2282, vrr_stack+1589);
 _BUILD_h0i0(Data,vrr_stack+1171, vrr_stack+3878, vrr_stack+3458, vrr_stack+2898, vrr_stack+2450, vrr_stack+1799);
 _BUILD_00k0(Data,vrr_stack+1759, vrr_stack+387, vrr_stack+359, vrr_stack+105, vrr_stack+84, NULL);
 _BUILD_00k0(Data,vrr_stack+1795, vrr_stack+499, vrr_stack+387, vrr_stack+228, vrr_stack+105, NULL);
 _BUILD_00k0(Data,vrr_stack+1831, vrr_stack+359, vrr_stack+611, vrr_stack+84, vrr_stack+126, NULL);
 _BUILD_p0k0(Data,vrr_stack+1867, vrr_stack+1759, vrr_stack+1831, NULL, NULL, vrr_stack+359);
 _BUILD_p0k0(Data,vrr_stack+1975, vrr_stack+1795, vrr_stack+1759, NULL, NULL, vrr_stack+387);
 _BUILD_d0k0(Data,vrr_stack+4298, vrr_stack+1975, vrr_stack+1867, vrr_stack+1795, vrr_stack+1759, vrr_stack+415);
 _BUILD_00k0(Data,vrr_stack+415, vrr_stack+769, vrr_stack+499, vrr_stack+748, vrr_stack+228, NULL);
 _BUILD_p0k0(Data,vrr_stack+4514, vrr_stack+415, vrr_stack+1795, NULL, NULL, vrr_stack+499);
 _BUILD_d0k0(Data,vrr_stack+4622, vrr_stack+4514, vrr_stack+1975, vrr_stack+415, vrr_stack+1795, vrr_stack+527);
 _BUILD_00k0(Data,vrr_stack+527, vrr_stack+611, vrr_stack+891, vrr_stack+126, vrr_stack+249, NULL);
 _BUILD_p0k0(Data,vrr_stack+63, vrr_stack+1831, vrr_stack+527, NULL, NULL, vrr_stack+611);
 _BUILD_d0k0(Data,vrr_stack+4838, vrr_stack+1867, vrr_stack+63, vrr_stack+1759, vrr_stack+1831, vrr_stack+639);
 _BUILD_f0k0(Data,vrr_stack+5054, vrr_stack+4298, vrr_stack+4838, vrr_stack+1975, vrr_stack+1867, vrr_stack+2114);
 _BUILD_f0k0(Data,vrr_stack+5414, vrr_stack+4622, vrr_stack+4298, vrr_stack+4514, vrr_stack+1975, vrr_stack+2282);
 _BUILD_g0k0(Data,vrr_stack+5774, vrr_stack+5414, vrr_stack+5054, vrr_stack+4622, vrr_stack+4298, vrr_stack+2450);
 _BUILD_00p0(Data,vrr_stack+639, Data->F+0, Data->F+1, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+642, vrr_stack+639, vrr_stack+21, Data->F+0, Data->F+1, NULL);
 _BUILD_00f0(Data,vrr_stack+648, vrr_stack+642, vrr_stack+24, vrr_stack+639, vrr_stack+21, NULL);
 _BUILD_00g0(Data,vrr_stack+658, vrr_stack+648, vrr_stack+723, vrr_stack+642, vrr_stack+24, NULL);
 _BUILD_00h0(Data,vrr_stack+673, vrr_stack+658, vrr_stack+733, vrr_stack+648, vrr_stack+723, NULL);
 _BUILD_00i0(Data,vrr_stack+694, vrr_stack+673, vrr_stack+748, vrr_stack+658, vrr_stack+733, NULL);
 _BUILD_00k0(Data,vrr_stack+563, vrr_stack+694, vrr_stack+769, vrr_stack+673, vrr_stack+748, NULL);
 _BUILD_p0k0(Data,vrr_stack+2083, vrr_stack+563, vrr_stack+415, NULL, NULL, vrr_stack+769);
 _BUILD_d0k0(Data,vrr_stack+2191, vrr_stack+2083, vrr_stack+4514, vrr_stack+563, vrr_stack+415, vrr_stack+797);
 _BUILD_f0k0(Data,vrr_stack+6314, vrr_stack+2191, vrr_stack+4622, vrr_stack+2083, vrr_stack+4514, vrr_stack+2730);
   tmp = vrr_stack + 6314;
   target_ptr = Libint->vrr_classes[3][7];
   for(i=0;i<360;i++)
     target_ptr[i] += tmp[i];
 _BUILD_g0k0(Data,vrr_stack+6674, vrr_stack+6314, vrr_stack+5414, vrr_stack+2191, vrr_stack+4622, vrr_stack+2898);
   tmp = vrr_stack + 6674;
   target_ptr = Libint->vrr_classes[4][7];
   for(i=0;i<540;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00p0(Data,vrr_stack+2083, Data->F+12, Data->F+13, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+2086, vrr_stack+39, vrr_stack+2083, Data->F+11, Data->F+12, NULL);
 _BUILD_00f0(Data,vrr_stack+2092, vrr_stack+30, vrr_stack+2086, vrr_stack+36, vrr_stack+39, NULL);
 _BUILD_00g0(Data,vrr_stack+2102, vrr_stack+881, vrr_stack+2092, vrr_stack+15, vrr_stack+30, NULL);
 _BUILD_00h0(Data,vrr_stack+2117, vrr_stack+0, vrr_stack+2102, vrr_stack+289, vrr_stack+881, NULL);
 _BUILD_00i0(Data,vrr_stack+2138, vrr_stack+42, vrr_stack+2117, vrr_stack+299, vrr_stack+0, NULL);
 _BUILD_00k0(Data,vrr_stack+2166, vrr_stack+891, vrr_stack+2138, vrr_stack+249, vrr_stack+42, NULL);
 _BUILD_p0k0(Data,vrr_stack+2202, vrr_stack+527, vrr_stack+2166, NULL, NULL, vrr_stack+891);
 _BUILD_d0k0(Data,vrr_stack+2310, vrr_stack+63, vrr_stack+2202, vrr_stack+1831, vrr_stack+527, vrr_stack+919);
 _BUILD_f0k0(Data,vrr_stack+2526, vrr_stack+4838, vrr_stack+2310, vrr_stack+1867, vrr_stack+63, vrr_stack+1003);
 _BUILD_g0k0(Data,vrr_stack+7214, vrr_stack+5054, vrr_stack+2526, vrr_stack+4298, vrr_stack+4838, vrr_stack+3178);
 _BUILD_h0k0(Data,vrr_stack+7754, vrr_stack+5774, vrr_stack+7214, vrr_stack+5414, vrr_stack+5054, vrr_stack+3458);
 _BUILD_h0k0(Data,vrr_stack+2886, vrr_stack+6674, vrr_stack+5774, vrr_stack+6314, vrr_stack+5414, vrr_stack+3878);
   tmp = vrr_stack + 2886;
   target_ptr = Libint->vrr_classes[5][7];
   for(i=0;i<756;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00l0(Data,vrr_stack+6314, vrr_stack+1759, vrr_stack+1831, vrr_stack+387, vrr_stack+359, NULL);
 _BUILD_00l0(Data,vrr_stack+6359, vrr_stack+1795, vrr_stack+1759, vrr_stack+499, vrr_stack+387, NULL);
 _BUILD_00l0(Data,vrr_stack+6404, vrr_stack+1831, vrr_stack+527, vrr_stack+359, vrr_stack+611, NULL);
 _BUILD_p0l0(Data,vrr_stack+6449, vrr_stack+6314, vrr_stack+6404, NULL, NULL, vrr_stack+1831);
 _BUILD_p0l0(Data,vrr_stack+919, vrr_stack+6359, vrr_stack+6314, NULL, NULL, vrr_stack+1759);
 _BUILD_d0l0(Data,vrr_stack+3642, vrr_stack+919, vrr_stack+6449, vrr_stack+6359, vrr_stack+6314, vrr_stack+1867);
 _BUILD_00l0(Data,vrr_stack+1867, vrr_stack+415, vrr_stack+1795, vrr_stack+769, vrr_stack+499, NULL);
 _BUILD_p0l0(Data,vrr_stack+3912, vrr_stack+1867, vrr_stack+6359, NULL, NULL, vrr_stack+1795);
 _BUILD_d0l0(Data,vrr_stack+8510, vrr_stack+3912, vrr_stack+919, vrr_stack+1867, vrr_stack+6359, vrr_stack+1975);
 _BUILD_00l0(Data,vrr_stack+1912, vrr_stack+527, vrr_stack+2166, vrr_stack+611, vrr_stack+891, NULL);
 _BUILD_p0l0(Data,vrr_stack+4047, vrr_stack+6404, vrr_stack+1912, NULL, NULL, vrr_stack+527);
 _BUILD_d0l0(Data,vrr_stack+8780, vrr_stack+6449, vrr_stack+4047, vrr_stack+6314, vrr_stack+6404, vrr_stack+63);
 _BUILD_f0l0(Data,vrr_stack+9050, vrr_stack+3642, vrr_stack+8780, vrr_stack+919, vrr_stack+6449, vrr_stack+4838);
 _BUILD_f0l0(Data,vrr_stack+9500, vrr_stack+8510, vrr_stack+3642, vrr_stack+3912, vrr_stack+919, vrr_stack+4298);
 _BUILD_g0l0(Data,vrr_stack+9950, vrr_stack+9500, vrr_stack+9050, vrr_stack+8510, vrr_stack+3642, vrr_stack+5054);
 _BUILD_00l0(Data,vrr_stack+4838, vrr_stack+563, vrr_stack+415, vrr_stack+694, vrr_stack+769, NULL);
 _BUILD_p0l0(Data,vrr_stack+4883, vrr_stack+4838, vrr_stack+1867, NULL, NULL, vrr_stack+415);
 _BUILD_d0l0(Data,vrr_stack+5018, vrr_stack+4883, vrr_stack+3912, vrr_stack+4838, vrr_stack+1867, vrr_stack+4514);
 _BUILD_f0l0(Data,vrr_stack+10625, vrr_stack+5018, vrr_stack+8510, vrr_stack+4883, vrr_stack+3912, vrr_stack+4622);
   tmp = vrr_stack + 10625;
   target_ptr = Libint->vrr_classes[3][8];
   for(i=0;i<450;i++)
     target_ptr[i] += tmp[i];
 _BUILD_g0l0(Data,vrr_stack+11075, vrr_stack+10625, vrr_stack+9500, vrr_stack+5018, vrr_stack+8510, vrr_stack+5414);
   tmp = vrr_stack + 11075;
   target_ptr = Libint->vrr_classes[4][8];
   for(i=0;i<675;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00p0(Data,vrr_stack+36, Data->F+13, Data->F+14, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+4883, vrr_stack+2083, vrr_stack+36, Data->F+12, Data->F+13, NULL);
 _BUILD_00f0(Data,vrr_stack+4889, vrr_stack+2086, vrr_stack+4883, vrr_stack+39, vrr_stack+2083, NULL);
 _BUILD_00g0(Data,vrr_stack+15, vrr_stack+2092, vrr_stack+4889, vrr_stack+30, vrr_stack+2086, NULL);
 _BUILD_00h0(Data,vrr_stack+4899, vrr_stack+2102, vrr_stack+15, vrr_stack+881, vrr_stack+2092, NULL);
 _BUILD_00i0(Data,vrr_stack+4920, vrr_stack+2117, vrr_stack+4899, vrr_stack+0, vrr_stack+2102, NULL);
 _BUILD_00k0(Data,vrr_stack+4948, vrr_stack+2138, vrr_stack+4920, vrr_stack+42, vrr_stack+2117, NULL);
 _BUILD_00l0(Data,vrr_stack+39, vrr_stack+2166, vrr_stack+4948, vrr_stack+891, vrr_stack+2138, NULL);
 _BUILD_p0l0(Data,vrr_stack+84, vrr_stack+1912, vrr_stack+39, NULL, NULL, vrr_stack+2166);
 _BUILD_d0l0(Data,vrr_stack+4984, vrr_stack+4047, vrr_stack+84, vrr_stack+6404, vrr_stack+1912, vrr_stack+2202);
 _BUILD_f0l0(Data,vrr_stack+5254, vrr_stack+8780, vrr_stack+4984, vrr_stack+6449, vrr_stack+4047, vrr_stack+2310);
 _BUILD_g0l0(Data,vrr_stack+11750, vrr_stack+9050, vrr_stack+5254, vrr_stack+3642, vrr_stack+8780, vrr_stack+2526);
 _BUILD_h0l0(Data,vrr_stack+12425, vrr_stack+9950, vrr_stack+11750, vrr_stack+9500, vrr_stack+9050, vrr_stack+7214);
 _BUILD_h0l0(Data,vrr_stack+13370, vrr_stack+11075, vrr_stack+9950, vrr_stack+10625, vrr_stack+9500, vrr_stack+5774);
   tmp = vrr_stack + 13370;
   target_ptr = Libint->vrr_classes[5][8];
   for(i=0;i<945;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00m0(Data,vrr_stack+10625, vrr_stack+6314, vrr_stack+6404, vrr_stack+1759, vrr_stack+1831, NULL);
 _BUILD_00m0(Data,vrr_stack+10680, vrr_stack+6359, vrr_stack+6314, vrr_stack+1795, vrr_stack+1759, NULL);
 _BUILD_00m0(Data,vrr_stack+10735, vrr_stack+6404, vrr_stack+1912, vrr_stack+1831, vrr_stack+527, NULL);
 _BUILD_p0m0(Data,vrr_stack+10790, vrr_stack+10625, vrr_stack+10735, NULL, NULL, vrr_stack+6404);
 _BUILD_p0m0(Data,vrr_stack+7214, vrr_stack+10680, vrr_stack+10625, NULL, NULL, vrr_stack+6314);
 _BUILD_d0m0(Data,vrr_stack+7379, vrr_stack+7214, vrr_stack+10790, vrr_stack+10680, vrr_stack+10625, vrr_stack+6449);
 _BUILD_00m0(Data,vrr_stack+6449, vrr_stack+1867, vrr_stack+6359, vrr_stack+415, vrr_stack+1795, NULL);
 _BUILD_p0m0(Data,vrr_stack+6504, vrr_stack+6449, vrr_stack+10680, NULL, NULL, vrr_stack+6359);
 _BUILD_d0m0(Data,vrr_stack+2202, vrr_stack+6504, vrr_stack+7214, vrr_stack+6449, vrr_stack+10680, vrr_stack+919);
 _BUILD_00m0(Data,vrr_stack+1759, vrr_stack+1912, vrr_stack+39, vrr_stack+527, vrr_stack+2166, NULL);
 _BUILD_p0m0(Data,vrr_stack+2532, vrr_stack+10735, vrr_stack+1759, NULL, NULL, vrr_stack+1912);
 _BUILD_d0m0(Data,vrr_stack+4182, vrr_stack+10790, vrr_stack+2532, vrr_stack+10625, vrr_stack+10735, vrr_stack+4047);
 _BUILD_f0m0(Data,vrr_stack+599, vrr_stack+7379, vrr_stack+4182, vrr_stack+7214, vrr_stack+10790, vrr_stack+8780);
 _BUILD_f0m0(Data,vrr_stack+14315, vrr_stack+2202, vrr_stack+7379, vrr_stack+6504, vrr_stack+7214, vrr_stack+3642);
 _BUILD_g0m0(Data,vrr_stack+14865, vrr_stack+14315, vrr_stack+599, vrr_stack+2202, vrr_stack+7379, vrr_stack+9050);
 _BUILD_00m0(Data,vrr_stack+3642, vrr_stack+4838, vrr_stack+1867, vrr_stack+563, vrr_stack+415, NULL);
 _BUILD_p0m0(Data,vrr_stack+3697, vrr_stack+3642, vrr_stack+6449, NULL, NULL, vrr_stack+1867);
 _BUILD_d0m0(Data,vrr_stack+8780, vrr_stack+3697, vrr_stack+6504, vrr_stack+3642, vrr_stack+6449, vrr_stack+3912);
 _BUILD_f0m0(Data,vrr_stack+15690, vrr_stack+8780, vrr_stack+2202, vrr_stack+3697, vrr_stack+6504, vrr_stack+8510);
   tmp = vrr_stack + 15690;
   target_ptr = Libint->vrr_classes[3][9];
   for(i=0;i<550;i++)
     target_ptr[i] += tmp[i];
 _BUILD_g0m0(Data,vrr_stack+16240, vrr_stack+15690, vrr_stack+14315, vrr_stack+8780, vrr_stack+2202, vrr_stack+9500);
   tmp = vrr_stack + 16240;
   target_ptr = Libint->vrr_classes[4][9];
   for(i=0;i<825;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00p0(Data,vrr_stack+8510, Data->F+14, Data->F+15, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+30, vrr_stack+36, vrr_stack+8510, Data->F+13, Data->F+14, NULL);
 _BUILD_00f0(Data,vrr_stack+8513, vrr_stack+4883, vrr_stack+30, vrr_stack+2083, vrr_stack+36, NULL);
 _BUILD_00g0(Data,vrr_stack+0, vrr_stack+4889, vrr_stack+8513, vrr_stack+2086, vrr_stack+4883, NULL);
 _BUILD_00h0(Data,vrr_stack+8523, vrr_stack+15, vrr_stack+0, vrr_stack+2092, vrr_stack+4889, NULL);
 _BUILD_00i0(Data,vrr_stack+8544, vrr_stack+4899, vrr_stack+8523, vrr_stack+2102, vrr_stack+15, NULL);
 _BUILD_00k0(Data,vrr_stack+8572, vrr_stack+4920, vrr_stack+8544, vrr_stack+2117, vrr_stack+4899, NULL);
 _BUILD_00l0(Data,vrr_stack+7709, vrr_stack+4948, vrr_stack+8572, vrr_stack+2138, vrr_stack+4920, NULL);
 _BUILD_00m0(Data,vrr_stack+8608, vrr_stack+39, vrr_stack+7709, vrr_stack+2166, vrr_stack+4948, NULL);
 _BUILD_p0m0(Data,vrr_stack+8663, vrr_stack+1759, vrr_stack+8608, NULL, NULL, vrr_stack+39);
 _BUILD_d0m0(Data,vrr_stack+8828, vrr_stack+2532, vrr_stack+8663, vrr_stack+10735, vrr_stack+1759, vrr_stack+84);
 _BUILD_f0m0(Data,vrr_stack+9158, vrr_stack+4182, vrr_stack+8828, vrr_stack+10790, vrr_stack+2532, vrr_stack+4984);
 _BUILD_g0m0(Data,vrr_stack+17065, vrr_stack+599, vrr_stack+9158, vrr_stack+7379, vrr_stack+4182, vrr_stack+5254);
 _BUILD_h0m0(Data,vrr_stack+17890, vrr_stack+14865, vrr_stack+17065, vrr_stack+14315, vrr_stack+599, vrr_stack+11750);
 _BUILD_h0m0(Data,vrr_stack+19045, vrr_stack+16240, vrr_stack+14865, vrr_stack+15690, vrr_stack+14315, vrr_stack+9950);
   tmp = vrr_stack + 19045;
   target_ptr = Libint->vrr_classes[5][9];
   for(i=0;i<1155;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00n0(Data,vrr_stack+15690, vrr_stack+10625, vrr_stack+10735, vrr_stack+6314, vrr_stack+6404, NULL);
 _BUILD_00n0(Data,vrr_stack+15756, vrr_stack+10680, vrr_stack+10625, vrr_stack+6359, vrr_stack+6314, NULL);
 _BUILD_00n0(Data,vrr_stack+15822, vrr_stack+10735, vrr_stack+1759, vrr_stack+6404, vrr_stack+1912, NULL);
 _BUILD_p0n0(Data,vrr_stack+15888, vrr_stack+15690, vrr_stack+15822, NULL, NULL, vrr_stack+10735);
 _BUILD_p0n0(Data,vrr_stack+11750, vrr_stack+15756, vrr_stack+15690, NULL, NULL, vrr_stack+10625);
 _BUILD_d0n0(Data,vrr_stack+11948, vrr_stack+11750, vrr_stack+15888, vrr_stack+15756, vrr_stack+15690, vrr_stack+10790);
 _BUILD_00n0(Data,vrr_stack+10790, vrr_stack+6449, vrr_stack+10680, vrr_stack+1867, vrr_stack+6359, NULL);
 _BUILD_p0n0(Data,vrr_stack+10856, vrr_stack+10790, vrr_stack+15756, NULL, NULL, vrr_stack+10680);
 _BUILD_d0n0(Data,vrr_stack+4984, vrr_stack+10856, vrr_stack+11750, vrr_stack+10790, vrr_stack+15756, vrr_stack+7214);
 _BUILD_00n0(Data,vrr_stack+7214, vrr_stack+1759, vrr_stack+8608, vrr_stack+1912, vrr_stack+39, NULL);
 _BUILD_p0n0(Data,vrr_stack+1912, vrr_stack+15822, vrr_stack+7214, NULL, NULL, vrr_stack+1759);
 _BUILD_d0n0(Data,vrr_stack+84, vrr_stack+15888, vrr_stack+1912, vrr_stack+15690, vrr_stack+15822, vrr_stack+2532);
 _BUILD_f0n0(Data,vrr_stack+20200, vrr_stack+11948, vrr_stack+84, vrr_stack+11750, vrr_stack+15888, vrr_stack+4182);
 _BUILD_f0n0(Data,vrr_stack+3697, vrr_stack+4984, vrr_stack+11948, vrr_stack+10856, vrr_stack+11750, vrr_stack+7379);
 _BUILD_g0n0(Data,vrr_stack+20860, vrr_stack+3697, vrr_stack+20200, vrr_stack+4984, vrr_stack+11948, vrr_stack+599);
 _BUILD_00n0(Data,vrr_stack+2532, vrr_stack+3642, vrr_stack+6449, vrr_stack+4838, vrr_stack+1867, NULL);
 _BUILD_p0n0(Data,vrr_stack+2598, vrr_stack+2532, vrr_stack+10790, NULL, NULL, vrr_stack+6449);
 _BUILD_d0n0(Data,vrr_stack+7280, vrr_stack+2598, vrr_stack+10856, vrr_stack+2532, vrr_stack+10790, vrr_stack+6504);
 _BUILD_f0n0(Data,vrr_stack+480, vrr_stack+7280, vrr_stack+4984, vrr_stack+2598, vrr_stack+10856, vrr_stack+2202);
   tmp = vrr_stack + 480;
   target_ptr = Libint->vrr_classes[3][10];
   for(i=0;i<660;i++)
     target_ptr[i] += tmp[i];
 _BUILD_g0n0(Data,vrr_stack+21850, vrr_stack+480, vrr_stack+3697, vrr_stack+7280, vrr_stack+4984, vrr_stack+14315);
   tmp = vrr_stack + 21850;
   target_ptr = Libint->vrr_classes[4][10];
   for(i=0;i<990;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00p0(Data,vrr_stack+14315, Data->F+15, Data->F+16, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+14318, vrr_stack+8510, vrr_stack+14315, Data->F+14, Data->F+15, NULL);
 _BUILD_00f0(Data,vrr_stack+14324, vrr_stack+30, vrr_stack+14318, vrr_stack+36, vrr_stack+8510, NULL);
 _BUILD_00g0(Data,vrr_stack+14334, vrr_stack+8513, vrr_stack+14324, vrr_stack+4883, vrr_stack+30, NULL);
 _BUILD_00h0(Data,vrr_stack+11054, vrr_stack+0, vrr_stack+14334, vrr_stack+4889, vrr_stack+8513, NULL);
 _BUILD_00i0(Data,vrr_stack+14349, vrr_stack+8523, vrr_stack+11054, vrr_stack+15, vrr_stack+0, NULL);
 _BUILD_00k0(Data,vrr_stack+14377, vrr_stack+8544, vrr_stack+14349, vrr_stack+4899, vrr_stack+8523, NULL);
 _BUILD_00l0(Data,vrr_stack+14413, vrr_stack+8572, vrr_stack+14377, vrr_stack+4920, vrr_stack+8544, NULL);
 _BUILD_00m0(Data,vrr_stack+14458, vrr_stack+7709, vrr_stack+14413, vrr_stack+4948, vrr_stack+8572, NULL);
 _BUILD_00n0(Data,vrr_stack+14513, vrr_stack+8608, vrr_stack+14458, vrr_stack+39, vrr_stack+7709, NULL);
 _BUILD_p0n0(Data,vrr_stack+14579, vrr_stack+7214, vrr_stack+14513, NULL, NULL, vrr_stack+8608);
 _BUILD_d0n0(Data,vrr_stack+7280, vrr_stack+1912, vrr_stack+14579, vrr_stack+15822, vrr_stack+7214, vrr_stack+8663);
 _BUILD_f0n0(Data,vrr_stack+22840, vrr_stack+84, vrr_stack+7280, vrr_stack+15888, vrr_stack+1912, vrr_stack+8828);
 _BUILD_g0n0(Data,vrr_stack+23500, vrr_stack+20200, vrr_stack+22840, vrr_stack+11948, vrr_stack+84, vrr_stack+9158);
 _BUILD_h0n0(Data,vrr_stack+24490, vrr_stack+20860, vrr_stack+23500, vrr_stack+3697, vrr_stack+20200, vrr_stack+17065);
 _BUILD_h0n0(Data,vrr_stack+25876, vrr_stack+21850, vrr_stack+20860, vrr_stack+480, vrr_stack+3697, vrr_stack+14865);
   tmp = vrr_stack + 25876;
   target_ptr = Libint->vrr_classes[5][10];
   for(i=0;i<1386;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00o0(Data,vrr_stack+480, vrr_stack+15690, vrr_stack+15822, vrr_stack+10625, vrr_stack+10735, NULL);
 _BUILD_00o0(Data,vrr_stack+558, vrr_stack+15756, vrr_stack+15690, vrr_stack+10680, vrr_stack+10625, NULL);
 _BUILD_00o0(Data,vrr_stack+636, vrr_stack+15822, vrr_stack+7214, vrr_stack+10735, vrr_stack+1759, NULL);
 _BUILD_p0o0(Data,vrr_stack+714, vrr_stack+480, vrr_stack+636, NULL, NULL, vrr_stack+15822);
 _BUILD_p0o0(Data,vrr_stack+17065, vrr_stack+558, vrr_stack+480, NULL, NULL, vrr_stack+15690);
 _BUILD_d0o0(Data,vrr_stack+17299, vrr_stack+17065, vrr_stack+714, vrr_stack+558, vrr_stack+480, vrr_stack+15888);
 _BUILD_00o0(Data,vrr_stack+15822, vrr_stack+10790, vrr_stack+15756, vrr_stack+6449, vrr_stack+10680, NULL);
 _BUILD_p0o0(Data,vrr_stack+15900, vrr_stack+15822, vrr_stack+558, NULL, NULL, vrr_stack+15756);
 _BUILD_d0o0(Data,vrr_stack+8663, vrr_stack+15900, vrr_stack+17065, vrr_stack+15822, vrr_stack+558, vrr_stack+11750);
 _BUILD_00o0(Data,vrr_stack+558, vrr_stack+7214, vrr_stack+14513, vrr_stack+1759, vrr_stack+8608, NULL);
 _BUILD_p0o0(Data,vrr_stack+9131, vrr_stack+636, vrr_stack+558, NULL, NULL, vrr_stack+7214);
 _BUILD_d0o0(Data,vrr_stack+9365, vrr_stack+714, vrr_stack+9131, vrr_stack+480, vrr_stack+636, vrr_stack+1912);
 _BUILD_f0o0(Data,vrr_stack+27262, vrr_stack+17299, vrr_stack+9365, vrr_stack+17065, vrr_stack+714, vrr_stack+84);
 _BUILD_f0o0(Data,vrr_stack+28042, vrr_stack+8663, vrr_stack+17299, vrr_stack+15900, vrr_stack+17065, vrr_stack+11948);
 _BUILD_g0o0(Data,vrr_stack+28822, vrr_stack+28042, vrr_stack+27262, vrr_stack+8663, vrr_stack+17299, vrr_stack+20200);
 _BUILD_00o0(Data,vrr_stack+20200, vrr_stack+2532, vrr_stack+10790, vrr_stack+3642, vrr_stack+6449, NULL);
 _BUILD_p0o0(Data,vrr_stack+17065, vrr_stack+20200, vrr_stack+15822, NULL, NULL, vrr_stack+10790);
 _BUILD_d0o0(Data,vrr_stack+20278, vrr_stack+17065, vrr_stack+15900, vrr_stack+20200, vrr_stack+15822, vrr_stack+10856);
 _BUILD_f0o0(Data,vrr_stack+1759, vrr_stack+20278, vrr_stack+8663, vrr_stack+17065, vrr_stack+15900, vrr_stack+4984);
   tmp = vrr_stack + 1759;
   target_ptr = Libint->vrr_classes[3][11];
   for(i=0;i<780;i++)
     target_ptr[i] += tmp[i];
 _BUILD_g0o0(Data,vrr_stack+4357, vrr_stack+1759, vrr_stack+28042, vrr_stack+20278, vrr_stack+8663, vrr_stack+3697);
   tmp = vrr_stack + 4357;
   target_ptr = Libint->vrr_classes[4][11];
   for(i=0;i<1170;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00p0(Data,vrr_stack+8663, Data->F+16, Data->F+17, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+8666, vrr_stack+14315, vrr_stack+8663, Data->F+15, Data->F+16, NULL);
 _BUILD_00f0(Data,vrr_stack+8672, vrr_stack+14318, vrr_stack+8666, vrr_stack+8510, vrr_stack+14315, NULL);
 _BUILD_00g0(Data,vrr_stack+15, vrr_stack+14324, vrr_stack+8672, vrr_stack+30, vrr_stack+14318, NULL);
 _BUILD_00h0(Data,vrr_stack+30, vrr_stack+14334, vrr_stack+15, vrr_stack+8513, vrr_stack+14324, NULL);
 _BUILD_00i0(Data,vrr_stack+51, vrr_stack+11054, vrr_stack+30, vrr_stack+0, vrr_stack+14334, NULL);
 _BUILD_00k0(Data,vrr_stack+0, vrr_stack+14349, vrr_stack+51, vrr_stack+8523, vrr_stack+11054, NULL);
 _BUILD_00l0(Data,vrr_stack+36, vrr_stack+14377, vrr_stack+0, vrr_stack+8544, vrr_stack+14349, NULL);
 _BUILD_00m0(Data,vrr_stack+81, vrr_stack+14413, vrr_stack+36, vrr_stack+8572, vrr_stack+14377, NULL);
 _BUILD_00n0(Data,vrr_stack+7214, vrr_stack+14458, vrr_stack+81, vrr_stack+7709, vrr_stack+14413, NULL);
 _BUILD_00o0(Data,vrr_stack+7676, vrr_stack+14513, vrr_stack+7214, vrr_stack+8608, vrr_stack+14458, NULL);
 _BUILD_p0o0(Data,vrr_stack+17065, vrr_stack+558, vrr_stack+7676, NULL, NULL, vrr_stack+14513);
 _BUILD_d0o0(Data,vrr_stack+0, vrr_stack+9131, vrr_stack+17065, vrr_stack+636, vrr_stack+558, vrr_stack+14579);
 _BUILD_f0o0(Data,vrr_stack+29992, vrr_stack+9365, vrr_stack+0, vrr_stack+714, vrr_stack+9131, vrr_stack+7280);
 _BUILD_g0o0(Data,vrr_stack+0, vrr_stack+27262, vrr_stack+29992, vrr_stack+17299, vrr_stack+9365, vrr_stack+22840);
 _BUILD_h0o0(Data,vrr_stack+29992, vrr_stack+28822, vrr_stack+0, vrr_stack+28042, vrr_stack+27262, vrr_stack+23500);
 _BUILD_h0o0(Data,vrr_stack+22840, vrr_stack+4357, vrr_stack+28822, vrr_stack+1759, vrr_stack+28042, vrr_stack+20860);
   tmp = vrr_stack + 22840;
   target_ptr = Libint->vrr_classes[5][11];
   for(i=0;i<1638;i++)
     target_ptr[i] += tmp[i];
 _BUILD_i0k0(Data,vrr_stack+1759, vrr_stack+2886, vrr_stack+7754, vrr_stack+6674, vrr_stack+5774, vrr_stack+1171);
   tmp = vrr_stack + 1759;
   target_ptr = Libint->vrr_classes[6][7];
   for(i=0;i<1008;i++)
     target_ptr[i] += tmp[i];
 _BUILD_i0l0(Data,vrr_stack+2767, vrr_stack+13370, vrr_stack+12425, vrr_stack+11075, vrr_stack+9950, vrr_stack+7754);
   tmp = vrr_stack + 2767;
   target_ptr = Libint->vrr_classes[6][8];
   for(i=0;i<1260;i++)
     target_ptr[i] += tmp[i];
 _BUILD_i0m0(Data,vrr_stack+27262, vrr_stack+19045, vrr_stack+17890, vrr_stack+16240, vrr_stack+14865, vrr_stack+12425);
   tmp = vrr_stack + 27262;
   target_ptr = Libint->vrr_classes[6][9];
   for(i=0;i<1540;i++)
     target_ptr[i] += tmp[i];
 _BUILD_i0n0(Data,vrr_stack+5527, vrr_stack+25876, vrr_stack+24490, vrr_stack+21850, vrr_stack+20860, vrr_stack+17890);
   tmp = vrr_stack + 5527;
   target_ptr = Libint->vrr_classes[6][10];
   for(i=0;i<1848;i++)
     target_ptr[i] += tmp[i];
 _BUILD_i0o0(Data,vrr_stack+7375, vrr_stack+22840, vrr_stack+29992, vrr_stack+4357, vrr_stack+28822, vrr_stack+24490);
   tmp = vrr_stack + 7375;
   target_ptr = Libint->vrr_classes[6][11];
   for(i=0;i<2184;i++)
     target_ptr[i] += tmp[i];

}

