/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include "libint.h"
#include "vrr_header.h"

  /* Computes quartets necessary to compute (kf|kf) integrals */

void vrr_order_kfkf(Libint_t * Libint, prim_data *Data)
{
 REALTYPE *vrr_stack = Libint->vrr_stack;
 REALTYPE *tmp, *target_ptr;
 int i, am[2];
 _BUILD_p000(Data,vrr_stack+0, Data->F+8, Data->F+9, NULL, NULL, NULL);
 _BUILD_p000(Data,vrr_stack+3, Data->F+7, Data->F+8, NULL, NULL, NULL);
 _BUILD_p000(Data,vrr_stack+6, Data->F+9, Data->F+10, NULL, NULL, NULL);
 _BUILD_d000(Data,vrr_stack+9, vrr_stack+0, vrr_stack+6, Data->F+8, Data->F+9, NULL);
 _BUILD_d000(Data,vrr_stack+15, vrr_stack+3, vrr_stack+0, Data->F+7, Data->F+8, NULL);
 _BUILD_f000(Data,vrr_stack+21, vrr_stack+15, vrr_stack+9, vrr_stack+3, vrr_stack+0, NULL);
 _BUILD_00p0(Data,vrr_stack+31, Data->F+8, Data->F+9, NULL, NULL, NULL);
 _BUILD_00p0(Data,vrr_stack+34, Data->F+7, Data->F+8, NULL, NULL, NULL);
 _BUILD_00p0(Data,vrr_stack+37, Data->F+9, Data->F+10, NULL, NULL, NULL);
 _BUILD_p0p0(Data,vrr_stack+40, vrr_stack+31, vrr_stack+37, NULL, NULL, Data->F+9);
 _BUILD_p0p0(Data,vrr_stack+49, vrr_stack+34, vrr_stack+31, NULL, NULL, Data->F+8);
 _BUILD_d0p0(Data,vrr_stack+58, vrr_stack+49, vrr_stack+40, vrr_stack+34, vrr_stack+31, vrr_stack+0);
 _BUILD_00p0(Data,vrr_stack+0, Data->F+6, Data->F+7, NULL, NULL, NULL);
 _BUILD_p0p0(Data,vrr_stack+76, vrr_stack+0, vrr_stack+34, NULL, NULL, Data->F+7);
 _BUILD_d0p0(Data,vrr_stack+85, vrr_stack+76, vrr_stack+49, vrr_stack+0, vrr_stack+34, vrr_stack+3);
 _BUILD_00p0(Data,vrr_stack+3, Data->F+10, Data->F+11, NULL, NULL, NULL);
 _BUILD_p0p0(Data,vrr_stack+103, vrr_stack+37, vrr_stack+3, NULL, NULL, Data->F+10);
 _BUILD_d0p0(Data,vrr_stack+112, vrr_stack+40, vrr_stack+103, vrr_stack+31, vrr_stack+37, vrr_stack+6);
 _BUILD_f0p0(Data,vrr_stack+130, vrr_stack+58, vrr_stack+112, vrr_stack+49, vrr_stack+40, vrr_stack+9);
 _BUILD_f0p0(Data,vrr_stack+160, vrr_stack+85, vrr_stack+58, vrr_stack+76, vrr_stack+49, vrr_stack+15);
 _BUILD_g0p0(Data,vrr_stack+190, vrr_stack+160, vrr_stack+130, vrr_stack+85, vrr_stack+58, vrr_stack+21);
 _BUILD_00d0(Data,vrr_stack+6, vrr_stack+31, vrr_stack+37, Data->F+8, Data->F+9, NULL);
 _BUILD_00d0(Data,vrr_stack+12, vrr_stack+34, vrr_stack+31, Data->F+7, Data->F+8, NULL);
 _BUILD_p0d0(Data,vrr_stack+235, vrr_stack+12, vrr_stack+6, NULL, NULL, vrr_stack+31);
 _BUILD_00d0(Data,vrr_stack+18, vrr_stack+0, vrr_stack+34, Data->F+6, Data->F+7, NULL);
 _BUILD_p0d0(Data,vrr_stack+253, vrr_stack+18, vrr_stack+12, NULL, NULL, vrr_stack+34);
 _BUILD_00d0(Data,vrr_stack+24, vrr_stack+37, vrr_stack+3, Data->F+9, Data->F+10, NULL);
 _BUILD_p0d0(Data,vrr_stack+271, vrr_stack+6, vrr_stack+24, NULL, NULL, vrr_stack+37);
 _BUILD_d0d0(Data,vrr_stack+289, vrr_stack+235, vrr_stack+271, vrr_stack+12, vrr_stack+6, vrr_stack+40);
 _BUILD_d0d0(Data,vrr_stack+325, vrr_stack+253, vrr_stack+235, vrr_stack+18, vrr_stack+12, vrr_stack+49);
 _BUILD_f0d0(Data,vrr_stack+361, vrr_stack+325, vrr_stack+289, vrr_stack+253, vrr_stack+235, vrr_stack+58);
 _BUILD_00p0(Data,vrr_stack+40, Data->F+5, Data->F+6, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+43, vrr_stack+40, vrr_stack+0, Data->F+5, Data->F+6, NULL);
 _BUILD_p0d0(Data,vrr_stack+49, vrr_stack+43, vrr_stack+18, NULL, NULL, vrr_stack+0);
 _BUILD_d0d0(Data,vrr_stack+421, vrr_stack+49, vrr_stack+253, vrr_stack+43, vrr_stack+18, vrr_stack+76);
 _BUILD_f0d0(Data,vrr_stack+457, vrr_stack+421, vrr_stack+325, vrr_stack+49, vrr_stack+253, vrr_stack+85);
 _BUILD_00p0(Data,vrr_stack+67, Data->F+11, Data->F+12, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+70, vrr_stack+3, vrr_stack+67, Data->F+10, Data->F+11, NULL);
 _BUILD_p0d0(Data,vrr_stack+76, vrr_stack+24, vrr_stack+70, NULL, NULL, vrr_stack+3);
 _BUILD_d0d0(Data,vrr_stack+517, vrr_stack+271, vrr_stack+76, vrr_stack+6, vrr_stack+24, vrr_stack+103);
 _BUILD_f0d0(Data,vrr_stack+553, vrr_stack+289, vrr_stack+517, vrr_stack+235, vrr_stack+271, vrr_stack+112);
 _BUILD_g0d0(Data,vrr_stack+613, vrr_stack+361, vrr_stack+553, vrr_stack+325, vrr_stack+289, vrr_stack+130);
 _BUILD_g0d0(Data,vrr_stack+703, vrr_stack+457, vrr_stack+361, vrr_stack+421, vrr_stack+325, vrr_stack+160);
 _BUILD_h0d0(Data,vrr_stack+793, vrr_stack+703, vrr_stack+613, vrr_stack+457, vrr_stack+361, vrr_stack+190);
 _BUILD_00f0(Data,vrr_stack+94, vrr_stack+12, vrr_stack+6, vrr_stack+34, vrr_stack+31, NULL);
 _BUILD_00f0(Data,vrr_stack+104, vrr_stack+18, vrr_stack+12, vrr_stack+0, vrr_stack+34, NULL);
 _BUILD_00f0(Data,vrr_stack+114, vrr_stack+6, vrr_stack+24, vrr_stack+31, vrr_stack+37, NULL);
 _BUILD_p0f0(Data,vrr_stack+124, vrr_stack+94, vrr_stack+114, NULL, NULL, vrr_stack+6);
 _BUILD_p0f0(Data,vrr_stack+154, vrr_stack+104, vrr_stack+94, NULL, NULL, vrr_stack+12);
 _BUILD_d0f0(Data,vrr_stack+919, vrr_stack+154, vrr_stack+124, vrr_stack+104, vrr_stack+94, vrr_stack+235);
 _BUILD_00f0(Data,vrr_stack+184, vrr_stack+43, vrr_stack+18, vrr_stack+40, vrr_stack+0, NULL);
 _BUILD_p0f0(Data,vrr_stack+194, vrr_stack+184, vrr_stack+104, NULL, NULL, vrr_stack+18);
 _BUILD_d0f0(Data,vrr_stack+979, vrr_stack+194, vrr_stack+154, vrr_stack+184, vrr_stack+104, vrr_stack+253);
 _BUILD_00f0(Data,vrr_stack+224, vrr_stack+24, vrr_stack+70, vrr_stack+37, vrr_stack+3, NULL);
 _BUILD_p0f0(Data,vrr_stack+234, vrr_stack+114, vrr_stack+224, NULL, NULL, vrr_stack+24);
 _BUILD_d0f0(Data,vrr_stack+1039, vrr_stack+124, vrr_stack+234, vrr_stack+94, vrr_stack+114, vrr_stack+271);
 _BUILD_f0f0(Data,vrr_stack+1099, vrr_stack+919, vrr_stack+1039, vrr_stack+154, vrr_stack+124, vrr_stack+289);
 _BUILD_f0f0(Data,vrr_stack+1199, vrr_stack+979, vrr_stack+919, vrr_stack+194, vrr_stack+154, vrr_stack+325);
 _BUILD_g0f0(Data,vrr_stack+1299, vrr_stack+1199, vrr_stack+1099, vrr_stack+979, vrr_stack+919, vrr_stack+361);
 _BUILD_00p0(Data,vrr_stack+0, Data->F+4, Data->F+5, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+264, vrr_stack+0, vrr_stack+40, Data->F+4, Data->F+5, NULL);
 _BUILD_00f0(Data,vrr_stack+30, vrr_stack+264, vrr_stack+43, vrr_stack+0, vrr_stack+40, NULL);
 _BUILD_p0f0(Data,vrr_stack+270, vrr_stack+30, vrr_stack+184, NULL, NULL, vrr_stack+43);
 _BUILD_d0f0(Data,vrr_stack+300, vrr_stack+270, vrr_stack+194, vrr_stack+30, vrr_stack+184, vrr_stack+49);
 _BUILD_f0f0(Data,vrr_stack+1449, vrr_stack+300, vrr_stack+979, vrr_stack+270, vrr_stack+194, vrr_stack+421);
 _BUILD_g0f0(Data,vrr_stack+1549, vrr_stack+1449, vrr_stack+1199, vrr_stack+300, vrr_stack+979, vrr_stack+457);
 _BUILD_00p0(Data,vrr_stack+40, Data->F+12, Data->F+13, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+49, vrr_stack+67, vrr_stack+40, Data->F+11, Data->F+12, NULL);
 _BUILD_00f0(Data,vrr_stack+55, vrr_stack+70, vrr_stack+49, vrr_stack+3, vrr_stack+67, NULL);
 _BUILD_p0f0(Data,vrr_stack+360, vrr_stack+224, vrr_stack+55, NULL, NULL, vrr_stack+70);
 _BUILD_d0f0(Data,vrr_stack+390, vrr_stack+234, vrr_stack+360, vrr_stack+114, vrr_stack+224, vrr_stack+76);
 _BUILD_f0f0(Data,vrr_stack+1699, vrr_stack+1039, vrr_stack+390, vrr_stack+124, vrr_stack+234, vrr_stack+517);
 _BUILD_g0f0(Data,vrr_stack+1799, vrr_stack+1099, vrr_stack+1699, vrr_stack+919, vrr_stack+1039, vrr_stack+553);
 _BUILD_h0f0(Data,vrr_stack+1949, vrr_stack+1299, vrr_stack+1799, vrr_stack+1199, vrr_stack+1099, vrr_stack+613);
 _BUILD_h0f0(Data,vrr_stack+450, vrr_stack+1549, vrr_stack+1299, vrr_stack+1449, vrr_stack+1199, vrr_stack+703);
 _BUILD_i0f0(Data,vrr_stack+2159, vrr_stack+450, vrr_stack+1949, vrr_stack+1549, vrr_stack+1299, vrr_stack+793);
 _BUILD_00g0(Data,vrr_stack+76, vrr_stack+94, vrr_stack+114, vrr_stack+12, vrr_stack+6, NULL);
 _BUILD_00g0(Data,vrr_stack+660, vrr_stack+104, vrr_stack+94, vrr_stack+18, vrr_stack+12, NULL);
 _BUILD_p0g0(Data,vrr_stack+675, vrr_stack+660, vrr_stack+76, NULL, NULL, vrr_stack+94);
 _BUILD_00g0(Data,vrr_stack+720, vrr_stack+184, vrr_stack+104, vrr_stack+43, vrr_stack+18, NULL);
 _BUILD_p0g0(Data,vrr_stack+735, vrr_stack+720, vrr_stack+660, NULL, NULL, vrr_stack+104);
 _BUILD_00g0(Data,vrr_stack+780, vrr_stack+114, vrr_stack+224, vrr_stack+6, vrr_stack+24, NULL);
 _BUILD_p0g0(Data,vrr_stack+795, vrr_stack+76, vrr_stack+780, NULL, NULL, vrr_stack+114);
 _BUILD_d0g0(Data,vrr_stack+2439, vrr_stack+675, vrr_stack+795, vrr_stack+660, vrr_stack+76, vrr_stack+124);
 _BUILD_d0g0(Data,vrr_stack+2529, vrr_stack+735, vrr_stack+675, vrr_stack+720, vrr_stack+660, vrr_stack+154);
 _BUILD_f0g0(Data,vrr_stack+2619, vrr_stack+2529, vrr_stack+2439, vrr_stack+735, vrr_stack+675, vrr_stack+919);
 _BUILD_00g0(Data,vrr_stack+124, vrr_stack+30, vrr_stack+184, vrr_stack+264, vrr_stack+43, NULL);
 _BUILD_p0g0(Data,vrr_stack+139, vrr_stack+124, vrr_stack+720, NULL, NULL, vrr_stack+184);
 _BUILD_d0g0(Data,vrr_stack+840, vrr_stack+139, vrr_stack+735, vrr_stack+124, vrr_stack+720, vrr_stack+194);
 _BUILD_f0g0(Data,vrr_stack+2769, vrr_stack+840, vrr_stack+2529, vrr_stack+139, vrr_stack+735, vrr_stack+979);
 _BUILD_00g0(Data,vrr_stack+194, vrr_stack+224, vrr_stack+55, vrr_stack+24, vrr_stack+70, NULL);
 _BUILD_p0g0(Data,vrr_stack+930, vrr_stack+780, vrr_stack+194, NULL, NULL, vrr_stack+224);
 _BUILD_d0g0(Data,vrr_stack+2919, vrr_stack+795, vrr_stack+930, vrr_stack+76, vrr_stack+780, vrr_stack+234);
 _BUILD_f0g0(Data,vrr_stack+3009, vrr_stack+2439, vrr_stack+2919, vrr_stack+675, vrr_stack+795, vrr_stack+1039);
 _BUILD_g0g0(Data,vrr_stack+3159, vrr_stack+2619, vrr_stack+3009, vrr_stack+2529, vrr_stack+2439, vrr_stack+1099);
 _BUILD_g0g0(Data,vrr_stack+3384, vrr_stack+2769, vrr_stack+2619, vrr_stack+840, vrr_stack+2529, vrr_stack+1199);
 _BUILD_h0g0(Data,vrr_stack+975, vrr_stack+3384, vrr_stack+3159, vrr_stack+2769, vrr_stack+2619, vrr_stack+1299);
 _BUILD_00p0(Data,vrr_stack+91, Data->F+3, Data->F+4, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+43, vrr_stack+91, vrr_stack+0, Data->F+3, Data->F+4, NULL);
 _BUILD_00f0(Data,vrr_stack+234, vrr_stack+43, vrr_stack+264, vrr_stack+91, vrr_stack+0, NULL);
 _BUILD_00g0(Data,vrr_stack+209, vrr_stack+234, vrr_stack+30, vrr_stack+43, vrr_stack+264, NULL);
 _BUILD_p0g0(Data,vrr_stack+1290, vrr_stack+209, vrr_stack+124, NULL, NULL, vrr_stack+30);
 _BUILD_d0g0(Data,vrr_stack+1335, vrr_stack+1290, vrr_stack+139, vrr_stack+209, vrr_stack+124, vrr_stack+270);
 _BUILD_f0g0(Data,vrr_stack+3609, vrr_stack+1335, vrr_stack+840, vrr_stack+1290, vrr_stack+139, vrr_stack+300);
 _BUILD_g0g0(Data,vrr_stack+3759, vrr_stack+3609, vrr_stack+2769, vrr_stack+1335, vrr_stack+840, vrr_stack+1449);
 _BUILD_h0g0(Data,vrr_stack+3984, vrr_stack+3759, vrr_stack+3384, vrr_stack+3609, vrr_stack+2769, vrr_stack+1549);
 _BUILD_00p0(Data,vrr_stack+0, Data->F+13, Data->F+14, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+3, vrr_stack+40, vrr_stack+0, Data->F+12, Data->F+13, NULL);
 _BUILD_00f0(Data,vrr_stack+9, vrr_stack+49, vrr_stack+3, vrr_stack+67, vrr_stack+40, NULL);
 _BUILD_00g0(Data,vrr_stack+244, vrr_stack+55, vrr_stack+9, vrr_stack+70, vrr_stack+49, NULL);
 _BUILD_p0g0(Data,vrr_stack+259, vrr_stack+194, vrr_stack+244, NULL, NULL, vrr_stack+55);
 _BUILD_d0g0(Data,vrr_stack+1425, vrr_stack+930, vrr_stack+259, vrr_stack+780, vrr_stack+194, vrr_stack+360);
 _BUILD_f0g0(Data,vrr_stack+1515, vrr_stack+2919, vrr_stack+1425, vrr_stack+795, vrr_stack+930, vrr_stack+390);
 _BUILD_g0g0(Data,vrr_stack+4299, vrr_stack+3009, vrr_stack+1515, vrr_stack+2439, vrr_stack+2919, vrr_stack+1699);
 _BUILD_h0g0(Data,vrr_stack+4524, vrr_stack+3159, vrr_stack+4299, vrr_stack+2619, vrr_stack+3009, vrr_stack+1799);
 _BUILD_i0g0(Data,vrr_stack+4839, vrr_stack+975, vrr_stack+4524, vrr_stack+3384, vrr_stack+3159, vrr_stack+1949);
 _BUILD_i0g0(Data,vrr_stack+1665, vrr_stack+3984, vrr_stack+975, vrr_stack+3759, vrr_stack+3384, vrr_stack+450);
 _BUILD_k0g0(Data,vrr_stack+5259, vrr_stack+1665, vrr_stack+4839, vrr_stack+3984, vrr_stack+975, vrr_stack+2159);
 _BUILD_00h0(Data,vrr_stack+304, vrr_stack+660, vrr_stack+76, vrr_stack+104, vrr_stack+94, NULL);
 _BUILD_00h0(Data,vrr_stack+325, vrr_stack+720, vrr_stack+660, vrr_stack+184, vrr_stack+104, NULL);
 _BUILD_00h0(Data,vrr_stack+346, vrr_stack+76, vrr_stack+780, vrr_stack+94, vrr_stack+114, NULL);
 _BUILD_p0h0(Data,vrr_stack+367, vrr_stack+304, vrr_stack+346, NULL, NULL, vrr_stack+76);
 _BUILD_p0h0(Data,vrr_stack+430, vrr_stack+325, vrr_stack+304, NULL, NULL, vrr_stack+660);
 _BUILD_d0h0(Data,vrr_stack+493, vrr_stack+430, vrr_stack+367, vrr_stack+325, vrr_stack+304, vrr_stack+675);
 _BUILD_00h0(Data,vrr_stack+675, vrr_stack+124, vrr_stack+720, vrr_stack+30, vrr_stack+184, NULL);
 _BUILD_p0h0(Data,vrr_stack+2085, vrr_stack+675, vrr_stack+325, NULL, NULL, vrr_stack+720);
 _BUILD_d0h0(Data,vrr_stack+2148, vrr_stack+2085, vrr_stack+430, vrr_stack+675, vrr_stack+325, vrr_stack+735);
 _BUILD_00h0(Data,vrr_stack+735, vrr_stack+780, vrr_stack+194, vrr_stack+114, vrr_stack+224, NULL);
 _BUILD_p0h0(Data,vrr_stack+2274, vrr_stack+346, vrr_stack+735, NULL, NULL, vrr_stack+780);
 _BUILD_d0h0(Data,vrr_stack+5799, vrr_stack+367, vrr_stack+2274, vrr_stack+304, vrr_stack+346, vrr_stack+795);
 _BUILD_f0h0(Data,vrr_stack+5925, vrr_stack+493, vrr_stack+5799, vrr_stack+430, vrr_stack+367, vrr_stack+2439);
 _BUILD_f0h0(Data,vrr_stack+6135, vrr_stack+2148, vrr_stack+493, vrr_stack+2085, vrr_stack+430, vrr_stack+2529);
 _BUILD_g0h0(Data,vrr_stack+6345, vrr_stack+6135, vrr_stack+5925, vrr_stack+2148, vrr_stack+493, vrr_stack+2619);
 _BUILD_00h0(Data,vrr_stack+795, vrr_stack+209, vrr_stack+124, vrr_stack+234, vrr_stack+30, NULL);
 _BUILD_p0h0(Data,vrr_stack+2337, vrr_stack+795, vrr_stack+675, NULL, NULL, vrr_stack+124);
 _BUILD_d0h0(Data,vrr_stack+2400, vrr_stack+2337, vrr_stack+2085, vrr_stack+795, vrr_stack+675, vrr_stack+139);
 _BUILD_f0h0(Data,vrr_stack+2526, vrr_stack+2400, vrr_stack+2148, vrr_stack+2337, vrr_stack+2085, vrr_stack+840);
 _BUILD_g0h0(Data,vrr_stack+6660, vrr_stack+2526, vrr_stack+6135, vrr_stack+2400, vrr_stack+2148, vrr_stack+2769);
 _BUILD_00h0(Data,vrr_stack+19, vrr_stack+194, vrr_stack+244, vrr_stack+224, vrr_stack+55, NULL);
 _BUILD_p0h0(Data,vrr_stack+816, vrr_stack+735, vrr_stack+19, NULL, NULL, vrr_stack+194);
 _BUILD_d0h0(Data,vrr_stack+2736, vrr_stack+2274, vrr_stack+816, vrr_stack+346, vrr_stack+735, vrr_stack+930);
 _BUILD_f0h0(Data,vrr_stack+6975, vrr_stack+5799, vrr_stack+2736, vrr_stack+367, vrr_stack+2274, vrr_stack+2919);
 _BUILD_g0h0(Data,vrr_stack+7185, vrr_stack+5925, vrr_stack+6975, vrr_stack+493, vrr_stack+5799, vrr_stack+3009);
 _BUILD_h0h0(Data,vrr_stack+7500, vrr_stack+6345, vrr_stack+7185, vrr_stack+6135, vrr_stack+5925, vrr_stack+3159);
 _BUILD_h0h0(Data,vrr_stack+2862, vrr_stack+6660, vrr_stack+6345, vrr_stack+2526, vrr_stack+6135, vrr_stack+3384);
 _BUILD_i0h0(Data,vrr_stack+7941, vrr_stack+2862, vrr_stack+7500, vrr_stack+6660, vrr_stack+6345, vrr_stack+975);
 _BUILD_00p0(Data,vrr_stack+224, Data->F+2, Data->F+3, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+227, vrr_stack+224, vrr_stack+91, Data->F+2, Data->F+3, NULL);
 _BUILD_00f0(Data,vrr_stack+139, vrr_stack+227, vrr_stack+43, vrr_stack+224, vrr_stack+91, NULL);
 _BUILD_00g0(Data,vrr_stack+91, vrr_stack+139, vrr_stack+234, vrr_stack+227, vrr_stack+43, NULL);
 _BUILD_00h0(Data,vrr_stack+149, vrr_stack+91, vrr_stack+209, vrr_stack+139, vrr_stack+234, NULL);
 _BUILD_p0h0(Data,vrr_stack+879, vrr_stack+149, vrr_stack+795, NULL, NULL, vrr_stack+209);
 _BUILD_d0h0(Data,vrr_stack+942, vrr_stack+879, vrr_stack+2337, vrr_stack+149, vrr_stack+795, vrr_stack+1290);
 _BUILD_f0h0(Data,vrr_stack+1068, vrr_stack+942, vrr_stack+2400, vrr_stack+879, vrr_stack+2337, vrr_stack+1335);
 _BUILD_g0h0(Data,vrr_stack+8529, vrr_stack+1068, vrr_stack+2526, vrr_stack+942, vrr_stack+2400, vrr_stack+3609);
 _BUILD_h0h0(Data,vrr_stack+3303, vrr_stack+8529, vrr_stack+6660, vrr_stack+1068, vrr_stack+2526, vrr_stack+3759);
 _BUILD_i0h0(Data,vrr_stack+8844, vrr_stack+3303, vrr_stack+2862, vrr_stack+8529, vrr_stack+6660, vrr_stack+3984);
 _BUILD_00p0(Data,vrr_stack+43, Data->F+14, Data->F+15, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+106, vrr_stack+0, vrr_stack+43, Data->F+13, Data->F+14, NULL);
 _BUILD_00f0(Data,vrr_stack+112, vrr_stack+3, vrr_stack+106, vrr_stack+40, vrr_stack+0, NULL);
 _BUILD_00g0(Data,vrr_stack+170, vrr_stack+9, vrr_stack+112, vrr_stack+49, vrr_stack+3, NULL);
 _BUILD_00h0(Data,vrr_stack+1278, vrr_stack+244, vrr_stack+170, vrr_stack+55, vrr_stack+9, NULL);
 _BUILD_p0h0(Data,vrr_stack+1299, vrr_stack+19, vrr_stack+1278, NULL, NULL, vrr_stack+244);
 _BUILD_d0h0(Data,vrr_stack+3744, vrr_stack+816, vrr_stack+1299, vrr_stack+735, vrr_stack+19, vrr_stack+259);
 _BUILD_f0h0(Data,vrr_stack+3870, vrr_stack+2736, vrr_stack+3744, vrr_stack+2274, vrr_stack+816, vrr_stack+1425);
 _BUILD_g0h0(Data,vrr_stack+9432, vrr_stack+6975, vrr_stack+3870, vrr_stack+5799, vrr_stack+2736, vrr_stack+1515);
 _BUILD_h0h0(Data,vrr_stack+9747, vrr_stack+7185, vrr_stack+9432, vrr_stack+5925, vrr_stack+6975, vrr_stack+4299);
 _BUILD_i0h0(Data,vrr_stack+10188, vrr_stack+7500, vrr_stack+9747, vrr_stack+6345, vrr_stack+7185, vrr_stack+4524);
 _BUILD_k0h0(Data,vrr_stack+4080, vrr_stack+7941, vrr_stack+10188, vrr_stack+2862, vrr_stack+7500, vrr_stack+4839);
 _BUILD_k0h0(Data,vrr_stack+10776, vrr_stack+8844, vrr_stack+7941, vrr_stack+3303, vrr_stack+2862, vrr_stack+1665);
 _BUILD_l0h0(Data,vrr_stack+11532, vrr_stack+10776, vrr_stack+4080, vrr_stack+8844, vrr_stack+7941, vrr_stack+5259);
 _BUILD_00i0(Data,vrr_stack+259, vrr_stack+304, vrr_stack+346, vrr_stack+660, vrr_stack+76, NULL);
 _BUILD_00i0(Data,vrr_stack+46, vrr_stack+325, vrr_stack+304, vrr_stack+720, vrr_stack+660, NULL);
 _BUILD_p0i0(Data,vrr_stack+1362, vrr_stack+46, vrr_stack+259, NULL, NULL, vrr_stack+304);
 _BUILD_00i0(Data,vrr_stack+1446, vrr_stack+675, vrr_stack+325, vrr_stack+124, vrr_stack+720, NULL);
 _BUILD_p0i0(Data,vrr_stack+1474, vrr_stack+1446, vrr_stack+46, NULL, NULL, vrr_stack+325);
 _BUILD_00i0(Data,vrr_stack+1558, vrr_stack+346, vrr_stack+735, vrr_stack+76, vrr_stack+780, NULL);
 _BUILD_p0i0(Data,vrr_stack+1586, vrr_stack+259, vrr_stack+1558, NULL, NULL, vrr_stack+346);
 _BUILD_d0i0(Data,vrr_stack+1670, vrr_stack+1362, vrr_stack+1586, vrr_stack+46, vrr_stack+259, vrr_stack+367);
 _BUILD_d0i0(Data,vrr_stack+1838, vrr_stack+1474, vrr_stack+1362, vrr_stack+1446, vrr_stack+46, vrr_stack+430);
 _BUILD_f0i0(Data,vrr_stack+4836, vrr_stack+1838, vrr_stack+1670, vrr_stack+1474, vrr_stack+1362, vrr_stack+493);
 _BUILD_00i0(Data,vrr_stack+367, vrr_stack+795, vrr_stack+675, vrr_stack+209, vrr_stack+124, NULL);
 _BUILD_p0i0(Data,vrr_stack+395, vrr_stack+367, vrr_stack+1446, NULL, NULL, vrr_stack+675);
 _BUILD_d0i0(Data,vrr_stack+479, vrr_stack+395, vrr_stack+1474, vrr_stack+367, vrr_stack+1446, vrr_stack+2085);
 _BUILD_f0i0(Data,vrr_stack+5116, vrr_stack+479, vrr_stack+1838, vrr_stack+395, vrr_stack+1474, vrr_stack+2148);
 _BUILD_00i0(Data,vrr_stack+647, vrr_stack+735, vrr_stack+19, vrr_stack+780, vrr_stack+194, NULL);
 _BUILD_p0i0(Data,vrr_stack+2006, vrr_stack+1558, vrr_stack+647, NULL, NULL, vrr_stack+735);
 _BUILD_d0i0(Data,vrr_stack+2090, vrr_stack+1586, vrr_stack+2006, vrr_stack+259, vrr_stack+1558, vrr_stack+2274);
 _BUILD_f0i0(Data,vrr_stack+5396, vrr_stack+1670, vrr_stack+2090, vrr_stack+1362, vrr_stack+1586, vrr_stack+5799);
 _BUILD_g0i0(Data,vrr_stack+12477, vrr_stack+4836, vrr_stack+5396, vrr_stack+1838, vrr_stack+1670, vrr_stack+5925);
 _BUILD_g0i0(Data,vrr_stack+5676, vrr_stack+5116, vrr_stack+4836, vrr_stack+479, vrr_stack+1838, vrr_stack+6135);
 _BUILD_h0i0(Data,vrr_stack+12897, vrr_stack+5676, vrr_stack+12477, vrr_stack+5116, vrr_stack+4836, vrr_stack+6345);
 _BUILD_00i0(Data,vrr_stack+2258, vrr_stack+149, vrr_stack+795, vrr_stack+91, vrr_stack+209, NULL);
 _BUILD_p0i0(Data,vrr_stack+6096, vrr_stack+2258, vrr_stack+367, NULL, NULL, vrr_stack+795);
 _BUILD_d0i0(Data,vrr_stack+6180, vrr_stack+6096, vrr_stack+395, vrr_stack+2258, vrr_stack+367, vrr_stack+2337);
 _BUILD_f0i0(Data,vrr_stack+6348, vrr_stack+6180, vrr_stack+479, vrr_stack+6096, vrr_stack+395, vrr_stack+2400);
 _BUILD_g0i0(Data,vrr_stack+13485, vrr_stack+6348, vrr_stack+5116, vrr_stack+6180, vrr_stack+479, vrr_stack+2526);
 _BUILD_h0i0(Data,vrr_stack+13905, vrr_stack+13485, vrr_stack+5676, vrr_stack+6348, vrr_stack+5116, vrr_stack+6660);
 _BUILD_00i0(Data,vrr_stack+2286, vrr_stack+19, vrr_stack+1278, vrr_stack+194, vrr_stack+244, NULL);
 _BUILD_p0i0(Data,vrr_stack+2314, vrr_stack+647, vrr_stack+2286, NULL, NULL, vrr_stack+19);
 _BUILD_d0i0(Data,vrr_stack+2398, vrr_stack+2006, vrr_stack+2314, vrr_stack+1558, vrr_stack+647, vrr_stack+816);
 _BUILD_f0i0(Data,vrr_stack+6628, vrr_stack+2090, vrr_stack+2398, vrr_stack+1586, vrr_stack+2006, vrr_stack+2736);
 _BUILD_g0i0(Data,vrr_stack+14493, vrr_stack+5396, vrr_stack+6628, vrr_stack+1670, vrr_stack+2090, vrr_stack+6975);
 _BUILD_h0i0(Data,vrr_stack+14913, vrr_stack+12477, vrr_stack+14493, vrr_stack+4836, vrr_stack+5396, vrr_stack+7185);
 _BUILD_i0i0(Data,vrr_stack+15501, vrr_stack+12897, vrr_stack+14913, vrr_stack+5676, vrr_stack+12477, vrr_stack+7500);
 _BUILD_i0i0(Data,vrr_stack+6908, vrr_stack+13905, vrr_stack+12897, vrr_stack+13485, vrr_stack+5676, vrr_stack+2862);
 _BUILD_k0i0(Data,vrr_stack+16285, vrr_stack+6908, vrr_stack+15501, vrr_stack+13905, vrr_stack+12897, vrr_stack+7941);
 _BUILD_00p0(Data,vrr_stack+40, Data->F+1, Data->F+2, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+816, vrr_stack+40, vrr_stack+224, Data->F+1, Data->F+2, NULL);
 _BUILD_00f0(Data,vrr_stack+822, vrr_stack+816, vrr_stack+227, vrr_stack+40, vrr_stack+224, NULL);
 _BUILD_00g0(Data,vrr_stack+832, vrr_stack+822, vrr_stack+139, vrr_stack+816, vrr_stack+227, NULL);
 _BUILD_00h0(Data,vrr_stack+847, vrr_stack+832, vrr_stack+91, vrr_stack+822, vrr_stack+139, NULL);
 _BUILD_00i0(Data,vrr_stack+185, vrr_stack+847, vrr_stack+149, vrr_stack+832, vrr_stack+91, NULL);
 _BUILD_p0i0(Data,vrr_stack+2566, vrr_stack+185, vrr_stack+2258, NULL, NULL, vrr_stack+149);
 _BUILD_d0i0(Data,vrr_stack+2650, vrr_stack+2566, vrr_stack+6096, vrr_stack+185, vrr_stack+2258, vrr_stack+879);
 _BUILD_f0i0(Data,vrr_stack+2818, vrr_stack+2650, vrr_stack+6180, vrr_stack+2566, vrr_stack+6096, vrr_stack+942);
 _BUILD_g0i0(Data,vrr_stack+7692, vrr_stack+2818, vrr_stack+6348, vrr_stack+2650, vrr_stack+6180, vrr_stack+1068);
 _BUILD_h0i0(Data,vrr_stack+17293, vrr_stack+7692, vrr_stack+13485, vrr_stack+2818, vrr_stack+6348, vrr_stack+8529);
 _BUILD_i0i0(Data,vrr_stack+17881, vrr_stack+17293, vrr_stack+13905, vrr_stack+7692, vrr_stack+13485, vrr_stack+3303);
 _BUILD_k0i0(Data,vrr_stack+18665, vrr_stack+17881, vrr_stack+6908, vrr_stack+17293, vrr_stack+13905, vrr_stack+8844);
 _BUILD_00p0(Data,vrr_stack+868, Data->F+15, Data->F+16, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+871, vrr_stack+43, vrr_stack+868, Data->F+14, Data->F+15, NULL);
 _BUILD_00f0(Data,vrr_stack+877, vrr_stack+106, vrr_stack+871, vrr_stack+0, vrr_stack+43, NULL);
 _BUILD_00g0(Data,vrr_stack+887, vrr_stack+112, vrr_stack+877, vrr_stack+3, vrr_stack+106, NULL);
 _BUILD_00h0(Data,vrr_stack+902, vrr_stack+170, vrr_stack+887, vrr_stack+9, vrr_stack+112, NULL);
 _BUILD_00i0(Data,vrr_stack+923, vrr_stack+1278, vrr_stack+902, vrr_stack+244, vrr_stack+170, NULL);
 _BUILD_p0i0(Data,vrr_stack+951, vrr_stack+2286, vrr_stack+923, NULL, NULL, vrr_stack+1278);
 _BUILD_d0i0(Data,vrr_stack+1035, vrr_stack+2314, vrr_stack+951, vrr_stack+647, vrr_stack+2286, vrr_stack+1299);
 _BUILD_f0i0(Data,vrr_stack+3098, vrr_stack+2398, vrr_stack+1035, vrr_stack+2006, vrr_stack+2314, vrr_stack+3744);
 _BUILD_g0i0(Data,vrr_stack+3378, vrr_stack+6628, vrr_stack+3098, vrr_stack+2090, vrr_stack+2398, vrr_stack+3870);
 _BUILD_h0i0(Data,vrr_stack+8112, vrr_stack+14493, vrr_stack+3378, vrr_stack+5396, vrr_stack+6628, vrr_stack+9432);
 _BUILD_i0i0(Data,vrr_stack+8700, vrr_stack+14913, vrr_stack+8112, vrr_stack+12477, vrr_stack+14493, vrr_stack+9747);
 _BUILD_k0i0(Data,vrr_stack+19673, vrr_stack+15501, vrr_stack+8700, vrr_stack+12897, vrr_stack+14913, vrr_stack+10188);
 _BUILD_l0i0(Data,vrr_stack+9484, vrr_stack+16285, vrr_stack+19673, vrr_stack+6908, vrr_stack+15501, vrr_stack+4080);
 _BUILD_l0i0(Data,vrr_stack+20681, vrr_stack+18665, vrr_stack+16285, vrr_stack+17881, vrr_stack+6908, vrr_stack+10776);
 _BUILD_m0i0(Data,vrr_stack+21941, vrr_stack+20681, vrr_stack+9484, vrr_stack+18665, vrr_stack+16285, vrr_stack+11532);
 _BUILD_00k0(Data,vrr_stack+1299, vrr_stack+46, vrr_stack+259, vrr_stack+325, vrr_stack+304, NULL);
 _BUILD_00k0(Data,vrr_stack+1203, vrr_stack+1446, vrr_stack+46, vrr_stack+675, vrr_stack+325, NULL);
 _BUILD_00k0(Data,vrr_stack+1239, vrr_stack+259, vrr_stack+1558, vrr_stack+304, vrr_stack+346, NULL);
 _BUILD_p0k0(Data,vrr_stack+3798, vrr_stack+1299, vrr_stack+1239, NULL, NULL, vrr_stack+259);
 _BUILD_p0k0(Data,vrr_stack+3906, vrr_stack+1203, vrr_stack+1299, NULL, NULL, vrr_stack+46);
 _BUILD_d0k0(Data,vrr_stack+4014, vrr_stack+3906, vrr_stack+3798, vrr_stack+1203, vrr_stack+1299, vrr_stack+1362);
 _BUILD_00k0(Data,vrr_stack+1335, vrr_stack+367, vrr_stack+1446, vrr_stack+795, vrr_stack+675, NULL);
 _BUILD_p0k0(Data,vrr_stack+4230, vrr_stack+1335, vrr_stack+1203, NULL, NULL, vrr_stack+1446);
 _BUILD_d0k0(Data,vrr_stack+4338, vrr_stack+4230, vrr_stack+3906, vrr_stack+1335, vrr_stack+1203, vrr_stack+1474);
 _BUILD_00k0(Data,vrr_stack+1474, vrr_stack+1558, vrr_stack+647, vrr_stack+346, vrr_stack+735, NULL);
 _BUILD_p0k0(Data,vrr_stack+4554, vrr_stack+1239, vrr_stack+1474, NULL, NULL, vrr_stack+1558);
 _BUILD_d0k0(Data,vrr_stack+10744, vrr_stack+3798, vrr_stack+4554, vrr_stack+1299, vrr_stack+1239, vrr_stack+1586);
 _BUILD_f0k0(Data,vrr_stack+10960, vrr_stack+4014, vrr_stack+10744, vrr_stack+3906, vrr_stack+3798, vrr_stack+1670);
 _BUILD_f0k0(Data,vrr_stack+11320, vrr_stack+4338, vrr_stack+4014, vrr_stack+4230, vrr_stack+3906, vrr_stack+1838);
 _BUILD_g0k0(Data,vrr_stack+11680, vrr_stack+11320, vrr_stack+10960, vrr_stack+4338, vrr_stack+4014, vrr_stack+4836);
 _BUILD_00k0(Data,vrr_stack+1586, vrr_stack+2258, vrr_stack+367, vrr_stack+149, vrr_stack+795, NULL);
 _BUILD_p0k0(Data,vrr_stack+1622, vrr_stack+1586, vrr_stack+1335, NULL, NULL, vrr_stack+367);
 _BUILD_d0k0(Data,vrr_stack+1730, vrr_stack+1622, vrr_stack+4230, vrr_stack+1586, vrr_stack+1335, vrr_stack+395);
 _BUILD_f0k0(Data,vrr_stack+4662, vrr_stack+1730, vrr_stack+4338, vrr_stack+1622, vrr_stack+4230, vrr_stack+479);
 _BUILD_g0k0(Data,vrr_stack+23481, vrr_stack+4662, vrr_stack+11320, vrr_stack+1730, vrr_stack+4338, vrr_stack+5116);
 _BUILD_00k0(Data,vrr_stack+395, vrr_stack+647, vrr_stack+2286, vrr_stack+735, vrr_stack+19, NULL);
 _BUILD_p0k0(Data,vrr_stack+431, vrr_stack+1474, vrr_stack+395, NULL, NULL, vrr_stack+647);
 _BUILD_d0k0(Data,vrr_stack+5022, vrr_stack+4554, vrr_stack+431, vrr_stack+1239, vrr_stack+1474, vrr_stack+2006);
 _BUILD_f0k0(Data,vrr_stack+24021, vrr_stack+10744, vrr_stack+5022, vrr_stack+3798, vrr_stack+4554, vrr_stack+2090);
 _BUILD_g0k0(Data,vrr_stack+24381, vrr_stack+10960, vrr_stack+24021, vrr_stack+4014, vrr_stack+10744, vrr_stack+5396);
 _BUILD_h0k0(Data,vrr_stack+24921, vrr_stack+11680, vrr_stack+24381, vrr_stack+11320, vrr_stack+10960, vrr_stack+12477);
 _BUILD_h0k0(Data,vrr_stack+25677, vrr_stack+23481, vrr_stack+11680, vrr_stack+4662, vrr_stack+11320, vrr_stack+5676);
 _BUILD_i0k0(Data,vrr_stack+26433, vrr_stack+25677, vrr_stack+24921, vrr_stack+23481, vrr_stack+11680, vrr_stack+12897);
 _BUILD_00k0(Data,vrr_stack+539, vrr_stack+185, vrr_stack+2258, vrr_stack+847, vrr_stack+149, NULL);
 _BUILD_p0k0(Data,vrr_stack+1946, vrr_stack+539, vrr_stack+1586, NULL, NULL, vrr_stack+2258);
 _BUILD_d0k0(Data,vrr_stack+5238, vrr_stack+1946, vrr_stack+1622, vrr_stack+539, vrr_stack+1586, vrr_stack+6096);
 _BUILD_f0k0(Data,vrr_stack+5454, vrr_stack+5238, vrr_stack+1730, vrr_stack+1946, vrr_stack+1622, vrr_stack+6180);
 _BUILD_g0k0(Data,vrr_stack+12220, vrr_stack+5454, vrr_stack+4662, vrr_stack+5238, vrr_stack+1730, vrr_stack+6348);
 _BUILD_h0k0(Data,vrr_stack+5814, vrr_stack+12220, vrr_stack+23481, vrr_stack+5454, vrr_stack+4662, vrr_stack+13485);
 _BUILD_i0k0(Data,vrr_stack+12760, vrr_stack+5814, vrr_stack+25677, vrr_stack+12220, vrr_stack+23481, vrr_stack+13905);
 _BUILD_00k0(Data,vrr_stack+575, vrr_stack+2286, vrr_stack+923, vrr_stack+19, vrr_stack+1278, NULL);
 _BUILD_p0k0(Data,vrr_stack+2054, vrr_stack+395, vrr_stack+575, NULL, NULL, vrr_stack+2286);
 _BUILD_d0k0(Data,vrr_stack+13768, vrr_stack+431, vrr_stack+2054, vrr_stack+1474, vrr_stack+395, vrr_stack+2314);
 _BUILD_f0k0(Data,vrr_stack+13984, vrr_stack+5022, vrr_stack+13768, vrr_stack+4554, vrr_stack+431, vrr_stack+2398);
 _BUILD_g0k0(Data,vrr_stack+27441, vrr_stack+24021, vrr_stack+13984, vrr_stack+10744, vrr_stack+5022, vrr_stack+6628);
 _BUILD_h0k0(Data,vrr_stack+27981, vrr_stack+24381, vrr_stack+27441, vrr_stack+10960, vrr_stack+24021, vrr_stack+14493);
 _BUILD_i0k0(Data,vrr_stack+28737, vrr_stack+24921, vrr_stack+27981, vrr_stack+11680, vrr_stack+24381, vrr_stack+14913);
 _BUILD_k0k0(Data,vrr_stack+29745, vrr_stack+26433, vrr_stack+28737, vrr_stack+25677, vrr_stack+24921, vrr_stack+15501);
 _BUILD_k0k0(Data,vrr_stack+14344, vrr_stack+12760, vrr_stack+26433, vrr_stack+5814, vrr_stack+25677, vrr_stack+6908);
 _BUILD_l0k0(Data,vrr_stack+31041, vrr_stack+14344, vrr_stack+29745, vrr_stack+12760, vrr_stack+26433, vrr_stack+16285);
 _BUILD_00p0(Data,vrr_stack+1275, Data->F+0, Data->F+1, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+2314, vrr_stack+1275, vrr_stack+40, Data->F+0, Data->F+1, NULL);
 _BUILD_00f0(Data,vrr_stack+2320, vrr_stack+2314, vrr_stack+816, vrr_stack+1275, vrr_stack+40, NULL);
 _BUILD_00g0(Data,vrr_stack+2330, vrr_stack+2320, vrr_stack+822, vrr_stack+2314, vrr_stack+816, NULL);
 _BUILD_00h0(Data,vrr_stack+2345, vrr_stack+2330, vrr_stack+832, vrr_stack+2320, vrr_stack+822, NULL);
 _BUILD_00i0(Data,vrr_stack+2366, vrr_stack+2345, vrr_stack+847, vrr_stack+2330, vrr_stack+832, NULL);
 _BUILD_00k0(Data,vrr_stack+611, vrr_stack+2366, vrr_stack+185, vrr_stack+2345, vrr_stack+847, NULL);
 _BUILD_p0k0(Data,vrr_stack+2394, vrr_stack+611, vrr_stack+539, NULL, NULL, vrr_stack+185);
 _BUILD_d0k0(Data,vrr_stack+6570, vrr_stack+2394, vrr_stack+1946, vrr_stack+611, vrr_stack+539, vrr_stack+2566);
 _BUILD_f0k0(Data,vrr_stack+6786, vrr_stack+6570, vrr_stack+5238, vrr_stack+2394, vrr_stack+1946, vrr_stack+2650);
 _BUILD_g0k0(Data,vrr_stack+7146, vrr_stack+6786, vrr_stack+5454, vrr_stack+6570, vrr_stack+5238, vrr_stack+2818);
 _BUILD_h0k0(Data,vrr_stack+15640, vrr_stack+7146, vrr_stack+12220, vrr_stack+6786, vrr_stack+5454, vrr_stack+7692);
 _BUILD_i0k0(Data,vrr_stack+32661, vrr_stack+15640, vrr_stack+5814, vrr_stack+7146, vrr_stack+12220, vrr_stack+17293);
 _BUILD_k0k0(Data,vrr_stack+6570, vrr_stack+32661, vrr_stack+12760, vrr_stack+15640, vrr_stack+5814, vrr_stack+17881);
   tmp = vrr_stack + 6570;
   target_ptr = Libint->vrr_classes[7][7];
   for(i=0;i<1296;i++)
     target_ptr[i] += tmp[i];
 _BUILD_l0k0(Data,vrr_stack+15640, vrr_stack+6570, vrr_stack+14344, vrr_stack+32661, vrr_stack+12760, vrr_stack+18665);
   tmp = vrr_stack + 15640;
   target_ptr = Libint->vrr_classes[8][7];
   for(i=0;i<1620;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00p0(Data,vrr_stack+1275, Data->F+16, Data->F+17, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+32661, vrr_stack+868, vrr_stack+1275, Data->F+15, Data->F+16, NULL);
 _BUILD_00f0(Data,vrr_stack+32667, vrr_stack+871, vrr_stack+32661, vrr_stack+43, vrr_stack+868, NULL);
 _BUILD_00g0(Data,vrr_stack+32677, vrr_stack+877, vrr_stack+32667, vrr_stack+106, vrr_stack+871, NULL);
 _BUILD_00h0(Data,vrr_stack+32692, vrr_stack+887, vrr_stack+32677, vrr_stack+112, vrr_stack+877, NULL);
 _BUILD_00i0(Data,vrr_stack+32713, vrr_stack+902, vrr_stack+32692, vrr_stack+170, vrr_stack+887, NULL);
 _BUILD_00k0(Data,vrr_stack+32741, vrr_stack+923, vrr_stack+32713, vrr_stack+1278, vrr_stack+902, NULL);
 _BUILD_p0k0(Data,vrr_stack+32777, vrr_stack+575, vrr_stack+32741, NULL, NULL, vrr_stack+923);
 _BUILD_d0k0(Data,vrr_stack+32885, vrr_stack+2054, vrr_stack+32777, vrr_stack+395, vrr_stack+575, vrr_stack+951);
 _BUILD_f0k0(Data,vrr_stack+33101, vrr_stack+13768, vrr_stack+32885, vrr_stack+431, vrr_stack+2054, vrr_stack+1035);
 _BUILD_g0k0(Data,vrr_stack+33461, vrr_stack+13984, vrr_stack+33101, vrr_stack+5022, vrr_stack+13768, vrr_stack+3098);
 _BUILD_h0k0(Data,vrr_stack+17260, vrr_stack+27441, vrr_stack+33461, vrr_stack+24021, vrr_stack+13984, vrr_stack+3378);
 _BUILD_i0k0(Data,vrr_stack+18016, vrr_stack+27981, vrr_stack+17260, vrr_stack+24381, vrr_stack+27441, vrr_stack+8112);
 _BUILD_k0k0(Data,vrr_stack+2394, vrr_stack+28737, vrr_stack+18016, vrr_stack+24921, vrr_stack+27981, vrr_stack+8700);
 _BUILD_l0k0(Data,vrr_stack+34001, vrr_stack+29745, vrr_stack+2394, vrr_stack+26433, vrr_stack+28737, vrr_stack+19673);
 _BUILD_m0k0(Data,vrr_stack+35621, vrr_stack+31041, vrr_stack+34001, vrr_stack+14344, vrr_stack+29745, vrr_stack+9484);
 _BUILD_m0k0(Data,vrr_stack+7866, vrr_stack+15640, vrr_stack+31041, vrr_stack+6570, vrr_stack+14344, vrr_stack+20681);
   tmp = vrr_stack + 7866;
   target_ptr = Libint->vrr_classes[9][7];
   for(i=0;i<1980;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00l0(Data,vrr_stack+6570, vrr_stack+1299, vrr_stack+1239, vrr_stack+46, vrr_stack+259, NULL);
 _BUILD_00l0(Data,vrr_stack+6615, vrr_stack+1203, vrr_stack+1299, vrr_stack+1446, vrr_stack+46, NULL);
 _BUILD_00l0(Data,vrr_stack+6660, vrr_stack+1239, vrr_stack+1474, vrr_stack+259, vrr_stack+1558, NULL);
 _BUILD_p0l0(Data,vrr_stack+6705, vrr_stack+6570, vrr_stack+6660, NULL, NULL, vrr_stack+1239);
 _BUILD_p0l0(Data,vrr_stack+6840, vrr_stack+6615, vrr_stack+6570, NULL, NULL, vrr_stack+1299);
 _BUILD_d0l0(Data,vrr_stack+6975, vrr_stack+6840, vrr_stack+6705, vrr_stack+6615, vrr_stack+6570, vrr_stack+3798);
 _BUILD_00l0(Data,vrr_stack+7245, vrr_stack+1335, vrr_stack+1203, vrr_stack+367, vrr_stack+1446, NULL);
 _BUILD_p0l0(Data,vrr_stack+7290, vrr_stack+7245, vrr_stack+6615, NULL, NULL, vrr_stack+1203);
 _BUILD_d0l0(Data,vrr_stack+7425, vrr_stack+7290, vrr_stack+6840, vrr_stack+7245, vrr_stack+6615, vrr_stack+3906);
 _BUILD_00l0(Data,vrr_stack+7695, vrr_stack+1474, vrr_stack+395, vrr_stack+1558, vrr_stack+647, NULL);
 _BUILD_p0l0(Data,vrr_stack+951, vrr_stack+6660, vrr_stack+7695, NULL, NULL, vrr_stack+1474);
 _BUILD_d0l0(Data,vrr_stack+37601, vrr_stack+6705, vrr_stack+951, vrr_stack+6570, vrr_stack+6660, vrr_stack+4554);
 _BUILD_f0l0(Data,vrr_stack+37871, vrr_stack+6975, vrr_stack+37601, vrr_stack+6840, vrr_stack+6705, vrr_stack+10744);
 _BUILD_f0l0(Data,vrr_stack+19024, vrr_stack+7425, vrr_stack+6975, vrr_stack+7290, vrr_stack+6840, vrr_stack+4014);
 _BUILD_g0l0(Data,vrr_stack+19474, vrr_stack+19024, vrr_stack+37871, vrr_stack+7425, vrr_stack+6975, vrr_stack+10960);
 _BUILD_00l0(Data,vrr_stack+4554, vrr_stack+1586, vrr_stack+1335, vrr_stack+2258, vrr_stack+367, NULL);
 _BUILD_p0l0(Data,vrr_stack+38321, vrr_stack+4554, vrr_stack+7245, NULL, NULL, vrr_stack+1335);
 _BUILD_d0l0(Data,vrr_stack+20149, vrr_stack+38321, vrr_stack+7290, vrr_stack+4554, vrr_stack+7245, vrr_stack+4230);
 _BUILD_f0l0(Data,vrr_stack+20419, vrr_stack+20149, vrr_stack+7425, vrr_stack+38321, vrr_stack+7290, vrr_stack+4338);
 _BUILD_g0l0(Data,vrr_stack+20869, vrr_stack+20419, vrr_stack+19024, vrr_stack+20149, vrr_stack+7425, vrr_stack+11320);
 _BUILD_00l0(Data,vrr_stack+38456, vrr_stack+395, vrr_stack+575, vrr_stack+647, vrr_stack+2286, NULL);
 _BUILD_p0l0(Data,vrr_stack+647, vrr_stack+7695, vrr_stack+38456, NULL, NULL, vrr_stack+395);
 _BUILD_d0l0(Data,vrr_stack+38501, vrr_stack+951, vrr_stack+647, vrr_stack+6660, vrr_stack+7695, vrr_stack+431);
 _BUILD_f0l0(Data,vrr_stack+9846, vrr_stack+37601, vrr_stack+38501, vrr_stack+6705, vrr_stack+951, vrr_stack+5022);
 _BUILD_g0l0(Data,vrr_stack+10296, vrr_stack+37871, vrr_stack+9846, vrr_stack+6975, vrr_stack+37601, vrr_stack+24021);
 _BUILD_h0l0(Data,vrr_stack+38771, vrr_stack+19474, vrr_stack+10296, vrr_stack+19024, vrr_stack+37871, vrr_stack+24381);
 _BUILD_h0l0(Data,vrr_stack+39716, vrr_stack+20869, vrr_stack+19474, vrr_stack+20419, vrr_stack+19024, vrr_stack+11680);
 _BUILD_i0l0(Data,vrr_stack+40661, vrr_stack+39716, vrr_stack+38771, vrr_stack+20869, vrr_stack+19474, vrr_stack+24921);
 _BUILD_00l0(Data,vrr_stack+24021, vrr_stack+539, vrr_stack+1586, vrr_stack+185, vrr_stack+2258, NULL);
 _BUILD_p0l0(Data,vrr_stack+24066, vrr_stack+24021, vrr_stack+4554, NULL, NULL, vrr_stack+1586);
 _BUILD_d0l0(Data,vrr_stack+24201, vrr_stack+24066, vrr_stack+38321, vrr_stack+24021, vrr_stack+4554, vrr_stack+1622);
 _BUILD_f0l0(Data,vrr_stack+24471, vrr_stack+24201, vrr_stack+20149, vrr_stack+24066, vrr_stack+38321, vrr_stack+1730);
 _BUILD_g0l0(Data,vrr_stack+24921, vrr_stack+24471, vrr_stack+20419, vrr_stack+24201, vrr_stack+20149, vrr_stack+4662);
 _BUILD_h0l0(Data,vrr_stack+10971, vrr_stack+24921, vrr_stack+20869, vrr_stack+24471, vrr_stack+20419, vrr_stack+23481);
 _BUILD_i0l0(Data,vrr_stack+41921, vrr_stack+10971, vrr_stack+39716, vrr_stack+24921, vrr_stack+20869, vrr_stack+25677);
 _BUILD_00l0(Data,vrr_stack+23481, vrr_stack+575, vrr_stack+32741, vrr_stack+2286, vrr_stack+923, NULL);
 _BUILD_p0l0(Data,vrr_stack+23526, vrr_stack+38456, vrr_stack+23481, NULL, NULL, vrr_stack+575);
 _BUILD_d0l0(Data,vrr_stack+23661, vrr_stack+647, vrr_stack+23526, vrr_stack+7695, vrr_stack+38456, vrr_stack+2054);
 _BUILD_f0l0(Data,vrr_stack+25596, vrr_stack+38501, vrr_stack+23661, vrr_stack+951, vrr_stack+647, vrr_stack+13768);
 _BUILD_g0l0(Data,vrr_stack+43181, vrr_stack+9846, vrr_stack+25596, vrr_stack+37601, vrr_stack+38501, vrr_stack+13984);
 _BUILD_h0l0(Data,vrr_stack+43856, vrr_stack+10296, vrr_stack+43181, vrr_stack+37871, vrr_stack+9846, vrr_stack+27441);
 _BUILD_i0l0(Data,vrr_stack+44801, vrr_stack+38771, vrr_stack+43856, vrr_stack+19474, vrr_stack+10296, vrr_stack+27981);
 _BUILD_k0l0(Data,vrr_stack+46061, vrr_stack+40661, vrr_stack+44801, vrr_stack+39716, vrr_stack+38771, vrr_stack+28737);
 _BUILD_k0l0(Data,vrr_stack+27441, vrr_stack+41921, vrr_stack+40661, vrr_stack+10971, vrr_stack+39716, vrr_stack+26433);
 _BUILD_l0l0(Data,vrr_stack+47681, vrr_stack+27441, vrr_stack+46061, vrr_stack+41921, vrr_stack+40661, vrr_stack+29745);
 _BUILD_00l0(Data,vrr_stack+29061, vrr_stack+611, vrr_stack+539, vrr_stack+2366, vrr_stack+185, NULL);
 _BUILD_p0l0(Data,vrr_stack+29106, vrr_stack+29061, vrr_stack+24021, NULL, NULL, vrr_stack+539);
 _BUILD_d0l0(Data,vrr_stack+29241, vrr_stack+29106, vrr_stack+24066, vrr_stack+29061, vrr_stack+24021, vrr_stack+1946);
 _BUILD_f0l0(Data,vrr_stack+29511, vrr_stack+29241, vrr_stack+24201, vrr_stack+29106, vrr_stack+24066, vrr_stack+5238);
 _BUILD_g0l0(Data,vrr_stack+29961, vrr_stack+29511, vrr_stack+24471, vrr_stack+29241, vrr_stack+24201, vrr_stack+5454);
 _BUILD_h0l0(Data,vrr_stack+26046, vrr_stack+29961, vrr_stack+24921, vrr_stack+29511, vrr_stack+24471, vrr_stack+12220);
 _BUILD_i0l0(Data,vrr_stack+49706, vrr_stack+26046, vrr_stack+10971, vrr_stack+29961, vrr_stack+24921, vrr_stack+5814);
 _BUILD_k0l0(Data,vrr_stack+29106, vrr_stack+49706, vrr_stack+41921, vrr_stack+26046, vrr_stack+10971, vrr_stack+12760);
   tmp = vrr_stack + 29106;
   target_ptr = Libint->vrr_classes[7][8];
   for(i=0;i<1620;i++)
     target_ptr[i] += tmp[i];
 _BUILD_l0l0(Data,vrr_stack+11916, vrr_stack+29106, vrr_stack+27441, vrr_stack+49706, vrr_stack+41921, vrr_stack+14344);
   tmp = vrr_stack + 11916;
   target_ptr = Libint->vrr_classes[8][8];
   for(i=0;i<2025;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00p0(Data,vrr_stack+49706, Data->F+17, Data->F+18, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+49709, vrr_stack+1275, vrr_stack+49706, Data->F+16, Data->F+17, NULL);
 _BUILD_00f0(Data,vrr_stack+49715, vrr_stack+32661, vrr_stack+49709, vrr_stack+868, vrr_stack+1275, NULL);
 _BUILD_00g0(Data,vrr_stack+49725, vrr_stack+32667, vrr_stack+49715, vrr_stack+871, vrr_stack+32661, NULL);
 _BUILD_00h0(Data,vrr_stack+1278, vrr_stack+32677, vrr_stack+49725, vrr_stack+877, vrr_stack+32667, NULL);
 _BUILD_00i0(Data,vrr_stack+49740, vrr_stack+32692, vrr_stack+1278, vrr_stack+887, vrr_stack+32677, NULL);
 _BUILD_00k0(Data,vrr_stack+49768, vrr_stack+32713, vrr_stack+49740, vrr_stack+902, vrr_stack+32692, NULL);
 _BUILD_00l0(Data,vrr_stack+49804, vrr_stack+32741, vrr_stack+49768, vrr_stack+923, vrr_stack+32713, NULL);
 _BUILD_p0l0(Data,vrr_stack+49849, vrr_stack+23481, vrr_stack+49804, NULL, NULL, vrr_stack+32741);
 _BUILD_d0l0(Data,vrr_stack+49984, vrr_stack+23526, vrr_stack+49849, vrr_stack+38456, vrr_stack+23481, vrr_stack+32777);
 _BUILD_f0l0(Data,vrr_stack+50254, vrr_stack+23661, vrr_stack+49984, vrr_stack+647, vrr_stack+23526, vrr_stack+32885);
 _BUILD_g0l0(Data,vrr_stack+26046, vrr_stack+25596, vrr_stack+50254, vrr_stack+38501, vrr_stack+23661, vrr_stack+33101);
 _BUILD_h0l0(Data,vrr_stack+4599, vrr_stack+43181, vrr_stack+26046, vrr_stack+9846, vrr_stack+25596, vrr_stack+33461);
 _BUILD_i0l0(Data,vrr_stack+13941, vrr_stack+43856, vrr_stack+4599, vrr_stack+10296, vrr_stack+43181, vrr_stack+17260);
 _BUILD_k0l0(Data,vrr_stack+50704, vrr_stack+44801, vrr_stack+13941, vrr_stack+38771, vrr_stack+43856, vrr_stack+18016);
 _BUILD_l0l0(Data,vrr_stack+52324, vrr_stack+46061, vrr_stack+50704, vrr_stack+40661, vrr_stack+44801, vrr_stack+2394);
 _BUILD_m0l0(Data,vrr_stack+1622, vrr_stack+47681, vrr_stack+52324, vrr_stack+27441, vrr_stack+46061, vrr_stack+34001);
 _BUILD_m0l0(Data,vrr_stack+32777, vrr_stack+11916, vrr_stack+47681, vrr_stack+29106, vrr_stack+27441, vrr_stack+31041);
   tmp = vrr_stack + 32777;
   target_ptr = Libint->vrr_classes[9][8];
   for(i=0;i<2475;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00m0(Data,vrr_stack+29106, vrr_stack+6570, vrr_stack+6660, vrr_stack+1299, vrr_stack+1239, NULL);
 _BUILD_00m0(Data,vrr_stack+29161, vrr_stack+6615, vrr_stack+6570, vrr_stack+1203, vrr_stack+1299, NULL);
 _BUILD_00m0(Data,vrr_stack+29216, vrr_stack+6660, vrr_stack+7695, vrr_stack+1239, vrr_stack+1474, NULL);
 _BUILD_p0m0(Data,vrr_stack+29271, vrr_stack+29106, vrr_stack+29216, NULL, NULL, vrr_stack+6660);
 _BUILD_p0m0(Data,vrr_stack+29436, vrr_stack+29161, vrr_stack+29106, NULL, NULL, vrr_stack+6570);
 _BUILD_d0m0(Data,vrr_stack+29601, vrr_stack+29436, vrr_stack+29271, vrr_stack+29161, vrr_stack+29106, vrr_stack+6705);
 _BUILD_00m0(Data,vrr_stack+6705, vrr_stack+7245, vrr_stack+6615, vrr_stack+1335, vrr_stack+1203, NULL);
 _BUILD_p0m0(Data,vrr_stack+29931, vrr_stack+6705, vrr_stack+29161, NULL, NULL, vrr_stack+6615);
 _BUILD_d0m0(Data,vrr_stack+30096, vrr_stack+29931, vrr_stack+29436, vrr_stack+6705, vrr_stack+29161, vrr_stack+6840);
 _BUILD_00m0(Data,vrr_stack+6760, vrr_stack+7695, vrr_stack+38456, vrr_stack+1474, vrr_stack+395, NULL);
 _BUILD_p0m0(Data,vrr_stack+30426, vrr_stack+29216, vrr_stack+6760, NULL, NULL, vrr_stack+7695);
 _BUILD_d0m0(Data,vrr_stack+30591, vrr_stack+29271, vrr_stack+30426, vrr_stack+29106, vrr_stack+29216, vrr_stack+951);
 _BUILD_f0m0(Data,vrr_stack+17260, vrr_stack+29601, vrr_stack+30591, vrr_stack+29436, vrr_stack+29271, vrr_stack+37601);
 _BUILD_f0m0(Data,vrr_stack+17810, vrr_stack+30096, vrr_stack+29601, vrr_stack+29931, vrr_stack+29436, vrr_stack+6975);
 _BUILD_g0m0(Data,vrr_stack+5544, vrr_stack+17810, vrr_stack+17260, vrr_stack+30096, vrr_stack+29601, vrr_stack+37871);
 _BUILD_00m0(Data,vrr_stack+37601, vrr_stack+4554, vrr_stack+7245, vrr_stack+1586, vrr_stack+1335, NULL);
 _BUILD_p0m0(Data,vrr_stack+37656, vrr_stack+37601, vrr_stack+6705, NULL, NULL, vrr_stack+7245);
 _BUILD_d0m0(Data,vrr_stack+37821, vrr_stack+37656, vrr_stack+29931, vrr_stack+37601, vrr_stack+6705, vrr_stack+7290);
 _BUILD_f0m0(Data,vrr_stack+18360, vrr_stack+37821, vrr_stack+30096, vrr_stack+37656, vrr_stack+29931, vrr_stack+7425);
 _BUILD_g0m0(Data,vrr_stack+54349, vrr_stack+18360, vrr_stack+17810, vrr_stack+37821, vrr_stack+30096, vrr_stack+19024);
 _BUILD_00m0(Data,vrr_stack+7290, vrr_stack+38456, vrr_stack+23481, vrr_stack+395, vrr_stack+575, NULL);
 _BUILD_p0m0(Data,vrr_stack+7345, vrr_stack+6760, vrr_stack+7290, NULL, NULL, vrr_stack+38456);
 _BUILD_d0m0(Data,vrr_stack+6815, vrr_stack+30426, vrr_stack+7345, vrr_stack+29216, vrr_stack+6760, vrr_stack+647);
 _BUILD_f0m0(Data,vrr_stack+647, vrr_stack+30591, vrr_stack+6815, vrr_stack+29271, vrr_stack+30426, vrr_stack+38501);
 _BUILD_g0m0(Data,vrr_stack+55174, vrr_stack+17260, vrr_stack+647, vrr_stack+29601, vrr_stack+30591, vrr_stack+9846);
 _BUILD_h0m0(Data,vrr_stack+55999, vrr_stack+5544, vrr_stack+55174, vrr_stack+17810, vrr_stack+17260, vrr_stack+10296);
 _BUILD_h0m0(Data,vrr_stack+57154, vrr_stack+54349, vrr_stack+5544, vrr_stack+18360, vrr_stack+17810, vrr_stack+19474);
 _BUILD_i0m0(Data,vrr_stack+58309, vrr_stack+57154, vrr_stack+55999, vrr_stack+54349, vrr_stack+5544, vrr_stack+38771);
 _BUILD_00m0(Data,vrr_stack+9846, vrr_stack+24021, vrr_stack+4554, vrr_stack+539, vrr_stack+1586, NULL);
 _BUILD_p0m0(Data,vrr_stack+9901, vrr_stack+9846, vrr_stack+37601, NULL, NULL, vrr_stack+4554);
 _BUILD_d0m0(Data,vrr_stack+10066, vrr_stack+9901, vrr_stack+37656, vrr_stack+9846, vrr_stack+37601, vrr_stack+38321);
 _BUILD_f0m0(Data,vrr_stack+10396, vrr_stack+10066, vrr_stack+37821, vrr_stack+9901, vrr_stack+37656, vrr_stack+20149);
 _BUILD_g0m0(Data,vrr_stack+38501, vrr_stack+10396, vrr_stack+18360, vrr_stack+10066, vrr_stack+37821, vrr_stack+20419);
 _BUILD_h0m0(Data,vrr_stack+18910, vrr_stack+38501, vrr_stack+54349, vrr_stack+10396, vrr_stack+18360, vrr_stack+20869);
 _BUILD_i0m0(Data,vrr_stack+20065, vrr_stack+18910, vrr_stack+57154, vrr_stack+38501, vrr_stack+54349, vrr_stack+39716);
 _BUILD_00m0(Data,vrr_stack+39326, vrr_stack+23481, vrr_stack+49804, vrr_stack+575, vrr_stack+32741, NULL);
 _BUILD_p0m0(Data,vrr_stack+39381, vrr_stack+7290, vrr_stack+39326, NULL, NULL, vrr_stack+23481);
 _BUILD_d0m0(Data,vrr_stack+39546, vrr_stack+7345, vrr_stack+39381, vrr_stack+6760, vrr_stack+7290, vrr_stack+23526);
 _BUILD_f0m0(Data,vrr_stack+39876, vrr_stack+6815, vrr_stack+39546, vrr_stack+30426, vrr_stack+7345, vrr_stack+23661);
 _BUILD_g0m0(Data,vrr_stack+59849, vrr_stack+647, vrr_stack+39876, vrr_stack+30591, vrr_stack+6815, vrr_stack+25596);
 _BUILD_h0m0(Data,vrr_stack+60674, vrr_stack+55174, vrr_stack+59849, vrr_stack+17260, vrr_stack+647, vrr_stack+43181);
 _BUILD_i0m0(Data,vrr_stack+61829, vrr_stack+55999, vrr_stack+60674, vrr_stack+5544, vrr_stack+55174, vrr_stack+43856);
 _BUILD_k0m0(Data,vrr_stack+63369, vrr_stack+58309, vrr_stack+61829, vrr_stack+57154, vrr_stack+55999, vrr_stack+44801);
 _BUILD_k0m0(Data,vrr_stack+43181, vrr_stack+20065, vrr_stack+58309, vrr_stack+18910, vrr_stack+57154, vrr_stack+40661);
 _BUILD_l0m0(Data,vrr_stack+65349, vrr_stack+43181, vrr_stack+63369, vrr_stack+20065, vrr_stack+58309, vrr_stack+46061);
 _BUILD_00m0(Data,vrr_stack+45161, vrr_stack+29061, vrr_stack+24021, vrr_stack+611, vrr_stack+539, NULL);
 _BUILD_p0m0(Data,vrr_stack+45216, vrr_stack+45161, vrr_stack+9846, NULL, NULL, vrr_stack+24021);
 _BUILD_d0m0(Data,vrr_stack+45381, vrr_stack+45216, vrr_stack+9901, vrr_stack+45161, vrr_stack+9846, vrr_stack+24066);
 _BUILD_f0m0(Data,vrr_stack+45711, vrr_stack+45381, vrr_stack+10066, vrr_stack+45216, vrr_stack+9901, vrr_stack+24201);
 _BUILD_g0m0(Data,vrr_stack+46261, vrr_stack+45711, vrr_stack+10396, vrr_stack+45381, vrr_stack+10066, vrr_stack+24471);
 _BUILD_h0m0(Data,vrr_stack+40426, vrr_stack+46261, vrr_stack+38501, vrr_stack+45711, vrr_stack+10396, vrr_stack+24921);
 _BUILD_i0m0(Data,vrr_stack+24066, vrr_stack+40426, vrr_stack+18910, vrr_stack+46261, vrr_stack+38501, vrr_stack+10971);
 _BUILD_k0m0(Data,vrr_stack+45216, vrr_stack+24066, vrr_stack+20065, vrr_stack+40426, vrr_stack+18910, vrr_stack+41921);
   tmp = vrr_stack + 45216;
   target_ptr = Libint->vrr_classes[7][9];
   for(i=0;i<1980;i++)
     target_ptr[i] += tmp[i];
 _BUILD_l0m0(Data,vrr_stack+40426, vrr_stack+45216, vrr_stack+43181, vrr_stack+24066, vrr_stack+20065, vrr_stack+27441);
   tmp = vrr_stack + 40426;
   target_ptr = Libint->vrr_classes[8][9];
   for(i=0;i<2475;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00p0(Data,vrr_stack+24066, Data->F+18, Data->F+19, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+24069, vrr_stack+49706, vrr_stack+24066, Data->F+17, Data->F+18, NULL);
 _BUILD_00f0(Data,vrr_stack+24075, vrr_stack+49709, vrr_stack+24069, vrr_stack+1275, vrr_stack+49706, NULL);
 _BUILD_00g0(Data,vrr_stack+24085, vrr_stack+49715, vrr_stack+24075, vrr_stack+32661, vrr_stack+49709, NULL);
 _BUILD_00h0(Data,vrr_stack+24100, vrr_stack+49725, vrr_stack+24085, vrr_stack+32667, vrr_stack+49715, NULL);
 _BUILD_00i0(Data,vrr_stack+24121, vrr_stack+1278, vrr_stack+24100, vrr_stack+32677, vrr_stack+49725, NULL);
 _BUILD_00k0(Data,vrr_stack+24149, vrr_stack+49740, vrr_stack+24121, vrr_stack+32692, vrr_stack+1278, NULL);
 _BUILD_00l0(Data,vrr_stack+32661, vrr_stack+49768, vrr_stack+24149, vrr_stack+32713, vrr_stack+49740, NULL);
 _BUILD_00m0(Data,vrr_stack+24185, vrr_stack+49804, vrr_stack+32661, vrr_stack+32741, vrr_stack+49768, NULL);
 _BUILD_p0m0(Data,vrr_stack+24240, vrr_stack+39326, vrr_stack+24185, NULL, NULL, vrr_stack+49804);
 _BUILD_d0m0(Data,vrr_stack+24405, vrr_stack+39381, vrr_stack+24240, vrr_stack+7290, vrr_stack+39326, vrr_stack+49849);
 _BUILD_f0m0(Data,vrr_stack+24735, vrr_stack+39546, vrr_stack+24405, vrr_stack+7345, vrr_stack+39381, vrr_stack+49984);
 _BUILD_g0m0(Data,vrr_stack+10946, vrr_stack+39876, vrr_stack+24735, vrr_stack+6815, vrr_stack+39546, vrr_stack+50254);
 _BUILD_h0m0(Data,vrr_stack+26721, vrr_stack+59849, vrr_stack+10946, vrr_stack+647, vrr_stack+39876, vrr_stack+26046);
 _BUILD_i0m0(Data,vrr_stack+67824, vrr_stack+60674, vrr_stack+26721, vrr_stack+55174, vrr_stack+59849, vrr_stack+4599);
 _BUILD_k0m0(Data,vrr_stack+69364, vrr_stack+61829, vrr_stack+67824, vrr_stack+55999, vrr_stack+60674, vrr_stack+13941);
 _BUILD_l0m0(Data,vrr_stack+71344, vrr_stack+63369, vrr_stack+69364, vrr_stack+58309, vrr_stack+61829, vrr_stack+50704);
 _BUILD_m0m0(Data,vrr_stack+73819, vrr_stack+65349, vrr_stack+71344, vrr_stack+43181, vrr_stack+63369, vrr_stack+52324);
 _BUILD_m0m0(Data,vrr_stack+49849, vrr_stack+40426, vrr_stack+65349, vrr_stack+45216, vrr_stack+43181, vrr_stack+47681);
   tmp = vrr_stack + 49849;
   target_ptr = Libint->vrr_classes[9][9];
   for(i=0;i<3025;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00n0(Data,vrr_stack+45216, vrr_stack+29106, vrr_stack+29216, vrr_stack+6570, vrr_stack+6660, NULL);
 _BUILD_00n0(Data,vrr_stack+45282, vrr_stack+29161, vrr_stack+29106, vrr_stack+6615, vrr_stack+6570, NULL);
 _BUILD_00n0(Data,vrr_stack+45348, vrr_stack+29216, vrr_stack+6760, vrr_stack+6660, vrr_stack+7695, NULL);
 _BUILD_p0n0(Data,vrr_stack+45414, vrr_stack+45216, vrr_stack+45348, NULL, NULL, vrr_stack+29216);
 _BUILD_p0n0(Data,vrr_stack+45612, vrr_stack+45282, vrr_stack+45216, NULL, NULL, vrr_stack+29106);
 _BUILD_d0n0(Data,vrr_stack+45810, vrr_stack+45612, vrr_stack+45414, vrr_stack+45282, vrr_stack+45216, vrr_stack+29271);
 _BUILD_00n0(Data,vrr_stack+29216, vrr_stack+6705, vrr_stack+29161, vrr_stack+7245, vrr_stack+6615, NULL);
 _BUILD_p0n0(Data,vrr_stack+46206, vrr_stack+29216, vrr_stack+45282, NULL, NULL, vrr_stack+29161);
 _BUILD_d0n0(Data,vrr_stack+46404, vrr_stack+46206, vrr_stack+45612, vrr_stack+29216, vrr_stack+45282, vrr_stack+29436);
 _BUILD_00n0(Data,vrr_stack+45282, vrr_stack+6760, vrr_stack+7290, vrr_stack+7695, vrr_stack+38456, NULL);
 _BUILD_p0n0(Data,vrr_stack+29282, vrr_stack+45348, vrr_stack+45282, NULL, NULL, vrr_stack+6760);
 _BUILD_d0n0(Data,vrr_stack+46800, vrr_stack+45414, vrr_stack+29282, vrr_stack+45216, vrr_stack+45348, vrr_stack+30426);
 _BUILD_f0n0(Data,vrr_stack+13941, vrr_stack+45810, vrr_stack+46800, vrr_stack+45612, vrr_stack+45414, vrr_stack+30591);
 _BUILD_f0n0(Data,vrr_stack+14601, vrr_stack+46404, vrr_stack+45810, vrr_stack+46206, vrr_stack+45612, vrr_stack+29601);
 _BUILD_g0n0(Data,vrr_stack+52874, vrr_stack+14601, vrr_stack+13941, vrr_stack+46404, vrr_stack+45810, vrr_stack+17260);
 _BUILD_00n0(Data,vrr_stack+45216, vrr_stack+37601, vrr_stack+6705, vrr_stack+4554, vrr_stack+7245, NULL);
 _BUILD_p0n0(Data,vrr_stack+45612, vrr_stack+45216, vrr_stack+29216, NULL, NULL, vrr_stack+6705);
 _BUILD_d0n0(Data,vrr_stack+17260, vrr_stack+45612, vrr_stack+46206, vrr_stack+45216, vrr_stack+29216, vrr_stack+29931);
 _BUILD_f0n0(Data,vrr_stack+4599, vrr_stack+17260, vrr_stack+46404, vrr_stack+45612, vrr_stack+46206, vrr_stack+30096);
 _BUILD_g0n0(Data,vrr_stack+29480, vrr_stack+4599, vrr_stack+14601, vrr_stack+17260, vrr_stack+46404, vrr_stack+17810);
 _BUILD_00n0(Data,vrr_stack+46206, vrr_stack+7290, vrr_stack+39326, vrr_stack+38456, vrr_stack+23481, NULL);
 _BUILD_p0n0(Data,vrr_stack+46272, vrr_stack+45282, vrr_stack+46206, NULL, NULL, vrr_stack+7290);
 _BUILD_d0n0(Data,vrr_stack+17656, vrr_stack+29282, vrr_stack+46272, vrr_stack+45348, vrr_stack+45282, vrr_stack+7345);
 _BUILD_f0n0(Data,vrr_stack+25285, vrr_stack+46800, vrr_stack+17656, vrr_stack+45414, vrr_stack+29282, vrr_stack+6815);
 _BUILD_g0n0(Data,vrr_stack+27876, vrr_stack+13941, vrr_stack+25285, vrr_stack+45810, vrr_stack+46800, vrr_stack+647);
 _BUILD_h0n0(Data,vrr_stack+6369, vrr_stack+52874, vrr_stack+27876, vrr_stack+14601, vrr_stack+13941, vrr_stack+55174);
 _BUILD_h0n0(Data,vrr_stack+76844, vrr_stack+29480, vrr_stack+52874, vrr_stack+4599, vrr_stack+14601, vrr_stack+5544);
 _BUILD_i0n0(Data,vrr_stack+78230, vrr_stack+76844, vrr_stack+6369, vrr_stack+29480, vrr_stack+52874, vrr_stack+55999);
 _BUILD_00n0(Data,vrr_stack+14601, vrr_stack+9846, vrr_stack+37601, vrr_stack+24021, vrr_stack+4554, NULL);
 _BUILD_p0n0(Data,vrr_stack+14667, vrr_stack+14601, vrr_stack+45216, NULL, NULL, vrr_stack+37601);
 _BUILD_d0n0(Data,vrr_stack+45810, vrr_stack+14667, vrr_stack+45612, vrr_stack+14601, vrr_stack+45216, vrr_stack+37656);
 _BUILD_f0n0(Data,vrr_stack+14865, vrr_stack+45810, vrr_stack+17260, vrr_stack+14667, vrr_stack+45612, vrr_stack+37821);
 _BUILD_g0n0(Data,vrr_stack+55174, vrr_stack+14865, vrr_stack+4599, vrr_stack+45810, vrr_stack+17260, vrr_stack+18360);
 _BUILD_h0n0(Data,vrr_stack+80078, vrr_stack+55174, vrr_stack+29480, vrr_stack+14865, vrr_stack+4599, vrr_stack+54349);
 _BUILD_i0n0(Data,vrr_stack+4097, vrr_stack+80078, vrr_stack+76844, vrr_stack+55174, vrr_stack+29480, vrr_stack+57154);
 _BUILD_00n0(Data,vrr_stack+45216, vrr_stack+39326, vrr_stack+24185, vrr_stack+23481, vrr_stack+49804, NULL);
 _BUILD_p0n0(Data,vrr_stack+23481, vrr_stack+46206, vrr_stack+45216, NULL, NULL, vrr_stack+39326);
 _BUILD_d0n0(Data,vrr_stack+17260, vrr_stack+46272, vrr_stack+23481, vrr_stack+45282, vrr_stack+46206, vrr_stack+39381);
 _BUILD_f0n0(Data,vrr_stack+29480, vrr_stack+17656, vrr_stack+17260, vrr_stack+29282, vrr_stack+46272, vrr_stack+39546);
 _BUILD_g0n0(Data,vrr_stack+56164, vrr_stack+25285, vrr_stack+29480, vrr_stack+46800, vrr_stack+17656, vrr_stack+39876);
 _BUILD_h0n0(Data,vrr_stack+81464, vrr_stack+27876, vrr_stack+56164, vrr_stack+13941, vrr_stack+25285, vrr_stack+59849);
 _BUILD_i0n0(Data,vrr_stack+82850, vrr_stack+6369, vrr_stack+81464, vrr_stack+52874, vrr_stack+27876, vrr_stack+60674);
 _BUILD_k0n0(Data,vrr_stack+84698, vrr_stack+78230, vrr_stack+82850, vrr_stack+76844, vrr_stack+6369, vrr_stack+61829);
 _BUILD_k0n0(Data,vrr_stack+59849, vrr_stack+4097, vrr_stack+78230, vrr_stack+80078, vrr_stack+76844, vrr_stack+58309);
 _BUILD_l0n0(Data,vrr_stack+87074, vrr_stack+59849, vrr_stack+84698, vrr_stack+4097, vrr_stack+78230, vrr_stack+63369);
 _BUILD_00n0(Data,vrr_stack+76844, vrr_stack+45161, vrr_stack+9846, vrr_stack+29061, vrr_stack+24021, NULL);
 _BUILD_p0n0(Data,vrr_stack+76910, vrr_stack+76844, vrr_stack+14601, NULL, NULL, vrr_stack+9846);
 _BUILD_d0n0(Data,vrr_stack+77108, vrr_stack+76910, vrr_stack+14667, vrr_stack+76844, vrr_stack+14601, vrr_stack+9901);
 _BUILD_f0n0(Data,vrr_stack+77504, vrr_stack+77108, vrr_stack+45810, vrr_stack+76910, vrr_stack+14667, vrr_stack+10066);
 _BUILD_g0n0(Data,vrr_stack+52874, vrr_stack+77504, vrr_stack+14865, vrr_stack+77108, vrr_stack+45810, vrr_stack+10396);
 _BUILD_h0n0(Data,vrr_stack+62225, vrr_stack+52874, vrr_stack+55174, vrr_stack+77504, vrr_stack+14865, vrr_stack+38501);
 _BUILD_i0n0(Data,vrr_stack+37601, vrr_stack+62225, vrr_stack+80078, vrr_stack+52874, vrr_stack+55174, vrr_stack+18910);
 _BUILD_k0n0(Data,vrr_stack+52874, vrr_stack+37601, vrr_stack+4097, vrr_stack+62225, vrr_stack+80078, vrr_stack+20065);
   tmp = vrr_stack + 52874;
   target_ptr = Libint->vrr_classes[7][10];
   for(i=0;i<2376;i++)
     target_ptr[i] += tmp[i];
 _BUILD_l0n0(Data,vrr_stack+62225, vrr_stack+52874, vrr_stack+59849, vrr_stack+37601, vrr_stack+4097, vrr_stack+43181);
   tmp = vrr_stack + 62225;
   target_ptr = Libint->vrr_classes[8][10];
   for(i=0;i<2970;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00p0(Data,vrr_stack+4097, Data->F+19, Data->F+20, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+4100, vrr_stack+24066, vrr_stack+4097, Data->F+18, Data->F+19, NULL);
 _BUILD_00f0(Data,vrr_stack+4106, vrr_stack+24069, vrr_stack+4100, vrr_stack+49706, vrr_stack+24066, NULL);
 _BUILD_00g0(Data,vrr_stack+4116, vrr_stack+24075, vrr_stack+4106, vrr_stack+49709, vrr_stack+24069, NULL);
 _BUILD_00h0(Data,vrr_stack+4131, vrr_stack+24085, vrr_stack+4116, vrr_stack+49715, vrr_stack+24075, NULL);
 _BUILD_00i0(Data,vrr_stack+4097, vrr_stack+24100, vrr_stack+4131, vrr_stack+49725, vrr_stack+24085, NULL);
 _BUILD_00k0(Data,vrr_stack+4125, vrr_stack+24121, vrr_stack+4097, vrr_stack+1278, vrr_stack+24100, NULL);
 _BUILD_00l0(Data,vrr_stack+4161, vrr_stack+24149, vrr_stack+4125, vrr_stack+49740, vrr_stack+24121, NULL);
 _BUILD_00m0(Data,vrr_stack+4097, vrr_stack+32661, vrr_stack+4161, vrr_stack+49768, vrr_stack+24149, NULL);
 _BUILD_00n0(Data,vrr_stack+4152, vrr_stack+24185, vrr_stack+4097, vrr_stack+49804, vrr_stack+32661, NULL);
 _BUILD_p0n0(Data,vrr_stack+4218, vrr_stack+45216, vrr_stack+4152, NULL, NULL, vrr_stack+24185);
 _BUILD_d0n0(Data,vrr_stack+4416, vrr_stack+23481, vrr_stack+4218, vrr_stack+46206, vrr_stack+45216, vrr_stack+24240);
 _BUILD_f0n0(Data,vrr_stack+4812, vrr_stack+17260, vrr_stack+4416, vrr_stack+46272, vrr_stack+23481, vrr_stack+24405);
 _BUILD_g0n0(Data,vrr_stack+23481, vrr_stack+29480, vrr_stack+4812, vrr_stack+17656, vrr_stack+17260, vrr_stack+24735);
 _BUILD_h0n0(Data,vrr_stack+80078, vrr_stack+56164, vrr_stack+23481, vrr_stack+25285, vrr_stack+29480, vrr_stack+10946);
 _BUILD_i0n0(Data,vrr_stack+23481, vrr_stack+81464, vrr_stack+80078, vrr_stack+27876, vrr_stack+56164, vrr_stack+26721);
 _BUILD_k0n0(Data,vrr_stack+25329, vrr_stack+82850, vrr_stack+23481, vrr_stack+6369, vrr_stack+81464, vrr_stack+67824);
 _BUILD_l0n0(Data,vrr_stack+27705, vrr_stack+84698, vrr_stack+25329, vrr_stack+78230, vrr_stack+82850, vrr_stack+69364);
 _BUILD_m0n0(Data,vrr_stack+23481, vrr_stack+87074, vrr_stack+27705, vrr_stack+59849, vrr_stack+84698, vrr_stack+71344);
 _BUILD_m0n0(Data,vrr_stack+67824, vrr_stack+62225, vrr_stack+87074, vrr_stack+52874, vrr_stack+59849, vrr_stack+65349);
   tmp = vrr_stack + 67824;
   target_ptr = Libint->vrr_classes[9][10];
   for(i=0;i<3630;i++)
     target_ptr[i] += tmp[i];
 _BUILD_n0k0(Data,vrr_stack+52874, vrr_stack+7866, vrr_stack+35621, vrr_stack+15640, vrr_stack+31041, vrr_stack+21941);
   tmp = vrr_stack + 52874;
   target_ptr = Libint->vrr_classes[10][7];
   for(i=0;i<2376;i++)
     target_ptr[i] += tmp[i];
 _BUILD_n0l0(Data,vrr_stack+55250, vrr_stack+32777, vrr_stack+1622, vrr_stack+11916, vrr_stack+47681, vrr_stack+35621);
   tmp = vrr_stack + 55250;
   target_ptr = Libint->vrr_classes[10][8];
   for(i=0;i<2970;i++)
     target_ptr[i] += tmp[i];
 _BUILD_n0m0(Data,vrr_stack+58220, vrr_stack+49849, vrr_stack+73819, vrr_stack+40426, vrr_stack+65349, vrr_stack+1622);
   tmp = vrr_stack + 58220;
   target_ptr = Libint->vrr_classes[10][9];
   for(i=0;i<3630;i++)
     target_ptr[i] += tmp[i];
 _BUILD_n0n0(Data,vrr_stack+27111, vrr_stack+67824, vrr_stack+23481, vrr_stack+62225, vrr_stack+87074, vrr_stack+73819);
   tmp = vrr_stack + 27111;
   target_ptr = Libint->vrr_classes[10][10];
   for(i=0;i<4356;i++)
     target_ptr[i] += tmp[i];

}

