/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include "libint.h"
#include "vrr_header.h"

  /* Computes quartets necessary to compute (kf|lg) integrals */

void vrr_order_kflg(Libint_t * Libint, prim_data *Data)
{
 REALTYPE *vrr_stack = Libint->vrr_stack;
 REALTYPE *tmp, *target_ptr;
 int i, am[2];
 _BUILD_p000(Data,vrr_stack+0, Data->F+9, Data->F+10, NULL, NULL, NULL);
 _BUILD_p000(Data,vrr_stack+3, Data->F+8, Data->F+9, NULL, NULL, NULL);
 _BUILD_d000(Data,vrr_stack+6, vrr_stack+3, vrr_stack+0, Data->F+8, Data->F+9, NULL);
 _BUILD_00p0(Data,vrr_stack+12, Data->F+9, Data->F+10, NULL, NULL, NULL);
 _BUILD_00p0(Data,vrr_stack+15, Data->F+8, Data->F+9, NULL, NULL, NULL);
 _BUILD_p0p0(Data,vrr_stack+18, vrr_stack+15, vrr_stack+12, NULL, NULL, Data->F+9);
 _BUILD_00p0(Data,vrr_stack+27, Data->F+7, Data->F+8, NULL, NULL, NULL);
 _BUILD_p0p0(Data,vrr_stack+30, vrr_stack+27, vrr_stack+15, NULL, NULL, Data->F+8);
 _BUILD_00p0(Data,vrr_stack+39, Data->F+10, Data->F+11, NULL, NULL, NULL);
 _BUILD_p0p0(Data,vrr_stack+42, vrr_stack+12, vrr_stack+39, NULL, NULL, Data->F+10);
 _BUILD_d0p0(Data,vrr_stack+51, vrr_stack+18, vrr_stack+42, vrr_stack+15, vrr_stack+12, vrr_stack+0);
 _BUILD_d0p0(Data,vrr_stack+69, vrr_stack+30, vrr_stack+18, vrr_stack+27, vrr_stack+15, vrr_stack+3);
 _BUILD_f0p0(Data,vrr_stack+87, vrr_stack+69, vrr_stack+51, vrr_stack+30, vrr_stack+18, vrr_stack+6);
 _BUILD_00d0(Data,vrr_stack+0, vrr_stack+15, vrr_stack+12, Data->F+8, Data->F+9, NULL);
 _BUILD_00d0(Data,vrr_stack+6, vrr_stack+27, vrr_stack+15, Data->F+7, Data->F+8, NULL);
 _BUILD_00d0(Data,vrr_stack+117, vrr_stack+12, vrr_stack+39, Data->F+9, Data->F+10, NULL);
 _BUILD_p0d0(Data,vrr_stack+123, vrr_stack+0, vrr_stack+117, NULL, NULL, vrr_stack+12);
 _BUILD_p0d0(Data,vrr_stack+141, vrr_stack+6, vrr_stack+0, NULL, NULL, vrr_stack+15);
 _BUILD_d0d0(Data,vrr_stack+159, vrr_stack+141, vrr_stack+123, vrr_stack+6, vrr_stack+0, vrr_stack+18);
 _BUILD_00p0(Data,vrr_stack+18, Data->F+6, Data->F+7, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+21, vrr_stack+18, vrr_stack+27, Data->F+6, Data->F+7, NULL);
 _BUILD_p0d0(Data,vrr_stack+195, vrr_stack+21, vrr_stack+6, NULL, NULL, vrr_stack+27);
 _BUILD_d0d0(Data,vrr_stack+213, vrr_stack+195, vrr_stack+141, vrr_stack+21, vrr_stack+6, vrr_stack+30);
 _BUILD_00p0(Data,vrr_stack+30, Data->F+11, Data->F+12, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+33, vrr_stack+39, vrr_stack+30, Data->F+10, Data->F+11, NULL);
 _BUILD_p0d0(Data,vrr_stack+249, vrr_stack+117, vrr_stack+33, NULL, NULL, vrr_stack+39);
 _BUILD_d0d0(Data,vrr_stack+267, vrr_stack+123, vrr_stack+249, vrr_stack+0, vrr_stack+117, vrr_stack+42);
 _BUILD_f0d0(Data,vrr_stack+303, vrr_stack+159, vrr_stack+267, vrr_stack+141, vrr_stack+123, vrr_stack+51);
 _BUILD_f0d0(Data,vrr_stack+363, vrr_stack+213, vrr_stack+159, vrr_stack+195, vrr_stack+141, vrr_stack+69);
 _BUILD_g0d0(Data,vrr_stack+423, vrr_stack+363, vrr_stack+303, vrr_stack+213, vrr_stack+159, vrr_stack+87);
 _BUILD_00f0(Data,vrr_stack+42, vrr_stack+0, vrr_stack+117, vrr_stack+15, vrr_stack+12, NULL);
 _BUILD_00f0(Data,vrr_stack+52, vrr_stack+6, vrr_stack+0, vrr_stack+27, vrr_stack+15, NULL);
 _BUILD_p0f0(Data,vrr_stack+62, vrr_stack+52, vrr_stack+42, NULL, NULL, vrr_stack+0);
 _BUILD_00f0(Data,vrr_stack+92, vrr_stack+21, vrr_stack+6, vrr_stack+18, vrr_stack+27, NULL);
 _BUILD_p0f0(Data,vrr_stack+513, vrr_stack+92, vrr_stack+52, NULL, NULL, vrr_stack+6);
 _BUILD_00f0(Data,vrr_stack+102, vrr_stack+117, vrr_stack+33, vrr_stack+12, vrr_stack+39, NULL);
 _BUILD_p0f0(Data,vrr_stack+543, vrr_stack+42, vrr_stack+102, NULL, NULL, vrr_stack+117);
 _BUILD_d0f0(Data,vrr_stack+573, vrr_stack+62, vrr_stack+543, vrr_stack+52, vrr_stack+42, vrr_stack+123);
 _BUILD_d0f0(Data,vrr_stack+633, vrr_stack+513, vrr_stack+62, vrr_stack+92, vrr_stack+52, vrr_stack+141);
 _BUILD_f0f0(Data,vrr_stack+693, vrr_stack+633, vrr_stack+573, vrr_stack+513, vrr_stack+62, vrr_stack+159);
 _BUILD_00p0(Data,vrr_stack+27, Data->F+5, Data->F+6, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+12, vrr_stack+27, vrr_stack+18, Data->F+5, Data->F+6, NULL);
 _BUILD_00f0(Data,vrr_stack+123, vrr_stack+12, vrr_stack+21, vrr_stack+27, vrr_stack+18, NULL);
 _BUILD_p0f0(Data,vrr_stack+133, vrr_stack+123, vrr_stack+92, NULL, NULL, vrr_stack+21);
 _BUILD_d0f0(Data,vrr_stack+793, vrr_stack+133, vrr_stack+513, vrr_stack+123, vrr_stack+92, vrr_stack+195);
 _BUILD_f0f0(Data,vrr_stack+853, vrr_stack+793, vrr_stack+633, vrr_stack+133, vrr_stack+513, vrr_stack+213);
 _BUILD_00p0(Data,vrr_stack+18, Data->F+12, Data->F+13, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+163, vrr_stack+30, vrr_stack+18, Data->F+11, Data->F+12, NULL);
 _BUILD_00f0(Data,vrr_stack+169, vrr_stack+33, vrr_stack+163, vrr_stack+39, vrr_stack+30, NULL);
 _BUILD_p0f0(Data,vrr_stack+179, vrr_stack+102, vrr_stack+169, NULL, NULL, vrr_stack+33);
 _BUILD_d0f0(Data,vrr_stack+953, vrr_stack+543, vrr_stack+179, vrr_stack+42, vrr_stack+102, vrr_stack+249);
 _BUILD_f0f0(Data,vrr_stack+1013, vrr_stack+573, vrr_stack+953, vrr_stack+62, vrr_stack+543, vrr_stack+267);
 _BUILD_g0f0(Data,vrr_stack+1113, vrr_stack+693, vrr_stack+1013, vrr_stack+633, vrr_stack+573, vrr_stack+303);
 _BUILD_g0f0(Data,vrr_stack+209, vrr_stack+853, vrr_stack+693, vrr_stack+793, vrr_stack+633, vrr_stack+363);
 _BUILD_h0f0(Data,vrr_stack+1263, vrr_stack+209, vrr_stack+1113, vrr_stack+853, vrr_stack+693, vrr_stack+423);
 _BUILD_00g0(Data,vrr_stack+359, vrr_stack+52, vrr_stack+42, vrr_stack+6, vrr_stack+0, NULL);
 _BUILD_00g0(Data,vrr_stack+374, vrr_stack+92, vrr_stack+52, vrr_stack+21, vrr_stack+6, NULL);
 _BUILD_00g0(Data,vrr_stack+389, vrr_stack+42, vrr_stack+102, vrr_stack+0, vrr_stack+117, NULL);
 _BUILD_p0g0(Data,vrr_stack+404, vrr_stack+359, vrr_stack+389, NULL, NULL, vrr_stack+42);
 _BUILD_p0g0(Data,vrr_stack+449, vrr_stack+374, vrr_stack+359, NULL, NULL, vrr_stack+52);
 _BUILD_d0g0(Data,vrr_stack+1473, vrr_stack+449, vrr_stack+404, vrr_stack+374, vrr_stack+359, vrr_stack+62);
 _BUILD_00g0(Data,vrr_stack+62, vrr_stack+123, vrr_stack+92, vrr_stack+12, vrr_stack+21, NULL);
 _BUILD_p0g0(Data,vrr_stack+1563, vrr_stack+62, vrr_stack+374, NULL, NULL, vrr_stack+92);
 _BUILD_d0g0(Data,vrr_stack+1608, vrr_stack+1563, vrr_stack+449, vrr_stack+62, vrr_stack+374, vrr_stack+513);
 _BUILD_00g0(Data,vrr_stack+77, vrr_stack+102, vrr_stack+169, vrr_stack+117, vrr_stack+33, NULL);
 _BUILD_p0g0(Data,vrr_stack+494, vrr_stack+389, vrr_stack+77, NULL, NULL, vrr_stack+102);
 _BUILD_d0g0(Data,vrr_stack+1698, vrr_stack+404, vrr_stack+494, vrr_stack+359, vrr_stack+389, vrr_stack+543);
 _BUILD_f0g0(Data,vrr_stack+1788, vrr_stack+1473, vrr_stack+1698, vrr_stack+449, vrr_stack+404, vrr_stack+573);
 _BUILD_f0g0(Data,vrr_stack+1938, vrr_stack+1608, vrr_stack+1473, vrr_stack+1563, vrr_stack+449, vrr_stack+633);
 _BUILD_g0g0(Data,vrr_stack+2088, vrr_stack+1938, vrr_stack+1788, vrr_stack+1608, vrr_stack+1473, vrr_stack+693);
 _BUILD_00p0(Data,vrr_stack+39, Data->F+4, Data->F+5, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+21, vrr_stack+39, vrr_stack+27, Data->F+4, Data->F+5, NULL);
 _BUILD_00f0(Data,vrr_stack+0, vrr_stack+21, vrr_stack+12, vrr_stack+39, vrr_stack+27, NULL);
 _BUILD_00g0(Data,vrr_stack+539, vrr_stack+0, vrr_stack+123, vrr_stack+21, vrr_stack+12, NULL);
 _BUILD_p0g0(Data,vrr_stack+554, vrr_stack+539, vrr_stack+62, NULL, NULL, vrr_stack+123);
 _BUILD_d0g0(Data,vrr_stack+599, vrr_stack+554, vrr_stack+1563, vrr_stack+539, vrr_stack+62, vrr_stack+133);
 _BUILD_f0g0(Data,vrr_stack+2313, vrr_stack+599, vrr_stack+1608, vrr_stack+554, vrr_stack+1563, vrr_stack+793);
 _BUILD_g0g0(Data,vrr_stack+2463, vrr_stack+2313, vrr_stack+1938, vrr_stack+599, vrr_stack+1608, vrr_stack+853);
 _BUILD_00p0(Data,vrr_stack+27, Data->F+13, Data->F+14, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+133, vrr_stack+18, vrr_stack+27, Data->F+12, Data->F+13, NULL);
 _BUILD_00f0(Data,vrr_stack+139, vrr_stack+163, vrr_stack+133, vrr_stack+30, vrr_stack+18, NULL);
 _BUILD_00g0(Data,vrr_stack+689, vrr_stack+169, vrr_stack+139, vrr_stack+33, vrr_stack+163, NULL);
 _BUILD_p0g0(Data,vrr_stack+704, vrr_stack+77, vrr_stack+689, NULL, NULL, vrr_stack+169);
 _BUILD_d0g0(Data,vrr_stack+749, vrr_stack+494, vrr_stack+704, vrr_stack+389, vrr_stack+77, vrr_stack+179);
 _BUILD_f0g0(Data,vrr_stack+2688, vrr_stack+1698, vrr_stack+749, vrr_stack+404, vrr_stack+494, vrr_stack+953);
 _BUILD_g0g0(Data,vrr_stack+2838, vrr_stack+1788, vrr_stack+2688, vrr_stack+1473, vrr_stack+1698, vrr_stack+1013);
 _BUILD_h0g0(Data,vrr_stack+3063, vrr_stack+2088, vrr_stack+2838, vrr_stack+1938, vrr_stack+1788, vrr_stack+1113);
 _BUILD_h0g0(Data,vrr_stack+839, vrr_stack+2463, vrr_stack+2088, vrr_stack+2313, vrr_stack+1938, vrr_stack+209);
 _BUILD_i0g0(Data,vrr_stack+3378, vrr_stack+839, vrr_stack+3063, vrr_stack+2463, vrr_stack+2088, vrr_stack+1263);
 _BUILD_00h0(Data,vrr_stack+179, vrr_stack+359, vrr_stack+389, vrr_stack+52, vrr_stack+42, NULL);
 _BUILD_00h0(Data,vrr_stack+200, vrr_stack+374, vrr_stack+359, vrr_stack+92, vrr_stack+52, NULL);
 _BUILD_p0h0(Data,vrr_stack+221, vrr_stack+200, vrr_stack+179, NULL, NULL, vrr_stack+359);
 _BUILD_00h0(Data,vrr_stack+284, vrr_stack+62, vrr_stack+374, vrr_stack+123, vrr_stack+92, NULL);
 _BUILD_p0h0(Data,vrr_stack+1154, vrr_stack+284, vrr_stack+200, NULL, NULL, vrr_stack+374);
 _BUILD_00h0(Data,vrr_stack+305, vrr_stack+389, vrr_stack+77, vrr_stack+42, vrr_stack+102, NULL);
 _BUILD_p0h0(Data,vrr_stack+1217, vrr_stack+179, vrr_stack+305, NULL, NULL, vrr_stack+389);
 _BUILD_d0h0(Data,vrr_stack+1280, vrr_stack+221, vrr_stack+1217, vrr_stack+200, vrr_stack+179, vrr_stack+404);
 _BUILD_d0h0(Data,vrr_stack+3798, vrr_stack+1154, vrr_stack+221, vrr_stack+284, vrr_stack+200, vrr_stack+449);
 _BUILD_f0h0(Data,vrr_stack+3924, vrr_stack+3798, vrr_stack+1280, vrr_stack+1154, vrr_stack+221, vrr_stack+1473);
 _BUILD_00h0(Data,vrr_stack+404, vrr_stack+539, vrr_stack+62, vrr_stack+0, vrr_stack+123, NULL);
 _BUILD_p0h0(Data,vrr_stack+425, vrr_stack+404, vrr_stack+284, NULL, NULL, vrr_stack+62);
 _BUILD_d0h0(Data,vrr_stack+1406, vrr_stack+425, vrr_stack+1154, vrr_stack+404, vrr_stack+284, vrr_stack+1563);
 _BUILD_f0h0(Data,vrr_stack+4134, vrr_stack+1406, vrr_stack+3798, vrr_stack+425, vrr_stack+1154, vrr_stack+1608);
 _BUILD_00h0(Data,vrr_stack+112, vrr_stack+77, vrr_stack+689, vrr_stack+102, vrr_stack+169, NULL);
 _BUILD_p0h0(Data,vrr_stack+1532, vrr_stack+305, vrr_stack+112, NULL, NULL, vrr_stack+77);
 _BUILD_d0h0(Data,vrr_stack+4344, vrr_stack+1217, vrr_stack+1532, vrr_stack+179, vrr_stack+305, vrr_stack+494);
 _BUILD_f0h0(Data,vrr_stack+4470, vrr_stack+1280, vrr_stack+4344, vrr_stack+221, vrr_stack+1217, vrr_stack+1698);
 _BUILD_g0h0(Data,vrr_stack+4680, vrr_stack+3924, vrr_stack+4470, vrr_stack+3798, vrr_stack+1280, vrr_stack+1788);
 _BUILD_g0h0(Data,vrr_stack+1595, vrr_stack+4134, vrr_stack+3924, vrr_stack+1406, vrr_stack+3798, vrr_stack+1938);
 _BUILD_h0h0(Data,vrr_stack+4995, vrr_stack+1595, vrr_stack+4680, vrr_stack+4134, vrr_stack+3924, vrr_stack+2088);
 _BUILD_00p0(Data,vrr_stack+488, Data->F+3, Data->F+4, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+491, vrr_stack+488, vrr_stack+39, Data->F+3, Data->F+4, NULL);
 _BUILD_00f0(Data,vrr_stack+497, vrr_stack+491, vrr_stack+21, vrr_stack+488, vrr_stack+39, NULL);
 _BUILD_00g0(Data,vrr_stack+507, vrr_stack+497, vrr_stack+0, vrr_stack+491, vrr_stack+21, NULL);
 _BUILD_00h0(Data,vrr_stack+326, vrr_stack+507, vrr_stack+539, vrr_stack+497, vrr_stack+0, NULL);
 _BUILD_p0h0(Data,vrr_stack+1910, vrr_stack+326, vrr_stack+404, NULL, NULL, vrr_stack+539);
 _BUILD_d0h0(Data,vrr_stack+1973, vrr_stack+1910, vrr_stack+425, vrr_stack+326, vrr_stack+404, vrr_stack+554);
 _BUILD_f0h0(Data,vrr_stack+2099, vrr_stack+1973, vrr_stack+1406, vrr_stack+1910, vrr_stack+425, vrr_stack+599);
 _BUILD_g0h0(Data,vrr_stack+5436, vrr_stack+2099, vrr_stack+4134, vrr_stack+1973, vrr_stack+1406, vrr_stack+2313);
 _BUILD_h0h0(Data,vrr_stack+5751, vrr_stack+5436, vrr_stack+1595, vrr_stack+2099, vrr_stack+4134, vrr_stack+2463);
 _BUILD_00p0(Data,vrr_stack+554, Data->F+14, Data->F+15, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+21, vrr_stack+27, vrr_stack+554, Data->F+13, Data->F+14, NULL);
 _BUILD_00f0(Data,vrr_stack+557, vrr_stack+133, vrr_stack+21, vrr_stack+18, vrr_stack+27, NULL);
 _BUILD_00g0(Data,vrr_stack+567, vrr_stack+139, vrr_stack+557, vrr_stack+163, vrr_stack+133, NULL);
 _BUILD_00h0(Data,vrr_stack+0, vrr_stack+689, vrr_stack+567, vrr_stack+169, vrr_stack+139, NULL);
 _BUILD_p0h0(Data,vrr_stack+582, vrr_stack+112, vrr_stack+0, NULL, NULL, vrr_stack+689);
 _BUILD_d0h0(Data,vrr_stack+2309, vrr_stack+1532, vrr_stack+582, vrr_stack+305, vrr_stack+112, vrr_stack+704);
 _BUILD_f0h0(Data,vrr_stack+2435, vrr_stack+4344, vrr_stack+2309, vrr_stack+1217, vrr_stack+1532, vrr_stack+749);
 _BUILD_g0h0(Data,vrr_stack+6192, vrr_stack+4470, vrr_stack+2435, vrr_stack+1280, vrr_stack+4344, vrr_stack+2688);
 _BUILD_h0h0(Data,vrr_stack+6507, vrr_stack+4680, vrr_stack+6192, vrr_stack+3924, vrr_stack+4470, vrr_stack+2838);
 _BUILD_i0h0(Data,vrr_stack+6948, vrr_stack+4995, vrr_stack+6507, vrr_stack+1595, vrr_stack+4680, vrr_stack+3063);
 _BUILD_i0h0(Data,vrr_stack+2645, vrr_stack+5751, vrr_stack+4995, vrr_stack+5436, vrr_stack+1595, vrr_stack+839);
 _BUILD_k0h0(Data,vrr_stack+7536, vrr_stack+2645, vrr_stack+6948, vrr_stack+5751, vrr_stack+4995, vrr_stack+3378);
 _BUILD_00i0(Data,vrr_stack+704, vrr_stack+200, vrr_stack+179, vrr_stack+374, vrr_stack+359, NULL);
 _BUILD_00i0(Data,vrr_stack+732, vrr_stack+284, vrr_stack+200, vrr_stack+62, vrr_stack+374, NULL);
 _BUILD_00i0(Data,vrr_stack+760, vrr_stack+179, vrr_stack+305, vrr_stack+359, vrr_stack+389, NULL);
 _BUILD_p0i0(Data,vrr_stack+788, vrr_stack+704, vrr_stack+760, NULL, NULL, vrr_stack+179);
 _BUILD_p0i0(Data,vrr_stack+872, vrr_stack+732, vrr_stack+704, NULL, NULL, vrr_stack+200);
 _BUILD_d0i0(Data,vrr_stack+956, vrr_stack+872, vrr_stack+788, vrr_stack+732, vrr_stack+704, vrr_stack+221);
 _BUILD_00i0(Data,vrr_stack+221, vrr_stack+404, vrr_stack+284, vrr_stack+539, vrr_stack+62, NULL);
 _BUILD_p0i0(Data,vrr_stack+3233, vrr_stack+221, vrr_stack+732, NULL, NULL, vrr_stack+284);
 _BUILD_d0i0(Data,vrr_stack+3317, vrr_stack+3233, vrr_stack+872, vrr_stack+221, vrr_stack+732, vrr_stack+1154);
 _BUILD_00i0(Data,vrr_stack+249, vrr_stack+305, vrr_stack+112, vrr_stack+389, vrr_stack+77, NULL);
 _BUILD_p0i0(Data,vrr_stack+1124, vrr_stack+760, vrr_stack+249, NULL, NULL, vrr_stack+305);
 _BUILD_d0i0(Data,vrr_stack+3485, vrr_stack+788, vrr_stack+1124, vrr_stack+704, vrr_stack+760, vrr_stack+1217);
 _BUILD_f0i0(Data,vrr_stack+8292, vrr_stack+956, vrr_stack+3485, vrr_stack+872, vrr_stack+788, vrr_stack+1280);
 _BUILD_f0i0(Data,vrr_stack+8572, vrr_stack+3317, vrr_stack+956, vrr_stack+3233, vrr_stack+872, vrr_stack+3798);
 _BUILD_g0i0(Data,vrr_stack+8852, vrr_stack+8572, vrr_stack+8292, vrr_stack+3317, vrr_stack+956, vrr_stack+3924);
 _BUILD_00i0(Data,vrr_stack+1208, vrr_stack+326, vrr_stack+404, vrr_stack+507, vrr_stack+539, NULL);
 _BUILD_p0i0(Data,vrr_stack+1236, vrr_stack+1208, vrr_stack+221, NULL, NULL, vrr_stack+404);
 _BUILD_d0i0(Data,vrr_stack+3653, vrr_stack+1236, vrr_stack+3233, vrr_stack+1208, vrr_stack+221, vrr_stack+425);
 _BUILD_f0i0(Data,vrr_stack+3821, vrr_stack+3653, vrr_stack+3317, vrr_stack+1236, vrr_stack+3233, vrr_stack+1406);
 _BUILD_g0i0(Data,vrr_stack+9272, vrr_stack+3821, vrr_stack+8572, vrr_stack+3653, vrr_stack+3317, vrr_stack+4134);
 _BUILD_00i0(Data,vrr_stack+425, vrr_stack+112, vrr_stack+0, vrr_stack+77, vrr_stack+689, NULL);
 _BUILD_p0i0(Data,vrr_stack+1320, vrr_stack+249, vrr_stack+425, NULL, NULL, vrr_stack+112);
 _BUILD_d0i0(Data,vrr_stack+4101, vrr_stack+1124, vrr_stack+1320, vrr_stack+760, vrr_stack+249, vrr_stack+1532);
 _BUILD_f0i0(Data,vrr_stack+9692, vrr_stack+3485, vrr_stack+4101, vrr_stack+788, vrr_stack+1124, vrr_stack+4344);
 _BUILD_g0i0(Data,vrr_stack+9972, vrr_stack+8292, vrr_stack+9692, vrr_stack+956, vrr_stack+3485, vrr_stack+4470);
 _BUILD_h0i0(Data,vrr_stack+10392, vrr_stack+8852, vrr_stack+9972, vrr_stack+8572, vrr_stack+8292, vrr_stack+4680);
 _BUILD_h0i0(Data,vrr_stack+4269, vrr_stack+9272, vrr_stack+8852, vrr_stack+3821, vrr_stack+8572, vrr_stack+1595);
 _BUILD_i0i0(Data,vrr_stack+10980, vrr_stack+4269, vrr_stack+10392, vrr_stack+9272, vrr_stack+8852, vrr_stack+4995);
 _BUILD_00p0(Data,vrr_stack+453, Data->F+2, Data->F+3, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+456, vrr_stack+453, vrr_stack+488, Data->F+2, Data->F+3, NULL);
 _BUILD_00f0(Data,vrr_stack+462, vrr_stack+456, vrr_stack+491, vrr_stack+453, vrr_stack+488, NULL);
 _BUILD_00g0(Data,vrr_stack+472, vrr_stack+462, vrr_stack+497, vrr_stack+456, vrr_stack+491, NULL);
 _BUILD_00h0(Data,vrr_stack+1404, vrr_stack+472, vrr_stack+507, vrr_stack+462, vrr_stack+497, NULL);
 _BUILD_00i0(Data,vrr_stack+1425, vrr_stack+1404, vrr_stack+326, vrr_stack+472, vrr_stack+507, NULL);
 _BUILD_p0i0(Data,vrr_stack+1453, vrr_stack+1425, vrr_stack+1208, NULL, NULL, vrr_stack+326);
 _BUILD_d0i0(Data,vrr_stack+1537, vrr_stack+1453, vrr_stack+1236, vrr_stack+1425, vrr_stack+1208, vrr_stack+1910);
 _BUILD_f0i0(Data,vrr_stack+4857, vrr_stack+1537, vrr_stack+3653, vrr_stack+1453, vrr_stack+1236, vrr_stack+1973);
 _BUILD_g0i0(Data,vrr_stack+11764, vrr_stack+4857, vrr_stack+3821, vrr_stack+1537, vrr_stack+3653, vrr_stack+2099);
 _BUILD_h0i0(Data,vrr_stack+1705, vrr_stack+11764, vrr_stack+9272, vrr_stack+4857, vrr_stack+3821, vrr_stack+5436);
 _BUILD_i0i0(Data,vrr_stack+12184, vrr_stack+1705, vrr_stack+4269, vrr_stack+11764, vrr_stack+9272, vrr_stack+5751);
 _BUILD_00p0(Data,vrr_stack+487, Data->F+15, Data->F+16, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+490, vrr_stack+554, vrr_stack+487, Data->F+14, Data->F+15, NULL);
 _BUILD_00f0(Data,vrr_stack+496, vrr_stack+21, vrr_stack+490, vrr_stack+27, vrr_stack+554, NULL);
 _BUILD_00g0(Data,vrr_stack+27, vrr_stack+557, vrr_stack+496, vrr_stack+133, vrr_stack+21, NULL);
 _BUILD_00h0(Data,vrr_stack+42, vrr_stack+567, vrr_stack+27, vrr_stack+139, vrr_stack+557, NULL);
 _BUILD_00i0(Data,vrr_stack+133, vrr_stack+0, vrr_stack+42, vrr_stack+689, vrr_stack+567, NULL);
 _BUILD_p0i0(Data,vrr_stack+5137, vrr_stack+425, vrr_stack+133, NULL, NULL, vrr_stack+0);
 _BUILD_d0i0(Data,vrr_stack+5221, vrr_stack+1320, vrr_stack+5137, vrr_stack+249, vrr_stack+425, vrr_stack+582);
 _BUILD_f0i0(Data,vrr_stack+5389, vrr_stack+4101, vrr_stack+5221, vrr_stack+1124, vrr_stack+1320, vrr_stack+2309);
 _BUILD_g0i0(Data,vrr_stack+5669, vrr_stack+9692, vrr_stack+5389, vrr_stack+3485, vrr_stack+4101, vrr_stack+2435);
 _BUILD_h0i0(Data,vrr_stack+12968, vrr_stack+9972, vrr_stack+5669, vrr_stack+8292, vrr_stack+9692, vrr_stack+6192);
 _BUILD_i0i0(Data,vrr_stack+13556, vrr_stack+10392, vrr_stack+12968, vrr_stack+8852, vrr_stack+9972, vrr_stack+6507);
 _BUILD_k0i0(Data,vrr_stack+14340, vrr_stack+10980, vrr_stack+13556, vrr_stack+4269, vrr_stack+10392, vrr_stack+6948);
 _BUILD_k0i0(Data,vrr_stack+6089, vrr_stack+12184, vrr_stack+10980, vrr_stack+1705, vrr_stack+4269, vrr_stack+2645);
 _BUILD_l0i0(Data,vrr_stack+15348, vrr_stack+6089, vrr_stack+14340, vrr_stack+12184, vrr_stack+10980, vrr_stack+7536);
 _BUILD_00k0(Data,vrr_stack+582, vrr_stack+704, vrr_stack+760, vrr_stack+200, vrr_stack+179, NULL);
 _BUILD_00k0(Data,vrr_stack+618, vrr_stack+732, vrr_stack+704, vrr_stack+284, vrr_stack+200, NULL);
 _BUILD_p0k0(Data,vrr_stack+2293, vrr_stack+618, vrr_stack+582, NULL, NULL, vrr_stack+704);
 _BUILD_00k0(Data,vrr_stack+654, vrr_stack+221, vrr_stack+732, vrr_stack+404, vrr_stack+284, NULL);
 _BUILD_p0k0(Data,vrr_stack+2401, vrr_stack+654, vrr_stack+618, NULL, NULL, vrr_stack+732);
 _BUILD_00k0(Data,vrr_stack+63, vrr_stack+760, vrr_stack+249, vrr_stack+179, vrr_stack+305, NULL);
 _BUILD_p0k0(Data,vrr_stack+2509, vrr_stack+582, vrr_stack+63, NULL, NULL, vrr_stack+760);
 _BUILD_d0k0(Data,vrr_stack+2617, vrr_stack+2293, vrr_stack+2509, vrr_stack+618, vrr_stack+582, vrr_stack+788);
 _BUILD_d0k0(Data,vrr_stack+2833, vrr_stack+2401, vrr_stack+2293, vrr_stack+654, vrr_stack+618, vrr_stack+872);
 _BUILD_f0k0(Data,vrr_stack+7097, vrr_stack+2833, vrr_stack+2617, vrr_stack+2401, vrr_stack+2293, vrr_stack+956);
 _BUILD_00k0(Data,vrr_stack+788, vrr_stack+1208, vrr_stack+221, vrr_stack+326, vrr_stack+404, NULL);
 _BUILD_p0k0(Data,vrr_stack+824, vrr_stack+788, vrr_stack+654, NULL, NULL, vrr_stack+221);
 _BUILD_d0k0(Data,vrr_stack+7457, vrr_stack+824, vrr_stack+2401, vrr_stack+788, vrr_stack+654, vrr_stack+3233);
 _BUILD_f0k0(Data,vrr_stack+7673, vrr_stack+7457, vrr_stack+2833, vrr_stack+824, vrr_stack+2401, vrr_stack+3317);
 _BUILD_00k0(Data,vrr_stack+932, vrr_stack+249, vrr_stack+425, vrr_stack+305, vrr_stack+112, NULL);
 _BUILD_p0k0(Data,vrr_stack+968, vrr_stack+63, vrr_stack+932, NULL, NULL, vrr_stack+249);
 _BUILD_d0k0(Data,vrr_stack+3049, vrr_stack+2509, vrr_stack+968, vrr_stack+582, vrr_stack+63, vrr_stack+1124);
 _BUILD_f0k0(Data,vrr_stack+16608, vrr_stack+2617, vrr_stack+3049, vrr_stack+2293, vrr_stack+2509, vrr_stack+3485);
 _BUILD_g0k0(Data,vrr_stack+16968, vrr_stack+7097, vrr_stack+16608, vrr_stack+2833, vrr_stack+2617, vrr_stack+8292);
 _BUILD_g0k0(Data,vrr_stack+17508, vrr_stack+7673, vrr_stack+7097, vrr_stack+7457, vrr_stack+2833, vrr_stack+8572);
 _BUILD_h0k0(Data,vrr_stack+8033, vrr_stack+17508, vrr_stack+16968, vrr_stack+7673, vrr_stack+7097, vrr_stack+8852);
 _BUILD_00k0(Data,vrr_stack+1076, vrr_stack+1425, vrr_stack+1208, vrr_stack+1404, vrr_stack+326, NULL);
 _BUILD_p0k0(Data,vrr_stack+277, vrr_stack+1076, vrr_stack+788, NULL, NULL, vrr_stack+1208);
 _BUILD_d0k0(Data,vrr_stack+3265, vrr_stack+277, vrr_stack+824, vrr_stack+1076, vrr_stack+788, vrr_stack+1236);
 _BUILD_f0k0(Data,vrr_stack+8789, vrr_stack+3265, vrr_stack+7457, vrr_stack+277, vrr_stack+824, vrr_stack+3653);
 _BUILD_g0k0(Data,vrr_stack+18048, vrr_stack+8789, vrr_stack+7673, vrr_stack+3265, vrr_stack+7457, vrr_stack+3821);
 _BUILD_h0k0(Data,vrr_stack+18588, vrr_stack+18048, vrr_stack+17508, vrr_stack+8789, vrr_stack+7673, vrr_stack+9272);
 _BUILD_00k0(Data,vrr_stack+1236, vrr_stack+425, vrr_stack+133, vrr_stack+112, vrr_stack+0, NULL);
 _BUILD_p0k0(Data,vrr_stack+3481, vrr_stack+932, vrr_stack+1236, NULL, NULL, vrr_stack+425);
 _BUILD_d0k0(Data,vrr_stack+3589, vrr_stack+968, vrr_stack+3481, vrr_stack+63, vrr_stack+932, vrr_stack+1320);
 _BUILD_f0k0(Data,vrr_stack+9149, vrr_stack+3049, vrr_stack+3589, vrr_stack+2509, vrr_stack+968, vrr_stack+4101);
 _BUILD_g0k0(Data,vrr_stack+19344, vrr_stack+16608, vrr_stack+9149, vrr_stack+2617, vrr_stack+3049, vrr_stack+9692);
 _BUILD_h0k0(Data,vrr_stack+19884, vrr_stack+16968, vrr_stack+19344, vrr_stack+7097, vrr_stack+16608, vrr_stack+9972);
 _BUILD_i0k0(Data,vrr_stack+20640, vrr_stack+8033, vrr_stack+19884, vrr_stack+17508, vrr_stack+16968, vrr_stack+10392);
 _BUILD_i0k0(Data,vrr_stack+9509, vrr_stack+18588, vrr_stack+8033, vrr_stack+18048, vrr_stack+17508, vrr_stack+4269);
 _BUILD_k0k0(Data,vrr_stack+21648, vrr_stack+9509, vrr_stack+20640, vrr_stack+18588, vrr_stack+8033, vrr_stack+10980);
 _BUILD_00p0(Data,vrr_stack+1272, Data->F+1, Data->F+2, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+1275, vrr_stack+1272, vrr_stack+453, Data->F+1, Data->F+2, NULL);
 _BUILD_00f0(Data,vrr_stack+1281, vrr_stack+1275, vrr_stack+456, vrr_stack+1272, vrr_stack+453, NULL);
 _BUILD_00g0(Data,vrr_stack+1291, vrr_stack+1281, vrr_stack+462, vrr_stack+1275, vrr_stack+456, NULL);
 _BUILD_00h0(Data,vrr_stack+1306, vrr_stack+1291, vrr_stack+472, vrr_stack+1281, vrr_stack+462, NULL);
 _BUILD_00i0(Data,vrr_stack+1327, vrr_stack+1306, vrr_stack+1404, vrr_stack+1291, vrr_stack+472, NULL);
 _BUILD_00k0(Data,vrr_stack+1355, vrr_stack+1327, vrr_stack+1425, vrr_stack+1306, vrr_stack+1404, NULL);
 _BUILD_p0k0(Data,vrr_stack+3805, vrr_stack+1355, vrr_stack+1076, NULL, NULL, vrr_stack+1425);
 _BUILD_d0k0(Data,vrr_stack+3913, vrr_stack+3805, vrr_stack+277, vrr_stack+1355, vrr_stack+1076, vrr_stack+1453);
 _BUILD_f0k0(Data,vrr_stack+4129, vrr_stack+3913, vrr_stack+3265, vrr_stack+3805, vrr_stack+277, vrr_stack+1537);
 _BUILD_g0k0(Data,vrr_stack+10517, vrr_stack+4129, vrr_stack+8789, vrr_stack+3913, vrr_stack+3265, vrr_stack+4857);
 _BUILD_h0k0(Data,vrr_stack+22944, vrr_stack+10517, vrr_stack+18048, vrr_stack+4129, vrr_stack+8789, vrr_stack+11764);
 _BUILD_i0k0(Data,vrr_stack+11057, vrr_stack+22944, vrr_stack+18588, vrr_stack+10517, vrr_stack+18048, vrr_stack+1705);
 _BUILD_k0k0(Data,vrr_stack+23700, vrr_stack+11057, vrr_stack+9509, vrr_stack+22944, vrr_stack+18588, vrr_stack+12184);
 _BUILD_00p0(Data,vrr_stack+1453, Data->F+16, Data->F+17, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+1456, vrr_stack+487, vrr_stack+1453, Data->F+15, Data->F+16, NULL);
 _BUILD_00f0(Data,vrr_stack+1462, vrr_stack+490, vrr_stack+1456, vrr_stack+554, vrr_stack+487, NULL);
 _BUILD_00g0(Data,vrr_stack+1472, vrr_stack+496, vrr_stack+1462, vrr_stack+21, vrr_stack+490, NULL);
 _BUILD_00h0(Data,vrr_stack+1487, vrr_stack+27, vrr_stack+1472, vrr_stack+557, vrr_stack+496, NULL);
 _BUILD_00i0(Data,vrr_stack+1508, vrr_stack+42, vrr_stack+1487, vrr_stack+567, vrr_stack+27, NULL);
 _BUILD_00k0(Data,vrr_stack+1536, vrr_stack+133, vrr_stack+1508, vrr_stack+0, vrr_stack+42, NULL);
 _BUILD_p0k0(Data,vrr_stack+1572, vrr_stack+1236, vrr_stack+1536, NULL, NULL, vrr_stack+133);
 _BUILD_d0k0(Data,vrr_stack+1680, vrr_stack+3481, vrr_stack+1572, vrr_stack+932, vrr_stack+1236, vrr_stack+5137);
 _BUILD_f0k0(Data,vrr_stack+1896, vrr_stack+3589, vrr_stack+1680, vrr_stack+968, vrr_stack+3481, vrr_stack+5221);
 _BUILD_g0k0(Data,vrr_stack+4489, vrr_stack+9149, vrr_stack+1896, vrr_stack+3049, vrr_stack+3589, vrr_stack+5389);
 _BUILD_h0k0(Data,vrr_stack+12065, vrr_stack+19344, vrr_stack+4489, vrr_stack+16608, vrr_stack+9149, vrr_stack+5669);
 _BUILD_i0k0(Data,vrr_stack+5029, vrr_stack+19884, vrr_stack+12065, vrr_stack+16968, vrr_stack+19344, vrr_stack+12968);
 _BUILD_k0k0(Data,vrr_stack+24996, vrr_stack+20640, vrr_stack+5029, vrr_stack+8033, vrr_stack+19884, vrr_stack+13556);
 _BUILD_l0k0(Data,vrr_stack+26292, vrr_stack+21648, vrr_stack+24996, vrr_stack+9509, vrr_stack+20640, vrr_stack+14340);
 _BUILD_l0k0(Data,vrr_stack+12821, vrr_stack+23700, vrr_stack+21648, vrr_stack+11057, vrr_stack+9509, vrr_stack+6089);
 _BUILD_m0k0(Data,vrr_stack+27912, vrr_stack+12821, vrr_stack+26292, vrr_stack+23700, vrr_stack+21648, vrr_stack+15348);
 _BUILD_00l0(Data,vrr_stack+1112, vrr_stack+618, vrr_stack+582, vrr_stack+732, vrr_stack+704, NULL);
 _BUILD_00l0(Data,vrr_stack+1157, vrr_stack+654, vrr_stack+618, vrr_stack+221, vrr_stack+732, NULL);
 _BUILD_00l0(Data,vrr_stack+161, vrr_stack+582, vrr_stack+63, vrr_stack+704, vrr_stack+760, NULL);
 _BUILD_p0l0(Data,vrr_stack+6037, vrr_stack+1112, vrr_stack+161, NULL, NULL, vrr_stack+582);
 _BUILD_p0l0(Data,vrr_stack+6172, vrr_stack+1157, vrr_stack+1112, NULL, NULL, vrr_stack+618);
 _BUILD_d0l0(Data,vrr_stack+6307, vrr_stack+6172, vrr_stack+6037, vrr_stack+1157, vrr_stack+1112, vrr_stack+2293);
 _BUILD_00l0(Data,vrr_stack+2256, vrr_stack+788, vrr_stack+654, vrr_stack+1208, vrr_stack+221, NULL);
 _BUILD_p0l0(Data,vrr_stack+6577, vrr_stack+2256, vrr_stack+1157, NULL, NULL, vrr_stack+654);
 _BUILD_d0l0(Data,vrr_stack+6712, vrr_stack+6577, vrr_stack+6172, vrr_stack+2256, vrr_stack+1157, vrr_stack+2401);
 _BUILD_00l0(Data,vrr_stack+2301, vrr_stack+63, vrr_stack+932, vrr_stack+760, vrr_stack+249, NULL);
 _BUILD_p0l0(Data,vrr_stack+2346, vrr_stack+161, vrr_stack+2301, NULL, NULL, vrr_stack+63);
 _BUILD_d0l0(Data,vrr_stack+14441, vrr_stack+6037, vrr_stack+2346, vrr_stack+1112, vrr_stack+161, vrr_stack+2509);
 _BUILD_f0l0(Data,vrr_stack+14711, vrr_stack+6307, vrr_stack+14441, vrr_stack+6172, vrr_stack+6037, vrr_stack+2617);
 _BUILD_f0l0(Data,vrr_stack+15161, vrr_stack+6712, vrr_stack+6307, vrr_stack+6577, vrr_stack+6172, vrr_stack+2833);
 _BUILD_g0l0(Data,vrr_stack+15611, vrr_stack+15161, vrr_stack+14711, vrr_stack+6712, vrr_stack+6307, vrr_stack+7097);
 _BUILD_00l0(Data,vrr_stack+2481, vrr_stack+1076, vrr_stack+788, vrr_stack+1425, vrr_stack+1208, NULL);
 _BUILD_p0l0(Data,vrr_stack+2526, vrr_stack+2481, vrr_stack+2256, NULL, NULL, vrr_stack+788);
 _BUILD_d0l0(Data,vrr_stack+2661, vrr_stack+2526, vrr_stack+6577, vrr_stack+2481, vrr_stack+2256, vrr_stack+824);
 _BUILD_f0l0(Data,vrr_stack+6982, vrr_stack+2661, vrr_stack+6712, vrr_stack+2526, vrr_stack+6577, vrr_stack+7457);
 _BUILD_g0l0(Data,vrr_stack+29892, vrr_stack+6982, vrr_stack+15161, vrr_stack+2661, vrr_stack+6712, vrr_stack+7673);
 _BUILD_00l0(Data,vrr_stack+824, vrr_stack+932, vrr_stack+1236, vrr_stack+249, vrr_stack+425, NULL);
 _BUILD_p0l0(Data,vrr_stack+7432, vrr_stack+2301, vrr_stack+824, NULL, NULL, vrr_stack+932);
 _BUILD_d0l0(Data,vrr_stack+7567, vrr_stack+2346, vrr_stack+7432, vrr_stack+161, vrr_stack+2301, vrr_stack+968);
 _BUILD_f0l0(Data,vrr_stack+30567, vrr_stack+14441, vrr_stack+7567, vrr_stack+6037, vrr_stack+2346, vrr_stack+3049);
 _BUILD_g0l0(Data,vrr_stack+31017, vrr_stack+14711, vrr_stack+30567, vrr_stack+6307, vrr_stack+14441, vrr_stack+16608);
 _BUILD_h0l0(Data,vrr_stack+31692, vrr_stack+15611, vrr_stack+31017, vrr_stack+15161, vrr_stack+14711, vrr_stack+16968);
 _BUILD_h0l0(Data,vrr_stack+16286, vrr_stack+29892, vrr_stack+15611, vrr_stack+6982, vrr_stack+15161, vrr_stack+17508);
 _BUILD_i0l0(Data,vrr_stack+32637, vrr_stack+16286, vrr_stack+31692, vrr_stack+29892, vrr_stack+15611, vrr_stack+8033);
 _BUILD_00l0(Data,vrr_stack+968, vrr_stack+1355, vrr_stack+1076, vrr_stack+1327, vrr_stack+1425, NULL);
 _BUILD_p0l0(Data,vrr_stack+2931, vrr_stack+968, vrr_stack+2481, NULL, NULL, vrr_stack+1076);
 _BUILD_d0l0(Data,vrr_stack+7837, vrr_stack+2931, vrr_stack+2526, vrr_stack+968, vrr_stack+2481, vrr_stack+277);
 _BUILD_f0l0(Data,vrr_stack+8107, vrr_stack+7837, vrr_stack+2661, vrr_stack+2931, vrr_stack+2526, vrr_stack+3265);
 _BUILD_g0l0(Data,vrr_stack+17231, vrr_stack+8107, vrr_stack+6982, vrr_stack+7837, vrr_stack+2661, vrr_stack+8789);
 _BUILD_h0l0(Data,vrr_stack+33897, vrr_stack+17231, vrr_stack+29892, vrr_stack+8107, vrr_stack+6982, vrr_stack+18048);
 _BUILD_i0l0(Data,vrr_stack+34842, vrr_stack+33897, vrr_stack+16286, vrr_stack+17231, vrr_stack+29892, vrr_stack+18588);
 _BUILD_00l0(Data,vrr_stack+1013, vrr_stack+1236, vrr_stack+1536, vrr_stack+425, vrr_stack+133, NULL);
 _BUILD_p0l0(Data,vrr_stack+3066, vrr_stack+824, vrr_stack+1013, NULL, NULL, vrr_stack+1236);
 _BUILD_d0l0(Data,vrr_stack+3201, vrr_stack+7432, vrr_stack+3066, vrr_stack+2301, vrr_stack+824, vrr_stack+3481);
 _BUILD_f0l0(Data,vrr_stack+8557, vrr_stack+7567, vrr_stack+3201, vrr_stack+2346, vrr_stack+7432, vrr_stack+3589);
 _BUILD_g0l0(Data,vrr_stack+17906, vrr_stack+30567, vrr_stack+8557, vrr_stack+14441, vrr_stack+7567, vrr_stack+9149);
 _BUILD_h0l0(Data,vrr_stack+36102, vrr_stack+31017, vrr_stack+17906, vrr_stack+14711, vrr_stack+30567, vrr_stack+19344);
 _BUILD_i0l0(Data,vrr_stack+18581, vrr_stack+31692, vrr_stack+36102, vrr_stack+15611, vrr_stack+31017, vrr_stack+19884);
 _BUILD_k0l0(Data,vrr_stack+37047, vrr_stack+32637, vrr_stack+18581, vrr_stack+16286, vrr_stack+31692, vrr_stack+20640);
 _BUILD_k0l0(Data,vrr_stack+19841, vrr_stack+34842, vrr_stack+32637, vrr_stack+33897, vrr_stack+16286, vrr_stack+9509);
 _BUILD_l0l0(Data,vrr_stack+38667, vrr_stack+19841, vrr_stack+37047, vrr_stack+34842, vrr_stack+32637, vrr_stack+21648);
 _BUILD_00p0(Data,vrr_stack+1058, Data->F+0, Data->F+1, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+1061, vrr_stack+1058, vrr_stack+1272, Data->F+0, Data->F+1, NULL);
 _BUILD_00f0(Data,vrr_stack+869, vrr_stack+1061, vrr_stack+1275, vrr_stack+1058, vrr_stack+1272, NULL);
 _BUILD_00g0(Data,vrr_stack+879, vrr_stack+869, vrr_stack+1281, vrr_stack+1061, vrr_stack+1275, NULL);
 _BUILD_00h0(Data,vrr_stack+894, vrr_stack+879, vrr_stack+1291, vrr_stack+869, vrr_stack+1281, NULL);
 _BUILD_00i0(Data,vrr_stack+3471, vrr_stack+894, vrr_stack+1306, vrr_stack+879, vrr_stack+1291, NULL);
 _BUILD_00k0(Data,vrr_stack+3499, vrr_stack+3471, vrr_stack+1327, vrr_stack+894, vrr_stack+1306, NULL);
 _BUILD_00l0(Data,vrr_stack+869, vrr_stack+3499, vrr_stack+1355, vrr_stack+3471, vrr_stack+1327, NULL);
 _BUILD_p0l0(Data,vrr_stack+3535, vrr_stack+869, vrr_stack+968, NULL, NULL, vrr_stack+1355);
 _BUILD_d0l0(Data,vrr_stack+206, vrr_stack+3535, vrr_stack+2931, vrr_stack+869, vrr_stack+968, vrr_stack+3805);
 _BUILD_f0l0(Data,vrr_stack+9007, vrr_stack+206, vrr_stack+7837, vrr_stack+3535, vrr_stack+2931, vrr_stack+3913);
 _BUILD_g0l0(Data,vrr_stack+9457, vrr_stack+9007, vrr_stack+8107, vrr_stack+206, vrr_stack+7837, vrr_stack+4129);
 _BUILD_h0l0(Data,vrr_stack+3535, vrr_stack+9457, vrr_stack+17231, vrr_stack+9007, vrr_stack+8107, vrr_stack+10517);
 _BUILD_i0l0(Data,vrr_stack+21461, vrr_stack+3535, vrr_stack+33897, vrr_stack+9457, vrr_stack+17231, vrr_stack+22944);
 _BUILD_k0l0(Data,vrr_stack+9007, vrr_stack+21461, vrr_stack+34842, vrr_stack+3535, vrr_stack+33897, vrr_stack+11057);
   tmp = vrr_stack + 9007;
   target_ptr = Libint->vrr_classes[7][8];
   for(i=0;i<1620;i++)
     target_ptr[i] += tmp[i];
 _BUILD_l0l0(Data,vrr_stack+40692, vrr_stack+9007, vrr_stack+19841, vrr_stack+21461, vrr_stack+34842, vrr_stack+23700);
   tmp = vrr_stack + 40692;
   target_ptr = Libint->vrr_classes[8][8];
   for(i=0;i<2025;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00p0(Data,vrr_stack+21461, Data->F+17, Data->F+18, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+21464, vrr_stack+1453, vrr_stack+21461, Data->F+16, Data->F+17, NULL);
 _BUILD_00f0(Data,vrr_stack+21470, vrr_stack+1456, vrr_stack+21464, vrr_stack+487, vrr_stack+1453, NULL);
 _BUILD_00g0(Data,vrr_stack+21480, vrr_stack+1462, vrr_stack+21470, vrr_stack+490, vrr_stack+1456, NULL);
 _BUILD_00h0(Data,vrr_stack+21495, vrr_stack+1472, vrr_stack+21480, vrr_stack+496, vrr_stack+1462, NULL);
 _BUILD_00i0(Data,vrr_stack+3471, vrr_stack+1487, vrr_stack+21495, vrr_stack+27, vrr_stack+1472, NULL);
 _BUILD_00k0(Data,vrr_stack+21516, vrr_stack+1508, vrr_stack+3471, vrr_stack+42, vrr_stack+1487, NULL);
 _BUILD_00l0(Data,vrr_stack+21552, vrr_stack+1536, vrr_stack+21516, vrr_stack+133, vrr_stack+1508, NULL);
 _BUILD_p0l0(Data,vrr_stack+21597, vrr_stack+1013, vrr_stack+21552, NULL, NULL, vrr_stack+1536);
 _BUILD_d0l0(Data,vrr_stack+21732, vrr_stack+3066, vrr_stack+21597, vrr_stack+824, vrr_stack+1013, vrr_stack+1572);
 _BUILD_f0l0(Data,vrr_stack+22002, vrr_stack+3201, vrr_stack+21732, vrr_stack+7432, vrr_stack+3066, vrr_stack+1680);
 _BUILD_g0l0(Data,vrr_stack+22452, vrr_stack+8557, vrr_stack+22002, vrr_stack+7567, vrr_stack+3201, vrr_stack+1896);
 _BUILD_h0l0(Data,vrr_stack+23127, vrr_stack+17906, vrr_stack+22452, vrr_stack+30567, vrr_stack+8557, vrr_stack+4489);
 _BUILD_i0l0(Data,vrr_stack+3535, vrr_stack+36102, vrr_stack+23127, vrr_stack+31017, vrr_stack+17906, vrr_stack+12065);
 _BUILD_k0l0(Data,vrr_stack+10627, vrr_stack+18581, vrr_stack+3535, vrr_stack+31692, vrr_stack+36102, vrr_stack+5029);
 _BUILD_l0l0(Data,vrr_stack+42717, vrr_stack+37047, vrr_stack+10627, vrr_stack+32637, vrr_stack+18581, vrr_stack+24996);
 _BUILD_m0l0(Data,vrr_stack+44742, vrr_stack+38667, vrr_stack+42717, vrr_stack+19841, vrr_stack+37047, vrr_stack+26292);
 _BUILD_m0l0(Data,vrr_stack+24072, vrr_stack+40692, vrr_stack+38667, vrr_stack+9007, vrr_stack+19841, vrr_stack+12821);
   tmp = vrr_stack + 24072;
   target_ptr = Libint->vrr_classes[9][8];
   for(i=0;i<2475;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00m0(Data,vrr_stack+9007, vrr_stack+1112, vrr_stack+161, vrr_stack+618, vrr_stack+582, NULL);
 _BUILD_00m0(Data,vrr_stack+9062, vrr_stack+1157, vrr_stack+1112, vrr_stack+654, vrr_stack+618, NULL);
 _BUILD_00m0(Data,vrr_stack+9117, vrr_stack+161, vrr_stack+2301, vrr_stack+582, vrr_stack+63, NULL);
 _BUILD_p0m0(Data,vrr_stack+9172, vrr_stack+9007, vrr_stack+9117, NULL, NULL, vrr_stack+161);
 _BUILD_p0m0(Data,vrr_stack+9337, vrr_stack+9062, vrr_stack+9007, NULL, NULL, vrr_stack+1112);
 _BUILD_d0m0(Data,vrr_stack+9502, vrr_stack+9337, vrr_stack+9172, vrr_stack+9062, vrr_stack+9007, vrr_stack+6037);
 _BUILD_00m0(Data,vrr_stack+9832, vrr_stack+2256, vrr_stack+1157, vrr_stack+788, vrr_stack+654, NULL);
 _BUILD_p0m0(Data,vrr_stack+9887, vrr_stack+9832, vrr_stack+9062, NULL, NULL, vrr_stack+1157);
 _BUILD_d0m0(Data,vrr_stack+10052, vrr_stack+9887, vrr_stack+9337, vrr_stack+9832, vrr_stack+9062, vrr_stack+6172);
 _BUILD_00m0(Data,vrr_stack+10382, vrr_stack+2301, vrr_stack+824, vrr_stack+63, vrr_stack+932, NULL);
 _BUILD_p0m0(Data,vrr_stack+10437, vrr_stack+9117, vrr_stack+10382, NULL, NULL, vrr_stack+2301);
 _BUILD_d0m0(Data,vrr_stack+1572, vrr_stack+9172, vrr_stack+10437, vrr_stack+9007, vrr_stack+9117, vrr_stack+2346);
 _BUILD_f0m0(Data,vrr_stack+26547, vrr_stack+9502, vrr_stack+1572, vrr_stack+9337, vrr_stack+9172, vrr_stack+14441);
 _BUILD_f0m0(Data,vrr_stack+27097, vrr_stack+10052, vrr_stack+9502, vrr_stack+9887, vrr_stack+9337, vrr_stack+6307);
 _BUILD_g0m0(Data,vrr_stack+4795, vrr_stack+27097, vrr_stack+26547, vrr_stack+10052, vrr_stack+9502, vrr_stack+14711);
 _BUILD_00m0(Data,vrr_stack+2346, vrr_stack+2481, vrr_stack+2256, vrr_stack+1076, vrr_stack+788, NULL);
 _BUILD_p0m0(Data,vrr_stack+1902, vrr_stack+2346, vrr_stack+9832, NULL, NULL, vrr_stack+2256);
 _BUILD_d0m0(Data,vrr_stack+5620, vrr_stack+1902, vrr_stack+9887, vrr_stack+2346, vrr_stack+9832, vrr_stack+6577);
 _BUILD_f0m0(Data,vrr_stack+5950, vrr_stack+5620, vrr_stack+10052, vrr_stack+1902, vrr_stack+9887, vrr_stack+6712);
 _BUILD_g0m0(Data,vrr_stack+12247, vrr_stack+5950, vrr_stack+27097, vrr_stack+5620, vrr_stack+10052, vrr_stack+15161);
 _BUILD_00m0(Data,vrr_stack+2401, vrr_stack+824, vrr_stack+1013, vrr_stack+932, vrr_stack+1236, NULL);
 _BUILD_p0m0(Data,vrr_stack+2067, vrr_stack+10382, vrr_stack+2401, NULL, NULL, vrr_stack+824);
 _BUILD_d0m0(Data,vrr_stack+6500, vrr_stack+10437, vrr_stack+2067, vrr_stack+9117, vrr_stack+10382, vrr_stack+7432);
 _BUILD_f0m0(Data,vrr_stack+13072, vrr_stack+1572, vrr_stack+6500, vrr_stack+9172, vrr_stack+10437, vrr_stack+7567);
 _BUILD_g0m0(Data,vrr_stack+13622, vrr_stack+26547, vrr_stack+13072, vrr_stack+9502, vrr_stack+1572, vrr_stack+30567);
 _BUILD_h0m0(Data,vrr_stack+14447, vrr_stack+4795, vrr_stack+13622, vrr_stack+27097, vrr_stack+26547, vrr_stack+31017);
 _BUILD_h0m0(Data,vrr_stack+47217, vrr_stack+12247, vrr_stack+4795, vrr_stack+5950, vrr_stack+27097, vrr_stack+15611);
 _BUILD_i0m0(Data,vrr_stack+48372, vrr_stack+47217, vrr_stack+14447, vrr_stack+12247, vrr_stack+4795, vrr_stack+31692);
 _BUILD_00m0(Data,vrr_stack+30567, vrr_stack+968, vrr_stack+2481, vrr_stack+1355, vrr_stack+1076, NULL);
 _BUILD_p0m0(Data,vrr_stack+30622, vrr_stack+30567, vrr_stack+2346, NULL, NULL, vrr_stack+2481);
 _BUILD_d0m0(Data,vrr_stack+30787, vrr_stack+30622, vrr_stack+1902, vrr_stack+30567, vrr_stack+2346, vrr_stack+2526);
 _BUILD_f0m0(Data,vrr_stack+31117, vrr_stack+30787, vrr_stack+5620, vrr_stack+30622, vrr_stack+1902, vrr_stack+2661);
 _BUILD_g0m0(Data,vrr_stack+31667, vrr_stack+31117, vrr_stack+5950, vrr_stack+30787, vrr_stack+5620, vrr_stack+6982);
 _BUILD_h0m0(Data,vrr_stack+49912, vrr_stack+31667, vrr_stack+12247, vrr_stack+31117, vrr_stack+5950, vrr_stack+29892);
 _BUILD_i0m0(Data,vrr_stack+51067, vrr_stack+49912, vrr_stack+47217, vrr_stack+31667, vrr_stack+12247, vrr_stack+16286);
 _BUILD_00m0(Data,vrr_stack+29892, vrr_stack+1013, vrr_stack+21552, vrr_stack+1236, vrr_stack+1536, NULL);
 _BUILD_p0m0(Data,vrr_stack+29947, vrr_stack+2401, vrr_stack+29892, NULL, NULL, vrr_stack+1013);
 _BUILD_d0m0(Data,vrr_stack+30112, vrr_stack+2067, vrr_stack+29947, vrr_stack+10382, vrr_stack+2401, vrr_stack+3066);
 _BUILD_f0m0(Data,vrr_stack+6830, vrr_stack+6500, vrr_stack+30112, vrr_stack+10437, vrr_stack+2067, vrr_stack+3201);
 _BUILD_g0m0(Data,vrr_stack+15602, vrr_stack+13072, vrr_stack+6830, vrr_stack+1572, vrr_stack+6500, vrr_stack+8557);
 _BUILD_h0m0(Data,vrr_stack+52607, vrr_stack+13622, vrr_stack+15602, vrr_stack+26547, vrr_stack+13072, vrr_stack+17906);
 _BUILD_i0m0(Data,vrr_stack+53762, vrr_stack+14447, vrr_stack+52607, vrr_stack+4795, vrr_stack+13622, vrr_stack+36102);
 _BUILD_k0m0(Data,vrr_stack+55302, vrr_stack+48372, vrr_stack+53762, vrr_stack+47217, vrr_stack+14447, vrr_stack+18581);
 _BUILD_k0m0(Data,vrr_stack+57282, vrr_stack+51067, vrr_stack+48372, vrr_stack+49912, vrr_stack+47217, vrr_stack+32637);
 _BUILD_l0m0(Data,vrr_stack+59262, vrr_stack+57282, vrr_stack+55302, vrr_stack+51067, vrr_stack+48372, vrr_stack+37047);
 _BUILD_00m0(Data,vrr_stack+36102, vrr_stack+869, vrr_stack+968, vrr_stack+3499, vrr_stack+1355, NULL);
 _BUILD_p0m0(Data,vrr_stack+36157, vrr_stack+36102, vrr_stack+30567, NULL, NULL, vrr_stack+968);
 _BUILD_d0m0(Data,vrr_stack+36322, vrr_stack+36157, vrr_stack+30622, vrr_stack+36102, vrr_stack+30567, vrr_stack+2931);
 _BUILD_f0m0(Data,vrr_stack+36652, vrr_stack+36322, vrr_stack+30787, vrr_stack+36157, vrr_stack+30622, vrr_stack+7837);
 _BUILD_g0m0(Data,vrr_stack+37202, vrr_stack+36652, vrr_stack+31117, vrr_stack+36322, vrr_stack+30787, vrr_stack+8107);
 _BUILD_h0m0(Data,vrr_stack+17906, vrr_stack+37202, vrr_stack+31667, vrr_stack+36652, vrr_stack+31117, vrr_stack+17231);
 _BUILD_i0m0(Data,vrr_stack+7380, vrr_stack+17906, vrr_stack+49912, vrr_stack+37202, vrr_stack+31667, vrr_stack+33897);
 _BUILD_k0m0(Data,vrr_stack+36157, vrr_stack+7380, vrr_stack+51067, vrr_stack+17906, vrr_stack+49912, vrr_stack+34842);
   tmp = vrr_stack + 36157;
   target_ptr = Libint->vrr_classes[7][9];
   for(i=0;i<1980;i++)
     target_ptr[i] += tmp[i];
 _BUILD_l0m0(Data,vrr_stack+32492, vrr_stack+36157, vrr_stack+57282, vrr_stack+7380, vrr_stack+51067, vrr_stack+19841);
   tmp = vrr_stack + 32492;
   target_ptr = Libint->vrr_classes[8][9];
   for(i=0;i<2475;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00p0(Data,vrr_stack+7380, Data->F+18, Data->F+19, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+7383, vrr_stack+21461, vrr_stack+7380, Data->F+17, Data->F+18, NULL);
 _BUILD_00f0(Data,vrr_stack+7389, vrr_stack+21464, vrr_stack+7383, vrr_stack+1453, vrr_stack+21461, NULL);
 _BUILD_00g0(Data,vrr_stack+7399, vrr_stack+21470, vrr_stack+7389, vrr_stack+1456, vrr_stack+21464, NULL);
 _BUILD_00h0(Data,vrr_stack+7414, vrr_stack+21480, vrr_stack+7399, vrr_stack+1462, vrr_stack+21470, NULL);
 _BUILD_00i0(Data,vrr_stack+7435, vrr_stack+21495, vrr_stack+7414, vrr_stack+1472, vrr_stack+21480, NULL);
 _BUILD_00k0(Data,vrr_stack+3499, vrr_stack+3471, vrr_stack+7435, vrr_stack+1487, vrr_stack+21495, NULL);
 _BUILD_00l0(Data,vrr_stack+7463, vrr_stack+21516, vrr_stack+3499, vrr_stack+1508, vrr_stack+3471, NULL);
 _BUILD_00m0(Data,vrr_stack+7508, vrr_stack+21552, vrr_stack+7463, vrr_stack+1536, vrr_stack+21516, NULL);
 _BUILD_p0m0(Data,vrr_stack+7563, vrr_stack+29892, vrr_stack+7508, NULL, NULL, vrr_stack+21552);
 _BUILD_d0m0(Data,vrr_stack+7728, vrr_stack+29947, vrr_stack+7563, vrr_stack+2401, vrr_stack+29892, vrr_stack+21597);
 _BUILD_f0m0(Data,vrr_stack+8058, vrr_stack+30112, vrr_stack+7728, vrr_stack+2067, vrr_stack+29947, vrr_stack+21732);
 _BUILD_g0m0(Data,vrr_stack+2526, vrr_stack+6830, vrr_stack+8058, vrr_stack+6500, vrr_stack+30112, vrr_stack+22002);
 _BUILD_h0m0(Data,vrr_stack+16427, vrr_stack+15602, vrr_stack+2526, vrr_stack+13072, vrr_stack+6830, vrr_stack+22452);
 _BUILD_i0m0(Data,vrr_stack+17582, vrr_stack+52607, vrr_stack+16427, vrr_stack+13622, vrr_stack+15602, vrr_stack+23127);
 _BUILD_k0m0(Data,vrr_stack+21597, vrr_stack+53762, vrr_stack+17582, vrr_stack+14447, vrr_stack+52607, vrr_stack+3535);
 _BUILD_l0m0(Data,vrr_stack+61737, vrr_stack+55302, vrr_stack+21597, vrr_stack+48372, vrr_stack+53762, vrr_stack+10627);
 _BUILD_m0m0(Data,vrr_stack+64212, vrr_stack+59262, vrr_stack+61737, vrr_stack+57282, vrr_stack+55302, vrr_stack+42717);
 _BUILD_m0m0(Data,vrr_stack+67237, vrr_stack+32492, vrr_stack+59262, vrr_stack+36157, vrr_stack+57282, vrr_stack+38667);
   tmp = vrr_stack + 67237;
   target_ptr = Libint->vrr_classes[9][9];
   for(i=0;i<3025;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00n0(Data,vrr_stack+36157, vrr_stack+9007, vrr_stack+9117, vrr_stack+1112, vrr_stack+161, NULL);
 _BUILD_00n0(Data,vrr_stack+36223, vrr_stack+9062, vrr_stack+9007, vrr_stack+1157, vrr_stack+1112, NULL);
 _BUILD_00n0(Data,vrr_stack+36289, vrr_stack+9117, vrr_stack+10382, vrr_stack+161, vrr_stack+2301, NULL);
 _BUILD_p0n0(Data,vrr_stack+36355, vrr_stack+36157, vrr_stack+36289, NULL, NULL, vrr_stack+9117);
 _BUILD_p0n0(Data,vrr_stack+36553, vrr_stack+36223, vrr_stack+36157, NULL, NULL, vrr_stack+9007);
 _BUILD_d0n0(Data,vrr_stack+36751, vrr_stack+36553, vrr_stack+36355, vrr_stack+36223, vrr_stack+36157, vrr_stack+9172);
 _BUILD_00n0(Data,vrr_stack+9172, vrr_stack+9832, vrr_stack+9062, vrr_stack+2256, vrr_stack+1157, NULL);
 _BUILD_p0n0(Data,vrr_stack+37147, vrr_stack+9172, vrr_stack+36223, NULL, NULL, vrr_stack+9062);
 _BUILD_d0n0(Data,vrr_stack+37345, vrr_stack+37147, vrr_stack+36553, vrr_stack+9172, vrr_stack+36223, vrr_stack+9337);
 _BUILD_00n0(Data,vrr_stack+9238, vrr_stack+10382, vrr_stack+2401, vrr_stack+2301, vrr_stack+824, NULL);
 _BUILD_p0n0(Data,vrr_stack+9304, vrr_stack+36289, vrr_stack+9238, NULL, NULL, vrr_stack+10382);
 _BUILD_d0n0(Data,vrr_stack+37741, vrr_stack+36355, vrr_stack+9304, vrr_stack+36157, vrr_stack+36289, vrr_stack+10437);
 _BUILD_f0n0(Data,vrr_stack+10437, vrr_stack+36751, vrr_stack+37741, vrr_stack+36553, vrr_stack+36355, vrr_stack+1572);
 _BUILD_f0n0(Data,vrr_stack+11097, vrr_stack+37345, vrr_stack+36751, vrr_stack+37147, vrr_stack+36553, vrr_stack+9502);
 _BUILD_g0n0(Data,vrr_stack+42717, vrr_stack+11097, vrr_stack+10437, vrr_stack+37345, vrr_stack+36751, vrr_stack+26547);
 _BUILD_00n0(Data,vrr_stack+26547, vrr_stack+2346, vrr_stack+9832, vrr_stack+2481, vrr_stack+2256, NULL);
 _BUILD_p0n0(Data,vrr_stack+26613, vrr_stack+26547, vrr_stack+9172, NULL, NULL, vrr_stack+9832);
 _BUILD_d0n0(Data,vrr_stack+11757, vrr_stack+26613, vrr_stack+37147, vrr_stack+26547, vrr_stack+9172, vrr_stack+9887);
 _BUILD_f0n0(Data,vrr_stack+43707, vrr_stack+11757, vrr_stack+37345, vrr_stack+26613, vrr_stack+37147, vrr_stack+10052);
 _BUILD_g0n0(Data,vrr_stack+3535, vrr_stack+43707, vrr_stack+11097, vrr_stack+11757, vrr_stack+37345, vrr_stack+27097);
 _BUILD_00n0(Data,vrr_stack+9887, vrr_stack+2401, vrr_stack+29892, vrr_stack+824, vrr_stack+1013, NULL);
 _BUILD_p0n0(Data,vrr_stack+9953, vrr_stack+9238, vrr_stack+9887, NULL, NULL, vrr_stack+2401);
 _BUILD_d0n0(Data,vrr_stack+26811, vrr_stack+9304, vrr_stack+9953, vrr_stack+36289, vrr_stack+9238, vrr_stack+2067);
 _BUILD_f0n0(Data,vrr_stack+27207, vrr_stack+37741, vrr_stack+26811, vrr_stack+36355, vrr_stack+9304, vrr_stack+6500);
 _BUILD_g0n0(Data,vrr_stack+34967, vrr_stack+10437, vrr_stack+27207, vrr_stack+36751, vrr_stack+37741, vrr_stack+13072);
 _BUILD_h0n0(Data,vrr_stack+19122, vrr_stack+42717, vrr_stack+34967, vrr_stack+11097, vrr_stack+10437, vrr_stack+13622);
 _BUILD_h0n0(Data,vrr_stack+70262, vrr_stack+3535, vrr_stack+42717, vrr_stack+43707, vrr_stack+11097, vrr_stack+4795);
 _BUILD_i0n0(Data,vrr_stack+71648, vrr_stack+70262, vrr_stack+19122, vrr_stack+3535, vrr_stack+42717, vrr_stack+14447);
 _BUILD_00n0(Data,vrr_stack+13072, vrr_stack+30567, vrr_stack+2346, vrr_stack+968, vrr_stack+2481, NULL);
 _BUILD_p0n0(Data,vrr_stack+13138, vrr_stack+13072, vrr_stack+26547, NULL, NULL, vrr_stack+2346);
 _BUILD_d0n0(Data,vrr_stack+13336, vrr_stack+13138, vrr_stack+26613, vrr_stack+13072, vrr_stack+26547, vrr_stack+1902);
 _BUILD_f0n0(Data,vrr_stack+13732, vrr_stack+13336, vrr_stack+11757, vrr_stack+13138, vrr_stack+26613, vrr_stack+5620);
 _BUILD_g0n0(Data,vrr_stack+14392, vrr_stack+13732, vrr_stack+43707, vrr_stack+13336, vrr_stack+11757, vrr_stack+5950);
 _BUILD_h0n0(Data,vrr_stack+4525, vrr_stack+14392, vrr_stack+3535, vrr_stack+13732, vrr_stack+43707, vrr_stack+12247);
 _BUILD_i0n0(Data,vrr_stack+73496, vrr_stack+4525, vrr_stack+70262, vrr_stack+14392, vrr_stack+3535, vrr_stack+47217);
 _BUILD_00n0(Data,vrr_stack+47217, vrr_stack+29892, vrr_stack+7508, vrr_stack+1013, vrr_stack+21552, NULL);
 _BUILD_p0n0(Data,vrr_stack+1013, vrr_stack+9887, vrr_stack+47217, NULL, NULL, vrr_stack+29892);
 _BUILD_d0n0(Data,vrr_stack+1211, vrr_stack+9953, vrr_stack+1013, vrr_stack+9238, vrr_stack+9887, vrr_stack+29947);
 _BUILD_f0n0(Data,vrr_stack+1607, vrr_stack+26811, vrr_stack+1211, vrr_stack+9304, vrr_stack+9953, vrr_stack+30112);
 _BUILD_g0n0(Data,vrr_stack+47283, vrr_stack+27207, vrr_stack+1607, vrr_stack+37741, vrr_stack+26811, vrr_stack+6830);
 _BUILD_h0n0(Data,vrr_stack+5911, vrr_stack+34967, vrr_stack+47283, vrr_stack+10437, vrr_stack+27207, vrr_stack+15602);
 _BUILD_i0n0(Data,vrr_stack+75344, vrr_stack+19122, vrr_stack+5911, vrr_stack+42717, vrr_stack+34967, vrr_stack+52607);
 _BUILD_k0n0(Data,vrr_stack+77192, vrr_stack+71648, vrr_stack+75344, vrr_stack+70262, vrr_stack+19122, vrr_stack+53762);
 _BUILD_k0n0(Data,vrr_stack+52607, vrr_stack+73496, vrr_stack+71648, vrr_stack+4525, vrr_stack+70262, vrr_stack+48372);
 _BUILD_l0n0(Data,vrr_stack+79568, vrr_stack+52607, vrr_stack+77192, vrr_stack+73496, vrr_stack+71648, vrr_stack+55302);
 _BUILD_00n0(Data,vrr_stack+54983, vrr_stack+36102, vrr_stack+30567, vrr_stack+869, vrr_stack+968, NULL);
 _BUILD_p0n0(Data,vrr_stack+55049, vrr_stack+54983, vrr_stack+13072, NULL, NULL, vrr_stack+30567);
 _BUILD_d0n0(Data,vrr_stack+55247, vrr_stack+55049, vrr_stack+13138, vrr_stack+54983, vrr_stack+13072, vrr_stack+30622);
 _BUILD_f0n0(Data,vrr_stack+55643, vrr_stack+55247, vrr_stack+13336, vrr_stack+55049, vrr_stack+13138, vrr_stack+30787);
 _BUILD_g0n0(Data,vrr_stack+48273, vrr_stack+55643, vrr_stack+13732, vrr_stack+55247, vrr_stack+13336, vrr_stack+31117);
 _BUILD_h0n0(Data,vrr_stack+82538, vrr_stack+48273, vrr_stack+14392, vrr_stack+55643, vrr_stack+13732, vrr_stack+31667);
 _BUILD_i0n0(Data,vrr_stack+55049, vrr_stack+82538, vrr_stack+4525, vrr_stack+48273, vrr_stack+14392, vrr_stack+49912);
 _BUILD_k0n0(Data,vrr_stack+48273, vrr_stack+55049, vrr_stack+73496, vrr_stack+82538, vrr_stack+4525, vrr_stack+51067);
   tmp = vrr_stack + 48273;
   target_ptr = Libint->vrr_classes[7][10];
   for(i=0;i<2376;i++)
     target_ptr[i] += tmp[i];
 _BUILD_l0n0(Data,vrr_stack+82538, vrr_stack+48273, vrr_stack+52607, vrr_stack+55049, vrr_stack+73496, vrr_stack+57282);
   tmp = vrr_stack + 82538;
   target_ptr = Libint->vrr_classes[8][10];
   for(i=0;i<2970;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00p0(Data,vrr_stack+55049, Data->F+19, Data->F+20, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+55052, vrr_stack+7380, vrr_stack+55049, Data->F+18, Data->F+19, NULL);
 _BUILD_00f0(Data,vrr_stack+55058, vrr_stack+7383, vrr_stack+55052, vrr_stack+21461, vrr_stack+7380, NULL);
 _BUILD_00g0(Data,vrr_stack+55068, vrr_stack+7389, vrr_stack+55058, vrr_stack+21464, vrr_stack+7383, NULL);
 _BUILD_00h0(Data,vrr_stack+55083, vrr_stack+7399, vrr_stack+55068, vrr_stack+21470, vrr_stack+7389, NULL);
 _BUILD_00i0(Data,vrr_stack+55104, vrr_stack+7414, vrr_stack+55083, vrr_stack+21480, vrr_stack+7399, NULL);
 _BUILD_00k0(Data,vrr_stack+55132, vrr_stack+7435, vrr_stack+55104, vrr_stack+21495, vrr_stack+7414, NULL);
 _BUILD_00l0(Data,vrr_stack+27867, vrr_stack+3499, vrr_stack+55132, vrr_stack+3471, vrr_stack+7435, NULL);
 _BUILD_00m0(Data,vrr_stack+55168, vrr_stack+7463, vrr_stack+27867, vrr_stack+21516, vrr_stack+3499, NULL);
 _BUILD_00n0(Data,vrr_stack+55223, vrr_stack+7508, vrr_stack+55168, vrr_stack+21552, vrr_stack+7463, NULL);
 _BUILD_p0n0(Data,vrr_stack+55289, vrr_stack+47217, vrr_stack+55223, NULL, NULL, vrr_stack+7508);
 _BUILD_d0n0(Data,vrr_stack+55487, vrr_stack+1013, vrr_stack+55289, vrr_stack+9887, vrr_stack+47217, vrr_stack+7563);
 _BUILD_f0n0(Data,vrr_stack+55883, vrr_stack+1211, vrr_stack+55487, vrr_stack+9953, vrr_stack+1013, vrr_stack+7728);
 _BUILD_g0n0(Data,vrr_stack+56543, vrr_stack+1607, vrr_stack+55883, vrr_stack+26811, vrr_stack+1211, vrr_stack+8058);
 _BUILD_h0n0(Data,vrr_stack+7563, vrr_stack+47283, vrr_stack+56543, vrr_stack+27207, vrr_stack+1607, vrr_stack+2526);
 _BUILD_i0n0(Data,vrr_stack+50649, vrr_stack+5911, vrr_stack+7563, vrr_stack+34967, vrr_stack+47283, vrr_stack+16427);
 _BUILD_k0n0(Data,vrr_stack+85508, vrr_stack+75344, vrr_stack+50649, vrr_stack+19122, vrr_stack+5911, vrr_stack+17582);
 _BUILD_l0n0(Data,vrr_stack+15382, vrr_stack+77192, vrr_stack+85508, vrr_stack+71648, vrr_stack+75344, vrr_stack+21597);
 _BUILD_m0n0(Data,vrr_stack+87884, vrr_stack+79568, vrr_stack+15382, vrr_stack+52607, vrr_stack+77192, vrr_stack+61737);
 _BUILD_m0n0(Data,vrr_stack+91514, vrr_stack+82538, vrr_stack+79568, vrr_stack+48273, vrr_stack+52607, vrr_stack+59262);
   tmp = vrr_stack + 91514;
   target_ptr = Libint->vrr_classes[9][10];
   for(i=0;i<3630;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00o0(Data,vrr_stack+48273, vrr_stack+36157, vrr_stack+36289, vrr_stack+9007, vrr_stack+9117, NULL);
 _BUILD_00o0(Data,vrr_stack+48351, vrr_stack+36223, vrr_stack+36157, vrr_stack+9062, vrr_stack+9007, NULL);
 _BUILD_00o0(Data,vrr_stack+48429, vrr_stack+36289, vrr_stack+9238, vrr_stack+9117, vrr_stack+10382, NULL);
 _BUILD_p0o0(Data,vrr_stack+48507, vrr_stack+48273, vrr_stack+48429, NULL, NULL, vrr_stack+36289);
 _BUILD_p0o0(Data,vrr_stack+48741, vrr_stack+48351, vrr_stack+48273, NULL, NULL, vrr_stack+36157);
 _BUILD_d0o0(Data,vrr_stack+48975, vrr_stack+48741, vrr_stack+48507, vrr_stack+48351, vrr_stack+48273, vrr_stack+36355);
 _BUILD_00o0(Data,vrr_stack+36355, vrr_stack+9172, vrr_stack+36223, vrr_stack+9832, vrr_stack+9062, NULL);
 _BUILD_p0o0(Data,vrr_stack+49443, vrr_stack+36355, vrr_stack+48351, NULL, NULL, vrr_stack+36223);
 _BUILD_d0o0(Data,vrr_stack+49677, vrr_stack+49443, vrr_stack+48741, vrr_stack+36355, vrr_stack+48351, vrr_stack+36553);
 _BUILD_00o0(Data,vrr_stack+36433, vrr_stack+9238, vrr_stack+9887, vrr_stack+10382, vrr_stack+2401, NULL);
 _BUILD_p0o0(Data,vrr_stack+36511, vrr_stack+48429, vrr_stack+36433, NULL, NULL, vrr_stack+9238);
 _BUILD_d0o0(Data,vrr_stack+50145, vrr_stack+48507, vrr_stack+36511, vrr_stack+48273, vrr_stack+48429, vrr_stack+9304);
 _BUILD_f0o0(Data,vrr_stack+61737, vrr_stack+48975, vrr_stack+50145, vrr_stack+48741, vrr_stack+48507, vrr_stack+37741);
 _BUILD_f0o0(Data,vrr_stack+37741, vrr_stack+49677, vrr_stack+48975, vrr_stack+49443, vrr_stack+48741, vrr_stack+36751);
 _BUILD_g0o0(Data,vrr_stack+62517, vrr_stack+37741, vrr_stack+61737, vrr_stack+49677, vrr_stack+48975, vrr_stack+10437);
 _BUILD_00o0(Data,vrr_stack+38521, vrr_stack+26547, vrr_stack+9172, vrr_stack+2346, vrr_stack+9832, NULL);
 _BUILD_p0o0(Data,vrr_stack+9304, vrr_stack+38521, vrr_stack+36355, NULL, NULL, vrr_stack+9172);
 _BUILD_d0o0(Data,vrr_stack+63687, vrr_stack+9304, vrr_stack+49443, vrr_stack+38521, vrr_stack+36355, vrr_stack+37147);
 _BUILD_f0o0(Data,vrr_stack+57533, vrr_stack+63687, vrr_stack+49677, vrr_stack+9304, vrr_stack+49443, vrr_stack+37345);
 _BUILD_g0o0(Data,vrr_stack+30622, vrr_stack+57533, vrr_stack+37741, vrr_stack+63687, vrr_stack+49677, vrr_stack+11097);
 _BUILD_00o0(Data,vrr_stack+9538, vrr_stack+9887, vrr_stack+47217, vrr_stack+2401, vrr_stack+29892, NULL);
 _BUILD_p0o0(Data,vrr_stack+2401, vrr_stack+36433, vrr_stack+9538, NULL, NULL, vrr_stack+9887);
 _BUILD_d0o0(Data,vrr_stack+2635, vrr_stack+36511, vrr_stack+2401, vrr_stack+48429, vrr_stack+36433, vrr_stack+9953);
 _BUILD_f0o0(Data,vrr_stack+9953, vrr_stack+50145, vrr_stack+2635, vrr_stack+48507, vrr_stack+36511, vrr_stack+26811);
 _BUILD_g0o0(Data,vrr_stack+20508, vrr_stack+61737, vrr_stack+9953, vrr_stack+48975, vrr_stack+50145, vrr_stack+27207);
 _BUILD_h0o0(Data,vrr_stack+21678, vrr_stack+62517, vrr_stack+20508, vrr_stack+37741, vrr_stack+61737, vrr_stack+34967);
 _BUILD_h0o0(Data,vrr_stack+95144, vrr_stack+30622, vrr_stack+62517, vrr_stack+57533, vrr_stack+37741, vrr_stack+42717);
 _BUILD_i0o0(Data,vrr_stack+96782, vrr_stack+95144, vrr_stack+21678, vrr_stack+30622, vrr_stack+62517, vrr_stack+19122);
 _BUILD_00o0(Data,vrr_stack+42717, vrr_stack+13072, vrr_stack+26547, vrr_stack+30567, vrr_stack+2346, NULL);
 _BUILD_p0o0(Data,vrr_stack+42795, vrr_stack+42717, vrr_stack+38521, NULL, NULL, vrr_stack+26547);
 _BUILD_d0o0(Data,vrr_stack+43029, vrr_stack+42795, vrr_stack+9304, vrr_stack+42717, vrr_stack+38521, vrr_stack+26613);
 _BUILD_f0o0(Data,vrr_stack+26613, vrr_stack+43029, vrr_stack+63687, vrr_stack+42795, vrr_stack+9304, vrr_stack+11757);
 _BUILD_g0o0(Data,vrr_stack+10733, vrr_stack+26613, vrr_stack+57533, vrr_stack+43029, vrr_stack+63687, vrr_stack+43707);
 _BUILD_h0o0(Data,vrr_stack+18352, vrr_stack+10733, vrr_stack+30622, vrr_stack+26613, vrr_stack+57533, vrr_stack+3535);
 _BUILD_i0o0(Data,vrr_stack+98966, vrr_stack+18352, vrr_stack+95144, vrr_stack+10733, vrr_stack+30622, vrr_stack+70262);
 _BUILD_00o0(Data,vrr_stack+70262, vrr_stack+47217, vrr_stack+55223, vrr_stack+29892, vrr_stack+7508, NULL);
 _BUILD_p0o0(Data,vrr_stack+29892, vrr_stack+9538, vrr_stack+70262, NULL, NULL, vrr_stack+47217);
 _BUILD_d0o0(Data,vrr_stack+70340, vrr_stack+2401, vrr_stack+29892, vrr_stack+36433, vrr_stack+9538, vrr_stack+1013);
 _BUILD_f0o0(Data,vrr_stack+70808, vrr_stack+2635, vrr_stack+70340, vrr_stack+36511, vrr_stack+2401, vrr_stack+1211);
 _BUILD_g0o0(Data,vrr_stack+43497, vrr_stack+9953, vrr_stack+70808, vrr_stack+50145, vrr_stack+2635, vrr_stack+1607);
 _BUILD_h0o0(Data,vrr_stack+0, vrr_stack+20508, vrr_stack+43497, vrr_stack+61737, vrr_stack+9953, vrr_stack+47283);
 _BUILD_i0o0(Data,vrr_stack+101150, vrr_stack+21678, vrr_stack+0, vrr_stack+62517, vrr_stack+20508, vrr_stack+5911);
 _BUILD_k0o0(Data,vrr_stack+103334, vrr_stack+96782, vrr_stack+101150, vrr_stack+95144, vrr_stack+21678, vrr_stack+75344);
 _BUILD_k0o0(Data,vrr_stack+106142, vrr_stack+98966, vrr_stack+96782, vrr_stack+18352, vrr_stack+95144, vrr_stack+71648);
 _BUILD_l0o0(Data,vrr_stack+108950, vrr_stack+106142, vrr_stack+103334, vrr_stack+98966, vrr_stack+96782, vrr_stack+77192);
 _BUILD_00o0(Data,vrr_stack+75344, vrr_stack+54983, vrr_stack+13072, vrr_stack+36102, vrr_stack+30567, NULL);
 _BUILD_p0o0(Data,vrr_stack+75422, vrr_stack+75344, vrr_stack+42717, NULL, NULL, vrr_stack+13072);
 _BUILD_d0o0(Data,vrr_stack+75656, vrr_stack+75422, vrr_stack+42795, vrr_stack+75344, vrr_stack+42717, vrr_stack+13138);
 _BUILD_f0o0(Data,vrr_stack+76124, vrr_stack+75656, vrr_stack+43029, vrr_stack+75422, vrr_stack+42795, vrr_stack+13336);
 _BUILD_g0o0(Data,vrr_stack+76904, vrr_stack+76124, vrr_stack+26613, vrr_stack+75656, vrr_stack+43029, vrr_stack+13732);
 _BUILD_h0o0(Data,vrr_stack+71588, vrr_stack+76904, vrr_stack+10733, vrr_stack+76124, vrr_stack+26613, vrr_stack+14392);
 _BUILD_i0o0(Data,vrr_stack+13138, vrr_stack+71588, vrr_stack+18352, vrr_stack+76904, vrr_stack+10733, vrr_stack+4525);
 _BUILD_k0o0(Data,vrr_stack+75422, vrr_stack+13138, vrr_stack+98966, vrr_stack+71588, vrr_stack+18352, vrr_stack+73496);
   tmp = vrr_stack + 75422;
   target_ptr = Libint->vrr_classes[7][11];
   for(i=0;i<2808;i++)
     target_ptr[i] += tmp[i];
 _BUILD_l0o0(Data,vrr_stack+71588, vrr_stack+75422, vrr_stack+106142, vrr_stack+13138, vrr_stack+98966, vrr_stack+52607);
   tmp = vrr_stack + 71588;
   target_ptr = Libint->vrr_classes[8][11];
   for(i=0;i<3510;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00p0(Data,vrr_stack+13138, Data->F+20, Data->F+21, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+13141, vrr_stack+55049, vrr_stack+13138, Data->F+19, Data->F+20, NULL);
 _BUILD_00f0(Data,vrr_stack+13147, vrr_stack+55052, vrr_stack+13141, vrr_stack+7380, vrr_stack+55049, NULL);
 _BUILD_00g0(Data,vrr_stack+13157, vrr_stack+55058, vrr_stack+13147, vrr_stack+7383, vrr_stack+55052, NULL);
 _BUILD_00h0(Data,vrr_stack+13172, vrr_stack+55068, vrr_stack+13157, vrr_stack+7389, vrr_stack+55058, NULL);
 _BUILD_00i0(Data,vrr_stack+13193, vrr_stack+55083, vrr_stack+13172, vrr_stack+7399, vrr_stack+55068, NULL);
 _BUILD_00k0(Data,vrr_stack+50613, vrr_stack+55104, vrr_stack+13193, vrr_stack+7414, vrr_stack+55083, NULL);
 _BUILD_00l0(Data,vrr_stack+13221, vrr_stack+55132, vrr_stack+50613, vrr_stack+7435, vrr_stack+55104, NULL);
 _BUILD_00m0(Data,vrr_stack+13266, vrr_stack+27867, vrr_stack+13221, vrr_stack+3499, vrr_stack+55132, NULL);
 _BUILD_00n0(Data,vrr_stack+13321, vrr_stack+55168, vrr_stack+13266, vrr_stack+7463, vrr_stack+27867, NULL);
 _BUILD_00o0(Data,vrr_stack+13387, vrr_stack+55223, vrr_stack+13321, vrr_stack+7508, vrr_stack+55168, NULL);
 _BUILD_p0o0(Data,vrr_stack+13465, vrr_stack+70262, vrr_stack+13387, NULL, NULL, vrr_stack+55223);
 _BUILD_d0o0(Data,vrr_stack+13699, vrr_stack+29892, vrr_stack+13465, vrr_stack+9538, vrr_stack+70262, vrr_stack+55289);
 _BUILD_f0o0(Data,vrr_stack+14167, vrr_stack+70340, vrr_stack+13699, vrr_stack+2401, vrr_stack+29892, vrr_stack+55487);
 _BUILD_g0o0(Data,vrr_stack+78230, vrr_stack+70808, vrr_stack+14167, vrr_stack+2635, vrr_stack+70340, vrr_stack+55883);
 _BUILD_h0o0(Data,vrr_stack+3103, vrr_stack+43497, vrr_stack+78230, vrr_stack+9953, vrr_stack+70808, vrr_stack+56543);
 _BUILD_i0o0(Data,vrr_stack+55289, vrr_stack+0, vrr_stack+3103, vrr_stack+20508, vrr_stack+43497, vrr_stack+7563);
 _BUILD_k0o0(Data,vrr_stack+4741, vrr_stack+101150, vrr_stack+55289, vrr_stack+21678, vrr_stack+0, vrr_stack+50649);
 _BUILD_l0o0(Data,vrr_stack+50649, vrr_stack+103334, vrr_stack+4741, vrr_stack+96782, vrr_stack+101150, vrr_stack+85508);
 _BUILD_m0o0(Data,vrr_stack+112460, vrr_stack+108950, vrr_stack+50649, vrr_stack+106142, vrr_stack+103334, vrr_stack+15382);
 _BUILD_m0o0(Data,vrr_stack+116750, vrr_stack+71588, vrr_stack+108950, vrr_stack+75422, vrr_stack+106142, vrr_stack+79568);
   tmp = vrr_stack + 116750;
   target_ptr = Libint->vrr_classes[9][11];
   for(i=0;i<4290;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00q0(Data,vrr_stack+75422, vrr_stack+48273, vrr_stack+48429, vrr_stack+36157, vrr_stack+36289, NULL);
 _BUILD_00q0(Data,vrr_stack+75513, vrr_stack+48351, vrr_stack+48273, vrr_stack+36223, vrr_stack+36157, NULL);
 _BUILD_00q0(Data,vrr_stack+75604, vrr_stack+48429, vrr_stack+36433, vrr_stack+36289, vrr_stack+9238, NULL);
 _BUILD_p0q0(Data,vrr_stack+75695, vrr_stack+75422, vrr_stack+75604, NULL, NULL, vrr_stack+48429);
 _BUILD_p0q0(Data,vrr_stack+75968, vrr_stack+75513, vrr_stack+75422, NULL, NULL, vrr_stack+48273);
 _BUILD_d0q0(Data,vrr_stack+76241, vrr_stack+75968, vrr_stack+75695, vrr_stack+75513, vrr_stack+75422, vrr_stack+48507);
 _BUILD_00q0(Data,vrr_stack+48429, vrr_stack+36355, vrr_stack+48351, vrr_stack+9172, vrr_stack+36223, NULL);
 _BUILD_p0q0(Data,vrr_stack+76787, vrr_stack+48429, vrr_stack+75513, NULL, NULL, vrr_stack+48351);
 _BUILD_d0q0(Data,vrr_stack+77060, vrr_stack+76787, vrr_stack+75968, vrr_stack+48429, vrr_stack+75513, vrr_stack+48741);
 _BUILD_00q0(Data,vrr_stack+75513, vrr_stack+36433, vrr_stack+9538, vrr_stack+9238, vrr_stack+9887, NULL);
 _BUILD_p0q0(Data,vrr_stack+48520, vrr_stack+75604, vrr_stack+75513, NULL, NULL, vrr_stack+36433);
 _BUILD_d0q0(Data,vrr_stack+77606, vrr_stack+75695, vrr_stack+48520, vrr_stack+75422, vrr_stack+75604, vrr_stack+36511);
 _BUILD_f0q0(Data,vrr_stack+36433, vrr_stack+76241, vrr_stack+77606, vrr_stack+75968, vrr_stack+75695, vrr_stack+50145);
 _BUILD_f0q0(Data,vrr_stack+85508, vrr_stack+77060, vrr_stack+76241, vrr_stack+76787, vrr_stack+75968, vrr_stack+48975);
 _BUILD_g0q0(Data,vrr_stack+86418, vrr_stack+85508, vrr_stack+36433, vrr_stack+77060, vrr_stack+76241, vrr_stack+61737);
 _BUILD_00q0(Data,vrr_stack+75422, vrr_stack+38521, vrr_stack+36355, vrr_stack+26547, vrr_stack+9172, NULL);
 _BUILD_p0q0(Data,vrr_stack+75968, vrr_stack+75422, vrr_stack+48429, NULL, NULL, vrr_stack+36355);
 _BUILD_d0q0(Data,vrr_stack+61737, vrr_stack+75968, vrr_stack+76787, vrr_stack+75422, vrr_stack+48429, vrr_stack+49443);
 _BUILD_f0q0(Data,vrr_stack+14947, vrr_stack+61737, vrr_stack+77060, vrr_stack+75968, vrr_stack+76787, vrr_stack+49677);
 _BUILD_g0q0(Data,vrr_stack+48793, vrr_stack+14947, vrr_stack+85508, vrr_stack+61737, vrr_stack+77060, vrr_stack+37741);
 _BUILD_00q0(Data,vrr_stack+76787, vrr_stack+9538, vrr_stack+70262, vrr_stack+9887, vrr_stack+47217, NULL);
 _BUILD_p0q0(Data,vrr_stack+76878, vrr_stack+75513, vrr_stack+76787, NULL, NULL, vrr_stack+9538);
 _BUILD_d0q0(Data,vrr_stack+37343, vrr_stack+48520, vrr_stack+76878, vrr_stack+75604, vrr_stack+75513, vrr_stack+2401);
 _BUILD_f0q0(Data,vrr_stack+15857, vrr_stack+77606, vrr_stack+37343, vrr_stack+75695, vrr_stack+48520, vrr_stack+2635);
 _BUILD_g0q0(Data,vrr_stack+16767, vrr_stack+36433, vrr_stack+15857, vrr_stack+76241, vrr_stack+77606, vrr_stack+9953);
 _BUILD_h0q0(Data,vrr_stack+121040, vrr_stack+86418, vrr_stack+16767, vrr_stack+85508, vrr_stack+36433, vrr_stack+20508);
 _BUILD_h0q0(Data,vrr_stack+122951, vrr_stack+48793, vrr_stack+86418, vrr_stack+14947, vrr_stack+85508, vrr_stack+62517);
 _BUILD_i0q0(Data,vrr_stack+124862, vrr_stack+122951, vrr_stack+121040, vrr_stack+48793, vrr_stack+86418, vrr_stack+21678);
 _BUILD_00q0(Data,vrr_stack+85508, vrr_stack+42717, vrr_stack+38521, vrr_stack+13072, vrr_stack+26547, NULL);
 _BUILD_p0q0(Data,vrr_stack+85599, vrr_stack+85508, vrr_stack+75422, NULL, NULL, vrr_stack+38521);
 _BUILD_d0q0(Data,vrr_stack+85872, vrr_stack+85599, vrr_stack+75968, vrr_stack+85508, vrr_stack+75422, vrr_stack+9304);
 _BUILD_f0q0(Data,vrr_stack+62283, vrr_stack+85872, vrr_stack+61737, vrr_stack+85599, vrr_stack+75968, vrr_stack+63687);
 _BUILD_g0q0(Data,vrr_stack+34967, vrr_stack+62283, vrr_stack+14947, vrr_stack+85872, vrr_stack+61737, vrr_stack+57533);
 _BUILD_h0q0(Data,vrr_stack+7549, vrr_stack+34967, vrr_stack+48793, vrr_stack+62283, vrr_stack+14947, vrr_stack+30622);
 _BUILD_i0q0(Data,vrr_stack+19990, vrr_stack+7549, vrr_stack+122951, vrr_stack+34967, vrr_stack+48793, vrr_stack+95144);
 _BUILD_00q0(Data,vrr_stack+75422, vrr_stack+70262, vrr_stack+13387, vrr_stack+47217, vrr_stack+55223, NULL);
 _BUILD_p0q0(Data,vrr_stack+47217, vrr_stack+76787, vrr_stack+75422, NULL, NULL, vrr_stack+70262);
 _BUILD_d0q0(Data,vrr_stack+61737, vrr_stack+76878, vrr_stack+47217, vrr_stack+75513, vrr_stack+76787, vrr_stack+29892);
 _BUILD_f0q0(Data,vrr_stack+14947, vrr_stack+37343, vrr_stack+61737, vrr_stack+48520, vrr_stack+76878, vrr_stack+70340);
 _BUILD_g0q0(Data,vrr_stack+29892, vrr_stack+15857, vrr_stack+14947, vrr_stack+77606, vrr_stack+37343, vrr_stack+70808);
 _BUILD_h0q0(Data,vrr_stack+47490, vrr_stack+16767, vrr_stack+29892, vrr_stack+36433, vrr_stack+15857, vrr_stack+43497);
 _BUILD_i0q0(Data,vrr_stack+127410, vrr_stack+121040, vrr_stack+47490, vrr_stack+86418, vrr_stack+16767, vrr_stack+0);
 _BUILD_k0q0(Data,vrr_stack+129958, vrr_stack+124862, vrr_stack+127410, vrr_stack+122951, vrr_stack+121040, vrr_stack+101150);
 _BUILD_k0q0(Data,vrr_stack+133234, vrr_stack+19990, vrr_stack+124862, vrr_stack+7549, vrr_stack+122951, vrr_stack+96782);
 _BUILD_l0q0(Data,vrr_stack+136510, vrr_stack+133234, vrr_stack+129958, vrr_stack+19990, vrr_stack+124862, vrr_stack+103334);
 _BUILD_00q0(Data,vrr_stack+122951, vrr_stack+75344, vrr_stack+42717, vrr_stack+54983, vrr_stack+13072, NULL);
 _BUILD_p0q0(Data,vrr_stack+123042, vrr_stack+122951, vrr_stack+85508, NULL, NULL, vrr_stack+42717);
 _BUILD_d0q0(Data,vrr_stack+123315, vrr_stack+123042, vrr_stack+85599, vrr_stack+122951, vrr_stack+85508, vrr_stack+42795);
 _BUILD_f0q0(Data,vrr_stack+123861, vrr_stack+123315, vrr_stack+85872, vrr_stack+123042, vrr_stack+85599, vrr_stack+43029);
 _BUILD_g0q0(Data,vrr_stack+42717, vrr_stack+123861, vrr_stack+62283, vrr_stack+123315, vrr_stack+85872, vrr_stack+26613);
 _BUILD_h0q0(Data,vrr_stack+85508, vrr_stack+42717, vrr_stack+34967, vrr_stack+123861, vrr_stack+62283, vrr_stack+10733);
 _BUILD_i0q0(Data,vrr_stack+101150, vrr_stack+85508, vrr_stack+7549, vrr_stack+42717, vrr_stack+34967, vrr_stack+18352);
 _BUILD_k0q0(Data,vrr_stack+95144, vrr_stack+101150, vrr_stack+19990, vrr_stack+85508, vrr_stack+7549, vrr_stack+98966);
   tmp = vrr_stack + 95144;
   target_ptr = Libint->vrr_classes[7][12];
   for(i=0;i<3276;i++)
     target_ptr[i] += tmp[i];
 _BUILD_l0q0(Data,vrr_stack+7549, vrr_stack+95144, vrr_stack+133234, vrr_stack+101150, vrr_stack+19990, vrr_stack+106142);
   tmp = vrr_stack + 7549;
   target_ptr = Libint->vrr_classes[8][12];
   for(i=0;i<4095;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00p0(Data,vrr_stack+11644, Data->F+21, Data->F+22, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+11647, vrr_stack+13138, vrr_stack+11644, Data->F+20, Data->F+21, NULL);
 _BUILD_00f0(Data,vrr_stack+11653, vrr_stack+13141, vrr_stack+11647, vrr_stack+55049, vrr_stack+13138, NULL);
 _BUILD_00g0(Data,vrr_stack+11663, vrr_stack+13147, vrr_stack+11653, vrr_stack+55052, vrr_stack+13141, NULL);
 _BUILD_00h0(Data,vrr_stack+11678, vrr_stack+13157, vrr_stack+11663, vrr_stack+55058, vrr_stack+13147, NULL);
 _BUILD_00i0(Data,vrr_stack+11644, vrr_stack+13172, vrr_stack+11678, vrr_stack+55068, vrr_stack+13157, NULL);
 _BUILD_00k0(Data,vrr_stack+11672, vrr_stack+13193, vrr_stack+11644, vrr_stack+55083, vrr_stack+13172, NULL);
 _BUILD_00l0(Data,vrr_stack+11708, vrr_stack+50613, vrr_stack+11672, vrr_stack+55104, vrr_stack+13193, NULL);
 _BUILD_00m0(Data,vrr_stack+11644, vrr_stack+13221, vrr_stack+11708, vrr_stack+55132, vrr_stack+50613, NULL);
 _BUILD_00n0(Data,vrr_stack+11699, vrr_stack+13266, vrr_stack+11644, vrr_stack+27867, vrr_stack+13221, NULL);
 _BUILD_00o0(Data,vrr_stack+11765, vrr_stack+13321, vrr_stack+11699, vrr_stack+55168, vrr_stack+13266, NULL);
 _BUILD_00q0(Data,vrr_stack+11644, vrr_stack+13387, vrr_stack+11765, vrr_stack+55223, vrr_stack+13321, NULL);
 _BUILD_p0q0(Data,vrr_stack+11735, vrr_stack+75422, vrr_stack+11644, NULL, NULL, vrr_stack+13387);
 _BUILD_d0q0(Data,vrr_stack+12008, vrr_stack+47217, vrr_stack+11735, vrr_stack+76787, vrr_stack+75422, vrr_stack+13465);
 _BUILD_f0q0(Data,vrr_stack+12554, vrr_stack+61737, vrr_stack+12008, vrr_stack+76878, vrr_stack+47217, vrr_stack+13699);
 _BUILD_g0q0(Data,vrr_stack+26547, vrr_stack+14947, vrr_stack+12554, vrr_stack+37343, vrr_stack+61737, vrr_stack+14167);
 _BUILD_h0q0(Data,vrr_stack+122951, vrr_stack+29892, vrr_stack+26547, vrr_stack+15857, vrr_stack+14947, vrr_stack+78230);
 _BUILD_i0q0(Data,vrr_stack+11644, vrr_stack+47490, vrr_stack+122951, vrr_stack+16767, vrr_stack+29892, vrr_stack+3103);
 _BUILD_k0q0(Data,vrr_stack+14192, vrr_stack+127410, vrr_stack+11644, vrr_stack+121040, vrr_stack+47490, vrr_stack+55289);
 _BUILD_l0q0(Data,vrr_stack+17468, vrr_stack+129958, vrr_stack+14192, vrr_stack+124862, vrr_stack+127410, vrr_stack+4741);
 _BUILD_m0q0(Data,vrr_stack+121040, vrr_stack+136510, vrr_stack+17468, vrr_stack+133234, vrr_stack+129958, vrr_stack+50649);
 _BUILD_m0q0(Data,vrr_stack+126045, vrr_stack+7549, vrr_stack+136510, vrr_stack+95144, vrr_stack+133234, vrr_stack+108950);
   tmp = vrr_stack + 126045;
   target_ptr = Libint->vrr_classes[9][12];
   for(i=0;i<5005;i++)
     target_ptr[i] += tmp[i];
 _BUILD_n0l0(Data,vrr_stack+95144, vrr_stack+24072, vrr_stack+44742, vrr_stack+40692, vrr_stack+38667, vrr_stack+27912);
   tmp = vrr_stack + 95144;
   target_ptr = Libint->vrr_classes[10][8];
   for(i=0;i<2970;i++)
     target_ptr[i] += tmp[i];
 _BUILD_n0m0(Data,vrr_stack+98114, vrr_stack+67237, vrr_stack+64212, vrr_stack+32492, vrr_stack+59262, vrr_stack+44742);
   tmp = vrr_stack + 98114;
   target_ptr = Libint->vrr_classes[10][9];
   for(i=0;i<3630;i++)
     target_ptr[i] += tmp[i];
 _BUILD_n0n0(Data,vrr_stack+101744, vrr_stack+91514, vrr_stack+87884, vrr_stack+82538, vrr_stack+79568, vrr_stack+64212);
   tmp = vrr_stack + 101744;
   target_ptr = Libint->vrr_classes[10][10];
   for(i=0;i<4356;i++)
     target_ptr[i] += tmp[i];
 _BUILD_n0o0(Data,vrr_stack+131050, vrr_stack+116750, vrr_stack+112460, vrr_stack+71588, vrr_stack+108950, vrr_stack+87884);
   tmp = vrr_stack + 131050;
   target_ptr = Libint->vrr_classes[10][11];
   for(i=0;i<5148;i++)
     target_ptr[i] += tmp[i];
 _BUILD_n0q0(Data,vrr_stack+106100, vrr_stack+126045, vrr_stack+121040, vrr_stack+7549, vrr_stack+136510, vrr_stack+112460);
   tmp = vrr_stack + 106100;
   target_ptr = Libint->vrr_classes[10][12];
   for(i=0;i<6006;i++)
     target_ptr[i] += tmp[i];

}

