/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include "libint.h"
#include "vrr_header.h"

  /* Computes quartets necessary to compute (md|li) integrals */

void vrr_order_mdli(Libint_t * Libint, prim_data *Data)
{
 REALTYPE *vrr_stack = Libint->vrr_stack;
 REALTYPE *tmp, *target_ptr;
 int i, am[2];
 _BUILD_p000(Data,vrr_stack+0, Data->F+9, Data->F+10, NULL, NULL, NULL);
 _BUILD_p000(Data,vrr_stack+3, Data->F+8, Data->F+9, NULL, NULL, NULL);
 _BUILD_p000(Data,vrr_stack+6, Data->F+10, Data->F+11, NULL, NULL, NULL);
 _BUILD_d000(Data,vrr_stack+9, vrr_stack+0, vrr_stack+6, Data->F+9, Data->F+10, NULL);
 _BUILD_d000(Data,vrr_stack+15, vrr_stack+3, vrr_stack+0, Data->F+8, Data->F+9, NULL);
 _BUILD_f000(Data,vrr_stack+21, vrr_stack+15, vrr_stack+9, vrr_stack+3, vrr_stack+0, NULL);
 _BUILD_00p0(Data,vrr_stack+31, Data->F+9, Data->F+10, NULL, NULL, NULL);
 _BUILD_00p0(Data,vrr_stack+34, Data->F+8, Data->F+9, NULL, NULL, NULL);
 _BUILD_00p0(Data,vrr_stack+37, Data->F+10, Data->F+11, NULL, NULL, NULL);
 _BUILD_p0p0(Data,vrr_stack+40, vrr_stack+31, vrr_stack+37, NULL, NULL, Data->F+10);
 _BUILD_p0p0(Data,vrr_stack+49, vrr_stack+34, vrr_stack+31, NULL, NULL, Data->F+9);
 _BUILD_d0p0(Data,vrr_stack+58, vrr_stack+49, vrr_stack+40, vrr_stack+34, vrr_stack+31, vrr_stack+0);
 _BUILD_00p0(Data,vrr_stack+0, Data->F+7, Data->F+8, NULL, NULL, NULL);
 _BUILD_p0p0(Data,vrr_stack+76, vrr_stack+0, vrr_stack+34, NULL, NULL, Data->F+8);
 _BUILD_d0p0(Data,vrr_stack+85, vrr_stack+76, vrr_stack+49, vrr_stack+0, vrr_stack+34, vrr_stack+3);
 _BUILD_00p0(Data,vrr_stack+3, Data->F+11, Data->F+12, NULL, NULL, NULL);
 _BUILD_p0p0(Data,vrr_stack+103, vrr_stack+37, vrr_stack+3, NULL, NULL, Data->F+11);
 _BUILD_d0p0(Data,vrr_stack+112, vrr_stack+40, vrr_stack+103, vrr_stack+31, vrr_stack+37, vrr_stack+6);
 _BUILD_f0p0(Data,vrr_stack+130, vrr_stack+58, vrr_stack+112, vrr_stack+49, vrr_stack+40, vrr_stack+9);
 _BUILD_f0p0(Data,vrr_stack+160, vrr_stack+85, vrr_stack+58, vrr_stack+76, vrr_stack+49, vrr_stack+15);
 _BUILD_g0p0(Data,vrr_stack+190, vrr_stack+160, vrr_stack+130, vrr_stack+85, vrr_stack+58, vrr_stack+21);
 _BUILD_00d0(Data,vrr_stack+6, vrr_stack+31, vrr_stack+37, Data->F+9, Data->F+10, NULL);
 _BUILD_00d0(Data,vrr_stack+12, vrr_stack+34, vrr_stack+31, Data->F+8, Data->F+9, NULL);
 _BUILD_p0d0(Data,vrr_stack+235, vrr_stack+12, vrr_stack+6, NULL, NULL, vrr_stack+31);
 _BUILD_00d0(Data,vrr_stack+18, vrr_stack+0, vrr_stack+34, Data->F+7, Data->F+8, NULL);
 _BUILD_p0d0(Data,vrr_stack+253, vrr_stack+18, vrr_stack+12, NULL, NULL, vrr_stack+34);
 _BUILD_00d0(Data,vrr_stack+24, vrr_stack+37, vrr_stack+3, Data->F+10, Data->F+11, NULL);
 _BUILD_p0d0(Data,vrr_stack+271, vrr_stack+6, vrr_stack+24, NULL, NULL, vrr_stack+37);
 _BUILD_d0d0(Data,vrr_stack+289, vrr_stack+235, vrr_stack+271, vrr_stack+12, vrr_stack+6, vrr_stack+40);
 _BUILD_d0d0(Data,vrr_stack+325, vrr_stack+253, vrr_stack+235, vrr_stack+18, vrr_stack+12, vrr_stack+49);
 _BUILD_f0d0(Data,vrr_stack+361, vrr_stack+325, vrr_stack+289, vrr_stack+253, vrr_stack+235, vrr_stack+58);
 _BUILD_00p0(Data,vrr_stack+40, Data->F+6, Data->F+7, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+43, vrr_stack+40, vrr_stack+0, Data->F+6, Data->F+7, NULL);
 _BUILD_p0d0(Data,vrr_stack+49, vrr_stack+43, vrr_stack+18, NULL, NULL, vrr_stack+0);
 _BUILD_d0d0(Data,vrr_stack+421, vrr_stack+49, vrr_stack+253, vrr_stack+43, vrr_stack+18, vrr_stack+76);
 _BUILD_f0d0(Data,vrr_stack+457, vrr_stack+421, vrr_stack+325, vrr_stack+49, vrr_stack+253, vrr_stack+85);
 _BUILD_00p0(Data,vrr_stack+67, Data->F+12, Data->F+13, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+70, vrr_stack+3, vrr_stack+67, Data->F+11, Data->F+12, NULL);
 _BUILD_p0d0(Data,vrr_stack+76, vrr_stack+24, vrr_stack+70, NULL, NULL, vrr_stack+3);
 _BUILD_d0d0(Data,vrr_stack+517, vrr_stack+271, vrr_stack+76, vrr_stack+6, vrr_stack+24, vrr_stack+103);
 _BUILD_f0d0(Data,vrr_stack+553, vrr_stack+289, vrr_stack+517, vrr_stack+235, vrr_stack+271, vrr_stack+112);
 _BUILD_g0d0(Data,vrr_stack+613, vrr_stack+361, vrr_stack+553, vrr_stack+325, vrr_stack+289, vrr_stack+130);
 _BUILD_g0d0(Data,vrr_stack+703, vrr_stack+457, vrr_stack+361, vrr_stack+421, vrr_stack+325, vrr_stack+160);
 _BUILD_h0d0(Data,vrr_stack+793, vrr_stack+703, vrr_stack+613, vrr_stack+457, vrr_stack+361, vrr_stack+190);
 _BUILD_00f0(Data,vrr_stack+94, vrr_stack+12, vrr_stack+6, vrr_stack+34, vrr_stack+31, NULL);
 _BUILD_00f0(Data,vrr_stack+104, vrr_stack+18, vrr_stack+12, vrr_stack+0, vrr_stack+34, NULL);
 _BUILD_00f0(Data,vrr_stack+114, vrr_stack+6, vrr_stack+24, vrr_stack+31, vrr_stack+37, NULL);
 _BUILD_p0f0(Data,vrr_stack+124, vrr_stack+94, vrr_stack+114, NULL, NULL, vrr_stack+6);
 _BUILD_p0f0(Data,vrr_stack+154, vrr_stack+104, vrr_stack+94, NULL, NULL, vrr_stack+12);
 _BUILD_d0f0(Data,vrr_stack+919, vrr_stack+154, vrr_stack+124, vrr_stack+104, vrr_stack+94, vrr_stack+235);
 _BUILD_00f0(Data,vrr_stack+184, vrr_stack+43, vrr_stack+18, vrr_stack+40, vrr_stack+0, NULL);
 _BUILD_p0f0(Data,vrr_stack+194, vrr_stack+184, vrr_stack+104, NULL, NULL, vrr_stack+18);
 _BUILD_d0f0(Data,vrr_stack+979, vrr_stack+194, vrr_stack+154, vrr_stack+184, vrr_stack+104, vrr_stack+253);
 _BUILD_00f0(Data,vrr_stack+224, vrr_stack+24, vrr_stack+70, vrr_stack+37, vrr_stack+3, NULL);
 _BUILD_p0f0(Data,vrr_stack+234, vrr_stack+114, vrr_stack+224, NULL, NULL, vrr_stack+24);
 _BUILD_d0f0(Data,vrr_stack+1039, vrr_stack+124, vrr_stack+234, vrr_stack+94, vrr_stack+114, vrr_stack+271);
 _BUILD_f0f0(Data,vrr_stack+1099, vrr_stack+919, vrr_stack+1039, vrr_stack+154, vrr_stack+124, vrr_stack+289);
 _BUILD_f0f0(Data,vrr_stack+1199, vrr_stack+979, vrr_stack+919, vrr_stack+194, vrr_stack+154, vrr_stack+325);
 _BUILD_g0f0(Data,vrr_stack+1299, vrr_stack+1199, vrr_stack+1099, vrr_stack+979, vrr_stack+919, vrr_stack+361);
 _BUILD_00p0(Data,vrr_stack+0, Data->F+5, Data->F+6, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+264, vrr_stack+0, vrr_stack+40, Data->F+5, Data->F+6, NULL);
 _BUILD_00f0(Data,vrr_stack+30, vrr_stack+264, vrr_stack+43, vrr_stack+0, vrr_stack+40, NULL);
 _BUILD_p0f0(Data,vrr_stack+270, vrr_stack+30, vrr_stack+184, NULL, NULL, vrr_stack+43);
 _BUILD_d0f0(Data,vrr_stack+300, vrr_stack+270, vrr_stack+194, vrr_stack+30, vrr_stack+184, vrr_stack+49);
 _BUILD_f0f0(Data,vrr_stack+1449, vrr_stack+300, vrr_stack+979, vrr_stack+270, vrr_stack+194, vrr_stack+421);
 _BUILD_g0f0(Data,vrr_stack+1549, vrr_stack+1449, vrr_stack+1199, vrr_stack+300, vrr_stack+979, vrr_stack+457);
 _BUILD_00p0(Data,vrr_stack+40, Data->F+13, Data->F+14, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+49, vrr_stack+67, vrr_stack+40, Data->F+12, Data->F+13, NULL);
 _BUILD_00f0(Data,vrr_stack+55, vrr_stack+70, vrr_stack+49, vrr_stack+3, vrr_stack+67, NULL);
 _BUILD_p0f0(Data,vrr_stack+360, vrr_stack+224, vrr_stack+55, NULL, NULL, vrr_stack+70);
 _BUILD_d0f0(Data,vrr_stack+390, vrr_stack+234, vrr_stack+360, vrr_stack+114, vrr_stack+224, vrr_stack+76);
 _BUILD_f0f0(Data,vrr_stack+1699, vrr_stack+1039, vrr_stack+390, vrr_stack+124, vrr_stack+234, vrr_stack+517);
 _BUILD_g0f0(Data,vrr_stack+1799, vrr_stack+1099, vrr_stack+1699, vrr_stack+919, vrr_stack+1039, vrr_stack+553);
 _BUILD_h0f0(Data,vrr_stack+1949, vrr_stack+1299, vrr_stack+1799, vrr_stack+1199, vrr_stack+1099, vrr_stack+613);
 _BUILD_h0f0(Data,vrr_stack+450, vrr_stack+1549, vrr_stack+1299, vrr_stack+1449, vrr_stack+1199, vrr_stack+703);
 _BUILD_i0f0(Data,vrr_stack+2159, vrr_stack+450, vrr_stack+1949, vrr_stack+1549, vrr_stack+1299, vrr_stack+793);
 _BUILD_00g0(Data,vrr_stack+76, vrr_stack+94, vrr_stack+114, vrr_stack+12, vrr_stack+6, NULL);
 _BUILD_00g0(Data,vrr_stack+660, vrr_stack+104, vrr_stack+94, vrr_stack+18, vrr_stack+12, NULL);
 _BUILD_p0g0(Data,vrr_stack+675, vrr_stack+660, vrr_stack+76, NULL, NULL, vrr_stack+94);
 _BUILD_00g0(Data,vrr_stack+720, vrr_stack+184, vrr_stack+104, vrr_stack+43, vrr_stack+18, NULL);
 _BUILD_p0g0(Data,vrr_stack+735, vrr_stack+720, vrr_stack+660, NULL, NULL, vrr_stack+104);
 _BUILD_00g0(Data,vrr_stack+780, vrr_stack+114, vrr_stack+224, vrr_stack+6, vrr_stack+24, NULL);
 _BUILD_p0g0(Data,vrr_stack+795, vrr_stack+76, vrr_stack+780, NULL, NULL, vrr_stack+114);
 _BUILD_d0g0(Data,vrr_stack+2439, vrr_stack+675, vrr_stack+795, vrr_stack+660, vrr_stack+76, vrr_stack+124);
 _BUILD_d0g0(Data,vrr_stack+2529, vrr_stack+735, vrr_stack+675, vrr_stack+720, vrr_stack+660, vrr_stack+154);
 _BUILD_f0g0(Data,vrr_stack+2619, vrr_stack+2529, vrr_stack+2439, vrr_stack+735, vrr_stack+675, vrr_stack+919);
 _BUILD_00g0(Data,vrr_stack+124, vrr_stack+30, vrr_stack+184, vrr_stack+264, vrr_stack+43, NULL);
 _BUILD_p0g0(Data,vrr_stack+139, vrr_stack+124, vrr_stack+720, NULL, NULL, vrr_stack+184);
 _BUILD_d0g0(Data,vrr_stack+840, vrr_stack+139, vrr_stack+735, vrr_stack+124, vrr_stack+720, vrr_stack+194);
 _BUILD_f0g0(Data,vrr_stack+2769, vrr_stack+840, vrr_stack+2529, vrr_stack+139, vrr_stack+735, vrr_stack+979);
 _BUILD_00g0(Data,vrr_stack+194, vrr_stack+224, vrr_stack+55, vrr_stack+24, vrr_stack+70, NULL);
 _BUILD_p0g0(Data,vrr_stack+930, vrr_stack+780, vrr_stack+194, NULL, NULL, vrr_stack+224);
 _BUILD_d0g0(Data,vrr_stack+2919, vrr_stack+795, vrr_stack+930, vrr_stack+76, vrr_stack+780, vrr_stack+234);
 _BUILD_f0g0(Data,vrr_stack+3009, vrr_stack+2439, vrr_stack+2919, vrr_stack+675, vrr_stack+795, vrr_stack+1039);
 _BUILD_g0g0(Data,vrr_stack+3159, vrr_stack+2619, vrr_stack+3009, vrr_stack+2529, vrr_stack+2439, vrr_stack+1099);
 _BUILD_g0g0(Data,vrr_stack+3384, vrr_stack+2769, vrr_stack+2619, vrr_stack+840, vrr_stack+2529, vrr_stack+1199);
 _BUILD_h0g0(Data,vrr_stack+975, vrr_stack+3384, vrr_stack+3159, vrr_stack+2769, vrr_stack+2619, vrr_stack+1299);
 _BUILD_00p0(Data,vrr_stack+91, Data->F+4, Data->F+5, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+43, vrr_stack+91, vrr_stack+0, Data->F+4, Data->F+5, NULL);
 _BUILD_00f0(Data,vrr_stack+234, vrr_stack+43, vrr_stack+264, vrr_stack+91, vrr_stack+0, NULL);
 _BUILD_00g0(Data,vrr_stack+209, vrr_stack+234, vrr_stack+30, vrr_stack+43, vrr_stack+264, NULL);
 _BUILD_p0g0(Data,vrr_stack+1290, vrr_stack+209, vrr_stack+124, NULL, NULL, vrr_stack+30);
 _BUILD_d0g0(Data,vrr_stack+1335, vrr_stack+1290, vrr_stack+139, vrr_stack+209, vrr_stack+124, vrr_stack+270);
 _BUILD_f0g0(Data,vrr_stack+3609, vrr_stack+1335, vrr_stack+840, vrr_stack+1290, vrr_stack+139, vrr_stack+300);
 _BUILD_g0g0(Data,vrr_stack+3759, vrr_stack+3609, vrr_stack+2769, vrr_stack+1335, vrr_stack+840, vrr_stack+1449);
 _BUILD_h0g0(Data,vrr_stack+3984, vrr_stack+3759, vrr_stack+3384, vrr_stack+3609, vrr_stack+2769, vrr_stack+1549);
 _BUILD_00p0(Data,vrr_stack+0, Data->F+14, Data->F+15, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+3, vrr_stack+40, vrr_stack+0, Data->F+13, Data->F+14, NULL);
 _BUILD_00f0(Data,vrr_stack+9, vrr_stack+49, vrr_stack+3, vrr_stack+67, vrr_stack+40, NULL);
 _BUILD_00g0(Data,vrr_stack+244, vrr_stack+55, vrr_stack+9, vrr_stack+70, vrr_stack+49, NULL);
 _BUILD_p0g0(Data,vrr_stack+259, vrr_stack+194, vrr_stack+244, NULL, NULL, vrr_stack+55);
 _BUILD_d0g0(Data,vrr_stack+1425, vrr_stack+930, vrr_stack+259, vrr_stack+780, vrr_stack+194, vrr_stack+360);
 _BUILD_f0g0(Data,vrr_stack+1515, vrr_stack+2919, vrr_stack+1425, vrr_stack+795, vrr_stack+930, vrr_stack+390);
 _BUILD_g0g0(Data,vrr_stack+4299, vrr_stack+3009, vrr_stack+1515, vrr_stack+2439, vrr_stack+2919, vrr_stack+1699);
 _BUILD_h0g0(Data,vrr_stack+4524, vrr_stack+3159, vrr_stack+4299, vrr_stack+2619, vrr_stack+3009, vrr_stack+1799);
 _BUILD_i0g0(Data,vrr_stack+4839, vrr_stack+975, vrr_stack+4524, vrr_stack+3384, vrr_stack+3159, vrr_stack+1949);
 _BUILD_i0g0(Data,vrr_stack+1665, vrr_stack+3984, vrr_stack+975, vrr_stack+3759, vrr_stack+3384, vrr_stack+450);
 _BUILD_k0g0(Data,vrr_stack+5259, vrr_stack+1665, vrr_stack+4839, vrr_stack+3984, vrr_stack+975, vrr_stack+2159);
 _BUILD_00h0(Data,vrr_stack+304, vrr_stack+660, vrr_stack+76, vrr_stack+104, vrr_stack+94, NULL);
 _BUILD_00h0(Data,vrr_stack+325, vrr_stack+720, vrr_stack+660, vrr_stack+184, vrr_stack+104, NULL);
 _BUILD_00h0(Data,vrr_stack+346, vrr_stack+76, vrr_stack+780, vrr_stack+94, vrr_stack+114, NULL);
 _BUILD_p0h0(Data,vrr_stack+367, vrr_stack+304, vrr_stack+346, NULL, NULL, vrr_stack+76);
 _BUILD_p0h0(Data,vrr_stack+430, vrr_stack+325, vrr_stack+304, NULL, NULL, vrr_stack+660);
 _BUILD_d0h0(Data,vrr_stack+493, vrr_stack+430, vrr_stack+367, vrr_stack+325, vrr_stack+304, vrr_stack+675);
 _BUILD_00h0(Data,vrr_stack+675, vrr_stack+124, vrr_stack+720, vrr_stack+30, vrr_stack+184, NULL);
 _BUILD_p0h0(Data,vrr_stack+2085, vrr_stack+675, vrr_stack+325, NULL, NULL, vrr_stack+720);
 _BUILD_d0h0(Data,vrr_stack+2148, vrr_stack+2085, vrr_stack+430, vrr_stack+675, vrr_stack+325, vrr_stack+735);
 _BUILD_00h0(Data,vrr_stack+735, vrr_stack+780, vrr_stack+194, vrr_stack+114, vrr_stack+224, NULL);
 _BUILD_p0h0(Data,vrr_stack+2274, vrr_stack+346, vrr_stack+735, NULL, NULL, vrr_stack+780);
 _BUILD_d0h0(Data,vrr_stack+5799, vrr_stack+367, vrr_stack+2274, vrr_stack+304, vrr_stack+346, vrr_stack+795);
 _BUILD_f0h0(Data,vrr_stack+5925, vrr_stack+493, vrr_stack+5799, vrr_stack+430, vrr_stack+367, vrr_stack+2439);
 _BUILD_f0h0(Data,vrr_stack+6135, vrr_stack+2148, vrr_stack+493, vrr_stack+2085, vrr_stack+430, vrr_stack+2529);
 _BUILD_g0h0(Data,vrr_stack+6345, vrr_stack+6135, vrr_stack+5925, vrr_stack+2148, vrr_stack+493, vrr_stack+2619);
 _BUILD_00h0(Data,vrr_stack+795, vrr_stack+209, vrr_stack+124, vrr_stack+234, vrr_stack+30, NULL);
 _BUILD_p0h0(Data,vrr_stack+2337, vrr_stack+795, vrr_stack+675, NULL, NULL, vrr_stack+124);
 _BUILD_d0h0(Data,vrr_stack+2400, vrr_stack+2337, vrr_stack+2085, vrr_stack+795, vrr_stack+675, vrr_stack+139);
 _BUILD_f0h0(Data,vrr_stack+2526, vrr_stack+2400, vrr_stack+2148, vrr_stack+2337, vrr_stack+2085, vrr_stack+840);
 _BUILD_g0h0(Data,vrr_stack+6660, vrr_stack+2526, vrr_stack+6135, vrr_stack+2400, vrr_stack+2148, vrr_stack+2769);
 _BUILD_00h0(Data,vrr_stack+19, vrr_stack+194, vrr_stack+244, vrr_stack+224, vrr_stack+55, NULL);
 _BUILD_p0h0(Data,vrr_stack+816, vrr_stack+735, vrr_stack+19, NULL, NULL, vrr_stack+194);
 _BUILD_d0h0(Data,vrr_stack+2736, vrr_stack+2274, vrr_stack+816, vrr_stack+346, vrr_stack+735, vrr_stack+930);
 _BUILD_f0h0(Data,vrr_stack+6975, vrr_stack+5799, vrr_stack+2736, vrr_stack+367, vrr_stack+2274, vrr_stack+2919);
 _BUILD_g0h0(Data,vrr_stack+7185, vrr_stack+5925, vrr_stack+6975, vrr_stack+493, vrr_stack+5799, vrr_stack+3009);
 _BUILD_h0h0(Data,vrr_stack+7500, vrr_stack+6345, vrr_stack+7185, vrr_stack+6135, vrr_stack+5925, vrr_stack+3159);
 _BUILD_h0h0(Data,vrr_stack+2862, vrr_stack+6660, vrr_stack+6345, vrr_stack+2526, vrr_stack+6135, vrr_stack+3384);
 _BUILD_i0h0(Data,vrr_stack+7941, vrr_stack+2862, vrr_stack+7500, vrr_stack+6660, vrr_stack+6345, vrr_stack+975);
 _BUILD_00p0(Data,vrr_stack+224, Data->F+3, Data->F+4, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+227, vrr_stack+224, vrr_stack+91, Data->F+3, Data->F+4, NULL);
 _BUILD_00f0(Data,vrr_stack+139, vrr_stack+227, vrr_stack+43, vrr_stack+224, vrr_stack+91, NULL);
 _BUILD_00g0(Data,vrr_stack+91, vrr_stack+139, vrr_stack+234, vrr_stack+227, vrr_stack+43, NULL);
 _BUILD_00h0(Data,vrr_stack+149, vrr_stack+91, vrr_stack+209, vrr_stack+139, vrr_stack+234, NULL);
 _BUILD_p0h0(Data,vrr_stack+879, vrr_stack+149, vrr_stack+795, NULL, NULL, vrr_stack+209);
 _BUILD_d0h0(Data,vrr_stack+942, vrr_stack+879, vrr_stack+2337, vrr_stack+149, vrr_stack+795, vrr_stack+1290);
 _BUILD_f0h0(Data,vrr_stack+1068, vrr_stack+942, vrr_stack+2400, vrr_stack+879, vrr_stack+2337, vrr_stack+1335);
 _BUILD_g0h0(Data,vrr_stack+8529, vrr_stack+1068, vrr_stack+2526, vrr_stack+942, vrr_stack+2400, vrr_stack+3609);
 _BUILD_h0h0(Data,vrr_stack+3303, vrr_stack+8529, vrr_stack+6660, vrr_stack+1068, vrr_stack+2526, vrr_stack+3759);
 _BUILD_i0h0(Data,vrr_stack+8844, vrr_stack+3303, vrr_stack+2862, vrr_stack+8529, vrr_stack+6660, vrr_stack+3984);
 _BUILD_00p0(Data,vrr_stack+43, Data->F+15, Data->F+16, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+106, vrr_stack+0, vrr_stack+43, Data->F+14, Data->F+15, NULL);
 _BUILD_00f0(Data,vrr_stack+112, vrr_stack+3, vrr_stack+106, vrr_stack+40, vrr_stack+0, NULL);
 _BUILD_00g0(Data,vrr_stack+170, vrr_stack+9, vrr_stack+112, vrr_stack+49, vrr_stack+3, NULL);
 _BUILD_00h0(Data,vrr_stack+1278, vrr_stack+244, vrr_stack+170, vrr_stack+55, vrr_stack+9, NULL);
 _BUILD_p0h0(Data,vrr_stack+1299, vrr_stack+19, vrr_stack+1278, NULL, NULL, vrr_stack+244);
 _BUILD_d0h0(Data,vrr_stack+3744, vrr_stack+816, vrr_stack+1299, vrr_stack+735, vrr_stack+19, vrr_stack+259);
 _BUILD_f0h0(Data,vrr_stack+3870, vrr_stack+2736, vrr_stack+3744, vrr_stack+2274, vrr_stack+816, vrr_stack+1425);
 _BUILD_g0h0(Data,vrr_stack+9432, vrr_stack+6975, vrr_stack+3870, vrr_stack+5799, vrr_stack+2736, vrr_stack+1515);
 _BUILD_h0h0(Data,vrr_stack+9747, vrr_stack+7185, vrr_stack+9432, vrr_stack+5925, vrr_stack+6975, vrr_stack+4299);
 _BUILD_i0h0(Data,vrr_stack+10188, vrr_stack+7500, vrr_stack+9747, vrr_stack+6345, vrr_stack+7185, vrr_stack+4524);
 _BUILD_k0h0(Data,vrr_stack+4080, vrr_stack+7941, vrr_stack+10188, vrr_stack+2862, vrr_stack+7500, vrr_stack+4839);
 _BUILD_k0h0(Data,vrr_stack+10776, vrr_stack+8844, vrr_stack+7941, vrr_stack+3303, vrr_stack+2862, vrr_stack+1665);
 _BUILD_l0h0(Data,vrr_stack+11532, vrr_stack+10776, vrr_stack+4080, vrr_stack+8844, vrr_stack+7941, vrr_stack+5259);
 _BUILD_00i0(Data,vrr_stack+259, vrr_stack+304, vrr_stack+346, vrr_stack+660, vrr_stack+76, NULL);
 _BUILD_00i0(Data,vrr_stack+46, vrr_stack+325, vrr_stack+304, vrr_stack+720, vrr_stack+660, NULL);
 _BUILD_p0i0(Data,vrr_stack+1362, vrr_stack+46, vrr_stack+259, NULL, NULL, vrr_stack+304);
 _BUILD_00i0(Data,vrr_stack+1446, vrr_stack+675, vrr_stack+325, vrr_stack+124, vrr_stack+720, NULL);
 _BUILD_p0i0(Data,vrr_stack+1474, vrr_stack+1446, vrr_stack+46, NULL, NULL, vrr_stack+325);
 _BUILD_00i0(Data,vrr_stack+1558, vrr_stack+346, vrr_stack+735, vrr_stack+76, vrr_stack+780, NULL);
 _BUILD_p0i0(Data,vrr_stack+1586, vrr_stack+259, vrr_stack+1558, NULL, NULL, vrr_stack+346);
 _BUILD_d0i0(Data,vrr_stack+1670, vrr_stack+1362, vrr_stack+1586, vrr_stack+46, vrr_stack+259, vrr_stack+367);
 _BUILD_d0i0(Data,vrr_stack+1838, vrr_stack+1474, vrr_stack+1362, vrr_stack+1446, vrr_stack+46, vrr_stack+430);
 _BUILD_f0i0(Data,vrr_stack+4836, vrr_stack+1838, vrr_stack+1670, vrr_stack+1474, vrr_stack+1362, vrr_stack+493);
 _BUILD_00i0(Data,vrr_stack+367, vrr_stack+795, vrr_stack+675, vrr_stack+209, vrr_stack+124, NULL);
 _BUILD_p0i0(Data,vrr_stack+395, vrr_stack+367, vrr_stack+1446, NULL, NULL, vrr_stack+675);
 _BUILD_d0i0(Data,vrr_stack+479, vrr_stack+395, vrr_stack+1474, vrr_stack+367, vrr_stack+1446, vrr_stack+2085);
 _BUILD_f0i0(Data,vrr_stack+5116, vrr_stack+479, vrr_stack+1838, vrr_stack+395, vrr_stack+1474, vrr_stack+2148);
 _BUILD_00i0(Data,vrr_stack+647, vrr_stack+735, vrr_stack+19, vrr_stack+780, vrr_stack+194, NULL);
 _BUILD_p0i0(Data,vrr_stack+2006, vrr_stack+1558, vrr_stack+647, NULL, NULL, vrr_stack+735);
 _BUILD_d0i0(Data,vrr_stack+2090, vrr_stack+1586, vrr_stack+2006, vrr_stack+259, vrr_stack+1558, vrr_stack+2274);
 _BUILD_f0i0(Data,vrr_stack+5396, vrr_stack+1670, vrr_stack+2090, vrr_stack+1362, vrr_stack+1586, vrr_stack+5799);
 _BUILD_g0i0(Data,vrr_stack+12477, vrr_stack+4836, vrr_stack+5396, vrr_stack+1838, vrr_stack+1670, vrr_stack+5925);
 _BUILD_g0i0(Data,vrr_stack+5676, vrr_stack+5116, vrr_stack+4836, vrr_stack+479, vrr_stack+1838, vrr_stack+6135);
 _BUILD_h0i0(Data,vrr_stack+12897, vrr_stack+5676, vrr_stack+12477, vrr_stack+5116, vrr_stack+4836, vrr_stack+6345);
 _BUILD_00i0(Data,vrr_stack+2258, vrr_stack+149, vrr_stack+795, vrr_stack+91, vrr_stack+209, NULL);
 _BUILD_p0i0(Data,vrr_stack+6096, vrr_stack+2258, vrr_stack+367, NULL, NULL, vrr_stack+795);
 _BUILD_d0i0(Data,vrr_stack+6180, vrr_stack+6096, vrr_stack+395, vrr_stack+2258, vrr_stack+367, vrr_stack+2337);
 _BUILD_f0i0(Data,vrr_stack+6348, vrr_stack+6180, vrr_stack+479, vrr_stack+6096, vrr_stack+395, vrr_stack+2400);
 _BUILD_g0i0(Data,vrr_stack+13485, vrr_stack+6348, vrr_stack+5116, vrr_stack+6180, vrr_stack+479, vrr_stack+2526);
 _BUILD_h0i0(Data,vrr_stack+13905, vrr_stack+13485, vrr_stack+5676, vrr_stack+6348, vrr_stack+5116, vrr_stack+6660);
 _BUILD_00i0(Data,vrr_stack+2286, vrr_stack+19, vrr_stack+1278, vrr_stack+194, vrr_stack+244, NULL);
 _BUILD_p0i0(Data,vrr_stack+2314, vrr_stack+647, vrr_stack+2286, NULL, NULL, vrr_stack+19);
 _BUILD_d0i0(Data,vrr_stack+2398, vrr_stack+2006, vrr_stack+2314, vrr_stack+1558, vrr_stack+647, vrr_stack+816);
 _BUILD_f0i0(Data,vrr_stack+6628, vrr_stack+2090, vrr_stack+2398, vrr_stack+1586, vrr_stack+2006, vrr_stack+2736);
 _BUILD_g0i0(Data,vrr_stack+14493, vrr_stack+5396, vrr_stack+6628, vrr_stack+1670, vrr_stack+2090, vrr_stack+6975);
 _BUILD_h0i0(Data,vrr_stack+14913, vrr_stack+12477, vrr_stack+14493, vrr_stack+4836, vrr_stack+5396, vrr_stack+7185);
 _BUILD_i0i0(Data,vrr_stack+15501, vrr_stack+12897, vrr_stack+14913, vrr_stack+5676, vrr_stack+12477, vrr_stack+7500);
 _BUILD_i0i0(Data,vrr_stack+6908, vrr_stack+13905, vrr_stack+12897, vrr_stack+13485, vrr_stack+5676, vrr_stack+2862);
 _BUILD_k0i0(Data,vrr_stack+16285, vrr_stack+6908, vrr_stack+15501, vrr_stack+13905, vrr_stack+12897, vrr_stack+7941);
 _BUILD_00p0(Data,vrr_stack+40, Data->F+2, Data->F+3, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+816, vrr_stack+40, vrr_stack+224, Data->F+2, Data->F+3, NULL);
 _BUILD_00f0(Data,vrr_stack+822, vrr_stack+816, vrr_stack+227, vrr_stack+40, vrr_stack+224, NULL);
 _BUILD_00g0(Data,vrr_stack+832, vrr_stack+822, vrr_stack+139, vrr_stack+816, vrr_stack+227, NULL);
 _BUILD_00h0(Data,vrr_stack+847, vrr_stack+832, vrr_stack+91, vrr_stack+822, vrr_stack+139, NULL);
 _BUILD_00i0(Data,vrr_stack+185, vrr_stack+847, vrr_stack+149, vrr_stack+832, vrr_stack+91, NULL);
 _BUILD_p0i0(Data,vrr_stack+2566, vrr_stack+185, vrr_stack+2258, NULL, NULL, vrr_stack+149);
 _BUILD_d0i0(Data,vrr_stack+2650, vrr_stack+2566, vrr_stack+6096, vrr_stack+185, vrr_stack+2258, vrr_stack+879);
 _BUILD_f0i0(Data,vrr_stack+2818, vrr_stack+2650, vrr_stack+6180, vrr_stack+2566, vrr_stack+6096, vrr_stack+942);
 _BUILD_g0i0(Data,vrr_stack+7692, vrr_stack+2818, vrr_stack+6348, vrr_stack+2650, vrr_stack+6180, vrr_stack+1068);
 _BUILD_h0i0(Data,vrr_stack+17293, vrr_stack+7692, vrr_stack+13485, vrr_stack+2818, vrr_stack+6348, vrr_stack+8529);
 _BUILD_i0i0(Data,vrr_stack+17881, vrr_stack+17293, vrr_stack+13905, vrr_stack+7692, vrr_stack+13485, vrr_stack+3303);
 _BUILD_k0i0(Data,vrr_stack+18665, vrr_stack+17881, vrr_stack+6908, vrr_stack+17293, vrr_stack+13905, vrr_stack+8844);
 _BUILD_00p0(Data,vrr_stack+868, Data->F+16, Data->F+17, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+871, vrr_stack+43, vrr_stack+868, Data->F+15, Data->F+16, NULL);
 _BUILD_00f0(Data,vrr_stack+877, vrr_stack+106, vrr_stack+871, vrr_stack+0, vrr_stack+43, NULL);
 _BUILD_00g0(Data,vrr_stack+887, vrr_stack+112, vrr_stack+877, vrr_stack+3, vrr_stack+106, NULL);
 _BUILD_00h0(Data,vrr_stack+902, vrr_stack+170, vrr_stack+887, vrr_stack+9, vrr_stack+112, NULL);
 _BUILD_00i0(Data,vrr_stack+923, vrr_stack+1278, vrr_stack+902, vrr_stack+244, vrr_stack+170, NULL);
 _BUILD_p0i0(Data,vrr_stack+951, vrr_stack+2286, vrr_stack+923, NULL, NULL, vrr_stack+1278);
 _BUILD_d0i0(Data,vrr_stack+1035, vrr_stack+2314, vrr_stack+951, vrr_stack+647, vrr_stack+2286, vrr_stack+1299);
 _BUILD_f0i0(Data,vrr_stack+3098, vrr_stack+2398, vrr_stack+1035, vrr_stack+2006, vrr_stack+2314, vrr_stack+3744);
 _BUILD_g0i0(Data,vrr_stack+3378, vrr_stack+6628, vrr_stack+3098, vrr_stack+2090, vrr_stack+2398, vrr_stack+3870);
 _BUILD_h0i0(Data,vrr_stack+8112, vrr_stack+14493, vrr_stack+3378, vrr_stack+5396, vrr_stack+6628, vrr_stack+9432);
 _BUILD_i0i0(Data,vrr_stack+8700, vrr_stack+14913, vrr_stack+8112, vrr_stack+12477, vrr_stack+14493, vrr_stack+9747);
 _BUILD_k0i0(Data,vrr_stack+19673, vrr_stack+15501, vrr_stack+8700, vrr_stack+12897, vrr_stack+14913, vrr_stack+10188);
 _BUILD_l0i0(Data,vrr_stack+9484, vrr_stack+16285, vrr_stack+19673, vrr_stack+6908, vrr_stack+15501, vrr_stack+4080);
 _BUILD_l0i0(Data,vrr_stack+20681, vrr_stack+18665, vrr_stack+16285, vrr_stack+17881, vrr_stack+6908, vrr_stack+10776);
 _BUILD_m0i0(Data,vrr_stack+21941, vrr_stack+20681, vrr_stack+9484, vrr_stack+18665, vrr_stack+16285, vrr_stack+11532);
 _BUILD_00k0(Data,vrr_stack+1299, vrr_stack+46, vrr_stack+259, vrr_stack+325, vrr_stack+304, NULL);
 _BUILD_00k0(Data,vrr_stack+1203, vrr_stack+1446, vrr_stack+46, vrr_stack+675, vrr_stack+325, NULL);
 _BUILD_00k0(Data,vrr_stack+1239, vrr_stack+259, vrr_stack+1558, vrr_stack+304, vrr_stack+346, NULL);
 _BUILD_p0k0(Data,vrr_stack+3798, vrr_stack+1299, vrr_stack+1239, NULL, NULL, vrr_stack+259);
 _BUILD_p0k0(Data,vrr_stack+3906, vrr_stack+1203, vrr_stack+1299, NULL, NULL, vrr_stack+46);
 _BUILD_d0k0(Data,vrr_stack+4014, vrr_stack+3906, vrr_stack+3798, vrr_stack+1203, vrr_stack+1299, vrr_stack+1362);
 _BUILD_00k0(Data,vrr_stack+1335, vrr_stack+367, vrr_stack+1446, vrr_stack+795, vrr_stack+675, NULL);
 _BUILD_p0k0(Data,vrr_stack+4230, vrr_stack+1335, vrr_stack+1203, NULL, NULL, vrr_stack+1446);
 _BUILD_d0k0(Data,vrr_stack+4338, vrr_stack+4230, vrr_stack+3906, vrr_stack+1335, vrr_stack+1203, vrr_stack+1474);
 _BUILD_00k0(Data,vrr_stack+1474, vrr_stack+1558, vrr_stack+647, vrr_stack+346, vrr_stack+735, NULL);
 _BUILD_p0k0(Data,vrr_stack+4554, vrr_stack+1239, vrr_stack+1474, NULL, NULL, vrr_stack+1558);
 _BUILD_d0k0(Data,vrr_stack+10744, vrr_stack+3798, vrr_stack+4554, vrr_stack+1299, vrr_stack+1239, vrr_stack+1586);
 _BUILD_f0k0(Data,vrr_stack+10960, vrr_stack+4014, vrr_stack+10744, vrr_stack+3906, vrr_stack+3798, vrr_stack+1670);
 _BUILD_f0k0(Data,vrr_stack+11320, vrr_stack+4338, vrr_stack+4014, vrr_stack+4230, vrr_stack+3906, vrr_stack+1838);
 _BUILD_g0k0(Data,vrr_stack+11680, vrr_stack+11320, vrr_stack+10960, vrr_stack+4338, vrr_stack+4014, vrr_stack+4836);
 _BUILD_00k0(Data,vrr_stack+1586, vrr_stack+2258, vrr_stack+367, vrr_stack+149, vrr_stack+795, NULL);
 _BUILD_p0k0(Data,vrr_stack+1622, vrr_stack+1586, vrr_stack+1335, NULL, NULL, vrr_stack+367);
 _BUILD_d0k0(Data,vrr_stack+1730, vrr_stack+1622, vrr_stack+4230, vrr_stack+1586, vrr_stack+1335, vrr_stack+395);
 _BUILD_f0k0(Data,vrr_stack+4662, vrr_stack+1730, vrr_stack+4338, vrr_stack+1622, vrr_stack+4230, vrr_stack+479);
 _BUILD_g0k0(Data,vrr_stack+23481, vrr_stack+4662, vrr_stack+11320, vrr_stack+1730, vrr_stack+4338, vrr_stack+5116);
 _BUILD_00k0(Data,vrr_stack+395, vrr_stack+647, vrr_stack+2286, vrr_stack+735, vrr_stack+19, NULL);
 _BUILD_p0k0(Data,vrr_stack+431, vrr_stack+1474, vrr_stack+395, NULL, NULL, vrr_stack+647);
 _BUILD_d0k0(Data,vrr_stack+5022, vrr_stack+4554, vrr_stack+431, vrr_stack+1239, vrr_stack+1474, vrr_stack+2006);
 _BUILD_f0k0(Data,vrr_stack+24021, vrr_stack+10744, vrr_stack+5022, vrr_stack+3798, vrr_stack+4554, vrr_stack+2090);
 _BUILD_g0k0(Data,vrr_stack+24381, vrr_stack+10960, vrr_stack+24021, vrr_stack+4014, vrr_stack+10744, vrr_stack+5396);
 _BUILD_h0k0(Data,vrr_stack+24921, vrr_stack+11680, vrr_stack+24381, vrr_stack+11320, vrr_stack+10960, vrr_stack+12477);
 _BUILD_h0k0(Data,vrr_stack+25677, vrr_stack+23481, vrr_stack+11680, vrr_stack+4662, vrr_stack+11320, vrr_stack+5676);
 _BUILD_i0k0(Data,vrr_stack+26433, vrr_stack+25677, vrr_stack+24921, vrr_stack+23481, vrr_stack+11680, vrr_stack+12897);
 _BUILD_00k0(Data,vrr_stack+539, vrr_stack+185, vrr_stack+2258, vrr_stack+847, vrr_stack+149, NULL);
 _BUILD_p0k0(Data,vrr_stack+1946, vrr_stack+539, vrr_stack+1586, NULL, NULL, vrr_stack+2258);
 _BUILD_d0k0(Data,vrr_stack+5238, vrr_stack+1946, vrr_stack+1622, vrr_stack+539, vrr_stack+1586, vrr_stack+6096);
 _BUILD_f0k0(Data,vrr_stack+5454, vrr_stack+5238, vrr_stack+1730, vrr_stack+1946, vrr_stack+1622, vrr_stack+6180);
 _BUILD_g0k0(Data,vrr_stack+12220, vrr_stack+5454, vrr_stack+4662, vrr_stack+5238, vrr_stack+1730, vrr_stack+6348);
 _BUILD_h0k0(Data,vrr_stack+5814, vrr_stack+12220, vrr_stack+23481, vrr_stack+5454, vrr_stack+4662, vrr_stack+13485);
 _BUILD_i0k0(Data,vrr_stack+12760, vrr_stack+5814, vrr_stack+25677, vrr_stack+12220, vrr_stack+23481, vrr_stack+13905);
 _BUILD_00k0(Data,vrr_stack+575, vrr_stack+2286, vrr_stack+923, vrr_stack+19, vrr_stack+1278, NULL);
 _BUILD_p0k0(Data,vrr_stack+2054, vrr_stack+395, vrr_stack+575, NULL, NULL, vrr_stack+2286);
 _BUILD_d0k0(Data,vrr_stack+13768, vrr_stack+431, vrr_stack+2054, vrr_stack+1474, vrr_stack+395, vrr_stack+2314);
 _BUILD_f0k0(Data,vrr_stack+13984, vrr_stack+5022, vrr_stack+13768, vrr_stack+4554, vrr_stack+431, vrr_stack+2398);
 _BUILD_g0k0(Data,vrr_stack+27441, vrr_stack+24021, vrr_stack+13984, vrr_stack+10744, vrr_stack+5022, vrr_stack+6628);
 _BUILD_h0k0(Data,vrr_stack+27981, vrr_stack+24381, vrr_stack+27441, vrr_stack+10960, vrr_stack+24021, vrr_stack+14493);
 _BUILD_i0k0(Data,vrr_stack+28737, vrr_stack+24921, vrr_stack+27981, vrr_stack+11680, vrr_stack+24381, vrr_stack+14913);
 _BUILD_k0k0(Data,vrr_stack+29745, vrr_stack+26433, vrr_stack+28737, vrr_stack+25677, vrr_stack+24921, vrr_stack+15501);
 _BUILD_k0k0(Data,vrr_stack+14344, vrr_stack+12760, vrr_stack+26433, vrr_stack+5814, vrr_stack+25677, vrr_stack+6908);
 _BUILD_l0k0(Data,vrr_stack+31041, vrr_stack+14344, vrr_stack+29745, vrr_stack+12760, vrr_stack+26433, vrr_stack+16285);
 _BUILD_00p0(Data,vrr_stack+1275, Data->F+1, Data->F+2, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+2314, vrr_stack+1275, vrr_stack+40, Data->F+1, Data->F+2, NULL);
 _BUILD_00f0(Data,vrr_stack+2320, vrr_stack+2314, vrr_stack+816, vrr_stack+1275, vrr_stack+40, NULL);
 _BUILD_00g0(Data,vrr_stack+2330, vrr_stack+2320, vrr_stack+822, vrr_stack+2314, vrr_stack+816, NULL);
 _BUILD_00h0(Data,vrr_stack+2345, vrr_stack+2330, vrr_stack+832, vrr_stack+2320, vrr_stack+822, NULL);
 _BUILD_00i0(Data,vrr_stack+2366, vrr_stack+2345, vrr_stack+847, vrr_stack+2330, vrr_stack+832, NULL);
 _BUILD_00k0(Data,vrr_stack+611, vrr_stack+2366, vrr_stack+185, vrr_stack+2345, vrr_stack+847, NULL);
 _BUILD_p0k0(Data,vrr_stack+2394, vrr_stack+611, vrr_stack+539, NULL, NULL, vrr_stack+185);
 _BUILD_d0k0(Data,vrr_stack+6570, vrr_stack+2394, vrr_stack+1946, vrr_stack+611, vrr_stack+539, vrr_stack+2566);
 _BUILD_f0k0(Data,vrr_stack+6786, vrr_stack+6570, vrr_stack+5238, vrr_stack+2394, vrr_stack+1946, vrr_stack+2650);
 _BUILD_g0k0(Data,vrr_stack+7146, vrr_stack+6786, vrr_stack+5454, vrr_stack+6570, vrr_stack+5238, vrr_stack+2818);
 _BUILD_h0k0(Data,vrr_stack+15640, vrr_stack+7146, vrr_stack+12220, vrr_stack+6786, vrr_stack+5454, vrr_stack+7692);
 _BUILD_i0k0(Data,vrr_stack+32661, vrr_stack+15640, vrr_stack+5814, vrr_stack+7146, vrr_stack+12220, vrr_stack+17293);
 _BUILD_k0k0(Data,vrr_stack+16396, vrr_stack+32661, vrr_stack+12760, vrr_stack+15640, vrr_stack+5814, vrr_stack+17881);
 _BUILD_l0k0(Data,vrr_stack+33669, vrr_stack+16396, vrr_stack+14344, vrr_stack+32661, vrr_stack+12760, vrr_stack+18665);
 _BUILD_00p0(Data,vrr_stack+2502, Data->F+17, Data->F+18, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+2505, vrr_stack+868, vrr_stack+2502, Data->F+16, Data->F+17, NULL);
 _BUILD_00f0(Data,vrr_stack+2511, vrr_stack+871, vrr_stack+2505, vrr_stack+43, vrr_stack+868, NULL);
 _BUILD_00g0(Data,vrr_stack+2521, vrr_stack+877, vrr_stack+2511, vrr_stack+106, vrr_stack+871, NULL);
 _BUILD_00h0(Data,vrr_stack+2536, vrr_stack+887, vrr_stack+2521, vrr_stack+112, vrr_stack+877, NULL);
 _BUILD_00i0(Data,vrr_stack+2557, vrr_stack+902, vrr_stack+2536, vrr_stack+170, vrr_stack+887, NULL);
 _BUILD_00k0(Data,vrr_stack+2585, vrr_stack+923, vrr_stack+2557, vrr_stack+1278, vrr_stack+902, NULL);
 _BUILD_p0k0(Data,vrr_stack+2621, vrr_stack+575, vrr_stack+2585, NULL, NULL, vrr_stack+923);
 _BUILD_d0k0(Data,vrr_stack+2729, vrr_stack+2054, vrr_stack+2621, vrr_stack+395, vrr_stack+575, vrr_stack+951);
 _BUILD_f0k0(Data,vrr_stack+7686, vrr_stack+13768, vrr_stack+2729, vrr_stack+431, vrr_stack+2054, vrr_stack+1035);
 _BUILD_g0k0(Data,vrr_stack+17692, vrr_stack+13984, vrr_stack+7686, vrr_stack+5022, vrr_stack+13768, vrr_stack+3098);
 _BUILD_h0k0(Data,vrr_stack+18232, vrr_stack+27441, vrr_stack+17692, vrr_stack+24021, vrr_stack+13984, vrr_stack+3378);
 _BUILD_i0k0(Data,vrr_stack+35289, vrr_stack+27981, vrr_stack+18232, vrr_stack+24381, vrr_stack+27441, vrr_stack+8112);
 _BUILD_k0k0(Data,vrr_stack+36297, vrr_stack+28737, vrr_stack+35289, vrr_stack+24921, vrr_stack+27981, vrr_stack+8700);
 _BUILD_l0k0(Data,vrr_stack+37593, vrr_stack+29745, vrr_stack+36297, vrr_stack+26433, vrr_stack+28737, vrr_stack+19673);
 _BUILD_m0k0(Data,vrr_stack+39213, vrr_stack+31041, vrr_stack+37593, vrr_stack+14344, vrr_stack+29745, vrr_stack+9484);
 _BUILD_m0k0(Data,vrr_stack+8046, vrr_stack+33669, vrr_stack+31041, vrr_stack+16396, vrr_stack+14344, vrr_stack+20681);
 _BUILD_n0k0(Data,vrr_stack+18988, vrr_stack+8046, vrr_stack+39213, vrr_stack+33669, vrr_stack+31041, vrr_stack+21941);
 _BUILD_00l0(Data,vrr_stack+951, vrr_stack+1299, vrr_stack+1239, vrr_stack+46, vrr_stack+259, NULL);
 _BUILD_00l0(Data,vrr_stack+996, vrr_stack+1203, vrr_stack+1299, vrr_stack+1446, vrr_stack+46, NULL);
 _BUILD_p0l0(Data,vrr_stack+1041, vrr_stack+996, vrr_stack+951, NULL, NULL, vrr_stack+1299);
 _BUILD_00l0(Data,vrr_stack+2945, vrr_stack+1335, vrr_stack+1203, vrr_stack+367, vrr_stack+1446, NULL);
 _BUILD_p0l0(Data,vrr_stack+2990, vrr_stack+2945, vrr_stack+996, NULL, NULL, vrr_stack+1203);
 _BUILD_00l0(Data,vrr_stack+3125, vrr_stack+1239, vrr_stack+1474, vrr_stack+259, vrr_stack+1558, NULL);
 _BUILD_p0l0(Data,vrr_stack+3170, vrr_stack+951, vrr_stack+3125, NULL, NULL, vrr_stack+1239);
 _BUILD_d0l0(Data,vrr_stack+3305, vrr_stack+1041, vrr_stack+3170, vrr_stack+996, vrr_stack+951, vrr_stack+3798);
 _BUILD_d0l0(Data,vrr_stack+3575, vrr_stack+2990, vrr_stack+1041, vrr_stack+2945, vrr_stack+996, vrr_stack+3906);
 _BUILD_f0l0(Data,vrr_stack+10026, vrr_stack+3575, vrr_stack+3305, vrr_stack+2990, vrr_stack+1041, vrr_stack+4014);
 _BUILD_00l0(Data,vrr_stack+3845, vrr_stack+1586, vrr_stack+1335, vrr_stack+2258, vrr_stack+367, NULL);
 _BUILD_p0l0(Data,vrr_stack+3890, vrr_stack+3845, vrr_stack+2945, NULL, NULL, vrr_stack+1335);
 _BUILD_d0l0(Data,vrr_stack+21364, vrr_stack+3890, vrr_stack+2990, vrr_stack+3845, vrr_stack+2945, vrr_stack+4230);
 _BUILD_f0l0(Data,vrr_stack+21634, vrr_stack+21364, vrr_stack+3575, vrr_stack+3890, vrr_stack+2990, vrr_stack+4338);
 _BUILD_00l0(Data,vrr_stack+4025, vrr_stack+1474, vrr_stack+395, vrr_stack+1558, vrr_stack+647, NULL);
 _BUILD_p0l0(Data,vrr_stack+4070, vrr_stack+3125, vrr_stack+4025, NULL, NULL, vrr_stack+1474);
 _BUILD_d0l0(Data,vrr_stack+4205, vrr_stack+3170, vrr_stack+4070, vrr_stack+951, vrr_stack+3125, vrr_stack+4554);
 _BUILD_f0l0(Data,vrr_stack+22084, vrr_stack+3305, vrr_stack+4205, vrr_stack+1041, vrr_stack+3170, vrr_stack+10744);
 _BUILD_g0l0(Data,vrr_stack+22534, vrr_stack+10026, vrr_stack+22084, vrr_stack+3575, vrr_stack+3305, vrr_stack+10960);
 _BUILD_g0l0(Data,vrr_stack+10476, vrr_stack+21634, vrr_stack+10026, vrr_stack+21364, vrr_stack+3575, vrr_stack+11320);
 _BUILD_h0l0(Data,vrr_stack+41193, vrr_stack+10476, vrr_stack+22534, vrr_stack+21634, vrr_stack+10026, vrr_stack+11680);
 _BUILD_00l0(Data,vrr_stack+4475, vrr_stack+539, vrr_stack+1586, vrr_stack+185, vrr_stack+2258, NULL);
 _BUILD_p0l0(Data,vrr_stack+4520, vrr_stack+4475, vrr_stack+3845, NULL, NULL, vrr_stack+1586);
 _BUILD_d0l0(Data,vrr_stack+11151, vrr_stack+4520, vrr_stack+3890, vrr_stack+4475, vrr_stack+3845, vrr_stack+1622);
 _BUILD_f0l0(Data,vrr_stack+11421, vrr_stack+11151, vrr_stack+21364, vrr_stack+4520, vrr_stack+3890, vrr_stack+1730);
 _BUILD_g0l0(Data,vrr_stack+42138, vrr_stack+11421, vrr_stack+21634, vrr_stack+11151, vrr_stack+21364, vrr_stack+4662);
 _BUILD_h0l0(Data,vrr_stack+42813, vrr_stack+42138, vrr_stack+10476, vrr_stack+11421, vrr_stack+21634, vrr_stack+23481);
 _BUILD_00l0(Data,vrr_stack+1622, vrr_stack+395, vrr_stack+575, vrr_stack+647, vrr_stack+2286, NULL);
 _BUILD_p0l0(Data,vrr_stack+647, vrr_stack+4025, vrr_stack+1622, NULL, NULL, vrr_stack+395);
 _BUILD_d0l0(Data,vrr_stack+1667, vrr_stack+4070, vrr_stack+647, vrr_stack+3125, vrr_stack+4025, vrr_stack+431);
 _BUILD_f0l0(Data,vrr_stack+23209, vrr_stack+4205, vrr_stack+1667, vrr_stack+3170, vrr_stack+4070, vrr_stack+5022);
 _BUILD_g0l0(Data,vrr_stack+43758, vrr_stack+22084, vrr_stack+23209, vrr_stack+3305, vrr_stack+4205, vrr_stack+24021);
 _BUILD_h0l0(Data,vrr_stack+44433, vrr_stack+22534, vrr_stack+43758, vrr_stack+10026, vrr_stack+22084, vrr_stack+24381);
 _BUILD_i0l0(Data,vrr_stack+23659, vrr_stack+41193, vrr_stack+44433, vrr_stack+10476, vrr_stack+22534, vrr_stack+24921);
 _BUILD_i0l0(Data,vrr_stack+45378, vrr_stack+42813, vrr_stack+41193, vrr_stack+42138, vrr_stack+10476, vrr_stack+25677);
 _BUILD_k0l0(Data,vrr_stack+46638, vrr_stack+45378, vrr_stack+23659, vrr_stack+42813, vrr_stack+41193, vrr_stack+26433);
 _BUILD_00l0(Data,vrr_stack+431, vrr_stack+611, vrr_stack+539, vrr_stack+2366, vrr_stack+185, NULL);
 _BUILD_p0l0(Data,vrr_stack+4655, vrr_stack+431, vrr_stack+4475, NULL, NULL, vrr_stack+539);
 _BUILD_d0l0(Data,vrr_stack+4790, vrr_stack+4655, vrr_stack+4520, vrr_stack+431, vrr_stack+4475, vrr_stack+1946);
 _BUILD_f0l0(Data,vrr_stack+24919, vrr_stack+4790, vrr_stack+11151, vrr_stack+4655, vrr_stack+4520, vrr_stack+5238);
 _BUILD_g0l0(Data,vrr_stack+25369, vrr_stack+24919, vrr_stack+11421, vrr_stack+4790, vrr_stack+11151, vrr_stack+5454);
 _BUILD_h0l0(Data,vrr_stack+26044, vrr_stack+25369, vrr_stack+42138, vrr_stack+24919, vrr_stack+11421, vrr_stack+12220);
 _BUILD_i0l0(Data,vrr_stack+48258, vrr_stack+26044, vrr_stack+42813, vrr_stack+25369, vrr_stack+42138, vrr_stack+5814);
 _BUILD_k0l0(Data,vrr_stack+49518, vrr_stack+48258, vrr_stack+45378, vrr_stack+26044, vrr_stack+42813, vrr_stack+12760);
 _BUILD_00l0(Data,vrr_stack+476, vrr_stack+575, vrr_stack+2585, vrr_stack+2286, vrr_stack+923, NULL);
 _BUILD_p0l0(Data,vrr_stack+5060, vrr_stack+1622, vrr_stack+476, NULL, NULL, vrr_stack+575);
 _BUILD_d0l0(Data,vrr_stack+5195, vrr_stack+647, vrr_stack+5060, vrr_stack+4025, vrr_stack+1622, vrr_stack+2054);
 _BUILD_f0l0(Data,vrr_stack+5465, vrr_stack+1667, vrr_stack+5195, vrr_stack+4070, vrr_stack+647, vrr_stack+13768);
 _BUILD_g0l0(Data,vrr_stack+11871, vrr_stack+23209, vrr_stack+5465, vrr_stack+4205, vrr_stack+1667, vrr_stack+13984);
 _BUILD_h0l0(Data,vrr_stack+12546, vrr_stack+43758, vrr_stack+11871, vrr_stack+22084, vrr_stack+23209, vrr_stack+27441);
 _BUILD_i0l0(Data,vrr_stack+51138, vrr_stack+44433, vrr_stack+12546, vrr_stack+22534, vrr_stack+43758, vrr_stack+27981);
 _BUILD_k0l0(Data,vrr_stack+26989, vrr_stack+23659, vrr_stack+51138, vrr_stack+41193, vrr_stack+44433, vrr_stack+28737);
 _BUILD_l0l0(Data,vrr_stack+52398, vrr_stack+46638, vrr_stack+26989, vrr_stack+45378, vrr_stack+23659, vrr_stack+29745);
 _BUILD_l0l0(Data,vrr_stack+28609, vrr_stack+49518, vrr_stack+46638, vrr_stack+48258, vrr_stack+45378, vrr_stack+14344);
 _BUILD_m0l0(Data,vrr_stack+54423, vrr_stack+28609, vrr_stack+52398, vrr_stack+49518, vrr_stack+46638, vrr_stack+31041);
 _BUILD_00p0(Data,vrr_stack+521, Data->F+0, Data->F+1, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+524, vrr_stack+521, vrr_stack+1275, Data->F+0, Data->F+1, NULL);
 _BUILD_00f0(Data,vrr_stack+782, vrr_stack+524, vrr_stack+2314, vrr_stack+521, vrr_stack+1275, NULL);
 _BUILD_00g0(Data,vrr_stack+1275, vrr_stack+782, vrr_stack+2320, vrr_stack+524, vrr_stack+2314, NULL);
 _BUILD_00h0(Data,vrr_stack+792, vrr_stack+1275, vrr_stack+2330, vrr_stack+782, vrr_stack+2320, NULL);
 _BUILD_00i0(Data,vrr_stack+813, vrr_stack+792, vrr_stack+2345, vrr_stack+1275, vrr_stack+2330, NULL);
 _BUILD_00k0(Data,vrr_stack+1937, vrr_stack+813, vrr_stack+2366, vrr_stack+792, vrr_stack+2345, NULL);
 _BUILD_00l0(Data,vrr_stack+1973, vrr_stack+1937, vrr_stack+611, vrr_stack+813, vrr_stack+2366, NULL);
 _BUILD_p0l0(Data,vrr_stack+2018, vrr_stack+1973, vrr_stack+431, NULL, NULL, vrr_stack+611);
 _BUILD_d0l0(Data,vrr_stack+5915, vrr_stack+2018, vrr_stack+4655, vrr_stack+1973, vrr_stack+431, vrr_stack+2394);
 _BUILD_f0l0(Data,vrr_stack+13491, vrr_stack+5915, vrr_stack+4790, vrr_stack+2018, vrr_stack+4655, vrr_stack+6570);
 _BUILD_g0l0(Data,vrr_stack+13941, vrr_stack+13491, vrr_stack+24919, vrr_stack+5915, vrr_stack+4790, vrr_stack+6786);
 _BUILD_h0l0(Data,vrr_stack+5915, vrr_stack+13941, vrr_stack+25369, vrr_stack+13491, vrr_stack+24919, vrr_stack+7146);
 _BUILD_i0l0(Data,vrr_stack+30634, vrr_stack+5915, vrr_stack+26044, vrr_stack+13941, vrr_stack+25369, vrr_stack+15640);
 _BUILD_k0l0(Data,vrr_stack+13491, vrr_stack+30634, vrr_stack+48258, vrr_stack+5915, vrr_stack+26044, vrr_stack+32661);
 _BUILD_l0l0(Data,vrr_stack+56898, vrr_stack+13491, vrr_stack+49518, vrr_stack+30634, vrr_stack+48258, vrr_stack+16396);
 _BUILD_m0l0(Data,vrr_stack+30634, vrr_stack+56898, vrr_stack+28609, vrr_stack+13491, vrr_stack+49518, vrr_stack+33669);
   tmp = vrr_stack + 30634;
   target_ptr = Libint->vrr_classes[9][8];
   for(i=0;i<2475;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00p0(Data,vrr_stack+13491, Data->F+18, Data->F+19, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+13494, vrr_stack+2502, vrr_stack+13491, Data->F+17, Data->F+18, NULL);
 _BUILD_00f0(Data,vrr_stack+13500, vrr_stack+2505, vrr_stack+13494, vrr_stack+868, vrr_stack+2502, NULL);
 _BUILD_00g0(Data,vrr_stack+13510, vrr_stack+2511, vrr_stack+13500, vrr_stack+871, vrr_stack+2505, NULL);
 _BUILD_00h0(Data,vrr_stack+13525, vrr_stack+2521, vrr_stack+13510, vrr_stack+877, vrr_stack+2511, NULL);
 _BUILD_00i0(Data,vrr_stack+13546, vrr_stack+2536, vrr_stack+13525, vrr_stack+887, vrr_stack+2521, NULL);
 _BUILD_00k0(Data,vrr_stack+13574, vrr_stack+2557, vrr_stack+13546, vrr_stack+902, vrr_stack+2536, NULL);
 _BUILD_00l0(Data,vrr_stack+13610, vrr_stack+2585, vrr_stack+13574, vrr_stack+923, vrr_stack+2557, NULL);
 _BUILD_p0l0(Data,vrr_stack+13655, vrr_stack+476, vrr_stack+13610, NULL, NULL, vrr_stack+2585);
 _BUILD_d0l0(Data,vrr_stack+13790, vrr_stack+5060, vrr_stack+13655, vrr_stack+1622, vrr_stack+476, vrr_stack+2621);
 _BUILD_f0l0(Data,vrr_stack+14060, vrr_stack+5195, vrr_stack+13790, vrr_stack+647, vrr_stack+5060, vrr_stack+2729);
 _BUILD_g0l0(Data,vrr_stack+14510, vrr_stack+5465, vrr_stack+14060, vrr_stack+1667, vrr_stack+5195, vrr_stack+7686);
 _BUILD_h0l0(Data,vrr_stack+15185, vrr_stack+11871, vrr_stack+14510, vrr_stack+23209, vrr_stack+5465, vrr_stack+17692);
 _BUILD_i0l0(Data,vrr_stack+16130, vrr_stack+12546, vrr_stack+15185, vrr_stack+43758, vrr_stack+11871, vrr_stack+18232);
 _BUILD_k0l0(Data,vrr_stack+33109, vrr_stack+51138, vrr_stack+16130, vrr_stack+44433, vrr_stack+12546, vrr_stack+35289);
 _BUILD_l0l0(Data,vrr_stack+5915, vrr_stack+26989, vrr_stack+33109, vrr_stack+23659, vrr_stack+51138, vrr_stack+36297);
 _BUILD_m0l0(Data,vrr_stack+34729, vrr_stack+52398, vrr_stack+5915, vrr_stack+46638, vrr_stack+26989, vrr_stack+37593);
 _BUILD_n0l0(Data,vrr_stack+58923, vrr_stack+54423, vrr_stack+34729, vrr_stack+28609, vrr_stack+52398, vrr_stack+39213);
 _BUILD_n0l0(Data,vrr_stack+37204, vrr_stack+30634, vrr_stack+54423, vrr_stack+56898, vrr_stack+28609, vrr_stack+8046);
   tmp = vrr_stack + 37204;
   target_ptr = Libint->vrr_classes[10][8];
   for(i=0;i<2970;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00m0(Data,vrr_stack+56898, vrr_stack+951, vrr_stack+3125, vrr_stack+1299, vrr_stack+1239, NULL);
 _BUILD_00m0(Data,vrr_stack+56953, vrr_stack+996, vrr_stack+951, vrr_stack+1203, vrr_stack+1299, NULL);
 _BUILD_p0m0(Data,vrr_stack+57008, vrr_stack+56953, vrr_stack+56898, NULL, NULL, vrr_stack+951);
 _BUILD_00m0(Data,vrr_stack+57173, vrr_stack+2945, vrr_stack+996, vrr_stack+1335, vrr_stack+1203, NULL);
 _BUILD_p0m0(Data,vrr_stack+57228, vrr_stack+57173, vrr_stack+56953, NULL, NULL, vrr_stack+996);
 _BUILD_00m0(Data,vrr_stack+57393, vrr_stack+3125, vrr_stack+4025, vrr_stack+1239, vrr_stack+1474, NULL);
 _BUILD_p0m0(Data,vrr_stack+57448, vrr_stack+56898, vrr_stack+57393, NULL, NULL, vrr_stack+3125);
 _BUILD_d0m0(Data,vrr_stack+57613, vrr_stack+57008, vrr_stack+57448, vrr_stack+56953, vrr_stack+56898, vrr_stack+3170);
 _BUILD_d0m0(Data,vrr_stack+57943, vrr_stack+57228, vrr_stack+57008, vrr_stack+57173, vrr_stack+56953, vrr_stack+1041);
 _BUILD_f0m0(Data,vrr_stack+58273, vrr_stack+57943, vrr_stack+57613, vrr_stack+57228, vrr_stack+57008, vrr_stack+3305);
 _BUILD_00m0(Data,vrr_stack+1041, vrr_stack+3845, vrr_stack+2945, vrr_stack+1586, vrr_stack+1335, NULL);
 _BUILD_p0m0(Data,vrr_stack+1096, vrr_stack+1041, vrr_stack+57173, NULL, NULL, vrr_stack+2945);
 _BUILD_d0m0(Data,vrr_stack+3170, vrr_stack+1096, vrr_stack+57228, vrr_stack+1041, vrr_stack+57173, vrr_stack+2990);
 _BUILD_f0m0(Data,vrr_stack+17390, vrr_stack+3170, vrr_stack+57943, vrr_stack+1096, vrr_stack+57228, vrr_stack+3575);
 _BUILD_00m0(Data,vrr_stack+2990, vrr_stack+4025, vrr_stack+1622, vrr_stack+1474, vrr_stack+395, NULL);
 _BUILD_p0m0(Data,vrr_stack+1261, vrr_stack+57393, vrr_stack+2990, NULL, NULL, vrr_stack+4025);
 _BUILD_d0m0(Data,vrr_stack+3500, vrr_stack+57448, vrr_stack+1261, vrr_stack+56898, vrr_stack+57393, vrr_stack+4070);
 _BUILD_f0m0(Data,vrr_stack+17940, vrr_stack+57613, vrr_stack+3500, vrr_stack+57008, vrr_stack+57448, vrr_stack+4205);
 _BUILD_g0m0(Data,vrr_stack+40174, vrr_stack+58273, vrr_stack+17940, vrr_stack+57943, vrr_stack+57613, vrr_stack+22084);
 _BUILD_g0m0(Data,vrr_stack+7940, vrr_stack+17390, vrr_stack+58273, vrr_stack+3170, vrr_stack+57943, vrr_stack+10026);
 _BUILD_h0m0(Data,vrr_stack+8765, vrr_stack+7940, vrr_stack+40174, vrr_stack+17390, vrr_stack+58273, vrr_stack+22534);
 _BUILD_00m0(Data,vrr_stack+22084, vrr_stack+4475, vrr_stack+3845, vrr_stack+539, vrr_stack+1586, NULL);
 _BUILD_p0m0(Data,vrr_stack+22139, vrr_stack+22084, vrr_stack+1041, NULL, NULL, vrr_stack+3845);
 _BUILD_d0m0(Data,vrr_stack+22304, vrr_stack+22139, vrr_stack+1096, vrr_stack+22084, vrr_stack+1041, vrr_stack+3890);
 _BUILD_f0m0(Data,vrr_stack+22634, vrr_stack+22304, vrr_stack+3170, vrr_stack+22139, vrr_stack+1096, vrr_stack+21364);
 _BUILD_g0m0(Data,vrr_stack+61893, vrr_stack+22634, vrr_stack+17390, vrr_stack+22304, vrr_stack+3170, vrr_stack+21634);
 _BUILD_h0m0(Data,vrr_stack+62718, vrr_stack+61893, vrr_stack+7940, vrr_stack+22634, vrr_stack+17390, vrr_stack+10476);
 _BUILD_00m0(Data,vrr_stack+21364, vrr_stack+1622, vrr_stack+476, vrr_stack+395, vrr_stack+575, NULL);
 _BUILD_p0m0(Data,vrr_stack+21419, vrr_stack+2990, vrr_stack+21364, NULL, NULL, vrr_stack+1622);
 _BUILD_d0m0(Data,vrr_stack+21584, vrr_stack+1261, vrr_stack+21419, vrr_stack+57393, vrr_stack+2990, vrr_stack+647);
 _BUILD_f0m0(Data,vrr_stack+9920, vrr_stack+3500, vrr_stack+21584, vrr_stack+57448, vrr_stack+1261, vrr_stack+1667);
 _BUILD_g0m0(Data,vrr_stack+63873, vrr_stack+17940, vrr_stack+9920, vrr_stack+57613, vrr_stack+3500, vrr_stack+23209);
 _BUILD_h0m0(Data,vrr_stack+64698, vrr_stack+40174, vrr_stack+63873, vrr_stack+58273, vrr_stack+17940, vrr_stack+43758);
 _BUILD_i0m0(Data,vrr_stack+65853, vrr_stack+8765, vrr_stack+64698, vrr_stack+7940, vrr_stack+40174, vrr_stack+44433);
 _BUILD_i0m0(Data,vrr_stack+43758, vrr_stack+62718, vrr_stack+8765, vrr_stack+61893, vrr_stack+7940, vrr_stack+41193);
 _BUILD_k0m0(Data,vrr_stack+67393, vrr_stack+43758, vrr_stack+65853, vrr_stack+62718, vrr_stack+8765, vrr_stack+23659);
 _BUILD_00m0(Data,vrr_stack+45298, vrr_stack+431, vrr_stack+4475, vrr_stack+611, vrr_stack+539, NULL);
 _BUILD_p0m0(Data,vrr_stack+1667, vrr_stack+45298, vrr_stack+22084, NULL, NULL, vrr_stack+4475);
 _BUILD_d0m0(Data,vrr_stack+23184, vrr_stack+1667, vrr_stack+22139, vrr_stack+45298, vrr_stack+22084, vrr_stack+4520);
 _BUILD_f0m0(Data,vrr_stack+23514, vrr_stack+23184, vrr_stack+22304, vrr_stack+1667, vrr_stack+22139, vrr_stack+11151);
 _BUILD_g0m0(Data,vrr_stack+24064, vrr_stack+23514, vrr_stack+22634, vrr_stack+23184, vrr_stack+22304, vrr_stack+11421);
 _BUILD_h0m0(Data,vrr_stack+10470, vrr_stack+24064, vrr_stack+61893, vrr_stack+23514, vrr_stack+22634, vrr_stack+42138);
 _BUILD_i0m0(Data,vrr_stack+40999, vrr_stack+10470, vrr_stack+62718, vrr_stack+24064, vrr_stack+61893, vrr_stack+42813);
 _BUILD_k0m0(Data,vrr_stack+69373, vrr_stack+40999, vrr_stack+43758, vrr_stack+10470, vrr_stack+62718, vrr_stack+45378);
 _BUILD_00m0(Data,vrr_stack+4520, vrr_stack+476, vrr_stack+13610, vrr_stack+575, vrr_stack+2585, NULL);
 _BUILD_p0m0(Data,vrr_stack+45353, vrr_stack+21364, vrr_stack+4520, NULL, NULL, vrr_stack+476);
 _BUILD_d0m0(Data,vrr_stack+45518, vrr_stack+21419, vrr_stack+45353, vrr_stack+2990, vrr_stack+21364, vrr_stack+5060);
 _BUILD_f0m0(Data,vrr_stack+45848, vrr_stack+21584, vrr_stack+45518, vrr_stack+1261, vrr_stack+21419, vrr_stack+5195);
 _BUILD_g0m0(Data,vrr_stack+42539, vrr_stack+9920, vrr_stack+45848, vrr_stack+3500, vrr_stack+21584, vrr_stack+5465);
 _BUILD_h0m0(Data,vrr_stack+71353, vrr_stack+63873, vrr_stack+42539, vrr_stack+17940, vrr_stack+9920, vrr_stack+11871);
 _BUILD_i0m0(Data,vrr_stack+72508, vrr_stack+64698, vrr_stack+71353, vrr_stack+40174, vrr_stack+63873, vrr_stack+12546);
 _BUILD_k0m0(Data,vrr_stack+74048, vrr_stack+65853, vrr_stack+72508, vrr_stack+8765, vrr_stack+64698, vrr_stack+51138);
 _BUILD_l0m0(Data,vrr_stack+76028, vrr_stack+67393, vrr_stack+74048, vrr_stack+43758, vrr_stack+65853, vrr_stack+26989);
 _BUILD_l0m0(Data,vrr_stack+78503, vrr_stack+69373, vrr_stack+67393, vrr_stack+40999, vrr_stack+43758, vrr_stack+46638);
 _BUILD_m0m0(Data,vrr_stack+80978, vrr_stack+78503, vrr_stack+76028, vrr_stack+69373, vrr_stack+67393, vrr_stack+52398);
 _BUILD_00m0(Data,vrr_stack+26989, vrr_stack+1973, vrr_stack+431, vrr_stack+1937, vrr_stack+611, NULL);
 _BUILD_p0m0(Data,vrr_stack+27044, vrr_stack+26989, vrr_stack+45298, NULL, NULL, vrr_stack+431);
 _BUILD_d0m0(Data,vrr_stack+27209, vrr_stack+27044, vrr_stack+1667, vrr_stack+26989, vrr_stack+45298, vrr_stack+4655);
 _BUILD_f0m0(Data,vrr_stack+27539, vrr_stack+27209, vrr_stack+23184, vrr_stack+27044, vrr_stack+1667, vrr_stack+4790);
 _BUILD_g0m0(Data,vrr_stack+51138, vrr_stack+27539, vrr_stack+23514, vrr_stack+27209, vrr_stack+23184, vrr_stack+24919);
 _BUILD_h0m0(Data,vrr_stack+51963, vrr_stack+51138, vrr_stack+24064, vrr_stack+27539, vrr_stack+23514, vrr_stack+25369);
 _BUILD_i0m0(Data,vrr_stack+27044, vrr_stack+51963, vrr_stack+10470, vrr_stack+51138, vrr_stack+24064, vrr_stack+26044);
 _BUILD_k0m0(Data,vrr_stack+24889, vrr_stack+27044, vrr_stack+40999, vrr_stack+51963, vrr_stack+10470, vrr_stack+48258);
 _BUILD_l0m0(Data,vrr_stack+51138, vrr_stack+24889, vrr_stack+69373, vrr_stack+27044, vrr_stack+40999, vrr_stack+49518);
 _BUILD_m0m0(Data,vrr_stack+46398, vrr_stack+51138, vrr_stack+78503, vrr_stack+24889, vrr_stack+69373, vrr_stack+28609);
   tmp = vrr_stack + 46398;
   target_ptr = Libint->vrr_classes[9][9];
   for(i=0;i<3025;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00p0(Data,vrr_stack+24889, Data->F+19, Data->F+20, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+24892, vrr_stack+13491, vrr_stack+24889, Data->F+18, Data->F+19, NULL);
 _BUILD_00f0(Data,vrr_stack+24898, vrr_stack+13494, vrr_stack+24892, vrr_stack+2502, vrr_stack+13491, NULL);
 _BUILD_00g0(Data,vrr_stack+3830, vrr_stack+13500, vrr_stack+24898, vrr_stack+2505, vrr_stack+13494, NULL);
 _BUILD_00h0(Data,vrr_stack+24908, vrr_stack+13510, vrr_stack+3830, vrr_stack+2511, vrr_stack+13500, NULL);
 _BUILD_00i0(Data,vrr_stack+24929, vrr_stack+13525, vrr_stack+24908, vrr_stack+2521, vrr_stack+13510, NULL);
 _BUILD_00k0(Data,vrr_stack+24957, vrr_stack+13546, vrr_stack+24929, vrr_stack+2536, vrr_stack+13525, NULL);
 _BUILD_00l0(Data,vrr_stack+24993, vrr_stack+13574, vrr_stack+24957, vrr_stack+2557, vrr_stack+13546, NULL);
 _BUILD_00m0(Data,vrr_stack+25038, vrr_stack+13610, vrr_stack+24993, vrr_stack+2585, vrr_stack+13574, NULL);
 _BUILD_p0m0(Data,vrr_stack+25093, vrr_stack+4520, vrr_stack+25038, NULL, NULL, vrr_stack+13610);
 _BUILD_d0m0(Data,vrr_stack+25258, vrr_stack+45353, vrr_stack+25093, vrr_stack+21364, vrr_stack+4520, vrr_stack+13655);
 _BUILD_f0m0(Data,vrr_stack+25588, vrr_stack+45518, vrr_stack+25258, vrr_stack+21419, vrr_stack+45353, vrr_stack+13790);
 _BUILD_g0m0(Data,vrr_stack+26138, vrr_stack+45848, vrr_stack+25588, vrr_stack+21584, vrr_stack+45518, vrr_stack+14060);
 _BUILD_h0m0(Data,vrr_stack+27044, vrr_stack+42539, vrr_stack+26138, vrr_stack+9920, vrr_stack+45848, vrr_stack+14510);
 _BUILD_i0m0(Data,vrr_stack+28199, vrr_stack+71353, vrr_stack+27044, vrr_stack+63873, vrr_stack+42539, vrr_stack+15185);
 _BUILD_k0m0(Data,vrr_stack+13655, vrr_stack+72508, vrr_stack+28199, vrr_stack+64698, vrr_stack+71353, vrr_stack+16130);
 _BUILD_l0m0(Data,vrr_stack+84003, vrr_stack+74048, vrr_stack+13655, vrr_stack+65853, vrr_stack+72508, vrr_stack+33109);
 _BUILD_m0m0(Data,vrr_stack+86478, vrr_stack+76028, vrr_stack+84003, vrr_stack+67393, vrr_stack+74048, vrr_stack+5915);
 _BUILD_n0m0(Data,vrr_stack+89503, vrr_stack+80978, vrr_stack+86478, vrr_stack+78503, vrr_stack+76028, vrr_stack+34729);
 _BUILD_n0m0(Data,vrr_stack+33109, vrr_stack+46398, vrr_stack+80978, vrr_stack+51138, vrr_stack+78503, vrr_stack+54423);
   tmp = vrr_stack + 33109;
   target_ptr = Libint->vrr_classes[10][9];
   for(i=0;i<3630;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00n0(Data,vrr_stack+36739, vrr_stack+56898, vrr_stack+57393, vrr_stack+951, vrr_stack+3125, NULL);
 _BUILD_00n0(Data,vrr_stack+36805, vrr_stack+56953, vrr_stack+56898, vrr_stack+996, vrr_stack+951, NULL);
 _BUILD_p0n0(Data,vrr_stack+36871, vrr_stack+36805, vrr_stack+36739, NULL, NULL, vrr_stack+56898);
 _BUILD_00n0(Data,vrr_stack+37069, vrr_stack+57173, vrr_stack+56953, vrr_stack+2945, vrr_stack+996, NULL);
 _BUILD_p0n0(Data,vrr_stack+15635, vrr_stack+37069, vrr_stack+36805, NULL, NULL, vrr_stack+56953);
 _BUILD_00n0(Data,vrr_stack+37135, vrr_stack+57393, vrr_stack+2990, vrr_stack+3125, vrr_stack+4025, NULL);
 _BUILD_p0n0(Data,vrr_stack+15833, vrr_stack+36739, vrr_stack+37135, NULL, NULL, vrr_stack+57393);
 _BUILD_d0n0(Data,vrr_stack+16031, vrr_stack+36871, vrr_stack+15833, vrr_stack+36805, vrr_stack+36739, vrr_stack+57448);
 _BUILD_d0n0(Data,vrr_stack+16427, vrr_stack+15635, vrr_stack+36871, vrr_stack+37069, vrr_stack+36805, vrr_stack+57008);
 _BUILD_f0n0(Data,vrr_stack+29739, vrr_stack+16427, vrr_stack+16031, vrr_stack+15635, vrr_stack+36871, vrr_stack+57613);
 _BUILD_00n0(Data,vrr_stack+57008, vrr_stack+1041, vrr_stack+57173, vrr_stack+3845, vrr_stack+2945, NULL);
 _BUILD_p0n0(Data,vrr_stack+57448, vrr_stack+57008, vrr_stack+37069, NULL, NULL, vrr_stack+57173);
 _BUILD_d0n0(Data,vrr_stack+16823, vrr_stack+57448, vrr_stack+15635, vrr_stack+57008, vrr_stack+37069, vrr_stack+57228);
 _BUILD_f0n0(Data,vrr_stack+4575, vrr_stack+16823, vrr_stack+16427, vrr_stack+57448, vrr_stack+15635, vrr_stack+57943);
 _BUILD_00n0(Data,vrr_stack+57228, vrr_stack+2990, vrr_stack+21364, vrr_stack+4025, vrr_stack+1622, NULL);
 _BUILD_p0n0(Data,vrr_stack+57646, vrr_stack+37135, vrr_stack+57228, NULL, NULL, vrr_stack+2990);
 _BUILD_d0n0(Data,vrr_stack+57844, vrr_stack+15833, vrr_stack+57646, vrr_stack+36739, vrr_stack+37135, vrr_stack+1261);
 _BUILD_f0n0(Data,vrr_stack+5235, vrr_stack+16031, vrr_stack+57844, vrr_stack+36871, vrr_stack+15833, vrr_stack+3500);
 _BUILD_g0n0(Data,vrr_stack+5895, vrr_stack+29739, vrr_stack+5235, vrr_stack+16427, vrr_stack+16031, vrr_stack+17940);
 _BUILD_g0n0(Data,vrr_stack+17940, vrr_stack+4575, vrr_stack+29739, vrr_stack+16823, vrr_stack+16427, vrr_stack+58273);
 _BUILD_h0n0(Data,vrr_stack+49423, vrr_stack+17940, vrr_stack+5895, vrr_stack+4575, vrr_stack+29739, vrr_stack+40174);
 _BUILD_00n0(Data,vrr_stack+40174, vrr_stack+22084, vrr_stack+1041, vrr_stack+4475, vrr_stack+3845, NULL);
 _BUILD_p0n0(Data,vrr_stack+3845, vrr_stack+40174, vrr_stack+57008, NULL, NULL, vrr_stack+1041);
 _BUILD_d0n0(Data,vrr_stack+4043, vrr_stack+3845, vrr_stack+57448, vrr_stack+40174, vrr_stack+57008, vrr_stack+1096);
 _BUILD_f0n0(Data,vrr_stack+40240, vrr_stack+4043, vrr_stack+16823, vrr_stack+3845, vrr_stack+57448, vrr_stack+3170);
 _BUILD_g0n0(Data,vrr_stack+6885, vrr_stack+40240, vrr_stack+4575, vrr_stack+4043, vrr_stack+16823, vrr_stack+17390);
 _BUILD_h0n0(Data,vrr_stack+50809, vrr_stack+6885, vrr_stack+17940, vrr_stack+40240, vrr_stack+4575, vrr_stack+7940);
 _BUILD_00n0(Data,vrr_stack+1096, vrr_stack+21364, vrr_stack+4520, vrr_stack+1622, vrr_stack+476, NULL);
 _BUILD_p0n0(Data,vrr_stack+1162, vrr_stack+57228, vrr_stack+1096, NULL, NULL, vrr_stack+21364);
 _BUILD_d0n0(Data,vrr_stack+58240, vrr_stack+57646, vrr_stack+1162, vrr_stack+37135, vrr_stack+57228, vrr_stack+21419);
 _BUILD_f0n0(Data,vrr_stack+17219, vrr_stack+57844, vrr_stack+58240, vrr_stack+15833, vrr_stack+57646, vrr_stack+21584);
 _BUILD_g0n0(Data,vrr_stack+52195, vrr_stack+5235, vrr_stack+17219, vrr_stack+16031, vrr_stack+57844, vrr_stack+9920);
 _BUILD_h0n0(Data,vrr_stack+11625, vrr_stack+5895, vrr_stack+52195, vrr_stack+29739, vrr_stack+5235, vrr_stack+63873);
 _BUILD_i0n0(Data,vrr_stack+93133, vrr_stack+49423, vrr_stack+11625, vrr_stack+17940, vrr_stack+5895, vrr_stack+64698);
 _BUILD_i0n0(Data,vrr_stack+63873, vrr_stack+50809, vrr_stack+49423, vrr_stack+6885, vrr_stack+17940, vrr_stack+8765);
 _BUILD_k0n0(Data,vrr_stack+7875, vrr_stack+63873, vrr_stack+93133, vrr_stack+50809, vrr_stack+49423, vrr_stack+65853);
 _BUILD_00n0(Data,vrr_stack+65721, vrr_stack+45298, vrr_stack+22084, vrr_stack+431, vrr_stack+4475, NULL);
 _BUILD_p0n0(Data,vrr_stack+65787, vrr_stack+65721, vrr_stack+40174, NULL, NULL, vrr_stack+22084);
 _BUILD_d0n0(Data,vrr_stack+65985, vrr_stack+65787, vrr_stack+3845, vrr_stack+65721, vrr_stack+40174, vrr_stack+22139);
 _BUILD_f0n0(Data,vrr_stack+66381, vrr_stack+65985, vrr_stack+4043, vrr_stack+65787, vrr_stack+3845, vrr_stack+22304);
 _BUILD_g0n0(Data,vrr_stack+53185, vrr_stack+66381, vrr_stack+40240, vrr_stack+65985, vrr_stack+4043, vrr_stack+22634);
 _BUILD_h0n0(Data,vrr_stack+94981, vrr_stack+53185, vrr_stack+6885, vrr_stack+66381, vrr_stack+40240, vrr_stack+61893);
 _BUILD_i0n0(Data,vrr_stack+96367, vrr_stack+94981, vrr_stack+50809, vrr_stack+53185, vrr_stack+6885, vrr_stack+62718);
 _BUILD_k0n0(Data,vrr_stack+98215, vrr_stack+96367, vrr_stack+63873, vrr_stack+94981, vrr_stack+50809, vrr_stack+43758);
 _BUILD_00n0(Data,vrr_stack+61893, vrr_stack+4520, vrr_stack+25038, vrr_stack+476, vrr_stack+13610, NULL);
 _BUILD_p0n0(Data,vrr_stack+476, vrr_stack+1096, vrr_stack+61893, NULL, NULL, vrr_stack+4520);
 _BUILD_d0n0(Data,vrr_stack+61959, vrr_stack+1162, vrr_stack+476, vrr_stack+57228, vrr_stack+1096, vrr_stack+45353);
 _BUILD_f0n0(Data,vrr_stack+62355, vrr_stack+58240, vrr_stack+61959, vrr_stack+57646, vrr_stack+1162, vrr_stack+45518);
 _BUILD_g0n0(Data,vrr_stack+22139, vrr_stack+17219, vrr_stack+62355, vrr_stack+57844, vrr_stack+58240, vrr_stack+45848);
 _BUILD_h0n0(Data,vrr_stack+43364, vrr_stack+52195, vrr_stack+22139, vrr_stack+5235, vrr_stack+17219, vrr_stack+42539);
 _BUILD_i0n0(Data,vrr_stack+100591, vrr_stack+11625, vrr_stack+43364, vrr_stack+5895, vrr_stack+52195, vrr_stack+71353);
 _BUILD_k0n0(Data,vrr_stack+102439, vrr_stack+93133, vrr_stack+100591, vrr_stack+49423, vrr_stack+11625, vrr_stack+72508);
 _BUILD_l0n0(Data,vrr_stack+104815, vrr_stack+7875, vrr_stack+102439, vrr_stack+63873, vrr_stack+93133, vrr_stack+74048);
 _BUILD_l0n0(Data,vrr_stack+71353, vrr_stack+98215, vrr_stack+7875, vrr_stack+96367, vrr_stack+63873, vrr_stack+67393);
 _BUILD_m0n0(Data,vrr_stack+107785, vrr_stack+71353, vrr_stack+104815, vrr_stack+98215, vrr_stack+7875, vrr_stack+76028);
 _BUILD_00n0(Data,vrr_stack+74323, vrr_stack+26989, vrr_stack+45298, vrr_stack+1973, vrr_stack+431, NULL);
 _BUILD_p0n0(Data,vrr_stack+74389, vrr_stack+74323, vrr_stack+65721, NULL, NULL, vrr_stack+45298);
 _BUILD_d0n0(Data,vrr_stack+74587, vrr_stack+74389, vrr_stack+65787, vrr_stack+74323, vrr_stack+65721, vrr_stack+1667);
 _BUILD_f0n0(Data,vrr_stack+74983, vrr_stack+74587, vrr_stack+65985, vrr_stack+74389, vrr_stack+65787, vrr_stack+23184);
 _BUILD_g0n0(Data,vrr_stack+75643, vrr_stack+74983, vrr_stack+66381, vrr_stack+74587, vrr_stack+65985, vrr_stack+23514);
 _BUILD_h0n0(Data,vrr_stack+76633, vrr_stack+75643, vrr_stack+53185, vrr_stack+74983, vrr_stack+66381, vrr_stack+24064);
 _BUILD_i0n0(Data,vrr_stack+67041, vrr_stack+76633, vrr_stack+94981, vrr_stack+75643, vrr_stack+53185, vrr_stack+10470);
 _BUILD_k0n0(Data,vrr_stack+111415, vrr_stack+67041, vrr_stack+96367, vrr_stack+76633, vrr_stack+94981, vrr_stack+40999);
 _BUILD_l0n0(Data,vrr_stack+74389, vrr_stack+111415, vrr_stack+98215, vrr_stack+67041, vrr_stack+96367, vrr_stack+69373);
 _BUILD_m0n0(Data,vrr_stack+67041, vrr_stack+74389, vrr_stack+71353, vrr_stack+111415, vrr_stack+98215, vrr_stack+78503);
   tmp = vrr_stack + 67041;
   target_ptr = Libint->vrr_classes[9][10];
   for(i=0;i<3630;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00p0(Data,vrr_stack+37201, Data->F+20, Data->F+21, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+111415, vrr_stack+24889, vrr_stack+37201, Data->F+19, Data->F+20, NULL);
 _BUILD_00f0(Data,vrr_stack+111421, vrr_stack+24892, vrr_stack+111415, vrr_stack+13491, vrr_stack+24889, NULL);
 _BUILD_00g0(Data,vrr_stack+111431, vrr_stack+24898, vrr_stack+111421, vrr_stack+13494, vrr_stack+24892, NULL);
 _BUILD_00h0(Data,vrr_stack+111446, vrr_stack+3830, vrr_stack+111431, vrr_stack+13500, vrr_stack+24898, NULL);
 _BUILD_00i0(Data,vrr_stack+111467, vrr_stack+24908, vrr_stack+111446, vrr_stack+13510, vrr_stack+3830, NULL);
 _BUILD_00k0(Data,vrr_stack+111495, vrr_stack+24929, vrr_stack+111467, vrr_stack+13525, vrr_stack+24908, NULL);
 _BUILD_00l0(Data,vrr_stack+111531, vrr_stack+24957, vrr_stack+111495, vrr_stack+13546, vrr_stack+24929, NULL);
 _BUILD_00m0(Data,vrr_stack+111576, vrr_stack+24993, vrr_stack+111531, vrr_stack+13574, vrr_stack+24957, NULL);
 _BUILD_00n0(Data,vrr_stack+111631, vrr_stack+25038, vrr_stack+111576, vrr_stack+13610, vrr_stack+24993, NULL);
 _BUILD_p0n0(Data,vrr_stack+111697, vrr_stack+61893, vrr_stack+111631, NULL, NULL, vrr_stack+25038);
 _BUILD_d0n0(Data,vrr_stack+111895, vrr_stack+476, vrr_stack+111697, vrr_stack+1096, vrr_stack+61893, vrr_stack+25093);
 _BUILD_f0n0(Data,vrr_stack+112291, vrr_stack+61959, vrr_stack+111895, vrr_stack+1162, vrr_stack+476, vrr_stack+25258);
 _BUILD_g0n0(Data,vrr_stack+112951, vrr_stack+62355, vrr_stack+112291, vrr_stack+58240, vrr_stack+61959, vrr_stack+25588);
 _BUILD_h0n0(Data,vrr_stack+77359, vrr_stack+22139, vrr_stack+112951, vrr_stack+17219, vrr_stack+62355, vrr_stack+26138);
 _BUILD_i0n0(Data,vrr_stack+25093, vrr_stack+43364, vrr_stack+77359, vrr_stack+52195, vrr_stack+22139, vrr_stack+27044);
 _BUILD_k0n0(Data,vrr_stack+40900, vrr_stack+100591, vrr_stack+25093, vrr_stack+11625, vrr_stack+43364, vrr_stack+28199);
 _BUILD_l0n0(Data,vrr_stack+113941, vrr_stack+102439, vrr_stack+40900, vrr_stack+93133, vrr_stack+100591, vrr_stack+13655);
 _BUILD_m0n0(Data,vrr_stack+116911, vrr_stack+104815, vrr_stack+113941, vrr_stack+7875, vrr_stack+102439, vrr_stack+84003);
 _BUILD_n0n0(Data,vrr_stack+120541, vrr_stack+107785, vrr_stack+116911, vrr_stack+71353, vrr_stack+104815, vrr_stack+86478);
 _BUILD_n0n0(Data,vrr_stack+84003, vrr_stack+67041, vrr_stack+107785, vrr_stack+74389, vrr_stack+71353, vrr_stack+80978);
   tmp = vrr_stack + 84003;
   target_ptr = Libint->vrr_classes[10][10];
   for(i=0;i<4356;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00o0(Data,vrr_stack+74389, vrr_stack+36739, vrr_stack+37135, vrr_stack+56898, vrr_stack+57393, NULL);
 _BUILD_00o0(Data,vrr_stack+74467, vrr_stack+36805, vrr_stack+36739, vrr_stack+56953, vrr_stack+56898, NULL);
 _BUILD_p0o0(Data,vrr_stack+74545, vrr_stack+74467, vrr_stack+74389, NULL, NULL, vrr_stack+36739);
 _BUILD_00o0(Data,vrr_stack+74779, vrr_stack+37069, vrr_stack+36805, vrr_stack+57173, vrr_stack+56953, NULL);
 _BUILD_p0o0(Data,vrr_stack+74857, vrr_stack+74779, vrr_stack+74467, NULL, NULL, vrr_stack+36805);
 _BUILD_00o0(Data,vrr_stack+56898, vrr_stack+37135, vrr_stack+57228, vrr_stack+57393, vrr_stack+2990, NULL);
 _BUILD_p0o0(Data,vrr_stack+75091, vrr_stack+74389, vrr_stack+56898, NULL, NULL, vrr_stack+37135);
 _BUILD_d0o0(Data,vrr_stack+75325, vrr_stack+74545, vrr_stack+75091, vrr_stack+74467, vrr_stack+74389, vrr_stack+15833);
 _BUILD_d0o0(Data,vrr_stack+75793, vrr_stack+74857, vrr_stack+74545, vrr_stack+74779, vrr_stack+74467, vrr_stack+36871);
 _BUILD_f0o0(Data,vrr_stack+76261, vrr_stack+75793, vrr_stack+75325, vrr_stack+74857, vrr_stack+74545, vrr_stack+16031);
 _BUILD_00o0(Data,vrr_stack+36871, vrr_stack+57008, vrr_stack+37069, vrr_stack+1041, vrr_stack+57173, NULL);
 _BUILD_p0o0(Data,vrr_stack+15833, vrr_stack+36871, vrr_stack+74779, NULL, NULL, vrr_stack+37069);
 _BUILD_d0o0(Data,vrr_stack+88359, vrr_stack+15833, vrr_stack+74857, vrr_stack+36871, vrr_stack+74779, vrr_stack+15635);
 _BUILD_f0o0(Data,vrr_stack+27044, vrr_stack+88359, vrr_stack+75793, vrr_stack+15833, vrr_stack+74857, vrr_stack+16427);
 _BUILD_00o0(Data,vrr_stack+36949, vrr_stack+57228, vrr_stack+1096, vrr_stack+2990, vrr_stack+21364, NULL);
 _BUILD_p0o0(Data,vrr_stack+16067, vrr_stack+56898, vrr_stack+36949, NULL, NULL, vrr_stack+57228);
 _BUILD_d0o0(Data,vrr_stack+16301, vrr_stack+75091, vrr_stack+16067, vrr_stack+74389, vrr_stack+56898, vrr_stack+57646);
 _BUILD_f0o0(Data,vrr_stack+27824, vrr_stack+75325, vrr_stack+16301, vrr_stack+74545, vrr_stack+75091, vrr_stack+57844);
 _BUILD_g0o0(Data,vrr_stack+78745, vrr_stack+76261, vrr_stack+27824, vrr_stack+75793, vrr_stack+75325, vrr_stack+5235);
 _BUILD_g0o0(Data,vrr_stack+23129, vrr_stack+27044, vrr_stack+76261, vrr_stack+88359, vrr_stack+75793, vrr_stack+29739);
 _BUILD_h0o0(Data,vrr_stack+28604, vrr_stack+23129, vrr_stack+78745, vrr_stack+27044, vrr_stack+76261, vrr_stack+5895);
 _BUILD_00o0(Data,vrr_stack+5235, vrr_stack+40174, vrr_stack+57008, vrr_stack+22084, vrr_stack+1041, NULL);
 _BUILD_p0o0(Data,vrr_stack+5313, vrr_stack+5235, vrr_stack+36871, NULL, NULL, vrr_stack+57008);
 _BUILD_d0o0(Data,vrr_stack+5547, vrr_stack+5313, vrr_stack+15833, vrr_stack+5235, vrr_stack+36871, vrr_stack+57448);
 _BUILD_f0o0(Data,vrr_stack+6015, vrr_stack+5547, vrr_stack+88359, vrr_stack+5313, vrr_stack+15833, vrr_stack+16823);
 _BUILD_g0o0(Data,vrr_stack+1360, vrr_stack+6015, vrr_stack+27044, vrr_stack+5547, vrr_stack+88359, vrr_stack+4575);
 _BUILD_h0o0(Data,vrr_stack+13011, vrr_stack+1360, vrr_stack+23129, vrr_stack+6015, vrr_stack+27044, vrr_stack+17940);
 _BUILD_00o0(Data,vrr_stack+4575, vrr_stack+1096, vrr_stack+61893, vrr_stack+21364, vrr_stack+4520, NULL);
 _BUILD_p0o0(Data,vrr_stack+21364, vrr_stack+36949, vrr_stack+4575, NULL, NULL, vrr_stack+1096);
 _BUILD_d0o0(Data,vrr_stack+21598, vrr_stack+16067, vrr_stack+21364, vrr_stack+56898, vrr_stack+36949, vrr_stack+1162);
 _BUILD_f0o0(Data,vrr_stack+79915, vrr_stack+16301, vrr_stack+21598, vrr_stack+75091, vrr_stack+16067, vrr_stack+58240);
 _BUILD_g0o0(Data,vrr_stack+2530, vrr_stack+27824, vrr_stack+79915, vrr_stack+75325, vrr_stack+16301, vrr_stack+17219);
 _BUILD_h0o0(Data,vrr_stack+16769, vrr_stack+78745, vrr_stack+2530, vrr_stack+76261, vrr_stack+27824, vrr_stack+52195);
 _BUILD_i0o0(Data,vrr_stack+124897, vrr_stack+28604, vrr_stack+16769, vrr_stack+23129, vrr_stack+78745, vrr_stack+11625);
 _BUILD_i0o0(Data,vrr_stack+10251, vrr_stack+13011, vrr_stack+28604, vrr_stack+1360, vrr_stack+23129, vrr_stack+49423);
 _BUILD_k0o0(Data,vrr_stack+127081, vrr_stack+10251, vrr_stack+124897, vrr_stack+13011, vrr_stack+28604, vrr_stack+93133);
 _BUILD_00o0(Data,vrr_stack+93133, vrr_stack+65721, vrr_stack+40174, vrr_stack+45298, vrr_stack+22084, NULL);
 _BUILD_p0o0(Data,vrr_stack+93211, vrr_stack+93133, vrr_stack+5235, NULL, NULL, vrr_stack+40174);
 _BUILD_d0o0(Data,vrr_stack+93445, vrr_stack+93211, vrr_stack+5313, vrr_stack+93133, vrr_stack+5235, vrr_stack+3845);
 _BUILD_f0o0(Data,vrr_stack+93913, vrr_stack+93445, vrr_stack+5547, vrr_stack+93211, vrr_stack+5313, vrr_stack+4043);
 _BUILD_g0o0(Data,vrr_stack+49423, vrr_stack+93913, vrr_stack+6015, vrr_stack+93445, vrr_stack+5547, vrr_stack+40240);
 _BUILD_h0o0(Data,vrr_stack+129889, vrr_stack+49423, vrr_stack+1360, vrr_stack+93913, vrr_stack+6015, vrr_stack+6885);
 _BUILD_i0o0(Data,vrr_stack+131527, vrr_stack+129889, vrr_stack+13011, vrr_stack+49423, vrr_stack+1360, vrr_stack+50809);
 _BUILD_k0o0(Data,vrr_stack+133711, vrr_stack+131527, vrr_stack+10251, vrr_stack+129889, vrr_stack+13011, vrr_stack+63873);
 _BUILD_00o0(Data,vrr_stack+40240, vrr_stack+61893, vrr_stack+111631, vrr_stack+4520, vrr_stack+25038, NULL);
 _BUILD_p0o0(Data,vrr_stack+40318, vrr_stack+4575, vrr_stack+40240, NULL, NULL, vrr_stack+61893);
 _BUILD_d0o0(Data,vrr_stack+3845, vrr_stack+21364, vrr_stack+40318, vrr_stack+36949, vrr_stack+4575, vrr_stack+476);
 _BUILD_f0o0(Data,vrr_stack+50593, vrr_stack+21598, vrr_stack+3845, vrr_stack+16067, vrr_stack+21364, vrr_stack+61959);
 _BUILD_g0o0(Data,vrr_stack+51373, vrr_stack+79915, vrr_stack+50593, vrr_stack+16301, vrr_stack+21598, vrr_stack+62355);
 _BUILD_h0o0(Data,vrr_stack+61959, vrr_stack+2530, vrr_stack+51373, vrr_stack+27824, vrr_stack+79915, vrr_stack+22139);
 _BUILD_i0o0(Data,vrr_stack+136519, vrr_stack+16769, vrr_stack+61959, vrr_stack+78745, vrr_stack+2530, vrr_stack+43364);
 _BUILD_k0o0(Data,vrr_stack+138703, vrr_stack+124897, vrr_stack+136519, vrr_stack+28604, vrr_stack+16769, vrr_stack+100591);
 _BUILD_l0o0(Data,vrr_stack+141511, vrr_stack+127081, vrr_stack+138703, vrr_stack+10251, vrr_stack+124897, vrr_stack+102439);
 _BUILD_l0o0(Data,vrr_stack+100591, vrr_stack+133711, vrr_stack+127081, vrr_stack+131527, vrr_stack+10251, vrr_stack+7875);
 _BUILD_m0o0(Data,vrr_stack+145021, vrr_stack+100591, vrr_stack+141511, vrr_stack+133711, vrr_stack+127081, vrr_stack+104815);
 _BUILD_00o0(Data,vrr_stack+104101, vrr_stack+74323, vrr_stack+65721, vrr_stack+26989, vrr_stack+45298, NULL);
 _BUILD_p0o0(Data,vrr_stack+104179, vrr_stack+104101, vrr_stack+93133, NULL, NULL, vrr_stack+65721);
 _BUILD_d0o0(Data,vrr_stack+104413, vrr_stack+104179, vrr_stack+93211, vrr_stack+104101, vrr_stack+93133, vrr_stack+65787);
 _BUILD_f0o0(Data,vrr_stack+104881, vrr_stack+104413, vrr_stack+93445, vrr_stack+104179, vrr_stack+93211, vrr_stack+65985);
 _BUILD_g0o0(Data,vrr_stack+105661, vrr_stack+104881, vrr_stack+93913, vrr_stack+104413, vrr_stack+93445, vrr_stack+66381);
 _BUILD_h0o0(Data,vrr_stack+63597, vrr_stack+105661, vrr_stack+49423, vrr_stack+104881, vrr_stack+93913, vrr_stack+53185);
 _BUILD_i0o0(Data,vrr_stack+6795, vrr_stack+63597, vrr_stack+129889, vrr_stack+105661, vrr_stack+49423, vrr_stack+94981);
 _BUILD_k0o0(Data,vrr_stack+104179, vrr_stack+6795, vrr_stack+131527, vrr_stack+63597, vrr_stack+129889, vrr_stack+96367);
 _BUILD_l0o0(Data,vrr_stack+94693, vrr_stack+104179, vrr_stack+133711, vrr_stack+6795, vrr_stack+131527, vrr_stack+98215);
 _BUILD_m0o0(Data,vrr_stack+149311, vrr_stack+94693, vrr_stack+100591, vrr_stack+104179, vrr_stack+133711, vrr_stack+71353);
   tmp = vrr_stack + 149311;
   target_ptr = Libint->vrr_classes[9][11];
   for(i=0;i<4290;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00p0(Data,vrr_stack+104179, Data->F+21, Data->F+22, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+104182, vrr_stack+37201, vrr_stack+104179, Data->F+20, Data->F+21, NULL);
 _BUILD_00f0(Data,vrr_stack+104188, vrr_stack+111415, vrr_stack+104182, vrr_stack+24889, vrr_stack+37201, NULL);
 _BUILD_00g0(Data,vrr_stack+104198, vrr_stack+111421, vrr_stack+104188, vrr_stack+24892, vrr_stack+111415, NULL);
 _BUILD_00h0(Data,vrr_stack+104213, vrr_stack+111431, vrr_stack+104198, vrr_stack+24898, vrr_stack+111421, NULL);
 _BUILD_00i0(Data,vrr_stack+104234, vrr_stack+111446, vrr_stack+104213, vrr_stack+3830, vrr_stack+111431, NULL);
 _BUILD_00k0(Data,vrr_stack+104262, vrr_stack+111467, vrr_stack+104234, vrr_stack+24908, vrr_stack+111446, NULL);
 _BUILD_00l0(Data,vrr_stack+104298, vrr_stack+111495, vrr_stack+104262, vrr_stack+24929, vrr_stack+111467, NULL);
 _BUILD_00m0(Data,vrr_stack+104343, vrr_stack+111531, vrr_stack+104298, vrr_stack+24957, vrr_stack+111495, NULL);
 _BUILD_00n0(Data,vrr_stack+104398, vrr_stack+111576, vrr_stack+104343, vrr_stack+24993, vrr_stack+111531, NULL);
 _BUILD_00o0(Data,vrr_stack+104464, vrr_stack+111631, vrr_stack+104398, vrr_stack+25038, vrr_stack+111576, NULL);
 _BUILD_p0o0(Data,vrr_stack+104542, vrr_stack+40240, vrr_stack+104464, NULL, NULL, vrr_stack+111631);
 _BUILD_d0o0(Data,vrr_stack+104776, vrr_stack+40318, vrr_stack+104542, vrr_stack+4575, vrr_stack+40240, vrr_stack+111697);
 _BUILD_f0o0(Data,vrr_stack+105244, vrr_stack+3845, vrr_stack+104776, vrr_stack+21364, vrr_stack+40318, vrr_stack+111895);
 _BUILD_g0o0(Data,vrr_stack+106024, vrr_stack+50593, vrr_stack+105244, vrr_stack+21598, vrr_stack+3845, vrr_stack+112291);
 _BUILD_h0o0(Data,vrr_stack+6795, vrr_stack+51373, vrr_stack+106024, vrr_stack+79915, vrr_stack+50593, vrr_stack+112951);
 _BUILD_i0o0(Data,vrr_stack+111697, vrr_stack+61959, vrr_stack+6795, vrr_stack+2530, vrr_stack+51373, vrr_stack+77359);
 _BUILD_k0o0(Data,vrr_stack+70671, vrr_stack+136519, vrr_stack+111697, vrr_stack+16769, vrr_stack+61959, vrr_stack+25093);
 _BUILD_l0o0(Data,vrr_stack+153601, vrr_stack+138703, vrr_stack+70671, vrr_stack+124897, vrr_stack+136519, vrr_stack+40900);
 _BUILD_m0o0(Data,vrr_stack+40552, vrr_stack+141511, vrr_stack+153601, vrr_stack+127081, vrr_stack+138703, vrr_stack+113941);
 _BUILD_n0o0(Data,vrr_stack+157111, vrr_stack+145021, vrr_stack+40552, vrr_stack+100591, vrr_stack+141511, vrr_stack+116911);
 _BUILD_n0o0(Data,vrr_stack+113881, vrr_stack+149311, vrr_stack+145021, vrr_stack+94693, vrr_stack+100591, vrr_stack+107785);
   tmp = vrr_stack + 113881;
   target_ptr = Libint->vrr_classes[10][11];
   for(i=0;i<5148;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00q0(Data,vrr_stack+94693, vrr_stack+74389, vrr_stack+56898, vrr_stack+36739, vrr_stack+37135, NULL);
 _BUILD_00q0(Data,vrr_stack+94784, vrr_stack+74467, vrr_stack+74389, vrr_stack+36805, vrr_stack+36739, NULL);
 _BUILD_p0q0(Data,vrr_stack+94875, vrr_stack+94784, vrr_stack+94693, NULL, NULL, vrr_stack+74389);
 _BUILD_00q0(Data,vrr_stack+95148, vrr_stack+74779, vrr_stack+74467, vrr_stack+37069, vrr_stack+36805, NULL);
 _BUILD_p0q0(Data,vrr_stack+95239, vrr_stack+95148, vrr_stack+94784, NULL, NULL, vrr_stack+74467);
 _BUILD_00q0(Data,vrr_stack+36739, vrr_stack+56898, vrr_stack+36949, vrr_stack+37135, vrr_stack+57228, NULL);
 _BUILD_p0q0(Data,vrr_stack+95512, vrr_stack+94693, vrr_stack+36739, NULL, NULL, vrr_stack+56898);
 _BUILD_d0q0(Data,vrr_stack+95785, vrr_stack+94875, vrr_stack+95512, vrr_stack+94784, vrr_stack+94693, vrr_stack+75091);
 _BUILD_d0q0(Data,vrr_stack+96331, vrr_stack+95239, vrr_stack+94875, vrr_stack+95148, vrr_stack+94784, vrr_stack+74545);
 _BUILD_f0q0(Data,vrr_stack+96877, vrr_stack+96331, vrr_stack+95785, vrr_stack+95239, vrr_stack+94875, vrr_stack+75325);
 _BUILD_00q0(Data,vrr_stack+74545, vrr_stack+36871, vrr_stack+74779, vrr_stack+57008, vrr_stack+37069, NULL);
 _BUILD_p0q0(Data,vrr_stack+75091, vrr_stack+74545, vrr_stack+95148, NULL, NULL, vrr_stack+74779);
 _BUILD_d0q0(Data,vrr_stack+97787, vrr_stack+75091, vrr_stack+95239, vrr_stack+74545, vrr_stack+95148, vrr_stack+74857);
 _BUILD_f0q0(Data,vrr_stack+98333, vrr_stack+97787, vrr_stack+96331, vrr_stack+75091, vrr_stack+95239, vrr_stack+75793);
 _BUILD_00q0(Data,vrr_stack+74857, vrr_stack+36949, vrr_stack+4575, vrr_stack+57228, vrr_stack+1096, NULL);
 _BUILD_p0q0(Data,vrr_stack+75364, vrr_stack+36739, vrr_stack+74857, NULL, NULL, vrr_stack+36949);
 _BUILD_d0q0(Data,vrr_stack+75637, vrr_stack+95512, vrr_stack+75364, vrr_stack+94693, vrr_stack+36739, vrr_stack+16067);
 _BUILD_f0q0(Data,vrr_stack+99243, vrr_stack+95785, vrr_stack+75637, vrr_stack+94875, vrr_stack+95512, vrr_stack+16301);
 _BUILD_g0q0(Data,vrr_stack+119029, vrr_stack+96877, vrr_stack+99243, vrr_stack+96331, vrr_stack+95785, vrr_stack+27824);
 _BUILD_g0q0(Data,vrr_stack+8433, vrr_stack+98333, vrr_stack+96877, vrr_stack+97787, vrr_stack+96331, vrr_stack+76261);
 _BUILD_h0q0(Data,vrr_stack+76183, vrr_stack+8433, vrr_stack+119029, vrr_stack+98333, vrr_stack+96877, vrr_stack+78745);
 _BUILD_00q0(Data,vrr_stack+27824, vrr_stack+5235, vrr_stack+36871, vrr_stack+40174, vrr_stack+57008, NULL);
 _BUILD_p0q0(Data,vrr_stack+27915, vrr_stack+27824, vrr_stack+74545, NULL, NULL, vrr_stack+36871);
 _BUILD_d0q0(Data,vrr_stack+16067, vrr_stack+27915, vrr_stack+75091, vrr_stack+27824, vrr_stack+74545, vrr_stack+15833);
 _BUILD_f0q0(Data,vrr_stack+78094, vrr_stack+16067, vrr_stack+97787, vrr_stack+27915, vrr_stack+75091, vrr_stack+88359);
 _BUILD_g0q0(Data,vrr_stack+63597, vrr_stack+78094, vrr_stack+98333, vrr_stack+16067, vrr_stack+97787, vrr_stack+27044);
 _BUILD_h0q0(Data,vrr_stack+56976, vrr_stack+63597, vrr_stack+8433, vrr_stack+78094, vrr_stack+98333, vrr_stack+23129);
 _BUILD_00q0(Data,vrr_stack+88359, vrr_stack+4575, vrr_stack+40240, vrr_stack+1096, vrr_stack+61893, NULL);
 _BUILD_p0q0(Data,vrr_stack+88450, vrr_stack+74857, vrr_stack+88359, NULL, NULL, vrr_stack+4575);
 _BUILD_d0q0(Data,vrr_stack+88723, vrr_stack+75364, vrr_stack+88450, vrr_stack+36739, vrr_stack+74857, vrr_stack+21364);
 _BUILD_f0q0(Data,vrr_stack+79004, vrr_stack+75637, vrr_stack+88723, vrr_stack+95512, vrr_stack+75364, vrr_stack+21598);
 _BUILD_g0q0(Data,vrr_stack+21364, vrr_stack+99243, vrr_stack+79004, vrr_stack+95785, vrr_stack+75637, vrr_stack+79915);
 _BUILD_h0q0(Data,vrr_stack+22729, vrr_stack+119029, vrr_stack+21364, vrr_stack+96877, vrr_stack+99243, vrr_stack+2530);
 _BUILD_i0q0(Data,vrr_stack+24640, vrr_stack+76183, vrr_stack+22729, vrr_stack+8433, vrr_stack+119029, vrr_stack+16769);
 _BUILD_i0q0(Data,vrr_stack+162259, vrr_stack+56976, vrr_stack+76183, vrr_stack+63597, vrr_stack+8433, vrr_stack+28604);
 _BUILD_k0q0(Data,vrr_stack+164807, vrr_stack+162259, vrr_stack+24640, vrr_stack+56976, vrr_stack+76183, vrr_stack+124897);
 _BUILD_00q0(Data,vrr_stack+124897, vrr_stack+93133, vrr_stack+5235, vrr_stack+65721, vrr_stack+40174, NULL);
 _BUILD_p0q0(Data,vrr_stack+124988, vrr_stack+124897, vrr_stack+27824, NULL, NULL, vrr_stack+5235);
 _BUILD_d0q0(Data,vrr_stack+125261, vrr_stack+124988, vrr_stack+27915, vrr_stack+124897, vrr_stack+27824, vrr_stack+5313);
 _BUILD_f0q0(Data,vrr_stack+125807, vrr_stack+125261, vrr_stack+16067, vrr_stack+124988, vrr_stack+27915, vrr_stack+5547);
 _BUILD_g0q0(Data,vrr_stack+28188, vrr_stack+125807, vrr_stack+78094, vrr_stack+125261, vrr_stack+16067, vrr_stack+6015);
 _BUILD_h0q0(Data,vrr_stack+16613, vrr_stack+28188, vrr_stack+63597, vrr_stack+125807, vrr_stack+78094, vrr_stack+1360);
 _BUILD_i0q0(Data,vrr_stack+0, vrr_stack+16613, vrr_stack+56976, vrr_stack+28188, vrr_stack+63597, vrr_stack+13011);
 _BUILD_k0q0(Data,vrr_stack+12435, vrr_stack+0, vrr_stack+162259, vrr_stack+16613, vrr_stack+56976, vrr_stack+10251);
 _BUILD_00q0(Data,vrr_stack+5313, vrr_stack+40240, vrr_stack+104464, vrr_stack+61893, vrr_stack+111631, NULL);
 _BUILD_p0q0(Data,vrr_stack+5404, vrr_stack+88359, vrr_stack+5313, NULL, NULL, vrr_stack+40240);
 _BUILD_d0q0(Data,vrr_stack+5677, vrr_stack+88450, vrr_stack+5404, vrr_stack+74857, vrr_stack+88359, vrr_stack+40318);
 _BUILD_f0q0(Data,vrr_stack+29553, vrr_stack+88723, vrr_stack+5677, vrr_stack+75364, vrr_stack+88450, vrr_stack+3845);
 _BUILD_g0q0(Data,vrr_stack+9798, vrr_stack+79004, vrr_stack+29553, vrr_stack+75637, vrr_stack+88723, vrr_stack+50593);
 _BUILD_h0q0(Data,vrr_stack+2548, vrr_stack+21364, vrr_stack+9798, vrr_stack+99243, vrr_stack+79004, vrr_stack+51373);
 _BUILD_i0q0(Data,vrr_stack+50593, vrr_stack+22729, vrr_stack+2548, vrr_stack+119029, vrr_stack+21364, vrr_stack+61959);
 _BUILD_k0q0(Data,vrr_stack+168083, vrr_stack+24640, vrr_stack+50593, vrr_stack+76183, vrr_stack+22729, vrr_stack+136519);
 _BUILD_l0q0(Data,vrr_stack+171359, vrr_stack+164807, vrr_stack+168083, vrr_stack+162259, vrr_stack+24640, vrr_stack+138703);
 _BUILD_l0q0(Data,vrr_stack+136519, vrr_stack+12435, vrr_stack+164807, vrr_stack+0, vrr_stack+162259, vrr_stack+127081);
 _BUILD_m0q0(Data,vrr_stack+175454, vrr_stack+136519, vrr_stack+171359, vrr_stack+12435, vrr_stack+164807, vrr_stack+141511);
 _BUILD_00q0(Data,vrr_stack+140614, vrr_stack+104101, vrr_stack+93133, vrr_stack+74323, vrr_stack+65721, NULL);
 _BUILD_p0q0(Data,vrr_stack+140705, vrr_stack+140614, vrr_stack+124897, NULL, NULL, vrr_stack+93133);
 _BUILD_d0q0(Data,vrr_stack+140978, vrr_stack+140705, vrr_stack+124988, vrr_stack+140614, vrr_stack+124897, vrr_stack+93211);
 _BUILD_f0q0(Data,vrr_stack+73479, vrr_stack+140978, vrr_stack+125261, vrr_stack+140705, vrr_stack+124988, vrr_stack+93445);
 _BUILD_g0q0(Data,vrr_stack+141524, vrr_stack+73479, vrr_stack+125807, vrr_stack+140978, vrr_stack+125261, vrr_stack+93913);
 _BUILD_h0q0(Data,vrr_stack+142889, vrr_stack+141524, vrr_stack+28188, vrr_stack+73479, vrr_stack+125807, vrr_stack+49423);
 _BUILD_i0q0(Data,vrr_stack+126717, vrr_stack+142889, vrr_stack+16613, vrr_stack+141524, vrr_stack+28188, vrr_stack+129889);
 _BUILD_k0q0(Data,vrr_stack+180459, vrr_stack+126717, vrr_stack+0, vrr_stack+142889, vrr_stack+16613, vrr_stack+131527);
 _BUILD_l0q0(Data,vrr_stack+140705, vrr_stack+180459, vrr_stack+12435, vrr_stack+126717, vrr_stack+0, vrr_stack+133711);
 _BUILD_m0q0(Data,vrr_stack+126717, vrr_stack+140705, vrr_stack+136519, vrr_stack+180459, vrr_stack+12435, vrr_stack+100591);
   tmp = vrr_stack + 126717;
   target_ptr = Libint->vrr_classes[9][12];
   for(i=0;i<5005;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00p0(Data,vrr_stack+180459, Data->F+22, Data->F+23, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+180462, vrr_stack+104179, vrr_stack+180459, Data->F+21, Data->F+22, NULL);
 _BUILD_00f0(Data,vrr_stack+180468, vrr_stack+104182, vrr_stack+180462, vrr_stack+37201, vrr_stack+104179, NULL);
 _BUILD_00g0(Data,vrr_stack+180478, vrr_stack+104188, vrr_stack+180468, vrr_stack+111415, vrr_stack+104182, NULL);
 _BUILD_00h0(Data,vrr_stack+180493, vrr_stack+104198, vrr_stack+180478, vrr_stack+111421, vrr_stack+104188, NULL);
 _BUILD_00i0(Data,vrr_stack+180514, vrr_stack+104213, vrr_stack+180493, vrr_stack+111431, vrr_stack+104198, NULL);
 _BUILD_00k0(Data,vrr_stack+58887, vrr_stack+104234, vrr_stack+180514, vrr_stack+111446, vrr_stack+104213, NULL);
 _BUILD_00l0(Data,vrr_stack+111415, vrr_stack+104262, vrr_stack+58887, vrr_stack+111467, vrr_stack+104234, NULL);
 _BUILD_00m0(Data,vrr_stack+180542, vrr_stack+104298, vrr_stack+111415, vrr_stack+111495, vrr_stack+104262, NULL);
 _BUILD_00n0(Data,vrr_stack+40174, vrr_stack+104343, vrr_stack+180542, vrr_stack+111531, vrr_stack+104298, NULL);
 _BUILD_00o0(Data,vrr_stack+111460, vrr_stack+104398, vrr_stack+40174, vrr_stack+111576, vrr_stack+104343, NULL);
 _BUILD_00q0(Data,vrr_stack+111538, vrr_stack+104464, vrr_stack+111460, vrr_stack+111631, vrr_stack+104398, NULL);
 _BUILD_p0q0(Data,vrr_stack+180597, vrr_stack+5313, vrr_stack+111538, NULL, NULL, vrr_stack+104464);
 _BUILD_d0q0(Data,vrr_stack+180870, vrr_stack+5404, vrr_stack+180597, vrr_stack+88359, vrr_stack+5313, vrr_stack+104542);
 _BUILD_f0q0(Data,vrr_stack+73479, vrr_stack+5677, vrr_stack+180870, vrr_stack+88450, vrr_stack+5404, vrr_stack+104776);
 _BUILD_g0q0(Data,vrr_stack+181416, vrr_stack+29553, vrr_stack+73479, vrr_stack+88723, vrr_stack+5677, vrr_stack+105244);
 _BUILD_h0q0(Data,vrr_stack+131722, vrr_stack+9798, vrr_stack+181416, vrr_stack+79004, vrr_stack+29553, vrr_stack+106024);
 _BUILD_i0q0(Data,vrr_stack+104542, vrr_stack+2548, vrr_stack+131722, vrr_stack+21364, vrr_stack+9798, vrr_stack+6795);
 _BUILD_k0q0(Data,vrr_stack+100153, vrr_stack+50593, vrr_stack+104542, vrr_stack+22729, vrr_stack+2548, vrr_stack+111697);
 _BUILD_l0q0(Data,vrr_stack+182781, vrr_stack+168083, vrr_stack+100153, vrr_stack+24640, vrr_stack+50593, vrr_stack+70671);
 _BUILD_m0q0(Data,vrr_stack+186876, vrr_stack+171359, vrr_stack+182781, vrr_stack+164807, vrr_stack+168083, vrr_stack+153601);
 _BUILD_n0q0(Data,vrr_stack+191881, vrr_stack+175454, vrr_stack+186876, vrr_stack+136519, vrr_stack+171359, vrr_stack+40552);
 _BUILD_n0q0(Data,vrr_stack+40318, vrr_stack+126717, vrr_stack+175454, vrr_stack+140705, vrr_stack+136519, vrr_stack+145021);
   tmp = vrr_stack + 40318;
   target_ptr = Libint->vrr_classes[10][12];
   for(i=0;i<6006;i++)
     target_ptr[i] += tmp[i];
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+140705, vrr_stack+94693, vrr_stack+36739, vrr_stack+74389, vrr_stack+56898, NULL);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+140810, vrr_stack+94784, vrr_stack+94693, vrr_stack+74467, vrr_stack+74389, NULL);
 am[0] = 1;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+140915, vrr_stack+140810, vrr_stack+140705, NULL, NULL, vrr_stack+94693);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+141230, vrr_stack+95148, vrr_stack+94784, vrr_stack+74779, vrr_stack+74467, NULL);
 am[0] = 1;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+141335, vrr_stack+141230, vrr_stack+140810, NULL, NULL, vrr_stack+94784);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+74389, vrr_stack+36739, vrr_stack+74857, vrr_stack+56898, vrr_stack+36949, NULL);
 am[0] = 1;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+141650, vrr_stack+140705, vrr_stack+74389, NULL, NULL, vrr_stack+36739);
 am[0] = 2;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+141965, vrr_stack+140915, vrr_stack+141650, vrr_stack+140810, vrr_stack+140705, vrr_stack+95512);
 am[0] = 2;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+142595, vrr_stack+141335, vrr_stack+140915, vrr_stack+141230, vrr_stack+140810, vrr_stack+94875);
 am[0] = 3;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+143225, vrr_stack+142595, vrr_stack+141965, vrr_stack+141335, vrr_stack+140915, vrr_stack+95785);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+94875, vrr_stack+74545, vrr_stack+95148, vrr_stack+36871, vrr_stack+74779, NULL);
 am[0] = 1;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+95512, vrr_stack+94875, vrr_stack+141230, NULL, NULL, vrr_stack+95148);
 am[0] = 2;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+144275, vrr_stack+95512, vrr_stack+141335, vrr_stack+94875, vrr_stack+141230, vrr_stack+95239);
 am[0] = 3;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+153601, vrr_stack+144275, vrr_stack+142595, vrr_stack+95512, vrr_stack+141335, vrr_stack+96331);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+95239, vrr_stack+74857, vrr_stack+88359, vrr_stack+36949, vrr_stack+4575, NULL);
 am[0] = 1;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+95827, vrr_stack+74389, vrr_stack+95239, NULL, NULL, vrr_stack+74857);
 am[0] = 2;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+96142, vrr_stack+141650, vrr_stack+95827, vrr_stack+140705, vrr_stack+74389, vrr_stack+75364);
 am[0] = 3;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+154651, vrr_stack+141965, vrr_stack+96142, vrr_stack+140915, vrr_stack+141650, vrr_stack+75637);
 am[0] = 4;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+70671, vrr_stack+143225, vrr_stack+154651, vrr_stack+142595, vrr_stack+141965, vrr_stack+99243);
 am[0] = 4;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+111629, vrr_stack+153601, vrr_stack+143225, vrr_stack+144275, vrr_stack+142595, vrr_stack+96877);
 am[0] = 5;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+133633, vrr_stack+111629, vrr_stack+70671, vrr_stack+153601, vrr_stack+143225, vrr_stack+119029);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+119029, vrr_stack+27824, vrr_stack+74545, vrr_stack+5235, vrr_stack+36871, NULL);
 am[0] = 1;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+119134, vrr_stack+119029, vrr_stack+94875, NULL, NULL, vrr_stack+74545);
 am[0] = 2;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+119449, vrr_stack+119134, vrr_stack+95512, vrr_stack+119029, vrr_stack+94875, vrr_stack+75091);
 am[0] = 3;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+155701, vrr_stack+119449, vrr_stack+144275, vrr_stack+119134, vrr_stack+95512, vrr_stack+97787);
 am[0] = 4;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+61893, vrr_stack+155701, vrr_stack+153601, vrr_stack+119449, vrr_stack+144275, vrr_stack+98333);
 am[0] = 5;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+96772, vrr_stack+61893, vrr_stack+111629, vrr_stack+155701, vrr_stack+153601, vrr_stack+8433);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+120079, vrr_stack+88359, vrr_stack+5313, vrr_stack+4575, vrr_stack+40240, NULL);
 am[0] = 1;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+120184, vrr_stack+95239, vrr_stack+120079, NULL, NULL, vrr_stack+88359);
 am[0] = 2;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+98977, vrr_stack+95827, vrr_stack+120184, vrr_stack+74389, vrr_stack+95239, vrr_stack+88450);
 am[0] = 3;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+72246, vrr_stack+96142, vrr_stack+98977, vrr_stack+141650, vrr_stack+95827, vrr_stack+88723);
 am[0] = 4;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+6223, vrr_stack+154651, vrr_stack+72246, vrr_stack+141965, vrr_stack+96142, vrr_stack+79004);
 am[0] = 5;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+197887, vrr_stack+70671, vrr_stack+6223, vrr_stack+143225, vrr_stack+154651, vrr_stack+21364);
 am[0] = 6;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+200092, vrr_stack+133633, vrr_stack+197887, vrr_stack+111629, vrr_stack+70671, vrr_stack+22729);
 am[0] = 6;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+21364, vrr_stack+96772, vrr_stack+133633, vrr_stack+61893, vrr_stack+111629, vrr_stack+76183);
 am[0] = 7;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+203032, vrr_stack+21364, vrr_stack+200092, vrr_stack+96772, vrr_stack+133633, vrr_stack+24640);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+24304, vrr_stack+124897, vrr_stack+27824, vrr_stack+93133, vrr_stack+5235, NULL);
 am[0] = 1;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+24409, vrr_stack+24304, vrr_stack+119029, NULL, NULL, vrr_stack+27824);
 am[0] = 2;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+24724, vrr_stack+24409, vrr_stack+119134, vrr_stack+24304, vrr_stack+119029, vrr_stack+27915);
 am[0] = 3;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+25354, vrr_stack+24724, vrr_stack+119449, vrr_stack+24409, vrr_stack+119134, vrr_stack+16067);
 am[0] = 4;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+79004, vrr_stack+25354, vrr_stack+155701, vrr_stack+24724, vrr_stack+119449, vrr_stack+78094);
 am[0] = 5;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+74948, vrr_stack+79004, vrr_stack+61893, vrr_stack+25354, vrr_stack+155701, vrr_stack+63597);
 am[0] = 6;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+63468, vrr_stack+74948, vrr_stack+96772, vrr_stack+79004, vrr_stack+61893, vrr_stack+56976);
 am[0] = 7;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+206812, vrr_stack+63468, vrr_stack+21364, vrr_stack+74948, vrr_stack+96772, vrr_stack+162259);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+162259, vrr_stack+5313, vrr_stack+111538, vrr_stack+40240, vrr_stack+104464, NULL);
 am[0] = 1;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+162364, vrr_stack+120079, vrr_stack+162259, NULL, NULL, vrr_stack+5313);
 am[0] = 2;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+162679, vrr_stack+120184, vrr_stack+162364, vrr_stack+95239, vrr_stack+120079, vrr_stack+5404);
 am[0] = 3;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+163309, vrr_stack+98977, vrr_stack+162679, vrr_stack+95827, vrr_stack+120184, vrr_stack+5677);
 am[0] = 4;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+56898, vrr_stack+72246, vrr_stack+163309, vrr_stack+96142, vrr_stack+98977, vrr_stack+29553);
 am[0] = 5;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+210592, vrr_stack+6223, vrr_stack+56898, vrr_stack+154651, vrr_stack+72246, vrr_stack+9798);
 am[0] = 6;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+7798, vrr_stack+197887, vrr_stack+210592, vrr_stack+70671, vrr_stack+6223, vrr_stack+2548);
 am[0] = 7;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+212797, vrr_stack+200092, vrr_stack+7798, vrr_stack+133633, vrr_stack+197887, vrr_stack+50593);
 am[0] = 8;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+49423, vrr_stack+203032, vrr_stack+212797, vrr_stack+21364, vrr_stack+200092, vrr_stack+168083);
 am[0] = 8;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+216577, vrr_stack+206812, vrr_stack+203032, vrr_stack+63468, vrr_stack+21364, vrr_stack+164807);
 am[0] = 9;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+164359, vrr_stack+216577, vrr_stack+49423, vrr_stack+206812, vrr_stack+203032, vrr_stack+171359);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+2548, vrr_stack+140614, vrr_stack+124897, vrr_stack+104101, vrr_stack+93133, NULL);
 am[0] = 1;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+93133, vrr_stack+2548, vrr_stack+24304, NULL, NULL, vrr_stack+124897);
 am[0] = 2;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+93448, vrr_stack+93133, vrr_stack+24409, vrr_stack+2548, vrr_stack+24304, vrr_stack+124988);
 am[0] = 3;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+2653, vrr_stack+93448, vrr_stack+24724, vrr_stack+93133, vrr_stack+24409, vrr_stack+125261);
 am[0] = 4;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+3703, vrr_stack+2653, vrr_stack+25354, vrr_stack+93448, vrr_stack+24724, vrr_stack+125807);
 am[0] = 5;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+170134, vrr_stack+3703, vrr_stack+79004, vrr_stack+2653, vrr_stack+25354, vrr_stack+28188);
 am[0] = 6;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+172339, vrr_stack+170134, vrr_stack+74948, vrr_stack+3703, vrr_stack+79004, vrr_stack+16613);
 am[0] = 7;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+221302, vrr_stack+172339, vrr_stack+63468, vrr_stack+170134, vrr_stack+74948, vrr_stack+0);
 am[0] = 8;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+225082, vrr_stack+221302, vrr_stack+206812, vrr_stack+172339, vrr_stack+63468, vrr_stack+12435);
 am[0] = 9;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+10738, vrr_stack+225082, vrr_stack+216577, vrr_stack+221302, vrr_stack+206812, vrr_stack+136519);
   tmp = vrr_stack + 10738;
   target_ptr = Libint->vrr_classes[9][13];
   for(i=0;i<5775;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00p0(Data,vrr_stack+221302, Data->F+23, Data->F+24, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+221305, vrr_stack+180459, vrr_stack+221302, Data->F+22, Data->F+23, NULL);
 _BUILD_00f0(Data,vrr_stack+221311, vrr_stack+180462, vrr_stack+221305, vrr_stack+104179, vrr_stack+180459, NULL);
 _BUILD_00g0(Data,vrr_stack+221321, vrr_stack+180468, vrr_stack+221311, vrr_stack+104182, vrr_stack+180462, NULL);
 _BUILD_00h0(Data,vrr_stack+221336, vrr_stack+180478, vrr_stack+221321, vrr_stack+104188, vrr_stack+180468, NULL);
 _BUILD_00i0(Data,vrr_stack+221357, vrr_stack+180493, vrr_stack+221336, vrr_stack+104198, vrr_stack+180478, NULL);
 _BUILD_00k0(Data,vrr_stack+221385, vrr_stack+180514, vrr_stack+221357, vrr_stack+104213, vrr_stack+180493, NULL);
 _BUILD_00l0(Data,vrr_stack+221421, vrr_stack+58887, vrr_stack+221385, vrr_stack+104234, vrr_stack+180514, NULL);
 _BUILD_00m0(Data,vrr_stack+221466, vrr_stack+111415, vrr_stack+221421, vrr_stack+104262, vrr_stack+58887, NULL);
 _BUILD_00n0(Data,vrr_stack+221521, vrr_stack+180542, vrr_stack+221466, vrr_stack+104298, vrr_stack+111415, NULL);
 _BUILD_00o0(Data,vrr_stack+40240, vrr_stack+40174, vrr_stack+221521, vrr_stack+104343, vrr_stack+180542, NULL);
 _BUILD_00q0(Data,vrr_stack+221587, vrr_stack+111460, vrr_stack+40240, vrr_stack+104398, vrr_stack+40174, NULL);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+221678, vrr_stack+111538, vrr_stack+221587, vrr_stack+104464, vrr_stack+111460, NULL);
 am[0] = 1;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+221783, vrr_stack+162259, vrr_stack+221678, NULL, NULL, vrr_stack+111538);
 am[0] = 2;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+222098, vrr_stack+162364, vrr_stack+221783, vrr_stack+120079, vrr_stack+162259, vrr_stack+180597);
 am[0] = 3;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+222728, vrr_stack+162679, vrr_stack+222098, vrr_stack+120184, vrr_stack+162364, vrr_stack+180870);
 am[0] = 4;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+0, vrr_stack+163309, vrr_stack+222728, vrr_stack+98977, vrr_stack+162679, vrr_stack+73479);
 am[0] = 5;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+170134, vrr_stack+56898, vrr_stack+0, vrr_stack+72246, vrr_stack+163309, vrr_stack+181416);
 am[0] = 6;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+172339, vrr_stack+210592, vrr_stack+170134, vrr_stack+6223, vrr_stack+56898, vrr_stack+131722);
 am[0] = 7;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+135838, vrr_stack+7798, vrr_stack+172339, vrr_stack+197887, vrr_stack+210592, vrr_stack+104542);
 am[0] = 8;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+229807, vrr_stack+212797, vrr_stack+135838, vrr_stack+200092, vrr_stack+7798, vrr_stack+100153);
 am[0] = 9;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+99607, vrr_stack+49423, vrr_stack+229807, vrr_stack+203032, vrr_stack+212797, vrr_stack+182781);
 am[0] = 10;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+234532, vrr_stack+164359, vrr_stack+99607, vrr_stack+216577, vrr_stack+49423, vrr_stack+186876);
 am[0] = 10;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+180597, vrr_stack+10738, vrr_stack+164359, vrr_stack+225082, vrr_stack+216577, vrr_stack+175454);
   tmp = vrr_stack + 180597;
   target_ptr = Libint->vrr_classes[10][13];
   for(i=0;i<6930;i++)
     target_ptr[i] += tmp[i];
 am[0] = 0;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+131722, vrr_stack+140705, vrr_stack+74389, vrr_stack+94693, vrr_stack+36739, NULL);
 am[0] = 0;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+131842, vrr_stack+140810, vrr_stack+140705, vrr_stack+94784, vrr_stack+94693, NULL);
 am[0] = 1;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+156751, vrr_stack+131842, vrr_stack+131722, NULL, NULL, vrr_stack+140705);
 am[0] = 0;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+131962, vrr_stack+141230, vrr_stack+140810, vrr_stack+95148, vrr_stack+94784, NULL);
 am[0] = 1;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+132082, vrr_stack+131962, vrr_stack+131842, NULL, NULL, vrr_stack+140810);
 am[0] = 0;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+140705, vrr_stack+74389, vrr_stack+95239, vrr_stack+36739, vrr_stack+74857, NULL);
 am[0] = 1;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+36739, vrr_stack+131722, vrr_stack+140705, NULL, NULL, vrr_stack+74389);
 am[0] = 2;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+132442, vrr_stack+156751, vrr_stack+36739, vrr_stack+131842, vrr_stack+131722, vrr_stack+141650);
 am[0] = 2;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+187527, vrr_stack+132082, vrr_stack+156751, vrr_stack+131962, vrr_stack+131842, vrr_stack+140915);
 am[0] = 3;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+188247, vrr_stack+187527, vrr_stack+132442, vrr_stack+132082, vrr_stack+156751, vrr_stack+141965);
 am[0] = 0;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+131842, vrr_stack+94875, vrr_stack+141230, vrr_stack+74545, vrr_stack+95148, NULL);
 am[0] = 1;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+141650, vrr_stack+131842, vrr_stack+131962, NULL, NULL, vrr_stack+141230);
 am[0] = 2;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+189447, vrr_stack+141650, vrr_stack+132082, vrr_stack+131842, vrr_stack+131962, vrr_stack+141335);
 am[0] = 3;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+190167, vrr_stack+189447, vrr_stack+187527, vrr_stack+141650, vrr_stack+132082, vrr_stack+142595);
 am[0] = 0;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+131962, vrr_stack+95239, vrr_stack+120079, vrr_stack+74857, vrr_stack+88359, NULL);
 am[0] = 1;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+132082, vrr_stack+140705, vrr_stack+131962, NULL, NULL, vrr_stack+95239);
 am[0] = 2;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+142010, vrr_stack+36739, vrr_stack+132082, vrr_stack+131722, vrr_stack+140705, vrr_stack+95827);
 am[0] = 3;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+223778, vrr_stack+132442, vrr_stack+142010, vrr_stack+156751, vrr_stack+36739, vrr_stack+96142);
 am[0] = 4;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+224978, vrr_stack+188247, vrr_stack+223778, vrr_stack+187527, vrr_stack+132442, vrr_stack+154651);
 am[0] = 4;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+226778, vrr_stack+190167, vrr_stack+188247, vrr_stack+189447, vrr_stack+187527, vrr_stack+143225);
 am[0] = 5;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+2653, vrr_stack+226778, vrr_stack+224978, vrr_stack+190167, vrr_stack+188247, vrr_stack+70671);
 am[0] = 0;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+131722, vrr_stack+119029, vrr_stack+94875, vrr_stack+27824, vrr_stack+74545, NULL);
 am[0] = 1;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+156751, vrr_stack+131722, vrr_stack+131842, NULL, NULL, vrr_stack+94875);
 am[0] = 2;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+187527, vrr_stack+156751, vrr_stack+141650, vrr_stack+131722, vrr_stack+131842, vrr_stack+95512);
 am[0] = 3;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+70671, vrr_stack+187527, vrr_stack+189447, vrr_stack+156751, vrr_stack+141650, vrr_stack+144275);
 am[0] = 4;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+142730, vrr_stack+70671, vrr_stack+190167, vrr_stack+187527, vrr_stack+189447, vrr_stack+153601);
 am[0] = 5;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+93133, vrr_stack+142730, vrr_stack+226778, vrr_stack+70671, vrr_stack+190167, vrr_stack+111629);
 am[0] = 0;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+131842, vrr_stack+120079, vrr_stack+162259, vrr_stack+88359, vrr_stack+5313, NULL);
 am[0] = 1;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+88359, vrr_stack+131962, vrr_stack+131842, NULL, NULL, vrr_stack+120079);
 am[0] = 2;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+88719, vrr_stack+132082, vrr_stack+88359, vrr_stack+140705, vrr_stack+131962, vrr_stack+120184);
 am[0] = 3;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+140705, vrr_stack+142010, vrr_stack+88719, vrr_stack+36739, vrr_stack+132082, vrr_stack+98977);
 am[0] = 4;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+111629, vrr_stack+223778, vrr_stack+140705, vrr_stack+132442, vrr_stack+142010, vrr_stack+72246);
 am[0] = 5;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+71871, vrr_stack+224978, vrr_stack+111629, vrr_stack+188247, vrr_stack+223778, vrr_stack+6223);
 am[0] = 6;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+188247, vrr_stack+2653, vrr_stack+71871, vrr_stack+226778, vrr_stack+224978, vrr_stack+197887);
 am[0] = 6;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+241462, vrr_stack+93133, vrr_stack+2653, vrr_stack+142730, vrr_stack+226778, vrr_stack+133633);
 am[0] = 7;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+244822, vrr_stack+241462, vrr_stack+188247, vrr_stack+93133, vrr_stack+2653, vrr_stack+200092);
 am[0] = 0;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+226778, vrr_stack+24304, vrr_stack+119029, vrr_stack+124897, vrr_stack+27824, NULL);
 am[0] = 1;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+226898, vrr_stack+226778, vrr_stack+131722, NULL, NULL, vrr_stack+119029);
 am[0] = 2;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+227258, vrr_stack+226898, vrr_stack+156751, vrr_stack+226778, vrr_stack+131722, vrr_stack+119134);
 am[0] = 3;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+227978, vrr_stack+227258, vrr_stack+187527, vrr_stack+226898, vrr_stack+156751, vrr_stack+119449);
 am[0] = 4;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+197887, vrr_stack+227978, vrr_stack+70671, vrr_stack+227258, vrr_stack+187527, vrr_stack+155701);
 am[0] = 5;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+199687, vrr_stack+197887, vrr_stack+142730, vrr_stack+227978, vrr_stack+70671, vrr_stack+61893);
 am[0] = 6;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+132442, vrr_stack+199687, vrr_stack+93133, vrr_stack+197887, vrr_stack+142730, vrr_stack+96772);
 am[0] = 7;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+249142, vrr_stack+132442, vrr_stack+241462, vrr_stack+199687, vrr_stack+93133, vrr_stack+21364);
 am[0] = 0;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+131722, vrr_stack+162259, vrr_stack+221678, vrr_stack+5313, vrr_stack+111538, NULL);
 am[0] = 1;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+21364, vrr_stack+131842, vrr_stack+131722, NULL, NULL, vrr_stack+162259);
 am[0] = 2;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+187527, vrr_stack+88359, vrr_stack+21364, vrr_stack+131962, vrr_stack+131842, vrr_stack+162364);
 am[0] = 3;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+70671, vrr_stack+88719, vrr_stack+187527, vrr_stack+132082, vrr_stack+88359, vrr_stack+162679);
 am[0] = 4;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+21724, vrr_stack+140705, vrr_stack+70671, vrr_stack+142010, vrr_stack+88719, vrr_stack+163309);
 am[0] = 5;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+93133, vrr_stack+111629, vrr_stack+21724, vrr_stack+223778, vrr_stack+140705, vrr_stack+56898);
 am[0] = 6;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+95653, vrr_stack+71871, vrr_stack+93133, vrr_stack+224978, vrr_stack+111629, vrr_stack+210592);
 am[0] = 7;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+253462, vrr_stack+188247, vrr_stack+95653, vrr_stack+2653, vrr_stack+71871, vrr_stack+7798);
 am[0] = 8;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+2653, vrr_stack+244822, vrr_stack+253462, vrr_stack+241462, vrr_stack+188247, vrr_stack+212797);
 am[0] = 8;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+210592, vrr_stack+249142, vrr_stack+244822, vrr_stack+132442, vrr_stack+241462, vrr_stack+203032);
 am[0] = 9;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+257782, vrr_stack+210592, vrr_stack+2653, vrr_stack+249142, vrr_stack+244822, vrr_stack+49423);
 am[0] = 0;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+49423, vrr_stack+2548, vrr_stack+24304, vrr_stack+140614, vrr_stack+124897, NULL);
 am[0] = 1;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+124897, vrr_stack+49423, vrr_stack+226778, NULL, NULL, vrr_stack+24304);
 am[0] = 2;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+125257, vrr_stack+124897, vrr_stack+226898, vrr_stack+49423, vrr_stack+226778, vrr_stack+24409);
 am[0] = 3;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+23524, vrr_stack+125257, vrr_stack+227258, vrr_stack+124897, vrr_stack+226898, vrr_stack+24724);
 am[0] = 4;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+49423, vrr_stack+23524, vrr_stack+227978, vrr_stack+125257, vrr_stack+227258, vrr_stack+25354);
 am[0] = 5;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+24724, vrr_stack+49423, vrr_stack+197887, vrr_stack+23524, vrr_stack+227978, vrr_stack+79004);
 am[0] = 6;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+241462, vrr_stack+24724, vrr_stack+199687, vrr_stack+49423, vrr_stack+197887, vrr_stack+74948);
 am[0] = 7;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+49423, vrr_stack+241462, vrr_stack+132442, vrr_stack+24724, vrr_stack+199687, vrr_stack+63468);
 am[0] = 8;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+197887, vrr_stack+49423, vrr_stack+249142, vrr_stack+241462, vrr_stack+132442, vrr_stack+206812);
 am[0] = 9;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+203287, vrr_stack+197887, vrr_stack+210592, vrr_stack+49423, vrr_stack+249142, vrr_stack+216577);
   tmp = vrr_stack + 203287;
   target_ptr = Libint->vrr_classes[9][14];
   for(i=0;i<6600;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00p0(Data,vrr_stack+249142, Data->F+24, Data->F+25, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+249145, vrr_stack+221302, vrr_stack+249142, Data->F+23, Data->F+24, NULL);
 _BUILD_00f0(Data,vrr_stack+249151, vrr_stack+221305, vrr_stack+249145, vrr_stack+180459, vrr_stack+221302, NULL);
 _BUILD_00g0(Data,vrr_stack+249161, vrr_stack+221311, vrr_stack+249151, vrr_stack+180462, vrr_stack+221305, NULL);
 _BUILD_00h0(Data,vrr_stack+249176, vrr_stack+221321, vrr_stack+249161, vrr_stack+180468, vrr_stack+221311, NULL);
 _BUILD_00i0(Data,vrr_stack+249142, vrr_stack+221336, vrr_stack+249176, vrr_stack+180478, vrr_stack+221321, NULL);
 _BUILD_00k0(Data,vrr_stack+249170, vrr_stack+221357, vrr_stack+249142, vrr_stack+180493, vrr_stack+221336, NULL);
 _BUILD_00l0(Data,vrr_stack+180459, vrr_stack+221385, vrr_stack+249170, vrr_stack+180514, vrr_stack+221357, NULL);
 _BUILD_00m0(Data,vrr_stack+249142, vrr_stack+221421, vrr_stack+180459, vrr_stack+58887, vrr_stack+221385, NULL);
 _BUILD_00n0(Data,vrr_stack+180459, vrr_stack+221466, vrr_stack+249142, vrr_stack+111415, vrr_stack+221421, NULL);
 _BUILD_00o0(Data,vrr_stack+249142, vrr_stack+221521, vrr_stack+180459, vrr_stack+180542, vrr_stack+221466, NULL);
 _BUILD_00q0(Data,vrr_stack+180459, vrr_stack+40240, vrr_stack+249142, vrr_stack+40174, vrr_stack+221521, NULL);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+249142, vrr_stack+221587, vrr_stack+180459, vrr_stack+111460, vrr_stack+40240, NULL);
 am[0] = 0;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+180459, vrr_stack+221678, vrr_stack+249142, vrr_stack+111538, vrr_stack+221587, NULL);
 am[0] = 1;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+249142, vrr_stack+131722, vrr_stack+180459, NULL, NULL, vrr_stack+221678);
 am[0] = 2;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+249502, vrr_stack+21364, vrr_stack+249142, vrr_stack+131842, vrr_stack+131722, vrr_stack+221783);
 am[0] = 3;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+131722, vrr_stack+187527, vrr_stack+249502, vrr_stack+88359, vrr_stack+21364, vrr_stack+222098);
 am[0] = 4;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+132922, vrr_stack+70671, vrr_stack+131722, vrr_stack+88719, vrr_stack+187527, vrr_stack+222728);
 am[0] = 5;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+249142, vrr_stack+21724, vrr_stack+132922, vrr_stack+140705, vrr_stack+70671, vrr_stack+0);
 am[0] = 6;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+241462, vrr_stack+93133, vrr_stack+249142, vrr_stack+111629, vrr_stack+21724, vrr_stack+170134);
 am[0] = 7;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+249142, vrr_stack+95653, vrr_stack+241462, vrr_stack+71871, vrr_stack+93133, vrr_stack+172339);
 am[0] = 8;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+70671, vrr_stack+253462, vrr_stack+249142, vrr_stack+188247, vrr_stack+95653, vrr_stack+135838);
 am[0] = 9;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+131722, vrr_stack+2653, vrr_stack+70671, vrr_stack+244822, vrr_stack+253462, vrr_stack+229807);
 am[0] = 10;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+70671, vrr_stack+257782, vrr_stack+131722, vrr_stack+210592, vrr_stack+2653, vrr_stack+99607);
 am[0] = 10;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+131722, vrr_stack+203287, vrr_stack+257782, vrr_stack+197887, vrr_stack+210592, vrr_stack+164359);
   tmp = vrr_stack + 131722;
   target_ptr = Libint->vrr_classes[10][14];
   for(i=0;i<7920;i++)
     target_ptr[i] += tmp[i];
 _BUILD_o0l0(Data,vrr_stack+153601, vrr_stack+37204, vrr_stack+58923, vrr_stack+30634, vrr_stack+54423, vrr_stack+18988);
   tmp = vrr_stack + 153601;
   target_ptr = Libint->vrr_classes[11][8];
   for(i=0;i<3510;i++)
     target_ptr[i] += tmp[i];
 _BUILD_o0m0(Data,vrr_stack+197887, vrr_stack+33109, vrr_stack+89503, vrr_stack+46398, vrr_stack+80978, vrr_stack+58923);
   tmp = vrr_stack + 197887;
   target_ptr = Libint->vrr_classes[11][9];
   for(i=0;i<4290;i++)
     target_ptr[i] += tmp[i];
 _BUILD_o0n0(Data,vrr_stack+139642, vrr_stack+84003, vrr_stack+120541, vrr_stack+67041, vrr_stack+107785, vrr_stack+89503);
   tmp = vrr_stack + 139642;
   target_ptr = Libint->vrr_classes[11][10];
   for(i=0;i<5148;i++)
     target_ptr[i] += tmp[i];
 _BUILD_o0o0(Data,vrr_stack+78591, vrr_stack+113881, vrr_stack+157111, vrr_stack+149311, vrr_stack+145021, vrr_stack+120541);
   tmp = vrr_stack + 78591;
   target_ptr = Libint->vrr_classes[11][11];
   for(i=0;i<6084;i++)
     target_ptr[i] += tmp[i];
 _BUILD_o0q0(Data,vrr_stack+144790, vrr_stack+40318, vrr_stack+191881, vrr_stack+126717, vrr_stack+175454, vrr_stack+157111);
   tmp = vrr_stack + 144790;
   target_ptr = Libint->vrr_classes[11][12];
   for(i=0;i<7098;i++)
     target_ptr[i] += tmp[i];
 am[0] = 11;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+84675, vrr_stack+180597, vrr_stack+234532, vrr_stack+10738, vrr_stack+164359, vrr_stack+191881);
   tmp = vrr_stack + 84675;
   target_ptr = Libint->vrr_classes[11][13];
   for(i=0;i<8190;i++)
     target_ptr[i] += tmp[i];
 am[0] = 11;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+157111, vrr_stack+131722, vrr_stack+70671, vrr_stack+203287, vrr_stack+257782, vrr_stack+234532);
   tmp = vrr_stack + 157111;
   target_ptr = Libint->vrr_classes[11][14];
   for(i=0;i<9360;i++)
     target_ptr[i] += tmp[i];

}

