/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include <libint/libint.h>
#include "libr12.h"
#include <libint/hrr_header.h>

#include "r12_hrr_header.h"

extern void vrr_grt_order_00dp(Libr12_t *, prim_data *);

  /* Computes (00|dp) integrals for linear R12-methods */

void hrr_grt_order_00dp(Libr12_t *Libr12, int num_prim_comb)
{
 prim_data *Data = Libr12->PrimQuartet;
 REALTYPE *int_stack = Libr12->int_stack;
 int i,j;
 REALTYPE tmp, *target;

 Libr12->gvrr_classes[1][2] = int_stack + 0;
 Libr12->t2vrr_classes[0][2] = int_stack + 18;
 Libr12->t2vrr_classes[0][3] = int_stack + 24;
 Libr12->t1vrr_classes[0][2] = int_stack + 34;
 Libr12->t1vrr_classes[0][3] = int_stack + 40;
 Libr12->rvrr_classes[0][2] = int_stack + 50;
 Libr12->rvrr_classes[0][3] = int_stack + 56;
 Libr12->gvrr_classes[0][2] = int_stack + 66;
 Libr12->gvrr_classes[0][3] = int_stack + 72;
 memset(int_stack,0,82*sizeof(REALTYPE));

 Libr12->r12vrr_stack = int_stack + 82;
 for(i=0;i<num_prim_comb;i++) {
   vrr_grt_order_00dp(Libr12, Data);
   Data++;
 }

 /*--- compute (00|[r12,T2]|dp) ---*/
   t2hrr3_build_dp(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+82, int_stack+24, int_stack+18, int_stack+72, int_stack+0, int_stack+66, 0, 0);
     Libr12->te_ptr[3] = int_stack + 82;
 /*--- compute (00|[r12,T1]|dp) ---*/
   hrr3_build_dp(Libr12->ShellQuartet.CD,int_stack+0, int_stack+40, int_stack+34, 1);
     Libr12->te_ptr[2] = int_stack + 0;
 /*--- compute (00||dp) ---*/
   hrr3_build_dp(Libr12->ShellQuartet.CD,int_stack+18, int_stack+56, int_stack+50, 1);
     Libr12->te_ptr[1] = int_stack + 18;
 /*--- compute (00|dp) ---*/
   hrr3_build_dp(Libr12->ShellQuartet.CD,int_stack+36, int_stack+72, int_stack+66, 1);
     Libr12->te_ptr[0] = int_stack + 36;

}
