/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include <libint/libint.h>
#include "libr12.h"
#include <libint/hrr_header.h>

#include "r12_hrr_header.h"

extern void vrr_grt_order_00gf(Libr12_t *, prim_data *);

  /* Computes (00|gf) integrals for linear R12-methods */

void hrr_grt_order_00gf(Libr12_t *Libr12, int num_prim_comb)
{
 prim_data *Data = Libr12->PrimQuartet;
 REALTYPE *int_stack = Libr12->int_stack;
 int i,j;
 REALTYPE tmp, *target;

 Libr12->gvrr_classes[1][4] = int_stack + 0;
 Libr12->t2vrr_classes[0][4] = int_stack + 45;
 Libr12->gvrr_classes[1][5] = int_stack + 60;
 Libr12->t2vrr_classes[0][5] = int_stack + 123;
 Libr12->gvrr_classes[1][6] = int_stack + 144;
 Libr12->t2vrr_classes[0][6] = int_stack + 228;
 Libr12->t2vrr_classes[0][7] = int_stack + 256;
 Libr12->t1vrr_classes[0][4] = int_stack + 292;
 Libr12->t1vrr_classes[0][5] = int_stack + 307;
 Libr12->t1vrr_classes[0][6] = int_stack + 328;
 Libr12->t1vrr_classes[0][7] = int_stack + 356;
 Libr12->rvrr_classes[0][4] = int_stack + 392;
 Libr12->rvrr_classes[0][5] = int_stack + 407;
 Libr12->rvrr_classes[0][6] = int_stack + 428;
 Libr12->rvrr_classes[0][7] = int_stack + 456;
 Libr12->gvrr_classes[0][4] = int_stack + 492;
 Libr12->gvrr_classes[0][5] = int_stack + 507;
 Libr12->gvrr_classes[0][6] = int_stack + 528;
 Libr12->gvrr_classes[0][7] = int_stack + 556;
 memset(int_stack,0,592*sizeof(REALTYPE));

 Libr12->r12vrr_stack = int_stack + 592;
 for(i=0;i<num_prim_comb;i++) {
   vrr_grt_order_00gf(Libr12, Data);
   Data++;
 }

 /*--- compute (00|gp) ---*/
   hrr3_build_gp(Libr12->ShellQuartet.CD,int_stack+592, int_stack+507, int_stack+492, 1);
 /*--- compute (00|hp) ---*/
   hrr3_build_hp(Libr12->ShellQuartet.CD,int_stack+637, int_stack+528, int_stack+507, 1);
 /*--- compute (00|gd) ---*/
   hrr3_build_gd(Libr12->ShellQuartet.CD,int_stack+700, int_stack+637, int_stack+592, 1);
 /*--- compute (p0|gp) ---*/
   hrr3_build_gp(Libr12->ShellQuartet.CD,int_stack+790, int_stack+60, int_stack+0, 3);
 /*--- compute (p0|hp) ---*/
   hrr3_build_hp(Libr12->ShellQuartet.CD,int_stack+925, int_stack+144, int_stack+60, 3);
 /*--- compute (p0|gd) ---*/
   hrr3_build_gd(Libr12->ShellQuartet.CD,int_stack+1114, int_stack+925, int_stack+790, 3);
 /*--- compute (00|ip) ---*/
   hrr3_build_ip(Libr12->ShellQuartet.CD,int_stack+1384, int_stack+556, int_stack+528, 1);
 /*--- compute (00|hd) ---*/
   hrr3_build_hd(Libr12->ShellQuartet.CD,int_stack+1468, int_stack+1384, int_stack+637, 1);
 /*--- compute (00|[r12,T2]|gp) ---*/
   t2hrr3_build_gp(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+1594, int_stack+123, int_stack+45, int_stack+507, int_stack+0, int_stack+492, 0, 0);
 /*--- compute (00|[r12,T2]|hp) ---*/
   t2hrr3_build_hp(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+1639, int_stack+228, int_stack+123, int_stack+528, int_stack+60, int_stack+507, 0, 0);
 /*--- compute (00|[r12,T2]|gd) ---*/
   t2hrr3_build_gd(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+0, int_stack+1639, int_stack+1594, int_stack+637, int_stack+790, int_stack+592, 0, 0);
 /*--- compute (00|[r12,T2]|ip) ---*/
   t2hrr3_build_ip(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+790, int_stack+256, int_stack+228, int_stack+556, int_stack+144, int_stack+528, 0, 0);
 /*--- compute (00|[r12,T2]|hd) ---*/
   t2hrr3_build_hd(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+492, int_stack+790, int_stack+1639, int_stack+1384, int_stack+925, int_stack+637, 0, 0);
 /*--- compute (00|[r12,T1]|gp) ---*/
   hrr3_build_gp(Libr12->ShellQuartet.CD,int_stack+1384, int_stack+307, int_stack+292, 1);
 /*--- compute (00|[r12,T1]|hp) ---*/
   hrr3_build_hp(Libr12->ShellQuartet.CD,int_stack+790, int_stack+328, int_stack+307, 1);
 /*--- compute (00|[r12,T1]|gd) ---*/
   hrr3_build_gd(Libr12->ShellQuartet.CD,int_stack+853, int_stack+790, int_stack+1384, 1);
 /*--- compute (00|[r12,T1]|ip) ---*/
   hrr3_build_ip(Libr12->ShellQuartet.CD,int_stack+1384, int_stack+356, int_stack+328, 1);
 /*--- compute (00|[r12,T1]|hd) ---*/
   hrr3_build_hd(Libr12->ShellQuartet.CD,int_stack+943, int_stack+1384, int_stack+790, 1);
 /*--- compute (00||gp) ---*/
   hrr3_build_gp(Libr12->ShellQuartet.CD,int_stack+1069, int_stack+407, int_stack+392, 1);
 /*--- compute (00||hp) ---*/
   hrr3_build_hp(Libr12->ShellQuartet.CD,int_stack+790, int_stack+428, int_stack+407, 1);
 /*--- compute (00||gd) ---*/
   hrr3_build_gd(Libr12->ShellQuartet.CD,int_stack+1594, int_stack+790, int_stack+1069, 1);
 /*--- compute (00||ip) ---*/
   hrr3_build_ip(Libr12->ShellQuartet.CD,int_stack+1384, int_stack+456, int_stack+428, 1);
 /*--- compute (00||hd) ---*/
   hrr3_build_hd(Libr12->ShellQuartet.CD,int_stack+1684, int_stack+1384, int_stack+790, 1);
 /*--- compute (00|[r12,T2]|gf) ---*/
   t2hrr3_build_gf(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+1810, int_stack+492, int_stack+0, int_stack+1468, int_stack+1114, int_stack+700, 0, 0);
     Libr12->te_ptr[3] = int_stack + 1810;
 /*--- compute (00|[r12,T1]|gf) ---*/
   hrr3_build_gf(Libr12->ShellQuartet.CD,int_stack+0, int_stack+943, int_stack+853, 1);
     Libr12->te_ptr[2] = int_stack + 0;
 /*--- compute (00||gf) ---*/
   hrr3_build_gf(Libr12->ShellQuartet.CD,int_stack+150, int_stack+1684, int_stack+1594, 1);
     Libr12->te_ptr[1] = int_stack + 150;
 /*--- compute (00|gf) ---*/
   hrr3_build_gf(Libr12->ShellQuartet.CD,int_stack+1594, int_stack+1468, int_stack+700, 1);
     Libr12->te_ptr[0] = int_stack + 1594;

}
