/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

  /* These machine-generated functions compute a quartet of (gs||hs) integrals */

#include <libint/libint.h>
#include "libr12.h"

REALTYPE *_r_build_g0h0_0(prim_data *Data, REALTYPE *vp, const REALTYPE *I0, const REALTYPE *I1, const REALTYPE *I2, const REALTYPE *I3, const REALTYPE *I4, const REALTYPE *I5)
{
  REALTYPE U00, U01, U02, U10, U11, U12, U20, U21, U22;
  REALTYPE U30, U31, U32, U40, U41, U42, U50, U51, U52;
  REALTYPE loo2p = Data->oo2p;
  REALTYPE oneo4zn;
  REALTYPE twoo4zn;
  REALTYPE threeo4zn;
  REALTYPE fouro4zn;
  REALTYPE fiveo4zn;
  REALTYPE oneo2z;
  REALTYPE twoo2z;
  REALTYPE threeo2z;
  oneo4zn = 1.0*Data->oo2z*Data->oo2n;
  twoo4zn = 2.0*Data->oo2z*Data->oo2n;
  threeo4zn = 3.0*Data->oo2z*Data->oo2n;
  fouro4zn = 4.0*Data->oo2z*Data->oo2n;
  fiveo4zn = 5.0*Data->oo2z*Data->oo2n;
  oneo2z = 1.0*Data->oo2z;
  twoo2z = 2.0*Data->oo2z;
  threeo2z = 3.0*Data->oo2z;
  U00 = Data->U[0][0];
  U01 = Data->U[0][1];
  U02 = Data->U[0][2];
  U10 = Data->U[0][0]*Data->oo2n + Data->U[1][0]*Data->oo2z;
  U11 = Data->U[0][1]*Data->oo2n + Data->U[1][1]*Data->oo2z;
  U12 = Data->U[0][2]*Data->oo2n + Data->U[1][2]*Data->oo2z;

*(vp++) = U00*I0[0] - U10*I3[0] + loo2p*I2[0]
        + (threeo2z)*I1[0] - (threeo4zn)*I4[0] - (fiveo4zn)*I5[0];
*(vp++) = U00*I0[1] - U10*I3[1] + loo2p*I2[1]
        + (threeo2z)*I1[1] - (threeo4zn)*I4[1] - (fouro4zn)*I5[1];
*(vp++) = U00*I0[2] - U10*I3[2] + loo2p*I2[2]
        + (threeo2z)*I1[2] - (threeo4zn)*I4[2] - (fouro4zn)*I5[2];
*(vp++) = U00*I0[3] - U10*I3[3] + loo2p*I2[3]
        + (threeo2z)*I1[3] - (threeo4zn)*I4[3] - (threeo4zn)*I5[3];
*(vp++) = U00*I0[4] - U10*I3[4] + loo2p*I2[4]
        + (threeo2z)*I1[4] - (threeo4zn)*I4[4] - (threeo4zn)*I5[4];
*(vp++) = U00*I0[5] - U10*I3[5] + loo2p*I2[5]
        + (threeo2z)*I1[5] - (threeo4zn)*I4[5] - (threeo4zn)*I5[5];
*(vp++) = U00*I0[6] - U10*I3[6] + loo2p*I2[6]
        + (threeo2z)*I1[6] - (threeo4zn)*I4[6] - (twoo4zn)*I5[6];
*(vp++) = U00*I0[7] - U10*I3[7] + loo2p*I2[7]
        + (threeo2z)*I1[7] - (threeo4zn)*I4[7] - (twoo4zn)*I5[7];
*(vp++) = U00*I0[8] - U10*I3[8] + loo2p*I2[8]
        + (threeo2z)*I1[8] - (threeo4zn)*I4[8] - (twoo4zn)*I5[8];
*(vp++) = U00*I0[9] - U10*I3[9] + loo2p*I2[9]
        + (threeo2z)*I1[9] - (threeo4zn)*I4[9] - (twoo4zn)*I5[9];
*(vp++) = U00*I0[10] - U10*I3[10] + loo2p*I2[10]
        + (threeo2z)*I1[10] - (threeo4zn)*I4[10] - (oneo4zn)*I5[10];
*(vp++) = U00*I0[11] - U10*I3[11] + loo2p*I2[11]
        + (threeo2z)*I1[11] - (threeo4zn)*I4[11] - (oneo4zn)*I5[11];
*(vp++) = U00*I0[12] - U10*I3[12] + loo2p*I2[12]
        + (threeo2z)*I1[12] - (threeo4zn)*I4[12] - (oneo4zn)*I5[12];
*(vp++) = U00*I0[13] - U10*I3[13] + loo2p*I2[13]
        + (threeo2z)*I1[13] - (threeo4zn)*I4[13] - (oneo4zn)*I5[13];
*(vp++) = U00*I0[14] - U10*I3[14] + loo2p*I2[14]
        + (threeo2z)*I1[14] - (threeo4zn)*I4[14] - (oneo4zn)*I5[14];
*(vp++) = U00*I0[15] - U10*I3[15] + loo2p*I2[15]
        + (threeo2z)*I1[15] - (threeo4zn)*I4[15];
*(vp++) = U00*I0[16] - U10*I3[16] + loo2p*I2[16]
        + (threeo2z)*I1[16] - (threeo4zn)*I4[16];
*(vp++) = U00*I0[17] - U10*I3[17] + loo2p*I2[17]
        + (threeo2z)*I1[17] - (threeo4zn)*I4[17];
*(vp++) = U00*I0[18] - U10*I3[18] + loo2p*I2[18]
        + (threeo2z)*I1[18] - (threeo4zn)*I4[18];
*(vp++) = U00*I0[19] - U10*I3[19] + loo2p*I2[19]
        + (threeo2z)*I1[19] - (threeo4zn)*I4[19];
*(vp++) = U00*I0[20] - U10*I3[20] + loo2p*I2[20]
        + (threeo2z)*I1[20] - (threeo4zn)*I4[20];
*(vp++) = U00*I0[21] - U10*I3[21] + loo2p*I2[21]
        + (twoo2z)*I1[21] - (twoo4zn)*I4[21] - (fiveo4zn)*I5[15];
*(vp++) = U00*I0[22] - U10*I3[22] + loo2p*I2[22]
        + (twoo2z)*I1[22] - (twoo4zn)*I4[22] - (fouro4zn)*I5[16];
*(vp++) = U00*I0[23] - U10*I3[23] + loo2p*I2[23]
        + (twoo2z)*I1[23] - (twoo4zn)*I4[23] - (fouro4zn)*I5[17];
*(vp++) = U00*I0[24] - U10*I3[24] + loo2p*I2[24]
        + (twoo2z)*I1[24] - (twoo4zn)*I4[24] - (threeo4zn)*I5[18];
*(vp++) = U00*I0[25] - U10*I3[25] + loo2p*I2[25]
        + (twoo2z)*I1[25] - (twoo4zn)*I4[25] - (threeo4zn)*I5[19];
*(vp++) = U00*I0[26] - U10*I3[26] + loo2p*I2[26]
        + (twoo2z)*I1[26] - (twoo4zn)*I4[26] - (threeo4zn)*I5[20];
*(vp++) = U00*I0[27] - U10*I3[27] + loo2p*I2[27]
        + (twoo2z)*I1[27] - (twoo4zn)*I4[27] - (twoo4zn)*I5[21];
*(vp++) = U00*I0[28] - U10*I3[28] + loo2p*I2[28]
        + (twoo2z)*I1[28] - (twoo4zn)*I4[28] - (twoo4zn)*I5[22];
*(vp++) = U00*I0[29] - U10*I3[29] + loo2p*I2[29]
        + (twoo2z)*I1[29] - (twoo4zn)*I4[29] - (twoo4zn)*I5[23];
*(vp++) = U00*I0[30] - U10*I3[30] + loo2p*I2[30]
        + (twoo2z)*I1[30] - (twoo4zn)*I4[30] - (twoo4zn)*I5[24];
*(vp++) = U00*I0[31] - U10*I3[31] + loo2p*I2[31]
        + (twoo2z)*I1[31] - (twoo4zn)*I4[31] - (oneo4zn)*I5[25];
*(vp++) = U00*I0[32] - U10*I3[32] + loo2p*I2[32]
        + (twoo2z)*I1[32] - (twoo4zn)*I4[32] - (oneo4zn)*I5[26];
*(vp++) = U00*I0[33] - U10*I3[33] + loo2p*I2[33]
        + (twoo2z)*I1[33] - (twoo4zn)*I4[33] - (oneo4zn)*I5[27];
*(vp++) = U00*I0[34] - U10*I3[34] + loo2p*I2[34]
        + (twoo2z)*I1[34] - (twoo4zn)*I4[34] - (oneo4zn)*I5[28];
*(vp++) = U00*I0[35] - U10*I3[35] + loo2p*I2[35]
        + (twoo2z)*I1[35] - (twoo4zn)*I4[35] - (oneo4zn)*I5[29];
*(vp++) = U00*I0[36] - U10*I3[36] + loo2p*I2[36]
        + (twoo2z)*I1[36] - (twoo4zn)*I4[36];
*(vp++) = U00*I0[37] - U10*I3[37] + loo2p*I2[37]
        + (twoo2z)*I1[37] - (twoo4zn)*I4[37];
*(vp++) = U00*I0[38] - U10*I3[38] + loo2p*I2[38]
        + (twoo2z)*I1[38] - (twoo4zn)*I4[38];
*(vp++) = U00*I0[39] - U10*I3[39] + loo2p*I2[39]
        + (twoo2z)*I1[39] - (twoo4zn)*I4[39];
*(vp++) = U00*I0[40] - U10*I3[40] + loo2p*I2[40]
        + (twoo2z)*I1[40] - (twoo4zn)*I4[40];
*(vp++) = U00*I0[41] - U10*I3[41] + loo2p*I2[41]
        + (twoo2z)*I1[41] - (twoo4zn)*I4[41];
*(vp++) = U00*I0[42] - U10*I3[42] + loo2p*I2[42]
        + (twoo2z)*I1[42] - (twoo4zn)*I4[42] - (fiveo4zn)*I5[30];
*(vp++) = U00*I0[43] - U10*I3[43] + loo2p*I2[43]
        + (twoo2z)*I1[43] - (twoo4zn)*I4[43] - (fouro4zn)*I5[31];
*(vp++) = U00*I0[44] - U10*I3[44] + loo2p*I2[44]
        + (twoo2z)*I1[44] - (twoo4zn)*I4[44] - (fouro4zn)*I5[32];
*(vp++) = U00*I0[45] - U10*I3[45] + loo2p*I2[45]
        + (twoo2z)*I1[45] - (twoo4zn)*I4[45] - (threeo4zn)*I5[33];
*(vp++) = U00*I0[46] - U10*I3[46] + loo2p*I2[46]
        + (twoo2z)*I1[46] - (twoo4zn)*I4[46] - (threeo4zn)*I5[34];
*(vp++) = U00*I0[47] - U10*I3[47] + loo2p*I2[47]
        + (twoo2z)*I1[47] - (twoo4zn)*I4[47] - (threeo4zn)*I5[35];
*(vp++) = U00*I0[48] - U10*I3[48] + loo2p*I2[48]
        + (twoo2z)*I1[48] - (twoo4zn)*I4[48] - (twoo4zn)*I5[36];
*(vp++) = U00*I0[49] - U10*I3[49] + loo2p*I2[49]
        + (twoo2z)*I1[49] - (twoo4zn)*I4[49] - (twoo4zn)*I5[37];
*(vp++) = U00*I0[50] - U10*I3[50] + loo2p*I2[50]
        + (twoo2z)*I1[50] - (twoo4zn)*I4[50] - (twoo4zn)*I5[38];
*(vp++) = U00*I0[51] - U10*I3[51] + loo2p*I2[51]
        + (twoo2z)*I1[51] - (twoo4zn)*I4[51] - (twoo4zn)*I5[39];
*(vp++) = U00*I0[52] - U10*I3[52] + loo2p*I2[52]
        + (twoo2z)*I1[52] - (twoo4zn)*I4[52] - (oneo4zn)*I5[40];
*(vp++) = U00*I0[53] - U10*I3[53] + loo2p*I2[53]
        + (twoo2z)*I1[53] - (twoo4zn)*I4[53] - (oneo4zn)*I5[41];
*(vp++) = U00*I0[54] - U10*I3[54] + loo2p*I2[54]
        + (twoo2z)*I1[54] - (twoo4zn)*I4[54] - (oneo4zn)*I5[42];
*(vp++) = U00*I0[55] - U10*I3[55] + loo2p*I2[55]
        + (twoo2z)*I1[55] - (twoo4zn)*I4[55] - (oneo4zn)*I5[43];
*(vp++) = U00*I0[56] - U10*I3[56] + loo2p*I2[56]
        + (twoo2z)*I1[56] - (twoo4zn)*I4[56] - (oneo4zn)*I5[44];
*(vp++) = U00*I0[57] - U10*I3[57] + loo2p*I2[57]
        + (twoo2z)*I1[57] - (twoo4zn)*I4[57];
*(vp++) = U00*I0[58] - U10*I3[58] + loo2p*I2[58]
        + (twoo2z)*I1[58] - (twoo4zn)*I4[58];
*(vp++) = U00*I0[59] - U10*I3[59] + loo2p*I2[59]
        + (twoo2z)*I1[59] - (twoo4zn)*I4[59];
*(vp++) = U00*I0[60] - U10*I3[60] + loo2p*I2[60]
        + (twoo2z)*I1[60] - (twoo4zn)*I4[60];
*(vp++) = U00*I0[61] - U10*I3[61] + loo2p*I2[61]
        + (twoo2z)*I1[61] - (twoo4zn)*I4[61];
*(vp++) = U00*I0[62] - U10*I3[62] + loo2p*I2[62]
        + (twoo2z)*I1[62] - (twoo4zn)*I4[62];
*(vp++) = U00*I0[63] - U10*I3[63] + loo2p*I2[63]
        + (oneo2z)*I1[63] - (oneo4zn)*I4[63] - (fiveo4zn)*I5[45];
*(vp++) = U00*I0[64] - U10*I3[64] + loo2p*I2[64]
        + (oneo2z)*I1[64] - (oneo4zn)*I4[64] - (fouro4zn)*I5[46];
*(vp++) = U00*I0[65] - U10*I3[65] + loo2p*I2[65]
        + (oneo2z)*I1[65] - (oneo4zn)*I4[65] - (fouro4zn)*I5[47];
*(vp++) = U00*I0[66] - U10*I3[66] + loo2p*I2[66]
        + (oneo2z)*I1[66] - (oneo4zn)*I4[66] - (threeo4zn)*I5[48];
*(vp++) = U00*I0[67] - U10*I3[67] + loo2p*I2[67]
        + (oneo2z)*I1[67] - (oneo4zn)*I4[67] - (threeo4zn)*I5[49];
*(vp++) = U00*I0[68] - U10*I3[68] + loo2p*I2[68]
        + (oneo2z)*I1[68] - (oneo4zn)*I4[68] - (threeo4zn)*I5[50];
*(vp++) = U00*I0[69] - U10*I3[69] + loo2p*I2[69]
        + (oneo2z)*I1[69] - (oneo4zn)*I4[69] - (twoo4zn)*I5[51];
*(vp++) = U00*I0[70] - U10*I3[70] + loo2p*I2[70]
        + (oneo2z)*I1[70] - (oneo4zn)*I4[70] - (twoo4zn)*I5[52];
*(vp++) = U00*I0[71] - U10*I3[71] + loo2p*I2[71]
        + (oneo2z)*I1[71] - (oneo4zn)*I4[71] - (twoo4zn)*I5[53];
*(vp++) = U00*I0[72] - U10*I3[72] + loo2p*I2[72]
        + (oneo2z)*I1[72] - (oneo4zn)*I4[72] - (twoo4zn)*I5[54];
*(vp++) = U00*I0[73] - U10*I3[73] + loo2p*I2[73]
        + (oneo2z)*I1[73] - (oneo4zn)*I4[73] - (oneo4zn)*I5[55];
*(vp++) = U00*I0[74] - U10*I3[74] + loo2p*I2[74]
        + (oneo2z)*I1[74] - (oneo4zn)*I4[74] - (oneo4zn)*I5[56];
*(vp++) = U00*I0[75] - U10*I3[75] + loo2p*I2[75]
        + (oneo2z)*I1[75] - (oneo4zn)*I4[75] - (oneo4zn)*I5[57];
*(vp++) = U00*I0[76] - U10*I3[76] + loo2p*I2[76]
        + (oneo2z)*I1[76] - (oneo4zn)*I4[76] - (oneo4zn)*I5[58];
*(vp++) = U00*I0[77] - U10*I3[77] + loo2p*I2[77]
        + (oneo2z)*I1[77] - (oneo4zn)*I4[77] - (oneo4zn)*I5[59];
*(vp++) = U00*I0[78] - U10*I3[78] + loo2p*I2[78]
        + (oneo2z)*I1[78] - (oneo4zn)*I4[78];
*(vp++) = U00*I0[79] - U10*I3[79] + loo2p*I2[79]
        + (oneo2z)*I1[79] - (oneo4zn)*I4[79];
*(vp++) = U00*I0[80] - U10*I3[80] + loo2p*I2[80]
        + (oneo2z)*I1[80] - (oneo4zn)*I4[80];
*(vp++) = U00*I0[81] - U10*I3[81] + loo2p*I2[81]
        + (oneo2z)*I1[81] - (oneo4zn)*I4[81];
*(vp++) = U00*I0[82] - U10*I3[82] + loo2p*I2[82]
        + (oneo2z)*I1[82] - (oneo4zn)*I4[82];
*(vp++) = U00*I0[83] - U10*I3[83] + loo2p*I2[83]
        + (oneo2z)*I1[83] - (oneo4zn)*I4[83];
*(vp++) = U00*I0[84] - U10*I3[84] + loo2p*I2[84]
        + (oneo2z)*I1[84] - (oneo4zn)*I4[84] - (fiveo4zn)*I5[60];
*(vp++) = U00*I0[85] - U10*I3[85] + loo2p*I2[85]
        + (oneo2z)*I1[85] - (oneo4zn)*I4[85] - (fouro4zn)*I5[61];
*(vp++) = U00*I0[86] - U10*I3[86] + loo2p*I2[86]
        + (oneo2z)*I1[86] - (oneo4zn)*I4[86] - (fouro4zn)*I5[62];
*(vp++) = U00*I0[87] - U10*I3[87] + loo2p*I2[87]
        + (oneo2z)*I1[87] - (oneo4zn)*I4[87] - (threeo4zn)*I5[63];
*(vp++) = U00*I0[88] - U10*I3[88] + loo2p*I2[88]
        + (oneo2z)*I1[88] - (oneo4zn)*I4[88] - (threeo4zn)*I5[64];
*(vp++) = U00*I0[89] - U10*I3[89] + loo2p*I2[89]
        + (oneo2z)*I1[89] - (oneo4zn)*I4[89] - (threeo4zn)*I5[65];
*(vp++) = U00*I0[90] - U10*I3[90] + loo2p*I2[90]
        + (oneo2z)*I1[90] - (oneo4zn)*I4[90] - (twoo4zn)*I5[66];
*(vp++) = U00*I0[91] - U10*I3[91] + loo2p*I2[91]
        + (oneo2z)*I1[91] - (oneo4zn)*I4[91] - (twoo4zn)*I5[67];
*(vp++) = U00*I0[92] - U10*I3[92] + loo2p*I2[92]
        + (oneo2z)*I1[92] - (oneo4zn)*I4[92] - (twoo4zn)*I5[68];
*(vp++) = U00*I0[93] - U10*I3[93] + loo2p*I2[93]
        + (oneo2z)*I1[93] - (oneo4zn)*I4[93] - (twoo4zn)*I5[69];
*(vp++) = U00*I0[94] - U10*I3[94] + loo2p*I2[94]
        + (oneo2z)*I1[94] - (oneo4zn)*I4[94] - (oneo4zn)*I5[70];
*(vp++) = U00*I0[95] - U10*I3[95] + loo2p*I2[95]
        + (oneo2z)*I1[95] - (oneo4zn)*I4[95] - (oneo4zn)*I5[71];
*(vp++) = U00*I0[96] - U10*I3[96] + loo2p*I2[96]
        + (oneo2z)*I1[96] - (oneo4zn)*I4[96] - (oneo4zn)*I5[72];
*(vp++) = U00*I0[97] - U10*I3[97] + loo2p*I2[97]
        + (oneo2z)*I1[97] - (oneo4zn)*I4[97] - (oneo4zn)*I5[73];
*(vp++) = U00*I0[98] - U10*I3[98] + loo2p*I2[98]
        + (oneo2z)*I1[98] - (oneo4zn)*I4[98] - (oneo4zn)*I5[74];
*(vp++) = U00*I0[99] - U10*I3[99] + loo2p*I2[99]
        + (oneo2z)*I1[99] - (oneo4zn)*I4[99];
*(vp++) = U00*I0[100] - U10*I3[100] + loo2p*I2[100]
        + (oneo2z)*I1[100] - (oneo4zn)*I4[100];
*(vp++) = U00*I0[101] - U10*I3[101] + loo2p*I2[101]
        + (oneo2z)*I1[101] - (oneo4zn)*I4[101];
*(vp++) = U00*I0[102] - U10*I3[102] + loo2p*I2[102]
        + (oneo2z)*I1[102] - (oneo4zn)*I4[102];
*(vp++) = U00*I0[103] - U10*I3[103] + loo2p*I2[103]
        + (oneo2z)*I1[103] - (oneo4zn)*I4[103];
*(vp++) = U00*I0[104] - U10*I3[104] + loo2p*I2[104]
        + (oneo2z)*I1[104] - (oneo4zn)*I4[104];
*(vp++) = U00*I0[105] - U10*I3[105] + loo2p*I2[105]
        + (oneo2z)*I1[105] - (oneo4zn)*I4[105] - (fiveo4zn)*I5[75];
*(vp++) = U00*I0[106] - U10*I3[106] + loo2p*I2[106]
        + (oneo2z)*I1[106] - (oneo4zn)*I4[106] - (fouro4zn)*I5[76];
*(vp++) = U00*I0[107] - U10*I3[107] + loo2p*I2[107]
        + (oneo2z)*I1[107] - (oneo4zn)*I4[107] - (fouro4zn)*I5[77];
*(vp++) = U00*I0[108] - U10*I3[108] + loo2p*I2[108]
        + (oneo2z)*I1[108] - (oneo4zn)*I4[108] - (threeo4zn)*I5[78];
*(vp++) = U00*I0[109] - U10*I3[109] + loo2p*I2[109]
        + (oneo2z)*I1[109] - (oneo4zn)*I4[109] - (threeo4zn)*I5[79];
*(vp++) = U00*I0[110] - U10*I3[110] + loo2p*I2[110]
        + (oneo2z)*I1[110] - (oneo4zn)*I4[110] - (threeo4zn)*I5[80];
*(vp++) = U00*I0[111] - U10*I3[111] + loo2p*I2[111]
        + (oneo2z)*I1[111] - (oneo4zn)*I4[111] - (twoo4zn)*I5[81];
*(vp++) = U00*I0[112] - U10*I3[112] + loo2p*I2[112]
        + (oneo2z)*I1[112] - (oneo4zn)*I4[112] - (twoo4zn)*I5[82];
*(vp++) = U00*I0[113] - U10*I3[113] + loo2p*I2[113]
        + (oneo2z)*I1[113] - (oneo4zn)*I4[113] - (twoo4zn)*I5[83];
*(vp++) = U00*I0[114] - U10*I3[114] + loo2p*I2[114]
        + (oneo2z)*I1[114] - (oneo4zn)*I4[114] - (twoo4zn)*I5[84];
*(vp++) = U00*I0[115] - U10*I3[115] + loo2p*I2[115]
        + (oneo2z)*I1[115] - (oneo4zn)*I4[115] - (oneo4zn)*I5[85];
*(vp++) = U00*I0[116] - U10*I3[116] + loo2p*I2[116]
        + (oneo2z)*I1[116] - (oneo4zn)*I4[116] - (oneo4zn)*I5[86];
*(vp++) = U00*I0[117] - U10*I3[117] + loo2p*I2[117]
        + (oneo2z)*I1[117] - (oneo4zn)*I4[117] - (oneo4zn)*I5[87];
*(vp++) = U00*I0[118] - U10*I3[118] + loo2p*I2[118]
        + (oneo2z)*I1[118] - (oneo4zn)*I4[118] - (oneo4zn)*I5[88];
*(vp++) = U00*I0[119] - U10*I3[119] + loo2p*I2[119]
        + (oneo2z)*I1[119] - (oneo4zn)*I4[119] - (oneo4zn)*I5[89];
*(vp++) = U00*I0[120] - U10*I3[120] + loo2p*I2[120]
        + (oneo2z)*I1[120] - (oneo4zn)*I4[120];
*(vp++) = U00*I0[121] - U10*I3[121] + loo2p*I2[121]
        + (oneo2z)*I1[121] - (oneo4zn)*I4[121];
*(vp++) = U00*I0[122] - U10*I3[122] + loo2p*I2[122]
        + (oneo2z)*I1[122] - (oneo4zn)*I4[122];
*(vp++) = U00*I0[123] - U10*I3[123] + loo2p*I2[123]
        + (oneo2z)*I1[123] - (oneo4zn)*I4[123];
*(vp++) = U00*I0[124] - U10*I3[124] + loo2p*I2[124]
        + (oneo2z)*I1[124] - (oneo4zn)*I4[124];
*(vp++) = U00*I0[125] - U10*I3[125] + loo2p*I2[125]
        + (oneo2z)*I1[125] - (oneo4zn)*I4[125];
*(vp++) = U00*I0[126] - U10*I3[126] + loo2p*I2[126] - (fiveo4zn)*I5[90];
*(vp++) = U00*I0[127] - U10*I3[127] + loo2p*I2[127] - (fouro4zn)*I5[91];
*(vp++) = U00*I0[128] - U10*I3[128] + loo2p*I2[128] - (fouro4zn)*I5[92];
*(vp++) = U00*I0[129] - U10*I3[129] + loo2p*I2[129] - (threeo4zn)*I5[93];
*(vp++) = U00*I0[130] - U10*I3[130] + loo2p*I2[130] - (threeo4zn)*I5[94];
*(vp++) = U00*I0[131] - U10*I3[131] + loo2p*I2[131] - (threeo4zn)*I5[95];
*(vp++) = U00*I0[132] - U10*I3[132] + loo2p*I2[132] - (twoo4zn)*I5[96];
*(vp++) = U00*I0[133] - U10*I3[133] + loo2p*I2[133] - (twoo4zn)*I5[97];
*(vp++) = U00*I0[134] - U10*I3[134] + loo2p*I2[134] - (twoo4zn)*I5[98];
*(vp++) = U00*I0[135] - U10*I3[135] + loo2p*I2[135] - (twoo4zn)*I5[99];
*(vp++) = U00*I0[136] - U10*I3[136] + loo2p*I2[136] - (oneo4zn)*I5[100];
*(vp++) = U00*I0[137] - U10*I3[137] + loo2p*I2[137] - (oneo4zn)*I5[101];
*(vp++) = U00*I0[138] - U10*I3[138] + loo2p*I2[138] - (oneo4zn)*I5[102];
*(vp++) = U00*I0[139] - U10*I3[139] + loo2p*I2[139] - (oneo4zn)*I5[103];
*(vp++) = U00*I0[140] - U10*I3[140] + loo2p*I2[140] - (oneo4zn)*I5[104];
*(vp++) = U00*I0[141] - U10*I3[141] + loo2p*I2[141];
*(vp++) = U00*I0[142] - U10*I3[142] + loo2p*I2[142];
*(vp++) = U00*I0[143] - U10*I3[143] + loo2p*I2[143];
*(vp++) = U00*I0[144] - U10*I3[144] + loo2p*I2[144];
*(vp++) = U00*I0[145] - U10*I3[145] + loo2p*I2[145];
*(vp++) = U00*I0[146] - U10*I3[146] + loo2p*I2[146];
*(vp++) = U00*I0[147] - U10*I3[147] + loo2p*I2[147] - (fiveo4zn)*I5[105];
*(vp++) = U00*I0[148] - U10*I3[148] + loo2p*I2[148] - (fouro4zn)*I5[106];
*(vp++) = U00*I0[149] - U10*I3[149] + loo2p*I2[149] - (fouro4zn)*I5[107];
*(vp++) = U00*I0[150] - U10*I3[150] + loo2p*I2[150] - (threeo4zn)*I5[108];
*(vp++) = U00*I0[151] - U10*I3[151] + loo2p*I2[151] - (threeo4zn)*I5[109];
*(vp++) = U00*I0[152] - U10*I3[152] + loo2p*I2[152] - (threeo4zn)*I5[110];
*(vp++) = U00*I0[153] - U10*I3[153] + loo2p*I2[153] - (twoo4zn)*I5[111];
*(vp++) = U00*I0[154] - U10*I3[154] + loo2p*I2[154] - (twoo4zn)*I5[112];
*(vp++) = U00*I0[155] - U10*I3[155] + loo2p*I2[155] - (twoo4zn)*I5[113];
*(vp++) = U00*I0[156] - U10*I3[156] + loo2p*I2[156] - (twoo4zn)*I5[114];
*(vp++) = U00*I0[157] - U10*I3[157] + loo2p*I2[157] - (oneo4zn)*I5[115];
return vp;
}

REALTYPE *_r_build_g0h0_1(prim_data *Data, REALTYPE *vp, const REALTYPE *I0, const REALTYPE *I1, const REALTYPE *I2, const REALTYPE *I3, const REALTYPE *I4, const REALTYPE *I5)
{
  REALTYPE U00, U01, U02, U10, U11, U12, U20, U21, U22;
  REALTYPE U30, U31, U32, U40, U41, U42, U50, U51, U52;
  REALTYPE loo2p = Data->oo2p;
  REALTYPE oneo4zn;
  REALTYPE twoo4zn;
  REALTYPE threeo4zn;
  REALTYPE fouro4zn;
  REALTYPE fiveo4zn;
  REALTYPE oneo2z;
  REALTYPE twoo2z;
  REALTYPE threeo2z;
  oneo4zn = 1.0*Data->oo2z*Data->oo2n;
  twoo4zn = 2.0*Data->oo2z*Data->oo2n;
  threeo4zn = 3.0*Data->oo2z*Data->oo2n;
  fouro4zn = 4.0*Data->oo2z*Data->oo2n;
  fiveo4zn = 5.0*Data->oo2z*Data->oo2n;
  oneo2z = 1.0*Data->oo2z;
  twoo2z = 2.0*Data->oo2z;
  threeo2z = 3.0*Data->oo2z;
  U00 = Data->U[0][0];
  U01 = Data->U[0][1];
  U02 = Data->U[0][2];
  U10 = Data->U[0][0]*Data->oo2n + Data->U[1][0]*Data->oo2z;
  U11 = Data->U[0][1]*Data->oo2n + Data->U[1][1]*Data->oo2z;
  U12 = Data->U[0][2]*Data->oo2n + Data->U[1][2]*Data->oo2z;

*(vp++) = U00*I0[158] - U10*I3[158] + loo2p*I2[158] - (oneo4zn)*I5[116];
*(vp++) = U00*I0[159] - U10*I3[159] + loo2p*I2[159] - (oneo4zn)*I5[117];
*(vp++) = U00*I0[160] - U10*I3[160] + loo2p*I2[160] - (oneo4zn)*I5[118];
*(vp++) = U00*I0[161] - U10*I3[161] + loo2p*I2[161] - (oneo4zn)*I5[119];
*(vp++) = U00*I0[162] - U10*I3[162] + loo2p*I2[162];
*(vp++) = U00*I0[163] - U10*I3[163] + loo2p*I2[163];
*(vp++) = U00*I0[164] - U10*I3[164] + loo2p*I2[164];
*(vp++) = U00*I0[165] - U10*I3[165] + loo2p*I2[165];
*(vp++) = U00*I0[166] - U10*I3[166] + loo2p*I2[166];
*(vp++) = U00*I0[167] - U10*I3[167] + loo2p*I2[167];
*(vp++) = U00*I0[168] - U10*I3[168] + loo2p*I2[168] - (fiveo4zn)*I5[120];
*(vp++) = U00*I0[169] - U10*I3[169] + loo2p*I2[169] - (fouro4zn)*I5[121];
*(vp++) = U00*I0[170] - U10*I3[170] + loo2p*I2[170] - (fouro4zn)*I5[122];
*(vp++) = U00*I0[171] - U10*I3[171] + loo2p*I2[171] - (threeo4zn)*I5[123];
*(vp++) = U00*I0[172] - U10*I3[172] + loo2p*I2[172] - (threeo4zn)*I5[124];
*(vp++) = U00*I0[173] - U10*I3[173] + loo2p*I2[173] - (threeo4zn)*I5[125];
*(vp++) = U00*I0[174] - U10*I3[174] + loo2p*I2[174] - (twoo4zn)*I5[126];
*(vp++) = U00*I0[175] - U10*I3[175] + loo2p*I2[175] - (twoo4zn)*I5[127];
*(vp++) = U00*I0[176] - U10*I3[176] + loo2p*I2[176] - (twoo4zn)*I5[128];
*(vp++) = U00*I0[177] - U10*I3[177] + loo2p*I2[177] - (twoo4zn)*I5[129];
*(vp++) = U00*I0[178] - U10*I3[178] + loo2p*I2[178] - (oneo4zn)*I5[130];
*(vp++) = U00*I0[179] - U10*I3[179] + loo2p*I2[179] - (oneo4zn)*I5[131];
*(vp++) = U00*I0[180] - U10*I3[180] + loo2p*I2[180] - (oneo4zn)*I5[132];
*(vp++) = U00*I0[181] - U10*I3[181] + loo2p*I2[181] - (oneo4zn)*I5[133];
*(vp++) = U00*I0[182] - U10*I3[182] + loo2p*I2[182] - (oneo4zn)*I5[134];
*(vp++) = U00*I0[183] - U10*I3[183] + loo2p*I2[183];
*(vp++) = U00*I0[184] - U10*I3[184] + loo2p*I2[184];
*(vp++) = U00*I0[185] - U10*I3[185] + loo2p*I2[185];
*(vp++) = U00*I0[186] - U10*I3[186] + loo2p*I2[186];
*(vp++) = U00*I0[187] - U10*I3[187] + loo2p*I2[187];
*(vp++) = U00*I0[188] - U10*I3[188] + loo2p*I2[188];
*(vp++) = U00*I0[189] - U10*I3[189] + loo2p*I2[189] - (fiveo4zn)*I5[135];
*(vp++) = U00*I0[190] - U10*I3[190] + loo2p*I2[190] - (fouro4zn)*I5[136];
*(vp++) = U00*I0[191] - U10*I3[191] + loo2p*I2[191] - (fouro4zn)*I5[137];
*(vp++) = U00*I0[192] - U10*I3[192] + loo2p*I2[192] - (threeo4zn)*I5[138];
*(vp++) = U00*I0[193] - U10*I3[193] + loo2p*I2[193] - (threeo4zn)*I5[139];
*(vp++) = U00*I0[194] - U10*I3[194] + loo2p*I2[194] - (threeo4zn)*I5[140];
*(vp++) = U00*I0[195] - U10*I3[195] + loo2p*I2[195] - (twoo4zn)*I5[141];
*(vp++) = U00*I0[196] - U10*I3[196] + loo2p*I2[196] - (twoo4zn)*I5[142];
*(vp++) = U00*I0[197] - U10*I3[197] + loo2p*I2[197] - (twoo4zn)*I5[143];
*(vp++) = U00*I0[198] - U10*I3[198] + loo2p*I2[198] - (twoo4zn)*I5[144];
*(vp++) = U00*I0[199] - U10*I3[199] + loo2p*I2[199] - (oneo4zn)*I5[145];
*(vp++) = U00*I0[200] - U10*I3[200] + loo2p*I2[200] - (oneo4zn)*I5[146];
*(vp++) = U00*I0[201] - U10*I3[201] + loo2p*I2[201] - (oneo4zn)*I5[147];
*(vp++) = U00*I0[202] - U10*I3[202] + loo2p*I2[202] - (oneo4zn)*I5[148];
*(vp++) = U00*I0[203] - U10*I3[203] + loo2p*I2[203] - (oneo4zn)*I5[149];
*(vp++) = U00*I0[204] - U10*I3[204] + loo2p*I2[204];
*(vp++) = U00*I0[205] - U10*I3[205] + loo2p*I2[205];
*(vp++) = U00*I0[206] - U10*I3[206] + loo2p*I2[206];
*(vp++) = U00*I0[207] - U10*I3[207] + loo2p*I2[207];
*(vp++) = U00*I0[208] - U10*I3[208] + loo2p*I2[208];
*(vp++) = U00*I0[209] - U10*I3[209] + loo2p*I2[209];
*(vp++) = U01*I0[126] - U11*I3[126] + loo2p*I2[210]
        + (threeo2z)*I1[63] - (threeo4zn)*I4[63];
*(vp++) = U01*I0[127] - U11*I3[127] + loo2p*I2[211]
        + (threeo2z)*I1[64] - (threeo4zn)*I4[64] - (oneo4zn)*I5[90];
*(vp++) = U01*I0[128] - U11*I3[128] + loo2p*I2[212]
        + (threeo2z)*I1[65] - (threeo4zn)*I4[65];
*(vp++) = U01*I0[129] - U11*I3[129] + loo2p*I2[213]
        + (threeo2z)*I1[66] - (threeo4zn)*I4[66] - (twoo4zn)*I5[91];
*(vp++) = U01*I0[130] - U11*I3[130] + loo2p*I2[214]
        + (threeo2z)*I1[67] - (threeo4zn)*I4[67] - (oneo4zn)*I5[92];
*(vp++) = U01*I0[131] - U11*I3[131] + loo2p*I2[215]
        + (threeo2z)*I1[68] - (threeo4zn)*I4[68];
*(vp++) = U01*I0[132] - U11*I3[132] + loo2p*I2[216]
        + (threeo2z)*I1[69] - (threeo4zn)*I4[69] - (threeo4zn)*I5[93];
*(vp++) = U01*I0[133] - U11*I3[133] + loo2p*I2[217]
        + (threeo2z)*I1[70] - (threeo4zn)*I4[70] - (twoo4zn)*I5[94];
*(vp++) = U01*I0[134] - U11*I3[134] + loo2p*I2[218]
        + (threeo2z)*I1[71] - (threeo4zn)*I4[71] - (oneo4zn)*I5[95];
*(vp++) = U01*I0[135] - U11*I3[135] + loo2p*I2[219]
        + (threeo2z)*I1[72] - (threeo4zn)*I4[72];
*(vp++) = U01*I0[136] - U11*I3[136] + loo2p*I2[220]
        + (threeo2z)*I1[73] - (threeo4zn)*I4[73] - (fouro4zn)*I5[96];
*(vp++) = U01*I0[137] - U11*I3[137] + loo2p*I2[221]
        + (threeo2z)*I1[74] - (threeo4zn)*I4[74] - (threeo4zn)*I5[97];
*(vp++) = U01*I0[138] - U11*I3[138] + loo2p*I2[222]
        + (threeo2z)*I1[75] - (threeo4zn)*I4[75] - (twoo4zn)*I5[98];
*(vp++) = U01*I0[139] - U11*I3[139] + loo2p*I2[223]
        + (threeo2z)*I1[76] - (threeo4zn)*I4[76] - (oneo4zn)*I5[99];
*(vp++) = U01*I0[140] - U11*I3[140] + loo2p*I2[224]
        + (threeo2z)*I1[77] - (threeo4zn)*I4[77];
*(vp++) = U01*I0[141] - U11*I3[141] + loo2p*I2[225]
        + (threeo2z)*I1[78] - (threeo4zn)*I4[78] - (fiveo4zn)*I5[100];
*(vp++) = U01*I0[142] - U11*I3[142] + loo2p*I2[226]
        + (threeo2z)*I1[79] - (threeo4zn)*I4[79] - (fouro4zn)*I5[101];
*(vp++) = U01*I0[143] - U11*I3[143] + loo2p*I2[227]
        + (threeo2z)*I1[80] - (threeo4zn)*I4[80] - (threeo4zn)*I5[102];
*(vp++) = U01*I0[144] - U11*I3[144] + loo2p*I2[228]
        + (threeo2z)*I1[81] - (threeo4zn)*I4[81] - (twoo4zn)*I5[103];
*(vp++) = U01*I0[145] - U11*I3[145] + loo2p*I2[229]
        + (threeo2z)*I1[82] - (threeo4zn)*I4[82] - (oneo4zn)*I5[104];
*(vp++) = U01*I0[146] - U11*I3[146] + loo2p*I2[230]
        + (threeo2z)*I1[83] - (threeo4zn)*I4[83];
*(vp++) = U01*I0[147] - U11*I3[147] + loo2p*I2[231]
        + (twoo2z)*I1[84] - (twoo4zn)*I4[84];
*(vp++) = U01*I0[148] - U11*I3[148] + loo2p*I2[232]
        + (twoo2z)*I1[85] - (twoo4zn)*I4[85] - (oneo4zn)*I5[105];
*(vp++) = U01*I0[149] - U11*I3[149] + loo2p*I2[233]
        + (twoo2z)*I1[86] - (twoo4zn)*I4[86];
*(vp++) = U01*I0[150] - U11*I3[150] + loo2p*I2[234]
        + (twoo2z)*I1[87] - (twoo4zn)*I4[87] - (twoo4zn)*I5[106];
*(vp++) = U01*I0[151] - U11*I3[151] + loo2p*I2[235]
        + (twoo2z)*I1[88] - (twoo4zn)*I4[88] - (oneo4zn)*I5[107];
*(vp++) = U01*I0[152] - U11*I3[152] + loo2p*I2[236]
        + (twoo2z)*I1[89] - (twoo4zn)*I4[89];
*(vp++) = U01*I0[153] - U11*I3[153] + loo2p*I2[237]
        + (twoo2z)*I1[90] - (twoo4zn)*I4[90] - (threeo4zn)*I5[108];
*(vp++) = U01*I0[154] - U11*I3[154] + loo2p*I2[238]
        + (twoo2z)*I1[91] - (twoo4zn)*I4[91] - (twoo4zn)*I5[109];
*(vp++) = U01*I0[155] - U11*I3[155] + loo2p*I2[239]
        + (twoo2z)*I1[92] - (twoo4zn)*I4[92] - (oneo4zn)*I5[110];
*(vp++) = U01*I0[156] - U11*I3[156] + loo2p*I2[240]
        + (twoo2z)*I1[93] - (twoo4zn)*I4[93];
*(vp++) = U01*I0[157] - U11*I3[157] + loo2p*I2[241]
        + (twoo2z)*I1[94] - (twoo4zn)*I4[94] - (fouro4zn)*I5[111];
*(vp++) = U01*I0[158] - U11*I3[158] + loo2p*I2[242]
        + (twoo2z)*I1[95] - (twoo4zn)*I4[95] - (threeo4zn)*I5[112];
*(vp++) = U01*I0[159] - U11*I3[159] + loo2p*I2[243]
        + (twoo2z)*I1[96] - (twoo4zn)*I4[96] - (twoo4zn)*I5[113];
*(vp++) = U01*I0[160] - U11*I3[160] + loo2p*I2[244]
        + (twoo2z)*I1[97] - (twoo4zn)*I4[97] - (oneo4zn)*I5[114];
*(vp++) = U01*I0[161] - U11*I3[161] + loo2p*I2[245]
        + (twoo2z)*I1[98] - (twoo4zn)*I4[98];
*(vp++) = U01*I0[162] - U11*I3[162] + loo2p*I2[246]
        + (twoo2z)*I1[99] - (twoo4zn)*I4[99] - (fiveo4zn)*I5[115];
*(vp++) = U01*I0[163] - U11*I3[163] + loo2p*I2[247]
        + (twoo2z)*I1[100] - (twoo4zn)*I4[100] - (fouro4zn)*I5[116];
*(vp++) = U01*I0[164] - U11*I3[164] + loo2p*I2[248]
        + (twoo2z)*I1[101] - (twoo4zn)*I4[101] - (threeo4zn)*I5[117];
*(vp++) = U01*I0[165] - U11*I3[165] + loo2p*I2[249]
        + (twoo2z)*I1[102] - (twoo4zn)*I4[102] - (twoo4zn)*I5[118];
*(vp++) = U01*I0[166] - U11*I3[166] + loo2p*I2[250]
        + (twoo2z)*I1[103] - (twoo4zn)*I4[103] - (oneo4zn)*I5[119];
*(vp++) = U01*I0[167] - U11*I3[167] + loo2p*I2[251]
        + (twoo2z)*I1[104] - (twoo4zn)*I4[104];
*(vp++) = U01*I0[168] - U11*I3[168] + loo2p*I2[252]
        + (oneo2z)*I1[105] - (oneo4zn)*I4[105];
*(vp++) = U01*I0[169] - U11*I3[169] + loo2p*I2[253]
        + (oneo2z)*I1[106] - (oneo4zn)*I4[106] - (oneo4zn)*I5[120];
*(vp++) = U01*I0[170] - U11*I3[170] + loo2p*I2[254]
        + (oneo2z)*I1[107] - (oneo4zn)*I4[107];
*(vp++) = U01*I0[171] - U11*I3[171] + loo2p*I2[255]
        + (oneo2z)*I1[108] - (oneo4zn)*I4[108] - (twoo4zn)*I5[121];
*(vp++) = U01*I0[172] - U11*I3[172] + loo2p*I2[256]
        + (oneo2z)*I1[109] - (oneo4zn)*I4[109] - (oneo4zn)*I5[122];
*(vp++) = U01*I0[173] - U11*I3[173] + loo2p*I2[257]
        + (oneo2z)*I1[110] - (oneo4zn)*I4[110];
*(vp++) = U01*I0[174] - U11*I3[174] + loo2p*I2[258]
        + (oneo2z)*I1[111] - (oneo4zn)*I4[111] - (threeo4zn)*I5[123];
*(vp++) = U01*I0[175] - U11*I3[175] + loo2p*I2[259]
        + (oneo2z)*I1[112] - (oneo4zn)*I4[112] - (twoo4zn)*I5[124];
*(vp++) = U01*I0[176] - U11*I3[176] + loo2p*I2[260]
        + (oneo2z)*I1[113] - (oneo4zn)*I4[113] - (oneo4zn)*I5[125];
*(vp++) = U01*I0[177] - U11*I3[177] + loo2p*I2[261]
        + (oneo2z)*I1[114] - (oneo4zn)*I4[114];
*(vp++) = U01*I0[178] - U11*I3[178] + loo2p*I2[262]
        + (oneo2z)*I1[115] - (oneo4zn)*I4[115] - (fouro4zn)*I5[126];
*(vp++) = U01*I0[179] - U11*I3[179] + loo2p*I2[263]
        + (oneo2z)*I1[116] - (oneo4zn)*I4[116] - (threeo4zn)*I5[127];
*(vp++) = U01*I0[180] - U11*I3[180] + loo2p*I2[264]
        + (oneo2z)*I1[117] - (oneo4zn)*I4[117] - (twoo4zn)*I5[128];
*(vp++) = U01*I0[181] - U11*I3[181] + loo2p*I2[265]
        + (oneo2z)*I1[118] - (oneo4zn)*I4[118] - (oneo4zn)*I5[129];
*(vp++) = U01*I0[182] - U11*I3[182] + loo2p*I2[266]
        + (oneo2z)*I1[119] - (oneo4zn)*I4[119];
*(vp++) = U01*I0[183] - U11*I3[183] + loo2p*I2[267]
        + (oneo2z)*I1[120] - (oneo4zn)*I4[120] - (fiveo4zn)*I5[130];
*(vp++) = U01*I0[184] - U11*I3[184] + loo2p*I2[268]
        + (oneo2z)*I1[121] - (oneo4zn)*I4[121] - (fouro4zn)*I5[131];
*(vp++) = U01*I0[185] - U11*I3[185] + loo2p*I2[269]
        + (oneo2z)*I1[122] - (oneo4zn)*I4[122] - (threeo4zn)*I5[132];
*(vp++) = U01*I0[186] - U11*I3[186] + loo2p*I2[270]
        + (oneo2z)*I1[123] - (oneo4zn)*I4[123] - (twoo4zn)*I5[133];
*(vp++) = U01*I0[187] - U11*I3[187] + loo2p*I2[271]
        + (oneo2z)*I1[124] - (oneo4zn)*I4[124] - (oneo4zn)*I5[134];
*(vp++) = U01*I0[188] - U11*I3[188] + loo2p*I2[272]
        + (oneo2z)*I1[125] - (oneo4zn)*I4[125];
*(vp++) = U01*I0[189] - U11*I3[189] + loo2p*I2[273];
*(vp++) = U01*I0[190] - U11*I3[190] + loo2p*I2[274] - (oneo4zn)*I5[135];
*(vp++) = U01*I0[191] - U11*I3[191] + loo2p*I2[275];
*(vp++) = U01*I0[192] - U11*I3[192] + loo2p*I2[276] - (twoo4zn)*I5[136];
*(vp++) = U01*I0[193] - U11*I3[193] + loo2p*I2[277] - (oneo4zn)*I5[137];
*(vp++) = U01*I0[194] - U11*I3[194] + loo2p*I2[278];
*(vp++) = U01*I0[195] - U11*I3[195] + loo2p*I2[279] - (threeo4zn)*I5[138];
*(vp++) = U01*I0[196] - U11*I3[196] + loo2p*I2[280] - (twoo4zn)*I5[139];
*(vp++) = U01*I0[197] - U11*I3[197] + loo2p*I2[281] - (oneo4zn)*I5[140];
*(vp++) = U01*I0[198] - U11*I3[198] + loo2p*I2[282];
*(vp++) = U01*I0[199] - U11*I3[199] + loo2p*I2[283] - (fouro4zn)*I5[141];
*(vp++) = U01*I0[200] - U11*I3[200] + loo2p*I2[284] - (threeo4zn)*I5[142];
*(vp++) = U01*I0[201] - U11*I3[201] + loo2p*I2[285] - (twoo4zn)*I5[143];
*(vp++) = U01*I0[202] - U11*I3[202] + loo2p*I2[286] - (oneo4zn)*I5[144];
*(vp++) = U01*I0[203] - U11*I3[203] + loo2p*I2[287];
*(vp++) = U01*I0[204] - U11*I3[204] + loo2p*I2[288] - (fiveo4zn)*I5[145];
*(vp++) = U01*I0[205] - U11*I3[205] + loo2p*I2[289] - (fouro4zn)*I5[146];
*(vp++) = U01*I0[206] - U11*I3[206] + loo2p*I2[290] - (threeo4zn)*I5[147];
*(vp++) = U01*I0[207] - U11*I3[207] + loo2p*I2[291] - (twoo4zn)*I5[148];
*(vp++) = U01*I0[208] - U11*I3[208] + loo2p*I2[292] - (oneo4zn)*I5[149];
*(vp++) = U01*I0[209] - U11*I3[209] + loo2p*I2[293];
*(vp++) = U02*I0[189] - U12*I3[189] + loo2p*I2[294]
        + (threeo2z)*I1[105] - (threeo4zn)*I4[105];
*(vp++) = U02*I0[190] - U12*I3[190] + loo2p*I2[295]
        + (threeo2z)*I1[106] - (threeo4zn)*I4[106];
*(vp++) = U02*I0[191] - U12*I3[191] + loo2p*I2[296]
        + (threeo2z)*I1[107] - (threeo4zn)*I4[107] - (oneo4zn)*I5[135];
*(vp++) = U02*I0[192] - U12*I3[192] + loo2p*I2[297]
        + (threeo2z)*I1[108] - (threeo4zn)*I4[108];
*(vp++) = U02*I0[193] - U12*I3[193] + loo2p*I2[298]
        + (threeo2z)*I1[109] - (threeo4zn)*I4[109] - (oneo4zn)*I5[136];
*(vp++) = U02*I0[194] - U12*I3[194] + loo2p*I2[299]
        + (threeo2z)*I1[110] - (threeo4zn)*I4[110] - (twoo4zn)*I5[137];
*(vp++) = U02*I0[195] - U12*I3[195] + loo2p*I2[300]
        + (threeo2z)*I1[111] - (threeo4zn)*I4[111];
*(vp++) = U02*I0[196] - U12*I3[196] + loo2p*I2[301]
        + (threeo2z)*I1[112] - (threeo4zn)*I4[112] - (oneo4zn)*I5[138];
*(vp++) = U02*I0[197] - U12*I3[197] + loo2p*I2[302]
        + (threeo2z)*I1[113] - (threeo4zn)*I4[113] - (twoo4zn)*I5[139];
*(vp++) = U02*I0[198] - U12*I3[198] + loo2p*I2[303]
        + (threeo2z)*I1[114] - (threeo4zn)*I4[114] - (threeo4zn)*I5[140];
*(vp++) = U02*I0[199] - U12*I3[199] + loo2p*I2[304]
        + (threeo2z)*I1[115] - (threeo4zn)*I4[115];
*(vp++) = U02*I0[200] - U12*I3[200] + loo2p*I2[305]
        + (threeo2z)*I1[116] - (threeo4zn)*I4[116] - (oneo4zn)*I5[141];
*(vp++) = U02*I0[201] - U12*I3[201] + loo2p*I2[306]
        + (threeo2z)*I1[117] - (threeo4zn)*I4[117] - (twoo4zn)*I5[142];
*(vp++) = U02*I0[202] - U12*I3[202] + loo2p*I2[307]
        + (threeo2z)*I1[118] - (threeo4zn)*I4[118] - (threeo4zn)*I5[143];
*(vp++) = U02*I0[203] - U12*I3[203] + loo2p*I2[308]
        + (threeo2z)*I1[119] - (threeo4zn)*I4[119] - (fouro4zn)*I5[144];
*(vp++) = U02*I0[204] - U12*I3[204] + loo2p*I2[309]
        + (threeo2z)*I1[120] - (threeo4zn)*I4[120];
*(vp++) = U02*I0[205] - U12*I3[205] + loo2p*I2[310]
        + (threeo2z)*I1[121] - (threeo4zn)*I4[121] - (oneo4zn)*I5[145];
*(vp++) = U02*I0[206] - U12*I3[206] + loo2p*I2[311]
        + (threeo2z)*I1[122] - (threeo4zn)*I4[122] - (twoo4zn)*I5[146];
*(vp++) = U02*I0[207] - U12*I3[207] + loo2p*I2[312]
        + (threeo2z)*I1[123] - (threeo4zn)*I4[123] - (threeo4zn)*I5[147];
*(vp++) = U02*I0[208] - U12*I3[208] + loo2p*I2[313]
        + (threeo2z)*I1[124] - (threeo4zn)*I4[124] - (fouro4zn)*I5[148];
*(vp++) = U02*I0[209] - U12*I3[209] + loo2p*I2[314]
        + (threeo2z)*I1[125] - (threeo4zn)*I4[125] - (fiveo4zn)*I5[149];
return vp;
}
