/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include <libint/libint.h>
#include "libderiv.h"
#include <libint/hrr_header.h>

#include "d1hrr_header.h"

extern void d12vrr_order_d0gg(Libderiv_t *, prim_data *);

  /* Computes derivatives of (d0|gg) integrals */

void d12hrr_order_d0gg(Libderiv_t *Libderiv, int num_prim_comb)
{
 prim_data *Data = Libderiv->PrimQuartet;
 double *int_stack = Libderiv->int_stack;
 double *zero_stack = Libderiv->zero_stack;
 int i,j;
 double tmp, *target;

 Libderiv->deriv_classes[2][8][11] = int_stack + 0;
 Libderiv->deriv_classes[2][8][10] = int_stack + 270;
 Libderiv->deriv_classes[2][8][9] = int_stack + 540;
 Libderiv->deriv_classes[2][8][8] = int_stack + 810;
 Libderiv->deriv_classes[2][8][7] = int_stack + 1080;
 Libderiv->dvrr_classes[2][7] = int_stack + 1350;
 Libderiv->deriv_classes[2][8][6] = int_stack + 1566;
 Libderiv->deriv_classes[2][8][2] = int_stack + 1836;
 Libderiv->deriv_classes[2][8][1] = int_stack + 2106;
 Libderiv->deriv_classes[2][8][0] = int_stack + 2376;
 Libderiv->deriv2_classes[2][4][143] = int_stack + 2646;
 Libderiv->deriv2_classes[2][5][143] = int_stack + 2736;
 Libderiv->deriv2_classes[2][6][143] = int_stack + 2862;
 Libderiv->deriv2_classes[2][7][143] = int_stack + 3030;
 Libderiv->deriv2_classes[2][8][143] = int_stack + 3246;
 Libderiv->deriv2_classes[2][4][131] = int_stack + 3516;
 Libderiv->deriv2_classes[2][5][131] = int_stack + 3606;
 Libderiv->deriv2_classes[2][6][131] = int_stack + 3732;
 Libderiv->deriv2_classes[2][7][131] = int_stack + 3900;
 Libderiv->deriv2_classes[2][8][131] = int_stack + 4116;
 Libderiv->deriv2_classes[2][4][130] = int_stack + 4386;
 Libderiv->deriv2_classes[2][5][130] = int_stack + 4476;
 Libderiv->deriv2_classes[2][6][130] = int_stack + 4602;
 Libderiv->deriv2_classes[2][7][130] = int_stack + 4770;
 Libderiv->deriv2_classes[2][8][130] = int_stack + 4986;
 Libderiv->deriv2_classes[2][4][119] = int_stack + 5256;
 Libderiv->deriv2_classes[2][5][119] = int_stack + 5346;
 Libderiv->deriv2_classes[2][6][119] = int_stack + 5472;
 Libderiv->deriv2_classes[2][7][119] = int_stack + 5640;
 Libderiv->deriv2_classes[2][8][119] = int_stack + 5856;
 Libderiv->deriv2_classes[2][4][118] = int_stack + 6126;
 Libderiv->deriv2_classes[2][5][118] = int_stack + 6216;
 Libderiv->deriv2_classes[2][6][118] = int_stack + 6342;
 Libderiv->deriv2_classes[2][7][118] = int_stack + 6510;
 Libderiv->deriv2_classes[2][8][118] = int_stack + 6726;
 Libderiv->deriv2_classes[2][4][117] = int_stack + 6996;
 Libderiv->deriv2_classes[2][5][117] = int_stack + 7086;
 Libderiv->deriv2_classes[2][6][117] = int_stack + 7212;
 Libderiv->deriv2_classes[2][7][117] = int_stack + 7380;
 Libderiv->deriv2_classes[2][8][117] = int_stack + 7596;
 Libderiv->deriv2_classes[2][4][107] = int_stack + 7866;
 Libderiv->deriv2_classes[2][5][107] = int_stack + 7956;
 Libderiv->deriv2_classes[2][6][107] = int_stack + 8082;
 Libderiv->deriv2_classes[2][7][107] = int_stack + 8250;
 Libderiv->deriv2_classes[2][8][107] = int_stack + 8466;
 Libderiv->deriv2_classes[2][4][106] = int_stack + 8736;
 Libderiv->deriv2_classes[2][5][106] = int_stack + 8826;
 Libderiv->deriv2_classes[2][6][106] = int_stack + 8952;
 Libderiv->deriv2_classes[2][7][106] = int_stack + 9120;
 Libderiv->deriv2_classes[2][8][106] = int_stack + 9336;
 Libderiv->deriv2_classes[2][4][105] = int_stack + 9606;
 Libderiv->deriv2_classes[2][5][105] = int_stack + 9696;
 Libderiv->deriv2_classes[2][6][105] = int_stack + 9822;
 Libderiv->deriv2_classes[2][7][105] = int_stack + 9990;
 Libderiv->deriv2_classes[2][8][105] = int_stack + 10206;
 Libderiv->deriv2_classes[2][4][104] = int_stack + 10476;
 Libderiv->deriv2_classes[2][5][104] = int_stack + 10566;
 Libderiv->deriv2_classes[2][6][104] = int_stack + 10692;
 Libderiv->deriv2_classes[2][7][104] = int_stack + 10860;
 Libderiv->deriv2_classes[2][8][104] = int_stack + 11076;
 Libderiv->deriv2_classes[2][4][95] = int_stack + 11346;
 Libderiv->deriv2_classes[2][5][95] = int_stack + 11436;
 Libderiv->deriv2_classes[2][6][95] = int_stack + 11562;
 Libderiv->deriv2_classes[2][7][95] = int_stack + 11730;
 Libderiv->deriv2_classes[2][8][95] = int_stack + 11946;
 Libderiv->deriv2_classes[2][4][94] = int_stack + 12216;
 Libderiv->deriv2_classes[2][5][94] = int_stack + 12306;
 Libderiv->deriv2_classes[2][6][94] = int_stack + 12432;
 Libderiv->deriv2_classes[2][7][94] = int_stack + 12600;
 Libderiv->deriv2_classes[2][8][94] = int_stack + 12816;
 Libderiv->deriv2_classes[2][4][93] = int_stack + 13086;
 Libderiv->deriv2_classes[2][5][93] = int_stack + 13176;
 Libderiv->deriv2_classes[2][6][93] = int_stack + 13302;
 Libderiv->deriv2_classes[2][7][93] = int_stack + 13470;
 Libderiv->deriv2_classes[2][8][93] = int_stack + 13686;
 Libderiv->deriv2_classes[2][4][92] = int_stack + 13956;
 Libderiv->deriv2_classes[2][5][92] = int_stack + 14046;
 Libderiv->deriv2_classes[2][6][92] = int_stack + 14172;
 Libderiv->deriv2_classes[2][7][92] = int_stack + 14340;
 Libderiv->deriv2_classes[2][8][92] = int_stack + 14556;
 Libderiv->deriv2_classes[2][4][91] = int_stack + 14826;
 Libderiv->deriv2_classes[2][5][91] = int_stack + 14916;
 Libderiv->deriv2_classes[2][6][91] = int_stack + 15042;
 Libderiv->deriv2_classes[2][7][91] = int_stack + 15210;
 Libderiv->deriv2_classes[2][8][91] = int_stack + 15426;
 Libderiv->deriv_classes[2][4][11] = int_stack + 15696;
 Libderiv->deriv2_classes[2][4][83] = int_stack + 15786;
 Libderiv->deriv_classes[2][5][11] = int_stack + 15876;
 Libderiv->deriv2_classes[2][5][83] = int_stack + 16002;
 Libderiv->deriv_classes[2][6][11] = int_stack + 16128;
 Libderiv->deriv2_classes[2][6][83] = int_stack + 16296;
 Libderiv->deriv_classes[2][7][11] = int_stack + 16464;
 Libderiv->deriv2_classes[2][7][83] = int_stack + 16680;
 Libderiv->deriv2_classes[2][8][83] = int_stack + 16896;
 Libderiv->deriv_classes[2][4][10] = int_stack + 17166;
 Libderiv->deriv2_classes[2][4][82] = int_stack + 17256;
 Libderiv->deriv_classes[2][5][10] = int_stack + 17346;
 Libderiv->deriv2_classes[2][5][82] = int_stack + 17472;
 Libderiv->deriv_classes[2][6][10] = int_stack + 17598;
 Libderiv->deriv2_classes[2][6][82] = int_stack + 17766;
 Libderiv->deriv_classes[2][7][10] = int_stack + 17934;
 Libderiv->deriv2_classes[2][7][82] = int_stack + 18150;
 Libderiv->deriv2_classes[2][8][82] = int_stack + 18366;
 Libderiv->deriv_classes[2][4][9] = int_stack + 18636;
 Libderiv->deriv2_classes[2][4][81] = int_stack + 18726;
 Libderiv->deriv_classes[2][5][9] = int_stack + 18816;
 Libderiv->deriv2_classes[2][5][81] = int_stack + 18942;
 Libderiv->deriv_classes[2][6][9] = int_stack + 19068;
 Libderiv->deriv2_classes[2][6][81] = int_stack + 19236;
 Libderiv->deriv_classes[2][7][9] = int_stack + 19404;
 Libderiv->deriv2_classes[2][7][81] = int_stack + 19620;
 Libderiv->deriv2_classes[2][8][81] = int_stack + 19836;
 Libderiv->deriv_classes[2][4][8] = int_stack + 20106;
 Libderiv->deriv2_classes[2][4][80] = int_stack + 20196;
 Libderiv->deriv_classes[2][5][8] = int_stack + 20286;
 Libderiv->deriv2_classes[2][5][80] = int_stack + 20412;
 Libderiv->deriv_classes[2][6][8] = int_stack + 20538;
 Libderiv->deriv2_classes[2][6][80] = int_stack + 20706;
 Libderiv->deriv_classes[2][7][8] = int_stack + 20874;
 Libderiv->deriv2_classes[2][7][80] = int_stack + 21090;
 Libderiv->deriv2_classes[2][8][80] = int_stack + 21306;
 Libderiv->deriv_classes[2][4][7] = int_stack + 21576;
 Libderiv->deriv2_classes[2][4][79] = int_stack + 21666;
 Libderiv->deriv_classes[2][5][7] = int_stack + 21756;
 Libderiv->deriv2_classes[2][5][79] = int_stack + 21882;
 Libderiv->deriv_classes[2][6][7] = int_stack + 22008;
 Libderiv->deriv2_classes[2][6][79] = int_stack + 22176;
 Libderiv->deriv_classes[2][7][7] = int_stack + 22344;
 Libderiv->deriv2_classes[2][7][79] = int_stack + 22560;
 Libderiv->deriv2_classes[2][8][79] = int_stack + 22776;
 Libderiv->dvrr_classes[2][4] = int_stack + 23046;
 Libderiv->deriv_classes[2][4][6] = int_stack + 23136;
 Libderiv->deriv2_classes[2][4][78] = int_stack + 23226;
 Libderiv->dvrr_classes[2][5] = int_stack + 23316;
 Libderiv->deriv_classes[2][5][6] = int_stack + 23442;
 Libderiv->deriv2_classes[2][5][78] = int_stack + 23568;
 Libderiv->dvrr_classes[2][6] = int_stack + 23694;
 Libderiv->deriv_classes[2][6][6] = int_stack + 23862;
 Libderiv->deriv2_classes[2][6][78] = int_stack + 24030;
 Libderiv->deriv_classes[2][7][6] = int_stack + 24198;
 Libderiv->deriv2_classes[2][7][78] = int_stack + 24414;
 Libderiv->deriv2_classes[2][8][78] = int_stack + 24630;
 Libderiv->deriv2_classes[2][4][35] = int_stack + 24900;
 Libderiv->deriv2_classes[2][5][35] = int_stack + 24990;
 Libderiv->deriv2_classes[2][6][35] = int_stack + 25116;
 Libderiv->deriv2_classes[2][7][35] = int_stack + 25284;
 Libderiv->deriv2_classes[2][8][35] = int_stack + 25500;
 Libderiv->deriv2_classes[2][4][34] = int_stack + 25770;
 Libderiv->deriv2_classes[2][5][34] = int_stack + 25860;
 Libderiv->deriv2_classes[2][6][34] = int_stack + 25986;
 Libderiv->deriv2_classes[2][7][34] = int_stack + 26154;
 Libderiv->deriv2_classes[2][8][34] = int_stack + 26370;
 Libderiv->deriv2_classes[2][4][33] = int_stack + 26640;
 Libderiv->deriv2_classes[2][5][33] = int_stack + 26730;
 Libderiv->deriv2_classes[2][6][33] = int_stack + 26856;
 Libderiv->deriv2_classes[2][7][33] = int_stack + 27024;
 Libderiv->deriv2_classes[2][8][33] = int_stack + 27240;
 Libderiv->deriv2_classes[2][4][32] = int_stack + 27510;
 Libderiv->deriv2_classes[2][5][32] = int_stack + 27600;
 Libderiv->deriv2_classes[2][6][32] = int_stack + 27726;
 Libderiv->deriv2_classes[2][7][32] = int_stack + 27894;
 Libderiv->deriv2_classes[2][8][32] = int_stack + 28110;
 Libderiv->deriv2_classes[2][4][31] = int_stack + 28380;
 Libderiv->deriv2_classes[2][5][31] = int_stack + 28470;
 Libderiv->deriv2_classes[2][6][31] = int_stack + 28596;
 Libderiv->deriv2_classes[2][7][31] = int_stack + 28764;
 Libderiv->deriv2_classes[2][8][31] = int_stack + 28980;
 Libderiv->deriv_classes[2][4][2] = int_stack + 29250;
 Libderiv->deriv2_classes[2][4][30] = int_stack + 29340;
 Libderiv->deriv_classes[2][5][2] = int_stack + 29430;
 Libderiv->deriv2_classes[2][5][30] = int_stack + 29556;
 Libderiv->deriv_classes[2][6][2] = int_stack + 29682;
 Libderiv->deriv2_classes[2][6][30] = int_stack + 29850;
 Libderiv->deriv_classes[2][7][2] = int_stack + 30018;
 Libderiv->deriv2_classes[2][7][30] = int_stack + 30234;
 Libderiv->deriv2_classes[2][8][30] = int_stack + 30450;
 Libderiv->deriv2_classes[2][4][26] = int_stack + 30720;
 Libderiv->deriv2_classes[2][5][26] = int_stack + 30810;
 Libderiv->deriv2_classes[2][6][26] = int_stack + 30936;
 Libderiv->deriv2_classes[2][7][26] = int_stack + 31104;
 Libderiv->deriv2_classes[2][8][26] = int_stack + 31320;
 Libderiv->deriv2_classes[2][4][23] = int_stack + 31590;
 Libderiv->deriv2_classes[2][5][23] = int_stack + 31680;
 Libderiv->deriv2_classes[2][6][23] = int_stack + 31806;
 Libderiv->deriv2_classes[2][7][23] = int_stack + 31974;
 Libderiv->deriv2_classes[2][8][23] = int_stack + 32190;
 Libderiv->deriv2_classes[2][4][22] = int_stack + 32460;
 Libderiv->deriv2_classes[2][5][22] = int_stack + 32550;
 Libderiv->deriv2_classes[2][6][22] = int_stack + 32676;
 Libderiv->deriv2_classes[2][7][22] = int_stack + 32844;
 Libderiv->deriv2_classes[2][8][22] = int_stack + 33060;
 Libderiv->deriv2_classes[2][4][21] = int_stack + 33330;
 Libderiv->deriv2_classes[2][5][21] = int_stack + 33420;
 Libderiv->deriv2_classes[2][6][21] = int_stack + 33546;
 Libderiv->deriv2_classes[2][7][21] = int_stack + 33714;
 Libderiv->deriv2_classes[2][8][21] = int_stack + 33930;
 Libderiv->deriv2_classes[2][4][20] = int_stack + 34200;
 Libderiv->deriv2_classes[2][5][20] = int_stack + 34290;
 Libderiv->deriv2_classes[2][6][20] = int_stack + 34416;
 Libderiv->deriv2_classes[2][7][20] = int_stack + 34584;
 Libderiv->deriv2_classes[2][8][20] = int_stack + 34800;
 Libderiv->deriv2_classes[2][4][19] = int_stack + 35070;
 Libderiv->deriv2_classes[2][5][19] = int_stack + 35160;
 Libderiv->deriv2_classes[2][6][19] = int_stack + 35286;
 Libderiv->deriv2_classes[2][7][19] = int_stack + 35454;
 Libderiv->deriv2_classes[2][8][19] = int_stack + 35670;
 Libderiv->deriv_classes[2][4][1] = int_stack + 35940;
 Libderiv->deriv2_classes[2][4][18] = int_stack + 36030;
 Libderiv->deriv_classes[2][5][1] = int_stack + 36120;
 Libderiv->deriv2_classes[2][5][18] = int_stack + 36246;
 Libderiv->deriv_classes[2][6][1] = int_stack + 36372;
 Libderiv->deriv2_classes[2][6][18] = int_stack + 36540;
 Libderiv->deriv_classes[2][7][1] = int_stack + 36708;
 Libderiv->deriv2_classes[2][7][18] = int_stack + 36924;
 Libderiv->deriv2_classes[2][8][18] = int_stack + 37140;
 Libderiv->deriv2_classes[2][4][14] = int_stack + 37410;
 Libderiv->deriv2_classes[2][5][14] = int_stack + 37500;
 Libderiv->deriv2_classes[2][6][14] = int_stack + 37626;
 Libderiv->deriv2_classes[2][7][14] = int_stack + 37794;
 Libderiv->deriv2_classes[2][8][14] = int_stack + 38010;
 Libderiv->deriv2_classes[2][4][13] = int_stack + 38280;
 Libderiv->deriv2_classes[2][5][13] = int_stack + 38370;
 Libderiv->deriv2_classes[2][6][13] = int_stack + 38496;
 Libderiv->deriv2_classes[2][7][13] = int_stack + 38664;
 Libderiv->deriv2_classes[2][8][13] = int_stack + 38880;
 Libderiv->deriv2_classes[2][4][11] = int_stack + 39150;
 Libderiv->deriv2_classes[2][5][11] = int_stack + 39240;
 Libderiv->deriv2_classes[2][6][11] = int_stack + 39366;
 Libderiv->deriv2_classes[2][7][11] = int_stack + 39534;
 Libderiv->deriv2_classes[2][8][11] = int_stack + 39750;
 Libderiv->deriv2_classes[2][4][10] = int_stack + 40020;
 Libderiv->deriv2_classes[2][5][10] = int_stack + 40110;
 Libderiv->deriv2_classes[2][6][10] = int_stack + 40236;
 Libderiv->deriv2_classes[2][7][10] = int_stack + 40404;
 Libderiv->deriv2_classes[2][8][10] = int_stack + 40620;
 Libderiv->deriv2_classes[2][4][9] = int_stack + 40890;
 Libderiv->deriv2_classes[2][5][9] = int_stack + 40980;
 Libderiv->deriv2_classes[2][6][9] = int_stack + 41106;
 Libderiv->deriv2_classes[2][7][9] = int_stack + 41274;
 Libderiv->deriv2_classes[2][8][9] = int_stack + 41490;
 Libderiv->deriv2_classes[2][4][8] = int_stack + 41760;
 Libderiv->deriv2_classes[2][5][8] = int_stack + 41850;
 Libderiv->deriv2_classes[2][6][8] = int_stack + 41976;
 Libderiv->deriv2_classes[2][7][8] = int_stack + 42144;
 Libderiv->deriv2_classes[2][8][8] = int_stack + 42360;
 Libderiv->deriv2_classes[2][4][7] = int_stack + 42630;
 Libderiv->deriv2_classes[2][5][7] = int_stack + 42720;
 Libderiv->deriv2_classes[2][6][7] = int_stack + 42846;
 Libderiv->deriv2_classes[2][7][7] = int_stack + 43014;
 Libderiv->deriv2_classes[2][8][7] = int_stack + 43230;
 Libderiv->deriv_classes[2][4][0] = int_stack + 43500;
 Libderiv->deriv2_classes[2][4][6] = int_stack + 43590;
 Libderiv->deriv_classes[2][5][0] = int_stack + 43680;
 Libderiv->deriv2_classes[2][5][6] = int_stack + 43806;
 Libderiv->deriv_classes[2][6][0] = int_stack + 43932;
 Libderiv->deriv2_classes[2][6][6] = int_stack + 44100;
 Libderiv->deriv_classes[2][7][0] = int_stack + 44268;
 Libderiv->deriv2_classes[2][7][6] = int_stack + 44484;
 Libderiv->deriv2_classes[2][8][6] = int_stack + 44700;
 Libderiv->deriv2_classes[2][4][2] = int_stack + 44970;
 Libderiv->deriv2_classes[2][5][2] = int_stack + 45060;
 Libderiv->deriv2_classes[2][6][2] = int_stack + 45186;
 Libderiv->deriv2_classes[2][7][2] = int_stack + 45354;
 Libderiv->deriv2_classes[2][8][2] = int_stack + 45570;
 Libderiv->deriv2_classes[2][4][1] = int_stack + 45840;
 Libderiv->deriv2_classes[2][5][1] = int_stack + 45930;
 Libderiv->deriv2_classes[2][6][1] = int_stack + 46056;
 Libderiv->deriv2_classes[2][7][1] = int_stack + 46224;
 Libderiv->deriv2_classes[2][8][1] = int_stack + 46440;
 Libderiv->deriv2_classes[2][4][0] = int_stack + 46710;
 Libderiv->deriv2_classes[2][5][0] = int_stack + 46800;
 Libderiv->deriv2_classes[2][6][0] = int_stack + 46926;
 Libderiv->deriv2_classes[2][7][0] = int_stack + 47094;
 Libderiv->deriv2_classes[2][8][0] = int_stack + 47310;
 memset(int_stack,0,380640);

 Libderiv->dvrr_stack = int_stack + 133404;
 for(i=0;i<num_prim_comb;i++) {
   d12vrr_order_d0gg(Libderiv, Data);
   Data++;
 }

 /*--- compute (d0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+47580,int_stack+23316,int_stack+23046,6);
 /*--- compute (d0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+47850,int_stack+23694,int_stack+23316,6);
 /*--- compute (d0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+48228,int_stack+47850,int_stack+47580,6);
 /*--- compute (d0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+48768,int_stack+1350,int_stack+23694,6);
 /*--- compute (d0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+49272,int_stack+48768,int_stack+47850,6);
 /*--- compute (d0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+50028,int_stack+49272,int_stack+48228,6);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+50928,int_stack+15876,int_stack+15696, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+23046,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+51198,int_stack+16128,int_stack+15876, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+23316,6);
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+51576,int_stack+51198,int_stack+50928, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+47580,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+52116,int_stack+16464,int_stack+16128, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+23694,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+52620,int_stack+52116,int_stack+51198, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+47850,6);
 /*--- compute (d0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+53376,int_stack+52620,int_stack+51576, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+48228,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+54276,int_stack+0,int_stack+16464, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1350,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+54924,int_stack+54276,int_stack+52116, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+48768,6);
 /*--- compute (d0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+55932,int_stack+54924,int_stack+52620, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+49272,6);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+0,int_stack+17346,int_stack+17166, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+23046, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+54276,int_stack+17598,int_stack+17346, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+23316, 0.0, zero_stack,6);
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+54654,int_stack+54276,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+47580, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+55194,int_stack+17934,int_stack+17598, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+23694, 0.0, zero_stack,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+57192,int_stack+55194,int_stack+54276, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+47850, 0.0, zero_stack,6);
 /*--- compute (d0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+57948,int_stack+57192,int_stack+54654, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+48228, 0.0, zero_stack,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+58848,int_stack+270,int_stack+17934, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1350, 0.0, zero_stack,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+59496,int_stack+58848,int_stack+55194, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+48768, 0.0, zero_stack,6);
 /*--- compute (d0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+60504,int_stack+59496,int_stack+57192, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+49272, 0.0, zero_stack,6);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+270,int_stack+18816,int_stack+18636, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+23046, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+58848,int_stack+19068,int_stack+18816, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+23316, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+59226,int_stack+58848,int_stack+270, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+47580, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+59766,int_stack+19404,int_stack+19068, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+23694, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+61764,int_stack+59766,int_stack+58848, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+47850, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+62520,int_stack+61764,int_stack+59226, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+48228, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+63420,int_stack+540,int_stack+19404, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1350, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+64068,int_stack+63420,int_stack+59766, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+48768, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+65076,int_stack+64068,int_stack+61764, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+49272, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+540,int_stack+20286,int_stack+20106, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+23046, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+63420,int_stack+20538,int_stack+20286, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+23316, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+63798,int_stack+63420,int_stack+540, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+47580, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+64338,int_stack+20874,int_stack+20538, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+23694, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+66336,int_stack+64338,int_stack+63420, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+47850, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+67092,int_stack+66336,int_stack+63798, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+48228, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+67992,int_stack+810,int_stack+20874, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1350, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+68640,int_stack+67992,int_stack+64338, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+48768, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+69648,int_stack+68640,int_stack+66336, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+49272, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+810,int_stack+21756,int_stack+21576, 0.0, zero_stack, 1.0, int_stack+23046, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+67992,int_stack+22008,int_stack+21756, 0.0, zero_stack, 1.0, int_stack+23316, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+68370,int_stack+67992,int_stack+810, 0.0, zero_stack, 1.0, int_stack+47580, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+68910,int_stack+22344,int_stack+22008, 0.0, zero_stack, 1.0, int_stack+23694, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+70908,int_stack+68910,int_stack+67992, 0.0, zero_stack, 1.0, int_stack+47850, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+71664,int_stack+70908,int_stack+68370, 0.0, zero_stack, 1.0, int_stack+48228, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+72564,int_stack+1080,int_stack+22344, 0.0, zero_stack, 1.0, int_stack+1350, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+73212,int_stack+72564,int_stack+68910, 0.0, zero_stack, 1.0, int_stack+48768, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+74220,int_stack+73212,int_stack+70908, 0.0, zero_stack, 1.0, int_stack+49272, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+1080,int_stack+23442,int_stack+23136, 1.0, int_stack+23046, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+72564,int_stack+23862,int_stack+23442, 1.0, int_stack+23316, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+72942,int_stack+72564,int_stack+1080, 1.0, int_stack+47580, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+73482,int_stack+24198,int_stack+23862, 1.0, int_stack+23694, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+75480,int_stack+73482,int_stack+72564, 1.0, int_stack+47850, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+76236,int_stack+75480,int_stack+72942, 1.0, int_stack+48228, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+47580,int_stack+1566,int_stack+24198, 1.0, int_stack+1350, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+77136,int_stack+47580,int_stack+73482, 1.0, int_stack+48768, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+47580,int_stack+77136,int_stack+75480, 1.0, int_stack+49272, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+77136,int_stack+29430,int_stack+29250,6);
 /*--- compute (d0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+77406,int_stack+29682,int_stack+29430,6);
 /*--- compute (d0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+77784,int_stack+77406,int_stack+77136,6);
 /*--- compute (d0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+78324,int_stack+30018,int_stack+29682,6);
 /*--- compute (d0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+48840,int_stack+78324,int_stack+77406,6);
 /*--- compute (d0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+78828,int_stack+48840,int_stack+77784,6);
 /*--- compute (d0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+79728,int_stack+1836,int_stack+30018,6);
 /*--- compute (d0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+80376,int_stack+79728,int_stack+78324,6);
 /*--- compute (d0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+81384,int_stack+80376,int_stack+48840,6);
 /*--- compute (d0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+79728,int_stack+36120,int_stack+35940,6);
 /*--- compute (d0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+79998,int_stack+36372,int_stack+36120,6);
 /*--- compute (d0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+80376,int_stack+79998,int_stack+79728,6);
 /*--- compute (d0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+1350,int_stack+36708,int_stack+36372,6);
 /*--- compute (d0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+82644,int_stack+1350,int_stack+79998,6);
 /*--- compute (d0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+83400,int_stack+82644,int_stack+80376,6);
 /*--- compute (d0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+84300,int_stack+2106,int_stack+36708,6);
 /*--- compute (d0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+84948,int_stack+84300,int_stack+1350,6);
 /*--- compute (d0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+85956,int_stack+84948,int_stack+82644,6);
 /*--- compute (d0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+84300,int_stack+43680,int_stack+43500,6);
 /*--- compute (d0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+84570,int_stack+43932,int_stack+43680,6);
 /*--- compute (d0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+84948,int_stack+84570,int_stack+84300,6);
 /*--- compute (d0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+87216,int_stack+44268,int_stack+43932,6);
 /*--- compute (d0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+87720,int_stack+87216,int_stack+84570,6);
 /*--- compute (d0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+88476,int_stack+87720,int_stack+84948,6);
 /*--- compute (d0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+89376,int_stack+2376,int_stack+44268,6);
 /*--- compute (d0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+90024,int_stack+89376,int_stack+87216,6);
 /*--- compute (d0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+91032,int_stack+90024,int_stack+87720,6);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+89376,int_stack+2736,int_stack+2646, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+15696,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+89646,int_stack+2862,int_stack+2736, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+15876,6);
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+90024,int_stack+89646,int_stack+89376, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+50928,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+92292,int_stack+3030,int_stack+2862, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+16128,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1854,int_stack+92292,int_stack+89646, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+51198,6);
 /*--- compute (d0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+92796,int_stack+1854,int_stack+90024, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+51576,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+89376,int_stack+3246,int_stack+3030, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+16464,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+90024,int_stack+89376,int_stack+92292, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+52116,6);
 /*--- compute (d0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+93696,int_stack+90024,int_stack+1854, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+52620,6);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+1854,int_stack+3606,int_stack+3516, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+15696, 1.0, int_stack+17166,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2124,int_stack+3732,int_stack+3606, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+15876, 1.0, int_stack+17346,6);
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+2502,int_stack+2124,int_stack+1854, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+50928, 1.0, int_stack+0,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+92292,int_stack+3900,int_stack+3732, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+16128, 1.0, int_stack+17598,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+3042,int_stack+92292,int_stack+2124, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+51198, 1.0, int_stack+54276,6);
 /*--- compute (d0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+89376,int_stack+3042,int_stack+2502, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+51576, 1.0, int_stack+54654,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1854,int_stack+4116,int_stack+3900, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+16464, 1.0, int_stack+17934,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+94956,int_stack+1854,int_stack+92292, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+52116, 1.0, int_stack+55194,6);
 /*--- compute (d0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+95964,int_stack+94956,int_stack+3042, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+52620, 1.0, int_stack+57192,6);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+94956,int_stack+4476,int_stack+4386, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+17166, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+95226,int_stack+4602,int_stack+4476, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+17346, 0.0, zero_stack,6);
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+1854,int_stack+95226,int_stack+94956, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+0, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+92292,int_stack+4770,int_stack+4602, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+17598, 0.0, zero_stack,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+90276,int_stack+92292,int_stack+95226, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+54276, 0.0, zero_stack,6);
 /*--- compute (d0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+94956,int_stack+90276,int_stack+1854, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+54654, 0.0, zero_stack,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1854,int_stack+4986,int_stack+4770, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+17934, 0.0, zero_stack,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2502,int_stack+1854,int_stack+92292, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+55194, 0.0, zero_stack,6);
 /*--- compute (d0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+3510,int_stack+2502,int_stack+90276, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+57192, 0.0, zero_stack,6);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+90276,int_stack+5346,int_stack+5256, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+15696, 0.0, zero_stack, 1.0, int_stack+18636,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+90546,int_stack+5472,int_stack+5346, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+15876, 0.0, zero_stack, 1.0, int_stack+18816,6);
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+1854,int_stack+90546,int_stack+90276, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+50928, 0.0, zero_stack, 1.0, int_stack+270,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+92292,int_stack+5640,int_stack+5472, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+16128, 0.0, zero_stack, 1.0, int_stack+19068,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2394,int_stack+92292,int_stack+90546, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+51198, 0.0, zero_stack, 1.0, int_stack+58848,6);
 /*--- compute (d0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+97224,int_stack+2394,int_stack+1854, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+51576, 0.0, zero_stack, 1.0, int_stack+59226,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+90276,int_stack+5856,int_stack+5640, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+16464, 0.0, zero_stack, 1.0, int_stack+19404,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+4770,int_stack+90276,int_stack+92292, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+52116, 0.0, zero_stack, 1.0, int_stack+59766,6);
 /*--- compute (d0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+98124,int_stack+4770,int_stack+2394, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+52620, 0.0, zero_stack, 1.0, int_stack+61764,6);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+4770,int_stack+6216,int_stack+6126, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+17166, 1.0, int_stack+18636, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+5040,int_stack+6342,int_stack+6216, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+17346, 1.0, int_stack+18816, 0.0, zero_stack,6);
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+5418,int_stack+5040,int_stack+4770, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+0, 1.0, int_stack+270, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+92292,int_stack+6510,int_stack+6342, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+17598, 1.0, int_stack+19068, 0.0, zero_stack,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+90276,int_stack+92292,int_stack+5040, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+54276, 1.0, int_stack+58848, 0.0, zero_stack,6);
 /*--- compute (d0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+1854,int_stack+90276,int_stack+5418, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+54654, 1.0, int_stack+59226, 0.0, zero_stack,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+4770,int_stack+6726,int_stack+6510, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+17934, 1.0, int_stack+19404, 0.0, zero_stack,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+5418,int_stack+4770,int_stack+92292, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+55194, 1.0, int_stack+59766, 0.0, zero_stack,6);
 /*--- compute (d0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+99384,int_stack+5418,int_stack+90276, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+57192, 1.0, int_stack+61764, 0.0, zero_stack,6);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+90276,int_stack+7086,int_stack+6996, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+18636, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+90546,int_stack+7212,int_stack+7086, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+18816, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+4770,int_stack+90546,int_stack+90276, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+270, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+92292,int_stack+7380,int_stack+7212, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+19068, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2754,int_stack+92292,int_stack+90546, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+58848, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+5310,int_stack+2754,int_stack+4770, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+59226, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+90276,int_stack+7596,int_stack+7380, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+19404, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+6210,int_stack+90276,int_stack+92292, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+59766, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+100644,int_stack+6210,int_stack+2754, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+61764, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+2754,int_stack+7956,int_stack+7866, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+15696, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+20106,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+3024,int_stack+8082,int_stack+7956, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+15876, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+20286,6);
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+4770,int_stack+3024,int_stack+2754, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+50928, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+540,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+92292,int_stack+8250,int_stack+8082, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+16128, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+20538,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+90276,int_stack+92292,int_stack+3024, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+51198, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+63420,6);
 /*--- compute (d0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+6210,int_stack+90276,int_stack+4770, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+51576, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+63798,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2754,int_stack+8466,int_stack+8250, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+16464, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+20874,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+7110,int_stack+2754,int_stack+92292, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+52116, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+64338,6);
 /*--- compute (d0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+101904,int_stack+7110,int_stack+90276, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+52620, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+66336,6);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+90276,int_stack+8826,int_stack+8736, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+17166, 0.0, zero_stack, 1.0, int_stack+20106, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+90546,int_stack+8952,int_stack+8826, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+17346, 0.0, zero_stack, 1.0, int_stack+20286, 0.0, zero_stack,6);
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+4770,int_stack+90546,int_stack+90276, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack, 1.0, int_stack+540, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+92292,int_stack+9120,int_stack+8952, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+17598, 0.0, zero_stack, 1.0, int_stack+20538, 0.0, zero_stack,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2754,int_stack+92292,int_stack+90546, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+54276, 0.0, zero_stack, 1.0, int_stack+63420, 0.0, zero_stack,6);
 /*--- compute (d0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+7110,int_stack+2754,int_stack+4770, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+54654, 0.0, zero_stack, 1.0, int_stack+63798, 0.0, zero_stack,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+90276,int_stack+9336,int_stack+9120, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+17934, 0.0, zero_stack, 1.0, int_stack+20874, 0.0, zero_stack,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+8010,int_stack+90276,int_stack+92292, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+55194, 0.0, zero_stack, 1.0, int_stack+64338, 0.0, zero_stack,6);
 /*--- compute (d0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+103164,int_stack+8010,int_stack+2754, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+57192, 0.0, zero_stack, 1.0, int_stack+66336, 0.0, zero_stack,6);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+2754,int_stack+9696,int_stack+9606, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+18636, 1.0, int_stack+20106, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+3024,int_stack+9822,int_stack+9696, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+18816, 1.0, int_stack+20286, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+4770,int_stack+3024,int_stack+2754, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+270, 1.0, int_stack+540, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+92292,int_stack+9990,int_stack+9822, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+19068, 1.0, int_stack+20538, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+90276,int_stack+92292,int_stack+3024, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+58848, 1.0, int_stack+63420, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+8010,int_stack+90276,int_stack+4770, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+59226, 1.0, int_stack+63798, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2754,int_stack+10206,int_stack+9990, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+19404, 1.0, int_stack+20874, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+8910,int_stack+2754,int_stack+92292, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+59766, 1.0, int_stack+64338, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+104424,int_stack+8910,int_stack+90276, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+61764, 1.0, int_stack+66336, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+90276,int_stack+10566,int_stack+10476, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+20106, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+90546,int_stack+10692,int_stack+10566, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+20286, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+4770,int_stack+90546,int_stack+90276, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+540, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+92292,int_stack+10860,int_stack+10692, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+20538, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2754,int_stack+92292,int_stack+90546, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+63420, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+8910,int_stack+2754,int_stack+4770, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+63798, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+90276,int_stack+11076,int_stack+10860, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+20874, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+9810,int_stack+90276,int_stack+92292, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+64338, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+105684,int_stack+9810,int_stack+2754, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+66336, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+2754,int_stack+11436,int_stack+11346, 0.0, zero_stack, 1.0, int_stack+15696, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+21576,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+3024,int_stack+11562,int_stack+11436, 0.0, zero_stack, 1.0, int_stack+15876, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+21756,6);
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+4770,int_stack+3024,int_stack+2754, 0.0, zero_stack, 1.0, int_stack+50928, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+810,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+92292,int_stack+11730,int_stack+11562, 0.0, zero_stack, 1.0, int_stack+16128, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+22008,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+90276,int_stack+92292,int_stack+3024, 0.0, zero_stack, 1.0, int_stack+51198, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+67992,6);
 /*--- compute (d0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+9810,int_stack+90276,int_stack+4770, 0.0, zero_stack, 1.0, int_stack+51576, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+68370,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2754,int_stack+11946,int_stack+11730, 0.0, zero_stack, 1.0, int_stack+16464, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+22344,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+10710,int_stack+2754,int_stack+92292, 0.0, zero_stack, 1.0, int_stack+52116, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+68910,6);
 /*--- compute (d0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+106944,int_stack+10710,int_stack+90276, 0.0, zero_stack, 1.0, int_stack+52620, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+70908,6);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+90276,int_stack+12306,int_stack+12216, 0.0, zero_stack, 1.0, int_stack+17166, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+21576, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+90546,int_stack+12432,int_stack+12306, 0.0, zero_stack, 1.0, int_stack+17346, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+21756, 0.0, zero_stack,6);
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+4770,int_stack+90546,int_stack+90276, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+810, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+92292,int_stack+12600,int_stack+12432, 0.0, zero_stack, 1.0, int_stack+17598, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+22008, 0.0, zero_stack,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2754,int_stack+92292,int_stack+90546, 0.0, zero_stack, 1.0, int_stack+54276, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+67992, 0.0, zero_stack,6);
 /*--- compute (d0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+10710,int_stack+2754,int_stack+4770, 0.0, zero_stack, 1.0, int_stack+54654, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+68370, 0.0, zero_stack,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+90276,int_stack+12816,int_stack+12600, 0.0, zero_stack, 1.0, int_stack+17934, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+22344, 0.0, zero_stack,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+11610,int_stack+90276,int_stack+92292, 0.0, zero_stack, 1.0, int_stack+55194, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+68910, 0.0, zero_stack,6);
 /*--- compute (d0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+108204,int_stack+11610,int_stack+2754, 0.0, zero_stack, 1.0, int_stack+57192, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+70908, 0.0, zero_stack,6);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+2754,int_stack+13176,int_stack+13086, 0.0, zero_stack, 1.0, int_stack+18636, 0.0, zero_stack, 1.0, int_stack+21576, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+3024,int_stack+13302,int_stack+13176, 0.0, zero_stack, 1.0, int_stack+18816, 0.0, zero_stack, 1.0, int_stack+21756, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+4770,int_stack+3024,int_stack+2754, 0.0, zero_stack, 1.0, int_stack+270, 0.0, zero_stack, 1.0, int_stack+810, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+92292,int_stack+13470,int_stack+13302, 0.0, zero_stack, 1.0, int_stack+19068, 0.0, zero_stack, 1.0, int_stack+22008, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+90276,int_stack+92292,int_stack+3024, 0.0, zero_stack, 1.0, int_stack+58848, 0.0, zero_stack, 1.0, int_stack+67992, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+11610,int_stack+90276,int_stack+4770, 0.0, zero_stack, 1.0, int_stack+59226, 0.0, zero_stack, 1.0, int_stack+68370, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2754,int_stack+13686,int_stack+13470, 0.0, zero_stack, 1.0, int_stack+19404, 0.0, zero_stack, 1.0, int_stack+22344, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+12510,int_stack+2754,int_stack+92292, 0.0, zero_stack, 1.0, int_stack+59766, 0.0, zero_stack, 1.0, int_stack+68910, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+109464,int_stack+12510,int_stack+90276, 0.0, zero_stack, 1.0, int_stack+61764, 0.0, zero_stack, 1.0, int_stack+70908, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+90276,int_stack+14046,int_stack+13956, 0.0, zero_stack, 1.0, int_stack+20106, 1.0, int_stack+21576, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+90546,int_stack+14172,int_stack+14046, 0.0, zero_stack, 1.0, int_stack+20286, 1.0, int_stack+21756, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+4770,int_stack+90546,int_stack+90276, 0.0, zero_stack, 1.0, int_stack+540, 1.0, int_stack+810, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+92292,int_stack+14340,int_stack+14172, 0.0, zero_stack, 1.0, int_stack+20538, 1.0, int_stack+22008, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2754,int_stack+92292,int_stack+90546, 0.0, zero_stack, 1.0, int_stack+63420, 1.0, int_stack+67992, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+12510,int_stack+2754,int_stack+4770, 0.0, zero_stack, 1.0, int_stack+63798, 1.0, int_stack+68370, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+90276,int_stack+14556,int_stack+14340, 0.0, zero_stack, 1.0, int_stack+20874, 1.0, int_stack+22344, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+13410,int_stack+90276,int_stack+92292, 0.0, zero_stack, 1.0, int_stack+64338, 1.0, int_stack+68910, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+110724,int_stack+13410,int_stack+2754, 0.0, zero_stack, 1.0, int_stack+66336, 1.0, int_stack+70908, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+2754,int_stack+14916,int_stack+14826, 0.0, zero_stack, 2.0, int_stack+21576, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+3024,int_stack+15042,int_stack+14916, 0.0, zero_stack, 2.0, int_stack+21756, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+4770,int_stack+3024,int_stack+2754, 0.0, zero_stack, 2.0, int_stack+810, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+92292,int_stack+15210,int_stack+15042, 0.0, zero_stack, 2.0, int_stack+22008, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+90276,int_stack+92292,int_stack+3024, 0.0, zero_stack, 2.0, int_stack+67992, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+13410,int_stack+90276,int_stack+4770, 0.0, zero_stack, 2.0, int_stack+68370, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2754,int_stack+15426,int_stack+15210, 0.0, zero_stack, 2.0, int_stack+22344, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+14310,int_stack+2754,int_stack+92292, 0.0, zero_stack, 2.0, int_stack+68910, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+111984,int_stack+14310,int_stack+90276, 0.0, zero_stack, 2.0, int_stack+70908, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+90276,int_stack+16002,int_stack+15786, 1.0, int_stack+15696, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+23136,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+90546,int_stack+16296,int_stack+16002, 1.0, int_stack+15876, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+23442,6);
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+4770,int_stack+90546,int_stack+90276, 1.0, int_stack+50928, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1080,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+92292,int_stack+16680,int_stack+16296, 1.0, int_stack+16128, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+23862,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2754,int_stack+92292,int_stack+90546, 1.0, int_stack+51198, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+72564,6);
 /*--- compute (d0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+14310,int_stack+2754,int_stack+4770, 1.0, int_stack+51576, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+72942,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+50928,int_stack+16896,int_stack+16680, 1.0, int_stack+16464, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+24198,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+15210,int_stack+50928,int_stack+92292, 1.0, int_stack+52116, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+73482,6);
 /*--- compute (d0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+50928,int_stack+15210,int_stack+2754, 1.0, int_stack+52620, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+75480,6);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+2754,int_stack+17472,int_stack+17256, 1.0, int_stack+17166, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+23136, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+3024,int_stack+17766,int_stack+17472, 1.0, int_stack+17346, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+23442, 0.0, zero_stack,6);
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+4770,int_stack+3024,int_stack+2754, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1080, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+92292,int_stack+18150,int_stack+17766, 1.0, int_stack+17598, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+23862, 0.0, zero_stack,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+90276,int_stack+92292,int_stack+3024, 1.0, int_stack+54276, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+72564, 0.0, zero_stack,6);
 /*--- compute (d0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+15210,int_stack+90276,int_stack+4770, 1.0, int_stack+54654, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+72942, 0.0, zero_stack,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+54276,int_stack+18366,int_stack+18150, 1.0, int_stack+17934, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+24198, 0.0, zero_stack,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+16110,int_stack+54276,int_stack+92292, 1.0, int_stack+55194, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+73482, 0.0, zero_stack,6);
 /*--- compute (d0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+54276,int_stack+16110,int_stack+90276, 1.0, int_stack+57192, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+75480, 0.0, zero_stack,6);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+0,int_stack+18942,int_stack+18726, 1.0, int_stack+18636, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+23136, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+57192,int_stack+19236,int_stack+18942, 1.0, int_stack+18816, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+23442, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+4770,int_stack+57192,int_stack+0, 1.0, int_stack+270, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1080, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+92292,int_stack+19620,int_stack+19236, 1.0, int_stack+19068, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+23862, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+90276,int_stack+92292,int_stack+57192, 1.0, int_stack+58848, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+72564, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+16110,int_stack+90276,int_stack+4770, 1.0, int_stack+59226, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+72942, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+58848,int_stack+19836,int_stack+19620, 1.0, int_stack+19404, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+24198, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+17010,int_stack+58848,int_stack+92292, 1.0, int_stack+59766, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+73482, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+58848,int_stack+17010,int_stack+90276, 1.0, int_stack+61764, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+75480, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+61764,int_stack+20412,int_stack+20196, 1.0, int_stack+20106, 0.0, zero_stack, 1.0, int_stack+23136, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+62034,int_stack+20706,int_stack+20412, 1.0, int_stack+20286, 0.0, zero_stack, 1.0, int_stack+23442, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+4770,int_stack+62034,int_stack+61764, 1.0, int_stack+540, 0.0, zero_stack, 1.0, int_stack+1080, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+92292,int_stack+21090,int_stack+20706, 1.0, int_stack+20538, 0.0, zero_stack, 1.0, int_stack+23862, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+90276,int_stack+92292,int_stack+62034, 1.0, int_stack+63420, 0.0, zero_stack, 1.0, int_stack+72564, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+17010,int_stack+90276,int_stack+4770, 1.0, int_stack+63798, 0.0, zero_stack, 1.0, int_stack+72942, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+63420,int_stack+21306,int_stack+21090, 1.0, int_stack+20874, 0.0, zero_stack, 1.0, int_stack+24198, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+17910,int_stack+63420,int_stack+92292, 1.0, int_stack+64338, 0.0, zero_stack, 1.0, int_stack+73482, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+63420,int_stack+17910,int_stack+90276, 1.0, int_stack+66336, 0.0, zero_stack, 1.0, int_stack+75480, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+66336,int_stack+21882,int_stack+21666, 1.0, int_stack+21576, 1.0, int_stack+23136, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+66606,int_stack+22176,int_stack+21882, 1.0, int_stack+21756, 1.0, int_stack+23442, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+4770,int_stack+66606,int_stack+66336, 1.0, int_stack+810, 1.0, int_stack+1080, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+92292,int_stack+22560,int_stack+22176, 1.0, int_stack+22008, 1.0, int_stack+23862, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+90276,int_stack+92292,int_stack+66606, 1.0, int_stack+67992, 1.0, int_stack+72564, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+17910,int_stack+90276,int_stack+4770, 1.0, int_stack+68370, 1.0, int_stack+72942, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+67992,int_stack+22776,int_stack+22560, 1.0, int_stack+22344, 1.0, int_stack+24198, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+18810,int_stack+67992,int_stack+92292, 1.0, int_stack+68910, 1.0, int_stack+73482, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+67992,int_stack+18810,int_stack+90276, 1.0, int_stack+70908, 1.0, int_stack+75480, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+70908,int_stack+23568,int_stack+23226, 2.0, int_stack+23136, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+71178,int_stack+24030,int_stack+23568, 2.0, int_stack+23442, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+4770,int_stack+71178,int_stack+70908, 2.0, int_stack+1080, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+92292,int_stack+24414,int_stack+24030, 2.0, int_stack+23862, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+90276,int_stack+92292,int_stack+71178, 2.0, int_stack+72564, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+18810,int_stack+90276,int_stack+4770, 2.0, int_stack+72942, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+72564,int_stack+24630,int_stack+24414, 2.0, int_stack+24198, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+19710,int_stack+72564,int_stack+92292, 2.0, int_stack+73482, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+72564,int_stack+19710,int_stack+90276, 2.0, int_stack+75480, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+75480,int_stack+24990,int_stack+24900, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+29250,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+75750,int_stack+25116,int_stack+24990, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+29430,6);
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+4770,int_stack+75750,int_stack+75480, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+77136,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+92292,int_stack+25284,int_stack+25116, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+29682,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+90276,int_stack+92292,int_stack+75750, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+77406,6);
 /*--- compute (d0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+19710,int_stack+90276,int_stack+4770, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+77784,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+75480,int_stack+25500,int_stack+25284, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+30018,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+20610,int_stack+75480,int_stack+92292, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+78324,6);
 /*--- compute (d0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+21618,int_stack+20610,int_stack+90276, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+48840,6);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+90276,int_stack+25860,int_stack+25770, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+29250, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+90546,int_stack+25986,int_stack+25860, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+29430, 0.0, zero_stack,6);
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+4770,int_stack+90546,int_stack+90276, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+77136, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+92292,int_stack+26154,int_stack+25986, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+29682, 0.0, zero_stack,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+75480,int_stack+92292,int_stack+90546, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+77406, 0.0, zero_stack,6);
 /*--- compute (d0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+20610,int_stack+75480,int_stack+4770, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+77784, 0.0, zero_stack,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+90276,int_stack+26370,int_stack+26154, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+30018, 0.0, zero_stack,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+22878,int_stack+90276,int_stack+92292, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+78324, 0.0, zero_stack,6);
 /*--- compute (d0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+23886,int_stack+22878,int_stack+75480, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+48840, 0.0, zero_stack,6);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+75480,int_stack+26730,int_stack+26640, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+29250, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+75750,int_stack+26856,int_stack+26730, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+29430, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+4770,int_stack+75750,int_stack+75480, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+77136, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+92292,int_stack+27024,int_stack+26856, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+29682, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+90276,int_stack+92292,int_stack+75750, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+77406, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+22878,int_stack+90276,int_stack+4770, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+77784, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+75480,int_stack+27240,int_stack+27024, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+30018, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+25146,int_stack+75480,int_stack+92292, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+78324, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+26154,int_stack+25146,int_stack+90276, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+48840, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+90276,int_stack+27600,int_stack+27510, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+29250, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+90546,int_stack+27726,int_stack+27600, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+29430, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+4770,int_stack+90546,int_stack+90276, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+77136, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+92292,int_stack+27894,int_stack+27726, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+29682, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+75480,int_stack+92292,int_stack+90546, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+77406, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+25146,int_stack+75480,int_stack+4770, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+77784, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+90276,int_stack+28110,int_stack+27894, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+30018, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+0,int_stack+90276,int_stack+92292, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+78324, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+113244,int_stack+0,int_stack+75480, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+48840, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+75480,int_stack+28470,int_stack+28380, 0.0, zero_stack, 1.0, int_stack+29250, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+75750,int_stack+28596,int_stack+28470, 0.0, zero_stack, 1.0, int_stack+29430, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+4770,int_stack+75750,int_stack+75480, 0.0, zero_stack, 1.0, int_stack+77136, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+92292,int_stack+28764,int_stack+28596, 0.0, zero_stack, 1.0, int_stack+29682, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+90276,int_stack+92292,int_stack+75750, 0.0, zero_stack, 1.0, int_stack+77406, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+0,int_stack+90276,int_stack+4770, 0.0, zero_stack, 1.0, int_stack+77784, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+75480,int_stack+28980,int_stack+28764, 0.0, zero_stack, 1.0, int_stack+30018, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+27414,int_stack+75480,int_stack+92292, 0.0, zero_stack, 1.0, int_stack+78324, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+114504,int_stack+27414,int_stack+90276, 0.0, zero_stack, 1.0, int_stack+48840, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+90276,int_stack+29556,int_stack+29340, 1.0, int_stack+29250, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+90546,int_stack+29850,int_stack+29556, 1.0, int_stack+29430, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+4770,int_stack+90546,int_stack+90276, 1.0, int_stack+77136, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+92292,int_stack+30234,int_stack+29850, 1.0, int_stack+29682, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+75480,int_stack+92292,int_stack+90546, 1.0, int_stack+77406, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+27414,int_stack+75480,int_stack+4770, 1.0, int_stack+77784, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+77136,int_stack+30450,int_stack+30234, 1.0, int_stack+30018, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+28314,int_stack+77136,int_stack+92292, 1.0, int_stack+78324, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+77136,int_stack+28314,int_stack+75480, 1.0, int_stack+48840, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+48840,int_stack+30810,int_stack+30720,6);
 /*--- compute (d0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+49110,int_stack+30936,int_stack+30810,6);
 /*--- compute (d0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+49488,int_stack+49110,int_stack+48840,6);
 /*--- compute (d0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+92292,int_stack+31104,int_stack+30936,6);
 /*--- compute (d0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+75480,int_stack+92292,int_stack+49110,6);
 /*--- compute (d0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+28314,int_stack+75480,int_stack+49488,6);
 /*--- compute (d0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+48840,int_stack+31320,int_stack+31104,6);
 /*--- compute (d0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+29214,int_stack+48840,int_stack+92292,6);
 /*--- compute (d0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+30222,int_stack+29214,int_stack+75480,6);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+75480,int_stack+31680,int_stack+31590, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+35940,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+75750,int_stack+31806,int_stack+31680, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+36120,6);
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+4770,int_stack+75750,int_stack+75480, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+79728,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+92292,int_stack+31974,int_stack+31806, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+36372,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+90276,int_stack+92292,int_stack+75750, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+79998,6);
 /*--- compute (d0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+29214,int_stack+90276,int_stack+4770, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+80376,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+75480,int_stack+32190,int_stack+31974, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+36708,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+48840,int_stack+75480,int_stack+92292, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1350,6);
 /*--- compute (d0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+115764,int_stack+48840,int_stack+90276, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+82644,6);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+90276,int_stack+32550,int_stack+32460, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+35940, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+90546,int_stack+32676,int_stack+32550, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+36120, 0.0, zero_stack,6);
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+4770,int_stack+90546,int_stack+90276, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+79728, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+92292,int_stack+32844,int_stack+32676, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+36372, 0.0, zero_stack,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+75480,int_stack+92292,int_stack+90546, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+79998, 0.0, zero_stack,6);
 /*--- compute (d0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+48840,int_stack+75480,int_stack+4770, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+80376, 0.0, zero_stack,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+90276,int_stack+33060,int_stack+32844, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+36708, 0.0, zero_stack,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+31482,int_stack+90276,int_stack+92292, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1350, 0.0, zero_stack,6);
 /*--- compute (d0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+117024,int_stack+31482,int_stack+75480, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+82644, 0.0, zero_stack,6);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+75480,int_stack+33420,int_stack+33330, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+35940, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+75750,int_stack+33546,int_stack+33420, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+36120, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+4770,int_stack+75750,int_stack+75480, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+79728, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+92292,int_stack+33714,int_stack+33546, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+36372, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+90276,int_stack+92292,int_stack+75750, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+79998, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+31482,int_stack+90276,int_stack+4770, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+80376, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+75480,int_stack+33930,int_stack+33714, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+36708, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+32382,int_stack+75480,int_stack+92292, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1350, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+118284,int_stack+32382,int_stack+90276, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+82644, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+90276,int_stack+34290,int_stack+34200, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+35940, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+90546,int_stack+34416,int_stack+34290, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+36120, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+4770,int_stack+90546,int_stack+90276, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+79728, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+92292,int_stack+34584,int_stack+34416, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+36372, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+75480,int_stack+92292,int_stack+90546, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+79998, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+32382,int_stack+75480,int_stack+4770, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+80376, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+90276,int_stack+34800,int_stack+34584, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+36708, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+33282,int_stack+90276,int_stack+92292, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1350, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+119544,int_stack+33282,int_stack+75480, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+82644, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+75480,int_stack+35160,int_stack+35070, 0.0, zero_stack, 1.0, int_stack+35940, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+75750,int_stack+35286,int_stack+35160, 0.0, zero_stack, 1.0, int_stack+36120, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+4770,int_stack+75750,int_stack+75480, 0.0, zero_stack, 1.0, int_stack+79728, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+92292,int_stack+35454,int_stack+35286, 0.0, zero_stack, 1.0, int_stack+36372, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+90276,int_stack+92292,int_stack+75750, 0.0, zero_stack, 1.0, int_stack+79998, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+33282,int_stack+90276,int_stack+4770, 0.0, zero_stack, 1.0, int_stack+80376, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+75480,int_stack+35670,int_stack+35454, 0.0, zero_stack, 1.0, int_stack+36708, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+34182,int_stack+75480,int_stack+92292, 0.0, zero_stack, 1.0, int_stack+1350, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+120804,int_stack+34182,int_stack+90276, 0.0, zero_stack, 1.0, int_stack+82644, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+90276,int_stack+36246,int_stack+36030, 1.0, int_stack+35940, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+90546,int_stack+36540,int_stack+36246, 1.0, int_stack+36120, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+4770,int_stack+90546,int_stack+90276, 1.0, int_stack+79728, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+92292,int_stack+36924,int_stack+36540, 1.0, int_stack+36372, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+75480,int_stack+92292,int_stack+90546, 1.0, int_stack+79998, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+34182,int_stack+75480,int_stack+4770, 1.0, int_stack+80376, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+79728,int_stack+37140,int_stack+36924, 1.0, int_stack+36708, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+80376,int_stack+79728,int_stack+92292, 1.0, int_stack+1350, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+35082,int_stack+80376,int_stack+75480, 1.0, int_stack+82644, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+82644,int_stack+37500,int_stack+37410,6);
 /*--- compute (d0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+82914,int_stack+37626,int_stack+37500,6);
 /*--- compute (d0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+4770,int_stack+82914,int_stack+82644,6);
 /*--- compute (d0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+92292,int_stack+37794,int_stack+37626,6);
 /*--- compute (d0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+75480,int_stack+92292,int_stack+82914,6);
 /*--- compute (d0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+79728,int_stack+75480,int_stack+4770,6);
 /*--- compute (d0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+82644,int_stack+38010,int_stack+37794,6);
 /*--- compute (d0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+36342,int_stack+82644,int_stack+92292,6);
 /*--- compute (d0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+122064,int_stack+36342,int_stack+75480,6);
 /*--- compute (d0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+75480,int_stack+38370,int_stack+38280,6);
 /*--- compute (d0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+75750,int_stack+38496,int_stack+38370,6);
 /*--- compute (d0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+4770,int_stack+75750,int_stack+75480,6);
 /*--- compute (d0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+92292,int_stack+38664,int_stack+38496,6);
 /*--- compute (d0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+82644,int_stack+92292,int_stack+75750,6);
 /*--- compute (d0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+36342,int_stack+82644,int_stack+4770,6);
 /*--- compute (d0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+75480,int_stack+38880,int_stack+38664,6);
 /*--- compute (d0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+37242,int_stack+75480,int_stack+92292,6);
 /*--- compute (d0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+123324,int_stack+37242,int_stack+82644,6);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+82644,int_stack+39240,int_stack+39150, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+43500,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+82914,int_stack+39366,int_stack+39240, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+43680,6);
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+4770,int_stack+82914,int_stack+82644, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+84300,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+92292,int_stack+39534,int_stack+39366, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+43932,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+75480,int_stack+92292,int_stack+82914, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+84570,6);
 /*--- compute (d0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+37242,int_stack+75480,int_stack+4770, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+84948,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+82644,int_stack+39750,int_stack+39534, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+44268,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+38142,int_stack+82644,int_stack+92292, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+87216,6);
 /*--- compute (d0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+124584,int_stack+38142,int_stack+75480, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+87720,6);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+75480,int_stack+40110,int_stack+40020, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+43500, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+75750,int_stack+40236,int_stack+40110, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+43680, 0.0, zero_stack,6);
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+4770,int_stack+75750,int_stack+75480, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+84300, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+92292,int_stack+40404,int_stack+40236, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+43932, 0.0, zero_stack,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+82644,int_stack+92292,int_stack+75750, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+84570, 0.0, zero_stack,6);
 /*--- compute (d0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+38142,int_stack+82644,int_stack+4770, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+84948, 0.0, zero_stack,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+75480,int_stack+40620,int_stack+40404, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+44268, 0.0, zero_stack,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+39042,int_stack+75480,int_stack+92292, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+87216, 0.0, zero_stack,6);
 /*--- compute (d0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+125844,int_stack+39042,int_stack+82644, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+87720, 0.0, zero_stack,6);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+82644,int_stack+40980,int_stack+40890, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+43500, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+82914,int_stack+41106,int_stack+40980, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+43680, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+4770,int_stack+82914,int_stack+82644, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+84300, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+92292,int_stack+41274,int_stack+41106, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+43932, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+75480,int_stack+92292,int_stack+82914, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+84570, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+39042,int_stack+75480,int_stack+4770, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+84948, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+82644,int_stack+41490,int_stack+41274, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+44268, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+39942,int_stack+82644,int_stack+92292, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+87216, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+127104,int_stack+39942,int_stack+75480, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+87720, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+75480,int_stack+41850,int_stack+41760, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+43500, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+75750,int_stack+41976,int_stack+41850, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+43680, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+4770,int_stack+75750,int_stack+75480, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+84300, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+92292,int_stack+42144,int_stack+41976, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+43932, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+82644,int_stack+92292,int_stack+75750, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+84570, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+39942,int_stack+82644,int_stack+4770, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+84948, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+75480,int_stack+42360,int_stack+42144, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+44268, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+40842,int_stack+75480,int_stack+92292, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+87216, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+128364,int_stack+40842,int_stack+82644, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+87720, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+82644,int_stack+42720,int_stack+42630, 0.0, zero_stack, 1.0, int_stack+43500, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+82914,int_stack+42846,int_stack+42720, 0.0, zero_stack, 1.0, int_stack+43680, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+4770,int_stack+82914,int_stack+82644, 0.0, zero_stack, 1.0, int_stack+84300, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+92292,int_stack+43014,int_stack+42846, 0.0, zero_stack, 1.0, int_stack+43932, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+75480,int_stack+92292,int_stack+82914, 0.0, zero_stack, 1.0, int_stack+84570, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+40842,int_stack+75480,int_stack+4770, 0.0, zero_stack, 1.0, int_stack+84948, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+82644,int_stack+43230,int_stack+43014, 0.0, zero_stack, 1.0, int_stack+44268, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+41742,int_stack+82644,int_stack+92292, 0.0, zero_stack, 1.0, int_stack+87216, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+129624,int_stack+41742,int_stack+75480, 0.0, zero_stack, 1.0, int_stack+87720, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+75480,int_stack+43806,int_stack+43590, 1.0, int_stack+43500, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+75750,int_stack+44100,int_stack+43806, 1.0, int_stack+43680, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+4770,int_stack+75750,int_stack+75480, 1.0, int_stack+84300, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+92292,int_stack+44484,int_stack+44100, 1.0, int_stack+43932, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+82644,int_stack+92292,int_stack+75750, 1.0, int_stack+84570, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+41742,int_stack+82644,int_stack+4770, 1.0, int_stack+84948, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+84300,int_stack+44700,int_stack+44484, 1.0, int_stack+44268, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+84948,int_stack+84300,int_stack+92292, 1.0, int_stack+87216, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+42642,int_stack+84948,int_stack+82644, 1.0, int_stack+87720, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+82644,int_stack+45060,int_stack+44970,6);
 /*--- compute (d0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+82914,int_stack+45186,int_stack+45060,6);
 /*--- compute (d0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+4770,int_stack+82914,int_stack+82644,6);
 /*--- compute (d0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+92292,int_stack+45354,int_stack+45186,6);
 /*--- compute (d0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+75480,int_stack+92292,int_stack+82914,6);
 /*--- compute (d0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+87216,int_stack+75480,int_stack+4770,6);
 /*--- compute (d0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+82644,int_stack+45570,int_stack+45354,6);
 /*--- compute (d0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+84300,int_stack+82644,int_stack+92292,6);
 /*--- compute (d0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+43902,int_stack+84300,int_stack+75480,6);
 /*--- compute (d0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+75480,int_stack+45930,int_stack+45840,6);
 /*--- compute (d0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+75750,int_stack+46056,int_stack+45930,6);
 /*--- compute (d0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+4770,int_stack+75750,int_stack+75480,6);
 /*--- compute (d0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+92292,int_stack+46224,int_stack+46056,6);
 /*--- compute (d0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+82644,int_stack+92292,int_stack+75750,6);
 /*--- compute (d0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+84300,int_stack+82644,int_stack+4770,6);
 /*--- compute (d0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+75480,int_stack+46440,int_stack+46224,6);
 /*--- compute (d0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+45162,int_stack+75480,int_stack+92292,6);
 /*--- compute (d0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+130884,int_stack+45162,int_stack+82644,6);
 /*--- compute (d0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+82644,int_stack+46800,int_stack+46710,6);
 /*--- compute (d0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+82914,int_stack+46926,int_stack+46800,6);
 /*--- compute (d0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+4770,int_stack+82914,int_stack+82644,6);
 /*--- compute (d0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+92292,int_stack+47094,int_stack+46926,6);
 /*--- compute (d0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+75480,int_stack+92292,int_stack+82914,6);
 /*--- compute (d0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+45162,int_stack+75480,int_stack+4770,6);
 /*--- compute (d0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+82644,int_stack+47310,int_stack+47094,6);
 /*--- compute (d0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+46062,int_stack+82644,int_stack+92292,6);
 /*--- compute (d0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+132144,int_stack+46062,int_stack+75480,6);
 /*--- compute (d0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+46062,int_stack+55932,int_stack+53376, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+50028,6);
     Libderiv->ABCD[11] = int_stack + 46062;
 /*--- compute (d0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+55536,int_stack+60504,int_stack+57948, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+50028, 0.0, zero_stack,6);
     Libderiv->ABCD[10] = int_stack + 55536;
 /*--- compute (d0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+60108,int_stack+65076,int_stack+62520, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+50028, 0.0, zero_stack, 0.0, zero_stack,6);
     Libderiv->ABCD[9] = int_stack + 60108;
 /*--- compute (d0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+64680,int_stack+69648,int_stack+67092, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+50028, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
     Libderiv->ABCD[8] = int_stack + 64680;
 /*--- compute (d0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+69252,int_stack+74220,int_stack+71664, 0.0, zero_stack, 1.0, int_stack+50028, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
     Libderiv->ABCD[7] = int_stack + 69252;
 /*--- compute (d0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+73824,int_stack+47580,int_stack+76236, 1.0, int_stack+50028, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
     Libderiv->ABCD[6] = int_stack + 73824;
 /*--- compute (d0|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+47412,int_stack+81384,int_stack+78828,6);
     Libderiv->ABCD[2] = int_stack + 47412;
 /*--- compute (d0|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+80628,int_stack+85956,int_stack+83400,6);
     Libderiv->ABCD[1] = int_stack + 80628;
 /*--- compute (d0|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+85200,int_stack+91032,int_stack+88476,6);
     Libderiv->ABCD[0] = int_stack + 85200;
 /*--- compute (d0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+81978,int_stack+93696,int_stack+92796, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+53376,6);
     Libderiv->ABCD[155] = int_stack + 81978;
 /*--- compute (d0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+90276,int_stack+95964,int_stack+89376, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+53376, 1.0, int_stack+57948,6);
     Libderiv->ABCD[143] = int_stack + 90276;
 /*--- compute (d0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+91626,int_stack+3510,int_stack+94956, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+57948, 0.0, zero_stack,6);
     Libderiv->ABCD[142] = int_stack + 91626;
 /*--- compute (d0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+92976,int_stack+98124,int_stack+97224, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+53376, 0.0, zero_stack, 1.0, int_stack+62520,6);
     Libderiv->ABCD[131] = int_stack + 92976;
 /*--- compute (d0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+94326,int_stack+99384,int_stack+1854, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+57948, 1.0, int_stack+62520, 0.0, zero_stack,6);
     Libderiv->ABCD[130] = int_stack + 94326;
 /*--- compute (d0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+95676,int_stack+100644,int_stack+5310, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+62520, 0.0, zero_stack, 0.0, zero_stack,6);
     Libderiv->ABCD[129] = int_stack + 95676;
 /*--- compute (d0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+97026,int_stack+101904,int_stack+6210, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+53376, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+67092,6);
     Libderiv->ABCD[119] = int_stack + 97026;
 /*--- compute (d0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+98376,int_stack+103164,int_stack+7110, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+57948, 0.0, zero_stack, 1.0, int_stack+67092, 0.0, zero_stack,6);
     Libderiv->ABCD[118] = int_stack + 98376;
 /*--- compute (d0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+99726,int_stack+104424,int_stack+8010, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+62520, 1.0, int_stack+67092, 0.0, zero_stack, 0.0, zero_stack,6);
     Libderiv->ABCD[117] = int_stack + 99726;
 /*--- compute (d0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+101076,int_stack+105684,int_stack+8910, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+67092, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
     Libderiv->ABCD[116] = int_stack + 101076;
 /*--- compute (d0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+102426,int_stack+106944,int_stack+9810, 0.0, zero_stack, 1.0, int_stack+53376, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+71664,6);
     Libderiv->ABCD[107] = int_stack + 102426;
 /*--- compute (d0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+103776,int_stack+108204,int_stack+10710, 0.0, zero_stack, 1.0, int_stack+57948, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+71664, 0.0, zero_stack,6);
     Libderiv->ABCD[106] = int_stack + 103776;
 /*--- compute (d0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+105126,int_stack+109464,int_stack+11610, 0.0, zero_stack, 1.0, int_stack+62520, 0.0, zero_stack, 1.0, int_stack+71664, 0.0, zero_stack, 0.0, zero_stack,6);
     Libderiv->ABCD[105] = int_stack + 105126;
 /*--- compute (d0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+106476,int_stack+110724,int_stack+12510, 0.0, zero_stack, 1.0, int_stack+67092, 1.0, int_stack+71664, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
     Libderiv->ABCD[104] = int_stack + 106476;
 /*--- compute (d0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+107826,int_stack+111984,int_stack+13410, 0.0, zero_stack, 2.0, int_stack+71664, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
     Libderiv->ABCD[103] = int_stack + 107826;
 /*--- compute (d0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+109176,int_stack+50928,int_stack+14310, 1.0, int_stack+53376, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+76236,6);
     Libderiv->ABCD[95] = int_stack + 109176;
 /*--- compute (d0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+110526,int_stack+54276,int_stack+15210, 1.0, int_stack+57948, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+76236, 0.0, zero_stack,6);
     Libderiv->ABCD[94] = int_stack + 110526;
 /*--- compute (d0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+111876,int_stack+58848,int_stack+16110, 1.0, int_stack+62520, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+76236, 0.0, zero_stack, 0.0, zero_stack,6);
     Libderiv->ABCD[93] = int_stack + 111876;
 /*--- compute (d0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+49740,int_stack+63420,int_stack+17010, 1.0, int_stack+67092, 0.0, zero_stack, 1.0, int_stack+76236, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
     Libderiv->ABCD[92] = int_stack + 49740;
 /*--- compute (d0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+51090,int_stack+67992,int_stack+17910, 1.0, int_stack+71664, 1.0, int_stack+76236, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
     Libderiv->ABCD[91] = int_stack + 51090;
 /*--- compute (d0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+52440,int_stack+72564,int_stack+18810, 2.0, int_stack+76236, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
     Libderiv->ABCD[90] = int_stack + 52440;
 /*--- compute (d0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+53790,int_stack+21618,int_stack+19710, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+78828,6);
     Libderiv->ABCD[47] = int_stack + 53790;
 /*--- compute (d0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+900,int_stack+23886,int_stack+20610, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+78828, 0.0, zero_stack,6);
     Libderiv->ABCD[46] = int_stack + 900;
 /*--- compute (d0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+2250,int_stack+26154,int_stack+22878, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+78828, 0.0, zero_stack, 0.0, zero_stack,6);
     Libderiv->ABCD[45] = int_stack + 2250;
 /*--- compute (d0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+3600,int_stack+113244,int_stack+25146, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+78828, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
     Libderiv->ABCD[44] = int_stack + 3600;
 /*--- compute (d0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+4950,int_stack+114504,int_stack+0, 0.0, zero_stack, 1.0, int_stack+78828, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
     Libderiv->ABCD[43] = int_stack + 4950;
 /*--- compute (d0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+113226,int_stack+77136,int_stack+27414, 1.0, int_stack+78828, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
     Libderiv->ABCD[42] = int_stack + 113226;
 /*--- compute (d0|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+6300,int_stack+30222,int_stack+28314,6);
     Libderiv->ABCD[38] = int_stack + 6300;
 /*--- compute (d0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+30114,int_stack+115764,int_stack+29214, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+83400,6);
     Libderiv->ABCD[35] = int_stack + 30114;
 /*--- compute (d0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+114576,int_stack+117024,int_stack+48840, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+83400, 0.0, zero_stack,6);
     Libderiv->ABCD[34] = int_stack + 114576;
 /*--- compute (d0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+115926,int_stack+118284,int_stack+31482, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+83400, 0.0, zero_stack, 0.0, zero_stack,6);
     Libderiv->ABCD[33] = int_stack + 115926;
 /*--- compute (d0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+117276,int_stack+119544,int_stack+32382, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+83400, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
     Libderiv->ABCD[32] = int_stack + 117276;
 /*--- compute (d0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+118626,int_stack+120804,int_stack+33282, 0.0, zero_stack, 1.0, int_stack+83400, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
     Libderiv->ABCD[31] = int_stack + 118626;
 /*--- compute (d0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+119976,int_stack+35082,int_stack+34182, 1.0, int_stack+83400, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
     Libderiv->ABCD[30] = int_stack + 119976;
 /*--- compute (d0|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+31464,int_stack+122064,int_stack+79728,6);
     Libderiv->ABCD[26] = int_stack + 31464;
 /*--- compute (d0|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+121326,int_stack+123324,int_stack+36342,6);
     Libderiv->ABCD[25] = int_stack + 121326;
 /*--- compute (d0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+122676,int_stack+124584,int_stack+37242, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+88476,6);
     Libderiv->ABCD[23] = int_stack + 122676;
 /*--- compute (d0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+124026,int_stack+125844,int_stack+38142, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+88476, 0.0, zero_stack,6);
     Libderiv->ABCD[22] = int_stack + 124026;
 /*--- compute (d0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+125376,int_stack+127104,int_stack+39042, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+88476, 0.0, zero_stack, 0.0, zero_stack,6);
     Libderiv->ABCD[21] = int_stack + 125376;
 /*--- compute (d0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+126726,int_stack+128364,int_stack+39942, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+88476, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
     Libderiv->ABCD[20] = int_stack + 126726;
 /*--- compute (d0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+128076,int_stack+129624,int_stack+40842, 0.0, zero_stack, 1.0, int_stack+88476, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
     Libderiv->ABCD[19] = int_stack + 128076;
 /*--- compute (d0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+129426,int_stack+42642,int_stack+41742, 1.0, int_stack+88476, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
     Libderiv->ABCD[18] = int_stack + 129426;
 /*--- compute (d0|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+88116,int_stack+43902,int_stack+87216,6);
     Libderiv->ABCD[14] = int_stack + 88116;
 /*--- compute (d0|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+86550,int_stack+130884,int_stack+84300,6);
     Libderiv->ABCD[13] = int_stack + 86550;
 /*--- compute (d0|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+83328,int_stack+132144,int_stack+45162,6);
     Libderiv->ABCD[12] = int_stack + 83328;

}
