/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include <libint/libint.h>
#include "libderiv.h"
#include <libint/hrr_header.h>

#include "d1hrr_header.h"

extern void d12vrr_order_hpgg(Libderiv_t *, prim_data *);

  /* Computes derivatives of (hp|gg) integrals */

void d12hrr_order_hpgg(Libderiv_t *Libderiv, int num_prim_comb)
{
 prim_data *Data = Libderiv->PrimQuartet;
 double *int_stack = Libderiv->int_stack;
 double *zero_stack = Libderiv->zero_stack;
 int i,j;
 double tmp, *target;

 Libderiv->deriv_classes[6][8][11] = int_stack + 0;
 Libderiv->deriv_classes[6][8][10] = int_stack + 1260;
 Libderiv->deriv_classes[6][8][9] = int_stack + 2520;
 Libderiv->deriv_classes[6][8][8] = int_stack + 3780;
 Libderiv->deriv_classes[6][8][7] = int_stack + 5040;
 Libderiv->dvrr_classes[6][7] = int_stack + 6300;
 Libderiv->deriv_classes[6][8][6] = int_stack + 7308;
 Libderiv->deriv_classes[6][8][2] = int_stack + 8568;
 Libderiv->deriv_classes[6][8][1] = int_stack + 9828;
 Libderiv->dvrr_classes[5][8] = int_stack + 11088;
 Libderiv->deriv_classes[6][8][0] = int_stack + 12033;
 Libderiv->deriv2_classes[5][4][143] = int_stack + 13293;
 Libderiv->deriv2_classes[5][5][143] = int_stack + 13608;
 Libderiv->deriv2_classes[5][6][143] = int_stack + 14049;
 Libderiv->deriv2_classes[5][7][143] = int_stack + 14637;
 Libderiv->deriv2_classes[5][8][143] = int_stack + 15393;
 Libderiv->deriv2_classes[6][4][143] = int_stack + 16338;
 Libderiv->deriv2_classes[6][5][143] = int_stack + 16758;
 Libderiv->deriv2_classes[6][6][143] = int_stack + 17346;
 Libderiv->deriv2_classes[6][7][143] = int_stack + 18130;
 Libderiv->deriv2_classes[6][8][143] = int_stack + 19138;
 Libderiv->deriv2_classes[5][4][131] = int_stack + 20398;
 Libderiv->deriv2_classes[5][5][131] = int_stack + 20713;
 Libderiv->deriv2_classes[5][6][131] = int_stack + 21154;
 Libderiv->deriv2_classes[5][7][131] = int_stack + 21742;
 Libderiv->deriv2_classes[5][8][131] = int_stack + 22498;
 Libderiv->deriv2_classes[6][4][131] = int_stack + 23443;
 Libderiv->deriv2_classes[6][5][131] = int_stack + 23863;
 Libderiv->deriv2_classes[6][6][131] = int_stack + 24451;
 Libderiv->deriv2_classes[6][7][131] = int_stack + 25235;
 Libderiv->deriv2_classes[6][8][131] = int_stack + 26243;
 Libderiv->deriv2_classes[5][4][130] = int_stack + 27503;
 Libderiv->deriv2_classes[5][5][130] = int_stack + 27818;
 Libderiv->deriv2_classes[5][6][130] = int_stack + 28259;
 Libderiv->deriv2_classes[5][7][130] = int_stack + 28847;
 Libderiv->deriv2_classes[5][8][130] = int_stack + 29603;
 Libderiv->deriv2_classes[6][4][130] = int_stack + 30548;
 Libderiv->deriv2_classes[6][5][130] = int_stack + 30968;
 Libderiv->deriv2_classes[6][6][130] = int_stack + 31556;
 Libderiv->deriv2_classes[6][7][130] = int_stack + 32340;
 Libderiv->deriv2_classes[6][8][130] = int_stack + 33348;
 Libderiv->deriv2_classes[5][4][119] = int_stack + 34608;
 Libderiv->deriv2_classes[5][5][119] = int_stack + 34923;
 Libderiv->deriv2_classes[5][6][119] = int_stack + 35364;
 Libderiv->deriv2_classes[5][7][119] = int_stack + 35952;
 Libderiv->deriv2_classes[5][8][119] = int_stack + 36708;
 Libderiv->deriv2_classes[6][4][119] = int_stack + 37653;
 Libderiv->deriv2_classes[6][5][119] = int_stack + 38073;
 Libderiv->deriv2_classes[6][6][119] = int_stack + 38661;
 Libderiv->deriv2_classes[6][7][119] = int_stack + 39445;
 Libderiv->deriv2_classes[6][8][119] = int_stack + 40453;
 Libderiv->deriv2_classes[5][4][118] = int_stack + 41713;
 Libderiv->deriv2_classes[5][5][118] = int_stack + 42028;
 Libderiv->deriv2_classes[5][6][118] = int_stack + 42469;
 Libderiv->deriv2_classes[5][7][118] = int_stack + 43057;
 Libderiv->deriv2_classes[5][8][118] = int_stack + 43813;
 Libderiv->deriv2_classes[6][4][118] = int_stack + 44758;
 Libderiv->deriv2_classes[6][5][118] = int_stack + 45178;
 Libderiv->deriv2_classes[6][6][118] = int_stack + 45766;
 Libderiv->deriv2_classes[6][7][118] = int_stack + 46550;
 Libderiv->deriv2_classes[6][8][118] = int_stack + 47558;
 Libderiv->deriv2_classes[5][4][117] = int_stack + 48818;
 Libderiv->deriv2_classes[5][5][117] = int_stack + 49133;
 Libderiv->deriv2_classes[5][6][117] = int_stack + 49574;
 Libderiv->deriv2_classes[5][7][117] = int_stack + 50162;
 Libderiv->deriv2_classes[5][8][117] = int_stack + 50918;
 Libderiv->deriv2_classes[6][4][117] = int_stack + 51863;
 Libderiv->deriv2_classes[6][5][117] = int_stack + 52283;
 Libderiv->deriv2_classes[6][6][117] = int_stack + 52871;
 Libderiv->deriv2_classes[6][7][117] = int_stack + 53655;
 Libderiv->deriv2_classes[6][8][117] = int_stack + 54663;
 Libderiv->deriv2_classes[5][4][107] = int_stack + 55923;
 Libderiv->deriv2_classes[5][5][107] = int_stack + 56238;
 Libderiv->deriv2_classes[5][6][107] = int_stack + 56679;
 Libderiv->deriv2_classes[5][7][107] = int_stack + 57267;
 Libderiv->deriv2_classes[5][8][107] = int_stack + 58023;
 Libderiv->deriv2_classes[6][4][107] = int_stack + 58968;
 Libderiv->deriv2_classes[6][5][107] = int_stack + 59388;
 Libderiv->deriv2_classes[6][6][107] = int_stack + 59976;
 Libderiv->deriv2_classes[6][7][107] = int_stack + 60760;
 Libderiv->deriv2_classes[6][8][107] = int_stack + 61768;
 Libderiv->deriv2_classes[5][4][106] = int_stack + 63028;
 Libderiv->deriv2_classes[5][5][106] = int_stack + 63343;
 Libderiv->deriv2_classes[5][6][106] = int_stack + 63784;
 Libderiv->deriv2_classes[5][7][106] = int_stack + 64372;
 Libderiv->deriv2_classes[5][8][106] = int_stack + 65128;
 Libderiv->deriv2_classes[6][4][106] = int_stack + 66073;
 Libderiv->deriv2_classes[6][5][106] = int_stack + 66493;
 Libderiv->deriv2_classes[6][6][106] = int_stack + 67081;
 Libderiv->deriv2_classes[6][7][106] = int_stack + 67865;
 Libderiv->deriv2_classes[6][8][106] = int_stack + 68873;
 Libderiv->deriv2_classes[5][4][105] = int_stack + 70133;
 Libderiv->deriv2_classes[5][5][105] = int_stack + 70448;
 Libderiv->deriv2_classes[5][6][105] = int_stack + 70889;
 Libderiv->deriv2_classes[5][7][105] = int_stack + 71477;
 Libderiv->deriv2_classes[5][8][105] = int_stack + 72233;
 Libderiv->deriv2_classes[6][4][105] = int_stack + 73178;
 Libderiv->deriv2_classes[6][5][105] = int_stack + 73598;
 Libderiv->deriv2_classes[6][6][105] = int_stack + 74186;
 Libderiv->deriv2_classes[6][7][105] = int_stack + 74970;
 Libderiv->deriv2_classes[6][8][105] = int_stack + 75978;
 Libderiv->deriv2_classes[5][4][104] = int_stack + 77238;
 Libderiv->deriv2_classes[5][5][104] = int_stack + 77553;
 Libderiv->deriv2_classes[5][6][104] = int_stack + 77994;
 Libderiv->deriv2_classes[5][7][104] = int_stack + 78582;
 Libderiv->deriv2_classes[5][8][104] = int_stack + 79338;
 Libderiv->deriv2_classes[6][4][104] = int_stack + 80283;
 Libderiv->deriv2_classes[6][5][104] = int_stack + 80703;
 Libderiv->deriv2_classes[6][6][104] = int_stack + 81291;
 Libderiv->deriv2_classes[6][7][104] = int_stack + 82075;
 Libderiv->deriv2_classes[6][8][104] = int_stack + 83083;
 Libderiv->deriv2_classes[5][4][95] = int_stack + 84343;
 Libderiv->deriv2_classes[5][5][95] = int_stack + 84658;
 Libderiv->deriv2_classes[5][6][95] = int_stack + 85099;
 Libderiv->deriv2_classes[5][7][95] = int_stack + 85687;
 Libderiv->deriv2_classes[5][8][95] = int_stack + 86443;
 Libderiv->deriv2_classes[6][4][95] = int_stack + 87388;
 Libderiv->deriv2_classes[6][5][95] = int_stack + 87808;
 Libderiv->deriv2_classes[6][6][95] = int_stack + 88396;
 Libderiv->deriv2_classes[6][7][95] = int_stack + 89180;
 Libderiv->deriv2_classes[6][8][95] = int_stack + 90188;
 Libderiv->deriv2_classes[5][4][94] = int_stack + 91448;
 Libderiv->deriv2_classes[5][5][94] = int_stack + 91763;
 Libderiv->deriv2_classes[5][6][94] = int_stack + 92204;
 Libderiv->deriv2_classes[5][7][94] = int_stack + 92792;
 Libderiv->deriv2_classes[5][8][94] = int_stack + 93548;
 Libderiv->deriv2_classes[6][4][94] = int_stack + 94493;
 Libderiv->deriv2_classes[6][5][94] = int_stack + 94913;
 Libderiv->deriv2_classes[6][6][94] = int_stack + 95501;
 Libderiv->deriv2_classes[6][7][94] = int_stack + 96285;
 Libderiv->deriv2_classes[6][8][94] = int_stack + 97293;
 Libderiv->deriv2_classes[5][4][93] = int_stack + 98553;
 Libderiv->deriv2_classes[5][5][93] = int_stack + 98868;
 Libderiv->deriv2_classes[5][6][93] = int_stack + 99309;
 Libderiv->deriv2_classes[5][7][93] = int_stack + 99897;
 Libderiv->deriv2_classes[5][8][93] = int_stack + 100653;
 Libderiv->deriv2_classes[6][4][93] = int_stack + 101598;
 Libderiv->deriv2_classes[6][5][93] = int_stack + 102018;
 Libderiv->deriv2_classes[6][6][93] = int_stack + 102606;
 Libderiv->deriv2_classes[6][7][93] = int_stack + 103390;
 Libderiv->deriv2_classes[6][8][93] = int_stack + 104398;
 Libderiv->deriv2_classes[5][4][92] = int_stack + 105658;
 Libderiv->deriv2_classes[5][5][92] = int_stack + 105973;
 Libderiv->deriv2_classes[5][6][92] = int_stack + 106414;
 Libderiv->deriv2_classes[5][7][92] = int_stack + 107002;
 Libderiv->deriv2_classes[5][8][92] = int_stack + 107758;
 Libderiv->deriv2_classes[6][4][92] = int_stack + 108703;
 Libderiv->deriv2_classes[6][5][92] = int_stack + 109123;
 Libderiv->deriv2_classes[6][6][92] = int_stack + 109711;
 Libderiv->deriv2_classes[6][7][92] = int_stack + 110495;
 Libderiv->deriv2_classes[6][8][92] = int_stack + 111503;
 Libderiv->deriv2_classes[5][4][91] = int_stack + 112763;
 Libderiv->deriv2_classes[5][5][91] = int_stack + 113078;
 Libderiv->deriv2_classes[5][6][91] = int_stack + 113519;
 Libderiv->deriv2_classes[5][7][91] = int_stack + 114107;
 Libderiv->deriv2_classes[5][8][91] = int_stack + 114863;
 Libderiv->deriv2_classes[6][4][91] = int_stack + 115808;
 Libderiv->deriv2_classes[6][5][91] = int_stack + 116228;
 Libderiv->deriv2_classes[6][6][91] = int_stack + 116816;
 Libderiv->deriv2_classes[6][7][91] = int_stack + 117600;
 Libderiv->deriv2_classes[6][8][91] = int_stack + 118608;
 Libderiv->deriv2_classes[5][4][83] = int_stack + 119868;
 Libderiv->deriv2_classes[5][5][83] = int_stack + 120183;
 Libderiv->deriv2_classes[5][6][83] = int_stack + 120624;
 Libderiv->deriv2_classes[5][7][83] = int_stack + 121212;
 Libderiv->deriv2_classes[5][8][83] = int_stack + 121968;
 Libderiv->deriv_classes[6][4][11] = int_stack + 122913;
 Libderiv->deriv2_classes[6][4][83] = int_stack + 123333;
 Libderiv->deriv_classes[6][5][11] = int_stack + 123753;
 Libderiv->deriv2_classes[6][5][83] = int_stack + 124341;
 Libderiv->deriv_classes[6][6][11] = int_stack + 124929;
 Libderiv->deriv2_classes[6][6][83] = int_stack + 125713;
 Libderiv->deriv_classes[6][7][11] = int_stack + 126497;
 Libderiv->deriv2_classes[6][7][83] = int_stack + 127505;
 Libderiv->deriv2_classes[6][8][83] = int_stack + 128513;
 Libderiv->deriv2_classes[5][4][82] = int_stack + 129773;
 Libderiv->deriv2_classes[5][5][82] = int_stack + 130088;
 Libderiv->deriv2_classes[5][6][82] = int_stack + 130529;
 Libderiv->deriv2_classes[5][7][82] = int_stack + 131117;
 Libderiv->deriv2_classes[5][8][82] = int_stack + 131873;
 Libderiv->deriv_classes[6][4][10] = int_stack + 132818;
 Libderiv->deriv2_classes[6][4][82] = int_stack + 133238;
 Libderiv->deriv_classes[6][5][10] = int_stack + 133658;
 Libderiv->deriv2_classes[6][5][82] = int_stack + 134246;
 Libderiv->deriv_classes[6][6][10] = int_stack + 134834;
 Libderiv->deriv2_classes[6][6][82] = int_stack + 135618;
 Libderiv->deriv_classes[6][7][10] = int_stack + 136402;
 Libderiv->deriv2_classes[6][7][82] = int_stack + 137410;
 Libderiv->deriv2_classes[6][8][82] = int_stack + 138418;
 Libderiv->deriv2_classes[5][4][81] = int_stack + 139678;
 Libderiv->deriv2_classes[5][5][81] = int_stack + 139993;
 Libderiv->deriv2_classes[5][6][81] = int_stack + 140434;
 Libderiv->deriv2_classes[5][7][81] = int_stack + 141022;
 Libderiv->deriv2_classes[5][8][81] = int_stack + 141778;
 Libderiv->deriv_classes[6][4][9] = int_stack + 142723;
 Libderiv->deriv2_classes[6][4][81] = int_stack + 143143;
 Libderiv->deriv_classes[6][5][9] = int_stack + 143563;
 Libderiv->deriv2_classes[6][5][81] = int_stack + 144151;
 Libderiv->deriv_classes[6][6][9] = int_stack + 144739;
 Libderiv->deriv2_classes[6][6][81] = int_stack + 145523;
 Libderiv->deriv_classes[6][7][9] = int_stack + 146307;
 Libderiv->deriv2_classes[6][7][81] = int_stack + 147315;
 Libderiv->deriv2_classes[6][8][81] = int_stack + 148323;
 Libderiv->deriv2_classes[5][4][80] = int_stack + 149583;
 Libderiv->deriv2_classes[5][5][80] = int_stack + 149898;
 Libderiv->deriv2_classes[5][6][80] = int_stack + 150339;
 Libderiv->deriv2_classes[5][7][80] = int_stack + 150927;
 Libderiv->deriv2_classes[5][8][80] = int_stack + 151683;
 Libderiv->deriv_classes[6][4][8] = int_stack + 152628;
 Libderiv->deriv2_classes[6][4][80] = int_stack + 153048;
 Libderiv->deriv_classes[6][5][8] = int_stack + 153468;
 Libderiv->deriv2_classes[6][5][80] = int_stack + 154056;
 Libderiv->deriv_classes[6][6][8] = int_stack + 154644;
 Libderiv->deriv2_classes[6][6][80] = int_stack + 155428;
 Libderiv->deriv_classes[6][7][8] = int_stack + 156212;
 Libderiv->deriv2_classes[6][7][80] = int_stack + 157220;
 Libderiv->deriv2_classes[6][8][80] = int_stack + 158228;
 Libderiv->deriv2_classes[5][4][79] = int_stack + 159488;
 Libderiv->deriv2_classes[5][5][79] = int_stack + 159803;
 Libderiv->deriv2_classes[5][6][79] = int_stack + 160244;
 Libderiv->deriv2_classes[5][7][79] = int_stack + 160832;
 Libderiv->deriv2_classes[5][8][79] = int_stack + 161588;
 Libderiv->deriv_classes[6][4][7] = int_stack + 162533;
 Libderiv->deriv2_classes[6][4][79] = int_stack + 162953;
 Libderiv->deriv_classes[6][5][7] = int_stack + 163373;
 Libderiv->deriv2_classes[6][5][79] = int_stack + 163961;
 Libderiv->deriv_classes[6][6][7] = int_stack + 164549;
 Libderiv->deriv2_classes[6][6][79] = int_stack + 165333;
 Libderiv->deriv_classes[6][7][7] = int_stack + 166117;
 Libderiv->deriv2_classes[6][7][79] = int_stack + 167125;
 Libderiv->deriv2_classes[6][8][79] = int_stack + 168133;
 Libderiv->deriv2_classes[5][4][78] = int_stack + 169393;
 Libderiv->deriv2_classes[5][5][78] = int_stack + 169708;
 Libderiv->deriv2_classes[5][6][78] = int_stack + 170149;
 Libderiv->deriv2_classes[5][7][78] = int_stack + 170737;
 Libderiv->deriv2_classes[5][8][78] = int_stack + 171493;
 Libderiv->dvrr_classes[6][4] = int_stack + 172438;
 Libderiv->deriv_classes[6][4][6] = int_stack + 172858;
 Libderiv->deriv2_classes[6][4][78] = int_stack + 173278;
 Libderiv->dvrr_classes[6][5] = int_stack + 173698;
 Libderiv->deriv_classes[6][5][6] = int_stack + 174286;
 Libderiv->deriv2_classes[6][5][78] = int_stack + 174874;
 Libderiv->dvrr_classes[6][6] = int_stack + 175462;
 Libderiv->deriv_classes[6][6][6] = int_stack + 176246;
 Libderiv->deriv2_classes[6][6][78] = int_stack + 177030;
 Libderiv->deriv_classes[6][7][6] = int_stack + 177814;
 Libderiv->deriv2_classes[6][7][78] = int_stack + 178822;
 Libderiv->deriv2_classes[6][8][78] = int_stack + 179830;
 Libderiv->deriv2_classes[5][4][35] = int_stack + 181090;
 Libderiv->deriv2_classes[5][5][35] = int_stack + 181405;
 Libderiv->deriv2_classes[5][6][35] = int_stack + 181846;
 Libderiv->deriv2_classes[5][7][35] = int_stack + 182434;
 Libderiv->deriv2_classes[5][8][35] = int_stack + 183190;
 Libderiv->deriv2_classes[6][4][35] = int_stack + 184135;
 Libderiv->deriv2_classes[6][5][35] = int_stack + 184555;
 Libderiv->deriv2_classes[6][6][35] = int_stack + 185143;
 Libderiv->deriv2_classes[6][7][35] = int_stack + 185927;
 Libderiv->deriv2_classes[6][8][35] = int_stack + 186935;
 Libderiv->deriv2_classes[5][4][34] = int_stack + 188195;
 Libderiv->deriv2_classes[5][5][34] = int_stack + 188510;
 Libderiv->deriv2_classes[5][6][34] = int_stack + 188951;
 Libderiv->deriv2_classes[5][7][34] = int_stack + 189539;
 Libderiv->deriv2_classes[5][8][34] = int_stack + 190295;
 Libderiv->deriv2_classes[6][4][34] = int_stack + 191240;
 Libderiv->deriv2_classes[6][5][34] = int_stack + 191660;
 Libderiv->deriv2_classes[6][6][34] = int_stack + 192248;
 Libderiv->deriv2_classes[6][7][34] = int_stack + 193032;
 Libderiv->deriv2_classes[6][8][34] = int_stack + 194040;
 Libderiv->deriv2_classes[5][4][33] = int_stack + 195300;
 Libderiv->deriv2_classes[5][5][33] = int_stack + 195615;
 Libderiv->deriv2_classes[5][6][33] = int_stack + 196056;
 Libderiv->deriv2_classes[5][7][33] = int_stack + 196644;
 Libderiv->deriv2_classes[5][8][33] = int_stack + 197400;
 Libderiv->deriv2_classes[6][4][33] = int_stack + 198345;
 Libderiv->deriv2_classes[6][5][33] = int_stack + 198765;
 Libderiv->deriv2_classes[6][6][33] = int_stack + 199353;
 Libderiv->deriv2_classes[6][7][33] = int_stack + 200137;
 Libderiv->deriv2_classes[6][8][33] = int_stack + 201145;
 Libderiv->deriv2_classes[5][4][32] = int_stack + 202405;
 Libderiv->deriv2_classes[5][5][32] = int_stack + 202720;
 Libderiv->deriv2_classes[5][6][32] = int_stack + 203161;
 Libderiv->deriv2_classes[5][7][32] = int_stack + 203749;
 Libderiv->deriv2_classes[5][8][32] = int_stack + 204505;
 Libderiv->deriv2_classes[6][4][32] = int_stack + 205450;
 Libderiv->deriv2_classes[6][5][32] = int_stack + 205870;
 Libderiv->deriv2_classes[6][6][32] = int_stack + 206458;
 Libderiv->deriv2_classes[6][7][32] = int_stack + 207242;
 Libderiv->deriv2_classes[6][8][32] = int_stack + 208250;
 Libderiv->deriv2_classes[5][4][31] = int_stack + 209510;
 Libderiv->deriv2_classes[5][5][31] = int_stack + 209825;
 Libderiv->deriv2_classes[5][6][31] = int_stack + 210266;
 Libderiv->deriv2_classes[5][7][31] = int_stack + 210854;
 Libderiv->deriv2_classes[5][8][31] = int_stack + 211610;
 Libderiv->deriv2_classes[6][4][31] = int_stack + 212555;
 Libderiv->deriv2_classes[6][5][31] = int_stack + 212975;
 Libderiv->deriv2_classes[6][6][31] = int_stack + 213563;
 Libderiv->deriv2_classes[6][7][31] = int_stack + 214347;
 Libderiv->deriv2_classes[6][8][31] = int_stack + 215355;
 Libderiv->deriv2_classes[5][4][30] = int_stack + 216615;
 Libderiv->deriv2_classes[5][5][30] = int_stack + 216930;
 Libderiv->deriv2_classes[5][6][30] = int_stack + 217371;
 Libderiv->deriv2_classes[5][7][30] = int_stack + 217959;
 Libderiv->deriv2_classes[5][8][30] = int_stack + 218715;
 Libderiv->deriv_classes[6][4][2] = int_stack + 219660;
 Libderiv->deriv2_classes[6][4][30] = int_stack + 220080;
 Libderiv->deriv_classes[6][5][2] = int_stack + 220500;
 Libderiv->deriv2_classes[6][5][30] = int_stack + 221088;
 Libderiv->deriv_classes[6][6][2] = int_stack + 221676;
 Libderiv->deriv2_classes[6][6][30] = int_stack + 222460;
 Libderiv->deriv_classes[6][7][2] = int_stack + 223244;
 Libderiv->deriv2_classes[6][7][30] = int_stack + 224252;
 Libderiv->deriv2_classes[6][8][30] = int_stack + 225260;
 Libderiv->deriv2_classes[5][4][26] = int_stack + 226520;
 Libderiv->deriv2_classes[5][5][26] = int_stack + 226835;
 Libderiv->deriv2_classes[5][6][26] = int_stack + 227276;
 Libderiv->deriv2_classes[5][7][26] = int_stack + 227864;
 Libderiv->deriv2_classes[5][8][26] = int_stack + 228620;
 Libderiv->deriv2_classes[6][4][26] = int_stack + 229565;
 Libderiv->deriv2_classes[6][5][26] = int_stack + 229985;
 Libderiv->deriv2_classes[6][6][26] = int_stack + 230573;
 Libderiv->deriv2_classes[6][7][26] = int_stack + 231357;
 Libderiv->deriv2_classes[6][8][26] = int_stack + 232365;
 Libderiv->deriv2_classes[5][4][23] = int_stack + 233625;
 Libderiv->deriv2_classes[5][5][23] = int_stack + 233940;
 Libderiv->deriv2_classes[5][6][23] = int_stack + 234381;
 Libderiv->deriv2_classes[5][7][23] = int_stack + 234969;
 Libderiv->deriv2_classes[5][8][23] = int_stack + 235725;
 Libderiv->deriv2_classes[6][4][23] = int_stack + 236670;
 Libderiv->deriv2_classes[6][5][23] = int_stack + 237090;
 Libderiv->deriv2_classes[6][6][23] = int_stack + 237678;
 Libderiv->deriv2_classes[6][7][23] = int_stack + 238462;
 Libderiv->deriv2_classes[6][8][23] = int_stack + 239470;
 Libderiv->deriv2_classes[5][4][22] = int_stack + 240730;
 Libderiv->deriv2_classes[5][5][22] = int_stack + 241045;
 Libderiv->deriv2_classes[5][6][22] = int_stack + 241486;
 Libderiv->deriv2_classes[5][7][22] = int_stack + 242074;
 Libderiv->deriv2_classes[5][8][22] = int_stack + 242830;
 Libderiv->deriv2_classes[6][4][22] = int_stack + 243775;
 Libderiv->deriv2_classes[6][5][22] = int_stack + 244195;
 Libderiv->deriv2_classes[6][6][22] = int_stack + 244783;
 Libderiv->deriv2_classes[6][7][22] = int_stack + 245567;
 Libderiv->deriv2_classes[6][8][22] = int_stack + 246575;
 Libderiv->deriv2_classes[5][4][21] = int_stack + 247835;
 Libderiv->deriv2_classes[5][5][21] = int_stack + 248150;
 Libderiv->deriv2_classes[5][6][21] = int_stack + 248591;
 Libderiv->deriv2_classes[5][7][21] = int_stack + 249179;
 Libderiv->deriv2_classes[5][8][21] = int_stack + 249935;
 Libderiv->deriv2_classes[6][4][21] = int_stack + 250880;
 Libderiv->deriv2_classes[6][5][21] = int_stack + 251300;
 Libderiv->deriv2_classes[6][6][21] = int_stack + 251888;
 Libderiv->deriv2_classes[6][7][21] = int_stack + 252672;
 Libderiv->deriv2_classes[6][8][21] = int_stack + 253680;
 Libderiv->deriv2_classes[5][4][20] = int_stack + 254940;
 Libderiv->deriv2_classes[5][5][20] = int_stack + 255255;
 Libderiv->deriv2_classes[5][6][20] = int_stack + 255696;
 Libderiv->deriv2_classes[5][7][20] = int_stack + 256284;
 Libderiv->deriv2_classes[5][8][20] = int_stack + 257040;
 Libderiv->deriv2_classes[6][4][20] = int_stack + 257985;
 Libderiv->deriv2_classes[6][5][20] = int_stack + 258405;
 Libderiv->deriv2_classes[6][6][20] = int_stack + 258993;
 Libderiv->deriv2_classes[6][7][20] = int_stack + 259777;
 Libderiv->deriv2_classes[6][8][20] = int_stack + 260785;
 Libderiv->deriv2_classes[5][4][19] = int_stack + 262045;
 Libderiv->deriv2_classes[5][5][19] = int_stack + 262360;
 Libderiv->deriv2_classes[5][6][19] = int_stack + 262801;
 Libderiv->deriv2_classes[5][7][19] = int_stack + 263389;
 Libderiv->deriv2_classes[5][8][19] = int_stack + 264145;
 Libderiv->deriv2_classes[6][4][19] = int_stack + 265090;
 Libderiv->deriv2_classes[6][5][19] = int_stack + 265510;
 Libderiv->deriv2_classes[6][6][19] = int_stack + 266098;
 Libderiv->deriv2_classes[6][7][19] = int_stack + 266882;
 Libderiv->deriv2_classes[6][8][19] = int_stack + 267890;
 Libderiv->deriv2_classes[5][4][18] = int_stack + 269150;
 Libderiv->deriv2_classes[5][5][18] = int_stack + 269465;
 Libderiv->deriv2_classes[5][6][18] = int_stack + 269906;
 Libderiv->deriv2_classes[5][7][18] = int_stack + 270494;
 Libderiv->deriv2_classes[5][8][18] = int_stack + 271250;
 Libderiv->deriv_classes[6][4][1] = int_stack + 272195;
 Libderiv->deriv2_classes[6][4][18] = int_stack + 272615;
 Libderiv->deriv_classes[6][5][1] = int_stack + 273035;
 Libderiv->deriv2_classes[6][5][18] = int_stack + 273623;
 Libderiv->deriv_classes[6][6][1] = int_stack + 274211;
 Libderiv->deriv2_classes[6][6][18] = int_stack + 274995;
 Libderiv->deriv_classes[6][7][1] = int_stack + 275779;
 Libderiv->deriv2_classes[6][7][18] = int_stack + 276787;
 Libderiv->deriv2_classes[6][8][18] = int_stack + 277795;
 Libderiv->deriv2_classes[5][4][14] = int_stack + 279055;
 Libderiv->deriv2_classes[5][5][14] = int_stack + 279370;
 Libderiv->deriv2_classes[5][6][14] = int_stack + 279811;
 Libderiv->deriv2_classes[5][7][14] = int_stack + 280399;
 Libderiv->deriv2_classes[5][8][14] = int_stack + 281155;
 Libderiv->deriv2_classes[6][4][14] = int_stack + 282100;
 Libderiv->deriv2_classes[6][5][14] = int_stack + 282520;
 Libderiv->deriv2_classes[6][6][14] = int_stack + 283108;
 Libderiv->deriv2_classes[6][7][14] = int_stack + 283892;
 Libderiv->deriv2_classes[6][8][14] = int_stack + 284900;
 Libderiv->deriv2_classes[5][4][13] = int_stack + 286160;
 Libderiv->deriv2_classes[5][5][13] = int_stack + 286475;
 Libderiv->deriv2_classes[5][6][13] = int_stack + 286916;
 Libderiv->deriv2_classes[5][7][13] = int_stack + 287504;
 Libderiv->deriv2_classes[5][8][13] = int_stack + 288260;
 Libderiv->deriv2_classes[6][4][13] = int_stack + 289205;
 Libderiv->deriv2_classes[6][5][13] = int_stack + 289625;
 Libderiv->deriv2_classes[6][6][13] = int_stack + 290213;
 Libderiv->deriv2_classes[6][7][13] = int_stack + 290997;
 Libderiv->deriv2_classes[6][8][13] = int_stack + 292005;
 Libderiv->deriv_classes[5][4][11] = int_stack + 293265;
 Libderiv->deriv_classes[5][5][11] = int_stack + 293580;
 Libderiv->deriv_classes[5][6][11] = int_stack + 294021;
 Libderiv->deriv_classes[5][7][11] = int_stack + 294609;
 Libderiv->deriv_classes[5][8][11] = int_stack + 295365;
 Libderiv->deriv2_classes[5][4][11] = int_stack + 296310;
 Libderiv->deriv2_classes[5][5][11] = int_stack + 296625;
 Libderiv->deriv2_classes[5][6][11] = int_stack + 297066;
 Libderiv->deriv2_classes[5][7][11] = int_stack + 297654;
 Libderiv->deriv2_classes[5][8][11] = int_stack + 298410;
 Libderiv->deriv2_classes[6][4][11] = int_stack + 299355;
 Libderiv->deriv2_classes[6][5][11] = int_stack + 299775;
 Libderiv->deriv2_classes[6][6][11] = int_stack + 300363;
 Libderiv->deriv2_classes[6][7][11] = int_stack + 301147;
 Libderiv->deriv2_classes[6][8][11] = int_stack + 302155;
 Libderiv->deriv_classes[5][4][10] = int_stack + 303415;
 Libderiv->deriv_classes[5][5][10] = int_stack + 303730;
 Libderiv->deriv_classes[5][6][10] = int_stack + 304171;
 Libderiv->deriv_classes[5][7][10] = int_stack + 304759;
 Libderiv->deriv_classes[5][8][10] = int_stack + 305515;
 Libderiv->deriv2_classes[5][4][10] = int_stack + 306460;
 Libderiv->deriv2_classes[5][5][10] = int_stack + 306775;
 Libderiv->deriv2_classes[5][6][10] = int_stack + 307216;
 Libderiv->deriv2_classes[5][7][10] = int_stack + 307804;
 Libderiv->deriv2_classes[5][8][10] = int_stack + 308560;
 Libderiv->deriv2_classes[6][4][10] = int_stack + 309505;
 Libderiv->deriv2_classes[6][5][10] = int_stack + 309925;
 Libderiv->deriv2_classes[6][6][10] = int_stack + 310513;
 Libderiv->deriv2_classes[6][7][10] = int_stack + 311297;
 Libderiv->deriv2_classes[6][8][10] = int_stack + 312305;
 Libderiv->deriv_classes[5][4][9] = int_stack + 313565;
 Libderiv->deriv_classes[5][5][9] = int_stack + 313880;
 Libderiv->deriv_classes[5][6][9] = int_stack + 314321;
 Libderiv->deriv_classes[5][7][9] = int_stack + 314909;
 Libderiv->deriv_classes[5][8][9] = int_stack + 315665;
 Libderiv->deriv2_classes[5][4][9] = int_stack + 316610;
 Libderiv->deriv2_classes[5][5][9] = int_stack + 316925;
 Libderiv->deriv2_classes[5][6][9] = int_stack + 317366;
 Libderiv->deriv2_classes[5][7][9] = int_stack + 317954;
 Libderiv->deriv2_classes[5][8][9] = int_stack + 318710;
 Libderiv->deriv2_classes[6][4][9] = int_stack + 319655;
 Libderiv->deriv2_classes[6][5][9] = int_stack + 320075;
 Libderiv->deriv2_classes[6][6][9] = int_stack + 320663;
 Libderiv->deriv2_classes[6][7][9] = int_stack + 321447;
 Libderiv->deriv2_classes[6][8][9] = int_stack + 322455;
 Libderiv->deriv_classes[5][4][8] = int_stack + 323715;
 Libderiv->deriv_classes[5][5][8] = int_stack + 324030;
 Libderiv->deriv_classes[5][6][8] = int_stack + 324471;
 Libderiv->deriv_classes[5][7][8] = int_stack + 325059;
 Libderiv->deriv_classes[5][8][8] = int_stack + 325815;
 Libderiv->deriv2_classes[5][4][8] = int_stack + 326760;
 Libderiv->deriv2_classes[5][5][8] = int_stack + 327075;
 Libderiv->deriv2_classes[5][6][8] = int_stack + 327516;
 Libderiv->deriv2_classes[5][7][8] = int_stack + 328104;
 Libderiv->deriv2_classes[5][8][8] = int_stack + 328860;
 Libderiv->deriv2_classes[6][4][8] = int_stack + 329805;
 Libderiv->deriv2_classes[6][5][8] = int_stack + 330225;
 Libderiv->deriv2_classes[6][6][8] = int_stack + 330813;
 Libderiv->deriv2_classes[6][7][8] = int_stack + 331597;
 Libderiv->deriv2_classes[6][8][8] = int_stack + 332605;
 Libderiv->deriv_classes[5][4][7] = int_stack + 333865;
 Libderiv->deriv_classes[5][5][7] = int_stack + 334180;
 Libderiv->deriv_classes[5][6][7] = int_stack + 334621;
 Libderiv->deriv_classes[5][7][7] = int_stack + 335209;
 Libderiv->deriv_classes[5][8][7] = int_stack + 335965;
 Libderiv->deriv2_classes[5][4][7] = int_stack + 336910;
 Libderiv->deriv2_classes[5][5][7] = int_stack + 337225;
 Libderiv->deriv2_classes[5][6][7] = int_stack + 337666;
 Libderiv->deriv2_classes[5][7][7] = int_stack + 338254;
 Libderiv->deriv2_classes[5][8][7] = int_stack + 339010;
 Libderiv->deriv2_classes[6][4][7] = int_stack + 339955;
 Libderiv->deriv2_classes[6][5][7] = int_stack + 340375;
 Libderiv->deriv2_classes[6][6][7] = int_stack + 340963;
 Libderiv->deriv2_classes[6][7][7] = int_stack + 341747;
 Libderiv->deriv2_classes[6][8][7] = int_stack + 342755;
 Libderiv->dvrr_classes[5][4] = int_stack + 344015;
 Libderiv->deriv_classes[5][4][6] = int_stack + 344330;
 Libderiv->dvrr_classes[5][5] = int_stack + 344645;
 Libderiv->deriv_classes[5][5][6] = int_stack + 345086;
 Libderiv->dvrr_classes[5][6] = int_stack + 345527;
 Libderiv->deriv_classes[5][6][6] = int_stack + 346115;
 Libderiv->dvrr_classes[5][7] = int_stack + 346703;
 Libderiv->deriv_classes[5][7][6] = int_stack + 347459;
 Libderiv->deriv_classes[5][8][6] = int_stack + 348215;
 Libderiv->deriv2_classes[5][4][6] = int_stack + 349160;
 Libderiv->deriv2_classes[5][5][6] = int_stack + 349475;
 Libderiv->deriv2_classes[5][6][6] = int_stack + 349916;
 Libderiv->deriv2_classes[5][7][6] = int_stack + 350504;
 Libderiv->deriv2_classes[5][8][6] = int_stack + 351260;
 Libderiv->deriv_classes[6][4][0] = int_stack + 352205;
 Libderiv->deriv2_classes[6][4][6] = int_stack + 352625;
 Libderiv->deriv_classes[6][5][0] = int_stack + 353045;
 Libderiv->deriv2_classes[6][5][6] = int_stack + 353633;
 Libderiv->deriv_classes[6][6][0] = int_stack + 354221;
 Libderiv->deriv2_classes[6][6][6] = int_stack + 355005;
 Libderiv->deriv_classes[6][7][0] = int_stack + 355789;
 Libderiv->deriv2_classes[6][7][6] = int_stack + 356797;
 Libderiv->deriv2_classes[6][8][6] = int_stack + 357805;
 Libderiv->deriv_classes[5][4][2] = int_stack + 359065;
 Libderiv->deriv_classes[5][5][2] = int_stack + 359380;
 Libderiv->deriv_classes[5][6][2] = int_stack + 359821;
 Libderiv->deriv_classes[5][7][2] = int_stack + 360409;
 Libderiv->deriv_classes[5][8][2] = int_stack + 361165;
 Libderiv->deriv2_classes[5][4][2] = int_stack + 362110;
 Libderiv->deriv2_classes[5][5][2] = int_stack + 362425;
 Libderiv->deriv2_classes[5][6][2] = int_stack + 362866;
 Libderiv->deriv2_classes[5][7][2] = int_stack + 363454;
 Libderiv->deriv2_classes[5][8][2] = int_stack + 364210;
 Libderiv->deriv2_classes[6][4][2] = int_stack + 365155;
 Libderiv->deriv2_classes[6][5][2] = int_stack + 365575;
 Libderiv->deriv2_classes[6][6][2] = int_stack + 366163;
 Libderiv->deriv2_classes[6][7][2] = int_stack + 366947;
 Libderiv->deriv2_classes[6][8][2] = int_stack + 367955;
 Libderiv->deriv_classes[5][4][1] = int_stack + 369215;
 Libderiv->deriv_classes[5][5][1] = int_stack + 369530;
 Libderiv->deriv_classes[5][6][1] = int_stack + 369971;
 Libderiv->deriv_classes[5][7][1] = int_stack + 370559;
 Libderiv->deriv_classes[5][8][1] = int_stack + 371315;
 Libderiv->deriv2_classes[5][4][1] = int_stack + 372260;
 Libderiv->deriv2_classes[5][5][1] = int_stack + 372575;
 Libderiv->deriv2_classes[5][6][1] = int_stack + 373016;
 Libderiv->deriv2_classes[5][7][1] = int_stack + 373604;
 Libderiv->deriv2_classes[5][8][1] = int_stack + 374360;
 Libderiv->deriv2_classes[6][4][1] = int_stack + 375305;
 Libderiv->deriv2_classes[6][5][1] = int_stack + 375725;
 Libderiv->deriv2_classes[6][6][1] = int_stack + 376313;
 Libderiv->deriv2_classes[6][7][1] = int_stack + 377097;
 Libderiv->deriv2_classes[6][8][1] = int_stack + 378105;
 Libderiv->deriv_classes[5][4][0] = int_stack + 379365;
 Libderiv->deriv_classes[5][5][0] = int_stack + 379680;
 Libderiv->deriv_classes[5][6][0] = int_stack + 380121;
 Libderiv->deriv_classes[5][7][0] = int_stack + 380709;
 Libderiv->deriv_classes[5][8][0] = int_stack + 381465;
 Libderiv->deriv2_classes[5][4][0] = int_stack + 382410;
 Libderiv->deriv2_classes[5][5][0] = int_stack + 382725;
 Libderiv->deriv2_classes[5][6][0] = int_stack + 383166;
 Libderiv->deriv2_classes[5][7][0] = int_stack + 383754;
 Libderiv->deriv2_classes[5][8][0] = int_stack + 384510;
 Libderiv->deriv2_classes[6][4][0] = int_stack + 385455;
 Libderiv->deriv2_classes[6][5][0] = int_stack + 385875;
 Libderiv->deriv2_classes[6][6][0] = int_stack + 386463;
 Libderiv->deriv2_classes[6][7][0] = int_stack + 387247;
 Libderiv->deriv2_classes[6][8][0] = int_stack + 388255;
 memset(int_stack,0,3116120);

 Libderiv->dvrr_stack = int_stack + 924154;
 for(i=0;i<num_prim_comb;i++) {
   d12vrr_order_hpgg(Libderiv, Data);
   Data++;
 }

 /*--- compute (h0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+389515,int_stack+344645,int_stack+344015,21);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+390460,int_stack+345527,int_stack+344645,21);
 /*--- compute (h0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+391783,int_stack+390460,int_stack+389515,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+393673,int_stack+346703,int_stack+345527,21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+395437,int_stack+393673,int_stack+390460,21);
 /*--- compute (h0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+398083,int_stack+395437,int_stack+391783,21);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+401233,int_stack+293580,int_stack+293265, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+344015,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+402178,int_stack+294021,int_stack+293580, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+344645,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+403501,int_stack+402178,int_stack+401233, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+389515,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+405391,int_stack+294609,int_stack+294021, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+345527,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+407155,int_stack+405391,int_stack+402178, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+390460,21);
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+409801,int_stack+407155,int_stack+403501, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+391783,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+412951,int_stack+295365,int_stack+294609, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+346703,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+415219,int_stack+412951,int_stack+405391, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+393673,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+418747,int_stack+415219,int_stack+407155, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+395437,21);
 /*--- compute (h0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+412951,int_stack+418747,int_stack+409801, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+398083,21);
 /*--- compute (i0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+417676,int_stack+173698,int_stack+172438,28);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+418936,int_stack+175462,int_stack+173698,28);
 /*--- compute (i0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+420700,int_stack+418936,int_stack+417676,28);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+423220,int_stack+6300,int_stack+175462,28);
 /*--- compute (i0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+425572,int_stack+423220,int_stack+418936,28);
 /*--- compute (i0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+429100,int_stack+425572,int_stack+420700,28);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+433300,int_stack+123753,int_stack+122913, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+172438,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+434560,int_stack+124929,int_stack+123753, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+173698,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+436324,int_stack+434560,int_stack+433300, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+417676,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+438844,int_stack+126497,int_stack+124929, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+175462,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+441196,int_stack+438844,int_stack+434560, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+418936,28);
 /*--- compute (i0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+444724,int_stack+441196,int_stack+436324, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+420700,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+448924,int_stack+0,int_stack+126497, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6300,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+451948,int_stack+448924,int_stack+438844, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+423220,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+456652,int_stack+451948,int_stack+441196, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+425572,28);
 /*--- compute (i0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+448924,int_stack+456652,int_stack+444724, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+429100,28);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+295365,int_stack+303730,int_stack+303415, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+344015, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+455224,int_stack+304171,int_stack+303730, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+344645, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+456547,int_stack+455224,int_stack+295365, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+389515, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+458437,int_stack+304759,int_stack+304171, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+345527, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+460201,int_stack+458437,int_stack+455224, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+390460, 0.0, zero_stack,21);
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+462847,int_stack+460201,int_stack+456547, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+391783, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+465997,int_stack+305515,int_stack+304759, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+346703, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+468265,int_stack+465997,int_stack+458437, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+393673, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+471793,int_stack+468265,int_stack+460201, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+395437, 0.0, zero_stack,21);
 /*--- compute (h0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+465997,int_stack+471793,int_stack+462847, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+398083, 0.0, zero_stack,21);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+0,int_stack+133658,int_stack+132818, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+172438, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+470722,int_stack+134834,int_stack+133658, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+173698, 0.0, zero_stack,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+472486,int_stack+470722,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+417676, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+475006,int_stack+136402,int_stack+134834, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+175462, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+477358,int_stack+475006,int_stack+470722, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+418936, 0.0, zero_stack,28);
 /*--- compute (i0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+480886,int_stack+477358,int_stack+472486, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+420700, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+485086,int_stack+1260,int_stack+136402, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6300, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+488110,int_stack+485086,int_stack+475006, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+423220, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+492814,int_stack+488110,int_stack+477358, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+425572, 0.0, zero_stack,28);
 /*--- compute (i0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+485086,int_stack+492814,int_stack+480886, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+429100, 0.0, zero_stack,28);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+305515,int_stack+313880,int_stack+313565, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+344015, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+491386,int_stack+314321,int_stack+313880, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+344645, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+492709,int_stack+491386,int_stack+305515, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+389515, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+494599,int_stack+314909,int_stack+314321, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+345527, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+496363,int_stack+494599,int_stack+491386, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+390460, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+499009,int_stack+496363,int_stack+492709, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+391783, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+502159,int_stack+315665,int_stack+314909, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+346703, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+504427,int_stack+502159,int_stack+494599, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+393673, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+507955,int_stack+504427,int_stack+496363, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+395437, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+502159,int_stack+507955,int_stack+499009, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+398083, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+1260,int_stack+143563,int_stack+142723, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+172438, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+506884,int_stack+144739,int_stack+143563, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+173698, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+508648,int_stack+506884,int_stack+1260, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+417676, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+511168,int_stack+146307,int_stack+144739, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+175462, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+513520,int_stack+511168,int_stack+506884, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+418936, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+517048,int_stack+513520,int_stack+508648, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+420700, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+521248,int_stack+2520,int_stack+146307, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6300, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+524272,int_stack+521248,int_stack+511168, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+423220, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+528976,int_stack+524272,int_stack+513520, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+425572, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+521248,int_stack+528976,int_stack+517048, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+429100, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+315665,int_stack+324030,int_stack+323715, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+344015, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+527548,int_stack+324471,int_stack+324030, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+344645, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+528871,int_stack+527548,int_stack+315665, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+389515, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+530761,int_stack+325059,int_stack+324471, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+345527, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+532525,int_stack+530761,int_stack+527548, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+390460, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+535171,int_stack+532525,int_stack+528871, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+391783, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+538321,int_stack+325815,int_stack+325059, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+346703, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+540589,int_stack+538321,int_stack+530761, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+393673, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+544117,int_stack+540589,int_stack+532525, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+395437, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+538321,int_stack+544117,int_stack+535171, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+398083, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+2520,int_stack+153468,int_stack+152628, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+172438, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+543046,int_stack+154644,int_stack+153468, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+173698, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+544810,int_stack+543046,int_stack+2520, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+417676, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+547330,int_stack+156212,int_stack+154644, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+175462, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+549682,int_stack+547330,int_stack+543046, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+418936, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+553210,int_stack+549682,int_stack+544810, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+420700, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+557410,int_stack+3780,int_stack+156212, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6300, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+560434,int_stack+557410,int_stack+547330, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+423220, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+565138,int_stack+560434,int_stack+549682, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+425572, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+557410,int_stack+565138,int_stack+553210, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+429100, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+325815,int_stack+334180,int_stack+333865, 0.0, zero_stack, 1.0, int_stack+344015, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+563710,int_stack+334621,int_stack+334180, 0.0, zero_stack, 1.0, int_stack+344645, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+565033,int_stack+563710,int_stack+325815, 0.0, zero_stack, 1.0, int_stack+389515, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+566923,int_stack+335209,int_stack+334621, 0.0, zero_stack, 1.0, int_stack+345527, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+568687,int_stack+566923,int_stack+563710, 0.0, zero_stack, 1.0, int_stack+390460, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+571333,int_stack+568687,int_stack+565033, 0.0, zero_stack, 1.0, int_stack+391783, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+574483,int_stack+335965,int_stack+335209, 0.0, zero_stack, 1.0, int_stack+346703, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+576751,int_stack+574483,int_stack+566923, 0.0, zero_stack, 1.0, int_stack+393673, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+580279,int_stack+576751,int_stack+568687, 0.0, zero_stack, 1.0, int_stack+395437, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+574483,int_stack+580279,int_stack+571333, 0.0, zero_stack, 1.0, int_stack+398083, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+3780,int_stack+163373,int_stack+162533, 0.0, zero_stack, 1.0, int_stack+172438, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+579208,int_stack+164549,int_stack+163373, 0.0, zero_stack, 1.0, int_stack+173698, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+580972,int_stack+579208,int_stack+3780, 0.0, zero_stack, 1.0, int_stack+417676, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+583492,int_stack+166117,int_stack+164549, 0.0, zero_stack, 1.0, int_stack+175462, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+585844,int_stack+583492,int_stack+579208, 0.0, zero_stack, 1.0, int_stack+418936, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+589372,int_stack+585844,int_stack+580972, 0.0, zero_stack, 1.0, int_stack+420700, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+593572,int_stack+5040,int_stack+166117, 0.0, zero_stack, 1.0, int_stack+6300, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+596596,int_stack+593572,int_stack+583492, 0.0, zero_stack, 1.0, int_stack+423220, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+601300,int_stack+596596,int_stack+585844, 0.0, zero_stack, 1.0, int_stack+425572, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+593572,int_stack+601300,int_stack+589372, 0.0, zero_stack, 1.0, int_stack+429100, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+335965,int_stack+345086,int_stack+344330, 1.0, int_stack+344015, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+599872,int_stack+346115,int_stack+345086, 1.0, int_stack+344645, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+601195,int_stack+599872,int_stack+335965, 1.0, int_stack+389515, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+603085,int_stack+347459,int_stack+346115, 1.0, int_stack+345527, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+604849,int_stack+603085,int_stack+599872, 1.0, int_stack+390460, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+607495,int_stack+604849,int_stack+601195, 1.0, int_stack+391783, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+389515,int_stack+348215,int_stack+347459, 1.0, int_stack+346703, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+610645,int_stack+389515,int_stack+603085, 1.0, int_stack+393673, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+614173,int_stack+610645,int_stack+604849, 1.0, int_stack+395437, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+618583,int_stack+614173,int_stack+607495, 1.0, int_stack+398083, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+5040,int_stack+174286,int_stack+172858, 1.0, int_stack+172438, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+610645,int_stack+176246,int_stack+174286, 1.0, int_stack+173698, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+612409,int_stack+610645,int_stack+5040, 1.0, int_stack+417676, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+614929,int_stack+177814,int_stack+176246, 1.0, int_stack+175462, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+389515,int_stack+614929,int_stack+610645, 1.0, int_stack+418936, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+623308,int_stack+389515,int_stack+612409, 1.0, int_stack+420700, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+417676,int_stack+7308,int_stack+177814, 1.0, int_stack+6300, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+627508,int_stack+417676,int_stack+614929, 1.0, int_stack+423220, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+417676,int_stack+627508,int_stack+389515, 1.0, int_stack+425572, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+627508,int_stack+417676,int_stack+623308, 1.0, int_stack+429100, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+6300,int_stack+11088,int_stack+346703,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+417676,int_stack+6300,int_stack+393673,21);
 /*--- compute (h0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+421204,int_stack+417676,int_stack+395437,21);
 /*--- compute (h0|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+425614,int_stack+421204,int_stack+398083,21);
 /*--- compute (h0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+11088,int_stack+359380,int_stack+359065,21);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+417676,int_stack+359821,int_stack+359380,21);
 /*--- compute (h0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+418999,int_stack+417676,int_stack+11088,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+420889,int_stack+360409,int_stack+359821,21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+422653,int_stack+420889,int_stack+417676,21);
 /*--- compute (h0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+393043,int_stack+422653,int_stack+418999,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+6300,int_stack+361165,int_stack+360409,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+396193,int_stack+6300,int_stack+420889,21);
 /*--- compute (h0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+633808,int_stack+396193,int_stack+422653,21);
 /*--- compute (h0|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+396193,int_stack+633808,int_stack+393043,21);
 /*--- compute (i0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+633808,int_stack+220500,int_stack+219660,28);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+635068,int_stack+221676,int_stack+220500,28);
 /*--- compute (i0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+430339,int_stack+635068,int_stack+633808,28);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+636832,int_stack+223244,int_stack+221676,28);
 /*--- compute (i0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+639184,int_stack+636832,int_stack+635068,28);
 /*--- compute (i0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+642712,int_stack+639184,int_stack+430339,28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+646912,int_stack+8568,int_stack+223244,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+649936,int_stack+646912,int_stack+636832,28);
 /*--- compute (i0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+654640,int_stack+649936,int_stack+639184,28);
 /*--- compute (i0|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+646912,int_stack+654640,int_stack+642712,28);
 /*--- compute (h0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+361165,int_stack+369530,int_stack+369215,21);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+653212,int_stack+369971,int_stack+369530,21);
 /*--- compute (h0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+654535,int_stack+653212,int_stack+361165,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+656425,int_stack+370559,int_stack+369971,21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+658189,int_stack+656425,int_stack+653212,21);
 /*--- compute (h0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+6300,int_stack+658189,int_stack+654535,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+660835,int_stack+371315,int_stack+370559,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+663103,int_stack+660835,int_stack+656425,21);
 /*--- compute (h0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+666631,int_stack+663103,int_stack+658189,21);
 /*--- compute (h0|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+660835,int_stack+666631,int_stack+6300,21);
 /*--- compute (i0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+665560,int_stack+273035,int_stack+272195,28);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+666820,int_stack+274211,int_stack+273035,28);
 /*--- compute (i0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+668584,int_stack+666820,int_stack+665560,28);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+671104,int_stack+275779,int_stack+274211,28);
 /*--- compute (i0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+673456,int_stack+671104,int_stack+666820,28);
 /*--- compute (i0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+676984,int_stack+673456,int_stack+668584,28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+681184,int_stack+9828,int_stack+275779,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+684208,int_stack+681184,int_stack+671104,28);
 /*--- compute (i0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+688912,int_stack+684208,int_stack+673456,28);
 /*--- compute (i0|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+681184,int_stack+688912,int_stack+676984,28);
 /*--- compute (h0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+371315,int_stack+379680,int_stack+379365,21);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+687484,int_stack+380121,int_stack+379680,21);
 /*--- compute (h0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+688807,int_stack+687484,int_stack+371315,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+690697,int_stack+380709,int_stack+380121,21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+692461,int_stack+690697,int_stack+687484,21);
 /*--- compute (h0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+695107,int_stack+692461,int_stack+688807,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+698257,int_stack+381465,int_stack+380709,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+700525,int_stack+698257,int_stack+690697,21);
 /*--- compute (h0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+704053,int_stack+700525,int_stack+692461,21);
 /*--- compute (h0|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+698257,int_stack+704053,int_stack+695107,21);
 /*--- compute (i0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+702982,int_stack+353045,int_stack+352205,28);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+704242,int_stack+354221,int_stack+353045,28);
 /*--- compute (i0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+706006,int_stack+704242,int_stack+702982,28);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+708526,int_stack+355789,int_stack+354221,28);
 /*--- compute (i0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+710878,int_stack+708526,int_stack+704242,28);
 /*--- compute (i0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+714406,int_stack+710878,int_stack+706006,28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+718606,int_stack+12033,int_stack+355789,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+721630,int_stack+718606,int_stack+708526,28);
 /*--- compute (i0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+726334,int_stack+721630,int_stack+710878,28);
 /*--- compute (i0|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+718606,int_stack+726334,int_stack+714406,28);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+381465,int_stack+13608,int_stack+13293, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+293265,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+724906,int_stack+14049,int_stack+13608, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+293580,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+726229,int_stack+724906,int_stack+381465, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+401233,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+728119,int_stack+14637,int_stack+14049, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+294021,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+729883,int_stack+728119,int_stack+724906, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+402178,21);
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+732529,int_stack+729883,int_stack+726229, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+403501,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+724906,int_stack+15393,int_stack+14637, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+294609,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+12033,int_stack+724906,int_stack+728119, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+405391,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+724906,int_stack+12033,int_stack+729883, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+407155,21);
 /*--- compute (h0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+735679,int_stack+724906,int_stack+732529, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+409801,21);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+724906,int_stack+16758,int_stack+16338, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+122913,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+726166,int_stack+17346,int_stack+16758, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+123753,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+727930,int_stack+726166,int_stack+724906, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+433300,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+730450,int_stack+18130,int_stack+17346, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+124929,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+12033,int_stack+730450,int_stack+726166, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+434560,28);
 /*--- compute (i0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+740404,int_stack+12033,int_stack+727930, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+436324,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+724906,int_stack+19138,int_stack+18130, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+126497,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+15561,int_stack+724906,int_stack+730450, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+438844,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+724906,int_stack+15561,int_stack+12033, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+441196,28);
 /*--- compute (i0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+12033,int_stack+724906,int_stack+740404, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+444724,28);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+381465,int_stack+20713,int_stack+20398, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+293265, 1.0, int_stack+303415,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+740404,int_stack+21154,int_stack+20713, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+293580, 1.0, int_stack+303730,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+741727,int_stack+740404,int_stack+381465, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+401233, 1.0, int_stack+295365,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+724906,int_stack+21742,int_stack+21154, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+294021, 1.0, int_stack+304171,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+726670,int_stack+724906,int_stack+740404, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+402178, 1.0, int_stack+455224,21);
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+729316,int_stack+726670,int_stack+741727, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+403501, 1.0, int_stack+456547,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+740404,int_stack+22498,int_stack+21742, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+294609, 1.0, int_stack+304759,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+18333,int_stack+740404,int_stack+724906, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+405391, 1.0, int_stack+458437,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+740404,int_stack+18333,int_stack+726670, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+407155, 1.0, int_stack+460201,21);
 /*--- compute (h0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+18333,int_stack+740404,int_stack+729316, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+409801, 1.0, int_stack+462847,21);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+740404,int_stack+23863,int_stack+23443, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+122913, 1.0, int_stack+132818,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+741664,int_stack+24451,int_stack+23863, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+123753, 1.0, int_stack+133658,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+724906,int_stack+741664,int_stack+740404, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+433300, 1.0, int_stack+0,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+727426,int_stack+25235,int_stack+24451, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+124929, 1.0, int_stack+134834,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+729778,int_stack+727426,int_stack+741664, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+434560, 1.0, int_stack+470722,28);
 /*--- compute (i0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+740404,int_stack+729778,int_stack+724906, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+436324, 1.0, int_stack+472486,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+744604,int_stack+26243,int_stack+25235, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+126497, 1.0, int_stack+136402,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+747628,int_stack+744604,int_stack+727426, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+438844, 1.0, int_stack+475006,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+752332,int_stack+747628,int_stack+729778, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+441196, 1.0, int_stack+477358,28);
 /*--- compute (i0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+744604,int_stack+752332,int_stack+740404, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+444724, 1.0, int_stack+480886,28);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+381465,int_stack+27818,int_stack+27503, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+303415, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+740404,int_stack+28259,int_stack+27818, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+303730, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+741727,int_stack+740404,int_stack+381465, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+295365, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+750904,int_stack+28847,int_stack+28259, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+304171, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+752668,int_stack+750904,int_stack+740404, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+455224, 0.0, zero_stack,21);
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+755314,int_stack+752668,int_stack+741727, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+456547, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+740404,int_stack+29603,int_stack+28847, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+304759, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+724906,int_stack+740404,int_stack+750904, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+458437, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+728434,int_stack+724906,int_stack+752668, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+460201, 0.0, zero_stack,21);
 /*--- compute (h0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+23058,int_stack+728434,int_stack+755314, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+462847, 0.0, zero_stack,21);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+724906,int_stack+30968,int_stack+30548, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+132818, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+726166,int_stack+31556,int_stack+30968, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+133658, 0.0, zero_stack,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+727930,int_stack+726166,int_stack+724906, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+0, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+730450,int_stack+32340,int_stack+31556, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+134834, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+750904,int_stack+730450,int_stack+726166, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+470722, 0.0, zero_stack,28);
 /*--- compute (i0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+740404,int_stack+750904,int_stack+727930, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+472486, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+724906,int_stack+33348,int_stack+32340, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+136402, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+27783,int_stack+724906,int_stack+730450, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+475006, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+724906,int_stack+27783,int_stack+750904, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+477358, 0.0, zero_stack,28);
 /*--- compute (i0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+750904,int_stack+724906,int_stack+740404, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+480886, 0.0, zero_stack,28);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+381465,int_stack+34923,int_stack+34608, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+293265, 0.0, zero_stack, 1.0, int_stack+313565,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+740404,int_stack+35364,int_stack+34923, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+293580, 0.0, zero_stack, 1.0, int_stack+313880,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+741727,int_stack+740404,int_stack+381465, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+401233, 0.0, zero_stack, 1.0, int_stack+305515,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+724906,int_stack+35952,int_stack+35364, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+294021, 0.0, zero_stack, 1.0, int_stack+314321,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+726670,int_stack+724906,int_stack+740404, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+402178, 0.0, zero_stack, 1.0, int_stack+491386,21);
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+729316,int_stack+726670,int_stack+741727, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+403501, 0.0, zero_stack, 1.0, int_stack+492709,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+740404,int_stack+36708,int_stack+35952, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+294609, 0.0, zero_stack, 1.0, int_stack+314909,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+27783,int_stack+740404,int_stack+724906, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+405391, 0.0, zero_stack, 1.0, int_stack+494599,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+31311,int_stack+27783,int_stack+726670, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+407155, 0.0, zero_stack, 1.0, int_stack+496363,21);
 /*--- compute (h0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+757204,int_stack+31311,int_stack+729316, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+409801, 0.0, zero_stack, 1.0, int_stack+499009,21);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+27783,int_stack+38073,int_stack+37653, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+122913, 0.0, zero_stack, 1.0, int_stack+142723,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+29043,int_stack+38661,int_stack+38073, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+123753, 0.0, zero_stack, 1.0, int_stack+143563,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+30807,int_stack+29043,int_stack+27783, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+433300, 0.0, zero_stack, 1.0, int_stack+1260,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+33327,int_stack+39445,int_stack+38661, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+124929, 0.0, zero_stack, 1.0, int_stack+144739,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+35679,int_stack+33327,int_stack+29043, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+434560, 0.0, zero_stack, 1.0, int_stack+506884,28);
 /*--- compute (i0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+740404,int_stack+35679,int_stack+30807, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+436324, 0.0, zero_stack, 1.0, int_stack+508648,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+27783,int_stack+40453,int_stack+39445, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+126497, 0.0, zero_stack, 1.0, int_stack+146307,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+724906,int_stack+27783,int_stack+33327, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+438844, 0.0, zero_stack, 1.0, int_stack+511168,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+27783,int_stack+724906,int_stack+35679, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+441196, 0.0, zero_stack, 1.0, int_stack+513520,28);
 /*--- compute (i0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+724906,int_stack+27783,int_stack+740404, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+444724, 0.0, zero_stack, 1.0, int_stack+517048,28);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+381465,int_stack+42028,int_stack+41713, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+303415, 1.0, int_stack+313565, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+740404,int_stack+42469,int_stack+42028, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+303730, 1.0, int_stack+313880, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+741727,int_stack+740404,int_stack+381465, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+295365, 1.0, int_stack+305515, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+27783,int_stack+43057,int_stack+42469, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+304171, 1.0, int_stack+314321, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+29547,int_stack+27783,int_stack+740404, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+455224, 1.0, int_stack+491386, 0.0, zero_stack,21);
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+32193,int_stack+29547,int_stack+741727, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+456547, 1.0, int_stack+492709, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+740404,int_stack+43813,int_stack+43057, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+304759, 1.0, int_stack+314909, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+35343,int_stack+740404,int_stack+27783, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+458437, 1.0, int_stack+494599, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+38871,int_stack+35343,int_stack+29547, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+460201, 1.0, int_stack+496363, 0.0, zero_stack,21);
 /*--- compute (h0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+761929,int_stack+38871,int_stack+32193, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+462847, 1.0, int_stack+499009, 0.0, zero_stack,21);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+27783,int_stack+45178,int_stack+44758, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+132818, 1.0, int_stack+142723, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+29043,int_stack+45766,int_stack+45178, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+133658, 1.0, int_stack+143563, 0.0, zero_stack,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+30807,int_stack+29043,int_stack+27783, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+0, 1.0, int_stack+1260, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+33327,int_stack+46550,int_stack+45766, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+134834, 1.0, int_stack+144739, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+35679,int_stack+33327,int_stack+29043, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+470722, 1.0, int_stack+506884, 0.0, zero_stack,28);
 /*--- compute (i0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+740404,int_stack+35679,int_stack+30807, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+472486, 1.0, int_stack+508648, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+27783,int_stack+47558,int_stack+46550, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+136402, 1.0, int_stack+146307, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+39207,int_stack+27783,int_stack+33327, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+475006, 1.0, int_stack+511168, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+27783,int_stack+39207,int_stack+35679, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+477358, 1.0, int_stack+513520, 0.0, zero_stack,28);
 /*--- compute (i0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+33663,int_stack+27783,int_stack+740404, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+480886, 1.0, int_stack+517048, 0.0, zero_stack,28);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+381465,int_stack+49133,int_stack+48818, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+313565, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+740404,int_stack+49574,int_stack+49133, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+313880, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+741727,int_stack+740404,int_stack+381465, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+305515, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+27783,int_stack+50162,int_stack+49574, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+314321, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+29547,int_stack+27783,int_stack+740404, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+491386, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+39963,int_stack+29547,int_stack+741727, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+492709, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+740404,int_stack+50918,int_stack+50162, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+314909, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+43113,int_stack+740404,int_stack+27783, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+494599, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+46641,int_stack+43113,int_stack+29547, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+496363, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+27783,int_stack+46641,int_stack+39963, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+499009, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+39963,int_stack+52283,int_stack+51863, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+142723, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+41223,int_stack+52871,int_stack+52283, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+143563, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+42987,int_stack+41223,int_stack+39963, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1260, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+45507,int_stack+53655,int_stack+52871, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+144739, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+47859,int_stack+45507,int_stack+41223, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+506884, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+740404,int_stack+47859,int_stack+42987, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+508648, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+39963,int_stack+54663,int_stack+53655, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+146307, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+766654,int_stack+39963,int_stack+45507, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+511168, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+39963,int_stack+766654,int_stack+47859, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+513520, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+45843,int_stack+39963,int_stack+740404, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+517048, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+381465,int_stack+56238,int_stack+55923, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+293265, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+323715,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+740404,int_stack+56679,int_stack+56238, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+293580, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+324030,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+741727,int_stack+740404,int_stack+381465, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+401233, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+315665,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+39963,int_stack+57267,int_stack+56679, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+294021, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+324471,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+41727,int_stack+39963,int_stack+740404, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+402178, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+527548,21);
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+766654,int_stack+41727,int_stack+741727, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+403501, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+528871,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+740404,int_stack+58023,int_stack+57267, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+294609, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+325059,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+52143,int_stack+740404,int_stack+39963, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+405391, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+530761,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+731206,int_stack+52143,int_stack+41727, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+407155, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+532525,21);
 /*--- compute (h0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+52143,int_stack+731206,int_stack+766654, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+409801, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+535171,21);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+766654,int_stack+59388,int_stack+58968, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+122913, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+152628,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+767914,int_stack+59976,int_stack+59388, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+123753, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+153468,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+731206,int_stack+767914,int_stack+766654, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+433300, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2520,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+56868,int_stack+60760,int_stack+59976, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+124929, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+154644,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+39963,int_stack+56868,int_stack+767914, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+434560, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+543046,28);
 /*--- compute (i0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+740404,int_stack+39963,int_stack+731206, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+436324, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+544810,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+731206,int_stack+61768,int_stack+60760, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+126497, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+156212,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+766654,int_stack+731206,int_stack+56868, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+438844, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+547330,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+56868,int_stack+766654,int_stack+39963, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+441196, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+549682,28);
 /*--- compute (i0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+766654,int_stack+56868,int_stack+740404, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+444724, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+553210,28);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+381465,int_stack+63343,int_stack+63028, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+303415, 0.0, zero_stack, 1.0, int_stack+323715, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+740404,int_stack+63784,int_stack+63343, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+303730, 0.0, zero_stack, 1.0, int_stack+324030, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+741727,int_stack+740404,int_stack+381465, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+295365, 0.0, zero_stack, 1.0, int_stack+315665, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+56868,int_stack+64372,int_stack+63784, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+304171, 0.0, zero_stack, 1.0, int_stack+324471, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+58632,int_stack+56868,int_stack+740404, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+455224, 0.0, zero_stack, 1.0, int_stack+527548, 0.0, zero_stack,21);
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+39963,int_stack+58632,int_stack+741727, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+456547, 0.0, zero_stack, 1.0, int_stack+528871, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+740404,int_stack+65128,int_stack+64372, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+304759, 0.0, zero_stack, 1.0, int_stack+325059, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+61278,int_stack+740404,int_stack+56868, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+458437, 0.0, zero_stack, 1.0, int_stack+530761, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+731206,int_stack+61278,int_stack+58632, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+460201, 0.0, zero_stack, 1.0, int_stack+532525, 0.0, zero_stack,21);
 /*--- compute (h0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+56868,int_stack+731206,int_stack+39963, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+462847, 0.0, zero_stack, 1.0, int_stack+535171, 0.0, zero_stack,21);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+39963,int_stack+66493,int_stack+66073, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+132818, 0.0, zero_stack, 1.0, int_stack+152628, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+41223,int_stack+67081,int_stack+66493, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+133658, 0.0, zero_stack, 1.0, int_stack+153468, 0.0, zero_stack,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+42987,int_stack+41223,int_stack+39963, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack, 1.0, int_stack+2520, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+731206,int_stack+67865,int_stack+67081, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+134834, 0.0, zero_stack, 1.0, int_stack+154644, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+61593,int_stack+731206,int_stack+41223, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+470722, 0.0, zero_stack, 1.0, int_stack+543046, 0.0, zero_stack,28);
 /*--- compute (i0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+740404,int_stack+61593,int_stack+42987, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+472486, 0.0, zero_stack, 1.0, int_stack+544810, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+39963,int_stack+68873,int_stack+67865, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+136402, 0.0, zero_stack, 1.0, int_stack+156212, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+65121,int_stack+39963,int_stack+731206, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+475006, 0.0, zero_stack, 1.0, int_stack+547330, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+39963,int_stack+65121,int_stack+61593, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+477358, 0.0, zero_stack, 1.0, int_stack+549682, 0.0, zero_stack,28);
 /*--- compute (i0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+61593,int_stack+39963,int_stack+740404, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+480886, 0.0, zero_stack, 1.0, int_stack+553210, 0.0, zero_stack,28);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+381465,int_stack+70448,int_stack+70133, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+313565, 1.0, int_stack+323715, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+740404,int_stack+70889,int_stack+70448, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+313880, 1.0, int_stack+324030, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+741727,int_stack+740404,int_stack+381465, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+305515, 1.0, int_stack+315665, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+39963,int_stack+71477,int_stack+70889, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+314321, 1.0, int_stack+324471, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+41727,int_stack+39963,int_stack+740404, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+491386, 1.0, int_stack+527548, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+67893,int_stack+41727,int_stack+741727, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+492709, 1.0, int_stack+528871, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+740404,int_stack+72233,int_stack+71477, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+314909, 1.0, int_stack+325059, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+731206,int_stack+740404,int_stack+39963, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+494599, 1.0, int_stack+530761, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+772954,int_stack+731206,int_stack+41727, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+496363, 1.0, int_stack+532525, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+39963,int_stack+772954,int_stack+67893, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+499009, 1.0, int_stack+535171, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+67893,int_stack+73598,int_stack+73178, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+142723, 1.0, int_stack+152628, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+69153,int_stack+74186,int_stack+73598, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+143563, 1.0, int_stack+153468, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+70917,int_stack+69153,int_stack+67893, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1260, 1.0, int_stack+2520, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+772954,int_stack+74970,int_stack+74186, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+144739, 1.0, int_stack+154644, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+731206,int_stack+772954,int_stack+69153, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+506884, 1.0, int_stack+543046, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+740404,int_stack+731206,int_stack+70917, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+508648, 1.0, int_stack+544810, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+67893,int_stack+75978,int_stack+74970, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+146307, 1.0, int_stack+156212, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+70917,int_stack+67893,int_stack+772954, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+511168, 1.0, int_stack+547330, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+772954,int_stack+70917,int_stack+731206, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+513520, 1.0, int_stack+549682, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+67893,int_stack+772954,int_stack+740404, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+517048, 1.0, int_stack+553210, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+381465,int_stack+77553,int_stack+77238, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+323715, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+740404,int_stack+77994,int_stack+77553, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+324030, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+741727,int_stack+740404,int_stack+381465, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+315665, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+772954,int_stack+78582,int_stack+77994, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+324471, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+774718,int_stack+772954,int_stack+740404, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+527548, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+731206,int_stack+774718,int_stack+741727, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+528871, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+740404,int_stack+79338,int_stack+78582, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+325059, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+74193,int_stack+740404,int_stack+772954, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+530761, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+777364,int_stack+74193,int_stack+774718, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+532525, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+74193,int_stack+777364,int_stack+731206, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+535171, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+731206,int_stack+80703,int_stack+80283, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+152628, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+732466,int_stack+81291,int_stack+80703, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+153468, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+772954,int_stack+732466,int_stack+731206, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+2520, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+78918,int_stack+82075,int_stack+81291, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+154644, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+775474,int_stack+78918,int_stack+732466, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+543046, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+740404,int_stack+775474,int_stack+772954, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+544810, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+731206,int_stack+83083,int_stack+82075, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+156212, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+779002,int_stack+731206,int_stack+78918, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+547330, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+783706,int_stack+779002,int_stack+775474, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+549682, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+772954,int_stack+783706,int_stack+740404, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+553210, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+381465,int_stack+84658,int_stack+84343, 0.0, zero_stack, 1.0, int_stack+293265, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+333865,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+740404,int_stack+85099,int_stack+84658, 0.0, zero_stack, 1.0, int_stack+293580, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+334180,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+741727,int_stack+740404,int_stack+381465, 0.0, zero_stack, 1.0, int_stack+401233, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+325815,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+78918,int_stack+85687,int_stack+85099, 0.0, zero_stack, 1.0, int_stack+294021, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+334621,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+80682,int_stack+78918,int_stack+740404, 0.0, zero_stack, 1.0, int_stack+402178, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+563710,21);
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+731206,int_stack+80682,int_stack+741727, 0.0, zero_stack, 1.0, int_stack+403501, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+565033,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+740404,int_stack+86443,int_stack+85687, 0.0, zero_stack, 1.0, int_stack+294609, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+335209,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+83328,int_stack+740404,int_stack+78918, 0.0, zero_stack, 1.0, int_stack+405391, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+566923,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+779254,int_stack+83328,int_stack+80682, 0.0, zero_stack, 1.0, int_stack+407155, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+568687,21);
 /*--- compute (h0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+78918,int_stack+779254,int_stack+731206, 0.0, zero_stack, 1.0, int_stack+409801, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+571333,21);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+731206,int_stack+87808,int_stack+87388, 0.0, zero_stack, 1.0, int_stack+122913, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+162533,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+732466,int_stack+88396,int_stack+87808, 0.0, zero_stack, 1.0, int_stack+123753, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+163373,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+779254,int_stack+732466,int_stack+731206, 0.0, zero_stack, 1.0, int_stack+433300, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3780,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+781774,int_stack+89180,int_stack+88396, 0.0, zero_stack, 1.0, int_stack+124929, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+164549,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+784126,int_stack+781774,int_stack+732466, 0.0, zero_stack, 1.0, int_stack+434560, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+579208,28);
 /*--- compute (i0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+740404,int_stack+784126,int_stack+779254, 0.0, zero_stack, 1.0, int_stack+436324, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+580972,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+731206,int_stack+90188,int_stack+89180, 0.0, zero_stack, 1.0, int_stack+126497, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+166117,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+83643,int_stack+731206,int_stack+781774, 0.0, zero_stack, 1.0, int_stack+438844, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+583492,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+787654,int_stack+83643,int_stack+784126, 0.0, zero_stack, 1.0, int_stack+441196, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+585844,28);
 /*--- compute (i0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+83643,int_stack+787654,int_stack+740404, 0.0, zero_stack, 1.0, int_stack+444724, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+589372,28);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+381465,int_stack+91763,int_stack+91448, 0.0, zero_stack, 1.0, int_stack+303415, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+333865, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+740404,int_stack+92204,int_stack+91763, 0.0, zero_stack, 1.0, int_stack+303730, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+334180, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+741727,int_stack+740404,int_stack+381465, 0.0, zero_stack, 1.0, int_stack+295365, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+325815, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+89943,int_stack+92792,int_stack+92204, 0.0, zero_stack, 1.0, int_stack+304171, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+334621, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+731206,int_stack+89943,int_stack+740404, 0.0, zero_stack, 1.0, int_stack+455224, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+563710, 0.0, zero_stack,21);
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+779254,int_stack+731206,int_stack+741727, 0.0, zero_stack, 1.0, int_stack+456547, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+565033, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+740404,int_stack+93548,int_stack+92792, 0.0, zero_stack, 1.0, int_stack+304759, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+335209, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+782404,int_stack+740404,int_stack+89943, 0.0, zero_stack, 1.0, int_stack+458437, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+566923, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+89943,int_stack+782404,int_stack+731206, 0.0, zero_stack, 1.0, int_stack+460201, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+568687, 0.0, zero_stack,21);
 /*--- compute (h0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+782404,int_stack+89943,int_stack+779254, 0.0, zero_stack, 1.0, int_stack+462847, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+571333, 0.0, zero_stack,21);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+779254,int_stack+94913,int_stack+94493, 0.0, zero_stack, 1.0, int_stack+132818, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+162533, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+780514,int_stack+95501,int_stack+94913, 0.0, zero_stack, 1.0, int_stack+133658, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+163373, 0.0, zero_stack,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+89943,int_stack+780514,int_stack+779254, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3780, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+92463,int_stack+96285,int_stack+95501, 0.0, zero_stack, 1.0, int_stack+134834, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+164549, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+731206,int_stack+92463,int_stack+780514, 0.0, zero_stack, 1.0, int_stack+470722, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+579208, 0.0, zero_stack,28);
 /*--- compute (i0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+740404,int_stack+731206,int_stack+89943, 0.0, zero_stack, 1.0, int_stack+472486, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+580972, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+779254,int_stack+97293,int_stack+96285, 0.0, zero_stack, 1.0, int_stack+136402, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+166117, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+787129,int_stack+779254,int_stack+92463, 0.0, zero_stack, 1.0, int_stack+475006, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+583492, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+89943,int_stack+787129,int_stack+731206, 0.0, zero_stack, 1.0, int_stack+477358, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+585844, 0.0, zero_stack,28);
 /*--- compute (i0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+787129,int_stack+89943,int_stack+740404, 0.0, zero_stack, 1.0, int_stack+480886, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+589372, 0.0, zero_stack,28);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+381465,int_stack+98868,int_stack+98553, 0.0, zero_stack, 1.0, int_stack+313565, 0.0, zero_stack, 1.0, int_stack+333865, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+740404,int_stack+99309,int_stack+98868, 0.0, zero_stack, 1.0, int_stack+313880, 0.0, zero_stack, 1.0, int_stack+334180, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+741727,int_stack+740404,int_stack+381465, 0.0, zero_stack, 1.0, int_stack+305515, 0.0, zero_stack, 1.0, int_stack+325815, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+89943,int_stack+99897,int_stack+99309, 0.0, zero_stack, 1.0, int_stack+314321, 0.0, zero_stack, 1.0, int_stack+334621, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+91707,int_stack+89943,int_stack+740404, 0.0, zero_stack, 1.0, int_stack+491386, 0.0, zero_stack, 1.0, int_stack+563710, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+779254,int_stack+91707,int_stack+741727, 0.0, zero_stack, 1.0, int_stack+492709, 0.0, zero_stack, 1.0, int_stack+565033, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+740404,int_stack+100653,int_stack+99897, 0.0, zero_stack, 1.0, int_stack+314909, 0.0, zero_stack, 1.0, int_stack+335209, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+94353,int_stack+740404,int_stack+89943, 0.0, zero_stack, 1.0, int_stack+494599, 0.0, zero_stack, 1.0, int_stack+566923, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+731206,int_stack+94353,int_stack+91707, 0.0, zero_stack, 1.0, int_stack+496363, 0.0, zero_stack, 1.0, int_stack+568687, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+89943,int_stack+731206,int_stack+779254, 0.0, zero_stack, 1.0, int_stack+499009, 0.0, zero_stack, 1.0, int_stack+571333, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+779254,int_stack+102018,int_stack+101598, 0.0, zero_stack, 1.0, int_stack+142723, 0.0, zero_stack, 1.0, int_stack+162533, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+780514,int_stack+102606,int_stack+102018, 0.0, zero_stack, 1.0, int_stack+143563, 0.0, zero_stack, 1.0, int_stack+163373, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+731206,int_stack+780514,int_stack+779254, 0.0, zero_stack, 1.0, int_stack+1260, 0.0, zero_stack, 1.0, int_stack+3780, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+94668,int_stack+103390,int_stack+102606, 0.0, zero_stack, 1.0, int_stack+144739, 0.0, zero_stack, 1.0, int_stack+164549, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+97020,int_stack+94668,int_stack+780514, 0.0, zero_stack, 1.0, int_stack+506884, 0.0, zero_stack, 1.0, int_stack+579208, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+740404,int_stack+97020,int_stack+731206, 0.0, zero_stack, 1.0, int_stack+508648, 0.0, zero_stack, 1.0, int_stack+580972, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+731206,int_stack+104398,int_stack+103390, 0.0, zero_stack, 1.0, int_stack+146307, 0.0, zero_stack, 1.0, int_stack+166117, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+100548,int_stack+731206,int_stack+94668, 0.0, zero_stack, 1.0, int_stack+511168, 0.0, zero_stack, 1.0, int_stack+583492, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+793429,int_stack+100548,int_stack+97020, 0.0, zero_stack, 1.0, int_stack+513520, 0.0, zero_stack, 1.0, int_stack+585844, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+94668,int_stack+793429,int_stack+740404, 0.0, zero_stack, 1.0, int_stack+517048, 0.0, zero_stack, 1.0, int_stack+589372, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+381465,int_stack+105973,int_stack+105658, 0.0, zero_stack, 1.0, int_stack+323715, 1.0, int_stack+333865, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+740404,int_stack+106414,int_stack+105973, 0.0, zero_stack, 1.0, int_stack+324030, 1.0, int_stack+334180, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+741727,int_stack+740404,int_stack+381465, 0.0, zero_stack, 1.0, int_stack+315665, 1.0, int_stack+325815, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+793429,int_stack+107002,int_stack+106414, 0.0, zero_stack, 1.0, int_stack+324471, 1.0, int_stack+334621, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+795193,int_stack+793429,int_stack+740404, 0.0, zero_stack, 1.0, int_stack+527548, 1.0, int_stack+563710, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+779254,int_stack+795193,int_stack+741727, 0.0, zero_stack, 1.0, int_stack+528871, 1.0, int_stack+565033, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+740404,int_stack+107758,int_stack+107002, 0.0, zero_stack, 1.0, int_stack+325059, 1.0, int_stack+335209, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+100968,int_stack+740404,int_stack+793429, 0.0, zero_stack, 1.0, int_stack+530761, 1.0, int_stack+566923, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+731206,int_stack+100968,int_stack+795193, 0.0, zero_stack, 1.0, int_stack+532525, 1.0, int_stack+568687, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+100968,int_stack+731206,int_stack+779254, 0.0, zero_stack, 1.0, int_stack+535171, 1.0, int_stack+571333, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+779254,int_stack+109123,int_stack+108703, 0.0, zero_stack, 1.0, int_stack+152628, 1.0, int_stack+162533, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+780514,int_stack+109711,int_stack+109123, 0.0, zero_stack, 1.0, int_stack+153468, 1.0, int_stack+163373, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+731206,int_stack+780514,int_stack+779254, 0.0, zero_stack, 1.0, int_stack+2520, 1.0, int_stack+3780, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+105693,int_stack+110495,int_stack+109711, 0.0, zero_stack, 1.0, int_stack+154644, 1.0, int_stack+164549, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+793429,int_stack+105693,int_stack+780514, 0.0, zero_stack, 1.0, int_stack+543046, 1.0, int_stack+579208, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+740404,int_stack+793429,int_stack+731206, 0.0, zero_stack, 1.0, int_stack+544810, 1.0, int_stack+580972, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+731206,int_stack+111503,int_stack+110495, 0.0, zero_stack, 1.0, int_stack+156212, 1.0, int_stack+166117, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+108045,int_stack+731206,int_stack+105693, 0.0, zero_stack, 1.0, int_stack+547330, 1.0, int_stack+583492, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+796957,int_stack+108045,int_stack+793429, 0.0, zero_stack, 1.0, int_stack+549682, 1.0, int_stack+585844, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+105693,int_stack+796957,int_stack+740404, 0.0, zero_stack, 1.0, int_stack+553210, 1.0, int_stack+589372, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+381465,int_stack+113078,int_stack+112763, 0.0, zero_stack, 2.0, int_stack+333865, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+740404,int_stack+113519,int_stack+113078, 0.0, zero_stack, 2.0, int_stack+334180, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+741727,int_stack+740404,int_stack+381465, 0.0, zero_stack, 2.0, int_stack+325815, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+793429,int_stack+114107,int_stack+113519, 0.0, zero_stack, 2.0, int_stack+334621, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+795193,int_stack+793429,int_stack+740404, 0.0, zero_stack, 2.0, int_stack+563710, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+779254,int_stack+795193,int_stack+741727, 0.0, zero_stack, 2.0, int_stack+565033, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+740404,int_stack+114863,int_stack+114107, 0.0, zero_stack, 2.0, int_stack+335209, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+797839,int_stack+740404,int_stack+793429, 0.0, zero_stack, 2.0, int_stack+566923, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+731206,int_stack+797839,int_stack+795193, 0.0, zero_stack, 2.0, int_stack+568687, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+793429,int_stack+731206,int_stack+779254, 0.0, zero_stack, 2.0, int_stack+571333, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+779254,int_stack+116228,int_stack+115808, 0.0, zero_stack, 2.0, int_stack+162533, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+780514,int_stack+116816,int_stack+116228, 0.0, zero_stack, 2.0, int_stack+163373, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+731206,int_stack+780514,int_stack+779254, 0.0, zero_stack, 2.0, int_stack+3780, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+798154,int_stack+117600,int_stack+116816, 0.0, zero_stack, 2.0, int_stack+164549, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+740404,int_stack+798154,int_stack+780514, 0.0, zero_stack, 2.0, int_stack+579208, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+111993,int_stack+740404,int_stack+731206, 0.0, zero_stack, 2.0, int_stack+580972, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+731206,int_stack+118608,int_stack+117600, 0.0, zero_stack, 2.0, int_stack+166117, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+800506,int_stack+731206,int_stack+798154, 0.0, zero_stack, 2.0, int_stack+583492, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+805210,int_stack+800506,int_stack+740404, 0.0, zero_stack, 2.0, int_stack+585844, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+798154,int_stack+805210,int_stack+111993, 0.0, zero_stack, 2.0, int_stack+589372, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+381465,int_stack+120183,int_stack+119868, 1.0, int_stack+293265, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+344330,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+111993,int_stack+120624,int_stack+120183, 1.0, int_stack+293580, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+345086,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+113316,int_stack+111993,int_stack+381465, 1.0, int_stack+401233, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+335965,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+115206,int_stack+121212,int_stack+120624, 1.0, int_stack+294021, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+346115,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+116970,int_stack+115206,int_stack+111993, 1.0, int_stack+402178, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+599872,21);
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+779254,int_stack+116970,int_stack+113316, 1.0, int_stack+403501, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+601195,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+111993,int_stack+121968,int_stack+121212, 1.0, int_stack+294609, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+347459,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+740404,int_stack+111993,int_stack+115206, 1.0, int_stack+405391, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+603085,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+111993,int_stack+740404,int_stack+116970, 1.0, int_stack+407155, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+604849,21);
 /*--- compute (h0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+116403,int_stack+111993,int_stack+779254, 1.0, int_stack+409801, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+607495,21);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+779254,int_stack+124341,int_stack+123333, 1.0, int_stack+122913, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+172858,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+780514,int_stack+125713,int_stack+124341, 1.0, int_stack+123753, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+174286,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+111993,int_stack+780514,int_stack+779254, 1.0, int_stack+433300, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5040,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+740404,int_stack+127505,int_stack+125713, 1.0, int_stack+124929, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+176246,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+121128,int_stack+740404,int_stack+780514, 1.0, int_stack+434560, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+610645,28);
 /*--- compute (i0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+804454,int_stack+121128,int_stack+111993, 1.0, int_stack+436324, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+612409,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+111993,int_stack+128513,int_stack+127505, 1.0, int_stack+126497, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+177814,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+124656,int_stack+111993,int_stack+740404, 1.0, int_stack+438844, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+614929,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+400918,int_stack+124656,int_stack+121128, 1.0, int_stack+441196, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+389515,28);
 /*--- compute (i0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+121128,int_stack+400918,int_stack+804454, 1.0, int_stack+444724, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+623308,28);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+381465,int_stack+130088,int_stack+129773, 1.0, int_stack+303415, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+344330, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+804454,int_stack+130529,int_stack+130088, 1.0, int_stack+303730, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+345086, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+805777,int_stack+804454,int_stack+381465, 1.0, int_stack+295365, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+335965, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+807667,int_stack+131117,int_stack+130529, 1.0, int_stack+304171, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+346115, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+400918,int_stack+807667,int_stack+804454, 1.0, int_stack+455224, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+599872, 0.0, zero_stack,21);
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+779254,int_stack+400918,int_stack+805777, 1.0, int_stack+456547, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+601195, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+455224,int_stack+131873,int_stack+131117, 1.0, int_stack+304759, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+347459, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+403564,int_stack+455224,int_stack+807667, 1.0, int_stack+458437, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+603085, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+111993,int_stack+403564,int_stack+400918, 1.0, int_stack+460201, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+604849, 0.0, zero_stack,21);
 /*--- compute (h0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+400918,int_stack+111993,int_stack+779254, 1.0, int_stack+462847, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+607495, 0.0, zero_stack,21);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+779254,int_stack+134246,int_stack+133238, 1.0, int_stack+132818, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+172858, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+780514,int_stack+135618,int_stack+134246, 1.0, int_stack+133658, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+174286, 0.0, zero_stack,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+111993,int_stack+780514,int_stack+779254, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5040, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+405643,int_stack+137410,int_stack+135618, 1.0, int_stack+134834, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+176246, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+407995,int_stack+405643,int_stack+780514, 1.0, int_stack+470722, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+610645, 0.0, zero_stack,28);
 /*--- compute (i0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+740404,int_stack+407995,int_stack+111993, 1.0, int_stack+472486, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+612409, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+111993,int_stack+138418,int_stack+137410, 1.0, int_stack+136402, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+177814, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+455224,int_stack+111993,int_stack+405643, 1.0, int_stack+475006, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+614929, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+470722,int_stack+455224,int_stack+407995, 1.0, int_stack+477358, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+389515, 0.0, zero_stack,28);
 /*--- compute (i0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+455224,int_stack+470722,int_stack+740404, 1.0, int_stack+480886, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+623308, 0.0, zero_stack,28);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+381465,int_stack+139993,int_stack+139678, 1.0, int_stack+313565, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+344330, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+740404,int_stack+140434,int_stack+139993, 1.0, int_stack+313880, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+345086, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+741727,int_stack+740404,int_stack+381465, 1.0, int_stack+305515, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+335965, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+470722,int_stack+141022,int_stack+140434, 1.0, int_stack+314321, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+346115, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+472486,int_stack+470722,int_stack+740404, 1.0, int_stack+491386, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+599872, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+779254,int_stack+472486,int_stack+741727, 1.0, int_stack+492709, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+601195, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+491386,int_stack+141778,int_stack+141022, 1.0, int_stack+314909, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+347459, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+740404,int_stack+491386,int_stack+470722, 1.0, int_stack+494599, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+603085, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+111993,int_stack+740404,int_stack+472486, 1.0, int_stack+496363, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+604849, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+470722,int_stack+111993,int_stack+779254, 1.0, int_stack+499009, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+607495, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+0,int_stack+144151,int_stack+143143, 1.0, int_stack+142723, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+172858, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+779254,int_stack+145523,int_stack+144151, 1.0, int_stack+143563, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+174286, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+111993,int_stack+779254,int_stack+0, 1.0, int_stack+1260, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5040, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+0,int_stack+147315,int_stack+145523, 1.0, int_stack+144739, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+176246, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+740404,int_stack+0,int_stack+779254, 1.0, int_stack+506884, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+610645, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+475447,int_stack+740404,int_stack+111993, 1.0, int_stack+508648, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+612409, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+111993,int_stack+148323,int_stack+147315, 1.0, int_stack+146307, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+177814, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+479647,int_stack+111993,int_stack+0, 1.0, int_stack+511168, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+614929, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+506884,int_stack+479647,int_stack+740404, 1.0, int_stack+513520, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+389515, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+491386,int_stack+506884,int_stack+475447, 1.0, int_stack+517048, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+623308, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+381465,int_stack+149898,int_stack+149583, 1.0, int_stack+323715, 0.0, zero_stack, 1.0, int_stack+344330, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+475447,int_stack+150339,int_stack+149898, 1.0, int_stack+324030, 0.0, zero_stack, 1.0, int_stack+345086, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+476770,int_stack+475447,int_stack+381465, 1.0, int_stack+315665, 0.0, zero_stack, 1.0, int_stack+335965, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+478660,int_stack+150927,int_stack+150339, 1.0, int_stack+324471, 0.0, zero_stack, 1.0, int_stack+346115, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+480424,int_stack+478660,int_stack+475447, 1.0, int_stack+527548, 0.0, zero_stack, 1.0, int_stack+599872, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+779254,int_stack+480424,int_stack+476770, 1.0, int_stack+528871, 0.0, zero_stack, 1.0, int_stack+601195, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+527548,int_stack+151683,int_stack+150927, 1.0, int_stack+325059, 0.0, zero_stack, 1.0, int_stack+347459, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+506884,int_stack+527548,int_stack+478660, 1.0, int_stack+530761, 0.0, zero_stack, 1.0, int_stack+603085, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+111993,int_stack+506884,int_stack+480424, 1.0, int_stack+532525, 0.0, zero_stack, 1.0, int_stack+604849, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+506884,int_stack+111993,int_stack+779254, 1.0, int_stack+535171, 0.0, zero_stack, 1.0, int_stack+607495, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+779254,int_stack+154056,int_stack+153048, 1.0, int_stack+152628, 0.0, zero_stack, 1.0, int_stack+172858, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+780514,int_stack+155428,int_stack+154056, 1.0, int_stack+153468, 0.0, zero_stack, 1.0, int_stack+174286, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+0,int_stack+780514,int_stack+779254, 1.0, int_stack+2520, 0.0, zero_stack, 1.0, int_stack+5040, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+111993,int_stack+157220,int_stack+155428, 1.0, int_stack+154644, 0.0, zero_stack, 1.0, int_stack+176246, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+511609,int_stack+111993,int_stack+780514, 1.0, int_stack+543046, 0.0, zero_stack, 1.0, int_stack+610645, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+740404,int_stack+511609,int_stack+0, 1.0, int_stack+544810, 0.0, zero_stack, 1.0, int_stack+612409, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+0,int_stack+158228,int_stack+157220, 1.0, int_stack+156212, 0.0, zero_stack, 1.0, int_stack+177814, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+515137,int_stack+0,int_stack+111993, 1.0, int_stack+547330, 0.0, zero_stack, 1.0, int_stack+614929, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+543046,int_stack+515137,int_stack+511609, 1.0, int_stack+549682, 0.0, zero_stack, 1.0, int_stack+389515, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+511609,int_stack+543046,int_stack+740404, 1.0, int_stack+553210, 0.0, zero_stack, 1.0, int_stack+623308, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+381465,int_stack+159803,int_stack+159488, 1.0, int_stack+333865, 1.0, int_stack+344330, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+740404,int_stack+160244,int_stack+159803, 1.0, int_stack+334180, 1.0, int_stack+345086, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+741727,int_stack+740404,int_stack+381465, 1.0, int_stack+325815, 1.0, int_stack+335965, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+543046,int_stack+160832,int_stack+160244, 1.0, int_stack+334621, 1.0, int_stack+346115, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+544810,int_stack+543046,int_stack+740404, 1.0, int_stack+563710, 1.0, int_stack+599872, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+779254,int_stack+544810,int_stack+741727, 1.0, int_stack+565033, 1.0, int_stack+601195, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+563710,int_stack+161588,int_stack+160832, 1.0, int_stack+335209, 1.0, int_stack+347459, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+740404,int_stack+563710,int_stack+543046, 1.0, int_stack+566923, 1.0, int_stack+603085, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+111993,int_stack+740404,int_stack+544810, 1.0, int_stack+568687, 1.0, int_stack+604849, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+543046,int_stack+111993,int_stack+779254, 1.0, int_stack+571333, 1.0, int_stack+607495, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+779254,int_stack+163961,int_stack+162953, 1.0, int_stack+162533, 1.0, int_stack+172858, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+780514,int_stack+165333,int_stack+163961, 1.0, int_stack+163373, 1.0, int_stack+174286, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+111993,int_stack+780514,int_stack+779254, 1.0, int_stack+3780, 1.0, int_stack+5040, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+740404,int_stack+167125,int_stack+165333, 1.0, int_stack+164549, 1.0, int_stack+176246, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+547771,int_stack+740404,int_stack+780514, 1.0, int_stack+579208, 1.0, int_stack+610645, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+551299,int_stack+547771,int_stack+111993, 1.0, int_stack+580972, 1.0, int_stack+612409, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+111993,int_stack+168133,int_stack+167125, 1.0, int_stack+166117, 1.0, int_stack+177814, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+563710,int_stack+111993,int_stack+740404, 1.0, int_stack+583492, 1.0, int_stack+614929, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+579208,int_stack+563710,int_stack+547771, 1.0, int_stack+585844, 1.0, int_stack+389515, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+563710,int_stack+579208,int_stack+551299, 1.0, int_stack+589372, 1.0, int_stack+623308, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+381465,int_stack+169708,int_stack+169393, 2.0, int_stack+344330, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+579208,int_stack+170149,int_stack+169708, 2.0, int_stack+345086, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+580531,int_stack+579208,int_stack+381465, 2.0, int_stack+335965, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+582421,int_stack+170737,int_stack+170149, 2.0, int_stack+346115, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+584185,int_stack+582421,int_stack+579208, 2.0, int_stack+599872, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+779254,int_stack+584185,int_stack+580531, 2.0, int_stack+601195, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+599872,int_stack+171493,int_stack+170737, 2.0, int_stack+347459, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+586831,int_stack+599872,int_stack+582421, 2.0, int_stack+603085, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+111993,int_stack+586831,int_stack+584185, 2.0, int_stack+604849, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+599872,int_stack+111993,int_stack+779254, 2.0, int_stack+607495, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+779254,int_stack+174874,int_stack+173278, 2.0, int_stack+172858, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+780514,int_stack+177030,int_stack+174874, 2.0, int_stack+174286, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+111993,int_stack+780514,int_stack+779254, 2.0, int_stack+5040, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+604597,int_stack+178822,int_stack+177030, 2.0, int_stack+176246, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+606949,int_stack+604597,int_stack+780514, 2.0, int_stack+610645, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+740404,int_stack+606949,int_stack+111993, 2.0, int_stack+612409, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+111993,int_stack+179830,int_stack+178822, 2.0, int_stack+177814, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+579208,int_stack+111993,int_stack+604597, 2.0, int_stack+614929, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+610477,int_stack+579208,int_stack+606949, 2.0, int_stack+389515, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+0,int_stack+610477,int_stack+740404, 2.0, int_stack+623308, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+381465,int_stack+181405,int_stack+181090, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+359065,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+623308,int_stack+181846,int_stack+181405, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+359380,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+624631,int_stack+623308,int_stack+381465, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+11088,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+740404,int_stack+182434,int_stack+181846, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+359821,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+389515,int_stack+740404,int_stack+623308, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+417676,21);
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+779254,int_stack+389515,int_stack+624631, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+418999,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+623308,int_stack+183190,int_stack+182434, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+360409,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+579208,int_stack+623308,int_stack+740404, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+420889,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+111993,int_stack+579208,int_stack+389515, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+422653,21);
 /*--- compute (h0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+579208,int_stack+111993,int_stack+779254, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+393043,21);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+779254,int_stack+184555,int_stack+184135, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+219660,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+780514,int_stack+185143,int_stack+184555, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+220500,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+111993,int_stack+780514,int_stack+779254, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+633808,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+389515,int_stack+185927,int_stack+185143, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+221676,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+583933,int_stack+389515,int_stack+780514, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+635068,28);
 /*--- compute (i0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+740404,int_stack+583933,int_stack+111993, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+430339,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+111993,int_stack+186935,int_stack+185927, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+223244,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+587461,int_stack+111993,int_stack+389515, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+636832,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+604597,int_stack+587461,int_stack+583933, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+639184,28);
 /*--- compute (i0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+583933,int_stack+604597,int_stack+740404, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+642712,28);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+381465,int_stack+188510,int_stack+188195, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+359065, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+740404,int_stack+188951,int_stack+188510, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+359380, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+741727,int_stack+740404,int_stack+381465, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+11088, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+604597,int_stack+189539,int_stack+188951, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+359821, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+606361,int_stack+604597,int_stack+740404, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+417676, 0.0, zero_stack,21);
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+779254,int_stack+606361,int_stack+741727, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+418999, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+740404,int_stack+190295,int_stack+189539, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+360409, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+389515,int_stack+740404,int_stack+604597, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+420889, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+111993,int_stack+389515,int_stack+606361, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+422653, 0.0, zero_stack,21);
 /*--- compute (h0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+604597,int_stack+111993,int_stack+779254, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+393043, 0.0, zero_stack,21);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+779254,int_stack+191660,int_stack+191240, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+219660, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+780514,int_stack+192248,int_stack+191660, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+220500, 0.0, zero_stack,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+111993,int_stack+780514,int_stack+779254, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+633808, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+389515,int_stack+193032,int_stack+192248, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+221676, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+609322,int_stack+389515,int_stack+780514, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+635068, 0.0, zero_stack,28);
 /*--- compute (i0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+740404,int_stack+609322,int_stack+111993, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+430339, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+111993,int_stack+194040,int_stack+193032, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+223244, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+612850,int_stack+111993,int_stack+389515, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+636832, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+547771,int_stack+612850,int_stack+609322, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+639184, 0.0, zero_stack,28);
 /*--- compute (i0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+609322,int_stack+547771,int_stack+740404, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+642712, 0.0, zero_stack,28);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+381465,int_stack+195615,int_stack+195300, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+359065, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+740404,int_stack+196056,int_stack+195615, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+359380, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+741727,int_stack+740404,int_stack+381465, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+11088, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+547771,int_stack+196644,int_stack+196056, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+359821, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+549535,int_stack+547771,int_stack+740404, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+417676, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+779254,int_stack+549535,int_stack+741727, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+418999, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+740404,int_stack+197400,int_stack+196644, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+360409, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+389515,int_stack+740404,int_stack+547771, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+420889, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+111993,int_stack+389515,int_stack+549535, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+422653, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+547771,int_stack+111993,int_stack+779254, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+393043, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+779254,int_stack+198765,int_stack+198345, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+219660, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+780514,int_stack+199353,int_stack+198765, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+220500, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+111993,int_stack+780514,int_stack+779254, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+633808, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+389515,int_stack+200137,int_stack+199353, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+221676, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+552496,int_stack+389515,int_stack+780514, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+635068, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+740404,int_stack+552496,int_stack+111993, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+430339, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+111993,int_stack+201145,int_stack+200137, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+223244, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+527548,int_stack+111993,int_stack+389515, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+636832, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+532252,int_stack+527548,int_stack+552496, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+639184, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+475447,int_stack+532252,int_stack+740404, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+642712, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+381465,int_stack+202720,int_stack+202405, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+359065, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+740404,int_stack+203161,int_stack+202720, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+359380, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+741727,int_stack+740404,int_stack+381465, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+11088, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+552496,int_stack+203749,int_stack+203161, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+359821, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+554260,int_stack+552496,int_stack+740404, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+417676, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+779254,int_stack+554260,int_stack+741727, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+418999, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+740404,int_stack+204505,int_stack+203749, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+360409, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+389515,int_stack+740404,int_stack+552496, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+420889, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+111993,int_stack+389515,int_stack+554260, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+422653, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+552496,int_stack+111993,int_stack+779254, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+393043, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+779254,int_stack+205870,int_stack+205450, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+219660, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+780514,int_stack+206458,int_stack+205870, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+220500, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+111993,int_stack+780514,int_stack+779254, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+633808, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+389515,int_stack+207242,int_stack+206458, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+221676, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+740404,int_stack+389515,int_stack+780514, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+635068, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+623308,int_stack+740404,int_stack+111993, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+430339, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+111993,int_stack+208250,int_stack+207242, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+223244, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+527548,int_stack+111993,int_stack+389515, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+636832, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+532252,int_stack+527548,int_stack+740404, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+639184, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+405643,int_stack+532252,int_stack+623308, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+642712, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+381465,int_stack+209825,int_stack+209510, 0.0, zero_stack, 1.0, int_stack+359065, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+623308,int_stack+210266,int_stack+209825, 0.0, zero_stack, 1.0, int_stack+359380, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+624631,int_stack+623308,int_stack+381465, 0.0, zero_stack, 1.0, int_stack+11088, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+740404,int_stack+210854,int_stack+210266, 0.0, zero_stack, 1.0, int_stack+359821, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+527548,int_stack+740404,int_stack+623308, 0.0, zero_stack, 1.0, int_stack+417676, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+779254,int_stack+527548,int_stack+624631, 0.0, zero_stack, 1.0, int_stack+418999, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+623308,int_stack+211610,int_stack+210854, 0.0, zero_stack, 1.0, int_stack+360409, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+389515,int_stack+623308,int_stack+740404, 0.0, zero_stack, 1.0, int_stack+420889, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+111993,int_stack+389515,int_stack+527548, 0.0, zero_stack, 1.0, int_stack+422653, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+527548,int_stack+111993,int_stack+779254, 0.0, zero_stack, 1.0, int_stack+393043, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+779254,int_stack+212975,int_stack+212555, 0.0, zero_stack, 1.0, int_stack+219660, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+780514,int_stack+213563,int_stack+212975, 0.0, zero_stack, 1.0, int_stack+220500, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+111993,int_stack+780514,int_stack+779254, 0.0, zero_stack, 1.0, int_stack+633808, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+532273,int_stack+214347,int_stack+213563, 0.0, zero_stack, 1.0, int_stack+221676, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+389515,int_stack+532273,int_stack+780514, 0.0, zero_stack, 1.0, int_stack+635068, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+740404,int_stack+389515,int_stack+111993, 0.0, zero_stack, 1.0, int_stack+430339, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+111993,int_stack+215355,int_stack+214347, 0.0, zero_stack, 1.0, int_stack+223244, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+804454,int_stack+111993,int_stack+532273, 0.0, zero_stack, 1.0, int_stack+636832, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+532273,int_stack+804454,int_stack+389515, 0.0, zero_stack, 1.0, int_stack+639184, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+804454,int_stack+532273,int_stack+740404, 0.0, zero_stack, 1.0, int_stack+642712, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+381465,int_stack+216930,int_stack+216615, 1.0, int_stack+359065, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+740404,int_stack+217371,int_stack+216930, 1.0, int_stack+359380, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+741727,int_stack+740404,int_stack+381465, 1.0, int_stack+11088, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+532273,int_stack+217959,int_stack+217371, 1.0, int_stack+359821, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+534037,int_stack+532273,int_stack+740404, 1.0, int_stack+417676, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+779254,int_stack+534037,int_stack+741727, 1.0, int_stack+418999, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+417676,int_stack+218715,int_stack+217959, 1.0, int_stack+360409, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+389515,int_stack+417676,int_stack+532273, 1.0, int_stack+420889, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+111993,int_stack+389515,int_stack+534037, 1.0, int_stack+422653, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+532273,int_stack+111993,int_stack+779254, 1.0, int_stack+393043, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+779254,int_stack+221088,int_stack+220080, 1.0, int_stack+219660, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+780514,int_stack+222460,int_stack+221088, 1.0, int_stack+220500, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+111993,int_stack+780514,int_stack+779254, 1.0, int_stack+633808, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+389515,int_stack+224252,int_stack+222460, 1.0, int_stack+221676, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+391867,int_stack+389515,int_stack+780514, 1.0, int_stack+635068, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+740404,int_stack+391867,int_stack+111993, 1.0, int_stack+430339, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+633808,int_stack+225260,int_stack+224252, 1.0, int_stack+223244, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+430339,int_stack+633808,int_stack+389515, 1.0, int_stack+636832, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+435043,int_stack+430339,int_stack+391867, 1.0, int_stack+639184, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+389515,int_stack+435043,int_stack+740404, 1.0, int_stack+642712, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (h0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+381465,int_stack+226835,int_stack+226520,21);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+536998,int_stack+227276,int_stack+226835,21);
 /*--- compute (h0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+740404,int_stack+536998,int_stack+381465,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+742294,int_stack+227864,int_stack+227276,21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+430339,int_stack+742294,int_stack+536998,21);
 /*--- compute (h0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+779254,int_stack+430339,int_stack+740404,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+432985,int_stack+228620,int_stack+227864,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+435253,int_stack+432985,int_stack+742294,21);
 /*--- compute (h0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+111993,int_stack+435253,int_stack+430339,21);
 /*--- compute (h0|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+430339,int_stack+111993,int_stack+779254,21);
 /*--- compute (i0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+779254,int_stack+229985,int_stack+229565,28);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+780514,int_stack+230573,int_stack+229985,28);
 /*--- compute (i0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+111993,int_stack+780514,int_stack+779254,28);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+435064,int_stack+231357,int_stack+230573,28);
 /*--- compute (i0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+437416,int_stack+435064,int_stack+780514,28);
 /*--- compute (i0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+740404,int_stack+437416,int_stack+111993,28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+111993,int_stack+232365,int_stack+231357,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+440944,int_stack+111993,int_stack+435064,28);
 /*--- compute (i0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+633808,int_stack+440944,int_stack+437416,28);
 /*--- compute (i0|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+435064,int_stack+633808,int_stack+740404,28);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+381465,int_stack+233940,int_stack+233625, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+369215,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+536998,int_stack+234381,int_stack+233940, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+369530,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+740404,int_stack+536998,int_stack+381465, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+361165,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+742294,int_stack+234969,int_stack+234381, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+369971,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+633808,int_stack+742294,int_stack+536998, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+653212,21);
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+779254,int_stack+633808,int_stack+740404, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+654535,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+636454,int_stack+235725,int_stack+234969, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+370559,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+638722,int_stack+636454,int_stack+742294, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+656425,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+111993,int_stack+638722,int_stack+633808, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+658189,21);
 /*--- compute (h0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+633808,int_stack+111993,int_stack+779254, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6300,21);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+779254,int_stack+237090,int_stack+236670, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+272195,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+780514,int_stack+237678,int_stack+237090, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+273035,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+111993,int_stack+780514,int_stack+779254, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+665560,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+638533,int_stack+238462,int_stack+237678, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+274211,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+640885,int_stack+638533,int_stack+780514, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+666820,28);
 /*--- compute (i0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+740404,int_stack+640885,int_stack+111993, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+668584,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+111993,int_stack+239470,int_stack+238462, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+275779,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+441364,int_stack+111993,int_stack+638533, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+671104,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+417676,int_stack+441364,int_stack+640885, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+673456,28);
 /*--- compute (i0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+441364,int_stack+417676,int_stack+740404, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+676984,28);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+381465,int_stack+241045,int_stack+240730, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+369215, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+536998,int_stack+241486,int_stack+241045, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+369530, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+740404,int_stack+536998,int_stack+381465, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+361165, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+742294,int_stack+242074,int_stack+241486, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+369971, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+417676,int_stack+742294,int_stack+536998, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+653212, 0.0, zero_stack,21);
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+779254,int_stack+417676,int_stack+740404, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+654535, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+420322,int_stack+242830,int_stack+242074, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+370559, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+638533,int_stack+420322,int_stack+742294, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+656425, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+111993,int_stack+638533,int_stack+417676, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+658189, 0.0, zero_stack,21);
 /*--- compute (h0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+417676,int_stack+111993,int_stack+779254, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6300, 0.0, zero_stack,21);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+447664,int_stack+244195,int_stack+243775, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+272195, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+779254,int_stack+244783,int_stack+244195, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+273035, 0.0, zero_stack,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+111993,int_stack+779254,int_stack+447664, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+665560, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+422401,int_stack+245567,int_stack+244783, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+274211, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+638533,int_stack+422401,int_stack+779254, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+666820, 0.0, zero_stack,28);
 /*--- compute (i0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+740404,int_stack+638533,int_stack+111993, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+668584, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+111993,int_stack+246575,int_stack+245567, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+275779, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+642061,int_stack+111993,int_stack+422401, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+671104, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+127428,int_stack+642061,int_stack+638533, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+673456, 0.0, zero_stack,28);
 /*--- compute (i0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+638533,int_stack+127428,int_stack+740404, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+676984, 0.0, zero_stack,28);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+381465,int_stack+248150,int_stack+247835, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+369215, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+536998,int_stack+248591,int_stack+248150, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+369530, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+740404,int_stack+536998,int_stack+381465, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+361165, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+742294,int_stack+249179,int_stack+248591, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+369971, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+127428,int_stack+742294,int_stack+536998, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+653212, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+779254,int_stack+127428,int_stack+740404, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+654535, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+130074,int_stack+249935,int_stack+249179, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+370559, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+132342,int_stack+130074,int_stack+742294, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+656425, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+111993,int_stack+132342,int_stack+127428, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+658189, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+127428,int_stack+111993,int_stack+779254, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6300, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+447664,int_stack+251300,int_stack+250880, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+272195, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+779254,int_stack+251888,int_stack+251300, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+273035, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+111993,int_stack+779254,int_stack+447664, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+665560, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+132153,int_stack+252672,int_stack+251888, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+274211, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+134505,int_stack+132153,int_stack+779254, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+666820, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+740404,int_stack+134505,int_stack+111993, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+668584, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+111993,int_stack+253680,int_stack+252672, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+275779, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+138033,int_stack+111993,int_stack+132153, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+671104, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+142737,int_stack+138033,int_stack+134505, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+673456, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+132153,int_stack+142737,int_stack+740404, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+676984, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+381465,int_stack+255255,int_stack+254940, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+369215, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+536998,int_stack+255696,int_stack+255255, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+369530, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+740404,int_stack+536998,int_stack+381465, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+361165, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+742294,int_stack+256284,int_stack+255696, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+369971, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+138453,int_stack+742294,int_stack+536998, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+653212, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+779254,int_stack+138453,int_stack+740404, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+654535, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+141099,int_stack+257040,int_stack+256284, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+370559, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+143367,int_stack+141099,int_stack+742294, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+656425, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+111993,int_stack+143367,int_stack+138453, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+658189, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+138453,int_stack+111993,int_stack+779254, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6300, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+447664,int_stack+258405,int_stack+257985, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+272195, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+779254,int_stack+258993,int_stack+258405, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+273035, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+111993,int_stack+779254,int_stack+447664, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+665560, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+143178,int_stack+259777,int_stack+258993, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+274211, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+145530,int_stack+143178,int_stack+779254, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+666820, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+740404,int_stack+145530,int_stack+111993, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+668584, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+111993,int_stack+260785,int_stack+259777, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+275779, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+149058,int_stack+111993,int_stack+143178, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+671104, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+153762,int_stack+149058,int_stack+145530, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+673456, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+143178,int_stack+153762,int_stack+740404, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+676984, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+381465,int_stack+262360,int_stack+262045, 0.0, zero_stack, 1.0, int_stack+369215, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+536998,int_stack+262801,int_stack+262360, 0.0, zero_stack, 1.0, int_stack+369530, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+740404,int_stack+536998,int_stack+381465, 0.0, zero_stack, 1.0, int_stack+361165, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+742294,int_stack+263389,int_stack+262801, 0.0, zero_stack, 1.0, int_stack+369971, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+149478,int_stack+742294,int_stack+536998, 0.0, zero_stack, 1.0, int_stack+653212, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+779254,int_stack+149478,int_stack+740404, 0.0, zero_stack, 1.0, int_stack+654535, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+152124,int_stack+264145,int_stack+263389, 0.0, zero_stack, 1.0, int_stack+370559, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+154392,int_stack+152124,int_stack+742294, 0.0, zero_stack, 1.0, int_stack+656425, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+111993,int_stack+154392,int_stack+149478, 0.0, zero_stack, 1.0, int_stack+658189, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+149478,int_stack+111993,int_stack+779254, 0.0, zero_stack, 1.0, int_stack+6300, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+447664,int_stack+265510,int_stack+265090, 0.0, zero_stack, 1.0, int_stack+272195, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+779254,int_stack+266098,int_stack+265510, 0.0, zero_stack, 1.0, int_stack+273035, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+111993,int_stack+779254,int_stack+447664, 0.0, zero_stack, 1.0, int_stack+665560, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+154203,int_stack+266882,int_stack+266098, 0.0, zero_stack, 1.0, int_stack+274211, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+156555,int_stack+154203,int_stack+779254, 0.0, zero_stack, 1.0, int_stack+666820, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+740404,int_stack+156555,int_stack+111993, 0.0, zero_stack, 1.0, int_stack+668584, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+111993,int_stack+267890,int_stack+266882, 0.0, zero_stack, 1.0, int_stack+275779, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+160083,int_stack+111993,int_stack+154203, 0.0, zero_stack, 1.0, int_stack+671104, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+164787,int_stack+160083,int_stack+156555, 0.0, zero_stack, 1.0, int_stack+673456, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+154203,int_stack+164787,int_stack+740404, 0.0, zero_stack, 1.0, int_stack+676984, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+381465,int_stack+269465,int_stack+269150, 1.0, int_stack+369215, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+536998,int_stack+269906,int_stack+269465, 1.0, int_stack+369530, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+740404,int_stack+536998,int_stack+381465, 1.0, int_stack+361165, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+742294,int_stack+270494,int_stack+269906, 1.0, int_stack+369971, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+160503,int_stack+742294,int_stack+536998, 1.0, int_stack+653212, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+779254,int_stack+160503,int_stack+740404, 1.0, int_stack+654535, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+653212,int_stack+271250,int_stack+270494, 1.0, int_stack+370559, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+163149,int_stack+653212,int_stack+742294, 1.0, int_stack+656425, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+111993,int_stack+163149,int_stack+160503, 1.0, int_stack+658189, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+160503,int_stack+111993,int_stack+779254, 1.0, int_stack+6300, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+447664,int_stack+273623,int_stack+272615, 1.0, int_stack+272195, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+6300,int_stack+274995,int_stack+273623, 1.0, int_stack+273035, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+8064,int_stack+6300,int_stack+447664, 1.0, int_stack+665560, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+779254,int_stack+276787,int_stack+274995, 1.0, int_stack+274211, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+111993,int_stack+779254,int_stack+6300, 1.0, int_stack+666820, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+740404,int_stack+111993,int_stack+8064, 1.0, int_stack+668584, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+6300,int_stack+277795,int_stack+276787, 1.0, int_stack+275779, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+665560,int_stack+6300,int_stack+779254, 1.0, int_stack+671104, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+165228,int_stack+665560,int_stack+111993, 1.0, int_stack+673456, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+665560,int_stack+165228,int_stack+740404, 1.0, int_stack+676984, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (h0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+381465,int_stack+279370,int_stack+279055,21);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+536998,int_stack+279811,int_stack+279370,21);
 /*--- compute (h0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+740404,int_stack+536998,int_stack+381465,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+742294,int_stack+280399,int_stack+279811,21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+165228,int_stack+742294,int_stack+536998,21);
 /*--- compute (h0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+779254,int_stack+165228,int_stack+740404,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+167874,int_stack+281155,int_stack+280399,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+170142,int_stack+167874,int_stack+742294,21);
 /*--- compute (h0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+111993,int_stack+170142,int_stack+165228,21);
 /*--- compute (h0|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+165228,int_stack+111993,int_stack+779254,21);
 /*--- compute (i0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+447664,int_stack+282520,int_stack+282100,28);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+779254,int_stack+283108,int_stack+282520,28);
 /*--- compute (i0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+111993,int_stack+779254,int_stack+447664,28);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+169953,int_stack+283892,int_stack+283108,28);
 /*--- compute (i0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+172305,int_stack+169953,int_stack+779254,28);
 /*--- compute (i0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+740404,int_stack+172305,int_stack+111993,28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+111993,int_stack+284900,int_stack+283892,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+175833,int_stack+111993,int_stack+169953,28);
 /*--- compute (i0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+180537,int_stack+175833,int_stack+172305,28);
 /*--- compute (i0|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+169953,int_stack+180537,int_stack+740404,28);
 /*--- compute (h0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+381465,int_stack+286475,int_stack+286160,21);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+536998,int_stack+286916,int_stack+286475,21);
 /*--- compute (h0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+740404,int_stack+536998,int_stack+381465,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+742294,int_stack+287504,int_stack+286916,21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+176253,int_stack+742294,int_stack+536998,21);
 /*--- compute (h0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+779254,int_stack+176253,int_stack+740404,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+178899,int_stack+288260,int_stack+287504,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+181167,int_stack+178899,int_stack+742294,21);
 /*--- compute (h0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+111993,int_stack+181167,int_stack+176253,21);
 /*--- compute (h0|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+176253,int_stack+111993,int_stack+779254,21);
 /*--- compute (i0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+447664,int_stack+289625,int_stack+289205,28);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+779254,int_stack+290213,int_stack+289625,28);
 /*--- compute (i0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+111993,int_stack+779254,int_stack+447664,28);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+180978,int_stack+290997,int_stack+290213,28);
 /*--- compute (i0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+183330,int_stack+180978,int_stack+779254,28);
 /*--- compute (i0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+740404,int_stack+183330,int_stack+111993,28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+111993,int_stack+292005,int_stack+290997,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+186858,int_stack+111993,int_stack+180978,28);
 /*--- compute (i0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+191562,int_stack+186858,int_stack+183330,28);
 /*--- compute (i0|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+180978,int_stack+191562,int_stack+740404,28);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+381465,int_stack+296625,int_stack+296310, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+379365,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+536998,int_stack+297066,int_stack+296625, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+379680,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+740404,int_stack+536998,int_stack+381465, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+371315,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+742294,int_stack+297654,int_stack+297066, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+380121,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+187278,int_stack+742294,int_stack+536998, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+687484,21);
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+779254,int_stack+187278,int_stack+740404, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+688807,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+189924,int_stack+298410,int_stack+297654, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+380709,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+192192,int_stack+189924,int_stack+742294, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+690697,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+111993,int_stack+192192,int_stack+187278, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+692461,21);
 /*--- compute (h0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+187278,int_stack+111993,int_stack+779254, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+695107,21);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+447664,int_stack+299775,int_stack+299355, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+352205,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+779254,int_stack+300363,int_stack+299775, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+353045,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+111993,int_stack+779254,int_stack+447664, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+702982,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+192003,int_stack+301147,int_stack+300363, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+354221,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+194355,int_stack+192003,int_stack+779254, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+704242,28);
 /*--- compute (i0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+740404,int_stack+194355,int_stack+111993, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+706006,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+111993,int_stack+302155,int_stack+301147, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+355789,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+197883,int_stack+111993,int_stack+192003, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+708526,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+202587,int_stack+197883,int_stack+194355, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+710878,28);
 /*--- compute (i0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+192003,int_stack+202587,int_stack+740404, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+714406,28);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+381465,int_stack+306775,int_stack+306460, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+379365, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+536998,int_stack+307216,int_stack+306775, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+379680, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+740404,int_stack+536998,int_stack+381465, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+371315, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+742294,int_stack+307804,int_stack+307216, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+380121, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+198303,int_stack+742294,int_stack+536998, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+687484, 0.0, zero_stack,21);
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+779254,int_stack+198303,int_stack+740404, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+688807, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+200949,int_stack+308560,int_stack+307804, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+380709, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+203217,int_stack+200949,int_stack+742294, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+690697, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+111993,int_stack+203217,int_stack+198303, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+692461, 0.0, zero_stack,21);
 /*--- compute (h0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+198303,int_stack+111993,int_stack+779254, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+695107, 0.0, zero_stack,21);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+447664,int_stack+309925,int_stack+309505, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+352205, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+779254,int_stack+310513,int_stack+309925, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+353045, 0.0, zero_stack,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+111993,int_stack+779254,int_stack+447664, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+702982, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+203028,int_stack+311297,int_stack+310513, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+354221, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+205380,int_stack+203028,int_stack+779254, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+704242, 0.0, zero_stack,28);
 /*--- compute (i0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+740404,int_stack+205380,int_stack+111993, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+706006, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+111993,int_stack+312305,int_stack+311297, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+355789, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+208908,int_stack+111993,int_stack+203028, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+708526, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+213612,int_stack+208908,int_stack+205380, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+710878, 0.0, zero_stack,28);
 /*--- compute (i0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+203028,int_stack+213612,int_stack+740404, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+714406, 0.0, zero_stack,28);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+381465,int_stack+316925,int_stack+316610, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+379365, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+536998,int_stack+317366,int_stack+316925, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+379680, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+740404,int_stack+536998,int_stack+381465, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+371315, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+742294,int_stack+317954,int_stack+317366, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+380121, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+209328,int_stack+742294,int_stack+536998, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+687484, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+779254,int_stack+209328,int_stack+740404, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+688807, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+211974,int_stack+318710,int_stack+317954, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+380709, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+214242,int_stack+211974,int_stack+742294, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+690697, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+111993,int_stack+214242,int_stack+209328, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+692461, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+209328,int_stack+111993,int_stack+779254, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+695107, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+447664,int_stack+320075,int_stack+319655, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+352205, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+779254,int_stack+320663,int_stack+320075, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+353045, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+111993,int_stack+779254,int_stack+447664, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+702982, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+214053,int_stack+321447,int_stack+320663, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+354221, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+216405,int_stack+214053,int_stack+779254, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+704242, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+740404,int_stack+216405,int_stack+111993, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+706006, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+111993,int_stack+322455,int_stack+321447, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+355789, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+219933,int_stack+111993,int_stack+214053, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+708526, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+224637,int_stack+219933,int_stack+216405, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+710878, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+214053,int_stack+224637,int_stack+740404, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+714406, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+381465,int_stack+327075,int_stack+326760, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+379365, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+536998,int_stack+327516,int_stack+327075, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+379680, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+740404,int_stack+536998,int_stack+381465, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+371315, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+742294,int_stack+328104,int_stack+327516, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+380121, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+220353,int_stack+742294,int_stack+536998, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+687484, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+779254,int_stack+220353,int_stack+740404, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+688807, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+222999,int_stack+328860,int_stack+328104, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+380709, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+225267,int_stack+222999,int_stack+742294, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+690697, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+111993,int_stack+225267,int_stack+220353, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+692461, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+220353,int_stack+111993,int_stack+779254, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+695107, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+447664,int_stack+330225,int_stack+329805, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+352205, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+779254,int_stack+330813,int_stack+330225, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+353045, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+111993,int_stack+779254,int_stack+447664, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+702982, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+225078,int_stack+331597,int_stack+330813, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+354221, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+227430,int_stack+225078,int_stack+779254, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+704242, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+740404,int_stack+227430,int_stack+111993, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+706006, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+111993,int_stack+332605,int_stack+331597, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+355789, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+230958,int_stack+111993,int_stack+225078, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+708526, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+235662,int_stack+230958,int_stack+227430, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+710878, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+225078,int_stack+235662,int_stack+740404, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+714406, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+381465,int_stack+337225,int_stack+336910, 0.0, zero_stack, 1.0, int_stack+379365, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+536998,int_stack+337666,int_stack+337225, 0.0, zero_stack, 1.0, int_stack+379680, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+740404,int_stack+536998,int_stack+381465, 0.0, zero_stack, 1.0, int_stack+371315, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+742294,int_stack+338254,int_stack+337666, 0.0, zero_stack, 1.0, int_stack+380121, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+231378,int_stack+742294,int_stack+536998, 0.0, zero_stack, 1.0, int_stack+687484, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+779254,int_stack+231378,int_stack+740404, 0.0, zero_stack, 1.0, int_stack+688807, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+234024,int_stack+339010,int_stack+338254, 0.0, zero_stack, 1.0, int_stack+380709, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+236292,int_stack+234024,int_stack+742294, 0.0, zero_stack, 1.0, int_stack+690697, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+111993,int_stack+236292,int_stack+231378, 0.0, zero_stack, 1.0, int_stack+692461, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+231378,int_stack+111993,int_stack+779254, 0.0, zero_stack, 1.0, int_stack+695107, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+447664,int_stack+340375,int_stack+339955, 0.0, zero_stack, 1.0, int_stack+352205, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+779254,int_stack+340963,int_stack+340375, 0.0, zero_stack, 1.0, int_stack+353045, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+111993,int_stack+779254,int_stack+447664, 0.0, zero_stack, 1.0, int_stack+702982, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+236103,int_stack+341747,int_stack+340963, 0.0, zero_stack, 1.0, int_stack+354221, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+238455,int_stack+236103,int_stack+779254, 0.0, zero_stack, 1.0, int_stack+704242, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+740404,int_stack+238455,int_stack+111993, 0.0, zero_stack, 1.0, int_stack+706006, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+111993,int_stack+342755,int_stack+341747, 0.0, zero_stack, 1.0, int_stack+355789, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+241983,int_stack+111993,int_stack+236103, 0.0, zero_stack, 1.0, int_stack+708526, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+246687,int_stack+241983,int_stack+238455, 0.0, zero_stack, 1.0, int_stack+710878, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+236103,int_stack+246687,int_stack+740404, 0.0, zero_stack, 1.0, int_stack+714406, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+381465,int_stack+349475,int_stack+349160, 1.0, int_stack+379365, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+536998,int_stack+349916,int_stack+349475, 1.0, int_stack+379680, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+740404,int_stack+536998,int_stack+381465, 1.0, int_stack+371315, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+742294,int_stack+350504,int_stack+349916, 1.0, int_stack+380121, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+242403,int_stack+742294,int_stack+536998, 1.0, int_stack+687484, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+779254,int_stack+242403,int_stack+740404, 1.0, int_stack+688807, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+687484,int_stack+351260,int_stack+350504, 1.0, int_stack+380709, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+245049,int_stack+687484,int_stack+742294, 1.0, int_stack+690697, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+111993,int_stack+245049,int_stack+242403, 1.0, int_stack+692461, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+242403,int_stack+111993,int_stack+779254, 1.0, int_stack+695107, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+447664,int_stack+353633,int_stack+352625, 1.0, int_stack+352205, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+779254,int_stack+355005,int_stack+353633, 1.0, int_stack+353045, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+111993,int_stack+779254,int_stack+447664, 1.0, int_stack+702982, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+247128,int_stack+356797,int_stack+355005, 1.0, int_stack+354221, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+249480,int_stack+247128,int_stack+779254, 1.0, int_stack+704242, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+740404,int_stack+249480,int_stack+111993, 1.0, int_stack+706006, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+111993,int_stack+357805,int_stack+356797, 1.0, int_stack+355789, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+702982,int_stack+111993,int_stack+247128, 1.0, int_stack+708526, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+253008,int_stack+702982,int_stack+249480, 1.0, int_stack+710878, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+702982,int_stack+253008,int_stack+740404, 1.0, int_stack+714406, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (h0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+740404,int_stack+362425,int_stack+362110,21);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+536998,int_stack+362866,int_stack+362425,21);
 /*--- compute (h0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+741349,int_stack+536998,int_stack+740404,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+709282,int_stack+363454,int_stack+362866,21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+711046,int_stack+709282,int_stack+536998,21);
 /*--- compute (h0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+779254,int_stack+711046,int_stack+741349,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+740404,int_stack+364210,int_stack+363454,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+713692,int_stack+740404,int_stack+709282,21);
 /*--- compute (h0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+111993,int_stack+713692,int_stack+711046,21);
 /*--- compute (h0|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+709282,int_stack+111993,int_stack+779254,21);
 /*--- compute (i0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+447664,int_stack+365575,int_stack+365155,28);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+779254,int_stack+366163,int_stack+365575,28);
 /*--- compute (i0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+111993,int_stack+779254,int_stack+447664,28);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+714007,int_stack+366947,int_stack+366163,28);
 /*--- compute (i0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+740404,int_stack+714007,int_stack+779254,28);
 /*--- compute (i0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+623308,int_stack+740404,int_stack+111993,28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+111993,int_stack+367955,int_stack+366947,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+247128,int_stack+111993,int_stack+714007,28);
 /*--- compute (i0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+251832,int_stack+247128,int_stack+740404,28);
 /*--- compute (i0|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+257712,int_stack+251832,int_stack+623308,28);
 /*--- compute (h0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+623308,int_stack+372575,int_stack+372260,21);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+536998,int_stack+373016,int_stack+372575,21);
 /*--- compute (h0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+624253,int_stack+536998,int_stack+623308,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+740404,int_stack+373604,int_stack+373016,21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+247128,int_stack+740404,int_stack+536998,21);
 /*--- compute (h0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+779254,int_stack+247128,int_stack+624253,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+623308,int_stack+374360,int_stack+373604,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+249774,int_stack+623308,int_stack+740404,21);
 /*--- compute (h0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+253302,int_stack+249774,int_stack+247128,21);
 /*--- compute (h0|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+247128,int_stack+253302,int_stack+779254,21);
 /*--- compute (i0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+447664,int_stack+375725,int_stack+375305,28);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+779254,int_stack+376313,int_stack+375725,28);
 /*--- compute (i0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+251853,int_stack+779254,int_stack+447664,28);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+254373,int_stack+377097,int_stack+376313,28);
 /*--- compute (i0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+740404,int_stack+254373,int_stack+779254,28);
 /*--- compute (i0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+623308,int_stack+740404,int_stack+251853,28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+779254,int_stack+378105,int_stack+377097,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+264012,int_stack+779254,int_stack+254373,28);
 /*--- compute (i0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+268716,int_stack+264012,int_stack+740404,28);
 /*--- compute (i0|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+274596,int_stack+268716,int_stack+623308,28);
 /*--- compute (h0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+623308,int_stack+382725,int_stack+382410,21);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+536998,int_stack+383166,int_stack+382725,21);
 /*--- compute (h0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+624253,int_stack+536998,int_stack+623308,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+740404,int_stack+383754,int_stack+383166,21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+264012,int_stack+740404,int_stack+536998,21);
 /*--- compute (h0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+779254,int_stack+264012,int_stack+624253,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+623308,int_stack+384510,int_stack+383754,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+266658,int_stack+623308,int_stack+740404,21);
 /*--- compute (h0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+270186,int_stack+266658,int_stack+264012,21);
 /*--- compute (h0|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+264012,int_stack+270186,int_stack+779254,21);
 /*--- compute (i0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+447664,int_stack+385875,int_stack+385455,28);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+779254,int_stack+386463,int_stack+385875,28);
 /*--- compute (i0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+268737,int_stack+779254,int_stack+447664,28);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+271257,int_stack+387247,int_stack+386463,28);
 /*--- compute (i0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+740404,int_stack+271257,int_stack+779254,28);
 /*--- compute (i0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+623308,int_stack+740404,int_stack+268737,28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+779254,int_stack+388255,int_stack+387247,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+251853,int_stack+779254,int_stack+271257,28);
 /*--- compute (i0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+280896,int_stack+251853,int_stack+740404,28);
 /*--- compute (i0|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+286776,int_stack+280896,int_stack+623308,28);
 /*--- compute (hp|gg) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+293076,int_stack+448924,int_stack+412951,225);
     Libderiv->ABCD[11] = int_stack + 293076;
 /*--- compute (hp|gg) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+307251,int_stack+485086,int_stack+465997,225);
     Libderiv->ABCD[10] = int_stack + 307251;
 /*--- compute (hp|gg) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+321426,int_stack+521248,int_stack+502159,225);
     Libderiv->ABCD[9] = int_stack + 321426;
 /*--- compute (hp|gg) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+335601,int_stack+557410,int_stack+538321,225);
     Libderiv->ABCD[8] = int_stack + 335601;
 /*--- compute (hp|gg) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+349776,int_stack+593572,int_stack+574483,225);
     Libderiv->ABCD[7] = int_stack + 349776;
 /*--- compute (hp|gg) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+363951,int_stack+627508,int_stack+618583,225);
     Libderiv->ABCD[6] = int_stack + 363951;
 /*--- compute (hp|gg) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+810754,int_stack+646912,int_stack+396193, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+425614, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
     Libderiv->ABCD[2] = int_stack + 810754;
 /*--- compute (hp|gg) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+644833,int_stack+681184,int_stack+660835, 0.0, zero_stack, 1.0, int_stack+425614, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
     Libderiv->ABCD[1] = int_stack + 644833;
 /*--- compute (hp|gg) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+671860,int_stack+718606,int_stack+698257, 1.0, int_stack+425614, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
     Libderiv->ABCD[0] = int_stack + 671860;
 /*--- compute (hp|gg) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+824929,int_stack+12033,int_stack+735679,225);
     Libderiv->ABCD[155] = int_stack + 824929;
 /*--- compute (hp|gg) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+839104,int_stack+744604,int_stack+18333,225);
     Libderiv->ABCD[143] = int_stack + 839104;
 /*--- compute (hp|gg) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+6300,int_stack+750904,int_stack+23058,225);
     Libderiv->ABCD[142] = int_stack + 6300;
 /*--- compute (hp|gg) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+731206,int_stack+724906,int_stack+757204,225);
     Libderiv->ABCD[131] = int_stack + 731206;
 /*--- compute (hp|gg) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+714007,int_stack+33663,int_stack+761929,225);
     Libderiv->ABCD[130] = int_stack + 714007;
 /*--- compute (hp|gg) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+745381,int_stack+45843,int_stack+27783,225);
     Libderiv->ABCD[129] = int_stack + 745381;
 /*--- compute (hp|gg) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+20475,int_stack+766654,int_stack+52143,225);
     Libderiv->ABCD[119] = int_stack + 20475;
 /*--- compute (hp|gg) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+853279,int_stack+61593,int_stack+56868,225);
     Libderiv->ABCD[118] = int_stack + 853279;
 /*--- compute (hp|gg) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+44688,int_stack+67893,int_stack+39963,225);
     Libderiv->ABCD[117] = int_stack + 44688;
 /*--- compute (hp|gg) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+58863,int_stack+772954,int_stack+74193,225);
     Libderiv->ABCD[116] = int_stack + 58863;
 /*--- compute (hp|gg) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+759556,int_stack+83643,int_stack+78918,225);
     Libderiv->ABCD[107] = int_stack + 759556;
 /*--- compute (hp|gg) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+73038,int_stack+787129,int_stack+782404,225);
     Libderiv->ABCD[106] = int_stack + 73038;
 /*--- compute (hp|gg) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+773731,int_stack+94668,int_stack+89943,225);
     Libderiv->ABCD[105] = int_stack + 773731;
 /*--- compute (hp|gg) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+867454,int_stack+105693,int_stack+100968,225);
     Libderiv->ABCD[104] = int_stack + 867454;
 /*--- compute (hp|gg) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+87213,int_stack+798154,int_stack+793429,225);
     Libderiv->ABCD[103] = int_stack + 87213;
 /*--- compute (hp|gg) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+787906,int_stack+121128,int_stack+116403,225);
     Libderiv->ABCD[95] = int_stack + 787906;
 /*--- compute (hp|gg) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+101388,int_stack+455224,int_stack+400918,225);
     Libderiv->ABCD[94] = int_stack + 101388;
 /*--- compute (hp|gg) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+447664,int_stack+491386,int_stack+470722,225);
     Libderiv->ABCD[93] = int_stack + 447664;
 /*--- compute (hp|gg) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+481747,int_stack+511609,int_stack+506884,225);
     Libderiv->ABCD[92] = int_stack + 481747;
 /*--- compute (hp|gg) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+506884,int_stack+563710,int_stack+543046,225);
     Libderiv->ABCD[91] = int_stack + 506884;
 /*--- compute (hp|gg) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+557221,int_stack+0,int_stack+599872,225);
     Libderiv->ABCD[90] = int_stack + 557221;
 /*--- compute (hp|gg) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+590233,int_stack+583933,int_stack+579208, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+412951, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
     Libderiv->ABCD[47] = int_stack + 590233;
 /*--- compute (hp|gg) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+881629,int_stack+609322,int_stack+604597, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+465997, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
     Libderiv->ABCD[46] = int_stack + 881629;
 /*--- compute (hp|gg) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+604408,int_stack+475447,int_stack+547771, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+502159, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
     Libderiv->ABCD[45] = int_stack + 604408;
 /*--- compute (hp|gg) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+895804,int_stack+405643,int_stack+552496, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+538321, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
     Libderiv->ABCD[44] = int_stack + 895804;
 /*--- compute (hp|gg) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+543046,int_stack+804454,int_stack+527548, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+574483, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
     Libderiv->ABCD[43] = int_stack + 543046;
 /*--- compute (hp|gg) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+909979,int_stack+389515,int_stack+532273, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+618583, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
     Libderiv->ABCD[42] = int_stack + 909979;
 /*--- compute (hp|gg) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+521059,int_stack+435064,int_stack+430339, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+396193, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
     Libderiv->ABCD[38] = int_stack + 521059;
 /*--- compute (hp|gg) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+378126,int_stack+441364,int_stack+633808, 0.0, zero_stack, 1.0, int_stack+412951, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
     Libderiv->ABCD[35] = int_stack + 378126;
 /*--- compute (hp|gg) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+623308,int_stack+638533,int_stack+417676, 0.0, zero_stack, 1.0, int_stack+465997, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
     Libderiv->ABCD[34] = int_stack + 623308;
 /*--- compute (hp|gg) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+417676,int_stack+132153,int_stack+127428, 0.0, zero_stack, 1.0, int_stack+502159, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
     Libderiv->ABCD[33] = int_stack + 417676;
 /*--- compute (hp|gg) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+431851,int_stack+143178,int_stack+138453, 0.0, zero_stack, 1.0, int_stack+538321, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
     Libderiv->ABCD[32] = int_stack + 431851;
 /*--- compute (hp|gg) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+115563,int_stack+154203,int_stack+149478, 0.0, zero_stack, 1.0, int_stack+574483, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
     Libderiv->ABCD[31] = int_stack + 115563;
 /*--- compute (hp|gg) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+129738,int_stack+665560,int_stack+160503, 0.0, zero_stack, 1.0, int_stack+618583, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
     Libderiv->ABCD[30] = int_stack + 129738;
 /*--- compute (hp|gg) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+143913,int_stack+169953,int_stack+165228, 0.0, zero_stack, 1.0, int_stack+396193, 1.0, int_stack+660835, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
     Libderiv->ABCD[26] = int_stack + 143913;
 /*--- compute (hp|gg) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+158088,int_stack+180978,int_stack+176253, 0.0, zero_stack, 2.0, int_stack+660835, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
     Libderiv->ABCD[25] = int_stack + 158088;
 /*--- compute (hp|gg) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+172263,int_stack+192003,int_stack+187278, 1.0, int_stack+412951, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
     Libderiv->ABCD[23] = int_stack + 172263;
 /*--- compute (hp|gg) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+400918,int_stack+203028,int_stack+198303, 1.0, int_stack+465997, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
     Libderiv->ABCD[22] = int_stack + 400918;
 /*--- compute (hp|gg) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+461839,int_stack+214053,int_stack+209328, 1.0, int_stack+502159, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
     Libderiv->ABCD[21] = int_stack + 461839;
 /*--- compute (hp|gg) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+186438,int_stack+225078,int_stack+220353, 1.0, int_stack+538321, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
     Libderiv->ABCD[20] = int_stack + 186438;
 /*--- compute (hp|gg) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+200613,int_stack+236103,int_stack+231378, 1.0, int_stack+574483, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
     Libderiv->ABCD[19] = int_stack + 200613;
 /*--- compute (hp|gg) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+571396,int_stack+702982,int_stack+242403, 1.0, int_stack+618583, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
     Libderiv->ABCD[18] = int_stack + 571396;
 /*--- compute (hp|gg) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+214788,int_stack+257712,int_stack+709282, 1.0, int_stack+396193, 0.0, zero_stack, 1.0, int_stack+698257, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
     Libderiv->ABCD[14] = int_stack + 214788;
 /*--- compute (hp|gg) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+228963,int_stack+274596,int_stack+247128, 1.0, int_stack+660835, 1.0, int_stack+698257, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
     Libderiv->ABCD[13] = int_stack + 228963;
 /*--- compute (hp|gg) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+268737,int_stack+286776,int_stack+264012, 2.0, int_stack+698257, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
     Libderiv->ABCD[12] = int_stack + 268737;

}
