/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include <libint/libint.h>
#include "libderiv.h"
#include <libint/hrr_header.h>

#include "d1hrr_header.h"

extern void d12vrr_order_p0hg(Libderiv_t *, prim_data *);

  /* Computes derivatives of (p0|hg) integrals */

void d12hrr_order_p0hg(Libderiv_t *Libderiv, int num_prim_comb)
{
 prim_data *Data = Libderiv->PrimQuartet;
 double *int_stack = Libderiv->int_stack;
 double *zero_stack = Libderiv->zero_stack;
 int i,j;
 double tmp, *target;

 Libderiv->deriv_classes[1][9][11] = int_stack + 0;
 Libderiv->deriv_classes[1][9][10] = int_stack + 165;
 Libderiv->deriv_classes[1][9][9] = int_stack + 330;
 Libderiv->deriv_classes[1][9][8] = int_stack + 495;
 Libderiv->deriv_classes[1][9][7] = int_stack + 660;
 Libderiv->dvrr_classes[1][8] = int_stack + 825;
 Libderiv->deriv_classes[1][9][6] = int_stack + 960;
 Libderiv->deriv_classes[1][9][2] = int_stack + 1125;
 Libderiv->deriv_classes[1][9][1] = int_stack + 1290;
 Libderiv->deriv_classes[1][9][0] = int_stack + 1455;
 Libderiv->deriv2_classes[1][5][143] = int_stack + 1620;
 Libderiv->deriv2_classes[1][6][143] = int_stack + 1683;
 Libderiv->deriv2_classes[1][7][143] = int_stack + 1767;
 Libderiv->deriv2_classes[1][8][143] = int_stack + 1875;
 Libderiv->deriv2_classes[1][9][143] = int_stack + 2010;
 Libderiv->deriv2_classes[1][5][131] = int_stack + 2175;
 Libderiv->deriv2_classes[1][6][131] = int_stack + 2238;
 Libderiv->deriv2_classes[1][7][131] = int_stack + 2322;
 Libderiv->deriv2_classes[1][8][131] = int_stack + 2430;
 Libderiv->deriv2_classes[1][9][131] = int_stack + 2565;
 Libderiv->deriv2_classes[1][5][130] = int_stack + 2730;
 Libderiv->deriv2_classes[1][6][130] = int_stack + 2793;
 Libderiv->deriv2_classes[1][7][130] = int_stack + 2877;
 Libderiv->deriv2_classes[1][8][130] = int_stack + 2985;
 Libderiv->deriv2_classes[1][9][130] = int_stack + 3120;
 Libderiv->deriv2_classes[1][5][119] = int_stack + 3285;
 Libderiv->deriv2_classes[1][6][119] = int_stack + 3348;
 Libderiv->deriv2_classes[1][7][119] = int_stack + 3432;
 Libderiv->deriv2_classes[1][8][119] = int_stack + 3540;
 Libderiv->deriv2_classes[1][9][119] = int_stack + 3675;
 Libderiv->deriv2_classes[1][5][118] = int_stack + 3840;
 Libderiv->deriv2_classes[1][6][118] = int_stack + 3903;
 Libderiv->deriv2_classes[1][7][118] = int_stack + 3987;
 Libderiv->deriv2_classes[1][8][118] = int_stack + 4095;
 Libderiv->deriv2_classes[1][9][118] = int_stack + 4230;
 Libderiv->deriv2_classes[1][5][117] = int_stack + 4395;
 Libderiv->deriv2_classes[1][6][117] = int_stack + 4458;
 Libderiv->deriv2_classes[1][7][117] = int_stack + 4542;
 Libderiv->deriv2_classes[1][8][117] = int_stack + 4650;
 Libderiv->deriv2_classes[1][9][117] = int_stack + 4785;
 Libderiv->deriv2_classes[1][5][107] = int_stack + 4950;
 Libderiv->deriv2_classes[1][6][107] = int_stack + 5013;
 Libderiv->deriv2_classes[1][7][107] = int_stack + 5097;
 Libderiv->deriv2_classes[1][8][107] = int_stack + 5205;
 Libderiv->deriv2_classes[1][9][107] = int_stack + 5340;
 Libderiv->deriv2_classes[1][5][106] = int_stack + 5505;
 Libderiv->deriv2_classes[1][6][106] = int_stack + 5568;
 Libderiv->deriv2_classes[1][7][106] = int_stack + 5652;
 Libderiv->deriv2_classes[1][8][106] = int_stack + 5760;
 Libderiv->deriv2_classes[1][9][106] = int_stack + 5895;
 Libderiv->deriv2_classes[1][5][105] = int_stack + 6060;
 Libderiv->deriv2_classes[1][6][105] = int_stack + 6123;
 Libderiv->deriv2_classes[1][7][105] = int_stack + 6207;
 Libderiv->deriv2_classes[1][8][105] = int_stack + 6315;
 Libderiv->deriv2_classes[1][9][105] = int_stack + 6450;
 Libderiv->deriv2_classes[1][5][104] = int_stack + 6615;
 Libderiv->deriv2_classes[1][6][104] = int_stack + 6678;
 Libderiv->deriv2_classes[1][7][104] = int_stack + 6762;
 Libderiv->deriv2_classes[1][8][104] = int_stack + 6870;
 Libderiv->deriv2_classes[1][9][104] = int_stack + 7005;
 Libderiv->deriv2_classes[1][5][95] = int_stack + 7170;
 Libderiv->deriv2_classes[1][6][95] = int_stack + 7233;
 Libderiv->deriv2_classes[1][7][95] = int_stack + 7317;
 Libderiv->deriv2_classes[1][8][95] = int_stack + 7425;
 Libderiv->deriv2_classes[1][9][95] = int_stack + 7560;
 Libderiv->deriv2_classes[1][5][94] = int_stack + 7725;
 Libderiv->deriv2_classes[1][6][94] = int_stack + 7788;
 Libderiv->deriv2_classes[1][7][94] = int_stack + 7872;
 Libderiv->deriv2_classes[1][8][94] = int_stack + 7980;
 Libderiv->deriv2_classes[1][9][94] = int_stack + 8115;
 Libderiv->deriv2_classes[1][5][93] = int_stack + 8280;
 Libderiv->deriv2_classes[1][6][93] = int_stack + 8343;
 Libderiv->deriv2_classes[1][7][93] = int_stack + 8427;
 Libderiv->deriv2_classes[1][8][93] = int_stack + 8535;
 Libderiv->deriv2_classes[1][9][93] = int_stack + 8670;
 Libderiv->deriv2_classes[1][5][92] = int_stack + 8835;
 Libderiv->deriv2_classes[1][6][92] = int_stack + 8898;
 Libderiv->deriv2_classes[1][7][92] = int_stack + 8982;
 Libderiv->deriv2_classes[1][8][92] = int_stack + 9090;
 Libderiv->deriv2_classes[1][9][92] = int_stack + 9225;
 Libderiv->deriv2_classes[1][5][91] = int_stack + 9390;
 Libderiv->deriv2_classes[1][6][91] = int_stack + 9453;
 Libderiv->deriv2_classes[1][7][91] = int_stack + 9537;
 Libderiv->deriv2_classes[1][8][91] = int_stack + 9645;
 Libderiv->deriv2_classes[1][9][91] = int_stack + 9780;
 Libderiv->deriv_classes[1][5][11] = int_stack + 9945;
 Libderiv->deriv2_classes[1][5][83] = int_stack + 10008;
 Libderiv->deriv_classes[1][6][11] = int_stack + 10071;
 Libderiv->deriv2_classes[1][6][83] = int_stack + 10155;
 Libderiv->deriv_classes[1][7][11] = int_stack + 10239;
 Libderiv->deriv2_classes[1][7][83] = int_stack + 10347;
 Libderiv->deriv_classes[1][8][11] = int_stack + 10455;
 Libderiv->deriv2_classes[1][8][83] = int_stack + 10590;
 Libderiv->deriv2_classes[1][9][83] = int_stack + 10725;
 Libderiv->deriv_classes[1][5][10] = int_stack + 10890;
 Libderiv->deriv2_classes[1][5][82] = int_stack + 10953;
 Libderiv->deriv_classes[1][6][10] = int_stack + 11016;
 Libderiv->deriv2_classes[1][6][82] = int_stack + 11100;
 Libderiv->deriv_classes[1][7][10] = int_stack + 11184;
 Libderiv->deriv2_classes[1][7][82] = int_stack + 11292;
 Libderiv->deriv_classes[1][8][10] = int_stack + 11400;
 Libderiv->deriv2_classes[1][8][82] = int_stack + 11535;
 Libderiv->deriv2_classes[1][9][82] = int_stack + 11670;
 Libderiv->deriv_classes[1][5][9] = int_stack + 11835;
 Libderiv->deriv2_classes[1][5][81] = int_stack + 11898;
 Libderiv->deriv_classes[1][6][9] = int_stack + 11961;
 Libderiv->deriv2_classes[1][6][81] = int_stack + 12045;
 Libderiv->deriv_classes[1][7][9] = int_stack + 12129;
 Libderiv->deriv2_classes[1][7][81] = int_stack + 12237;
 Libderiv->deriv_classes[1][8][9] = int_stack + 12345;
 Libderiv->deriv2_classes[1][8][81] = int_stack + 12480;
 Libderiv->deriv2_classes[1][9][81] = int_stack + 12615;
 Libderiv->deriv_classes[1][5][8] = int_stack + 12780;
 Libderiv->deriv2_classes[1][5][80] = int_stack + 12843;
 Libderiv->deriv_classes[1][6][8] = int_stack + 12906;
 Libderiv->deriv2_classes[1][6][80] = int_stack + 12990;
 Libderiv->deriv_classes[1][7][8] = int_stack + 13074;
 Libderiv->deriv2_classes[1][7][80] = int_stack + 13182;
 Libderiv->deriv_classes[1][8][8] = int_stack + 13290;
 Libderiv->deriv2_classes[1][8][80] = int_stack + 13425;
 Libderiv->deriv2_classes[1][9][80] = int_stack + 13560;
 Libderiv->deriv_classes[1][5][7] = int_stack + 13725;
 Libderiv->deriv2_classes[1][5][79] = int_stack + 13788;
 Libderiv->deriv_classes[1][6][7] = int_stack + 13851;
 Libderiv->deriv2_classes[1][6][79] = int_stack + 13935;
 Libderiv->deriv_classes[1][7][7] = int_stack + 14019;
 Libderiv->deriv2_classes[1][7][79] = int_stack + 14127;
 Libderiv->deriv_classes[1][8][7] = int_stack + 14235;
 Libderiv->deriv2_classes[1][8][79] = int_stack + 14370;
 Libderiv->deriv2_classes[1][9][79] = int_stack + 14505;
 Libderiv->dvrr_classes[1][5] = int_stack + 14670;
 Libderiv->deriv_classes[1][5][6] = int_stack + 14733;
 Libderiv->deriv2_classes[1][5][78] = int_stack + 14796;
 Libderiv->dvrr_classes[1][6] = int_stack + 14859;
 Libderiv->deriv_classes[1][6][6] = int_stack + 14943;
 Libderiv->deriv2_classes[1][6][78] = int_stack + 15027;
 Libderiv->dvrr_classes[1][7] = int_stack + 15111;
 Libderiv->deriv_classes[1][7][6] = int_stack + 15219;
 Libderiv->deriv2_classes[1][7][78] = int_stack + 15327;
 Libderiv->deriv_classes[1][8][6] = int_stack + 15435;
 Libderiv->deriv2_classes[1][8][78] = int_stack + 15570;
 Libderiv->deriv2_classes[1][9][78] = int_stack + 15705;
 Libderiv->deriv2_classes[1][5][35] = int_stack + 15870;
 Libderiv->deriv2_classes[1][6][35] = int_stack + 15933;
 Libderiv->deriv2_classes[1][7][35] = int_stack + 16017;
 Libderiv->deriv2_classes[1][8][35] = int_stack + 16125;
 Libderiv->deriv2_classes[1][9][35] = int_stack + 16260;
 Libderiv->deriv2_classes[1][5][34] = int_stack + 16425;
 Libderiv->deriv2_classes[1][6][34] = int_stack + 16488;
 Libderiv->deriv2_classes[1][7][34] = int_stack + 16572;
 Libderiv->deriv2_classes[1][8][34] = int_stack + 16680;
 Libderiv->deriv2_classes[1][9][34] = int_stack + 16815;
 Libderiv->deriv2_classes[1][5][33] = int_stack + 16980;
 Libderiv->deriv2_classes[1][6][33] = int_stack + 17043;
 Libderiv->deriv2_classes[1][7][33] = int_stack + 17127;
 Libderiv->deriv2_classes[1][8][33] = int_stack + 17235;
 Libderiv->deriv2_classes[1][9][33] = int_stack + 17370;
 Libderiv->deriv2_classes[1][5][32] = int_stack + 17535;
 Libderiv->deriv2_classes[1][6][32] = int_stack + 17598;
 Libderiv->deriv2_classes[1][7][32] = int_stack + 17682;
 Libderiv->deriv2_classes[1][8][32] = int_stack + 17790;
 Libderiv->deriv2_classes[1][9][32] = int_stack + 17925;
 Libderiv->deriv2_classes[1][5][31] = int_stack + 18090;
 Libderiv->deriv2_classes[1][6][31] = int_stack + 18153;
 Libderiv->deriv2_classes[1][7][31] = int_stack + 18237;
 Libderiv->deriv2_classes[1][8][31] = int_stack + 18345;
 Libderiv->deriv2_classes[1][9][31] = int_stack + 18480;
 Libderiv->deriv_classes[1][5][2] = int_stack + 18645;
 Libderiv->deriv2_classes[1][5][30] = int_stack + 18708;
 Libderiv->deriv_classes[1][6][2] = int_stack + 18771;
 Libderiv->deriv2_classes[1][6][30] = int_stack + 18855;
 Libderiv->deriv_classes[1][7][2] = int_stack + 18939;
 Libderiv->deriv2_classes[1][7][30] = int_stack + 19047;
 Libderiv->deriv_classes[1][8][2] = int_stack + 19155;
 Libderiv->deriv2_classes[1][8][30] = int_stack + 19290;
 Libderiv->deriv2_classes[1][9][30] = int_stack + 19425;
 Libderiv->deriv2_classes[1][5][26] = int_stack + 19590;
 Libderiv->deriv2_classes[1][6][26] = int_stack + 19653;
 Libderiv->deriv2_classes[1][7][26] = int_stack + 19737;
 Libderiv->deriv2_classes[1][8][26] = int_stack + 19845;
 Libderiv->deriv2_classes[1][9][26] = int_stack + 19980;
 Libderiv->deriv2_classes[1][5][23] = int_stack + 20145;
 Libderiv->deriv2_classes[1][6][23] = int_stack + 20208;
 Libderiv->deriv2_classes[1][7][23] = int_stack + 20292;
 Libderiv->deriv2_classes[1][8][23] = int_stack + 20400;
 Libderiv->deriv2_classes[1][9][23] = int_stack + 20535;
 Libderiv->deriv2_classes[1][5][22] = int_stack + 20700;
 Libderiv->deriv2_classes[1][6][22] = int_stack + 20763;
 Libderiv->deriv2_classes[1][7][22] = int_stack + 20847;
 Libderiv->deriv2_classes[1][8][22] = int_stack + 20955;
 Libderiv->deriv2_classes[1][9][22] = int_stack + 21090;
 Libderiv->deriv2_classes[1][5][21] = int_stack + 21255;
 Libderiv->deriv2_classes[1][6][21] = int_stack + 21318;
 Libderiv->deriv2_classes[1][7][21] = int_stack + 21402;
 Libderiv->deriv2_classes[1][8][21] = int_stack + 21510;
 Libderiv->deriv2_classes[1][9][21] = int_stack + 21645;
 Libderiv->deriv2_classes[1][5][20] = int_stack + 21810;
 Libderiv->deriv2_classes[1][6][20] = int_stack + 21873;
 Libderiv->deriv2_classes[1][7][20] = int_stack + 21957;
 Libderiv->deriv2_classes[1][8][20] = int_stack + 22065;
 Libderiv->deriv2_classes[1][9][20] = int_stack + 22200;
 Libderiv->deriv2_classes[1][5][19] = int_stack + 22365;
 Libderiv->deriv2_classes[1][6][19] = int_stack + 22428;
 Libderiv->deriv2_classes[1][7][19] = int_stack + 22512;
 Libderiv->deriv2_classes[1][8][19] = int_stack + 22620;
 Libderiv->deriv2_classes[1][9][19] = int_stack + 22755;
 Libderiv->deriv_classes[1][5][1] = int_stack + 22920;
 Libderiv->deriv2_classes[1][5][18] = int_stack + 22983;
 Libderiv->deriv_classes[1][6][1] = int_stack + 23046;
 Libderiv->deriv2_classes[1][6][18] = int_stack + 23130;
 Libderiv->deriv_classes[1][7][1] = int_stack + 23214;
 Libderiv->deriv2_classes[1][7][18] = int_stack + 23322;
 Libderiv->deriv_classes[1][8][1] = int_stack + 23430;
 Libderiv->deriv2_classes[1][8][18] = int_stack + 23565;
 Libderiv->deriv2_classes[1][9][18] = int_stack + 23700;
 Libderiv->deriv2_classes[1][5][14] = int_stack + 23865;
 Libderiv->deriv2_classes[1][6][14] = int_stack + 23928;
 Libderiv->deriv2_classes[1][7][14] = int_stack + 24012;
 Libderiv->deriv2_classes[1][8][14] = int_stack + 24120;
 Libderiv->deriv2_classes[1][9][14] = int_stack + 24255;
 Libderiv->deriv2_classes[1][5][13] = int_stack + 24420;
 Libderiv->deriv2_classes[1][6][13] = int_stack + 24483;
 Libderiv->deriv2_classes[1][7][13] = int_stack + 24567;
 Libderiv->deriv2_classes[1][8][13] = int_stack + 24675;
 Libderiv->deriv2_classes[1][9][13] = int_stack + 24810;
 Libderiv->deriv2_classes[1][5][11] = int_stack + 24975;
 Libderiv->deriv2_classes[1][6][11] = int_stack + 25038;
 Libderiv->deriv2_classes[1][7][11] = int_stack + 25122;
 Libderiv->deriv2_classes[1][8][11] = int_stack + 25230;
 Libderiv->deriv2_classes[1][9][11] = int_stack + 25365;
 Libderiv->deriv2_classes[1][5][10] = int_stack + 25530;
 Libderiv->deriv2_classes[1][6][10] = int_stack + 25593;
 Libderiv->deriv2_classes[1][7][10] = int_stack + 25677;
 Libderiv->deriv2_classes[1][8][10] = int_stack + 25785;
 Libderiv->deriv2_classes[1][9][10] = int_stack + 25920;
 Libderiv->deriv2_classes[1][5][9] = int_stack + 26085;
 Libderiv->deriv2_classes[1][6][9] = int_stack + 26148;
 Libderiv->deriv2_classes[1][7][9] = int_stack + 26232;
 Libderiv->deriv2_classes[1][8][9] = int_stack + 26340;
 Libderiv->deriv2_classes[1][9][9] = int_stack + 26475;
 Libderiv->deriv2_classes[1][5][8] = int_stack + 26640;
 Libderiv->deriv2_classes[1][6][8] = int_stack + 26703;
 Libderiv->deriv2_classes[1][7][8] = int_stack + 26787;
 Libderiv->deriv2_classes[1][8][8] = int_stack + 26895;
 Libderiv->deriv2_classes[1][9][8] = int_stack + 27030;
 Libderiv->deriv2_classes[1][5][7] = int_stack + 27195;
 Libderiv->deriv2_classes[1][6][7] = int_stack + 27258;
 Libderiv->deriv2_classes[1][7][7] = int_stack + 27342;
 Libderiv->deriv2_classes[1][8][7] = int_stack + 27450;
 Libderiv->deriv2_classes[1][9][7] = int_stack + 27585;
 Libderiv->deriv_classes[1][5][0] = int_stack + 27750;
 Libderiv->deriv2_classes[1][5][6] = int_stack + 27813;
 Libderiv->deriv_classes[1][6][0] = int_stack + 27876;
 Libderiv->deriv2_classes[1][6][6] = int_stack + 27960;
 Libderiv->deriv_classes[1][7][0] = int_stack + 28044;
 Libderiv->deriv2_classes[1][7][6] = int_stack + 28152;
 Libderiv->deriv_classes[1][8][0] = int_stack + 28260;
 Libderiv->deriv2_classes[1][8][6] = int_stack + 28395;
 Libderiv->deriv2_classes[1][9][6] = int_stack + 28530;
 Libderiv->deriv2_classes[1][5][2] = int_stack + 28695;
 Libderiv->deriv2_classes[1][6][2] = int_stack + 28758;
 Libderiv->deriv2_classes[1][7][2] = int_stack + 28842;
 Libderiv->deriv2_classes[1][8][2] = int_stack + 28950;
 Libderiv->deriv2_classes[1][9][2] = int_stack + 29085;
 Libderiv->deriv2_classes[1][5][1] = int_stack + 29250;
 Libderiv->deriv2_classes[1][6][1] = int_stack + 29313;
 Libderiv->deriv2_classes[1][7][1] = int_stack + 29397;
 Libderiv->deriv2_classes[1][8][1] = int_stack + 29505;
 Libderiv->deriv2_classes[1][9][1] = int_stack + 29640;
 Libderiv->deriv2_classes[1][5][0] = int_stack + 29805;
 Libderiv->deriv2_classes[1][6][0] = int_stack + 29868;
 Libderiv->deriv2_classes[1][7][0] = int_stack + 29952;
 Libderiv->deriv2_classes[1][8][0] = int_stack + 30060;
 Libderiv->deriv2_classes[1][9][0] = int_stack + 30195;
 memset(int_stack,0,242880);

 Libderiv->dvrr_stack = int_stack + 87918;
 for(i=0;i<num_prim_comb;i++) {
   d12vrr_order_p0hg(Libderiv, Data);
   Data++;
 }

 /*--- compute (p0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+30360,int_stack+14859,int_stack+14670,3);
 /*--- compute (p0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+30549,int_stack+15111,int_stack+14859,3);
 /*--- compute (p0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+30801,int_stack+30549,int_stack+30360,3);
 /*--- compute (p0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+31179,int_stack+825,int_stack+15111,3);
 /*--- compute (p0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+31503,int_stack+31179,int_stack+30549,3);
 /*--- compute (p0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+32007,int_stack+31503,int_stack+30801,3);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+32637,int_stack+10071,int_stack+9945, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+14670,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+32826,int_stack+10239,int_stack+10071, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+14859,3);
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+33078,int_stack+32826,int_stack+32637, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+30360,3);
 /*--- compute (p0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+33456,int_stack+10455,int_stack+10239, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+15111,3);
 /*--- compute (p0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+33780,int_stack+33456,int_stack+32826, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+30549,3);
 /*--- compute (p0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+34284,int_stack+33780,int_stack+33078, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+30801,3);
 /*--- compute (p0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+34914,int_stack+0,int_stack+10455, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+825,3);
 /*--- compute (p0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+35319,int_stack+34914,int_stack+33456, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+31179,3);
 /*--- compute (p0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+35967,int_stack+35319,int_stack+33780, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+31503,3);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+34914,int_stack+11016,int_stack+10890, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+14670, 0.0, zero_stack,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+35103,int_stack+11184,int_stack+11016, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+14859, 0.0, zero_stack,3);
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+35355,int_stack+35103,int_stack+34914, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+30360, 0.0, zero_stack,3);
 /*--- compute (p0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+36807,int_stack+11400,int_stack+11184, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+15111, 0.0, zero_stack,3);
 /*--- compute (p0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+37131,int_stack+36807,int_stack+35103, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+30549, 0.0, zero_stack,3);
 /*--- compute (p0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+37635,int_stack+37131,int_stack+35355, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+30801, 0.0, zero_stack,3);
 /*--- compute (p0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+38265,int_stack+165,int_stack+11400, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+825, 0.0, zero_stack,3);
 /*--- compute (p0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+38670,int_stack+38265,int_stack+36807, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+31179, 0.0, zero_stack,3);
 /*--- compute (p0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+39318,int_stack+38670,int_stack+37131, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+31503, 0.0, zero_stack,3);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+38265,int_stack+11961,int_stack+11835, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+14670, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+38454,int_stack+12129,int_stack+11961, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+14859, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+38706,int_stack+38454,int_stack+38265, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+30360, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+0,int_stack+12345,int_stack+12129, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+15111, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+40158,int_stack+0,int_stack+38454, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+30549, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+40662,int_stack+40158,int_stack+38706, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+30801, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+41292,int_stack+330,int_stack+12345, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+825, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+41697,int_stack+41292,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+31179, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+42345,int_stack+41697,int_stack+40158, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+31503, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+41292,int_stack+12906,int_stack+12780, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+14670, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+41481,int_stack+13074,int_stack+12906, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+14859, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+41733,int_stack+41481,int_stack+41292, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+30360, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+43185,int_stack+13290,int_stack+13074, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+15111, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+43509,int_stack+43185,int_stack+41481, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+30549, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+44013,int_stack+43509,int_stack+41733, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+30801, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+44643,int_stack+495,int_stack+13290, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+825, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+45048,int_stack+44643,int_stack+43185, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+31179, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+45696,int_stack+45048,int_stack+43509, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+31503, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+44643,int_stack+13851,int_stack+13725, 0.0, zero_stack, 1.0, int_stack+14670, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+44832,int_stack+14019,int_stack+13851, 0.0, zero_stack, 1.0, int_stack+14859, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+45084,int_stack+44832,int_stack+44643, 0.0, zero_stack, 1.0, int_stack+30360, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+324,int_stack+14235,int_stack+14019, 0.0, zero_stack, 1.0, int_stack+15111, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+46536,int_stack+324,int_stack+44832, 0.0, zero_stack, 1.0, int_stack+30549, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+47040,int_stack+46536,int_stack+45084, 0.0, zero_stack, 1.0, int_stack+30801, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+47670,int_stack+660,int_stack+14235, 0.0, zero_stack, 1.0, int_stack+825, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+48075,int_stack+47670,int_stack+324, 0.0, zero_stack, 1.0, int_stack+31179, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+48723,int_stack+48075,int_stack+46536, 0.0, zero_stack, 1.0, int_stack+31503, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+47670,int_stack+14943,int_stack+14733, 1.0, int_stack+14670, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+47859,int_stack+15219,int_stack+14943, 1.0, int_stack+14859, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+48111,int_stack+47859,int_stack+47670, 1.0, int_stack+30360, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+49563,int_stack+15435,int_stack+15219, 1.0, int_stack+15111, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+49887,int_stack+49563,int_stack+47859, 1.0, int_stack+30549, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+50391,int_stack+49887,int_stack+48111, 1.0, int_stack+30801, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+30360,int_stack+960,int_stack+15435, 1.0, int_stack+825, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+51021,int_stack+30360,int_stack+49563, 1.0, int_stack+31179, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+30360,int_stack+51021,int_stack+49887, 1.0, int_stack+31503, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+51021,int_stack+18771,int_stack+18645,3);
 /*--- compute (p0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+51210,int_stack+18939,int_stack+18771,3);
 /*--- compute (p0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+51462,int_stack+51210,int_stack+51021,3);
 /*--- compute (p0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+31200,int_stack+19155,int_stack+18939,3);
 /*--- compute (p0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+51840,int_stack+31200,int_stack+51210,3);
 /*--- compute (p0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+52344,int_stack+51840,int_stack+51462,3);
 /*--- compute (p0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+31524,int_stack+1125,int_stack+19155,3);
 /*--- compute (p0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+52974,int_stack+31524,int_stack+31200,3);
 /*--- compute (p0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+53622,int_stack+52974,int_stack+51840,3);
 /*--- compute (p0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+52974,int_stack+23046,int_stack+22920,3);
 /*--- compute (p0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+53163,int_stack+23214,int_stack+23046,3);
 /*--- compute (p0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+31524,int_stack+53163,int_stack+52974,3);
 /*--- compute (p0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+54462,int_stack+23430,int_stack+23214,3);
 /*--- compute (p0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+648,int_stack+54462,int_stack+53163,3);
 /*--- compute (p0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+54786,int_stack+648,int_stack+31524,3);
 /*--- compute (p0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+55416,int_stack+1290,int_stack+23430,3);
 /*--- compute (p0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+55821,int_stack+55416,int_stack+54462,3);
 /*--- compute (p0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+56469,int_stack+55821,int_stack+648,3);
 /*--- compute (p0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+55416,int_stack+27876,int_stack+27750,3);
 /*--- compute (p0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+55605,int_stack+28044,int_stack+27876,3);
 /*--- compute (p0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+55857,int_stack+55605,int_stack+55416,3);
 /*--- compute (p0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+57309,int_stack+28260,int_stack+28044,3);
 /*--- compute (p0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+57633,int_stack+57309,int_stack+55605,3);
 /*--- compute (p0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+58137,int_stack+57633,int_stack+55857,3);
 /*--- compute (p0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+58767,int_stack+1455,int_stack+28260,3);
 /*--- compute (p0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+59172,int_stack+58767,int_stack+57309,3);
 /*--- compute (p0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+59820,int_stack+59172,int_stack+57633,3);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+58767,int_stack+1683,int_stack+1620, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+9945,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+58956,int_stack+1767,int_stack+1683, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+10071,3);
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+59208,int_stack+58956,int_stack+58767, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+32637,3);
 /*--- compute (p0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+60660,int_stack+1875,int_stack+1767, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+10239,3);
 /*--- compute (p0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1152,int_stack+60660,int_stack+58956, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+32826,3);
 /*--- compute (p0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+60984,int_stack+1152,int_stack+59208, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+33078,3);
 /*--- compute (p0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+58767,int_stack+2010,int_stack+1875, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+10455,3);
 /*--- compute (p0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+59172,int_stack+58767,int_stack+60660, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+33456,3);
 /*--- compute (p0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+61614,int_stack+59172,int_stack+1152, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+33780,3);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1152,int_stack+2238,int_stack+2175, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+9945, 1.0, int_stack+10890,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1341,int_stack+2322,int_stack+2238, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+10071, 1.0, int_stack+11016,3);
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1593,int_stack+1341,int_stack+1152, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+32637, 1.0, int_stack+34914,3);
 /*--- compute (p0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+60660,int_stack+2430,int_stack+2322, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+10239, 1.0, int_stack+11184,3);
 /*--- compute (p0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+58767,int_stack+60660,int_stack+1341, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+32826, 1.0, int_stack+35103,3);
 /*--- compute (p0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+62454,int_stack+58767,int_stack+1593, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+33078, 1.0, int_stack+35355,3);
 /*--- compute (p0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1152,int_stack+2565,int_stack+2430, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+10455, 1.0, int_stack+11400,3);
 /*--- compute (p0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1557,int_stack+1152,int_stack+60660, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+33456, 1.0, int_stack+36807,3);
 /*--- compute (p0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+63084,int_stack+1557,int_stack+58767, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+33780, 1.0, int_stack+37131,3);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+58767,int_stack+2793,int_stack+2730, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+10890, 0.0, zero_stack,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+58956,int_stack+2877,int_stack+2793, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+11016, 0.0, zero_stack,3);
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+59208,int_stack+58956,int_stack+58767, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+34914, 0.0, zero_stack,3);
 /*--- compute (p0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+60660,int_stack+2985,int_stack+2877, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+11184, 0.0, zero_stack,3);
 /*--- compute (p0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1152,int_stack+60660,int_stack+58956, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+35103, 0.0, zero_stack,3);
 /*--- compute (p0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1656,int_stack+1152,int_stack+59208, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+35355, 0.0, zero_stack,3);
 /*--- compute (p0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+58767,int_stack+3120,int_stack+2985, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+11400, 0.0, zero_stack,3);
 /*--- compute (p0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+59172,int_stack+58767,int_stack+60660, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+36807, 0.0, zero_stack,3);
 /*--- compute (p0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+2286,int_stack+59172,int_stack+1152, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+37131, 0.0, zero_stack,3);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1152,int_stack+3348,int_stack+3285, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+9945, 0.0, zero_stack, 1.0, int_stack+11835,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1341,int_stack+3432,int_stack+3348, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+10071, 0.0, zero_stack, 1.0, int_stack+11961,3);
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+58767,int_stack+1341,int_stack+1152, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+32637, 0.0, zero_stack, 1.0, int_stack+38265,3);
 /*--- compute (p0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+60660,int_stack+3540,int_stack+3432, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+10239, 0.0, zero_stack, 1.0, int_stack+12129,3);
 /*--- compute (p0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+59145,int_stack+60660,int_stack+1341, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+32826, 0.0, zero_stack, 1.0, int_stack+38454,3);
 /*--- compute (p0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+63924,int_stack+59145,int_stack+58767, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+33078, 0.0, zero_stack, 1.0, int_stack+38706,3);
 /*--- compute (p0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1152,int_stack+3675,int_stack+3540, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+10455, 0.0, zero_stack, 1.0, int_stack+12345,3);
 /*--- compute (p0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+3126,int_stack+1152,int_stack+60660, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+33456, 0.0, zero_stack, 1.0, int_stack+0,3);
 /*--- compute (p0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+64554,int_stack+3126,int_stack+59145, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+33780, 0.0, zero_stack, 1.0, int_stack+40158,3);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+3126,int_stack+3903,int_stack+3840, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+10890, 1.0, int_stack+11835, 0.0, zero_stack,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+3315,int_stack+3987,int_stack+3903, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+11016, 1.0, int_stack+11961, 0.0, zero_stack,3);
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+3567,int_stack+3315,int_stack+3126, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+34914, 1.0, int_stack+38265, 0.0, zero_stack,3);
 /*--- compute (p0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+60660,int_stack+4095,int_stack+3987, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+11184, 1.0, int_stack+12129, 0.0, zero_stack,3);
 /*--- compute (p0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1152,int_stack+60660,int_stack+3315, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+35103, 1.0, int_stack+38454, 0.0, zero_stack,3);
 /*--- compute (p0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+58767,int_stack+1152,int_stack+3567, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+35355, 1.0, int_stack+38706, 0.0, zero_stack,3);
 /*--- compute (p0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+3126,int_stack+4230,int_stack+4095, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+11400, 1.0, int_stack+12345, 0.0, zero_stack,3);
 /*--- compute (p0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+3531,int_stack+3126,int_stack+60660, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+36807, 1.0, int_stack+0, 0.0, zero_stack,3);
 /*--- compute (p0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+65394,int_stack+3531,int_stack+1152, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+37131, 1.0, int_stack+40158, 0.0, zero_stack,3);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1152,int_stack+4458,int_stack+4395, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+11835, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1341,int_stack+4542,int_stack+4458, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+11961, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+3126,int_stack+1341,int_stack+1152, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+38265, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+60660,int_stack+4650,int_stack+4542, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+12129, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+3504,int_stack+60660,int_stack+1341, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+38454, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+4008,int_stack+3504,int_stack+3126, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+38706, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1152,int_stack+4785,int_stack+4650, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+12345, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+66234,int_stack+1152,int_stack+60660, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+66882,int_stack+66234,int_stack+3504, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+40158, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+66234,int_stack+5013,int_stack+4950, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+9945, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+12780,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+66423,int_stack+5097,int_stack+5013, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+10071, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+12906,3);
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1152,int_stack+66423,int_stack+66234, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+32637, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+41292,3);
 /*--- compute (p0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+60660,int_stack+5205,int_stack+5097, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+10239, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+13074,3);
 /*--- compute (p0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+3126,int_stack+60660,int_stack+66423, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+32826, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+41481,3);
 /*--- compute (p0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+66234,int_stack+3126,int_stack+1152, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+33078, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+41733,3);
 /*--- compute (p0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1152,int_stack+5340,int_stack+5205, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+10455, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+13290,3);
 /*--- compute (p0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+4638,int_stack+1152,int_stack+60660, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+33456, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+43185,3);
 /*--- compute (p0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+67722,int_stack+4638,int_stack+3126, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+33780, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+43509,3);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+3126,int_stack+5568,int_stack+5505, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+10890, 0.0, zero_stack, 1.0, int_stack+12780, 0.0, zero_stack,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+3315,int_stack+5652,int_stack+5568, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+11016, 0.0, zero_stack, 1.0, int_stack+12906, 0.0, zero_stack,3);
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+3567,int_stack+3315,int_stack+3126, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+34914, 0.0, zero_stack, 1.0, int_stack+41292, 0.0, zero_stack,3);
 /*--- compute (p0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+60660,int_stack+5760,int_stack+5652, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+11184, 0.0, zero_stack, 1.0, int_stack+13074, 0.0, zero_stack,3);
 /*--- compute (p0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1152,int_stack+60660,int_stack+3315, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+35103, 0.0, zero_stack, 1.0, int_stack+41481, 0.0, zero_stack,3);
 /*--- compute (p0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+4638,int_stack+1152,int_stack+3567, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+35355, 0.0, zero_stack, 1.0, int_stack+41733, 0.0, zero_stack,3);
 /*--- compute (p0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+3126,int_stack+5895,int_stack+5760, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+11400, 0.0, zero_stack, 1.0, int_stack+13290, 0.0, zero_stack,3);
 /*--- compute (p0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+5268,int_stack+3126,int_stack+60660, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+36807, 0.0, zero_stack, 1.0, int_stack+43185, 0.0, zero_stack,3);
 /*--- compute (p0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+3126,int_stack+5268,int_stack+1152, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+37131, 0.0, zero_stack, 1.0, int_stack+43509, 0.0, zero_stack,3);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1152,int_stack+6123,int_stack+6060, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+11835, 1.0, int_stack+12780, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1341,int_stack+6207,int_stack+6123, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+11961, 1.0, int_stack+12906, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+5268,int_stack+1341,int_stack+1152, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+38265, 1.0, int_stack+41292, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+60660,int_stack+6315,int_stack+6207, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+12129, 1.0, int_stack+13074, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+5646,int_stack+60660,int_stack+1341, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+38454, 1.0, int_stack+41481, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+68562,int_stack+5646,int_stack+5268, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+38706, 1.0, int_stack+41733, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1152,int_stack+6450,int_stack+6315, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+12345, 1.0, int_stack+13290, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+69192,int_stack+1152,int_stack+60660, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+0, 1.0, int_stack+43185, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+69840,int_stack+69192,int_stack+5646, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+40158, 1.0, int_stack+43509, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+69192,int_stack+6678,int_stack+6615, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+12780, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+69381,int_stack+6762,int_stack+6678, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+12906, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1152,int_stack+69381,int_stack+69192, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+41292, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+60660,int_stack+6870,int_stack+6762, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+13074, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+5268,int_stack+60660,int_stack+69381, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+41481, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+69192,int_stack+5268,int_stack+1152, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+41733, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1152,int_stack+7005,int_stack+6870, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+13290, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+5772,int_stack+1152,int_stack+60660, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+43185, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+70680,int_stack+5772,int_stack+5268, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+43509, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+5268,int_stack+7233,int_stack+7170, 0.0, zero_stack, 1.0, int_stack+9945, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+13725,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+5457,int_stack+7317,int_stack+7233, 0.0, zero_stack, 1.0, int_stack+10071, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+13851,3);
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+5709,int_stack+5457,int_stack+5268, 0.0, zero_stack, 1.0, int_stack+32637, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+44643,3);
 /*--- compute (p0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+60660,int_stack+7425,int_stack+7317, 0.0, zero_stack, 1.0, int_stack+10239, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+14019,3);
 /*--- compute (p0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1152,int_stack+60660,int_stack+5457, 0.0, zero_stack, 1.0, int_stack+32826, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+44832,3);
 /*--- compute (p0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+6087,int_stack+1152,int_stack+5709, 0.0, zero_stack, 1.0, int_stack+33078, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+45084,3);
 /*--- compute (p0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+5268,int_stack+7560,int_stack+7425, 0.0, zero_stack, 1.0, int_stack+10455, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+14235,3);
 /*--- compute (p0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+6717,int_stack+5268,int_stack+60660, 0.0, zero_stack, 1.0, int_stack+33456, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+324,3);
 /*--- compute (p0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+71520,int_stack+6717,int_stack+1152, 0.0, zero_stack, 1.0, int_stack+33780, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+46536,3);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1152,int_stack+7788,int_stack+7725, 0.0, zero_stack, 1.0, int_stack+10890, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+13725, 0.0, zero_stack,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1341,int_stack+7872,int_stack+7788, 0.0, zero_stack, 1.0, int_stack+11016, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+13851, 0.0, zero_stack,3);
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+6717,int_stack+1341,int_stack+1152, 0.0, zero_stack, 1.0, int_stack+34914, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+44643, 0.0, zero_stack,3);
 /*--- compute (p0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+60660,int_stack+7980,int_stack+7872, 0.0, zero_stack, 1.0, int_stack+11184, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+14019, 0.0, zero_stack,3);
 /*--- compute (p0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+7095,int_stack+60660,int_stack+1341, 0.0, zero_stack, 1.0, int_stack+35103, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+44832, 0.0, zero_stack,3);
 /*--- compute (p0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+5268,int_stack+7095,int_stack+6717, 0.0, zero_stack, 1.0, int_stack+35355, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+45084, 0.0, zero_stack,3);
 /*--- compute (p0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1152,int_stack+8115,int_stack+7980, 0.0, zero_stack, 1.0, int_stack+11400, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+14235, 0.0, zero_stack,3);
 /*--- compute (p0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+7599,int_stack+1152,int_stack+60660, 0.0, zero_stack, 1.0, int_stack+36807, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+324, 0.0, zero_stack,3);
 /*--- compute (p0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+72360,int_stack+7599,int_stack+7095, 0.0, zero_stack, 1.0, int_stack+37131, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+46536, 0.0, zero_stack,3);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+5898,int_stack+8343,int_stack+8280, 0.0, zero_stack, 1.0, int_stack+11835, 0.0, zero_stack, 1.0, int_stack+13725, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+60660,int_stack+8427,int_stack+8343, 0.0, zero_stack, 1.0, int_stack+11961, 0.0, zero_stack, 1.0, int_stack+13851, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1152,int_stack+60660,int_stack+5898, 0.0, zero_stack, 1.0, int_stack+38265, 0.0, zero_stack, 1.0, int_stack+44643, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+6717,int_stack+8535,int_stack+8427, 0.0, zero_stack, 1.0, int_stack+12129, 0.0, zero_stack, 1.0, int_stack+14019, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+7041,int_stack+6717,int_stack+60660, 0.0, zero_stack, 1.0, int_stack+38454, 0.0, zero_stack, 1.0, int_stack+44832, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+7545,int_stack+7041,int_stack+1152, 0.0, zero_stack, 1.0, int_stack+38706, 0.0, zero_stack, 1.0, int_stack+45084, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1152,int_stack+8670,int_stack+8535, 0.0, zero_stack, 1.0, int_stack+12345, 0.0, zero_stack, 1.0, int_stack+14235, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+8175,int_stack+1152,int_stack+6717, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack, 1.0, int_stack+324, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+73200,int_stack+8175,int_stack+7041, 0.0, zero_stack, 1.0, int_stack+40158, 0.0, zero_stack, 1.0, int_stack+46536, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+5898,int_stack+8898,int_stack+8835, 0.0, zero_stack, 1.0, int_stack+12780, 1.0, int_stack+13725, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+8175,int_stack+8982,int_stack+8898, 0.0, zero_stack, 1.0, int_stack+12906, 1.0, int_stack+13851, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+8427,int_stack+8175,int_stack+5898, 0.0, zero_stack, 1.0, int_stack+41292, 1.0, int_stack+44643, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+60660,int_stack+9090,int_stack+8982, 0.0, zero_stack, 1.0, int_stack+13074, 1.0, int_stack+14019, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1152,int_stack+60660,int_stack+8175, 0.0, zero_stack, 1.0, int_stack+41481, 1.0, int_stack+44832, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+6717,int_stack+1152,int_stack+8427, 0.0, zero_stack, 1.0, int_stack+41733, 1.0, int_stack+45084, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+8175,int_stack+9225,int_stack+9090, 0.0, zero_stack, 1.0, int_stack+13290, 1.0, int_stack+14235, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+8580,int_stack+8175,int_stack+60660, 0.0, zero_stack, 1.0, int_stack+43185, 1.0, int_stack+324, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+74040,int_stack+8580,int_stack+1152, 0.0, zero_stack, 1.0, int_stack+43509, 1.0, int_stack+46536, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+5898,int_stack+9453,int_stack+9390, 0.0, zero_stack, 2.0, int_stack+13725, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1152,int_stack+9537,int_stack+9453, 0.0, zero_stack, 2.0, int_stack+13851, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+8175,int_stack+1152,int_stack+5898, 0.0, zero_stack, 2.0, int_stack+44643, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+60660,int_stack+9645,int_stack+9537, 0.0, zero_stack, 2.0, int_stack+14019, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+8553,int_stack+60660,int_stack+1152, 0.0, zero_stack, 2.0, int_stack+44832, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+74880,int_stack+8553,int_stack+8175, 0.0, zero_stack, 2.0, int_stack+45084, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1152,int_stack+9780,int_stack+9645, 0.0, zero_stack, 2.0, int_stack+14235, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+9057,int_stack+1152,int_stack+60660, 0.0, zero_stack, 2.0, int_stack+324, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+75510,int_stack+9057,int_stack+8553, 0.0, zero_stack, 2.0, int_stack+46536, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+5898,int_stack+10155,int_stack+10008, 1.0, int_stack+9945, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+14733,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+60660,int_stack+10347,int_stack+10155, 1.0, int_stack+10071, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+14943,3);
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1152,int_stack+60660,int_stack+5898, 1.0, int_stack+32637, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+47670,3);
 /*--- compute (p0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+8175,int_stack+10590,int_stack+10347, 1.0, int_stack+10239, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+15219,3);
 /*--- compute (p0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+8499,int_stack+8175,int_stack+60660, 1.0, int_stack+32826, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+47859,3);
 /*--- compute (p0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+9003,int_stack+8499,int_stack+1152, 1.0, int_stack+33078, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+48111,3);
 /*--- compute (p0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1152,int_stack+10725,int_stack+10590, 1.0, int_stack+10455, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+15435,3);
 /*--- compute (p0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+32637,int_stack+1152,int_stack+8175, 1.0, int_stack+33456, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+49563,3);
 /*--- compute (p0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+9633,int_stack+32637,int_stack+8499, 1.0, int_stack+33780, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+49887,3);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+5898,int_stack+11100,int_stack+10953, 1.0, int_stack+10890, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+14733, 0.0, zero_stack,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+32637,int_stack+11292,int_stack+11100, 1.0, int_stack+11016, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+14943, 0.0, zero_stack,3);
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+32889,int_stack+32637,int_stack+5898, 1.0, int_stack+34914, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+47670, 0.0, zero_stack,3);
 /*--- compute (p0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+60660,int_stack+11535,int_stack+11292, 1.0, int_stack+11184, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+15219, 0.0, zero_stack,3);
 /*--- compute (p0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1152,int_stack+60660,int_stack+32637, 1.0, int_stack+35103, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+47859, 0.0, zero_stack,3);
 /*--- compute (p0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+33267,int_stack+1152,int_stack+32889, 1.0, int_stack+35355, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+48111, 0.0, zero_stack,3);
 /*--- compute (p0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+32637,int_stack+11670,int_stack+11535, 1.0, int_stack+11400, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+15435, 0.0, zero_stack,3);
 /*--- compute (p0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+34914,int_stack+32637,int_stack+60660, 1.0, int_stack+36807, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+49563, 0.0, zero_stack,3);
 /*--- compute (p0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+10473,int_stack+34914,int_stack+1152, 1.0, int_stack+37131, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+49887, 0.0, zero_stack,3);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+5898,int_stack+12045,int_stack+11898, 1.0, int_stack+11835, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+14733, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1152,int_stack+12237,int_stack+12045, 1.0, int_stack+11961, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+14943, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+34914,int_stack+1152,int_stack+5898, 1.0, int_stack+38265, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+47670, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+60660,int_stack+12480,int_stack+12237, 1.0, int_stack+12129, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+15219, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+35292,int_stack+60660,int_stack+1152, 1.0, int_stack+38454, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+47859, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+32637,int_stack+35292,int_stack+34914, 1.0, int_stack+38706, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+48111, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1152,int_stack+12615,int_stack+12480, 1.0, int_stack+12345, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+15435, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+38265,int_stack+1152,int_stack+60660, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+49563, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+11313,int_stack+38265,int_stack+35292, 1.0, int_stack+40158, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+49887, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+5898,int_stack+12990,int_stack+12843, 1.0, int_stack+12780, 0.0, zero_stack, 1.0, int_stack+14733, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+40158,int_stack+13182,int_stack+12990, 1.0, int_stack+12906, 0.0, zero_stack, 1.0, int_stack+14943, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+38265,int_stack+40158,int_stack+5898, 1.0, int_stack+41292, 0.0, zero_stack, 1.0, int_stack+47670, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+0,int_stack+13425,int_stack+13182, 1.0, int_stack+13074, 0.0, zero_stack, 1.0, int_stack+15219, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1152,int_stack+0,int_stack+40158, 1.0, int_stack+41481, 0.0, zero_stack, 1.0, int_stack+47859, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+38643,int_stack+1152,int_stack+38265, 1.0, int_stack+41733, 0.0, zero_stack, 1.0, int_stack+48111, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+40158,int_stack+13560,int_stack+13425, 1.0, int_stack+13290, 0.0, zero_stack, 1.0, int_stack+15435, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+41292,int_stack+40158,int_stack+0, 1.0, int_stack+43185, 0.0, zero_stack, 1.0, int_stack+49563, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+34914,int_stack+41292,int_stack+1152, 1.0, int_stack+43509, 0.0, zero_stack, 1.0, int_stack+49887, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+5898,int_stack+13935,int_stack+13788, 1.0, int_stack+13725, 1.0, int_stack+14733, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1152,int_stack+14127,int_stack+13935, 1.0, int_stack+13851, 1.0, int_stack+14943, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+38265,int_stack+1152,int_stack+5898, 1.0, int_stack+44643, 1.0, int_stack+47670, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+0,int_stack+14370,int_stack+14127, 1.0, int_stack+14019, 1.0, int_stack+15219, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+40158,int_stack+0,int_stack+1152, 1.0, int_stack+44832, 1.0, int_stack+47859, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+41292,int_stack+40158,int_stack+38265, 1.0, int_stack+45084, 1.0, int_stack+48111, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1152,int_stack+14505,int_stack+14370, 1.0, int_stack+14235, 1.0, int_stack+15435, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+44643,int_stack+1152,int_stack+0, 1.0, int_stack+324, 1.0, int_stack+49563, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+12153,int_stack+44643,int_stack+40158, 1.0, int_stack+46536, 1.0, int_stack+49887, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+5898,int_stack+15027,int_stack+14796, 2.0, int_stack+14733, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+46536,int_stack+15327,int_stack+15027, 2.0, int_stack+14943, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+38265,int_stack+46536,int_stack+5898, 2.0, int_stack+47670, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+60660,int_stack+15570,int_stack+15327, 2.0, int_stack+15219, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+40158,int_stack+60660,int_stack+46536, 2.0, int_stack+47859, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+44643,int_stack+40158,int_stack+38265, 2.0, int_stack+48111, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+46536,int_stack+15705,int_stack+15570, 2.0, int_stack+15435, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+0,int_stack+46536,int_stack+60660, 2.0, int_stack+49563, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+47670,int_stack+0,int_stack+40158, 2.0, int_stack+49887, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+5898,int_stack+15933,int_stack+15870, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+18645,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+40158,int_stack+16017,int_stack+15933, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+18771,3);
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+38265,int_stack+40158,int_stack+5898, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+51021,3);
 /*--- compute (p0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+60660,int_stack+16125,int_stack+16017, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+18939,3);
 /*--- compute (p0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+46536,int_stack+60660,int_stack+40158, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+51210,3);
 /*--- compute (p0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+0,int_stack+46536,int_stack+38265, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+51462,3);
 /*--- compute (p0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+40158,int_stack+16260,int_stack+16125, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+19155,3);
 /*--- compute (p0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+49563,int_stack+40158,int_stack+60660, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+31200,3);
 /*--- compute (p0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+12993,int_stack+49563,int_stack+46536, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+51840,3);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+5898,int_stack+16488,int_stack+16425, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+18645, 0.0, zero_stack,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+46536,int_stack+16572,int_stack+16488, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+18771, 0.0, zero_stack,3);
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+38265,int_stack+46536,int_stack+5898, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+51021, 0.0, zero_stack,3);
 /*--- compute (p0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+60660,int_stack+16680,int_stack+16572, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+18939, 0.0, zero_stack,3);
 /*--- compute (p0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+40158,int_stack+60660,int_stack+46536, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+51210, 0.0, zero_stack,3);
 /*--- compute (p0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+49563,int_stack+40158,int_stack+38265, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+51462, 0.0, zero_stack,3);
 /*--- compute (p0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+46536,int_stack+16815,int_stack+16680, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+19155, 0.0, zero_stack,3);
 /*--- compute (p0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+43185,int_stack+46536,int_stack+60660, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+31200, 0.0, zero_stack,3);
 /*--- compute (p0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+13833,int_stack+43185,int_stack+40158, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+51840, 0.0, zero_stack,3);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+5898,int_stack+17043,int_stack+16980, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+18645, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+40158,int_stack+17127,int_stack+17043, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+18771, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+38265,int_stack+40158,int_stack+5898, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+51021, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+60660,int_stack+17235,int_stack+17127, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+18939, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+46536,int_stack+60660,int_stack+40158, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+51210, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+43185,int_stack+46536,int_stack+38265, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+51462, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+40158,int_stack+17370,int_stack+17235, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+19155, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+36807,int_stack+40158,int_stack+60660, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+31200, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+14673,int_stack+36807,int_stack+46536, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+51840, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+5898,int_stack+17598,int_stack+17535, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+18645, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+46536,int_stack+17682,int_stack+17598, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+18771, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+38265,int_stack+46536,int_stack+5898, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+51021, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+60660,int_stack+17790,int_stack+17682, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+18939, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+40158,int_stack+60660,int_stack+46536, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+51210, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+36807,int_stack+40158,int_stack+38265, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+51462, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+46536,int_stack+17925,int_stack+17790, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+19155, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+8175,int_stack+46536,int_stack+60660, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+31200, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+15513,int_stack+8175,int_stack+40158, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+51840, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+5898,int_stack+18153,int_stack+18090, 0.0, zero_stack, 1.0, int_stack+18645, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+40158,int_stack+18237,int_stack+18153, 0.0, zero_stack, 1.0, int_stack+18771, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+38265,int_stack+40158,int_stack+5898, 0.0, zero_stack, 1.0, int_stack+51021, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+60660,int_stack+18345,int_stack+18237, 0.0, zero_stack, 1.0, int_stack+18939, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+46536,int_stack+60660,int_stack+40158, 0.0, zero_stack, 1.0, int_stack+51210, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+8175,int_stack+46536,int_stack+38265, 0.0, zero_stack, 1.0, int_stack+51462, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+40158,int_stack+18480,int_stack+18345, 0.0, zero_stack, 1.0, int_stack+19155, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+16353,int_stack+40158,int_stack+60660, 0.0, zero_stack, 1.0, int_stack+31200, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+17001,int_stack+16353,int_stack+46536, 0.0, zero_stack, 1.0, int_stack+51840, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+5898,int_stack+18855,int_stack+18708, 1.0, int_stack+18645, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+46536,int_stack+19047,int_stack+18855, 1.0, int_stack+18771, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+38265,int_stack+46536,int_stack+5898, 1.0, int_stack+51021, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+60660,int_stack+19290,int_stack+19047, 1.0, int_stack+18939, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+40158,int_stack+60660,int_stack+46536, 1.0, int_stack+51210, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+16353,int_stack+40158,int_stack+38265, 1.0, int_stack+51462, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+46536,int_stack+19425,int_stack+19290, 1.0, int_stack+19155, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+51021,int_stack+46536,int_stack+60660, 1.0, int_stack+31200, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+17841,int_stack+51021,int_stack+40158, 1.0, int_stack+51840, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+5898,int_stack+19653,int_stack+19590,3);
 /*--- compute (p0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+40158,int_stack+19737,int_stack+19653,3);
 /*--- compute (p0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+38265,int_stack+40158,int_stack+5898,3);
 /*--- compute (p0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+31200,int_stack+19845,int_stack+19737,3);
 /*--- compute (p0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+46536,int_stack+31200,int_stack+40158,3);
 /*--- compute (p0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+51021,int_stack+46536,int_stack+38265,3);
 /*--- compute (p0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+40158,int_stack+19980,int_stack+19845,3);
 /*--- compute (p0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+51651,int_stack+40158,int_stack+31200,3);
 /*--- compute (p0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+18681,int_stack+51651,int_stack+46536,3);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+5898,int_stack+20208,int_stack+20145, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+22920,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+46536,int_stack+20292,int_stack+20208, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+23046,3);
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+38265,int_stack+46536,int_stack+5898, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+52974,3);
 /*--- compute (p0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+31200,int_stack+20400,int_stack+20292, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+23214,3);
 /*--- compute (p0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+40158,int_stack+31200,int_stack+46536, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+53163,3);
 /*--- compute (p0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+51651,int_stack+40158,int_stack+38265, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+31524,3);
 /*--- compute (p0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+46536,int_stack+20535,int_stack+20400, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+23430,3);
 /*--- compute (p0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+19521,int_stack+46536,int_stack+31200, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+54462,3);
 /*--- compute (p0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+76350,int_stack+19521,int_stack+40158, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+648,3);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+5898,int_stack+20763,int_stack+20700, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+22920, 0.0, zero_stack,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+40158,int_stack+20847,int_stack+20763, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+23046, 0.0, zero_stack,3);
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+38265,int_stack+40158,int_stack+5898, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+52974, 0.0, zero_stack,3);
 /*--- compute (p0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+31200,int_stack+20955,int_stack+20847, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+23214, 0.0, zero_stack,3);
 /*--- compute (p0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+46536,int_stack+31200,int_stack+40158, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+53163, 0.0, zero_stack,3);
 /*--- compute (p0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+19521,int_stack+46536,int_stack+38265, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+31524, 0.0, zero_stack,3);
 /*--- compute (p0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+40158,int_stack+21090,int_stack+20955, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+23430, 0.0, zero_stack,3);
 /*--- compute (p0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+20151,int_stack+40158,int_stack+31200, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+54462, 0.0, zero_stack,3);
 /*--- compute (p0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+77190,int_stack+20151,int_stack+46536, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+648, 0.0, zero_stack,3);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+5898,int_stack+21318,int_stack+21255, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+22920, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+46536,int_stack+21402,int_stack+21318, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+23046, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+38265,int_stack+46536,int_stack+5898, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+52974, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+31200,int_stack+21510,int_stack+21402, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+23214, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+40158,int_stack+31200,int_stack+46536, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+53163, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+20151,int_stack+40158,int_stack+38265, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+31524, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+46536,int_stack+21645,int_stack+21510, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+23430, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+20781,int_stack+46536,int_stack+31200, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+54462, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+78030,int_stack+20781,int_stack+40158, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+648, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+5898,int_stack+21873,int_stack+21810, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+22920, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+40158,int_stack+21957,int_stack+21873, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+23046, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+38265,int_stack+40158,int_stack+5898, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+52974, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+31200,int_stack+22065,int_stack+21957, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+23214, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+46536,int_stack+31200,int_stack+40158, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+53163, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+20781,int_stack+46536,int_stack+38265, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+31524, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+40158,int_stack+22200,int_stack+22065, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+23430, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+21411,int_stack+40158,int_stack+31200, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+54462, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+78870,int_stack+21411,int_stack+46536, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+648, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+5898,int_stack+22428,int_stack+22365, 0.0, zero_stack, 1.0, int_stack+22920, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+46536,int_stack+22512,int_stack+22428, 0.0, zero_stack, 1.0, int_stack+23046, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+38265,int_stack+46536,int_stack+5898, 0.0, zero_stack, 1.0, int_stack+52974, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+31200,int_stack+22620,int_stack+22512, 0.0, zero_stack, 1.0, int_stack+23214, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+40158,int_stack+31200,int_stack+46536, 0.0, zero_stack, 1.0, int_stack+53163, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+21411,int_stack+40158,int_stack+38265, 0.0, zero_stack, 1.0, int_stack+31524, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+46536,int_stack+22755,int_stack+22620, 0.0, zero_stack, 1.0, int_stack+23430, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+22041,int_stack+46536,int_stack+31200, 0.0, zero_stack, 1.0, int_stack+54462, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+79710,int_stack+22041,int_stack+40158, 0.0, zero_stack, 1.0, int_stack+648, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+5898,int_stack+23130,int_stack+22983, 1.0, int_stack+22920, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+40158,int_stack+23322,int_stack+23130, 1.0, int_stack+23046, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+38265,int_stack+40158,int_stack+5898, 1.0, int_stack+52974, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+31200,int_stack+23565,int_stack+23322, 1.0, int_stack+23214, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+46536,int_stack+31200,int_stack+40158, 1.0, int_stack+53163, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+52974,int_stack+46536,int_stack+38265, 1.0, int_stack+31524, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+31524,int_stack+23700,int_stack+23565, 1.0, int_stack+23430, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+22041,int_stack+31524,int_stack+31200, 1.0, int_stack+54462, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+22689,int_stack+22041,int_stack+46536, 1.0, int_stack+648, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+5898,int_stack+23928,int_stack+23865,3);
 /*--- compute (p0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+46536,int_stack+24012,int_stack+23928,3);
 /*--- compute (p0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+38265,int_stack+46536,int_stack+5898,3);
 /*--- compute (p0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+54462,int_stack+24120,int_stack+24012,3);
 /*--- compute (p0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+40158,int_stack+54462,int_stack+46536,3);
 /*--- compute (p0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+22041,int_stack+40158,int_stack+38265,3);
 /*--- compute (p0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+46536,int_stack+24255,int_stack+24120,3);
 /*--- compute (p0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+31200,int_stack+46536,int_stack+54462,3);
 /*--- compute (p0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+23529,int_stack+31200,int_stack+40158,3);
 /*--- compute (p0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+5898,int_stack+24483,int_stack+24420,3);
 /*--- compute (p0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+40158,int_stack+24567,int_stack+24483,3);
 /*--- compute (p0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+38265,int_stack+40158,int_stack+5898,3);
 /*--- compute (p0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+54462,int_stack+24675,int_stack+24567,3);
 /*--- compute (p0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+46536,int_stack+54462,int_stack+40158,3);
 /*--- compute (p0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+31200,int_stack+46536,int_stack+38265,3);
 /*--- compute (p0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+40158,int_stack+24810,int_stack+24675,3);
 /*--- compute (p0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+630,int_stack+40158,int_stack+54462,3);
 /*--- compute (p0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+80550,int_stack+630,int_stack+46536,3);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+5898,int_stack+25038,int_stack+24975, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+27750,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+46536,int_stack+25122,int_stack+25038, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+27876,3);
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+38265,int_stack+46536,int_stack+5898, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+55416,3);
 /*--- compute (p0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+54462,int_stack+25230,int_stack+25122, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+28044,3);
 /*--- compute (p0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+40158,int_stack+54462,int_stack+46536, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+55605,3);
 /*--- compute (p0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+630,int_stack+40158,int_stack+38265, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+55857,3);
 /*--- compute (p0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+46536,int_stack+25365,int_stack+25230, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+28260,3);
 /*--- compute (p0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+24369,int_stack+46536,int_stack+54462, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+57309,3);
 /*--- compute (p0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+81390,int_stack+24369,int_stack+40158, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+57633,3);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+5898,int_stack+25593,int_stack+25530, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+27750, 0.0, zero_stack,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+40158,int_stack+25677,int_stack+25593, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+27876, 0.0, zero_stack,3);
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+38265,int_stack+40158,int_stack+5898, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+55416, 0.0, zero_stack,3);
 /*--- compute (p0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+54462,int_stack+25785,int_stack+25677, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+28044, 0.0, zero_stack,3);
 /*--- compute (p0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+46536,int_stack+54462,int_stack+40158, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+55605, 0.0, zero_stack,3);
 /*--- compute (p0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+24369,int_stack+46536,int_stack+38265, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+55857, 0.0, zero_stack,3);
 /*--- compute (p0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+40158,int_stack+25920,int_stack+25785, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+28260, 0.0, zero_stack,3);
 /*--- compute (p0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+24999,int_stack+40158,int_stack+54462, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+57309, 0.0, zero_stack,3);
 /*--- compute (p0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+82230,int_stack+24999,int_stack+46536, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+57633, 0.0, zero_stack,3);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+5898,int_stack+26148,int_stack+26085, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+27750, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+46536,int_stack+26232,int_stack+26148, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+27876, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+38265,int_stack+46536,int_stack+5898, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+55416, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+54462,int_stack+26340,int_stack+26232, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+28044, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+40158,int_stack+54462,int_stack+46536, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+55605, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+24999,int_stack+40158,int_stack+38265, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+55857, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+46536,int_stack+26475,int_stack+26340, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+28260, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+25629,int_stack+46536,int_stack+54462, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+57309, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+83070,int_stack+25629,int_stack+40158, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+57633, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+5898,int_stack+26703,int_stack+26640, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+27750, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+40158,int_stack+26787,int_stack+26703, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+27876, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+38265,int_stack+40158,int_stack+5898, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+55416, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+54462,int_stack+26895,int_stack+26787, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+28044, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+46536,int_stack+54462,int_stack+40158, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+55605, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+25629,int_stack+46536,int_stack+38265, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+55857, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+40158,int_stack+27030,int_stack+26895, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+28260, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+26259,int_stack+40158,int_stack+54462, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+57309, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+83910,int_stack+26259,int_stack+46536, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+57633, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+5898,int_stack+27258,int_stack+27195, 0.0, zero_stack, 1.0, int_stack+27750, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+46536,int_stack+27342,int_stack+27258, 0.0, zero_stack, 1.0, int_stack+27876, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+38265,int_stack+46536,int_stack+5898, 0.0, zero_stack, 1.0, int_stack+55416, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+54462,int_stack+27450,int_stack+27342, 0.0, zero_stack, 1.0, int_stack+28044, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+40158,int_stack+54462,int_stack+46536, 0.0, zero_stack, 1.0, int_stack+55605, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+26259,int_stack+40158,int_stack+38265, 0.0, zero_stack, 1.0, int_stack+55857, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+46536,int_stack+27585,int_stack+27450, 0.0, zero_stack, 1.0, int_stack+28260, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+26889,int_stack+46536,int_stack+54462, 0.0, zero_stack, 1.0, int_stack+57309, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+84750,int_stack+26889,int_stack+40158, 0.0, zero_stack, 1.0, int_stack+57633, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+5898,int_stack+27960,int_stack+27813, 1.0, int_stack+27750, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+40158,int_stack+28152,int_stack+27960, 1.0, int_stack+27876, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+38265,int_stack+40158,int_stack+5898, 1.0, int_stack+55416, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+54462,int_stack+28395,int_stack+28152, 1.0, int_stack+28044, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+46536,int_stack+54462,int_stack+40158, 1.0, int_stack+55605, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+26889,int_stack+46536,int_stack+38265, 1.0, int_stack+55857, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+40158,int_stack+28530,int_stack+28395, 1.0, int_stack+28260, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+55416,int_stack+40158,int_stack+54462, 1.0, int_stack+57309, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+27519,int_stack+55416,int_stack+46536, 1.0, int_stack+57633, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+5898,int_stack+28758,int_stack+28695,3);
 /*--- compute (p0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+46536,int_stack+28842,int_stack+28758,3);
 /*--- compute (p0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+38265,int_stack+46536,int_stack+5898,3);
 /*--- compute (p0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+54462,int_stack+28950,int_stack+28842,3);
 /*--- compute (p0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+40158,int_stack+54462,int_stack+46536,3);
 /*--- compute (p0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+55416,int_stack+40158,int_stack+38265,3);
 /*--- compute (p0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+46536,int_stack+29085,int_stack+28950,3);
 /*--- compute (p0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+57309,int_stack+46536,int_stack+54462,3);
 /*--- compute (p0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+28359,int_stack+57309,int_stack+40158,3);
 /*--- compute (p0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+5898,int_stack+29313,int_stack+29250,3);
 /*--- compute (p0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+40158,int_stack+29397,int_stack+29313,3);
 /*--- compute (p0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+38265,int_stack+40158,int_stack+5898,3);
 /*--- compute (p0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+54462,int_stack+29505,int_stack+29397,3);
 /*--- compute (p0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+46536,int_stack+54462,int_stack+40158,3);
 /*--- compute (p0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+57309,int_stack+46536,int_stack+38265,3);
 /*--- compute (p0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+40158,int_stack+29640,int_stack+29505,3);
 /*--- compute (p0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+85590,int_stack+40158,int_stack+54462,3);
 /*--- compute (p0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+86238,int_stack+85590,int_stack+46536,3);
 /*--- compute (p0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+5898,int_stack+29868,int_stack+29805,3);
 /*--- compute (p0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+46536,int_stack+29952,int_stack+29868,3);
 /*--- compute (p0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+38265,int_stack+46536,int_stack+5898,3);
 /*--- compute (p0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+54462,int_stack+30060,int_stack+29952,3);
 /*--- compute (p0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+40158,int_stack+54462,int_stack+46536,3);
 /*--- compute (p0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+85590,int_stack+40158,int_stack+38265,3);
 /*--- compute (p0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+46536,int_stack+30195,int_stack+30060,3);
 /*--- compute (p0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+29199,int_stack+46536,int_stack+54462,3);
 /*--- compute (p0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+87078,int_stack+29199,int_stack+40158,3);
 /*--- compute (p0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+29199,int_stack+35967,int_stack+34284, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+32007,3);
     Libderiv->ABCD[11] = int_stack + 29199;
 /*--- compute (p0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+35754,int_stack+39318,int_stack+37635, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+32007, 0.0, zero_stack,3);
     Libderiv->ABCD[10] = int_stack + 35754;
 /*--- compute (p0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+39273,int_stack+42345,int_stack+40662, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+32007, 0.0, zero_stack, 0.0, zero_stack,3);
     Libderiv->ABCD[9] = int_stack + 39273;
 /*--- compute (p0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+41922,int_stack+45696,int_stack+44013, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+32007, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
     Libderiv->ABCD[8] = int_stack + 41922;
 /*--- compute (p0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+45273,int_stack+48723,int_stack+47040, 0.0, zero_stack, 1.0, int_stack+32007, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
     Libderiv->ABCD[7] = int_stack + 45273;
 /*--- compute (p0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+48510,int_stack+30360,int_stack+50391, 1.0, int_stack+32007, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
     Libderiv->ABCD[6] = int_stack + 48510;
 /*--- compute (p0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+30144,int_stack+53622,int_stack+52344,3);
     Libderiv->ABCD[2] = int_stack + 30144;
 /*--- compute (p0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+53604,int_stack+56469,int_stack+54786,3);
     Libderiv->ABCD[1] = int_stack + 53604;
 /*--- compute (p0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+56046,int_stack+59820,int_stack+58137,3);
     Libderiv->ABCD[0] = int_stack + 56046;
 /*--- compute (p0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+59397,int_stack+61614,int_stack+60984, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+34284,3);
     Libderiv->ABCD[155] = int_stack + 59397;
 /*--- compute (p0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+60342,int_stack+63084,int_stack+62454, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+34284, 1.0, int_stack+37635,3);
     Libderiv->ABCD[143] = int_stack + 60342;
 /*--- compute (p0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+61287,int_stack+2286,int_stack+1656, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+37635, 0.0, zero_stack,3);
     Libderiv->ABCD[142] = int_stack + 61287;
 /*--- compute (p0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1260,int_stack+64554,int_stack+63924, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+34284, 0.0, zero_stack, 1.0, int_stack+40662,3);
     Libderiv->ABCD[131] = int_stack + 1260;
 /*--- compute (p0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+62232,int_stack+65394,int_stack+58767, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+37635, 1.0, int_stack+40662, 0.0, zero_stack,3);
     Libderiv->ABCD[130] = int_stack + 62232;
 /*--- compute (p0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+63177,int_stack+66882,int_stack+4008, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+40662, 0.0, zero_stack, 0.0, zero_stack,3);
     Libderiv->ABCD[129] = int_stack + 63177;
 /*--- compute (p0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+64122,int_stack+67722,int_stack+66234, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+34284, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+44013,3);
     Libderiv->ABCD[119] = int_stack + 64122;
 /*--- compute (p0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+65067,int_stack+3126,int_stack+4638, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+37635, 0.0, zero_stack, 1.0, int_stack+44013, 0.0, zero_stack,3);
     Libderiv->ABCD[118] = int_stack + 65067;
 /*--- compute (p0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+2205,int_stack+69840,int_stack+68562, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+40662, 1.0, int_stack+44013, 0.0, zero_stack, 0.0, zero_stack,3);
     Libderiv->ABCD[117] = int_stack + 2205;
 /*--- compute (p0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+3150,int_stack+70680,int_stack+69192, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+44013, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
     Libderiv->ABCD[116] = int_stack + 3150;
 /*--- compute (p0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+4095,int_stack+71520,int_stack+6087, 0.0, zero_stack, 1.0, int_stack+34284, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+47040,3);
     Libderiv->ABCD[107] = int_stack + 4095;
 /*--- compute (p0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+66012,int_stack+72360,int_stack+5268, 0.0, zero_stack, 1.0, int_stack+37635, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+47040, 0.0, zero_stack,3);
     Libderiv->ABCD[106] = int_stack + 66012;
 /*--- compute (p0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+5040,int_stack+73200,int_stack+7545, 0.0, zero_stack, 1.0, int_stack+40662, 0.0, zero_stack, 1.0, int_stack+47040, 0.0, zero_stack, 0.0, zero_stack,3);
     Libderiv->ABCD[105] = int_stack + 5040;
 /*--- compute (p0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+66957,int_stack+74040,int_stack+6717, 0.0, zero_stack, 1.0, int_stack+44013, 1.0, int_stack+47040, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
     Libderiv->ABCD[104] = int_stack + 66957;
 /*--- compute (p0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+5985,int_stack+75510,int_stack+74880, 0.0, zero_stack, 2.0, int_stack+47040, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
     Libderiv->ABCD[103] = int_stack + 5985;
 /*--- compute (p0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+6930,int_stack+9633,int_stack+9003, 1.0, int_stack+34284, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+50391,3);
     Libderiv->ABCD[95] = int_stack + 6930;
 /*--- compute (p0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+8805,int_stack+10473,int_stack+33267, 1.0, int_stack+37635, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+50391, 0.0, zero_stack,3);
     Libderiv->ABCD[94] = int_stack + 8805;
 /*--- compute (p0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+33267,int_stack+11313,int_stack+32637, 1.0, int_stack+40662, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+50391, 0.0, zero_stack, 0.0, zero_stack,3);
     Libderiv->ABCD[93] = int_stack + 33267;
 /*--- compute (p0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+31830,int_stack+34914,int_stack+38643, 1.0, int_stack+44013, 0.0, zero_stack, 1.0, int_stack+50391, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
     Libderiv->ABCD[92] = int_stack + 31830;
 /*--- compute (p0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+34212,int_stack+12153,int_stack+41292, 1.0, int_stack+47040, 1.0, int_stack+50391, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
     Libderiv->ABCD[91] = int_stack + 34212;
 /*--- compute (p0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+9750,int_stack+47670,int_stack+44643, 2.0, int_stack+50391, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
     Libderiv->ABCD[90] = int_stack + 9750;
 /*--- compute (p0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+10695,int_stack+12993,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+52344,3);
     Libderiv->ABCD[47] = int_stack + 10695;
 /*--- compute (p0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+11640,int_stack+13833,int_stack+49563, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+52344, 0.0, zero_stack,3);
     Libderiv->ABCD[46] = int_stack + 11640;
 /*--- compute (p0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+12585,int_stack+14673,int_stack+43185, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+52344, 0.0, zero_stack, 0.0, zero_stack,3);
     Libderiv->ABCD[45] = int_stack + 12585;
 /*--- compute (p0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+13530,int_stack+15513,int_stack+36807, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+52344, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
     Libderiv->ABCD[44] = int_stack + 13530;
 /*--- compute (p0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+14475,int_stack+17001,int_stack+8175, 0.0, zero_stack, 1.0, int_stack+52344, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
     Libderiv->ABCD[43] = int_stack + 14475;
 /*--- compute (p0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+49455,int_stack+17841,int_stack+16353, 1.0, int_stack+52344, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
     Libderiv->ABCD[42] = int_stack + 49455;
 /*--- compute (p0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+15420,int_stack+18681,int_stack+51021,3);
     Libderiv->ABCD[38] = int_stack + 15420;
 /*--- compute (p0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+16365,int_stack+76350,int_stack+51651, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+54786,3);
     Libderiv->ABCD[35] = int_stack + 16365;
 /*--- compute (p0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+17310,int_stack+77190,int_stack+19521, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+54786, 0.0, zero_stack,3);
     Libderiv->ABCD[34] = int_stack + 17310;
 /*--- compute (p0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+18255,int_stack+78030,int_stack+20151, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+54786, 0.0, zero_stack, 0.0, zero_stack,3);
     Libderiv->ABCD[33] = int_stack + 18255;
 /*--- compute (p0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+19200,int_stack+78870,int_stack+20781, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+54786, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
     Libderiv->ABCD[32] = int_stack + 19200;
 /*--- compute (p0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+20145,int_stack+79710,int_stack+21411, 0.0, zero_stack, 1.0, int_stack+54786, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
     Libderiv->ABCD[31] = int_stack + 20145;
 /*--- compute (p0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+21090,int_stack+22689,int_stack+52974, 1.0, int_stack+54786, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
     Libderiv->ABCD[30] = int_stack + 21090;
 /*--- compute (p0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+50400,int_stack+23529,int_stack+22041,3);
     Libderiv->ABCD[26] = int_stack + 50400;
 /*--- compute (p0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+22035,int_stack+80550,int_stack+31200,3);
     Libderiv->ABCD[25] = int_stack + 22035;
 /*--- compute (p0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+22980,int_stack+81390,int_stack+630, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+58137,3);
     Libderiv->ABCD[23] = int_stack + 22980;
 /*--- compute (p0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+0,int_stack+82230,int_stack+24369, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+58137, 0.0, zero_stack,3);
     Libderiv->ABCD[22] = int_stack + 0;
 /*--- compute (p0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+23925,int_stack+83070,int_stack+24999, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+58137, 0.0, zero_stack, 0.0, zero_stack,3);
     Libderiv->ABCD[21] = int_stack + 23925;
 /*--- compute (p0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+51345,int_stack+83910,int_stack+25629, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+58137, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
     Libderiv->ABCD[20] = int_stack + 51345;
 /*--- compute (p0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+24870,int_stack+84750,int_stack+26259, 0.0, zero_stack, 1.0, int_stack+58137, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
     Libderiv->ABCD[19] = int_stack + 24870;
 /*--- compute (p0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+25815,int_stack+27519,int_stack+26889, 1.0, int_stack+58137, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
     Libderiv->ABCD[18] = int_stack + 25815;
 /*--- compute (p0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+57939,int_stack+28359,int_stack+55416,3);
     Libderiv->ABCD[14] = int_stack + 57939;
 /*--- compute (p0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+54549,int_stack+86238,int_stack+57309,3);
     Libderiv->ABCD[13] = int_stack + 54549;
 /*--- compute (p0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+56991,int_stack+87078,int_stack+85590,3);
     Libderiv->ABCD[12] = int_stack + 56991;

}
