/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include <libint/libint.h>
#include "libderiv.h"
#include <libint/hrr_header.h>

#include "d1hrr_header.h"

extern void d1vrr_order_ffii(Libderiv_t *, prim_data *);

  /* Computes derivatives of (ff|ii) integrals */

void d1hrr_order_ffii(Libderiv_t *Libderiv, int num_prim_comb)
{
 prim_data *Data = Libderiv->PrimQuartet;
 double *int_stack = Libderiv->int_stack;
 double *zero_stack = Libderiv->zero_stack;
 int i,j;
 double tmp, *target;

 Libderiv->deriv_classes[3][6][11] = int_stack + 0;
 Libderiv->deriv_classes[3][7][11] = int_stack + 280;
 Libderiv->deriv_classes[3][8][11] = int_stack + 640;
 Libderiv->deriv_classes[3][9][11] = int_stack + 1090;
 Libderiv->deriv_classes[3][10][11] = int_stack + 1640;
 Libderiv->deriv_classes[3][11][11] = int_stack + 2300;
 Libderiv->deriv_classes[3][12][11] = int_stack + 3080;
 Libderiv->deriv_classes[4][6][11] = int_stack + 3990;
 Libderiv->deriv_classes[4][7][11] = int_stack + 4410;
 Libderiv->deriv_classes[4][8][11] = int_stack + 4950;
 Libderiv->deriv_classes[4][9][11] = int_stack + 5625;
 Libderiv->deriv_classes[4][10][11] = int_stack + 6450;
 Libderiv->deriv_classes[4][11][11] = int_stack + 7440;
 Libderiv->deriv_classes[4][12][11] = int_stack + 8610;
 Libderiv->deriv_classes[5][6][11] = int_stack + 9975;
 Libderiv->deriv_classes[5][7][11] = int_stack + 10563;
 Libderiv->deriv_classes[5][8][11] = int_stack + 11319;
 Libderiv->deriv_classes[5][9][11] = int_stack + 12264;
 Libderiv->deriv_classes[5][10][11] = int_stack + 13419;
 Libderiv->deriv_classes[5][11][11] = int_stack + 14805;
 Libderiv->deriv_classes[5][12][11] = int_stack + 16443;
 Libderiv->deriv_classes[6][6][11] = int_stack + 18354;
 Libderiv->deriv_classes[6][7][11] = int_stack + 19138;
 Libderiv->deriv_classes[6][8][11] = int_stack + 20146;
 Libderiv->deriv_classes[6][9][11] = int_stack + 21406;
 Libderiv->deriv_classes[6][10][11] = int_stack + 22946;
 Libderiv->deriv_classes[6][11][11] = int_stack + 24794;
 Libderiv->deriv_classes[6][12][11] = int_stack + 26978;
 Libderiv->deriv_classes[3][6][10] = int_stack + 29526;
 Libderiv->deriv_classes[3][7][10] = int_stack + 29806;
 Libderiv->deriv_classes[3][8][10] = int_stack + 30166;
 Libderiv->deriv_classes[3][9][10] = int_stack + 30616;
 Libderiv->deriv_classes[3][10][10] = int_stack + 31166;
 Libderiv->deriv_classes[3][11][10] = int_stack + 31826;
 Libderiv->deriv_classes[3][12][10] = int_stack + 32606;
 Libderiv->deriv_classes[4][6][10] = int_stack + 33516;
 Libderiv->deriv_classes[4][7][10] = int_stack + 33936;
 Libderiv->deriv_classes[4][8][10] = int_stack + 34476;
 Libderiv->deriv_classes[4][9][10] = int_stack + 35151;
 Libderiv->deriv_classes[4][10][10] = int_stack + 35976;
 Libderiv->deriv_classes[4][11][10] = int_stack + 36966;
 Libderiv->deriv_classes[4][12][10] = int_stack + 38136;
 Libderiv->deriv_classes[5][6][10] = int_stack + 39501;
 Libderiv->deriv_classes[5][7][10] = int_stack + 40089;
 Libderiv->deriv_classes[5][8][10] = int_stack + 40845;
 Libderiv->deriv_classes[5][9][10] = int_stack + 41790;
 Libderiv->deriv_classes[5][10][10] = int_stack + 42945;
 Libderiv->deriv_classes[5][11][10] = int_stack + 44331;
 Libderiv->deriv_classes[5][12][10] = int_stack + 45969;
 Libderiv->deriv_classes[6][6][10] = int_stack + 47880;
 Libderiv->deriv_classes[6][7][10] = int_stack + 48664;
 Libderiv->deriv_classes[6][8][10] = int_stack + 49672;
 Libderiv->deriv_classes[6][9][10] = int_stack + 50932;
 Libderiv->deriv_classes[6][10][10] = int_stack + 52472;
 Libderiv->deriv_classes[6][11][10] = int_stack + 54320;
 Libderiv->deriv_classes[6][12][10] = int_stack + 56504;
 Libderiv->deriv_classes[3][6][9] = int_stack + 59052;
 Libderiv->deriv_classes[3][7][9] = int_stack + 59332;
 Libderiv->deriv_classes[3][8][9] = int_stack + 59692;
 Libderiv->deriv_classes[3][9][9] = int_stack + 60142;
 Libderiv->deriv_classes[3][10][9] = int_stack + 60692;
 Libderiv->deriv_classes[3][11][9] = int_stack + 61352;
 Libderiv->deriv_classes[3][12][9] = int_stack + 62132;
 Libderiv->deriv_classes[4][6][9] = int_stack + 63042;
 Libderiv->deriv_classes[4][7][9] = int_stack + 63462;
 Libderiv->deriv_classes[4][8][9] = int_stack + 64002;
 Libderiv->deriv_classes[4][9][9] = int_stack + 64677;
 Libderiv->deriv_classes[4][10][9] = int_stack + 65502;
 Libderiv->deriv_classes[4][11][9] = int_stack + 66492;
 Libderiv->deriv_classes[4][12][9] = int_stack + 67662;
 Libderiv->deriv_classes[5][6][9] = int_stack + 69027;
 Libderiv->deriv_classes[5][7][9] = int_stack + 69615;
 Libderiv->deriv_classes[5][8][9] = int_stack + 70371;
 Libderiv->deriv_classes[5][9][9] = int_stack + 71316;
 Libderiv->deriv_classes[5][10][9] = int_stack + 72471;
 Libderiv->deriv_classes[5][11][9] = int_stack + 73857;
 Libderiv->deriv_classes[5][12][9] = int_stack + 75495;
 Libderiv->deriv_classes[6][6][9] = int_stack + 77406;
 Libderiv->deriv_classes[6][7][9] = int_stack + 78190;
 Libderiv->deriv_classes[6][8][9] = int_stack + 79198;
 Libderiv->deriv_classes[6][9][9] = int_stack + 80458;
 Libderiv->deriv_classes[6][10][9] = int_stack + 81998;
 Libderiv->deriv_classes[6][11][9] = int_stack + 83846;
 Libderiv->deriv_classes[6][12][9] = int_stack + 86030;
 Libderiv->deriv_classes[3][6][8] = int_stack + 88578;
 Libderiv->deriv_classes[3][7][8] = int_stack + 88858;
 Libderiv->deriv_classes[3][8][8] = int_stack + 89218;
 Libderiv->deriv_classes[3][9][8] = int_stack + 89668;
 Libderiv->deriv_classes[3][10][8] = int_stack + 90218;
 Libderiv->deriv_classes[3][11][8] = int_stack + 90878;
 Libderiv->deriv_classes[3][12][8] = int_stack + 91658;
 Libderiv->deriv_classes[4][6][8] = int_stack + 92568;
 Libderiv->deriv_classes[4][7][8] = int_stack + 92988;
 Libderiv->deriv_classes[4][8][8] = int_stack + 93528;
 Libderiv->deriv_classes[4][9][8] = int_stack + 94203;
 Libderiv->deriv_classes[4][10][8] = int_stack + 95028;
 Libderiv->deriv_classes[4][11][8] = int_stack + 96018;
 Libderiv->deriv_classes[4][12][8] = int_stack + 97188;
 Libderiv->deriv_classes[5][6][8] = int_stack + 98553;
 Libderiv->deriv_classes[5][7][8] = int_stack + 99141;
 Libderiv->deriv_classes[5][8][8] = int_stack + 99897;
 Libderiv->deriv_classes[5][9][8] = int_stack + 100842;
 Libderiv->deriv_classes[5][10][8] = int_stack + 101997;
 Libderiv->deriv_classes[5][11][8] = int_stack + 103383;
 Libderiv->deriv_classes[5][12][8] = int_stack + 105021;
 Libderiv->deriv_classes[6][6][8] = int_stack + 106932;
 Libderiv->deriv_classes[6][7][8] = int_stack + 107716;
 Libderiv->deriv_classes[6][8][8] = int_stack + 108724;
 Libderiv->deriv_classes[6][9][8] = int_stack + 109984;
 Libderiv->deriv_classes[6][10][8] = int_stack + 111524;
 Libderiv->deriv_classes[6][11][8] = int_stack + 113372;
 Libderiv->deriv_classes[6][12][8] = int_stack + 115556;
 Libderiv->deriv_classes[3][6][7] = int_stack + 118104;
 Libderiv->deriv_classes[3][7][7] = int_stack + 118384;
 Libderiv->deriv_classes[3][8][7] = int_stack + 118744;
 Libderiv->deriv_classes[3][9][7] = int_stack + 119194;
 Libderiv->deriv_classes[3][10][7] = int_stack + 119744;
 Libderiv->deriv_classes[3][11][7] = int_stack + 120404;
 Libderiv->deriv_classes[3][12][7] = int_stack + 121184;
 Libderiv->deriv_classes[4][6][7] = int_stack + 122094;
 Libderiv->deriv_classes[4][7][7] = int_stack + 122514;
 Libderiv->deriv_classes[4][8][7] = int_stack + 123054;
 Libderiv->deriv_classes[4][9][7] = int_stack + 123729;
 Libderiv->deriv_classes[4][10][7] = int_stack + 124554;
 Libderiv->deriv_classes[4][11][7] = int_stack + 125544;
 Libderiv->deriv_classes[4][12][7] = int_stack + 126714;
 Libderiv->deriv_classes[5][6][7] = int_stack + 128079;
 Libderiv->deriv_classes[5][7][7] = int_stack + 128667;
 Libderiv->deriv_classes[5][8][7] = int_stack + 129423;
 Libderiv->deriv_classes[5][9][7] = int_stack + 130368;
 Libderiv->deriv_classes[5][10][7] = int_stack + 131523;
 Libderiv->deriv_classes[5][11][7] = int_stack + 132909;
 Libderiv->deriv_classes[5][12][7] = int_stack + 134547;
 Libderiv->deriv_classes[6][6][7] = int_stack + 136458;
 Libderiv->deriv_classes[6][7][7] = int_stack + 137242;
 Libderiv->deriv_classes[6][8][7] = int_stack + 138250;
 Libderiv->deriv_classes[6][9][7] = int_stack + 139510;
 Libderiv->deriv_classes[6][10][7] = int_stack + 141050;
 Libderiv->deriv_classes[6][11][7] = int_stack + 142898;
 Libderiv->deriv_classes[6][12][7] = int_stack + 145082;
 Libderiv->deriv_classes[3][6][6] = int_stack + 147630;
 Libderiv->deriv_classes[3][7][6] = int_stack + 147910;
 Libderiv->deriv_classes[3][8][6] = int_stack + 148270;
 Libderiv->deriv_classes[3][9][6] = int_stack + 148720;
 Libderiv->deriv_classes[3][10][6] = int_stack + 149270;
 Libderiv->deriv_classes[3][11][6] = int_stack + 149930;
 Libderiv->deriv_classes[3][12][6] = int_stack + 150710;
 Libderiv->deriv_classes[4][6][6] = int_stack + 151620;
 Libderiv->deriv_classes[4][7][6] = int_stack + 152040;
 Libderiv->deriv_classes[4][8][6] = int_stack + 152580;
 Libderiv->deriv_classes[4][9][6] = int_stack + 153255;
 Libderiv->deriv_classes[4][10][6] = int_stack + 154080;
 Libderiv->deriv_classes[4][11][6] = int_stack + 155070;
 Libderiv->deriv_classes[4][12][6] = int_stack + 156240;
 Libderiv->deriv_classes[5][6][6] = int_stack + 157605;
 Libderiv->deriv_classes[5][7][6] = int_stack + 158193;
 Libderiv->deriv_classes[5][8][6] = int_stack + 158949;
 Libderiv->deriv_classes[5][9][6] = int_stack + 159894;
 Libderiv->deriv_classes[5][10][6] = int_stack + 161049;
 Libderiv->deriv_classes[5][11][6] = int_stack + 162435;
 Libderiv->deriv_classes[5][12][6] = int_stack + 164073;
 Libderiv->dvrr_classes[6][6] = int_stack + 165984;
 Libderiv->deriv_classes[6][6][6] = int_stack + 166768;
 Libderiv->dvrr_classes[6][7] = int_stack + 167552;
 Libderiv->deriv_classes[6][7][6] = int_stack + 168560;
 Libderiv->dvrr_classes[6][8] = int_stack + 169568;
 Libderiv->deriv_classes[6][8][6] = int_stack + 170828;
 Libderiv->dvrr_classes[6][9] = int_stack + 172088;
 Libderiv->deriv_classes[6][9][6] = int_stack + 173628;
 Libderiv->dvrr_classes[6][10] = int_stack + 175168;
 Libderiv->deriv_classes[6][10][6] = int_stack + 177016;
 Libderiv->dvrr_classes[6][11] = int_stack + 178864;
 Libderiv->deriv_classes[6][11][6] = int_stack + 181048;
 Libderiv->deriv_classes[6][12][6] = int_stack + 183232;
 Libderiv->deriv_classes[3][6][2] = int_stack + 185780;
 Libderiv->deriv_classes[3][7][2] = int_stack + 186060;
 Libderiv->deriv_classes[3][8][2] = int_stack + 186420;
 Libderiv->deriv_classes[3][9][2] = int_stack + 186870;
 Libderiv->deriv_classes[3][10][2] = int_stack + 187420;
 Libderiv->deriv_classes[3][11][2] = int_stack + 188080;
 Libderiv->deriv_classes[3][12][2] = int_stack + 188860;
 Libderiv->deriv_classes[4][6][2] = int_stack + 189770;
 Libderiv->deriv_classes[4][7][2] = int_stack + 190190;
 Libderiv->deriv_classes[4][8][2] = int_stack + 190730;
 Libderiv->deriv_classes[4][9][2] = int_stack + 191405;
 Libderiv->deriv_classes[4][10][2] = int_stack + 192230;
 Libderiv->deriv_classes[4][11][2] = int_stack + 193220;
 Libderiv->deriv_classes[4][12][2] = int_stack + 194390;
 Libderiv->deriv_classes[5][6][2] = int_stack + 195755;
 Libderiv->deriv_classes[5][7][2] = int_stack + 196343;
 Libderiv->deriv_classes[5][8][2] = int_stack + 197099;
 Libderiv->deriv_classes[5][9][2] = int_stack + 198044;
 Libderiv->deriv_classes[5][10][2] = int_stack + 199199;
 Libderiv->deriv_classes[5][11][2] = int_stack + 200585;
 Libderiv->deriv_classes[5][12][2] = int_stack + 202223;
 Libderiv->deriv_classes[6][6][2] = int_stack + 204134;
 Libderiv->deriv_classes[6][7][2] = int_stack + 204918;
 Libderiv->deriv_classes[6][8][2] = int_stack + 205926;
 Libderiv->deriv_classes[6][9][2] = int_stack + 207186;
 Libderiv->deriv_classes[6][10][2] = int_stack + 208726;
 Libderiv->deriv_classes[6][11][2] = int_stack + 210574;
 Libderiv->deriv_classes[6][12][2] = int_stack + 212758;
 Libderiv->deriv_classes[3][6][1] = int_stack + 215306;
 Libderiv->deriv_classes[3][7][1] = int_stack + 215586;
 Libderiv->deriv_classes[3][8][1] = int_stack + 215946;
 Libderiv->deriv_classes[3][9][1] = int_stack + 216396;
 Libderiv->deriv_classes[3][10][1] = int_stack + 216946;
 Libderiv->deriv_classes[3][11][1] = int_stack + 217606;
 Libderiv->deriv_classes[3][12][1] = int_stack + 218386;
 Libderiv->deriv_classes[4][6][1] = int_stack + 219296;
 Libderiv->deriv_classes[4][7][1] = int_stack + 219716;
 Libderiv->deriv_classes[4][8][1] = int_stack + 220256;
 Libderiv->deriv_classes[4][9][1] = int_stack + 220931;
 Libderiv->deriv_classes[4][10][1] = int_stack + 221756;
 Libderiv->deriv_classes[4][11][1] = int_stack + 222746;
 Libderiv->deriv_classes[4][12][1] = int_stack + 223916;
 Libderiv->deriv_classes[5][6][1] = int_stack + 225281;
 Libderiv->deriv_classes[5][7][1] = int_stack + 225869;
 Libderiv->deriv_classes[5][8][1] = int_stack + 226625;
 Libderiv->deriv_classes[5][9][1] = int_stack + 227570;
 Libderiv->deriv_classes[5][10][1] = int_stack + 228725;
 Libderiv->deriv_classes[5][11][1] = int_stack + 230111;
 Libderiv->deriv_classes[5][12][1] = int_stack + 231749;
 Libderiv->deriv_classes[6][6][1] = int_stack + 233660;
 Libderiv->deriv_classes[6][7][1] = int_stack + 234444;
 Libderiv->deriv_classes[6][8][1] = int_stack + 235452;
 Libderiv->deriv_classes[6][9][1] = int_stack + 236712;
 Libderiv->deriv_classes[6][10][1] = int_stack + 238252;
 Libderiv->deriv_classes[6][11][1] = int_stack + 240100;
 Libderiv->deriv_classes[6][12][1] = int_stack + 242284;
 Libderiv->dvrr_classes[3][6] = int_stack + 244832;
 Libderiv->dvrr_classes[3][7] = int_stack + 245112;
 Libderiv->dvrr_classes[3][8] = int_stack + 245472;
 Libderiv->dvrr_classes[3][9] = int_stack + 245922;
 Libderiv->dvrr_classes[3][10] = int_stack + 246472;
 Libderiv->dvrr_classes[3][11] = int_stack + 247132;
 Libderiv->dvrr_classes[3][12] = int_stack + 247912;
 Libderiv->deriv_classes[3][6][0] = int_stack + 248822;
 Libderiv->deriv_classes[3][7][0] = int_stack + 249102;
 Libderiv->deriv_classes[3][8][0] = int_stack + 249462;
 Libderiv->deriv_classes[3][9][0] = int_stack + 249912;
 Libderiv->deriv_classes[3][10][0] = int_stack + 250462;
 Libderiv->deriv_classes[3][11][0] = int_stack + 251122;
 Libderiv->deriv_classes[3][12][0] = int_stack + 251902;
 Libderiv->dvrr_classes[4][6] = int_stack + 252812;
 Libderiv->dvrr_classes[4][7] = int_stack + 253232;
 Libderiv->dvrr_classes[4][8] = int_stack + 253772;
 Libderiv->dvrr_classes[4][9] = int_stack + 254447;
 Libderiv->dvrr_classes[4][10] = int_stack + 255272;
 Libderiv->dvrr_classes[4][11] = int_stack + 256262;
 Libderiv->dvrr_classes[4][12] = int_stack + 257432;
 Libderiv->deriv_classes[4][6][0] = int_stack + 258797;
 Libderiv->deriv_classes[4][7][0] = int_stack + 259217;
 Libderiv->deriv_classes[4][8][0] = int_stack + 259757;
 Libderiv->deriv_classes[4][9][0] = int_stack + 260432;
 Libderiv->deriv_classes[4][10][0] = int_stack + 261257;
 Libderiv->deriv_classes[4][11][0] = int_stack + 262247;
 Libderiv->deriv_classes[4][12][0] = int_stack + 263417;
 Libderiv->dvrr_classes[5][6] = int_stack + 264782;
 Libderiv->dvrr_classes[5][7] = int_stack + 265370;
 Libderiv->dvrr_classes[5][8] = int_stack + 266126;
 Libderiv->dvrr_classes[5][9] = int_stack + 267071;
 Libderiv->dvrr_classes[5][10] = int_stack + 268226;
 Libderiv->dvrr_classes[5][11] = int_stack + 269612;
 Libderiv->dvrr_classes[5][12] = int_stack + 271250;
 Libderiv->deriv_classes[5][6][0] = int_stack + 273161;
 Libderiv->deriv_classes[5][7][0] = int_stack + 273749;
 Libderiv->deriv_classes[5][8][0] = int_stack + 274505;
 Libderiv->deriv_classes[5][9][0] = int_stack + 275450;
 Libderiv->deriv_classes[5][10][0] = int_stack + 276605;
 Libderiv->deriv_classes[5][11][0] = int_stack + 277991;
 Libderiv->deriv_classes[5][12][0] = int_stack + 279629;
 Libderiv->deriv_classes[6][6][0] = int_stack + 281540;
 Libderiv->deriv_classes[6][7][0] = int_stack + 282324;
 Libderiv->deriv_classes[6][8][0] = int_stack + 283332;
 Libderiv->deriv_classes[6][9][0] = int_stack + 284592;
 Libderiv->deriv_classes[6][10][0] = int_stack + 286132;
 Libderiv->deriv_classes[6][11][0] = int_stack + 287980;
 Libderiv->deriv_classes[6][12][0] = int_stack + 290164;
 memset(int_stack,0,2341696);

 Libderiv->dvrr_stack = int_stack + 1477896;
 for(i=0;i<num_prim_comb;i++) {
   d1vrr_order_ffii(Libderiv, Data);
   Data++;
 }

 /*--- compute (f0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+292712,int_stack+245112,int_stack+244832,10);
 /*--- compute (f0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+293552,int_stack+245472,int_stack+245112,10);
 /*--- compute (f0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+294632,int_stack+293552,int_stack+292712,10);
 /*--- compute (f0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+296312,int_stack+245922,int_stack+245472,10);
 /*--- compute (f0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+297662,int_stack+296312,int_stack+293552,10);
 /*--- compute (f0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+299822,int_stack+297662,int_stack+294632,10);
 /*--- compute (f0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+302622,int_stack+246472,int_stack+245922,10);
 /*--- compute (f0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+304272,int_stack+302622,int_stack+296312,10);
 /*--- compute (f0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+306972,int_stack+304272,int_stack+297662,10);
 /*--- compute (f0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+310572,int_stack+306972,int_stack+299822,10);
 /*--- compute (f0|np) ---*/
   hrr3_build_np(Libderiv->CD,int_stack+314772,int_stack+247132,int_stack+246472,10);
 /*--- compute (f0|md) ---*/
   hrr3_build_md(Libderiv->CD,int_stack+316752,int_stack+314772,int_stack+302622,10);
 /*--- compute (f0|lf) ---*/
   hrr3_build_lf(Libderiv->CD,int_stack+320052,int_stack+316752,int_stack+304272,10);
 /*--- compute (f0|kg) ---*/
   hrr3_build_kg(Libderiv->CD,int_stack+324552,int_stack+320052,int_stack+306972,10);
 /*--- compute (f0|ih) ---*/
   hrr3_build_ih(Libderiv->CD,int_stack+329952,int_stack+324552,int_stack+310572,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+335832,int_stack+280,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+244832,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+336672,int_stack+640,int_stack+280, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+245112,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+337752,int_stack+336672,int_stack+335832, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+292712,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+339432,int_stack+1090,int_stack+640, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+245472,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+340782,int_stack+339432,int_stack+336672, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+293552,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+342942,int_stack+340782,int_stack+337752, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+294632,10);
 /*--- compute (f0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+335832,int_stack+1640,int_stack+1090, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+245922,10);
 /*--- compute (f0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+345742,int_stack+335832,int_stack+339432, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+296312,10);
 /*--- compute (f0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+348442,int_stack+345742,int_stack+340782, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+297662,10);
 /*--- compute (f0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+337482,int_stack+348442,int_stack+342942, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+299822,10);
 /*--- compute (f0|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+341682,int_stack+2300,int_stack+1640, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+246472,10);
 /*--- compute (f0|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+352042,int_stack+341682,int_stack+335832, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+302622,10);
 /*--- compute (f0|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+355342,int_stack+352042,int_stack+345742, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+304272,10);
 /*--- compute (f0|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+359842,int_stack+355342,int_stack+348442, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+306972,10);
 /*--- compute (f0|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+343662,int_stack+359842,int_stack+337482, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+310572,10);
 /*--- compute (f0|op) ---*/
   d1hrr3_build_op(Libderiv->CD,int_stack+335832,int_stack+3080,int_stack+2300, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+247132,10);
 /*--- compute (f0|nd) ---*/
   d1hrr3_build_nd(Libderiv->CD,int_stack+0,int_stack+335832,int_stack+341682, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+314772,10);
 /*--- compute (f0|mf) ---*/
   d1hrr3_build_mf(Libderiv->CD,int_stack+335832,int_stack+0,int_stack+352042, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+316752,10);
 /*--- compute (f0|lg) ---*/
   d1hrr3_build_lg(Libderiv->CD,int_stack+365242,int_stack+335832,int_stack+355342, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+320052,10);
 /*--- compute (f0|kh) ---*/
   d1hrr3_build_kh(Libderiv->CD,int_stack+335832,int_stack+365242,int_stack+359842, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+324552,10);
 /*--- compute (f0|ii) ---*/
   d1hrr3_build_ii(Libderiv->CD,int_stack+349542,int_stack+335832,int_stack+343662, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+329952,10);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+335832,int_stack+253232,int_stack+252812,15);
 /*--- compute (g0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+337092,int_stack+253772,int_stack+253232,15);
 /*--- compute (g0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+338712,int_stack+337092,int_stack+335832,15);
 /*--- compute (g0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+341232,int_stack+254447,int_stack+253772,15);
 /*--- compute (g0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+343257,int_stack+341232,int_stack+337092,15);
 /*--- compute (g0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+357382,int_stack+343257,int_stack+338712,15);
 /*--- compute (g0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+346497,int_stack+255272,int_stack+254447,15);
 /*--- compute (g0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+361582,int_stack+346497,int_stack+341232,15);
 /*--- compute (g0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+365632,int_stack+361582,int_stack+343257,15);
 /*--- compute (g0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+371032,int_stack+365632,int_stack+357382,15);
 /*--- compute (g0|np) ---*/
   hrr3_build_np(Libderiv->CD,int_stack+0,int_stack+256262,int_stack+255272,15);
 /*--- compute (g0|md) ---*/
   hrr3_build_md(Libderiv->CD,int_stack+377332,int_stack+0,int_stack+346497,15);
 /*--- compute (g0|lf) ---*/
   hrr3_build_lf(Libderiv->CD,int_stack+382282,int_stack+377332,int_stack+361582,15);
 /*--- compute (g0|kg) ---*/
   hrr3_build_kg(Libderiv->CD,int_stack+389032,int_stack+382282,int_stack+365632,15);
 /*--- compute (g0|ih) ---*/
   hrr3_build_ih(Libderiv->CD,int_stack+397132,int_stack+389032,int_stack+371032,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+405952,int_stack+4410,int_stack+3990, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+252812,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+407212,int_stack+4950,int_stack+4410, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+253232,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+408832,int_stack+407212,int_stack+405952, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+335832,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+411352,int_stack+5625,int_stack+4950, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+253772,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+413377,int_stack+411352,int_stack+407212, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+337092,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+416617,int_stack+413377,int_stack+408832, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+338712,15);
 /*--- compute (g0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+405952,int_stack+6450,int_stack+5625, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+254447,15);
 /*--- compute (g0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+420817,int_stack+405952,int_stack+411352, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+341232,15);
 /*--- compute (g0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+424867,int_stack+420817,int_stack+413377, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+343257,15);
 /*--- compute (g0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+408427,int_stack+424867,int_stack+416617, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+357382,15);
 /*--- compute (g0|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+414727,int_stack+7440,int_stack+6450, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+255272,15);
 /*--- compute (g0|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+430267,int_stack+414727,int_stack+405952, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+346497,15);
 /*--- compute (g0|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+435217,int_stack+430267,int_stack+420817, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+361582,15);
 /*--- compute (g0|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+441967,int_stack+435217,int_stack+424867, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+365632,15);
 /*--- compute (g0|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+417697,int_stack+441967,int_stack+408427, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+371032,15);
 /*--- compute (g0|op) ---*/
   d1hrr3_build_op(Libderiv->CD,int_stack+405952,int_stack+8610,int_stack+7440, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+256262,15);
 /*--- compute (g0|nd) ---*/
   d1hrr3_build_nd(Libderiv->CD,int_stack+2970,int_stack+405952,int_stack+414727, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+0,15);
 /*--- compute (g0|mf) ---*/
   d1hrr3_build_mf(Libderiv->CD,int_stack+405952,int_stack+2970,int_stack+430267, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+377332,15);
 /*--- compute (g0|lg) ---*/
   d1hrr3_build_lg(Libderiv->CD,int_stack+450067,int_stack+405952,int_stack+435217, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+382282,15);
 /*--- compute (g0|kh) ---*/
   d1hrr3_build_kh(Libderiv->CD,int_stack+405952,int_stack+450067,int_stack+441967, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+389032,15);
 /*--- compute (g0|ii) ---*/
   d1hrr3_build_ii(Libderiv->CD,int_stack+426517,int_stack+405952,int_stack+417697, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+397132,15);
 /*--- compute (fp|ii) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+438277,int_stack+426517,int_stack+349542,784);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+405952,int_stack+265370,int_stack+264782,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+407716,int_stack+266126,int_stack+265370,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+409984,int_stack+407716,int_stack+405952,21);
 /*--- compute (h0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+413512,int_stack+267071,int_stack+266126,21);
 /*--- compute (h0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+416347,int_stack+413512,int_stack+407716,21);
 /*--- compute (h0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+2970,int_stack+416347,int_stack+409984,21);
 /*--- compute (h0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+420883,int_stack+268226,int_stack+267071,21);
 /*--- compute (h0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+348972,int_stack+420883,int_stack+413512,21);
 /*--- compute (h0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+461797,int_stack+348972,int_stack+416347,21);
 /*--- compute (h0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+469357,int_stack+461797,int_stack+2970,21);
 /*--- compute (h0|np) ---*/
   hrr3_build_np(Libderiv->CD,int_stack+478177,int_stack+269612,int_stack+268226,21);
 /*--- compute (h0|md) ---*/
   hrr3_build_md(Libderiv->CD,int_stack+482335,int_stack+478177,int_stack+420883,21);
 /*--- compute (h0|lf) ---*/
   hrr3_build_lf(Libderiv->CD,int_stack+489265,int_stack+482335,int_stack+348972,21);
 /*--- compute (h0|kg) ---*/
   hrr3_build_kg(Libderiv->CD,int_stack+498715,int_stack+489265,int_stack+461797,21);
 /*--- compute (h0|ih) ---*/
   hrr3_build_ih(Libderiv->CD,int_stack+510055,int_stack+498715,int_stack+469357,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+424348,int_stack+10563,int_stack+9975, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+264782,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+354642,int_stack+11319,int_stack+10563, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+265370,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+522403,int_stack+354642,int_stack+424348, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+405952,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+525931,int_stack+12264,int_stack+11319, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+266126,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+528766,int_stack+525931,int_stack+354642, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+407716,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+533302,int_stack+528766,int_stack+522403, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+409984,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+522403,int_stack+13419,int_stack+12264, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+267071,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+539182,int_stack+522403,int_stack+525931, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+413512,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+544852,int_stack+539182,int_stack+528766, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+416347,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+552412,int_stack+544852,int_stack+533302, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2970,21);
 /*--- compute (h0|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+525868,int_stack+14805,int_stack+13419, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+268226,21);
 /*--- compute (h0|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+530026,int_stack+525868,int_stack+522403, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+420883,21);
 /*--- compute (h0|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+561232,int_stack+530026,int_stack+539182, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+348972,21);
 /*--- compute (h0|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+570682,int_stack+561232,int_stack+544852, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+461797,21);
 /*--- compute (h0|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+536956,int_stack+570682,int_stack+552412, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+469357,21);
 /*--- compute (h0|op) ---*/
   d1hrr3_build_op(Libderiv->CD,int_stack+549304,int_stack+16443,int_stack+14805, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+269612,21);
 /*--- compute (h0|nd) ---*/
   d1hrr3_build_nd(Libderiv->CD,int_stack+8850,int_stack+549304,int_stack+525868, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+478177,21);
 /*--- compute (h0|mf) ---*/
   d1hrr3_build_mf(Libderiv->CD,int_stack+549304,int_stack+8850,int_stack+530026, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+482335,21);
 /*--- compute (h0|lg) ---*/
   d1hrr3_build_lg(Libderiv->CD,int_stack+522403,int_stack+549304,int_stack+561232, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+489265,21);
 /*--- compute (h0|kh) ---*/
   d1hrr3_build_kh(Libderiv->CD,int_stack+549304,int_stack+522403,int_stack+570682, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+498715,21);
 /*--- compute (h0|ii) ---*/
   d1hrr3_build_ii(Libderiv->CD,int_stack+565180,int_stack+549304,int_stack+536956, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+510055,21);
 /*--- compute (gp|ii) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+522403,int_stack+565180,int_stack+426517,784);
 /*--- compute (fd|ii) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+581644,int_stack+522403,int_stack+438277,784);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+557683,int_stack+167552,int_stack+165984,28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+560035,int_stack+169568,int_stack+167552,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+8850,int_stack+560035,int_stack+557683,28);
 /*--- compute (i0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+13554,int_stack+172088,int_stack+169568,28);
 /*--- compute (i0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+424348,int_stack+13554,int_stack+560035,28);
 /*--- compute (i0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+430396,int_stack+424348,int_stack+8850,28);
 /*--- compute (i0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+438236,int_stack+175168,int_stack+172088,28);
 /*--- compute (i0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+442856,int_stack+438236,int_stack+13554,28);
 /*--- compute (i0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+450416,int_stack+442856,int_stack+424348,28);
 /*--- compute (i0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+628684,int_stack+450416,int_stack+430396,28);
 /*--- compute (i0|np) ---*/
   hrr3_build_np(Libderiv->CD,int_stack+640444,int_stack+178864,int_stack+175168,28);
 /*--- compute (i0|md) ---*/
   hrr3_build_md(Libderiv->CD,int_stack+645988,int_stack+640444,int_stack+438236,28);
 /*--- compute (i0|lf) ---*/
   hrr3_build_lf(Libderiv->CD,int_stack+655228,int_stack+645988,int_stack+442856,28);
 /*--- compute (i0|kg) ---*/
   hrr3_build_kg(Libderiv->CD,int_stack+667828,int_stack+655228,int_stack+450416,28);
 /*--- compute (i0|ih) ---*/
   hrr3_build_ih(Libderiv->CD,int_stack+682948,int_stack+667828,int_stack+628684,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+354642,int_stack+19138,int_stack+18354, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+165984,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+699412,int_stack+20146,int_stack+19138, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+167552,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+702436,int_stack+699412,int_stack+354642, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+557683,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+707140,int_stack+21406,int_stack+20146, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+169568,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+710920,int_stack+707140,int_stack+699412, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+560035,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+716968,int_stack+710920,int_stack+702436, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8850,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+699412,int_stack+22946,int_stack+21406, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+172088,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+724808,int_stack+699412,int_stack+707140, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+13554,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+732368,int_stack+724808,int_stack+710920, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+424348,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+704032,int_stack+732368,int_stack+716968, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+430396,28);
 /*--- compute (i0|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+715792,int_stack+24794,int_stack+22946, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+175168,28);
 /*--- compute (i0|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+742448,int_stack+715792,int_stack+699412, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+438236,28);
 /*--- compute (i0|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+751688,int_stack+742448,int_stack+724808, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+442856,28);
 /*--- compute (i0|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+764288,int_stack+751688,int_stack+732368, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+450416,28);
 /*--- compute (i0|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+721336,int_stack+764288,int_stack+704032, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+628684,28);
 /*--- compute (i0|op) ---*/
   d1hrr3_build_op(Libderiv->CD,int_stack+699412,int_stack+26978,int_stack+24794, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+178864,28);
 /*--- compute (i0|nd) ---*/
   d1hrr3_build_nd(Libderiv->CD,int_stack+17334,int_stack+699412,int_stack+715792, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+640444,28);
 /*--- compute (i0|mf) ---*/
   d1hrr3_build_mf(Libderiv->CD,int_stack+699412,int_stack+17334,int_stack+742448, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+645988,28);
 /*--- compute (i0|lg) ---*/
   d1hrr3_build_lg(Libderiv->CD,int_stack+779408,int_stack+699412,int_stack+751688, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+655228,28);
 /*--- compute (i0|kh) ---*/
   d1hrr3_build_kh(Libderiv->CD,int_stack+699412,int_stack+779408,int_stack+764288, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+667828,28);
 /*--- compute (i0|ii) ---*/
   d1hrr3_build_ii(Libderiv->CD,int_stack+737800,int_stack+699412,int_stack+721336, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+682948,28);
 /*--- compute (hp|ii) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+759752,int_stack+737800,int_stack+565180,784);
 /*--- compute (gd|ii) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+809144,int_stack+759752,int_stack+522403,784);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+522403,int_stack+29806,int_stack+29526, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+244832, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+523243,int_stack+30166,int_stack+29806, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+245112, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+524323,int_stack+523243,int_stack+522403, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+292712, 0.0, zero_stack,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+526003,int_stack+30616,int_stack+30166, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+245472, 0.0, zero_stack,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+527353,int_stack+526003,int_stack+523243, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+293552, 0.0, zero_stack,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+529513,int_stack+527353,int_stack+524323, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+294632, 0.0, zero_stack,10);
 /*--- compute (f0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+522403,int_stack+31166,int_stack+30616, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+245922, 0.0, zero_stack,10);
 /*--- compute (f0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+532313,int_stack+522403,int_stack+526003, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+296312, 0.0, zero_stack,10);
 /*--- compute (f0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+535013,int_stack+532313,int_stack+527353, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+297662, 0.0, zero_stack,10);
 /*--- compute (f0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+524053,int_stack+535013,int_stack+529513, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+299822, 0.0, zero_stack,10);
 /*--- compute (f0|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+528253,int_stack+31826,int_stack+31166, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+246472, 0.0, zero_stack,10);
 /*--- compute (f0|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+538613,int_stack+528253,int_stack+522403, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+302622, 0.0, zero_stack,10);
 /*--- compute (f0|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+541913,int_stack+538613,int_stack+532313, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+304272, 0.0, zero_stack,10);
 /*--- compute (f0|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+546413,int_stack+541913,int_stack+535013, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+306972, 0.0, zero_stack,10);
 /*--- compute (f0|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+530233,int_stack+546413,int_stack+524053, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+310572, 0.0, zero_stack,10);
 /*--- compute (f0|op) ---*/
   d1hrr3_build_op(Libderiv->CD,int_stack+522403,int_stack+32606,int_stack+31826, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+247132, 0.0, zero_stack,10);
 /*--- compute (f0|nd) ---*/
   d1hrr3_build_nd(Libderiv->CD,int_stack+551813,int_stack+522403,int_stack+528253, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+314772, 0.0, zero_stack,10);
 /*--- compute (f0|mf) ---*/
   d1hrr3_build_mf(Libderiv->CD,int_stack+522403,int_stack+551813,int_stack+538613, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+316752, 0.0, zero_stack,10);
 /*--- compute (f0|lg) ---*/
   d1hrr3_build_lg(Libderiv->CD,int_stack+699412,int_stack+522403,int_stack+541913, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+320052, 0.0, zero_stack,10);
 /*--- compute (f0|kh) ---*/
   d1hrr3_build_kh(Libderiv->CD,int_stack+522403,int_stack+699412,int_stack+546413, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+324552, 0.0, zero_stack,10);
 /*--- compute (f0|ii) ---*/
   d1hrr3_build_ii(Libderiv->CD,int_stack+699412,int_stack+522403,int_stack+530233, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+329952, 0.0, zero_stack,10);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+522403,int_stack+33936,int_stack+33516, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+252812, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+523663,int_stack+34476,int_stack+33936, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+253232, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+525283,int_stack+523663,int_stack+522403, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+335832, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+527803,int_stack+35151,int_stack+34476, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+253772, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+529828,int_stack+527803,int_stack+523663, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+337092, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+533068,int_stack+529828,int_stack+525283, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+338712, 0.0, zero_stack,15);
 /*--- compute (g0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+522403,int_stack+35976,int_stack+35151, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+254447, 0.0, zero_stack,15);
 /*--- compute (g0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+537268,int_stack+522403,int_stack+527803, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+341232, 0.0, zero_stack,15);
 /*--- compute (g0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+541318,int_stack+537268,int_stack+529828, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+343257, 0.0, zero_stack,15);
 /*--- compute (g0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+524878,int_stack+541318,int_stack+533068, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+357382, 0.0, zero_stack,15);
 /*--- compute (g0|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+531178,int_stack+36966,int_stack+35976, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+255272, 0.0, zero_stack,15);
 /*--- compute (g0|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+546718,int_stack+531178,int_stack+522403, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+346497, 0.0, zero_stack,15);
 /*--- compute (g0|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+707252,int_stack+546718,int_stack+537268, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+361582, 0.0, zero_stack,15);
 /*--- compute (g0|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+714002,int_stack+707252,int_stack+541318, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+365632, 0.0, zero_stack,15);
 /*--- compute (g0|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+534148,int_stack+714002,int_stack+524878, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+371032, 0.0, zero_stack,15);
 /*--- compute (g0|op) ---*/
   d1hrr3_build_op(Libderiv->CD,int_stack+522403,int_stack+38136,int_stack+36966, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+256262, 0.0, zero_stack,15);
 /*--- compute (g0|nd) ---*/
   d1hrr3_build_nd(Libderiv->CD,int_stack+551668,int_stack+522403,int_stack+531178, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack,15);
 /*--- compute (g0|mf) ---*/
   d1hrr3_build_mf(Libderiv->CD,int_stack+522403,int_stack+551668,int_stack+546718, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+377332, 0.0, zero_stack,15);
 /*--- compute (g0|lg) ---*/
   d1hrr3_build_lg(Libderiv->CD,int_stack+542968,int_stack+522403,int_stack+707252, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+382282, 0.0, zero_stack,15);
 /*--- compute (g0|kh) ---*/
   d1hrr3_build_kh(Libderiv->CD,int_stack+522403,int_stack+542968,int_stack+714002, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+389032, 0.0, zero_stack,15);
 /*--- compute (g0|ii) ---*/
   d1hrr3_build_ii(Libderiv->CD,int_stack+542968,int_stack+522403,int_stack+534148, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+397132, 0.0, zero_stack,15);
 /*--- compute (fp|ii) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+707252,int_stack+542968,int_stack+699412,784);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+699412,int_stack+40089,int_stack+39501, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+264782, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+701176,int_stack+40845,int_stack+40089, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+265370, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+703444,int_stack+701176,int_stack+699412, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+405952, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+522403,int_stack+41790,int_stack+40845, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+266126, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+525238,int_stack+522403,int_stack+701176, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+407716, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+529774,int_stack+525238,int_stack+703444, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+409984, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+699412,int_stack+42945,int_stack+41790, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+267071, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+535654,int_stack+699412,int_stack+522403, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+413512, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+730772,int_stack+535654,int_stack+525238, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+416347, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+738332,int_stack+730772,int_stack+529774, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2970, 0.0, zero_stack,21);
 /*--- compute (h0|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+522403,int_stack+44331,int_stack+42945, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+268226, 0.0, zero_stack,21);
 /*--- compute (h0|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+526561,int_stack+522403,int_stack+699412, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+420883, 0.0, zero_stack,21);
 /*--- compute (h0|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+747152,int_stack+526561,int_stack+535654, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+348972, 0.0, zero_stack,21);
 /*--- compute (h0|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+756602,int_stack+747152,int_stack+730772, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+461797, 0.0, zero_stack,21);
 /*--- compute (h0|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+767942,int_stack+756602,int_stack+738332, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+469357, 0.0, zero_stack,21);
 /*--- compute (h0|op) ---*/
   d1hrr3_build_op(Libderiv->CD,int_stack+730772,int_stack+45969,int_stack+44331, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+269612, 0.0, zero_stack,21);
 /*--- compute (h0|nd) ---*/
   d1hrr3_build_nd(Libderiv->CD,int_stack+735686,int_stack+730772,int_stack+522403, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+478177, 0.0, zero_stack,21);
 /*--- compute (h0|mf) ---*/
   d1hrr3_build_mf(Libderiv->CD,int_stack+780290,int_stack+735686,int_stack+526561, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+482335, 0.0, zero_stack,21);
 /*--- compute (h0|lg) ---*/
   d1hrr3_build_lg(Libderiv->CD,int_stack+522403,int_stack+780290,int_stack+747152, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+489265, 0.0, zero_stack,21);
 /*--- compute (h0|kh) ---*/
   d1hrr3_build_kh(Libderiv->CD,int_stack+780290,int_stack+522403,int_stack+756602, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+498715, 0.0, zero_stack,21);
 /*--- compute (h0|ii) ---*/
   d1hrr3_build_ii(Libderiv->CD,int_stack+522403,int_stack+780290,int_stack+767942, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+510055, 0.0, zero_stack,21);
 /*--- compute (gp|ii) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+730772,int_stack+522403,int_stack+542968,784);
 /*--- compute (fd|ii) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+879704,int_stack+730772,int_stack+707252,784);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+538867,int_stack+48664,int_stack+47880, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+165984, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+541219,int_stack+49672,int_stack+48664, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+167552, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+544243,int_stack+541219,int_stack+538867, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+557683, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+548947,int_stack+50932,int_stack+49672, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+169568, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+766052,int_stack+548947,int_stack+541219, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+560035, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+772100,int_stack+766052,int_stack+544243, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8850, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+538867,int_stack+52472,int_stack+50932, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+172088, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+779940,int_stack+538867,int_stack+548947, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+13554, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+543487,int_stack+779940,int_stack+766052, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+424348, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+787500,int_stack+543487,int_stack+772100, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+430396, 0.0, zero_stack,28);
 /*--- compute (i0|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+766052,int_stack+54320,int_stack+52472, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+175168, 0.0, zero_stack,28);
 /*--- compute (i0|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+799260,int_stack+766052,int_stack+538867, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+438236, 0.0, zero_stack,28);
 /*--- compute (i0|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+699412,int_stack+799260,int_stack+779940, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+442856, 0.0, zero_stack,28);
 /*--- compute (i0|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+771596,int_stack+699412,int_stack+543487, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+450416, 0.0, zero_stack,28);
 /*--- compute (i0|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+538867,int_stack+771596,int_stack+787500, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+628684, 0.0, zero_stack,28);
 /*--- compute (i0|op) ---*/
   d1hrr3_build_op(Libderiv->CD,int_stack+786716,int_stack+56504,int_stack+54320, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+178864, 0.0, zero_stack,28);
 /*--- compute (i0|nd) ---*/
   d1hrr3_build_nd(Libderiv->CD,int_stack+712012,int_stack+786716,int_stack+766052, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+640444, 0.0, zero_stack,28);
 /*--- compute (i0|mf) ---*/
   d1hrr3_build_mf(Libderiv->CD,int_stack+17334,int_stack+712012,int_stack+799260, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+645988, 0.0, zero_stack,28);
 /*--- compute (i0|lg) ---*/
   d1hrr3_build_lg(Libderiv->CD,int_stack+786716,int_stack+17334,int_stack+699412, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+655228, 0.0, zero_stack,28);
 /*--- compute (i0|kh) ---*/
   d1hrr3_build_kh(Libderiv->CD,int_stack+699412,int_stack+786716,int_stack+771596, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+667828, 0.0, zero_stack,28);
 /*--- compute (i0|ii) ---*/
   d1hrr3_build_ii(Libderiv->CD,int_stack+17334,int_stack+699412,int_stack+538867, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+682948, 0.0, zero_stack,28);
 /*--- compute (hp|ii) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+926744,int_stack+17334,int_stack+522403,784);
 /*--- compute (gd|ii) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+976136,int_stack+926744,int_stack+730772,784);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+926744,int_stack+59332,int_stack+59052, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+244832, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+927584,int_stack+59692,int_stack+59332, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+245112, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+928664,int_stack+927584,int_stack+926744, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+292712, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+930344,int_stack+60142,int_stack+59692, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+245472, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+931694,int_stack+930344,int_stack+927584, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+293552, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+933854,int_stack+931694,int_stack+928664, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+294632, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+926744,int_stack+60692,int_stack+60142, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+245922, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+936654,int_stack+926744,int_stack+930344, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+296312, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+939354,int_stack+936654,int_stack+931694, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+297662, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+928394,int_stack+939354,int_stack+933854, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+299822, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+932594,int_stack+61352,int_stack+60692, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+246472, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+942954,int_stack+932594,int_stack+926744, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+302622, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+946254,int_stack+942954,int_stack+936654, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+304272, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+950754,int_stack+946254,int_stack+939354, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+306972, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+934574,int_stack+950754,int_stack+928394, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+310572, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|op) ---*/
   d1hrr3_build_op(Libderiv->CD,int_stack+926744,int_stack+62132,int_stack+61352, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+247132, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|nd) ---*/
   d1hrr3_build_nd(Libderiv->CD,int_stack+956154,int_stack+926744,int_stack+932594, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+314772, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|mf) ---*/
   d1hrr3_build_mf(Libderiv->CD,int_stack+926744,int_stack+956154,int_stack+942954, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+316752, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|lg) ---*/
   d1hrr3_build_lg(Libderiv->CD,int_stack+956154,int_stack+926744,int_stack+946254, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+320052, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kh) ---*/
   d1hrr3_build_kh(Libderiv->CD,int_stack+926744,int_stack+956154,int_stack+950754, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+324552, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ii) ---*/
   d1hrr3_build_ii(Libderiv->CD,int_stack+940454,int_stack+926744,int_stack+934574, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+329952, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+926744,int_stack+63462,int_stack+63042, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+252812, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+928004,int_stack+64002,int_stack+63462, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+253232, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+929624,int_stack+928004,int_stack+926744, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+335832, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+932144,int_stack+64677,int_stack+64002, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+253772, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+934169,int_stack+932144,int_stack+928004, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+337092, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+948294,int_stack+934169,int_stack+929624, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+338712, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+926744,int_stack+65502,int_stack+64677, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+254447, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+952494,int_stack+926744,int_stack+932144, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+341232, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+956544,int_stack+952494,int_stack+934169, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+343257, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+929219,int_stack+956544,int_stack+948294, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+357382, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+948294,int_stack+66492,int_stack+65502, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+255272, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+961944,int_stack+948294,int_stack+926744, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+346497, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+966894,int_stack+961944,int_stack+952494, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+361582, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+522403,int_stack+966894,int_stack+956544, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+365632, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+951264,int_stack+522403,int_stack+929219, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+371032, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|op) ---*/
   d1hrr3_build_op(Libderiv->CD,int_stack+926744,int_stack+67662,int_stack+66492, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+256262, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|nd) ---*/
   d1hrr3_build_nd(Libderiv->CD,int_stack+930254,int_stack+926744,int_stack+948294, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|mf) ---*/
   d1hrr3_build_mf(Libderiv->CD,int_stack+530503,int_stack+930254,int_stack+961944, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+377332, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lg) ---*/
   d1hrr3_build_lg(Libderiv->CD,int_stack+926744,int_stack+530503,int_stack+966894, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+382282, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kh) ---*/
   d1hrr3_build_kh(Libderiv->CD,int_stack+530503,int_stack+926744,int_stack+522403, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+389032, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ii) ---*/
   d1hrr3_build_ii(Libderiv->CD,int_stack+926744,int_stack+530503,int_stack+951264, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+397132, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|ii) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+522403,int_stack+926744,int_stack+940454,784);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+545923,int_stack+69615,int_stack+69027, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+264782, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+547687,int_stack+70371,int_stack+69615, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+265370, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+549955,int_stack+547687,int_stack+545923, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+405952, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+553483,int_stack+71316,int_stack+70371, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+266126, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+938504,int_stack+553483,int_stack+547687, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+407716, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+943040,int_stack+938504,int_stack+549955, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+409984, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+545923,int_stack+72471,int_stack+71316, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+267071, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+948920,int_stack+545923,int_stack+553483, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+413512, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+549388,int_stack+948920,int_stack+938504, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+416347, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+954590,int_stack+549388,int_stack+943040, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2970, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+938504,int_stack+73857,int_stack+72471, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+268226, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+963410,int_stack+938504,int_stack+545923, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+420883, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+17334,int_stack+963410,int_stack+948920, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+348972, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+942662,int_stack+17334,int_stack+549388, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+461797, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+26784,int_stack+942662,int_stack+954590, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+469357, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|op) ---*/
   d1hrr3_build_op(Libderiv->CD,int_stack+545923,int_stack+75495,int_stack+73857, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+269612, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|nd) ---*/
   d1hrr3_build_nd(Libderiv->CD,int_stack+954002,int_stack+545923,int_stack+938504, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+478177, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|mf) ---*/
   d1hrr3_build_mf(Libderiv->CD,int_stack+545923,int_stack+954002,int_stack+963410, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+482335, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lg) ---*/
   d1hrr3_build_lg(Libderiv->CD,int_stack+954002,int_stack+545923,int_stack+17334, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+489265, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kh) ---*/
   d1hrr3_build_kh(Libderiv->CD,int_stack+39132,int_stack+954002,int_stack+942662, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+498715, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ii) ---*/
   d1hrr3_build_ii(Libderiv->CD,int_stack+938504,int_stack+39132,int_stack+26784, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+510055, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|ii) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+17334,int_stack+938504,int_stack+926744,784);
 /*--- compute (fd|ii) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+699412,int_stack+17334,int_stack+522403,784);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+522403,int_stack+78190,int_stack+77406, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+165984, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+524755,int_stack+79198,int_stack+78190, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+167552, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+527779,int_stack+524755,int_stack+522403, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+557683, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+532483,int_stack+80458,int_stack+79198, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+169568, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+536263,int_stack+532483,int_stack+524755, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+560035, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+542311,int_stack+536263,int_stack+527779, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8850, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+522403,int_stack+81998,int_stack+80458, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+172088, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+926744,int_stack+522403,int_stack+532483, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+13554, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+52614,int_stack+926744,int_stack+536263, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+424348, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+527023,int_stack+52614,int_stack+542311, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+430396, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+538783,int_stack+83846,int_stack+81998, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+175168, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+544327,int_stack+538783,int_stack+522403, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+438236, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+62694,int_stack+544327,int_stack+926744, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+442856, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+954968,int_stack+62694,int_stack+52614, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+450416, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+746452,int_stack+954968,int_stack+527023, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+628684, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|op) ---*/
   d1hrr3_build_op(Libderiv->CD,int_stack+52614,int_stack+86030,int_stack+83846, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+178864, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|nd) ---*/
   d1hrr3_build_nd(Libderiv->CD,int_stack+926744,int_stack+52614,int_stack+538783, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+640444, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|mf) ---*/
   d1hrr3_build_mf(Libderiv->CD,int_stack+522403,int_stack+926744,int_stack+544327, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+645988, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lg) ---*/
   d1hrr3_build_lg(Libderiv->CD,int_stack+537803,int_stack+522403,int_stack+62694, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+655228, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kh) ---*/
   d1hrr3_build_kh(Libderiv->CD,int_stack+52614,int_stack+537803,int_stack+954968, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+667828, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ii) ---*/
   d1hrr3_build_ii(Libderiv->CD,int_stack+522403,int_stack+52614,int_stack+746452, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+682948, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|ii) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+746452,int_stack+522403,int_stack+938504,784);
 /*--- compute (gd|ii) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+1046696,int_stack+746452,int_stack+17334,784);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+17334,int_stack+88858,int_stack+88578, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+244832, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+18174,int_stack+89218,int_stack+88858, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+245112, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+19254,int_stack+18174,int_stack+17334, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+292712, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+20934,int_stack+89668,int_stack+89218, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+245472, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+22284,int_stack+20934,int_stack+18174, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+293552, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+24444,int_stack+22284,int_stack+19254, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+294632, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+17334,int_stack+90218,int_stack+89668, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+245922, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+27244,int_stack+17334,int_stack+20934, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+296312, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+29944,int_stack+27244,int_stack+22284, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+297662, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+18984,int_stack+29944,int_stack+24444, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+299822, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+23184,int_stack+90878,int_stack+90218, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+246472, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+33544,int_stack+23184,int_stack+17334, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+302622, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+36844,int_stack+33544,int_stack+27244, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+304272, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+41344,int_stack+36844,int_stack+29944, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+306972, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+25164,int_stack+41344,int_stack+18984, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+310572, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|op) ---*/
   d1hrr3_build_op(Libderiv->CD,int_stack+17334,int_stack+91658,int_stack+90878, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+247132, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|nd) ---*/
   d1hrr3_build_nd(Libderiv->CD,int_stack+46744,int_stack+17334,int_stack+23184, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+314772, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|mf) ---*/
   d1hrr3_build_mf(Libderiv->CD,int_stack+17334,int_stack+46744,int_stack+33544, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+316752, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|lg) ---*/
   d1hrr3_build_lg(Libderiv->CD,int_stack+46744,int_stack+17334,int_stack+36844, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+320052, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kh) ---*/
   d1hrr3_build_kh(Libderiv->CD,int_stack+17334,int_stack+46744,int_stack+41344, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+324552, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ii) ---*/
   d1hrr3_build_ii(Libderiv->CD,int_stack+31044,int_stack+17334,int_stack+25164, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+329952, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+17334,int_stack+92988,int_stack+92568, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+252812, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+18594,int_stack+93528,int_stack+92988, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+253232, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+20214,int_stack+18594,int_stack+17334, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+335832, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+22734,int_stack+94203,int_stack+93528, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+253772, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+24759,int_stack+22734,int_stack+18594, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+337092, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+38884,int_stack+24759,int_stack+20214, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+338712, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+17334,int_stack+95028,int_stack+94203, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+254447, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+43084,int_stack+17334,int_stack+22734, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+341232, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+47134,int_stack+43084,int_stack+24759, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+343257, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+19809,int_stack+47134,int_stack+38884, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+357382, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+38884,int_stack+96018,int_stack+95028, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+255272, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+52534,int_stack+38884,int_stack+17334, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+346497, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+57484,int_stack+52534,int_stack+43084, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+361582, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+64234,int_stack+57484,int_stack+47134, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+365632, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+41854,int_stack+64234,int_stack+19809, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+371032, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|op) ---*/
   d1hrr3_build_op(Libderiv->CD,int_stack+17334,int_stack+97188,int_stack+96018, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+256262, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|nd) ---*/
   d1hrr3_build_nd(Libderiv->CD,int_stack+20844,int_stack+17334,int_stack+38884, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|mf) ---*/
   d1hrr3_build_mf(Libderiv->CD,int_stack+72334,int_stack+20844,int_stack+52534, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+377332, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lg) ---*/
   d1hrr3_build_lg(Libderiv->CD,int_stack+17334,int_stack+72334,int_stack+57484, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+382282, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kh) ---*/
   d1hrr3_build_kh(Libderiv->CD,int_stack+72334,int_stack+17334,int_stack+64234, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+389032, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ii) ---*/
   d1hrr3_build_ii(Libderiv->CD,int_stack+17334,int_stack+72334,int_stack+41854, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+397132, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|ii) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+38884,int_stack+17334,int_stack+31044,784);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+29094,int_stack+99141,int_stack+98553, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+264782, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+30858,int_stack+99897,int_stack+99141, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+265370, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+33126,int_stack+30858,int_stack+29094, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+405952, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+62404,int_stack+100842,int_stack+99897, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+266126, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+65239,int_stack+62404,int_stack+30858, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+407716, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+69775,int_stack+65239,int_stack+33126, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+409984, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+29094,int_stack+101997,int_stack+100842, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+267071, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+32559,int_stack+29094,int_stack+62404, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+413512, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+75655,int_stack+32559,int_stack+65239, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+416347, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+83215,int_stack+75655,int_stack+69775, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2970, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+62404,int_stack+103383,int_stack+101997, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+268226, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+66562,int_stack+62404,int_stack+29094, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+420883, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+92035,int_stack+66562,int_stack+32559, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+348972, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+746452,int_stack+92035,int_stack+75655, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+461797, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+757792,int_stack+746452,int_stack+83215, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+469357, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|op) ---*/
   d1hrr3_build_op(Libderiv->CD,int_stack+29094,int_stack+105021,int_stack+103383, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+269612, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|nd) ---*/
   d1hrr3_build_nd(Libderiv->CD,int_stack+73492,int_stack+29094,int_stack+62404, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+478177, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|mf) ---*/
   d1hrr3_build_mf(Libderiv->CD,int_stack+770140,int_stack+73492,int_stack+66562, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+482335, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lg) ---*/
   d1hrr3_build_lg(Libderiv->CD,int_stack+62404,int_stack+770140,int_stack+92035, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+489265, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kh) ---*/
   d1hrr3_build_kh(Libderiv->CD,int_stack+770140,int_stack+62404,int_stack+746452, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+498715, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ii) ---*/
   d1hrr3_build_ii(Libderiv->CD,int_stack+62404,int_stack+770140,int_stack+757792, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+510055, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|ii) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+522403,int_stack+62404,int_stack+17334,784);
 /*--- compute (fd|ii) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+746452,int_stack+522403,int_stack+38884,784);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+17334,int_stack+107716,int_stack+106932, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+165984, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+19686,int_stack+108724,int_stack+107716, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+167552, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+22710,int_stack+19686,int_stack+17334, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+557683, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+27414,int_stack+109984,int_stack+108724, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+169568, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+31194,int_stack+27414,int_stack+19686, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+560035, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+37242,int_stack+31194,int_stack+22710, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8850, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+17334,int_stack+111524,int_stack+109984, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+172088, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+45082,int_stack+17334,int_stack+27414, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+13554, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+793492,int_stack+45082,int_stack+31194, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+424348, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+21954,int_stack+793492,int_stack+37242, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+430396, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+33714,int_stack+113372,int_stack+111524, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+175168, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+52642,int_stack+33714,int_stack+17334, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+438236, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+78868,int_stack+52642,int_stack+45082, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+442856, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+91468,int_stack+78868,int_stack+793492, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+450416, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+926744,int_stack+91468,int_stack+21954, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+628684, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|op) ---*/
   d1hrr3_build_op(Libderiv->CD,int_stack+793492,int_stack+115556,int_stack+113372, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+178864, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|nd) ---*/
   d1hrr3_build_nd(Libderiv->CD,int_stack+17334,int_stack+793492,int_stack+33714, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+640444, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|mf) ---*/
   d1hrr3_build_mf(Libderiv->CD,int_stack+793492,int_stack+17334,int_stack+52642, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+645988, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lg) ---*/
   d1hrr3_build_lg(Libderiv->CD,int_stack+17334,int_stack+793492,int_stack+78868, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+655228, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kh) ---*/
   d1hrr3_build_kh(Libderiv->CD,int_stack+36234,int_stack+17334,int_stack+91468, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+667828, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ii) ---*/
   d1hrr3_build_ii(Libderiv->CD,int_stack+78868,int_stack+36234,int_stack+926744, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+682948, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|ii) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+926744,int_stack+78868,int_stack+62404,784);
 /*--- compute (gd|ii) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+17334,int_stack+926744,int_stack+522403,784);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+522403,int_stack+118384,int_stack+118104, 0.0, zero_stack, 1.0, int_stack+244832, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+523243,int_stack+118744,int_stack+118384, 0.0, zero_stack, 1.0, int_stack+245112, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+524323,int_stack+523243,int_stack+522403, 0.0, zero_stack, 1.0, int_stack+292712, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+526003,int_stack+119194,int_stack+118744, 0.0, zero_stack, 1.0, int_stack+245472, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+527353,int_stack+526003,int_stack+523243, 0.0, zero_stack, 1.0, int_stack+293552, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+529513,int_stack+527353,int_stack+524323, 0.0, zero_stack, 1.0, int_stack+294632, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+522403,int_stack+119744,int_stack+119194, 0.0, zero_stack, 1.0, int_stack+245922, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+532313,int_stack+522403,int_stack+526003, 0.0, zero_stack, 1.0, int_stack+296312, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+535013,int_stack+532313,int_stack+527353, 0.0, zero_stack, 1.0, int_stack+297662, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+524053,int_stack+535013,int_stack+529513, 0.0, zero_stack, 1.0, int_stack+299822, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+528253,int_stack+120404,int_stack+119744, 0.0, zero_stack, 1.0, int_stack+246472, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+538613,int_stack+528253,int_stack+522403, 0.0, zero_stack, 1.0, int_stack+302622, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+541913,int_stack+538613,int_stack+532313, 0.0, zero_stack, 1.0, int_stack+304272, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+546413,int_stack+541913,int_stack+535013, 0.0, zero_stack, 1.0, int_stack+306972, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+530233,int_stack+546413,int_stack+524053, 0.0, zero_stack, 1.0, int_stack+310572, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|op) ---*/
   d1hrr3_build_op(Libderiv->CD,int_stack+522403,int_stack+121184,int_stack+120404, 0.0, zero_stack, 1.0, int_stack+247132, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|nd) ---*/
   d1hrr3_build_nd(Libderiv->CD,int_stack+551813,int_stack+522403,int_stack+528253, 0.0, zero_stack, 1.0, int_stack+314772, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|mf) ---*/
   d1hrr3_build_mf(Libderiv->CD,int_stack+522403,int_stack+551813,int_stack+538613, 0.0, zero_stack, 1.0, int_stack+316752, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|lg) ---*/
   d1hrr3_build_lg(Libderiv->CD,int_stack+926744,int_stack+522403,int_stack+541913, 0.0, zero_stack, 1.0, int_stack+320052, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kh) ---*/
   d1hrr3_build_kh(Libderiv->CD,int_stack+522403,int_stack+926744,int_stack+546413, 0.0, zero_stack, 1.0, int_stack+324552, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ii) ---*/
   d1hrr3_build_ii(Libderiv->CD,int_stack+926744,int_stack+522403,int_stack+530233, 0.0, zero_stack, 1.0, int_stack+329952, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+522403,int_stack+122514,int_stack+122094, 0.0, zero_stack, 1.0, int_stack+252812, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+523663,int_stack+123054,int_stack+122514, 0.0, zero_stack, 1.0, int_stack+253232, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+525283,int_stack+523663,int_stack+522403, 0.0, zero_stack, 1.0, int_stack+335832, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+527803,int_stack+123729,int_stack+123054, 0.0, zero_stack, 1.0, int_stack+253772, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+529828,int_stack+527803,int_stack+523663, 0.0, zero_stack, 1.0, int_stack+337092, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+533068,int_stack+529828,int_stack+525283, 0.0, zero_stack, 1.0, int_stack+338712, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+522403,int_stack+124554,int_stack+123729, 0.0, zero_stack, 1.0, int_stack+254447, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+537268,int_stack+522403,int_stack+527803, 0.0, zero_stack, 1.0, int_stack+341232, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+541318,int_stack+537268,int_stack+529828, 0.0, zero_stack, 1.0, int_stack+343257, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+524878,int_stack+541318,int_stack+533068, 0.0, zero_stack, 1.0, int_stack+357382, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+531178,int_stack+125544,int_stack+124554, 0.0, zero_stack, 1.0, int_stack+255272, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+546718,int_stack+531178,int_stack+522403, 0.0, zero_stack, 1.0, int_stack+346497, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+934584,int_stack+546718,int_stack+537268, 0.0, zero_stack, 1.0, int_stack+361582, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+941334,int_stack+934584,int_stack+541318, 0.0, zero_stack, 1.0, int_stack+365632, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+534148,int_stack+941334,int_stack+524878, 0.0, zero_stack, 1.0, int_stack+371032, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|op) ---*/
   d1hrr3_build_op(Libderiv->CD,int_stack+522403,int_stack+126714,int_stack+125544, 0.0, zero_stack, 1.0, int_stack+256262, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|nd) ---*/
   d1hrr3_build_nd(Libderiv->CD,int_stack+551668,int_stack+522403,int_stack+531178, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|mf) ---*/
   d1hrr3_build_mf(Libderiv->CD,int_stack+522403,int_stack+551668,int_stack+546718, 0.0, zero_stack, 1.0, int_stack+377332, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lg) ---*/
   d1hrr3_build_lg(Libderiv->CD,int_stack+542968,int_stack+522403,int_stack+934584, 0.0, zero_stack, 1.0, int_stack+382282, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kh) ---*/
   d1hrr3_build_kh(Libderiv->CD,int_stack+522403,int_stack+542968,int_stack+941334, 0.0, zero_stack, 1.0, int_stack+389032, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ii) ---*/
   d1hrr3_build_ii(Libderiv->CD,int_stack+542968,int_stack+522403,int_stack+534148, 0.0, zero_stack, 1.0, int_stack+397132, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|ii) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+934584,int_stack+542968,int_stack+926744,784);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+926744,int_stack+128667,int_stack+128079, 0.0, zero_stack, 1.0, int_stack+264782, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+928508,int_stack+129423,int_stack+128667, 0.0, zero_stack, 1.0, int_stack+265370, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+930776,int_stack+928508,int_stack+926744, 0.0, zero_stack, 1.0, int_stack+405952, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+522403,int_stack+130368,int_stack+129423, 0.0, zero_stack, 1.0, int_stack+266126, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+525238,int_stack+522403,int_stack+928508, 0.0, zero_stack, 1.0, int_stack+407716, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+529774,int_stack+525238,int_stack+930776, 0.0, zero_stack, 1.0, int_stack+409984, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+926744,int_stack+131523,int_stack+130368, 0.0, zero_stack, 1.0, int_stack+267071, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+535654,int_stack+926744,int_stack+522403, 0.0, zero_stack, 1.0, int_stack+413512, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+958104,int_stack+535654,int_stack+525238, 0.0, zero_stack, 1.0, int_stack+416347, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+965664,int_stack+958104,int_stack+529774, 0.0, zero_stack, 1.0, int_stack+2970, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+522403,int_stack+132909,int_stack+131523, 0.0, zero_stack, 1.0, int_stack+268226, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+526561,int_stack+522403,int_stack+926744, 0.0, zero_stack, 1.0, int_stack+420883, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+87894,int_stack+526561,int_stack+535654, 0.0, zero_stack, 1.0, int_stack+348972, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+97344,int_stack+87894,int_stack+958104, 0.0, zero_stack, 1.0, int_stack+461797, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+108684,int_stack+97344,int_stack+965664, 0.0, zero_stack, 1.0, int_stack+469357, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|op) ---*/
   d1hrr3_build_op(Libderiv->CD,int_stack+958104,int_stack+134547,int_stack+132909, 0.0, zero_stack, 1.0, int_stack+269612, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|nd) ---*/
   d1hrr3_build_nd(Libderiv->CD,int_stack+963018,int_stack+958104,int_stack+522403, 0.0, zero_stack, 1.0, int_stack+478177, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|mf) ---*/
   d1hrr3_build_mf(Libderiv->CD,int_stack+121032,int_stack+963018,int_stack+526561, 0.0, zero_stack, 1.0, int_stack+482335, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lg) ---*/
   d1hrr3_build_lg(Libderiv->CD,int_stack+522403,int_stack+121032,int_stack+87894, 0.0, zero_stack, 1.0, int_stack+489265, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kh) ---*/
   d1hrr3_build_kh(Libderiv->CD,int_stack+958104,int_stack+522403,int_stack+97344, 0.0, zero_stack, 1.0, int_stack+498715, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ii) ---*/
   d1hrr3_build_ii(Libderiv->CD,int_stack+522403,int_stack+958104,int_stack+108684, 0.0, zero_stack, 1.0, int_stack+510055, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|ii) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+87894,int_stack+522403,int_stack+542968,784);
 /*--- compute (fd|ii) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+1117256,int_stack+87894,int_stack+934584,784);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+538867,int_stack+137242,int_stack+136458, 0.0, zero_stack, 1.0, int_stack+165984, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+541219,int_stack+138250,int_stack+137242, 0.0, zero_stack, 1.0, int_stack+167552, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+544243,int_stack+541219,int_stack+538867, 0.0, zero_stack, 1.0, int_stack+557683, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+548947,int_stack+139510,int_stack+138250, 0.0, zero_stack, 1.0, int_stack+169568, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+123174,int_stack+548947,int_stack+541219, 0.0, zero_stack, 1.0, int_stack+560035, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+129222,int_stack+123174,int_stack+544243, 0.0, zero_stack, 1.0, int_stack+8850, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+538867,int_stack+141050,int_stack+139510, 0.0, zero_stack, 1.0, int_stack+172088, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+926744,int_stack+538867,int_stack+548947, 0.0, zero_stack, 1.0, int_stack+13554, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+543487,int_stack+926744,int_stack+123174, 0.0, zero_stack, 1.0, int_stack+424348, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+934304,int_stack+543487,int_stack+129222, 0.0, zero_stack, 1.0, int_stack+430396, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+123174,int_stack+142898,int_stack+141050, 0.0, zero_stack, 1.0, int_stack+175168, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+128718,int_stack+123174,int_stack+538867, 0.0, zero_stack, 1.0, int_stack+438236, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+946064,int_stack+128718,int_stack+926744, 0.0, zero_stack, 1.0, int_stack+442856, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+958664,int_stack+946064,int_stack+543487, 0.0, zero_stack, 1.0, int_stack+450416, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+538867,int_stack+958664,int_stack+934304, 0.0, zero_stack, 1.0, int_stack+628684, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|op) ---*/
   d1hrr3_build_op(Libderiv->CD,int_stack+926744,int_stack+145082,int_stack+142898, 0.0, zero_stack, 1.0, int_stack+178864, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|nd) ---*/
   d1hrr3_build_nd(Libderiv->CD,int_stack+933296,int_stack+926744,int_stack+123174, 0.0, zero_stack, 1.0, int_stack+640444, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|mf) ---*/
   d1hrr3_build_mf(Libderiv->CD,int_stack+793492,int_stack+933296,int_stack+128718, 0.0, zero_stack, 1.0, int_stack+645988, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lg) ---*/
   d1hrr3_build_lg(Libderiv->CD,int_stack+123174,int_stack+793492,int_stack+946064, 0.0, zero_stack, 1.0, int_stack+655228, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kh) ---*/
   d1hrr3_build_kh(Libderiv->CD,int_stack+926744,int_stack+123174,int_stack+958664, 0.0, zero_stack, 1.0, int_stack+667828, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ii) ---*/
   d1hrr3_build_ii(Libderiv->CD,int_stack+123174,int_stack+926744,int_stack+538867, 0.0, zero_stack, 1.0, int_stack+682948, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|ii) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+926744,int_stack+123174,int_stack+522403,784);
 /*--- compute (gd|ii) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+1164296,int_stack+926744,int_stack+87894,784);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+87894,int_stack+147910,int_stack+147630, 1.0, int_stack+244832, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+88734,int_stack+148270,int_stack+147910, 1.0, int_stack+245112, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+89814,int_stack+88734,int_stack+87894, 1.0, int_stack+292712, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+91494,int_stack+148720,int_stack+148270, 1.0, int_stack+245472, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+92844,int_stack+91494,int_stack+88734, 1.0, int_stack+293552, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+95004,int_stack+92844,int_stack+89814, 1.0, int_stack+294632, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+292712,int_stack+149270,int_stack+148720, 1.0, int_stack+245922, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+87894,int_stack+292712,int_stack+91494, 1.0, int_stack+296312, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+97804,int_stack+87894,int_stack+92844, 1.0, int_stack+297662, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+294362,int_stack+97804,int_stack+95004, 1.0, int_stack+299822, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+298562,int_stack+149930,int_stack+149270, 1.0, int_stack+246472, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+90594,int_stack+298562,int_stack+292712, 1.0, int_stack+302622, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+101404,int_stack+90594,int_stack+87894, 1.0, int_stack+304272, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+300542,int_stack+101404,int_stack+97804, 1.0, int_stack+306972, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+93894,int_stack+300542,int_stack+294362, 1.0, int_stack+310572, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|op) ---*/
   d1hrr3_build_op(Libderiv->CD,int_stack+87894,int_stack+150710,int_stack+149930, 1.0, int_stack+247132, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|nd) ---*/
   d1hrr3_build_nd(Libderiv->CD,int_stack+292712,int_stack+87894,int_stack+298562, 1.0, int_stack+314772, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|mf) ---*/
   d1hrr3_build_mf(Libderiv->CD,int_stack+305942,int_stack+292712,int_stack+90594, 1.0, int_stack+316752, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|lg) ---*/
   d1hrr3_build_lg(Libderiv->CD,int_stack+292712,int_stack+305942,int_stack+101404, 1.0, int_stack+320052, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kh) ---*/
   d1hrr3_build_kh(Libderiv->CD,int_stack+305942,int_stack+292712,int_stack+300542, 1.0, int_stack+324552, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ii) ---*/
   d1hrr3_build_ii(Libderiv->CD,int_stack+292712,int_stack+305942,int_stack+93894, 1.0, int_stack+329952, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+300552,int_stack+152040,int_stack+151620, 1.0, int_stack+252812, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+301812,int_stack+152580,int_stack+152040, 1.0, int_stack+253232, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+303432,int_stack+301812,int_stack+300552, 1.0, int_stack+335832, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+305952,int_stack+153255,int_stack+152580, 1.0, int_stack+253772, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+307977,int_stack+305952,int_stack+301812, 1.0, int_stack+337092, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+87894,int_stack+307977,int_stack+303432, 1.0, int_stack+338712, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+335832,int_stack+154080,int_stack+153255, 1.0, int_stack+254447, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+300552,int_stack+335832,int_stack+305952, 1.0, int_stack+341232, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+92094,int_stack+300552,int_stack+307977, 1.0, int_stack+343257, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+338307,int_stack+92094,int_stack+87894, 1.0, int_stack+357382, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+87894,int_stack+155070,int_stack+154080, 1.0, int_stack+255272, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+304602,int_stack+87894,int_stack+335832, 1.0, int_stack+346497, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+97494,int_stack+304602,int_stack+300552, 1.0, int_stack+361582, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+104244,int_stack+97494,int_stack+92094, 1.0, int_stack+365632, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+112344,int_stack+104244,int_stack+338307, 1.0, int_stack+371032, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|op) ---*/
   d1hrr3_build_op(Libderiv->CD,int_stack+300552,int_stack+156240,int_stack+155070, 1.0, int_stack+256262, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|nd) ---*/
   d1hrr3_build_nd(Libderiv->CD,int_stack+335832,int_stack+300552,int_stack+87894, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|mf) ---*/
   d1hrr3_build_mf(Libderiv->CD,int_stack+87894,int_stack+335832,int_stack+304602, 1.0, int_stack+377332, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lg) ---*/
   d1hrr3_build_lg(Libderiv->CD,int_stack+335832,int_stack+87894,int_stack+97494, 1.0, int_stack+382282, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kh) ---*/
   d1hrr3_build_kh(Libderiv->CD,int_stack+87894,int_stack+335832,int_stack+104244, 1.0, int_stack+389032, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ii) ---*/
   d1hrr3_build_ii(Libderiv->CD,int_stack+335832,int_stack+87894,int_stack+112344, 1.0, int_stack+397132, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|ii) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+87894,int_stack+335832,int_stack+292712,784);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+292712,int_stack+158193,int_stack+157605, 1.0, int_stack+264782, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+294476,int_stack+158949,int_stack+158193, 1.0, int_stack+265370, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+296744,int_stack+294476,int_stack+292712, 1.0, int_stack+405952, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+300272,int_stack+159894,int_stack+158949, 1.0, int_stack+266126, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+303107,int_stack+300272,int_stack+294476, 1.0, int_stack+407716, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+307643,int_stack+303107,int_stack+296744, 1.0, int_stack+409984, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+405952,int_stack+161049,int_stack+159894, 1.0, int_stack+267071, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+292712,int_stack+405952,int_stack+300272, 1.0, int_stack+413512, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+111414,int_stack+292712,int_stack+303107, 1.0, int_stack+416347, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+409417,int_stack+111414,int_stack+307643, 1.0, int_stack+2970, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+2970,int_stack+162435,int_stack+161049, 1.0, int_stack+268226, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+298382,int_stack+2970,int_stack+405952, 1.0, int_stack+420883, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+305312,int_stack+298382,int_stack+292712, 1.0, int_stack+348972, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+118974,int_stack+305312,int_stack+111414, 1.0, int_stack+461797, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+130314,int_stack+118974,int_stack+409417, 1.0, int_stack+469357, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|op) ---*/
   d1hrr3_build_op(Libderiv->CD,int_stack+111414,int_stack+164073,int_stack+162435, 1.0, int_stack+269612, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|nd) ---*/
   d1hrr3_build_nd(Libderiv->CD,int_stack+405952,int_stack+111414,int_stack+2970, 1.0, int_stack+478177, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|mf) ---*/
   d1hrr3_build_mf(Libderiv->CD,int_stack+142662,int_stack+405952,int_stack+298382, 1.0, int_stack+482335, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lg) ---*/
   d1hrr3_build_lg(Libderiv->CD,int_stack+405952,int_stack+142662,int_stack+305312, 1.0, int_stack+489265, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kh) ---*/
   d1hrr3_build_kh(Libderiv->CD,int_stack+142662,int_stack+405952,int_stack+118974, 1.0, int_stack+498715, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ii) ---*/
   d1hrr3_build_ii(Libderiv->CD,int_stack+405952,int_stack+142662,int_stack+130314, 1.0, int_stack+510055, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|ii) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+522403,int_stack+405952,int_stack+335832,784);
 /*--- compute (fd|ii) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+111414,int_stack+522403,int_stack+87894,784);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+87894,int_stack+168560,int_stack+166768, 1.0, int_stack+165984, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+90246,int_stack+170828,int_stack+168560, 1.0, int_stack+167552, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+93270,int_stack+90246,int_stack+87894, 1.0, int_stack+557683, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+97974,int_stack+173628,int_stack+170828, 1.0, int_stack+169568, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+101754,int_stack+97974,int_stack+90246, 1.0, int_stack+560035, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+557683,int_stack+101754,int_stack+93270, 1.0, int_stack+8850, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+565523,int_stack+177016,int_stack+173628, 1.0, int_stack+172088, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+570143,int_stack+565523,int_stack+97974, 1.0, int_stack+13554, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+87894,int_stack+570143,int_stack+101754, 1.0, int_stack+424348, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+97974,int_stack+87894,int_stack+557683, 1.0, int_stack+430396, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+557683,int_stack+181048,int_stack+177016, 1.0, int_stack+175168, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+335832,int_stack+557683,int_stack+565523, 1.0, int_stack+438236, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+345072,int_stack+335832,int_stack+570143, 1.0, int_stack+442856, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+563227,int_stack+345072,int_stack+87894, 1.0, int_stack+450416, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+357672,int_stack+563227,int_stack+97974, 1.0, int_stack+628684, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|op) ---*/
   d1hrr3_build_op(Libderiv->CD,int_stack+628684,int_stack+183232,int_stack+181048, 1.0, int_stack+178864, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|nd) ---*/
   d1hrr3_build_nd(Libderiv->CD,int_stack+87894,int_stack+628684,int_stack+557683, 1.0, int_stack+640444, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|mf) ---*/
   d1hrr3_build_mf(Libderiv->CD,int_stack+628684,int_stack+87894,int_stack+335832, 1.0, int_stack+645988, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lg) ---*/
   d1hrr3_build_lg(Libderiv->CD,int_stack+87894,int_stack+628684,int_stack+345072, 1.0, int_stack+655228, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kh) ---*/
   d1hrr3_build_kh(Libderiv->CD,int_stack+628684,int_stack+87894,int_stack+563227, 1.0, int_stack+667828, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ii) ---*/
   d1hrr3_build_ii(Libderiv->CD,int_stack+87894,int_stack+628684,int_stack+357672, 1.0, int_stack+682948, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|ii) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+926744,int_stack+87894,int_stack+405952,784);
 /*--- compute (gd|ii) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+405952,int_stack+926744,int_stack+522403,784);
 /*--- compute (f0|op) ---*/
   hrr3_build_op(Libderiv->CD,int_stack+522403,int_stack+247912,int_stack+247132,10);
 /*--- compute (f0|nd) ---*/
   hrr3_build_nd(Libderiv->CD,int_stack+524743,int_stack+522403,int_stack+314772,10);
 /*--- compute (f0|mf) ---*/
   hrr3_build_mf(Libderiv->CD,int_stack+528703,int_stack+524743,int_stack+316752,10);
 /*--- compute (f0|lg) ---*/
   hrr3_build_lg(Libderiv->CD,int_stack+534203,int_stack+528703,int_stack+320052,10);
 /*--- compute (f0|kh) ---*/
   hrr3_build_kh(Libderiv->CD,int_stack+522403,int_stack+534203,int_stack+324552,10);
 /*--- compute (f0|ii) ---*/
   hrr3_build_ii(Libderiv->CD,int_stack+529963,int_stack+522403,int_stack+329952,10);
 /*--- compute (g0|op) ---*/
   hrr3_build_op(Libderiv->CD,int_stack+522403,int_stack+257432,int_stack+256262,15);
 /*--- compute (g0|nd) ---*/
   hrr3_build_nd(Libderiv->CD,int_stack+537803,int_stack+522403,int_stack+0,15);
 /*--- compute (g0|mf) ---*/
   hrr3_build_mf(Libderiv->CD,int_stack+0,int_stack+537803,int_stack+377332,15);
 /*--- compute (g0|lg) ---*/
   hrr3_build_lg(Libderiv->CD,int_stack+537803,int_stack+0,int_stack+382282,15);
 /*--- compute (g0|kh) ---*/
   hrr3_build_kh(Libderiv->CD,int_stack+0,int_stack+537803,int_stack+389032,15);
 /*--- compute (g0|ii) ---*/
   hrr3_build_ii(Libderiv->CD,int_stack+537803,int_stack+0,int_stack+397132,15);
 /*--- compute (fp|ii) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+87894,int_stack+537803,int_stack+529963,784);
 /*--- compute (h0|op) ---*/
   hrr3_build_op(Libderiv->CD,int_stack+0,int_stack+271250,int_stack+269612,21);
 /*--- compute (h0|nd) ---*/
   hrr3_build_nd(Libderiv->CD,int_stack+4914,int_stack+0,int_stack+478177,21);
 /*--- compute (h0|mf) ---*/
   hrr3_build_mf(Libderiv->CD,int_stack+549563,int_stack+4914,int_stack+482335,21);
 /*--- compute (h0|lg) ---*/
   hrr3_build_lg(Libderiv->CD,int_stack+0,int_stack+549563,int_stack+489265,21);
 /*--- compute (h0|kh) ---*/
   hrr3_build_kh(Libderiv->CD,int_stack+549563,int_stack+0,int_stack+498715,21);
 /*--- compute (h0|ii) ---*/
   hrr3_build_ii(Libderiv->CD,int_stack+0,int_stack+549563,int_stack+510055,21);
 /*--- compute (gp|ii) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+926744,int_stack+0,int_stack+537803,784);
 /*--- compute (fd|ii) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+476512,int_stack+926744,int_stack+87894,784);
 /*--- compute (f0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+549563,int_stack+186060,int_stack+185780,10);
 /*--- compute (f0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+550403,int_stack+186420,int_stack+186060,10);
 /*--- compute (f0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+551483,int_stack+550403,int_stack+549563,10);
 /*--- compute (f0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+553163,int_stack+186870,int_stack+186420,10);
 /*--- compute (f0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+554513,int_stack+553163,int_stack+550403,10);
 /*--- compute (f0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+556673,int_stack+554513,int_stack+551483,10);
 /*--- compute (f0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+549563,int_stack+187420,int_stack+186870,10);
 /*--- compute (f0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+559473,int_stack+549563,int_stack+553163,10);
 /*--- compute (f0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+562173,int_stack+559473,int_stack+554513,10);
 /*--- compute (f0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+551213,int_stack+562173,int_stack+556673,10);
 /*--- compute (f0|np) ---*/
   hrr3_build_np(Libderiv->CD,int_stack+555413,int_stack+188080,int_stack+187420,10);
 /*--- compute (f0|md) ---*/
   hrr3_build_md(Libderiv->CD,int_stack+565773,int_stack+555413,int_stack+549563,10);
 /*--- compute (f0|lf) ---*/
   hrr3_build_lf(Libderiv->CD,int_stack+569073,int_stack+565773,int_stack+559473,10);
 /*--- compute (f0|kg) ---*/
   hrr3_build_kg(Libderiv->CD,int_stack+573573,int_stack+569073,int_stack+562173,10);
 /*--- compute (f0|ih) ---*/
   hrr3_build_ih(Libderiv->CD,int_stack+557393,int_stack+573573,int_stack+551213,10);
 /*--- compute (f0|op) ---*/
   hrr3_build_op(Libderiv->CD,int_stack+549563,int_stack+188860,int_stack+188080,10);
 /*--- compute (f0|nd) ---*/
   hrr3_build_nd(Libderiv->CD,int_stack+962024,int_stack+549563,int_stack+555413,10);
 /*--- compute (f0|mf) ---*/
   hrr3_build_mf(Libderiv->CD,int_stack+549563,int_stack+962024,int_stack+565773,10);
 /*--- compute (f0|lg) ---*/
   hrr3_build_lg(Libderiv->CD,int_stack+962024,int_stack+549563,int_stack+569073,10);
 /*--- compute (f0|kh) ---*/
   hrr3_build_kh(Libderiv->CD,int_stack+549563,int_stack+962024,int_stack+573573,10);
 /*--- compute (f0|ii) ---*/
   hrr3_build_ii(Libderiv->CD,int_stack+962024,int_stack+549563,int_stack+557393,10);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+549563,int_stack+190190,int_stack+189770,15);
 /*--- compute (g0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+550823,int_stack+190730,int_stack+190190,15);
 /*--- compute (g0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+552443,int_stack+550823,int_stack+549563,15);
 /*--- compute (g0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+554963,int_stack+191405,int_stack+190730,15);
 /*--- compute (g0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+556988,int_stack+554963,int_stack+550823,15);
 /*--- compute (g0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+560228,int_stack+556988,int_stack+552443,15);
 /*--- compute (g0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+549563,int_stack+192230,int_stack+191405,15);
 /*--- compute (g0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+564428,int_stack+549563,int_stack+554963,15);
 /*--- compute (g0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+568478,int_stack+564428,int_stack+556988,15);
 /*--- compute (g0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+552038,int_stack+568478,int_stack+560228,15);
 /*--- compute (g0|np) ---*/
   hrr3_build_np(Libderiv->CD,int_stack+558338,int_stack+193220,int_stack+192230,15);
 /*--- compute (g0|md) ---*/
   hrr3_build_md(Libderiv->CD,int_stack+573878,int_stack+558338,int_stack+549563,15);
 /*--- compute (g0|lf) ---*/
   hrr3_build_lf(Libderiv->CD,int_stack+628684,int_stack+573878,int_stack+564428,15);
 /*--- compute (g0|kg) ---*/
   hrr3_build_kg(Libderiv->CD,int_stack+635434,int_stack+628684,int_stack+568478,15);
 /*--- compute (g0|ih) ---*/
   hrr3_build_ih(Libderiv->CD,int_stack+561308,int_stack+635434,int_stack+552038,15);
 /*--- compute (g0|op) ---*/
   hrr3_build_op(Libderiv->CD,int_stack+549563,int_stack+194390,int_stack+193220,15);
 /*--- compute (g0|nd) ---*/
   hrr3_build_nd(Libderiv->CD,int_stack+969864,int_stack+549563,int_stack+558338,15);
 /*--- compute (g0|mf) ---*/
   hrr3_build_mf(Libderiv->CD,int_stack+549563,int_stack+969864,int_stack+573878,15);
 /*--- compute (g0|lg) ---*/
   hrr3_build_lg(Libderiv->CD,int_stack+570128,int_stack+549563,int_stack+628684,15);
 /*--- compute (g0|kh) ---*/
   hrr3_build_kh(Libderiv->CD,int_stack+549563,int_stack+570128,int_stack+635434,15);
 /*--- compute (g0|ii) ---*/
   hrr3_build_ii(Libderiv->CD,int_stack+628684,int_stack+549563,int_stack+561308,15);
 /*--- compute (fp|ii) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+549563,int_stack+628684,int_stack+962024, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+529963, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,784);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+962024,int_stack+196343,int_stack+195755,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+963788,int_stack+197099,int_stack+196343,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+966056,int_stack+963788,int_stack+962024,21);
 /*--- compute (h0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+969584,int_stack+198044,int_stack+197099,21);
 /*--- compute (h0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+573083,int_stack+969584,int_stack+963788,21);
 /*--- compute (h0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+640444,int_stack+573083,int_stack+966056,21);
 /*--- compute (h0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+962024,int_stack+199199,int_stack+198044,21);
 /*--- compute (h0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+646324,int_stack+962024,int_stack+969584,21);
 /*--- compute (h0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+965489,int_stack+646324,int_stack+573083,21);
 /*--- compute (h0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+651994,int_stack+965489,int_stack+640444,21);
 /*--- compute (h0|np) ---*/
   hrr3_build_np(Libderiv->CD,int_stack+640444,int_stack+200585,int_stack+199199,21);
 /*--- compute (h0|md) ---*/
   hrr3_build_md(Libderiv->CD,int_stack+573083,int_stack+640444,int_stack+962024,21);
 /*--- compute (h0|lf) ---*/
   hrr3_build_lf(Libderiv->CD,int_stack+660814,int_stack+573083,int_stack+646324,21);
 /*--- compute (h0|kg) ---*/
   hrr3_build_kg(Libderiv->CD,int_stack+670264,int_stack+660814,int_stack+965489,21);
 /*--- compute (h0|ih) ---*/
   hrr3_build_ih(Libderiv->CD,int_stack+962024,int_stack+670264,int_stack+651994,21);
 /*--- compute (h0|op) ---*/
   hrr3_build_op(Libderiv->CD,int_stack+644602,int_stack+202223,int_stack+200585,21);
 /*--- compute (h0|nd) ---*/
   hrr3_build_nd(Libderiv->CD,int_stack+649516,int_stack+644602,int_stack+640444,21);
 /*--- compute (h0|mf) ---*/
   hrr3_build_mf(Libderiv->CD,int_stack+681604,int_stack+649516,int_stack+573083,21);
 /*--- compute (h0|lg) ---*/
   hrr3_build_lg(Libderiv->CD,int_stack+640444,int_stack+681604,int_stack+660814,21);
 /*--- compute (h0|kh) ---*/
   hrr3_build_kh(Libderiv->CD,int_stack+681604,int_stack+640444,int_stack+670264,21);
 /*--- compute (h0|ii) ---*/
   hrr3_build_ii(Libderiv->CD,int_stack+640444,int_stack+681604,int_stack+962024,21);
 /*--- compute (gp|ii) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+656908,int_stack+640444,int_stack+628684, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+537803, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,784);
 /*--- compute (fd|ii) ---*/
   d1hrr1_build_fd(Libderiv->AB,int_stack+292712,int_stack+656908,int_stack+549563, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+87894, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,784);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+549563,int_stack+204918,int_stack+204134,28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+551915,int_stack+205926,int_stack+204918,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+554939,int_stack+551915,int_stack+549563,28);
 /*--- compute (i0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+559643,int_stack+207186,int_stack+205926,28);
 /*--- compute (i0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+563423,int_stack+559643,int_stack+551915,28);
 /*--- compute (i0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+569471,int_stack+563423,int_stack+554939,28);
 /*--- compute (i0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+549563,int_stack+208726,int_stack+207186,28);
 /*--- compute (i0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+628684,int_stack+549563,int_stack+559643,28);
 /*--- compute (i0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+962024,int_stack+628684,int_stack+563423,28);
 /*--- compute (i0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+554183,int_stack+962024,int_stack+569471,28);
 /*--- compute (i0|np) ---*/
   hrr3_build_np(Libderiv->CD,int_stack+565943,int_stack+210574,int_stack+208726,28);
 /*--- compute (i0|md) ---*/
   hrr3_build_md(Libderiv->CD,int_stack+571487,int_stack+565943,int_stack+549563,28);
 /*--- compute (i0|lf) ---*/
   hrr3_build_lf(Libderiv->CD,int_stack+158454,int_stack+571487,int_stack+628684,28);
 /*--- compute (i0|kg) ---*/
   hrr3_build_kg(Libderiv->CD,int_stack+171054,int_stack+158454,int_stack+962024,28);
 /*--- compute (i0|ih) ---*/
   hrr3_build_ih(Libderiv->CD,int_stack+186174,int_stack+171054,int_stack+554183,28);
 /*--- compute (i0|op) ---*/
   hrr3_build_op(Libderiv->CD,int_stack+962024,int_stack+212758,int_stack+210574,28);
 /*--- compute (i0|nd) ---*/
   hrr3_build_nd(Libderiv->CD,int_stack+628684,int_stack+962024,int_stack+565943,28);
 /*--- compute (i0|mf) ---*/
   hrr3_build_mf(Libderiv->CD,int_stack+549563,int_stack+628684,int_stack+571487,28);
 /*--- compute (i0|lg) ---*/
   hrr3_build_lg(Libderiv->CD,int_stack+339752,int_stack+549563,int_stack+158454,28);
 /*--- compute (i0|kh) ---*/
   hrr3_build_kh(Libderiv->CD,int_stack+549563,int_stack+339752,int_stack+171054,28);
 /*--- compute (i0|ii) ---*/
   hrr3_build_ii(Libderiv->CD,int_stack+339752,int_stack+549563,int_stack+186174,28);
 /*--- compute (hp|ii) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+158454,int_stack+339752,int_stack+640444, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,784);
 /*--- compute (gd|ii) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+1234856,int_stack+158454,int_stack+656908, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+926744, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,784);
 /*--- compute (f0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+158454,int_stack+215586,int_stack+215306,10);
 /*--- compute (f0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+159294,int_stack+215946,int_stack+215586,10);
 /*--- compute (f0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+160374,int_stack+159294,int_stack+158454,10);
 /*--- compute (f0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+162054,int_stack+216396,int_stack+215946,10);
 /*--- compute (f0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+163404,int_stack+162054,int_stack+159294,10);
 /*--- compute (f0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+165564,int_stack+163404,int_stack+160374,10);
 /*--- compute (f0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+158454,int_stack+216946,int_stack+216396,10);
 /*--- compute (f0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+168364,int_stack+158454,int_stack+162054,10);
 /*--- compute (f0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+171064,int_stack+168364,int_stack+163404,10);
 /*--- compute (f0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+160104,int_stack+171064,int_stack+165564,10);
 /*--- compute (f0|np) ---*/
   hrr3_build_np(Libderiv->CD,int_stack+164304,int_stack+217606,int_stack+216946,10);
 /*--- compute (f0|md) ---*/
   hrr3_build_md(Libderiv->CD,int_stack+174664,int_stack+164304,int_stack+158454,10);
 /*--- compute (f0|lf) ---*/
   hrr3_build_lf(Libderiv->CD,int_stack+177964,int_stack+174664,int_stack+168364,10);
 /*--- compute (f0|kg) ---*/
   hrr3_build_kg(Libderiv->CD,int_stack+182464,int_stack+177964,int_stack+171064,10);
 /*--- compute (f0|ih) ---*/
   hrr3_build_ih(Libderiv->CD,int_stack+166284,int_stack+182464,int_stack+160104,10);
 /*--- compute (f0|op) ---*/
   hrr3_build_op(Libderiv->CD,int_stack+158454,int_stack+218386,int_stack+217606,10);
 /*--- compute (f0|nd) ---*/
   hrr3_build_nd(Libderiv->CD,int_stack+187864,int_stack+158454,int_stack+164304,10);
 /*--- compute (f0|mf) ---*/
   hrr3_build_mf(Libderiv->CD,int_stack+158454,int_stack+187864,int_stack+174664,10);
 /*--- compute (f0|lg) ---*/
   hrr3_build_lg(Libderiv->CD,int_stack+187864,int_stack+158454,int_stack+177964,10);
 /*--- compute (f0|kh) ---*/
   hrr3_build_kh(Libderiv->CD,int_stack+158454,int_stack+187864,int_stack+182464,10);
 /*--- compute (f0|ii) ---*/
   hrr3_build_ii(Libderiv->CD,int_stack+172164,int_stack+158454,int_stack+166284,10);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+158454,int_stack+219716,int_stack+219296,15);
 /*--- compute (g0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+159714,int_stack+220256,int_stack+219716,15);
 /*--- compute (g0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+161334,int_stack+159714,int_stack+158454,15);
 /*--- compute (g0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+163854,int_stack+220931,int_stack+220256,15);
 /*--- compute (g0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+165879,int_stack+163854,int_stack+159714,15);
 /*--- compute (g0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+180004,int_stack+165879,int_stack+161334,15);
 /*--- compute (g0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+158454,int_stack+221756,int_stack+220931,15);
 /*--- compute (g0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+184204,int_stack+158454,int_stack+163854,15);
 /*--- compute (g0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+188254,int_stack+184204,int_stack+165879,15);
 /*--- compute (g0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+160929,int_stack+188254,int_stack+180004,15);
 /*--- compute (g0|np) ---*/
   hrr3_build_np(Libderiv->CD,int_stack+180004,int_stack+222746,int_stack+221756,15);
 /*--- compute (g0|md) ---*/
   hrr3_build_md(Libderiv->CD,int_stack+193654,int_stack+180004,int_stack+158454,15);
 /*--- compute (g0|lf) ---*/
   hrr3_build_lf(Libderiv->CD,int_stack+198604,int_stack+193654,int_stack+184204,15);
 /*--- compute (g0|kg) ---*/
   hrr3_build_kg(Libderiv->CD,int_stack+205354,int_stack+198604,int_stack+188254,15);
 /*--- compute (g0|ih) ---*/
   hrr3_build_ih(Libderiv->CD,int_stack+182974,int_stack+205354,int_stack+160929,15);
 /*--- compute (g0|op) ---*/
   hrr3_build_op(Libderiv->CD,int_stack+158454,int_stack+223916,int_stack+222746,15);
 /*--- compute (g0|nd) ---*/
   hrr3_build_nd(Libderiv->CD,int_stack+161964,int_stack+158454,int_stack+180004,15);
 /*--- compute (g0|mf) ---*/
   hrr3_build_mf(Libderiv->CD,int_stack+213454,int_stack+161964,int_stack+193654,15);
 /*--- compute (g0|lg) ---*/
   hrr3_build_lg(Libderiv->CD,int_stack+158454,int_stack+213454,int_stack+198604,15);
 /*--- compute (g0|kh) ---*/
   hrr3_build_kh(Libderiv->CD,int_stack+213454,int_stack+158454,int_stack+205354,15);
 /*--- compute (g0|ii) ---*/
   hrr3_build_ii(Libderiv->CD,int_stack+158454,int_stack+213454,int_stack+182974,15);
 /*--- compute (fp|ii) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+180004,int_stack+158454,int_stack+172164, 0.0, zero_stack, 1.0, int_stack+529963, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,784);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+170214,int_stack+225869,int_stack+225281,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+171978,int_stack+226625,int_stack+225869,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+174246,int_stack+171978,int_stack+170214,21);
 /*--- compute (h0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+203524,int_stack+227570,int_stack+226625,21);
 /*--- compute (h0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+206359,int_stack+203524,int_stack+171978,21);
 /*--- compute (h0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+210895,int_stack+206359,int_stack+174246,21);
 /*--- compute (h0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+170214,int_stack+228725,int_stack+227570,21);
 /*--- compute (h0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+173679,int_stack+170214,int_stack+203524,21);
 /*--- compute (h0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+216775,int_stack+173679,int_stack+206359,21);
 /*--- compute (h0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+339752,int_stack+216775,int_stack+210895,21);
 /*--- compute (h0|np) ---*/
   hrr3_build_np(Libderiv->CD,int_stack+203524,int_stack+230111,int_stack+228725,21);
 /*--- compute (h0|md) ---*/
   hrr3_build_md(Libderiv->CD,int_stack+207682,int_stack+203524,int_stack+170214,21);
 /*--- compute (h0|lf) ---*/
   hrr3_build_lf(Libderiv->CD,int_stack+348572,int_stack+207682,int_stack+173679,21);
 /*--- compute (h0|kg) ---*/
   hrr3_build_kg(Libderiv->CD,int_stack+358022,int_stack+348572,int_stack+216775,21);
 /*--- compute (h0|ih) ---*/
   hrr3_build_ih(Libderiv->CD,int_stack+214612,int_stack+358022,int_stack+339752,21);
 /*--- compute (h0|op) ---*/
   hrr3_build_op(Libderiv->CD,int_stack+339752,int_stack+231749,int_stack+230111,21);
 /*--- compute (h0|nd) ---*/
   hrr3_build_nd(Libderiv->CD,int_stack+170214,int_stack+339752,int_stack+203524,21);
 /*--- compute (h0|mf) ---*/
   hrr3_build_mf(Libderiv->CD,int_stack+369362,int_stack+170214,int_stack+207682,21);
 /*--- compute (h0|lg) ---*/
   hrr3_build_lg(Libderiv->CD,int_stack+380912,int_stack+369362,int_stack+348572,21);
 /*--- compute (h0|kh) ---*/
   hrr3_build_kh(Libderiv->CD,int_stack+339752,int_stack+380912,int_stack+358022,21);
 /*--- compute (h0|ii) ---*/
   hrr3_build_ii(Libderiv->CD,int_stack+355628,int_stack+339752,int_stack+214612,21);
 /*--- compute (gp|ii) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+628684,int_stack+355628,int_stack+158454, 0.0, zero_stack, 1.0, int_stack+537803, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,784);
 /*--- compute (fd|ii) ---*/
   d1hrr1_build_fd(Libderiv->AB,int_stack+1305416,int_stack+628684,int_stack+180004, 0.0, zero_stack, 1.0, int_stack+87894, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,784);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+158454,int_stack+234444,int_stack+233660,28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+160806,int_stack+235452,int_stack+234444,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+163830,int_stack+160806,int_stack+158454,28);
 /*--- compute (i0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+168534,int_stack+236712,int_stack+235452,28);
 /*--- compute (i0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+172314,int_stack+168534,int_stack+160806,28);
 /*--- compute (i0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+178362,int_stack+172314,int_stack+163830,28);
 /*--- compute (i0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+158454,int_stack+238252,int_stack+236712,28);
 /*--- compute (i0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+186202,int_stack+158454,int_stack+168534,28);
 /*--- compute (i0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+193762,int_stack+186202,int_stack+172314,28);
 /*--- compute (i0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+163074,int_stack+193762,int_stack+178362,28);
 /*--- compute (i0|np) ---*/
   hrr3_build_np(Libderiv->CD,int_stack+174834,int_stack+240100,int_stack+238252,28);
 /*--- compute (i0|md) ---*/
   hrr3_build_md(Libderiv->CD,int_stack+203842,int_stack+174834,int_stack+158454,28);
 /*--- compute (i0|lf) ---*/
   hrr3_build_lf(Libderiv->CD,int_stack+213082,int_stack+203842,int_stack+186202,28);
 /*--- compute (i0|kg) ---*/
   hrr3_build_kg(Libderiv->CD,int_stack+339752,int_stack+213082,int_stack+193762,28);
 /*--- compute (i0|ih) ---*/
   hrr3_build_ih(Libderiv->CD,int_stack+180378,int_stack+339752,int_stack+163074,28);
 /*--- compute (i0|op) ---*/
   hrr3_build_op(Libderiv->CD,int_stack+158454,int_stack+242284,int_stack+240100,28);
 /*--- compute (i0|nd) ---*/
   hrr3_build_nd(Libderiv->CD,int_stack+225682,int_stack+158454,int_stack+174834,28);
 /*--- compute (i0|mf) ---*/
   hrr3_build_mf(Libderiv->CD,int_stack+158454,int_stack+225682,int_stack+203842,28);
 /*--- compute (i0|lg) ---*/
   hrr3_build_lg(Libderiv->CD,int_stack+225682,int_stack+158454,int_stack+213082,28);
 /*--- compute (i0|kh) ---*/
   hrr3_build_kh(Libderiv->CD,int_stack+158454,int_stack+225682,int_stack+339752,28);
 /*--- compute (i0|ii) ---*/
   hrr3_build_ii(Libderiv->CD,int_stack+196842,int_stack+158454,int_stack+180378,28);
 /*--- compute (hp|ii) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+1352456,int_stack+196842,int_stack+355628, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,784);
 /*--- compute (gd|ii) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+158454,int_stack+1352456,int_stack+628684, 0.0, zero_stack, 1.0, int_stack+926744, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,784);
 /*--- compute (f0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+628684,int_stack+249102,int_stack+248822,10);
 /*--- compute (f0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+629524,int_stack+249462,int_stack+249102,10);
 /*--- compute (f0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+630604,int_stack+629524,int_stack+628684,10);
 /*--- compute (f0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+632284,int_stack+249912,int_stack+249462,10);
 /*--- compute (f0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+633634,int_stack+632284,int_stack+629524,10);
 /*--- compute (f0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+635794,int_stack+633634,int_stack+630604,10);
 /*--- compute (f0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+628684,int_stack+250462,int_stack+249912,10);
 /*--- compute (f0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+638594,int_stack+628684,int_stack+632284,10);
 /*--- compute (f0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+641294,int_stack+638594,int_stack+633634,10);
 /*--- compute (f0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+630334,int_stack+641294,int_stack+635794,10);
 /*--- compute (f0|np) ---*/
   hrr3_build_np(Libderiv->CD,int_stack+634534,int_stack+251122,int_stack+250462,10);
 /*--- compute (f0|md) ---*/
   hrr3_build_md(Libderiv->CD,int_stack+644894,int_stack+634534,int_stack+628684,10);
 /*--- compute (f0|lf) ---*/
   hrr3_build_lf(Libderiv->CD,int_stack+648194,int_stack+644894,int_stack+638594,10);
 /*--- compute (f0|kg) ---*/
   hrr3_build_kg(Libderiv->CD,int_stack+652694,int_stack+648194,int_stack+641294,10);
 /*--- compute (f0|ih) ---*/
   hrr3_build_ih(Libderiv->CD,int_stack+636514,int_stack+652694,int_stack+630334,10);
 /*--- compute (f0|op) ---*/
   hrr3_build_op(Libderiv->CD,int_stack+628684,int_stack+251902,int_stack+251122,10);
 /*--- compute (f0|nd) ---*/
   hrr3_build_nd(Libderiv->CD,int_stack+658094,int_stack+628684,int_stack+634534,10);
 /*--- compute (f0|mf) ---*/
   hrr3_build_mf(Libderiv->CD,int_stack+628684,int_stack+658094,int_stack+644894,10);
 /*--- compute (f0|lg) ---*/
   hrr3_build_lg(Libderiv->CD,int_stack+658094,int_stack+628684,int_stack+648194,10);
 /*--- compute (f0|kh) ---*/
   hrr3_build_kh(Libderiv->CD,int_stack+628684,int_stack+658094,int_stack+652694,10);
 /*--- compute (f0|ii) ---*/
   hrr3_build_ii(Libderiv->CD,int_stack+642394,int_stack+628684,int_stack+636514,10);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+628684,int_stack+259217,int_stack+258797,15);
 /*--- compute (g0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+629944,int_stack+259757,int_stack+259217,15);
 /*--- compute (g0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+631564,int_stack+629944,int_stack+628684,15);
 /*--- compute (g0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+634084,int_stack+260432,int_stack+259757,15);
 /*--- compute (g0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+636109,int_stack+634084,int_stack+629944,15);
 /*--- compute (g0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+650234,int_stack+636109,int_stack+631564,15);
 /*--- compute (g0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+628684,int_stack+261257,int_stack+260432,15);
 /*--- compute (g0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+654434,int_stack+628684,int_stack+634084,15);
 /*--- compute (g0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+658484,int_stack+654434,int_stack+636109,15);
 /*--- compute (g0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+631159,int_stack+658484,int_stack+650234,15);
 /*--- compute (g0|np) ---*/
   hrr3_build_np(Libderiv->CD,int_stack+650234,int_stack+262247,int_stack+261257,15);
 /*--- compute (g0|md) ---*/
   hrr3_build_md(Libderiv->CD,int_stack+663884,int_stack+650234,int_stack+628684,15);
 /*--- compute (g0|lf) ---*/
   hrr3_build_lf(Libderiv->CD,int_stack+668834,int_stack+663884,int_stack+654434,15);
 /*--- compute (g0|kg) ---*/
   hrr3_build_kg(Libderiv->CD,int_stack+675584,int_stack+668834,int_stack+658484,15);
 /*--- compute (g0|ih) ---*/
   hrr3_build_ih(Libderiv->CD,int_stack+653204,int_stack+675584,int_stack+631159,15);
 /*--- compute (g0|op) ---*/
   hrr3_build_op(Libderiv->CD,int_stack+628684,int_stack+263417,int_stack+262247,15);
 /*--- compute (g0|nd) ---*/
   hrr3_build_nd(Libderiv->CD,int_stack+632194,int_stack+628684,int_stack+650234,15);
 /*--- compute (g0|mf) ---*/
   hrr3_build_mf(Libderiv->CD,int_stack+683684,int_stack+632194,int_stack+663884,15);
 /*--- compute (g0|lg) ---*/
   hrr3_build_lg(Libderiv->CD,int_stack+628684,int_stack+683684,int_stack+668834,15);
 /*--- compute (g0|kh) ---*/
   hrr3_build_kh(Libderiv->CD,int_stack+683684,int_stack+628684,int_stack+675584,15);
 /*--- compute (g0|ii) ---*/
   hrr3_build_ii(Libderiv->CD,int_stack+628684,int_stack+683684,int_stack+653204,15);
 /*--- compute (fp|ii) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+650234,int_stack+628684,int_stack+642394, 1.0, int_stack+529963, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,784);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+640444,int_stack+273749,int_stack+273161,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+642208,int_stack+274505,int_stack+273749,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+644476,int_stack+642208,int_stack+640444,21);
 /*--- compute (h0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+673754,int_stack+275450,int_stack+274505,21);
 /*--- compute (h0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+676589,int_stack+673754,int_stack+642208,21);
 /*--- compute (h0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+681125,int_stack+676589,int_stack+644476,21);
 /*--- compute (h0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+640444,int_stack+276605,int_stack+275450,21);
 /*--- compute (h0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+643909,int_stack+640444,int_stack+673754,21);
 /*--- compute (h0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+687005,int_stack+643909,int_stack+676589,21);
 /*--- compute (h0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+1352456,int_stack+687005,int_stack+681125,21);
 /*--- compute (h0|np) ---*/
   hrr3_build_np(Libderiv->CD,int_stack+673754,int_stack+277991,int_stack+276605,21);
 /*--- compute (h0|md) ---*/
   hrr3_build_md(Libderiv->CD,int_stack+677912,int_stack+673754,int_stack+640444,21);
 /*--- compute (h0|lf) ---*/
   hrr3_build_lf(Libderiv->CD,int_stack+1361276,int_stack+677912,int_stack+643909,21);
 /*--- compute (h0|kg) ---*/
   hrr3_build_kg(Libderiv->CD,int_stack+1370726,int_stack+1361276,int_stack+687005,21);
 /*--- compute (h0|ih) ---*/
   hrr3_build_ih(Libderiv->CD,int_stack+684842,int_stack+1370726,int_stack+1352456,21);
 /*--- compute (h0|op) ---*/
   hrr3_build_op(Libderiv->CD,int_stack+1352456,int_stack+279629,int_stack+277991,21);
 /*--- compute (h0|nd) ---*/
   hrr3_build_nd(Libderiv->CD,int_stack+640444,int_stack+1352456,int_stack+673754,21);
 /*--- compute (h0|mf) ---*/
   hrr3_build_mf(Libderiv->CD,int_stack+1382066,int_stack+640444,int_stack+677912,21);
 /*--- compute (h0|lg) ---*/
   hrr3_build_lg(Libderiv->CD,int_stack+229014,int_stack+1382066,int_stack+1361276,21);
 /*--- compute (h0|kh) ---*/
   hrr3_build_kh(Libderiv->CD,int_stack+1382066,int_stack+229014,int_stack+1370726,21);
 /*--- compute (h0|ii) ---*/
   hrr3_build_ii(Libderiv->CD,int_stack+229014,int_stack+1382066,int_stack+684842,21);
 /*--- compute (gp|ii) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+245478,int_stack+229014,int_stack+628684, 1.0, int_stack+537803, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,784);
 /*--- compute (fd|ii) ---*/
   d1hrr1_build_fd(Libderiv->AB,int_stack+1352456,int_stack+245478,int_stack+650234, 1.0, int_stack+87894, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,784);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+87894,int_stack+282324,int_stack+281540,28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+90246,int_stack+283332,int_stack+282324,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+93270,int_stack+90246,int_stack+87894,28);
 /*--- compute (i0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+97974,int_stack+284592,int_stack+283332,28);
 /*--- compute (i0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+101754,int_stack+97974,int_stack+90246,28);
 /*--- compute (i0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+628684,int_stack+101754,int_stack+93270,28);
 /*--- compute (i0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+87894,int_stack+286132,int_stack+284592,28);
 /*--- compute (i0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+636524,int_stack+87894,int_stack+97974,28);
 /*--- compute (i0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+644084,int_stack+636524,int_stack+101754,28);
 /*--- compute (i0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+92514,int_stack+644084,int_stack+628684,28);
 /*--- compute (i0|np) ---*/
   hrr3_build_np(Libderiv->CD,int_stack+628684,int_stack+287980,int_stack+286132,28);
 /*--- compute (i0|md) ---*/
   hrr3_build_md(Libderiv->CD,int_stack+654164,int_stack+628684,int_stack+87894,28);
 /*--- compute (i0|lf) ---*/
   hrr3_build_lf(Libderiv->CD,int_stack+663404,int_stack+654164,int_stack+636524,28);
 /*--- compute (i0|kg) ---*/
   hrr3_build_kg(Libderiv->CD,int_stack+676004,int_stack+663404,int_stack+644084,28);
 /*--- compute (i0|ih) ---*/
   hrr3_build_ih(Libderiv->CD,int_stack+634228,int_stack+676004,int_stack+92514,28);
 /*--- compute (i0|op) ---*/
   hrr3_build_op(Libderiv->CD,int_stack+87894,int_stack+290164,int_stack+287980,28);
 /*--- compute (i0|nd) ---*/
   hrr3_build_nd(Libderiv->CD,int_stack+94446,int_stack+87894,int_stack+628684,28);
 /*--- compute (i0|mf) ---*/
   hrr3_build_mf(Libderiv->CD,int_stack+339752,int_stack+94446,int_stack+654164,28);
 /*--- compute (i0|lg) ---*/
   hrr3_build_lg(Libderiv->CD,int_stack+87894,int_stack+339752,int_stack+663404,28);
 /*--- compute (i0|kh) ---*/
   hrr3_build_kh(Libderiv->CD,int_stack+339752,int_stack+87894,int_stack+676004,28);
 /*--- compute (i0|ii) ---*/
   hrr3_build_ii(Libderiv->CD,int_stack+87894,int_stack+339752,int_stack+634228,28);
 /*--- compute (hp|ii) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+339752,int_stack+87894,int_stack+229014, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,784);
 /*--- compute (gd|ii) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+628684,int_stack+339752,int_stack+245478, 1.0, int_stack+926744, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,784);
 /*--- compute (ff|ii) ---*/
   hrr1_build_ff(Libderiv->AB,int_stack+1399496,int_stack+809144,int_stack+581644,784);
     Libderiv->ABCD[11] = int_stack + 1399496;
 /*--- compute (ff|ii) ---*/
   hrr1_build_ff(Libderiv->AB,int_stack+523552,int_stack+976136,int_stack+879704,784);
     Libderiv->ABCD[10] = int_stack + 523552;
 /*--- compute (ff|ii) ---*/
   hrr1_build_ff(Libderiv->AB,int_stack+793492,int_stack+1046696,int_stack+699412,784);
     Libderiv->ABCD[9] = int_stack + 793492;
 /*--- compute (ff|ii) ---*/
   hrr1_build_ff(Libderiv->AB,int_stack+871892,int_stack+17334,int_stack+746452,784);
     Libderiv->ABCD[8] = int_stack + 871892;
 /*--- compute (ff|ii) ---*/
   hrr1_build_ff(Libderiv->AB,int_stack+0,int_stack+1164296,int_stack+1117256,784);
     Libderiv->ABCD[7] = int_stack + 0;
 /*--- compute (ff|ii) ---*/
   hrr1_build_ff(Libderiv->AB,int_stack+699244,int_stack+405952,int_stack+111414,784);
     Libderiv->ABCD[6] = int_stack + 699244;
 /*--- compute (ff|ii) ---*/
   d1hrr1_build_ff(Libderiv->AB,int_stack+339752,int_stack+1234856,int_stack+292712, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+476512, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,784);
     Libderiv->ABCD[2] = int_stack + 339752;
 /*--- compute (ff|ii) ---*/
   d1hrr1_build_ff(Libderiv->AB,int_stack+78400,int_stack+158454,int_stack+1305416, 0.0, zero_stack, 1.0, int_stack+476512, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,784);
     Libderiv->ABCD[1] = int_stack + 78400;
 /*--- compute (ff|ii) ---*/
   d1hrr1_build_ff(Libderiv->AB,int_stack+156800,int_stack+628684,int_stack+1352456, 1.0, int_stack+476512, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,784);
     Libderiv->ABCD[0] = int_stack + 156800;

}
