/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include "libint.h"
#include "vrr_header.h"

  /* Computes quartets necessary to compute (lh|kk) integrals */

void vrr_order_lhkk(Libint_t * Libint, prim_data *Data)
{
 REALTYPE *vrr_stack = Libint->vrr_stack;
 REALTYPE *tmp, *target_ptr;
 int i, am[2];
 _BUILD_p000(Data,vrr_stack+0, Data->F+10, Data->F+11, NULL, NULL, NULL);
 _BUILD_p000(Data,vrr_stack+3, Data->F+9, Data->F+10, NULL, NULL, NULL);
 _BUILD_d000(Data,vrr_stack+6, vrr_stack+3, vrr_stack+0, Data->F+9, Data->F+10, NULL);
 _BUILD_p000(Data,vrr_stack+12, Data->F+8, Data->F+9, NULL, NULL, NULL);
 _BUILD_d000(Data,vrr_stack+15, vrr_stack+12, vrr_stack+3, Data->F+8, Data->F+9, NULL);
 _BUILD_p000(Data,vrr_stack+21, Data->F+11, Data->F+12, NULL, NULL, NULL);
 _BUILD_d000(Data,vrr_stack+24, vrr_stack+0, vrr_stack+21, Data->F+10, Data->F+11, NULL);
 _BUILD_f000(Data,vrr_stack+30, vrr_stack+6, vrr_stack+24, vrr_stack+3, vrr_stack+0, NULL);
 _BUILD_f000(Data,vrr_stack+40, vrr_stack+15, vrr_stack+6, vrr_stack+12, vrr_stack+3, NULL);
 _BUILD_g000(Data,vrr_stack+50, vrr_stack+40, vrr_stack+30, vrr_stack+15, vrr_stack+6, NULL);
 _BUILD_p000(Data,vrr_stack+65, Data->F+7, Data->F+8, NULL, NULL, NULL);
 _BUILD_d000(Data,vrr_stack+68, vrr_stack+65, vrr_stack+12, Data->F+7, Data->F+8, NULL);
 _BUILD_f000(Data,vrr_stack+74, vrr_stack+68, vrr_stack+15, vrr_stack+65, vrr_stack+12, NULL);
 _BUILD_g000(Data,vrr_stack+84, vrr_stack+74, vrr_stack+40, vrr_stack+68, vrr_stack+15, NULL);
 _BUILD_p000(Data,vrr_stack+99, Data->F+12, Data->F+13, NULL, NULL, NULL);
 _BUILD_d000(Data,vrr_stack+102, vrr_stack+21, vrr_stack+99, Data->F+11, Data->F+12, NULL);
 _BUILD_f000(Data,vrr_stack+108, vrr_stack+24, vrr_stack+102, vrr_stack+0, vrr_stack+21, NULL);
 _BUILD_g000(Data,vrr_stack+118, vrr_stack+30, vrr_stack+108, vrr_stack+6, vrr_stack+24, NULL);
 _BUILD_h000(Data,vrr_stack+133, vrr_stack+50, vrr_stack+118, vrr_stack+40, vrr_stack+30, NULL);
 _BUILD_h000(Data,vrr_stack+154, vrr_stack+84, vrr_stack+50, vrr_stack+74, vrr_stack+40, NULL);
 _BUILD_i000(Data,vrr_stack+175, vrr_stack+154, vrr_stack+133, vrr_stack+84, vrr_stack+50, NULL);
 _BUILD_00p0(Data,vrr_stack+203, Data->F+10, Data->F+11, NULL, NULL, NULL);
 _BUILD_00p0(Data,vrr_stack+206, Data->F+9, Data->F+10, NULL, NULL, NULL);
 _BUILD_p0p0(Data,vrr_stack+209, vrr_stack+206, vrr_stack+203, NULL, NULL, Data->F+10);
 _BUILD_00p0(Data,vrr_stack+218, Data->F+8, Data->F+9, NULL, NULL, NULL);
 _BUILD_p0p0(Data,vrr_stack+221, vrr_stack+218, vrr_stack+206, NULL, NULL, Data->F+9);
 _BUILD_00p0(Data,vrr_stack+230, Data->F+11, Data->F+12, NULL, NULL, NULL);
 _BUILD_p0p0(Data,vrr_stack+233, vrr_stack+203, vrr_stack+230, NULL, NULL, Data->F+11);
 _BUILD_d0p0(Data,vrr_stack+242, vrr_stack+209, vrr_stack+233, vrr_stack+206, vrr_stack+203, vrr_stack+0);
 _BUILD_d0p0(Data,vrr_stack+260, vrr_stack+221, vrr_stack+209, vrr_stack+218, vrr_stack+206, vrr_stack+3);
 _BUILD_f0p0(Data,vrr_stack+278, vrr_stack+260, vrr_stack+242, vrr_stack+221, vrr_stack+209, vrr_stack+6);
 _BUILD_00p0(Data,vrr_stack+0, Data->F+7, Data->F+8, NULL, NULL, NULL);
 _BUILD_p0p0(Data,vrr_stack+3, vrr_stack+0, vrr_stack+218, NULL, NULL, Data->F+8);
 _BUILD_d0p0(Data,vrr_stack+308, vrr_stack+3, vrr_stack+221, vrr_stack+0, vrr_stack+218, vrr_stack+12);
 _BUILD_f0p0(Data,vrr_stack+326, vrr_stack+308, vrr_stack+260, vrr_stack+3, vrr_stack+221, vrr_stack+15);
 _BUILD_00p0(Data,vrr_stack+12, Data->F+12, Data->F+13, NULL, NULL, NULL);
 _BUILD_p0p0(Data,vrr_stack+356, vrr_stack+230, vrr_stack+12, NULL, NULL, Data->F+12);
 _BUILD_d0p0(Data,vrr_stack+365, vrr_stack+233, vrr_stack+356, vrr_stack+203, vrr_stack+230, vrr_stack+21);
 _BUILD_f0p0(Data,vrr_stack+383, vrr_stack+242, vrr_stack+365, vrr_stack+209, vrr_stack+233, vrr_stack+24);
 _BUILD_g0p0(Data,vrr_stack+413, vrr_stack+278, vrr_stack+383, vrr_stack+260, vrr_stack+242, vrr_stack+30);
 _BUILD_g0p0(Data,vrr_stack+458, vrr_stack+326, vrr_stack+278, vrr_stack+308, vrr_stack+260, vrr_stack+40);
 _BUILD_h0p0(Data,vrr_stack+503, vrr_stack+458, vrr_stack+413, vrr_stack+326, vrr_stack+278, vrr_stack+50);
 _BUILD_00p0(Data,vrr_stack+15, Data->F+6, Data->F+7, NULL, NULL, NULL);
 _BUILD_p0p0(Data,vrr_stack+18, vrr_stack+15, vrr_stack+0, NULL, NULL, Data->F+7);
 _BUILD_d0p0(Data,vrr_stack+27, vrr_stack+18, vrr_stack+3, vrr_stack+15, vrr_stack+0, vrr_stack+65);
 _BUILD_f0p0(Data,vrr_stack+566, vrr_stack+27, vrr_stack+308, vrr_stack+18, vrr_stack+3, vrr_stack+68);
 _BUILD_g0p0(Data,vrr_stack+596, vrr_stack+566, vrr_stack+326, vrr_stack+27, vrr_stack+308, vrr_stack+74);
 _BUILD_h0p0(Data,vrr_stack+641, vrr_stack+596, vrr_stack+458, vrr_stack+566, vrr_stack+326, vrr_stack+84);
 _BUILD_00p0(Data,vrr_stack+45, Data->F+13, Data->F+14, NULL, NULL, NULL);
 _BUILD_p0p0(Data,vrr_stack+48, vrr_stack+12, vrr_stack+45, NULL, NULL, Data->F+13);
 _BUILD_d0p0(Data,vrr_stack+57, vrr_stack+356, vrr_stack+48, vrr_stack+230, vrr_stack+12, vrr_stack+99);
 _BUILD_f0p0(Data,vrr_stack+704, vrr_stack+365, vrr_stack+57, vrr_stack+233, vrr_stack+356, vrr_stack+102);
 _BUILD_g0p0(Data,vrr_stack+734, vrr_stack+383, vrr_stack+704, vrr_stack+242, vrr_stack+365, vrr_stack+108);
 _BUILD_h0p0(Data,vrr_stack+779, vrr_stack+413, vrr_stack+734, vrr_stack+278, vrr_stack+383, vrr_stack+118);
 _BUILD_i0p0(Data,vrr_stack+842, vrr_stack+503, vrr_stack+779, vrr_stack+458, vrr_stack+413, vrr_stack+133);
 _BUILD_i0p0(Data,vrr_stack+926, vrr_stack+641, vrr_stack+503, vrr_stack+596, vrr_stack+458, vrr_stack+154);
 _BUILD_k0p0(Data,vrr_stack+1010, vrr_stack+926, vrr_stack+842, vrr_stack+641, vrr_stack+503, vrr_stack+175);
 _BUILD_00d0(Data,vrr_stack+75, vrr_stack+206, vrr_stack+203, Data->F+9, Data->F+10, NULL);
 _BUILD_00d0(Data,vrr_stack+81, vrr_stack+218, vrr_stack+206, Data->F+8, Data->F+9, NULL);
 _BUILD_00d0(Data,vrr_stack+87, vrr_stack+203, vrr_stack+230, Data->F+10, Data->F+11, NULL);
 _BUILD_p0d0(Data,vrr_stack+93, vrr_stack+75, vrr_stack+87, NULL, NULL, vrr_stack+203);
 _BUILD_p0d0(Data,vrr_stack+111, vrr_stack+81, vrr_stack+75, NULL, NULL, vrr_stack+206);
 _BUILD_d0d0(Data,vrr_stack+129, vrr_stack+111, vrr_stack+93, vrr_stack+81, vrr_stack+75, vrr_stack+209);
 _BUILD_00d0(Data,vrr_stack+209, vrr_stack+0, vrr_stack+218, Data->F+7, Data->F+8, NULL);
 _BUILD_p0d0(Data,vrr_stack+165, vrr_stack+209, vrr_stack+81, NULL, NULL, vrr_stack+218);
 _BUILD_d0d0(Data,vrr_stack+1118, vrr_stack+165, vrr_stack+111, vrr_stack+209, vrr_stack+81, vrr_stack+221);
 _BUILD_00d0(Data,vrr_stack+221, vrr_stack+230, vrr_stack+12, Data->F+11, Data->F+12, NULL);
 _BUILD_p0d0(Data,vrr_stack+183, vrr_stack+87, vrr_stack+221, NULL, NULL, vrr_stack+230);
 _BUILD_d0d0(Data,vrr_stack+1154, vrr_stack+93, vrr_stack+183, vrr_stack+75, vrr_stack+87, vrr_stack+233);
 _BUILD_f0d0(Data,vrr_stack+1190, vrr_stack+129, vrr_stack+1154, vrr_stack+111, vrr_stack+93, vrr_stack+242);
 _BUILD_f0d0(Data,vrr_stack+1250, vrr_stack+1118, vrr_stack+129, vrr_stack+165, vrr_stack+111, vrr_stack+260);
 _BUILD_g0d0(Data,vrr_stack+1310, vrr_stack+1250, vrr_stack+1190, vrr_stack+1118, vrr_stack+129, vrr_stack+278);
 _BUILD_00d0(Data,vrr_stack+233, vrr_stack+15, vrr_stack+0, Data->F+6, Data->F+7, NULL);
 _BUILD_p0d0(Data,vrr_stack+239, vrr_stack+233, vrr_stack+209, NULL, NULL, vrr_stack+0);
 _BUILD_d0d0(Data,vrr_stack+257, vrr_stack+239, vrr_stack+165, vrr_stack+233, vrr_stack+209, vrr_stack+3);
 _BUILD_f0d0(Data,vrr_stack+1400, vrr_stack+257, vrr_stack+1118, vrr_stack+239, vrr_stack+165, vrr_stack+308);
 _BUILD_g0d0(Data,vrr_stack+1460, vrr_stack+1400, vrr_stack+1250, vrr_stack+257, vrr_stack+1118, vrr_stack+326);
 _BUILD_00d0(Data,vrr_stack+3, vrr_stack+12, vrr_stack+45, Data->F+12, Data->F+13, NULL);
 _BUILD_p0d0(Data,vrr_stack+293, vrr_stack+221, vrr_stack+3, NULL, NULL, vrr_stack+12);
 _BUILD_d0d0(Data,vrr_stack+311, vrr_stack+183, vrr_stack+293, vrr_stack+87, vrr_stack+221, vrr_stack+356);
 _BUILD_f0d0(Data,vrr_stack+1550, vrr_stack+1154, vrr_stack+311, vrr_stack+93, vrr_stack+183, vrr_stack+365);
 _BUILD_g0d0(Data,vrr_stack+1610, vrr_stack+1190, vrr_stack+1550, vrr_stack+129, vrr_stack+1154, vrr_stack+383);
 _BUILD_h0d0(Data,vrr_stack+1700, vrr_stack+1310, vrr_stack+1610, vrr_stack+1250, vrr_stack+1190, vrr_stack+413);
 _BUILD_h0d0(Data,vrr_stack+1826, vrr_stack+1460, vrr_stack+1310, vrr_stack+1400, vrr_stack+1250, vrr_stack+458);
 _BUILD_i0d0(Data,vrr_stack+1952, vrr_stack+1826, vrr_stack+1700, vrr_stack+1460, vrr_stack+1310, vrr_stack+503);
 _BUILD_00p0(Data,vrr_stack+9, Data->F+5, Data->F+6, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+347, vrr_stack+9, vrr_stack+15, Data->F+5, Data->F+6, NULL);
 _BUILD_p0d0(Data,vrr_stack+353, vrr_stack+347, vrr_stack+233, NULL, NULL, vrr_stack+15);
 _BUILD_d0d0(Data,vrr_stack+371, vrr_stack+353, vrr_stack+239, vrr_stack+347, vrr_stack+233, vrr_stack+18);
 _BUILD_f0d0(Data,vrr_stack+407, vrr_stack+371, vrr_stack+257, vrr_stack+353, vrr_stack+239, vrr_stack+27);
 _BUILD_g0d0(Data,vrr_stack+467, vrr_stack+407, vrr_stack+1400, vrr_stack+371, vrr_stack+257, vrr_stack+566);
 _BUILD_h0d0(Data,vrr_stack+2120, vrr_stack+467, vrr_stack+1460, vrr_stack+407, vrr_stack+1400, vrr_stack+596);
 _BUILD_i0d0(Data,vrr_stack+2246, vrr_stack+2120, vrr_stack+1826, vrr_stack+467, vrr_stack+1460, vrr_stack+641);
 _BUILD_00p0(Data,vrr_stack+227, Data->F+14, Data->F+15, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+18, vrr_stack+45, vrr_stack+227, Data->F+13, Data->F+14, NULL);
 _BUILD_p0d0(Data,vrr_stack+24, vrr_stack+3, vrr_stack+18, NULL, NULL, vrr_stack+45);
 _BUILD_d0d0(Data,vrr_stack+557, vrr_stack+293, vrr_stack+24, vrr_stack+221, vrr_stack+3, vrr_stack+48);
 _BUILD_f0d0(Data,vrr_stack+593, vrr_stack+311, vrr_stack+557, vrr_stack+183, vrr_stack+293, vrr_stack+57);
 _BUILD_g0d0(Data,vrr_stack+2414, vrr_stack+1550, vrr_stack+593, vrr_stack+1154, vrr_stack+311, vrr_stack+704);
 _BUILD_h0d0(Data,vrr_stack+2504, vrr_stack+1610, vrr_stack+2414, vrr_stack+1190, vrr_stack+1550, vrr_stack+734);
 _BUILD_i0d0(Data,vrr_stack+2630, vrr_stack+1700, vrr_stack+2504, vrr_stack+1310, vrr_stack+1610, vrr_stack+779);
 _BUILD_k0d0(Data,vrr_stack+2798, vrr_stack+1952, vrr_stack+2630, vrr_stack+1826, vrr_stack+1700, vrr_stack+842);
 _BUILD_k0d0(Data,vrr_stack+653, vrr_stack+2246, vrr_stack+1952, vrr_stack+2120, vrr_stack+1826, vrr_stack+926);
 _BUILD_l0d0(Data,vrr_stack+3014, vrr_stack+653, vrr_stack+2798, vrr_stack+2246, vrr_stack+1952, vrr_stack+1010);
 _BUILD_00f0(Data,vrr_stack+48, vrr_stack+75, vrr_stack+87, vrr_stack+206, vrr_stack+203, NULL);
 _BUILD_00f0(Data,vrr_stack+58, vrr_stack+81, vrr_stack+75, vrr_stack+218, vrr_stack+206, NULL);
 _BUILD_p0f0(Data,vrr_stack+869, vrr_stack+58, vrr_stack+48, NULL, NULL, vrr_stack+75);
 _BUILD_00f0(Data,vrr_stack+899, vrr_stack+209, vrr_stack+81, vrr_stack+0, vrr_stack+218, NULL);
 _BUILD_p0f0(Data,vrr_stack+909, vrr_stack+899, vrr_stack+58, NULL, NULL, vrr_stack+81);
 _BUILD_00f0(Data,vrr_stack+939, vrr_stack+87, vrr_stack+221, vrr_stack+203, vrr_stack+230, NULL);
 _BUILD_p0f0(Data,vrr_stack+949, vrr_stack+48, vrr_stack+939, NULL, NULL, vrr_stack+87);
 _BUILD_d0f0(Data,vrr_stack+979, vrr_stack+869, vrr_stack+949, vrr_stack+58, vrr_stack+48, vrr_stack+93);
 _BUILD_d0f0(Data,vrr_stack+1039, vrr_stack+909, vrr_stack+869, vrr_stack+899, vrr_stack+58, vrr_stack+111);
 _BUILD_f0f0(Data,vrr_stack+3284, vrr_stack+1039, vrr_stack+979, vrr_stack+909, vrr_stack+869, vrr_stack+129);
 _BUILD_00f0(Data,vrr_stack+93, vrr_stack+233, vrr_stack+209, vrr_stack+15, vrr_stack+0, NULL);
 _BUILD_p0f0(Data,vrr_stack+103, vrr_stack+93, vrr_stack+899, NULL, NULL, vrr_stack+209);
 _BUILD_d0f0(Data,vrr_stack+3384, vrr_stack+103, vrr_stack+909, vrr_stack+93, vrr_stack+899, vrr_stack+165);
 _BUILD_f0f0(Data,vrr_stack+3444, vrr_stack+3384, vrr_stack+1039, vrr_stack+103, vrr_stack+909, vrr_stack+1118);
 _BUILD_00f0(Data,vrr_stack+133, vrr_stack+221, vrr_stack+3, vrr_stack+230, vrr_stack+12, NULL);
 _BUILD_p0f0(Data,vrr_stack+143, vrr_stack+939, vrr_stack+133, NULL, NULL, vrr_stack+221);
 _BUILD_d0f0(Data,vrr_stack+3544, vrr_stack+949, vrr_stack+143, vrr_stack+48, vrr_stack+939, vrr_stack+183);
 _BUILD_f0f0(Data,vrr_stack+3604, vrr_stack+979, vrr_stack+3544, vrr_stack+869, vrr_stack+949, vrr_stack+1154);
 _BUILD_g0f0(Data,vrr_stack+3704, vrr_stack+3284, vrr_stack+3604, vrr_stack+1039, vrr_stack+979, vrr_stack+1190);
 _BUILD_g0f0(Data,vrr_stack+1099, vrr_stack+3444, vrr_stack+3284, vrr_stack+3384, vrr_stack+1039, vrr_stack+1250);
 _BUILD_h0f0(Data,vrr_stack+3854, vrr_stack+1099, vrr_stack+3704, vrr_stack+3444, vrr_stack+3284, vrr_stack+1310);
 _BUILD_00f0(Data,vrr_stack+173, vrr_stack+347, vrr_stack+233, vrr_stack+9, vrr_stack+15, NULL);
 _BUILD_p0f0(Data,vrr_stack+1249, vrr_stack+173, vrr_stack+93, NULL, NULL, vrr_stack+233);
 _BUILD_d0f0(Data,vrr_stack+1279, vrr_stack+1249, vrr_stack+103, vrr_stack+173, vrr_stack+93, vrr_stack+239);
 _BUILD_f0f0(Data,vrr_stack+4064, vrr_stack+1279, vrr_stack+3384, vrr_stack+1249, vrr_stack+103, vrr_stack+257);
 _BUILD_g0f0(Data,vrr_stack+4164, vrr_stack+4064, vrr_stack+3444, vrr_stack+1279, vrr_stack+3384, vrr_stack+1400);
 _BUILD_h0f0(Data,vrr_stack+4314, vrr_stack+4164, vrr_stack+1099, vrr_stack+4064, vrr_stack+3444, vrr_stack+1460);
 _BUILD_00f0(Data,vrr_stack+239, vrr_stack+3, vrr_stack+18, vrr_stack+12, vrr_stack+45, NULL);
 _BUILD_p0f0(Data,vrr_stack+249, vrr_stack+133, vrr_stack+239, NULL, NULL, vrr_stack+3);
 _BUILD_d0f0(Data,vrr_stack+1339, vrr_stack+143, vrr_stack+249, vrr_stack+939, vrr_stack+133, vrr_stack+293);
 _BUILD_f0f0(Data,vrr_stack+1399, vrr_stack+3544, vrr_stack+1339, vrr_stack+949, vrr_stack+143, vrr_stack+311);
 _BUILD_g0f0(Data,vrr_stack+4524, vrr_stack+3604, vrr_stack+1399, vrr_stack+979, vrr_stack+3544, vrr_stack+1550);
 _BUILD_h0f0(Data,vrr_stack+4674, vrr_stack+3704, vrr_stack+4524, vrr_stack+3284, vrr_stack+3604, vrr_stack+1610);
 _BUILD_i0f0(Data,vrr_stack+4884, vrr_stack+3854, vrr_stack+4674, vrr_stack+1099, vrr_stack+3704, vrr_stack+1700);
 _BUILD_i0f0(Data,vrr_stack+1499, vrr_stack+4314, vrr_stack+3854, vrr_stack+4164, vrr_stack+1099, vrr_stack+1826);
 _BUILD_k0f0(Data,vrr_stack+5164, vrr_stack+1499, vrr_stack+4884, vrr_stack+4314, vrr_stack+3854, vrr_stack+1952);
 _BUILD_00p0(Data,vrr_stack+230, Data->F+4, Data->F+5, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+12, vrr_stack+230, vrr_stack+9, Data->F+4, Data->F+5, NULL);
 _BUILD_00f0(Data,vrr_stack+279, vrr_stack+12, vrr_stack+347, vrr_stack+230, vrr_stack+9, NULL);
 _BUILD_p0f0(Data,vrr_stack+289, vrr_stack+279, vrr_stack+173, NULL, NULL, vrr_stack+347);
 _BUILD_d0f0(Data,vrr_stack+1779, vrr_stack+289, vrr_stack+1249, vrr_stack+279, vrr_stack+173, vrr_stack+353);
 _BUILD_f0f0(Data,vrr_stack+1839, vrr_stack+1779, vrr_stack+1279, vrr_stack+289, vrr_stack+1249, vrr_stack+371);
 _BUILD_g0f0(Data,vrr_stack+1939, vrr_stack+1839, vrr_stack+4064, vrr_stack+1779, vrr_stack+1279, vrr_stack+407);
 _BUILD_h0f0(Data,vrr_stack+5524, vrr_stack+1939, vrr_stack+4164, vrr_stack+1839, vrr_stack+4064, vrr_stack+467);
 _BUILD_i0f0(Data,vrr_stack+5734, vrr_stack+5524, vrr_stack+4314, vrr_stack+1939, vrr_stack+4164, vrr_stack+2120);
 _BUILD_k0f0(Data,vrr_stack+6014, vrr_stack+5734, vrr_stack+1499, vrr_stack+5524, vrr_stack+4314, vrr_stack+2246);
 _BUILD_00p0(Data,vrr_stack+9, Data->F+15, Data->F+16, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+215, vrr_stack+227, vrr_stack+9, Data->F+14, Data->F+15, NULL);
 _BUILD_00f0(Data,vrr_stack+353, vrr_stack+18, vrr_stack+215, vrr_stack+45, vrr_stack+227, NULL);
 _BUILD_p0f0(Data,vrr_stack+363, vrr_stack+239, vrr_stack+353, NULL, NULL, vrr_stack+18);
 _BUILD_d0f0(Data,vrr_stack+393, vrr_stack+249, vrr_stack+363, vrr_stack+133, vrr_stack+239, vrr_stack+24);
 _BUILD_f0f0(Data,vrr_stack+453, vrr_stack+1339, vrr_stack+393, vrr_stack+143, vrr_stack+249, vrr_stack+557);
 _BUILD_g0f0(Data,vrr_stack+2089, vrr_stack+1399, vrr_stack+453, vrr_stack+3544, vrr_stack+1339, vrr_stack+593);
 _BUILD_h0f0(Data,vrr_stack+6374, vrr_stack+4524, vrr_stack+2089, vrr_stack+3604, vrr_stack+1399, vrr_stack+2414);
 _BUILD_i0f0(Data,vrr_stack+6584, vrr_stack+4674, vrr_stack+6374, vrr_stack+3704, vrr_stack+4524, vrr_stack+2504);
 _BUILD_k0f0(Data,vrr_stack+2239, vrr_stack+4884, vrr_stack+6584, vrr_stack+3854, vrr_stack+4674, vrr_stack+2630);
 _BUILD_l0f0(Data,vrr_stack+6864, vrr_stack+5164, vrr_stack+2239, vrr_stack+1499, vrr_stack+4884, vrr_stack+2798);
 _BUILD_l0f0(Data,vrr_stack+7314, vrr_stack+6014, vrr_stack+5164, vrr_stack+5734, vrr_stack+1499, vrr_stack+653);
 _BUILD_m0f0(Data,vrr_stack+7764, vrr_stack+7314, vrr_stack+6864, vrr_stack+6014, vrr_stack+5164, vrr_stack+3014);
 _BUILD_00g0(Data,vrr_stack+24, vrr_stack+58, vrr_stack+48, vrr_stack+81, vrr_stack+75, NULL);
 _BUILD_00g0(Data,vrr_stack+553, vrr_stack+899, vrr_stack+58, vrr_stack+209, vrr_stack+81, NULL);
 _BUILD_00g0(Data,vrr_stack+568, vrr_stack+48, vrr_stack+939, vrr_stack+75, vrr_stack+87, NULL);
 _BUILD_p0g0(Data,vrr_stack+583, vrr_stack+24, vrr_stack+568, NULL, NULL, vrr_stack+48);
 _BUILD_p0g0(Data,vrr_stack+628, vrr_stack+553, vrr_stack+24, NULL, NULL, vrr_stack+58);
 _BUILD_d0g0(Data,vrr_stack+673, vrr_stack+628, vrr_stack+583, vrr_stack+553, vrr_stack+24, vrr_stack+869);
 _BUILD_00g0(Data,vrr_stack+763, vrr_stack+93, vrr_stack+899, vrr_stack+233, vrr_stack+209, NULL);
 _BUILD_p0g0(Data,vrr_stack+778, vrr_stack+763, vrr_stack+553, NULL, NULL, vrr_stack+899);
 _BUILD_d0g0(Data,vrr_stack+2599, vrr_stack+778, vrr_stack+628, vrr_stack+763, vrr_stack+553, vrr_stack+909);
 _BUILD_00g0(Data,vrr_stack+909, vrr_stack+939, vrr_stack+133, vrr_stack+87, vrr_stack+221, NULL);
 _BUILD_p0g0(Data,vrr_stack+823, vrr_stack+568, vrr_stack+909, NULL, NULL, vrr_stack+939);
 _BUILD_d0g0(Data,vrr_stack+2689, vrr_stack+583, vrr_stack+823, vrr_stack+24, vrr_stack+568, vrr_stack+949);
 _BUILD_f0g0(Data,vrr_stack+2779, vrr_stack+673, vrr_stack+2689, vrr_stack+628, vrr_stack+583, vrr_stack+979);
 _BUILD_f0g0(Data,vrr_stack+2929, vrr_stack+2599, vrr_stack+673, vrr_stack+778, vrr_stack+628, vrr_stack+1039);
 _BUILD_g0g0(Data,vrr_stack+8314, vrr_stack+2929, vrr_stack+2779, vrr_stack+2599, vrr_stack+673, vrr_stack+3284);
 _BUILD_00g0(Data,vrr_stack+924, vrr_stack+173, vrr_stack+93, vrr_stack+347, vrr_stack+233, NULL);
 _BUILD_p0g0(Data,vrr_stack+949, vrr_stack+924, vrr_stack+763, NULL, NULL, vrr_stack+93);
 _BUILD_d0g0(Data,vrr_stack+994, vrr_stack+949, vrr_stack+778, vrr_stack+924, vrr_stack+763, vrr_stack+103);
 _BUILD_f0g0(Data,vrr_stack+3079, vrr_stack+994, vrr_stack+2599, vrr_stack+949, vrr_stack+778, vrr_stack+3384);
 _BUILD_g0g0(Data,vrr_stack+8539, vrr_stack+3079, vrr_stack+2929, vrr_stack+994, vrr_stack+2599, vrr_stack+3444);
 _BUILD_00g0(Data,vrr_stack+1084, vrr_stack+133, vrr_stack+239, vrr_stack+221, vrr_stack+3, NULL);
 _BUILD_p0g0(Data,vrr_stack+3229, vrr_stack+909, vrr_stack+1084, NULL, NULL, vrr_stack+133);
 _BUILD_d0g0(Data,vrr_stack+3274, vrr_stack+823, vrr_stack+3229, vrr_stack+568, vrr_stack+909, vrr_stack+143);
 _BUILD_f0g0(Data,vrr_stack+3364, vrr_stack+2689, vrr_stack+3274, vrr_stack+583, vrr_stack+823, vrr_stack+3544);
 _BUILD_g0g0(Data,vrr_stack+8764, vrr_stack+2779, vrr_stack+3364, vrr_stack+673, vrr_stack+2689, vrr_stack+3604);
 _BUILD_h0g0(Data,vrr_stack+8989, vrr_stack+8314, vrr_stack+8764, vrr_stack+2929, vrr_stack+2779, vrr_stack+3704);
 _BUILD_h0g0(Data,vrr_stack+3514, vrr_stack+8539, vrr_stack+8314, vrr_stack+3079, vrr_stack+2929, vrr_stack+1099);
 _BUILD_i0g0(Data,vrr_stack+9304, vrr_stack+3514, vrr_stack+8989, vrr_stack+8539, vrr_stack+8314, vrr_stack+3854);
 _BUILD_00g0(Data,vrr_stack+1099, vrr_stack+279, vrr_stack+173, vrr_stack+12, vrr_stack+347, NULL);
 _BUILD_p0g0(Data,vrr_stack+1114, vrr_stack+1099, vrr_stack+924, NULL, NULL, vrr_stack+173);
 _BUILD_d0g0(Data,vrr_stack+1159, vrr_stack+1114, vrr_stack+949, vrr_stack+1099, vrr_stack+924, vrr_stack+1249);
 _BUILD_f0g0(Data,vrr_stack+3829, vrr_stack+1159, vrr_stack+994, vrr_stack+1114, vrr_stack+949, vrr_stack+1279);
 _BUILD_g0g0(Data,vrr_stack+9724, vrr_stack+3829, vrr_stack+3079, vrr_stack+1159, vrr_stack+994, vrr_stack+4064);
 _BUILD_h0g0(Data,vrr_stack+9949, vrr_stack+9724, vrr_stack+8539, vrr_stack+3829, vrr_stack+3079, vrr_stack+4164);
 _BUILD_i0g0(Data,vrr_stack+10264, vrr_stack+9949, vrr_stack+3514, vrr_stack+9724, vrr_stack+8539, vrr_stack+4314);
 _BUILD_00g0(Data,vrr_stack+1249, vrr_stack+239, vrr_stack+353, vrr_stack+3, vrr_stack+18, NULL);
 _BUILD_p0g0(Data,vrr_stack+1264, vrr_stack+1084, vrr_stack+1249, NULL, NULL, vrr_stack+239);
 _BUILD_d0g0(Data,vrr_stack+3979, vrr_stack+3229, vrr_stack+1264, vrr_stack+909, vrr_stack+1084, vrr_stack+249);
 _BUILD_f0g0(Data,vrr_stack+4069, vrr_stack+3274, vrr_stack+3979, vrr_stack+823, vrr_stack+3229, vrr_stack+1339);
 _BUILD_g0g0(Data,vrr_stack+4219, vrr_stack+3364, vrr_stack+4069, vrr_stack+2689, vrr_stack+3274, vrr_stack+1399);
 _BUILD_h0g0(Data,vrr_stack+10684, vrr_stack+8764, vrr_stack+4219, vrr_stack+2779, vrr_stack+3364, vrr_stack+4524);
 _BUILD_i0g0(Data,vrr_stack+10999, vrr_stack+8989, vrr_stack+10684, vrr_stack+8314, vrr_stack+8764, vrr_stack+4674);
 _BUILD_k0g0(Data,vrr_stack+11419, vrr_stack+9304, vrr_stack+10999, vrr_stack+3514, vrr_stack+8989, vrr_stack+4884);
 _BUILD_k0g0(Data,vrr_stack+4444, vrr_stack+10264, vrr_stack+9304, vrr_stack+9949, vrr_stack+3514, vrr_stack+1499);
 _BUILD_l0g0(Data,vrr_stack+11959, vrr_stack+4444, vrr_stack+11419, vrr_stack+10264, vrr_stack+9304, vrr_stack+5164);
 _BUILD_00p0(Data,vrr_stack+249, Data->F+3, Data->F+4, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+221, vrr_stack+249, vrr_stack+230, Data->F+3, Data->F+4, NULL);
 _BUILD_00f0(Data,vrr_stack+252, vrr_stack+221, vrr_stack+12, vrr_stack+249, vrr_stack+230, NULL);
 _BUILD_00g0(Data,vrr_stack+262, vrr_stack+252, vrr_stack+279, vrr_stack+221, vrr_stack+12, NULL);
 _BUILD_p0g0(Data,vrr_stack+1309, vrr_stack+262, vrr_stack+1099, NULL, NULL, vrr_stack+279);
 _BUILD_d0g0(Data,vrr_stack+1354, vrr_stack+1309, vrr_stack+1114, vrr_stack+262, vrr_stack+1099, vrr_stack+289);
 _BUILD_f0g0(Data,vrr_stack+1444, vrr_stack+1354, vrr_stack+1159, vrr_stack+1309, vrr_stack+1114, vrr_stack+1779);
 _BUILD_g0g0(Data,vrr_stack+1594, vrr_stack+1444, vrr_stack+3829, vrr_stack+1354, vrr_stack+1159, vrr_stack+1839);
 _BUILD_h0g0(Data,vrr_stack+4984, vrr_stack+1594, vrr_stack+9724, vrr_stack+1444, vrr_stack+3829, vrr_stack+1939);
 _BUILD_i0g0(Data,vrr_stack+12634, vrr_stack+4984, vrr_stack+9949, vrr_stack+1594, vrr_stack+9724, vrr_stack+5524);
 _BUILD_k0g0(Data,vrr_stack+13054, vrr_stack+12634, vrr_stack+10264, vrr_stack+4984, vrr_stack+9949, vrr_stack+5734);
 _BUILD_l0g0(Data,vrr_stack+5299, vrr_stack+13054, vrr_stack+4444, vrr_stack+12634, vrr_stack+10264, vrr_stack+6014);
 _BUILD_00p0(Data,vrr_stack+289, Data->F+16, Data->F+17, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+12, vrr_stack+9, vrr_stack+289, Data->F+15, Data->F+16, NULL);
 _BUILD_00f0(Data,vrr_stack+292, vrr_stack+215, vrr_stack+12, vrr_stack+227, vrr_stack+9, NULL);
 _BUILD_00g0(Data,vrr_stack+302, vrr_stack+353, vrr_stack+292, vrr_stack+18, vrr_stack+215, NULL);
 _BUILD_p0g0(Data,vrr_stack+1819, vrr_stack+1249, vrr_stack+302, NULL, NULL, vrr_stack+353);
 _BUILD_d0g0(Data,vrr_stack+1864, vrr_stack+1264, vrr_stack+1819, vrr_stack+1084, vrr_stack+1249, vrr_stack+363);
 _BUILD_f0g0(Data,vrr_stack+5974, vrr_stack+3979, vrr_stack+1864, vrr_stack+3229, vrr_stack+1264, vrr_stack+393);
 _BUILD_g0g0(Data,vrr_stack+6124, vrr_stack+4069, vrr_stack+5974, vrr_stack+3274, vrr_stack+3979, vrr_stack+453);
 _BUILD_h0g0(Data,vrr_stack+13594, vrr_stack+4219, vrr_stack+6124, vrr_stack+3364, vrr_stack+4069, vrr_stack+2089);
 _BUILD_i0g0(Data,vrr_stack+13909, vrr_stack+10684, vrr_stack+13594, vrr_stack+8764, vrr_stack+4219, vrr_stack+6374);
 _BUILD_k0g0(Data,vrr_stack+14329, vrr_stack+10999, vrr_stack+13909, vrr_stack+8989, vrr_stack+10684, vrr_stack+6584);
 _BUILD_l0g0(Data,vrr_stack+14869, vrr_stack+11419, vrr_stack+14329, vrr_stack+9304, vrr_stack+10999, vrr_stack+2239);
 _BUILD_m0g0(Data,vrr_stack+15544, vrr_stack+11959, vrr_stack+14869, vrr_stack+4444, vrr_stack+11419, vrr_stack+6864);
 _BUILD_m0g0(Data,vrr_stack+6349, vrr_stack+5299, vrr_stack+11959, vrr_stack+13054, vrr_stack+4444, vrr_stack+7314);
 _BUILD_n0g0(Data,vrr_stack+16369, vrr_stack+6349, vrr_stack+15544, vrr_stack+5299, vrr_stack+11959, vrr_stack+7764);
 _BUILD_00h0(Data,vrr_stack+363, vrr_stack+24, vrr_stack+568, vrr_stack+58, vrr_stack+48, NULL);
 _BUILD_00h0(Data,vrr_stack+384, vrr_stack+553, vrr_stack+24, vrr_stack+899, vrr_stack+58, NULL);
 _BUILD_p0h0(Data,vrr_stack+405, vrr_stack+384, vrr_stack+363, NULL, NULL, vrr_stack+24);
 _BUILD_00h0(Data,vrr_stack+58, vrr_stack+763, vrr_stack+553, vrr_stack+93, vrr_stack+899, NULL);
 _BUILD_p0h0(Data,vrr_stack+468, vrr_stack+58, vrr_stack+384, NULL, NULL, vrr_stack+553);
 _BUILD_00h0(Data,vrr_stack+531, vrr_stack+568, vrr_stack+909, vrr_stack+48, vrr_stack+939, NULL);
 _BUILD_p0h0(Data,vrr_stack+1954, vrr_stack+363, vrr_stack+531, NULL, NULL, vrr_stack+568);
 _BUILD_d0h0(Data,vrr_stack+2017, vrr_stack+405, vrr_stack+1954, vrr_stack+384, vrr_stack+363, vrr_stack+583);
 _BUILD_d0h0(Data,vrr_stack+2143, vrr_stack+468, vrr_stack+405, vrr_stack+58, vrr_stack+384, vrr_stack+628);
 _BUILD_f0h0(Data,vrr_stack+2269, vrr_stack+2143, vrr_stack+2017, vrr_stack+468, vrr_stack+405, vrr_stack+673);
 _BUILD_00h0(Data,vrr_stack+583, vrr_stack+924, vrr_stack+763, vrr_stack+173, vrr_stack+93, NULL);
 _BUILD_p0h0(Data,vrr_stack+604, vrr_stack+583, vrr_stack+58, NULL, NULL, vrr_stack+763);
 _BUILD_d0h0(Data,vrr_stack+7174, vrr_stack+604, vrr_stack+468, vrr_stack+583, vrr_stack+58, vrr_stack+778);
 _BUILD_f0h0(Data,vrr_stack+7300, vrr_stack+7174, vrr_stack+2143, vrr_stack+604, vrr_stack+468, vrr_stack+2599);
 _BUILD_00h0(Data,vrr_stack+778, vrr_stack+909, vrr_stack+1084, vrr_stack+939, vrr_stack+133, NULL);
 _BUILD_p0h0(Data,vrr_stack+667, vrr_stack+531, vrr_stack+778, NULL, NULL, vrr_stack+909);
 _BUILD_d0h0(Data,vrr_stack+2479, vrr_stack+1954, vrr_stack+667, vrr_stack+363, vrr_stack+531, vrr_stack+823);
 _BUILD_f0h0(Data,vrr_stack+7510, vrr_stack+2017, vrr_stack+2479, vrr_stack+405, vrr_stack+1954, vrr_stack+2689);
 _BUILD_g0h0(Data,vrr_stack+7720, vrr_stack+2269, vrr_stack+7510, vrr_stack+2143, vrr_stack+2017, vrr_stack+2779);
 _BUILD_g0h0(Data,vrr_stack+2605, vrr_stack+7300, vrr_stack+2269, vrr_stack+7174, vrr_stack+2143, vrr_stack+2929);
 _BUILD_h0h0(Data,vrr_stack+17359, vrr_stack+2605, vrr_stack+7720, vrr_stack+7300, vrr_stack+2269, vrr_stack+8314);
 _BUILD_00h0(Data,vrr_stack+799, vrr_stack+1099, vrr_stack+924, vrr_stack+279, vrr_stack+173, NULL);
 _BUILD_p0h0(Data,vrr_stack+820, vrr_stack+799, vrr_stack+583, NULL, NULL, vrr_stack+924);
 _BUILD_d0h0(Data,vrr_stack+2920, vrr_stack+820, vrr_stack+604, vrr_stack+799, vrr_stack+583, vrr_stack+949);
 _BUILD_f0h0(Data,vrr_stack+8035, vrr_stack+2920, vrr_stack+7174, vrr_stack+820, vrr_stack+604, vrr_stack+994);
 _BUILD_g0h0(Data,vrr_stack+17800, vrr_stack+8035, vrr_stack+7300, vrr_stack+2920, vrr_stack+7174, vrr_stack+3079);
 _BUILD_h0h0(Data,vrr_stack+18115, vrr_stack+17800, vrr_stack+2605, vrr_stack+8035, vrr_stack+7300, vrr_stack+8539);
 _BUILD_00h0(Data,vrr_stack+939, vrr_stack+1084, vrr_stack+1249, vrr_stack+133, vrr_stack+239, NULL);
 _BUILD_p0h0(Data,vrr_stack+960, vrr_stack+778, vrr_stack+939, NULL, NULL, vrr_stack+1084);
 _BUILD_d0h0(Data,vrr_stack+79, vrr_stack+667, vrr_stack+960, vrr_stack+531, vrr_stack+778, vrr_stack+3229);
 _BUILD_f0h0(Data,vrr_stack+3046, vrr_stack+2479, vrr_stack+79, vrr_stack+1954, vrr_stack+667, vrr_stack+3274);
 _BUILD_g0h0(Data,vrr_stack+8245, vrr_stack+7510, vrr_stack+3046, vrr_stack+2017, vrr_stack+2479, vrr_stack+3364);
 _BUILD_h0h0(Data,vrr_stack+18556, vrr_stack+7720, vrr_stack+8245, vrr_stack+2269, vrr_stack+7510, vrr_stack+8764);
 _BUILD_i0h0(Data,vrr_stack+18997, vrr_stack+17359, vrr_stack+18556, vrr_stack+2605, vrr_stack+7720, vrr_stack+8989);
 _BUILD_i0h0(Data,vrr_stack+8560, vrr_stack+18115, vrr_stack+17359, vrr_stack+17800, vrr_stack+2605, vrr_stack+3514);
 _BUILD_k0h0(Data,vrr_stack+19585, vrr_stack+8560, vrr_stack+18997, vrr_stack+18115, vrr_stack+17359, vrr_stack+9304);
 _BUILD_00h0(Data,vrr_stack+1023, vrr_stack+262, vrr_stack+1099, vrr_stack+252, vrr_stack+279, NULL);
 _BUILD_p0h0(Data,vrr_stack+3256, vrr_stack+1023, vrr_stack+799, NULL, NULL, vrr_stack+1099);
 _BUILD_d0h0(Data,vrr_stack+3319, vrr_stack+3256, vrr_stack+820, vrr_stack+1023, vrr_stack+799, vrr_stack+1114);
 _BUILD_f0h0(Data,vrr_stack+3445, vrr_stack+3319, vrr_stack+2920, vrr_stack+3256, vrr_stack+820, vrr_stack+1159);
 _BUILD_g0h0(Data,vrr_stack+9148, vrr_stack+3445, vrr_stack+8035, vrr_stack+3319, vrr_stack+2920, vrr_stack+3829);
 _BUILD_h0h0(Data,vrr_stack+20341, vrr_stack+9148, vrr_stack+17800, vrr_stack+3445, vrr_stack+8035, vrr_stack+9724);
 _BUILD_i0h0(Data,vrr_stack+20782, vrr_stack+20341, vrr_stack+18115, vrr_stack+9148, vrr_stack+17800, vrr_stack+9949);
 _BUILD_k0h0(Data,vrr_stack+9463, vrr_stack+20782, vrr_stack+8560, vrr_stack+20341, vrr_stack+18115, vrr_stack+10264);
 _BUILD_00h0(Data,vrr_stack+1114, vrr_stack+1249, vrr_stack+302, vrr_stack+239, vrr_stack+353, NULL);
 _BUILD_p0h0(Data,vrr_stack+1135, vrr_stack+939, vrr_stack+1114, NULL, NULL, vrr_stack+1249);
 _BUILD_d0h0(Data,vrr_stack+3655, vrr_stack+960, vrr_stack+1135, vrr_stack+778, vrr_stack+939, vrr_stack+1264);
 _BUILD_f0h0(Data,vrr_stack+10219, vrr_stack+79, vrr_stack+3655, vrr_stack+667, vrr_stack+960, vrr_stack+3979);
 _BUILD_g0h0(Data,vrr_stack+21370, vrr_stack+3046, vrr_stack+10219, vrr_stack+2479, vrr_stack+79, vrr_stack+4069);
 _BUILD_h0h0(Data,vrr_stack+21685, vrr_stack+8245, vrr_stack+21370, vrr_stack+7510, vrr_stack+3046, vrr_stack+4219);
 _BUILD_i0h0(Data,vrr_stack+3781, vrr_stack+18556, vrr_stack+21685, vrr_stack+7720, vrr_stack+8245, vrr_stack+10684);
 _BUILD_k0h0(Data,vrr_stack+22126, vrr_stack+18997, vrr_stack+3781, vrr_stack+17359, vrr_stack+18556, vrr_stack+10999);
 _BUILD_l0h0(Data,vrr_stack+10429, vrr_stack+19585, vrr_stack+22126, vrr_stack+8560, vrr_stack+18997, vrr_stack+11419);
 _BUILD_l0h0(Data,vrr_stack+22882, vrr_stack+9463, vrr_stack+19585, vrr_stack+20782, vrr_stack+8560, vrr_stack+4444);
 _BUILD_m0h0(Data,vrr_stack+23827, vrr_stack+22882, vrr_stack+10429, vrr_stack+9463, vrr_stack+19585, vrr_stack+11959);
 _BUILD_00p0(Data,vrr_stack+1264, Data->F+2, Data->F+3, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+18, vrr_stack+1264, vrr_stack+249, Data->F+2, Data->F+3, NULL);
 _BUILD_00f0(Data,vrr_stack+205, vrr_stack+18, vrr_stack+221, vrr_stack+1264, vrr_stack+249, NULL);
 _BUILD_00g0(Data,vrr_stack+1267, vrr_stack+205, vrr_stack+252, vrr_stack+18, vrr_stack+221, NULL);
 _BUILD_00h0(Data,vrr_stack+221, vrr_stack+1267, vrr_stack+262, vrr_stack+205, vrr_stack+252, NULL);
 _BUILD_p0h0(Data,vrr_stack+4369, vrr_stack+221, vrr_stack+1023, NULL, NULL, vrr_stack+262);
 _BUILD_d0h0(Data,vrr_stack+4432, vrr_stack+4369, vrr_stack+3256, vrr_stack+221, vrr_stack+1023, vrr_stack+1309);
 _BUILD_f0h0(Data,vrr_stack+4558, vrr_stack+4432, vrr_stack+3319, vrr_stack+4369, vrr_stack+3256, vrr_stack+1354);
 _BUILD_g0h0(Data,vrr_stack+11374, vrr_stack+4558, vrr_stack+3445, vrr_stack+4432, vrr_stack+3319, vrr_stack+1444);
 _BUILD_h0h0(Data,vrr_stack+11689, vrr_stack+11374, vrr_stack+9148, vrr_stack+4558, vrr_stack+3445, vrr_stack+1594);
 _BUILD_i0h0(Data,vrr_stack+24982, vrr_stack+11689, vrr_stack+20341, vrr_stack+11374, vrr_stack+9148, vrr_stack+4984);
 _BUILD_k0h0(Data,vrr_stack+25570, vrr_stack+24982, vrr_stack+20782, vrr_stack+11689, vrr_stack+20341, vrr_stack+12634);
 _BUILD_l0h0(Data,vrr_stack+26326, vrr_stack+25570, vrr_stack+9463, vrr_stack+24982, vrr_stack+20782, vrr_stack+13054);
 _BUILD_m0h0(Data,vrr_stack+12130, vrr_stack+26326, vrr_stack+22882, vrr_stack+25570, vrr_stack+9463, vrr_stack+5299);
 _BUILD_00p0(Data,vrr_stack+242, Data->F+17, Data->F+18, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+245, vrr_stack+289, vrr_stack+242, Data->F+16, Data->F+17, NULL);
 _BUILD_00f0(Data,vrr_stack+251, vrr_stack+12, vrr_stack+245, vrr_stack+9, vrr_stack+289, NULL);
 _BUILD_00g0(Data,vrr_stack+1282, vrr_stack+292, vrr_stack+251, vrr_stack+215, vrr_stack+12, NULL);
 _BUILD_00h0(Data,vrr_stack+1297, vrr_stack+302, vrr_stack+1282, vrr_stack+353, vrr_stack+292, NULL);
 _BUILD_p0h0(Data,vrr_stack+1318, vrr_stack+1114, vrr_stack+1297, NULL, NULL, vrr_stack+302);
 _BUILD_d0h0(Data,vrr_stack+1381, vrr_stack+1135, vrr_stack+1318, vrr_stack+939, vrr_stack+1114, vrr_stack+1819);
 _BUILD_f0h0(Data,vrr_stack+1507, vrr_stack+3655, vrr_stack+1381, vrr_stack+960, vrr_stack+1135, vrr_stack+1864);
 _BUILD_g0h0(Data,vrr_stack+4768, vrr_stack+10219, vrr_stack+1507, vrr_stack+79, vrr_stack+3655, vrr_stack+5974);
 _BUILD_h0h0(Data,vrr_stack+5083, vrr_stack+21370, vrr_stack+4768, vrr_stack+3046, vrr_stack+10219, vrr_stack+6124);
 _BUILD_i0h0(Data,vrr_stack+5524, vrr_stack+21685, vrr_stack+5083, vrr_stack+8245, vrr_stack+21370, vrr_stack+13594);
 _BUILD_k0h0(Data,vrr_stack+27271, vrr_stack+3781, vrr_stack+5524, vrr_stack+18556, vrr_stack+21685, vrr_stack+13909);
 _BUILD_l0h0(Data,vrr_stack+13285, vrr_stack+22126, vrr_stack+27271, vrr_stack+18997, vrr_stack+3781, vrr_stack+14329);
 _BUILD_m0h0(Data,vrr_stack+28027, vrr_stack+10429, vrr_stack+13285, vrr_stack+19585, vrr_stack+22126, vrr_stack+14869);
 _BUILD_n0h0(Data,vrr_stack+29182, vrr_stack+23827, vrr_stack+28027, vrr_stack+22882, vrr_stack+10429, vrr_stack+15544);
 _BUILD_n0h0(Data,vrr_stack+14230, vrr_stack+12130, vrr_stack+23827, vrr_stack+26326, vrr_stack+22882, vrr_stack+6349);
 _BUILD_o0h0(Data,vrr_stack+30568, vrr_stack+14230, vrr_stack+29182, vrr_stack+12130, vrr_stack+23827, vrr_stack+16369);
 _BUILD_00i0(Data,vrr_stack+1717, vrr_stack+384, vrr_stack+363, vrr_stack+553, vrr_stack+24, NULL);
 _BUILD_00i0(Data,vrr_stack+1745, vrr_stack+58, vrr_stack+384, vrr_stack+763, vrr_stack+553, NULL);
 _BUILD_00i0(Data,vrr_stack+1773, vrr_stack+363, vrr_stack+531, vrr_stack+24, vrr_stack+568, NULL);
 _BUILD_p0i0(Data,vrr_stack+1801, vrr_stack+1717, vrr_stack+1773, NULL, NULL, vrr_stack+363);
 _BUILD_p0i0(Data,vrr_stack+6112, vrr_stack+1745, vrr_stack+1717, NULL, NULL, vrr_stack+384);
 _BUILD_d0i0(Data,vrr_stack+6196, vrr_stack+6112, vrr_stack+1801, vrr_stack+1745, vrr_stack+1717, vrr_stack+405);
 _BUILD_00i0(Data,vrr_stack+405, vrr_stack+583, vrr_stack+58, vrr_stack+924, vrr_stack+763, NULL);
 _BUILD_p0i0(Data,vrr_stack+6364, vrr_stack+405, vrr_stack+1745, NULL, NULL, vrr_stack+58);
 _BUILD_d0i0(Data,vrr_stack+6448, vrr_stack+6364, vrr_stack+6112, vrr_stack+405, vrr_stack+1745, vrr_stack+468);
 _BUILD_00i0(Data,vrr_stack+433, vrr_stack+531, vrr_stack+778, vrr_stack+568, vrr_stack+909, NULL);
 _BUILD_p0i0(Data,vrr_stack+6616, vrr_stack+1773, vrr_stack+433, NULL, NULL, vrr_stack+531);
 _BUILD_d0i0(Data,vrr_stack+6700, vrr_stack+1801, vrr_stack+6616, vrr_stack+1717, vrr_stack+1773, vrr_stack+1954);
 _BUILD_f0i0(Data,vrr_stack+6868, vrr_stack+6196, vrr_stack+6700, vrr_stack+6112, vrr_stack+1801, vrr_stack+2017);
 _BUILD_f0i0(Data,vrr_stack+15616, vrr_stack+6448, vrr_stack+6196, vrr_stack+6364, vrr_stack+6112, vrr_stack+2143);
 _BUILD_g0i0(Data,vrr_stack+15896, vrr_stack+15616, vrr_stack+6868, vrr_stack+6448, vrr_stack+6196, vrr_stack+2269);
 _BUILD_00i0(Data,vrr_stack+461, vrr_stack+799, vrr_stack+583, vrr_stack+1099, vrr_stack+924, NULL);
 _BUILD_p0i0(Data,vrr_stack+1885, vrr_stack+461, vrr_stack+405, NULL, NULL, vrr_stack+583);
 _BUILD_d0i0(Data,vrr_stack+1969, vrr_stack+1885, vrr_stack+6364, vrr_stack+461, vrr_stack+405, vrr_stack+604);
 _BUILD_f0i0(Data,vrr_stack+2137, vrr_stack+1969, vrr_stack+6448, vrr_stack+1885, vrr_stack+6364, vrr_stack+7174);
 _BUILD_g0i0(Data,vrr_stack+16316, vrr_stack+2137, vrr_stack+15616, vrr_stack+1969, vrr_stack+6448, vrr_stack+7300);
 _BUILD_00i0(Data,vrr_stack+604, vrr_stack+778, vrr_stack+939, vrr_stack+909, vrr_stack+1084, NULL);
 _BUILD_p0i0(Data,vrr_stack+7148, vrr_stack+433, vrr_stack+604, NULL, NULL, vrr_stack+778);
 _BUILD_d0i0(Data,vrr_stack+7232, vrr_stack+6616, vrr_stack+7148, vrr_stack+1773, vrr_stack+433, vrr_stack+667);
 _BUILD_f0i0(Data,vrr_stack+16736, vrr_stack+6700, vrr_stack+7232, vrr_stack+1801, vrr_stack+6616, vrr_stack+2479);
 _BUILD_g0i0(Data,vrr_stack+32206, vrr_stack+6868, vrr_stack+16736, vrr_stack+6196, vrr_stack+6700, vrr_stack+7510);
 _BUILD_h0i0(Data,vrr_stack+32626, vrr_stack+15896, vrr_stack+32206, vrr_stack+15616, vrr_stack+6868, vrr_stack+7720);
 _BUILD_h0i0(Data,vrr_stack+7400, vrr_stack+16316, vrr_stack+15896, vrr_stack+2137, vrr_stack+15616, vrr_stack+2605);
 _BUILD_i0i0(Data,vrr_stack+33214, vrr_stack+7400, vrr_stack+32626, vrr_stack+16316, vrr_stack+15896, vrr_stack+17359);
 _BUILD_00i0(Data,vrr_stack+632, vrr_stack+1023, vrr_stack+799, vrr_stack+262, vrr_stack+1099, NULL);
 _BUILD_p0i0(Data,vrr_stack+660, vrr_stack+632, vrr_stack+461, NULL, NULL, vrr_stack+799);
 _BUILD_d0i0(Data,vrr_stack+2417, vrr_stack+660, vrr_stack+1885, vrr_stack+632, vrr_stack+461, vrr_stack+820);
 _BUILD_f0i0(Data,vrr_stack+2585, vrr_stack+2417, vrr_stack+1969, vrr_stack+660, vrr_stack+1885, vrr_stack+2920);
 _BUILD_g0i0(Data,vrr_stack+17016, vrr_stack+2585, vrr_stack+2137, vrr_stack+2417, vrr_stack+1969, vrr_stack+8035);
 _BUILD_h0i0(Data,vrr_stack+33998, vrr_stack+17016, vrr_stack+16316, vrr_stack+2585, vrr_stack+2137, vrr_stack+17800);
 _BUILD_i0i0(Data,vrr_stack+34586, vrr_stack+33998, vrr_stack+7400, vrr_stack+17016, vrr_stack+16316, vrr_stack+18115);
 _BUILD_00i0(Data,vrr_stack+820, vrr_stack+939, vrr_stack+1114, vrr_stack+1084, vrr_stack+1249, NULL);
 _BUILD_p0i0(Data,vrr_stack+848, vrr_stack+604, vrr_stack+820, NULL, NULL, vrr_stack+939);
 _BUILD_d0i0(Data,vrr_stack+2865, vrr_stack+7148, vrr_stack+848, vrr_stack+433, vrr_stack+604, vrr_stack+960);
 _BUILD_f0i0(Data,vrr_stack+17436, vrr_stack+7232, vrr_stack+2865, vrr_stack+6616, vrr_stack+7148, vrr_stack+79);
 _BUILD_g0i0(Data,vrr_stack+17716, vrr_stack+16736, vrr_stack+17436, vrr_stack+6700, vrr_stack+7232, vrr_stack+3046);
 _BUILD_h0i0(Data,vrr_stack+35370, vrr_stack+32206, vrr_stack+17716, vrr_stack+6868, vrr_stack+16736, vrr_stack+8245);
 _BUILD_i0i0(Data,vrr_stack+35958, vrr_stack+32626, vrr_stack+35370, vrr_stack+15896, vrr_stack+32206, vrr_stack+18556);
 _BUILD_k0i0(Data,vrr_stack+36742, vrr_stack+33214, vrr_stack+35958, vrr_stack+7400, vrr_stack+32626, vrr_stack+18997);
 _BUILD_k0i0(Data,vrr_stack+18136, vrr_stack+34586, vrr_stack+33214, vrr_stack+33998, vrr_stack+7400, vrr_stack+8560);
 _BUILD_l0i0(Data,vrr_stack+37750, vrr_stack+18136, vrr_stack+36742, vrr_stack+34586, vrr_stack+33214, vrr_stack+19585);
 _BUILD_00i0(Data,vrr_stack+79, vrr_stack+221, vrr_stack+1023, vrr_stack+1267, vrr_stack+262, NULL);
 _BUILD_p0i0(Data,vrr_stack+107, vrr_stack+79, vrr_stack+632, NULL, NULL, vrr_stack+1023);
 _BUILD_d0i0(Data,vrr_stack+3033, vrr_stack+107, vrr_stack+660, vrr_stack+79, vrr_stack+632, vrr_stack+3256);
 _BUILD_f0i0(Data,vrr_stack+7988, vrr_stack+3033, vrr_stack+2417, vrr_stack+107, vrr_stack+660, vrr_stack+3319);
 _BUILD_g0i0(Data,vrr_stack+8268, vrr_stack+7988, vrr_stack+2585, vrr_stack+3033, vrr_stack+2417, vrr_stack+3445);
 _BUILD_h0i0(Data,vrr_stack+19144, vrr_stack+8268, vrr_stack+17016, vrr_stack+7988, vrr_stack+2585, vrr_stack+9148);
 _BUILD_i0i0(Data,vrr_stack+39010, vrr_stack+19144, vrr_stack+33998, vrr_stack+8268, vrr_stack+17016, vrr_stack+20341);
 _BUILD_k0i0(Data,vrr_stack+19732, vrr_stack+39010, vrr_stack+34586, vrr_stack+19144, vrr_stack+33998, vrr_stack+20782);
 _BUILD_l0i0(Data,vrr_stack+39794, vrr_stack+19732, vrr_stack+18136, vrr_stack+39010, vrr_stack+34586, vrr_stack+9463);
 _BUILD_00i0(Data,vrr_stack+261, vrr_stack+1114, vrr_stack+1297, vrr_stack+1249, vrr_stack+302, NULL);
 _BUILD_p0i0(Data,vrr_stack+3201, vrr_stack+820, vrr_stack+261, NULL, NULL, vrr_stack+1114);
 _BUILD_d0i0(Data,vrr_stack+3285, vrr_stack+848, vrr_stack+3201, vrr_stack+604, vrr_stack+820, vrr_stack+1135);
 _BUILD_f0i0(Data,vrr_stack+8688, vrr_stack+2865, vrr_stack+3285, vrr_stack+7148, vrr_stack+848, vrr_stack+3655);
 _BUILD_g0i0(Data,vrr_stack+8968, vrr_stack+17436, vrr_stack+8688, vrr_stack+7232, vrr_stack+2865, vrr_stack+10219);
 _BUILD_h0i0(Data,vrr_stack+9388, vrr_stack+17716, vrr_stack+8968, vrr_stack+16736, vrr_stack+17436, vrr_stack+21370);
 _BUILD_i0i0(Data,vrr_stack+20740, vrr_stack+35370, vrr_stack+9388, vrr_stack+32206, vrr_stack+17716, vrr_stack+21685);
 _BUILD_k0i0(Data,vrr_stack+41054, vrr_stack+35958, vrr_stack+20740, vrr_stack+32626, vrr_stack+35370, vrr_stack+3781);
 _BUILD_l0i0(Data,vrr_stack+42062, vrr_stack+36742, vrr_stack+41054, vrr_stack+33214, vrr_stack+35958, vrr_stack+22126);
 _BUILD_m0i0(Data,vrr_stack+43322, vrr_stack+37750, vrr_stack+42062, vrr_stack+18136, vrr_stack+36742, vrr_stack+10429);
 _BUILD_m0i0(Data,vrr_stack+44862, vrr_stack+39794, vrr_stack+37750, vrr_stack+19732, vrr_stack+18136, vrr_stack+22882);
 _BUILD_n0i0(Data,vrr_stack+21524, vrr_stack+44862, vrr_stack+43322, vrr_stack+39794, vrr_stack+37750, vrr_stack+23827);
 _BUILD_00p0(Data,vrr_stack+1135, Data->F+1, Data->F+2, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+215, vrr_stack+1135, vrr_stack+1264, Data->F+1, Data->F+2, NULL);
 _BUILD_00f0(Data,vrr_stack+1138, vrr_stack+215, vrr_stack+18, vrr_stack+1135, vrr_stack+1264, NULL);
 _BUILD_00g0(Data,vrr_stack+1148, vrr_stack+1138, vrr_stack+205, vrr_stack+215, vrr_stack+18, NULL);
 _BUILD_00h0(Data,vrr_stack+18, vrr_stack+1148, vrr_stack+1267, vrr_stack+1138, vrr_stack+205, NULL);
 _BUILD_00i0(Data,vrr_stack+1163, vrr_stack+18, vrr_stack+221, vrr_stack+1148, vrr_stack+1267, NULL);
 _BUILD_p0i0(Data,vrr_stack+1191, vrr_stack+1163, vrr_stack+79, NULL, NULL, vrr_stack+221);
 _BUILD_d0i0(Data,vrr_stack+3453, vrr_stack+1191, vrr_stack+107, vrr_stack+1163, vrr_stack+79, vrr_stack+4369);
 _BUILD_f0i0(Data,vrr_stack+3621, vrr_stack+3453, vrr_stack+3033, vrr_stack+1191, vrr_stack+107, vrr_stack+4432);
 _BUILD_g0i0(Data,vrr_stack+3901, vrr_stack+3621, vrr_stack+7988, vrr_stack+3453, vrr_stack+3033, vrr_stack+4558);
 _BUILD_h0i0(Data,vrr_stack+9976, vrr_stack+3901, vrr_stack+8268, vrr_stack+3621, vrr_stack+7988, vrr_stack+11374);
 _BUILD_i0i0(Data,vrr_stack+10564, vrr_stack+9976, vrr_stack+19144, vrr_stack+3901, vrr_stack+8268, vrr_stack+11689);
 _BUILD_k0i0(Data,vrr_stack+23372, vrr_stack+10564, vrr_stack+39010, vrr_stack+9976, vrr_stack+19144, vrr_stack+24982);
 _BUILD_l0i0(Data,vrr_stack+46402, vrr_stack+23372, vrr_stack+19732, vrr_stack+10564, vrr_stack+39010, vrr_stack+25570);
 _BUILD_m0i0(Data,vrr_stack+24380, vrr_stack+46402, vrr_stack+39794, vrr_stack+23372, vrr_stack+19732, vrr_stack+26326);
 _BUILD_n0i0(Data,vrr_stack+47662, vrr_stack+24380, vrr_stack+44862, vrr_stack+46402, vrr_stack+39794, vrr_stack+12130);
 _BUILD_00p0(Data,vrr_stack+39, Data->F+18, Data->F+19, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+42, vrr_stack+242, vrr_stack+39, Data->F+17, Data->F+18, NULL);
 _BUILD_00f0(Data,vrr_stack+48, vrr_stack+245, vrr_stack+42, vrr_stack+289, vrr_stack+242, NULL);
 _BUILD_00g0(Data,vrr_stack+191, vrr_stack+251, vrr_stack+48, vrr_stack+12, vrr_stack+245, NULL);
 _BUILD_00h0(Data,vrr_stack+960, vrr_stack+1282, vrr_stack+191, vrr_stack+292, vrr_stack+251, NULL);
 _BUILD_00i0(Data,vrr_stack+981, vrr_stack+1297, vrr_stack+960, vrr_stack+302, vrr_stack+1282, NULL);
 _BUILD_p0i0(Data,vrr_stack+4321, vrr_stack+261, vrr_stack+981, NULL, NULL, vrr_stack+1297);
 _BUILD_d0i0(Data,vrr_stack+4405, vrr_stack+3201, vrr_stack+4321, vrr_stack+820, vrr_stack+261, vrr_stack+1318);
 _BUILD_f0i0(Data,vrr_stack+11348, vrr_stack+3285, vrr_stack+4405, vrr_stack+848, vrr_stack+3201, vrr_stack+1381);
 _BUILD_g0i0(Data,vrr_stack+11628, vrr_stack+8688, vrr_stack+11348, vrr_stack+2865, vrr_stack+3285, vrr_stack+1507);
 _BUILD_h0i0(Data,vrr_stack+12048, vrr_stack+8968, vrr_stack+11628, vrr_stack+17436, vrr_stack+8688, vrr_stack+4768);
 _BUILD_i0i0(Data,vrr_stack+25920, vrr_stack+9388, vrr_stack+12048, vrr_stack+17716, vrr_stack+8968, vrr_stack+5083);
 _BUILD_k0i0(Data,vrr_stack+49510, vrr_stack+20740, vrr_stack+25920, vrr_stack+35370, vrr_stack+9388, vrr_stack+5524);
 _BUILD_l0i0(Data,vrr_stack+4573, vrr_stack+41054, vrr_stack+49510, vrr_stack+35958, vrr_stack+20740, vrr_stack+27271);
 _BUILD_m0i0(Data,vrr_stack+50518, vrr_stack+42062, vrr_stack+4573, vrr_stack+36742, vrr_stack+41054, vrr_stack+13285);
 _BUILD_n0i0(Data,vrr_stack+52058, vrr_stack+43322, vrr_stack+50518, vrr_stack+37750, vrr_stack+42062, vrr_stack+28027);
 _BUILD_o0i0(Data,vrr_stack+26704, vrr_stack+21524, vrr_stack+52058, vrr_stack+44862, vrr_stack+43322, vrr_stack+29182);
 _BUILD_o0i0(Data,vrr_stack+53906, vrr_stack+47662, vrr_stack+21524, vrr_stack+24380, vrr_stack+44862, vrr_stack+14230);
 _BUILD_q0i0(Data,vrr_stack+12636, vrr_stack+53906, vrr_stack+26704, vrr_stack+47662, vrr_stack+21524, vrr_stack+30568);
 _BUILD_00k0(Data,vrr_stack+1318, vrr_stack+1717, vrr_stack+1773, vrr_stack+384, vrr_stack+363, NULL);
 _BUILD_00k0(Data,vrr_stack+1354, vrr_stack+1745, vrr_stack+1717, vrr_stack+58, vrr_stack+384, NULL);
 _BUILD_p0k0(Data,vrr_stack+1390, vrr_stack+1354, vrr_stack+1318, NULL, NULL, vrr_stack+1717);
 _BUILD_00k0(Data,vrr_stack+1498, vrr_stack+405, vrr_stack+1745, vrr_stack+583, vrr_stack+58, NULL);
 _BUILD_p0k0(Data,vrr_stack+1534, vrr_stack+1498, vrr_stack+1354, NULL, NULL, vrr_stack+1745);
 _BUILD_00k0(Data,vrr_stack+1642, vrr_stack+1773, vrr_stack+433, vrr_stack+363, vrr_stack+531, NULL);
 _BUILD_p0k0(Data,vrr_stack+289, vrr_stack+1318, vrr_stack+1642, NULL, NULL, vrr_stack+1773);
 _BUILD_d0k0(Data,vrr_stack+5833, vrr_stack+1390, vrr_stack+289, vrr_stack+1354, vrr_stack+1318, vrr_stack+1801);
 _BUILD_d0k0(Data,vrr_stack+15184, vrr_stack+1534, vrr_stack+1390, vrr_stack+1498, vrr_stack+1354, vrr_stack+6112);
 _BUILD_f0k0(Data,vrr_stack+28888, vrr_stack+15184, vrr_stack+5833, vrr_stack+1534, vrr_stack+1390, vrr_stack+6196);
 _BUILD_00k0(Data,vrr_stack+1801, vrr_stack+461, vrr_stack+405, vrr_stack+799, vrr_stack+583, NULL);
 _BUILD_p0k0(Data,vrr_stack+6049, vrr_stack+1801, vrr_stack+1498, NULL, NULL, vrr_stack+405);
 _BUILD_d0k0(Data,vrr_stack+15400, vrr_stack+6049, vrr_stack+1534, vrr_stack+1801, vrr_stack+1498, vrr_stack+6364);
 _BUILD_f0k0(Data,vrr_stack+29248, vrr_stack+15400, vrr_stack+15184, vrr_stack+6049, vrr_stack+1534, vrr_stack+6448);
 _BUILD_00k0(Data,vrr_stack+1837, vrr_stack+433, vrr_stack+604, vrr_stack+531, vrr_stack+778, NULL);
 _BUILD_p0k0(Data,vrr_stack+489, vrr_stack+1642, vrr_stack+1837, NULL, NULL, vrr_stack+433);
 _BUILD_d0k0(Data,vrr_stack+6157, vrr_stack+289, vrr_stack+489, vrr_stack+1318, vrr_stack+1642, vrr_stack+6616);
 _BUILD_f0k0(Data,vrr_stack+29608, vrr_stack+5833, vrr_stack+6157, vrr_stack+1390, vrr_stack+289, vrr_stack+6700);
 _BUILD_g0k0(Data,vrr_stack+29968, vrr_stack+28888, vrr_stack+29608, vrr_stack+15184, vrr_stack+5833, vrr_stack+6868);
 _BUILD_g0k0(Data,vrr_stack+6373, vrr_stack+29248, vrr_stack+28888, vrr_stack+15400, vrr_stack+15184, vrr_stack+15616);
 _BUILD_h0k0(Data,vrr_stack+30508, vrr_stack+6373, vrr_stack+29968, vrr_stack+29248, vrr_stack+28888, vrr_stack+15896);
 _BUILD_00k0(Data,vrr_stack+15616, vrr_stack+632, vrr_stack+461, vrr_stack+1023, vrr_stack+799, NULL);
 _BUILD_p0k0(Data,vrr_stack+15652, vrr_stack+15616, vrr_stack+1801, NULL, NULL, vrr_stack+461);
 _BUILD_d0k0(Data,vrr_stack+15760, vrr_stack+15652, vrr_stack+6049, vrr_stack+15616, vrr_stack+1801, vrr_stack+1885);
 _BUILD_f0k0(Data,vrr_stack+31264, vrr_stack+15760, vrr_stack+15400, vrr_stack+15652, vrr_stack+6049, vrr_stack+1969);
 _BUILD_g0k0(Data,vrr_stack+31624, vrr_stack+31264, vrr_stack+29248, vrr_stack+15760, vrr_stack+15400, vrr_stack+2137);
 _BUILD_h0k0(Data,vrr_stack+56090, vrr_stack+31624, vrr_stack+6373, vrr_stack+31264, vrr_stack+29248, vrr_stack+16316);
 _BUILD_00k0(Data,vrr_stack+15976, vrr_stack+604, vrr_stack+820, vrr_stack+778, vrr_stack+939, NULL);
 _BUILD_p0k0(Data,vrr_stack+16012, vrr_stack+1837, vrr_stack+15976, NULL, NULL, vrr_stack+604);
 _BUILD_d0k0(Data,vrr_stack+16120, vrr_stack+489, vrr_stack+16012, vrr_stack+1642, vrr_stack+1837, vrr_stack+7148);
 _BUILD_f0k0(Data,vrr_stack+16336, vrr_stack+6157, vrr_stack+16120, vrr_stack+289, vrr_stack+489, vrr_stack+7232);
 _BUILD_g0k0(Data,vrr_stack+1873, vrr_stack+29608, vrr_stack+16336, vrr_stack+5833, vrr_stack+6157, vrr_stack+16736);
 _BUILD_h0k0(Data,vrr_stack+56846, vrr_stack+29968, vrr_stack+1873, vrr_stack+28888, vrr_stack+29608, vrr_stack+32206);
 _BUILD_i0k0(Data,vrr_stack+57602, vrr_stack+30508, vrr_stack+56846, vrr_stack+6373, vrr_stack+29968, vrr_stack+32626);
 _BUILD_i0k0(Data,vrr_stack+32164, vrr_stack+56090, vrr_stack+30508, vrr_stack+31624, vrr_stack+6373, vrr_stack+7400);
 _BUILD_k0k0(Data,vrr_stack+58610, vrr_stack+32164, vrr_stack+57602, vrr_stack+56090, vrr_stack+30508, vrr_stack+33214);
 _BUILD_00k0(Data,vrr_stack+16696, vrr_stack+79, vrr_stack+632, vrr_stack+221, vrr_stack+1023, NULL);
 _BUILD_p0k0(Data,vrr_stack+16732, vrr_stack+16696, vrr_stack+15616, NULL, NULL, vrr_stack+632);
 _BUILD_d0k0(Data,vrr_stack+6913, vrr_stack+16732, vrr_stack+15652, vrr_stack+16696, vrr_stack+15616, vrr_stack+660);
 _BUILD_f0k0(Data,vrr_stack+7129, vrr_stack+6913, vrr_stack+15760, vrr_stack+16732, vrr_stack+15652, vrr_stack+2417);
 _BUILD_g0k0(Data,vrr_stack+33172, vrr_stack+7129, vrr_stack+31264, vrr_stack+6913, vrr_stack+15760, vrr_stack+2585);
 _BUILD_h0k0(Data,vrr_stack+59906, vrr_stack+33172, vrr_stack+31624, vrr_stack+7129, vrr_stack+31264, vrr_stack+17016);
 _BUILD_i0k0(Data,vrr_stack+60662, vrr_stack+59906, vrr_stack+56090, vrr_stack+33172, vrr_stack+31624, vrr_stack+33998);
 _BUILD_k0k0(Data,vrr_stack+61670, vrr_stack+60662, vrr_stack+32164, vrr_stack+59906, vrr_stack+56090, vrr_stack+34586);
 _BUILD_00k0(Data,vrr_stack+660, vrr_stack+820, vrr_stack+261, vrr_stack+939, vrr_stack+1114, NULL);
 _BUILD_p0k0(Data,vrr_stack+696, vrr_stack+15976, vrr_stack+660, NULL, NULL, vrr_stack+820);
 _BUILD_d0k0(Data,vrr_stack+16840, vrr_stack+16012, vrr_stack+696, vrr_stack+1837, vrr_stack+15976, vrr_stack+848);
 _BUILD_f0k0(Data,vrr_stack+17056, vrr_stack+16120, vrr_stack+16840, vrr_stack+489, vrr_stack+16012, vrr_stack+2865);
 _BUILD_g0k0(Data,vrr_stack+2413, vrr_stack+16336, vrr_stack+17056, vrr_stack+6157, vrr_stack+16120, vrr_stack+17436);
 _BUILD_h0k0(Data,vrr_stack+33712, vrr_stack+1873, vrr_stack+2413, vrr_stack+29608, vrr_stack+16336, vrr_stack+17716);
 _BUILD_i0k0(Data,vrr_stack+62966, vrr_stack+56846, vrr_stack+33712, vrr_stack+29968, vrr_stack+1873, vrr_stack+35370);
 _BUILD_k0k0(Data,vrr_stack+34468, vrr_stack+57602, vrr_stack+62966, vrr_stack+30508, vrr_stack+56846, vrr_stack+35958);
 _BUILD_l0k0(Data,vrr_stack+63974, vrr_stack+58610, vrr_stack+34468, vrr_stack+32164, vrr_stack+57602, vrr_stack+36742);
 _BUILD_l0k0(Data,vrr_stack+35764, vrr_stack+61670, vrr_stack+58610, vrr_stack+60662, vrr_stack+32164, vrr_stack+18136);
 _BUILD_m0k0(Data,vrr_stack+65594, vrr_stack+35764, vrr_stack+63974, vrr_stack+61670, vrr_stack+58610, vrr_stack+37750);
 _BUILD_00k0(Data,vrr_stack+848, vrr_stack+1163, vrr_stack+79, vrr_stack+18, vrr_stack+221, NULL);
 _BUILD_p0k0(Data,vrr_stack+17416, vrr_stack+848, vrr_stack+16696, NULL, NULL, vrr_stack+79);
 _BUILD_d0k0(Data,vrr_stack+17524, vrr_stack+17416, vrr_stack+16732, vrr_stack+848, vrr_stack+16696, vrr_stack+107);
 _BUILD_f0k0(Data,vrr_stack+17740, vrr_stack+17524, vrr_stack+6913, vrr_stack+17416, vrr_stack+16732, vrr_stack+3033);
 _BUILD_g0k0(Data,vrr_stack+18100, vrr_stack+17740, vrr_stack+7129, vrr_stack+17524, vrr_stack+6913, vrr_stack+7988);
 _BUILD_h0k0(Data,vrr_stack+7489, vrr_stack+18100, vrr_stack+33172, vrr_stack+17740, vrr_stack+7129, vrr_stack+8268);
 _BUILD_i0k0(Data,vrr_stack+37384, vrr_stack+7489, vrr_stack+59906, vrr_stack+18100, vrr_stack+33172, vrr_stack+19144);
 _BUILD_k0k0(Data,vrr_stack+67574, vrr_stack+37384, vrr_stack+60662, vrr_stack+7489, vrr_stack+59906, vrr_stack+39010);
 _BUILD_l0k0(Data,vrr_stack+68870, vrr_stack+67574, vrr_stack+61670, vrr_stack+37384, vrr_stack+60662, vrr_stack+19732);
 _BUILD_m0k0(Data,vrr_stack+18640, vrr_stack+68870, vrr_stack+35764, vrr_stack+67574, vrr_stack+61670, vrr_stack+39794);
 _BUILD_00k0(Data,vrr_stack+107, vrr_stack+261, vrr_stack+981, vrr_stack+1114, vrr_stack+1297, NULL);
 _BUILD_p0k0(Data,vrr_stack+20620, vrr_stack+660, vrr_stack+107, NULL, NULL, vrr_stack+261);
 _BUILD_d0k0(Data,vrr_stack+2953, vrr_stack+696, vrr_stack+20620, vrr_stack+15976, vrr_stack+660, vrr_stack+3201);
 _BUILD_f0k0(Data,vrr_stack+8245, vrr_stack+16840, vrr_stack+2953, vrr_stack+16012, vrr_stack+696, vrr_stack+3285);
 _BUILD_g0k0(Data,vrr_stack+38392, vrr_stack+17056, vrr_stack+8245, vrr_stack+16120, vrr_stack+16840, vrr_stack+8688);
 _BUILD_h0k0(Data,vrr_stack+38932, vrr_stack+2413, vrr_stack+38392, vrr_stack+16336, vrr_stack+17056, vrr_stack+8968);
 _BUILD_i0k0(Data,vrr_stack+39688, vrr_stack+33712, vrr_stack+38932, vrr_stack+1873, vrr_stack+2413, vrr_stack+9388);
 _BUILD_k0k0(Data,vrr_stack+8605, vrr_stack+62966, vrr_stack+39688, vrr_stack+56846, vrr_stack+33712, vrr_stack+20740);
 _BUILD_l0k0(Data,vrr_stack+70490, vrr_stack+34468, vrr_stack+8605, vrr_stack+57602, vrr_stack+62966, vrr_stack+41054);
 _BUILD_m0k0(Data,vrr_stack+72110, vrr_stack+63974, vrr_stack+70490, vrr_stack+58610, vrr_stack+34468, vrr_stack+42062);
 _BUILD_n0k0(Data,vrr_stack+40696, vrr_stack+65594, vrr_stack+72110, vrr_stack+35764, vrr_stack+63974, vrr_stack+43322);
 _BUILD_n0k0(Data,vrr_stack+74090, vrr_stack+18640, vrr_stack+65594, vrr_stack+68870, vrr_stack+35764, vrr_stack+44862);
 _BUILD_o0k0(Data,vrr_stack+43072, vrr_stack+74090, vrr_stack+40696, vrr_stack+18640, vrr_stack+65594, vrr_stack+21524);
 _BUILD_00p0(Data,vrr_stack+143, Data->F+0, Data->F+1, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+146, vrr_stack+143, vrr_stack+1135, Data->F+0, Data->F+1, NULL);
 _BUILD_00f0(Data,vrr_stack+152, vrr_stack+146, vrr_stack+215, vrr_stack+143, vrr_stack+1135, NULL);
 _BUILD_00g0(Data,vrr_stack+162, vrr_stack+152, vrr_stack+1138, vrr_stack+146, vrr_stack+215, NULL);
 _BUILD_00h0(Data,vrr_stack+58, vrr_stack+162, vrr_stack+1148, vrr_stack+152, vrr_stack+1138, NULL);
 _BUILD_00i0(Data,vrr_stack+884, vrr_stack+58, vrr_stack+18, vrr_stack+162, vrr_stack+1148, NULL);
 _BUILD_00k0(Data,vrr_stack+206, vrr_stack+884, vrr_stack+1163, vrr_stack+58, vrr_stack+18, NULL);
 _BUILD_p0k0(Data,vrr_stack+20728, vrr_stack+206, vrr_stack+848, NULL, NULL, vrr_stack+1163);
 _BUILD_d0k0(Data,vrr_stack+20836, vrr_stack+20728, vrr_stack+17416, vrr_stack+206, vrr_stack+848, vrr_stack+1191);
 _BUILD_f0k0(Data,vrr_stack+21052, vrr_stack+20836, vrr_stack+17524, vrr_stack+20728, vrr_stack+17416, vrr_stack+3453);
 _BUILD_g0k0(Data,vrr_stack+21412, vrr_stack+21052, vrr_stack+17740, vrr_stack+20836, vrr_stack+17524, vrr_stack+3621);
 _BUILD_h0k0(Data,vrr_stack+21952, vrr_stack+21412, vrr_stack+18100, vrr_stack+21052, vrr_stack+17740, vrr_stack+3901);
 _BUILD_i0k0(Data,vrr_stack+3169, vrr_stack+21952, vrr_stack+7489, vrr_stack+21412, vrr_stack+18100, vrr_stack+9976);
 _BUILD_k0k0(Data,vrr_stack+76466, vrr_stack+3169, vrr_stack+37384, vrr_stack+21952, vrr_stack+7489, vrr_stack+10564);
 _BUILD_l0k0(Data,vrr_stack+20728, vrr_stack+76466, vrr_stack+67574, vrr_stack+3169, vrr_stack+37384, vrr_stack+23372);
   tmp = vrr_stack + 20728;
   target_ptr = Libint->vrr_classes[8][7];
   for(i=0;i<1620;i++)
     target_ptr[i] += tmp[i];
 _BUILD_m0k0(Data,vrr_stack+22348, vrr_stack+20728, vrr_stack+68870, vrr_stack+76466, vrr_stack+67574, vrr_stack+46402);
   tmp = vrr_stack + 22348;
   target_ptr = Libint->vrr_classes[9][7];
   for(i=0;i<1980;i++)
     target_ptr[i] += tmp[i];
 _BUILD_n0k0(Data,vrr_stack+76466, vrr_stack+22348, vrr_stack+18640, vrr_stack+20728, vrr_stack+68870, vrr_stack+24380);
   tmp = vrr_stack + 76466;
   target_ptr = Libint->vrr_classes[10][7];
   for(i=0;i<2376;i++)
     target_ptr[i] += tmp[i];
 _BUILD_o0k0(Data,vrr_stack+78842, vrr_stack+76466, vrr_stack+74090, vrr_stack+22348, vrr_stack+18640, vrr_stack+47662);
   tmp = vrr_stack + 78842;
   target_ptr = Libint->vrr_classes[11][7];
   for(i=0;i<2808;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00p0(Data,vrr_stack+20728, Data->F+19, Data->F+20, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+20731, vrr_stack+39, vrr_stack+20728, Data->F+18, Data->F+19, NULL);
 _BUILD_00f0(Data,vrr_stack+20737, vrr_stack+42, vrr_stack+20731, vrr_stack+242, vrr_stack+39, NULL);
 _BUILD_00g0(Data,vrr_stack+20747, vrr_stack+48, vrr_stack+20737, vrr_stack+245, vrr_stack+42, NULL);
 _BUILD_00h0(Data,vrr_stack+58, vrr_stack+191, vrr_stack+20747, vrr_stack+251, vrr_stack+48, NULL);
 _BUILD_00i0(Data,vrr_stack+20762, vrr_stack+960, vrr_stack+58, vrr_stack+1282, vrr_stack+191, NULL);
 _BUILD_00k0(Data,vrr_stack+20790, vrr_stack+981, vrr_stack+20762, vrr_stack+1297, vrr_stack+960, NULL);
 _BUILD_p0k0(Data,vrr_stack+20826, vrr_stack+107, vrr_stack+20790, NULL, NULL, vrr_stack+981);
 _BUILD_d0k0(Data,vrr_stack+20934, vrr_stack+20620, vrr_stack+20826, vrr_stack+660, vrr_stack+107, vrr_stack+4321);
 _BUILD_f0k0(Data,vrr_stack+21150, vrr_stack+2953, vrr_stack+20934, vrr_stack+696, vrr_stack+20620, vrr_stack+4405);
 _BUILD_g0k0(Data,vrr_stack+21510, vrr_stack+8245, vrr_stack+21150, vrr_stack+16840, vrr_stack+2953, vrr_stack+11348);
 _BUILD_h0k0(Data,vrr_stack+22050, vrr_stack+38392, vrr_stack+21510, vrr_stack+17056, vrr_stack+8245, vrr_stack+11628);
 _BUILD_i0k0(Data,vrr_stack+22806, vrr_stack+38932, vrr_stack+22050, vrr_stack+2413, vrr_stack+38392, vrr_stack+12048);
 _BUILD_k0k0(Data,vrr_stack+23814, vrr_stack+39688, vrr_stack+22806, vrr_stack+33712, vrr_stack+38932, vrr_stack+25920);
 _BUILD_l0k0(Data,vrr_stack+9901, vrr_stack+8605, vrr_stack+23814, vrr_stack+62966, vrr_stack+39688, vrr_stack+49510);
 _BUILD_m0k0(Data,vrr_stack+45880, vrr_stack+70490, vrr_stack+9901, vrr_stack+34468, vrr_stack+8605, vrr_stack+4573);
 _BUILD_n0k0(Data,vrr_stack+3169, vrr_stack+72110, vrr_stack+45880, vrr_stack+63974, vrr_stack+70490, vrr_stack+50518);
 _BUILD_o0k0(Data,vrr_stack+47860, vrr_stack+40696, vrr_stack+3169, vrr_stack+65594, vrr_stack+72110, vrr_stack+52058);
 _BUILD_q0k0(Data,vrr_stack+81650, vrr_stack+43072, vrr_stack+47860, vrr_stack+74090, vrr_stack+40696, vrr_stack+26704);
 _BUILD_q0k0(Data,vrr_stack+25110, vrr_stack+78842, vrr_stack+43072, vrr_stack+76466, vrr_stack+74090, vrr_stack+53906);
   tmp = vrr_stack + 25110;
   target_ptr = Libint->vrr_classes[12][7];
   for(i=0;i<3276;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00l0(Data,vrr_stack+76466, vrr_stack+1318, vrr_stack+1642, vrr_stack+1717, vrr_stack+1773, NULL);
 _BUILD_00l0(Data,vrr_stack+76511, vrr_stack+1354, vrr_stack+1318, vrr_stack+1745, vrr_stack+1717, NULL);
 _BUILD_p0l0(Data,vrr_stack+76556, vrr_stack+76511, vrr_stack+76466, NULL, NULL, vrr_stack+1318);
 _BUILD_00l0(Data,vrr_stack+76691, vrr_stack+1498, vrr_stack+1354, vrr_stack+405, vrr_stack+1745, NULL);
 _BUILD_p0l0(Data,vrr_stack+76736, vrr_stack+76691, vrr_stack+76511, NULL, NULL, vrr_stack+1354);
 _BUILD_00l0(Data,vrr_stack+76871, vrr_stack+1642, vrr_stack+1837, vrr_stack+1773, vrr_stack+433, NULL);
 _BUILD_p0l0(Data,vrr_stack+76916, vrr_stack+76466, vrr_stack+76871, NULL, NULL, vrr_stack+1642);
 _BUILD_d0l0(Data,vrr_stack+77051, vrr_stack+76556, vrr_stack+76916, vrr_stack+76511, vrr_stack+76466, vrr_stack+289);
 _BUILD_d0l0(Data,vrr_stack+77321, vrr_stack+76736, vrr_stack+76556, vrr_stack+76691, vrr_stack+76511, vrr_stack+1390);
 _BUILD_f0l0(Data,vrr_stack+77591, vrr_stack+77321, vrr_stack+77051, vrr_stack+76736, vrr_stack+76556, vrr_stack+5833);
 _BUILD_00l0(Data,vrr_stack+1390, vrr_stack+1801, vrr_stack+1498, vrr_stack+461, vrr_stack+405, NULL);
 _BUILD_p0l0(Data,vrr_stack+289, vrr_stack+1390, vrr_stack+76691, NULL, NULL, vrr_stack+1498);
 _BUILD_d0l0(Data,vrr_stack+78041, vrr_stack+289, vrr_stack+76736, vrr_stack+1390, vrr_stack+76691, vrr_stack+1534);
 _BUILD_f0l0(Data,vrr_stack+78311, vrr_stack+78041, vrr_stack+77321, vrr_stack+289, vrr_stack+76736, vrr_stack+15184);
 _BUILD_00l0(Data,vrr_stack+15184, vrr_stack+1837, vrr_stack+15976, vrr_stack+433, vrr_stack+604, NULL);
 _BUILD_p0l0(Data,vrr_stack+15229, vrr_stack+76871, vrr_stack+15184, NULL, NULL, vrr_stack+1837);
 _BUILD_d0l0(Data,vrr_stack+28386, vrr_stack+76916, vrr_stack+15229, vrr_stack+76466, vrr_stack+76871, vrr_stack+489);
 _BUILD_f0l0(Data,vrr_stack+5545, vrr_stack+77051, vrr_stack+28386, vrr_stack+76556, vrr_stack+76916, vrr_stack+6157);
 _BUILD_g0l0(Data,vrr_stack+11521, vrr_stack+77591, vrr_stack+5545, vrr_stack+77321, vrr_stack+77051, vrr_stack+29608);
 _BUILD_g0l0(Data,vrr_stack+50668, vrr_stack+78311, vrr_stack+77591, vrr_stack+78041, vrr_stack+77321, vrr_stack+28888);
 _BUILD_h0l0(Data,vrr_stack+51343, vrr_stack+50668, vrr_stack+11521, vrr_stack+78311, vrr_stack+77591, vrr_stack+29968);
 _BUILD_00l0(Data,vrr_stack+29608, vrr_stack+15616, vrr_stack+1801, vrr_stack+632, vrr_stack+461, NULL);
 _BUILD_p0l0(Data,vrr_stack+29653, vrr_stack+29608, vrr_stack+1390, NULL, NULL, vrr_stack+1801);
 _BUILD_d0l0(Data,vrr_stack+29788, vrr_stack+29653, vrr_stack+289, vrr_stack+29608, vrr_stack+1390, vrr_stack+6049);
 _BUILD_f0l0(Data,vrr_stack+30058, vrr_stack+29788, vrr_stack+78041, vrr_stack+29653, vrr_stack+289, vrr_stack+15400);
 _BUILD_g0l0(Data,vrr_stack+52288, vrr_stack+30058, vrr_stack+78311, vrr_stack+29788, vrr_stack+78041, vrr_stack+29248);
 _BUILD_h0l0(Data,vrr_stack+28656, vrr_stack+52288, vrr_stack+50668, vrr_stack+30058, vrr_stack+78311, vrr_stack+6373);
 _BUILD_00l0(Data,vrr_stack+15364, vrr_stack+15976, vrr_stack+660, vrr_stack+604, vrr_stack+820, NULL);
 _BUILD_p0l0(Data,vrr_stack+15409, vrr_stack+15184, vrr_stack+15364, NULL, NULL, vrr_stack+15976);
 _BUILD_d0l0(Data,vrr_stack+5995, vrr_stack+15229, vrr_stack+15409, vrr_stack+76871, vrr_stack+15184, vrr_stack+16012);
 _BUILD_f0l0(Data,vrr_stack+6265, vrr_stack+28386, vrr_stack+5995, vrr_stack+76916, vrr_stack+15229, vrr_stack+16120);
 _BUILD_g0l0(Data,vrr_stack+52963, vrr_stack+5545, vrr_stack+6265, vrr_stack+77051, vrr_stack+28386, vrr_stack+16336);
 _BUILD_h0l0(Data,vrr_stack+53638, vrr_stack+11521, vrr_stack+52963, vrr_stack+77591, vrr_stack+5545, vrr_stack+1873);
 _BUILD_i0l0(Data,vrr_stack+54583, vrr_stack+51343, vrr_stack+53638, vrr_stack+50668, vrr_stack+11521, vrr_stack+56846);
 _BUILD_i0l0(Data,vrr_stack+84926, vrr_stack+28656, vrr_stack+51343, vrr_stack+52288, vrr_stack+50668, vrr_stack+30508);
 _BUILD_k0l0(Data,vrr_stack+86186, vrr_stack+84926, vrr_stack+54583, vrr_stack+28656, vrr_stack+51343, vrr_stack+57602);
 _BUILD_00l0(Data,vrr_stack+30508, vrr_stack+16696, vrr_stack+15616, vrr_stack+79, vrr_stack+632, NULL);
 _BUILD_p0l0(Data,vrr_stack+30553, vrr_stack+30508, vrr_stack+29608, NULL, NULL, vrr_stack+15616);
 _BUILD_d0l0(Data,vrr_stack+30688, vrr_stack+30553, vrr_stack+29653, vrr_stack+30508, vrr_stack+29608, vrr_stack+15652);
 _BUILD_f0l0(Data,vrr_stack+56846, vrr_stack+30688, vrr_stack+29788, vrr_stack+30553, vrr_stack+29653, vrr_stack+15760);
 _BUILD_g0l0(Data,vrr_stack+57296, vrr_stack+56846, vrr_stack+30058, vrr_stack+30688, vrr_stack+29788, vrr_stack+31264);
 _BUILD_h0l0(Data,vrr_stack+87806, vrr_stack+57296, vrr_stack+52288, vrr_stack+56846, vrr_stack+30058, vrr_stack+31624);
 _BUILD_i0l0(Data,vrr_stack+88751, vrr_stack+87806, vrr_stack+28656, vrr_stack+57296, vrr_stack+52288, vrr_stack+56090);
 _BUILD_k0l0(Data,vrr_stack+90011, vrr_stack+88751, vrr_stack+84926, vrr_stack+87806, vrr_stack+28656, vrr_stack+32164);
 _BUILD_00l0(Data,vrr_stack+15652, vrr_stack+660, vrr_stack+107, vrr_stack+820, vrr_stack+261, NULL);
 _BUILD_p0l0(Data,vrr_stack+15697, vrr_stack+15364, vrr_stack+15652, NULL, NULL, vrr_stack+660);
 _BUILD_d0l0(Data,vrr_stack+30958, vrr_stack+15409, vrr_stack+15697, vrr_stack+15184, vrr_stack+15364, vrr_stack+696);
 _BUILD_f0l0(Data,vrr_stack+31228, vrr_stack+5995, vrr_stack+30958, vrr_stack+15229, vrr_stack+15409, vrr_stack+16840);
 _BUILD_g0l0(Data,vrr_stack+31678, vrr_stack+6265, vrr_stack+31228, vrr_stack+28386, vrr_stack+5995, vrr_stack+17056);
 _BUILD_h0l0(Data,vrr_stack+55843, vrr_stack+52963, vrr_stack+31678, vrr_stack+5545, vrr_stack+6265, vrr_stack+2413);
 _BUILD_i0l0(Data,vrr_stack+91631, vrr_stack+53638, vrr_stack+55843, vrr_stack+11521, vrr_stack+52963, vrr_stack+33712);
 _BUILD_k0l0(Data,vrr_stack+92891, vrr_stack+54583, vrr_stack+91631, vrr_stack+51343, vrr_stack+53638, vrr_stack+62966);
 _BUILD_l0l0(Data,vrr_stack+94511, vrr_stack+86186, vrr_stack+92891, vrr_stack+84926, vrr_stack+54583, vrr_stack+34468);
 _BUILD_l0l0(Data,vrr_stack+33712, vrr_stack+90011, vrr_stack+86186, vrr_stack+88751, vrr_stack+84926, vrr_stack+58610);
 _BUILD_m0l0(Data,vrr_stack+96536, vrr_stack+33712, vrr_stack+94511, vrr_stack+90011, vrr_stack+86186, vrr_stack+63974);
 _BUILD_00l0(Data,vrr_stack+62966, vrr_stack+848, vrr_stack+16696, vrr_stack+1163, vrr_stack+79, NULL);
 _BUILD_p0l0(Data,vrr_stack+63011, vrr_stack+62966, vrr_stack+30508, NULL, NULL, vrr_stack+16696);
 _BUILD_d0l0(Data,vrr_stack+63146, vrr_stack+63011, vrr_stack+30553, vrr_stack+62966, vrr_stack+30508, vrr_stack+16732);
 _BUILD_f0l0(Data,vrr_stack+16732, vrr_stack+63146, vrr_stack+30688, vrr_stack+63011, vrr_stack+30553, vrr_stack+6913);
 _BUILD_g0l0(Data,vrr_stack+63416, vrr_stack+16732, vrr_stack+56846, vrr_stack+63146, vrr_stack+30688, vrr_stack+7129);
 _BUILD_h0l0(Data,vrr_stack+64091, vrr_stack+63416, vrr_stack+57296, vrr_stack+16732, vrr_stack+56846, vrr_stack+33172);
 _BUILD_i0l0(Data,vrr_stack+32353, vrr_stack+64091, vrr_stack+87806, vrr_stack+63416, vrr_stack+57296, vrr_stack+59906);
 _BUILD_k0l0(Data,vrr_stack+57971, vrr_stack+32353, vrr_stack+88751, vrr_stack+64091, vrr_stack+87806, vrr_stack+60662);
 _BUILD_l0l0(Data,vrr_stack+59591, vrr_stack+57971, vrr_stack+90011, vrr_stack+32353, vrr_stack+88751, vrr_stack+61670);
 _BUILD_m0l0(Data,vrr_stack+99011, vrr_stack+59591, vrr_stack+33712, vrr_stack+57971, vrr_stack+90011, vrr_stack+35764);
 _BUILD_00l0(Data,vrr_stack+17182, vrr_stack+107, vrr_stack+20790, vrr_stack+261, vrr_stack+981, NULL);
 _BUILD_p0l0(Data,vrr_stack+17227, vrr_stack+15652, vrr_stack+17182, NULL, NULL, vrr_stack+107);
 _BUILD_d0l0(Data,vrr_stack+65036, vrr_stack+15697, vrr_stack+17227, vrr_stack+15364, vrr_stack+15652, vrr_stack+20620);
 _BUILD_f0l0(Data,vrr_stack+35737, vrr_stack+30958, vrr_stack+65036, vrr_stack+15409, vrr_stack+15697, vrr_stack+2953);
 _BUILD_g0l0(Data,vrr_stack+36187, vrr_stack+31228, vrr_stack+35737, vrr_stack+5995, vrr_stack+30958, vrr_stack+8245);
 _BUILD_h0l0(Data,vrr_stack+61616, vrr_stack+31678, vrr_stack+36187, vrr_stack+6265, vrr_stack+31228, vrr_stack+38392);
 _BUILD_i0l0(Data,vrr_stack+1873, vrr_stack+55843, vrr_stack+61616, vrr_stack+52963, vrr_stack+31678, vrr_stack+38932);
 _BUILD_k0l0(Data,vrr_stack+101486, vrr_stack+91631, vrr_stack+1873, vrr_stack+53638, vrr_stack+55843, vrr_stack+39688);
 _BUILD_l0l0(Data,vrr_stack+38392, vrr_stack+92891, vrr_stack+101486, vrr_stack+54583, vrr_stack+91631, vrr_stack+8605);
 _BUILD_m0l0(Data,vrr_stack+103106, vrr_stack+94511, vrr_stack+38392, vrr_stack+86186, vrr_stack+92891, vrr_stack+70490);
 _BUILD_n0l0(Data,vrr_stack+105581, vrr_stack+96536, vrr_stack+103106, vrr_stack+33712, vrr_stack+94511, vrr_stack+72110);
 _BUILD_n0l0(Data,vrr_stack+70490, vrr_stack+99011, vrr_stack+96536, vrr_stack+59591, vrr_stack+33712, vrr_stack+65594);
 _BUILD_o0l0(Data,vrr_stack+108551, vrr_stack+70490, vrr_stack+105581, vrr_stack+99011, vrr_stack+96536, vrr_stack+40696);
 _BUILD_00l0(Data,vrr_stack+73460, vrr_stack+206, vrr_stack+848, vrr_stack+884, vrr_stack+1163, NULL);
 _BUILD_p0l0(Data,vrr_stack+73505, vrr_stack+73460, vrr_stack+62966, NULL, NULL, vrr_stack+848);
 _BUILD_d0l0(Data,vrr_stack+73640, vrr_stack+73505, vrr_stack+63011, vrr_stack+73460, vrr_stack+62966, vrr_stack+17416);
 _BUILD_f0l0(Data,vrr_stack+40417, vrr_stack+73640, vrr_stack+63146, vrr_stack+73505, vrr_stack+63011, vrr_stack+17524);
 _BUILD_g0l0(Data,vrr_stack+40867, vrr_stack+40417, vrr_stack+16732, vrr_stack+73640, vrr_stack+63146, vrr_stack+17740);
 _BUILD_h0l0(Data,vrr_stack+41542, vrr_stack+40867, vrr_stack+63416, vrr_stack+40417, vrr_stack+16732, vrr_stack+18100);
 _BUILD_i0l0(Data,vrr_stack+8245, vrr_stack+41542, vrr_stack+64091, vrr_stack+40867, vrr_stack+63416, vrr_stack+7489);
 _BUILD_k0l0(Data,vrr_stack+65306, vrr_stack+8245, vrr_stack+32353, vrr_stack+41542, vrr_stack+64091, vrr_stack+37384);
 _BUILD_l0l0(Data,vrr_stack+40417, vrr_stack+65306, vrr_stack+57971, vrr_stack+8245, vrr_stack+32353, vrr_stack+67574);
   tmp = vrr_stack + 40417;
   target_ptr = Libint->vrr_classes[8][8];
   for(i=0;i<2025;i++)
     target_ptr[i] += tmp[i];
 _BUILD_m0l0(Data,vrr_stack+6715, vrr_stack+40417, vrr_stack+59591, vrr_stack+65306, vrr_stack+57971, vrr_stack+68870);
   tmp = vrr_stack + 6715;
   target_ptr = Libint->vrr_classes[9][8];
   for(i=0;i<2475;i++)
     target_ptr[i] += tmp[i];
 _BUILD_n0l0(Data,vrr_stack+65306, vrr_stack+6715, vrr_stack+99011, vrr_stack+40417, vrr_stack+59591, vrr_stack+18640);
   tmp = vrr_stack + 65306;
   target_ptr = Libint->vrr_classes[10][8];
   for(i=0;i<2970;i++)
     target_ptr[i] += tmp[i];
 _BUILD_o0l0(Data,vrr_stack+112061, vrr_stack+65306, vrr_stack+70490, vrr_stack+6715, vrr_stack+99011, vrr_stack+74090);
   tmp = vrr_stack + 112061;
   target_ptr = Libint->vrr_classes[11][8];
   for(i=0;i<3510;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00p0(Data,vrr_stack+6715, Data->F+20, Data->F+21, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+6718, vrr_stack+20728, vrr_stack+6715, Data->F+19, Data->F+20, NULL);
 _BUILD_00f0(Data,vrr_stack+6724, vrr_stack+20731, vrr_stack+6718, vrr_stack+39, vrr_stack+20728, NULL);
 _BUILD_00g0(Data,vrr_stack+6734, vrr_stack+20737, vrr_stack+6724, vrr_stack+42, vrr_stack+20731, NULL);
 _BUILD_00h0(Data,vrr_stack+6749, vrr_stack+20747, vrr_stack+6734, vrr_stack+48, vrr_stack+20737, NULL);
 _BUILD_00i0(Data,vrr_stack+79, vrr_stack+58, vrr_stack+6749, vrr_stack+191, vrr_stack+20747, NULL);
 _BUILD_00k0(Data,vrr_stack+3133, vrr_stack+20762, vrr_stack+79, vrr_stack+960, vrr_stack+58, NULL);
 _BUILD_00l0(Data,vrr_stack+6770, vrr_stack+20790, vrr_stack+3133, vrr_stack+981, vrr_stack+20762, NULL);
 _BUILD_p0l0(Data,vrr_stack+6815, vrr_stack+17182, vrr_stack+6770, NULL, NULL, vrr_stack+20790);
 _BUILD_d0l0(Data,vrr_stack+6950, vrr_stack+17227, vrr_stack+6815, vrr_stack+15652, vrr_stack+17182, vrr_stack+20826);
 _BUILD_f0l0(Data,vrr_stack+7220, vrr_stack+65036, vrr_stack+6950, vrr_stack+15697, vrr_stack+17227, vrr_stack+20934);
 _BUILD_g0l0(Data,vrr_stack+7670, vrr_stack+35737, vrr_stack+7220, vrr_stack+30958, vrr_stack+65036, vrr_stack+21150);
 _BUILD_h0l0(Data,vrr_stack+8345, vrr_stack+36187, vrr_stack+7670, vrr_stack+31228, vrr_stack+35737, vrr_stack+21510);
 _BUILD_i0l0(Data,vrr_stack+40417, vrr_stack+61616, vrr_stack+8345, vrr_stack+31678, vrr_stack+36187, vrr_stack+22050);
 _BUILD_k0l0(Data,vrr_stack+20826, vrr_stack+1873, vrr_stack+40417, vrr_stack+55843, vrr_stack+61616, vrr_stack+22806);
 _BUILD_l0l0(Data,vrr_stack+68276, vrr_stack+101486, vrr_stack+20826, vrr_stack+91631, vrr_stack+1873, vrr_stack+23814);
 _BUILD_m0l0(Data,vrr_stack+22446, vrr_stack+38392, vrr_stack+68276, vrr_stack+92891, vrr_stack+101486, vrr_stack+9901);
 _BUILD_n0l0(Data,vrr_stack+17362, vrr_stack+103106, vrr_stack+22446, vrr_stack+94511, vrr_stack+38392, vrr_stack+45880);
 _BUILD_o0l0(Data,vrr_stack+115571, vrr_stack+105581, vrr_stack+17362, vrr_stack+96536, vrr_stack+103106, vrr_stack+3169);
 _BUILD_q0l0(Data,vrr_stack+119081, vrr_stack+108551, vrr_stack+115571, vrr_stack+70490, vrr_stack+105581, vrr_stack+47860);
 _BUILD_q0l0(Data,vrr_stack+45880, vrr_stack+112061, vrr_stack+108551, vrr_stack+65306, vrr_stack+70490, vrr_stack+43072);
   tmp = vrr_stack + 45880;
   target_ptr = Libint->vrr_classes[12][8];
   for(i=0;i<4095;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00m0(Data,vrr_stack+65306, vrr_stack+76466, vrr_stack+76871, vrr_stack+1318, vrr_stack+1642, NULL);
 _BUILD_00m0(Data,vrr_stack+65361, vrr_stack+76511, vrr_stack+76466, vrr_stack+1354, vrr_stack+1318, NULL);
 _BUILD_p0m0(Data,vrr_stack+65416, vrr_stack+65361, vrr_stack+65306, NULL, NULL, vrr_stack+76466);
 _BUILD_00m0(Data,vrr_stack+65581, vrr_stack+76691, vrr_stack+76511, vrr_stack+1498, vrr_stack+1354, NULL);
 _BUILD_p0m0(Data,vrr_stack+65636, vrr_stack+65581, vrr_stack+65361, NULL, NULL, vrr_stack+76511);
 _BUILD_00m0(Data,vrr_stack+65801, vrr_stack+76871, vrr_stack+15184, vrr_stack+1642, vrr_stack+1837, NULL);
 _BUILD_p0m0(Data,vrr_stack+65856, vrr_stack+65306, vrr_stack+65801, NULL, NULL, vrr_stack+76871);
 _BUILD_d0m0(Data,vrr_stack+66021, vrr_stack+65416, vrr_stack+65856, vrr_stack+65361, vrr_stack+65306, vrr_stack+76916);
 _BUILD_d0m0(Data,vrr_stack+66351, vrr_stack+65636, vrr_stack+65416, vrr_stack+65581, vrr_stack+65361, vrr_stack+76556);
 _BUILD_f0m0(Data,vrr_stack+66681, vrr_stack+66351, vrr_stack+66021, vrr_stack+65636, vrr_stack+65416, vrr_stack+77051);
 _BUILD_00m0(Data,vrr_stack+76556, vrr_stack+1390, vrr_stack+76691, vrr_stack+1801, vrr_stack+1498, NULL);
 _BUILD_p0m0(Data,vrr_stack+76916, vrr_stack+76556, vrr_stack+65581, NULL, NULL, vrr_stack+76691);
 _BUILD_d0m0(Data,vrr_stack+67231, vrr_stack+76916, vrr_stack+65636, vrr_stack+76556, vrr_stack+65581, vrr_stack+76736);
 _BUILD_f0m0(Data,vrr_stack+67561, vrr_stack+67231, vrr_stack+66351, vrr_stack+76916, vrr_stack+65636, vrr_stack+77321);
 _BUILD_00m0(Data,vrr_stack+76736, vrr_stack+15184, vrr_stack+15364, vrr_stack+1837, vrr_stack+15976, NULL);
 _BUILD_p0m0(Data,vrr_stack+68111, vrr_stack+65801, vrr_stack+76736, NULL, NULL, vrr_stack+15184);
 _BUILD_d0m0(Data,vrr_stack+77081, vrr_stack+65856, vrr_stack+68111, vrr_stack+65306, vrr_stack+65801, vrr_stack+15229);
 _BUILD_f0m0(Data,vrr_stack+3169, vrr_stack+66021, vrr_stack+77081, vrr_stack+65416, vrr_stack+65856, vrr_stack+28386);
 _BUILD_g0m0(Data,vrr_stack+123176, vrr_stack+66681, vrr_stack+3169, vrr_stack+66351, vrr_stack+66021, vrr_stack+5545);
 _BUILD_g0m0(Data,vrr_stack+3719, vrr_stack+67561, vrr_stack+66681, vrr_stack+67231, vrr_stack+66351, vrr_stack+77591);
 _BUILD_h0m0(Data,vrr_stack+4544, vrr_stack+3719, vrr_stack+123176, vrr_stack+67561, vrr_stack+66681, vrr_stack+11521);
 _BUILD_00m0(Data,vrr_stack+28386, vrr_stack+29608, vrr_stack+1390, vrr_stack+15616, vrr_stack+1801, NULL);
 _BUILD_p0m0(Data,vrr_stack+28441, vrr_stack+28386, vrr_stack+76556, NULL, NULL, vrr_stack+1390);
 _BUILD_d0m0(Data,vrr_stack+77411, vrr_stack+28441, vrr_stack+76916, vrr_stack+28386, vrr_stack+76556, vrr_stack+289);
 _BUILD_f0m0(Data,vrr_stack+49975, vrr_stack+77411, vrr_stack+67231, vrr_stack+28441, vrr_stack+76916, vrr_stack+78041);
 _BUILD_g0m0(Data,vrr_stack+9290, vrr_stack+49975, vrr_stack+67561, vrr_stack+77411, vrr_stack+67231, vrr_stack+78311);
 _BUILD_h0m0(Data,vrr_stack+10115, vrr_stack+9290, vrr_stack+3719, vrr_stack+49975, vrr_stack+67561, vrr_stack+50668);
 _BUILD_00m0(Data,vrr_stack+15229, vrr_stack+15364, vrr_stack+15652, vrr_stack+15976, vrr_stack+660, NULL);
 _BUILD_p0m0(Data,vrr_stack+77741, vrr_stack+76736, vrr_stack+15229, NULL, NULL, vrr_stack+15364);
 _BUILD_d0m0(Data,vrr_stack+77906, vrr_stack+68111, vrr_stack+77741, vrr_stack+65801, vrr_stack+76736, vrr_stack+15409);
 _BUILD_f0m0(Data,vrr_stack+78236, vrr_stack+77081, vrr_stack+77906, vrr_stack+65856, vrr_stack+68111, vrr_stack+5995);
 _BUILD_g0m0(Data,vrr_stack+11270, vrr_stack+3169, vrr_stack+78236, vrr_stack+66021, vrr_stack+77081, vrr_stack+6265);
 _BUILD_h0m0(Data,vrr_stack+41677, vrr_stack+123176, vrr_stack+11270, vrr_stack+66681, vrr_stack+3169, vrr_stack+52963);
 _BUILD_i0m0(Data,vrr_stack+73505, vrr_stack+4544, vrr_stack+41677, vrr_stack+3719, vrr_stack+123176, vrr_stack+53638);
 _BUILD_i0m0(Data,vrr_stack+52963, vrr_stack+10115, vrr_stack+4544, vrr_stack+9290, vrr_stack+3719, vrr_stack+51343);
 _BUILD_k0m0(Data,vrr_stack+124001, vrr_stack+52963, vrr_stack+73505, vrr_stack+10115, vrr_stack+4544, vrr_stack+54583);
 _BUILD_00m0(Data,vrr_stack+54503, vrr_stack+30508, vrr_stack+29608, vrr_stack+16696, vrr_stack+15616, NULL);
 _BUILD_p0m0(Data,vrr_stack+54558, vrr_stack+54503, vrr_stack+28386, NULL, NULL, vrr_stack+29608);
 _BUILD_d0m0(Data,vrr_stack+54723, vrr_stack+54558, vrr_stack+28441, vrr_stack+54503, vrr_stack+28386, vrr_stack+29653);
 _BUILD_f0m0(Data,vrr_stack+55053, vrr_stack+54723, vrr_stack+77411, vrr_stack+54558, vrr_stack+28441, vrr_stack+29788);
 _BUILD_g0m0(Data,vrr_stack+5699, vrr_stack+55053, vrr_stack+49975, vrr_stack+54723, vrr_stack+77411, vrr_stack+30058);
 _BUILD_h0m0(Data,vrr_stack+50525, vrr_stack+5699, vrr_stack+9290, vrr_stack+55053, vrr_stack+49975, vrr_stack+52288);
 _BUILD_i0m0(Data,vrr_stack+125981, vrr_stack+50525, vrr_stack+10115, vrr_stack+5699, vrr_stack+9290, vrr_stack+28656);
 _BUILD_k0m0(Data,vrr_stack+127521, vrr_stack+125981, vrr_stack+52963, vrr_stack+50525, vrr_stack+10115, vrr_stack+84926);
 _BUILD_00m0(Data,vrr_stack+84926, vrr_stack+15652, vrr_stack+17182, vrr_stack+660, vrr_stack+107, NULL);
 _BUILD_p0m0(Data,vrr_stack+84981, vrr_stack+15229, vrr_stack+84926, NULL, NULL, vrr_stack+15652);
 _BUILD_d0m0(Data,vrr_stack+85146, vrr_stack+77741, vrr_stack+84981, vrr_stack+76736, vrr_stack+15229, vrr_stack+15697);
 _BUILD_f0m0(Data,vrr_stack+15697, vrr_stack+77906, vrr_stack+85146, vrr_stack+68111, vrr_stack+77741, vrr_stack+30958);
 _BUILD_g0m0(Data,vrr_stack+29653, vrr_stack+78236, vrr_stack+15697, vrr_stack+77081, vrr_stack+77906, vrr_stack+31228);
 _BUILD_h0m0(Data,vrr_stack+51680, vrr_stack+11270, vrr_stack+29653, vrr_stack+3169, vrr_stack+78236, vrr_stack+31678);
 _BUILD_i0m0(Data,vrr_stack+129501, vrr_stack+41677, vrr_stack+51680, vrr_stack+123176, vrr_stack+11270, vrr_stack+55843);
 _BUILD_k0m0(Data,vrr_stack+131041, vrr_stack+73505, vrr_stack+129501, vrr_stack+4544, vrr_stack+41677, vrr_stack+91631);
 _BUILD_l0m0(Data,vrr_stack+133021, vrr_stack+124001, vrr_stack+131041, vrr_stack+52963, vrr_stack+73505, vrr_stack+92891);
 _BUILD_l0m0(Data,vrr_stack+91631, vrr_stack+127521, vrr_stack+124001, vrr_stack+125981, vrr_stack+52963, vrr_stack+86186);
 _BUILD_m0m0(Data,vrr_stack+135496, vrr_stack+91631, vrr_stack+133021, vrr_stack+127521, vrr_stack+124001, vrr_stack+94511);
 _BUILD_00m0(Data,vrr_stack+94106, vrr_stack+62966, vrr_stack+30508, vrr_stack+848, vrr_stack+16696, NULL);
 _BUILD_p0m0(Data,vrr_stack+94161, vrr_stack+94106, vrr_stack+54503, NULL, NULL, vrr_stack+30508);
 _BUILD_d0m0(Data,vrr_stack+94326, vrr_stack+94161, vrr_stack+54558, vrr_stack+94106, vrr_stack+54503, vrr_stack+30553);
 _BUILD_f0m0(Data,vrr_stack+94656, vrr_stack+94326, vrr_stack+54723, vrr_stack+94161, vrr_stack+54558, vrr_stack+30688);
 _BUILD_g0m0(Data,vrr_stack+30553, vrr_stack+94656, vrr_stack+55053, vrr_stack+94326, vrr_stack+54723, vrr_stack+56846);
 _BUILD_h0m0(Data,vrr_stack+95206, vrr_stack+30553, vrr_stack+5699, vrr_stack+94656, vrr_stack+55053, vrr_stack+57296);
 _BUILD_i0m0(Data,vrr_stack+85476, vrr_stack+95206, vrr_stack+50525, vrr_stack+30553, vrr_stack+5699, vrr_stack+87806);
 _BUILD_k0m0(Data,vrr_stack+55603, vrr_stack+85476, vrr_stack+125981, vrr_stack+95206, vrr_stack+50525, vrr_stack+88751);
 _BUILD_l0m0(Data,vrr_stack+87016, vrr_stack+55603, vrr_stack+127521, vrr_stack+85476, vrr_stack+125981, vrr_stack+90011);
 _BUILD_m0m0(Data,vrr_stack+138521, vrr_stack+87016, vrr_stack+91631, vrr_stack+55603, vrr_stack+127521, vrr_stack+33712);
 _BUILD_00m0(Data,vrr_stack+31378, vrr_stack+17182, vrr_stack+6770, vrr_stack+107, vrr_stack+20790, NULL);
 _BUILD_p0m0(Data,vrr_stack+31433, vrr_stack+84926, vrr_stack+31378, NULL, NULL, vrr_stack+17182);
 _BUILD_d0m0(Data,vrr_stack+31598, vrr_stack+84981, vrr_stack+31433, vrr_stack+15229, vrr_stack+84926, vrr_stack+17227);
 _BUILD_f0m0(Data,vrr_stack+89491, vrr_stack+85146, vrr_stack+31598, vrr_stack+77741, vrr_stack+84981, vrr_stack+65036);
 _BUILD_g0m0(Data,vrr_stack+90041, vrr_stack+15697, vrr_stack+89491, vrr_stack+77906, vrr_stack+85146, vrr_stack+35737);
 _BUILD_h0m0(Data,vrr_stack+75045, vrr_stack+29653, vrr_stack+90041, vrr_stack+78236, vrr_stack+15697, vrr_stack+36187);
 _BUILD_i0m0(Data,vrr_stack+33613, vrr_stack+51680, vrr_stack+75045, vrr_stack+11270, vrr_stack+29653, vrr_stack+61616);
 _BUILD_k0m0(Data,vrr_stack+35153, vrr_stack+129501, vrr_stack+33613, vrr_stack+41677, vrr_stack+51680, vrr_stack+1873);
 _BUILD_l0m0(Data,vrr_stack+141546, vrr_stack+131041, vrr_stack+35153, vrr_stack+73505, vrr_stack+129501, vrr_stack+101486);
 _BUILD_m0m0(Data,vrr_stack+144021, vrr_stack+133021, vrr_stack+141546, vrr_stack+124001, vrr_stack+131041, vrr_stack+38392);
 _BUILD_n0m0(Data,vrr_stack+147046, vrr_stack+135496, vrr_stack+144021, vrr_stack+91631, vrr_stack+133021, vrr_stack+103106);
 _BUILD_n0m0(Data,vrr_stack+101486, vrr_stack+138521, vrr_stack+135496, vrr_stack+87016, vrr_stack+91631, vrr_stack+96536);
 _BUILD_o0m0(Data,vrr_stack+150676, vrr_stack+101486, vrr_stack+147046, vrr_stack+138521, vrr_stack+135496, vrr_stack+105581);
 _BUILD_00m0(Data,vrr_stack+105116, vrr_stack+73460, vrr_stack+62966, vrr_stack+206, vrr_stack+848, NULL);
 _BUILD_p0m0(Data,vrr_stack+105171, vrr_stack+105116, vrr_stack+94106, NULL, NULL, vrr_stack+62966);
 _BUILD_d0m0(Data,vrr_stack+105336, vrr_stack+105171, vrr_stack+94161, vrr_stack+105116, vrr_stack+94106, vrr_stack+63011);
 _BUILD_f0m0(Data,vrr_stack+105666, vrr_stack+105336, vrr_stack+94326, vrr_stack+105171, vrr_stack+94161, vrr_stack+63146);
 _BUILD_g0m0(Data,vrr_stack+106216, vrr_stack+105666, vrr_stack+94656, vrr_stack+105336, vrr_stack+94326, vrr_stack+16732);
 _BUILD_h0m0(Data,vrr_stack+107041, vrr_stack+106216, vrr_stack+30553, vrr_stack+105666, vrr_stack+94656, vrr_stack+63416);
 _BUILD_i0m0(Data,vrr_stack+96361, vrr_stack+107041, vrr_stack+95206, vrr_stack+106216, vrr_stack+30553, vrr_stack+64091);
 _BUILD_k0m0(Data,vrr_stack+63011, vrr_stack+96361, vrr_stack+85476, vrr_stack+107041, vrr_stack+95206, vrr_stack+32353);
 _BUILD_l0m0(Data,vrr_stack+105171, vrr_stack+63011, vrr_stack+55603, vrr_stack+96361, vrr_stack+85476, vrr_stack+57971);
   tmp = vrr_stack + 105171;
   target_ptr = Libint->vrr_classes[8][9];
   for(i=0;i<2475;i++)
     target_ptr[i] += tmp[i];
 _BUILD_m0m0(Data,vrr_stack+37133, vrr_stack+105171, vrr_stack+87016, vrr_stack+63011, vrr_stack+55603, vrr_stack+59591);
   tmp = vrr_stack + 37133;
   target_ptr = Libint->vrr_classes[9][9];
   for(i=0;i<3025;i++)
     target_ptr[i] += tmp[i];
 _BUILD_n0m0(Data,vrr_stack+57583, vrr_stack+37133, vrr_stack+138521, vrr_stack+105171, vrr_stack+87016, vrr_stack+99011);
   tmp = vrr_stack + 57583;
   target_ptr = Libint->vrr_classes[10][9];
   for(i=0;i<3630;i++)
     target_ptr[i] += tmp[i];
 _BUILD_o0m0(Data,vrr_stack+96361, vrr_stack+57583, vrr_stack+101486, vrr_stack+37133, vrr_stack+138521, vrr_stack+70490);
   tmp = vrr_stack + 96361;
   target_ptr = Libint->vrr_classes[11][9];
   for(i=0;i<4290;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00p0(Data,vrr_stack+37133, Data->F+21, Data->F+22, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+37136, vrr_stack+6715, vrr_stack+37133, Data->F+20, Data->F+21, NULL);
 _BUILD_00f0(Data,vrr_stack+37142, vrr_stack+6718, vrr_stack+37136, vrr_stack+20728, vrr_stack+6715, NULL);
 _BUILD_00g0(Data,vrr_stack+37152, vrr_stack+6724, vrr_stack+37142, vrr_stack+20731, vrr_stack+6718, NULL);
 _BUILD_00h0(Data,vrr_stack+37167, vrr_stack+6734, vrr_stack+37152, vrr_stack+20737, vrr_stack+6724, NULL);
 _BUILD_00i0(Data,vrr_stack+37188, vrr_stack+6749, vrr_stack+37167, vrr_stack+20747, vrr_stack+6734, NULL);
 _BUILD_00k0(Data,vrr_stack+37216, vrr_stack+79, vrr_stack+37188, vrr_stack+58, vrr_stack+6749, NULL);
 _BUILD_00l0(Data,vrr_stack+37252, vrr_stack+3133, vrr_stack+37216, vrr_stack+20762, vrr_stack+79, NULL);
 _BUILD_00m0(Data,vrr_stack+37297, vrr_stack+6770, vrr_stack+37252, vrr_stack+20790, vrr_stack+3133, NULL);
 _BUILD_p0m0(Data,vrr_stack+37352, vrr_stack+31378, vrr_stack+37297, NULL, NULL, vrr_stack+6770);
 _BUILD_d0m0(Data,vrr_stack+37517, vrr_stack+31433, vrr_stack+37352, vrr_stack+84926, vrr_stack+31378, vrr_stack+6815);
 _BUILD_f0m0(Data,vrr_stack+37847, vrr_stack+31598, vrr_stack+37517, vrr_stack+84981, vrr_stack+31433, vrr_stack+6950);
 _BUILD_g0m0(Data,vrr_stack+38397, vrr_stack+89491, vrr_stack+37847, vrr_stack+85146, vrr_stack+31598, vrr_stack+7220);
 _BUILD_h0m0(Data,vrr_stack+39222, vrr_stack+90041, vrr_stack+38397, vrr_stack+15697, vrr_stack+89491, vrr_stack+7670);
 _BUILD_i0m0(Data,vrr_stack+105171, vrr_stack+75045, vrr_stack+39222, vrr_stack+29653, vrr_stack+90041, vrr_stack+8345);
 _BUILD_k0m0(Data,vrr_stack+6815, vrr_stack+33613, vrr_stack+105171, vrr_stack+51680, vrr_stack+75045, vrr_stack+40417);
 _BUILD_l0m0(Data,vrr_stack+70301, vrr_stack+35153, vrr_stack+6815, vrr_stack+129501, vrr_stack+33613, vrr_stack+20826);
 _BUILD_m0m0(Data,vrr_stack+154966, vrr_stack+141546, vrr_stack+70301, vrr_stack+131041, vrr_stack+35153, vrr_stack+68276);
 _BUILD_n0m0(Data,vrr_stack+157991, vrr_stack+144021, vrr_stack+154966, vrr_stack+133021, vrr_stack+141546, vrr_stack+22446);
 _BUILD_o0m0(Data,vrr_stack+20332, vrr_stack+147046, vrr_stack+157991, vrr_stack+135496, vrr_stack+144021, vrr_stack+17362);
 _BUILD_q0m0(Data,vrr_stack+161621, vrr_stack+150676, vrr_stack+20332, vrr_stack+101486, vrr_stack+147046, vrr_stack+115571);
 _BUILD_q0m0(Data,vrr_stack+166626, vrr_stack+96361, vrr_stack+150676, vrr_stack+57583, vrr_stack+101486, vrr_stack+108551);
   tmp = vrr_stack + 166626;
   target_ptr = Libint->vrr_classes[12][9];
   for(i=0;i<5005;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00n0(Data,vrr_stack+57583, vrr_stack+65306, vrr_stack+65801, vrr_stack+76466, vrr_stack+76871, NULL);
 _BUILD_00n0(Data,vrr_stack+57649, vrr_stack+65361, vrr_stack+65306, vrr_stack+76511, vrr_stack+76466, NULL);
 _BUILD_p0n0(Data,vrr_stack+57715, vrr_stack+57649, vrr_stack+57583, NULL, NULL, vrr_stack+65306);
 _BUILD_00n0(Data,vrr_stack+57913, vrr_stack+65581, vrr_stack+65361, vrr_stack+76691, vrr_stack+76511, NULL);
 _BUILD_p0n0(Data,vrr_stack+57979, vrr_stack+57913, vrr_stack+57649, NULL, NULL, vrr_stack+65361);
 _BUILD_00n0(Data,vrr_stack+58177, vrr_stack+65801, vrr_stack+76736, vrr_stack+76871, vrr_stack+15184, NULL);
 _BUILD_p0n0(Data,vrr_stack+58243, vrr_stack+57583, vrr_stack+58177, NULL, NULL, vrr_stack+65801);
 _BUILD_d0n0(Data,vrr_stack+58441, vrr_stack+57715, vrr_stack+58243, vrr_stack+57649, vrr_stack+57583, vrr_stack+65856);
 _BUILD_d0n0(Data,vrr_stack+58837, vrr_stack+57979, vrr_stack+57715, vrr_stack+57913, vrr_stack+57649, vrr_stack+65416);
 _BUILD_f0n0(Data,vrr_stack+59233, vrr_stack+58837, vrr_stack+58441, vrr_stack+57979, vrr_stack+57715, vrr_stack+66021);
 _BUILD_00n0(Data,vrr_stack+65416, vrr_stack+76556, vrr_stack+65581, vrr_stack+1390, vrr_stack+76691, NULL);
 _BUILD_p0n0(Data,vrr_stack+65856, vrr_stack+65416, vrr_stack+57913, NULL, NULL, vrr_stack+65581);
 _BUILD_d0n0(Data,vrr_stack+59893, vrr_stack+65856, vrr_stack+57979, vrr_stack+65416, vrr_stack+57913, vrr_stack+65636);
 _BUILD_f0n0(Data,vrr_stack+60289, vrr_stack+59893, vrr_stack+58837, vrr_stack+65856, vrr_stack+57979, vrr_stack+66351);
 _BUILD_00n0(Data,vrr_stack+65636, vrr_stack+76736, vrr_stack+15229, vrr_stack+15184, vrr_stack+15364, NULL);
 _BUILD_p0n0(Data,vrr_stack+66054, vrr_stack+58177, vrr_stack+65636, NULL, NULL, vrr_stack+76736);
 _BUILD_d0n0(Data,vrr_stack+66252, vrr_stack+58243, vrr_stack+66054, vrr_stack+57583, vrr_stack+58177, vrr_stack+68111);
 _BUILD_f0n0(Data,vrr_stack+68111, vrr_stack+58441, vrr_stack+66252, vrr_stack+57715, vrr_stack+58243, vrr_stack+77081);
 _BUILD_g0n0(Data,vrr_stack+68771, vrr_stack+59233, vrr_stack+68111, vrr_stack+58837, vrr_stack+58441, vrr_stack+3169);
 _BUILD_g0n0(Data,vrr_stack+60949, vrr_stack+60289, vrr_stack+59233, vrr_stack+59893, vrr_stack+58837, vrr_stack+66681);
 _BUILD_h0n0(Data,vrr_stack+115571, vrr_stack+60949, vrr_stack+68771, vrr_stack+60289, vrr_stack+59233, vrr_stack+123176);
 _BUILD_00n0(Data,vrr_stack+123176, vrr_stack+28386, vrr_stack+76556, vrr_stack+29608, vrr_stack+1390, NULL);
 _BUILD_p0n0(Data,vrr_stack+123242, vrr_stack+123176, vrr_stack+65416, NULL, NULL, vrr_stack+76556);
 _BUILD_d0n0(Data,vrr_stack+123440, vrr_stack+123242, vrr_stack+65856, vrr_stack+123176, vrr_stack+65416, vrr_stack+76916);
 _BUILD_f0n0(Data,vrr_stack+61939, vrr_stack+123440, vrr_stack+59893, vrr_stack+123242, vrr_stack+65856, vrr_stack+67231);
 _BUILD_g0n0(Data,vrr_stack+116957, vrr_stack+61939, vrr_stack+60289, vrr_stack+123440, vrr_stack+59893, vrr_stack+67561);
 _BUILD_h0n0(Data,vrr_stack+66648, vrr_stack+116957, vrr_stack+60949, vrr_stack+61939, vrr_stack+60289, vrr_stack+3719);
 _BUILD_00n0(Data,vrr_stack+123836, vrr_stack+15229, vrr_stack+84926, vrr_stack+15364, vrr_stack+15652, NULL);
 _BUILD_p0n0(Data,vrr_stack+3169, vrr_stack+65636, vrr_stack+123836, NULL, NULL, vrr_stack+15229);
 _BUILD_d0n0(Data,vrr_stack+3367, vrr_stack+66054, vrr_stack+3169, vrr_stack+58177, vrr_stack+65636, vrr_stack+77741);
 _BUILD_f0n0(Data,vrr_stack+3763, vrr_stack+66252, vrr_stack+3367, vrr_stack+58243, vrr_stack+66054, vrr_stack+77906);
 _BUILD_g0n0(Data,vrr_stack+117947, vrr_stack+68111, vrr_stack+3763, vrr_stack+58441, vrr_stack+66252, vrr_stack+78236);
 _BUILD_h0n0(Data,vrr_stack+106711, vrr_stack+68771, vrr_stack+117947, vrr_stack+59233, vrr_stack+68111, vrr_stack+11270);
 _BUILD_i0n0(Data,vrr_stack+63011, vrr_stack+115571, vrr_stack+106711, vrr_stack+60949, vrr_stack+68771, vrr_stack+41677);
 _BUILD_i0n0(Data,vrr_stack+40377, vrr_stack+66648, vrr_stack+115571, vrr_stack+116957, vrr_stack+60949, vrr_stack+4544);
 _BUILD_k0n0(Data,vrr_stack+17227, vrr_stack+40377, vrr_stack+63011, vrr_stack+66648, vrr_stack+115571, vrr_stack+73505);
 _BUILD_00n0(Data,vrr_stack+73505, vrr_stack+54503, vrr_stack+28386, vrr_stack+30508, vrr_stack+29608, NULL);
 _BUILD_p0n0(Data,vrr_stack+73571, vrr_stack+73505, vrr_stack+123176, NULL, NULL, vrr_stack+28386);
 _BUILD_d0n0(Data,vrr_stack+73769, vrr_stack+73571, vrr_stack+123242, vrr_stack+73505, vrr_stack+123176, vrr_stack+28441);
 _BUILD_f0n0(Data,vrr_stack+28441, vrr_stack+73769, vrr_stack+123440, vrr_stack+73571, vrr_stack+123242, vrr_stack+77411);
 _BUILD_g0n0(Data,vrr_stack+11270, vrr_stack+28441, vrr_stack+61939, vrr_stack+73769, vrr_stack+123440, vrr_stack+49975);
 _BUILD_h0n0(Data,vrr_stack+107, vrr_stack+11270, vrr_stack+116957, vrr_stack+28441, vrr_stack+61939, vrr_stack+9290);
 _BUILD_i0n0(Data,vrr_stack+76791, vrr_stack+107, vrr_stack+66648, vrr_stack+11270, vrr_stack+116957, vrr_stack+10115);
 _BUILD_k0n0(Data,vrr_stack+8795, vrr_stack+76791, vrr_stack+40377, vrr_stack+107, vrr_stack+66648, vrr_stack+52963);
 _BUILD_00n0(Data,vrr_stack+49975, vrr_stack+84926, vrr_stack+31378, vrr_stack+15652, vrr_stack+17182, NULL);
 _BUILD_p0n0(Data,vrr_stack+50041, vrr_stack+123836, vrr_stack+49975, NULL, NULL, vrr_stack+84926);
 _BUILD_d0n0(Data,vrr_stack+29101, vrr_stack+3169, vrr_stack+50041, vrr_stack+65636, vrr_stack+123836, vrr_stack+84981);
 _BUILD_f0n0(Data,vrr_stack+74165, vrr_stack+3367, vrr_stack+29101, vrr_stack+66054, vrr_stack+3169, vrr_stack+85146);
 _BUILD_g0n0(Data,vrr_stack+4423, vrr_stack+3763, vrr_stack+74165, vrr_stack+66252, vrr_stack+3367, vrr_stack+15697);
 _BUILD_h0n0(Data,vrr_stack+1493, vrr_stack+117947, vrr_stack+4423, vrr_stack+68111, vrr_stack+3763, vrr_stack+29653);
 _BUILD_i0n0(Data,vrr_stack+15284, vrr_stack+106711, vrr_stack+1493, vrr_stack+68771, vrr_stack+117947, vrr_stack+51680);
 _BUILD_k0n0(Data,vrr_stack+51680, vrr_stack+63011, vrr_stack+15284, vrr_stack+115571, vrr_stack+106711, vrr_stack+129501);
 _BUILD_l0n0(Data,vrr_stack+171631, vrr_stack+17227, vrr_stack+51680, vrr_stack+40377, vrr_stack+63011, vrr_stack+131041);
 _BUILD_l0n0(Data,vrr_stack+129501, vrr_stack+8795, vrr_stack+17227, vrr_stack+76791, vrr_stack+40377, vrr_stack+124001);
 _BUILD_m0n0(Data,vrr_stack+174601, vrr_stack+129501, vrr_stack+171631, vrr_stack+8795, vrr_stack+17227, vrr_stack+133021);
 _BUILD_00n0(Data,vrr_stack+132471, vrr_stack+94106, vrr_stack+54503, vrr_stack+62966, vrr_stack+30508, NULL);
 _BUILD_p0n0(Data,vrr_stack+132537, vrr_stack+132471, vrr_stack+73505, NULL, NULL, vrr_stack+54503);
 _BUILD_d0n0(Data,vrr_stack+132735, vrr_stack+132537, vrr_stack+73571, vrr_stack+132471, vrr_stack+73505, vrr_stack+54558);
 _BUILD_f0n0(Data,vrr_stack+133131, vrr_stack+132735, vrr_stack+73769, vrr_stack+132537, vrr_stack+73571, vrr_stack+54723);
 _BUILD_g0n0(Data,vrr_stack+133791, vrr_stack+133131, vrr_stack+28441, vrr_stack+132735, vrr_stack+73769, vrr_stack+55053);
 _BUILD_h0n0(Data,vrr_stack+123902, vrr_stack+133791, vrr_stack+11270, vrr_stack+133131, vrr_stack+28441, vrr_stack+5699);
 _BUILD_i0n0(Data,vrr_stack+178231, vrr_stack+123902, vrr_stack+107, vrr_stack+133791, vrr_stack+11270, vrr_stack+50525);
 _BUILD_k0n0(Data,vrr_stack+180079, vrr_stack+178231, vrr_stack+76791, vrr_stack+123902, vrr_stack+107, vrr_stack+125981);
 _BUILD_l0n0(Data,vrr_stack+182455, vrr_stack+180079, vrr_stack+8795, vrr_stack+178231, vrr_stack+76791, vrr_stack+127521);
 _BUILD_m0n0(Data,vrr_stack+125288, vrr_stack+182455, vrr_stack+129501, vrr_stack+180079, vrr_stack+8795, vrr_stack+91631);
 _BUILD_00n0(Data,vrr_stack+54558, vrr_stack+31378, vrr_stack+37297, vrr_stack+17182, vrr_stack+6770, NULL);
 _BUILD_p0n0(Data,vrr_stack+54624, vrr_stack+49975, vrr_stack+54558, NULL, NULL, vrr_stack+31378);
 _BUILD_d0n0(Data,vrr_stack+54822, vrr_stack+50041, vrr_stack+54624, vrr_stack+123836, vrr_stack+49975, vrr_stack+31433);
 _BUILD_f0n0(Data,vrr_stack+134781, vrr_stack+29101, vrr_stack+54822, vrr_stack+3169, vrr_stack+50041, vrr_stack+31598);
 _BUILD_g0n0(Data,vrr_stack+31433, vrr_stack+74165, vrr_stack+134781, vrr_stack+3367, vrr_stack+29101, vrr_stack+89491);
 _BUILD_h0n0(Data,vrr_stack+50239, vrr_stack+4423, vrr_stack+31433, vrr_stack+3763, vrr_stack+74165, vrr_stack+90041);
 _BUILD_i0n0(Data,vrr_stack+89491, vrr_stack+1493, vrr_stack+50239, vrr_stack+117947, vrr_stack+4423, vrr_stack+75045);
 _BUILD_k0n0(Data,vrr_stack+91339, vrr_stack+15284, vrr_stack+89491, vrr_stack+106711, vrr_stack+1493, vrr_stack+33613);
 _BUILD_l0n0(Data,vrr_stack+185425, vrr_stack+51680, vrr_stack+91339, vrr_stack+63011, vrr_stack+15284, vrr_stack+35153);
 _BUILD_m0n0(Data,vrr_stack+32423, vrr_stack+171631, vrr_stack+185425, vrr_stack+17227, vrr_stack+51680, vrr_stack+141546);
 _BUILD_n0n0(Data,vrr_stack+188395, vrr_stack+174601, vrr_stack+32423, vrr_stack+129501, vrr_stack+171631, vrr_stack+144021);
 _BUILD_n0n0(Data,vrr_stack+141546, vrr_stack+125288, vrr_stack+174601, vrr_stack+182455, vrr_stack+129501, vrr_stack+135496);
 _BUILD_o0n0(Data,vrr_stack+192751, vrr_stack+141546, vrr_stack+188395, vrr_stack+125288, vrr_stack+174601, vrr_stack+147046);
 _BUILD_00n0(Data,vrr_stack+145902, vrr_stack+105116, vrr_stack+94106, vrr_stack+73460, vrr_stack+62966, NULL);
 _BUILD_p0n0(Data,vrr_stack+145968, vrr_stack+145902, vrr_stack+132471, NULL, NULL, vrr_stack+94106);
 _BUILD_d0n0(Data,vrr_stack+146166, vrr_stack+145968, vrr_stack+132537, vrr_stack+145902, vrr_stack+132471, vrr_stack+94161);
 _BUILD_f0n0(Data,vrr_stack+146562, vrr_stack+146166, vrr_stack+132735, vrr_stack+145968, vrr_stack+132537, vrr_stack+94326);
 _BUILD_g0n0(Data,vrr_stack+147222, vrr_stack+146562, vrr_stack+133131, vrr_stack+146166, vrr_stack+132735, vrr_stack+94656);
 _BUILD_h0n0(Data,vrr_stack+148212, vrr_stack+147222, vrr_stack+133791, vrr_stack+146562, vrr_stack+133131, vrr_stack+30553);
 _BUILD_i0n0(Data,vrr_stack+135441, vrr_stack+148212, vrr_stack+123902, vrr_stack+147222, vrr_stack+133791, vrr_stack+95206);
 _BUILD_k0n0(Data,vrr_stack+197899, vrr_stack+135441, vrr_stack+178231, vrr_stack+148212, vrr_stack+123902, vrr_stack+85476);
 _BUILD_l0n0(Data,vrr_stack+145968, vrr_stack+197899, vrr_stack+180079, vrr_stack+135441, vrr_stack+178231, vrr_stack+55603);
   tmp = vrr_stack + 145968;
   target_ptr = Libint->vrr_classes[8][10];
   for(i=0;i<2970;i++)
     target_ptr[i] += tmp[i];
 _BUILD_m0n0(Data,vrr_stack+200275, vrr_stack+145968, vrr_stack+182455, vrr_stack+197899, vrr_stack+180079, vrr_stack+87016);
   tmp = vrr_stack + 200275;
   target_ptr = Libint->vrr_classes[9][10];
   for(i=0;i<3630;i++)
     target_ptr[i] += tmp[i];
 _BUILD_n0n0(Data,vrr_stack+84981, vrr_stack+200275, vrr_stack+125288, vrr_stack+145968, vrr_stack+182455, vrr_stack+138521);
   tmp = vrr_stack + 84981;
   target_ptr = Libint->vrr_classes[10][10];
   for(i=0;i<4356;i++)
     target_ptr[i] += tmp[i];
 _BUILD_o0n0(Data,vrr_stack+135441, vrr_stack+84981, vrr_stack+141546, vrr_stack+200275, vrr_stack+125288, vrr_stack+101486);
   tmp = vrr_stack + 135441;
   target_ptr = Libint->vrr_classes[11][10];
   for(i=0;i<5148;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00p0(Data,vrr_stack+145968, Data->F+22, Data->F+23, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+145971, vrr_stack+37133, vrr_stack+145968, Data->F+21, Data->F+22, NULL);
 _BUILD_00f0(Data,vrr_stack+145977, vrr_stack+37136, vrr_stack+145971, vrr_stack+6715, vrr_stack+37133, NULL);
 _BUILD_00g0(Data,vrr_stack+145987, vrr_stack+37142, vrr_stack+145977, vrr_stack+6718, vrr_stack+37136, NULL);
 _BUILD_00h0(Data,vrr_stack+146002, vrr_stack+37152, vrr_stack+145987, vrr_stack+6724, vrr_stack+37142, NULL);
 _BUILD_00i0(Data,vrr_stack+146023, vrr_stack+37167, vrr_stack+146002, vrr_stack+6734, vrr_stack+37152, NULL);
 _BUILD_00k0(Data,vrr_stack+146051, vrr_stack+37188, vrr_stack+146023, vrr_stack+6749, vrr_stack+37167, NULL);
 _BUILD_00l0(Data,vrr_stack+15184, vrr_stack+37216, vrr_stack+146051, vrr_stack+79, vrr_stack+37188, NULL);
 _BUILD_00m0(Data,vrr_stack+51625, vrr_stack+37252, vrr_stack+15184, vrr_stack+3133, vrr_stack+37216, NULL);
 _BUILD_00n0(Data,vrr_stack+146087, vrr_stack+37297, vrr_stack+51625, vrr_stack+6770, vrr_stack+37252, NULL);
 _BUILD_p0n0(Data,vrr_stack+146153, vrr_stack+54558, vrr_stack+146087, NULL, NULL, vrr_stack+37297);
 _BUILD_d0n0(Data,vrr_stack+146351, vrr_stack+54624, vrr_stack+146153, vrr_stack+49975, vrr_stack+54558, vrr_stack+37352);
 _BUILD_f0n0(Data,vrr_stack+146747, vrr_stack+54822, vrr_stack+146351, vrr_stack+50041, vrr_stack+54624, vrr_stack+37517);
 _BUILD_g0n0(Data,vrr_stack+147407, vrr_stack+134781, vrr_stack+146747, vrr_stack+29101, vrr_stack+54822, vrr_stack+37847);
 _BUILD_h0n0(Data,vrr_stack+148397, vrr_stack+31433, vrr_stack+147407, vrr_stack+74165, vrr_stack+134781, vrr_stack+38397);
 _BUILD_i0n0(Data,vrr_stack+37352, vrr_stack+50239, vrr_stack+148397, vrr_stack+4423, vrr_stack+31433, vrr_stack+39222);
 _BUILD_k0n0(Data,vrr_stack+197899, vrr_stack+89491, vrr_stack+37352, vrr_stack+1493, vrr_stack+50239, vrr_stack+105171);
 _BUILD_l0n0(Data,vrr_stack+200275, vrr_stack+91339, vrr_stack+197899, vrr_stack+15284, vrr_stack+89491, vrr_stack+6815);
 _BUILD_m0n0(Data,vrr_stack+100651, vrr_stack+185425, vrr_stack+200275, vrr_stack+51680, vrr_stack+91339, vrr_stack+70301);
 _BUILD_n0n0(Data,vrr_stack+203245, vrr_stack+32423, vrr_stack+100651, vrr_stack+171631, vrr_stack+185425, vrr_stack+154966);
 _BUILD_o0n0(Data,vrr_stack+207601, vrr_stack+188395, vrr_stack+203245, vrr_stack+174601, vrr_stack+32423, vrr_stack+157991);
 _BUILD_q0n0(Data,vrr_stack+154966, vrr_stack+192751, vrr_stack+207601, vrr_stack+141546, vrr_stack+188395, vrr_stack+20332);
 _BUILD_q0n0(Data,vrr_stack+212749, vrr_stack+135441, vrr_stack+192751, vrr_stack+84981, vrr_stack+141546, vrr_stack+150676);
   tmp = vrr_stack + 212749;
   target_ptr = Libint->vrr_classes[12][10];
   for(i=0;i<6006;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00o0(Data,vrr_stack+84981, vrr_stack+57583, vrr_stack+58177, vrr_stack+65306, vrr_stack+65801, NULL);
 _BUILD_00o0(Data,vrr_stack+85059, vrr_stack+57649, vrr_stack+57583, vrr_stack+65361, vrr_stack+65306, NULL);
 _BUILD_p0o0(Data,vrr_stack+85137, vrr_stack+85059, vrr_stack+84981, NULL, NULL, vrr_stack+57583);
 _BUILD_00o0(Data,vrr_stack+85371, vrr_stack+57913, vrr_stack+57649, vrr_stack+65581, vrr_stack+65361, NULL);
 _BUILD_p0o0(Data,vrr_stack+85449, vrr_stack+85371, vrr_stack+85059, NULL, NULL, vrr_stack+57649);
 _BUILD_00o0(Data,vrr_stack+85683, vrr_stack+58177, vrr_stack+65636, vrr_stack+65801, vrr_stack+76736, NULL);
 _BUILD_p0o0(Data,vrr_stack+85761, vrr_stack+84981, vrr_stack+85683, NULL, NULL, vrr_stack+58177);
 _BUILD_d0o0(Data,vrr_stack+85995, vrr_stack+85137, vrr_stack+85761, vrr_stack+85059, vrr_stack+84981, vrr_stack+58243);
 _BUILD_d0o0(Data,vrr_stack+86463, vrr_stack+85449, vrr_stack+85137, vrr_stack+85371, vrr_stack+85059, vrr_stack+57715);
 _BUILD_f0o0(Data,vrr_stack+86931, vrr_stack+86463, vrr_stack+85995, vrr_stack+85449, vrr_stack+85137, vrr_stack+58441);
 _BUILD_00o0(Data,vrr_stack+57715, vrr_stack+65416, vrr_stack+57913, vrr_stack+76556, vrr_stack+65581, NULL);
 _BUILD_p0o0(Data,vrr_stack+58243, vrr_stack+57715, vrr_stack+85371, NULL, NULL, vrr_stack+57913);
 _BUILD_d0o0(Data,vrr_stack+87711, vrr_stack+58243, vrr_stack+85449, vrr_stack+57715, vrr_stack+85371, vrr_stack+57979);
 _BUILD_f0o0(Data,vrr_stack+88179, vrr_stack+87711, vrr_stack+86463, vrr_stack+58243, vrr_stack+85449, vrr_stack+58837);
 _BUILD_00o0(Data,vrr_stack+57979, vrr_stack+65636, vrr_stack+123836, vrr_stack+76736, vrr_stack+15229, NULL);
 _BUILD_p0o0(Data,vrr_stack+58477, vrr_stack+85683, vrr_stack+57979, NULL, NULL, vrr_stack+65636);
 _BUILD_d0o0(Data,vrr_stack+58711, vrr_stack+85761, vrr_stack+58477, vrr_stack+84981, vrr_stack+85683, vrr_stack+66054);
 _BUILD_f0o0(Data,vrr_stack+105171, vrr_stack+85995, vrr_stack+58711, vrr_stack+85137, vrr_stack+85761, vrr_stack+66252);
 _BUILD_g0o0(Data,vrr_stack+39200, vrr_stack+86931, vrr_stack+105171, vrr_stack+86463, vrr_stack+85995, vrr_stack+68111);
 _BUILD_g0o0(Data,vrr_stack+94161, vrr_stack+88179, vrr_stack+86931, vrr_stack+87711, vrr_stack+86463, vrr_stack+59233);
 _BUILD_h0o0(Data,vrr_stack+55218, vrr_stack+94161, vrr_stack+39200, vrr_stack+88179, vrr_stack+86931, vrr_stack+68771);
 _BUILD_00o0(Data,vrr_stack+66054, vrr_stack+123176, vrr_stack+65416, vrr_stack+28386, vrr_stack+76556, NULL);
 _BUILD_p0o0(Data,vrr_stack+66132, vrr_stack+66054, vrr_stack+57715, NULL, NULL, vrr_stack+65416);
 _BUILD_d0o0(Data,vrr_stack+59179, vrr_stack+66132, vrr_stack+58243, vrr_stack+66054, vrr_stack+57715, vrr_stack+65856);
 _BUILD_f0o0(Data,vrr_stack+149783, vrr_stack+59179, vrr_stack+87711, vrr_stack+66132, vrr_stack+58243, vrr_stack+59893);
 _BUILD_g0o0(Data,vrr_stack+29497, vrr_stack+149783, vrr_stack+88179, vrr_stack+59179, vrr_stack+87711, vrr_stack+60289);
 _BUILD_h0o0(Data,vrr_stack+74825, vrr_stack+29497, vrr_stack+94161, vrr_stack+149783, vrr_stack+88179, vrr_stack+60949);
 _BUILD_00o0(Data,vrr_stack+66366, vrr_stack+123836, vrr_stack+49975, vrr_stack+15229, vrr_stack+84926, NULL);
 _BUILD_p0o0(Data,vrr_stack+59647, vrr_stack+57979, vrr_stack+66366, NULL, NULL, vrr_stack+123836);
 _BUILD_d0o0(Data,vrr_stack+59881, vrr_stack+58477, vrr_stack+59647, vrr_stack+85683, vrr_stack+57979, vrr_stack+3169);
 _BUILD_f0o0(Data,vrr_stack+60349, vrr_stack+58711, vrr_stack+59881, vrr_stack+85761, vrr_stack+58477, vrr_stack+3367);
 _BUILD_g0o0(Data,vrr_stack+5413, vrr_stack+105171, vrr_stack+60349, vrr_stack+85995, vrr_stack+58711, vrr_stack+3763);
 _BUILD_h0o0(Data,vrr_stack+6583, vrr_stack+39200, vrr_stack+5413, vrr_stack+86931, vrr_stack+105171, vrr_stack+117947);
 _BUILD_i0o0(Data,vrr_stack+68034, vrr_stack+55218, vrr_stack+6583, vrr_stack+94161, vrr_stack+39200, vrr_stack+106711);
 _BUILD_i0o0(Data,vrr_stack+105951, vrr_stack+74825, vrr_stack+55218, vrr_stack+29497, vrr_stack+94161, vrr_stack+115571);
 _BUILD_k0o0(Data,vrr_stack+70218, vrr_stack+105951, vrr_stack+68034, vrr_stack+74825, vrr_stack+55218, vrr_stack+63011);
 _BUILD_00o0(Data,vrr_stack+115571, vrr_stack+73505, vrr_stack+123176, vrr_stack+54503, vrr_stack+28386, NULL);
 _BUILD_p0o0(Data,vrr_stack+115649, vrr_stack+115571, vrr_stack+66054, NULL, NULL, vrr_stack+123176);
 _BUILD_d0o0(Data,vrr_stack+115883, vrr_stack+115649, vrr_stack+66132, vrr_stack+115571, vrr_stack+66054, vrr_stack+123242);
 _BUILD_f0o0(Data,vrr_stack+117947, vrr_stack+115883, vrr_stack+59179, vrr_stack+115649, vrr_stack+66132, vrr_stack+123440);
 _BUILD_g0o0(Data,vrr_stack+62599, vrr_stack+117947, vrr_stack+149783, vrr_stack+115883, vrr_stack+59179, vrr_stack+61939);
 _BUILD_h0o0(Data,vrr_stack+63769, vrr_stack+62599, vrr_stack+29497, vrr_stack+117947, vrr_stack+149783, vrr_stack+116957);
 _BUILD_i0o0(Data,vrr_stack+19603, vrr_stack+63769, vrr_stack+74825, vrr_stack+62599, vrr_stack+29497, vrr_stack+66648);
 _BUILD_k0o0(Data,vrr_stack+21787, vrr_stack+19603, vrr_stack+105951, vrr_stack+63769, vrr_stack+74825, vrr_stack+40377);
 _BUILD_00o0(Data,vrr_stack+123242, vrr_stack+49975, vrr_stack+54558, vrr_stack+84926, vrr_stack+31378, NULL);
 _BUILD_p0o0(Data,vrr_stack+123320, vrr_stack+66366, vrr_stack+123242, NULL, NULL, vrr_stack+49975);
 _BUILD_d0o0(Data,vrr_stack+116351, vrr_stack+59647, vrr_stack+123320, vrr_stack+57979, vrr_stack+66366, vrr_stack+50041);
 _BUILD_f0o0(Data,vrr_stack+116819, vrr_stack+59881, vrr_stack+116351, vrr_stack+58477, vrr_stack+59647, vrr_stack+29101);
 _BUILD_g0o0(Data,vrr_stack+66444, vrr_stack+60349, vrr_stack+116819, vrr_stack+58711, vrr_stack+59881, vrr_stack+74165);
 _BUILD_h0o0(Data,vrr_stack+40370, vrr_stack+5413, vrr_stack+66444, vrr_stack+105171, vrr_stack+60349, vrr_stack+4423);
 _BUILD_i0o0(Data,vrr_stack+2879, vrr_stack+6583, vrr_stack+40370, vrr_stack+39200, vrr_stack+5413, vrr_stack+1493);
 _BUILD_k0o0(Data,vrr_stack+218755, vrr_stack+68034, vrr_stack+2879, vrr_stack+55218, vrr_stack+6583, vrr_stack+15284);
 _BUILD_l0o0(Data,vrr_stack+221563, vrr_stack+70218, vrr_stack+218755, vrr_stack+105951, vrr_stack+68034, vrr_stack+51680);
 _BUILD_l0o0(Data,vrr_stack+225073, vrr_stack+21787, vrr_stack+70218, vrr_stack+19603, vrr_stack+105951, vrr_stack+17227);
 _BUILD_m0o0(Data,vrr_stack+15229, vrr_stack+225073, vrr_stack+221563, vrr_stack+21787, vrr_stack+70218, vrr_stack+171631);
 _BUILD_00o0(Data,vrr_stack+171631, vrr_stack+132471, vrr_stack+73505, vrr_stack+94106, vrr_stack+54503, NULL);
 _BUILD_p0o0(Data,vrr_stack+171709, vrr_stack+171631, vrr_stack+115571, NULL, NULL, vrr_stack+73505);
 _BUILD_d0o0(Data,vrr_stack+171943, vrr_stack+171709, vrr_stack+115649, vrr_stack+171631, vrr_stack+115571, vrr_stack+73571);
 _BUILD_f0o0(Data,vrr_stack+172411, vrr_stack+171943, vrr_stack+115883, vrr_stack+171709, vrr_stack+115649, vrr_stack+73769);
 _BUILD_g0o0(Data,vrr_stack+73571, vrr_stack+172411, vrr_stack+117947, vrr_stack+171943, vrr_stack+115883, vrr_stack+28441);
 _BUILD_h0o0(Data,vrr_stack+51680, vrr_stack+73571, vrr_stack+62599, vrr_stack+172411, vrr_stack+117947, vrr_stack+11270);
 _BUILD_i0o0(Data,vrr_stack+228583, vrr_stack+51680, vrr_stack+63769, vrr_stack+73571, vrr_stack+62599, vrr_stack+107);
 _BUILD_k0o0(Data,vrr_stack+0, vrr_stack+228583, vrr_stack+19603, vrr_stack+51680, vrr_stack+63769, vrr_stack+76791);
 _BUILD_l0o0(Data,vrr_stack+230767, vrr_stack+0, vrr_stack+21787, vrr_stack+228583, vrr_stack+19603, vrr_stack+8795);
 _BUILD_m0o0(Data,vrr_stack+8221, vrr_stack+230767, vrr_stack+225073, vrr_stack+0, vrr_stack+21787, vrr_stack+129501);
 _BUILD_00o0(Data,vrr_stack+74741, vrr_stack+54558, vrr_stack+146087, vrr_stack+31378, vrr_stack+37297, NULL);
 _BUILD_p0o0(Data,vrr_stack+173191, vrr_stack+123242, vrr_stack+74741, NULL, NULL, vrr_stack+54558);
 _BUILD_d0o0(Data,vrr_stack+173425, vrr_stack+123320, vrr_stack+173191, vrr_stack+66366, vrr_stack+123242, vrr_stack+54624);
 _BUILD_f0o0(Data,vrr_stack+53318, vrr_stack+116351, vrr_stack+173425, vrr_stack+59647, vrr_stack+123320, vrr_stack+54822);
 _BUILD_g0o0(Data,vrr_stack+61129, vrr_stack+116819, vrr_stack+53318, vrr_stack+59881, vrr_stack+116351, vrr_stack+134781);
 _BUILD_h0o0(Data,vrr_stack+76463, vrr_stack+66444, vrr_stack+61129, vrr_stack+60349, vrr_stack+116819, vrr_stack+31433);
 _BUILD_i0o0(Data,vrr_stack+128918, vrr_stack+40370, vrr_stack+76463, vrr_stack+5413, vrr_stack+66444, vrr_stack+50239);
 _BUILD_k0o0(Data,vrr_stack+234277, vrr_stack+2879, vrr_stack+128918, vrr_stack+6583, vrr_stack+40370, vrr_stack+89491);
 _BUILD_l0o0(Data,vrr_stack+237085, vrr_stack+218755, vrr_stack+234277, vrr_stack+68034, vrr_stack+2879, vrr_stack+91339);
 _BUILD_m0o0(Data,vrr_stack+88959, vrr_stack+221563, vrr_stack+237085, vrr_stack+70218, vrr_stack+218755, vrr_stack+185425);
 _BUILD_n0o0(Data,vrr_stack+240595, vrr_stack+15229, vrr_stack+88959, vrr_stack+225073, vrr_stack+221563, vrr_stack+32423);
 _BUILD_n0o0(Data,vrr_stack+30667, vrr_stack+8221, vrr_stack+15229, vrr_stack+230767, vrr_stack+225073, vrr_stack+174601);
 _BUILD_o0o0(Data,vrr_stack+245743, vrr_stack+30667, vrr_stack+240595, vrr_stack+8221, vrr_stack+15229, vrr_stack+188395);
 _BUILD_00o0(Data,vrr_stack+185425, vrr_stack+145902, vrr_stack+132471, vrr_stack+105116, vrr_stack+94106, NULL);
 _BUILD_p0o0(Data,vrr_stack+185503, vrr_stack+185425, vrr_stack+171631, NULL, NULL, vrr_stack+132471);
 _BUILD_d0o0(Data,vrr_stack+185737, vrr_stack+185503, vrr_stack+171709, vrr_stack+185425, vrr_stack+171631, vrr_stack+132537);
 _BUILD_f0o0(Data,vrr_stack+186205, vrr_stack+185737, vrr_stack+171943, vrr_stack+185503, vrr_stack+171709, vrr_stack+132735);
 _BUILD_g0o0(Data,vrr_stack+186985, vrr_stack+186205, vrr_stack+172411, vrr_stack+185737, vrr_stack+171943, vrr_stack+133131);
 _BUILD_h0o0(Data,vrr_stack+188155, vrr_stack+186985, vrr_stack+73571, vrr_stack+186205, vrr_stack+172411, vrr_stack+133791);
 _BUILD_i0o0(Data,vrr_stack+132537, vrr_stack+188155, vrr_stack+51680, vrr_stack+186985, vrr_stack+73571, vrr_stack+123902);
 _BUILD_k0o0(Data,vrr_stack+189793, vrr_stack+132537, vrr_stack+228583, vrr_stack+188155, vrr_stack+51680, vrr_stack+178231);
 _BUILD_l0o0(Data,vrr_stack+185503, vrr_stack+189793, vrr_stack+0, vrr_stack+132537, vrr_stack+228583, vrr_stack+180079);
   tmp = vrr_stack + 185503;
   target_ptr = Libint->vrr_classes[8][11];
   for(i=0;i<3510;i++)
     target_ptr[i] += tmp[i];
 _BUILD_m0o0(Data,vrr_stack+173893, vrr_stack+185503, vrr_stack+230767, vrr_stack+189793, vrr_stack+0, vrr_stack+182455);
   tmp = vrr_stack + 173893;
   target_ptr = Libint->vrr_classes[9][11];
   for(i=0;i<4290;i++)
     target_ptr[i] += tmp[i];
 _BUILD_n0o0(Data,vrr_stack+178183, vrr_stack+173893, vrr_stack+8221, vrr_stack+185503, vrr_stack+230767, vrr_stack+125288);
   tmp = vrr_stack + 178183;
   target_ptr = Libint->vrr_classes[10][11];
   for(i=0;i<5148;i++)
     target_ptr[i] += tmp[i];
 _BUILD_o0o0(Data,vrr_stack+185503, vrr_stack+178183, vrr_stack+30667, vrr_stack+173893, vrr_stack+8221, vrr_stack+141546);
   tmp = vrr_stack + 185503;
   target_ptr = Libint->vrr_classes[11][11];
   for(i=0;i<6084;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00p0(Data,vrr_stack+173893, Data->F+23, Data->F+24, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+74819, vrr_stack+145968, vrr_stack+173893, Data->F+22, Data->F+23, NULL);
 _BUILD_00f0(Data,vrr_stack+173896, vrr_stack+145971, vrr_stack+74819, vrr_stack+37133, vrr_stack+145968, NULL);
 _BUILD_00g0(Data,vrr_stack+173906, vrr_stack+145977, vrr_stack+173896, vrr_stack+37136, vrr_stack+145971, NULL);
 _BUILD_00h0(Data,vrr_stack+173921, vrr_stack+145987, vrr_stack+173906, vrr_stack+37142, vrr_stack+145977, NULL);
 _BUILD_00i0(Data,vrr_stack+173942, vrr_stack+146002, vrr_stack+173921, vrr_stack+37152, vrr_stack+145987, NULL);
 _BUILD_00k0(Data,vrr_stack+173970, vrr_stack+146023, vrr_stack+173942, vrr_stack+37167, vrr_stack+146002, NULL);
 _BUILD_00l0(Data,vrr_stack+174006, vrr_stack+146051, vrr_stack+173970, vrr_stack+37188, vrr_stack+146023, NULL);
 _BUILD_00m0(Data,vrr_stack+84926, vrr_stack+15184, vrr_stack+174006, vrr_stack+37216, vrr_stack+146051, NULL);
 _BUILD_00n0(Data,vrr_stack+174051, vrr_stack+51625, vrr_stack+84926, vrr_stack+37252, vrr_stack+15184, NULL);
 _BUILD_00o0(Data,vrr_stack+174117, vrr_stack+146087, vrr_stack+174051, vrr_stack+37297, vrr_stack+51625, NULL);
 _BUILD_p0o0(Data,vrr_stack+174195, vrr_stack+74741, vrr_stack+174117, NULL, NULL, vrr_stack+146087);
 _BUILD_d0o0(Data,vrr_stack+174429, vrr_stack+173191, vrr_stack+174195, vrr_stack+123242, vrr_stack+74741, vrr_stack+146153);
 _BUILD_f0o0(Data,vrr_stack+174897, vrr_stack+173425, vrr_stack+174429, vrr_stack+123320, vrr_stack+173191, vrr_stack+146351);
 _BUILD_g0o0(Data,vrr_stack+175677, vrr_stack+53318, vrr_stack+174897, vrr_stack+116351, vrr_stack+173425, vrr_stack+146747);
 _BUILD_h0o0(Data,vrr_stack+132537, vrr_stack+61129, vrr_stack+175677, vrr_stack+116819, vrr_stack+53318, vrr_stack+147407);
 _BUILD_i0o0(Data,vrr_stack+146153, vrr_stack+76463, vrr_stack+132537, vrr_stack+66444, vrr_stack+61129, vrr_stack+148397);
 _BUILD_k0o0(Data,vrr_stack+123902, vrr_stack+128918, vrr_stack+146153, vrr_stack+40370, vrr_stack+76463, vrr_stack+37352);
 _BUILD_l0o0(Data,vrr_stack+140589, vrr_stack+234277, vrr_stack+123902, vrr_stack+2879, vrr_stack+128918, vrr_stack+197899);
 _BUILD_m0o0(Data,vrr_stack+251827, vrr_stack+237085, vrr_stack+140589, vrr_stack+218755, vrr_stack+234277, vrr_stack+200275);
 _BUILD_n0o0(Data,vrr_stack+197899, vrr_stack+88959, vrr_stack+251827, vrr_stack+221563, vrr_stack+237085, vrr_stack+100651);
 _BUILD_o0o0(Data,vrr_stack+256117, vrr_stack+240595, vrr_stack+197899, vrr_stack+15229, vrr_stack+88959, vrr_stack+203245);
 _BUILD_q0o0(Data,vrr_stack+262201, vrr_stack+245743, vrr_stack+256117, vrr_stack+30667, vrr_stack+240595, vrr_stack+207601);
 _BUILD_q0o0(Data,vrr_stack+203047, vrr_stack+185503, vrr_stack+245743, vrr_stack+178183, vrr_stack+30667, vrr_stack+192751);
   tmp = vrr_stack + 203047;
   target_ptr = Libint->vrr_classes[12][11];
   for(i=0;i<7098;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00q0(Data,vrr_stack+100651, vrr_stack+84981, vrr_stack+85683, vrr_stack+57583, vrr_stack+58177, NULL);
 _BUILD_00q0(Data,vrr_stack+100742, vrr_stack+85059, vrr_stack+84981, vrr_stack+57649, vrr_stack+57583, NULL);
 _BUILD_p0q0(Data,vrr_stack+100833, vrr_stack+100742, vrr_stack+100651, NULL, NULL, vrr_stack+84981);
 _BUILD_00q0(Data,vrr_stack+101106, vrr_stack+85371, vrr_stack+85059, vrr_stack+57913, vrr_stack+57649, NULL);
 _BUILD_p0q0(Data,vrr_stack+101197, vrr_stack+101106, vrr_stack+100742, NULL, NULL, vrr_stack+85059);
 _BUILD_00q0(Data,vrr_stack+101470, vrr_stack+85683, vrr_stack+57979, vrr_stack+58177, vrr_stack+65636, NULL);
 _BUILD_p0q0(Data,vrr_stack+101561, vrr_stack+100651, vrr_stack+101470, NULL, NULL, vrr_stack+85683);
 _BUILD_d0q0(Data,vrr_stack+101834, vrr_stack+100833, vrr_stack+101561, vrr_stack+100742, vrr_stack+100651, vrr_stack+85761);
 _BUILD_d0q0(Data,vrr_stack+102380, vrr_stack+101197, vrr_stack+100833, vrr_stack+101106, vrr_stack+100742, vrr_stack+85137);
 _BUILD_f0q0(Data,vrr_stack+102926, vrr_stack+102380, vrr_stack+101834, vrr_stack+101197, vrr_stack+100833, vrr_stack+85995);
 _BUILD_00q0(Data,vrr_stack+85137, vrr_stack+57715, vrr_stack+85371, vrr_stack+65416, vrr_stack+57913, NULL);
 _BUILD_p0q0(Data,vrr_stack+85761, vrr_stack+85137, vrr_stack+101106, NULL, NULL, vrr_stack+85371);
 _BUILD_d0q0(Data,vrr_stack+103836, vrr_stack+85761, vrr_stack+101197, vrr_stack+85137, vrr_stack+101106, vrr_stack+85449);
 _BUILD_f0q0(Data,vrr_stack+210145, vrr_stack+103836, vrr_stack+102380, vrr_stack+85761, vrr_stack+101197, vrr_stack+86463);
 _BUILD_00q0(Data,vrr_stack+85449, vrr_stack+57979, vrr_stack+66366, vrr_stack+65636, vrr_stack+123836, NULL);
 _BUILD_p0q0(Data,vrr_stack+86034, vrr_stack+101470, vrr_stack+85449, NULL, NULL, vrr_stack+57979);
 _BUILD_d0q0(Data,vrr_stack+86307, vrr_stack+101561, vrr_stack+86034, vrr_stack+100651, vrr_stack+101470, vrr_stack+58477);
 _BUILD_f0q0(Data,vrr_stack+211055, vrr_stack+101834, vrr_stack+86307, vrr_stack+100833, vrr_stack+101561, vrr_stack+58711);
 _BUILD_g0q0(Data,vrr_stack+148337, vrr_stack+102926, vrr_stack+211055, vrr_stack+102380, vrr_stack+101834, vrr_stack+105171);
 _BUILD_g0q0(Data,vrr_stack+104382, vrr_stack+210145, vrr_stack+102926, vrr_stack+103836, vrr_stack+102380, vrr_stack+86931);
 _BUILD_h0q0(Data,vrr_stack+176847, vrr_stack+104382, vrr_stack+148337, vrr_stack+210145, vrr_stack+102926, vrr_stack+39200);
 _BUILD_00q0(Data,vrr_stack+58477, vrr_stack+66054, vrr_stack+57715, vrr_stack+123176, vrr_stack+65416, NULL);
 _BUILD_p0q0(Data,vrr_stack+58568, vrr_stack+58477, vrr_stack+85137, NULL, NULL, vrr_stack+57715);
 _BUILD_d0q0(Data,vrr_stack+86853, vrr_stack+58568, vrr_stack+85761, vrr_stack+58477, vrr_stack+85137, vrr_stack+58243);
 _BUILD_f0q0(Data,vrr_stack+178758, vrr_stack+86853, vrr_stack+103836, vrr_stack+58568, vrr_stack+85761, vrr_stack+87711);
 _BUILD_g0q0(Data,vrr_stack+179668, vrr_stack+178758, vrr_stack+210145, vrr_stack+86853, vrr_stack+103836, vrr_stack+88179);
 _BUILD_h0q0(Data,vrr_stack+181033, vrr_stack+179668, vrr_stack+104382, vrr_stack+178758, vrr_stack+210145, vrr_stack+94161);
 _BUILD_00q0(Data,vrr_stack+58841, vrr_stack+66366, vrr_stack+123242, vrr_stack+123836, vrr_stack+49975, NULL);
 _BUILD_p0q0(Data,vrr_stack+87399, vrr_stack+85449, vrr_stack+58841, NULL, NULL, vrr_stack+66366);
 _BUILD_d0q0(Data,vrr_stack+87672, vrr_stack+86034, vrr_stack+87399, vrr_stack+101470, vrr_stack+85449, vrr_stack+59647);
 _BUILD_f0q0(Data,vrr_stack+182944, vrr_stack+86307, vrr_stack+87672, vrr_stack+101561, vrr_stack+86034, vrr_stack+59881);
 _BUILD_g0q0(Data,vrr_stack+183854, vrr_stack+211055, vrr_stack+182944, vrr_stack+101834, vrr_stack+86307, vrr_stack+60349);
 _BUILD_h0q0(Data,vrr_stack+126710, vrr_stack+148337, vrr_stack+183854, vrr_stack+102926, vrr_stack+211055, vrr_stack+5413);
 _BUILD_i0q0(Data,vrr_stack+93249, vrr_stack+176847, vrr_stack+126710, vrr_stack+104382, vrr_stack+148337, vrr_stack+6583);
 _BUILD_i0q0(Data,vrr_stack+35815, vrr_stack+181033, vrr_stack+176847, vrr_stack+179668, vrr_stack+104382, vrr_stack+55218);
 _BUILD_k0q0(Data,vrr_stack+269299, vrr_stack+35815, vrr_stack+93249, vrr_stack+181033, vrr_stack+176847, vrr_stack+68034);
 _BUILD_00q0(Data,vrr_stack+59647, vrr_stack+115571, vrr_stack+66054, vrr_stack+73505, vrr_stack+123176, NULL);
 _BUILD_p0q0(Data,vrr_stack+59738, vrr_stack+59647, vrr_stack+58477, NULL, NULL, vrr_stack+66054);
 _BUILD_d0q0(Data,vrr_stack+60011, vrr_stack+59738, vrr_stack+58568, vrr_stack+59647, vrr_stack+58477, vrr_stack+66132);
 _BUILD_f0q0(Data,vrr_stack+191587, vrr_stack+60011, vrr_stack+86853, vrr_stack+59738, vrr_stack+58568, vrr_stack+59179);
 _BUILD_g0q0(Data,vrr_stack+54624, vrr_stack+191587, vrr_stack+178758, vrr_stack+60011, vrr_stack+86853, vrr_stack+149783);
 _BUILD_h0q0(Data,vrr_stack+67614, vrr_stack+54624, vrr_stack+179668, vrr_stack+191587, vrr_stack+178758, vrr_stack+29497);
 _BUILD_i0q0(Data,vrr_stack+5063, vrr_stack+67614, vrr_stack+181033, vrr_stack+54624, vrr_stack+179668, vrr_stack+74825);
 _BUILD_k0q0(Data,vrr_stack+272575, vrr_stack+5063, vrr_stack+35815, vrr_stack+67614, vrr_stack+181033, vrr_stack+105951);
 _BUILD_00q0(Data,vrr_stack+74825, vrr_stack+123242, vrr_stack+74741, vrr_stack+49975, vrr_stack+54558, NULL);
 _BUILD_p0q0(Data,vrr_stack+49975, vrr_stack+58841, vrr_stack+74825, NULL, NULL, vrr_stack+123242);
 _BUILD_d0q0(Data,vrr_stack+50248, vrr_stack+87399, vrr_stack+49975, vrr_stack+85449, vrr_stack+58841, vrr_stack+123320);
 _BUILD_f0q0(Data,vrr_stack+74916, vrr_stack+87672, vrr_stack+50248, vrr_stack+86034, vrr_stack+87399, vrr_stack+116351);
 _BUILD_g0q0(Data,vrr_stack+105747, vrr_stack+182944, vrr_stack+74916, vrr_stack+86307, vrr_stack+87672, vrr_stack+116819);
 _BUILD_h0q0(Data,vrr_stack+28386, vrr_stack+183854, vrr_stack+105747, vrr_stack+211055, vrr_stack+182944, vrr_stack+66444);
 _BUILD_i0q0(Data,vrr_stack+275851, vrr_stack+126710, vrr_stack+28386, vrr_stack+148337, vrr_stack+183854, vrr_stack+40370);
 _BUILD_k0q0(Data,vrr_stack+38363, vrr_stack+93249, vrr_stack+275851, vrr_stack+176847, vrr_stack+126710, vrr_stack+2879);
 _BUILD_l0q0(Data,vrr_stack+278399, vrr_stack+269299, vrr_stack+38363, vrr_stack+35815, vrr_stack+93249, vrr_stack+218755);
 _BUILD_l0q0(Data,vrr_stack+282494, vrr_stack+272575, vrr_stack+269299, vrr_stack+5063, vrr_stack+35815, vrr_stack+70218);
 _BUILD_m0q0(Data,vrr_stack+286589, vrr_stack+282494, vrr_stack+278399, vrr_stack+272575, vrr_stack+269299, vrr_stack+221563);
 _BUILD_00q0(Data,vrr_stack+218755, vrr_stack+171631, vrr_stack+115571, vrr_stack+132471, vrr_stack+73505, NULL);
 _BUILD_p0q0(Data,vrr_stack+218846, vrr_stack+218755, vrr_stack+59647, NULL, NULL, vrr_stack+115571);
 _BUILD_d0q0(Data,vrr_stack+219119, vrr_stack+218846, vrr_stack+59738, vrr_stack+218755, vrr_stack+59647, vrr_stack+115649);
 _BUILD_f0q0(Data,vrr_stack+219665, vrr_stack+219119, vrr_stack+60011, vrr_stack+218846, vrr_stack+59738, vrr_stack+115883);
 _BUILD_g0q0(Data,vrr_stack+115649, vrr_stack+219665, vrr_stack+191587, vrr_stack+219119, vrr_stack+60011, vrr_stack+117947);
 _BUILD_h0q0(Data,vrr_stack+117014, vrr_stack+115649, vrr_stack+54624, vrr_stack+219665, vrr_stack+191587, vrr_stack+62599);
 _BUILD_i0q0(Data,vrr_stack+220575, vrr_stack+117014, vrr_stack+67614, vrr_stack+115649, vrr_stack+54624, vrr_stack+63769);
 _BUILD_k0q0(Data,vrr_stack+69525, vrr_stack+220575, vrr_stack+5063, vrr_stack+117014, vrr_stack+67614, vrr_stack+19603);
 _BUILD_l0q0(Data,vrr_stack+291594, vrr_stack+69525, vrr_stack+272575, vrr_stack+220575, vrr_stack+5063, vrr_stack+21787);
 _BUILD_m0q0(Data,vrr_stack+19519, vrr_stack+291594, vrr_stack+282494, vrr_stack+69525, vrr_stack+272575, vrr_stack+225073);
 _BUILD_00q0(Data,vrr_stack+118925, vrr_stack+74741, vrr_stack+174117, vrr_stack+54558, vrr_stack+146087, NULL);
 _BUILD_p0q0(Data,vrr_stack+223123, vrr_stack+74825, vrr_stack+118925, NULL, NULL, vrr_stack+74741);
 _BUILD_d0q0(Data,vrr_stack+223396, vrr_stack+49975, vrr_stack+223123, vrr_stack+58841, vrr_stack+74825, vrr_stack+173191);
 _BUILD_f0q0(Data,vrr_stack+223942, vrr_stack+50248, vrr_stack+223396, vrr_stack+87399, vrr_stack+49975, vrr_stack+173425);
 _BUILD_g0q0(Data,vrr_stack+224852, vrr_stack+74916, vrr_stack+223942, vrr_stack+87672, vrr_stack+50248, vrr_stack+53318);
 _BUILD_h0q0(Data,vrr_stack+226217, vrr_stack+105747, vrr_stack+224852, vrr_stack+182944, vrr_stack+74916, vrr_stack+61129);
 _BUILD_i0q0(Data,vrr_stack+60557, vrr_stack+28386, vrr_stack+226217, vrr_stack+183854, vrr_stack+105747, vrr_stack+76463);
 _BUILD_k0q0(Data,vrr_stack+295689, vrr_stack+275851, vrr_stack+60557, vrr_stack+126710, vrr_stack+28386, vrr_stack+128918);
 _BUILD_l0q0(Data,vrr_stack+298965, vrr_stack+38363, vrr_stack+295689, vrr_stack+93249, vrr_stack+275851, vrr_stack+234277);
 _BUILD_m0q0(Data,vrr_stack+303060, vrr_stack+278399, vrr_stack+298965, vrr_stack+269299, vrr_stack+38363, vrr_stack+237085);
 _BUILD_n0q0(Data,vrr_stack+234277, vrr_stack+286589, vrr_stack+303060, vrr_stack+282494, vrr_stack+278399, vrr_stack+88959);
 _BUILD_n0q0(Data,vrr_stack+308065, vrr_stack+19519, vrr_stack+286589, vrr_stack+291594, vrr_stack+282494, vrr_stack+15229);
 _BUILD_o0q0(Data,vrr_stack+314071, vrr_stack+308065, vrr_stack+234277, vrr_stack+19519, vrr_stack+286589, vrr_stack+240595);
 _BUILD_00q0(Data,vrr_stack+15229, vrr_stack+185425, vrr_stack+171631, vrr_stack+145902, vrr_stack+132471, NULL);
 _BUILD_p0q0(Data,vrr_stack+15320, vrr_stack+15229, vrr_stack+218755, NULL, NULL, vrr_stack+171631);
 _BUILD_d0q0(Data,vrr_stack+15593, vrr_stack+15320, vrr_stack+218846, vrr_stack+15229, vrr_stack+218755, vrr_stack+171709);
 _BUILD_f0q0(Data,vrr_stack+16139, vrr_stack+15593, vrr_stack+219119, vrr_stack+15320, vrr_stack+218846, vrr_stack+171943);
 _BUILD_g0q0(Data,vrr_stack+17049, vrr_stack+16139, vrr_stack+219665, vrr_stack+15593, vrr_stack+219119, vrr_stack+172411);
 _BUILD_h0q0(Data,vrr_stack+171709, vrr_stack+17049, vrr_stack+115649, vrr_stack+16139, vrr_stack+219665, vrr_stack+73571);
 _BUILD_i0q0(Data,vrr_stack+240283, vrr_stack+171709, vrr_stack+117014, vrr_stack+17049, vrr_stack+115649, vrr_stack+51680);
 _BUILD_k0q0(Data,vrr_stack+15320, vrr_stack+240283, vrr_stack+220575, vrr_stack+171709, vrr_stack+117014, vrr_stack+228583);
 _BUILD_l0q0(Data,vrr_stack+88218, vrr_stack+15320, vrr_stack+69525, vrr_stack+240283, vrr_stack+220575, vrr_stack+0);
   tmp = vrr_stack + 88218;
   target_ptr = Libint->vrr_classes[8][12];
   for(i=0;i<4095;i++)
     target_ptr[i] += tmp[i];
 _BUILD_m0q0(Data,vrr_stack+0, vrr_stack+88218, vrr_stack+291594, vrr_stack+15320, vrr_stack+69525, vrr_stack+230767);
   tmp = vrr_stack + 0;
   target_ptr = Libint->vrr_classes[9][12];
   for(i=0;i<5005;i++)
     target_ptr[i] += tmp[i];
 _BUILD_n0q0(Data,vrr_stack+228128, vrr_stack+0, vrr_stack+19519, vrr_stack+88218, vrr_stack+291594, vrr_stack+8221);
   tmp = vrr_stack + 228128;
   target_ptr = Libint->vrr_classes[10][12];
   for(i=0;i<6006;i++)
     target_ptr[i] += tmp[i];
 _BUILD_o0q0(Data,vrr_stack+321169, vrr_stack+228128, vrr_stack+308065, vrr_stack+0, vrr_stack+19519, vrr_stack+30667);
   tmp = vrr_stack + 321169;
   target_ptr = Libint->vrr_classes[11][12];
   for(i=0;i<7098;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00p0(Data,vrr_stack+0, Data->F+24, Data->F+25, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+3, vrr_stack+173893, vrr_stack+0, Data->F+23, Data->F+24, NULL);
 _BUILD_00f0(Data,vrr_stack+9, vrr_stack+74819, vrr_stack+3, vrr_stack+145968, vrr_stack+173893, NULL);
 _BUILD_00g0(Data,vrr_stack+19, vrr_stack+173896, vrr_stack+9, vrr_stack+145971, vrr_stack+74819, NULL);
 _BUILD_00h0(Data,vrr_stack+34, vrr_stack+173906, vrr_stack+19, vrr_stack+145977, vrr_stack+173896, NULL);
 _BUILD_00i0(Data,vrr_stack+55, vrr_stack+173921, vrr_stack+34, vrr_stack+145987, vrr_stack+173906, NULL);
 _BUILD_00k0(Data,vrr_stack+83, vrr_stack+173942, vrr_stack+55, vrr_stack+146002, vrr_stack+173921, NULL);
 _BUILD_00l0(Data,vrr_stack+119, vrr_stack+173970, vrr_stack+83, vrr_stack+146023, vrr_stack+173942, NULL);
 _BUILD_00m0(Data,vrr_stack+164, vrr_stack+174006, vrr_stack+119, vrr_stack+146051, vrr_stack+173970, NULL);
 _BUILD_00n0(Data,vrr_stack+123176, vrr_stack+84926, vrr_stack+164, vrr_stack+15184, vrr_stack+174006, NULL);
 _BUILD_00o0(Data,vrr_stack+219, vrr_stack+174051, vrr_stack+123176, vrr_stack+51625, vrr_stack+84926, NULL);
 _BUILD_00q0(Data,vrr_stack+297, vrr_stack+174117, vrr_stack+219, vrr_stack+146087, vrr_stack+174051, NULL);
 _BUILD_p0q0(Data,vrr_stack+388, vrr_stack+118925, vrr_stack+297, NULL, NULL, vrr_stack+174117);
 _BUILD_d0q0(Data,vrr_stack+661, vrr_stack+223123, vrr_stack+388, vrr_stack+74825, vrr_stack+118925, vrr_stack+174195);
 _BUILD_f0q0(Data,vrr_stack+1207, vrr_stack+223396, vrr_stack+661, vrr_stack+49975, vrr_stack+223123, vrr_stack+174429);
 _BUILD_g0q0(Data,vrr_stack+2117, vrr_stack+223942, vrr_stack+1207, vrr_stack+50248, vrr_stack+223396, vrr_stack+174897);
 _BUILD_h0q0(Data,vrr_stack+88218, vrr_stack+224852, vrr_stack+2117, vrr_stack+74916, vrr_stack+223942, vrr_stack+175677);
 _BUILD_i0q0(Data,vrr_stack+174195, vrr_stack+226217, vrr_stack+88218, vrr_stack+105747, vrr_stack+224852, vrr_stack+132537);
 _BUILD_k0q0(Data,vrr_stack+15320, vrr_stack+60557, vrr_stack+174195, vrr_stack+28386, vrr_stack+226217, vrr_stack+146153);
 _BUILD_l0q0(Data,vrr_stack+240283, vrr_stack+295689, vrr_stack+15320, vrr_stack+275851, vrr_stack+60557, vrr_stack+123902);
 _BUILD_m0q0(Data,vrr_stack+128621, vrr_stack+298965, vrr_stack+240283, vrr_stack+38363, vrr_stack+295689, vrr_stack+140589);
 _BUILD_n0q0(Data,vrr_stack+140589, vrr_stack+303060, vrr_stack+128621, vrr_stack+278399, vrr_stack+298965, vrr_stack+251827);
 _BUILD_o0q0(Data,vrr_stack+328267, vrr_stack+234277, vrr_stack+140589, vrr_stack+286589, vrr_stack+303060, vrr_stack+197899);
 _BUILD_q0q0(Data,vrr_stack+335365, vrr_stack+314071, vrr_stack+328267, vrr_stack+308065, vrr_stack+234277, vrr_stack+256117);
 _BUILD_q0q0(Data,vrr_stack+251827, vrr_stack+321169, vrr_stack+314071, vrr_stack+228128, vrr_stack+308065, vrr_stack+245743);
   tmp = vrr_stack + 251827;
   target_ptr = Libint->vrr_classes[12][12];
   for(i=0;i<8281;i++)
     target_ptr[i] += tmp[i];
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+228128, vrr_stack+100651, vrr_stack+101470, vrr_stack+84981, vrr_stack+85683, NULL);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+228233, vrr_stack+100742, vrr_stack+100651, vrr_stack+85059, vrr_stack+84981, NULL);
 am[0] = 1;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+228338, vrr_stack+228233, vrr_stack+228128, NULL, NULL, vrr_stack+100651);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+228653, vrr_stack+101106, vrr_stack+100742, vrr_stack+85371, vrr_stack+85059, NULL);
 am[0] = 1;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+228758, vrr_stack+228653, vrr_stack+228233, NULL, NULL, vrr_stack+100742);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+84981, vrr_stack+101470, vrr_stack+85449, vrr_stack+85683, vrr_stack+57979, NULL);
 am[0] = 1;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+229073, vrr_stack+228128, vrr_stack+84981, NULL, NULL, vrr_stack+101470);
 am[0] = 2;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+229388, vrr_stack+228338, vrr_stack+229073, vrr_stack+228233, vrr_stack+228128, vrr_stack+101561);
 am[0] = 2;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+230018, vrr_stack+228758, vrr_stack+228338, vrr_stack+228653, vrr_stack+228233, vrr_stack+100833);
 am[0] = 3;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+230648, vrr_stack+230018, vrr_stack+229388, vrr_stack+228758, vrr_stack+228338, vrr_stack+101834);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+100833, vrr_stack+85137, vrr_stack+101106, vrr_stack+57715, vrr_stack+85371, NULL);
 am[0] = 1;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+101561, vrr_stack+100833, vrr_stack+228653, NULL, NULL, vrr_stack+101106);
 am[0] = 2;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+231698, vrr_stack+101561, vrr_stack+228758, vrr_stack+100833, vrr_stack+228653, vrr_stack+101197);
 am[0] = 3;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+232328, vrr_stack+231698, vrr_stack+230018, vrr_stack+101561, vrr_stack+228758, vrr_stack+102380);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+101197, vrr_stack+85449, vrr_stack+58841, vrr_stack+57979, vrr_stack+66366, NULL);
 am[0] = 1;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+101876, vrr_stack+84981, vrr_stack+101197, NULL, NULL, vrr_stack+85449);
 am[0] = 2;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+102191, vrr_stack+229073, vrr_stack+101876, vrr_stack+228128, vrr_stack+84981, vrr_stack+86034);
 am[0] = 3;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+197899, vrr_stack+229388, vrr_stack+102191, vrr_stack+228338, vrr_stack+229073, vrr_stack+86307);
 am[0] = 4;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+198949, vrr_stack+230648, vrr_stack+197899, vrr_stack+230018, vrr_stack+229388, vrr_stack+211055);
 am[0] = 4;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+211055, vrr_stack+232328, vrr_stack+230648, vrr_stack+231698, vrr_stack+230018, vrr_stack+102926);
 am[0] = 5;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+200524, vrr_stack+211055, vrr_stack+198949, vrr_stack+232328, vrr_stack+230648, vrr_stack+148337);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+212630, vrr_stack+58477, vrr_stack+85137, vrr_stack+66054, vrr_stack+57715, NULL);
 am[0] = 1;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+86034, vrr_stack+212630, vrr_stack+100833, NULL, NULL, vrr_stack+85137);
 am[0] = 2;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+102821, vrr_stack+86034, vrr_stack+101561, vrr_stack+212630, vrr_stack+100833, vrr_stack+85761);
 am[0] = 3;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+260108, vrr_stack+102821, vrr_stack+231698, vrr_stack+86034, vrr_stack+101561, vrr_stack+103836);
 am[0] = 4;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+146595, vrr_stack+260108, vrr_stack+232328, vrr_stack+102821, vrr_stack+231698, vrr_stack+210145);
 am[0] = 5;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+148170, vrr_stack+146595, vrr_stack+211055, vrr_stack+260108, vrr_stack+232328, vrr_stack+104382);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+210145, vrr_stack+58841, vrr_stack+74825, vrr_stack+66366, vrr_stack+123242, NULL);
 am[0] = 1;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+210250, vrr_stack+101197, vrr_stack+210145, NULL, NULL, vrr_stack+58841);
 am[0] = 2;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+103451, vrr_stack+101876, vrr_stack+210250, vrr_stack+84981, vrr_stack+101197, vrr_stack+87399);
 am[0] = 3;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+104081, vrr_stack+102191, vrr_stack+103451, vrr_stack+229073, vrr_stack+101876, vrr_stack+87672);
 am[0] = 4;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+3482, vrr_stack+197899, vrr_stack+104081, vrr_stack+229388, vrr_stack+102191, vrr_stack+182944);
 am[0] = 5;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+90129, vrr_stack+198949, vrr_stack+3482, vrr_stack+230648, vrr_stack+197899, vrr_stack+183854);
 am[0] = 6;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+123320, vrr_stack+200524, vrr_stack+90129, vrr_stack+211055, vrr_stack+198949, vrr_stack+126710);
 am[0] = 6;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+50794, vrr_stack+148170, vrr_stack+200524, vrr_stack+146595, vrr_stack+211055, vrr_stack+176847);
 am[0] = 7;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+30297, vrr_stack+50794, vrr_stack+123320, vrr_stack+148170, vrr_stack+200524, vrr_stack+93249);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+182944, vrr_stack+59647, vrr_stack+58477, vrr_stack+115571, vrr_stack+66054, NULL);
 am[0] = 1;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+183049, vrr_stack+182944, vrr_stack+212630, NULL, NULL, vrr_stack+58477);
 am[0] = 2;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+183364, vrr_stack+183049, vrr_stack+86034, vrr_stack+182944, vrr_stack+212630, vrr_stack+58568);
 am[0] = 3;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+183994, vrr_stack+183364, vrr_stack+102821, vrr_stack+183049, vrr_stack+86034, vrr_stack+86853);
 am[0] = 4;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+86349, vrr_stack+183994, vrr_stack+260108, vrr_stack+183364, vrr_stack+102821, vrr_stack+178758);
 am[0] = 5;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+176743, vrr_stack+86349, vrr_stack+146595, vrr_stack+183994, vrr_stack+260108, vrr_stack+179668);
 am[0] = 6;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+92334, vrr_stack+176743, vrr_stack+148170, vrr_stack+86349, vrr_stack+146595, vrr_stack+181033);
 am[0] = 7;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+178948, vrr_stack+92334, vrr_stack+50794, vrr_stack+176743, vrr_stack+148170, vrr_stack+35815);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+58568, vrr_stack+74825, vrr_stack+118925, vrr_stack+123242, vrr_stack+74741, NULL);
 am[0] = 1;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+185044, vrr_stack+210145, vrr_stack+58568, NULL, NULL, vrr_stack+74825);
 am[0] = 2;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+233378, vrr_stack+210250, vrr_stack+185044, vrr_stack+101197, vrr_stack+210145, vrr_stack+49975);
 am[0] = 3;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+95274, vrr_stack+103451, vrr_stack+233378, vrr_stack+101876, vrr_stack+210250, vrr_stack+50248);
 am[0] = 4;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+171709, vrr_stack+104081, vrr_stack+95274, vrr_stack+102191, vrr_stack+103451, vrr_stack+74916);
 am[0] = 5;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+74916, vrr_stack+3482, vrr_stack+171709, vrr_stack+197899, vrr_stack+104081, vrr_stack+105747);
 am[0] = 6;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+105131, vrr_stack+90129, vrr_stack+74916, vrr_stack+198949, vrr_stack+3482, vrr_stack+28386);
 am[0] = 7;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+63105, vrr_stack+123320, vrr_stack+105131, vrr_stack+200524, vrr_stack+90129, vrr_stack+275851);
 am[0] = 8;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+7611, vrr_stack+30297, vrr_stack+63105, vrr_stack+50794, vrr_stack+123320, vrr_stack+38363);
 am[0] = 8;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+34077, vrr_stack+178948, vrr_stack+30297, vrr_stack+92334, vrr_stack+50794, vrr_stack+269299);
 am[0] = 9;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+343646, vrr_stack+34077, vrr_stack+7611, vrr_stack+178948, vrr_stack+30297, vrr_stack+278399);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+269299, vrr_stack+218755, vrr_stack+59647, vrr_stack+171631, vrr_stack+115571, NULL);
 am[0] = 1;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+269404, vrr_stack+269299, vrr_stack+182944, NULL, NULL, vrr_stack+59647);
 am[0] = 2;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+269719, vrr_stack+269404, vrr_stack+183049, vrr_stack+269299, vrr_stack+182944, vrr_stack+59738);
 am[0] = 3;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+270349, vrr_stack+269719, vrr_stack+183364, vrr_stack+269404, vrr_stack+183049, vrr_stack+60011);
 am[0] = 4;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+275851, vrr_stack+270349, vrr_stack+183994, vrr_stack+269719, vrr_stack+183364, vrr_stack+191587);
 am[0] = 5;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+277426, vrr_stack+275851, vrr_stack+86349, vrr_stack+270349, vrr_stack+183994, vrr_stack+54624);
 am[0] = 6;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+53734, vrr_stack+277426, vrr_stack+176743, vrr_stack+275851, vrr_stack+86349, vrr_stack+67614);
 am[0] = 7;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+38802, vrr_stack+53734, vrr_stack+92334, vrr_stack+277426, vrr_stack+176743, vrr_stack+5063);
 am[0] = 8;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+349421, vrr_stack+38802, vrr_stack+178948, vrr_stack+53734, vrr_stack+92334, vrr_stack+272575);
 am[0] = 9;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+354146, vrr_stack+349421, vrr_stack+34077, vrr_stack+38802, vrr_stack+178948, vrr_stack+282494);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+191587, vrr_stack+118925, vrr_stack+297, vrr_stack+74741, vrr_stack+174117, NULL);
 am[0] = 1;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+191692, vrr_stack+58568, vrr_stack+191587, NULL, NULL, vrr_stack+118925);
 am[0] = 2;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+192007, vrr_stack+185044, vrr_stack+191692, vrr_stack+210145, vrr_stack+58568, vrr_stack+223123);
 am[0] = 3;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+271399, vrr_stack+233378, vrr_stack+192007, vrr_stack+210250, vrr_stack+185044, vrr_stack+223396);
 am[0] = 4;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+272449, vrr_stack+95274, vrr_stack+271399, vrr_stack+103451, vrr_stack+233378, vrr_stack+223942);
 am[0] = 5;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+279631, vrr_stack+171709, vrr_stack+272449, vrr_stack+104081, vrr_stack+95274, vrr_stack+224852);
 am[0] = 6;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+223123, vrr_stack+74916, vrr_stack+279631, vrr_stack+3482, vrr_stack+171709, vrr_stack+226217);
 am[0] = 7;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+281836, vrr_stack+105131, vrr_stack+223123, vrr_stack+90129, vrr_stack+74916, vrr_stack+60557);
 am[0] = 8;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+359921, vrr_stack+63105, vrr_stack+281836, vrr_stack+123320, vrr_stack+105131, vrr_stack+295689);
 am[0] = 9;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+364646, vrr_stack+7611, vrr_stack+359921, vrr_stack+30297, vrr_stack+63105, vrr_stack+298965);
 am[0] = 10;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+295689, vrr_stack+343646, vrr_stack+364646, vrr_stack+34077, vrr_stack+7611, vrr_stack+303060);
 am[0] = 10;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+370421, vrr_stack+354146, vrr_stack+343646, vrr_stack+349421, vrr_stack+34077, vrr_stack+286589);
 am[0] = 11;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+377351, vrr_stack+370421, vrr_stack+295689, vrr_stack+354146, vrr_stack+343646, vrr_stack+234277);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+302619, vrr_stack+15229, vrr_stack+218755, vrr_stack+185425, vrr_stack+171631, NULL);
 am[0] = 1;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+302724, vrr_stack+302619, vrr_stack+269299, NULL, NULL, vrr_stack+218755);
 am[0] = 2;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+303039, vrr_stack+302724, vrr_stack+269404, vrr_stack+302619, vrr_stack+269299, vrr_stack+218846);
 am[0] = 3;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+303669, vrr_stack+303039, vrr_stack+269719, vrr_stack+302724, vrr_stack+269404, vrr_stack+219119);
 am[0] = 4;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+304719, vrr_stack+303669, vrr_stack+270349, vrr_stack+303039, vrr_stack+269719, vrr_stack+219665);
 am[0] = 5;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+59738, vrr_stack+304719, vrr_stack+275851, vrr_stack+303669, vrr_stack+270349, vrr_stack+115649);
 am[0] = 6;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+285616, vrr_stack+59738, vrr_stack+277426, vrr_stack+304719, vrr_stack+275851, vrr_stack+117014);
 am[0] = 7;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+302724, vrr_stack+285616, vrr_stack+53734, vrr_stack+59738, vrr_stack+277426, vrr_stack+220575);
 am[0] = 8;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+234008, vrr_stack+302724, vrr_stack+38802, vrr_stack+285616, vrr_stack+53734, vrr_stack+69525);
   tmp = vrr_stack + 234008;
   target_ptr = Libint->vrr_classes[8][13];
   for(i=0;i<4725;i++)
     target_ptr[i] += tmp[i];
 am[0] = 9;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+285616, vrr_stack+234008, vrr_stack+349421, vrr_stack+302724, vrr_stack+38802, vrr_stack+291594);
   tmp = vrr_stack + 285616;
   target_ptr = Libint->vrr_classes[9][13];
   for(i=0;i<5775;i++)
     target_ptr[i] += tmp[i];
 am[0] = 10;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+66885, vrr_stack+285616, vrr_stack+354146, vrr_stack+234008, vrr_stack+349421, vrr_stack+19519);
   tmp = vrr_stack + 66885;
   target_ptr = Libint->vrr_classes[10][13];
   for(i=0;i<6930;i++)
     target_ptr[i] += tmp[i];
 am[0] = 11;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+385541, vrr_stack+66885, vrr_stack+370421, vrr_stack+285616, vrr_stack+354146, vrr_stack+308065);
   tmp = vrr_stack + 385541;
   target_ptr = Libint->vrr_classes[11][13];
   for(i=0;i<8190;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00p0(Data,vrr_stack+285616, Data->F+25, Data->F+26, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+285619, vrr_stack+0, vrr_stack+285616, Data->F+24, Data->F+25, NULL);
 _BUILD_00f0(Data,vrr_stack+285625, vrr_stack+3, vrr_stack+285619, vrr_stack+173893, vrr_stack+0, NULL);
 _BUILD_00g0(Data,vrr_stack+285635, vrr_stack+9, vrr_stack+285625, vrr_stack+74819, vrr_stack+3, NULL);
 _BUILD_00h0(Data,vrr_stack+285650, vrr_stack+19, vrr_stack+285635, vrr_stack+173896, vrr_stack+9, NULL);
 _BUILD_00i0(Data,vrr_stack+285671, vrr_stack+34, vrr_stack+285650, vrr_stack+173906, vrr_stack+19, NULL);
 _BUILD_00k0(Data,vrr_stack+285699, vrr_stack+55, vrr_stack+285671, vrr_stack+173921, vrr_stack+34, NULL);
 _BUILD_00l0(Data,vrr_stack+15184, vrr_stack+83, vrr_stack+285699, vrr_stack+173942, vrr_stack+55, NULL);
 _BUILD_00m0(Data,vrr_stack+285735, vrr_stack+119, vrr_stack+15184, vrr_stack+173970, vrr_stack+83, NULL);
 _BUILD_00n0(Data,vrr_stack+285790, vrr_stack+164, vrr_stack+285735, vrr_stack+174006, vrr_stack+119, NULL);
 _BUILD_00o0(Data,vrr_stack+171631, vrr_stack+123176, vrr_stack+285790, vrr_stack+84926, vrr_stack+164, NULL);
 _BUILD_00q0(Data,vrr_stack+285856, vrr_stack+219, vrr_stack+171631, vrr_stack+174051, vrr_stack+123176, NULL);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+285947, vrr_stack+297, vrr_stack+285856, vrr_stack+174117, vrr_stack+219, NULL);
 am[0] = 1;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+286052, vrr_stack+191587, vrr_stack+285947, NULL, NULL, vrr_stack+297);
 am[0] = 2;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+286367, vrr_stack+191692, vrr_stack+286052, vrr_stack+58568, vrr_stack+191587, vrr_stack+388);
 am[0] = 3;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+286997, vrr_stack+192007, vrr_stack+286367, vrr_stack+185044, vrr_stack+191692, vrr_stack+661);
 am[0] = 4;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+288047, vrr_stack+271399, vrr_stack+286997, vrr_stack+233378, vrr_stack+192007, vrr_stack+1207);
 am[0] = 5;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+289622, vrr_stack+272449, vrr_stack+288047, vrr_stack+95274, vrr_stack+271399, vrr_stack+2117);
 am[0] = 6;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+388, vrr_stack+279631, vrr_stack+289622, vrr_stack+171709, vrr_stack+272449, vrr_stack+88218);
 am[0] = 7;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+291827, vrr_stack+223123, vrr_stack+388, vrr_stack+74916, vrr_stack+279631, vrr_stack+174195);
 am[0] = 8;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+234008, vrr_stack+281836, vrr_stack+291827, vrr_stack+105131, vrr_stack+223123, vrr_stack+15320);
 am[0] = 9;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+15320, vrr_stack+359921, vrr_stack+234008, vrr_stack+63105, vrr_stack+281836, vrr_stack+240283);
 am[0] = 10;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+238733, vrr_stack+364646, vrr_stack+15320, vrr_stack+7611, vrr_stack+359921, vrr_stack+128621);
 am[0] = 11;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+302724, vrr_stack+295689, vrr_stack+238733, vrr_stack+343646, vrr_stack+364646, vrr_stack+140589);
 am[0] = 12;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+393731, vrr_stack+377351, vrr_stack+302724, vrr_stack+370421, vrr_stack+295689, vrr_stack+328267);
 am[0] = 12;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+403286, vrr_stack+385541, vrr_stack+377351, vrr_stack+66885, vrr_stack+370421, vrr_stack+314071);
   tmp = vrr_stack + 403286;
   target_ptr = Libint->vrr_classes[12][13];
   for(i=0;i<9555;i++)
     target_ptr[i] += tmp[i];
 am[0] = 0;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+66885, vrr_stack+228128, vrr_stack+84981, vrr_stack+100651, vrr_stack+101470, NULL);
 am[0] = 0;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+67005, vrr_stack+228233, vrr_stack+228128, vrr_stack+100742, vrr_stack+100651, NULL);
 am[0] = 1;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+67125, vrr_stack+67005, vrr_stack+66885, NULL, NULL, vrr_stack+228128);
 am[0] = 0;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+67485, vrr_stack+228653, vrr_stack+228233, vrr_stack+101106, vrr_stack+100742, NULL);
 am[0] = 1;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+67605, vrr_stack+67485, vrr_stack+67005, NULL, NULL, vrr_stack+228233);
 am[0] = 0;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+100651, vrr_stack+84981, vrr_stack+101197, vrr_stack+101470, vrr_stack+85449, NULL);
 am[0] = 1;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+67965, vrr_stack+66885, vrr_stack+100651, NULL, NULL, vrr_stack+84981);
 am[0] = 2;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+68325, vrr_stack+67125, vrr_stack+67965, vrr_stack+67005, vrr_stack+66885, vrr_stack+229073);
 am[0] = 2;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+69045, vrr_stack+67605, vrr_stack+67125, vrr_stack+67485, vrr_stack+67005, vrr_stack+228338);
 am[0] = 3;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+69765, vrr_stack+69045, vrr_stack+68325, vrr_stack+67605, vrr_stack+67125, vrr_stack+229388);
 am[0] = 0;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+67005, vrr_stack+100833, vrr_stack+228653, vrr_stack+85137, vrr_stack+101106, NULL);
 am[0] = 1;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+229073, vrr_stack+67005, vrr_stack+67485, NULL, NULL, vrr_stack+228653);
 am[0] = 2;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+70965, vrr_stack+229073, vrr_stack+67605, vrr_stack+67005, vrr_stack+67485, vrr_stack+228758);
 am[0] = 3;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+71685, vrr_stack+70965, vrr_stack+69045, vrr_stack+229073, vrr_stack+67605, vrr_stack+230018);
 am[0] = 0;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+67485, vrr_stack+101197, vrr_stack+210145, vrr_stack+85449, vrr_stack+58841, NULL);
 am[0] = 1;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+67605, vrr_stack+100651, vrr_stack+67485, NULL, NULL, vrr_stack+101197);
 am[0] = 2;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+229433, vrr_stack+67965, vrr_stack+67605, vrr_stack+66885, vrr_stack+100651, vrr_stack+101876);
 am[0] = 3;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+72885, vrr_stack+68325, vrr_stack+229433, vrr_stack+67125, vrr_stack+67965, vrr_stack+102191);
 am[0] = 4;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+328267, vrr_stack+69765, vrr_stack+72885, vrr_stack+69045, vrr_stack+68325, vrr_stack+197899);
 am[0] = 4;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+330067, vrr_stack+71685, vrr_stack+69765, vrr_stack+70965, vrr_stack+69045, vrr_stack+230648);
 am[0] = 5;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+331867, vrr_stack+330067, vrr_stack+328267, vrr_stack+71685, vrr_stack+69765, vrr_stack+198949);
 am[0] = 0;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+66885, vrr_stack+212630, vrr_stack+100833, vrr_stack+58477, vrr_stack+85137, NULL);
 am[0] = 1;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+67125, vrr_stack+66885, vrr_stack+67005, NULL, NULL, vrr_stack+100833);
 am[0] = 2;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+69045, vrr_stack+67125, vrr_stack+229073, vrr_stack+66885, vrr_stack+67005, vrr_stack+101561);
 am[0] = 3;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+197899, vrr_stack+69045, vrr_stack+70965, vrr_stack+67125, vrr_stack+229073, vrr_stack+231698);
 am[0] = 4;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+230153, vrr_stack+197899, vrr_stack+71685, vrr_stack+69045, vrr_stack+70965, vrr_stack+232328);
 am[0] = 5;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+140589, vrr_stack+230153, vrr_stack+330067, vrr_stack+197899, vrr_stack+71685, vrr_stack+211055);
 am[0] = 0;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+67005, vrr_stack+210145, vrr_stack+58568, vrr_stack+58841, vrr_stack+74825, NULL);
 am[0] = 1;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+70965, vrr_stack+67485, vrr_stack+67005, NULL, NULL, vrr_stack+210145);
 am[0] = 2;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+71325, vrr_stack+67605, vrr_stack+70965, vrr_stack+100651, vrr_stack+67485, vrr_stack+210250);
 am[0] = 3;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+100651, vrr_stack+229433, vrr_stack+71325, vrr_stack+67965, vrr_stack+67605, vrr_stack+103451);
 am[0] = 4;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+210145, vrr_stack+72885, vrr_stack+100651, vrr_stack+68325, vrr_stack+229433, vrr_stack+104081);
 am[0] = 5;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+143109, vrr_stack+328267, vrr_stack+210145, vrr_stack+69765, vrr_stack+72885, vrr_stack+3482);
 am[0] = 6;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+21095, vrr_stack+331867, vrr_stack+143109, vrr_stack+330067, vrr_stack+328267, vrr_stack+90129);
 am[0] = 6;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+3328, vrr_stack+140589, vrr_stack+331867, vrr_stack+230153, vrr_stack+330067, vrr_stack+200524);
 am[0] = 7;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+87924, vrr_stack+3328, vrr_stack+21095, vrr_stack+140589, vrr_stack+331867, vrr_stack+123320);
 am[0] = 0;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+330067, vrr_stack+182944, vrr_stack+212630, vrr_stack+59647, vrr_stack+58477, NULL);
 am[0] = 1;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+330187, vrr_stack+330067, vrr_stack+66885, NULL, NULL, vrr_stack+212630);
 am[0] = 2;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+330547, vrr_stack+330187, vrr_stack+67125, vrr_stack+330067, vrr_stack+66885, vrr_stack+86034);
 am[0] = 3;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+69765, vrr_stack+330547, vrr_stack+69045, vrr_stack+330187, vrr_stack+67125, vrr_stack+102821);
 am[0] = 4;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+101851, vrr_stack+69765, vrr_stack+197899, vrr_stack+330547, vrr_stack+69045, vrr_stack+260108);
 am[0] = 5;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+199099, vrr_stack+101851, vrr_stack+230153, vrr_stack+69765, vrr_stack+197899, vrr_stack+146595);
 am[0] = 6;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+59738, vrr_stack+199099, vrr_stack+140589, vrr_stack+101851, vrr_stack+230153, vrr_stack+148170);
 am[0] = 7;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+145629, vrr_stack+59738, vrr_stack+3328, vrr_stack+199099, vrr_stack+140589, vrr_stack+50794);
 am[0] = 0;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+66885, vrr_stack+58568, vrr_stack+191587, vrr_stack+74825, vrr_stack+118925, NULL);
 am[0] = 1;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+67125, vrr_stack+67005, vrr_stack+66885, NULL, NULL, vrr_stack+58568);
 am[0] = 2;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+140589, vrr_stack+70965, vrr_stack+67125, vrr_stack+67485, vrr_stack+67005, vrr_stack+185044);
 am[0] = 3;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+197899, vrr_stack+71325, vrr_stack+140589, vrr_stack+67605, vrr_stack+70965, vrr_stack+233378);
 am[0] = 4;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+141309, vrr_stack+100651, vrr_stack+197899, vrr_stack+229433, vrr_stack+71325, vrr_stack+95274);
 am[0] = 5;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+310914, vrr_stack+210145, vrr_stack+141309, vrr_stack+72885, vrr_stack+100651, vrr_stack+171709);
 am[0] = 6;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+171709, vrr_stack+143109, vrr_stack+310914, vrr_stack+328267, vrr_stack+210145, vrr_stack+74916);
 am[0] = 7;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+72045, vrr_stack+21095, vrr_stack+171709, vrr_stack+331867, vrr_stack+143109, vrr_stack+105131);
 am[0] = 8;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+226063, vrr_stack+87924, vrr_stack+72045, vrr_stack+3328, vrr_stack+21095, vrr_stack+63105);
 am[0] = 8;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+123242, vrr_stack+145629, vrr_stack+87924, vrr_stack+59738, vrr_stack+3328, vrr_stack+30297);
 am[0] = 9;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+128642, vrr_stack+123242, vrr_stack+226063, vrr_stack+145629, vrr_stack+87924, vrr_stack+7611);
 am[0] = 0;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+3328, vrr_stack+269299, vrr_stack+182944, vrr_stack+218755, vrr_stack+59647, NULL);
 am[0] = 1;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+3448, vrr_stack+3328, vrr_stack+330067, NULL, NULL, vrr_stack+182944);
 am[0] = 2;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+3808, vrr_stack+3448, vrr_stack+330187, vrr_stack+3328, vrr_stack+330067, vrr_stack+183049);
 am[0] = 3;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+4528, vrr_stack+3808, vrr_stack+330547, vrr_stack+3448, vrr_stack+330187, vrr_stack+183364);
 am[0] = 4;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+5728, vrr_stack+4528, vrr_stack+69765, vrr_stack+3808, vrr_stack+330547, vrr_stack+183994);
 am[0] = 5;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+7528, vrr_stack+5728, vrr_stack+101851, vrr_stack+4528, vrr_stack+69765, vrr_stack+86349);
 am[0] = 6;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+328267, vrr_stack+7528, vrr_stack+199099, vrr_stack+5728, vrr_stack+101851, vrr_stack+176743);
 am[0] = 7;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+101851, vrr_stack+328267, vrr_stack+59738, vrr_stack+7528, vrr_stack+199099, vrr_stack+92334);
 am[0] = 8;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+28386, vrr_stack+101851, vrr_stack+145629, vrr_stack+328267, vrr_stack+59738, vrr_stack+178948);
 am[0] = 9;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+175069, vrr_stack+28386, vrr_stack+123242, vrr_stack+101851, vrr_stack+145629, vrr_stack+34077);
 am[0] = 0;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+145629, vrr_stack+191587, vrr_stack+285947, vrr_stack+118925, vrr_stack+297, NULL);
 am[0] = 1;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+145749, vrr_stack+66885, vrr_stack+145629, NULL, NULL, vrr_stack+191587);
 am[0] = 2;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+146109, vrr_stack+67125, vrr_stack+145749, vrr_stack+67005, vrr_stack+66885, vrr_stack+191692);
 am[0] = 3;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+146829, vrr_stack+140589, vrr_stack+146109, vrr_stack+70965, vrr_stack+67125, vrr_stack+192007);
 am[0] = 4;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+148029, vrr_stack+197899, vrr_stack+146829, vrr_stack+71325, vrr_stack+140589, vrr_stack+271399);
 am[0] = 5;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+199099, vrr_stack+141309, vrr_stack+148029, vrr_stack+100651, vrr_stack+197899, vrr_stack+272449);
 am[0] = 6;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+271399, vrr_stack+310914, vrr_stack+199099, vrr_stack+210145, vrr_stack+141309, vrr_stack+279631);
 am[0] = 7;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+67485, vrr_stack+171709, vrr_stack+271399, vrr_stack+143109, vrr_stack+310914, vrr_stack+223123);
 am[0] = 8;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+218846, vrr_stack+72045, vrr_stack+67485, vrr_stack+21095, vrr_stack+171709, vrr_stack+281836);
 am[0] = 9;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+56674, vrr_stack+226063, vrr_stack+218846, vrr_stack+87924, vrr_stack+72045, vrr_stack+359921);
 am[0] = 10;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+84926, vrr_stack+128642, vrr_stack+56674, vrr_stack+123242, vrr_stack+226063, vrr_stack+364646);
 am[0] = 10;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+359921, vrr_stack+175069, vrr_stack+128642, vrr_stack+28386, vrr_stack+123242, vrr_stack+343646);
 am[0] = 11;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+412841, vrr_stack+359921, vrr_stack+84926, vrr_stack+175069, vrr_stack+128642, vrr_stack+295689);
 am[0] = 0;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+67005, vrr_stack+302619, vrr_stack+269299, vrr_stack+15229, vrr_stack+218755, NULL);
 am[0] = 1;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+343646, vrr_stack+67005, vrr_stack+3328, NULL, NULL, vrr_stack+269299);
 am[0] = 2;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+344006, vrr_stack+343646, vrr_stack+3448, vrr_stack+67005, vrr_stack+3328, vrr_stack+269404);
 am[0] = 3;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+100651, vrr_stack+344006, vrr_stack+3808, vrr_stack+343646, vrr_stack+3448, vrr_stack+269719);
 am[0] = 4;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+344726, vrr_stack+100651, vrr_stack+4528, vrr_stack+344006, vrr_stack+3808, vrr_stack+270349);
 am[0] = 5;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+143109, vrr_stack+344726, vrr_stack+5728, vrr_stack+100651, vrr_stack+4528, vrr_stack+275851);
 am[0] = 6;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+123242, vrr_stack+143109, vrr_stack+7528, vrr_stack+344726, vrr_stack+5728, vrr_stack+277426);
 am[0] = 7;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+343646, vrr_stack+123242, vrr_stack+328267, vrr_stack+143109, vrr_stack+7528, vrr_stack+53734);
 am[0] = 8;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+3328, vrr_stack+343646, vrr_stack+101851, vrr_stack+123242, vrr_stack+328267, vrr_stack+38802);
   tmp = vrr_stack + 3328;
   target_ptr = Libint->vrr_classes[8][14];
   for(i=0;i<5400;i++)
     target_ptr[i] += tmp[i];
 am[0] = 9;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+328267, vrr_stack+3328, vrr_stack+28386, vrr_stack+343646, vrr_stack+101851, vrr_stack+349421);
   tmp = vrr_stack + 328267;
   target_ptr = Libint->vrr_classes[9][14];
   for(i=0;i<6600;i++)
     target_ptr[i] += tmp[i];
 am[0] = 10;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+343646, vrr_stack+328267, vrr_stack+175069, vrr_stack+3328, vrr_stack+28386, vrr_stack+354146);
   tmp = vrr_stack + 343646;
   target_ptr = Libint->vrr_classes[10][14];
   for(i=0;i<7920;i++)
     target_ptr[i] += tmp[i];
 am[0] = 11;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+28386, vrr_stack+343646, vrr_stack+359921, vrr_stack+328267, vrr_stack+175069, vrr_stack+370421);
   tmp = vrr_stack + 28386;
   target_ptr = Libint->vrr_classes[11][14];
   for(i=0;i<9360;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00p0(Data,vrr_stack+175069, Data->F+26, Data->F+27, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+175072, vrr_stack+285616, vrr_stack+175069, Data->F+25, Data->F+26, NULL);
 _BUILD_00f0(Data,vrr_stack+175078, vrr_stack+285619, vrr_stack+175072, vrr_stack+0, vrr_stack+285616, NULL);
 _BUILD_00g0(Data,vrr_stack+175088, vrr_stack+285625, vrr_stack+175078, vrr_stack+3, vrr_stack+285619, NULL);
 _BUILD_00h0(Data,vrr_stack+175103, vrr_stack+285635, vrr_stack+175088, vrr_stack+9, vrr_stack+285625, NULL);
 _BUILD_00i0(Data,vrr_stack+175069, vrr_stack+285650, vrr_stack+175103, vrr_stack+19, vrr_stack+285635, NULL);
 _BUILD_00k0(Data,vrr_stack+175097, vrr_stack+285671, vrr_stack+175069, vrr_stack+34, vrr_stack+285650, NULL);
 _BUILD_00l0(Data,vrr_stack+0, vrr_stack+285699, vrr_stack+175097, vrr_stack+55, vrr_stack+285671, NULL);
 _BUILD_00m0(Data,vrr_stack+175069, vrr_stack+15184, vrr_stack+0, vrr_stack+83, vrr_stack+285699, NULL);
 _BUILD_00n0(Data,vrr_stack+0, vrr_stack+285735, vrr_stack+175069, vrr_stack+119, vrr_stack+15184, NULL);
 _BUILD_00o0(Data,vrr_stack+15184, vrr_stack+285790, vrr_stack+0, vrr_stack+164, vrr_stack+285735, NULL);
 _BUILD_00q0(Data,vrr_stack+218755, vrr_stack+171631, vrr_stack+15184, vrr_stack+123176, vrr_stack+285790, NULL);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+123176, vrr_stack+285856, vrr_stack+218755, vrr_stack+219, vrr_stack+171631, NULL);
 am[0] = 0;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+67005, vrr_stack+285947, vrr_stack+123176, vrr_stack+297, vrr_stack+285856, NULL);
 am[0] = 1;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+123176, vrr_stack+145629, vrr_stack+67005, NULL, NULL, vrr_stack+285947);
 am[0] = 2;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+123536, vrr_stack+145749, vrr_stack+123176, vrr_stack+66885, vrr_stack+145629, vrr_stack+286052);
 am[0] = 3;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+124256, vrr_stack+146109, vrr_stack+123536, vrr_stack+67125, vrr_stack+145749, vrr_stack+286367);
 am[0] = 4;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+125456, vrr_stack+146829, vrr_stack+124256, vrr_stack+140589, vrr_stack+146109, vrr_stack+286997);
 am[0] = 5;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+175069, vrr_stack+148029, vrr_stack+125456, vrr_stack+197899, vrr_stack+146829, vrr_stack+288047);
 am[0] = 6;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+123176, vrr_stack+199099, vrr_stack+175069, vrr_stack+141309, vrr_stack+148029, vrr_stack+289622);
 am[0] = 7;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+175069, vrr_stack+271399, vrr_stack+123176, vrr_stack+310914, vrr_stack+199099, vrr_stack+388);
 am[0] = 8;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+123176, vrr_stack+67485, vrr_stack+175069, vrr_stack+171709, vrr_stack+271399, vrr_stack+291827);
 am[0] = 9;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+140589, vrr_stack+218846, vrr_stack+123176, vrr_stack+72045, vrr_stack+67485, vrr_stack+234008);
 am[0] = 10;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+171631, vrr_stack+56674, vrr_stack+140589, vrr_stack+226063, vrr_stack+218846, vrr_stack+15320);
 am[0] = 11;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+140589, vrr_stack+84926, vrr_stack+171631, vrr_stack+128642, vrr_stack+56674, vrr_stack+238733);
 am[0] = 12;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+171631, vrr_stack+412841, vrr_stack+140589, vrr_stack+359921, vrr_stack+84926, vrr_stack+302724);
 am[0] = 12;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+84926, vrr_stack+28386, vrr_stack+412841, vrr_stack+343646, vrr_stack+359921, vrr_stack+377351);
   tmp = vrr_stack + 84926;
   target_ptr = Libint->vrr_classes[12][14];
   for(i=0;i<10920;i++)
     target_ptr[i] += tmp[i];
 am[0] = 13;  am[1] = 7;
 vrr_build_xxxx(am,Data,vrr_stack+343646, vrr_stack+25110, vrr_stack+81650, vrr_stack+78842, vrr_stack+43072, vrr_stack+12636);
   tmp = vrr_stack + 343646;
   target_ptr = Libint->vrr_classes[13][7];
   for(i=0;i<3780;i++)
     target_ptr[i] += tmp[i];
 am[0] = 13;  am[1] = 8;
 vrr_build_xxxx(am,Data,vrr_stack+347426, vrr_stack+45880, vrr_stack+119081, vrr_stack+112061, vrr_stack+108551, vrr_stack+81650);
   tmp = vrr_stack + 347426;
   target_ptr = Libint->vrr_classes[13][8];
   for(i=0;i<4725;i++)
     target_ptr[i] += tmp[i];
 am[0] = 13;  am[1] = 9;
 vrr_build_xxxx(am,Data,vrr_stack+352151, vrr_stack+166626, vrr_stack+161621, vrr_stack+96361, vrr_stack+150676, vrr_stack+119081);
   tmp = vrr_stack + 352151;
   target_ptr = Libint->vrr_classes[13][9];
   for(i=0;i<5775;i++)
     target_ptr[i] += tmp[i];
 am[0] = 13;  am[1] = 10;
 vrr_build_xxxx(am,Data,vrr_stack+357926, vrr_stack+212749, vrr_stack+154966, vrr_stack+135441, vrr_stack+192751, vrr_stack+161621);
   tmp = vrr_stack + 357926;
   target_ptr = Libint->vrr_classes[13][10];
   for(i=0;i<6930;i++)
     target_ptr[i] += tmp[i];
 am[0] = 13;  am[1] = 11;
 vrr_build_xxxx(am,Data,vrr_stack+364856, vrr_stack+203047, vrr_stack+262201, vrr_stack+185503, vrr_stack+245743, vrr_stack+154966);
   tmp = vrr_stack + 364856;
   target_ptr = Libint->vrr_classes[13][11];
   for(i=0;i<8190;i++)
     target_ptr[i] += tmp[i];
 am[0] = 13;  am[1] = 12;
 vrr_build_xxxx(am,Data,vrr_stack+95846, vrr_stack+251827, vrr_stack+335365, vrr_stack+321169, vrr_stack+314071, vrr_stack+262201);
   tmp = vrr_stack + 95846;
   target_ptr = Libint->vrr_classes[13][12];
   for(i=0;i<9555;i++)
     target_ptr[i] += tmp[i];
 am[0] = 13;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+105401, vrr_stack+403286, vrr_stack+393731, vrr_stack+385541, vrr_stack+377351, vrr_stack+335365);
   tmp = vrr_stack + 105401;
   target_ptr = Libint->vrr_classes[13][13];
   for(i=0;i<11025;i++)
     target_ptr[i] += tmp[i];
 am[0] = 13;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+373046, vrr_stack+84926, vrr_stack+171631, vrr_stack+28386, vrr_stack+412841, vrr_stack+393731);
   tmp = vrr_stack + 373046;
   target_ptr = Libint->vrr_classes[13][14];
   for(i=0;i<12600;i++)
     target_ptr[i] += tmp[i];

}

